/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/path","vs/base/common/uri","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","fs","vs/platform/product/common/productService","vs/base/common/strings","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/environment/electron-main/environmentMainService","vs/base/common/cancellation","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/base/common/arrays","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/labels","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/environment/common/environment","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","crypto","net","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/stream","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/tunnel","vs/platform/sign/common/sign","vs/platform/webview/common/webviewManagerService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/processes","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","assert","vs/code/electron-main/main"],J=function(j){for(var e=[],v=0,R=j.length;v<R;v++)e[v]=Q[j[v]];return e};define(Q[101],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,L){if(!R)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=v}),define(Q[46],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(I){return(r,w,p)=>{let n=null,S=null;if(typeof p.value=="function"?(n="value",S=p.value):typeof p.get=="function"&&(n="get",S=p.get),!S)throw new Error("not supported");p[n]=I(S,w)}}e.createDecorator=v;function R(I,r,w){let p=null,n=null;if(typeof w.value=="function"?(p="value",n=w.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(p="get",n=w.get),!n)throw new Error("not supported");const S=`$memoize$${r}`;w[p]=function(...E){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,E)}),this[S]}}e.memoize=R;function L(I,r,w){return v((p,n)=>{const S=`$debounce$${n}`,E=`$debounce$result$${n}`;return function(...b){this[E]||(this[E]=w?w():void 0),clearTimeout(this[S]),r&&(this[E]=r(this[E],...b),b=[this[E]]),this[S]=setTimeout(()=>{p.apply(this,b),this[E]=w?w():void 0},I)}})}e.debounce=L;function y(I,r,w){return v((p,n)=>{const S=`$throttle$timer$${n}`,E=`$throttle$result$${n}`,b=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...m){if(this[E]||(this[E]=w?w():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),r&&(this[E]=r(this[E],...m)),!this[d]){const M=this[b]+I;M<=Date.now()?(this[b]=Date.now(),p.apply(this,[this[E]]),this[E]=w?w():void 0):(this[d]=!0,this[S]=setTimeout(()=>{this[d]=!1,this[b]=Date.now(),p.apply(this,[this[E]]),this[E]=w?w():void 0},M-Date.now()))}}})}e.throttle=y}),define(Q[19],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function L(c){w(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=L;function y(c){w(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=y;function I(c){if(c instanceof Error){let{name:t,message:i}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:i,stack:s}}return c}e.transformErrorForSerialization=I;const r="Canceled";function w(c){return c instanceof Error&&c.name===r&&c.message===r}e.isPromiseCanceledError=w;class p extends Error{constructor(){super(r);this.name=this.message}}e.CancellationError=p;function n(){const c=new Error(r);return c.name=c.message,c}e.canceled=n;function S(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=S;function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=E;function b(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function d(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=m;class M extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=M;class P extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=P;class o extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=o;function u(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function l(c,t=Object.create(null)){const i=new Error(c);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=l}),define(Q[35],J([0,1,19]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(N,H=0){return N[N.length-(1+H)]}e.tail=R;function L(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}e.tail2=L;function y(N,H,V=(_,A)=>_===A){if(N===H)return!0;if(!N||!H||N.length!==H.length)return!1;for(let _=0,A=N.length;_<A;_++)if(!V(N[_],H[_]))return!1;return!0}e.equals=y;function I(N,H,V){let _=0,A=N.length-1;for(;_<=A;){const O=(_+A)/2|0,D=V(N[O],H);if(D<0)_=O+1;else if(D>0)A=O-1;else return O}return-(_+1)}e.binarySearch=I;function r(N,H){let V=0,_=N.length;if(_===0)return 0;for(;V<_;){const A=Math.floor((V+_)/2);H(N[A])?_=A:V=A+1}return V}e.findFirstInSorted=r;function w(N,H,V){if(N=N|0,N>=H.length)throw new TypeError("invalid index");let _=H[Math.floor(H.length*Math.random())],A=[],O=[],D=[];for(let F of H){const C=V(F,_);C<0?A.push(F):C>0?O.push(F):D.push(F)}return N<A.length?w(N,A,V):N<A.length+D.length?D[0]:w(N-(A.length+D.length),O,V)}e.quickSelect=w;function p(N,H){const V=[];let _;for(const A of N.slice(0).sort(H))!_||H(_[0],A)!==0?(_=[A],V.push(_)):_.push(A);return V}e.groupBy=p;function n(N,H,V){const _=[];function A(F,C,K){if(!(C===0&&K.length===0)){const G=_[_.length-1];G&&G.start+G.deleteCount===F?(G.deleteCount+=C,G.toInsert.push(...K)):_.push({start:F,deleteCount:C,toInsert:K})}}let O=0,D=0;for(;;){if(O===N.length){A(O,0,H.slice(D));break}if(D===H.length){A(O,N.length-O,[]);break}const F=N[O],C=H[D],K=V(F,C);K===0?(O+=1,D+=1):K<0?(A(O,1,[]),O+=1):K>0&&(A(O,0,[C]),D+=1)}return _}e.sortedDiff=n;function S(N,H,V){const _=n(N,H,V),A=[],O=[];for(const D of _)A.push(...N.slice(D.start,D.start+D.deleteCount)),O.push(...D.toInsert);return{removed:A,added:O}}e.delta=S;function E(N,H,V){if(V===0)return[];const _=N.slice(0,V).sort(H);return d(N,H,_,V,N.length),_}e.top=E;function b(N,H,V,_,A){return V===0?Promise.resolve([]):new Promise((O,D)=>{(async()=>{const F=N.length,C=N.slice(0,V).sort(H);for(let K=V,G=Math.min(V+_,F);K<F;K=G,G=Math.min(G+_,F)){if(K>V&&await new Promise(Y=>setTimeout(Y)),A&&A.isCancellationRequested)throw(0,v.canceled)();d(N,H,C,K,G)}return C})().then(O,D)})}e.topAsync=b;function d(N,H,V,_,A){for(const O=V.length;_<A;_++){const D=N[_];if(H(D,V[O-1])<0){V.pop();const F=r(V,C=>H(D,C)<0);V.splice(F,0,D)}}}function m(N){return N.filter(H=>!!H)}e.coalesce=m;function M(N){let H=0;for(let V=0;V<N.length;V++)N[V]&&(N[H]=N[V],H+=1);N.length=H}e.coalesceInPlace=M;function P(N,H,V){N.splice(V,0,N.splice(H,1)[0])}e.move=P;function o(N){return!Array.isArray(N)||N.length===0}e.isFalsyOrEmpty=o;function u(N){return Array.isArray(N)&&N.length>0}e.isNonEmptyArray=u;function l(N,H){if(!H)return N.filter((_,A)=>N.indexOf(_)===A);const V=Object.create(null);return N.filter(_=>{const A=H(_);return V[A]?!1:(V[A]=!0,!0)})}e.distinct=l;function c(N){const H=new Set;return N.filter(V=>H.has(V)?!1:(H.add(V),!0))}e.distinctES6=c;function t(N){const H=Object.create(null);return V=>{const _=N(V);return H[_]?!1:(H[_]=!0,!0)}}e.uniqueFilter=t;function i(N,H){for(let V=N.length-1;V>=0;V--){const _=N[V];if(H(_))return V}return-1}e.lastIndex=i;function s(N,H){return N.length>0?N[0]:H}e.firstOrDefault=s;function a(N,H,V=(_,A)=>_===A){let _=0;for(let A=0,O=Math.min(N.length,H.length);A<O&&V(N[A],H[A]);A++)_++;return _}e.commonPrefixLength=a;function h(N){return[].concat(...N)}e.flatten=h;function f(N,H){let V=typeof H=="number"?N:0;typeof H=="number"?V=N:(V=0,H=N);const _=[];if(V<=H)for(let A=V;A<H;A++)_.push(A);else for(let A=V;A>H;A--)_.push(A);return _}e.range=f;function g(N,H,V){return N.reduce((_,A)=>(_[H(A)]=V?V(A):A,_),Object.create(null))}e.index=g;function k(N,H){return N.push(H),()=>T(N,H)}e.insert=k;function T(N,H){const V=N.indexOf(H);if(V>-1)return N.splice(V,1),H}e.remove=T;function U(N,H,V){const _=N.slice(0,H),A=N.slice(H);return _.concat(V,A)}e.arrayInsert=U;function B(N,H){let V;if(typeof H=="number"){let _=H;V=()=>{const A=Math.sin(_++)*179426549;return A-Math.floor(A)}}else V=Math.random;for(let _=N.length-1;_>0;_-=1){const A=Math.floor(V()*(_+1)),O=N[_];N[_]=N[A],N[A]=O}}e.shuffle=B;function X(N,H){const V=N.indexOf(H);V>-1&&(N.splice(V,1),N.unshift(H))}e.pushToStart=X;function te(N,H){const V=N.indexOf(H);V>-1&&(N.splice(V,1),N.push(H))}e.pushToEnd=te;function oe(N,H){return Array.isArray(N)?N.map(H):H(N)}e.mapArrayOrNot=oe;function W(N){return Array.isArray(N)?N:[N]}e.asArray=W;function $(N){return N[Math.floor(Math.random()*N.length)]}e.getRandomElement=$;function z(N,H){for(const V of N){const _=H(V);if(_!==void 0)return _}}e.mapFind=z}),define(Q[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const L=this;let y=!1,I;return function(){return y||(y=!0,I=R.apply(L,arguments)),I}}e.once=v}),define(Q[63],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function L(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}R.is=L;const y=Object.freeze([]);function I(){return y}R.empty=I;function*r(c){yield c}R.single=r;function w(c){return c||y}R.from=w;function p(c){return!c||c[Symbol.iterator]().next().done===!0}R.isEmpty=p;function n(c){return c[Symbol.iterator]().next().value}R.first=n;function S(c,t){for(const i of c)if(t(i))return!0;return!1}R.some=S;function E(c,t){for(const i of c)if(t(i))return i}R.find=E;function*b(c,t){for(const i of c)t(i)&&(yield i)}R.filter=b;function*d(c,t){for(const i of c)yield t(i)}R.map=d;function*m(...c){for(const t of c)for(const i of t)yield i}R.concat=m;function*M(c){for(const t of c)for(const i of t)yield i}R.concatNested=M;function P(c,t,i){let s=i;for(const a of c)s=t(s,a);return s}R.reduce=P;function*o(c,t,i=c.length){for(t<0&&(t+=c.length),i<0?i+=c.length:i>c.length&&(i=c.length);t<i;t++)yield c[t]}R.slice=o;function u(c,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,c];const s=c[Symbol.iterator]();for(let a=0;a<t;a++){const h=s.next();if(h.done)return[i,R.empty()];i.push(h.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=u;function l(c,t,i=(s,a)=>s===a){const s=c[Symbol.iterator](),a=t[Symbol.iterator]();for(;;){const h=s.next(),f=a.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!i(h.value,f.value))return!1}}R.equals=l})(v=e.Iterable||(e.Iterable={}))}),define(Q[43],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var y;(function(t){t.DEFAULT={allowTrailingComma:!0}})(y=e.ParseOptions||(e.ParseOptions={}));function I(t,i=!1){let s=0,a=t.length,h="",f=0,g=16,k=0;function T($){let z=0,N=0;for(;z<$;){const H=t.charCodeAt(s);if(H>=48&&H<=57)N=N*16+H-48;else if(H>=65&&H<=70)N=N*16+H-65+10;else if(H>=97&&H<=102)N=N*16+H-97+10;else break;s++,z++}return z<$&&(N=-1),N}function U($){s=$,h="",f=0,g=16,k=0}function B(){const $=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&p(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&p(t.charCodeAt(s)))for(s++;s<t.length&&p(t.charCodeAt(s));)s++;else return k=3,t.substring($,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&p(t.charCodeAt(s))){for(s++;s<t.length&&p(t.charCodeAt(s));)s++;z=s}else k=3;return t.substring($,z)}function X(){let $="",z=s;for(;;){if(s>=a){$+=t.substring(z,s),k=2;break}const N=t.charCodeAt(s);if(N===34){$+=t.substring(z,s),s++;break}if(N===92){if($+=t.substring(z,s),s++,s>=a){k=2;break}switch(t.charCodeAt(s++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:const V=T(4);V>=0?$+=String.fromCharCode(V):k=4;break;default:k=5}z=s;continue}if(N>=0&&N<=31)if(w(N)){$+=t.substring(z,s),k=2;break}else k=6;s++}return $}function te(){if(h="",k=0,f=s,s>=a)return f=a,g=17;let $=t.charCodeAt(s);if(r($)){do s++,h+=String.fromCharCode($),$=t.charCodeAt(s);while(r($));return g=15}if(w($))return s++,h+=String.fromCharCode($),$===13&&t.charCodeAt(s)===10&&(s++,h+=`
`),g=14;switch($){case 123:return s++,g=1;case 125:return s++,g=2;case 91:return s++,g=3;case 93:return s++,g=4;case 58:return s++,g=6;case 44:return s++,g=5;case 34:return s++,h=X(),g=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<a&&!w(t.charCodeAt(s));)s++;return h=t.substring(z,s),g=12}if(t.charCodeAt(s+1)===42){s+=2;const N=a-1;let H=!1;for(;s<N;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,H=!0;break}s++}return H||(s++,k=1),h=t.substring(z,s),g=13}return h+=String.fromCharCode($),s++,g=16;case 45:if(h+=String.fromCharCode($),s++,s===a||!p(t.charCodeAt(s)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=B(),g=11;default:for(;s<a&&oe($);)s++,$=t.charCodeAt(s);if(f!==s){switch(h=t.substring(f,s),h){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return h+=String.fromCharCode($),s++,g=16}}function oe($){if(r($)||w($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let $;do $=te();while($>=12&&$<=15);return $}return{setPosition:U,getPosition:()=>s,scan:i?W:te,getToken:()=>g,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=I;function r(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function S(t,i){const s=[],a=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function k(T,U,B,X){f.value=T,f.offset=U,f.length=B,f.type=X,f.colonOffset=void 0,h=f}try{u(t,{onObjectBegin:(T,U)=>{if(i<=T)throw a;h=void 0,g=i>T,s.push("")},onObjectProperty:(T,U,B)=>{if(i<U||(k(T,U,B,"property"),s[s.length-1]=T,i<=U+B))throw a},onObjectEnd:(T,U)=>{if(i<=T)throw a;h=void 0,s.pop()},onArrayBegin:(T,U)=>{if(i<=T)throw a;h=void 0,s.push(0)},onArrayEnd:(T,U)=>{if(i<=T)throw a;h=void 0,s.pop()},onLiteralValue:(T,U,B)=>{if(i<U||(k(T,U,B,c(T)),i<=U+B))throw a},onSeparator:(T,U,B)=>{if(i<=U)throw a;if(T===":"&&h&&h.type==="property")h.colonOffset=U,g=!1,h=void 0;else if(T===","){const X=s[s.length-1];typeof X=="number"?s[s.length-1]=X+1:(g=!0,s[s.length-1]=""),h=void 0}}})}catch(T){if(T!==a)throw T}return{path:s,previousNode:h,isAtPropertyKey:g,matches:T=>{let U=0;for(let B=0;U<T.length&&B<s.length;B++)if(T[U]===s[B]||T[U]==="*")U++;else if(T[U]!=="**")return!1;return U===T.length}}}e.getLocation=S;function E(t,i=[],s=y.DEFAULT){let a=null,h=[];const f=[];function g(T){Array.isArray(h)?h.push(T):a!==null&&(h[a]=T)}return u(t,{onObjectBegin:()=>{const T={};g(T),f.push(h),h=T,a=null},onObjectProperty:T=>{a=T},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const T=[];g(T),f.push(h),h=T,a=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:g,onError:(T,U,B)=>{i.push({error:T,offset:U,length:B})}},s),h[0]}e.parse=E;function b(t,i=[],s=y.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){a.type==="property"&&(a.length=T-a.offset,a=a.parent)}function f(T){return a.children.push(T),T}u(t,{onObjectBegin:T=>{a=f({type:"object",offset:T,length:-1,parent:a,children:[]})},onObjectProperty:(T,U,B)=>{a=f({type:"property",offset:U,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:T,offset:U,length:B,parent:a})},onObjectEnd:(T,U)=>{a.length=T+U-a.offset,a=a.parent,h(T+U)},onArrayBegin:(T,U)=>{a=f({type:"array",offset:T,length:-1,parent:a,children:[]})},onArrayEnd:(T,U)=>{a.length=T+U-a.offset,a=a.parent,h(T+U)},onLiteralValue:(T,U,B)=>{f({type:c(T),offset:U,length:B,parent:a,value:T}),h(U+B)},onSeparator:(T,U,B)=>{a.type==="property"&&(T===":"?a.colonOffset=U:T===","&&h(U))},onError:(T,U,B)=>{i.push({error:T,offset:U,length:B})}},s);const k=a.children[0];return k&&delete k.parent,k}e.parseTree=b;function d(t,i){if(!!t){let s=t;for(let a of i)if(typeof a=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let h=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===a){s=f.children[1],h=!0;break}if(!h)return}else{const h=a;if(s.type!=="array"||h<0||!Array.isArray(s.children)||h>=s.children.length)return;s=s.children[h]}return s}}e.findNodeAtLocation=d;function m(t){if(!t.parent||!t.parent.children)return[];const i=m(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=m;function M(t){switch(t.type){case"array":return t.children.map(M);case"object":const i=Object.create(null);for(let s of t.children){const a=s.children[1];a&&(i[s.children[0].value]=M(a))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=M;function P(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=P;function o(t,i,s=!1){if(P(t,i,s)){const a=t.children;if(Array.isArray(a))for(let h=0;h<a.length&&a[h].offset<=i;h++){const f=o(a[h],i,s);if(f)return f}return t}}e.findNodeAtOffset=o;function u(t,i,s=y.DEFAULT){const a=I(t,!1);function h(C){return C?()=>C(a.getTokenOffset(),a.getTokenLength()):()=>!0}function f(C){return C?K=>C(K,a.getTokenOffset(),a.getTokenLength()):()=>!0}const g=h(i.onObjectBegin),k=f(i.onObjectProperty),T=h(i.onObjectEnd),U=h(i.onArrayBegin),B=h(i.onArrayEnd),X=f(i.onLiteralValue),te=f(i.onSeparator),oe=h(i.onComment),W=f(i.onError),$=s&&s.disallowComments,z=s&&s.allowTrailingComma;function N(){for(;;){const C=a.scan();switch(a.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:$||H(11);break;case 2:H(12);break;case 6:H(16);break}switch(C){case 12:case 13:$?H(10):oe();break;case 16:H(1);break;case 15:case 14:break;default:return C}}}function H(C,K=[],G=[]){if(W(C),K.length+G.length>0){let Y=a.getToken();for(;Y!==17;){if(K.indexOf(Y)!==-1){N();break}else if(G.indexOf(Y)!==-1)break;Y=N()}}}function V(C){const K=a.getTokenValue();return C?X(K):k(K),N(),!0}function _(){switch(a.getToken()){case 11:let C=0;try{C=JSON.parse(a.getTokenValue()),typeof C!="number"&&(H(2),C=0)}catch(K){H(2)}X(C);break;case 7:X(null);break;case 8:X(!0);break;case 9:X(!1);break;default:return!1}return N(),!0}function A(){return a.getToken()!==10?(H(3,[],[2,5]),!1):(V(!1),a.getToken()===6?(te(":"),N(),F()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function O(){g(),N();let C=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(C||H(4,[],[]),te(","),N(),a.getToken()===2&&z)break}else C&&H(6,[],[]);A()||H(4,[],[2,5]),C=!0}return T(),a.getToken()!==2?H(7,[2],[]):N(),!0}function D(){U(),N();let C=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(C||H(4,[],[]),te(","),N(),a.getToken()===4&&z)break}else C&&H(6,[],[]);F()||H(4,[],[4,5]),C=!0}return B(),a.getToken()!==4?H(8,[4],[]):N(),!0}function F(){switch(a.getToken()){case 3:return D();case 1:return O();case 10:return V(!0);default:return _()}}return N(),a.getToken()===17?s.allowEmptyContent?!0:(H(4,[],[]),!1):F()?(a.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=u;function l(t,i){let s=I(t),a=[],h,f=0,g;do switch(g=s.getPosition(),h=s.scan(),h){case 12:case 13:case 17:f!==g&&a.push(t.substring(f,g)),i!==void 0&&a.push(s.getTokenValue().replace(/[^\r\n]/g,i)),f=s.getPosition();break}while(h!==17);return a.join("")}e.stripComments=l;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Q[102],J([0,1,43]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(w,p,n){let S,E,b,d,m;if(p){for(d=p.offset,m=d+p.length,b=d;b>0&&!r(w,b-1);)b--;let f=m;for(;f<w.length&&!r(w,f);)f++;E=w.substring(b,f),S=y(E,n)}else E=w,S=0,b=0,d=0,m=w.length;const M=I(n,w);let P=!1,o=0,u;n.insertSpaces?u=L(" ",n.tabSize||4):u="	";const l=(0,v.createScanner)(E,!1);let c=!1;function t(){return M+L(u,S+o)}function i(){let f=l.scan();for(P=!1;f===15||f===14;)P=P||f===14,f=l.scan();return c=f===16||l.getTokenError()!==0,f}const s=[];function a(f,g,k){!c&&g<m&&k>d&&w.substring(g,k)!==f&&s.push({offset:g,length:k-g,content:f})}let h=i();if(h!==17){const f=l.getTokenOffset()+b,g=L(u,S);a(g,b,f)}for(;h!==17;){let f=l.getTokenOffset()+l.getTokenLength()+b,g=i(),k="";for(;!P&&(g===12||g===13);){const U=l.getTokenOffset()+b;a(" ",f,U),f=l.getTokenOffset()+l.getTokenLength()+b,k=g===12?t():"",g=i()}if(g===2)h!==1&&(o--,k=t());else if(g===4)h!==3&&(o--,k=t());else{switch(h){case 3:case 1:o++,k=t();break;case 5:case 12:k=t();break;case 13:P?k=t():k=" ";break;case 6:k=" ";break;case 10:if(g===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:g===12||g===13?k=" ":g!==5&&g!==17&&(c=!0);break;case 16:c=!0;break}P&&(g===12||g===13)&&(k=t())}const T=l.getTokenOffset()+b;a(k,f,T),h=g}return s}e.format=R;function L(w,p){let n="";for(let S=0;S<p;S++)n+=w;return n}function y(w,p){let n=0,S=0;const E=p.tabSize||4;for(;n<w.length;){const b=w.charAt(n);if(b===" ")S++;else if(b==="	")S+=E;else break;n++}return Math.floor(S/E)}function I(w,p){for(let n=0;n<p.length;n++){const S=p.charAt(n);if(S==="\r")return n+1<p.length&&p.charAt(n+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=I;function r(w,p){return`\r
`.indexOf(w.charAt(p))!==-1}e.isEOL=r}),define(Q[103],J([0,1,43,102]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(p,n,S){return y(p,n,void 0,S)}e.removeProperty=L;function y(p,n,S,E,b){const d=n.slice(),m=[],M=(0,v.parseTree)(p,m);let P,o;for(;d.length>0&&(o=d.pop(),P=(0,v.findNodeAtLocation)(M,d),P===void 0&&S!==void 0);)typeof o=="string"?S={[o]:S}:S=[S];if(P)if(P.type==="object"&&typeof o=="string"&&Array.isArray(P.children)){const u=(0,v.findNodeAtLocation)(P,[o]);if(u!==void 0)if(S===void 0){if(!u.parent)throw new Error("Malformed AST");const l=P.children.indexOf(u.parent);let c,t=u.parent.offset+u.parent.length;if(l>0){const i=P.children[l-1];c=i.offset+i.length}else c=P.offset+1,P.children.length>1&&(t=P.children[1].offset);return I(p,{offset:c,length:t-c,content:""},E)}else return I(p,{offset:u.offset,length:u.length,content:JSON.stringify(S)},E);else{if(S===void 0)return[];const l=`${JSON.stringify(o)}: ${JSON.stringify(S)}`,c=b?b(P.children.map(i=>i.children[0].value)):P.children.length;let t;if(c>0){const i=P.children[c-1];t={offset:i.offset+i.length,length:0,content:","+l}}else P.children.length===0?t={offset:P.offset+1,length:0,content:l}:t={offset:P.offset+1,length:0,content:l+","};return I(p,t,E)}}else if(P.type==="array"&&typeof o=="number"&&Array.isArray(P.children))if(S!==void 0){const u=`${JSON.stringify(S)}`;let l;if(P.children.length===0||o===0)l={offset:P.offset+1,length:0,content:P.children.length===0?u:u+","};else{const c=o===-1||o>P.children.length?P.children.length:o,t=P.children[c-1];l={offset:t.offset+t.length,length:0,content:","+u}}return I(p,l,E)}else{const u=o,l=P.children[u];let c;if(P.children.length===1)c={offset:P.offset+1,length:P.length-2,content:""};else if(P.children.length-1===u){const t=P.children[u-1],i=t.offset+t.length,s=P.offset+P.length;c={offset:i,length:s-2-i,content:""}}else c={offset:l.offset,length:P.children[u+1].offset-l.offset,content:""};return I(p,c,E)}else throw new Error(`Can not add ${typeof o!="number"?"index":"property"} to parent of type ${P.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(p,{offset:M?M.offset:0,length:M?M.length:0,content:JSON.stringify(S)},E)}}e.setProperty=y;function I(p,n,S){let E=r(p,n),b=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;b>0&&!(0,R.isEOL)(E,b-1);)b--;for(;d<E.length&&!(0,R.isEOL)(E,d);)d++}const m=(0,R.format)(E,{offset:b,length:d-b},S);for(let P=m.length-1;P>=0;P--){const o=m[P];E=r(E,o),b=Math.min(b,o.offset),d=Math.max(d,o.offset+o.length),d+=o.content.length-o.length}const M=p.length-(E.length-d)-b;return[{offset:b,length:M,content:E.substring(b,d)}]}e.withFormatting=I;function r(p,n){return p.substring(0,n.offset)+n.content+p.substring(n.offset+n.length)}e.applyEdit=r;function w(p,n){let S=n.slice(0).sort((b,d)=>{const m=b.offset-d.offset;return m===0?b.length-d.length:m}),E=p.length;for(let b=S.length-1;b>=0;b--){let d=S[b];if(d.offset+d.length<=E)p=r(p,d);else throw new Error("Overlapping edit");E=d.offset}return p}e.applyEdits=w}),define(Q[57],J([0,1,19]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(o){o[o.DependsOnKbLayout=-1]="DependsOnKbLayout",o[o.Unknown=0]="Unknown",o[o.Backspace=1]="Backspace",o[o.Tab=2]="Tab",o[o.Enter=3]="Enter",o[o.Shift=4]="Shift",o[o.Ctrl=5]="Ctrl",o[o.Alt=6]="Alt",o[o.PauseBreak=7]="PauseBreak",o[o.CapsLock=8]="CapsLock",o[o.Escape=9]="Escape",o[o.Space=10]="Space",o[o.PageUp=11]="PageUp",o[o.PageDown=12]="PageDown",o[o.End=13]="End",o[o.Home=14]="Home",o[o.LeftArrow=15]="LeftArrow",o[o.UpArrow=16]="UpArrow",o[o.RightArrow=17]="RightArrow",o[o.DownArrow=18]="DownArrow",o[o.Insert=19]="Insert",o[o.Delete=20]="Delete",o[o.KEY_0=21]="KEY_0",o[o.KEY_1=22]="KEY_1",o[o.KEY_2=23]="KEY_2",o[o.KEY_3=24]="KEY_3",o[o.KEY_4=25]="KEY_4",o[o.KEY_5=26]="KEY_5",o[o.KEY_6=27]="KEY_6",o[o.KEY_7=28]="KEY_7",o[o.KEY_8=29]="KEY_8",o[o.KEY_9=30]="KEY_9",o[o.KEY_A=31]="KEY_A",o[o.KEY_B=32]="KEY_B",o[o.KEY_C=33]="KEY_C",o[o.KEY_D=34]="KEY_D",o[o.KEY_E=35]="KEY_E",o[o.KEY_F=36]="KEY_F",o[o.KEY_G=37]="KEY_G",o[o.KEY_H=38]="KEY_H",o[o.KEY_I=39]="KEY_I",o[o.KEY_J=40]="KEY_J",o[o.KEY_K=41]="KEY_K",o[o.KEY_L=42]="KEY_L",o[o.KEY_M=43]="KEY_M",o[o.KEY_N=44]="KEY_N",o[o.KEY_O=45]="KEY_O",o[o.KEY_P=46]="KEY_P",o[o.KEY_Q=47]="KEY_Q",o[o.KEY_R=48]="KEY_R",o[o.KEY_S=49]="KEY_S",o[o.KEY_T=50]="KEY_T",o[o.KEY_U=51]="KEY_U",o[o.KEY_V=52]="KEY_V",o[o.KEY_W=53]="KEY_W",o[o.KEY_X=54]="KEY_X",o[o.KEY_Y=55]="KEY_Y",o[o.KEY_Z=56]="KEY_Z",o[o.Meta=57]="Meta",o[o.ContextMenu=58]="ContextMenu",o[o.F1=59]="F1",o[o.F2=60]="F2",o[o.F3=61]="F3",o[o.F4=62]="F4",o[o.F5=63]="F5",o[o.F6=64]="F6",o[o.F7=65]="F7",o[o.F8=66]="F8",o[o.F9=67]="F9",o[o.F10=68]="F10",o[o.F11=69]="F11",o[o.F12=70]="F12",o[o.F13=71]="F13",o[o.F14=72]="F14",o[o.F15=73]="F15",o[o.F16=74]="F16",o[o.F17=75]="F17",o[o.F18=76]="F18",o[o.F19=77]="F19",o[o.NumLock=78]="NumLock",o[o.ScrollLock=79]="ScrollLock",o[o.US_SEMICOLON=80]="US_SEMICOLON",o[o.US_EQUAL=81]="US_EQUAL",o[o.US_COMMA=82]="US_COMMA",o[o.US_MINUS=83]="US_MINUS",o[o.US_DOT=84]="US_DOT",o[o.US_SLASH=85]="US_SLASH",o[o.US_BACKTICK=86]="US_BACKTICK",o[o.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",o[o.US_BACKSLASH=88]="US_BACKSLASH",o[o.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",o[o.US_QUOTE=90]="US_QUOTE",o[o.OEM_8=91]="OEM_8",o[o.OEM_102=92]="OEM_102",o[o.NUMPAD_0=93]="NUMPAD_0",o[o.NUMPAD_1=94]="NUMPAD_1",o[o.NUMPAD_2=95]="NUMPAD_2",o[o.NUMPAD_3=96]="NUMPAD_3",o[o.NUMPAD_4=97]="NUMPAD_4",o[o.NUMPAD_5=98]="NUMPAD_5",o[o.NUMPAD_6=99]="NUMPAD_6",o[o.NUMPAD_7=100]="NUMPAD_7",o[o.NUMPAD_8=101]="NUMPAD_8",o[o.NUMPAD_9=102]="NUMPAD_9",o[o.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",o[o.NUMPAD_ADD=104]="NUMPAD_ADD",o[o.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",o[o.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",o[o.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",o[o.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",o[o.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",o[o.ABNT_C1=110]="ABNT_C1",o[o.ABNT_C2=111]="ABNT_C2",o[o.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class L{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(u,l){this._keyCodeToStr[u]=l,this._strToKeyCode[l.toLowerCase()]=u}keyCodeToStr(u){return this._keyCodeToStr[u]}strToKeyCode(u){return this._strToKeyCode[u.toLowerCase()]||0}}const y=new L,I=new L,r=new L;(function(){function o(u,l,c=l,t=c){y.define(u,l),I.define(u,c),r.define(u,t)}o(0,"unknown"),o(1,"Backspace"),o(2,"Tab"),o(3,"Enter"),o(4,"Shift"),o(5,"Ctrl"),o(6,"Alt"),o(7,"PauseBreak"),o(8,"CapsLock"),o(9,"Escape"),o(10,"Space"),o(11,"PageUp"),o(12,"PageDown"),o(13,"End"),o(14,"Home"),o(15,"LeftArrow","Left"),o(16,"UpArrow","Up"),o(17,"RightArrow","Right"),o(18,"DownArrow","Down"),o(19,"Insert"),o(20,"Delete"),o(21,"0"),o(22,"1"),o(23,"2"),o(24,"3"),o(25,"4"),o(26,"5"),o(27,"6"),o(28,"7"),o(29,"8"),o(30,"9"),o(31,"A"),o(32,"B"),o(33,"C"),o(34,"D"),o(35,"E"),o(36,"F"),o(37,"G"),o(38,"H"),o(39,"I"),o(40,"J"),o(41,"K"),o(42,"L"),o(43,"M"),o(44,"N"),o(45,"O"),o(46,"P"),o(47,"Q"),o(48,"R"),o(49,"S"),o(50,"T"),o(51,"U"),o(52,"V"),o(53,"W"),o(54,"X"),o(55,"Y"),o(56,"Z"),o(57,"Meta"),o(58,"ContextMenu"),o(59,"F1"),o(60,"F2"),o(61,"F3"),o(62,"F4"),o(63,"F5"),o(64,"F6"),o(65,"F7"),o(66,"F8"),o(67,"F9"),o(68,"F10"),o(69,"F11"),o(70,"F12"),o(71,"F13"),o(72,"F14"),o(73,"F15"),o(74,"F16"),o(75,"F17"),o(76,"F18"),o(77,"F19"),o(78,"NumLock"),o(79,"ScrollLock"),o(80,";",";","OEM_1"),o(81,"=","=","OEM_PLUS"),o(82,",",",","OEM_COMMA"),o(83,"-","-","OEM_MINUS"),o(84,".",".","OEM_PERIOD"),o(85,"/","/","OEM_2"),o(86,"`","`","OEM_3"),o(110,"ABNT_C1"),o(111,"ABNT_C2"),o(87,"[","[","OEM_4"),o(88,"\\","\\","OEM_5"),o(89,"]","]","OEM_6"),o(90,"'","'","OEM_7"),o(91,"OEM_8"),o(92,"OEM_102"),o(93,"NumPad0"),o(94,"NumPad1"),o(95,"NumPad2"),o(96,"NumPad3"),o(97,"NumPad4"),o(98,"NumPad5"),o(99,"NumPad6"),o(100,"NumPad7"),o(101,"NumPad8"),o(102,"NumPad9"),o(103,"NumPad_Multiply"),o(104,"NumPad_Add"),o(105,"NumPad_Separator"),o(106,"NumPad_Subtract"),o(107,"NumPad_Decimal"),o(108,"NumPad_Divide")})();var w;(function(o){function u(s){return y.keyCodeToStr(s)}o.toString=u;function l(s){return y.strToKeyCode(s)}o.fromString=l;function c(s){return I.keyCodeToStr(s)}o.toUserSettingsUS=c;function t(s){return r.keyCodeToStr(s)}o.toUserSettingsGeneral=t;function i(s){return I.strToKeyCode(s)||r.strToKeyCode(s)}o.fromUserSettings=i})(w=e.KeyCodeUtils||(e.KeyCodeUtils={}));var p;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl",o[o.KeyCode=255]="KeyCode"})(p||(p={}));var n;(function(o){o[o.CtrlCmd=2048]="CtrlCmd",o[o.Shift=1024]="Shift",o[o.Alt=512]="Alt",o[o.WinCtrl=256]="WinCtrl"})(n=e.KeyMod||(e.KeyMod={}));function S(o,u){const l=(u&65535)<<16>>>0;return(o|l)>>>0}e.KeyChord=S;function E(o,u){if(o===0)return null;const l=(o&65535)>>>0,c=(o&4294901760)>>>16;return c!==0?new m([b(l,u),b(c,u)]):new m([b(l,u)])}e.createKeybinding=E;function b(o,u){const l=!!(o&2048),c=!!(o&256),t=u===2?c:l,i=!!(o&1024),s=!!(o&512),a=u===2?l:c,h=o&255;return new d(t,i,s,a,h)}e.createSimpleKeybinding=b;class d{constructor(u,l,c,t,i){this.ctrlKey=u,this.shiftKey=l,this.altKey=c,this.metaKey=t,this.keyCode=i}equals(u){return this.ctrlKey===u.ctrlKey&&this.shiftKey===u.shiftKey&&this.altKey===u.altKey&&this.metaKey===u.metaKey&&this.keyCode===u.keyCode}getHashCode(){const u=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",c=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${u}${l}${c}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(u){if(u.length===0)throw(0,v.illegalArgument)("parts");this.parts=u}getHashCode(){let u="";for(let l=0,c=this.parts.length;l<c;l++)l!==0&&(u+=";"),u+=this.parts[l].getHashCode();return u}equals(u){if(u===null||this.parts.length!==u.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(u.parts[l]))return!1;return!0}}e.ChordKeybinding=m;class M{constructor(u,l,c,t,i,s){this.ctrlKey=u,this.shiftKey=l,this.altKey=c,this.metaKey=t,this.keyLabel=i,this.keyAriaLabel=s}}e.ResolvedKeybindingPart=M;class P{}e.ResolvedKeybinding=P}),define(Q[2],J([0,1,42,63]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let y=null;function I(u){y=u}if(e.setDisposableTracker=I,L){const u="__is_disposable_tracked__";y=new class{trackDisposable(l){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[u]||console.log(c)},3e3)}markTracked(l){if(l&&l!==m.None)try{l[u]=!0}catch(c){}}}}function r(u){!y||y.markTracked(u)}function w(u){return y&&y.trackDisposable(u),u}e.trackDisposable=w;class p extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=p;function n(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=n;function S(u){if(R.Iterable.is(u)){let l=[];for(const c of u)if(c){r(c);try{c.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new p(l);return Array.isArray(u)?[]:u}else if(u)return r(u),u.dispose(),u}e.dispose=S;function E(...u){return u.forEach(r),b(()=>S(u))}e.combinedDisposable=E;function b(u){const l=w({dispose:()=>{r(l),u()}});return l}e.toDisposable=b;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(r(this),this._isDisposed=!0,this.clear())}clear(){try{S(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return r(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,w(this)}dispose(){r(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class M{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var c;this._isDisposed||l===this._value||((c=this._value)===null||c===void 0||c.dispose(),l&&r(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,r(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=M;class P{constructor(){this.references=new Map}acquire(l,...c){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...c)},this.references.set(l,t));const{object:i}=t,s=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:i,dispose:s}}}e.ReferenceCollection=P;class o{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=o}),define(Q[78],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(y){this.element=y,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let y=this._first;for(;y!==v.Undefined;){const I=y.next;y.prev=v.Undefined,y.next=v.Undefined,y=I}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(y){return this._insert(y,!1)}push(y){return this._insert(y,!0)}_insert(y,I){const r=new v(y);if(this._first===v.Undefined)this._first=r,this._last=r;else if(I){const p=this._last;this._last=r,r.prev=p,p.next=r}else{const p=this._first;this._first=r,r.next=p,p.prev=r}this._size+=1;let w=!1;return()=>{w||(w=!0,this._remove(r))}}shift(){if(this._first!==v.Undefined){const y=this._first.element;return this._remove(this._first),y}}pop(){if(this._last!==v.Undefined){const y=this._last.element;return this._remove(this._last),y}}_remove(y){if(y.prev!==v.Undefined&&y.next!==v.Undefined){const I=y.prev;I.next=y.next,y.next.prev=I}else y.prev===v.Undefined&&y.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):y.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):y.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let y=this._first;for(;y!==v.Undefined;)yield y.element,y=y.next}}e.LinkedList=R});"use strict";(function(){function j(L){const y=[];typeof L=="number"&&y.push("code/timeOrigin",L);function I(w){y.push(w,Date.now())}function r(){const w=[];for(let p=0;p<y.length;p+=2)w.push({name:y[p],startTime:y[p+1]});return w}return{mark:I,getMarks:r}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const y=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const I of performance.getEntriesByType("mark"))y.push({name:I.name,startTime:Math.round(L+I.startTime)});return y}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function v(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))})(),define(Q[3],J([0,1]),function(j,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let L=!1,y=!1,I=!1,r=!1,w=!1,p=!1,n=!1,S,E=R,b,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const M=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=M&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const a=m==null?void 0:m.env.VSCODE_BROWSER_CODE_LOADING;if(typeof a=="string")return a==="none"||a==="code"||a==="bypassHeatCheck"||a==="bypassHeatCheckAndEagerCompile"?a:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!M)d=navigator.userAgent,L=d.indexOf("Windows")>=0,y=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=d.indexOf("Linux")>=0,p=!0,S=navigator.language,E=S;else if(typeof m=="object"){L=m.platform==="win32",y=m.platform==="darwin",I=m.platform==="linux",r=I&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,S=R,E=R;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),f=h.availableLanguages["*"];S=h.locale,E=f||R,b=h._translationsConfigFile}catch(h){}w=!0}else console.error("Unable to resolve platform.");var P;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function o(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=o;let u=0;y?u=1:L?u=3:I&&(u=2),e.isWindows=L,e.isMacintosh=y,e.isLinux=I,e.isLinuxSnap=r,e.isNative=w,e.isWeb=p,e.isIOS=n,e.platform=u,e.userAgent=d,e.language=E;var l;(function(a){function h(){return e.language}a.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=f;function g(){return e.language==="en"}a.isDefault=g})(l=e.Language||(e.Language={})),e.locale=S,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeSetImmediateId)for(let T=0,U=f.length;T<U;T++){const B=f[T];if(B.id===k.data.vscodeSetImmediateId){f.splice(T,1),B.callback();return}}});let g=0;return k=>{const T=++g;f.push({id:T,callback:k}),e.globals.postMessage({vscodeSetImmediateId:T},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const h=Promise.resolve();return f=>h.then(f)}();var c;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=y||n?2:L?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,t=new Uint16Array(a.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(Q[32],J([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof v.globals.vscode!="undefined"){const L=v.globals.vscode.process;R={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(y){return(0,v.setImmediate)(y)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(L){return(0,v.setImmediate)(L)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(Q[7],J([0,1,32]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,L=97,y=90,I=122,r=46,w=47,p=92,n=58,S=63;class E extends Error{constructor(l,c,t){let i;typeof c=="string"&&c.indexOf("not ")===0?(i="must not be",c=c.replace(/^not /,"")):i="must be";const s=l.indexOf(".")!==-1?"property":"argument";let a=`The "${l}" ${s} ${i} of type ${c}`;a+=`. Received type ${typeof t}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function b(u,l){if(typeof u!="string")throw new E(l,"string",u)}function d(u){return u===w||u===p}function m(u){return u===w}function M(u){return u>=R&&u<=y||u>=L&&u<=I}function P(u,l,c,t){let i="",s=0,a=-1,h=0,f=0;for(let g=0;g<=u.length;++g){if(g<u.length)f=u.charCodeAt(g);else{if(t(f))break;f=w}if(t(f)){if(!(a===g-1||h===1))if(h===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==r||i.charCodeAt(i.length-2)!==r){if(i.length>2){const k=i.lastIndexOf(c);k===-1?(i="",s=0):(i=i.slice(0,k),s=i.length-1-i.lastIndexOf(c)),a=g,h=0;continue}else if(i.length!==0){i="",s=0,a=g,h=0;continue}}l&&(i+=i.length>0?`${c}..`:"..",s=2)}else i.length>0?i+=`${c}${u.slice(a+1,g)}`:i=u.slice(a+1,g),s=g-a-1;a=g,h=0}else f===r&&h!==-1?++h:h=-1}return i}function o(u,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const c=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${t}`:`${c}${u}${t}`:t}e.win32={resolve(...u){let l="",c="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],b(s,"path"),s.length===0)continue}else l.length===0?s=v.cwd():(s=v.env[`=${l}`]||v.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===p)&&(s=`${l}\\`));const a=s.length;let h=0,f="",g=!1;const k=s.charCodeAt(0);if(a===1)d(k)&&(h=1,g=!0);else if(d(k))if(g=!0,d(s.charCodeAt(1))){let T=2,U=T;for(;T<a&&!d(s.charCodeAt(T));)T++;if(T<a&&T!==U){const B=s.slice(U,T);for(U=T;T<a&&d(s.charCodeAt(T));)T++;if(T<a&&T!==U){for(U=T;T<a&&!d(s.charCodeAt(T));)T++;(T===a||T!==U)&&(f=`\\\\${B}\\${s.slice(U,T)}`,h=T)}}}else h=1;else M(k)&&s.charCodeAt(1)===n&&(f=s.slice(0,2),h=2,a>2&&d(s.charCodeAt(2))&&(g=!0,h=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(c=`${s.slice(h)}\\${c}`,t=g,g&&l.length>0)break}return c=P(c,!t,"\\",d),t?`${l}\\${c}`:`${l}${c}`||"."},normalize(u){b(u,"path");const l=u.length;if(l===0)return".";let c=0,t,i=!1;const s=u.charCodeAt(0);if(l===1)return m(s)?"\\":u;if(d(s))if(i=!0,d(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(u.charCodeAt(h));)h++;if(h<l&&h!==f){const g=u.slice(f,h);for(f=h;h<l&&d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(u.charCodeAt(h));)h++;if(h===l)return`\\\\${g}\\${u.slice(f)}\\`;h!==f&&(t=`\\\\${g}\\${u.slice(f,h)}`,c=h)}}}else c=1;else M(s)&&u.charCodeAt(1)===n&&(t=u.slice(0,2),c=2,l>2&&d(u.charCodeAt(2))&&(i=!0,c=3));let a=c<l?P(u.slice(c),!i,"\\",d):"";return a.length===0&&!i&&(a="."),a.length>0&&d(u.charCodeAt(l-1))&&(a+="\\"),t===void 0?i?`\\${a}`:a:i?`${t}\\${a}`:`${t}${a}`},isAbsolute(u){b(u,"path");const l=u.length;if(l===0)return!1;const c=u.charCodeAt(0);return d(c)||l>2&&M(c)&&u.charCodeAt(1)===n&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,c;for(let s=0;s<u.length;++s){const a=u[s];b(a,"path"),a.length>0&&(l===void 0?l=c=a:l+=`\\${a}`)}if(l===void 0)return".";let t=!0,i=0;if(typeof c=="string"&&d(c.charCodeAt(0))){++i;const s=c.length;s>1&&d(c.charCodeAt(1))&&(++i,s>2&&(d(c.charCodeAt(2))?++i:t=!1))}if(t){for(;i<l.length&&d(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.win32.normalize(l)},relative(u,l){if(b(u,"from"),b(l,"to"),u===l)return"";const c=e.win32.resolve(u),t=e.win32.resolve(l);if(c===t||(u=c.toLowerCase(),l=t.toLowerCase(),u===l))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===p;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===p;)s--;const a=s-i;let h=0;for(;h<l.length&&l.charCodeAt(h)===p;)h++;let f=l.length;for(;f-1>h&&l.charCodeAt(f-1)===p;)f--;const g=f-h,k=a<g?a:g;let T=-1,U=0;for(;U<k;U++){const X=u.charCodeAt(i+U);if(X!==l.charCodeAt(h+U))break;X===p&&(T=U)}if(U!==k){if(T===-1)return t}else{if(g>k){if(l.charCodeAt(h+U)===p)return t.slice(h+U+1);if(U===2)return t.slice(h+U)}a>k&&(u.charCodeAt(i+U)===p?T=U:U===2&&(T=3)),T===-1&&(T=0)}let B="";for(U=i+T+1;U<=s;++U)(U===s||u.charCodeAt(U)===p)&&(B+=B.length===0?"..":"\\..");return h+=T,B.length>0?`${B}${t.slice(h,f)}`:(t.charCodeAt(h)===p&&++h,t.slice(h,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===p){if(l.charCodeAt(1)===p){const c=l.charCodeAt(2);if(c!==S&&c!==r)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(M(l.charCodeAt(0))&&l.charCodeAt(1)===n&&l.charCodeAt(2)===p)return`\\\\?\\${l}`;return u},dirname(u){b(u,"path");const l=u.length;if(l===0)return".";let c=-1,t=0;const i=u.charCodeAt(0);if(l===1)return d(i)?u:".";if(d(i)){if(c=t=1,d(u.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&d(u.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(u.charCodeAt(h));)h++;if(h===l)return u;h!==f&&(c=t=h+1)}}}}else M(i)&&u.charCodeAt(1)===n&&(c=l>2&&d(u.charCodeAt(2))?3:2,t=c);let s=-1,a=!0;for(let h=l-1;h>=t;--h)if(d(u.charCodeAt(h))){if(!a){s=h;break}}else a=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,l){l!==void 0&&b(l,"ext"),b(u,"path");let c=0,t=-1,i=!0,s;if(u.length>=2&&M(u.charCodeAt(0))&&u.charCodeAt(1)===n&&(c=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=c;--s){const f=u.charCodeAt(s);if(d(f)){if(!i){c=s+1;break}}else h===-1&&(i=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return c===t?t=h:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=c;--s)if(d(u.charCodeAt(s))){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){b(u,"path");let l=0,c=-1,t=0,i=-1,s=!0,a=0;u.length>=2&&u.charCodeAt(1)===n&&M(u.charCodeAt(0))&&(l=t=2);for(let h=u.length-1;h>=l;--h){const f=u.charCodeAt(h);if(d(f)){if(!s){t=h+1;break}continue}i===-1&&(s=!1,i=h+1),f===r?c===-1?c=h:a!==1&&(a=1):c!==-1&&(a=-1)}return c===-1||i===-1||a===0||a===1&&c===i-1&&c===t+1?"":u.slice(c,i)},format:o.bind(null,"\\"),parse(u){b(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.length;let t=0,i=u.charCodeAt(0);if(c===1)return d(i)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(d(i)){if(t=1,d(u.charCodeAt(1))){let T=2,U=T;for(;T<c&&!d(u.charCodeAt(T));)T++;if(T<c&&T!==U){for(U=T;T<c&&d(u.charCodeAt(T));)T++;if(T<c&&T!==U){for(U=T;T<c&&!d(u.charCodeAt(T));)T++;T===c?t=T:T!==U&&(t=T+1)}}}}else if(M(i)&&u.charCodeAt(1)===n){if(c<=2)return l.root=l.dir=u,l;if(t=2,d(u.charCodeAt(2))){if(c===3)return l.root=l.dir=u,l;t=3}}t>0&&(l.root=u.slice(0,t));let s=-1,a=t,h=-1,f=!0,g=u.length-1,k=0;for(;g>=t;--g){if(i=u.charCodeAt(g),d(i)){if(!f){a=g+1;break}continue}h===-1&&(f=!1,h=g+1),i===r?s===-1?s=g:k!==1&&(k=1):s!==-1&&(k=-1)}return h!==-1&&(s===-1||k===0||k===1&&s===h-1&&s===a+1?l.base=l.name=u.slice(a,h):(l.name=u.slice(a,s),l.base=u.slice(a,h),l.ext=u.slice(s,h))),a>0&&a!==t?l.dir=u.slice(0,a-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",c=!1;for(let t=u.length-1;t>=-1&&!c;t--){const i=t>=0?u[t]:v.cwd();b(i,"path"),i.length!==0&&(l=`${i}/${l}`,c=i.charCodeAt(0)===w)}return l=P(l,!c,"/",m),c?`/${l}`:l.length>0?l:"."},normalize(u){if(b(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w,c=u.charCodeAt(u.length-1)===w;return u=P(u,!l,"/",m),u.length===0?l?"/":c?"./":".":(c&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return b(u,"path"),u.length>0&&u.charCodeAt(0)===w},join(...u){if(u.length===0)return".";let l;for(let c=0;c<u.length;++c){const t=u[c];b(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(b(u,"from"),b(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const c=1,t=u.length,i=t-c,s=1,a=l.length-s,h=i<a?i:a;let f=-1,g=0;for(;g<h;g++){const T=u.charCodeAt(c+g);if(T!==l.charCodeAt(s+g))break;T===w&&(f=g)}if(g===h)if(a>h){if(l.charCodeAt(s+g)===w)return l.slice(s+g+1);if(g===0)return l.slice(s+g)}else i>h&&(u.charCodeAt(c+g)===w?f=g:g===0&&(f=0));let k="";for(g=c+f+1;g<=t;++g)(g===t||u.charCodeAt(g)===w)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(b(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===w;let c=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===w){if(!t){c=i;break}}else t=!1;return c===-1?l?"/":".":l&&c===1?"//":u.slice(0,c)},basename(u,l){l!==void 0&&b(l,"ext"),b(u,"path");let c=0,t=-1,i=!0,s;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let a=l.length-1,h=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===w){if(!i){c=s+1;break}}else h===-1&&(i=!1,h=s+1),a>=0&&(f===l.charCodeAt(a)?--a==-1&&(t=s):(a=-1,t=h))}return c===t?t=h:t===-1&&(t=u.length),u.slice(c,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===w){if(!i){c=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(c,t)},extname(u){b(u,"path");let l=-1,c=0,t=-1,i=!0,s=0;for(let a=u.length-1;a>=0;--a){const h=u.charCodeAt(a);if(h===w){if(!i){c=a+1;break}continue}t===-1&&(i=!1,t=a+1),h===r?l===-1?l=a:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||t===-1||s===0||s===1&&l===t-1&&l===c+1?"":u.slice(l,t)},format:o.bind(null,"/"),parse(u){b(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.charCodeAt(0)===w;let t;c?(l.root="/",t=1):t=0;let i=-1,s=0,a=-1,h=!0,f=u.length-1,g=0;for(;f>=t;--f){const k=u.charCodeAt(f);if(k===w){if(!h){s=f+1;break}continue}a===-1&&(h=!1,a=f+1),k===r?i===-1?i=f:g!==1&&(g=1):i!==-1&&(g=-1)}if(a!==-1){const k=s===0&&c?1:s;i===-1||g===0||g===1&&i===a-1&&i===s+1?l.base=l.name=u.slice(k,a):(l.name=u.slice(k,i),l.base=u.slice(k,a),l.ext=u.slice(i,a))}return s>0?l.dir=u.slice(0,s-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[104],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var v;(function(y){y[y.stdout=0]="stdout",y[y.stderr=1]="stderr"})(v=e.Source||(e.Source={}));var R;(function(y){y[y.Success=0]="Success",y[y.Unknown=1]="Unknown",y[y.AccessDenied=2]="AccessDenied",y[y.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(y,...I){const r=I.reduce((n,S)=>(n[S]=!0,n),{}),w=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(y).filter(n=>!r[n]).forEach(n=>{for(let S=0;S<w.length;S++)if(n.search(w[S])!==-1){delete y[n];break}})}e.sanitizeProcessEnvironment=L}),define(Q[79],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.None=0]="None",r[r.Hyper=1]="Hyper",r[r.Super=2]="Super",r[r.Fn=3]="Fn",r[r.FnLock=4]="FnLock",r[r.Suspend=5]="Suspend",r[r.Resume=6]="Resume",r[r.Turbo=7]="Turbo",r[r.Sleep=8]="Sleep",r[r.WakeUp=9]="WakeUp",r[r.KeyA=10]="KeyA",r[r.KeyB=11]="KeyB",r[r.KeyC=12]="KeyC",r[r.KeyD=13]="KeyD",r[r.KeyE=14]="KeyE",r[r.KeyF=15]="KeyF",r[r.KeyG=16]="KeyG",r[r.KeyH=17]="KeyH",r[r.KeyI=18]="KeyI",r[r.KeyJ=19]="KeyJ",r[r.KeyK=20]="KeyK",r[r.KeyL=21]="KeyL",r[r.KeyM=22]="KeyM",r[r.KeyN=23]="KeyN",r[r.KeyO=24]="KeyO",r[r.KeyP=25]="KeyP",r[r.KeyQ=26]="KeyQ",r[r.KeyR=27]="KeyR",r[r.KeyS=28]="KeyS",r[r.KeyT=29]="KeyT",r[r.KeyU=30]="KeyU",r[r.KeyV=31]="KeyV",r[r.KeyW=32]="KeyW",r[r.KeyX=33]="KeyX",r[r.KeyY=34]="KeyY",r[r.KeyZ=35]="KeyZ",r[r.Digit1=36]="Digit1",r[r.Digit2=37]="Digit2",r[r.Digit3=38]="Digit3",r[r.Digit4=39]="Digit4",r[r.Digit5=40]="Digit5",r[r.Digit6=41]="Digit6",r[r.Digit7=42]="Digit7",r[r.Digit8=43]="Digit8",r[r.Digit9=44]="Digit9",r[r.Digit0=45]="Digit0",r[r.Enter=46]="Enter",r[r.Escape=47]="Escape",r[r.Backspace=48]="Backspace",r[r.Tab=49]="Tab",r[r.Space=50]="Space",r[r.Minus=51]="Minus",r[r.Equal=52]="Equal",r[r.BracketLeft=53]="BracketLeft",r[r.BracketRight=54]="BracketRight",r[r.Backslash=55]="Backslash",r[r.IntlHash=56]="IntlHash",r[r.Semicolon=57]="Semicolon",r[r.Quote=58]="Quote",r[r.Backquote=59]="Backquote",r[r.Comma=60]="Comma",r[r.Period=61]="Period",r[r.Slash=62]="Slash",r[r.CapsLock=63]="CapsLock",r[r.F1=64]="F1",r[r.F2=65]="F2",r[r.F3=66]="F3",r[r.F4=67]="F4",r[r.F5=68]="F5",r[r.F6=69]="F6",r[r.F7=70]="F7",r[r.F8=71]="F8",r[r.F9=72]="F9",r[r.F10=73]="F10",r[r.F11=74]="F11",r[r.F12=75]="F12",r[r.PrintScreen=76]="PrintScreen",r[r.ScrollLock=77]="ScrollLock",r[r.Pause=78]="Pause",r[r.Insert=79]="Insert",r[r.Home=80]="Home",r[r.PageUp=81]="PageUp",r[r.Delete=82]="Delete",r[r.End=83]="End",r[r.PageDown=84]="PageDown",r[r.ArrowRight=85]="ArrowRight",r[r.ArrowLeft=86]="ArrowLeft",r[r.ArrowDown=87]="ArrowDown",r[r.ArrowUp=88]="ArrowUp",r[r.NumLock=89]="NumLock",r[r.NumpadDivide=90]="NumpadDivide",r[r.NumpadMultiply=91]="NumpadMultiply",r[r.NumpadSubtract=92]="NumpadSubtract",r[r.NumpadAdd=93]="NumpadAdd",r[r.NumpadEnter=94]="NumpadEnter",r[r.Numpad1=95]="Numpad1",r[r.Numpad2=96]="Numpad2",r[r.Numpad3=97]="Numpad3",r[r.Numpad4=98]="Numpad4",r[r.Numpad5=99]="Numpad5",r[r.Numpad6=100]="Numpad6",r[r.Numpad7=101]="Numpad7",r[r.Numpad8=102]="Numpad8",r[r.Numpad9=103]="Numpad9",r[r.Numpad0=104]="Numpad0",r[r.NumpadDecimal=105]="NumpadDecimal",r[r.IntlBackslash=106]="IntlBackslash",r[r.ContextMenu=107]="ContextMenu",r[r.Power=108]="Power",r[r.NumpadEqual=109]="NumpadEqual",r[r.F13=110]="F13",r[r.F14=111]="F14",r[r.F15=112]="F15",r[r.F16=113]="F16",r[r.F17=114]="F17",r[r.F18=115]="F18",r[r.F19=116]="F19",r[r.F20=117]="F20",r[r.F21=118]="F21",r[r.F22=119]="F22",r[r.F23=120]="F23",r[r.F24=121]="F24",r[r.Open=122]="Open",r[r.Help=123]="Help",r[r.Select=124]="Select",r[r.Again=125]="Again",r[r.Undo=126]="Undo",r[r.Cut=127]="Cut",r[r.Copy=128]="Copy",r[r.Paste=129]="Paste",r[r.Find=130]="Find",r[r.AudioVolumeMute=131]="AudioVolumeMute",r[r.AudioVolumeUp=132]="AudioVolumeUp",r[r.AudioVolumeDown=133]="AudioVolumeDown",r[r.NumpadComma=134]="NumpadComma",r[r.IntlRo=135]="IntlRo",r[r.KanaMode=136]="KanaMode",r[r.IntlYen=137]="IntlYen",r[r.Convert=138]="Convert",r[r.NonConvert=139]="NonConvert",r[r.Lang1=140]="Lang1",r[r.Lang2=141]="Lang2",r[r.Lang3=142]="Lang3",r[r.Lang4=143]="Lang4",r[r.Lang5=144]="Lang5",r[r.Abort=145]="Abort",r[r.Props=146]="Props",r[r.NumpadParenLeft=147]="NumpadParenLeft",r[r.NumpadParenRight=148]="NumpadParenRight",r[r.NumpadBackspace=149]="NumpadBackspace",r[r.NumpadMemoryStore=150]="NumpadMemoryStore",r[r.NumpadMemoryRecall=151]="NumpadMemoryRecall",r[r.NumpadMemoryClear=152]="NumpadMemoryClear",r[r.NumpadMemoryAdd=153]="NumpadMemoryAdd",r[r.NumpadMemorySubtract=154]="NumpadMemorySubtract",r[r.NumpadClear=155]="NumpadClear",r[r.NumpadClearEntry=156]="NumpadClearEntry",r[r.ControlLeft=157]="ControlLeft",r[r.ShiftLeft=158]="ShiftLeft",r[r.AltLeft=159]="AltLeft",r[r.MetaLeft=160]="MetaLeft",r[r.ControlRight=161]="ControlRight",r[r.ShiftRight=162]="ShiftRight",r[r.AltRight=163]="AltRight",r[r.MetaRight=164]="MetaRight",r[r.BrightnessUp=165]="BrightnessUp",r[r.BrightnessDown=166]="BrightnessDown",r[r.MediaPlay=167]="MediaPlay",r[r.MediaRecord=168]="MediaRecord",r[r.MediaFastForward=169]="MediaFastForward",r[r.MediaRewind=170]="MediaRewind",r[r.MediaTrackNext=171]="MediaTrackNext",r[r.MediaTrackPrevious=172]="MediaTrackPrevious",r[r.MediaStop=173]="MediaStop",r[r.Eject=174]="Eject",r[r.MediaPlayPause=175]="MediaPlayPause",r[r.MediaSelect=176]="MediaSelect",r[r.LaunchMail=177]="LaunchMail",r[r.LaunchApp2=178]="LaunchApp2",r[r.LaunchApp1=179]="LaunchApp1",r[r.SelectTask=180]="SelectTask",r[r.LaunchScreenSaver=181]="LaunchScreenSaver",r[r.BrowserSearch=182]="BrowserSearch",r[r.BrowserHome=183]="BrowserHome",r[r.BrowserBack=184]="BrowserBack",r[r.BrowserForward=185]="BrowserForward",r[r.BrowserStop=186]="BrowserStop",r[r.BrowserRefresh=187]="BrowserRefresh",r[r.BrowserFavorites=188]="BrowserFavorites",r[r.ZoomToggle=189]="ZoomToggle",r[r.MailReply=190]="MailReply",r[r.MailForward=191]="MailForward",r[r.MailSend=192]="MailSend",r[r.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const R=[],L=Object.create(null),y=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:r=>y[r]||0,toEnum:r=>L[r]||0,toString:r=>R[r]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class I{constructor(w,p,n,S,E){this.ctrlKey=w,this.shiftKey=p,this.altKey=n,this.metaKey=S,this.scanCode=E}equals(w){return this.ctrlKey===w.ctrlKey&&this.shiftKey===w.shiftKey&&this.altKey===w.altKey&&this.metaKey===w.metaKey&&this.scanCode===w.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=I,function(){function r(w,p){R[w]=p,L[p]=w,y[p.toLowerCase()]=w}r(0,"None"),r(1,"Hyper"),r(2,"Super"),r(3,"Fn"),r(4,"FnLock"),r(5,"Suspend"),r(6,"Resume"),r(7,"Turbo"),r(8,"Sleep"),r(9,"WakeUp"),r(10,"KeyA"),r(11,"KeyB"),r(12,"KeyC"),r(13,"KeyD"),r(14,"KeyE"),r(15,"KeyF"),r(16,"KeyG"),r(17,"KeyH"),r(18,"KeyI"),r(19,"KeyJ"),r(20,"KeyK"),r(21,"KeyL"),r(22,"KeyM"),r(23,"KeyN"),r(24,"KeyO"),r(25,"KeyP"),r(26,"KeyQ"),r(27,"KeyR"),r(28,"KeyS"),r(29,"KeyT"),r(30,"KeyU"),r(31,"KeyV"),r(32,"KeyW"),r(33,"KeyX"),r(34,"KeyY"),r(35,"KeyZ"),r(36,"Digit1"),r(37,"Digit2"),r(38,"Digit3"),r(39,"Digit4"),r(40,"Digit5"),r(41,"Digit6"),r(42,"Digit7"),r(43,"Digit8"),r(44,"Digit9"),r(45,"Digit0"),r(46,"Enter"),r(47,"Escape"),r(48,"Backspace"),r(49,"Tab"),r(50,"Space"),r(51,"Minus"),r(52,"Equal"),r(53,"BracketLeft"),r(54,"BracketRight"),r(55,"Backslash"),r(56,"IntlHash"),r(57,"Semicolon"),r(58,"Quote"),r(59,"Backquote"),r(60,"Comma"),r(61,"Period"),r(62,"Slash"),r(63,"CapsLock"),r(64,"F1"),r(65,"F2"),r(66,"F3"),r(67,"F4"),r(68,"F5"),r(69,"F6"),r(70,"F7"),r(71,"F8"),r(72,"F9"),r(73,"F10"),r(74,"F11"),r(75,"F12"),r(76,"PrintScreen"),r(77,"ScrollLock"),r(78,"Pause"),r(79,"Insert"),r(80,"Home"),r(81,"PageUp"),r(82,"Delete"),r(83,"End"),r(84,"PageDown"),r(85,"ArrowRight"),r(86,"ArrowLeft"),r(87,"ArrowDown"),r(88,"ArrowUp"),r(89,"NumLock"),r(90,"NumpadDivide"),r(91,"NumpadMultiply"),r(92,"NumpadSubtract"),r(93,"NumpadAdd"),r(94,"NumpadEnter"),r(95,"Numpad1"),r(96,"Numpad2"),r(97,"Numpad3"),r(98,"Numpad4"),r(99,"Numpad5"),r(100,"Numpad6"),r(101,"Numpad7"),r(102,"Numpad8"),r(103,"Numpad9"),r(104,"Numpad0"),r(105,"NumpadDecimal"),r(106,"IntlBackslash"),r(107,"ContextMenu"),r(108,"Power"),r(109,"NumpadEqual"),r(110,"F13"),r(111,"F14"),r(112,"F15"),r(113,"F16"),r(114,"F17"),r(115,"F18"),r(116,"F19"),r(117,"F20"),r(118,"F21"),r(119,"F22"),r(120,"F23"),r(121,"F24"),r(122,"Open"),r(123,"Help"),r(124,"Select"),r(125,"Again"),r(126,"Undo"),r(127,"Cut"),r(128,"Copy"),r(129,"Paste"),r(130,"Find"),r(131,"AudioVolumeMute"),r(132,"AudioVolumeUp"),r(133,"AudioVolumeDown"),r(134,"NumpadComma"),r(135,"IntlRo"),r(136,"KanaMode"),r(137,"IntlYen"),r(138,"Convert"),r(139,"NonConvert"),r(140,"Lang1"),r(141,"Lang2"),r(142,"Lang3"),r(143,"Lang4"),r(144,"Lang5"),r(145,"Abort"),r(146,"Props"),r(147,"NumpadParenLeft"),r(148,"NumpadParenRight"),r(149,"NumpadBackspace"),r(150,"NumpadMemoryStore"),r(151,"NumpadMemoryRecall"),r(152,"NumpadMemoryClear"),r(153,"NumpadMemoryAdd"),r(154,"NumpadMemorySubtract"),r(155,"NumpadClear"),r(156,"NumpadClearEntry"),r(157,"ControlLeft"),r(158,"ShiftLeft"),r(159,"AltLeft"),r(160,"MetaLeft"),r(161,"ControlRight"),r(162,"ShiftRight"),r(163,"AltRight"),r(164,"MetaRight"),r(165,"BrightnessUp"),r(166,"BrightnessDown"),r(167,"MediaPlay"),r(168,"MediaRecord"),r(169,"MediaFastForward"),r(170,"MediaRewind"),r(171,"MediaTrackNext"),r(172,"MediaTrackPrevious"),r(173,"MediaStop"),r(174,"Eject"),r(175,"MediaPlayPause"),r(176,"MediaSelect"),r(177,"LaunchMail"),r(178,"LaunchApp2"),r(179,"LaunchApp1"),r(180,"SelectTask"),r(181,"LaunchScreenSaver"),r(182,"BrowserSearch"),r(183,"BrowserHome"),r(184,"BrowserBack"),r(185,"BrowserForward"),r(186,"BrowserStop"),r(187,"BrowserRefresh"),r(188,"BrowserFavorites"),r(189,"ZoomToggle"),r(190,"MailReply"),r(191,"MailForward"),r(192,"MailSend")}(),function(){for(let w=0;w<=193;w++)e.IMMUTABLE_CODE_TO_KEY_CODE[w]=-1;for(let w=0;w<=112;w++)e.IMMUTABLE_KEY_CODE_TO_CODE[w]=-1;function r(w,p){e.IMMUTABLE_CODE_TO_KEY_CODE[w]=p,p!==0&&p!==3&&p!==5&&p!==4&&p!==6&&p!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[p]=w)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,r(0,0),r(1,0),r(2,0),r(3,0),r(4,0),r(5,0),r(6,0),r(7,0),r(8,0),r(9,0),r(46,3),r(47,9),r(48,1),r(49,2),r(50,10),r(63,8),r(64,59),r(65,60),r(66,61),r(67,62),r(68,63),r(69,64),r(70,65),r(71,66),r(72,67),r(73,68),r(74,69),r(75,70),r(76,0),r(77,79),r(78,7),r(79,19),r(80,14),r(81,11),r(82,20),r(83,13),r(84,12),r(85,17),r(86,15),r(87,18),r(88,16),r(89,78),r(90,108),r(91,103),r(92,106),r(93,104),r(94,3),r(95,94),r(96,95),r(97,96),r(98,97),r(99,98),r(100,99),r(101,100),r(102,101),r(103,102),r(104,93),r(105,107),r(107,58),r(108,0),r(109,0),r(110,71),r(111,72),r(112,73),r(113,74),r(114,75),r(115,76),r(116,77),r(117,0),r(118,0),r(119,0),r(120,0),r(121,0),r(122,0),r(123,0),r(124,0),r(125,0),r(126,0),r(127,0),r(128,0),r(129,0),r(130,0),r(131,0),r(132,0),r(133,0),r(134,105),r(136,0),r(138,0),r(139,0),r(140,0),r(141,0),r(142,0),r(143,0),r(144,0),r(145,0),r(146,0),r(147,0),r(148,0),r(149,0),r(150,0),r(151,0),r(152,0),r(153,0),r(154,0),r(155,0),r(156,0),r(157,5),r(158,4),r(159,6),r(160,57),r(161,5),r(162,4),r(163,6),r(164,57),r(165,0),r(166,0),r(167,0),r(168,0),r(169,0),r(170,0),r(171,0),r(172,0),r(173,0),r(174,0),r(175,0),r(176,0),r(177,0),r(178,0),r(179,0),r(180,0),r(181,0),r(182,0),r(183,0),r(184,0),r(185,0),r(186,0),r(187,0),r(188,0),r(189,0),r(190,0),r(191,0),r(192,0)}()}),define(Q[105],J([0,1,57,79]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class L{static _readModifiers(I){I=I.toLowerCase().trim();let r=!1,w=!1,p=!1,n=!1,S;do S=!1,/^ctrl(\+|\-)/.test(I)&&(r=!0,I=I.substr("ctrl-".length),S=!0),/^shift(\+|\-)/.test(I)&&(w=!0,I=I.substr("shift-".length),S=!0),/^alt(\+|\-)/.test(I)&&(p=!0,I=I.substr("alt-".length),S=!0),/^meta(\+|\-)/.test(I)&&(n=!0,I=I.substr("meta-".length),S=!0),/^win(\+|\-)/.test(I)&&(n=!0,I=I.substr("win-".length),S=!0),/^cmd(\+|\-)/.test(I)&&(n=!0,I=I.substr("cmd-".length),S=!0);while(S);let E;const b=I.indexOf(" ");return b>0?(E=I.substring(0,b),I=I.substring(b)):(E=I,I=""),{remains:I,ctrl:r,shift:w,alt:p,meta:n,key:E}}static parseSimpleKeybinding(I){const r=this._readModifiers(I),w=v.KeyCodeUtils.fromUserSettings(r.key);return[new v.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,w),r.remains]}static parseKeybinding(I,r){if(!I)return null;const w=[];let p;do[p,I]=this.parseSimpleKeybinding(I),w.push(p);while(I.length>0);return new v.ChordKeybinding(w)}static parseSimpleUserBinding(I){const r=this._readModifiers(I),w=r.key.match(/^\[([^\]]+)\]$/);if(w){const n=w[1],S=R.ScanCodeUtils.lowerCaseToEnum(n);return[new R.ScanCodeBinding(r.ctrl,r.shift,r.alt,r.meta,S),r.remains]}const p=v.KeyCodeUtils.fromUserSettings(r.key);return[new v.SimpleKeybinding(r.ctrl,r.shift,r.alt,r.meta,p),r.remains]}static parseUserBinding(I){if(!I)return[];const r=[];let w;for(;I.length>0;)[w,I]=this.parseSimpleUserBinding(I),r.push(w);return r}}e.KeybindingParser=L}),define(Q[106],J([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class L{constructor(I){this._highResolution=R&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new L(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Q[5],J([0,1,19,42,2,78,106]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var r;(function(P){P.None=()=>L.Disposable.None;function o(W){return($,z=null,N)=>{let H=!1,V;return V=W(_=>{if(!H)return V?V.dispose():H=!0,$.call(z,_)},null,N),H&&V.dispose(),V}}P.once=o;function u(W,$){return a((z,N=null,H)=>W(V=>z.call(N,$(V)),null,H))}P.map=u;function l(W,$){return a((z,N=null,H)=>W(V=>{$(V),z.call(N,V)},null,H))}P.forEach=l;function c(W,$){return a((z,N=null,H)=>W(V=>$(V)&&z.call(N,V),null,H))}P.filter=c;function t(W){return W}P.signal=t;function i(...W){return($,z=null,N)=>(0,L.combinedDisposable)(...W.map(H=>H(V=>$.call(z,V),null,N)))}P.any=i;function s(W,$,z){let N=z;return u(W,H=>(N=$(N,H),N))}P.reduce=s;function a(W){let $;const z=new E({onFirstListenerAdd(){$=W(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}P.snapshot=a;function h(W,$,z=100,N=!1,H){let V,_,A,O=0;const D=new E({leakWarningThreshold:H,onFirstListenerAdd(){V=W(F=>{O++,_=$(_,F),N&&!A&&(D.fire(_),_=void 0),clearTimeout(A),A=setTimeout(()=>{const C=_;_=void 0,A=void 0,(!N||O>1)&&D.fire(C),O=0},z)})},onLastListenerRemove(){V.dispose()}});return D.event}P.debounce=h;function f(W){const $=new Date().getTime();return u(o(W),z=>new Date().getTime()-$)}P.stopwatch=f;function g(W){let $=!0,z;return c(W,N=>{const H=$||N!==z;return $=!1,z=N,H})}P.latch=g;function k(W,$=!1,z=[]){let N=z.slice(),H=W(A=>{N?N.push(A):_.fire(A)});const V=()=>{N&&N.forEach(A=>_.fire(A)),N=null},_=new E({onFirstListenerAdd(){H||(H=W(A=>_.fire(A)))},onFirstListenerDidAdd(){N&&($?setTimeout(V):V())},onLastListenerRemove(){H&&H.dispose(),H=null}});return _.event}P.buffer=k;class T{constructor($){this.event=$}map($){return new T(u(this.event,$))}forEach($){return new T(l(this.event,$))}filter($){return new T(c(this.event,$))}reduce($,z){return new T(s(this.event,$,z))}latch(){return new T(g(this.event))}debounce($,z=100,N=!1,H){return new T(h(this.event,$,z,N,H))}on($,z,N){return this.event($,z,N)}once($,z,N){return o(this.event)($,z,N)}}function U(W){return new T(W)}P.chain=U;function B(W,$,z=N=>N){const N=(...A)=>_.fire(z(...A)),H=()=>W.on($,N),V=()=>W.removeListener($,N),_=new E({onFirstListenerAdd:H,onLastListenerRemove:V});return _.event}P.fromNodeEventEmitter=B;function X(W,$,z=N=>N){const N=(...A)=>_.fire(z(...A)),H=()=>W.addEventListener($,N),V=()=>W.removeEventListener($,N),_=new E({onFirstListenerAdd:H,onLastListenerRemove:V});return _.event}P.fromDOMEventEmitter=X;function te(W){const $=new E;let z=!1;return W.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}P.fromPromise=te;function oe(W){return new Promise($=>o(W)($))}P.toPromise=oe})(r=e.Event||(e.Event={}));class w{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${w._idPool++}`}start(o){this._stopWatch=new I.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}w._idPool=0;let p=-1;function n(P){const o=p;return p=P,{dispose(){p=o}}}e.setGlobalLeakWarningThreshold=n;class S{constructor(o,u=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o){let u=p;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),!(u<=0||o<u)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(l)||0;if(this._stacks.set(l,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[s,a]of this._stacks)(!t||i<a)&&(t=s,i=a);console.warn(`[${this.name}] potential listener LEAK detected, having ${o} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class E{constructor(o){var u;this._disposed=!1,this._options=o,this._leakageMon=p>0?new S(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new w(this._options._profName):void 0}get event(){return this._event||(this._event=(o,u,l)=>{var c;this._listeners||(this._listeners=new y.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[o,u]:o);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,u);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let a;return a={dispose:()=>{s&&s(),a.dispose=E._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof L.DisposableStore?l.add(a):Array.isArray(l)&&l.push(a),a}),this._event}fire(o){var u,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,o]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(i){(0,v.onUnexpectedError)(i)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var o,u,l;(o=this._listeners)===null||o===void 0||o.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class b extends E{constructor(o){super(o);this._isPaused=0,this._eventQueue=new y.LinkedList,this._mergeFn=o==null?void 0:o.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}e.PauseableEmitter=b;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const u={event:o,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const l=()=>{this.hasListeners&&this.unhook(u);const c=this.events.indexOf(u);this.events.splice(c,1)};return(0,L.toDisposable)((0,R.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(u=>this.emitter.fire(u))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class m{constructor(){this.buffers=[]}wrapEvent(o){return(u,l,c)=>o(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(l,t)):u.call(l,t)},void 0,c)}bufferEvents(o){const u=[];this.buffers.push(u);const l=o();return this.buffers.pop(),u.forEach(c=>c()),l}}e.EventBufferer=m;class M{constructor(){this.listening=!1,this.inputEvent=r.None,this.inputEventListener=L.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=M}),define(Q[26],J([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(r,w){const p=setTimeout(r.bind(w),0);return{dispose(){clearTimeout(p)}}});var L;(function(r){function w(p){return p===r.None||p===r.Cancelled||p instanceof y?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}r.isCancellationToken=w,r.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),r.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(L=e.CancellationToken||(e.CancellationToken={}));class y{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(w){this._token=void 0,this._parentListener=void 0,this._parentListener=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new y),this._token}cancel(){this._token?this._token instanceof y&&this._token.cancel():this._token=L.Cancelled}dispose(w=!1){w&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof y&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=I}),define(Q[107],J([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(S){const E=this._icons.get(S.id);E?S.description?E.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new R;e.iconRegistry=L;function y(n,S){return new r(n,S)}e.registerCodicon=y;function I(n){return n?n.replace(/\$\((.*?)\)/g,(S,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=I;class r{constructor(S,E,b){this.id=S,this.definition=E,this.description=b,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=r;function w(n,S){const E=["codicon","codicon-"+n];return S&&E.push("codicon-modifier-"+S),E}e.getClassNamesArray=w;var p;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const S=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function E(m){if(m instanceof r)return["codicon","codicon-"+m.id];const M=S.exec(m.id);if(!M)return E(r.error);let[,P,o]=M;const u=["codicon","codicon-"+P];return o&&u.push("codicon-modifier-"+o.substr(1)),u}n.asClassNameArray=E;function b(m){return E(m).join(" ")}n.asClassName=b;function d(m){return"."+E(m).join(".")}n.asCSSSelector=d})(p=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(r=e.Codicon||(e.Codicon={}))}),define(Q[64],J([0,1,19,2]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=L;function y(u){const l=u;return l?L(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=y;function I(u,l){return new r(u,l)}e.newWriteableStream=I;class r{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,v.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(c);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(u,l){const c=[];let t;for(;(t=u.read())!==null;)c.push(t);return l(c)}e.consumeReadable=w;function p(u,l,c){const t=[];let i;for(;(i=u.read())!==null&&t.length<c;)t.push(i);return i===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=p;function n(u,l){return new Promise((c,t)=>{const i=[];S(u,{onData:s=>{l&&i.push(s)},onError:s=>{l?t(s):c(void 0)},onEnd:()=>{c(l?l(i):void 0)}})})}e.consumeStream=n;function S(u,l){u.on("error",c=>l.onError(c)),u.on("end",()=>l.onEnd()),u.on("data",c=>l.onData(c))}e.listenStream=S;function E(u,l){return new Promise((c,t)=>{const i=new R.DisposableStore,s=[],a=g=>{if(s.push(g),s.length>l)return i.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},h=g=>t(g),f=()=>c({stream:u,buffer:s,ended:!0});i.add((0,R.toDisposable)(()=>u.removeListener("error",h))),u.on("error",h),i.add((0,R.toDisposable)(()=>u.removeListener("end",f))),u.on("end",f),i.add((0,R.toDisposable)(()=>u.removeListener("data",a))),u.on("data",a)})}e.peekStream=E;function b(u,l){const c=I(l);return c.end(u),c}e.toStream=b;function d(){const u=I(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=d;function m(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.toReadable=m;function M(u,l,c){const t=I(c);return S(u,{onData:i=>t.write(l.data(i)),onError:i=>t.error(l.error?l.error(i):i),onEnd:()=>t.end()}),t}e.transform=M;function P(u,l,c){let t=!1;return{read:()=>{const i=l.read();return t?i:(t=!0,i!==null?c([u,i]):u)}}}e.prefixedReadable=P;function o(u,l,c){let t=!1;const i=I(c);return S(l,{onData:s=>t?i.write(s):(t=!0,i.write(c([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=o}),define(Q[22],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(q){return!q||typeof q!="string"?!0:q.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function L(q,...ie){return ie.length===0?q:q.replace(R,function(ae,le){const de=parseInt(le,10);return isNaN(de)||de<0||de>=ie.length?ae:ie[de]})}e.format=L;function y(q){return q.replace(/[<>&]/g,function(ie){switch(ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ie}})}e.escape=y;function I(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function r(q,ie){let ae=0;const le=ie.charCodeAt(0);for(let de=q.length-1;de>=0;de--)q.charCodeAt(de)===le&&ae++;return ae}e.count=r;function w(q,ie,ae="\u2026"){return q.length<=ie?q:`${q.substr(0,ie)}${ae}`}e.truncate=w;function p(q,ie=" "){const ae=n(q,ie);return S(ae,ie)}e.trim=p;function n(q,ie){if(!q||!ie)return q;const ae=ie.length;if(ae===0||q.length===0)return q;let le=0;for(;q.indexOf(ie,le)===le;)le=le+ae;return q.substring(le)}e.ltrim=n;function S(q,ie){if(!q||!ie)return q;const ae=ie.length,le=q.length;if(ae===0||le===0)return q;let de=le,ye=-1;for(;ye=q.lastIndexOf(ie,de-1),!(ye===-1||ye+ae!==de);){if(ye===0)return"";de=ye}return q.substring(0,de)}e.rtrim=S;function E(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function b(q){return q.replace(/\*/g,"")}e.stripWildcards=b;function d(q,ie,ae={}){if(!q)throw new Error("Cannot create regex from empty string");ie||(q=I(q)),ae.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let le="";return ae.global&&(le+="g"),ae.matchCase||(le+="i"),ae.multiline&&(le+="m"),ae.unicode&&(le+="u"),new RegExp(q,le)}e.createRegExp=d;function m(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function M(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=M;function P(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}e.regExpFlags=P;function o(q){return q.split(/\r\n|\r|\n/)}e.splitLines=o;function u(q){for(let ie=0,ae=q.length;ie<ae;ie++){const le=q.charCodeAt(ie);if(le!==32&&le!==9)return ie}return-1}e.firstNonWhitespaceIndex=u;function l(q,ie=0,ae=q.length){for(let le=ie;le<ae;le++){const de=q.charCodeAt(le);if(de!==32&&de!==9)return q.substring(ie,le)}return q.substring(ie,ae)}e.getLeadingWhitespace=l;function c(q,ie=q.length-1){for(let ae=ie;ae>=0;ae--){const le=q.charCodeAt(ae);if(le!==32&&le!==9)return ae}return-1}e.lastNonWhitespaceIndex=c;function t(q,ie){return q<ie?-1:q>ie?1:0}e.compare=t;function i(q,ie,ae=0,le=q.length,de=0,ye=ie.length){for(;ae<le&&de<ye;ae++,de++){let We=q.charCodeAt(ae),Ne=ie.charCodeAt(de);if(We<Ne)return-1;if(We>Ne)return 1}const Me=le-ae,Te=ye-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstring=i;function s(q,ie){return a(q,ie,0,q.length,0,ie.length)}e.compareIgnoreCase=s;function a(q,ie,ae=0,le=q.length,de=0,ye=ie.length){for(;ae<le&&de<ye;ae++,de++){let We=q.charCodeAt(ae),Ne=ie.charCodeAt(de);if(We!==Ne){const he=We-Ne;if(!(he===32&&f(Ne))&&!(he===-32&&f(We)))return h(We)&&h(Ne)?he:i(q.toLowerCase(),ie.toLowerCase(),ae,le,de,ye)}}const Me=le-ae,Te=ye-de;return Me<Te?-1:Me>Te?1:0}e.compareSubstringIgnoreCase=a;function h(q){return q>=97&&q<=122}e.isLowerAsciiLetter=h;function f(q){return q>=65&&q<=90}e.isUpperAsciiLetter=f;function g(q){return h(q)||f(q)}function k(q,ie){return q.length===ie.length&&T(q,ie)}e.equalsIgnoreCase=k;function T(q,ie,ae=q.length){for(let le=0;le<ae;le++){const de=q.charCodeAt(le),ye=ie.charCodeAt(le);if(de!==ye){if(g(de)&&g(ye)){const Me=Math.abs(de-ye);if(Me!==0&&Me!==32)return!1}else if(String.fromCharCode(de).toLowerCase()!==String.fromCharCode(ye).toLowerCase())return!1}}return!0}function U(q,ie){const ae=ie.length;return ie.length>q.length?!1:T(q,ie,ae)}e.startsWithIgnoreCase=U;function B(q,ie){let ae,le=Math.min(q.length,ie.length);for(ae=0;ae<le;ae++)if(q.charCodeAt(ae)!==ie.charCodeAt(ae))return ae;return le}e.commonPrefixLength=B;function X(q,ie){let ae,le=Math.min(q.length,ie.length);const de=q.length-1,ye=ie.length-1;for(ae=0;ae<le;ae++)if(q.charCodeAt(de-ae)!==ie.charCodeAt(ye-ae))return ae;return le}e.commonSuffixLength=X;function te(q){return 55296<=q&&q<=56319}e.isHighSurrogate=te;function oe(q){return 56320<=q&&q<=57343}e.isLowSurrogate=oe;function W(q,ie){return(q-55296<<10)+(ie-56320)+65536}e.computeCodePoint=W;function $(q,ie,ae){const le=q.charCodeAt(ae);if(te(le)&&ae+1<ie){const de=q.charCodeAt(ae+1);if(oe(de))return W(le,de)}return le}e.getNextCodePoint=$;function z(q,ie){const ae=q.charCodeAt(ie-1);if(oe(ae)&&ie>1){const le=q.charCodeAt(ie-2);if(te(le))return W(le,ae)}return ae}function N(q,ie){const ae=Be.getInstance(),le=ie,de=q.length,ye=$(q,de,ie);ie+=ye>=65536?2:1;let Me=ae.getGraphemeBreakType(ye);for(;ie<de;){const Te=$(q,de,ie),We=ae.getGraphemeBreakType(Te);if(He(Me,We))break;ie+=Te>=65536?2:1,Me=We}return ie-le}e.nextCharLength=N;function H(q,ie){const ae=Be.getInstance(),le=ie,de=z(q,ie);ie-=de>=65536?2:1;let ye=ae.getGraphemeBreakType(de);for(;ie>0;){const Me=z(q,ie),Te=ae.getGraphemeBreakType(Me);if(He(Te,ye))break;ie-=Me>=65536?2:1,ye=Te}return le-ie}e.prevCharLength=H;function V(q,ie){const ae=Be.getInstance(),le=q.length,de=ie,ye=$(q,le,ie),Me=ae.getGraphemeBreakType(ye);ie+=ye>=65536?2:1;let Te=Me;for(;ie<le;){const Ne=$(q,le,ie),he=ae.getGraphemeBreakType(Ne);if(He(Te,he))break;ie+=Ne>=65536?2:1,Te=he}const We=ie;for(ie=de,Te=Me;ie>0;){const Ne=z(q,ie),he=ae.getGraphemeBreakType(Ne);if(He(he,Te))break;ie-=Ne>=65536?2:1,Te=he}return[ie,We]}function _(q,ie){return ie>0&&oe(q.charCodeAt(ie))?V(q,ie-1):V(q,ie)}e.getCharContainingOffset=_;function A(q){const ie=q.length;let ae=0,le=0;for(;le<ie;){const Me=$(q,ie,le);le+=Me>=65536?2:1,Me<128?ae+=1:Me<2048?ae+=2:Me<65536?ae+=3:ae+=4}const de=new Uint8Array(ae);le=0;let ye=0;for(;le<ie;){const Me=$(q,ie,le);le+=Me>=65536?2:1,Me<128?de[ye++]=Me:Me<2048?(de[ye++]=192|(Me&1984)>>>6,de[ye++]=128|(Me&63)>>>0):Me<65536?(de[ye++]=224|(Me&61440)>>>12,de[ye++]=128|(Me&4032)>>>6,de[ye++]=128|(Me&63)>>>0):(de[ye++]=240|(Me&1835008)>>>18,de[ye++]=128|(Me&258048)>>>12,de[ye++]=128|(Me&4032)>>>6,de[ye++]=128|(Me&63)>>>0)}return de}e.encodeUTF8=A;function O(q){const ie=q.byteLength,ae=[];let le=0;for(;le<ie;){const de=q[le];let ye;if(de>=240&&le+3<ie?ye=(q[le++]&7)<<18>>>0|(q[le++]&63)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:de>=224&&le+2<ie?ye=(q[le++]&15)<<12>>>0|(q[le++]&63)<<6>>>0|(q[le++]&63)<<0>>>0:de>=192&&le+1<ie?ye=(q[le++]&31)<<6>>>0|(q[le++]&63)<<0>>>0:ye=q[le++],ye>=0&&ye<=55295||ye>=57344&&ye<=65535)ae.push(String.fromCharCode(ye));else if(ye>=65536&&ye<=1114111){const Me=ye-65536,Te=55296+((Me&1047552)>>>10),We=56320+((Me&1023)>>>0);ae.push(String.fromCharCode(Te)),ae.push(String.fromCharCode(We))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=O;const D=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function F(q){return D.test(q)}e.containsRTL=F;const C=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(q){return C.test(q)}e.containsEmoji=K;const G=/^[\t\n\r\x20-\x7E]*$/;function Y(q){return G.test(q)}e.isBasicASCII=Y,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(q){return e.UNUSUAL_LINE_TERMINATORS.test(q)}e.containsUnusualLineTerminators=Z;function re(q){for(let ie=0,ae=q.length;ie<ae;ie++)if(se(q.charCodeAt(ie)))return!0;return!1}e.containsFullWidthCharacter=re;function se(q){return q=+q,q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}e.isFullWidthCharacter=se;function x(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129003||q>=129280&&q<=129535||q>=129648&&q<=129750}e.isEmojiImprecise=x;function ne(q,ie){if(q.length<ie)return q;const ae=/\b/g;let le=0;for(;ae.test(q)&&!(q.length-ae.lastIndex<ie);)le=ae.lastIndex,ae.lastIndex+=1;return q.substring(le).replace(/^\s/,"")}e.lcut=ne;const ue=/\x1B\x5B[12]?K/g,be=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function Ee(q){return q&&(q=q.replace(ue,""),q=q.replace(be,""),q=q.replace(me,"")),q}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Le(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Le;function we(q){return Le(q)?q.substr(1):q}e.stripUTF8BOM=we;function ve(q,ie){if(!q||!ie||q.length<ie.length)return!1;const ae=ie.length,le=q.toLowerCase();let de=0,ye=-1;for(;de<ae;){const Me=le.indexOf(ie[de],ye+1);if(Me<0)return!1;ye=Me,de++}return!0}e.fuzzyContains=ve;function Ie(q,ie=!1){return q?(ie&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}e.containsUppercaseCharacter=Ie;function Re(q){return q.charAt(0).toUpperCase()+q.slice(1)}e.uppercaseFirstLetter=Re;function _e(q,ie=1){if(ie===0)return"";let ae=-1;do ae=q.indexOf(`
`,ae+1),ie--;while(ie>0&&ae>=0);return ae===-1?q:(q[ae-1]==="\r"&&ae--,q.substr(0,ae))}e.getNLines=_e;function Ve(q){const ie=90-65+1;return q=q%(2*ie),q<ie?String.fromCharCode(97+q):String.fromCharCode(65+q-ie)}e.singleLetterHash=Ve;function Ze(q){return Be.getInstance().getGraphemeBreakType(q)}e.getGraphemeBreakType=Ze;function He(q,ie){return q===0?ie!==5&&ie!==7:q===2&&ie===3?!1:q===4||q===2||q===3||ie===4||ie===2||ie===3?!0:!(q===8&&(ie===8||ie===9||ie===11||ie===12)||(q===11||q===9)&&(ie===9||ie===10)||(q===12||q===10)&&ie===10||ie===5||ie===13||ie===7||q===1||q===13&&ie===14||q===6&&ie===6)}e.breakBetweenGraphemeBreakType=He;var ht;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(ht=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=ot()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(ie){if(ie<32)return ie===10?3:ie===13?2:4;if(ie<127)return 0;const ae=this._data,le=ae.length/3;let de=1;for(;de<=le;)if(ie<ae[3*de])de=2*de;else if(ie>ae[3*de+1])de=2*de+1;else return ae[3*de+2];return 0}}Be._INSTANCE=null;function ot(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function tt(q,ie){if(q===0)return 0;const ae=dt(q,ie);if(ae!==void 0)return ae;const le=z(ie,q);return q-=Ke(le),q}e.getLeftDeleteOffset=tt;function dt(q,ie){let ae=z(ie,q);for(q-=Ke(ae);ft(ae)||ae===65039||ae===8419;){if(q===0)return;ae=z(ie,q),q-=Ke(ae)}if(!!x(ae)){if(q>=0){const le=z(ie,q);le===8205&&(q-=Ke(le))}return q}}function Ke(q){return q>=65536?2:1}function ft(q){return 127995<=q&&q<=127999}var at;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={}))}),define(Q[23],J([0,1,22,64]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",y=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let r,w;class p{constructor(g){this.buffer=g,this.byteLength=this.buffer.byteLength}static alloc(g){return L?new p(Buffer.allocUnsafe(g)):new p(new Uint8Array(g))}static wrap(g){return L&&!Buffer.isBuffer(g)&&(g=Buffer.from(g.buffer,g.byteOffset,g.byteLength)),new p(g)}static fromString(g,k){return!((k==null?void 0:k.dontUseNodeBuffer)||!1)&&L?new p(Buffer.from(g)):y?(r||(r=new TextEncoder),new p(r.encode(g))):new p(v.encodeUTF8(g))}static concat(g,k){if(typeof k=="undefined"){k=0;for(let B=0,X=g.length;B<X;B++)k+=g[B].byteLength}const T=p.alloc(k);let U=0;for(let B=0,X=g.length;B<X;B++){const te=g[B];T.set(te,U),U+=te.byteLength}return T}toString(){return L?this.buffer.toString():I?(w||(w=new TextDecoder),w.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(g,k){return new p(this.buffer.subarray(g,k))}set(g,k){g instanceof p?this.buffer.set(g.buffer,k):this.buffer.set(g,k)}readUInt32BE(g){return E(this.buffer,g)}writeUInt32BE(g,k){b(this.buffer,g,k)}readUInt32LE(g){return d(this.buffer,g)}writeUInt32LE(g,k){m(this.buffer,g,k)}readUInt8(g){return M(this.buffer,g)}writeUInt8(g,k){P(this.buffer,g,k)}}e.VSBuffer=p;function n(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0}e.readUInt16LE=n;function S(f,g,k){f[k+0]=g&255,g=g>>>8,f[k+1]=g&255}e.writeUInt16LE=S;function E(f,g){return f[g]*2**24+f[g+1]*2**16+f[g+2]*2**8+f[g+3]}e.readUInt32BE=E;function b(f,g,k){f[k+3]=g,g=g>>>8,f[k+2]=g,g=g>>>8,f[k+1]=g,g=g>>>8,f[k]=g}e.writeUInt32BE=b;function d(f,g){return f[g+0]<<0>>>0|f[g+1]<<8>>>0|f[g+2]<<16>>>0|f[g+3]<<24>>>0}e.readUInt32LE=d;function m(f,g,k){f[k+0]=g&255,g=g>>>8,f[k+1]=g&255,g=g>>>8,f[k+2]=g&255,g=g>>>8,f[k+3]=g&255}e.writeUInt32LE=m;function M(f,g){return f[g]}e.readUInt8=M;function P(f,g,k){f[k]=g}e.writeUInt8=P;function o(f){return R.consumeReadable(f,g=>p.concat(g))}e.readableToBuffer=o;function u(f){return R.toReadable(f)}e.bufferToReadable=u;function l(f){return R.consumeStream(f,g=>p.concat(g))}e.streamToBuffer=l;async function c(f){return f.ended?p.concat(f.buffer):p.concat([...f.buffer,await l(f.stream)])}e.bufferedStreamToBuffer=c;function t(f){return R.toStream(f,g=>p.concat(g))}e.bufferToStream=t;function i(f){return R.transform(f,{data:g=>typeof g=="string"?p.fromString(g):p.wrap(g)},g=>p.concat(g))}e.streamToBufferReadableStream=i;function s(f){return R.newWriteableStream(g=>p.concat(g),f)}e.newWriteableBufferStream=s;function a(f,g){return R.prefixedReadable(f,g,k=>p.concat(k))}e.prefixedBufferReadable=a;function h(f,g){return R.prefixedStream(f,g,k=>p.concat(k))}e.prefixedBufferStream=h}),define(Q[80],J([0,1,22]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(P){return L(P,0)}e.hash=R;function L(P,o){switch(typeof P){case"object":return P===null?y(349,o):Array.isArray(P)?w(P,o):p(P,o);case"string":return r(P,o);case"boolean":return I(P,o);case"number":return y(P,o);case"undefined":return y(937,o);default:return y(617,o)}}e.doHash=L;function y(P,o){return(o<<5)-o+P|0}function I(P,o){return y(P?433:863,o)}function r(P,o){o=y(149417,o);for(let u=0,l=P.length;u<l;u++)o=y(P.charCodeAt(u),o);return o}e.stringHash=r;function w(P,o){return o=y(104579,o),P.reduce((u,l)=>L(l,u),o)}function p(P,o){return o=y(181387,o),Object.keys(P).sort().reduce((u,l)=>(u=r(l,u),L(P[l],u)),o)}class n{constructor(){this._value=0}get value(){return this._value}hash(o){return this._value=L(o,this._value),this._value}}e.Hasher=n;var S;(function(P){P[P.BLOCK_SIZE=64]="BLOCK_SIZE",P[P.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function E(P,o,u=32){const l=u-o,c=~((1<<l)-1);return(P<<o|(c&P)>>>l)>>>0}function b(P,o=0,u=P.byteLength,l=0){for(let c=0;c<u;c++)P[o+c]=l}function d(P,o,u="0"){for(;P.length<o;)P=u+P;return P}function m(P,o=32){return P instanceof ArrayBuffer?Array.from(new Uint8Array(P)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((P>>>0).toString(16),o/4)}e.toHexString=m;class M{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(o){const u=o.length;if(u!==0){const l=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=o.charCodeAt(0),s=0);;){let a=i;if(v.isHighSurrogate(i))if(s+1<u){const h=o.charCodeAt(s+1);v.isLowSurrogate(h)?(s++,a=v.computeCodePoint(i,h)):a=65533}else{t=i;break}else v.isLowSurrogate(i)&&(a=65533);if(c=this._push(l,c,a),s++,s<u)i=o.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(o,u,l){return l<128?o[u++]=l:l<2048?(o[u++]=192|(l&1984)>>>6,o[u++]=128|(l&63)>>>0):l<65536?(o[u++]=224|(l&61440)>>>12,o[u++]=128|(l&4032)>>>6,o[u++]=128|(l&63)>>>0):(o[u++]=240|(l&1835008)>>>18,o[u++]=128|(l&258048)>>>12,o[u++]=128|(l&4032)>>>6,o[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const o=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(o/4294967296),!1),this._buffDV.setUint32(60,o%4294967296,!1),this._step()}_step(){const o=M._bigBlock32,u=this._buffDV;for(let g=0;g<64;g+=4)o.setUint32(g,u.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)o.setUint32(g,E(o.getUint32(g-12,!1)^o.getUint32(g-32,!1)^o.getUint32(g-56,!1)^o.getUint32(g-64,!1),1),!1);let l=this._h0,c=this._h1,t=this._h2,i=this._h3,s=this._h4,a,h,f;for(let g=0;g<80;g++)g<20?(a=c&t|~c&i,h=1518500249):g<40?(a=c^t^i,h=1859775393):g<60?(a=c&t|c&i|t&i,h=2400959708):(a=c^t^i,h=3395469782),f=E(l,5)+a+s+h+o.getUint32(g*4,!1)&4294967295,s=i,i=t,t=E(c,30),c=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=M,M._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[13],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(g){return Array.isArray(g)}e.isArray=v;function R(g){return typeof g=="string"}e.isString=R;function L(g){return Array.isArray(g)&&g.every(k=>R(k))}e.isStringArray=L;function y(g){return typeof g=="object"&&g!==null&&!Array.isArray(g)&&!(g instanceof RegExp)&&!(g instanceof Date)}e.isObject=y;function I(g){return typeof g=="number"&&!isNaN(g)}e.isNumber=I;function r(g){return!!g&&typeof g[Symbol.iterator]=="function"}e.isIterable=r;function w(g){return g===!0||g===!1}e.isBoolean=w;function p(g){return typeof g=="undefined"}e.isUndefined=p;function n(g){return!S(g)}e.isDefined=n;function S(g){return p(g)||g===null}e.isUndefinedOrNull=S;function E(g,k){if(!g)throw new Error(k?`Unexpected type, expected '${k}'`:"Unexpected type")}e.assertType=E;function b(g){if(S(g))throw new Error("Assertion Failed: argument is undefined or null");return g}e.assertIsDefined=b;function d(...g){const k=[];for(let T=0;T<g.length;T++){const U=g[T];if(S(U))throw new Error(`Assertion Failed: argument at index ${T} is undefined or null`);k.push(U)}return k}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function M(g){if(!y(g))return!1;for(let k in g)if(m.call(g,k))return!1;return!0}e.isEmptyObject=M;function P(g){return typeof g=="function"}e.isFunction=P;function o(...g){return g.length>0&&g.every(P)}e.areFunctions=o;function u(g,k){const T=Math.min(g.length,k.length);for(let U=0;U<T;U++)l(g[U],k[U])}e.validateConstraints=u;function l(g,k){if(R(k)){if(typeof g!==k)throw new Error(`argument does not match constraint: typeof ${k}`)}else if(P(k)){try{if(g instanceof k)return}catch(T){}if(!S(g)&&g.constructor===k||k.length===1&&k.call(void 0,g)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(g){let k=[],T=Object.getPrototypeOf(g);for(;Object.prototype!==T;)k=k.concat(Object.getOwnPropertyNames(T)),T=Object.getPrototypeOf(T);return k}e.getAllPropertyNames=c;function t(g){const k=[];for(const T of c(g))typeof g[T]=="function"&&k.push(T);return k}e.getAllMethodNames=t;function i(g,k){const T=B=>function(){const X=Array.prototype.slice.call(arguments,0);return k(B,X)};let U={};for(const B of g)U[B]=T(B);return U}e.createProxyObject=i;function s(g){return g===null?void 0:g}e.withNullAsUndefined=s;function a(g){return typeof g=="undefined"?null:g}e.withUndefinedAsNull=a;function h(g){return class{constructor(){return new Proxy({},{get(k,T){if(k[T])return k[T];throw new Error(`Not Implemented: ${g}->${String(T)}`)}})}}}e.NotImplementedProxy=h;function f(g){throw new Error("Unreachable")}e.assertNever=f}),define(Q[30],J([0,1,3,22,7,13]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function I(i){return i===47||i===92}e.isPathSeparator=I;function r(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=r;function w(i,s=L.posix.sep){if(!i)return"";const a=i.length,h=i.charCodeAt(0);if(I(h)){if(I(i.charCodeAt(1))&&!I(i.charCodeAt(2))){let g=3;const k=g;for(;g<a&&!I(i.charCodeAt(g));g++);if(k!==g&&!I(i.charCodeAt(g+1))){for(g+=1;g<a;g++)if(I(i.charCodeAt(g)))return i.slice(0,g+1).replace(/[\\/]/g,s)}}return s}else if(M(h)&&i.charCodeAt(1)===58)return I(i.charCodeAt(2))?i.slice(0,2)+s:i.slice(0,2);let f=i.indexOf("://");if(f!==-1){for(f+=3;f<a;f++)if(I(i.charCodeAt(f)))return i.slice(0,f+1)}return""}e.getRoot=w;function p(i){if(!v.isWindows||!i||i.length<5)return!1;let s=i.charCodeAt(0);if(s!==92||(s=i.charCodeAt(1),s!==92))return!1;let a=2;const h=a;for(;a<i.length&&(s=i.charCodeAt(a),s!==92);a++);return!(h===a||(s=i.charCodeAt(a+1),isNaN(s)||s===92))}e.isUNC=p;const n=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(i,s=v.isWindows){const a=s?n:S;return!(!i||i.length===0||/^\s+$/.test(i)||(a.lastIndex=0,a.test(i))||s&&E.test(i)||i==="."||i===".."||s&&i[i.length-1]==="."||s&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=b;function d(i,s,a){const h=i===s;return!a||h?h:!i||!s?!1:(0,R.equalsIgnoreCase)(i,s)}e.isEqual=d;function m(i,s,a,h=L.sep){if(i===s)return!0;if(!i||!s||s.length>i.length)return!1;if(a){if(!(0,R.startsWithIgnoreCase)(i,s))return!1;if(s.length===i.length)return!0;let g=s.length;return s.charAt(s.length-1)===h&&g--,i.charAt(g)===h}return s.charAt(s.length-1)!==h&&(s+=h),i.indexOf(s)===0}e.isEqualOrParent=m;function M(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=M;function P(i,s){return v.isWindows&&i.endsWith(":")&&(i+=L.sep),(0,L.isAbsolute)(i)||(i=(0,L.join)(s,i)),i=(0,L.normalize)(i),v.isWindows?(i=(0,R.rtrim)(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=(0,R.rtrim)(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=P;function o(i){const s=(0,L.normalize)(i);return v.isWindows?i.length>3?!1:u(s)&&(i.length===2||s.charCodeAt(2)===92):s===L.posix.sep}e.isRootOrDriveLetter=o;function u(i){return v.isWindows?M(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=u;function l(i){return u(i)?i[0]:void 0}e.getDriveLetter=l;function c(i,s,a){return s.length>i.length?-1:i===s?0:(a&&(i=i.toLowerCase(),s=s.toLowerCase()),i.indexOf(s))}e.indexOfPath=c;function t(i){const s=i.split(":");let a,h,f;if(s.forEach(g=>{const k=Number(g);(0,y.isNumber)(k)?h===void 0?h=k:f===void 0&&(f=k):a=a?[a,g].join(":"):g}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(Q[44],J([0,1,13]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const M=Array.isArray(m)?[]:{};return Object.keys(m).forEach(P=>{m[P]&&typeof m[P]=="object"?M[P]=R(m[P]):M[P]=m[P]}),M}e.deepClone=R;function L(m){if(!m||typeof m!="object")return m;const M=[m];for(;M.length>0;){const P=M.shift();Object.freeze(P);for(const o in P)if(y.call(P,o)){const u=P[o];typeof u=="object"&&!Object.isFrozen(u)&&M.push(u)}}return m}e.deepFreeze=L;const y=Object.prototype.hasOwnProperty;function I(m,M){return r(m,M,new Set)}e.cloneAndChange=I;function r(m,M,P){if((0,v.isUndefinedOrNull)(m))return m;const o=M(m);if(typeof o!="undefined")return o;if((0,v.isArray)(m)){const u=[];for(const l of m)u.push(r(l,M,P));return u}if((0,v.isObject)(m)){if(P.has(m))throw new Error("Cannot clone recursive data-structure");P.add(m);const u={};for(let l in m)y.call(m,l)&&(u[l]=r(m[l],M,P));return P.delete(m),u}return m}function w(m,M,P=!0){return(0,v.isObject)(m)?((0,v.isObject)(M)&&Object.keys(M).forEach(o=>{o in m?P&&((0,v.isObject)(m[o])&&(0,v.isObject)(M[o])?w(m[o],M[o],P):m[o]=M[o]):m[o]=M[o]}),m):M}e.mixin=w;function p(m,M){if(m===M)return!0;if(m==null||M===null||M===void 0||typeof m!=typeof M||typeof m!="object"||Array.isArray(m)!==Array.isArray(M))return!1;let P,o;if(Array.isArray(m)){if(m.length!==M.length)return!1;for(P=0;P<m.length;P++)if(!p(m[P],M[P]))return!1}else{const u=[];for(o in m)u.push(o);u.sort();const l=[];for(o in M)l.push(o);if(l.sort(),!p(u,l))return!1;for(P=0;P<u.length;P++)if(!p(m[u[P]],M[u[P]]))return!1}return!0}e.equals=p;function n(m){const M=new Set;return JSON.stringify(m,(P,o)=>{if((0,v.isObject)(o)||Array.isArray(o)){if(M.has(o))return"[Circular]";M.add(o)}return o})}e.safeStringify=n;function S(m,M,P){const o=M(m);return typeof o=="undefined"?P:o}e.getOrDefault=S;function E(m,M){const P=Object.create(null);return!m||!M||Object.keys(M).forEach(u=>{const l=m[u],c=M[u];p(l,c)||(P[u]=c)}),P}e.distinct=E;function b(m,M){const P=M.toLowerCase(),o=Object.keys(m).find(u=>u.toLowerCase()===P);return o?m[o]:m[M]}e.getCaseInsensitive=b;function d(m,M){const P=Object.create(null);for(const o of Object.keys(m))M(o,m[o])&&(P[o]=m[o]);return P}e.filter=d}),define(Q[8],J([0,1,3,7]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,y=/^\//,I=/^\/\//;function r(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!y.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(s,a){return!s&&!a?"file":s}function p(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==S&&(a=S+a):a=S;break}return a}const n="",S="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(a,h,f,g,k,T=!1){typeof a=="object"?(this.scheme=a.scheme||n,this.authority=a.authority||n,this.path=a.path||n,this.query=a.query||n,this.fragment=a.fragment||n):(this.scheme=w(a,T),this.authority=h||n,this.path=p(this.scheme,f||n),this.query=g||n,this.fragment=k||n,r(this,T))}static isUri(a){return a instanceof b?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}get fsPath(){return u(this,!1)}with(a){if(!a)return this;let{scheme:h,authority:f,path:g,query:k,fragment:T}=a;return h===void 0?h=this.scheme:h===null&&(h=n),f===void 0?f=this.authority:f===null&&(f=n),g===void 0?g=this.path:g===null&&(g=n),k===void 0?k=this.query:k===null&&(k=n),T===void 0?T=this.fragment:T===null&&(T=n),h===this.scheme&&f===this.authority&&g===this.path&&k===this.query&&T===this.fragment?this:new m(h,f,g,k,T)}static parse(a,h=!1){const f=E.exec(a);return f?new m(f[2]||n,i(f[4]||n),i(f[5]||n),i(f[7]||n),i(f[9]||n),h):new m(n,n,n,n,n)}static file(a){let h=n;if(v.isWindows&&(a=a.replace(/\\/g,S)),a[0]===S&&a[1]===S){const f=a.indexOf(S,2);f===-1?(h=a.substring(2),a=S):(h=a.substring(2,f),a=a.substring(f)||S)}return new m("file",h,a,n,n)}static from(a){return new m(a.scheme,a.authority,a.path,a.query,a.fragment)}static joinPath(a,...h){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&a.scheme==="file"?f=b.file(R.win32.join(u(a,!0),...h)).path:f=R.posix.join(a.path,...h),a.with({path:f})}toString(a=!1){return l(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof b)return a;{const h=new m(a);return h._formatted=a.external,h._fsPath=a._sep===d?a.fsPath:null,h}}else return a}}e.URI=b;const d=v.isWindows?1:void 0;class m extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(a=!1){return a?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=d),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const M={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function P(s,a){let h,f=-1;for(let g=0;g<s.length;g++){const k=s.charCodeAt(g);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||a&&k===47)f!==-1&&(h+=encodeURIComponent(s.substring(f,g)),f=-1),h!==void 0&&(h+=s.charAt(g));else{h===void 0&&(h=s.substr(0,g));const T=M[k];T!==void 0?(f!==-1&&(h+=encodeURIComponent(s.substring(f,g)),f=-1),h+=T):f===-1&&(f=g)}}return f!==-1&&(h+=encodeURIComponent(s.substring(f))),h!==void 0?h:s}function o(s){let a;for(let h=0;h<s.length;h++){const f=s.charCodeAt(h);f===35||f===63?(a===void 0&&(a=s.substr(0,h)),a+=M[f]):a!==void 0&&(a+=s[h])}return a!==void 0?a:s}function u(s,a){let h;return s.authority&&s.path.length>1&&s.scheme==="file"?h=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?h=s.path.substr(1):h=s.path[1].toLowerCase()+s.path.substr(2):h=s.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=u;function l(s,a){const h=a?o:P;let f="",{scheme:g,authority:k,path:T,query:U,fragment:B}=s;if(g&&(f+=g,f+=":"),(k||g==="file")&&(f+=S,f+=S),k){let X=k.indexOf("@");if(X!==-1){const te=k.substr(0,X);k=k.substr(X+1),X=te.indexOf(":"),X===-1?f+=h(te,!1):(f+=h(te.substr(0,X),!1),f+=":",f+=h(te.substr(X+1),!1)),f+="@"}k=k.toLowerCase(),X=k.indexOf(":"),X===-1?f+=h(k,!1):(f+=h(k.substr(0,X),!1),f+=k.substr(X))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const X=T.charCodeAt(1);X>=65&&X<=90&&(T=`/${String.fromCharCode(X+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const X=T.charCodeAt(0);X>=65&&X<=90&&(T=`${String.fromCharCode(X+32)}:${T.substr(2)}`)}f+=h(T,!0)}return U&&(f+="?",f+=h(U,!1)),B&&(f+="#",f+=a?B:P(B,!1)),f}function c(s){try{return decodeURIComponent(s)}catch(a){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,a=>c(a)):s}}),define(Q[108],J([0,1,8]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(p){const n=p;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=R;function L(p){const n=[];let S;try{const E=JSON.parse(p.arguments),b=E[E.length-1];b&&b.__$stack&&(E.pop(),S=b.__$stack),n.push(...E)}catch(E){n.push("Unable to log remote console arguments",p.arguments)}return{args:n,stack:S}}e.parse=L;function y(p){if(typeof p!="string")return y(L(p).stack);const n=p;if(n){const S=I(n),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=y;function I(p){if(!p)return p;const n=p.indexOf(`
`);return n===-1?p:p.substring(0,n)}function r(p,n){const{args:S,stack:E}=L(p),b=typeof S[0]=="string"&&S.length===1;let d=I(E);d&&(d=`(${d.trim()})`);let m=[];if(typeof S[0]=="string"?d&&b?m=[`%c[${n}] %c${S[0]} %c${d}`,w("blue"),w(""),w("grey")]:m=[`%c[${n}] %c${S[0]}`,w("blue"),w(""),...S.slice(1)]:m=[`%c[${n}]%`,w("blue"),...S],d&&!b&&m.push(d),typeof console[p.severity]!="function")throw new Error("Unknown console method");console[p.severity].apply(console,m)}e.log=r;function w(p){return`color: ${p}`}});var Mt=this&&this.__classPrivateFieldSet||function(j,e,v,R,L){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?L.call(j,v):L?L.value=v:e.set(j,v),v},qe=this&&this.__classPrivateFieldGet||function(j,e,v,R){if(v==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!R:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?R:v==="a"?R.call(j):R?R.value:e.get(j)};define(Q[36],J([0,1,8,22]),function(j,e,v,R){"use strict";var L,y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function r(t,i,s){let a=t.get(i);return a===void 0&&(a=s,t.set(i,a)),a}e.getOrSet=r;function w(t){const i=[];return t.forEach((s,a)=>{i.push(`${a} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=w;function p(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=p;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}e.StringIterator=n;class S{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class E{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,R.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=E;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new E(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,R.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class m{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class M{constructor(i){this._iter=i}static forUris(i=()=>!1){return new M(new d(i))}static forPaths(){return new M(new E)}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new S)}clear(){this._root=void 0}set(i,s){const a=this._iter.reset(i);let h;for(this._root||(this._root=new m,this._root.segment=a.value()),h=this._root;;){const g=a.cmp(h.segment);if(g>0)h.left||(h.left=new m,h.left.segment=a.value()),h=h.left;else if(g<0)h.right||(h.right=new m,h.right.segment=a.value()),h=h.right;else if(a.hasNext())a.next(),h.mid||(h.mid=new m,h.mid.segment=a.value()),h=h.mid;else break}const f=h.value;return h.value=s,h.key=i,f}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const a=this._iter.reset(i),h=[];let f=this._root;for(;f;){const g=a.cmp(f.segment);if(g>0)h.push([1,f]),f=f.left;else if(g<0)h.push([-1,f]),f=f.right;else if(a.hasNext())a.next(),h.push([0,f]),f=f.mid;else{for(s?(f.left=void 0,f.mid=void 0,f.right=void 0):f.value=void 0;h.length>0&&f.isEmpty();){let[k,T]=h.pop();switch(k){case 1:T.left=void 0;break;case 0:T.mid=void 0;break;case-1:T.right=void 0;break}f=T}break}}}findSubstr(i){const s=this._iter.reset(i);let a=this._root,h;for(;a;){const f=s.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(s.hasNext())s.next(),h=a.value||h,a=a.mid;else break}return a&&a.value||h}findSuperstr(i){const s=this._iter.reset(i);let a=this._root;for(;a;){const h=s.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[s,a]of this)i(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=M;class P{constructor(i,s){this[L]="ResourceMap",i instanceof P?(this.map=new Map(i.map),this.toKey=s!=null?s:P.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:P.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[a,h]of this.map)i(h,v.URI.parse(a),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield v.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[v.URI.parse(i[0]),i[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[v.URI.parse(i[0]),i[1]]}}e.ResourceMap=P,P.defaultToKey=t=>t.toString();var o;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(o=e.Touch||(e.Touch={}));class u{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const a=this._map.get(i);if(!!a)return s!==0&&this.touch(a,s),a.value}set(i,s,a=0){let h=this._map.get(i);if(h)h.value=s,a!==0&&this.touch(h,a);else{switch(h={key:i,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(h);break;case 1:this.addItemFirst(h);break;case 2:this.addItemLast(h);break;default:this.addItemLast(h);break}this._map.set(i,h),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,s){const a=this._state;let h=this._head;for(;h;){if(s?i.bind(s)(h.value,h.key,this):i(h.value,h.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.key,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}values(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:a.value,done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}entries(){const i=this,s=this._state;let a=this._head;const h={[Symbol.iterator](){return h},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const f={value:[a.key,a.value],done:!1};return a=a.next,f}else return{value:void 0,done:!0}}};return h}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>i;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,a=i.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const a=i.next,h=i.previous;i===this._tail?(h.next=void 0,this._tail=h):(a.previous=h,h.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const a=i.next,h=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=h,h.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,a)=>{i.push([a,s])}),i}fromJSON(i){this.clear();for(const[s,a]of i)this.set(s,a)}}e.LinkedMap=u;class l extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class c{constructor(i){I.set(this,void 0),Mt(this,I,i,"f")}get size(){return qe(this,I,"f").size}forEach(i,s){qe(this,I,"f").forEach(i,s)}get(i){return qe(this,I,"f").get(i)}has(i){return qe(this,I,"f").has(i)}entries(){return qe(this,I,"f").entries()}keys(){return qe(this,I,"f").keys()}values(){return qe(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return qe(this,I,"f").entries()}}e.ReadonlyMapView=c}),define(Q[109],J([0,1,23,22,8]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function y(p){return JSON.stringify(p,r)}e.stringify=y;function I(p){let n=JSON.parse(p);return n=w(n),n}e.parse=I;function r(p,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,R.regExpFlags)(n)}:n}function w(p,n=0){if(!p||n>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return L.URI.revive(p);case 2:return new RegExp(p.source,p.flags)}if(p instanceof v.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let S=0;S<p.length;++S)p[S]=w(p[S],n+1);else for(const S in p)Object.hasOwnProperty.call(p,S)&&(p[S]=w(p[S],n+1))}return p}e.revive=w}),define(Q[10],J([0,1,8,3]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(r){r.inMemory="inmemory",r.vscode="vscode",r.internal="private",r.walkThrough="walkThrough",r.walkThroughSnippet="walkThroughSnippet",r.http="http",r.https="https",r.file="file",r.mailto="mailto",r.untitled="untitled",r.data="data",r.command="command",r.vscodeRemote="vscode-remote",r.vscodeRemoteResource="vscode-remote-resource",r.userData="vscode-userdata",r.vscodeCustomEditor="vscode-custom-editor",r.vscodeNotebook="vscode-notebook",r.vscodeNotebookCell="vscode-notebook-cell",r.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",r.vscodeNotebookCellOutput="vscode-notebook-cell-output",r.vscodeSettings="vscode-settings",r.vscodeWorkspaceTrust="vscode-workspace-trust",r.vscodeTerminal="vscode-terminal",r.webviewPanel="webview-panel",r.vscodeWebview="vscode-webview",r.extension="extension",r.vscodeFileResource="vscode-file",r.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class y{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(w){this._preferredWebSchema=w}setDelegate(w){this._delegate=w}set(w,p,n){this._hosts[w]=p,this._ports[w]=n}setConnectionToken(w,p){this._connectionTokens[w]=p}rewrite(w){if(this._delegate)return this._delegate(w);const p=w.authority;let n=this._hosts[p];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const S=this._ports[p],E=this._connectionTokens[p];let b=`path=${encodeURIComponent(w.path)}`;return typeof E=="string"&&(b+=`&tkn=${encodeURIComponent(E)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${S}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new y;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(w,p,n){const S=this.toUri(w,p);return S.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(S):R.isNative&&(n||R.isPreferringBrowserCodeLoad)&&S.scheme===L.file?S.with({scheme:L.vscodeFileResource,authority:S.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(w,p){const n=this.toUri(w,p);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(w,p){return v.URI.isUri(w)?w:v.URI.parse(p.toUrl(w))}}e.FileAccess=new I}),define(Q[65],J([0,1,36]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function L(p){return w(p,"NFC",R)}e.normalizeNFC=L;const y=new v.LRUCache(1e4);function I(p){return w(p,"NFD",y)}e.normalizeNFD=I;const r=/[^\u0000-\u0080]/;function w(p,n,S){if(!e.canNormalize||!p)return p;const E=S.get(p);if(E)return E;let b;return r.test(p)?b=p.normalize(n):b=p,S.set(p,b),b}e.removeAccents=function(){if(e.canNormalize){const p=/[\u0300-\u036f]/g;return function(n){return I(n).replace(p,"")}}else return function(p){return p}}()}),define(Q[15],J([0,1,30,7,8,22,10,3]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(b){return(0,L.uriToFsPath)(b,!0)}e.originalFSPath=w;class p{constructor(d){this._ignorePathCasing=d}compare(d,m,M=!1){return d===m?0:(0,y.compare)(this.getComparisonKey(d,M),this.getComparisonKey(m,M))}isEqual(d,m,M=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,M)===this.getComparisonKey(m,M)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,M=!1){if(d.scheme===m.scheme){if(d.scheme===I.Schemas.file)return v.isEqualOrParent(w(d),w(m),this._ignorePathCasing(d))&&d.query===m.query&&(M||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return v.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(M||d.fragment===m.fragment)}return!1}joinPath(d,...m){return L.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===I.Schemas.file?m=L.URI.file(R.dirname(w(d))).path:(m=R.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===I.Schemas.file?m=L.URI.file(R.normalize(w(d))).path:m=R.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(!(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))){if(d.scheme===I.Schemas.file){const o=R.relative(w(d),w(m));return r.isWindows?v.toSlashes(o):o}let M=d.path||"/",P=m.path||"/";if(this._ignorePathCasing(d)){let o=0;for(const u=Math.min(M.length,P.length);o<u&&!(M.charCodeAt(o)!==P.charCodeAt(o)&&M.charAt(o).toLowerCase()!==P.charAt(o).toLowerCase());o++);M=P.substr(0,o)+M.substr(o)}return R.posix.relative(M,P)}}resolvePath(d,m){if(d.scheme===I.Schemas.file){const M=L.URI.file(R.resolve(w(d),m));return d.with({authority:M.authority,path:M.path})}return m.indexOf("/")===-1&&(m=v.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),d.with({path:R.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,y.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=R.sep){if(d.scheme===I.Schemas.file){const M=w(d);return M.length>v.getRoot(M).length&&M[M.length-1]===m}else{const M=d.path;return M.length>1&&M.charCodeAt(M.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=R.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=R.sep){let M=!1;if(d.scheme===I.Schemas.file){const P=w(d);M=P!==void 0&&P.length===v.getRoot(P).length&&P[P.length-1]===m}else{m="/";const P=d.path;M=P.length===1&&P.charCodeAt(P.length-1)===47}return!M&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(b=>b.scheme===I.Schemas.file?!r.isLinux:!0),e.extUriIgnorePathCase=new p(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(b,d){const m=[];for(let M=0;M<b.length;M++){const P=d(b[M]);b.some((o,u)=>u===M?!1:(0,e.isEqualOrParent)(P,d(o)))||m.push(b[M])}return m}e.distinctParents=n;var S;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function d(m){const M=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,c]=u.split(":");l&&c&&M.set(l,c)});const o=m.path.substring(0,m.path.indexOf(";"));return o&&M.set(b.META_DATA_MIME,o),M}b.parseMetaData=d})(S=e.DataUri||(e.DataUri={}));function E(b,d,m){if(d){let M=b.path;return M&&M[0]!==R.posix.sep&&(M=R.posix.sep+M),b.with({scheme:m,authority:d,path:M})}return b.with({scheme:m})}e.toLocalResource=E}),define(Q[9],J([0,1,26,19,5,2,78,15]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function w(V){return!!V&&typeof V.then=="function"}e.isThenable=w;function p(V){const _=new v.CancellationTokenSource,A=V(_.token),O=new Promise((D,F)=>{_.token.onCancellationRequested(()=>{F((0,R.canceled)())}),Promise.resolve(A).then(C=>{_.dispose(),D(C)},C=>{_.dispose(),F(C)})});return new class{cancel(){_.cancel()}then(D,F){return O.then(D,F)}catch(D){return this.then(void 0,D)}finally(D){return O.finally(D)}}}e.createCancelablePromise=p;function n(V,_,A){return Promise.race([V,new Promise(O=>_.onCancellationRequested(()=>O(A)))])}e.raceCancellation=n;async function S(V){let _=-1;const A=V.map((D,F)=>D.then(C=>(_=F,C))),O=await Promise.race(A);return V.forEach((D,F)=>{F!==_&&D.cancel()}),O}e.raceCancellablePromises=S;function E(V,_,A){let O;const D=setTimeout(()=>{O==null||O(void 0),A==null||A()},_);return Promise.race([V.finally(()=>clearTimeout(D)),new Promise(F=>O=F)])}e.raceTimeout=E;function b(V){return new Promise((_,A)=>{const O=V();w(O)?O.then(_,A):_(O)})}e.asPromise=b;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(A,A).then(O)})}return new Promise((A,O)=>{this.queuedPromise.then(A,O)})}return this.activePromise=_(),new Promise((A,O)=>{this.activePromise.then(D=>{this.activePromise=null,A(D)},D=>{this.activePromise=null,O(D)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=m;class M{constructor(){this.promiseMap=new Map}queue(_,A){var O;const F=((O=this.promiseMap.get(_))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(_)===F&&this.promiseMap.delete(_)});return this.promiseMap.set(_,F),F}}e.SequencerByKey=M;class P{constructor(_){this.defaultDelay=_,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,A=this.defaultDelay){return this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,D)=>{this.doResolve=O,this.doReject=D}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},A),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=P;class o{constructor(_){this.delayer=new P(_),this.throttler=new d}trigger(_,A){return this.delayer.trigger(()=>this.throttler.queue(_),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=o;class u{constructor(){this._isOpen=!1,this._promise=new Promise((_,A)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class l extends u{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function c(V,_){return _?new Promise((A,O)=>{const D=setTimeout(A,V);_.onCancellationRequested(()=>{clearTimeout(D),O((0,R.canceled)())})}):p(A=>c(V,A))}e.timeout=c;function t(V,_=0){const A=setTimeout(V,_);return(0,y.toDisposable)(()=>clearTimeout(A))}e.disposableTimeout=t;function i(V){return V.then(void 0,_=>{})}e.ignoreErrors=i;function s(V){const _=[];let A=0;const O=V.length;function D(){return A<O?V[A++]():null}function F(C){C!=null&&_.push(C);const K=D();return K?K.then(F):Promise.resolve(_)}return Promise.resolve(null).then(F)}e.sequence=s;function a(V,_=O=>!!O,A=null){let O=0;const D=V.length,F=()=>{if(O>=D)return Promise.resolve(A);const C=V[O++];return Promise.resolve(C()).then(G=>_(G)?Promise.resolve(G):F())};return F()}e.first=a;function h(V,_=O=>!!O,A=null){if(V.length===0)return Promise.resolve(A);let O=V.length;const D=()=>{var F,C;O=-1;for(const K of V)(C=(F=K).cancel)===null||C===void 0||C.call(F)};return new Promise((F,C)=>{for(const K of V)K.then(G=>{--O>=0&&_(G)?(D(),F(G)):O===0&&F(A)}).catch(G=>{--O>=0&&(D(),C(G))})})}e.firstParallel=h;class f{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(_){return this._size++,new Promise((A,O)=>{this.outstandingPromises.push({factory:_,c:A,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const A=_.factory();A.then(_.c,_.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class g extends f{constructor(){super(1)}}e.Queue=g;class k{constructor(){this.queues=new Map}queueFor(_,A=r.extUri){const O=A.getComparisonKey(_);let D=this.queues.get(O);return D||(D=new g,L.Event.once(D.onFinished)(()=>{D==null||D.dispose(),this.queues.delete(O)}),this.queues.set(O,D)),D}dispose(){this.queues.forEach(_=>_.dispose()),this.queues.clear()}}e.ResourceQueue=k;class T{constructor(_,A){this._token=-1,typeof _=="function"&&typeof A=="number"&&this.setIfNotSet(_,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},A)}setIfNotSet(_,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},A))}}e.TimeoutTimer=T;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,A){this.cancel(),this._token=setInterval(()=>{_()},A)}}e.IntervalTimer=U;class B{constructor(_,A){this.timeoutToken=-1,this.runner=_,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=B;class X extends B{constructor(_,A){super(_,A);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner&&this.runner(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=X,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const V=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=_=>{const A=setTimeout(()=>_(V));let O=!1;return{dispose(){O||(O=!0,clearTimeout(A))}}}}else e.runWhenIdle=(V,_)=>{const A=requestIdleCallback(V,typeof _=="number"?{timeout:_}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(A))}}}}();class te{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=te;async function oe(V,_,A){let O;for(let D=0;D<A;D++)try{return await V()}catch(F){O=F,await c(_)}throw O}e.retry=oe;class W{hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var _;(_=this._pending)===null||_===void 0||_.cancel()}setPending(_,A,O){return this._pending={taskId:_,cancel:()=>O==null?void 0:O(),promise:A},A.then(()=>this.donePending(_),()=>this.donePending(_)),A}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let A,O;const D=new Promise((F,C)=>{A=F,O=C});this._next={run:_,promise:D,promiseResolve:A,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=W;class ${constructor(_){this.interval=_,this.lastIncrementTime=0,this.value=0}increment(){const _=Date.now();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=$;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,A)=>{this.completeCallback=_,this.errorCallback=A})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(A=>{this.completeCallback(_),this.resolved=!0,A()})}error(_){return new Promise(A=>{this.errorCallback(_),this.rejected=!0,A()})}cancel(){new Promise(_=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,_()})}}e.DeferredPromise=z;class N extends L.Emitter{async fireAsync(_,A,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const D of this._listeners)this._asyncDeliveryQueue.push([D,_]);for(;this._asyncDeliveryQueue.size>0&&!A.isCancellationRequested;){const[D,F]=this._asyncDeliveryQueue.shift(),C=[],K=Object.assign(Object.assign({},F),{waitUntil:G=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");O&&(G=O(G,typeof D=="function"?D:D[0])),C.push(G)}});try{typeof D=="function"?D.call(void 0,K):D[0].call(D[1],K)}catch(G){(0,R.onUnexpectedError)(G);continue}Object.freeze(C),await H.settled(C).catch(G=>(0,R.onUnexpectedError)(G))}}}}e.AsyncEmitter=N;var H;(function(V){async function _(F){return typeof Promise.allSettled=="function"?A(F):O(F)}V.allSettled=_;async function A(F){return Promise.allSettled(F)}async function O(F){return Promise.all(F.map(C=>C.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function D(F){let C;const K=await Promise.all(F.map(G=>G.then(Y=>Y,Y=>{C||(C=Y)})));if(typeof C!="undefined")throw C;return K}V.settled=D})(H=e.Promises||(e.Promises={}))}),define(Q[110],J([0,1,22,30,7,36,9]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function r(){return Object.create(null)}e.getEmptyExpression=r;const w="**",p="/",n="[/\\\\]",S="[^/\\\\]",E=/\//g;function b(A){switch(A){case 0:return"";case 1:return`${S}*?`;default:return`(?:${n}|${S}+${n}|${n}${S}+)*?`}}function d(A,O){if(!A)return[];const D=[];let F=!1,C=!1,K="";for(const G of A){switch(G){case O:if(!F&&!C){D.push(K),K="";continue}break;case"{":F=!0;break;case"}":F=!1;break;case"[":C=!0;break;case"]":C=!1;break}K+=G}return K&&D.push(K),D}e.splitGlobAware=d;function m(A){if(!A)return"";let O="";const D=d(A,p);if(D.every(F=>F===w))O=".*";else{let F=!1;D.forEach((C,K)=>{if(C===w){F||(O+=b(2),F=!0);return}let G=!1,Y="",Z=!1,re="";for(const se of C){if(se!=="}"&&G){Y+=se;continue}if(Z&&(se!=="]"||!re)){let x;se==="-"?x=se:(se==="^"||se==="!")&&!re?x="^":se===p?x="":x=v.escapeRegExpCharacters(se),re+=x;continue}switch(se){case"{":G=!0;continue;case"[":Z=!0;continue;case"}":O+=`(?:${d(Y,",").map(ue=>m(ue)).join("|")})`,G=!1,Y="";break;case"]":O+="["+re+"]",Z=!1,re="";break;case"?":O+=S;continue;case"*":O+=b(1);continue;default:O+=v.escapeRegExpCharacters(se)}}K<D.length-1&&(D[K+1]!==w||K+2<D.length)&&(O+=n),F=!1})}return O}const M=/^\*\*\/\*\.[\w\.-]+$/,P=/^\*\*\/([\w\.-]+)\/?$/,o=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new y.LRUCache(1e4),i=function(){return!1},s=function(){return null};function a(A,O){if(!A)return s;let D;typeof A!="string"?D=A.pattern:D=A,D=D.trim();const F=`${D}_${!!O.trimForExclusions}`;let C=t.get(F);if(C)return h(C,A);let K;if(M.test(D)){const G=D.substr(4);C=function(Y,Z){return typeof Y=="string"&&Y.endsWith(G)?D:null}}else(K=P.exec(f(D,O)))?C=g(K[1],D):(O.trimForExclusions?u:o).test(D)?C=k(D,O):(K=l.exec(f(D,O)))?C=T(K[1].substr(1),D,!0):(K=c.exec(f(D,O)))?C=T(K[1],D,!1):C=U(D);return t.set(F,C),h(C,A)}function h(A,O){return typeof O=="string"?A:function(D,F){return R.isEqualOrParent(D,O.base)?A(L.relative(O.base,D),F):null}}function f(A,O){return O.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function g(A,O){const D=`/${A}`,F=`\\${A}`,C=function(G,Y){return typeof G!="string"?null:Y?Y===A?O:null:G===A||G.endsWith(D)||G.endsWith(F)?O:null},K=[A];return C.basenames=K,C.patterns=[O],C.allBasenames=K,C}function k(A,O){const D=_(A.slice(1,-1).split(",").map(Y=>a(Y,O)).filter(Y=>Y!==s),A),F=D.length;if(!F)return s;if(F===1)return D[0];const C=function(Y,Z){for(let re=0,se=D.length;re<se;re++)if(D[re](Y,Z))return A;return null},K=D.find(Y=>!!Y.allBasenames);K&&(C.allBasenames=K.allBasenames);const G=D.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(C.allPaths=G),C}function T(A,O,D){const F=L.sep===L.posix.sep,C=F?A:A.replace(E,L.sep),K=L.sep+C,G=L.posix.sep+A,Y=D?function(Z,re){return typeof Z=="string"&&(Z===C||Z.endsWith(K)||!F&&(Z===A||Z.endsWith(G)))?O:null}:function(Z,re){return typeof Z=="string"&&(Z===C||!F&&Z===A)?O:null};return Y.allPaths=[(D?"*/":"./")+A],Y}function U(A){try{const O=new RegExp(`^${m(A)}$`);return function(D){return O.lastIndex=0,typeof D=="string"&&O.test(D)?A:null}}catch(O){return s}}function B(A,O,D){return!A||typeof O!="string"?!1:X(A)(O,void 0,D)}e.match=B;function X(A,O={}){if(!A)return i;if(typeof A=="string"||$(A)){const D=a(A,O);if(D===s)return i;const F=function(C,K){return!!D(C,K)};return D.allBasenames&&(F.allBasenames=D.allBasenames),D.allPaths&&(F.allPaths=D.allPaths),F}return H(A,O)}e.parse=X;function te(A){if(!!A){let O;return D=>(O||(O=(A()||Promise.resolve([])).then(F=>F?W(F):{})),O.then(F=>!!F[D]))}}e.hasSiblingPromiseFn=te;function oe(A){if(!!A){let O;return D=>{if(!O){const F=A();O=F?W(F):{}}return!!O[D]}}}e.hasSiblingFn=oe;function W(A){const O={};for(const D of A)O[D]=!0;return O}function $(A){const O=A;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=$;function z(A){return A.allBasenames||[]}e.getBasenameTerms=z;function N(A){return A.allPaths||[]}e.getPathTerms=N;function H(A,O){const D=_(Object.getOwnPropertyNames(A).map(Y=>V(Y,A[Y],O)).filter(Y=>Y!==s)),F=D.length;if(!F)return s;if(!D.some(Y=>!!Y.requiresSiblings)){if(F===1)return D[0];const Y=function(se,x){for(let ne=0,ue=D.length;ne<ue;ne++){const be=D[ne](se,x);if(be)return be}return null},Z=D.find(se=>!!se.allBasenames);Z&&(Y.allBasenames=Z.allBasenames);const re=D.reduce((se,x)=>x.allPaths?se.concat(x.allPaths):se,[]);return re.length&&(Y.allPaths=re),Y}const C=function(Y,Z,re){let se;for(let x=0,ne=D.length;x<ne;x++){const ue=D[x];ue.requiresSiblings&&re&&(Z||(Z=L.basename(Y)),se||(se=Z.substr(0,Z.length-L.extname(Y).length)));const be=ue(Y,Z,se,re);if(be)return be}return null},K=D.find(Y=>!!Y.allBasenames);K&&(C.allBasenames=K.allBasenames);const G=D.reduce((Y,Z)=>Z.allPaths?Y.concat(Z.allPaths):Y,[]);return G.length&&(C.allPaths=G),C}function V(A,O,D){if(O===!1)return s;const F=a(A,D);if(F===s)return s;if(typeof O=="boolean")return F;if(O){const C=O.when;if(typeof C=="string"){const K=(G,Y,Z,re)=>{if(!re||!F(G,Y))return null;const se=C.replace("$(basename)",Z),x=re(se);return(0,I.isThenable)(x)?x.then(ne=>ne?A:null):x?A:null};return K.requiresSiblings=!0,K}}return F}function _(A,O){const D=A.filter(Y=>!!Y.basenames);if(D.length<2)return A;const F=D.reduce((Y,Z)=>{const re=Z.basenames;return re?Y.concat(re):Y},[]);let C;if(O){C=[];for(let Y=0,Z=F.length;Y<Z;Y++)C.push(O)}else C=D.reduce((Y,Z)=>{const re=Z.patterns;return re?Y.concat(re):Y},[]);const K=function(Y,Z){if(typeof Y!="string")return null;if(!Z){let se;for(se=Y.length;se>0;se--){const x=Y.charCodeAt(se-1);if(x===47||x===92)break}Z=Y.substr(se)}const re=F.indexOf(Z);return re!==-1?C[re]:null};K.basenames=F,K.patterns=C,K.allBasenames=F;const G=A.filter(Y=>!Y.basenames);return G.push(K),G}}),define(Q[39],J([0,1,8,7,22,10,3,15,30]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function p(a,h,f){if(typeof a=="string"&&(a=v.URI.file(a)),f){const k=f.getWorkspaceFolder(a);if(k){const T=f.getWorkspace().folders.length>1;let U;if((0,r.isEqual)(k.uri,a)?U="":U=(0,r.relativePath)(k.uri,a),T){const B=k.name?k.name:(0,r.basename)(k.uri);U=U?B+" \u2022 "+U:B}return U}}if(a.scheme!==y.Schemas.file&&a.scheme!==y.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,w.hasDriveLetter)(a.fsPath))return(0,R.normalize)(S(a.fsPath));let g=(0,R.normalize)(a.fsPath);return!I.isWindows&&(h==null?void 0:h.userHome)&&(g=b(g,h.userHome.fsPath)),g}e.getPathLabel=p;function n(a){if(!!a){typeof a=="string"&&(a=v.URI.file(a));const h=(0,r.basename)(a)||(a.scheme===y.Schemas.file?a.fsPath:a.path);return I.isWindows&&(0,w.isRootOrDriveLetter)(h)?S(h):h}}e.getBaseLabel=n;function S(a){return(0,w.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}e.normalizeDriveLetter=S;let E=Object.create(null);function b(a,h){if(I.isWindows||!a||!h)return a;let f=E.original===h?E.normalized:void 0;return f||(f=`${(0,L.rtrim)(h,R.posix.sep)}${R.posix.sep}`,E={original:h,normalized:f}),(I.isLinux?a.startsWith(f):(0,L.startsWithIgnoreCase)(a,f))&&(a=`~/${a.substr(f.length)}`),a}e.tildify=b;function d(a,h){return a.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const m="\u2026",M="\\\\",P="~";function o(a,h=R.sep){const f=new Array(a.length);let g=!1;for(let k=0;k<a.length;k++){let T=a[k];if(T===""){f[k]=`.${h}`;continue}if(!T){f[k]=T;continue}g=!0;let U="";T.indexOf(M)===0?(U=T.substr(0,T.indexOf(M)+M.length),T=T.substr(T.indexOf(M)+M.length)):T.indexOf(h)===0?(U=T.substr(0,T.indexOf(h)+h.length),T=T.substr(T.indexOf(h)+h.length)):T.indexOf(P)===0&&(U=T.substr(0,T.indexOf(P)+P.length),T=T.substr(T.indexOf(P)+P.length));const B=T.split(h);for(let X=1;g&&X<=B.length;X++)for(let te=B.length-X;g&&te>=0;te--){g=!1;let oe=B.slice(te,te+X).join(h);for(let W=0;!g&&W<a.length;W++)if(W!==k&&a[W]&&a[W].indexOf(oe)>-1){const $=te+X===B.length,z=te>0&&a[W].indexOf(h)>-1?h+oe:oe,N=a[W].endsWith(z);g=!$||N}if(!g){let W="";(B[0].endsWith(":")||U!=="")&&(te===1&&(te=0,X++,oe=B[0]+h+oe),te>0&&(W=B[0]+h),W=U+W),te>0&&(W=W+m+h),W=W+oe,te+X<B.length&&(W=W+h+m),f[k]=W}}g&&(f[k]=T)}return f}e.shorten=o;var u;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(a,h=Object.create(null)){const f=[];let g=!1,k="";for(const T of a)if(T==="$"||g&&T==="{")k&&f.push({value:k,type:u.TEXT}),k="",g=!0;else if(T==="}"&&g){const U=h[k];if(typeof U=="string")U.length&&f.push({value:U,type:u.VARIABLE});else if(U){const B=f[f.length-1];(!B||B.type!==u.SEPARATOR)&&f.push({value:U.label,type:u.SEPARATOR})}k="",g=!1}else k+=T;return k&&!g&&f.push({value:k,type:u.TEXT}),f.filter((T,U)=>{if(T.type===u.SEPARATOR){const B=f[U-1],X=f[U+1];return[B,X].every(te=>te&&(te.type===u.VARIABLE||te.type===u.TEXT)&&te.value.length>0)}return!0}).map(T=>T.value).join("")}e.template=l;function c(a,h){return I.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):a.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(a,h){return I.isMacintosh||h?a.replace(/\(&&\w\)|&&/g,""):I.isWindows?a.replace(/&&|&/g,f=>f==="&"?"&&":"&"):a.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(a){return a.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(a){const h=a.indexOf("/")!==-1?R.posix:R.win32,f=h.basename(a),g=h.dirname(a);return f.length?{name:f,parentPath:g}:{name:g,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(w){return v.test(w)}e.isUUID=R;const L=new Uint8Array(16),y=[];for(let w=0;w<256;w++)y.push(w.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};function r(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let w=0,p="";return p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p+="-",p+=y[L[w++]],p+=y[L[w++]],p+="-",p+=y[L[w++]],p+=y[L[w++]],p+="-",p+=y[L[w++]],p+=y[L[w++]],p+="-",p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p+=y[L[w++]],p}e.generateUuid=r}),define(Q[111],J([0,1,20,58,42]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function y(I,r){if(await new Promise((n,S)=>{const E=v.createReadStream(I),b=R.createHash("sha1");E.pipe(b);const d=(0,L.once)((m,M)=>{E.removeAllListeners(),b.removeAllListeners(),m?S(m):n(M)});E.once("error",d),E.once("end",d),b.once("error",d),b.once("data",m=>d(void 0,m.toString("hex")))})!==r)throw new Error("Hash mismatch")}e.checksum=y}),define(Q[81],J([0,1,236]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(y="utf8"){this.stringDecoder=new v.StringDecoder(y),this.remaining=null}write(y){const I=[],r=this.remaining?this.remaining+this.stringDecoder.write(y):this.stringDecoder.write(y);if(r.length<1)return I;let w=0,p,n=w;for(;n<r.length;)if(p=r.charCodeAt(n),p===13||p===10){if(I.push(r.substring(w,n)),n++,n<r.length){const S=p;p=r.charCodeAt(n),(S===13&&p===10||S===10&&p===13)&&n++}w=n}else n++;return this.remaining=w<r.length?r.substr(w):null,I}end(){return this.remaining}}e.LineDecoder=R}),define(Q[112],J([0,1,27]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(r){const w=r.replace(/\-/g,":").toLowerCase();return!R.has(w)}function y(){return new Promise(async(r,w)=>{const p=setTimeout(()=>w("Unable to retrieve mac address (timeout after 10s)"),1e4);try{r(await I())}catch(n){w(n)}finally{clearTimeout(p)}})}e.getMac=y;function I(){return new Promise((r,w)=>{try{const p=(0,v.networkInterfaces)();for(let n in p){const S=p[n];if(S){for(const{mac:E}of S)if(L(E))return r(E)}}w("Unable to retrieve mac address (unexpected format)")}catch(p){w(p)}})}}),define(Q[66],J([0,1,19,28,27,36,112]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=y.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,S=0;const E=(0,L.networkInterfaces)();for(let b in E){const d=E[b];if(d)for(const{mac:m,internal:M}of d)M||(S+=1,this._isVirtualMachineMacAdress(m.toUpperCase())&&(n+=1))}this._value=S>0?n/S:0}return this._value}};let r;async function w(){return r||(r=(async()=>await p()||R.generateUuid())()),r}e.getMachineId=w;async function p(){try{const n=await new Promise((E,b)=>{j(["crypto"],E,b)}),S=await(0,I.getMac)();return n.createHash("sha256").update(S,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(Q[16],J([0,1,20,27,7,9,3,30,28,65,15,8]),function(j,e,v,R,L,y,I,r,w,p,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function b(z,N=E.UNLINK){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return N===E.UNLINK?m(z):d(z)}e.rimraf=b;async function d(z){try{const N=(0,L.join)((0,R.tmpdir)(),(0,w.generateUuid)());try{await v.promises.rename(z,N)}catch(H){return m(z)}m(N).catch(H=>{})}catch(N){if(N.code!=="ENOENT")throw N}}async function m(z){return v.promises.rmdir(z,{recursive:!0,maxRetries:3})}function M(z){if((0,r.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(z,{recursive:!0})}e.rimrafSync=M;async function P(z,N){return l(await(N?o(z):v.promises.readdir(z)))}e.readdir=P;async function o(z){try{return await v.promises.readdir(z,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const N=[],H=await P(z);for(const V of H){let _=!1,A=!1,O=!1;try{const D=await v.promises.lstat((0,L.join)(z,V));_=D.isFile(),A=D.isDirectory(),O=D.isSymbolicLink()}catch(D){console.warn("[node.js fs] unexpected error from lstat after readdir: ",D)}N.push({name:V,isFile:()=>_,isDirectory:()=>A,isSymbolicLink:()=>O})}return N}function u(z){return l(v.readdirSync(z))}e.readdirSync=u;function l(z){return z.map(N=>typeof N=="string"?I.isMacintosh?(0,p.normalizeNFC)(N):N:(N.name=I.isMacintosh?(0,p.normalizeNFC)(N.name):N.name,N))}async function c(z){const N=await P(z),H=[];for(const V of N)await i.existsDirectory((0,L.join)(z,V))&&H.push(V);return H}e.readDirsInDir=c;function t(z,N=1e3){return new Promise(H=>{let V=!1;const _=setInterval(()=>{V||(V=!0,v.access(z,A=>{V=!1,A&&(clearInterval(_),H(void 0))}))},N)})}e.whenDeleted=t;var i;(function(z){async function N(_){let A;try{if(A=await v.promises.lstat(_),!A.isSymbolicLink())return{stat:A}}catch(O){}try{return{stat:await v.promises.stat(_),symbolicLink:(A==null?void 0:A.isSymbolicLink())?{dangling:!1}:void 0}}catch(O){if(O.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};if(I.isWindows&&O.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(_)),symbolicLink:{dangling:!1}}}catch(D){if(D.code==="ENOENT"&&A)return{stat:A,symbolicLink:{dangling:!0}};throw D}throw O}}z.stat=N;async function H(_){try{const{stat:A,symbolicLink:O}=await z.stat(_);return A.isFile()&&(O==null?void 0:O.dangling)!==!0}catch(A){}return!1}z.existsFile=H;async function V(_){try{const{stat:A,symbolicLink:O}=await z.stat(_);return A.isDirectory()&&(O==null?void 0:O.dangling)!==!0}catch(A){}return!1}z.existsDirectory=V})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new y.ResourceQueue;function a(z,N,H){return s.queueFor(S.URI.file(z),n.extUriBiasedIgnorePathCase).queue(()=>{const V=k(H);return new Promise((_,A)=>f(z,N,V,O=>O?A(O):_()))})}e.writeFile=a;let h=!0;function f(z,N,H,V){if(!h)return v.writeFile(z,N,{mode:H.mode,flag:H.flag},V);v.open(z,H.flag,H.mode,(_,A)=>{if(_)return V(_);v.writeFile(A,N,O=>{if(O)return v.close(A,()=>V(O));v.fdatasync(A,D=>(D&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",D),h=!1),v.close(A,F=>V(F))))})})}function g(z,N,H){const V=k(H);if(!h)return v.writeFileSync(z,N,{mode:V.mode,flag:V.flag});const _=v.openSync(z,V.flag,V.mode);try{v.writeFileSync(_,N);try{v.fdatasyncSync(_)}catch(A){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",A),h=!1}}finally{v.closeSync(_)}}e.writeFileSync=g;function k(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function T(z,N){if(z!==N){async function H(V){try{const _=await v.promises.lstat(V);if(_.isDirectory()||_.isSymbolicLink())return;const A=await v.promises.open(V,"a");try{await A.utimes(_.atime,new Date)}finally{await A.close()}}catch(_){}}try{await v.promises.rename(z,N),await H(N)}catch(V){if(z.toLowerCase()!==N.toLowerCase()&&V.code==="EXDEV"||z.endsWith("."))await U(z,N,{preserveSymlinks:!1}),await b(z,E.MOVE),await H(N);else throw V}}}e.move=T;async function U(z,N,H){return X(z,N,{root:{source:z,target:N},options:H,handledSourcePaths:new Set})}e.copy=U;const B=511;async function X(z,N,H){if(!H.handledSourcePaths.has(z)){H.handledSourcePaths.add(z);const{stat:V,symbolicLink:_}=await i.stat(z);if(_){if(H.options.preserveSymlinks)try{return await W(z,N,H)}catch(A){console.warn("[node.js fs] copy of symlink failed: ",A)}if(_.dangling)return}return V.isDirectory()?te(z,N,V.mode&B,H):oe(z,N,V.mode&B)}}async function te(z,N,H,V){await v.promises.mkdir(N,{recursive:!0,mode:H});const _=await P(z);for(const A of _)await X((0,L.join)(z,A),(0,L.join)(N,A),V)}async function oe(z,N,H){await v.promises.copyFile(z,N),await v.promises.chmod(N,H)}async function W(z,N,H){let V=await v.promises.readlink(z);(0,r.isEqualOrParent)(V,H.root.source,!I.isLinux)&&(V=(0,L.join)(H.root.target,V.substr(H.root.source.length+1))),await v.promises.symlink(V,N)}async function $(z){try{return await v.promises.access(z),!0}catch(N){return!1}}e.exists=$}),define(Q[113],J([0,1,20,114,22,7,16]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function r(S){const E=(0,y.dirname)(S);if(S===E)return S;const b=((0,y.basename)(S)||S).toLowerCase();try{const m=(0,I.readdirSync)(E).filter(M=>M.toLowerCase()===b);if(m.length===1){const M=r(E);if(M)return(0,y.join)(M,m[0])}else if(m.length>1){const M=m.indexOf(b);if(M>=0){const P=r(E);if(P)return(0,y.join)(P,m[M])}}}catch(d){}return null}e.realcaseSync=r;async function w(S){try{return await(0,R.promisify)(v.realpath)(S)}catch(E){const b=n(S);return await v.promises.access(b,v.constants.R_OK),b}}e.realpath=w;function p(S){try{return v.realpathSync(S)}catch(E){const b=n(S);return v.accessSync(b,v.constants.R_OK),b}}e.realpathSync=p;function n(S){return(0,L.rtrim)((0,y.normalize)(S),y.sep)}}),define(Q[115],J([0,1,59]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function R(r,w,p){let n=!1;return new Promise(S=>{const E=setTimeout(()=>{if(!n)return n=!0,S(0)},p);L(r,w,b=>{if(!n)return n=!0,clearTimeout(E),S(b)})})}e.findFreePort=R;function L(r,w,p){if(w===0)return p(0);const n=new v.Socket;n.once("connect",()=>(I(n),L(r+1,w-1,p))),n.once("data",()=>{}),n.once("error",S=>(I(n),S.code!=="ECONNREFUSED"?L(r+1,w-1,p):p(r))),n.connect(r,"127.0.0.1")}function y(r,w,p){let n=!1,S,E=1;const b=v.createServer({pauseOnConnect:!0});function d(m,M){n||(n=!0,b.removeAllListeners(),b.close(),S&&clearTimeout(S),M(m))}return new Promise(m=>{S=setTimeout(()=>{d(0,m)},p),b.on("listening",()=>{d(r,m)}),b.on("error",M=>{M&&(M.code==="EADDRINUSE"||M.code==="EACCES")&&E<w?(r++,E++,b.listen(r,"127.0.0.1")):d(0,m)}),b.on("close",()=>{d(0,m)}),b.listen(r,"127.0.0.1")})}e.findFreePortFaster=y;function I(r){try{r.removeAllListeners("connect"),r.removeAllListeners("error"),r.end(),r.destroy(),r.unref()}catch(w){console.error(w)}}});var Fe=this&&this.__await||function(j){return this instanceof Fe?(this.v=j,this):new Fe(j)},pt=this&&this.__asyncGenerator||function(j,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=v.apply(j,e||[]),L,y=[];return L={},I("next"),I("throw"),I("return"),L[Symbol.asyncIterator]=function(){return this},L;function I(E){R[E]&&(L[E]=function(b){return new Promise(function(d,m){y.push([E,b,d,m])>1||r(E,b)})})}function r(E,b){try{w(R[E](b))}catch(d){S(y[0][3],d)}}function w(E){E.value instanceof Fe?Promise.resolve(E.value.v).then(p,n):S(y[0][2],E)}function p(E){r("next",E)}function n(E){r("throw",E)}function S(E,b){E(b),y.shift(),y.length&&r(y[0][0],y[0][1])}},yt=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],v;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),v={},R("next"),R("throw"),R("return"),v[Symbol.asyncIterator]=function(){return this},v);function R(y){v[y]=j[y]&&function(I){return new Promise(function(r,w){I=j[y](I),L(r,w,I.done,I.value)})}}function L(y,I,r,w){Promise.resolve(w).then(function(p){y({value:p,done:r})},I)}};define(Q[116],J([0,1,16,27,7]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const y=/^\d+$/,I=/^Microsoft.PowerShell_.*/,r=/^Microsoft.PowerShellPreview_.*/;var w;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(w||(w={}));let p;switch(process.arch){case"ia32":case"x32":p=1;break;case"arm":case"arm64":p=2;break;default:p=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class S{constructor(c,t,i){this.exePath=c,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:l=!1}={}){return l?p===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:l=!1,findPreview:c=!1}={}){const t=E({useAlternateBitness:l});if(!t)return null;const i=L.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(i))return null;let s=-1,a=null;for(const g of await v.readdir(i)){let k=-1;if(c){const U=g.indexOf("-");if(U<0)continue;const B=g.substring(0,U);if(!y.test(B)||g.substring(U+1)!=="preview")continue;k=parseInt(B,10)}else{if(!y.test(g))continue;k=parseInt(g,10)}if(!(k<=s)){const T=L.join(i,g,"pwsh.exe");!await v.SymlinkSupport.existsFile(T)||(a=T,s=k)}}if(!a)return null;const h=t.includes("x86")?" (x86)":"",f=c?" Preview":"";return new S(a,`PowerShell${f}${h}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=l?{pwshMsixDirRegex:r,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const s of await v.readdir(c))if(t.test(s)){const a=L.join(c,s,"pwsh.exe");return new S(a,i)}return null}function m(){const l=L.join(R.homedir(),".dotnet","tools","pwsh.exe");return new S(l,".NET Core PowerShell Global Tool")}function M(){const l=L.join(process.env.windir,p===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(l,"Windows PowerShell",!0)}function P(){return pt(this,arguments,function*(){let c=yield Fe(b());c&&(yield yield Fe(c)),c=yield Fe(b({useAlternateBitness:!0})),c&&(yield yield Fe(c)),c=yield Fe(d()),c&&(yield yield Fe(c)),c=m(),c&&(yield yield Fe(c)),c=yield Fe(b({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(d({findPreview:!0})),c&&(yield yield Fe(c)),c=yield Fe(b({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield Fe(c)),c=M(),c&&(yield yield Fe(c))})}function o(){return pt(this,arguments,function*(){var c,t;try{for(var i=yt(P()),s;s=yield Fe(i.next()),!s.done;){const a=s.value;(yield Fe(a.exists()))&&(yield yield Fe(a))}}catch(a){c={error:a}}finally{try{s&&!s.done&&(t=i.return)&&(yield Fe(t.call(i)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=o;async function u(){var l,c;try{for(var t=yt(o()),i;i=await t.next(),!i.done;)return i.value}catch(s){l={error:s}}finally{try{i&&!i.done&&(c=t.return)&&await c.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=u}),define(Q[82],J([0,1,45,10]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(I){return new Promise((r,w)=>{let p;const n=new Map;function S(d,m,M,P,o){const u=n.get(m);if(d===I||u){const l={name:E(M),cmd:M,pid:d,ppid:m,load:P,mem:o};n.set(d,l),d===I&&(p=l),u&&(u.children||(u.children=[]),u.children.push(l),u.children.length>1&&(u.children=u.children.sort((c,t)=>c.pid-t.pid)))}}function E(d){const m=/--disable-blink-features=Auxclick/,M=/\\watcher\\win32\\CodeHelper\.exe/,P=/--crashes-directory/,o=/\\pipe\\winpty-control/,u=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(M.exec(d))return"watcherService ";if(P.exec(d))return"electron-crash-reporter";if(o.exec(d))return"winpty-process";if(u.exec(d))return"console-window-host (Windows internal process)";let c=l.exec(d);if(c&&c.length===2)return c[1]==="renderer"?m.exec(d)?"shared-process":"window":c[1];const t=/[a-zA-Z-]+\.js/g;let i="";do c=t.exec(d),c&&(i+=c+" ");while(c);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${i}`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,M)=>{j(["windows-process-tree"],m,M)}).then(m=>{m.getProcessList(I,M=>{m.getProcessCpuUsage(M,P=>{const o=new Map;P.forEach(u=>{const l=d(u.commandLine||"");o.set(u.pid,{name:E(l),cmd:l,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),p=o.get(I),p?(o.forEach(u=>{const l=o.get(u.ppid);l&&(l.children||(l.children=[]),l.children.push(u))}),o.forEach(u=>{u.children&&(u.children=u.children.sort((l,c)=>l.pid-c.pid))}),r(p)):w(new Error(`Root process ${I} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{function b(){let d=[p];const m=[];for(;d.length;){const P=d.shift();P&&(m.push(P.pid),P.children&&(d=d.concat(P.children)))}let M=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);M+=" "+m.join(" "),(0,v.exec)(M,{},(P,o,u)=>{if(P||u)w(P||new Error(u.toString()));else{const l=o.toString().split(`
`);for(let c=0;c<m.length;c++){const t=n.get(m[c]);t.load=parseFloat(l[c])}if(!p){w(new Error(`Root process ${I} not found`));return}r(p)}})}(0,v.exec)("which ps",{},(d,m,M)=>{if(d||M)if(process.platform!=="linux")w(d||new Error(M.toString()));else{const P=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,v.exec)(P,{},(o,u,l)=>{o||l?w(o||new Error(l.toString())):(y(u,S),b())})}else{const P=m.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${P} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,c)=>{u||c&&!c.includes("screen size is bogus")?w(u||new Error(c.toString())):(y(l,S),process.platform==="linux"?b():p?r(p):w(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=L;function y(I,r){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,p=I.toString().split(`
`);for(const n of p){const S=w.exec(n.trim());S&&S.length===6&&r(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(Q[117],J([0,1,7,20,3,65,2,16]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function w(S,E,b){return n({path:S,isDirectory:!1},E,b)}e.watchFile=w;function p(S,E,b){return n({path:S,isDirectory:!0},E,b)}e.watchFolder=p,e.CHANGE_BUFFER_DELAY=100;function n(S,E,b){const d=(0,v.basename)(S.path),m=new Map;let M=!1,P=[(0,I.toDisposable)(()=>{m.forEach(o=>(0,I.dispose)(o)),m.clear()})];try{const o=(0,R.watch)(S.path);P.push((0,I.toDisposable)(()=>{o.removeAllListeners(),o.close()}));const u=new Set;S.isDirectory&&(0,r.readdir)(S.path).then(l=>l.forEach(c=>u.add(c))),o.on("error",(l,c)=>{M||b(`Failed to watch ${S.path} for changes using fs.watch() (${l}, ${c})`)}),o.on("change",(l,c)=>{if(!M){let t="";if(c&&(t=c.toString(),L.isMacintosh&&(t=(0,y.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const i=S.isDirectory?(0,v.join)(S.path,t):S.path;if(S.isDirectory)if(l==="rename"){const s=m.get(i);s&&(0,I.dispose)(s);const a=setTimeout(async()=>{m.delete(i);const h=await(0,r.exists)(i);if(!M){let f;h?u.has(t)?f="changed":(f="added",u.add(t)):(u.delete(t),f="deleted"),E(f,i)}},e.CHANGE_BUFFER_DELAY);m.set(i,(0,I.toDisposable)(()=>clearTimeout(a)))}else{let s;u.has(t)?s="changed":(s="added",u.add(t)),E(s,i)}else if(l==="rename"||t!==d){const s=setTimeout(async()=>{const a=await(0,r.exists)(i);M||(a?(E("changed",i),P=[n(S,E,b)]):E("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,I.dispose)(P),P=[(0,I.toDisposable)(()=>clearTimeout(s))]}else E("changed",i)}}})}catch(o){(0,r.exists)(S.path).then(u=>{u&&!M&&b(`Failed to watch ${S.path} for changes using fs.watch() (${o.toString()})`)})}return(0,I.toDisposable)(()=>{M=!0,P=(0,I.dispose)(P)})}}),define(Q[118],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[119],J([0,1,14,118,13]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function y(){v.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(r,w,p,n,S)=>{const E=I(r,n,p);E.popup({window:(0,L.withNullAsUndefined)(v.BrowserWindow.fromWebContents(r.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{E&&r.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=y;function I(r,w,p){const n=new v.Menu;return p.forEach(S=>{let E;S.type==="separator"?E=new v.MenuItem({type:S.type}):Array.isArray(S.submenu)?E=new v.MenuItem({submenu:I(r,w,S.submenu),label:S.label}):E=new v.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(b,d,m)=>r.sender.send(w,S.id,m)}),n.append(E)}),n}});var ce=this&&this.__decorate||function(j,e,v,R){var L=arguments.length,y=L<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")y=Reflect.decorate(j,e,v,R);else for(var r=j.length-1;r>=0;r--)(I=j[r])&&(y=(L<3?I(y):L>3?I(e,v,y):I(e,v))||y);return L>3&&y&&Object.defineProperty(e,v,y),y};define(Q[33],J([0,1,5,2,9,26,19,23,35,13,109,22,46]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function d(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(m=e.ResponseType||(e.ResponseType={}));function M(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var P;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(P||(P={}));class o{constructor(A){this.buffer=A,this.pos=0}read(A){const O=this.buffer.slice(this.pos,this.pos+A);return this.pos+=O.byteLength,O}}class u{constructor(){this.buffers=[]}get buffer(){return r.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var l;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object"})(l||(l={}));function c(_){const A=r.VSBuffer.alloc(4);return A.writeUInt32BE(_,0),A}function t(_){return _.read(4).readUInt32BE(0)}function i(_){const A=r.VSBuffer.alloc(1);return A.writeUInt8(_,0),A}const s={Undefined:i(l.Undefined),String:i(l.String),Buffer:i(l.Buffer),VSBuffer:i(l.VSBuffer),Array:i(l.Array),Object:i(l.Object)},a=typeof Buffer!="undefined";function h(_,A){if(typeof A=="undefined")_.write(s.Undefined);else if(typeof A=="string"){const O=r.VSBuffer.fromString(A);_.write(s.String),_.write(c(O.byteLength)),_.write(O)}else if(a&&Buffer.isBuffer(A)){const O=r.VSBuffer.wrap(A);_.write(s.Buffer),_.write(c(O.byteLength)),_.write(O)}else if(A instanceof r.VSBuffer)_.write(s.VSBuffer),_.write(c(A.byteLength)),_.write(A);else if(Array.isArray(A)){_.write(s.Array),_.write(c(A.length));for(const O of A)h(_,O)}else{const O=r.VSBuffer.fromString(JSON.stringify(A));_.write(s.Object),_.write(c(O.byteLength)),_.write(O)}}function f(_){switch(_.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return _.read(t(_)).toString();case l.Buffer:return _.read(t(_)).buffer;case l.VSBuffer:return _.read(t(_));case l.Array:{const O=t(_),D=[];for(let F=0;F<O;F++)D.push(f(_));return D}case l.Object:return JSON.parse(_.read(t(_)).toString())}}class g{constructor(A,O,D=null,F=1e3){this.protocol=A,this.ctx=O,this.logger=D,this.timeoutDelay=F,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(C=>this.onRawMessage(C)),this.sendResponse({type:200})}registerChannel(A,O){this.channels.set(A,O),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const O=this.send([A.type]);this.logger&&this.logger.logOutgoing(O,0,1,M(A.type));return}case 201:case 202:case 204:case 203:{const O=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(O,A.id,1,M(A.type),A.data);return}}}send(A,O=void 0){const D=new u;return h(D,A),h(D,O),this.sendBuffer(D.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(O){return 0}}onRawMessage(A){const O=new o(A),D=f(O),F=f(O),C=D[0];switch(C){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,D[1],1,`${d(C)}: ${D[2]}.${D[3]}`,F),this.onPromise({type:C,id:D[1],channelName:D[2],name:D[3],arg:F});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,D[1],1,`${d(C)}: ${D[2]}.${D[3]}`,F),this.onEventListen({type:C,id:D[1],channelName:D[2],name:D[3],arg:F});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,D[1],1,`${d(C)}`),this.disposeActiveRequest({type:C,id:D[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,D[1],1,`${d(C)}`),this.disposeActiveRequest({type:C,id:D[1]})}}onPromise(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const D=new y.CancellationTokenSource;let F;try{F=O.call(this.ctx,A.name,A.arg,D.token)}catch(G){F=Promise.reject(G)}const C=A.id;F.then(G=>{this.sendResponse({id:C,data:G,type:201}),this.activeRequests.delete(A.id)},G=>{G instanceof Error?this.sendResponse({id:C,data:{message:G.message,name:G.name,stack:G.stack?G.stack.split?G.stack.split(`
`):G.stack:void 0},type:202}):this.sendResponse({id:C,data:G,type:203}),this.activeRequests.delete(A.id)});const K=(0,R.toDisposable)(()=>D.cancel());this.activeRequests.set(A.id,K)}onEventListen(A){const O=this.channels.get(A.channelName);if(!O){this.collectPendingRequest(A);return}const D=A.id,C=O.listen(this.ctx,A.name,A.arg)(K=>this.sendResponse({id:D,data:K,type:204}));this.activeRequests.set(A.id,C)}disposeActiveRequest(A){const O=this.activeRequests.get(A.id);O&&(O.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let O=this.pendingRequests.get(A.channelName);O||(O=[],this.pendingRequests.set(A.channelName,O));const D=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);O.push({request:A,timeoutTimer:D})}flushPendingRequests(A){const O=this.pendingRequests.get(A);if(O){for(const D of O)switch(clearTimeout(D.timeoutTimer),D.request.type){case 100:this.onPromise(D.request);break;case 102:this.onEventListen(D.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=g;var k;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class T{constructor(A,O=null){this.protocol=A,this.isDisposed=!1,this.state=P.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(D=>this.onBuffer(D)),this.logger=O}getChannel(A){const O=this;return{call(D,F,C){return O.isDisposed?Promise.reject(I.canceled()):O.requestPromise(A,D,F,C)},listen(D,F){return O.isDisposed?Promise.reject(I.canceled()):O.requestEvent(A,D,F)}}}requestPromise(A,O,D,F=y.CancellationToken.None){const C=this.lastRequestId++,G={id:C,type:100,channelName:A,name:O,arg:D};if(F.isCancellationRequested)return Promise.reject(I.canceled());let Y;return new Promise((re,se)=>{if(F.isCancellationRequested)return se(I.canceled());const x=()=>{const me=Ee=>{switch(Ee.type){case 201:this.handlers.delete(C),re(Ee.data);break;case 202:this.handlers.delete(C);const Le=new Error(Ee.data.message);Le.stack=Ee.data.stack,Le.name=Ee.data.name,se(Le);break;case 203:this.handlers.delete(C),se(Ee.data);break}};this.handlers.set(C,me),this.sendRequest(G)};let ne=null;this.state===P.Idle?x():(ne=(0,L.createCancelablePromise)(me=>this.whenInitialized()),ne.then(()=>{ne=null,x()}));const ue=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:C,type:101}),se(I.canceled())},be=F.onCancellationRequested(ue);Y=(0,R.combinedDisposable)((0,R.toDisposable)(ue),be),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(A,O,D){const F=this.lastRequestId++,K={id:F,type:102,channelName:A,name:O,arg:D};let G=null;const Y=new v.Emitter({onFirstListenerAdd:()=>{G=(0,L.createCancelablePromise)(re=>this.whenInitialized()),G.then(()=>{G=null,this.activeRequests.add(Y),this.sendRequest(K)})},onLastListenerRemove:()=>{G?(G.cancel(),G=null):(this.activeRequests.delete(Y),this.sendRequest({id:F,type:103}))}}),Z=re=>Y.fire(re.data);return this.handlers.set(F,Z),Y.event}sendRequest(A){switch(A.type){case 100:case 102:{const O=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(O,A.id,0,`${d(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const O=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(O,A.id,0,d(A.type));return}}}send(A,O=void 0){const D=new u;return h(D,A),h(D,O),this.sendBuffer(D.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(O){return 0}}onBuffer(A){const O=new o(A),D=f(O),F=f(O),C=D[0];switch(C){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,M(C)),this.onResponse({type:D[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,D[1],0,M(C),F),this.onResponse({type:D[0],id:D[1],data:F})}}onResponse(A){if(A.type===200){this.state=P.Idle,this._onDidInitialize.fire();return}const O=this.handlers.get(A.id);O&&O(A)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===P.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}ce([E.memoize],T.prototype,"onDidInitializePromise",null),e.ChannelClient=T;class U{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:O,onDidClientDisconnect:D})=>{v.Event.once(O.onMessage)(C=>{const K=new o(C),G=f(K),Y=new g(O,G),Z=new T(O);this.channels.forEach((se,x)=>Y.registerChannel(x,se));const re={channelServer:Y,channelClient:Z,ctx:G};this._connections.add(re),this._onDidAddConnection.fire(re),D(()=>{Y.dispose(),Z.dispose(),this._connections.delete(re),this._onDidRemoveConnection.fire(re)})})})}get connections(){const A=[];return this._connections.forEach(O=>A.push(O)),A}getChannel(A,O){const D=this;return{call(F,C,K){let G;if((0,p.isFunction)(O)){let Z=(0,w.getRandomElement)(D.connections.filter(O));G=Z?Promise.resolve(Z):v.Event.toPromise(v.Event.filter(D.onDidAddConnection,O))}else G=O.routeCall(D,F,C);const Y=G.then(Z=>Z.channelClient.getChannel(A));return X(Y).call(F,C,K)},listen(F,C){if((0,p.isFunction)(O))return D.getMulticastEvent(A,O,F,C);const K=O.routeEvent(D,F,C).then(G=>G.channelClient.getChannel(A));return X(K).listen(F,C)}}}getMulticastEvent(A,O,D,F){const C=this;let K=new R.DisposableStore;const G=new v.Emitter({onFirstListenerAdd:()=>{K=new R.DisposableStore;const Y=new v.EventMultiplexer,Z=new Map,re=x=>{const ue=x.channelClient.getChannel(A).listen(D,F),be=Y.add(ue);Z.set(x,be)},se=x=>{const ne=Z.get(x);!ne||(ne.dispose(),Z.delete(x))};C.connections.filter(O).forEach(re),v.Event.filter(C.onDidAddConnection,O)(re,void 0,K),C.onDidRemoveConnection(se,void 0,K),Y.event(G.fire,G,K),K.add(Y)},onLastListenerRemove:()=>{K.dispose()}});return G.event}registerChannel(A,O){this.channels.set(A,O),this._connections.forEach(D=>{D.channelServer.registerChannel(A,O)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=U;class B{constructor(A,O,D=null){const F=new u;h(F,O),A.send(F.buffer),this.channelClient=new T(A,D),this.channelServer=new g(A,O,D)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,O){this.channelServer.registerChannel(A,O)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=B;function X(_){return{call(A,O,D){return _.then(F=>F.call(A,O,D))},listen(A,O){const D=new v.Relay;return _.then(F=>D.input=F.listen(A,O)),D.event}}}e.getDelayedChannel=X;function te(_){let A=!1;return{call(O,D,F){return A?_.call(O,D,F):(0,L.timeout)(0).then(()=>A=!0).then(()=>_.call(O,D,F))},listen(O,D){if(A)return _.listen(O,D);const F=new v.Relay;return(0,L.timeout)(0).then(()=>A=!0).then(()=>F.input=_.listen(O,D)),F.event}}}e.getNextTickChannel=te;class oe{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const O of A.connections)if(await Promise.resolve(this.fn(O.ctx)))return Promise.resolve(O);return await v.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=oe;var W;(function(_){function A(F,C){const K=F,G=C&&C.disableMarshalling,Y=new Map;for(const Z in K)D(Z)&&Y.set(Z,v.Event.buffer(K[Z],!0));return new class{listen(Z,re){const se=Y.get(re);if(se)return se;throw new Error(`Event not found: ${re}`)}call(Z,re,se){const x=K[re];if(typeof x=="function"){if(!G&&Array.isArray(se))for(let ne=0;ne<se.length;ne++)se[ne]=(0,n.revive)(se[ne]);return x.apply(K,se)}throw new Error(`Method not found: ${re}`)}}}_.fromService=A;function O(F,C){const K=C&&C.disableMarshalling;return new Proxy({},{get(G,Y){var Z;if(typeof Y=="string")return((Z=C==null?void 0:C.properties)===null||Z===void 0?void 0:Z.has(Y))?C.properties.get(Y):D(Y)?F.listen(Y):async function(...re){let se;C&&!(0,p.isUndefinedOrNull)(C.context)?se=[C.context,...re]:se=re;const x=await F.call(Y,se);return K?x:(0,n.revive)(x)};throw new Error(`Property not found: ${String(Y)}`)}})}_.toService=O;function D(F){return F[0]==="o"&&F[1]==="n"&&S.isUpperAsciiLetter(F.charCodeAt(2))}})(W=e.ProxyChannel||(e.ProxyChannel={}));const $=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function z(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){let A=_.toString();if(A!=="[object Object]")return A}return _}function N(_){return Array.isArray(_)?_.map(z):z(_)}function H(_,A,O,D,F,C,K){K=N(K);const G=$[F],Y=G[D%G.length];let Z=[`%c[${_}]%c[${String(A).padStart(7," ")}]%c[len: ${String(O).padStart(5," ")}]%c${String(D).padStart(5," ")} - ${C}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(C)?(Z=Z.concat(K),Z.push(")")):Z.push(K),console.log.apply(console,Z)}e.logWithColors=H;class V{constructor(A,O){this._outgoingPrefix=A,this._incomingPrefix=O,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,O,D,F,C){this._totalOutgoing+=A,H(this._outgoingPrefix,this._totalOutgoing,A,O,D,F,C)}logIncoming(A,O,D,F,C){this._totalIncoming+=A,H(this._incomingPrefix,this._totalIncoming,A,O,D,F,C)}}e.IPCLogger=V}),define(Q[120],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(L,y){this.sender=L,this.onMessage=y}send(L){try{this.sender.send("vscode:message",L.buffer)}catch(y){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(Q[121],J([0,1,5,33,23]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class y{constructor(w){this.port=w,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",p=>L.VSBuffer.wrap(p.data)),w.start()}send(w){this.port.postMessage(w.buffer)}disconnect(){this.port.close()}}e.Protocol=y;class I extends R.IPCClient{constructor(w,p){const n=new y(w);super(n,p);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=I}),define(Q[83],J([0,1,5,33,2,23,3,32]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let w=null;function p(){return w||(w=y.VSBuffer.alloc(0)),w}class n{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,a){if(s===0)return p();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const k=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=s),k}if(this._chunks[0].byteLength>s){const k=this._chunks[0].slice(0,s);return a&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),k}let h=y.VSBuffer.alloc(s),f=0,g=0;for(;s>0;){const k=this._chunks[g];if(k.byteLength>s){const T=k.slice(0,s);h.set(T,f),f+=s,a&&(this._chunks[g]=k.slice(s),this._totalLength-=s),s-=s}else h.set(k,f),f+=k.byteLength,a?(this._chunks.shift(),this._totalLength-=k.byteLength):g++,s-=k.byteLength}return h}}e.ChunkStream=n;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(S||(S={}));var E;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(s,a,h,f){this.type=s,this.id=a,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(s){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new n,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,g=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new b(h,f,g,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=y.VSBuffer.alloc(13);a.writeUInt8(s.type,0),a.writeUInt32BE(s.id,1),a.writeUInt32BE(s.ack,5),a.writeUInt32BE(s.data.byteLength,9),this._writeSoon(a,s.data)}}_bufferAdd(s,a){const h=this._totalLength===0;return this._data.push(s,a),this._totalLength+=s.byteLength+a.byteLength,h}_bufferTake(){const s=y.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,a){this._bufferAdd(s,a)&&I.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class M extends L.Disposable{constructor(s){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new b(1,0,0,s))}}e.Protocol=M;class P extends R.IPCClient{constructor(s,a,h=null){super(s,a,h);this.protocol=s}static fromSocket(s,a){return new P(new M(s),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=P;class o{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,r.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=o;class u{constructor(s){this.data=s,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],a=0,h=this._first;for(;h;)s[a++]=h.data,h=h.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const a=new u(s);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let a=0;a<c._HISTORY_LENGTH;a++)this.lastRuns[a]=s-1e3*a;setInterval(()=>{for(let a=c._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),a=(1+c._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<c._HISTORY_LENGTH;f++)s-this.lastRuns[f]<=a&&h++;return 1-h/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,a=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new o,this.onControlMessage=this._onControlMessage.event,this._onMessage=new o,this.onMessage=this._onMessage.event,this._onDidDispose=new o,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new o,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new o,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,L.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new b(5,0,0,p());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const a=new b(4,0,0,p());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,a){this._isReconnecting=!0,this._socketDisposables=(0,L.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let a=0,h=s.length;a<h;a++)this._socketWriter.write(s[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new b(6,0,0,p())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const a=this._outgoingUnackMsg.toArray();for(let h=0,f=a.length;h<f;h++)this._socketWriter.write(a[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new b(1,a,this._incomingAckId,s);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(s){const a=new b(2,0,0,s);this._socketWriter.write(a)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),a=Date.now()-s.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new b(3,0,this._incomingAckId,p());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(Q[122],J([0,1,14,5,33,120,2,23]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function w(n,S){const E=R.Event.fromNodeEventEmitter(v.ipcMain,S,(d,m)=>({event:d,message:m})),b=R.Event.filter(E,({event:d})=>d.sender.id===n);return R.Event.map(b,({message:d})=>d&&r.VSBuffer.wrap(d))}class p extends L.IPCServer{constructor(){super(p.getOnDidClientConnect())}static getOnDidClientConnect(){const S=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return R.Event.map(S,E=>{const b=E.id,d=p.Clients.get(b);d&&d.dispose();const m=new R.Emitter;p.Clients.set(b,(0,I.toDisposable)(()=>m.fire()));const M=w(b,"vscode:message"),P=R.Event.any(R.Event.signal(w(b,"vscode:disconnect")),m.event);return{protocol:new y.Protocol(E,M),onDidClientDisconnect:P}})}}e.Server=p,p.Clients=new Map}),define(Q[84],J([0,1,14,5,28,121]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class I extends y.Client{constructor(p,n){super({addEventListener:(S,E)=>p.addListener(S,E),removeEventListener:(S,E)=>p.removeListener(S,E),postMessage:S=>p.postMessage(S),start:()=>p.start(),close:()=>p.close()},n)}}e.Client=I;async function r(w){if(w.isDestroyed()||w.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const p=(0,L.generateUuid)();w.webContents.send("vscode:createMessageChannel",p);const n=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,b)=>({nonce:b,port:E.ports[0]})),{port:S}=await R.Event.toPromise(R.Event.once(R.Event.filter(n,E=>E.nonce===p)));return S}e.connect=r}),define(Q[85],J([0,1,2,5,9,13]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var r;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(r||(r={}));class w extends v.Disposable{constructor(S,E=Object.create(null)){super();this.database=S,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=r.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){var E,b;(E=S.changed)===null||E===void 0||E.forEach((d,m)=>this.accept(m,d)),(b=S.deleted)===null||b===void 0||b.forEach(d=>this.accept(d,void 0))}accept(S,E){if(this.state!==r.Closed){let b=!1;(0,y.isUndefinedOrNull)(E)?b=this.cache.delete(S):this.cache.get(S)!==E&&(this.cache.set(S,E),b=!0),b&&this._onDidChangeStorage.fire(S)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===r.None&&(this.state=r.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,E){const b=this.cache.get(S);return(0,y.isUndefinedOrNull)(b)?E:b}getBoolean(S,E){const b=this.get(S);return(0,y.isUndefinedOrNull)(b)?E:b==="true"}getNumber(S,E){const b=this.get(S);return(0,y.isUndefinedOrNull)(b)?E:parseInt(b,10)}async set(S,E){if(this.state!==r.Closed){if((0,y.isUndefinedOrNull)(E))return this.delete(S);const b=String(E);if(this.cache.get(S)!==b)return this.cache.set(S,b),this.pendingInserts.set(S,b),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(S){if(this.state!==r.Closed&&!!this.cache.delete(S))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=r.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(S){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class p{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((E,b)=>this.items.set(b,E)),S.delete&&S.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=p}),define(Q[123],J([0,1,20,5,9,36,7,16]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class w{constructor(S,E=Object.create(null)){this.path=S,this.options=E,this.name=(0,I.basename)(this.path),this.logger=new p(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const S=await this.whenConnected,E=new Map;return(await this.all(S,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(S){const E=await this.whenConnected;return this.doUpdateItems(E,S)}doUpdateItems(S,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,y.mapToString)(E.insert):"0"}), delete(${E.delete?(0,y.setToString)(E.delete):"0"})`),this.transaction(S,()=>{const b=E.insert,d=E.delete;if(b&&b.size>0){const m=[];m.push([]);let M=0;b.forEach((P,o)=>{let u=m[M];u.length>w.MAX_HOST_PARAMETERS&&(M++,u=[],m.push(u)),u.push(o,P)}),m.forEach(P=>{this.prepare(S,`INSERT INTO ItemTable VALUES ${new Array(P.length/2).fill("(?,?)").join(",")}`,o=>o.run(P),()=>{const o=[];let u=0;return b.forEach((l,c)=>{o.push(c),u+=l.length}),`Keys: ${o.join(", ")} Length: ${u}`})})}if(d&&d.size){const m=[];m.push([]);let M=0;d.forEach(P=>{let o=m[M];o.length>w.MAX_HOST_PARAMETERS&&(M++,o=[],m.push(o)),o.push(P)}),m.forEach(P=>{this.prepare(S,`DELETE FROM ItemTable WHERE key IN (${new Array(P.length).fill("?").join(",")})`,o=>o.run(P),()=>{const o=[];return d.forEach(u=>{o.push(u)}),`Keys: ${o.join(", ")}`})})}})}async close(S){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,S)}doClose(S,E){return new Promise((b,d)=>{S.db.close(m=>(m&&this.handleSQLiteError(S,`[storage ${this.name}] close(): ${m}`),this.path===w.IN_MEMORY_PATH?b():!S.isErroneous&&!S.isInMemory?this.backup().then(b,M=>(this.logger.error(`[storage ${this.name}] backup(): ${M}`),b())):typeof E=="function"?v.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(M=>{const P=()=>this.doClose(M,void 0);return this.doUpdateItems(M,{insert:E()}).then(()=>P(),o=>(P(),Promise.reject(o)))})).then(b,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const S=this.toBackupPath(this.path);return(0,r.copy)(this.path,S,{preserveSymlinks:!1})}toBackupPath(S){return`${S}.backup`}async checkIntegrity(S){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${S})`);const E=await this.whenConnected,b=await this.get(E,S?"PRAGMA integrity_check":"PRAGMA quick_check"),d=S?b.integrity_check:b.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(S,E=!0){this.logger.trace(`[storage ${this.name}] open(${S}, retryOnBusy: ${E})`);try{return await this.doConnect(S)}catch(b){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${b}`),b.code==="SQLITE_BUSY"&&E)return await(0,L.timeout)(w.BUSY_OPEN_TIMEOUT),this.connect(S,!1);try{await v.promises.unlink(S);try{await v.promises.rename(this.toBackupPath(S),S)}catch(d){}return await this.doConnect(S)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(w.IN_MEMORY_PATH)}}}handleSQLiteError(S,E){S.isErroneous=!0,S.lastError=E,this.logger.error(E)}doConnect(S){return new Promise((E,b)=>{new Promise((d,m)=>{j(["vscode-sqlite3"],d,m)}).then(d=>{const m={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(S,M=>M?m.db?m.db.close(()=>b(M)):b(M):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(m),P=>m.db.close(()=>b(P)))),isInMemory:S===w.IN_MEMORY_PATH};m.db.on("error",M=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${M}`)),this.logger.isTracing&&m.db.on("trace",M=>this.logger.trace(`[storage ${this.name}] Trace (event): ${M}`))},b)})}exec(S,E){return new Promise((b,d)=>{S.db.exec(E,m=>m?(this.handleSQLiteError(S,`[storage ${this.name}] exec(): ${m}`),d(m)):b())})}get(S,E){return new Promise((b,d)=>{S.db.get(E,(m,M)=>m?(this.handleSQLiteError(S,`[storage ${this.name}] get(): ${m}`),d(m)):b(M))})}all(S,E){return new Promise((b,d)=>{S.db.all(E,(m,M)=>m?(this.handleSQLiteError(S,`[storage ${this.name}] all(): ${m}`),d(m)):b(M))})}transaction(S,E){return new Promise((b,d)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),E(),S.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(S,`[storage ${this.name}] transaction(): ${m}`),d(m)):b())})})}prepare(S,E,b,d){const m=S.db.prepare(E),M=P=>{this.handleSQLiteError(S,`[storage ${this.name}] prepare(): ${P} (${E}). Details: ${d()}`)};m.on("error",M),b(m),m.finalize(P=>{P&&M(P),m.removeListener("error",M)})}}e.SQLiteStorageDatabase=w,w.IN_MEMORY_PATH=":memory:",w.BUSY_OPEN_TIMEOUT=2e3,w.MAX_HOST_PARAMETERS=256;class p{constructor(S){S&&typeof S.logTrace=="function"&&process.env[p.VSCODE_TRACE_STORAGE]&&(this.logTrace=S.logTrace),S&&typeof S.logError=="function"&&(this.logError=S.logError)}get isTracing(){return!!this.logTrace}trace(S){this.logTrace&&this.logTrace(S)}error(S){this.logError&&this.logError(S)}}p.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[124],J([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[125],J([0,1,124]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,L=R*60,y=L*24,I=y*7,r=y*30,w=y*365;function p(S,E){typeof S!="number"&&(S=S.getTime());const b=Math.round((new Date().getTime()-S)/1e3);if(b<-30)return(0,v.localize)(0,null,p(new Date().getTime()+b*1e3,!1));if(b<30)return(0,v.localize)(1,null);let d;return b<R?(d=b,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):b<L?(d=Math.floor(b/R),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):b<y?(d=Math.floor(b/L),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):b<I?(d=Math.floor(b/y),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):b<r?(d=Math.floor(b/I),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):b<w?(d=Math.floor(b/r),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(b/w),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=p;function n(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Q[126],J([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[67],J([0,1,126,13,35]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function y(p,n){return n&&(p.stack||p.stacktrace)?v.localize(0,null,r(p),I(p.stack)||I(p.stacktrace)):r(p)}function I(p){return Array.isArray(p)?p.join(`
`):p}function r(p){return typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?v.localize(1,null,p.message):p.message||v.localize(2,null)}function w(p=null,n=!1){if(!p)return v.localize(3,null);if(Array.isArray(p)){const S=L.coalesce(p),E=w(S[0],n);return S.length>1?v.localize(4,null,E,S.length):E}if(R.isString(p))return p;if(p.detail){const S=p.detail;if(S.error)return y(S.error,n);if(S.exception)return y(S.exception,n)}return p.stack?y(p,n):p.message?p.message:v.localize(5,null)}e.toErrorMessage=w}),define(Q[127],J([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[128],J([0,1,127]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(I,r,w=r){this.modifierLabels=[null],this.modifierLabels[2]=I,this.modifierLabels[1]=r,this.modifierLabels[3]=w}toLabel(I,r,w){if(r.length===0)return null;const p=[];for(let n=0,S=r.length;n<S;n++){const E=r[n],b=w(E);if(b===null)return null;p[n]=L(E,b,this.modifierLabels[I])}return p.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function L(y,I,r){if(I===null)return"";const w=[];return y.ctrlKey&&w.push(r.ctrlKey),y.shiftKey&&w.push(r.shiftKey),y.altKey&&w.push(r.altKey),y.metaKey&&w.push(r.metaKey),I!==""&&w.push(I),w.join(r.separator)}}),define(Q[129],J([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[68],J([0,1,7,20,16,45,129,32,13,44,30,3,81,10]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(c,t){if(S.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const s=y.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],i);return new Promise(a=>{s.once("error",h=>{a({success:!1,error:h})}),s.once("exit",(h,f)=>{a(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(S.isLinux||S.isMacintosh)try{const i=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(s=>{y.execFile(i,[c.pid.toString()],{encoding:"utf8",shell:!0},(a,h,f)=>{s(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function M(c=r.env){return c.comspec||"cmd.exe"}e.getWindowsShell=M;class P{constructor(t,i,s,a){if(i!==void 0&&s!==void 0&&a!==void 0)this.cmd=t,this.args=i,this.shell=s,this.options=a;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(r.env).forEach(f=>{h[f]=r.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(v.sep);return i!==-1&&(t=t.substring(i+1)),P.WellKnowCommands[t]?t:"other"}start(t){return S.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(r.cwd()))?Promise.reject(new Error(I.localize(0,null))):this.useExec().then(i=>{let s,a;const h=new Promise((f,g)=>{s=f,a=g});if(i){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=y.exec(f,this.options,(g,k,T)=>{this.childProcess=null;const U=g;U&&U.killed?a({killed:this.terminateRequested,stdout:k.toString(),stderr:T.toString()}):this.handleExec(s,t,g,k,T)})}else{let f=null;const g=k=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(k,s,t,a);const T={terminated:this.terminateRequested};w.isNumber(k)&&(T.cmdCode=k),s(T)};if(this.shell&&S.isWindows){const k=p.deepClone(this.options);k.windowsVerbatimArguments=!0,k.detached=!1;let T=!1,U=!1;const B=[];let X=this.ensureQuotes(this.cmd);B.push(X.value),T=X.quoted,this.args&&this.args.forEach(oe=>{X=this.ensureQuotes(oe),B.push(X.value),U=U&&X.quoted});const te=["/s","/c"];T?U?te.push('"'+B.join(" ")+'"'):B.length>1?te.push('"'+B[0]+'" '+B.slice(1).join(" ")):te.push('"'+B[0]+'"'):te.push(B.join(" ")),f=y.spawn(M(),te,k)}else this.cmd&&(f=y.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(w.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",k=>{this.childProcess=null,a({terminated:this.terminateRequested,error:k})}),f.pid&&(this.childProcess.on("close",g),this.handleSpawn(f,s,t,a,!0)))}return h})}handleClose(t,i,s,a){}ensureQuotes(t){return P.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!S.isWindows)return t(!1);const i=y.spawn(M(),["/s","/c"]);i.on("error",s=>t(!0)),i.on("exit",s=>t(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class o extends P{constructor(t,i,s,a){super(t,i,s,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,s,a,h){[a,h].forEach((f,g)=>{const k=new E.LineDecoder;k.write(f).forEach(B=>{i({line:B,source:g===0?0:1})});const U=k.end();U&&i({line:U,source:g===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,i,s,a,h){const f=new E.LineDecoder,g=new E.LineDecoder;t.stdout.on("data",k=>{f.write(k).forEach(U=>s({line:U,source:0}))}),t.stderr.on("data",k=>{g.write(k).forEach(U=>s({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=g}handleClose(t,i,s,a){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&s({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&s({line:f,source:1})}}e.LineProcess=o;function u(c){let t=[],i=!1;const s=function(a){if(i){t.push(a);return}(!c.send(a,f=>{if(f&&console.error(f),i=!1,t.length>0){const g=t.slice(0);t=[],g.forEach(k=>s(k))}})||S.isWindows)&&(i=!0)};return{send:s}}e.createQueuedSender=u;var l;(function(c){async function t(i,s,a){if(v.isAbsolute(i))return i;if(s===void 0&&(s=r.cwd()),v.dirname(i)!=="."||(a===void 0&&w.isString(r.env.PATH)&&(a=r.env.PATH.split(v.delimiter)),a===void 0||a.length===0))return v.join(s,i);async function f(g){return await L.exists(g)?!(await R.promises.stat(g)).isDirectory():!1}for(let g of a){let k;if(v.isAbsolute(g)?k=v.join(g,i):k=v.join(s,g,i),await f(k))return k;let T=k+".com";if(await f(T)||(T=k+".exe",await f(T)))return T}return v.join(s,i)}c.findExecutable=t})(l=e.win32||(e.win32={}))}),define(Q[130],J([0,1,27,3,116,68]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(b,d){return b===1?R.isWindows?S():y.getWindowsShell(d):p(b,d)}e.getSystemShell=I;function r(b,d){return b===1?R.isWindows?E(d):y.getWindowsShell(d):p(b,d)}e.getSystemShellSync=r;let w=null;function p(b,d){if(R.isLinux&&b===2||R.isMacintosh&&b===3)return"/bin/bash";if(!w){let m;if(R.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=(0,v.userInfo)().shell}catch(M){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}w=m}return w}let n=null;async function S(){return n||(n=(await(0,L.getFirstAvailablePowerShellInstallation)()).exePath),n}function E(b){if(n)return n;const d=R.isWindows&&parseFloat((0,v.release)())>=10,m=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),M=`${b.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?M:y.getWindowsShell(b)}}),define(Q[86],J([0,1,45,2,9,44,5,68,33,108,26,19,23,3]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends w.ChannelServer{constructor(P){super({send:o=>{try{process.send&&process.send(o.buffer.toString("base64"))}catch(u){}},onMessage:I.Event.fromNodeEventEmitter(process,"message",o=>E.VSBuffer.wrap(Buffer.from(o,"base64")))},P);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(P,o){this.modulePath=P,this.options=o,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=o&&o.timeout?o.timeout:6e4;this.disposeDelayer=new L.Delayer(u),this.child=null,this._client=null}getChannel(P){const o=this;return{call(u,l,c){return o.requestPromise(P,u,l,c)},listen(u,l){return o.requestEvent(P,u,l)}}}requestPromise(P,o,u,l=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(S.canceled());this.disposeDelayer.cancel();const c=this.getCachedChannel(P),t=(0,L.createCancelablePromise)(a=>c.call(o,u,a)),i=l.onCancellationRequested(()=>t.cancel()),s=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(s),t.finally(()=>{i.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(P,o,u){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let l;const c=new I.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(P).listen(o,u)(c.fire,c),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return c.event}get client(){if(!this._client){const P=this.options&&this.options.args?this.options.args:[],o=Object.create(null);o.env=Object.assign(Object.assign({},(0,y.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(o.env=Object.assign(Object.assign({},o.env),this.options.env)),this.options&&this.options.freshExecArgv&&(o.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),b.isMacintosh&&o.env&&delete o.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,P,o);const u=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,p.isRemoteConsoleLog)(h)){(0,p.log)(h,`IPC Library: ${this.options.serverName}`);return}u.fire(E.VSBuffer.wrap(Buffer.from(h,"base64")))});const c=this.options.useQueue?(0,r.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&c.send(h.buffer.toString("base64")),i=u.event,s={send:t,onMessage:i};this._client=new w.ChannelClient(s);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",a),this.activeRequests.forEach(g=>(0,R.dispose)(g)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(P){let o=this.channels.get(P);return o||(o=this.client.getChannel(P),this.channels.set(P,o)),o}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(Q[131],J([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[132],J([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[133],J([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[134],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[135],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[136],J([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[137],J([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[138],J([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[139],J([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[140],J([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[141],J([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[142],J([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[143],J([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[144],J([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[145],J([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[146],J([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[147],J([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[148],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[149],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[150],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[151],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[152],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[153],J([0,1,5,2]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class L{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(r,w,p){switch(w){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:p[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:p[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:p[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:p[0],port:p[1],subId:p[2]}))}throw new Error("Method not implemented.")}listen(r,w,p){switch(w){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=L,L.ChannelName="extensionhostdebugservice";class y extends R.Disposable{constructor(r){super();this.channel=r}reload(r){this.channel.call("reload",[r])}get onReload(){return this.channel.listen("reload")}close(r){this.channel.call("close",[r])}get onClose(){return this.channel.listen("close")}attachSession(r,w,p){this.channel.call("attach",[r,w,p])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(r,w){this.channel.call("terminate",[r,w])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(r,w,p){return this.channel.call("openExtensionDevelopmentHostWindow",[r,w||{},p])}}e.ExtensionHostDebugChannelClient=y}),define(Q[154],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class v{constructor(I){this.driver=I}listen(I,r){throw new Error(`No event found: ${r}`)}call(I,r,w){switch(r){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${r}`)}}e.WindowDriverChannel=v;class R{constructor(I){this.channel=I}click(I,r,w){return this.channel.call("click",[I,r,w])}doubleClick(I){return this.channel.call("doubleClick",I)}setValue(I,r){return this.channel.call("setValue",[I,r])}getTitle(){return this.channel.call("getTitle")}isActiveElement(I){return this.channel.call("isActiveElement",I)}getElements(I,r){return this.channel.call("getElements",[I,r])}getElementXY(I,r,w){return this.channel.call("getElementXY",[I,r,w])}typeInEditor(I,r){return this.channel.call("typeInEditor",[I,r])}getTerminalBuffer(I){return this.channel.call("getTerminalBuffer",I)}writeInTerminal(I,r){return this.channel.call("writeInTerminal",[I,r])}}e.WindowDriverChannelClient=R;class L{constructor(I){this.channel=I}registerWindowDriver(I){return this.channel.call("registerWindowDriver",I)}reloadWindowDriver(I){return this.channel.call("reloadWindowDriver",I)}}e.WindowDriverRegistryChannelClient=L}),define(Q[155],J([0,1,7,15,46,125,10,8,32]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class p{constructor(d,m,M){this._args=d,this.paths=m,this.productService=M}get appRoot(){return(0,v.dirname)(I.FileAccess.asFileUri("",j).fsPath)}get userHome(){return r.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return r.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return r.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return r.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(r.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return r.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return r.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=w.env.VSCODE_PORTABLE;return d?r.URI.file((0,v.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return r.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,v.resolve)(d):(0,v.normalize)((0,v.join)(I.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,v.resolve)(d):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,v.resolve)(d);const m=w.env.VSCODE_EXTENSIONS;if(m)return m;const M=w.env.VSCODE_PORTABLE;return M?(0,v.join)(M,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?r.URI.parse(m):r.URI.file((0,v.normalize)(m)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?r.URI.parse(d):r.URI.file((0,v.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!w.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(r.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return r.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([L.memoize],p.prototype,"appRoot",null),ce([L.memoize],p.prototype,"userHome",null),ce([L.memoize],p.prototype,"userDataPath",null),ce([L.memoize],p.prototype,"appSettingsHome",null),ce([L.memoize],p.prototype,"tmpDir",null),ce([L.memoize],p.prototype,"userRoamingDataHome",null),ce([L.memoize],p.prototype,"settingsResource",null),ce([L.memoize],p.prototype,"userDataSyncHome",null),ce([L.memoize],p.prototype,"userDataSyncLogResource",null),ce([L.memoize],p.prototype,"sync",null),ce([L.memoize],p.prototype,"machineSettingsResource",null),ce([L.memoize],p.prototype,"globalStorageHome",null),ce([L.memoize],p.prototype,"workspaceStorageHome",null),ce([L.memoize],p.prototype,"keybindingsResource",null),ce([L.memoize],p.prototype,"keyboardLayoutResource",null),ce([L.memoize],p.prototype,"argvResource",null),ce([L.memoize],p.prototype,"snippetsHome",null),ce([L.memoize],p.prototype,"isExtensionDevelopment",null),ce([L.memoize],p.prototype,"untitledWorkspacesHome",null),ce([L.memoize],p.prototype,"installSourcePath",null),ce([L.memoize],p.prototype,"builtinExtensionsPath",null),ce([L.memoize],p.prototype,"extensionsPath",null),ce([L.memoize],p.prototype,"extensionDevelopmentLocationURI",null),ce([L.memoize],p.prototype,"extensionDevelopmentKind",null),ce([L.memoize],p.prototype,"extensionTestsLocationURI",null),ce([L.memoize],p.prototype,"debugExtensionHost",null),ce([L.memoize],p.prototype,"serviceMachineIdResource",null),ce([L.memoize],p.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=p;function n(b,d){return E(b["inspect-extensions"],b["inspect-brk-extensions"],5870,d,b.debugId)}e.parseExtensionHostPort=n;function S(b,d){return E(b["inspect-search"],b["inspect-brk-search"],5876,d)}e.parseSearchPort=S;function E(b,d,m,M,P){const u=Number(d||b)||(M?null:m),l=u?Boolean(!!d):!1;return{port:u,break:l,debugId:P}}}),define(Q[87],J([0,1,237,134,3]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const y={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function r(d,m,M=I){const P={},o=[],u=[];for(let i in m){const s=m[i];s.alias&&(P[i]=s.alias),s.type==="string"||s.type==="string[]"?(o.push(i),s.deprecates&&o.push(s.deprecates)):s.type==="boolean"&&(u.push(i),s.deprecates&&u.push(s.deprecates))}const l=v(d,{string:o,boolean:u,alias:P}),c={},t=l;c._=l._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in m){const s=m[i];s.alias&&delete t[s.alias];let a=t[i];s.deprecates&&t.hasOwnProperty(s.deprecates)&&(a||(a=t[s.deprecates]),delete t[s.deprecates]),typeof a!="undefined"&&(s.type==="string[]"?a&&!Array.isArray(a)&&(a=[a]):s.type==="string"&&Array.isArray(a)&&(a=a.pop(),M.onMultipleValues(i,a)),c[i]=a),delete t[i]}for(let i in t)M.onUnknownOption(i);return c}e.parseArgs=r;function w(d,m){let M="";return m.args&&(Array.isArray(m.args)?M=` <${m.args.join("> <")}>`:M=` <${m.args}>`),m.alias?`-${m.alias} --${d}${M}`:`--${d}${M}`}function p(d,m){let M=0,P=[];for(const c in d){const t=d[c],i=w(c,t);M=Math.max(M,i.length),P.push([i,t.description])}let o=M+2+1;if(m-o<25)return P.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let u=m-o-1,l=[];for(const c of P){let t=c[0],i=S(c[1],u),s=n(o-t.length-2);l.push("  "+t+s+i[0]);for(let a=1;a<i.length;a++)l.push(n(o)+i[a])}return l}e.formatOptions=p;function n(d){return" ".repeat(d)}function S(d,m){let M=[];for(;d.length;){let P=d.length<m?d.length:d.lastIndexOf(" ",m),o=d.slice(0,P).trim();d=d.slice(P),M.push(o)}return M}function E(d,m,M,P,o=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${d} ${M}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${m} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),o&&(L.isWindows?l.push((0,R.localize)(35,null,m)):l.push((0,R.localize)(36,null,m)),l.push(""));const c={};for(const t in P){const i=P[t];if(i.description&&i.cat){let s=c[i.cat];s||(c[i.cat]=s={}),s[t]=i}}for(let t in c){const i=t;let s=c[i];s&&(l.push(y[i]),l.push(...p(s,u)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=E;function b(d,m){return`${d||(0,R.localize)(37,null)}
${m||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=b}),define(Q[156],J([0,1,87,59,153]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class y extends L.ExtensionHostDebugBroadcastChannel{constructor(r){super();this.windowsMainService=r}call(r,w,p){return w==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(p[0],p[1],p[2]):super.call(r,w,p)}async openExtensionDevelopmentHostWindow(r,w,p){const n=(0,v.parseArgs)(r,v.OPTIONS);n.debugRenderer=p;const S=n.extensionDevelopmentPath;if(!S)return{success:!1};let E;const b=Object.keys(w);for(let u of b){let l=w[u];l===null||(E||(E=Object.create(null)),E[u]=l)}const[d]=this.windowsMainService.openExtensionDevelopmentHostWindow(S,{context:5,cli:n,userEnv:E});if(!p)return{success:!0};const m=d.win;if(!m)return{success:!0};const M=m.webContents.debugger;let P=M.isAttached()?Infinity:0;const o=(0,R.createServer)(u=>{P++==0&&M.attach();let l=!1;const c=s=>{l||u.write(JSON.stringify(s)+"\0")},t=(s,a,h,f)=>c({method:a,params:h,sessionId:f});m.on("close",()=>{M.removeListener("message",t),u.end(),l=!0}),M.addListener("message",t);let i=Buffer.alloc(0);u.on("data",s=>{i=Buffer.concat([i,s]);for(let a=i.indexOf(0);a!==-1;a=i.indexOf(0)){let h;try{const f=i.slice(0,a).toString("utf8");i=i.slice(a+1),h=JSON.parse(f)}catch(f){console.error("error reading cdp line",f)}M.sendCommand(h.method,h.params,h.sessionId).then(f=>c({id:h.id,sessionId:h.sessionId,result:f})).catch(f=>c({id:h.id,sessionId:h.sessionId,error:{code:0,message:f.message}}))}}),u.on("error",s=>{console.error("error on cdp pipe:",s)}),u.on("close",()=>{l=!0,--P==0&&M.detach()})});return await new Promise(u=>o.listen(0,u)),m.on("close",()=>o.close()),{rendererDebugPort:o.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=y}),function(){"use strict";function j(e,v,R,L){function y(r){const w=I(r),p=[w];return e.isAbsolute(w)||p.unshift(L),e.resolve(...p)}function I(r){const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");const p=r["user-data-dir"];if(p)return p;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(S,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,R)}return{getUserDataPath:y}}if(typeof define=="function")define(Q[157],J([0,158,27,10,15,32]),function(e,v,R,L,y,I){const r=y.dirname(L.FileAccess.asFileUri("",e)),w=e.__$__nodeRequire(y.joinPath(r,"package.json").fsPath);return j(v,R,w.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=j(v,R,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[159],J([0,1,27,157,155]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class y extends L.AbstractNativeEnvironmentService{constructor(r,w){super(r,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,R.getUserDataPath)(r)},w)}}e.NativeEnvironmentService=y}),define(Q[160],J([0,1,20,27,7]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function y(I){const r=(0,L.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(r,""),I&&console.log(`Marker file for --wait created: ${r}`),r}catch(w){I&&console.error(`Failed to create marker file for --wait: ${w}`);return}}e.createWaitMarkerFile=y}),define(Q[161],J([0,1,137]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function L(S){return S=S.trim(),S==="*"||R.test(S)}e.isValidVersionStr=L;function y(S){if(!L(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=S.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=y;function I(S){if(!S)return null;let E=S.majorBase,b=S.majorMustEqual,d=S.minorBase,m=S.minorMustEqual,M=S.patchBase,P=S.patchMustEqual;return S.hasCaret&&(E===0||(m=!1),P=!1),{majorBase:E,majorMustEqual:b,minorBase:d,minorMustEqual:m,patchBase:M,patchMustEqual:P,isMinimum:S.hasGreaterEquals}}e.normalizeVersion=I;function r(S,E){let b;typeof S=="string"?b=I(y(S)):b=S;let d;if(typeof E=="string"?d=I(y(E)):d=E,!b||!d)return!1;let m=b.majorBase,M=b.minorBase,P=b.patchBase,o=d.majorBase,u=d.minorBase,l=d.patchBase,c=d.majorMustEqual,t=d.minorMustEqual,i=d.patchMustEqual;return d.isMinimum?m>o?!0:m<o?!1:M>u?!0:M<u?!1:P>=l:(m===1&&o===0&&(!c||!t||!i)&&(o=1,u=0,l=0,c=!0,t=!1,i=!1),m<o?!1:m>o?!c:M<u?!1:M>u?!t:P<l?!1:P>l?!i:!0)}e.isValidVersion=r;function w(S,E,b){return E.isBuiltin||typeof E.main=="undefined"?!0:n(S,E.engines.vscode,b)}e.isValidExtensionVersion=w;function p(S,E){return S==="*"||n(E,S)}e.isEngineValid=p;function n(S,E,b=[]){let d=I(y(E));if(!d)return b.push(v.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return b.push(v.localize(1,null,E)),!1}else if(!d.majorMustEqual)return b.push(v.localize(2,null,E)),!1;return r(S,d)?!0:(b.push(v.localize(3,null,S,E)),!1)}e.isVersionValid=n}),define(Q[162],J([0,1,33,86,2,10]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends L.Disposable{constructor(w,p,n,S){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=S,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(y.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(w.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.setFolders(this.folders)}setVerboseLogging(w){this.verboseLogging=w,!this.isDisposed&&this.service&&this.service.setVerboseLogging(w)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${w}`})}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Q[163],J([0,1,33,86,2,10]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends L.Disposable{constructor(w,p,n,S,E={}){super();this.folders=w,this.onDidFilesChange=p,this.onLogMessage=n,this.verboseLogging=S,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const w=this._register(new R.Client(y.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(w.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(w.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(p=>!this.isDisposed&&this.onDidFilesChange(p))),this._register(this.service.onDidLogMessage(p=>this.onLogMessage(p))),this.service.setRoots(this.folders)}error(w){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${w}`})}setVerboseLogging(w){this.verboseLogging=w,this.service&&this.service.setVerboseLogging(w)}setFolders(w){this.folders=w,this.service&&this.service.setRoots(w)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(Q[164],J([0,1,45,81,110,10]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(w,p,n,S,E){this.watchedFolder=w,this.eventCallback=n,this.logCallback=S,this.verboseLogging=E,this.restartCounter=0,Array.isArray(p)?this.ignored=p.map(b=>L.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${w}`),this.startWatcher()}startWatcher(){const w=[this.watchedFolder];this.verboseLogging&&w.push("-verbose"),this.handle=v.spawn(y.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,w);const p=new R.LineDecoder;this.handle.stdout.on("data",n=>{const S=[];p.write(n).forEach(E=>{const b=E.split("|");if(b.length===2){const d=Number(b[0]),m=b[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(M=>M(m))){this.verboseLogging&&this.log(m);return}S.push({type:I.changeTypeMap[d],path:m})}else this.log(b[1])}}),S.length>0&&this.eventCallback(S)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,S)=>this.onExit(n,S))}onError(w){this.error("process error: "+w.toString())}onExit(w,p){this.handle&&(this.error(`terminated unexpectedly (code: ${w}, signal: ${p})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(w){this.logCallback({type:"error",message:`[File Watcher (C#)] ${w}`})}log(w){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${w}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(Q[165],J([0,1,164,7,22]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y{constructor(r,w,p,n){this.onDidFilesChange=w,this.onLogMessage=p,this.verboseLogging=n,this.service=void 0,this.folder=r[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,L.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,r=>this.onFileEvents(r),r=>this.onLogMessage(r),this.verboseLogging)}setVerboseLogging(r){this.verboseLogging=r,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(r){this.isDisposed||r.length>0&&this.onDidFilesChange(r)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=y}),define(Q[69],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(y,I=[],r=!1){this.ctor=y,this.staticArguments=I,this.supportsDelayedInstantiation=r}}e.SyncDescriptor=v;const R=(L,...y)=>new v(L,y);e.createSyncDescriptor=R}),define(Q[166],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(y){this.incoming=new Map,this.outgoing=new Map,this.data=y}}e.Node=v;class R{constructor(y){this._hashFn=y,this._nodes=new Map}roots(){const y=[];for(let I of this._nodes.values())I.outgoing.size===0&&y.push(I);return y}insertEdge(y,I){const r=this.lookupOrInsertNode(y),w=this.lookupOrInsertNode(I);r.outgoing.set(this._hashFn(I),w),w.incoming.set(this._hashFn(y),r)}removeNode(y){const I=this._hashFn(y);this._nodes.delete(I);for(let r of this._nodes.values())r.outgoing.delete(I),r.incoming.delete(I)}lookupOrInsertNode(y){const I=this._hashFn(y);let r=this._nodes.get(I);return r||(r=new v(y),this._nodes.set(I,r)),r}lookup(y){return this._nodes.get(this._hashFn(y))}isEmpty(){return this._nodes.size===0}toString(){let y=[];for(let[I,r]of this._nodes)y.push(`${I}, (incoming)[${[...r.incoming.keys()].join(", ")}], (outgoing)[${[...r.outgoing.keys()].join(",")}]`);return y.join(`
`)}findCycleSlow(){for(let[y,I]of this._nodes){const r=new Set([y]),w=this._findCycle(I,r);if(w)return w}}_findCycle(y,I){for(let[r,w]of y.outgoing){if(I.has(r))return[...I,r].join(" -> ");I.add(r);const p=this._findCycle(w,I);if(p)return p;I.delete(r)}}}e.Graph=R}),define(Q[4],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(r){r.serviceIds=new Map,r.DI_TARGET="$di$target",r.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[r.DI_DEPENDENCIES]||[]}r.getServiceDependencies=w})(v=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function R(r,w,p,n){w[v.DI_TARGET]===w?w[v.DI_DEPENDENCIES].push({id:r,index:p,optional:n}):(w[v.DI_DEPENDENCIES]=[{id:r,index:p,optional:n}],w[v.DI_TARGET]=w)}function L(r){if(v.serviceIds.has(r))return v.serviceIds.get(r);const w=function(p,n,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(w,p,S,!1)};return w.toString=()=>r,v.serviceIds.set(r,w),w}e.createDecorator=L;function y(r){return r}e.refineServiceDecorator=y;function I(r){return function(w,p,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(r,w,n,!0)}}e.optional=I}),define(Q[70],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function R(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=R}),define(Q[88],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class R{constructor(y){this.machineId=y}encryption(){return new Promise((y,I)=>j(["vscode-encrypt"],y,I))}async encrypt(y){try{return(await this.encryption()).encrypt(this.machineId,y)}catch(I){return y}}async decrypt(y){try{return(await this.encryption()).decrypt(this.machineId,y)}catch(I){return y}}}e.EncryptionMainService=R}),define(Q[53],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[167],J([0,1,136,4,10]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function y(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=y;var I;(function(S){S[S.NoneOrRelevance=0]="NoneOrRelevance",S[S.LastUpdatedDate=1]="LastUpdatedDate",S[S.Title=2]="Title",S[S.PublisherName=3]="PublisherName",S[S.InstallCount=4]="InstallCount",S[S.PublishedDate=5]="PublishedDate",S[S.AverageRating=6]="AverageRating",S[S.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var r;(function(S){S[S.Default=0]="Default",S[S.Ascending=1]="Ascending",S[S.Descending=2]="Descending"})(r=e.SortOrder||(e.SortOrder={}));var w;(function(S){S.Uninstall="uninstall"})(w=e.StatisticType||(e.StatisticType={}));var p;(function(S){S[S.None=0]="None",S[S.Install=1]="Install",S[S.Update=2]="Update"})(p=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(E,b){super(E);this.code=b}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(Q[168],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(Q[169],J([0,1,22,4]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var y;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(y=e.ExtensionType||(e.ExtensionType={}));class I{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,S){if(typeof n=="undefined"||n===null)return typeof S=="undefined"||S===null;if(typeof S=="undefined"||S===null)return!1;if(typeof n=="string"||typeof S=="string"){let E=typeof n=="string"?n:n.value,b=typeof S=="string"?S:S.value;return v.equalsIgnoreCase(E,b)}return n._lower===S._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=I;function r(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.isLanguagePackExtension=r;function w(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[170],J([0,1,22,169]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(b,d){return b.uuid&&d.uuid?b.uuid===d.uuid:b.id===d.id?!0:(0,v.compareIgnoreCase)(b.id,d.id)===0}e.areSameExtensions=L;class y{constructor(d,m){this.version=m,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof y?L(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=y;function I(b,d){return`${b}.${d}`}e.getExtensionId=I;function r(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=r;function w(b,d){return r(I(b,d))}e.getGalleryExtensionId=w;function p(b,d){const m=[],M=P=>{for(const o of m)if(o.some(u=>L(d(u),d(P))))return o;return null};for(const P of b){const o=M(P);o?o.push(P):m.push([P])}return m}e.groupByExtension=p;function n(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function S(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(b){const d=new Set;for(const m of b)m.malicious&&d.add(m.id.id);return d}e.getMaliciousExtensionsSet=E}),define(Q[89],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,v.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,v.createDecorator)("externalTerminal")}),define(Q[24],J([0,1,140,7,8,4,22,13,36]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function p(W){return W.create===!0}e.isFileOpenForWriteOptions=p;var n;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var S;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=E;function b(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=b;function d(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=m;var M;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(M=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=P;function o(W,$){const z=new P(W.toString(),$);return l(z,$),z}e.createFileSystemProviderError=o;function u(W){return W||o((0,v.localize)(0,null),M.Unknown)}e.ensureFileSystemProviderError=u;function l(W,$){return W.name=$?`${$} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=l;function c(W){if(!W)return M.Unknown;if(W instanceof P)return W.code;const $=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!$)return M.Unknown;switch($[1]){case M.FileExists:return M.FileExists;case M.FileIsADirectory:return M.FileIsADirectory;case M.FileNotADirectory:return M.FileNotADirectory;case M.FileNotFound:return M.FileNotFound;case M.FileExceedsMemoryLimit:return M.FileExceedsMemoryLimit;case M.FileTooLarge:return M.FileTooLarge;case M.FileWriteLocked:return M.FileWriteLocked;case M.NoPermissions:return M.NoPermissions;case M.Unavailable:return M.Unavailable}return M.Unknown}e.toFileSystemProviderErrorCode=c;function t(W){if(W instanceof g)return W.fileOperationResult;switch(c(W)){case M.FileNotFound:return 1;case M.FileIsADirectory:return 0;case M.FileNotADirectory:return 10;case M.FileWriteLocked:return 5;case M.NoPermissions:return 6;case M.FileExists:return 4;case M.FileExceedsMemoryLimit:return 9;case M.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var i;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class s{constructor($,z,N){this.resource=$,this.operation=z,this.target=N}isOperation($){return this.operation===$}}e.FileOperationEvent=s;var a;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const N of $)switch(N.type){case 1:this.added||(this.added=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(N.resource,N);break;case 0:this.updated||(this.updated=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(N.resource,N);break;case 2:this.deleted||(this.deleted=w.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(N.resource,N);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...N){var H,V,_,A,O,D;if(!$)return!1;const F=N.length>0;return!!((!F||N.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get($))||z.includeChildren&&((V=this.added)===null||V===void 0?void 0:V.findSuperstr($)))||(!F||N.includes(0))&&(((_=this.updated)===null||_===void 0?void 0:_.get($))||z.includeChildren&&((A=this.updated)===null||A===void 0?void 0:A.findSuperstr($)))||(!F||N.includes(2))&&(((O=this.deleted)===null||O===void 0?void 0:O.findSubstr($))||z.includeChildren&&((D=this.deleted)===null||D===void 0?void 0:D.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],N=$===1?this.added:$===0?this.updated:this.deleted;if(N)for(const[,H]of N)z.push(H);return z}filter($){return new h(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(W,$,z){return!W||!$||W===$||$.length>W.length?!1:($.charAt($.length-1)!==R.sep&&($+=R.sep),z?(0,I.startsWithIgnoreCase)(W,$):W.indexOf($)===0)}e.isParent=f;class g extends Error{constructor($,z,N){super($);this.fileOperationResult=z,this.options=N}static isFileOperationError($){return $ instanceof Error&&!(0,r.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=g;var k;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(k=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=U;async function B(W,$){if(!$.canHandleResource(L.URI.from({scheme:W.scheme})))return new Promise(z=>{const N=$.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===W.scheme&&H.added&&(N.dispose(),z())})})}e.whenProviderRegistered=B,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class X{static formatSize($){return(0,r.isNumber)($)||($=0),$<X.KB?(0,v.localize)(1,null,$.toFixed(0)):$<X.MB?(0,v.localize)(2,null,($/X.KB).toFixed(2)):$<X.GB?(0,v.localize)(3,null,($/X.MB).toFixed(2)):$<X.TB?(0,v.localize)(4,null,($/X.GB).toFixed(2)):(0,v.localize)(5,null,($/X.TB).toFixed(2))}}e.ByteSize=X,X.KB=1024,X.MB=X.KB*X.KB,X.GB=X.MB*X.KB,X.TB=X.GB*X.KB;var te;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(te=e.Arch||(e.Arch={}));function oe(W){return{maxFileSize:W===0?300*X.MB:16*X.GB,maxHeapSize:W===0?700*X.MB:2*700*X.MB}}e.getPlatformLimits=oe}),define(Q[54],J([0,1,238,135,24,87]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(E,b){const d={onUnknownOption:M=>{console.warn((0,R.localize)(0,null,M))},onMultipleValues:(M,P)=>{console.warn((0,R.localize)(1,null,M,P))}},m=(0,y.parseArgs)(E,y.OPTIONS,b?d:void 0);return m.goto&&m._.forEach(M=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(M),(0,R.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function r(E){const b=E.findIndex(d=>!/^-/.test(d));if(b>-1)return[...E.slice(0,b),...E.slice(b+1)]}function w(E){let[,...b]=E;process.env.VSCODE_DEV&&(b=r(b)||[]);const d=!S(process.env);return I(b,d)}e.parseMainProcessArgv=w;function p(E){const[,,...b]=E;return I(b,!0)}e.parseCLIProcessArgv=p;function n(E,...b){const d=E.indexOf("--");return d===-1?E.push(...b):E.splice(d,0,...b),E}e.addArg=n;function S(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),define(Q[90],J([0,1,158,45,28,3,54,67,130]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function p(E,b,d){return b["force-disable-user-env"]?(E.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(E.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(d)&&!b["force-user-env"]?(E.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(d)?E.trace("resolveShellEnv(): running (--force-user-env)"):E.trace("resolveShellEnv(): running (macOS/Linux)"),n||(n=S(E)),n)}e.resolveShellEnv=p;let n;async function S(E){const b=new Promise(async(d,m)=>{const M=process.env.ELECTRON_RUN_AS_NODE;E.trace("getUnixShellEnvironment#runAsNode",M);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;E.trace("getUnixShellEnvironment#noAttach",P);const o=(0,L.generateUuid)().replace(/-/g,"").substr(0,12),u=new RegExp(o+"(.*)"+o),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});E.trace("getUnixShellEnvironment#env",l);const c=await(0,w.getSystemShell)(y.OS,l);E.trace("getUnixShellEnvironment#shell",c);const t=v.basename(c);let i,s;/^pwsh(-preview)?$/.test(t)?(i=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,s=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,s=["-ilc"]),E.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),i);const a=(0,R.spawn)(c,[...s,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});a.on("error",g=>{E.error("getUnixShellEnvironment#errorChildProcess",(0,r.toErrorMessage)(g)),d({})});const h=[];a.stdout.on("data",g=>h.push(g));const f=[];a.stderr.on("data",g=>f.push(g)),a.on("close",(g,k)=>{const T=Buffer.concat(h).toString("utf8");E.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(f).toString("utf8");if(U.trim()&&E.trace("getUnixShellEnvironment#stderr",U),g||k)return m(new Error(`Failed to get environment (code ${g}, signal ${k})`));const B=u.exec(T),X=B?B[1]:"{}";try{const te=JSON.parse(X);M?te.ELECTRON_RUN_AS_NODE=M:delete te.ELECTRON_RUN_AS_NODE,P?te.ELECTRON_NO_ATTACH_CONSOLE=P:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.XDG_RUNTIME_DIR,E.trace("getUnixShellEnvironment#result",te),d(te)}catch(te){E.error("getUnixShellEnvironment#errorCaught",(0,r.toErrorMessage)(te)),m(te)}})});try{return await b}catch(d){return E.error("getUnixShellEnvironment#error",(0,r.toErrorMessage)(d)),{}}}}),define(Q[91],J([0,1,8,24,3]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function y(w){return w.map(p=>({type:p.type,resource:v.URI.file(p.path)}))}e.toFileChanges=y;function I(w){const p=new r;for(const n of w)p.processEvent(n);return p.normalize()}e.normalizeFileChanges=I;class r{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(p){const n=this.mapPathToChange.get(p.path);if(n){const S=n.type,E=p.type;S===1&&E===2?(this.mapPathToChange.delete(p.path),this.normalized.splice(this.normalized.indexOf(n),1)):S===2&&E===1?n.type=0:S===1&&E===0||(n.type=E)}else this.normalized.push(p),this.mapPathToChange.set(p.path,p)}normalize(){const p=[],n=[];return this.normalized.filter(S=>S.type!==2?(p.push(S),!1):!0).sort((S,E)=>S.path.length-E.path.length).filter(S=>n.some(E=>(0,R.isParent)(S.path,E,!L.isLinux))?!1:(n.push(S.path),!0)).concat(p)}}}),define(Q[171],J([0,1,91,2,16,113,117,9,7]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class p extends R.Disposable{constructor(S,E,b,d){super();this.path=S,this.onDidFilesChange=E,this.onLogMessage=b,this.verboseLogging=d,this.fileChangesDelayer=this._register(new r.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(S){this.verboseLogging=S}async startWatching(){try{const{stat:S,symbolicLink:E}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(E)try{b=await(0,y.realpath)(b)}catch(d){if(this.onError(d),E.dangling)return}S.isDirectory()?this._register((0,I.watchFolder)(b,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(m))})},d=>this.onError(d))):this._register((0,I.watchFile)(b,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(S){S.code!=="ENOENT"&&this.onError(S)}}onFileChange(S){this.fileChangesBuffer.push(S),this.verboseLogging&&this.onVerbose(`${S.type===1?"[ADDED]":S.type===2?"[DELETED]":"[CHANGED]"} ${S.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=(0,v.normalizeFileChanges)(E);this.verboseLogging&&b.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(S){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${S}`})}onVerbose(S){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${S}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=p}),define(Q[71],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...L){this._entries=new Map;for(let[y,I]of L)this.set(y,I)}set(L,y){const I=this._entries.get(L);return this._entries.set(L,y),I}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=v}),define(Q[172],J([0,1,19,166,69,4,71,9]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const w=!1;class p extends Error{constructor(d){var m;super("cyclic dependency between services");this.message=(m=d.findCycleSlow())!==null&&m!==void 0?m:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new I.ServiceCollection,m=!1,M){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=M,this._services.set(y.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...m){let M=E.traceInvocation(d),P=!1;try{return d({get:(u,l)=>{if(P)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(u,M);if(!c&&l!==y.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return c}},...m)}finally{P=!0,M.stop()}}createInstance(d,...m){let M,P;return d instanceof L.SyncDescriptor?(M=E.traceCreation(d.ctor),P=this._createInstance(d.ctor,d.staticArguments.concat(m),M)):(M=E.traceCreation(d),P=this._createInstance(d,m,M)),M.stop(),P}_createInstance(d,m=[],M){let P=y._util.getServiceDependencies(d).sort((l,c)=>l.index-c.index),o=[];for(const l of P){let c=this._getOrCreateServiceInstance(l.id,M);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);o.push(c)}let u=P.length>0?P[0].index:m.length;if(m.length!==u){console.warn(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${m.length} static arguments`);let l=u-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,u)}return new d(...[...m,...o])}_setServiceInstance(d,m){if(this._services.get(d)instanceof L.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let M=this._getServiceInstanceOrDescriptor(d);return M instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,M,m.branch(d,!0)):(m.branch(d,!1),M)}_safeCreateAndCacheServiceInstance(d,m,M){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,M)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,M){const P=new R.Graph(l=>l.id.toString());let o=0;const u=[{id:d,desc:m,_trace:M}];for(;u.length;){const l=u.pop();if(P.lookupOrInsertNode(l),o++>1e3)throw new p(P);for(let c of y._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const i={id:c.id,desc:t,_trace:l._trace.branch(c.id,!0)};P.insertEdge(l,i),u.push(i)}}}for(;;){const l=P.roots();if(l.length===0){if(!P.isEmpty())throw new p(P);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof L.SyncDescriptor){const i=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,i)}P.removeNode(c)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,M=[],P,o){if(this._services.get(d)instanceof L.SyncDescriptor)return this._createServiceInstance(m,M,P,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,M,P,o);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],M,P){if(M){const o=new r.IdleValue(()=>this._createInstance(d,m,P));return new Proxy(Object.create(null),{get(u,l){if(l in u)return u[l];let c=o.value,t=c[l];return typeof t!="function"||(t=t.bind(c),u[l]=t),t},set(u,l,c){return o.value[l]=c,!0}})}else return this._createInstance(d,m,P)}}e.InstantiationService=n;var S;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(S||(S={}));class E{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return w?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return w?new E(0,d.name):E._None}branch(d,m){let M=new E(2,d.toString());return this._dep.push([d,m,M]),M}stop(){let d=Date.now()-this._start;E._totals+=d;let m=!1;function M(o,u){let l=[],c=new Array(o+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){m=!0,l.push(`${c}CREATES -> ${t}`);let a=M(o+1,s);a&&l.push(a)}else l.push(`${c}uses -> ${t}`);return l.join(`
`)}let P=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${M(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(P.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(Q[173],J([0,1,19,128,57]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class y extends L.ResolvedKeybinding{constructor(r,w){super();if(w.length===0)throw(0,v.illegalArgument)("parts");this._os=r,this._parts=w}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,r=>this._getLabel(r))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,r=>this._getAriaLabel(r))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,r=>this._getElectronAccelerator(r))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,r=>this._getUserSettingsLabel(r))}isWYSIWYG(){return this._parts.every(r=>this._isWYSIWYG(r))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(r=>this._getPart(r))}_getPart(r){return new L.ResolvedKeybindingPart(r.ctrlKey,r.shiftKey,r.altKey,r.metaKey,this._getLabel(r),this._getAriaLabel(r))}getDispatchParts(){return this._parts.map(r=>this._getDispatchPart(r))}getSingleModifierDispatchParts(){return this._parts.map(r=>this._getSingleModifierDispatchPart(r))}}e.BaseResolvedKeybinding=y}),define(Q[174],J([0,1,57,173]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class L extends R.BaseResolvedKeybinding{constructor(I,r){super(r,I.parts)}_keyCodeToUILabel(I){if(this._os===2)switch(I){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(I)}_getLabel(I){return I.isDuplicateModifierCase()?"":this._keyCodeToUILabel(I.keyCode)}_getAriaLabel(I){return I.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(I.keyCode)}_keyCodeToElectronAccelerator(I){if(I>=93&&I<=108)return null;switch(I){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(I)}_getElectronAccelerator(I){return I.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(I.keyCode)}_getUserSettingsLabel(I){if(I.isDuplicateModifierCase())return"";const r=v.KeyCodeUtils.toUserSettingsUS(I.keyCode);return r&&r.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(I){return L.getDispatchStr(I)}static getDispatchStr(I){if(I.isModifierKey())return null;let r="";return I.ctrlKey&&(r+="ctrl+"),I.shiftKey&&(r+="shift+"),I.altKey&&(r+="alt+"),I.metaKey&&(r+="meta+"),r+=v.KeyCodeUtils.toString(I.keyCode),r}_getSingleModifierDispatchPart(I){return I.keyCode===5&&!I.shiftKey&&!I.altKey&&!I.metaKey?"ctrl":I.keyCode===4&&!I.ctrlKey&&!I.altKey&&!I.metaKey?"shift":I.keyCode===6&&!I.ctrlKey&&!I.shiftKey&&!I.metaKey?"alt":I.keyCode===57&&!I.ctrlKey&&!I.shiftKey&&!I.altKey?"meta":null}}e.USLayoutResolvedKeybinding=L}),define(Q[175],J([0,1,9]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(L,y){if(L.length===0)return Promise.resolve(!1);const I=[];let r=!1;for(let w of L){if(w===!0)return Promise.resolve(!0);(0,v.isThenable)(w)&&I.push(w.then(p=>{p&&(r=!0)},p=>{y(p),r=!0}))}return v.Promises.settled(I).then(()=>r)}e.handleVetos=R}),define(Q[6],J([0,1,4,2,3,5,67]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function r(){return new Date().toISOString()}var w;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(w=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=w.Info;class p extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new y.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=p;class n extends p{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(w.Trace)&&this.log(w.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(w.Debug)&&this.log(w.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(w.Info)&&this.log(w.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(w.Warning)&&this.log(w.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(w.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(w.Error,this.format(s))}else this.log(w.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(w.Critical)&&this.log(w.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let a=t[s];if(typeof a=="object")try{a=JSON.stringify(a)}catch(h){}i+=(s>0?" ":"")+a}return i}}e.AbstractMessageLogger=n;class S extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=w.Trace&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}debug(t,...i){this.getLevel()<=w.Debug&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}info(t,...i){this.getLevel()<=w.Info&&(this.useColors?console.log(`[90m[main ${r()}][0m`,t,...i):console.log(`[main ${r()}]`,t,...i))}warn(t,...i){this.getLevel()<=w.Warning&&(this.useColors?console.warn(`[93m[main ${r()}][0m`,t,...i):console.warn(`[main ${r()}]`,t,...i))}error(t,...i){this.getLevel()<=w.Error&&(this.useColors?console.error(`[91m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}critical(t,...i){this.getLevel()<=w.Critical&&(this.useColors?console.error(`[90m[main ${r()}][0m`,t,...i):console.error(`[main ${r()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class E extends p{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=w.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=w.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=w.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=w.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=w.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=w.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=E;class b extends p{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=w.Trace&&this.adapter.log(w.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=w.Debug&&this.adapter.log(w.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=w.Info&&this.adapter.log(w.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=w.Warning&&this.adapter.log(w.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=w.Error&&this.adapter.log(w.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=w.Critical&&this.adapter.log(w.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,I.toErrorMessage)(t,this.getLevel()<=w.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class d extends p{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class m extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=m;class M extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?w.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=M;class P{constructor(){this.onDidChangeLogLevel=new y.Emitter().event}setLevel(t){}getLevel(){return w.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=P;function o(c){if(c.verbose)return w.Trace;if(typeof c.logLevel=="string"){const t=u(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function u(c){switch(c){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Critical;case"off":return w.Off}}e.parseLogLevel=u;function l(c){switch(c){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Critical:return"critical";case w.Off:return"off"}}e.LogLevelToString=l}),define(Q[92],J([0,1,6]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(y,I){switch(I){case v.LogLevel.Trace:return y.trace;case v.LogLevel.Debug:return y.debug;case v.LogLevel.Info:return y.info;case v.LogLevel.Warning:return y.warn;case v.LogLevel.Error:return y.error;case v.LogLevel.Critical:return y.critical;default:throw new Error("Invalid log level")}}class L extends v.AbstractLogger{constructor(I=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(I),this._register(this.onDidChangeLogLevel(r=>{this._logger&&this._logger.setLevel(r)}))}set logger(I){this._logger=I;for(const{level:r,args:w}of this.buffer)R(I,r).apply(I,w);this.buffer=[]}_log(I,...r){this._logger?R(this._logger,I).apply(this._logger,r):this.getLevel()<=I&&this.buffer.push({level:I,args:r})}trace(I,...r){this._log(v.LogLevel.Trace,I,...r)}debug(I,...r){this._log(v.LogLevel.Debug,I,...r)}info(I,...r){this._log(v.LogLevel.Info,I,...r)}warn(I,...r){this._log(v.LogLevel.Warning,I,...r)}error(I,...r){this._log(v.LogLevel.Error,I,...r)}critical(I,...r){this._log(v.LogLevel.Critical,I,...r)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=L});var ee=this&&this.__param||function(j,e){return function(v,R){e(v,R,j)}};define(Q[176],J([0,1,6,24,9,23,15,4,92]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const p=5*R.ByteSize.MB;let n=class extends v.AbstractLogger{constructor(b,d,m,M){super();this.name=b,this.resource=d,this.fileService=M,this.backupIndex=1,this.setLevel(m),this.queue=this._register(new L.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const b=arguments[0];if(b instanceof Error){const d=Array.prototype.slice.call(arguments);d[0]=b.stack,this._log(v.LogLevel.Error,this.format(d))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(b,d){this._log(b,this.format(d))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(b){if(b.fileOperationResult!==3)throw b}}_log(b,d){this.queue.queue(async()=>{await this.initializePromise;let m=await this.loadContent();m.length>p&&(await this.fileService.writeFile(this.getBackupResource(),y.VSBuffer.fromString(m)),m=""),m+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(b)}] ${d}
`,await this.fileService.writeFile(this.resource,y.VSBuffer.fromString(m))})}getCurrentTimestamp(){const b=M=>M<10?`0${M}`:M,d=M=>M<10?`00${M}`:M<100?`0${M}`:M,m=new Date;return`${m.getFullYear()}-${b(m.getMonth()+1)}-${b(m.getDate())} ${b(m.getHours())}:${b(m.getMinutes())}:${b(m.getSeconds())}.${d(m.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,I.joinPath)((0,I.dirname)(this.resource),`${(0,I.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(b){return""}}stringifyLogLevel(b){switch(b){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(b){let d="";for(let m=0;m<b.length;m++){let M=b[m];if(typeof M=="object")try{M=JSON.stringify(M)}catch(P){}d+=(m>0?" ":"")+M}return d}};n=ce([ee(3,R.IFileService)],n),e.FileLogger=n;let S=class extends v.AbstractLoggerService{constructor(b,d,m){super(b.getLevel(),b.onDidChangeLogLevel);this.instantiationService=d,this.fileService=m}doCreateLogger(b,d){const m=new w.BufferLogService(d);return(0,R.whenProviderRegistered)(b,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(n,(0,I.basename)(b),b,m.getLevel())),m}};S=ce([ee(0,v.ILogService),ee(1,r.IInstantiationService),ee(2,R.IFileService)],S),e.FileLoggerService=S}),define(Q[177],J([0,1,6,5,8]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class y{constructor(E){this.service=E,this.onDidChangeLogLevel=R.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(E,b,d){switch(b){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=y;class I{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){I.setLevel(this.channel,E)}static setLevel(E,b){return E.call("setLevel",b)}}e.LogLevelChannelClient=I;class r{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,b){throw new Error(`Event not found: ${b}`)}async call(E,b,d){switch(b){case"createLogger":this.createLogger(L.URI.revive(d[0]),d[1]);return;case"log":return this.log(L.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${b}`)}createLogger(E,b){this.loggers.set(E.toString(),this.loggerService.createLogger(E,b))}consoleLog(E,b){let d=console.log;switch(E){case v.LogLevel.Error:d=console.error;break;case v.LogLevel.Warning:d=console.warn;break;case v.LogLevel.Info:d=console.info;break}d.call(console,...b)}log(E,b){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,M]of b)switch(m){case v.LogLevel.Trace:d.trace(M);break;case v.LogLevel.Debug:d.debug(M);break;case v.LogLevel.Info:d.info(M);break;case v.LogLevel.Warning:d.warn(M);break;case v.LogLevel.Error:d.error(M);break;case v.LogLevel.Critical:d.critical(M);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=r;class w extends v.AbstractLoggerService{constructor(E,b,d){super(E,b);this.channel=d}createConsoleMainLogger(){return new v.AdapterLogger({log:(E,b)=>{this.channel.call("consoleLog",[E,b])}})}doCreateLogger(E,b,d){return new p(this.channel,E,b,d)}}e.LoggerChannelClient=w;class p extends v.AbstractMessageLogger{constructor(E,b,d,m){super(m==null?void 0:m.always);this.channel=E,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[b,m]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(E,b){const d=[[E,b]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(E){this.channel.call("log",[this.file,E])}}class n extends v.LogService{constructor(E,b){super(b);this.parent=E,this._register(E.onDidChangeLogLevel(d=>b.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=n}),define(Q[93],J([0,1,6,24]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function L(w,p,n,S){try{const E=await new Promise((b,d)=>{j(["spdlog"],b,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(w,p,n,S)}catch(E){console.error(E)}return null}function y(w,p,n,S){return j.__$__nodeRequire("spdlog").createRotatingLogger(w,p,n,S)}e.createRotatingLogger=y;function I(w,p,n){switch(p){case v.LogLevel.Trace:w.trace(n);break;case v.LogLevel.Debug:w.debug(n);break;case v.LogLevel.Info:w.info(n);break;case v.LogLevel.Warning:w.warn(n);break;case v.LogLevel.Error:w.error(n);break;case v.LogLevel.Critical:w.critical(n);break;default:throw new Error("Invalid log level")}}class r extends v.AbstractMessageLogger{constructor(p,n,S,E){super();this.name=p,this.filepath=n,this.rotating=S,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const p=this.rotating?6:1,n=30/p*R.ByteSize.MB;return L(this.name,this.filepath,n,p).then(S=>{if(S){this._logger=S,this._logger.setLevel(this.getLevel());for(const{level:E,message:b}of this.buffer)I(this._logger,E,b);this.buffer=[]}})}log(p,n){this._logger?I(this._logger,p,n):this.getLevel()<=p&&this.buffer.push({level:p,message:n})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=r}),define(Q[178],J([0,1,6,15,10,176,93,24,28]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let p=class extends v.AbstractLoggerService{constructor(S,E){super(S.getLevel(),S.onDidChangeLogLevel);this.fileService=E}doCreateLogger(S,E,b){var d;if(S.scheme===L.Schemas.file){const m=new I.SpdLogLogger((b==null?void 0:b.name)||(0,w.generateUuid)(),S.fsPath,!(b==null?void 0:b.donotRotate),E);return(b==null?void 0:b.donotUseFormatters)&&m.clearFormatters(),m}else return new y.FileLogger((d=b==null?void 0:b.name)!==null&&d!==void 0?d:(0,R.basename)(S),S,E,this.fileService)}};p=ce([ee(0,v.ILogService),ee(1,r.IFileService)],p),e.LoggerService=p}),define(Q[179],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(I){return I.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function R(I){return I.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function L(I){return I.uri!==void 0}e.isMenubarMenuItemRecentAction=L;function y(I){return!v(I)&&!R(I)&&!L(I)}e.isMenubarMenuItemAction=y}),define(Q[47],J([0,1,10,3,32,15]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof R.globals.vscode!="undefined"){const r=R.globals.vscode.context.configuration();if(r)I=r.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(j==null?void 0:j.__$__nodeRequire)=="function"){const r=(0,y.dirname)(v.FileAccess.asFileUri("",j));I=j.__$__nodeRequire((0,y.joinPath)(r,"product.json").fsPath);const w=j.__$__nodeRequire((0,y.joinPath)(r,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:w.version})}else I={},Object.keys(I).length===0&&Object.assign(I,{version:"1.57.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=I}),define(Q[94],J([0,1,141,23,24,19,47]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function r(S,E,b,d,m,M){let P;try{await w(S,E,b,d,m,M)}catch(o){P=o}finally{P&&m.errorTransformer&&(P=m.errorTransformer(P)),typeof P!="undefined"&&b.error(P),b.end()}}e.readFileIntoStream=r;async function w(S,E,b,d,m,M){p(M);const P=await S.open(E,{create:!1});try{p(M);let o=0,u=0,l=m&&typeof m.length=="number"?m.length:void 0,c=R.VSBuffer.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),t=m&&typeof m.position=="number"?m.position:0,i=0;do u=await S.read(P,t,c.buffer,i,c.byteLength-i),t+=u,i+=u,o+=u,typeof l=="number"&&(l-=u),i===c.byteLength&&(await b.write(d(c)),c=R.VSBuffer.alloc(Math.min(m.bufferSize,typeof l=="number"?l:m.bufferSize)),i=0);while(u>0&&(typeof l!="number"||l>0)&&p(M)&&n(o,m));if(i>0){let s=i;typeof l=="number"&&(s=Math.min(i,l)),b.write(d(c.slice(0,s)))}}catch(o){throw(0,L.ensureFileSystemProviderError)(o)}finally{await S.close(P)}}function p(S){if(S.isCancellationRequested)throw(0,y.canceled)();return!0}function n(S,E){if(E==null?void 0:E.limits){if(typeof E.limits.memory=="number"&&S>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,v.localize)(0,null,I.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&S>E.limits.size)throw(0,L.createFileSystemProviderError)((0,v.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[180],J([0,1,139,72,2,24,5,15,36,35,6,23,64,9,26,10,94,63]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let o=class extends L.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const t=new L.DisposableStore;return t.add(c.onDidChangeFile(i=>this._onDidFilesChange.fire(new y.FileChangesEvent(i,!this.isPathCaseSensitive(c))))),t.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&t.add(c.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,L.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,L.dispose)(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){c.push(t)}}),!this.provider.has(l)&&await b.Promises.settled(c)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,c){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&c)}listCapabilities(){return P.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,r.isAbsolutePath)(l))throw new y.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,l.toString()),t}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasReadWriteCapability)(c)||(0,y.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(c)||(0,y.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(t){throw(0,y.toFileSystemProviderErrorCode)(t)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(t)}}async doResolveFile(l,c){const t=await this.withProvider(l),i=this.isPathCaseSensitive(t),s=c==null?void 0:c.resolveTo,a=c==null?void 0:c.resolveSingleChildDescendants,h=c==null?void 0:c.resolveMetadata,f=await t.stat(l);let g;return this.toFileStat(t,l,f,void 0,!!h,(k,T)=>(g||(g=w.TernarySearchTree.forUris(()=>!i),g.set(l,!0),(0,p.isNonEmptyArray)(s)&&s.forEach(U=>g.set(U,!0))),Boolean(g.findSuperstr(k.resource)||g.get(k.resource))?!0:k.isDirectory&&a?T===1:!1))}async toFileStat(l,c,t,i,s,a){const{providerExtUri:h}=this.getExtUri(l),f={resource:c,name:h.basename(c),isFile:(t.type&y.FileType.File)!=0,isDirectory:(t.type&y.FileType.Directory)!=0,isSymbolicLink:(t.type&y.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,y.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&a(f,i)){try{const g=await l.readdir(c),k=await b.Promises.settled(g.map(async([T,U])=>{try{const B=h.joinPath(c,T),X=s?await l.stat(B):{type:U};return await this.toFileStat(l,B,X,g.length,s,a)}catch(B){return this.logService.trace(B),null}}));f.children=(0,p.coalesce)(k)}catch(g){this.logService.trace(g),f.children=[]}return f}return f}async resolveAll(l){return b.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(t){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(t){return t}return!0}async doValidateCreateFile(l,c){if(!(c==null?void 0:c.overwrite)&&await this.exists(l))throw new y.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=S.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const i=await this.writeFile(l,c);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,i)),i}async writeFile(l,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(i);try{await this.validateWriteFile(i,l,t)||await this.mkdirp(i,s.dirname(l));let h;if((0,y.hasReadWriteCapability)(i)&&!(c instanceof S.VSBuffer))if((0,E.isReadableStream)(c)){const f=await(0,E.peekStream)(c,3);f.ended?h=S.VSBuffer.concat(f.buffer):h=f}else h=(0,E.peekReadable)(c,f=>S.VSBuffer.concat(f),3);else h=c;!(0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)&&h instanceof S.VSBuffer?await this.doWriteUnbuffered(i,l,t,h):await this.doWriteBuffered(i,l,t,h instanceof S.VSBuffer?(0,S.bufferToReadable)(h):h)}catch(a){throw new y.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(c)));let s;try{s=await l.stat(c)}catch(a){return}if((s.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,v.localize)(6,null,this.resourceForError(c)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,y.etag)({mtime:t.mtime,size:s.size}))throw new y.FileOperationError((0,v.localize)(7,null),3,t);return s}async readFile(l,c){const t=await this.withReadProvider(l);return(c==null?void 0:c.atomic)?this.doReadFileAtomic(t,l,c):this.doReadFile(t,l,c)}async doReadFileAtomic(l,c,t){return new Promise((i,s)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,c,t);i(a)}catch(a){s(a)}})})}async doReadFile(l,c,t){const i=await this.doReadFileStream(l,c,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,S.streamToBuffer)(i.value)})}async readFileStream(l,c){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,c)}async doReadFileStream(l,c,t){const i=new d.CancellationTokenSource,s=this.validateReadFile(c,t).then(h=>h,h=>{throw i.cancel(),h});let a;try{t&&typeof t.etag=="string"&&t.etag!==y.ETAG_DISABLED&&await s,!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?a=this.readFileUnbuffered(l,c,t):(0,y.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,c,i.token,t):a=this.readFileBuffered(l,c,i.token,t);const h=await s;return Object.assign(Object.assign({},h),{value:a})}catch(h){throw a&&await(0,E.consumeStream)(a),new y.FileOperationError((0,v.localize)(8,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(h).toString()),(0,y.toFileOperationResult)(h),t)}}readFileStreamed(l,c,t,i=Object.create(null)){const s=l.readFileStream(c,i,t);return(0,E.transform)(s,{data:a=>a instanceof S.VSBuffer?a:S.VSBuffer.wrap(a),error:a=>new y.FileOperationError((0,v.localize)(9,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),i)},a=>S.VSBuffer.concat(a))}readFileBuffered(l,c,t,i=Object.create(null)){const s=(0,S.newWriteableBufferStream)();return(0,M.readFileIntoStream)(l,c,s,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new y.FileOperationError((0,v.localize)(10,null,this.resourceForError(c),(0,y.ensureFileSystemProviderError)(a).toString()),(0,y.toFileOperationResult)(a),i)}),t),s}readFileUnbuffered(l,c,t){const i=(0,E.newWriteableStream)(s=>S.VSBuffer.concat(s));return(async()=>{try{let s=await l.readFile(c);t&&typeof t.position=="number"&&(s=s.slice(t.position)),t&&typeof t.length=="number"&&(s=s.slice(0,t.length)),this.validateReadFileLimits(c,s.byteLength,t),i.end(S.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async validateReadFile(l,c){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new y.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,c);if(c&&typeof c.etag=="string"&&c.etag!==y.ETAG_DISABLED&&c.etag===t.etag)throw new y.FileOperationError((0,v.localize)(12,null),2,c);return this.validateReadFileLimits(l,t.size,c),t}validateReadFileLimits(l,c,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&c>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&c>t.limits.size&&(i=7),typeof i=="number")throw new y.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),i)}}async canMove(l,c,t){return this.doCanMoveCopy(l,c,"move",t)}async canCopy(l,c,t){return this.doCanMoveCopy(l,c,"copy",t)}async doCanMoveCopy(l,c,t,i){if(l.toString()!==c.toString())try{const s=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,l,a,c,t,i)}catch(s){return s}return!0}async move(l,c,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(i,l,s,c,"move",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,a==="move"?2:3,h)),h}async copy(l,c,t){const i=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),a=await this.doMoveCopy(i,l,s,c,"copy",!!t),h=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,a==="copy"?3:2,h)),h}async doMoveCopy(l,c,t,i,s,a){if(c.toString()===i.toString())return s;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,c,t,i,s,a);if(h&&!f&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),s==="copy"){if(l===t&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(c,i,{overwrite:a});else{const g=await this.resolve(c);g.isDirectory?await this.doCopyFolder(l,g,t,i):await this.doCopyFile(l,c,t,i)}return s}else return l===t?(await l.rename(c,i,{overwrite:a}),s):(await this.doMoveCopy(l,c,t,i,"copy",a),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,t,i){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,c,t,i);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,c,t,i);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,c,t,i);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,c,t,i)}async doCopyFolder(l,c,t,i){await t.mkdir(i),Array.isArray(c.children)&&await b.Promises.settled(c.children.map(async s=>{const a=this.getExtUri(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),t,a):this.doCopyFile(l,s.resource,t,a)}))}async doValidateMoveCopy(l,c,t,i,s,a){let h=!1;if(l===t){const{providerExtUri:g,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(h=g.isEqual(c,i)),h&&s==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(c),this.resourceForError(i)));if(!h&&g.isEqualOrParent(i,c))throw new Error((0,v.localize)(15,null,this.resourceForError(c),this.resourceForError(i)))}const f=await this.exists(i);if(f&&!h){if(!a)throw new y.FileOperationError((0,v.localize)(16,null,this.resourceForError(c),this.resourceForError(i)),4);if(l===t){const{providerExtUri:g}=this.getExtUri(l);if(g.isEqualOrParent(c,i))throw new Error((0,v.localize)(17,null,this.resourceForError(c),this.resourceForError(i)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?r.extUri:r.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,t)),t}async mkdirp(l,c){const t=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(c,i.dirname(c));)try{if(((await l.stat(c)).type&y.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,y.toFileSystemProviderErrorCode)(s)!==y.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(c)),c=i.dirname(c)}for(let s=t.length-1;s>=0;s--){c=i.joinPath(c,t[s]);try{await l.mkdir(c)}catch(a){if((0,y.toFileSystemProviderErrorCode)(a)!==y.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(t){return t}return!0}async doValidateDelete(l,c){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(c==null?void 0:c.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));const s=await this.exists(l);if(!s)throw new y.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!(c==null?void 0:c.recursive)&&s){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return t}async del(l,c){const t=await this.doValidateDelete(l,c),i=!!(c==null?void 0:c.useTrash),s=!!(c==null?void 0:c.recursive);await t.delete(l,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}watch(l,c={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(l,c).then(s=>{t?(0,L.dispose)(s):i=()=>(0,L.dispose)(s)},s=>this.logService.error(s)),(0,L.toDisposable)(()=>i())}async doWatch(l,c){const t=await this.withProvider(l),i=this.toWatchKey(t,l,c),s=this.activeWatchers.get(i)||{count:0,disposable:t.watch(l,c)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,(0,L.toDisposable)(()=>{s.count--,s.count===0&&((0,L.dispose)(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(l,c,t){const{providerExtUri:i}=this.getExtUri(l);return[i.getComparisonKey(c),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,L.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{var s;const a=await l.open(c,{create:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1});try{(0,E.isReadableStream)(i)||(0,E.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(l,a,i):await this.doWriteReadableBufferedQueued(l,a,i)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await l.close(a)}})}async doWriteStreamBufferedQueued(l,c,t){let i=0,s;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const a=S.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,c,a,a.byteLength,i,0),i+=a.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise(async(a,h)=>{(0,E.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(l,c,f,f.byteLength,i,0)}catch(g){return h(g)}i+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>h(f),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(l,c,t){let i=0,s;for(;(s=t.read())!==null;)await this.doWriteBuffer(l,c,s,s.byteLength,i,0),i+=s.byteLength}async doWriteBuffer(l,c,t,i,s,a){let h=0;for(;h<i;)h+=await l.write(c,s+h,t.buffer,a+h,i-h)}async doWriteUnbuffered(l,c,t,i){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,t,i))}async doWriteUnbufferedQueued(l,c,t,i){var s;let a;i instanceof S.VSBuffer?a=i:(0,E.isReadableStream)(i)?a=await(0,S.streamToBuffer)(i):(0,E.isReadableBufferedStream)(i)?a=await(0,S.bufferedStreamToBuffer)(i):a=(0,S.readableToBuffer)(i),await l.writeFile(c,a.buffer,{create:!0,overwrite:!0,unlock:(s=t==null?void 0:t.unlock)!==null&&s!==void 0?s:!1})}async doPipeBuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,t,i))}async doPipeBufferedQueued(l,c,t,i){let s,a;try{s=await l.open(c,{create:!1}),a=await t.open(i,{create:!0,unlock:!1});const h=S.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,g=0,k=0;do k=await l.read(s,f,h.buffer,g,h.byteLength-g),await this.doWriteBuffer(t,a,h,k,f,g),f+=k,g+=k,g===h.byteLength&&(g=0);while(k>0)}catch(h){throw(0,y.ensureFileSystemProviderError)(h)}finally{await b.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof a=="number"?t.close(a):Promise.resolve()])}}async doPipeUnbuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,t,i))}async doPipeUnbufferedQueued(l,c,t,i){return t.writeFile(i,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,t,i))}async doPipeUnbufferedToBufferedQueued(l,c,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const a=await l.readFile(c);await this.doWriteBuffer(t,s,S.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,y.ensureFileSystemProviderError)(a)}finally{await t.close(s)}}async doPipeBufferedToUnbuffered(l,c,t,i){const s=await(0,S.streamToBuffer)(this.readFileBuffered(l,c,d.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,s)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new y.FileOperationError((0,v.localize)(22,null,this.resourceForError(c)),6);return l}resourceForError(l){return l.scheme===m.Schemas.file?l.fsPath:l.toString(!0)}};o=ce([ee(0,n.ILogService)],o),e.FileService=o}),define(Q[181],J([0,1,20,114,2,24,5,3,16,7,15,30,9,6,142,91,163,165,162,171,64,94,35,23]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class s extends L.Disposable{constructor(h,f){var g;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((g=this.options)===null||g===void 0?void 0:g.bufferSize)||64*1024,this.onDidChangeCapabilities=I.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new I.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,r.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:g}=await w.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,g),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,w.readdir)(this.toFilePath(h),{withFileTypes:!0}),g=[];return await Promise.all(f.map(async k=>{try{let T;k.isSymbolicLink()?T=(await this.stat((0,n.joinPath)(h,k.name))).type:T=this.toType(k),g.push([k.name,T])}catch(T){this.logService.trace(T)}})),g}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let g;return(f==null?void 0:f.dangling)?g=y.FileType.Unknown:h.isFile()?g=y.FileType.File:h.isDirectory()?g=y.FileType.Directory:g=y.FileType.Unknown,f&&(g|=y.FileType.SymbolicLink),g}async readFile(h){try{const f=this.toFilePath(h);return await v.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,g){const k=(0,l.newWriteableStream)(T=>i.VSBuffer.concat(T.map(U=>i.VSBuffer.wrap(U))).buffer);return(0,c.readFileIntoStream)(this,h,k,T=>T.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),g),k}async writeFile(h,f,g){let k;try{const T=this.toFilePath(h);if(!g.create||!g.overwrite){if(await(0,w.exists)(T)){if(!g.overwrite)throw(0,y.createFileSystemProviderError)((0,d.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!g.create)throw(0,y.createFileSystemProviderError)((0,d.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(h,{create:!0,unlock:g.unlock}),await this.write(k,0,f,0,f.byteLength)}catch(T){throw await this.toFileSystemProviderWriteError(h,T)}finally{typeof k=="number"&&await this.close(k)}}async open(h,f){try{const g=this.toFilePath(h);if((0,y.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await w.SymlinkSupport.stat(g);U.mode&128||await v.promises.chmod(g,U.mode|128)}catch(U){this.logService.trace(U)}let k;if((0,y.isFileOpenForWriteOptions)(f)){if(r.isWindows)try{await v.promises.truncate(g,0),k="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}k||(k="w")}else k="r";const T=await(0,R.promisify)(v.open)(g,k);return this.mapHandleToPos.set(T,0),(0,y.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(T,h),T}catch(g){throw(0,y.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,g):this.toFileSystemProviderError(g)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,R.promisify)(v.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,R.promisify)(v.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,g,k,T){const U=this.normalizePos(h,f);let B=null;try{const X=await(0,R.promisify)(v.read)(h,g,k,T,U);return typeof X=="number"?B=X:B=X.bytesRead,B}catch(X){throw this.toFileSystemProviderError(X)}finally{this.updatePos(h,U,B)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,g){const k=this.mapHandleToPos.get(h);typeof k=="number"&&(typeof f=="number"||(typeof g=="number"?this.mapHandleToPos.set(h,k+g):this.mapHandleToPos.delete(h)))}async write(h,f,g,k,T){return(0,E.retry)(()=>this.doWrite(h,f,g,k,T),100,3)}async doWrite(h,f,g,k,T){const U=this.normalizePos(h,f);let B=null;try{const X=await(0,R.promisify)(v.write)(h,g,k,T,U);return typeof X=="number"?B=X:B=X.bytesWritten,B}catch(X){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),X)}finally{this.updatePos(h,U,B)}}async mkdir(h){try{await v.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const g=this.toFilePath(h);await this.doDelete(g,f)}catch(g){throw this.toFileSystemProviderError(g)}}async doDelete(h,f){f.recursive?await(0,w.rimraf)(h,w.RimRafMode.MOVE):await v.promises.unlink(h)}async rename(h,f,g){const k=this.toFilePath(h),T=this.toFilePath(f);if(k!==T)try{await this.validateTargetDeleted(h,f,"move",g.overwrite),await(0,w.move)(k,T)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,p.basename)(k),(0,p.basename)((0,p.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(h,f,g){const k=this.toFilePath(h),T=this.toFilePath(f);if(k!==T)try{await this.validateTargetDeleted(h,f,"copy",g.overwrite),await(0,w.copy)(k,T,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,p.basename)(k),(0,p.basename)((0,p.dirname)(T)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(h,f,g,k){const T=this.toFilePath(h),U=this.toFilePath(f);let B=!1;if(!!(this.capabilities&1024)||(B=(0,S.isEqual)(T,U,!0)),B&&g==="copy")throw(0,y.createFileSystemProviderError)((0,d.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!B&&await(0,w.exists)(U)){if(!k)throw(0,y.createFileSystemProviderError)((0,d.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const g={path:this.toFilePath(h),excludes:f},k=(0,t.insert)(this.recursiveFoldersToWatch,g);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{k(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,g;if(this.recursiveWatcher instanceof o.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let k,T;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(k=M.FileWatcher,T=(g=this.options)===null||g===void 0?void 0:g.watcher):this.recursiveFoldersToWatch.length===1?r.isWindows?k=P.FileWatcher:k=M.FileWatcher:k=o.FileWatcher,this.recursiveWatcher=new k(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,m.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===b.LogLevel.Trace,T),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new u.FileWatcher(this.toFilePath(h),k=>this._onDidChangeFile.fire((0,m.toFileChanges)(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===b.LogLevel.Trace),g=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)});return(0,L.combinedDisposable)(f,g)}toFilePath(h){return(0,p.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof y.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=y.FileSystemProviderErrorCode.NoPermissions;break;default:f=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let g=this.toFileSystemProviderError(f);if(h&&g.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:k}=await w.SymlinkSupport.stat(this.toFilePath(h));k.mode&128||(g=(0,y.createFileSystemProviderError)(f,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(k){this.logService.trace(k)}return g}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=s}),define(Q[21],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(Q[182],J([0,1,58,6,21]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let y=class{constructor(r,w){this.productService=r,this.logService=w,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(r,w){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const p=/^(.*)#([^#]+)$/.exec(w);if(!p)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",w),!1;const[,n,S]=p;let E=this.trustedExtensionUrlPublicKeys.get(r);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[r],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",r),!1;this.trustedExtensionUrlPublicKeys.set(r,[...E])}const b=Buffer.from(decodeURIComponent(S),"base64");if(b.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",w),!1;const d=b.slice(0,6),m=b.readUIntBE(0,6),M=Date.now()-m;if(M<0||M>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",w),!1;const P=b.slice(6),o=v.createVerify("SHA256");o.write(d),o.write(Buffer.from(n)),o.end();for(let u=0;u<E.length;u++){let l=E[u];if(l!==null){if(typeof l=="string")try{l=v.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),E[u]=l}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${r}:`,c),E[u]=null;continue}if(o.verify(l,P))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",w),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",w),!1}};y=ce([ee(0,L.IProductService),ee(1,R.ILogService)],y),e.ExtensionUrlTrustService=y}),define(Q[55],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(Q[183],J([0,1,2,10,8,53,14,6,36,3,15,28]),function(j,e,v,R,L,y,I,r,w,p,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends v.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=w.TernarySearchTree.forUris(()=>!p.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(L.URI.file(d.appRoot)),this.addValidFileRoot(L.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=I.session;d.protocol.registerFileProtocol(R.Schemas.vscodeFileResource,(m,M)=>this.handleResourceRequest(m,M)),d.protocol.interceptFileProtocol(R.Schemas.file,(m,M)=>this.handleFileRequest(m,M)),this._register((0,v.toDisposable)(()=>{d.protocol.unregisterProtocol(R.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(R.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?v.Disposable.None:(this.validRoots.set(d,!0),(0,v.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const M=L.URI.parse(d.url);return p.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${M.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})):this.validRoots.findSubstr(M)?m({path:M.fsPath}):this.validExtensions.has((0,n.extname)(M))?m({path:M.fsPath}):(this.logService.error(`${R.Schemas.file}: Refused to load resource ${M.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3}))}handleResourceRequest(d,m){const M=L.URI.parse(d.url),P=R.FileAccess.asFileUri(M);return this.validRoots.findSubstr(P)?m({path:P.fsPath}):this.validExtensions.has((0,n.extname)(P))?m({path:P.fsPath}):(this.logService.error(`${R.Schemas.vscodeFileResource}: Refused to load resource ${P.fsPath} from ${R.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(){let d;const m=L.URI.from({scheme:"vscode",path:(0,S.generateUuid)()}),M=m.toString(),P=async()=>d;return I.ipcMain.handle(M,P),this.logService.trace(`IPC Object URL: Registered new channel ${M}.`),{resource:m,update:o=>d=o,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${M}.`),I.ipcMain.removeHandler(M)}}}};E=ce([ee(0,y.INativeEnvironmentService),ee(1,r.ILogService)],E),e.ProtocolMainService=E}),define(Q[37],J([0,1,13,101]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(I,r){R.ok(v.isString(I)),R.ok(v.isObject(r)),R.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,r)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new L}),define(Q[184],J([0,1,37,5]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(r){return r.length>0&&r.charAt(r.length-1)==="#"?r.substring(0,r.length-1):r}class y{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(w,p){this.schemasById[L(w)]=p,this._onDidChangeSchema.fire(w)}notifySchemaChanged(w){this._onDidChangeSchema.fire(w)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new y;v.Registry.add(e.Extensions.JSONContribution,I)}),define(Q[48],J([0,1,132,5,37,13,184]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var r;(function(M){M[M.APPLICATION=1]="APPLICATION",M[M.MACHINE=2]="MACHINE",M[M.WINDOW=3]="WINDOW",M[M.RESOURCE=4]="RESOURCE",M[M.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",M[M.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(r=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const w=L.Registry.as(I.Extensions.JSONContribution);class p{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(P,o=!0){this.registerConfigurations([P],o)}registerConfigurations(P,o=!0){const u=[];P.forEach(l=>{u.push(...this.validateAndRegisterProperties(l,o,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(P){const o=[],u=l=>{if(l.properties)for(const c in l.properties)o.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,l.properties[c]);l.allOf&&l.allOf.forEach(c=>u(c))};for(const l of P){u(l);const c=this.configurationContributors.indexOf(l);c!==-1&&this.configurationContributors.splice(c,1)}w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}registerDefaultConfigurations(P){const o=[],u=[];for(const l of P)for(const c in l)if(o.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),l[c]);const t={type:"object",default:this.defaultValues[c],description:v.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};u.push(S(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=l[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}deregisterDefaultConfigurations(P){const o=[];for(const u of P)for(const l in u)if(o.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const c=this.configurationProperties[l];c&&(this.updatePropertyDefaultValue(l,c),this.updateSchema(l,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(o)}notifyConfigurationSchemaUpdated(...P){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(P){for(const o of P)this.overrideIdentifiers.add(o);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(P,o=!0,u,l=3){var c;l=y.isUndefinedOrNull(P.scope)?l:P.scope;let t=[],i=P.properties;if(i)for(let a in i){if(o&&d(a)){delete i[a];continue}const h=i[a];if(this.updatePropertyDefaultValue(a,h),e.OVERRIDE_PROPERTY_PATTERN.test(a)?h.scope=void 0:(h.scope=y.isUndefinedOrNull(h.scope)?l:h.scope,h.restricted=y.isUndefinedOrNull(h.restricted)?!!((c=u==null?void 0:u.restrictedConfigurations)===null||c===void 0?void 0:c.includes(a)):h.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),t.push(a)}let s=P.allOf;if(s)for(let a of s)t.push(...this.validateAndRegisterProperties(a,o,u,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(P){const o=u=>{let l=u.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let c=u.allOf;c&&c.forEach(o)};o(P)}updateSchema(P,o){switch(e.allSettings.properties[P]=o,o.scope){case 1:e.applicationSettings.properties[P]=o;break;case 2:e.machineSettings.properties[P]=o;break;case 6:e.machineOverridableSettings.properties[P]=o;break;case 3:e.windowSettings.properties[P]=o;break;case 4:e.resourceSettings.properties[P]=o;break;case 5:e.resourceSettings.properties[P]=o,this.resourceLanguageSettingsSchema.properties[P]=o;break}}removeFromSchema(P,o){switch(delete e.allSettings.properties[P],o.scope){case 1:delete e.applicationSettings.properties[P];break;case 2:delete e.machineSettings.properties[P];break;case 6:delete e.machineOverridableSettings.properties[P];break;case 3:delete e.windowSettings.properties[P];break;case 4:case 5:delete e.resourceSettings.properties[P];break}}updateOverridePropertyPatternKey(){for(const P of this.overrideIdentifiers.values()){const o=`[${P}]`,u={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(o,u),e.allSettings.properties[o]=u,e.applicationSettings.properties[o]=u,e.machineSettings.properties[o]=u,e.machineOverridableSettings.properties[o]=u,e.windowSettings.properties[o]=u,e.resourceSettings.properties[o]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(P,o){let u=this.defaultValues[P];y.isUndefined(u)&&(u=o.default),y.isUndefined(u)&&(u=E(o.type)),o.default=u}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function S(M){return M.substring(1,M.length-1)}e.overrideIdentifierFromKey=S;function E(M){switch(Array.isArray(M)?M[0]:M){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const b=new p;L.Registry.add(e.Extensions.Configuration,b);function d(M){return M.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(M)?v.localize(5,null,M):b.getConfigurationProperties()[M]!==void 0?v.localize(6,null,M):null:v.localize(4,null)}e.validateProperty=d;function m(){const M=[],P=b.getConfigurationProperties();for(const o of Object.keys(P))M.push([o,P[o].scope]);return M.push(["launch",4]),M.push(["task",4]),M}e.getScopes=m}),define(Q[17],J([0,1,44,13,8,37,4,48]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function w(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.isConfigurationOverrides=w;var p;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(p=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function S(i,s){const a=s?i?s.keys.filter(B=>i.keys.indexOf(B)===-1):[...s.keys]:[],h=i?s?i.keys.filter(B=>s.keys.indexOf(B)===-1):[...i.keys]:[],f=[];if(s&&i){for(const B of i.keys)if(s.keys.indexOf(B)!==-1){const X=P(i.contents,B),te=P(s.contents,B);v.equals(X,te)||f.push(B)}}const g=[],k=B=>{const X={};for(const te of B)for(const oe of te.identifiers)X[c(oe)]=te;return X},T=s?k(s.overrides):{},U=i?k(i.overrides):{};if(Object.keys(T).length)for(const B of a){const X=T[B];X&&g.push([(0,r.overrideIdentifierFromKey)(B),X.keys])}if(Object.keys(U).length)for(const B of h){const X=U[B];X&&g.push([(0,r.overrideIdentifierFromKey)(B),X.keys])}if(Object.keys(T).length&&Object.keys(U).length)for(const B of f){const X=U[B],te=T[B];if(X&&te){const oe=S({contents:X.contents,keys:X.keys,overrides:[]},{contents:te.contents,keys:te.keys,overrides:[]});g.push([(0,r.overrideIdentifierFromKey)(B),[...oe.added,...oe.removed,...oe.updated]])}}return{added:a,removed:h,updated:f,overrides:g}}e.compare=S;function E(i,s){const a=[];for(const h of Object.keys(i))if(r.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const g in i[h])f[g]=i[h][g];a.push({identifiers:[(0,r.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:b(f,s)})}return a}e.toOverrides=E;function b(i,s){const a=Object.create(null);for(let h in i)d(a,h,i[h],s);return a}e.toValuesTree=b;function d(i,s,a,h){const f=s.split("."),g=f.pop();let k=i;for(let T=0;T<f.length;T++){let U=f[T],B=k[U];switch(typeof B){case"undefined":B=k[U]=Object.create(null);break;case"object":break;default:h(`Ignoring ${s} as ${f.slice(0,T+1).join(".")} is ${JSON.stringify(B)}`);return}k=B}if(typeof k=="object"&&k!==null)try{k[g]=a}catch(T){h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else h(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=d;function m(i,s){const a=s.split(".");M(i,a)}e.removeFromValueTree=m;function M(i,s){const a=s.shift();if(s.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const h=i[a];typeof h=="object"&&!Array.isArray(h)&&(M(h,s),Object.keys(h).length===0&&delete i[a])}}function P(i,s,a){function h(k,T){let U=k;for(const B of T){if(typeof U!="object"||U===null)return;U=U[B]}return U}const f=s.split("."),g=h(i,f);return typeof g=="undefined"?a:g}e.getConfigurationValue=P;function o(i,s,a){Object.keys(s).forEach(h=>{h!=="__proto__"&&(h in i?R.isObject(i[h])&&R.isObject(s[h])?o(i[h],s[h],a):a&&(i[h]=s[h]):i[h]=s[h])})}e.merge=o;function u(){const i=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function l(){const i=Object.create(null),s=y.Registry.as(r.Extensions.Configuration).getConfigurationProperties();for(let a in s){let h=s[a].default;d(i,a,h,f=>console.error(`Conflict in default settings: ${f}`))}return i}e.getDefaultValues=l;function c(i){return`[${i}]`}e.keyFromOverrideIdentifier=c;function t(i,s,a){const h=i.inspect(s),f=i.inspect(a);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(Q[185],J([0,1,43,36,35,13,44,8,48,17,37,2,5]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,p.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?(0,p.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const a of L.distinct([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[a],f=i[a];f&&(typeof h=="object"&&typeof f=="object"?(h=I.deepClone(h),this.mergeContents(h,f)):h=f),s[a]=h}return new b(s,this.keys,this.overrides)}merge(...t){const i=I.deepClone(this.contents),s=I.deepClone(this.overrides),a=[...this.keys];for(const h of t){this.mergeContents(i,h.contents);for(const f of h.overrides){const[g]=s.filter(k=>L.equals(k.identifiers,f.identifiers));g?this.mergeContents(g.contents,f.contents):s.push(I.deepClone(f))}for(const f of h.keys)a.indexOf(f)===-1&&a.push(f)}return new b(i,a,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&y.isObject(t[s])&&y.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=I.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,p.addToValueTree)(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,p.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class d extends b{constructor(){const t=(0,p.getDefaultValues)(),i=(0,p.getConfigurationKeys)(),s=[];for(const a of Object.keys(t))w.OVERRIDE_PROPERTY_PATTERN.test(a)&&s.push({identifiers:[(0,w.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(t[a]),contents:(0,p.toValuesTree)(t[a],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,i,s)}}e.DefaultConfigurationModel=d;class m{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!y.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:a,overrides:h,restricted:f}=this.doParseRaw(t,i);this._configurationModel=new b(s,a,h),this._restrictedConfigurations=f||[]}doParseContent(t){let i={},s=null,a=[],h=[],f=[];function g(T){Array.isArray(a)?a.push(T):s&&(a[s]=T)}let k={onObjectBegin:()=>{let T={};g(T),h.push(a),a=T,s=null},onObjectProperty:T=>{s=T},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{let T=[];g(T),h.push(a),a=T,s=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:g,onError:(T,U,B)=>{f.push({error:T,offset:U,length:B})}};if(t)try{v.visit(t,k),i=a[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(t,i){const s=n.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),a=this.filter(t,s,!0,i);t=a.raw;const h=(0,p.toValuesTree)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(t),g=(0,p.toOverrides)(t,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:h,keys:f,overrides:g,restricted:a.restricted}}filter(t,i,s,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:t,restricted:[]};const h={},f=[];for(let g in t)if(w.OVERRIDE_PROPERTY_PATTERN.test(g)&&s){const k=this.filter(t[g],i,!1,a);h[g]=k.raw,f.push(...k.restricted)}else{const k=i[g],T=k?typeof k.scope!="undefined"?k.scope:3:void 0;(k==null?void 0:k.restricted)&&f.push(g),(T===void 0||a.scopes===void 0||a.scopes.includes(T))&&(a.skipRestricted&&(k==null?void 0:k.restricted)||(h[g]=t[g]))}return{raw:h,restricted:f}}}e.ConfigurationModelParser=m;class M extends S.Disposable{constructor(t,i,s,a){super();this.userSettingsResource=t,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=M;class P{constructor(t,i,s=new b,a=new b,h=new R.ResourceMap,f=new b,g=new R.ResourceMap,k=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=g,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let a;s.resource?(a=this._memoryConfigurationByResource.get(s.resource),a||(a=new b,this._memoryConfigurationByResource.set(s.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(t):a.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const a=this.getConsolidateConfigurationModel(i,s),h=this.getFolderConfigurationModelForResource(i.resource,s),f=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,g=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),k=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),B=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,X=h?i.overrideIdentifier?h.freeze().override(i.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,te=i.overrideIdentifier?f.override(i.overrideIdentifier).getValue(t):f.getValue(t),oe=a.getValue(t),W=L.distinct(L.flatten(a.overrides.map($=>$.identifiers))).filter($=>a.getOverrideValue(t,$)!==void 0);return{defaultValue:g,userValue:k,userLocalValue:T,userRemoteValue:U,workspaceValue:B,workspaceFolderValue:X,memoryValue:te,value:oe,default:g!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:B!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:X!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:i.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:te!==void 0?{value:f.getValue(t),override:i.overrideIdentifier?f.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:W.length?W:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(a=>w.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const h=(0,w.overrideIdentifierFromKey)(a),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),g=t.getKeysForOverrideIdentifier(h),k=[...g.filter(T=>f.indexOf(T)===-1),...f.filter(T=>g.indexOf(T)===-1),...f.filter(T=>!I.equals(this._defaultConfiguration.override(h).getValue(T),t.override(h).getValue(T)))];return[h,k]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.localUserConfiguration,t),f=[...i,...s,...a];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.remoteUserConfiguration,t);let f=[...i,...s,...a];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:a,overrides:h}=(0,p.compare)(this.workspaceConfiguration,t);let f=[...i,...s,...a];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:a,updated:h,removed:f,overrides:g}=(0,p.compare)(s,i);let k=[...a,...h,...f];return(k.length||!s)&&this.updateFolderConfiguration(t,i),{keys:k,overrides:g}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:a,removed:h,overrides:f}=(0,p.compare)(i,void 0);return{keys:[...s,...a,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const a=i.getFolder(t);a&&(s=this.getFolderConsolidatedConfiguration(a.uri)||s);const h=this._memoryConfigurationByResource.get(t);h&&(s=s.merge(h))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(t);a?(i=s.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:a,keys:h}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:a,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(a=>i.add(a))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),a=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,g)=>(f.set(r.URI.revive(g[0]),this.parseConfigurationModel(g[1])),f),new R.ResourceMap);return new P(i,s,new b,a,h,new b,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=P;function o(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,i=new Map;for(const a of c)a.keys.forEach(h=>t.add(h)),a.overrides.forEach(([h,f])=>{const g=(0,R.getOrSet)(i,h,new Set);f.forEach(k=>g.add(k))});const s=[];return i.forEach((a,h)=>s.push([h,[...a.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=o;class u{constructor(t,i,s,a){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=a,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(g=>h.add(g)),t.overrides.forEach(([,g])=>g.forEach(k=>h.add(k))),this.affectedKeys=[...h.values()];const f=new b;this.affectedKeys.forEach(g=>f.setValue(g,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=P.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,h=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!I.equals(a,h)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=(0,p.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof s=="object"&&(a=Object.keys(s)[0]);){if(t=t[a],!t)return!1;s=s[a]}return!0}}e.ConfigurationChangeEvent=u;class l extends u{constructor(t,i,s,a){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=a}}e.AllKeysConfigurationChangeEvent=l}),define(Q[186],J([0,1,37,48,2,17,185,5,9,15]),function(j,e,v,R,L,y,I,r,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(E,b){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new r.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,p.extUriBiasedIgnorePathCase,b)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new w.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,b){const d=typeof E=="string"?E:void 0,m=(0,y.isConfigurationOverrides)(E)?E:(0,y.isConfigurationOverrides)(b)?b:{};return this.configuration.getValue(d,m,void 0)}updateValue(E,b,d,m){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const b=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,b,1)}onDidDefaultConfigurationChange(E){const b=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,E);this.trigger(d,b,6)}trigger(E,b,d){const m=new I.ConfigurationChangeEvent(E,{data:b},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Q[187],J([0,1,45,7,68,138,16,3,89,17,4,10,104]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=y.localize(0,null);class d{async getDefaultTerminalForPlatforms(){const t=await P.getDefaultTerminalLinuxReady();return{windows:m.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let m=class Qe extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,L.getWindowsShell(),t)}spawnTerminal(t,i,s,a){const h=i.terminal.external,f=(h==null?void 0:h.windowsExec)||Qe.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const g=R.basename(f).toLowerCase();if(g==="cmder"||g==="cmder.exe")return t.spawn(f,a?[a]:void 0),Promise.resolve(void 0);const k=["/c","start","/wait"];return f.indexOf(" ")>=0&&k.push('""'),k.push(f),(g==="wt"||g==="wt.exe")&&k.push("-d ."),new Promise((T,U)=>{const B=o(process),X=t.spawn(s,k,{cwd:a,env:B});X.on("error",U),X.on("exit",()=>T())})}runInTerminal(t,i,s,a,h){const f=h.windowsExec||Qe.getDefaultTerminalWindows();return new Promise((g,k)=>{const T=`"${i} - ${b}"`,U=`""${s.join('" "')}" & pause"`,B=["/c","start",T,"/wait",f,"/c",U],X=Object.assign({},o(process),a);Object.keys(X).filter(W=>X[W]===null).forEach(W=>delete X[W]);const te={cwd:i,env:X,windowsVerbatimArguments:!0};v.spawn(Qe.CMD,B,te).on("error",W=>{k(u(W))}),g(void 0)})}static getDefaultTerminalWindows(){if(!Qe._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");Qe._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return Qe._DEFAULT_TERMINAL_WINDOWS}};m.CMD="cmd.exe",m=ce([ee(0,(0,n.optional)(p.IConfigurationService))],m),e.WindowsExternalTerminalService=m;let M=class Et extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,t)}runInTerminal(t,i,s,a,h){const f=h.osxExec||w.DEFAULT_TERMINAL_OSX;return new Promise((g,k)=>{if(f===w.DEFAULT_TERMINAL_OSX||f==="iTerm.app"){const T=f===w.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",B=[S.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${T}.scpt`,j).fsPath,"-t",t||b,"-w",i];for(let oe of s)B.push("-a"),B.push(oe);if(a)for(let oe in a){const W=a[oe];W===null?(B.push("-u"),B.push(oe)):(B.push("-e"),B.push(`${oe}=${W}`))}let X="";const te=v.spawn(Et.OSASCRIPT,B);te.on("error",oe=>{k(u(oe))}),te.stderr.on("data",oe=>{X+=oe.toString()}),te.on("exit",oe=>{if(oe===0)g(void 0);else if(X){const W=X.split(`
`,1);k(new Error(W[0]))}else k(new Error(y.localize(1,null,T,oe)))})}else k(new Error(y.localize(2,null,f)))})}spawnTerminal(t,i,s){const a=i.terminal.external,h=(a==null?void 0:a.osxExec)||w.DEFAULT_TERMINAL_OSX;return new Promise((f,g)=>{const k=["-a",h];s&&k.push(s);const T=t.spawn("/usr/bin/open",k);T.on("error",g),T.on("exit",()=>f())})}};M.OSASCRIPT="/usr/bin/osascript",M=ce([ee(0,(0,n.optional)(p.IConfigurationService))],M),e.MacExternalTerminalService=M;let P=class Je extends d{constructor(t){super();this._configurationService=t}openTerminal(t){const i=this._configurationService.getValue();return this.spawnTerminal(v,i,t)}runInTerminal(t,i,s,a,h){const f=h.linuxExec?Promise.resolve(h.linuxExec):Je.getDefaultTerminalLinuxReady();return new Promise((g,k)=>{let T=[];f.then(U=>{U.indexOf("gnome-terminal")>=0?T.push("-x"):T.push("-e"),T.push("bash"),T.push("-c");const B=`${l(s)}; echo; read -p "${Je.WAIT_MESSAGE}" -n1;`;T.push(`''${B}''`);const X=Object.assign({},process.env,a);Object.keys(X).filter($=>X[$]===null).forEach($=>delete X[$]);const te={cwd:i,env:X};let oe="";const W=v.spawn(U,T,te);W.on("error",$=>{k(u($))}),W.stderr.on("data",$=>{oe+=$.toString()}),W.on("exit",$=>{if($===0)g(void 0);else if(oe){const z=oe.split(`
`,1);k(new Error(z[0]))}else k(new Error(y.localize(4,null,U,$)))})})})}static async getDefaultTerminalLinuxReady(){return Je._DEFAULT_TERMINAL_LINUX_READY||(Je._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{r.isLinux?await I.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),Je._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,i,s){const a=i.terminal.external,h=(a==null?void 0:a.linuxExec)?Promise.resolve(a.linuxExec):Je.getDefaultTerminalLinuxReady();return new Promise((f,g)=>{h.then(k=>{const T=o(process),U=t.spawn(k,[],{cwd:s,env:T});U.on("error",g),U.on("exit",()=>f())})})}};P.WAIT_MESSAGE=y.localize(3,null),P=ce([ee(0,(0,n.optional)(p.IConfigurationService))],P),e.LinuxExternalTerminalService=P;function o(c){const t=c.env;return(0,E.sanitizeProcessEnvironment)(t),t}function u(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(y.localize(5,null,c.path)):c}function l(c){let t="";for(let i of c)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}}),define(Q[188],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(I){I[I.Unknown=0]="Unknown",I[I.DisableTrust=1]="DisableTrust",I[I.MachineTrusted=2]="MachineTrusted"})(R=e.RemoteTrustOption||(e.RemoteTrustOption={}));var L;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class y extends Error{constructor(r,w=L.Unknown,p){super(r);this._message=r,this._code=w,this._detail=p,this.isHandled=w===L.NotAvailable&&p===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype)}static isTemporarilyNotAvailable(r){return r instanceof y&&r._code===L.TemporarilyNotAvailable}static isNoResolverFound(r){return r instanceof y&&r._code===L.NoResolverFound}static isHandled(r){return r instanceof y&&r.isHandled}}e.RemoteAuthorityResolverError=y}),define(Q[189],J([0,1,83,28,2,23,5,188,19,9,26]),function(j,e,v,R,L,y,I,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var E;(function(D){D[D.Management=1]="Management",D[D.ExtensionHost=2]="ExtensionHost",D[D.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function b(D){switch(D){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(D){const F=new n.CancellationTokenSource;return setTimeout(()=>F.cancel(),D),F.token}function m(D,F){if(D.isCancellationRequested||F.isCancellationRequested)return n.CancellationToken.Cancelled;const C=new n.CancellationTokenSource;return D.onCancellationRequested(()=>C.cancel()),F.onCancellationRequested(()=>C.cancel()),C.token}class M{constructor(F){this._state="pending",this._disposables=new L.DisposableStore,this.promise=new Promise((C,K)=>{this._resolvePromise=C,this._rejectPromise=K}),F.isCancellationRequested?this._timeout():this._disposables.add(F.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(F){this._state==="pending"?this._disposables.add(F):F.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(F))}reject(F){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(F))}}function P(D,F){const C=new M(F);return C.registerDisposable(D.onControlMessage(K=>{const G=JSON.parse(K.toString()),Y=H(G);Y?C.reject(Y):C.resolve(G)})),C.promise}function o(D,F,C,K,G,Y){const Z=new M(Y);return F.connect(C,K,G,(re,se)=>{Z.didTimeout?(re&&D.error(re),se==null||se.dispose()):re||!se?Z.reject(re):Z.resolve(se)}),Z.promise}function u(D,F){const C=new M(F);return D.then(K=>{C.didTimeout||C.resolve(K)},K=>{C.didTimeout||C.reject(K)}),C.promise}async function l(D,F,C,K){const G=A(D,F);D.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await o(D.logService,D.socketFactory,D.host,D.port,`reconnectionToken=${D.reconnectionToken}&reconnection=${D.reconnectionProtocol?"true":"false"}`,K)}catch(x){throw D.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),D.logService.error(x),x}D.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let Z,re;D.reconnectionProtocol?(D.reconnectionProtocol.beginAcceptReconnection(Y,null),Z=D.reconnectionProtocol,re=!1):(Z=new v.PersistentProtocol(Y,null),re=!0),D.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se={type:"auth",auth:D.connectionToken||"00000000000000000000"};Z.sendControl(y.VSBuffer.fromString(JSON.stringify(se)));try{const x=await P(Z,m(K,d(1e4)));if(x.type!=="sign"||typeof x.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}D.logService.trace(`${G} 4/6. received SignRequest control message.`);const ne=await u(D.signService.sign(x.data),K),ue={type:"connectionType",commit:D.commit,signedData:ne,desiredConnectionType:F};return C&&(ue.args=C),D.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(y.VSBuffer.fromString(JSON.stringify(ue))),{protocol:Z,ownsProtocol:re}}catch(x){throw x&&x.code==="ETIMEDOUT"&&(D.logService.error(`${G} the handshake timed out. Error:`),D.logService.error(x)),x&&x.code==="VSCODE_CONNECTION_ERROR"&&(D.logService.error(`${G} received error control message when negotiating connection. Error:`),D.logService.error(x)),re&&N(Z),x}}async function c(D,F,C,K){const G=Date.now(),Y=A(D,F),{protocol:Z,ownsProtocol:re}=await l(D,F,C,K),se=new M(K);return se.registerDisposable(Z.onControlMessage(x=>{const ne=JSON.parse(x.toString()),ue=H(ne);ue?(D.logService.error(`${Y} received error control message when negotiating connection. Error:`),D.logService.error(ue),re&&N(Z),se.reject(ue)):(D.reconnectionProtocol&&D.reconnectionProtocol.endAcceptReconnection(),D.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${O(G)}!`),se.resolve({protocol:Z,firstMessage:ne}))})),se.promise}async function t(D,F){const{protocol:C}=await c(D,1,void 0,F);return{protocol:C}}async function i(D,F,C){const{protocol:K,firstMessage:G}=await c(D,2,F,C),Y=G&&G.debugPort;return{protocol:K,debugPort:Y}}async function s(D,F,C){const K=Date.now(),G=A(D,3),{protocol:Y}=await l(D,3,F,C);return D.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${O(K)}!`),Y}async function a(D,F,C){const{host:K,port:G,connectionToken:Y}=await D.addressProvider.getAddress();return{commit:D.commit,host:K,port:G,connectionToken:Y,reconnectionToken:F,reconnectionProtocol:C,socketFactory:D.socketFactory,signService:D.signService,logService:D.logService}}async function h(D,F,C){try{const K=(0,R.generateUuid)(),G=await a(D,K,null),{protocol:Y}=await t(G,n.CancellationToken.None);return new $(D,F,C,K,Y)}catch(K){throw D.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),D.logService.error(K),W.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=h;async function f(D,F){try{const C=(0,R.generateUuid)(),K=await a(D,C,null),{protocol:G,debugPort:Y}=await i(K,F,n.CancellationToken.None);return new z(D,F,C,G,Y)}catch(C){throw D.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),D.logService.error(C),W.triggerPermanentFailure(0,0,r.RemoteAuthorityResolverError.isHandled(C)),C}}e.connectRemoteAgentExtensionHost=f;async function g(D,F){const C=await a(D,(0,R.generateUuid)(),null);return await s(C,{port:F},n.CancellationToken.None)}e.connectRemoteAgentTunnel=g;function k(D){return(0,p.createCancelablePromise)(F=>new Promise((C,K)=>{const G=setTimeout(C,D*1e3);F.onCancellationRequested(()=>{clearTimeout(G),C()})}))}var T;(function(D){D[D.ConnectionLost=0]="ConnectionLost",D[D.ReconnectionWait=1]="ReconnectionWait",D[D.ReconnectionRunning=2]="ReconnectionRunning",D[D.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",D[D.ConnectionGain=4]="ConnectionGain"})(T=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(F,C){this.reconnectionToken=F,this.millisSinceLastIncomingData=C,this.type=0}}e.ConnectionLostEvent=U;class B{constructor(F,C,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=C,this.durationSeconds=K,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=B;class X{constructor(F,C,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=C,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=X;class te{constructor(F,C,K){this.reconnectionToken=F,this.millisSinceLastIncomingData=C,this.attempt=K,this.type=4}}e.ConnectionGainEvent=te;class oe{constructor(F,C,K,G){this.reconnectionToken=F,this.millisSinceLastIncomingData=C,this.attempt=K,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=oe;class W extends L.Disposable{constructor(F,C,K,G){super();this._connectionType=F,this._onDidStateChange=this._register(new I.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=C,this.reconnectionToken=K,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new te(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),W._instances.push(this),W._permanentFailure&&this._gotoPermanentFailure(W._permanentFailureMillisSinceLastIncomingData,W._permanentFailureAttempt,W._permanentFailureHandled)}static triggerPermanentFailure(F,C,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=F,this._permanentFailureAttempt=C,this._permanentFailureHandled=K,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!W._permanentFailure){const F=_(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const C=[0,5,5,10,10,10,10,10,30],K=Date.now();let G=-1;do{G++;const Y=G<C.length?C[G]:C[C.length-1];try{if(Y>0){const re=k(Y);this._onDidStateChange.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,re)),this._options.logService.info(`${F} waiting for ${Y} seconds before reconnecting...`);try{await re}catch(se){}}if(W._permanentFailure){this._options.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${F} resolving connection...`);const Z=await a(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${F} connecting to ${Z.host}:${Z.port}...`),await this._reconnect(Z,d(S)),this._options.logService.info(`${F} reconnected!`),this._onDidStateChange.fire(new te(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Z),W.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Z),W.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(r.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this._options.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this._options.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if((0,w.isPromiseCanceledError)(Z)){this._options.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Z);continue}if(Z instanceof r.RemoteAuthorityResolverError){this._options.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Z),W.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,r.RemoteAuthorityResolverError.isHandled(Z));break}this._options.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Z),W.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!W._permanentFailure)}}_gotoPermanentFailure(F,C,K){this._onDidStateChange.fire(new oe(this.reconnectionToken,F,C,K)),N(this.protocol)}}W._permanentFailure=!1,W._permanentFailureMillisSinceLastIncomingData=0,W._permanentFailureAttempt=0,W._permanentFailureHandled=!1,W._instances=[];class $ extends W{constructor(F,C,K,G,Y){super(1,F,G,Y);this.client=this._register(new v.Client(Y,{remoteAuthority:C,clientId:K},F.ipcLogger))}async _reconnect(F,C){await t(F,C)}}e.ManagementPersistentConnection=$;class z extends W{constructor(F,C,K,G,Y){super(2,F,K,G);this._startArguments=C,this.debugPort=Y}async _reconnect(F,C){await i(F,this._startArguments,C)}}e.ExtensionHostPersistentConnection=z;function N(D){try{D.acceptDisconnect();const F=D.getSocket();D.dispose(),F.dispose()}catch(F){(0,w.onUnexpectedError)(F)}}function H(D){if(D&&D.type==="error"){const F=new Error(`Connection error: ${D.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function V(D,F){for(;D.length<F;)D+=" ";return D}function _(D,F,C){return`[remote-connection][${V(b(D),13)}][${F.substr(0,5)}\u2026][${C?"reconnect":"initial"}]`}function A(D,F){return`${_(F,D.reconnectionToken,!!D.reconnectionProtocol)}[${D.host}:${D.port}]`}function O(D){return`${Date.now()-D} ms`}}),define(Q[73],J([0,1,10]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(w){return w.scheme===v.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=R;function L(w){if(!!w){const p=w.indexOf("+");return p<0?w:w.substr(0,p)}}e.getRemoteName=L;function y(w){return w.scheme!==v.Schemas.file&&w.scheme!==v.Schemas.vscodeRemote}function I(w){if(w.folders.length)return w.folders.every(p=>y(p.uri))?w.folders[0].uri:void 0;if(w.configuration&&y(w.configuration))return w.configuration}e.getVirtualWorkspaceLocation=I;function r(w){var p;return(p=I(w))===null||p===void 0?void 0:p.scheme}e.getVirtualWorkspaceScheme=r}),define(Q[74],J([0,1,5,3,4,6]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,L.createDecorator)("tunnelService");var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(I=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function r(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const b=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!b)return{address:b[1],port:+b[2]}}}e.extractLocalHostUriMetaDataForPortMapping=r,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=w,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=p;function n(E,b){return b?b!==1&&E<1024:!R.isWindows&&E<1024}e.isPortPrivileged=n;let S=class{constructor(b){this.logService=b,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(b,d){return this._tunnelProvider=b,b?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async b=>{const d=[],m=Array.from(this._tunnels.values());for(let M of m){const P=Array.from(M.values());for(let o of P){const u=await o.value;u&&d.push(u)}}b(d)})}async dispose(){for(const b of this._tunnels.values()){for(const{value:d}of b.values())await d.then(m=>m==null?void 0:m.dispose());b.clear()}this._tunnels.clear()}openTunnel(b,d,m,M,P=!1,o=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${M}.`),!!b){d||(d="localhost");const u=this.retainOrCreateTunnel(b,d,m,M,P,o);return u?u.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(c),c}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}}makeTunnel(b){return{tunnelRemotePort:b.tunnelRemotePort,tunnelRemoteHost:b.tunnelRemoteHost,tunnelLocalPort:b.tunnelLocalPort,localAddress:b.localAddress,public:b.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${b.tunnelRemoteHost}:${b.tunnelRemotePort} `);const d=this._tunnels.get(b.tunnelRemoteHost);if(d){const m=d.get(b.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(b.tunnelRemoteHost,b.tunnelRemotePort,m))}}}}async tryDisposeTunnel(b,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${b}:${d}.`);const M=m.value.then(async P=>{P&&(await P.dispose(!0),this._onTunnelClosed.fire({host:P.tunnelRemoteHost,port:P.tunnelRemotePort}))});return this._tunnels.has(b)&&this._tunnels.get(b).delete(d),M}}async closeTunnel(b,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${b}:${d} `);const m=this._tunnels.get(b);if(m&&m.has(d)){const M=m.get(d);M.refcount=0,await this.tryDisposeTunnel(b,d,M)}}addTunnelToMap(b,d,m){this._tunnels.has(b)||this._tunnels.set(b,new Map),this._tunnels.get(b).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(b,d){const m=this._tunnels.get(b);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(b))}getTunnelFromMap(b,d){let m=[b];w(b)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):p(b)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const M=m.map(P=>this._tunnels.get(P));for(const P of M){const o=P==null?void 0:P.get(d);if(o)return o}}canTunnel(b){return!!r(b)}createWithProvider(b,d,m,M,P,o){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${M}.`);const l={elevationRequired:P?n(M===void 0?m:M):!1},c={remoteAddress:{host:d,port:m},localAddressPort:M,public:o},t=b.forwardPort(c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,m,t),t}};S=ce([ee(0,y.ILogService)],S),e.AbstractTunnelService=S}),define(Q[49],J([0,1,145,4,48,37,23]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function r(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=r;function w(d){return d.res.statusCode===204}async function p(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);return w(d)?null:(await(0,I.streamToBuffer)(d.stream)).toString()}e.asText=p;async function n(d){if(!r(d))throw new Error("Server returned "+d.res.statusCode);if(w(d))return null;const M=(await(0,I.streamToBuffer)(d.stream)).toString();try{return JSON.parse(M)}catch(P){throw P.message+=`:
`+M,P}}e.asJson=n;function S(d){b(d)}e.updateProxyConfigurationsScope=S;let E;function b(d){const m=y.Registry.as(L.Extensions.Configuration);E&&m.deregisterConfigurations([E]),E={id:"http",order:15,title:(0,v.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null),(0,v.localize)(7,null)],default:"override",description:(0,v.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(9,null),restricted:!0}}},m.registerConfiguration(E)}b(2)}),define(Q[190],J([0,1,191,13]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function L(I,r){return I.protocol==="http:"?r.HTTP_PROXY||r.http_proxy||null:I.protocol==="https:"&&(r.HTTPS_PROXY||r.https_proxy||r.HTTP_PROXY||r.http_proxy)||null}async function y(I,r,w={}){const p=(0,v.parse)(I),n=w.proxyUrl||L(p,r);if(!n)return null;const S=(0,v.parse)(n);if(!/^https?:$/.test(S.protocol||""))return null;const E={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,R.isBoolean)(w.strictSSL)?w.strictSSL:!0};return p.protocol==="http:"?new(await new Promise((b,d)=>{j(["http-proxy-agent"],b,d)}))(E):new(await new Promise((b,d)=>{j(["https-proxy-agent"],b,d)}))(E)}e.getProxyAgent=y}),define(Q[192],J([0,1,28,23]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(y,I,r){let w=r&&r.get("storage.serviceMachineId",0)||null;if(w)return w;try{const n=(await I.readFile(y.serviceMachineIdResource)).value.toString();w=(0,v.isUUID)(n)?n:null}catch(p){w=null}if(!w){w=(0,v.generateUuid)();try{await I.writeFile(y.serviceMachineIdResource,R.VSBuffer.fromString(w))}catch(p){}}return r&&r.store("storage.serviceMachineId",w,0,1),w}e.getServiceMachineId=L}),define(Q[75],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[193],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((L,y)=>j(["vsda"],L,y))}async sign(L){try{const y=await this.vsda(),I=new y.signer;if(I)return I.sign(L)}catch(y){}return L}}e.SignService=v}),define(Q[38],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,v.createDecorator)("stateMainService")}),define(Q[18],J([0,1,14,6,38,5,4,175,3,2,9,13,32]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,I.createDecorator)("lifecycleMainService");var b;(function(M){M[M.CLOSE=1]="CLOSE",M[M.QUIT=2]="QUIT",M[M.RELOAD=3]="RELOAD",M[M.LOAD=4]="LOAD"})(b=e.UnloadReason||(e.UnloadReason={}));var d;(function(M){M[M.Starting=1]="Starting",M[M.Ready=2]="Ready",M[M.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class ct extends p.Disposable{constructor(P,o){super();this.logService=P,this.stateMainService=o,this._onBeforeShutdown=this._register(new y.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new y.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new y.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new y.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new y.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const P=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),w.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",P);const o=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!w.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",o),v.app.once("will-quit",u=>{this.logService.trace("Lifecycle#app.on(will-quit)"),u.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",P),v.app.removeListener("window-all-closed",o),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const P=[this.stateMainService.flush()];return this._onWillShutdown.fire({join(o){P.push(o)}}),this.pendingWillShutdownPromise=n.Promises.settled(P).then(()=>{},o=>this.logService.error(o)),this.pendingWillShutdownPromise}set phase(P){if(P<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==P){this.logService.trace(`lifecycle (main): phase changed (value: ${P})`),this._phase=P;const o=this.phaseWhen.get(this._phase);o&&(o.open(),this.phaseWhen.delete(this._phase))}}async when(P){if(!(P<=this._phase)){let o=this.phaseWhen.get(P);o||(o=new n.Barrier,this.phaseWhen.set(P,o)),await o.wait()}}registerWindow(P){const o=new p.DisposableStore;this.windowCounter++,o.add(P.onWillLoad(l=>this._onWillLoadWindow.fire({window:P,workspace:l.workspace})));const u=(0,S.assertIsDefined)(P.win);u.on("close",l=>{const c=P.id;if(this.windowToCloseRequest.has(c)){this.windowToCloseRequest.delete(c);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${P.id}`),l.preventDefault(),this.unload(P,1).then(t=>{if(t){this.windowToCloseRequest.delete(c);return}this.windowToCloseRequest.add(c),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${c}`),this._onBeforeCloseWindow.fire(P),P.close()})}),u.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${P.id}`),this.windowCounter--,o.dispose(),this.windowCounter===0&&(!w.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(P,o){await this.unload(P,3)||P.reload(o)}async unload(P,o){if(!P.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${P.id}`);const u=this._quitRequested?2:o;let l=await this.onBeforeUnloadWindowInRenderer(P,u);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${P.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(P,u),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${P.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${P.id})`),await this.onWillUnloadWindowInRenderer(P,u),!1))}handleWindowUnloadVeto(P){return P?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(P){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(P),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(P,o){return new Promise(u=>{const l=this.oneTimeListenerTokenGenerator++,c=`vscode:ok${l}`,t=`vscode:cancel${l}`;v.ipcMain.once(c,()=>{u(!1)}),v.ipcMain.once(t,()=>{u(!0)}),P.send("vscode:onBeforeUnload",{okChannel:c,cancelChannel:t,reason:o})})}onBeforeUnloadWindowInMain(P,o){const u=[];return this._onBeforeUnloadWindow.fire({reason:o,window:P,veto(l){u.push(l)}}),(0,r.handleVetos)(u,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(P,o){return new Promise(u=>{const c=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(c,()=>u()),P.send("vscode:onWillUnload",{replyChannel:c,reason:o})})}quit(P){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${P}`),P&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(o=>{this.pendingQuitPromiseResolve=o,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}async relaunch(P){this.logService.trace("Lifecycle#relaunch()");const o=process.argv.slice(1);if((P==null?void 0:P.addArgs)&&o.push(...P.addArgs),P==null?void 0:P.removeArgs)for(const c of P.removeArgs){const t=o.indexOf(c);t>=0&&o.splice(t,1)}const u=()=>{try{if(w.isWindows){const c=(0,E.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.logService.error(c)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:o})};v.app.once("quit",u),await this.quit(!0)&&v.app.removeListener("quit",u)}async kill(P){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,n.timeout)(1e3),(async()=>{for(const o of v.BrowserWindow.getAllWindows())if(o&&!o.isDestroyed()){let u;o.webContents&&!o.webContents.isDestroyed()?u=new Promise(l=>o.once("closed",l)):u=Promise.resolve(),o.destroy(),await u}})()]),v.app.exit(P)}};m.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",m=ce([ee(0,R.ILogService),ee(1,L.IStateMainService)],m),e.LifecycleMainService=m}),define(Q[194],J([0,1,4,5,2,18]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,v.createDecorator)("keyboardLayoutMainService");let I=class extends L.Disposable{constructor(p){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,p.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const p=await new Promise((n,S)=>{j(["native-keymap"],n,S)});this._keyboardLayoutData=r(p),p.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=r(p),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};I=ce([ee(0,y.ILifecycleMainService)],I),e.KeyboardLayoutMainService=I;function r(w){const p=w.getKeyMap(),n=w.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:n}}}),define(Q[95],J([0,1,4,5,2,13,85,9]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const w="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var p;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(p=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var S;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(S=e.StorageTarget||(e.StorageTarget={}));class E extends L.Disposable{constructor(M={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=M,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new r.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,r.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,L.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(M,P){P===w?(M===0?this._globalKeyTargets=void 0:M===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:M})):this._onDidChangeValue.fire({scope:M,key:P,target:this.getKeyTargets(M)[P]})}emitWillSaveState(M){this._onWillSaveState.fire({reason:M})}get(M,P,o){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.get(M,o)}getBoolean(M,P,o){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.getBoolean(M,o)}getNumber(M,P,o){var u;return(u=this.getStorage(P))===null||u===void 0?void 0:u.getNumber(M,o)}store(M,P,o,u){if((0,y.isUndefinedOrNull)(P)){this.remove(M,o);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(M,o,u),(l=this.getStorage(o))===null||l===void 0||l.set(M,P)})}remove(M,P){this.withPausedEmitters(()=>{var o;this.updateKeyTarget(M,P,void 0),(o=this.getStorage(P))===null||o===void 0||o.delete(M)})}withPausedEmitters(M){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{M()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(M,P){const o=[],u=this.getKeyTargets(M);for(const l of Object.keys(u))u[l]===P&&o.push(l);return o}updateKeyTarget(M,P,o){var u,l;const c=this.getKeyTargets(P);typeof o=="number"?c[M]!==o&&(c[M]=o,(u=this.getStorage(P))===null||u===void 0||u.set(w,JSON.stringify(c))):typeof c[M]=="number"&&(delete c[M],(l=this.getStorage(P))===null||l===void 0||l.set(w,JSON.stringify(c)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(M){return M===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(M){const P=this.get(w,M);if(P)try{return JSON.parse(P)}catch(o){}return Object.create(null)}isNew(M){return this.getBoolean(e.IS_NEW_KEY,M)===!0}async flush(){var M,P,o,u;this._onWillSaveState.fire({reason:p.NONE}),await r.Promises.settled([(P=(M=this.getStorage(0))===null||M===void 0?void 0:M.whenFlushed())!==null&&P!==void 0?P:Promise.resolve(),(u=(o=this.getStorage(1))===null||o===void 0?void 0:o.whenFlushed())!==null&&u!==void 0?u:Promise.resolve()])}async logStorage(){var M,P,o,u,l,c;const t=(P=(M=this.getStorage(0))===null||M===void 0?void 0:M.items)!==null&&P!==void 0?P:new Map,i=(u=(o=this.getStorage(1))===null||o===void 0?void 0:o.items)!==null&&u!==void 0?u:new Map;return d(t,i,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(c=this.getLogDetails(1))!==null&&c!==void 0?c:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends E{constructor(){super();this.globalStorage=new I.Storage(new I.InMemoryStorageDatabase),this.workspaceStorage=new I.Storage(new I.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(M=>this.emitDidChangeValue(1,M))),this._register(this.globalStorage.onDidChangeStorage(M=>this.emitDidChangeValue(0,M)))}getStorage(M){return M===0?this.globalStorage:this.workspaceStorage}getLogDetails(M){return M===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(M){}}e.InMemoryStorageService=b;async function d(m,M,P,o){const u=h=>{try{return JSON.parse(h)}catch(f){return h}},l=new Map,c=new Map;m.forEach((h,f)=>{l.set(f,h),c.set(f,u(h))});const t=new Map,i=new Map;M.forEach((h,f)=>{t.set(f,h),i.set(f,u(h))}),console.group(`Storage: Global (path: ${P})`);let s=[];l.forEach((h,f)=>{s.push({key:f,value:h})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${o})`);let a=[];t.forEach((h,f)=>{a.push({key:f,value:h})}),console.table(a),console.groupEnd(),console.log(i)}e.logStorage=d}),define(Q[195],J([0,1,3,32,28,8]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;function I(p){if(v.platform===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}async function r(p,n,S,E,b,d,m,M,P,o){const u=Object.create(null);u["common.machineId"]=m,u.sessionID=(0,L.generateUuid)()+Date.now(),u.commitHash=b,u.version=d,u["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,v.PlatformToString)(v.platform),u["common.nodePlatform"]=R.platform,u["common.nodeArch"]=E,u["common.product"]=o||"desktop";const l=w(M||[]);l&&(u["common.msftInternal"]=l);let c=0;const t=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(u["common.snap"]="true");const i=I(S);i&&(u["common.platformDetail"]=i);try{const s=await p.readFile(y.URI.file(P));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=r;function w(p){const n=R.env.USERDNSDOMAIN;if(!n)return!1;const S=n.toLowerCase();return p.some(E=>S===E)}}),define(Q[31],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Q[196],J([0,1,27,66,70,20,7,43,82,21,3,8,31,63,10,24,16]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function P(t,i){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],a=new Map,h=new Map,f=2e4;function g(U,B,X,te){const oe=B.substring(U.length+1);return new Promise(async W=>{var $,z,N;let H;try{H=await(0,M.readdir)(B,{withFileTypes:!0})}catch(A){W();return}if(te.count>=f){te.count+=H.length,te.maxReached=!0,W();return}let V=H.length;if(V===0){W();return}let _=H;te.count+H.length>f&&(te.maxReached=!0,V=f-te.count,_=H.slice(0,V)),te.count+=H.length;for(const A of _)if(A.isDirectory()){if(X.includes(A.name)||await g(U,(0,I.join)(B,A.name),X,te),--V==0){W();return}}else{const O=A.name.lastIndexOf(".");if(O>=0){const D=A.name.substring(O+1);D&&a.set(D,(($=a.get(D))!==null&&$!==void 0?$:0)+1)}for(const D of s)((z=D.relativePathPattern)===null||z===void 0?void 0:z.test(oe))!==!1&&D.filePattern.test(A.name)&&h.set(D.tag,((N=h.get(D.tag))!==null&&N!==void 0?N:0)+1);if(--V==0){W();return}}})}const k={count:0,maxReached:!1};await g(t,t,i,k);const T=await l(t);return{configFiles:o(h),fileTypes:o(a),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=P;function o(t){return[...b.Iterable.map(t.entries(),([i,s])=>({name:i,count:s}))].sort((i,s)=>s.count-i.count)}function u(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},i=v.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=u;function l(t){let i=new Map,s=(0,I.join)(t,".vscode","launch.json");return new Promise((a,h)=>{(0,y.exists)(s,f=>{if(f)(0,y.readFile)(s,(g,k)=>{if(g)return a([]);const T=[],U=(0,r.parse)(k.toString(),T);if(T.length)return console.log(`Unable to parse ${s}`),a([]);if((0,r.getNodeType)(U)==="object"&&U.configurations)for(const B of U.configurations){const X=B.type;X&&(i.has(X)?i.set(X,i.get(X)+1):i.set(X,1))}return a(o(i))});else return a([])})})}e.collectLaunchConfigs=l;let c=class{constructor(i,s){this.telemetryService=i,this.productService=s}formatMachineInfo(i){const s=[];return s.push(`OS Version:       ${i.os}`),s.push(`CPUs:             ${i.cpus}`),s.push(`Memory (System):  ${i.memory}`),s.push(`VM:               ${i.vmHint}`),s.join(`
`)}formatEnvironment(i){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const a=v.cpus();return a&&a.length>0&&s.push(`CPUs:             ${a[0].model} (${a.length} x ${a[0].speed})`),s.push(`Memory (System):  ${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||s.push(`Load (avg):       ${v.loadavg().map(h=>Math.round(h)).join(", ")}`),s.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${i.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(i,s){return Promise.all([(0,w.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async a=>{let[h,f]=a,g=this.formatProcessList(i,h);return s.forEach(k=>{if((0,L.isRemoteDiagnosticError)(k))g+=`
${k.errorMessage}`,f+=`
${k.errorMessage}`;else if(g+=`

Remote: ${k.hostName}`,k.processes&&(g+=`
${this.formatProcessList(i,k.processes)}`),k.workspaceMetadata){f+=`
|  Remote: ${k.hostName}`;for(const T of Object.keys(k.workspaceMetadata)){const U=k.workspaceMetadata[T];let B=`${U.fileCount} files`;U.maxFilesReached&&(B=`more than ${B}`),f+=`|    Folder (${T}): ${B}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:g,workspaceInfo:f}})}async getSystemInfo(i,s){const{memory:a,vmHint:h,os:f,cpus:g}=u(),k={os:f,memory:a,cpus:g,vmHint:h,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:s};return n.isWindows||(k.load=`${v.loadavg().map(T=>Math.round(T)).join(", ")}`),n.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(i,s){const a=[];return(0,w.listProcesses)(i.mainPID).then(async h=>(a.push(""),a.push(this.formatEnvironment(i)),a.push(""),a.push(this.formatProcessList(i,h)),i.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(a.push(""),a.push("Workspace Stats: "),a.push(await this.formatWorkspaceMetadata(i))),s.forEach(f=>{if((0,L.isRemoteDiagnosticError)(f))a.push(`
${f.errorMessage}`);else if(a.push(`

`),a.push(`Remote:           ${f.hostName}`),a.push(this.formatMachineInfo(f.machineInfo)),f.processes&&a.push(this.formatProcessList(i,f.processes)),f.workspaceMetadata)for(const g of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[g];let T=`${k.fileCount} files`;k.maxFilesReached&&(T=`more than ${T}`),a.push(`Folder (${g}): ${T}`),a.push(this.formatWorkspaceStats(k))}}),a.push(""),a.push(""),a.join(`
`)))}formatWorkspaceStats(i){const s=[],a=60;let h=0;const f=(U,B)=>{const X=` ${U}(${B})`;h+X.length>a?(s.push(g),g="|                 ",h=g.length):h+=X.length,g+=X};let g="|      File types:";const k=10;let T=i.fileTypes.length>k?k:i.fileTypes.length;for(let U=0;U<T;U++){const B=i.fileTypes[U];f(B.name,B.count)}if(s.push(g),i.configFiles.length>=0&&(g="|      Conf files:",h=0,i.configFiles.forEach(U=>{f(U.name,U.count)}),s.push(g)),i.launchConfigFiles.length>0){let U="|      Launch Configs:";i.launchConfigFiles.forEach(B=>{U+=B.count>1?` ${B.name}(${B.count})`:` ${B.name}`}),s.push(U)}return s.join(`
`)}expandGPUFeatures(i){const s=Math.max(...Object.keys(i).map(a=>a.length));return Object.keys(i).map(a=>`${a}:  ${" ".repeat(s-a.length)}  ${i[a]}`).join(`
                  `)}formatWorkspaceMetadata(i){const s=[],a=[];return i.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(s.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const g=S.URI.revive(f);if(g.scheme===d.Schemas.file){const k=g.fsPath;a.push(P(k,["node_modules",".git"]).then(T=>{let U=`${T.fileCount} files`;T.maxFilesReached&&(U=`more than ${U}`),s.push(`|    Folder (${(0,I.basename)(k)}): ${U}`),s.push(this.formatWorkspaceStats(T))}).catch(T=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${T.toString()})`)}))}else s.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(a).then(h=>s.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(i,s){const a=new Map;i.windows.forEach(f=>a.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(i.mainPID,a,h,s,0),h.join(`
`)}formatProcessItem(i,s,a,h,f){const g=f===0;let k;g?k=h.pid===i?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(k=`${k} (${s.get(h.pid)})`));const T=process.platform==="win32"?h.mem:v.totalmem()*(h.mem/100);a.push(`${h.load.toFixed(0).padStart(5," ")}	${(T/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(h.children)&&h.children.forEach(U=>this.formatProcessItem(i,s,a,U,f+1))}async reportWorkspaceStats(i){for(const{uri:s}of i.folders){const a=S.URI.revive(s);if(a.scheme===d.Schemas.file){const h=a.fsPath;try{const f=await P(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),f.fileTypes.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),f.launchConfigFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})}),f.configFiles.forEach(g=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:g.name,count:g.count})})}catch(f){}}}}};c=ce([ee(0,E.ITelemetryService),ee(1,p.IProductService)],c),e.DiagnosticsService=c}),define(Q[197],J([0,1,19,167,170,44,31,49,161,53,26,6,24,8,21,95,192,4,15]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var u;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished"})(u||(u={}));function l(..._){return String(_.reduce((A,O)=>A|O,0))}var c;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(c||(c={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:u.None,criteria:[],assetTypes:[]};class h{constructor(A=a){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,O=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:A,pageSize:O}))}withFilter(A,...O){const D=[...this.state.criteria,...O.length?O.map(F=>({filterType:A,value:F})):[{filterType:A}]];return new h(Object.assign(Object.assign({},this.state),{criteria:D}))}withSortBy(A){return new h(Object.assign(Object.assign({},this.state),{sortBy:A}))}withSortOrder(A){return new h(Object.assign(Object.assign({},this.state),{sortOrder:A}))}withFlags(...A){return new h(Object.assign(Object.assign({},this.state),{flags:A.reduce((O,D)=>O|D,0)}))}withAssetTypes(...A){return new h(Object.assign(Object.assign({},this.state),{assetTypes:A}))}get raw(){const{criteria:A,pageNumber:O,pageSize:D,sortBy:F,sortOrder:C,flags:K,assetTypes:G}=this.state;return{filters:[{criteria:A,pageNumber:O,pageSize:D,sortBy:F,sortOrder:C}],assetTypes:G,flags:K}}get searchText(){const A=this.state.criteria.filter(O=>O.filterType===c.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(_,A){const O=(_||[]).filter(D=>D.statisticName===A)[0];return O?O.value:0}function g(_){const A="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(D=>D.assetType.indexOf(A)===0).reduce((D,F)=>{const C=B(_,F.assetType);return C&&D.push([F.assetType.substring(A.length),C]),D},[])}function k(_){if(_.properties){const A=_.properties.filter(F=>F.key===t.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),D=A.filter(F=>O.test(F.value))[0];return D?{uri:D.value,fallbackUri:D.value}:null}return B(_,t.Repository)}function T(_){return{uri:`${_.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${_.fallbackAssetUri}/${t.VSIX}`}}function U(_){const A=B(_,t.Icon);if(A)return A;const O=R.DefaultIconPath;return{uri:O,fallbackUri:O}}function B(_,A){return _.files.filter(D=>D.assetType===A)[0]?{uri:`${_.assetUri}/${A}`,fallbackUri:`${_.fallbackAssetUri}/${A}`}:null}function X(_,A){const O=_.properties?_.properties.filter(F=>F.key===A):[],D=O.length>0&&O[0].value;return D?D.split(",").map(F=>(0,L.adoptToGalleryExtensionId)(F)):[]}function te(_){const A=_.properties?_.properties.filter(O=>O.key===i.Engine):[];return A.length>0&&A[0].value||""}function oe(_){const A=_.properties?_.properties.filter(D=>D.key===i.LocalizedLanguages):[],O=A.length>0&&A[0].value||"";return O?O.split(","):[]}function W(_){return _.indexOf("preview")!==-1}function $(_){const A=_.properties?_.properties.find(O=>O.key===i.WebExtension):void 0;return!!A&&A.value==="true"}function z(_){return _.files.some(A=>A.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,o.joinPath)(b.URI.parse(_.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function N(_,A,O,D,F){const C={manifest:B(A,t.Manifest),readme:B(A,t.Details),changelog:B(A,t.Changelog),license:B(A,t.License),repository:k(A),download:T(A),icon:U(A),coreTranslations:g(A)};return{identifier:{id:(0,L.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:A.version,date:A.lastUpdated,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,description:_.shortDescription||"",installCount:f(_.statistics,"install"),rating:f(_.statistics,"averagerating"),ratingCount:f(_.statistics,"ratingcount"),assetUri:b.URI.parse(A.assetUri),webResource:z(A),assetTypes:A.files.map(({assetType:K})=>K),assets:C,properties:{dependencies:X(A,i.Dependency),extensionPack:X(A,i.ExtensionPack),engine:te(A),localizedLanguages:oe(A),webExtension:$(A)},telemetryData:{index:(D.pageNumber-1)*D.pageSize+O,querySource:F},preview:W(_.flags)}}let H=class{constructor(A,O,D,F,C,K,G){this.requestService=A,this.logService=O,this.environmentService=D,this.telemetryService=F,this.fileService=C,this.productService=K;const Y=K.extensionsGallery;this.extensionsGalleryUrl=Y&&Y.serviceUrl,this.extensionsControlUrl=Y&&Y.controlUrl,this.commonHeadersPromise=V(K.version,this.environmentService,this.fileService,G)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,O){const D=[];let{total:F,firstPage:C,getPage:K}=await this.query({names:A,pageSize:A.length},O);D.push(...C);for(let G=1;D.length<F&&(C=await K(G,O),C.length);G++)D.push(...C);return D}async getCompatibleExtension(A,O){const D=await this.getCompatibleExtensionByEngine(A,O);return(D==null?void 0:D.properties.webExtension)?D.webResource?D:null:D}async getCompatibleExtensionByEngine(A,O){const D=(0,R.isIExtensionIdentifier)(A)?null:A;if(D&&D.properties.engine&&(0,w.isEngineValid)(D.properties.engine,this.productService.version))return D;const{id:F,uuid:C}=D?D.identifier:A;let K=new h().withFlags(u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");C?K=K.withFilter(c.ExtensionId,C):K=K.withFilter(c.ExtensionName,F);const{galleryExtensions:G}=await this.queryGallery(K,n.CancellationToken.None),[Y]=G;if(!Y||!Y.versions.length)return null;if(O){const re=Y.versions.filter(se=>se.version===O)[0];if(re){const se=N(Y,re,0,K);if(se.properties.engine&&(0,w.isEngineValid)(se.properties.engine,this.productService.version))return se}return null}const Z=await this.getLastValidExtensionVersion(Y,Y.versions);return Z?N(Y,Z,0,K):null}async query(A,O){const D=n.CancellationToken.isCancellationToken(A)?{}:A,F=n.CancellationToken.isCancellationToken(A)?A:O;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let C=D.text||"";const K=(0,y.getOrDefault)(D,x=>x.pageSize,50);let G=new h().withFlags(u.IncludeLatestVersionOnly,u.IncludeAssetUri,u.IncludeStatistics,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,K).withFilter(c.Target,"Microsoft.VisualStudio.Code");C?(C=C.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Category,ue||ne),"")),C=C.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(x,ne,ue)=>(G=G.withFilter(c.Tag,ue||ne),"")),C=C.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(c.Featured),"")),C=C.trim(),C&&(C=C.length<200?C:C.substring(0,200),G=G.withFilter(c.SearchText,C)),G=G.withSortBy(0)):D.ids?G=G.withFilter(c.ExtensionId,...D.ids):D.names?G=G.withFilter(c.ExtensionName,...D.names):G=G.withSortBy(4),typeof D.sortBy=="number"&&(G=G.withSortBy(D.sortBy)),typeof D.sortOrder=="number"&&(G=G.withSortOrder(D.sortOrder));const{galleryExtensions:Y,total:Z}=await this.queryGallery(G,F),re=Y.map((x,ne)=>N(x,x.versions[0],ne,G,D.source)),se=async(x,ne)=>{if(ne.isCancellationRequested)throw(0,v.canceled)();const ue=G.withPage(x+1),{galleryExtensions:be}=await this.queryGallery(ue,ne);return be.map((me,Ee)=>N(me,me.versions[0],Ee,ue,D.source))};return{firstPage:re,total:Z,pageSize:G.pageSize,getPage:se}}async queryGallery(A,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,u.ExcludeNonValidated).withFilter(c.ExcludeWithFlags,l(u.Unpublished));const D=await this.commonHeadersPromise,F=JSON.stringify(A.raw),C=Object.assign(Object.assign({},D),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(F.length)}),K=new Date().getTime();let G,Y,Z=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:F,headers:C},O),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:Z};const re=await(0,r.asJson)(G);if(re){const se=re.results[0],x=se.extensions,ne=se.resultMetadata&&se.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return Z=ne&&ne.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:x,total:Z}}return{galleryExtensions:[],total:Z}}catch(re){throw Y=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},A.telemetryData),{requestBodySize:String(F.length),duration:new Date().getTime()-K,success:!!G&&(0,r.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:Y?(0,v.isPromiseCanceledError)(Y)?"canceled":(0,v.getErrorMessage)(Y).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Z)}))}}async reportStatistic(A,O,D,F){if(!!this.isEnabled()){const C=await this.commonHeadersPromise,K=Object.assign(Object.assign({},C),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${A}/extensions/${O}/${D}/stats?statType=${F}`),headers:K},n.CancellationToken.None)}catch(G){}}}async download(A,O,D){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const F=(0,L.getGalleryExtensionTelemetryData)(A),C=new Date().getTime(),K=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},F),{duration:re})),G=D===1?"install":D===2?"update":"",Y=G?{uri:`${A.assets.download.uri}&${G}=true`,fallbackUri:`${A.assets.download.fallbackUri}?${G}=true`}:A.assets.download,Z=await this.getAsset(Y);await this.fileService.writeFile(O,Z.stream),K(new Date().getTime()-C)}async getReadme(A,O){if(A.assets.readme){const D=await this.getAsset(A.assets.readme,{},O);return await(0,r.asText)(D)||""}return""}async getManifest(A,O){if(A.assets.manifest){const D=await this.getAsset(A.assets.manifest,{},O),F=await(0,r.asText)(D);return F?JSON.parse(F):null}return null}async getCoreTranslation(A,O){const D=A.assets.coreTranslations.filter(F=>F[0]===O.toUpperCase())[0];if(D){const F=await this.getAsset(D[1]),C=await(0,r.asText)(F);return C?JSON.parse(C):null}return null}async getChangelog(A,O){if(A.assets.changelog){const D=await this.getAsset(A.assets.changelog,{},O);return await(0,r.asText)(D)||""}return""}async getAllVersions(A,O){let D=new h().withFlags(u.IncludeVersions,u.IncludeFiles,u.IncludeVersionProperties).withPage(1,1).withFilter(c.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?D=D.withFilter(c.ExtensionId,A.identifier.uuid):D=D.withFilter(c.ExtensionName,A.identifier.id);const F=[],{galleryExtensions:C}=await this.queryGallery(D,n.CancellationToken.None);return C.length&&(O?await Promise.all(C[0].versions.map(async K=>{let G;try{G=await this.getEngine(K)}catch(Y){}G&&(0,w.isEngineValid)(G,this.productService.version)&&F.push({version:K.version,date:K.lastUpdated})})):F.push(...C[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),F}async getAsset(A,O={},D=n.CancellationToken.None){const F=await this.commonHeadersPromise,C={type:"GET"},K=Object.assign(Object.assign({},F),O.headers||{});O=Object.assign(Object.assign(Object.assign({},O),C),{headers:K});const G=A.uri,Y=A.fallbackUri,Z=Object.assign(Object.assign({},O),{url:G});try{const re=await this.requestService.request(Z,D);if(re.res.statusCode===200)return re;const se=await(0,r.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${se}`)}catch(re){if((0,v.isPromiseCanceledError)(re))throw re;const se=(0,v.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:se});const x=Object.assign(Object.assign({},O),{url:Y});return this.requestService.request(x,D)}}async getLastValidExtensionVersion(A,O){const D=this.getLastValidExtensionVersionFromProperties(A,O);return D||this.getLastValidExtensionVersionRecursively(A,O)}getLastValidExtensionVersionFromProperties(A,O){for(const D of O){const F=te(D);if(!F)return null;if((0,w.isEngineValid)(F,this.productService.version))return D}return null}async getEngine(A){const O=te(A);if(O)return O;const D=B(A,t.Manifest);if(!D)throw new Error("Manifest was not found");const F={"Accept-Encoding":"gzip"},C=await this.getAsset(D,{headers:F}),K=await(0,r.asJson)(C);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(A,O){if(!O.length)return null;const D=O[0],F=await this.getEngine(D);return(0,w.isEngineValid)(F,this.productService.version)?(D.properties=D.properties||[],D.properties.push({key:i.Engine,value:F}),D):this.getLastValidExtensionVersionRecursively(A,O.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await(0,r.asJson)(A),D=new Map;if(O)for(const F of O.malicious){const C=D.get(F)||{id:{id:F},malicious:!0,slow:!1};C.malicious=!0,D.set(F,C)}return[...D.values()]}};H=ce([ee(0,r.IRequestService),ee(1,S.ILogService),ee(2,p.IEnvironmentService),ee(3,I.ITelemetryService),ee(4,E.IFileService),ee(5,d.IProductService),ee(6,(0,P.optional)(m.IStorageService))],H),e.ExtensionGalleryService=H;async function V(_,A,O,D){const F={"X-Market-Client-Id":`VSCode ${_}`,"User-Agent":`VSCode ${_}`},C=await(0,M.getServiceMachineId)(A,O,D);return F["X-Market-User-Id"]=C,F}e.resolveMarketplaceHeaders=V}),define(Q[198],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(y){this.appender=y}listen(y,I){throw new Error(`Event not found: ${I}`)}call(y,I,{eventName:r,data:w}){return this.appender.log(r,w),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(y){this.channel=y}log(y,I){return this.channel.call("log",{eventName:y,data:I}).then(void 0,r=>`Failed to log telemetry: ${console.warn(r)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(Q[199],J([0,1,47,146,22,4,17,48,2,44,37]),function(j,e,v,R,L,y,I,r,w,p,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new w.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let M of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(M),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(M=>{const P=/^[a-f0-9]+$/i.test(M["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!P})}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const m=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,M=d["common.instanceId"],P=d["common.machineId"],o=d["common.firstSessionDate"],u=d["common.msftInternal"];return{sessionId:m,instanceId:M,machineId:P,firstSessionDate:o,msftInternal:u}}dispose(){this._disposables.dispose()}publicLog(d,m,M){return this.isOptedIn?this._commonProperties.then(P=>{m=(0,p.mixin)(m,P),m=(0,p.mixin)(m,this._experimentProperties),m=(0,p.cloneAndChange)(m,o=>{if(typeof o=="string")return this._cleanupInfo(o,M)}),this._appender.log(d,m)},P=>{console.error(P)}):Promise.resolve(void 0)}publicLog2(d,m,M){return this.publicLog(d,m,M)}publicLogError(d,m){return this.sendErrorTelemetry?this.publicLog(d,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_cleanupInfo(d,m){let M=d;if(m){const P=[];for(let c of this._cleanupPatterns)for(;;){const t=c.exec(d);if(!t)break;P.push([t.index,c.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(M="";;){const c=u.exec(d);if(!c)break;!o.test(c[0])&&P.every(([t,i])=>c.index<t||c.index>=i)&&(M+=d.substring(l,c.index)+"<REDACTED: user-file-path>",l=u.lastIndex)}l<d.length&&(M+=d.substr(l))}for(let P of this._cleanupPatterns)M=M.replace(P,"");return M}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ce([ee(1,(0,y.optional)(I.IConfigurationService))],S),e.TelemetryService=S;const E="telemetry";n.Registry.as(r.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,R.localize)(2,null,v.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[96],J([0,1,17,44,13,9]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,m){return Promise.resolve(void 0)}publicLog2(d,m){return this.publicLog(d,m)}publicLogError(d,m){return Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(m,M,P){}async publicLogError(m,M,P){}}e.NullEndpointTelemetryService=I;function r(...d){return{log:(m,M)=>d.forEach(P=>P.log(m,M)),flush:()=>y.Promises.settled(d.map(m=>m.flush()))}}e.combinedAppender=r,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function w(d,m){return m.onDidChangeConfiguration(M=>{M.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(M.source),configurationKeys:E(M.sourceConfig)})})}e.configurationTelemetry=w;function p(d){const m=Object.create(null),M=Object.create(null),P=Object.create(null);S(d,P);for(let o in P){o=o.length>150?o.substr(o.length-149):o;const u=P[o];typeof u=="number"?M[o]=u:typeof u=="boolean"?M[o]=u?1:0:typeof u=="string"?m[o]=u.substring(0,1023):typeof u!="undefined"&&u!==null&&(m[o]=u)}return{properties:m,measurements:M}}e.validateTelemetryData=p;function n(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(P=>{d.indexOf(`${P}+`)===0&&(m=P)}),m}e.cleanRemoteAuthority=n;function S(d,m,M=0,P){if(!!d)for(let o of Object.getOwnPropertyNames(d)){const u=d[o],l=P?P+o:o;Array.isArray(u)?m[l]=(0,R.safeStringify)(u):u instanceof Date?m[l]=u.toISOString():(0,L.isObject)(u)?M<2?S(u,m,M+1,l+"."):m[l]=(0,R.safeStringify)(u):m[l]=u}}function E(d){if(!d)return[];const m=[];return b(m,"",d),m}function b(d,m,M){M&&typeof M=="object"&&!Array.isArray(M)?Object.keys(M).forEach(P=>b(d,m?`${m}.${P}`:P,M[P])):d.push(m)}}),define(Q[200],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Q[201],J([0,1,4,2,37,5,200,107]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var w;(function(M){function P(o){return o&&typeof o=="object"&&typeof o.id=="string"}M.isThemeColor=P})(w=e.ThemeColor||(e.ThemeColor={}));function p(M){return{id:M}}e.themeColorFromId=p;var n;(function(M){function P(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||w.isThemeColor(t.color))}M.isThemeIcon=P;const o=new RegExp(`^\\$\\((${r.CSSIcon.iconNameExpression}(?:${r.CSSIcon.iconModifierExpression})?)\\)$`);function u(t){const i=o.exec(t);if(!!i){let[,s]=i;return{id:s}}}M.fromString=u;function l(t,i){let s=t.id;const a=s.lastIndexOf("~");return a!==-1&&(s=s.substring(0,a)),i&&(s=`${s}~${i}`),{id:s}}M.modify=l;function c(t,i){var s,a;return t.id===i.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((a=i.color)===null||a===void 0?void 0:a.id)}M.isEqual=c,M.asClassNameArray=r.CSSIcon.asClassNameArray,M.asClassName=r.CSSIcon.asClassName,M.asCSSSelector=r.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=r.Codicon.file,e.FolderThemeIcon=r.Codicon.folder;function S(M){switch(M){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=S,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new y.Emitter}onColorThemeChange(P){return this.themingParticipants.push(P),this.onThemingParticipantAddedEmitter.fire(P),(0,R.toDisposable)(()=>{const o=this.themingParticipants.indexOf(P);this.themingParticipants.splice(o,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new E;L.Registry.add(e.Extensions.ThemingContribution,b);function d(M){return b.onColorThemeChange(M)}e.registerThemingParticipant=d;class m extends R.Disposable{constructor(P){super();this.themeService=P,this.theme=P.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(o=>this.onThemeChange(o)))}onThemeChange(P){this.theme=P,this.updateStyles()}updateStyles(){}getColor(P,o){let u=this.theme.getColor(P);return u&&o&&(u=o(u,this.theme)),u?u.toString():null}}e.Themable=m}),define(Q[60],J([0,1,14,3,38,4]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const I="#FFFFFF",r="#1E1E1E",w="#000000",p="theme",n="themeBackground",S="windowSplash";e.IThemeMainService=(0,y.createDecorator)("themeMainService");let E=class{constructor(d){this.stateMainService=d}getBackgroundColor(){if((R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme)return w;let d=this.stateMainService.getItem(n,null);if(!d){let m;(R.isWindows||R.isMacintosh)&&v.nativeTheme.shouldUseInvertedColorScheme?m="hc-black":m=this.stateMainService.getItem(p,"vs-dark").split(" ")[0],d=m==="hc-black"?w:m==="vs"?I:r}return R.isMacintosh&&d.toUpperCase()===r&&(d="#171717"),d}saveWindowSplash(d,m){this.stateMainService.setItems([{key:p,data:m.baseTheme},{key:n,data:m.colorInfo.background},{key:S,data:m}]),typeof d=="number"&&this.updateBackgroundColor(d,m)}updateBackgroundColor(d,m){for(const M of v.BrowserWindow.getAllWindows())if(M.id===d){M.setBackgroundColor(m.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(S)}};E=ce([ee(0,L.IStateMainService)],E),e.ThemeMainService=E}),define(Q[40],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(y){y.Uninitialized="uninitialized",y.Idle="idle",y.CheckingForUpdates="checking for updates",y.AvailableForDownload="available for download",y.Downloading="downloading",y.Downloaded="downloaded",y.Updating="updating",y.Ready="ready"})(R=e.StateType||(e.StateType={}));var L;(function(y){y[y.Setup=0]="Setup",y[y.Archive=1]="Archive",y[y.Snap=2]="Snap"})(L=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(y,I)=>({type:"idle",updateType:y,error:I}),CheckingForUpdates:y=>({type:"checking for updates",explicit:y}),AvailableForDownload:y=>({type:"available for download",update:y}),Downloading:y=>({type:"downloading",update:y}),Downloaded:y=>({type:"downloaded",update:y}),Updating:y=>({type:"updating",update:y}),Ready:y=>({type:"ready",update:y})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(Q[202],J([0,1,37,48,147,3]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:y.isWindows&&!y.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[203],J([0,1,5,40]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class L{constructor(r){this.service=r}listen(r,w){switch(w){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"checkForUpdates":return this.service.checkForUpdates(p);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${w}`)}}e.UpdateChannel=L;class y{constructor(r){this.channel=r,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(w=>this.state=w),this.channel.call("_getInitialState").then(w=>this.state=w)}get state(){return this._state}set state(r){this._state=r,this._onStateChange.fire(r)}checkForUpdates(r){return this.channel.call("checkForUpdates",r)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=y}),define(Q[97],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(Q[204],J([0,1,8]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(r){this.handler=r}listen(r,w){throw new Error(`Event not found: ${w}`)}call(r,w,p){switch(w){case"handleURL":return this.handler.handleURL(v.URI.revive(p[0]),p[1])}throw new Error(`Call not found: ${w}`)}}e.URLHandlerChannel=R;class L{constructor(r){this.channel=r}handleURL(r,w){return this.channel.call("handleURL",[r.toJSON(),w])}}e.URLHandlerChannelClient=L;class y{constructor(r){this.next=r}async routeCall(r,w,p,n){if(w!=="handleURL")throw new Error(`Call not found: ${w}`);if(p){const S=v.URI.revive(p);if(S&&S.query){const E=/\bwindowId=(\d+)/.exec(S.query);if(E){const b=E[1],d=new RegExp(`window:${b}`),m=r.connections.find(M=>d.test(M.ctx));if(m)return m}}}return this.next.routeCall(r,w,p,n)}routeEvent(r,w){throw new Error(`Event not found: ${w}`)}}e.URLHandlerRouter=y}),define(Q[205],J([0,1,8,9,2,21]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class I extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(p,n){const S=[...this.handlers.values()];return(0,R.first)(S.map(E=>()=>E.handleURL(p,n)),void 0,!1).then(E=>E||!1)}registerHandler(p){return this.handlers.add(p),(0,L.toDisposable)(()=>this.handlers.delete(p))}}e.AbstractURLService=I;let r=class extends I{constructor(p){super();this.productService=p}create(p){let{authority:n,path:S,query:E,fragment:b}=p||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return n&&S&&S.indexOf("/")!==0&&(S=`/${S}`),v.URI.from({scheme:this.productService.urlProtocol,authority:n,path:S,query:E,fragment:b})}};r=ce([ee(0,y.IProductService)],r),e.NativeURLService=r}),define(Q[206],J([0,1,5,14,8,2,3,9]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function w(n){try{return L.URI.parse(n)}catch(S){return null}}class p{constructor(S,E,b,d,m){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=y.Disposable.None,this.disposables=new y.DisposableStore,this.uris=S,I.isWindows){const o=d.isBuilt?[]:[`"${d.appRoot}"`];o.push("--open-url","--"),R.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,o)}const M=v.Event.map(v.Event.fromNodeEventEmitter(R.app,"open-url",(o,u)=>({event:o,url:u})),({event:o,url:u})=>(o.preventDefault(),u));this.disposables.add(M(o=>{const u=w(o);!u||this.urlService.open(u,{originalUrl:o})})),b.getWindows().filter(o=>o.isReady).length>0?this.flush():v.Event.once(b.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const S=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||S.push(E);S.length!==0&&(this.uris=S,this.flushDisposable=(0,r.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=p}),define(Q[76],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.webviewPartitionId=e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService"),e.webviewPartitionId="webview"}),define(Q[207],J([0,1,14,2,10,8,76]),function(j,e,v,R,L,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class r extends R.Disposable{constructor(){super();const p=v.session.fromPartition(I.webviewPartitionId),n=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n),p.protocol.registerFileProtocol(L.Schemas.vscodeWebview,n)}async handleWebviewRequest(p,n){try{const S=y.URI.parse(p.url),E=r.validWebviewFilePaths.get(S.path);if(typeof E=="string"){const b=S.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${E}`:`vs/workbench/contrib/webview/browser/pre/${E}`,d=L.FileAccess.asFileUri(b,j);return n(decodeURIComponent(d.fsPath))}}catch(S){}n({error:-10})}}e.WebviewProtocolProvider=r,r.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/electron-browser-index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"],["/service-worker.js","service-worker.js"]])}),define(Q[61],J([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(p){return!!p.workspaceUri}e.isWorkspaceToOpen=R;function L(p){return!!p.folderUri}e.isFolderToOpen=L;function y(p){return!!p.fileUri}e.isFileToOpen=y;function I(p){const n=r(p),S=p.getValue("window.menuBarVisibility");return S==="default"||n==="native"&&S==="compact"||v.isMacintosh&&v.isNative?"classic":S}e.getMenuBarVisibility=I;function r(p){if(v.isWeb)return"custom";const n=p.getValue("window");if(n){if(v.isMacintosh&&n.nativeTabs===!0||v.isMacintosh&&n.nativeFullScreen===!1)return"native";const b=n.titleBarStyle;if(b==="native"||b==="custom")return b}return v.isLinux?"native":"custom"}e.getTitleBarStyle=r;function w(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=w}),define(Q[34],J([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const L=function(r=1){return{width:1024,height:768,mode:r}};e.defaultWindowState=L;var y;(function(r){r[r.Maximized=0]="Maximized",r[r.Normal=1]="Normal",r[r.Minimized=2]="Minimized",r[r.Fullscreen=3]="Fullscreen"})(y=e.WindowMode||(e.WindowMode={}));var I;(function(r){r[r.UNRESPONSIVE=1]="UNRESPONSIVE",r[r.CRASHED=2]="CRASHED",r[r.LOAD=3]="LOAD"})(I=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(Q[208],J([0,1,14,2,74,76,207,34]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends R.Disposable{constructor(n,S){super();this.windowsMainService=S,this._register(new I.WebviewProtocolProvider);const E=v.session.fromPartition(y.webviewPartitionId);E.setPermissionRequestHandler((b,d,m)=>m(d==="clipboard-read")),E.setPermissionCheckHandler((b,d)=>d==="clipboard-read")}async setIgnoreMenuShortcuts(n,S){let E;if(typeof n.windowId=="number"){const{windowId:b}=n,d=this.windowsMainService.getWindowById(b);if(!(d==null?void 0:d.win))throw new Error(`Invalid windowId: ${b}`);E=d.win.webContents}else{const{webContentsId:b}=n;if(E=v.webContents.fromId(b),!E)throw new Error(`Invalid webContentsId: ${b}`)}E.isDestroyed()||E.setIgnoreMenuShortcuts(S)}};w=ce([ee(0,L.ITunnelService),ee(1,r.IWindowsMainService)],w),e.WebviewMainService=w}),define(Q[209],J([0,1,5,2,9]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class y extends R.Disposable{constructor({onDidOpenWindow:r,onDidFocusWindow:w,getActiveWindowId:p}){super();this.disposables=this._register(new R.DisposableStore),v.Event.latch(v.Event.any(r,w))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,L.createCancelablePromise)(()=>p()),(async()=>{try{const S=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:S}catch(S){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(r){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=r}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=y}),define(Q[210],J([0,1,8,15,4,36]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,L.createDecorator)("contextService");var I;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function r(E){const b=E;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=r;function w(E){const b=E;return!!(b&&typeof b=="object"&&v.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=w;class p{constructor(b,d,m,M){this._id=b,this._configuration=m,this._ignorePathCasing=M,this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(b){this._id=b.id,this._configuration=b.configuration,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=y.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=p;class n{constructor(b,d){this.raw=d,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,R.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function S(E){return new n({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=S}),define(Q[29],J([0,1,4,150,210,8,3,7,15,103,43,10,39,30,73]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function M(z){return(typeof z=="string"?(0,r.extname)(z):(0,w.extname)(z))===m}e.hasWorkspaceFileExtension=M,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function P(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=P;function o(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=o;function u(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=u;function l(z){const N=z;return typeof(N==null?void 0:N.id)=="string"&&y.URI.isUri(N.uri)}e.isSingleFolderWorkspaceIdentifier=l;function c(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=c;function t(z){const N=z;return typeof(N==null?void 0:N.id)=="string"&&y.URI.isUri(N.configPath)}e.isWorkspaceIdentifier=t;function i(z){const N=z;if(N==null?void 0:N.uri)return{id:N.id,uri:y.URI.revive(N.uri)};const H=z;if(H==null?void 0:H.configPath)return{id:H.id,configPath:y.URI.revive(H.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=i;function s(z,N){return w.extUriBiasedIgnorePathCase.isEqualOrParent(z,N.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function a(z){return h(z)||f(z)}e.isStoredWorkspaceFolder=a;function h(z){const N=z;return typeof(N==null?void 0:N.path)=="string"&&(!N.name||typeof N.name=="string")}e.isRawFileWorkspaceFolder=h;function f(z){const N=z;return typeof(N==null?void 0:N.uri)=="string"&&(!N.name||typeof N.name=="string")}e.isRawUriWorkspaceFolder=f;function g(z,N,H,V,_=!I.isWindows,A){if(z.scheme!==V.scheme)return{name:H,uri:z.toString(!0)};let O=N?void 0:A.relativePath(V,z);if(O!==void 0)O.length===0?O=".":I.isWindows&&z.scheme===S.Schemas.file&&!_&&(O=O.replace(/\//g,"\\"));else if(z.scheme===S.Schemas.file)O=z.fsPath,I.isWindows&&(O=(0,E.normalizeDriveLetter)(O),_&&(O=(0,b.toSlashes)(O)));else{if(!A.isEqualAuthority(z.authority,V.authority))return{name:H,uri:z.toString(!0)};O=z.path}return{name:H,path:O}}e.getStoredWorkspaceFolder=g;function k(z,N,H){let V=[],_=new Set;const A=H.dirname(N);for(let O of z){let D;if(h(O))O.path&&(D=H.resolvePath(A,O.path));else if(f(O))try{D=y.URI.parse(O.uri),D.path[0]!=="/"&&(D=D.with({path:"/"+D.path}))}catch(F){console.warn(F)}if(D){let F=H.getComparisonKey(D);if(!_.has(F)){_.add(F);const C=O.name||H.basenameOrAuthority(D);V.push(new L.WorkspaceFolder({uri:D,name:C,index:V.length},O))}}}return V}e.toWorkspaceFolders=k;function T(z,N,H,V,_){let A=U(N,z);const O=_.dirname(N),D=_.dirname(V),F=[],C=B(A.folders);for(const Z of A.folders){const re=h(Z)?_.resolvePath(O,Z.path):y.URI.parse(Z.uri);let se;H?se=!1:se=!h(Z)||(0,r.isAbsolute)(Z.path),F.push(g(re,se,Z.name,D,C,_))}const K={insertSpaces:!1,tabSize:4,eol:I.isLinux||I.isMacintosh?`
`:`\r
`},G=p.setProperty(z,["folders"],F,K);let Y=p.applyEdits(z,G);return A.remoteAuthority===(0,d.getRemoteAuthority)(V)&&(Y=p.applyEdits(Y,p.removeProperty(Y,["remoteAuthority"],K))),Y}e.rewriteWorkspaceFileForNewLocation=T;function U(z,N){let H=n.parse(N);if(H&&Array.isArray(H.folders))H.folders=H.folders.filter(V=>a(V));else throw new Error(`${z} looks like an invalid workspace file.`);return H}function B(z){return I.isWindows?z.some(N=>h(N)&&N.path.indexOf("/")>=0):!0}e.useSlashForPath=B;function X(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function te(z){return typeof z.folderUri=="string"}function oe(z){return typeof z.fileUri=="string"}function W(z,N){const H={workspaces:[],files:[]};if(z){const V=function(A,O){for(let D=0;D<A.length;D++)try{O(A[D],D)}catch(F){N.warn(`Error restoring recent entry ${JSON.stringify(A[D])}: ${F.toString()}. Skip entry.`)}},_=z;if(Array.isArray(_.entries))V(_.entries,A=>{const O=A.label,D=A.remoteAuthority;X(A)?H.workspaces.push({label:O,remoteAuthority:D,workspace:{id:A.workspace.id,configPath:y.URI.parse(A.workspace.configPath)}}):te(A)?H.workspaces.push({label:O,remoteAuthority:D,folderUri:y.URI.parse(A.folderUri)}):oe(A)&&H.files.push({label:O,remoteAuthority:D,fileUri:y.URI.parse(A.fileUri)})});else{const A=z;Array.isArray(A.workspaces3)&&V(A.workspaces3,(O,D)=>{const F=Array.isArray(A.workspaceLabels)&&A.workspaceLabels[D]||void 0;typeof O=="object"&&typeof O.id=="string"&&typeof O.configURIPath=="string"?H.workspaces.push({label:F,workspace:{id:O.id,configPath:y.URI.parse(O.configURIPath)}}):typeof O=="string"&&H.workspaces.push({label:F,folderUri:y.URI.parse(O)})}),Array.isArray(A.files2)&&V(A.files2,(O,D)=>{const F=Array.isArray(A.fileLabels)&&A.fileLabels[D]||void 0;typeof O=="string"&&H.files.push({label:F,fileUri:y.URI.parse(O)})})}}return H}e.restoreRecentlyOpened=W;function $(z){const N={entries:[]};for(const H of z.workspaces)o(H)?N.entries.push({folderUri:H.folderUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority}):N.entries.push({workspace:{id:H.workspace.id,configPath:H.workspace.configPath.toString()},label:H.label,remoteAuthority:H.remoteAuthority});for(const H of z.files)N.entries.push({fileUri:H.fileUri.toString(),label:H.label,remoteAuthority:H.remoteAuthority});return N}e.toStoreData=$}),define(Q[50],J([0,1,4,29]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function L(y){const I=y;return I&&(0,R.isWorkspaceIdentifier)(I.workspace)}e.isWorkspaceBackupInfo=L}),define(Q[51],J([0,1,4,14,9,38,3,7,65,16,13,133,29,39,2,80]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let M=class mt{constructor(o){this.stateMainService=o,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)}),u)}pickFolder(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFolders:!0,title:(0,S.localize)(1,null)}),u)}pickFile(o,u){return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:(0,S.localize)(2,null)}),u)}pickWorkspace(o,u){const l=(0,S.localize)(3,null),c=(0,b.mnemonicButtonLabel)((0,S.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},o),{pickFiles:!0,title:l,filters:t,buttonLabel:c}),u)}async doPick(o,u){const l={title:o.title,buttonLabel:o.buttonLabel,filters:o.filters};l.defaultPath=o.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof o.pickFiles=="boolean"||typeof o.pickFolders=="boolean")&&(l.properties=void 0,o.pickFiles&&o.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",o.pickFolders?"openDirectory":"openFile","createDirectory"]),I.isMacintosh&&l.properties.push("treatPackageAsDirectory");const c=u||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,n.withNullAsUndefined)(c));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,r.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(o){if(o){let u=this.windowDialogQueues.get(o.id);return u||(u=new L.Queue,this.windowDialogQueues.set(o.id,u)),u}else return this.noWindowDialogueQueue}showMessageBox(o,u){return this.getWindowDialogQueue(u).queue(async()=>u?R.dialog.showMessageBox(u,o):R.dialog.showMessageBox(o))}async showSaveDialog(o,u){const l=this.acquireFileDialogLock(o,u);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let c;return u?c=await R.dialog.showSaveDialog(u,o):c=await R.dialog.showSaveDialog(o),c.filePath=this.normalizePath(c.filePath),c})}finally{(0,d.dispose)(l)}}normalizePath(o){return o&&I.isMacintosh&&(o=(0,w.normalizeNFC)(o)),o}normalizePaths(o){return o.map(u=>this.normalizePath(u))}async showOpenDialog(o,u){o.defaultPath&&(await(0,p.exists)(o.defaultPath)||(o.defaultPath=void 0));const l=this.acquireFileDialogLock(o,u);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(u).queue(async()=>{let c;return u?c=await R.dialog.showOpenDialog(u,o):c=await R.dialog.showOpenDialog(o),c.filePaths=this.normalizePaths(c.filePaths),c})}finally{(0,d.dispose)(l)}}acquireFileDialogLock(o,u){if(!u)return d.Disposable.None;let l=this.windowFileDialogLocks.get(u.id);l||(l=new Set,this.windowFileDialogLocks.set(u.id,l));const c=(0,m.hash)(o);if(!l.has(c))return l.add(c),(0,d.toDisposable)(()=>{l==null||l.delete(c),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(u.id)})}};M.workingDirPickerStorageKey="pickerWorkingDir",M=ce([ee(0,y.IStateMainService)],M),e.DialogMainService=M}),define(Q[211],J([0,1,5,2,29]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class y extends R.Disposable{constructor(r,w){super();this.logService=r,this.storageMainService=w,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(r,w)=>(r?r.push(w):r=[w],r),y.STORAGE_CHANGE_DEBOUNCE_TIME)(r=>{r.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(r))}))}serializeGlobalStorageEvents(r){const w=new Map,p=new Set;return r.forEach(n=>{const S=this.storageMainService.globalStorage.get(n.key);typeof S=="string"?w.set(n.key,S):p.add(n.key)}),{changed:Array.from(w.entries()),deleted:Array.from(p.values())}}listen(r,w){switch(w){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${w}`)}async call(r,w,p){const n=(0,L.reviveIdentifier)(p.workspace),S=await this.withStorageInitialized(n);switch(w){case"getItems":return Array.from(S.items.entries());case"updateItems":{const E=p;if(E.insert)for(const[b,d]of E.insert)S.set(b,d);E.delete&&E.delete.forEach(b=>S.delete(b));break}case"close":{if(n)return S.close();break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(r){const w=r?this.storageMainService.workspaceStorage(r):this.storageMainService.globalStorage;try{await w.init()}catch(p){this.logService.error(`StorageIPC#init: Unable to init ${r?"workspace":"global"} storage due to ${p}`)}return w}}e.StorageDatabaseChannel=y,y.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[212],J([0,1,20,16,5,2,6,123,85,7,95,31,28,29]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends y.Disposable{constructor(o){super();this.logService=o,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new L.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new w.Storage(new w.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const o=await this.doCreate();this.storage.dispose(),this.storage=o,this._register(o.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(o);const u=o.getBoolean(n.IS_NEW_KEY);u===void 0?o.set(n.IS_NEW_KEY,!0):u&&o.set(n.IS_NEW_KEY,!1)}catch(o){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${o}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===I.LogLevel.Trace?o=>this.logService.trace(o):void 0,logError:o=>this.logService.error(o)}}doInit(o){return o.init()}get items(){return this.storage.items}get(o,u){return this.storage.get(o,u)}set(o,u){return this.storage.set(o,u)}delete(o){return this.storage.delete(o)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class m extends d{constructor(o,u,l){super(u);this.options=o,this.environmentService=l}async doCreate(){let o;return this.options.useInMemoryStorage?o=r.SQLiteStorageDatabase.IN_MEMORY_PATH:o=(0,p.join)(this.environmentService.globalStorageHome.fsPath,m.STORAGE_NAME),new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}))}async doInit(o){await super.doInit(o),this.updateTelemetryState(o)}updateTelemetryState(o){o.get(S.instanceStorageKey,void 0)===void 0&&o.set(S.instanceStorageKey,(0,E.generateUuid)()),o.get(S.firstSessionDateStorageKey,void 0)===void 0&&o.set(S.firstSessionDateStorageKey,new Date().toUTCString());const c=o.get(S.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();o.set(S.lastSessionDateStorageKey,typeof c=="undefined"?null:c),o.set(S.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=m,m.STORAGE_NAME="state.vscdb";class M extends d{constructor(o,u,l,c){super(l);this.workspace=o,this.options=u,this.environmentService=c}async doCreate(){const{storageFilePath:o,wasCreated:u}=await this.prepareWorkspaceStorageFolder();return new w.Storage(new r.SQLiteStorageDatabase(o,{logging:this.createLogginOptions()}),{hint:u?w.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:r.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const o=(0,p.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),u=(0,p.join)(o,M.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(o)?{storageFilePath:u,wasCreated:!1}:(await v.promises.mkdir(o,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(o),{storageFilePath:u,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(o){let u;if((0,b.isSingleFolderWorkspaceIdentifier)(this.workspace)?u={folder:this.workspace.uri.toString()}:(0,b.isWorkspaceIdentifier)(this.workspace)&&(u={workspace:this.workspace.configPath.toString()}),u)try{const l=(0,p.join)(o,M.WORKSPACE_META_NAME);await(0,R.exists)(l)||await(0,R.writeFile)(l,JSON.stringify(u,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=M,M.WORKSPACE_STORAGE_NAME="state.vscdb",M.WORKSPACE_META_NAME="workspace.json"}),define(Q[98],J([0,1,42,2,53,4,18,6,212]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,y.createDecorator)("storageMainService");let p=class extends R.Disposable{constructor(S,E,b){super();this.logService=S,this.environmentService=E,this.lifecycleMainService=b,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async S=>{S.workspace&&this.workspaceStorage(S.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(S=>{S.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)S.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const S=new w.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(S.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),S}createWorkspaceStorage(S){return new w.WorkspaceStorageMain(S,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(S){let E=this.mapWorkspaceToStorage.get(S.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${S.id})`),E=this.createWorkspaceStorage(S),this.mapWorkspaceToStorage.set(S.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${S.id})`),this.mapWorkspaceToStorage.delete(S.id)})),E}};p=ce([ee(0,r.ILogService),ee(1,L.IEnvironmentService),ee(2,I.ILifecycleMainService)],p),e.StorageMainService=p}),define(Q[99],J([0,1,8,29,15]),function(j,e,v,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function y(w,p,n){for(const E of w){const b=E.openedWorkspace;if((0,R.isWorkspaceIdentifier)(b)){const d=n(b);if(d){if(d.folders.some(m=>L.extUriBiasedIgnorePathCase.isEqualOrParent(p,m.uri)))return E}else if(L.extUriBiasedIgnorePathCase.isEqualOrParent(p,b.configPath))return E}}const S=w.filter(E=>(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqualOrParent(p,E.openedWorkspace.uri));if(S.length)return S.sort((E,b)=>-(E.openedWorkspace.uri.path.length-b.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=y;function I(w,p){for(const n of w)if((0,R.isWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.configPath,p)||(0,R.isSingleFolderWorkspaceIdentifier)(n.openedWorkspace)&&L.extUriBiasedIgnorePathCase.isEqual(n.openedWorkspace.uri,p))return n}e.findWindowOnWorkspaceOrFolder=I;function r(w,p){var n,S;const E=b=>p.some(d=>L.extUriBiasedIgnorePathCase.isEqual(v.URI.file(d),v.URI.file(b)));for(const b of w)if((S=(n=b.config)===null||n===void 0?void 0:n.extensionDevelopmentPath)===null||S===void 0?void 0:S.some(d=>E(d)))return b}e.findWindowOnExtensionDevelopmentPath=r}),define(Q[213],J([0,1,14,2,3,15,8,17,18,6,38,34,29]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let b=class vt extends R.Disposable{constructor(u,l,c,t,i){super();this.windowsMainService=u,this.stateMainService=l,this.lifecycleMainService=c,this.logService=t,this.configurationService=i,this._state=d(this.stateMainService.getItem(vt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(i=>!i.isExtensionDevelopmentHost)),t&&(u.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const c=M(u);this.stateMainService.setItem(vt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{var t;const i=(0,E.isWorkspaceIdentifier)(u.openedWorkspace)&&((t=c.workspace)===null||t===void 0?void 0:t.id)===u.openedWorkspace.id,s=(0,E.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(i||s)&&(c.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(u){return{workspace:(0,E.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const l=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((c==null?void 0:c.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(c==null?void 0:c.restoreFullscreen)),t&&L.isMacintosh&&this.windowsMainService.getWindows().some(i=>i.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(u){const l=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=u.workspace;if((0,E.isWorkspaceIdentifier)(h)){const g=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===h.id).map(k=>k.uiState);if(g.length)return g[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(h)){const g=this.state.openedWindows.filter(k=>k.folderUri&&y.extUriBiasedIgnorePathCase.isEqual(k.folderUri,h.uri)).map(k=>k.uiState);if(g.length)return g[0]}else if(u.backupPath){const g=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(g.length)return g[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let c;const t=v.screen.getAllDisplays();if(t.length===1)c=t[0];else{if(L.isMacintosh){const h=v.screen.getCursorScreenPoint();c=v.screen.getDisplayNearestPoint(h)}!c&&l&&(c=v.screen.getDisplayMatching(l.getBounds())),c||(c=v.screen.getPrimaryDisplay()||t[0])}let i=(0,S.defaultWindowState)();i.x=Math.round(c.bounds.x+c.bounds.width/2-i.width/2),i.y=Math.round(c.bounds.y+c.bounds.height/2-i.height/2);const s=this.configurationService.getValue("window");let a=!0;if(s==null?void 0:s.newWindowDimensions){if(s.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(s.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const h=l.serializeWindowState();h.mode===3?i.mode=3:i=h,a=i.mode!==3&&s.newWindowDimensions==="offset"}}return a&&(i=this.ensureNoOverlap(i)),i.hasDefaultState=!0,i}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const l=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;l.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};b.windowsStateStorageKey="windowsState",b=ce([ee(0,S.IWindowsMainService),ee(1,n.IStateMainService),ee(2,w.ILifecycleMainService),ee(3,p.ILogService),ee(4,r.IConfigurationService)],b),e.WindowsStateHandler=b;function d(o){const u={openedWindows:[]},l=o||{openedWindows:[]};return l.lastActiveWindow&&(u.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(u.openedWindows=l.openedWindows.map(c=>m(c))),u}e.restoreWindowsState=d;function m(o){const u={uiState:o.uiState};return o.backupPath&&(u.backupPath=o.backupPath),o.remoteAuthority&&(u.remoteAuthority=o.remoteAuthority),o.folder&&(u.folderUri=I.URI.parse(o.folder)),o.workspaceIdentifier&&(u.workspace={id:o.workspaceIdentifier.id,configPath:I.URI.parse(o.workspaceIdentifier.configURIPath)}),u}function M(o){return{lastActiveWindow:o.lastActiveWindow&&P(o.lastActiveWindow),lastPluginDevelopmentHostWindow:o.lastPluginDevelopmentHostWindow&&P(o.lastPluginDevelopmentHostWindow),openedWindows:o.openedWindows.map(u=>P(u))}}e.getWindowsStateStoreData=M;function P(o){return{workspaceIdentifier:o.workspace&&{id:o.workspace.id,configURIPath:o.workspace.configPath.toString()},folder:o.folderUri&&o.folderUri.toString(),backupPath:o.backupPath,remoteAuthority:o.remoteAuthority,uiState:o.uiState}}}),define(Q[56],J([0,1,58,59,214,5,33,7,27,28,2,23,83,19,3]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(g){this.socket=g,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,b.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(g){const k=T=>g(S.VSBuffer.wrap(T));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(g){return this.socket.on("close",g),{dispose:()=>this.socket.off("close",g)}}onEnd(g){return this.socket.on("end",g),{dispose:()=>this.socket.off("end",g)}}write(g){if(!this.socket.destroyed)try{this.socket.write(g.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,b.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,b.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((g,k)=>{if(this.socket.bufferSize===0){g();return}const T=()=>{this.socket.off("close",T),this.socket.off("end",T),this.socket.off("error",T),this.socket.off("timeout",T),this.socket.off("drain",T),g()};this.socket.on("close",T),this.socket.on("end",T),this.socket.on("error",T),this.socket.on("timeout",T),this.socket.on("drain",T)})}}e.NodeSocket=m;var M;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(M||(M={}));var P;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(P||(P={}));class o extends n.Disposable{constructor(g,k,T,U){super();this._onDidZlibFlush=this._register(new y.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new y.Emitter),this._onClose=this._register(new y.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=g,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=U,k?(this._zlibInflate=L.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",B=>{console.error(B),(0,b.onUnexpectedError)(B),this._onClose.fire()}),this._zlibInflate.on("data",B=>{this._pendingInflateData.push(B)}),T&&(this._zlibInflate.write(T.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=L.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",B=>{console.error(B),(0,b.onUnexpectedError)(B),this._onClose.fire()}),this._zlibDeflate.on("data",B=>{this._pendingDeflateData.push(B)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(B=>this._acceptChunk(B))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?S.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):S.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this._onData.event(g)}onClose(g){return this._onClose.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){this._totalOutgoingDataBytes+=g.byteLength,this._zlibDeflate?(this._zlibDeflate.write(g.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(S.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(g,!1)}_write(g,k){let T=2;g.byteLength<126?T+=0:g.byteLength<2**16?T+=2:T+=8;const U=S.VSBuffer.alloc(T);if(k?U.writeUInt8(194,0):U.writeUInt8(130,0),g.byteLength<126)U.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){U.writeUInt8(126,1);let B=1;U.writeUInt8(g.byteLength>>>8&255,++B),U.writeUInt8(g.byteLength>>>0&255,++B)}else{U.writeUInt8(127,1);let B=1;U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(0,++B),U.writeUInt8(g.byteLength>>>24&255,++B),U.writeUInt8(g.byteLength>>>16&255,++B),U.writeUInt8(g.byteLength>>>8&255,++B),U.writeUInt8(g.byteLength>>>0&255,++B)}this._totalOutgoingWireBytes+=U.byteLength+g.byteLength,this.socket.write(S.VSBuffer.concat([U,g]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(g){if(g.byteLength!==0){for(this._totalIncomingWireBytes+=g.byteLength,this._incomingData.acceptChunk(g);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),U=(k.readUInt8(0)&128)>>>7,B=k.readUInt8(1),X=(B&128)>>>7,te=B&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(te===126?2:0)+(te===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),T=k.readUInt8(1),U=(T&128)>>>7;let B=T&127,X=1;B===126?B=k.readUInt8(++X)*2**8+k.readUInt8(++X):B===127&&(B=k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*0+k.readUInt8(++X)*2**24+k.readUInt8(++X)*2**16+k.readUInt8(++X)*2**8+k.readUInt8(++X));let te=0;U&&(te=k.readUInt8(++X)*2**24+k.readUInt8(++X)*2**16+k.readUInt8(++X)*2**8+k.readUInt8(++X)),this._state.state=3,this._state.readLen=B,this._state.mask=te}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);u(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const T=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=T.length,this._onData.fire(S.VSBuffer.wrap(T))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await y.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=o;function u(f,g){if(g!==0){let k=f.byteLength>>>2;for(let oe=0;oe<k;oe++){const W=f.readUInt32BE(oe*4);f.writeUInt32BE(W^g,oe*4)}let T=k*4,U=f.byteLength-T;const B=g>>>24&255,X=g>>>16&255,te=g>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(T)^B,T),U>=2&&f.writeUInt8(f.readUInt8(T+1)^X,T+1),U>=3&&f.writeUInt8(f.readUInt8(T+2)^te,T+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const f=(0,p.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let g;return e.XDG_RUNTIME_DIR?g=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):g=(0,r.join)((0,w.tmpdir)(),`vscode-ipc-${f}.sock`),i(g),g}e.createRandomIPCHandle=c;function t(f,g,k){const T=(0,v.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${k}-${g}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,r.join)(e.XDG_RUNTIME_DIR,`vscode-${T.substr(0,8)}-${k}-${g}.sock`):U=(0,r.join)(f,`${k}-${g}.sock`),i(U),U}e.createStaticIPCHandle=t;function i(f){const g=l[d.platform];typeof g=="number"&&f.length>=g&&console.warn(`WARNING: IPC handle "${f}" is longer than ${g} chars, try a shorter --user-data-dir`)}class s extends I.IPCServer{constructor(g){super(s.toClientConnectionEvent(g));this.server=g}static toClientConnectionEvent(g){const k=y.Event.fromNodeEventEmitter(g,"connection");return y.Event.map(k,T=>({protocol:new E.Protocol(new m(T)),onDidClientDisconnect:y.Event.once(y.Event.fromNodeEventEmitter(T,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function a(f){return new Promise((g,k)=>{const T=(0,R.createServer)();T.on("error",k),T.listen(f,()=>{T.removeListener("error",k),g(new s(T))})})}e.serve=a;function h(f,g){return new Promise((k,T)=>{const U=(0,R.createConnection)(f,()=>{U.removeListener("error",T),k(E.Client.fromSocket(new m(U),g))});U.once("error",T)})}e.connect=h}),define(Q[215],J([0,1,56]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(w){this.driver=w}listen(w,p){throw new Error("No event found")}call(w,p,n){switch(p){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(n);case"reloadWindow":return this.driver.reloadWindow(n);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(n[0],n[1]);case"click":return this.driver.click(n[0],n[1],n[2],n[3]);case"doubleClick":return this.driver.doubleClick(n[0],n[1]);case"setValue":return this.driver.setValue(n[0],n[1],n[2]);case"getTitle":return this.driver.getTitle(n[0]);case"isActiveElement":return this.driver.isActiveElement(n[0],n[1]);case"getElements":return this.driver.getElements(n[0],n[1],n[2]);case"getElementXY":return this.driver.getElementXY(n[0],n[1],n[2]);case"typeInEditor":return this.driver.typeInEditor(n[0],n[1],n[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(n[0],n[1]);case"writeInTerminal":return this.driver.writeInTerminal(n[0],n[1],n[2])}throw new Error(`Call not found: ${p}`)}}e.DriverChannel=R;class L{constructor(w){this.channel=w}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(w){return this.channel.call("capturePage",w)}reloadWindow(w){return this.channel.call("reloadWindow",w)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(w,p){return this.channel.call("dispatchKeybinding",[w,p])}click(w,p,n,S){return this.channel.call("click",[w,p,n,S])}doubleClick(w,p){return this.channel.call("doubleClick",[w,p])}setValue(w,p,n){return this.channel.call("setValue",[w,p,n])}getTitle(w){return this.channel.call("getTitle",[w])}isActiveElement(w,p){return this.channel.call("isActiveElement",[w,p])}getElements(w,p,n){return this.channel.call("getElements",[w,p,n])}getElementXY(w,p,n,S){return this.channel.call("getElementXY",[w,p,n,S])}typeInEditor(w,p,n){return this.channel.call("typeInEditor",[w,p,n])}getTerminalBuffer(w,p){return this.channel.call("getTerminalBuffer",[w,p])}writeInTerminal(w,p,n){return this.channel.call("writeInTerminal",[w,p,n])}}e.DriverChannelClient=L;class y{constructor(w){this.registry=w}listen(w,p){throw new Error(`Event not found: ${p}`)}call(w,p,n){switch(p){case"registerWindowDriver":return this.registry.registerWindowDriver(n);case"reloadWindowDriver":return this.registry.reloadWindowDriver(n)}throw new Error(`Call not found: ${p}`)}}e.WindowDriverRegistryChannel=y;async function I(r){const w=await(0,v.connect)(r,"driverClient"),p=w.getChannel("driver"),n=new L(p);return{client:w,driver:n}}e.connect=I}),define(Q[25],J([0,1,7,46,4,53,159,56]),function(j,e,v,R,L,y,I,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,L.refineServiceDecorator)(y.IEnvironmentService);class w extends I.NativeEnvironmentService{get cachedLanguagesPath(){return(0,v.join)(this.userDataPath,"clp")}get backupHome(){return(0,v.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,v.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,r.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}get chromeCachedDataDir(){return(0,v.join)(this.userDataPath,"Code Cache")}}ce([R.memoize],w.prototype,"cachedLanguagesPath",null),ce([R.memoize],w.prototype,"backupHome",null),ce([R.memoize],w.prototype,"backupWorkspacesPath",null),ce([R.memoize],w.prototype,"mainIPCHandle",null),ce([R.memoize],w.prototype,"sandbox",null),ce([R.memoize],w.prototype,"driverVerbose",null),ce([R.memoize],w.prototype,"disableUpdates",null),ce([R.memoize],w.prototype,"disableKeytar",null),ce([R.memoize],w.prototype,"nodeCachedDataDir",null),ce([R.memoize],w.prototype,"chromeCachedDataDir",null),e.EnvironmentMainService=w}),define(Q[216],J([0,1,20,58,7,3,16,50,25,17,24,6,29,8,30,10,15]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let P=class{constructor(u,l,c){this.configurationService=l,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=M.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,i)=>(0,d.isEqual)(t,i,!y.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await v.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){u=Object.create(null)}u.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos));let l=[];try{Array.isArray(u.rootURIWorkspaces)&&(l=u.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:b.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let c=[];try{Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(t=>b.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==n.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===n.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var u;const l=this.configurationService.getValue();return((u=l==null?void 0:l.files)===null||u===void 0?void 0:u.hotExit)||n.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,l){this.workspaces.some(t=>u.workspace.id===t.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return l&&this.moveBackupFolderSync(c,l),c}moveBackupFolderSync(u,l){if(v.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),v.existsSync(l))try{v.renameSync(l,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const l=u.id,c=this.workspaces.findIndex(t=>t.workspace.id===l);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(l=>this.backupUriComparer.isEqual(u,l))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const l=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(u,l){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:l}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const l=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(u){return(0,L.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const l=new Set,c=[];for(let t of u){const i=t.workspace;if(!(0,E.isWorkspaceIdentifier)(i))return[];if(!l.has(i.id)){l.add(i.id);const s=this.getBackupPath(i.id);await this.doHasBackups(s)?i.configPath.scheme!==m.Schemas.file||await(0,I.exists)(i.configPath.fsPath)?c.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let t of u){const i=this.backupUriComparer.getComparisonKey(t);if(!c.has(i)){c.add(i);const s=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(s)?t.scheme!==m.Schemas.file||await(0,I.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let t of u){const i=t.backupFolder;if(typeof i!="string")return[];if(!c.has(i)){c.add(i);const s=this.getBackupPath(i);await this.doHasBackups(s)?l.push(t):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(u){try{await(0,I.exists)(u)&&await(0,I.rimraf)(u,I.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{await v.promises.rename(u,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{v.renameSync(u,c)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const u=[];for(const l of this.workspaces)await this.hasBackups(l)&&u.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&u.push(l);return u}hasBackups(u){let l;return b.URI.isUri(u)?l=this.getBackupPath(this.getFolderHash(u)):(0,r.isWorkspaceBackupInfo)(u)?l=this.getBackupPath(u.workspace.id):l=u.backupFolder,this.doHasBackups(l)}async doHasBackups(u){try{const l=await(0,I.readdir)(u);for(const c of l)try{if((await(0,I.readdir)((0,L.join)(u,c))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,I.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await(0,I.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let l;return u.scheme===m.Schemas.file?l=y.isLinux?u.fsPath:u.fsPath.toLowerCase():l=u.toString().toLowerCase(),(0,R.createHash)("md5").update(l).digest("hex")}};P=ce([ee(0,w.IEnvironmentMainService),ee(1,p.IConfigurationService),ee(2,S.ILogService)],P),e.BackupMainService=P}),define(Q[41],J([0,1,5,34,14,18,3,25,51,16,8,31,4,27,66,6,7,21,46,2,60]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let c=class ut extends u.Disposable{constructor(i,s,a,h,f,g,k,T,U){super();this.sharedProcess=i,this.windowsMainService=s,this.dialogMainService=a,this.lifecycleMainService=h,this.environmentMainService=f,this.telemetryService=g,this.logService=k,this.productService=T,this.themeMainService=U,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,X)=>X.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,X)=>X.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,X)=>X.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),v.Event.filter(v.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,X)=>X.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new v.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,X,te)=>te),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),v.Event.fromNodeEventEmitter(L.screen,"display-added"),v.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(s=>{var a,h;return{id:s.id,workspace:s.openedWorkspace,title:(h=(a=s.win)===null||a===void 0?void 0:a.getTitle())!==null&&h!==void 0?h:"",filename:s.getRepresentedFilename(),dirty:s.isDocumentEdited()}})}async getWindowCount(i){return this.windowsMainService.getWindowCount()}async getActiveWindowId(i){const s=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(s)return s.id}openWindow(i,s,a){return Array.isArray(s)?this.doOpenWindow(i,s,a):this.doOpenEmptyWindow(i,s)}async doOpenWindow(i,s,a=Object.create(null)){s.length>0&&this.windowsMainService.open({context:5,contextWindowId:i,urisToOpen:s,cli:this.environmentMainService.args,forceNewWindow:a.forceNewWindow,forceReuseWindow:a.forceReuseWindow,preferNewWindow:a.preferNewWindow,diffMode:a.diffMode,addMode:a.addMode,gotoLineMode:a.gotoLineMode,noRecentEntry:a.noRecentEntry,waitMarkerFileURI:a.waitMarkerFileURI,remoteAuthority:a.remoteAuthority||void 0})}async doOpenEmptyWindow(i,s){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:i},s)}async toggleFullScreen(i){const s=this.windowById(i);s&&s.toggleFullScreen()}async handleTitleDoubleClick(i){const s=this.windowById(i);s&&s.handleTitleDoubleClick()}async isMaximized(i){const s=this.windowById(i);return(s==null?void 0:s.win)?s.win.isMaximized():!1}async maximizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.maximize()}async unmaximizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.unmaximize()}async minimizeWindow(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.minimize()}async focusWindow(i,s){var a;s&&typeof s.windowId=="number"&&(i=s.windowId);const h=this.windowById(i);h&&h.focus({force:(a=s==null?void 0:s.force)!==null&&a!==void 0?a:!1})}async setMinimumSize(i,s,a){const h=this.windowById(i);if(h==null?void 0:h.win){const[f,g]=h.win.getSize(),[k,T]=h.win.getMinimumSize(),[U,B]=[s!=null?s:k,a!=null?a:T],[X,te]=[Math.max(f,U),Math.max(g,B)];(k!==U||T!==B)&&h.win.setMinimumSize(U,B),(f!==X||g!==te)&&h.win.setSize(X,te)}}async saveWindowSplash(i,s){this.themeMainService.saveWindowSplash(i,s)}async showMessageBox(i,s){return this.dialogMainService.showMessageBox(s,this.toBrowserWindow(i))}async showSaveDialog(i,s){return this.dialogMainService.showSaveDialog(s,this.toBrowserWindow(i))}async showOpenDialog(i,s){return this.dialogMainService.showOpenDialog(s,this.toBrowserWindow(i))}toBrowserWindow(i){const s=this.windowById(i);if(s==null?void 0:s.win)return s.win}async pickFileFolderAndOpen(i,s){const a=await this.dialogMainService.pickFileFolder(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFileFolder",s.telemetryExtraData),this.doOpenPicked(await Promise.all(a.map(async h=>await p.SymlinkSupport.existsDirectory(h)?{folderUri:n.URI.file(h)}:{fileUri:n.URI.file(h)})),s,i))}async pickFolderAndOpen(i,s){const a=await this.dialogMainService.pickFolder(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFolder",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({folderUri:n.URI.file(h)})),s,i))}async pickFileAndOpen(i,s){const a=await this.dialogMainService.pickFile(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openFile",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({fileUri:n.URI.file(h)})),s,i))}async pickWorkspaceAndOpen(i,s){const a=await this.dialogMainService.pickWorkspace(s);a&&(this.sendPickerTelemetry(a,s.telemetryEventName||"openWorkspace",s.telemetryExtraData),this.doOpenPicked(a.map(h=>({workspaceUri:n.URI.file(h)})),s,i))}doOpenPicked(i,s,a){this.windowsMainService.open({context:3,contextWindowId:a,cli:this.environmentMainService.args,urisToOpen:i,forceNewWindow:s.forceNewWindow})}sendPickerTelemetry(i,s,a){const h=i?i.length:0;this.telemetryService.publicLog(s,Object.assign(Object.assign({},a),{outcome:h?"success":"canceled",numberOfPaths:h}))}async showItemInFolder(i,s){L.shell.showItemInFolder(s)}async setRepresentedFilename(i,s){const a=this.windowById(i);a&&a.setRepresentedFilename(s)}async setDocumentEdited(i,s){const a=this.windowById(i);a&&a.setDocumentEdited(s)}async openExternal(i,s){return I.isLinuxSnap?this.safeSnapOpenExternal(s):L.shell.openExternal(s),!0}safeSnapOpenExternal(i){const s=process.env.GDK_PIXBUF_MODULE_FILE,a=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(i),process.env.GDK_PIXBUF_MODULE_FILE=s,process.env.GDK_PIXBUF_MODULEDIR=a}moveItemToTrash(i,s){return L.shell.trashItem(s)}async isAdmin(){let i;return I.isWindows?i=(await new Promise((s,a)=>{j(["native-is-elevated"],s,a)}))():i=process.getuid()===0,i}async writeElevated(i,s,a,h){const f=await new Promise((g,k)=>{j(["sudo-prompt"],g,k)});return new Promise((g,k)=>{const T=[`"${this.cliPath}"`];(h==null?void 0:h.unlock)&&T.push("--file-chmod"),T.push("--file-write",`"${s.fsPath}"`,`"${a.fsPath}"`);const U={name:this.productService.nameLong.replace("-",""),icns:I.isMacintosh&&this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};f.exec(T.join(" "),U,(B,X,te)=>{X&&this.logService.trace(`[sudo-prompt] received stdout: ${X}`),te&&this.logService.trace(`[sudo-prompt] received stderr: ${te}`),B?k(B):g(void 0)})})}get cliPath(){return I.isWindows?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):I.isLinux?this.environmentMainService.isBuilt?(0,M.join)((0,M.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,M.join)(this.environmentMainService.appRoot,"bin","code"):(0,M.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,b.totalmem)(),freemem:(0,b.freemem)(),loadavg:(0,b.loadavg)()}}async getOSProperties(){return{arch:(0,b.arch)(),platform:(0,b.platform)(),release:(0,b.release)(),type:(0,b.type)(),cpus:(0,b.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(i,s,a){process.kill(s,a)}async readClipboardText(i,s){return L.clipboard.readText(s)}async writeClipboardText(i,s,a){return L.clipboard.writeText(s,a)}async readClipboardFindText(i){return L.clipboard.readFindText()}async writeClipboardFindText(i,s){return L.clipboard.writeFindText(s)}async writeClipboardBuffer(i,s,a,h){return L.clipboard.writeBuffer(s,Buffer.from(a),h)}async readClipboardBuffer(i,s){return L.clipboard.readBuffer(s)}async hasClipboard(i,s,a){return L.clipboard.has(s,a)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(i,s){const a=this.windowById(i);a&&a.updateTouchBar(s)}async notifyReady(i){const s=this.windowById(i);s&&s.setReady()}async relaunch(i,s){return this.lifecycleMainService.relaunch(s)}async reload(i,s){const a=this.windowById(i);if(a)return this.lifecycleMainService.reload(a,(s==null?void 0:s.disableExtensions)!==void 0?{_:[],"disable-extensions":s==null?void 0:s.disableExtensions}:void 0)}async closeWindow(i){this.closeWindowById(i,i)}async closeWindowById(i,s){const a=this.windowById(s);if(a==null?void 0:a.win)return a.win.close()}async quit(i){const s=this.windowsMainService.getLastActiveWindow();(s==null?void 0:s.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&s.win?s.win.close():this.lifecycleMainService.quit()}async exit(i,s){await this.lifecycleMainService.kill(s)}async resolveProxy(i,s){var a,h;const f=this.windowById(i),g=(h=(a=f==null?void 0:f.win)===null||a===void 0?void 0:a.webContents)===null||h===void 0?void 0:h.session;if(g)return g.resolveProxy(s)}async openDevTools(i,s){const a=this.windowById(i);(a==null?void 0:a.win)&&a.win.webContents.openDevTools(s)}async toggleDevTools(i){const s=this.windowById(i);(s==null?void 0:s.win)&&s.win.webContents.toggleDevTools()}async sendInputEvent(i,s){const a=this.windowById(i);(a==null?void 0:a.win)&&(s.type==="mouseDown"||s.type==="mouseUp")&&a.win.webContents.sendInputEvent(s)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(i,s,a,h){if(!!I.isWindows){const f=await new Promise((g,k)=>{j(["vscode-windows-registry"],g,k)});try{return f.GetStringRegKey(s,a,h)}catch(g){return}}}async getPassword(i,s,a){const h=await this.withKeytar(),f=await h.getPassword(s,a);if(f)try{let{content:g,hasNextChunk:k}=JSON.parse(f);if(!g||!k)return f;let T=1;for(;k;){const U=await h.getPassword(s,`${a}-${T}`),B=JSON.parse(U);g+=B.content,k=B.hasNextChunk}return g}catch(g){return f}return f}async setPassword(i,s,a,h){const f=await this.withKeytar();if(I.isWindows&&h.length>ut.MAX_PASSWORD_LENGTH){let g=0,k=0,T=!0;for(;T;){const U=h.substring(g,g+ut.PASSWORD_CHUNK_SIZE);g+=ut.PASSWORD_CHUNK_SIZE,T=h.length-g>0;const B={content:U,hasNextChunk:T};await f.setPassword(s,k?`${a}-${k}`:a,JSON.stringify(B)),k++}}else await f.setPassword(s,a,h);this._onDidChangePassword.fire({service:s,account:a})}async deletePassword(i,s,a){const f=await(await this.withKeytar()).deletePassword(s,a);return f&&this._onDidChangePassword.fire({service:s,account:a}),f}async findPassword(i,s){return(await this.withKeytar()).findPassword(s)}async findCredentials(i,s){return(await this.withKeytar()).findCredentials(s)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((i,s)=>{j(["keytar"],i,s)})}windowById(i){if(typeof i=="number")return this.windowsMainService.getWindowById(i)}};c.MAX_PASSWORD_LENGTH=2500,c.PASSWORD_CHUNK_SIZE=c.MAX_PASSWORD_LENGTH-100,ce([o.memoize],c.prototype,"cliPath",null),c=ce([ee(1,R.IWindowsMainService),ee(2,w.IDialogMainService),ee(3,y.ILifecycleMainService),ee(4,r.IEnvironmentMainService),ee(5,S.ITelemetryService),ee(6,m.ILogService),ee(7,P.IProductService),ee(8,l.IThemeMainService)],c),e.NativeHostMainService=c}),define(Q[217],J([0,1,2,5,80,14,6,34,41,88,28,21,26]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var b;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(b||(b={}));let d=class extends v.Disposable{constructor(M,P,o,u,l){super();this.logService=M,this.windowsMainService=P,this.nativeHostMainService=o,this.encryptionMainService=u,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=b.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const M=R.Event.fromNodeEventEmitter(y.app,"login",(P,o,u,l,c)=>({event:P,webContents:o,req:u,authInfo:l,callback:c}));this._register(M(this.onLogin,this))}async onLogin({event:M,authInfo:P,req:o,callback:u}){if(!!P.isProxy){if(!this.pendingProxyResolve&&this.state===b.LoginDialogShown&&o.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}M.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(P);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(M){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const P=await this.doResolveProxyCredentials(M);if(P)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),P;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(M){var P,o,u,l;this.logService.trace("auth#doResolveProxyCredentials - enter",M);const c=String((0,L.hash)({scheme:M.scheme,host:M.host,port:M.port}));let t,i;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c);if(f){const g=JSON.parse(await this.encryptionMainService.decrypt(f));t=g.username,i=g.password}}catch(f){this.logService.error(f)}if(this.state!==b.StoredCredentialsUsed&&typeof t=="string"&&typeof i=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=b.StoredCredentialsUsed,{username:t,password:i};const s=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!s){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${s.id} to handle proxy login`);const a={authInfo:M,username:(o=(P=this.sessionCredentials)===null||P===void 0?void 0:P.username)!==null&&o!==void 0?o:t,password:(l=(u=this.sessionCredentials)===null||u===void 0?void 0:u.password)!==null&&l!==void 0?l:i,replyChannel:`vscode:proxyAuthResponse:${(0,n.generateUuid)()}`};s.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,a),this.state=b.LoginDialogShown;const h=await new Promise(f=>{var g;const k=async(T,U,B)=>{var X;if(U===a.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${s.id}`),(X=s.win)===null||X===void 0||X.webContents.off("ipc-message",k),B){const te={username:B.username,password:B.password};try{if(B.remember){const oe=await this.encryptionMainService.encrypt(JSON.stringify(te));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c,oe)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,c)}catch(oe){this.logService.error(oe)}f({username:te.username,password:te.password})}else f(void 0)};(g=s.win)===null||g===void 0||g.webContents.on("ipc-message",k)});return this.sessionCredentials=h,h}};d=ce([ee(0,I.ILogService),ee(1,r.IWindowsMainService),ee(2,w.INativeHostMainService),ee(3,p.IEncryptionMainService),ee(4,S.IProductService)],d),e.ProxyAuthHandler=d}),define(Q[218],J([0,1,215,154,34,56,2,33,57,174,3,5,79,105,9,18,41]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function P(l){return l<21}let o=class{constructor(c,t,i,s,a){this.windowServer=c,this.options=t,this.windowsMainService=i,this.lifecycleMainService=s,this.nativeHostMainService=a,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new S.Emitter}async registerWindowDriver(c){return this.registeredWindowIds.add(c),this.reloadingWindowIds.delete(c),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(c){this.reloadingWindowIds.add(c)}async getWindowIds(){return this.windowsMainService.getWindows().map(c=>c.id).filter(c=>this.registeredWindowIds.has(c)&&!this.reloadingWindowIds.has(c))}async capturePage(c){await this.whenUnfrozen(c);const t=this.windowsMainService.getWindowById(c);if(!(t==null?void 0:t.win))throw new Error("Invalid window");return(await t.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(c){await this.whenUnfrozen(c);const t=this.windowsMainService.getWindowById(c);if(!t)throw new Error("Invalid window");this.reloadingWindowIds.add(c),this.lifecycleMainService.reload(t)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(c,t){await this.whenUnfrozen(c);const i=b.KeybindingParser.parseUserBinding(t);for(let s of i)await this._dispatchKeybinding(c,s)}async _dispatchKeybinding(c,t){if(t instanceof E.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const i=this.windowsMainService.getWindowById(c);if(!(i==null?void 0:i.win))throw new Error("Invalid window");const s=i.win.webContents,a=new w.SimpleKeybinding(!1,!1,!1,!1,t.keyCode),f=new p.USLayoutResolvedKeybinding(a.toChord(),n.OS).getElectronAccelerator(),g=[];t.ctrlKey&&g.push("ctrl"),t.metaKey&&g.push("meta"),t.shiftKey&&g.push("shift"),t.altKey&&g.push("alt"),s.sendInputEvent({type:"keyDown",keyCode:f,modifiers:g}),P(t.keyCode)||s.sendInputEvent({type:"char",keyCode:f,modifiers:g}),s.sendInputEvent({type:"keyUp",keyCode:f,modifiers:g}),await(0,d.timeout)(100)}async click(c,t,i,s){await(await this.getWindowDriver(c)).click(t,i,s)}async doubleClick(c,t){await(await this.getWindowDriver(c)).doubleClick(t)}async setValue(c,t,i){await(await this.getWindowDriver(c)).setValue(t,i)}async getTitle(c){return await(await this.getWindowDriver(c)).getTitle()}async isActiveElement(c,t){return await(await this.getWindowDriver(c)).isActiveElement(t)}async getElements(c,t,i){return await(await this.getWindowDriver(c)).getElements(t,i)}async getElementXY(c,t,i,s){return await(await this.getWindowDriver(c)).getElementXY(t,i,s)}async typeInEditor(c,t,i){await(await this.getWindowDriver(c)).typeInEditor(t,i)}async getTerminalBuffer(c,t){return await(await this.getWindowDriver(c)).getTerminalBuffer(t)}async writeInTerminal(c,t,i){await(await this.getWindowDriver(c)).writeInTerminal(t,i)}async getWindowDriver(c){await this.whenUnfrozen(c);const t=`window:${c}`,i=new r.StaticRouter(a=>a===t),s=this.windowServer.getChannel("windowDriver",i);return new R.WindowDriverChannelClient(s)}async whenUnfrozen(c){for(;this.reloadingWindowIds.has(c);)await S.Event.toPromise(this.onDidReloadingChange.event)}};o=ce([ee(2,L.IWindowsMainService),ee(3,m.ILifecycleMainService),ee(4,M.INativeHostMainService)],o),e.Driver=o;async function u(l,c,t,i){const s=t.driverVerbose,a=i.createInstance(o,l,{verbose:s}),h=new v.WindowDriverRegistryChannel(a);l.registerChannel("windowDriverRegistry",h);const f=await(0,y.serve)(c),g=new v.DriverChannel(a);return f.registerChannel("driver",g),(0,I.combinedDisposable)(f,l)}e.serve=u}),define(Q[219],J([0,1,59,56]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(L,y,I,r){const w=n=>r(n,void 0),p=v.createConnection({host:L,port:y},()=>{p.removeListener("error",w);const n=Buffer.alloc(16);for(let d=0;d<16;d++)n[d]=Math.round(Math.random()*256);const S=n.toString("base64");let E=[`GET ws://${/:/.test(L)?`[${L}]`:L}:${y}/?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`];p.write(E.join(`\r
`)+`\r
\r
`);const b=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",b),r(void 0,new R.NodeSocket(p)))};p.on("data",b)});p.once("error",w)}}}),define(Q[220],J([0,1,59,9,2,115,6,21,189,74,219,75]),function(j,e,v,R,L,y,I,r,w,p,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(M,P,o,u){return new b(M,P,o,u).waitForReady()}class b extends L.Disposable{constructor(P,o,u,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=P,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=c=>this._onConnection(c),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=u,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(o=>{o()})}async waitForReady(){var P;let o=await(0,y.findFreePortFaster)((P=this.suggestedLocalPort)!==null&&P!==void 0?P:this.tunnelRemotePort,2,1e3),u=null;return u=this._server.listen(o).address(),u||(o=0,u=this._server.listen(o).address()),this.tunnelLocalPort=u.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(P){P.pause();const o=await(0,w.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),u=o.getSocket().socket,l=o.readEntireBuffer();o.dispose(),l.byteLength>0&&P.write(l.buffer),P.on("end",()=>{this._socketsDispose.delete(P.localAddress),u.end()}),P.on("close",()=>u.end()),P.on("error",()=>{this._socketsDispose.delete(P.localAddress),u.destroy()}),u.on("end",()=>P.end()),u.on("close",()=>P.end()),u.on("error",()=>{P.destroy()}),P.pipe(u),u.pipe(P),this._socketsDispose.set(P.localAddress,()=>{P.end(),u.end()})}}let d=class extends p.AbstractTunnelService{constructor(P,o,u,l){super(o);this.socketFactory=P,this.signService=u,this.productService=l}retainOrCreateTunnel(P,o,u,l,c,t){const i=this.getTunnelFromMap(o,u);if(i)return++i.refcount,i.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,o,u,l,c,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${u} on local port ${l}.`);const s={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:P,signService:this.signService,logService:this.logService,ipcLogger:null},a=E(s,o,u,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(o,u,a),a}}};d=ce([ee(1,I.ILogService),ee(2,S.ISignService),ee(3,r.IProductService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(P,o,u){super(n.nodeSocketFactory,P,o,u)}};m=ce([ee(0,I.ILogService),ee(1,S.ISignService),ee(2,r.IProductService)],m),e.TunnelService=m}),define(Q[221],J([0,1,214,191,2,13,19,190,17,6,23,53,90]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let b=class extends L.Disposable{constructor(m,M,P){super();this.environmentService=M,this.logService=P,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,M){this.logService.trace("RequestService#request",m.url);const{proxyUrl:P,strictSSL:o}=this,u=Object.assign(Object.assign({},process.env),await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),l=m.agent?m.agent:await(0,r.getProxyAgent)(m.url||"",u,{proxyUrl:P,strictSSL:o});return m.agent=l,m.strictSSL=o,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,M)}async getNodeRequest(m){return((0,R.parse)(m.url).protocol==="https:"?await new Promise((o,u)=>{j(["https"],o,u)}):await new Promise((o,u)=>{j(["http"],o,u)})).request}_request(m,M){return new Promise(async(P,o)=>{let u;const l=(0,R.parse)(m.url),c=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,y.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),u=c(t,i=>{const s=(0,y.isNumber)(m.followRedirects)?m.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)this._request(Object.assign(Object.assign({},m),{url:i.headers.location,followRedirects:s-1}),M).then(P,o);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,v.createGunzip)())),P({res:i,stream:(0,n.streamToBufferReadableStream)(a)})}}),u.on("error",o),m.timeout&&u.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&u.write(m.data),u.end(),M.onCancellationRequested(()=>{u.abort(),o((0,I.canceled)())})})}async resolveProxy(m){}};b=ce([ee(0,w.IConfigurationService),ee(1,S.INativeEnvironmentService),ee(2,p.ILogService)],b),e.RequestService=b}),define(Q[222],J([0,1,221,14]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function L(I){return R.net.request}class y extends v.RequestService{request(r,w){return super.request(Object.assign(Object.assign({},r||{}),{getRawRequest:L}),w)}}e.RequestMainService=y}),define(Q[223],J([0,1,47,14,25,9,6,18,60,10,3,2,84,13,5,55]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let M=class extends S.Disposable{constructor(o,u,l,c,t,i,s){super();this.machineId=o,this.userEnv=u,this.environmentMainService=l,this.lifecycleMainService=c,this.logService=t,this.themeMainService=i,this.protocolMainService=s,this.firstWindowConnectionBarrier=new y.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new d.Emitter),this.onDidError=d.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),R.ipcMain.on("vscode:createSharedProcessMessageChannel",async(o,u)=>this.onWindowConnection(o,u))}async onWindowConnection(o,u){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(o.sender.isDestroyed())return l.close();o.sender.postMessage("vscode:createSharedProcessMessageChannelResult",u,[l])}onWillShutdown(){const o=this.window;!o||(!o.isDestroyed()&&!o.webContents.isDestroyed()&&o.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(o.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{o.close()}catch(u){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(o=>R.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),o()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(o=>R.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),o()}))})()),this._whenIpcReady}createWindow(){const o=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new R.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:p.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`],v8CacheOptions:n.browserCodeLoadingCacheStrategy,nodeIntegration:!0,contextIsolation:!1,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),o.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:v.default}),this.window.loadURL(p.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=o=>{var u;this.logService.trace("SharedProcess#close prevented"),o.preventDefault(),((u=this.window)===null||u===void 0?void 0:u.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(o,u)=>this._onDidError.fire({type:2,details:u})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(o,u,l)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${l}`})))}async connect(){await this.whenIpcReady;const o=(0,b.assertIsDefined)(this.window);return(0,E.connect)(o)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var o,u;return(u=(o=this.window)===null||o===void 0?void 0:o.isVisible())!==null&&u!==void 0?u:!1}};M=ce([ee(2,L.IEnvironmentMainService),ee(3,r.ILifecycleMainService),ee(4,I.ILogService),ee(5,w.IThemeMainService),ee(6,m.IProtocolMainService)],M),e.SharedProcess=M}),define(Q[224],J([0,1,7,20,16,13,6,25,9]),function(j,e,v,R,L,y,I,r,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class p{constructor(E,b){this.dbPath=E,this.logService=b,this.database=Object.create(null),this.lastFlushedSerializedDatabase=void 0,this.flushDelayer=new w.ThrottledDelayer(100)}async init(){this.database=await this.load()}async load(){try{return this.lastFlushedSerializedDatabase=(await R.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(E){return E.code!=="ENOENT"&&this.logService.error(E),Object.create(null)}}getItem(E,b){const d=this.database[E];return(0,y.isUndefinedOrNull)(d)?b:d}setItem(E,b){if((0,y.isUndefinedOrNull)(b))return this.removeItem(E);(typeof b=="string"||typeof b=="number"||typeof b=="boolean")&&this.database[E]===b||(this.database[E]=b,this.save())}setItems(E){let b=!1;for(const{key:d,data:m}of E)if((0,y.isUndefinedOrNull)(m))this.database[d]=void 0,b=!0;else{if((typeof m=="string"||typeof m=="number"||typeof m=="boolean")&&this.database[d]===m)continue;this.database[d]=m,b=!0}b&&this.save()}removeItem(E){(0,y.isUndefined)(this.database[E])||(this.database[E]=void 0,this.save())}save(E){return this.flushDelayer.trigger(()=>this.doSave(),E)}async doSave(){const E=JSON.stringify(this.database,null,4);if(E!==this.lastFlushedSerializedDatabase)try{await(0,L.writeFile)(this.dbPath,E),this.lastFlushedSerializedDatabase=E}catch(b){this.logService.error(b)}}flush(){return this.save(0)}}e.FileStorage=p;let n=class It{constructor(E,b){this.logService=b,this.storageDidInit=!1,this.fileStorage=new p((0,v.join)(E.userDataPath,It.STATE_FILE),b)}async init(){if(!this.storageDidInit)return this.storageDidInit=!0,this.fileStorage.init()}checkInit(){this.storageDidInit||this.logService.warn("StateMainService used before init()")}getItem(E,b){return this.checkInit(),this.fileStorage.getItem(E,b)}setItem(E,b){this.checkInit(),this.fileStorage.setItem(E,b)}setItems(E){this.checkInit(),this.fileStorage.setItems(E)}removeItem(E){this.checkInit(),this.fileStorage.removeItem(E)}flush(){return this.checkInit(),this.fileStorage.flush()}};n.STATE_FILE="storage.json",n=ce([ee(0,r.IEnvironmentMainService),ee(1,I.ILogService)],n),e.StateMainService=n}),define(Q[77],J([0,1,5,9,17,18,21,40,25,6,49,26]),function(j,e,v,R,L,y,I,r,w,p,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,m,M){return`${M.updateUrl}/api/update/${d}/${m}/${M.commit}`}e.createUpdateURL=E;let b=class{constructor(m,M,P,o,u,l){this.lifecycleMainService=m,this.configurationService=M,this.environmentMainService=P,this.requestService=o,this.logService=u,this.productService=l,this._state=r.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,L.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),M=this.getProductQuality(m);if(!M){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(M),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(r.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},S.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};b=ce([ee(0,y.ILifecycleMainService),ee(1,L.IConfigurationService),ee(2,w.IEnvironmentMainService),ee(3,n.IRequestService),ee(4,p.ILogService),ee(5,I.IProductService)],b),e.AbstractUpdateService=b}),define(Q[225],J([0,1,14,2,5,46,17,18,40,31,25,6,77,49,21]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends E.AbstractUpdateService{constructor(P,o,u,l,c,t,i){super(P,o,l,c,t,i);this.telemetryService=u,this.disposables=new R.DisposableStore}get onRawError(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"error",(P,o)=>o)}get onRawUpdateNotAvailable(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(P,o,u)=>({url:o,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return L.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(P,o,u,l)=>({releaseNotes:o,version:u,productVersion:u,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(P){this.logService.error("UpdateService error:",P);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?P:void 0;this.setState(w.State.Idle(1,u))}buildUpdateFeedUrl(P){let o;this.productService.darwinUniversalAssetId?o=this.productService.darwinUniversalAssetId:o=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,E.createUpdateURL)(o,P,this.productService);try{v.autoUpdater.setFeedURL({url:u})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return u}doCheckForUpdates(P){this.setState(w.State.CheckingForUpdates(P)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(P){this.state.type==="checking for updates"&&this.setState(w.State.Downloading(P))}onUpdateDownloaded(P){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:P.version}),this.setState(w.State.Ready(P)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(w.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([y.memoize],m.prototype,"onRawError",null),ce([y.memoize],m.prototype,"onRawUpdateNotAvailable",null),ce([y.memoize],m.prototype,"onRawUpdateAvailable",null),ce([y.memoize],m.prototype,"onRawUpdateDownloaded",null),m=ce([ee(0,r.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,p.ITelemetryService),ee(3,n.IEnvironmentMainService),ee(4,b.IRequestService),ee(5,S.ILogService),ee(6,d.IProductService)],m),e.DarwinUpdateService=m}),define(Q[226],J([0,1,21,17,18,40,31,25,6,77,49,26,41]),function(j,e,v,R,L,y,I,r,w,p,n,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let b=class extends p.AbstractUpdateService{constructor(m,M,P,o,u,l,c,t){super(m,M,o,u,l,t);this.telemetryService=P,this.nativeHostMainService=c}buildUpdateFeedUrl(m){return(0,p.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(y.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},S.CancellationToken.None).then(n.asJson).then(M=>{!M||!M.url||!M.version||!M.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(y.State.Idle(1))):this.setState(y.State.AvailableForDownload(M))}).then(void 0,M=>{this.logService.error(M),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const P=m?M.message||M:void 0;this.setState(y.State.Idle(1,P))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(y.State.Idle(1))}};b=ce([ee(0,L.ILifecycleMainService),ee(1,R.IConfigurationService),ee(2,I.ITelemetryService),ee(3,r.IEnvironmentMainService),ee(4,n.IRequestService),ee(5,w.ILogService),ee(6,E.INativeHostMainService),ee(7,v.IProductService)],b),e.LinuxUpdateService=b}),define(Q[227],J([0,1,5,9,18,40,25,6,7,20,45,31]),function(j,e,v,R,L,y,I,r,w,p,n,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(m,M,P){if(this.lifecycleMainService=m,this.logService=P,this._state=y.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,M.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(y.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,o=>this.logService.error(o))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([ee(0,L.ILifecycleMainService),ee(1,I.IEnvironmentMainService),ee(2,r.ILogService)],E);let b=class extends E{constructor(m,M,P,o,u,l){super(P,o,u);this.snap=m,this.snapRevision=M,this.telemetryService=l;const c=(0,p.watch)(w.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(c,"change",(h,f)=>f),i=v.Event.filter(t,h=>h==="current"),a=v.Event.debounce(i,(h,f)=>f,2e3)(()=>this.checkForUpdates(!1));P.onWillShutdown(()=>{a.dispose(),c.close()})}doCheckForUpdates(){this.setState(y.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(m=>{m?this.setState(y.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2)))},m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(y.State.Idle(2,m.message||m))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+w.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((P,o)=>(0,p.realpath)(`${w.dirname(this.snap)}/current`,(u,l)=>u?o(u):P(l))),M=w.basename(m);return this.snapRevision!==M}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};b=ce([ee(2,L.ILifecycleMainService),ee(3,I.IEnvironmentMainService),ee(4,r.ILogService),ee(5,S.ITelemetryService)],b),e.SnapUpdateService=b}),define(Q[228],J([0,1,20,7,16,46,17,18,21,40,31,25,6,77,49,111,27,45,26,9,24,8,41]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function i(f,g=1e3){for(;!f();)await(0,u.timeout)(g)}let s;function a(){return typeof s=="undefined"&&(s=v.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),s}let h=class extends b.AbstractUpdateService{constructor(g,k,T,U,B,X,te,oe,W){super(g,k,U,B,X,W);this.telemetryService=T,this.fileService=te,this.nativeHostMainService=oe}get cachePath(){const g=R.join((0,M.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.promises.mkdir(g,{recursive:!0}).then(()=>g)}initialize(){super.initialize(),a()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(g){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),a()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,b.createUpdateURL)(k,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(p.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},o.CancellationToken.None).then(d.asJson).then(k=>{const T=a();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(p.State.Idle(T)),Promise.resolve(null)):T===1?(this.setState(p.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(p.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(U=>L.exists(U).then(B=>{if(B)return Promise.resolve(U);const X=k.url,te=k.hash,oe=`${U}.tmp`;return this.requestService.request({url:X},o.CancellationToken.None).then(W=>this.fileService.writeFile(c.URI.file(oe),W.stream)).then(te?()=>(0,m.checksum)(oe,k.hash):()=>{}).then(()=>v.promises.rename(oe,U)).then(()=>U)})).then(U=>{const B=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},B&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(p.State.Downloaded(k)):this.setState(p.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const T=g?k.message||k:void 0;this.setState(p.State.Idle(a(),T))}))}async doDownloadUpdate(g){g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(p.State.Idle(a()))}async getUpdatePackagePath(g){const k=await this.cachePath;return R.join(k,`CodeSetup-${this.productService.quality}-${g}.exe`)}async cleanup(g=null){const k=g?X=>!new RegExp(`${this.productService.quality}-${g}\\.exe$`).test(X):()=>!0,T=await this.cachePath,B=(await L.readdir(T)).filter(k).map(async X=>{try{await v.promises.unlink(R.join(T,X))}catch(te){}});await Promise.all(B)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const g=this.state.update;this.setState(p.State.Updating(g));const k=await this.cachePath;this.availableUpdate.updateFilePath=R.join(k,`CodeSetup-${this.productService.quality}-${g.version}.flag`),await L.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,P.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(p.State.Idle(a()))});const U=`${this.productService.win32MutexName}-ready`,B=await new Promise((X,te)=>{j(["windows-mutex"],X,te)});i(()=>B.isActive(U)).then(()=>this.setState(p.State.Ready(g)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):(0,P.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return a()}};ce([y.memoize],h.prototype,"cachePath",null),h=ce([ee(0,r.ILifecycleMainService),ee(1,I.IConfigurationService),ee(2,n.ITelemetryService),ee(3,S.IEnvironmentMainService),ee(4,d.IRequestService),ee(5,E.ILogService),ee(6,l.IFileService),ee(7,t.INativeHostMainService),ee(8,w.IProductService)],h),e.Win32UpdateService=h}),define(Q[52],J([0,1,29,25,7,16,20,3,5,6,58,43,10,2,15,4,152,21,14,13,50,51,99]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let i=class extends b.Disposable{constructor(f,g,k,T,U){super();this.environmentMainService=f,this.logService=g,this.backupMainService=k,this.dialogMainService=T,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new w.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new w.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!!this.isWorkspacePath(f)&&f.scheme===E.Schemas.file){let g;try{g=(0,I.readFileSync)(f.fsPath,"utf8")}catch(k){return}return this.doResolveWorkspace(f,g)}}isWorkspacePath(f){return(0,v.isUntitledWorkspace)(f,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,g){try{const k=this.doParseStoredWorkspace(f,g),T=s(f);return{id:T.id,configPath:T.configPath,folders:(0,v.toWorkspaceFolders)(k.folders,T.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:k.remoteAuthority}}catch(k){this.logService.warn(k.toString())}}doParseStoredWorkspace(f,g){const k=(0,S.parse)(g);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(T=>(0,v.isStoredWorkspaceFolder)(T));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return k}async createUntitledWorkspace(f,g){const{workspace:k,storedWorkspace:T}=this.newUntitledWorkspace(f,g),U=k.configPath.fsPath;return await I.promises.mkdir((0,L.dirname)(U),{recursive:!0}),await(0,y.writeFile)(U,JSON.stringify(T,null,"	")),k}createUntitledWorkspaceSync(f,g){const{workspace:k,storedWorkspace:T}=this.newUntitledWorkspace(f,g),U=k.configPath.fsPath;return(0,I.mkdirSync)((0,L.dirname)(U),{recursive:!0}),(0,y.writeFileSync)(U,JSON.stringify(T,null,"	")),k}newUntitledWorkspace(f=[],g){const k=(Date.now()+Math.round(Math.random()*1e3)).toString(),T=(0,d.joinPath)(this.untitledWorkspacesHome,k),U=(0,d.joinPath)(T,v.UNTITLED_WORKSPACE_NAME),B=[];for(const X of f)B.push((0,v.getStoredWorkspaceFolder)(X.uri,!0,X.name,T,!r.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:s(U),storedWorkspace:{folders:B,remoteAuthority:g}}}async getWorkspaceIdentifier(f){return s(f)}isUntitledWorkspace(f){return(0,v.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const g=(0,d.originalFSPath)(f.configPath);try{(0,y.rimrafSync)((0,L.dirname)(g));const k=(0,L.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,I.existsSync)(k)&&(0,y.writeFileSync)((0,L.join)(k,"obsolete"),"")}catch(k){this.logService.warn(`Unable to delete untitled workspace ${g} (${k}).`)}}getUntitledWorkspacesSync(){const f=[];try{const g=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(k=>(0,d.joinPath)(this.untitledWorkspacesHome,k,v.UNTITLED_WORKSPACE_NAME));for(const k of g){const T=s(k),U=this.resolveLocalWorkspaceSync(k);U?f.push({workspace:T,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(T)}}catch(g){g.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${g}).`)}return f}async enterWorkspace(f,g,k){if(!(!f||!f.win||!f.isReady)&&!!await this.isValidTargetWorkspacePath(f,g,k)){const U=this.doEnterWorkspace(f,s(k));if(!!U)return this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U}}async isValidTargetWorkspacePath(f,g,k){if(!k)return!0;if((0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,k))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(g,k)){const T={title:this.productService.nameLong,type:"info",buttons:[(0,M.localize)(0,null)],message:(0,M.localize)(1,null,(0,d.basename)(k)),detail:(0,M.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(T,(0,u.withNullAsUndefined)(o.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,g){if(!!f.config){f.focus();let k;return f.config.extensionDevelopmentPath||(k=this.backupMainService.registerWorkspaceBackupSync({workspace:g,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=g,f.config.backupPath=k,{workspace:g,backupPath:k}}}};i=ce([ee(0,R.IEnvironmentMainService),ee(1,p.ILogService),ee(2,l.IBackupMainService),ee(3,c.IDialogMainService),ee(4,P.IProductService)],i),e.WorkspacesManagementMainService=i;function s(h){function f(){let g=h.scheme===E.Schemas.file?(0,d.originalFSPath)(h):h.toString();return r.isLinux||(g=g.toLowerCase()),(0,n.createHash)("md5").update(g).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=s;function a(h,f){function g(){if(h.scheme!==E.Schemas.file)return(0,n.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,I.statSync)(h.fsPath)}catch(U){return}let T;return r.isLinux?T=f.ino:r.isMacintosh?T=f.birthtime.getTime():r.isWindows&&(typeof f.birthtimeMs=="number"?T=Math.floor(f.birthtimeMs):T=f.birthtime.getTime()),(0,n.createHash)("md5").update(h.fsPath).update(T?String(T):"").digest("hex")}const k=g();if(typeof k=="string")return{id:k,uri:h}}e.getSingleFolderWorkspaceIdentifier=a}),define(Q[100],J([0,1,6,97,3,4,34,16,52,17,8,14,35,54,26,29,13]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,y.createDecorator)(e.ID);let P=class{constructor(u,l,c,t,i){this.logService=u,this.windowsMainService=l,this.urlService=c,this.workspacesManagementMainService=t,this.configurationService=i}async start(u,l){this.logService.trace("Received data from other instance: ",u,l),L.isMacintosh&&S.app.focus({steal:!0});const c=this.parseOpenUrl(u);if(c.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:i,url:s}of c)this.urlService.open(i,{originalUrl:s})})}else return this.startOpenWindow(u,l)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,E.coalesce)(u._urls.map(l=>{try{return{uri:n.URI.parse(l),url:l}}catch(c){return null}})):[]}async startOpenWindow(u,l){const c=(0,b.isLaunchedFromCli)(l)?0:4;let t=[];const i=u.wait&&u.waitMarkerFilePath?n.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0;if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,{context:c,cli:u,userEnv:l,waitMarkerFileURI:i,remoteAuthority:s});else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!L.isMacintosh}}if(a)t=this.windowsMainService.open({context:c,cli:u,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:i,remoteAuthority:s});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:c,cli:u,forceEmpty:!0,remoteAuthority:s})}}else t=this.windowsMainService.open({context:c,cli:u,userEnv:l,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],waitMarkerFileURI:i,gotoLineMode:u.goto,remoteAuthority:s});if(i&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,r.whenDeleted)(i.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return S.BrowserWindow.getAllWindows().forEach(l=>{const c=this.windowsMainService.getWindowById(l.id);c?u.push(this.codeWindowToInfo(c)):u.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!S.app.accessibilitySupportEnabled,gpuFeatureStatus:S.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(i=>{const s=t.remoteAuthority;if(s){const a=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:a,args:h}),S.ipcMain.once(a,(f,g)=>{g||i({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),i(g)}),setTimeout(()=>{i({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else i(void 0)})))).filter(t=>!!t)}getFolderURIs(u){const l=[],c=u.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(c))l.push(c.uri);else if((0,m.isWorkspaceIdentifier)(c)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);t&&t.folders.forEach(s=>{l.push(s.uri)})}return l}codeWindowToInfo(u){const l=this.getFolderURIs(u),c=(0,M.assertIsDefined)(u.win);return this.browserWindowToInfo(c,l,u.remoteAuthority)}browserWindowToInfo(u,l=[],c){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:l,remoteAuthority:c}}};P=ce([ee(0,v.ILogService),ee(1,I.IWindowsMainService),ee(2,R.IURLService),ee(3,w.IWorkspacesManagementMainService),ee(4,p.IConfigurationService)],P),e.LaunchMainService=P}),define(Q[229],J([0,1,143,27,47,14,100,70,25,3,6,82,51,4,61,10,41,55,2]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,b.createDecorator)("issueMainService");let u=class Pt{constructor(c,t,i,s,a,h,f,g){this.userEnv=c,this.environmentMainService=t,this.launchMainService=i,this.logService=s,this.diagnosticsService=a,this.dialogMainService=h,this.nativeHostMainService=f,this.protocolMainService=g,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){y.ipcMain.on("vscode:issueSystemInfoRequest",async c=>{const[t,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),s=await this.diagnosticsService.getSystemInfo(t,i);this.safeSend(c,"vscode:issueSystemInfoResponse",s)}),y.ipcMain.on("vscode:listProcesses",async c=>{const t=[];try{const i=await this.launchMainService.getMainProcessId();t.push({name:(0,v.localize)(0,null),rootProcess:await(0,S.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(a=>{(0,r.isRemoteDiagnosticError)(a)?t.push({name:a.hostName,rootProcess:a}):a.processes&&t.push({name:a.hostName,rootProcess:a.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(c,"vscode:listProcessesResponse",t)}),y.ipcMain.on("vscode:issueReporterClipboard",async c=>{const t={message:(0,v.localize)(1,null),type:"warning",buttons:[(0,v.localize)(2,null),(0,v.localize)(3,null)]};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(c,"vscode:issueReporterClipboardResponse",i.response===0)}}),y.ipcMain.on("vscode:issuePerformanceInfoRequest",async c=>{const t=await this.getPerformanceInfo();this.safeSend(c,"vscode:issuePerformanceInfoResponse",t)}),y.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const c={message:(0,v.localize)(4,null),type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(c,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),y.ipcMain.on("vscode:workbenchCommand",(c,t)=>{const{id:i,from:s,args:a}=t;let h;switch(s){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${s}`)}h&&h.webContents.send("vscode:runAction",{id:i,from:s,args:a})}),y.ipcMain.on("vscode:openExternal",(c,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),y.ipcMain.on("vscode:closeIssueReporter",c=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),y.ipcMain.on("vscode:closeProcessExplorer",c=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),y.ipcMain.on("vscode:windowsInfoRequest",async c=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(c,"vscode:windowsInfoResponse",t.windows)})}safeSend(c,t,...i){c.sender.isDestroyed()||c.sender.send(t,...i)}async openReporter(c){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=y.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,s,{backgroundColor:c.styles.backgroundColor,title:(0,v.localize)(7,null),zoomLevel:c.zoomLevel,alwaysOnTop:!1}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:c,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:L.default}),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,i.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,i.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(c){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=y.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const i=new o.DisposableStore,s=i.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,s,{backgroundColor:c.styles.backgroundColor,title:(0,v.localize)(8,null),zoomLevel:c.zoomLevel,alwaysOnTop:!0}),s.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:c,product:L.default}),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,i.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,i.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(c,t,i){const s=new y.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:c.width,height:c.height,minWidth:300,minHeight:200,x:c.x,y:c.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`,"--context-isolation"],v8CacheOptions:p.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return s.setMenuBarVisibility(!1),s}async getSystemStatus(){const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(c,t)}getWindowPosition(c,t,i){let s;const a=y.screen.getAllDisplays();if(a.length===1)s=a[0];else{if(p.isMacintosh){const g=y.screen.getCursorScreenPoint();s=y.screen.getDisplayNearestPoint(g)}!s&&c&&(s=y.screen.getDisplayMatching(c.getBounds())),s||(s=y.screen.getPrimaryDisplay()||a[0])}const h={width:t,height:i},f=s.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[c,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(c,t)}catch(c){throw this.logService.warn("issueService#getPerformanceInfo ",c.message),c}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=ce([ee(1,w.IEnvironmentMainService),ee(2,I.ILaunchMainService),ee(3,n.ILogService),ee(4,r.IDiagnosticsService),ee(5,E.IDialogMainService),ee(6,M.INativeHostMainService),ee(7,P.IProtocolMainService)],u),e.IssueMainService=u}),define(Q[230],J([0,1,7,148,72,5,8,14,25,6,17,21,61,2,3,34,29,52,50,197,60,31,51,39,201,18,98,24,10,54,26,41,55]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t,i,s,a,h,f,g,k,T,U,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var X;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(X||(X={}));let te=class extends b.Disposable{constructor(W,$,z,N,H,V,_,A,O,D,F,C,K,G,Y){super();this.logService=$,this.environmentMainService=z,this.fileService=N,this.configurationService=V,this.themeMainService=_,this.workspacesManagementMainService=A,this.backupMainService=O,this.telemetryService=D,this.dialogMainService=F,this.lifecycleMainService=C,this.nativeHostMainService=K,this.productService=G,this.protocolMainService=Y,this._onWillLoad=this._register(new y.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new y.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new y.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new y.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[Z,re]=this.restoreWindowState(W.state);this.windowState=Z,this.logService.trace("window#ctor: using window state",Z);const se=this.windowState.mode===0||this.windowState.mode===3,x=this.configurationService.getValue("window"),ne={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:E.WindowMinimumSize.WIDTH,minHeight:E.WindowMinimumSize.HEIGHT,show:!se,title:this.productService.nameLong,webPreferences:Object.assign({preload:g.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:this.environmentMainService.sandbox?[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`,"--context-isolation"]:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:d.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,E.zoomLevelToZoomFactor)(x==null?void 0:x.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1})};d.browserCodeLoadingCacheStrategy?this.logService.info(`window#ctor: using vscode-file:// protocol and V8 cache options: ${d.browserCodeLoadingCacheStrategy}`):this.logService.trace("window#ctor: vscode-file:// protocol is explicitly disabled"),d.isLinux?ne.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):d.isWindows&&!this.environmentMainService.isBuilt&&(ne.icon=(0,v.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),d.isMacintosh&&!this.useNativeFullScreen()&&(ne.fullscreenable=!1),d.isMacintosh&&(ne.acceptFirstMouse=!0,(x==null?void 0:x.clickThroughInactive)===!1&&(ne.acceptFirstMouse=!1));const ue=d.isMacintosh&&(x==null?void 0:x.nativeTabs)===!0;ue&&(ne.tabbingIdentifier=this.productService.nameShort);const be=(0,E.getTitleBarStyle)(this.configurationService)==="custom";if(be&&(ne.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,d.isMacintosh||(ne.frame=!1)),(0,L.mark)("code/willCreateCodeBrowserWindow"),this._win=new r.BrowserWindow(ne),(0,L.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),d.isMacintosh&&be&&this._win.setSheetOffset(22),d.isMacintosh&&re&&(!ue||r.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(me=>typeof me=="number")){const me=this.windowState;this._win.setBounds({width:me.width,height:me.height,x:me.x,y:me.y})}se&&((0,L.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,L.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:Z=>H.globalStorage.get(Z),store:(Z,re)=>H.globalStorage.set(Z,re)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var W;return(W=this.currentConfig)===null||W===void 0?void 0:W.backupPath}get openedWorkspace(){var W;return(W=this.currentConfig)===null||W===void 0?void 0:W.workspace}get remoteAuthority(){var W;return(W=this.currentConfig)===null||W===void 0?void 0:W.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var W;return!!((W=this.currentConfig)===null||W===void 0?void 0:W.extensionDevelopmentPath)}get isExtensionTestHost(){var W;return!!((W=this.currentConfig)===null||W===void 0?void 0:W.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var W;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((W=this.currentConfig)===null||W===void 0?void 0:W.debugId)}setRepresentedFilename(W){d.isMacintosh?this._win.setRepresentedFilename(W):this.representedFilename=W}getRepresentedFilename(){return d.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(W){d.isMacintosh&&this._win.setDocumentEdited(W),this.documentEdited=W}isDocumentEdited(){return d.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(W){d.isMacintosh&&(W==null?void 0:W.force)&&r.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(W=>{if(this.isReady)return W(this);this.whenReadyCallbacks.push(W)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(W=>{function $(){z.dispose(),N.dispose(),W()}const z=this.onDidClose(()=>$()),N=this.onWillLoad(()=>$())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,H)=>this.onWindowError(2,H)),this._win.webContents.on("did-fail-load",(N,H,V)=>this.onWindowError(3,V)),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const W=new Set([g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemoteResource,"devtools"]),$=N=>{for(let H=N;H;H=H.parent)if(H.url.startsWith(`${g.Schemas.vscodeWebview}://`))return!0;return!1};this._win.webContents.session.webRequest.onBeforeRequest((N,H)=>{const V=I.URI.parse(N.url);if(V.path.endsWith(".svg")&&!(W.has(V.scheme)||V.path.includes(g.Schemas.vscodeRemoteResource))){const A=$(N.frame);return H({cancel:!A})}return H({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((N,H)=>{const V=N.responseHeaders,_=V["content-type"]||V["Content-Type"];if(_&&Array.isArray(_)){const A=I.URI.parse(N.url);if(A.path.endsWith(".svg")&&W.has(A.scheme))return V["Content-Type"]=["image/svg+xml"],H({cancel:!1,responseHeaders:V});if(!A.path.includes(g.Schemas.vscodeRemoteResource)&&_.some(O=>O.toLowerCase().includes("image/svg"))){const O=$(N.frame);return H({cancel:!O})}}return H({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),d.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!0),r.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this.currentConfig&&(this.currentConfig.maximized=!1),r.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",T.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",T.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(N,H)=>{const V=await this.marketplaceHeadersPromise;H({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,V)})})}async onWindowError(W,$){var z;switch(W){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof $=="string"?$:$==null?void 0:$.reason}, code: ${typeof $=="string"?"<unknown>":(z=$==null?void 0:$.exitCode)!==null&&z!==void 0?z:"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof $=="string"?$:$==null?void 0:$.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:W,reason:typeof $!="string"?$==null?void 0:$.reason:void 0}),W===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const N=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,R.localize)(0,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(1,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(2,null))],message:(0,R.localize)(3,null),detail:(0,R.localize)(4,null),noLink:!0},this._win);if(!this._win)return;N.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):N.response===2&&this.destroyWindow()}else if(W===2){let N;typeof $=="string"||!$?N=(0,R.localize)(5,null):N=(0,R.localize)(6,null,$.reason);const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,R.localize)(7,null)),(0,i.mnemonicButtonLabel)((0,R.localize)(8,null))],message:N,detail:(0,R.localize)(9,null),noLink:!0},this._win);if(!this._win)return;H.response===0?this.reload():H.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(W){var $;(($=this.openedWorkspace)===null||$===void 0?void 0:$.id)===W.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const W=this.getMenuBarVisibility();W!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=W,this.setMenuBarVisibility(W));let $=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;($==null?void 0:$.endsWith("/"))&&($=$.substr(0,$.length-1));const z=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if(($||"").indexOf("@")===-1&&($!==this.currentHttpProxy||z!==this.currentNoProxy)){this.currentHttpProxy=$,this.currentNoProxy=z;const N=$||"",H=z?`${z},<local>`:"<local>";this.logService.trace(`Setting proxy to '${N}', bypassing '${H}'`),this._win.webContents.session.setProxy({proxyRules:N,proxyBypassRules:H,pacScript:""})}}addTabbedWindow(W){d.isMacintosh&&W.win&&this._win.addTabbedWindow(W.win)}load(W,$=Object.create(null)){this.isDocumentEdited()&&(!$.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),$.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(W,$),this.readyState===0?this.currentConfig=W:(this.pendingLoadConfig=W,this.readyState=2),this._win.loadURL(g.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:W.workspace})}updateConfiguration(W,$){var z,N;const H=(N=(z=this.currentConfig)!==null&&z!==void 0?z:this.pendingLoadConfig)===null||N===void 0?void 0:N.userEnv;H&&(0,k.isLaunchedFromCli)(H)&&!(0,k.isLaunchedFromCli)(W.userEnv)&&(W.userEnv=Object.assign(Object.assign({},H),W.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(W.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),$.disableExtensions!==void 0&&(W["disable-extensions"]=$.disableExtensions),W.fullscreen=this.isFullScreen,W.maximized=this._win.isMaximized(),W.partsSplash=this.themeMainService.getWindowSplash(),(0,L.mark)("code/willOpenNewWindow"),W.perfMarks=(0,L.getMarks)(),this.configObjectUrl.update(W)}async reload(W){const $=Object.assign({},this.currentConfig);$.workspace=await this.validateWorkspace($),delete $.filesToOpenOrCreate,delete $.filesToDiff,delete $.filesToWait,this.isExtensionDevelopmentHost&&W&&($.verbose=W.verbose,$.debugId=W.debugId,$["inspect-extensions"]=W["inspect-extensions"],$["inspect-brk-extensions"]=W["inspect-brk-extensions"],$["extensions-dir"]=W["extensions-dir"]),$.isInitialStartup=!1,this.load($,{isReload:!0,disableExtensions:W==null?void 0:W["disable-extensions"]})}async validateWorkspace(W){if((0,M.isWorkspaceIdentifier)(W.workspace)){const $=W.workspace.configPath;if($.scheme===g.Schemas.file&&!await this.fileService.exists($))return}else if((0,M.isSingleFolderWorkspaceIdentifier)(W.workspace)){const $=W.workspace.uri;if($.scheme===g.Schemas.file&&!await this.fileService.exists($))return}return W.workspace}serializeWindowState(){if(!this._win)return(0,m.defaultWindowState)();if(this.isFullScreen){let z;try{z=r.screen.getDisplayMatching(this.getBounds())}catch(V){}const N=(0,m.defaultWindowState)();return{mode:3,display:z?z.id:void 0,width:this.windowState.width||N.width,height:this.windowState.height||N.height,x:this.windowState.x||0,y:this.windowState.y||0}}const W=Object.create(null);let $;if(!d.isMacintosh&&this._win.isMaximized()?$=0:$=1,$===0?W.mode=0:W.mode=1,$===1||$===0){let z;$===1?z=this.getBounds():z=this._win.getNormalBounds(),W.x=z.x,W.y=z.y,W.width=z.width,W.height=z.height}return W}restoreWindowState(W){(0,L.mark)("code/willRestoreCodeWindowState");let $=!1;if(W)try{const z=r.screen.getAllDisplays();$=z.length>1,W=this.validateWindowState(W,z)}catch(z){this.logService.warn(`Unexpected error validating window state: ${z}
${z.stack}`)}return(0,L.mark)("code/didRestoreCodeWindowState"),[W||(0,m.defaultWindowState)(),$]}validateWindowState(W,$){var z,N;if(this.logService.trace(`window#validateWindowState: validating window state on ${$.length} display(s)`,W),typeof W.x!="number"||typeof W.y!="number"||typeof W.width!="number"||typeof W.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(W.width<=0||W.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if($.length===1){const A=this.getWorkingArea($[0]);if(A){this.logService.trace("window#validateWindowState: 1 monitor working area",A);function H(){!W||typeof W.x!="number"||typeof W.y!="number"||!A||(W.x<A.x&&(W.x=A.x),W.y<A.y&&(W.y=A.y))}H(),W.width>A.width&&(W.width=A.width),W.height>A.height&&(W.height=A.height),W.x>A.x+A.width-128&&(W.x=A.x+A.width-W.width),W.y>A.y+A.height-128&&(W.y=A.y+A.height-W.height),H()}return W}if(W.display&&W.mode===3){const A=$.find(O=>O.id===W.display);if(A&&typeof((z=A.bounds)===null||z===void 0?void 0:z.x)=="number"&&typeof((N=A.bounds)===null||N===void 0?void 0:N.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const O=(0,m.defaultWindowState)(3);return O.x=A.bounds.x,O.y=A.bounds.y,O}}let V,_;try{V=r.screen.getDisplayMatching({x:W.x,y:W.y,width:W.width,height:W.height}),_=this.getWorkingArea(V)}catch(A){}if(V&&_&&W.x+W.width>_.x&&W.y+W.height>_.y&&W.x<_.x+_.width&&W.y<_.y+_.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",_),W}getWorkingArea(W){if(W.workArea.width>0&&W.workArea.height>0)return W.workArea;if(W.bounds.width>0&&W.bounds.height>0)return W.bounds}getBounds(){const[W,$]=this._win.getPosition(),[z,N]=this._win.getSize();return{x:W,y:$,width:z,height:N}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(W){this.useNativeFullScreen()?this.setNativeFullScreen(W):this.setSimpleFullScreen(W),this.sendWhenReady(W?"vscode:enterFullScreen":"vscode:leaveFullScreen",T.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(W){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(W)}setSimpleFullScreen(W){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(W),this._win.webContents.focus()}useNativeFullScreen(){const W=this.configurationService.getValue("window");return!W||typeof W.nativeFullScreen!="boolean"||W.nativeTabs?!0:W.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let W=(0,E.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(W)<0&&(W="classic"),W}setMenuBarVisibility(W,$=!0){d.isMacintosh||(W==="toggle"&&$&&this.send("vscode:showInfoMessage",(0,R.localize)(10,null)),W==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(W)}):this.doSetMenuBarVisibility(W))}doSetMenuBarVisibility(W){const $=this.isFullScreen;switch(W){case"classic":this._win.setMenuBarVisibility(!$),this._win.autoHideMenuBar=$;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.isMacintosh)switch(r.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(W,$,...z){this.isReady?this.send(W,...z):this.ready().then(()=>{$.isCancellationRequested||this.send(W,...z)})}send(W,...$){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${W} for window that is destroyed`);return}this._win.webContents.send(W,...$)}}updateTouchBar(W){!d.isMacintosh||this.touchBarGroups.forEach(($,z)=>{const N=W[z];$.segments=this.createTouchBarGroupSegments(N)})}createTouchBar(){if(!!d.isMacintosh){for(let W=0;W<10;W++){const $=this.createTouchBarGroup();this.touchBarGroups.push($)}this._win.setTouchBar(new r.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(W=[]){const $=this.createTouchBarGroupSegments(W),z=new r.TouchBar.TouchBarSegmentedControl({segments:$,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",T.CancellationToken.None,{id:z.segments[N].id,from:"touchbar"})}});return z}createTouchBarGroupSegments(W=[]){return W.map(z=>{var N,H;let V;z.icon&&!s.ThemeIcon.isThemeIcon(z.icon)&&((H=(N=z.icon)===null||N===void 0?void 0:N.dark)===null||H===void 0?void 0:H.scheme)===g.Schemas.file&&(V=r.nativeImage.createFromPath(I.URI.revive(z.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let _;return typeof z.title=="string"?_=z.title:_=z.title.value,{id:z.id,label:V?void 0:_,icon:V}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};te=ce([ee(1,p.ILogService),ee(2,w.IEnvironmentMainService),ee(3,f.IFileService),ee(4,h.IStorageMainService),ee(5,n.IConfigurationService),ee(6,l.IThemeMainService),ee(7,P.IWorkspacesManagementMainService),ee(8,o.IBackupMainService),ee(9,c.ITelemetryService),ee(10,t.IDialogMainService),ee(11,a.ILifecycleMainService),ee(12,U.INativeHostMainService),ee(13,S.IProductService),ee(14,B.IProtocolMainService)],te),e.CodeWindow=te}),define(Q[62],J([0,1,151,35,38,14,6,39,5,3,29,52,9,15,8,10,16,18,4,2]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,o.createDecorator)("workspacesHistoryMainService");let l=class je extends u.Disposable{constructor(f,g,k,T){super();this.stateMainService=f,this.logService=g,this.workspacesManagementMainService=k,this.lifecycleMainService=T,this._onDidChangeRecentlyOpened=this._register(new w.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!p.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const g=[],k=[];for(let T of f)if((0,n.isRecentWorkspace)(T))!this.workspacesManagementMainService.isUntitledWorkspace(T.workspace)&&i(g,T.workspace)===-1&&g.push(T);else if((0,n.isRecentFolder)(T))s(g,T.folderUri)===-1&&g.push(T);else{const U=a(k,T.fileUri)>=0,B=T.fileUri.scheme===m.Schemas.file&&je.COMMON_FILES_FILTER.indexOf((0,b.basename)(T.fileUri))>=0;!U&&!B&&(k.push(T),p.isWindows&&T.fileUri.scheme===m.Schemas.file&&y.app.addRecentDocument(T.fileUri.fsPath))}this.addEntriesFromStorage(g,k),g.length>je.MAX_TOTAL_RECENT_ENTRIES&&(g.length=je.MAX_TOTAL_RECENT_ENTRIES),k.length>je.MAX_TOTAL_RECENT_ENTRIES&&(k.length=je.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:g,files:k}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const g=B=>{const X=t(B);for(const te of f)if(b.extUriBiasedIgnorePathCase.isEqual(te,X))return!1;return!0},k=this.getRecentlyOpened(),T=k.workspaces.filter(g),U=k.files.filter(g);(T.length!==k.workspaces.length||U.length!==k.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:T}),this._onDidChangeRecentlyOpened.fire(),p.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!p.isMacintosh){y.app.clearRecentDocuments();const f=this.getRecentlyOpened(),g=[];let k=0;for(let U=0;U<f.workspaces.length&&k<je.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const B=t(f.workspaces[U]);if(B.scheme===m.Schemas.file){const X=(0,b.originalFSPath)(B);await(0,M.exists)(X)&&(g.push(X),k++)}}const T=[];for(let U=0;U<f.files.length&&k<je.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const B=t(f.files[U]);if(B.scheme===m.Schemas.file){const X=(0,b.originalFSPath)(B);if(je.COMMON_FILES_FILTER.includes((0,b.basename)(B))||g.includes(X))continue;await(0,M.exists)(X)&&(T.push(X),k++)}}T.reverse().forEach(U=>y.app.addRecentDocument(U)),g.reverse().forEach(U=>y.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),y.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var g,k;const T=[],U=[],B=(g=f==null?void 0:f.config)===null||g===void 0?void 0:g.workspace;(0,n.isWorkspaceIdentifier)(B)&&!this.workspacesManagementMainService.isUntitledWorkspace(B)?T.push({workspace:B}):(0,n.isSingleFolderWorkspaceIdentifier)(B)&&T.push({folderUri:B.uri});const X=(k=f==null?void 0:f.config)===null||k===void 0?void 0:k.filesToOpenOrCreate;if(X)for(let te of X){const oe=te.fileUri;oe&&a(U,oe)===-1&&U.push({fileUri:oe})}return this.addEntriesFromStorage(T,U),{workspaces:T,files:U}}addEntriesFromStorage(f,g){let k=this.getRecentlyOpenedFromStorage();for(let T of k.workspaces){let U=(0,n.isRecentFolder)(T)?s(f,T.folderUri):i(f,T.workspace);U>=0?f[U].label=f[U].label||T.label:f.push(T)}for(let T of k.files){let U=a(g,T.fileUri);U>=0?g[U].label=g[U].label||T.label:g.push(T)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem(je.recentlyOpenedStorageKey);return(0,n.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const g=(0,n.toStoreData)(f);this.stateMainService.setItem(je.recentlyOpenedStorageKey,g)}updateWindowsJumpList(){if(!!p.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let g=[];for(let U of y.app.getJumpListSettings().removedItems){const B=U.args;if(B){const X=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(B);X&&g.push(d.URI.parse(X[2]))}}this.removeRecentlyOpened(g);let k=!1;const T=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const B=(0,n.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:X,description:te}=this.getWindowsJumpListLabel(B,U.label);let oe;return d.URI.isUri(B)?oe=`--folder-uri "${B.toString()}"`:(k=!0,oe=`--file-uri "${B.configPath.toString()}"`),{type:"task",title:X.substr(0,255),description:te.substr(0,255),program:process.execPath,args:oe,iconPath:"explorer.exe",iconIndex:0}}));T.length>0&&f.push({type:"custom",name:k?(0,v.localize)(2,null):(0,v.localize)(3,null),items:T})}f.push({type:"recent"});try{y.app.setJumpList(f)}catch(g){this.logService.warn("updateWindowsJumpList#setJumpList",g)}}}getWindowsJumpListLabel(f,g){if(g)return{title:(0,r.splitName)(g).name,description:g};if(d.URI.isUri(f))return{title:(0,b.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,v.localize)(4,null),description:""};let k=(0,b.basename)(f.configPath);return k.endsWith(n.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-n.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,k),description:c(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=ce([ee(0,L.IStateMainService),ee(1,I.ILogService),ee(2,S.IWorkspacesManagementMainService),ee(3,P.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function c(h){return h.scheme==="file"?(0,r.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,n.isRecentFolder)(h)?h.folderUri:(0,n.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function i(h,f){return h.findIndex(g=>(0,n.isRecentWorkspace)(g)&&g.workspace.id===f.id)}function s(h,f){return h.findIndex(g=>(0,n.isRecentFolder)(g)&&b.extUriBiasedIgnorePathCase.isEqual(g.folderUri,f))}function a(h,f){return h.findIndex(g=>b.extUriBiasedIgnorePathCase.isEqual(g.fileUri,f))}}),define(Q[231],J([0,1,144,3,25,14,61,17,31,40,21,9,6,39,34,62,179,8,38,18,41,26]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let i=class wt{constructor(h,f,g,k,T,U,B,X,te,oe,W){this.updateService=h,this.configurationService=f,this.windowsMainService=g,this.environmentMainService=k,this.telemetryService=T,this.workspacesHistoryMainService=U,this.stateMainService=B,this.lifecycleMainService=X,this.logService=te,this.nativeHostMainService=oe,this.productService=W,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new S.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new S.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,I.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateMainService.getItem(wt.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,B,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:B==null?void 0:B.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,B,X)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:B==null?void 0:B.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,B,X)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,B,X)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(X),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const g=this.productService.reportIssueUrl;g&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(g,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const U=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${U}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const T=this.productService.privacyStatementUrl;T&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const U=k.indexOf("?")>0?"&":"?";this.openUrl(`${T}${U}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(T,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateMainService.setItem(wt.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!R.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!y.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=y.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){y.Menu.setApplicationMenu(R.isMacintosh?new y.Menu:null);return}const f=new y.Menu;let g;if(R.isMacintosh){const F=new y.Menu;g=new y.MenuItem({label:this.productService.nameShort,submenu:F}),this.setMacApplicationMenu(F),f.append(g)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const F=new y.Menu;F.append(new y.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),y.app.dock.setMenu(F)}const k=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:k});this.setMenuById(k,"File"),f.append(T);const U=new y.Menu,B=new y.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(B);const X=new y.Menu,te=new y.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:X});this.setMenuById(X,"Selection"),f.append(te);const oe=new y.Menu,W=new y.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:oe});this.setMenuById(oe,"View"),f.append(W);const $=new y.Menu,z=new y.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:$});this.setMenuById($,"Go"),f.append(z);const N=new y.Menu,H=new y.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:N});this.setMenuById(N,"Run"),f.append(H);const V=new y.Menu,_=new y.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:V});this.setMenuById(V,"Terminal"),f.append(_);let A;if(this.shouldDrawMenu("Window")){const F=new y.Menu;A=new y.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:F,role:"window"}),this.setMacWindowMenu(F)}A&&f.append(A);const O=new y.Menu,D=new y.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:O,role:"help"});this.setMenuById(O,"Help"),f.append(D),f.items&&f.items.length>0?y.Menu.setApplicationMenu(f):y.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),g=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const $=new y.Menu;this.setMenuById($,"Preferences"),k=new y.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:$})}const T=new y.Menu,U=new y.MenuItem({label:v.localize(12,null),role:"services",submenu:T}),B=new y.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),X=new y.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),te=new y.MenuItem({label:v.localize(15,null),role:"unhide"}),oe=new y.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const $=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!y.BrowserWindow.getFocusedWindow()||($==null?void 0:$.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),W=[f];W.push(...g),k&&W.push(s(),k),W.push(s(),U,s(),B,X,te,s(),oe),W.forEach($=>h.append($))}shouldDrawMenu(h){if(!R.isMacintosh&&(0,I.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(g=>{if((0,M.isMenubarMenuItemSeparator)(g))h.append(s());else if((0,M.isMenubarMenuItemSubmenu)(g)){const k=new y.Menu,T=new y.MenuItem({label:this.mnemonicLabel(g.label),submenu:k});this.setMenu(k,g.submenu.items),h.append(T)}else(0,M.isMenubarMenuItemRecentAction)(g)?h.append(this.createOpenRecentMenuItem(g)):(0,M.isMenubarMenuItemAction)(g)&&(g.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[g.id]?h.append(new y.MenuItem(this.likeAction(g.id,{label:this.mnemonicLabel(g.label),click:this.fallbackMenuHandlers[g.id]}))):h.append(this.createMenuItem(g.label,g.id,!1,g.checked)):h.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)):h.append(this.createMenuItem(g.label,g.id,g.enabled!==!1,!!g.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(g=>h.append(g)),h.append(s()))}createOpenRecentMenuItem(h){const f=P.URI.revive(h.uri),g=h.id,k=g==="openRecentFile"?{fileUri:f}:g==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new y.MenuItem(this.likeAction(g,{label:h.label,click:(T,U,B)=>{const X=this.isOptionClick(B);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:X,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!R.isMacintosh&&(h.ctrlKey||h.shiftKey)||R.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,g){const k={label:this.mnemonicLabel(h),role:g,enabled:!0};return new y.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(h){const f=new y.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),g=new y.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new y.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),T=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(s()),U.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,g,s(),T,...U,s(),k].forEach(B=>h.append(B))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new y.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new y.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new y.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new y.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new y.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new y.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new y.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,g,k){const T=this.mnemonicLabel(h),U=typeof f=="function"?f:(W,$,z)=>{const N=W?W.userSettingsLabel:null;let H=f;Array.isArray(f)&&(H=this.isOptionClick(z)?f[1]:f[0]),N&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:N}):this.runActionInRenderer({type:"commandId",commandId:H})},B=typeof g=="boolean"?g:this.windowsMainService.getWindowCount()>0,X=typeof k=="boolean"?k:!1,te={label:T,click:U,enabled:B};X&&(te.type="checkbox",te.checked=X);let oe;return typeof f=="string"?oe=f:Array.isArray(f)&&(oe=f[0]),R.isMacintosh&&(oe==="editor.action.clipboardCutAction"?te.role="cut":oe==="editor.action.clipboardCopyAction"?te.role="copy":oe==="editor.action.clipboardPasteAction"&&(te.role="paste"),oe==="undo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:W=>W.undo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("undo:")}):oe==="redo"?te.click=this.makeContextAwareClickHandler(U,{inDevTools:W=>W.redo(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("redo:")}):oe==="editor.action.selectAll"&&(te.click=this.makeContextAwareClickHandler(U,{inDevTools:W=>W.selectAll(),inNoWindow:()=>y.Menu.sendActionToFirstResponder("selectAll:")}))),new y.MenuItem(this.withKeybinding(oe,te))}makeContextAwareClickHandler(h,f){return(g,k,T)=>{const U=y.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);h(g,k||U,T)}}runActionInRenderer(h){let f=y.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();(k==null?void 0:k.isMinimized())&&(f=k.win)}const g=f?this.windowsMainService.getWindowById(f.id):void 0;if(g){if(this.logService.trace("menubar#runActionInRenderer",h),R.isMacintosh&&!this.environmentMainService.isBuilt&&!g.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const k={id:h.commandId,from:"menu"};g.sendWhenReady("vscode:runAction",c.CancellationToken.None,k)}else{const k={userSettingsLabel:h.userSettingsLabel};g.sendWhenReady("vscode:runKeybinding",c.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const g=typeof h=="string"?this.keybindings[h]:void 0;if(g==null?void 0:g.label){if(g.isNative!==!1)f.accelerator=g.label,f.userSettingsLabel=g.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${g.label}]`:f.label=`${f.label} [${g.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,g=!f.accelerator){g&&(f=this.withKeybinding(h,f));const k=f.click;return f.click=(T,U,B)=>{this.reportMenuActionTelemetry(h),k&&k(T,U,B)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,b.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};i.lastKnownMenubarStorageKey="lastKnownMenubarData",i=ce([ee(0,p.IUpdateService),ee(1,r.IConfigurationService),ee(2,d.IWindowsMainService),ee(3,L.IEnvironmentMainService),ee(4,w.ITelemetryService),ee(5,m.IWorkspacesHistoryMainService),ee(6,o.IStateMainService),ee(7,u.ILifecycleMainService),ee(8,E.ILogService),ee(9,l.INativeHostMainService),ee(10,n.IProductService)],i),e.Menubar=i;function s(){return new y.MenuItem({type:"separator"})}}),define(Q[232],J([0,1,231,6,4,18]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,L.createDecorator)("menubarMainService");let I=class{constructor(w,p,n){this.instantiationService=w,this.lifecycleMainService=p,this.logService=n,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(w,p){this.logService.trace("menubarService#updateMenubar",w),(await this.menubar).updateMenu(p,w)}};I=ce([ee(0,L.IInstantiationService),ee(1,y.ILifecycleMainService),ee(2,R.ILogService)],I),e.MenubarMainService=I}),define(Q[233],J([0,1,20,27,47,72,7,149,35,50,25,38,230,14,18,17,6,61,99,5,21,62,3,29,4,10,8,15,73,213,52,42,2,51,13,30,39,26,24,32,55]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t,i,s,a,h,f,g,k,T,U,B,X,te,oe,W,$,z,N,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(O){return(0,i.isWorkspaceIdentifier)(O==null?void 0:O.workspace)}function _(O){return(0,i.isSingleFolderWorkspaceIdentifier)(O==null?void 0:O.workspace)}let A=class et extends B.Disposable{constructor(D,F,C,K,G,Y,Z,re,se,x,ne,ue,be,me,Ee){super();this.machineId=D,this.initialUserEnv=F,this.logService=C,this.stateMainService=K,this.environmentMainService=G,this.lifecycleMainService=Y,this.backupMainService=Z,this.configurationService=re,this.workspacesHistoryMainService=se,this.workspacesManagementMainService=x,this.instantiationService=ne,this.dialogMainService=ue,this.fileService=be,this.productService=me,this.protocolMainService=Ee,this._onDidOpenWindow=this._register(new u.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new u.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new u.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new u.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new k.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(D=>this._onDidSignalReadyWindow.fire(D.window))),this._register(this.onDidSignalReadyWindow(D=>{var F,C;if(((F=D.config)===null||F===void 0?void 0:F.extensionDevelopmentPath)||((C=D.config)===null||C===void 0?void 0:C.extensionTestsPath)){const K=new B.DisposableStore;if(K.add(u.Event.any(D.onDidClose,D.onDidDestroy)(()=>K.dispose())),D.config.extensionDevelopmentPath)for(const G of D.config.extensionDevelopmentPath)K.add(this.protocolMainService.addValidFileRoot(h.URI.file(G)));D.config.extensionTestsPath&&K.add(this.protocolMainService.addValidFileRoot(h.URI.file(D.config.extensionTestsPath)))}}))}openEmptyWindow(D,F){let C=this.environmentMainService.args;const K=(F==null?void 0:F.remoteAuthority)||void 0,G=!0,Y=F==null?void 0:F.forceReuseWindow,Z=!Y;return this.open(Object.assign(Object.assign({},D),{cli:C,forceEmpty:G,forceNewWindow:Z,forceReuseWindow:Y,remoteAuthority:K}))}open(D){this.logService.trace("windowsManager#open"),D.addMode&&(D.initialStartup||!this.getLastActiveWindow())&&(D.addMode=!1);const F=[],C=[],K=[],G=[],Y=[];let Z,re=0;const se=this.getPathsToOpen(D);this.logService.trace("windowsManager#open pathsToOpen",se);for(const me of se)_(me)?D.addMode?F.push(me):C.push(me):V(me)?K.push(me):me.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:me.remoteAuthority}),Z.filesToOpenOrCreate.push(me)):me.backupPath?Y.push({backupFolder:(0,I.basename)(me.backupPath),remoteAuthority:me.remoteAuthority}):re++;D.diffMode&&(Z==null?void 0:Z.filesToOpenOrCreate.length)===2&&(Z.filesToDiff=Z.filesToOpenOrCreate,Z.filesToOpenOrCreate=[]),Z&&D.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:D.waitMarkerFileURI}),D.initialStartup?(G.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),K.push(...G),Y.push(...this.backupMainService.getEmptyWindowBackupPaths())):Y.length=0;const{windows:x,filesOpenedInWindow:ne}=this.doOpen(D,K,C,Y,re,Z,F);if(this.logService.trace(`windowsManager#open used window count ${x.length} (workspacesToOpen: ${K.length}, foldersToOpen: ${C.length}, emptyToRestore: ${Y.length}, emptyToOpen: ${re})`),x.length>1)if(ne)ne.focus();else{const me=this.windowsStateHandler.state.lastActiveWindow&&!D.forceEmpty&&!D.cli._.length&&!D.cli["file-uri"]&&!D.cli["folder-uri"]&&!(D.urisToOpen&&D.urisToOpen.length);let Ee=!0,Le=!0;if(me){const we=x.filter(ve=>this.windowsStateHandler.state.lastActiveWindow&&ve.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Ee=!1,Le=!1)}if(Ee)for(let we=x.length-1;we>=0;we--){const ve=x[we];if(!(ve.openedWorkspace&&G.some(Ie=>ve.openedWorkspace&&Ie.workspace.id===ve.openedWorkspace.id)||ve.backupPath&&Y.some(Ie=>ve.backupPath&&Ie.backupFolder===(0,I.basename)(ve.backupPath)))){ve.focus(),Le=!1;break}}Le&&x[x.length-1].focus()}const ue=Z&&Z.filesToDiff.length>0;if(!x.some(me=>me.isExtensionDevelopmentHost)&&!ue&&!D.noRecentEntry){const me=[];for(const Ee of se)V(Ee)?me.push({label:Ee.label,workspace:Ee.workspace,remoteAuthority:Ee.remoteAuthority}):_(Ee)?me.push({label:Ee.label,folderUri:Ee.workspace.uri,remoteAuthority:Ee.remoteAuthority}):Ee.fileUri&&me.push({label:Ee.label,fileUri:Ee.fileUri,remoteAuthority:Ee.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(me)}const be=D.waitMarkerFileURI;return D.context===0&&be&&x.length===1&&x[0]&&(async()=>{await x[0].whenClosedOrLoaded;try{await this.fileService.del(be)}catch(me){}})(),x}doOpen(D,F,C,K,G,Y,Z){const re=[];let se;function x(we,ve){re.push(we),ve&&(se=we,Y=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ue}=this.shouldOpenNewWindow(D);if(!D.initialStartup&&Z.length>0){const we=Z[0].remoteAuthority,ve=this.getLastActiveWindowForAuthority(we);ve&&x(this.doAddFoldersToExistingWindow(ve,Z.map(Ie=>Ie.workspace.uri)))}const be=C.length+F.length+K.length;if(Y&&be===0){const we=Y.filesToOpenOrCreate[0]||Y.filesToDiff[0],ve=this.getWindows().filter(Re=>Y&&Re.remoteAuthority===Y.remoteAuthority);let Ie;(we==null?void 0:we.fileUri)&&!ue&&((D.context===4||D.context===0||D.context===1)&&(Ie=(0,o.findWindowOnFile)(ve,we.fileUri,Re=>Re.configPath.scheme===a.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Re.configPath):void 0)),Ie||(Ie=this.doGetLastActiveWindow(ve))),Ie?(0,i.isWorkspaceIdentifier)(Ie.openedWorkspace)?F.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):(0,i.isSingleFolderWorkspaceIdentifier)(Ie.openedWorkspace)?C.push({workspace:Ie.openedWorkspace,remoteAuthority:Ie.remoteAuthority}):x(this.doOpenFilesInExistingWindow(D,Ie,Y),!0):x(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Y,forceNewWindow:!0,remoteAuthority:Y.remoteAuthority,forceNewTabbedWindow:D.forceNewTabbedWindow}),!0)}const me=(0,w.distinct)(F,we=>we.workspace.id);if(me.length>0){const we=(0,w.coalesce)(me.map(ve=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.configPath)));if(we.length>0){const ve=we[0],Ie=(Y==null?void 0:Y.remoteAuthority)===ve.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(D,ve,Ie),!!Ie),ne=!0}me.forEach(ve=>{if(!we.some(_e=>_e.openedWorkspace&&_e.openedWorkspace.id===ve.workspace.id)){const Ie=ve.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;x(this.doOpenFolderOrWorkspace(D,ve,ne,Re),!!Re),ne=!0}})}const Ee=(0,w.distinct)(C,we=>f.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Ee.length>0){const we=(0,w.coalesce)(Ee.map(ve=>(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ve.workspace.uri)));if(we.length>0){const ve=we[0],Ie=(Y==null?void 0:Y.remoteAuthority)===ve.remoteAuthority?Y:void 0;x(this.doOpenFilesInExistingWindow(D,ve,Ie),!!Ie),ne=!0}Ee.forEach(ve=>{if(!we.some(_e=>(0,i.isSingleFolderWorkspaceIdentifier)(_e.openedWorkspace)&&f.extUriBiasedIgnorePathCase.isEqual(_e.openedWorkspace.uri,ve.workspace.uri))){const Ie=ve.remoteAuthority,Re=(Y==null?void 0:Y.remoteAuthority)===Ie?Y:void 0;x(this.doOpenFolderOrWorkspace(D,ve,ne,Re),!!Re),ne=!0}})}const Le=(0,w.distinct)(K,we=>we.backupFolder);if(Le.length>0&&Le.forEach(we=>{const ve=we.remoteAuthority,Ie=(Y==null?void 0:Y.remoteAuthority)===ve?Y:void 0;x(this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,filesToOpen:Ie,remoteAuthority:ve,forceNewWindow:!0,forceNewTabbedWindow:D.forceNewTabbedWindow,emptyWindowBackupInfo:we}),!!Ie),ne=!0}),re.length===0||Y){Y&&!G&&G++;const we=Y?Y.remoteAuthority:D.remoteAuthority;for(let ve=0;ve<G;ve++)x(this.doOpenEmpty(D,ne,we,Y),!!Y),ne=!0}return{windows:(0,w.distinct)(re),filesOpenedInWindow:se}}doOpenFilesInExistingWindow(D,F,C){var K;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),F.focus();const G={filesToOpenOrCreate:C==null?void 0:C.filesToOpenOrCreate,filesToDiff:C==null?void 0:C.filesToDiff,filesToWait:C==null?void 0:C.filesToWait,termProgram:(K=D==null?void 0:D.userEnv)===null||K===void 0?void 0:K.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",$.CancellationToken.None,G),F}doAddFoldersToExistingWindow(D,F){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),D.focus();const C={foldersToAdd:F};return D.sendWhenReady("vscode:addFolders",$.CancellationToken.None,C),D}doOpenEmpty(D,F,C,K,G){return!F&&!G&&typeof D.contextWindowId=="number"&&(G=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:C,forceNewWindow:F,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}doOpenFolderOrWorkspace(D,F,C,K,G){return!C&&!G&&typeof D.contextWindowId=="number"&&(G=this.getWindowById(D.contextWindowId)),this.openInBrowserWindow({workspace:F.workspace,userEnv:D.userEnv,cli:D.cli,initialStartup:D.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:C,forceNewTabbedWindow:D.forceNewTabbedWindow,filesToOpen:K,windowToUse:G})}getPathsToOpen(D){var F;let C,K=!1,G=!1;if(D.urisToOpen&&D.urisToOpen.length>0?(C=this.doExtractPathsFromAPI(D),K=!0):D.forceEmpty?C=[Object.create(null)]:D.cli._.length||D.cli["folder-uri"]||D.cli["file-uri"]?(C=this.doExtractPathsFromCLI(D.cli),C.length===0&&C.push(Object.create(null)),K=!0):(C=this.doGetPathsFromLastSession(),C.length===0&&C.push(Object.create(null)),G=!0),!D.addMode&&K){const Y=C.filter(Z=>_(Z));if(Y.length>1){const Z=Y[0].remoteAuthority;if(Y.every(re=>re.remoteAuthority===Z)){const re=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(se=>({uri:se.workspace.uri})));C.push({workspace:re,remoteAuthority:Z}),C=C.filter(se=>!_(se))}}}return D.initialStartup&&!G&&((F=this.configurationService.getValue("window"))===null||F===void 0?void 0:F.restoreWindows)==="preserve"&&C.unshift(...this.doGetPathsFromLastSession().filter(Y=>V(Y)||_(Y)||Y.backupPath)),C}doExtractPathsFromAPI(D){const F=[],C={gotoLineMode:D.gotoLineMode,remoteAuthority:D.remoteAuthority};for(const K of(0,w.coalesce)(D.urisToOpen||[])){const G=this.resolveOpenable(K,C);if(G)G.label=K.label,F.push(G);else{const Y=this.resourceFromOpenable(K),Z={title:this.productService.nameLong,type:"info",buttons:[(0,r.localize)(0,null)],message:Y.scheme===a.Schemas.file?(0,r.localize)(1,null):(0,r.localize)(2,null),detail:Y.scheme===a.Schemas.file?(0,r.localize)(3,null,(0,W.getPathLabel)(Y.fsPath,this.environmentMainService)):(0,r.localize)(4,null,Y.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,te.withNullAsUndefined)(b.BrowserWindow.getFocusedWindow()))}}return F}doExtractPathsFromCLI(D){const F=[],C={ignoreFileNotFound:!0,gotoLineMode:D.goto,remoteAuthority:D.remote||void 0,forceOpenWorkspaceAsFile:!1},K=D["folder-uri"];if(K)for(const Z of K){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable({folderUri:re},C);se&&F.push(se)}}const G=D["file-uri"];if(G)for(const Z of G){const re=this.cliArgToUri(Z);if(re){const se=this.resolveOpenable((0,i.hasWorkspaceFileExtension)(Z)?{workspaceUri:re}:{fileUri:re},C);se&&F.push(se)}}const Y=D._;for(const Z of Y){const re=C.remoteAuthority?this.doResolvePathRemote(Z,C):this.doResolveFilePath(Z,C);re&&F.push(re)}return F}cliArgToUri(D){try{const F=h.URI.parse(D);if(!F.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${D}`);return}return F}catch(F){this.logService.error(`Invalid URI input string: ${D}, ${F.message}`)}}doGetPathsFromLastSession(){const D=this.getRestoreWindowsSetting();switch(D){case"none":return[];case"one":case"all":case"preserve":case"folders":const F=[];D!=="one"&&F.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&F.push(this.windowsStateHandler.state.lastActiveWindow);const C=[];for(const K of F)if(K.workspace){const G=this.resolveOpenable({workspaceUri:K.workspace.configPath},{remoteAuthority:K.remoteAuthority});V(G)&&C.push(G)}else if(K.folderUri){const G=this.resolveOpenable({folderUri:K.folderUri},{remoteAuthority:K.remoteAuthority});_(G)&&C.push(G)}else D!=="folders"&&K.backupPath&&C.push({backupPath:K.backupPath,remoteAuthority:K.remoteAuthority});return C}}getRestoreWindowsSetting(){let D;if(this.lifecycleMainService.wasRestarted)D="all";else{const F=this.configurationService.getValue("window");D=(F==null?void 0:F.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(D)||(D="all")}return D}resolveOpenable(D,F={}){let C=this.resourceFromOpenable(D);return C.scheme===a.Schemas.file?((0,P.isFileToOpen)(D)&&(F=Object.assign(Object.assign({},F),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(C.fsPath,F)):this.doResolveRemoteOpenable(D,F)}doResolveRemoteOpenable(D,F){let C=this.resourceFromOpenable(D);const K=(0,g.getRemoteAuthority)(C)||F.remoteAuthority;if(C=(0,f.removeTrailingPathSeparator)((0,f.normalizePath)(C)),(0,P.isFileToOpen)(D)){if(F.gotoLineMode){const{path:G,line:Y,column:Z}=(0,oe.parseLineAndColumnAware)(C.path);return{fileUri:C.with({path:G}),lineNumber:Y,columnNumber:Z,remoteAuthority:K}}return{fileUri:C,remoteAuthority:K}}else if((0,P.isWorkspaceToOpen)(D))return{workspace:(0,T.getWorkspaceIdentifier)(C),remoteAuthority:K};return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(C),remoteAuthority:K}}resourceFromOpenable(D){return(0,P.isWorkspaceToOpen)(D)?D.workspaceUri:(0,P.isFolderToOpen)(D)?D.folderUri:D.fileUri}doResolveFilePath(D,F){let C,K;F.gotoLineMode&&({path:D,line:C,column:K}=(0,oe.parseLineAndColumnAware)(D)),D=(0,oe.sanitizeFilePath)((0,I.normalize)(D),(0,N.cwd)());try{const G=(0,v.statSync)(D);if(G.isFile()){if(!F.forceOpenWorkspaceAsFile){const Y=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.URI.file(D));if(Y)return{workspace:{id:Y.id,configPath:Y.configPath},remoteAuthority:Y.remoteAuthority,exists:!0}}return{fileUri:h.URI.file(D),lineNumber:C,columnNumber:K,exists:!0}}else if(G.isDirectory())return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(h.URI.file(D),G),exists:!0}}catch(G){const Y=h.URI.file(D);if(this.workspacesHistoryMainService.removeRecentlyOpened([Y]),F.ignoreFileNotFound)return{fileUri:Y,exists:!1}}}doResolvePathRemote(D,F){const C=D.charCodeAt(0),K=F.remoteAuthority;let G,Y;F.gotoLineMode&&({path:D,line:G,column:Y}=(0,oe.parseLineAndColumnAware)(D)),C!==47&&((0,oe.isWindowsDriveLetter)(C)&&D.charCodeAt(D.charCodeAt(1))===58&&(D=(0,oe.toSlashes)(D)),D=`/${D}`);const Z=h.URI.from({scheme:a.Schemas.vscodeRemote,authority:K,path:D});if(D.charCodeAt(D.length-1)!==47){if((0,i.hasWorkspaceFileExtension)(D))return F.forceOpenWorkspaceAsFile?{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:F.remoteAuthority}:{workspace:(0,T.getWorkspaceIdentifier)(Z),remoteAuthority:K};if(F.gotoLineMode||I.posix.basename(D).indexOf(".")!==-1)return{fileUri:Z,lineNumber:G,columnNumber:Y,remoteAuthority:K}}return{workspace:(0,T.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:K}}shouldOpenNewWindow(D){const F=this.configurationService.getValue("window"),C=(F==null?void 0:F.openFoldersInNewWindow)||"default",K=(F==null?void 0:F.openFilesInNewWindow)||"off";let G=(D.preferNewWindow||D.forceNewWindow)&&!D.forceReuseWindow;!D.forceNewWindow&&!D.forceReuseWindow&&(C==="on"||C==="off")&&(G=C==="on");let Y=!1;return D.forceNewWindow||D.forceReuseWindow?Y=!!D.forceNewWindow&&!D.forceReuseWindow:(t.isMacintosh?D.context===1&&(Y=!0):D.context!==3&&D.context!==2&&!(D.userEnv&&D.userEnv.TERM_PROGRAM==="vscode")&&(Y=!0),!D.cli.extensionDevelopmentPath&&(K==="on"||K==="off")&&(Y=K==="on")),{openFolderInNewWindow:!!G,openFilesInNewWindow:Y}}openExtensionDevelopmentHostWindow(D,F){const C=(0,o.findWindowOnExtensionDevelopmentPath)(this.getWindows(),D);if(C)return this.lifecycleMainService.reload(C,F.cli),C.focus(),[C];let K=F.cli["folder-uri"]||[],G=F.cli["file-uri"]||[],Y=F.cli._;if(!Y.length&&!K.length&&!G.length&&!F.cli.extensionTestsPath){const x=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=x&&(x.workspace||x.folderUri);ne&&(h.URI.isUri(ne)?ne.scheme===a.Schemas.file?Y=[ne.fsPath]:K=[ne.toString()]:ne.configPath.scheme===a.Schemas.file?Y=[(0,f.originalFSPath)(ne.configPath)]:G=[ne.configPath.toString()])}let Z=F.remoteAuthority;for(const x of D)if(x.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=h.URI.parse(x),ue=(0,g.getRemoteAuthority)(ne);ue&&(Z?ue!==Z&&this.logService.error("more than one extension development path authority"):Z=ue)}Y=Y.filter(x=>{const ne=h.URI.file(x);return(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,g.getRemoteAuthority)(ne)===Z}),K=K.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,g.getRemoteAuthority)(ne)===Z:!1}),G=G.filter(x=>{const ne=this.cliArgToUri(x);return ne&&!!(0,o.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,g.getRemoteAuthority)(ne)===Z:!1}),F.cli._=Y,F.cli["folder-uri"]=K,F.cli["file-uri"]=G;const re=!Y.length&&!K.length&&!G.length,se={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:re,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:Z};return this.open(se)}openInBrowserWindow(D){var F,C,K,G,Y;const Z=this.configurationService.getValue("window"),re=Object.assign(Object.assign(Object.assign({},this.environmentMainService.args),D.cli),{machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupPath:D.emptyWindowBackupInfo?(0,I.join)(this.environmentMainService.backupHome,D.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:D.remoteAuthority,workspace:D.workspace,userEnv:Object.assign(Object.assign({},this.initialUserEnv),D.userEnv),filesToOpenOrCreate:(F=D.filesToOpen)===null||F===void 0?void 0:F.filesToOpenOrCreate,filesToDiff:(C=D.filesToOpen)===null||C===void 0?void 0:C.filesToDiff,filesToWait:(K=D.filesToOpen)===null||K===void 0?void 0:K.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:L.default,isInitialStartup:D.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)()},zoomLevel:typeof(Z==null?void 0:Z.zoomLevel)=="number"?Z.zoomLevel:void 0,autoDetectHighContrast:(G=Z==null?void 0:Z.autoDetectHighContrast)!==null&&G!==void 0?G:!0,accessibilitySupport:b.app.accessibilitySupportEnabled,colorScheme:{dark:b.nativeTheme.shouldUseDarkColors,highContrast:b.nativeTheme.shouldUseInvertedColorScheme||b.nativeTheme.shouldUseHighContrastColors}});let se;if(!D.forceNewWindow&&!D.forceNewTabbedWindow&&(se=D.windowToUse||this.getLastActiveWindow(),se&&se.focus()),se){const x=se.config;!re.extensionDevelopmentPath&&x&&!!x.extensionDevelopmentPath&&(re.extensionDevelopmentPath=x.extensionDevelopmentPath,re.verbose=x.verbose,re["inspect-brk-extensions"]=x["inspect-brk-extensions"],re.debugId=x.debugId,re["inspect-extensions"]=x["inspect-extensions"],re["extensions-dir"]=x["extensions-dir"])}else{const x=this.windowsStateHandler.getNewWindowState(re);(0,y.mark)("code/willCreateCodeWindow");const ne=se=this.instantiationService.createInstance(E.CodeWindow,{state:x,extensionDevelopmentPath:re.extensionDevelopmentPath,isExtensionTestHost:!!re.extensionTestsPath});if((0,y.mark)("code/didCreateCodeWindow"),D.forceNewTabbedWindow){const be=this.getLastActiveWindow();be&&be.addTabbedWindow(ne)}et.WINDOWS.push(ne),this._onDidOpenWindow.fire(ne),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,U.once)(ne.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(ne)),(0,U.once)(ne.onDidClose)(()=>this.onWindowClosed(ne)),(0,U.once)(ne.onDidDestroy)(()=>this._onDidDestroyWindow.fire(ne));const ue=(0,te.assertIsDefined)((Y=ne.win)===null||Y===void 0?void 0:Y.webContents);ue.removeAllListeners("devtools-reload-page"),ue.on("devtools-reload-page",()=>this.lifecycleMainService.reload(ne)),this.lifecycleMainService.registerWindow(ne)}return re.windowId=se.id,se.isReady?this.lifecycleMainService.unload(se,4).then(x=>{x||this.doOpenInBrowserWindow(se,re,D)}):this.doOpenInBrowserWindow(se,re,D),se}doOpenInBrowserWindow(D,F,C){if(!F.extensionDevelopmentPath)if((0,i.isWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:F.workspace,remoteAuthority:F.remoteAuthority});else if((0,i.isSingleFolderWorkspaceIdentifier)(F.workspace))F.backupPath=this.backupMainService.registerFolderBackupSync(F.workspace.uri);else{const K=C.emptyWindowBackupInfo&&C.emptyWindowBackupInfo.backupFolder;F.backupPath=this.backupMainService.registerEmptyWindowBackupSync(K,F.remoteAuthority)}D.load(F)}onWindowClosed(D){const F=et.WINDOWS.indexOf(D);et.WINDOWS.splice(F,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const D=b.BrowserWindow.getFocusedWindow();if(D)return this.getWindowById(D.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(D){return this.doGetLastActiveWindow(this.getWindows().filter(F=>F.remoteAuthority===D))}doGetLastActiveWindow(D){const F=Math.max.apply(Math,D.map(C=>C.lastFocusTime));return D.find(C=>C.lastFocusTime===F)}sendToFocused(D,...F){const C=this.getFocusedWindow()||this.getLastActiveWindow();C&&C.sendWhenReady(D,$.CancellationToken.None,...F)}sendToAll(D,F,C){for(const K of this.getWindows())C&&C.indexOf(K.id)>=0||K.sendWhenReady(D,$.CancellationToken.None,F)}getWindows(){return et.WINDOWS}getWindowCount(){return et.WINDOWS.length}getWindowById(D){const F=this.getWindows().filter(C=>C.id===D);return(0,w.firstOrDefault)(F)}getWindowByWebContents(D){const F=b.BrowserWindow.fromWebContents(D);if(!!F)return this.getWindowById(F.id)}};A.WINDOWS=[],A=ce([ee(2,M.ILogService),ee(3,S.IStateMainService),ee(4,n.IEnvironmentMainService),ee(5,d.ILifecycleMainService),ee(6,p.IBackupMainService),ee(7,m.IConfigurationService),ee(8,c.IWorkspacesHistoryMainService),ee(9,T.IWorkspacesManagementMainService),ee(10,s.IInstantiationService),ee(11,X.IDialogMainService),ee(12,z.IFileService),ee(13,l.IProductService),ee(14,H.IProtocolMainService)],A),e.WindowsMainService=A}),define(Q[234],J([0,1,52,34,62,50]),function(j,e,v,R,L,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let I=class{constructor(w,p,n,S){this.workspacesManagementMainService=w,this.windowsMainService=p,this.workspacesHistoryMainService=n,this.backupMainService=S,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(w,p){const n=this.windowsMainService.getWindowById(w);if(n)return this.workspacesManagementMainService.enterWorkspace(n,this.windowsMainService.getWindows(),p)}createUntitledWorkspace(w,p,n){return this.workspacesManagementMainService.createUntitledWorkspace(p,n)}deleteUntitledWorkspace(w,p){return this.workspacesManagementMainService.deleteUntitledWorkspace(p)}getWorkspaceIdentifier(w,p){return this.workspacesManagementMainService.getWorkspaceIdentifier(p)}async getRecentlyOpened(w){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(w))}async addRecentlyOpened(w,p){return this.workspacesHistoryMainService.addRecentlyOpened(p)}async removeRecentlyOpened(w,p){return this.workspacesHistoryMainService.removeRecentlyOpened(p)}async clearRecentlyOpened(w){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};I=ce([ee(0,v.IWorkspacesManagementMainService),ee(1,R.IWindowsMainService),ee(2,L.IWorkspacesHistoryMainService),ee(3,y.IBackupMainService)],I),e.WorkspacesMainService=I}),define(Q[235],J([0,1,27,20,14,3,233,18,90,40,203,33,122,84,223,100,4,71,69,6,38,25,17,97,204,31,96,198,199,195,21,217,2,34,8,29,234,66,228,226,225,229,177,19,206,218,232,119,7,15,131,10,227,98,211,216,50,62,205,52,70,156,41,51,13,39,208,76,24,43,28,23,88,209,194,54,30,9,168,182,42,73,75,89,187]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t,i,s,a,h,f,g,k,T,U,B,X,te,oe,W,$,z,N,H,V,_,A,O,D,F,C,K,G,Y,Z,re,se,x,ne,ue,be,me,Ee,Le,we,ve,Ie,Re,_e,Ve,Ze,He,ht,Be,ot,tt,dt,Ke,ft,at,q,ie,ae,le,de,ye,Me,Te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let We=class extends B.Disposable{constructor(he,pe,fe,ge,Se,Ae,De,ke,Pe,Ue){super();this.mainProcessNodeIpcServer=he,this.userEnv=pe,this.mainInstantiationService=fe,this.logService=ge,this.environmentMainService=Se,this.lifecycleMainService=Ae,this.configurationService=De,this.stateMainService=ke,this.fileService=Pe,this.productService=Ue,this.registerListeners()}registerListeners(){(0,A.setUnexpectedErrorHandler)(fe=>this.onUnexpectedError(fe)),process.on("uncaughtException",fe=>this.onUnexpectedError(fe)),process.on("unhandledRejection",fe=>(0,A.onUnexpectedError)(fe)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,C.registerContextMenuListener)(),L.app.on("accessibility-support-changed",(fe,ge)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",ge)}),L.app.on("activate",(fe,ge)=>{var Se;this.logService.trace("app#activate"),ge||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),L.app.on("remote-require",(fe,ge,Se)=>{this.logService.trace("app#on(remote-require): prevented"),fe.preventDefault()}),L.app.on("remote-get-global",(fe,ge,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),fe.preventDefault()}),L.app.on("remote-get-builtin",(fe,ge,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&fe.preventDefault()}),L.app.on("remote-get-current-window",fe=>{this.logService.trace("app#on(remote-get-current-window): prevented"),fe.preventDefault()}),L.app.on("remote-get-current-web-contents",fe=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),fe.preventDefault())}),L.app.on("web-contents-created",(fe,ge)=>{ge.on("will-attach-webview",(Ae,De,ke)=>{const Pe=Ue=>{if(!Ue)return!1;const ze=te.URI.parse(Ue);if(ze.scheme===Z.Schemas.vscodeWebview)return ze.path==="/index.html"||ze.path==="/electron-browser-index.html";const Ge=ze.fsPath.toLowerCase(),Ye=te.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ge.startsWith(Ye+K.sep)};delete De.preload,De.nodeIntegration=!1,!(Pe(ke.src)&&Pe(De.preloadURL))&&(delete De.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ae.preventDefault())}),ge.on("will-navigate",Ae=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),ge.on("new-window",(Ae,De)=>{var ke;Ae.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,De)});const Se=Ae=>Ae.startsWith(`${Z.Schemas.vscodeWebview}://`);L.session.defaultSession.setPermissionRequestHandler((Ae,De,ke,Pe)=>Se(Pe.requestingUrl)?ke(De==="clipboard-read"):ke(!1)),L.session.defaultSession.setPermissionCheckHandler((Ae,De,ke,Pe)=>Se(Pe.requestingUrl)?De==="clipboard-read":!1)});let he=[],pe;L.app.on("open-file",(fe,ge)=>{this.logService.trace("app#open-file: ",ge),fe.preventDefault(),he.push(this.getWindowOpenableFromPathSync(ge)),pe!==void 0&&(clearTimeout(pe),pe=void 0),pe=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:he,gotoLineMode:!1,preferNewWindow:!0}),he=[],pe=void 0},100)}),L.app.on("new-window-for-tab",()=>{var fe;(fe=this.windowsMainService)===null||fe===void 0||fe.openEmptyWindow({context:4})}),L.ipcMain.handle("vscode:fetchShellEnv",fe=>{var ge;const Se=(ge=this.windowsMainService)===null||ge===void 0?void 0:ge.getWindowByWebContents(fe.sender);let Ae,De;return(Se==null?void 0:Se.config)?(Ae=Se.config,De=Object.assign(Object.assign({},process.env),Se.config.userEnv)):(Ae=this.environmentMainService.args,De=process.env),(0,w.resolveShellEnv)(this.logService,Ae,De)}),L.ipcMain.handle("vscode:writeNlsFile",(fe,ge,Se)=>{const Ae=this.validateNlsPath([ge]);if(!Ae||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ae,ot.VSBuffer.fromString(Se))}),L.ipcMain.handle("vscode:readNlsFile",async(fe,...ge)=>{const Se=this.validateNlsPath(ge);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),L.ipcMain.on("vscode:toggleDevTools",fe=>fe.sender.toggleDevTools()),L.ipcMain.on("vscode:openDevTools",fe=>fe.sender.openDevTools()),L.ipcMain.on("vscode:reloadWindow",fe=>fe.sender.reload())}validateNlsPath(he){let pe;for(const fe of he)typeof fe=="string"&&(typeof pe!="string"?pe=fe:pe=(0,K.join)(pe,fe));if(!(typeof pe!="string"||!(0,K.isAbsolute)(pe)||!(0,at.isEqualOrParent)(pe,this.environmentMainService.cachedLanguagesPath,!y.isLinux)))return te.URI.file(pe)}onUnexpectedError(he){var pe;if(he){const fe={message:`[uncaught exception in main]: ${he.message}`,stack:he.stack};(pe=this.windowsMainService)===null||pe===void 0||pe.sendToFocused("vscode:reportError",JSON.stringify(fe))}this.logService.error(`[uncaught exception in main]: ${he}`),he.stack&&this.logService.error(he.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);try{const Pe=te.URI.file(this.environmentMainService.chromeCachedDataDir);this.logService.trace(`Deleting Chrome cached data path: ${Pe.fsPath}`),await this.fileService.del(Pe,{recursive:!0})}catch(Pe){Pe.fileOperationResult!==1&&this.logService.error(Pe)}const he=this.productService.win32AppUserModelId;y.isWindows&&he&&L.app.setAppUserModelId(he);try{y.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!L.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&L.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Pe){this.logService.error(Pe)}const pe=new E.Server;this.logService.trace("Resolving machine identifier...");const fe=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${fe}`);const{sharedProcess:ge,sharedProcessReady:Se,sharedProcessClient:Ae}=this.setupSharedProcess(fe),De=await this.initServices(fe,ge,Se);if(this.environmentMainService.driverHandle){const Pe=await(0,D.serve)(pe,this.environmentMainService.driverHandle,this.environmentMainService,De);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Pe)}this._register(De.createInstance(U.ProxyAuthHandler)),De.invokeFunction(Pe=>this.initChannels(Pe,pe,Ae));const ke=De.invokeFunction(Pe=>this.openFirstWindow(Pe,pe));De.invokeFunction(Pe=>this.afterWindowOpen(Pe,ge)),this.environmentMainService.args.trace&&De.invokeFunction(Pe=>this.stopTracingEventually(Pe,ke))}async resolveMachineId(){let he=this.stateMainService.getItem(a.machineIdKey);return(!he||y.isMacintosh&&he==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(he=await(0,$.getMachineId)(),this.stateMainService.setItem(a.machineIdKey,he)),he}setupSharedProcess(he){const pe=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,he,this.userEnv)),fe=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Se=await pe.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new b.Client(Se,"main")})(),ge=(async()=>(await pe.whenReady(),fe))();return{sharedProcess:pe,sharedProcessReady:ge,sharedProcessClient:fe}}async initServices(he,pe,fe){const ge=new P.ServiceCollection;switch(process.platform){case"win32":ge.set(p.IUpdateService,new o.SyncDescriptor(z.Win32UpdateService));break;case"linux":y.isLinuxSnap?ge.set(p.IUpdateService,new o.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ge.set(p.IUpdateService,new o.SyncDescriptor(N.LinuxUpdateService));break;case"darwin":ge.set(p.IUpdateService,new o.SyncDescriptor(H.DarwinUpdateService));break}ge.set(X.IWindowsMainService,new o.SyncDescriptor(I.WindowsMainService,[he,this.userEnv])),ge.set(Ie.IDialogMainService,new o.SyncDescriptor(Ie.DialogMainService)),ge.set(m.ILaunchMainService,new o.SyncDescriptor(m.LaunchMainService)),ge.set(Le.IDiagnosticsService,S.ProxyChannel.toService((0,S.getDelayedChannel)(fe.then(Ae=>Ae.getChannel("diagnostics"))))),ge.set(V.IIssueMainService,new o.SyncDescriptor(V.IssueMainService,[this.userEnv])),ge.set(tt.IEncryptionMainService,new o.SyncDescriptor(tt.EncryptionMainService,[he])),ge.set(Ke.IKeyboardLayoutMainService,new o.SyncDescriptor(Ke.KeyboardLayoutMainService)),ge.set(ve.INativeHostMainService,new o.SyncDescriptor(ve.NativeHostMainService,[pe])),ge.set(Ze.IWebviewManagerService,new o.SyncDescriptor(Ve.WebviewMainService)),ge.set(oe.IWorkspacesService,new o.SyncDescriptor(W.WorkspacesMainService)),ge.set(Ee.IWorkspacesManagementMainService,new o.SyncDescriptor(Ee.WorkspacesManagementMainService)),ge.set(be.IWorkspacesHistoryMainService,new o.SyncDescriptor(be.WorkspacesHistoryMainService)),ge.set(F.IMenubarMainService,new o.SyncDescriptor(F.MenubarMainService)),ge.set(ie.IExtensionUrlTrustService,new o.SyncDescriptor(ae.ExtensionUrlTrustService)),ge.set(se.IStorageMainService,new o.SyncDescriptor(se.StorageMainService)),y.isWindows?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.WindowsExternalTerminalService)):y.isMacintosh?ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.MacExternalTerminalService)):y.isLinux&&ge.set(Me.IExternalTerminalMainService,new o.SyncDescriptor(Te.LinuxExternalTerminalService));const Se=new ne.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ge.set(ue.IBackupMainService,Se),ge.set(i.IURLService,new o.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Ae=(0,S.getDelayedChannel)(fe.then(ze=>ze.getChannel("telemetryAppender"))),De=new f.TelemetryAppenderClient(Ae),ke=(0,k.resolveCommonProperties)(this.fileService,(0,v.release)(),(0,v.hostname)(),process.arch,this.productService.commit,this.productService.version,he,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Pe=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Ue={appender:De,commonProperties:ke,piiPaths:Pe,sendErrorTelemetry:!0};ge.set(a.ITelemetryService,new o.SyncDescriptor(g.TelemetryService,[Ue]))}else ge.set(a.ITelemetryService,h.NullTelemetryService);return await Se.initialize(),this.mainInstantiationService.createChild(ge)}initChannels(he,pe,fe){const ge=S.ProxyChannel.fromService(he.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ge);const Se=new n.UpdateChannel(he.get(p.IUpdateService));pe.registerChannel("update",Se);const Ae=S.ProxyChannel.fromService(he.get(V.IIssueMainService));pe.registerChannel("issue",Ae);const De=S.ProxyChannel.fromService(he.get(tt.IEncryptionMainService));pe.registerChannel("encryption",De);const ke=S.ProxyChannel.fromService(he.get(ye.ISignService));pe.registerChannel("sign",ke);const Pe=S.ProxyChannel.fromService(he.get(Ke.IKeyboardLayoutMainService));pe.registerChannel("keyboardLayout",Pe),this.nativeHostMainService=he.get(ve.INativeHostMainService);const Ue=S.ProxyChannel.fromService(this.nativeHostMainService);pe.registerChannel("nativeHost",Ue),fe.then($e=>$e.registerChannel("nativeHost",Ue));const ze=S.ProxyChannel.fromService(he.get(oe.IWorkspacesService));pe.registerChannel("workspaces",ze);const Ge=S.ProxyChannel.fromService(he.get(F.IMenubarMainService));pe.registerChannel("menubar",Ge);const Ye=S.ProxyChannel.fromService(he.get(i.IURLService));pe.registerChannel("url",Ye);const Oe=S.ProxyChannel.fromService(he.get(ie.IExtensionUrlTrustService));pe.registerChannel("extensionUrlTrust",Oe);const lt=S.ProxyChannel.fromService(he.get(Ze.IWebviewManagerService));pe.registerChannel("webview",lt);const xe=this._register(new x.StorageDatabaseChannel(this.logService,he.get(se.IStorageMainService)));pe.registerChannel("storage",xe),fe.then($e=>$e.registerChannel("storage",xe));const it=S.ProxyChannel.fromService(he.get(Me.IExternalTerminalMainService));pe.registerChannel("externalTerminal",it);const nt=new _.LogLevelChannel(he.get(u.ILogService));pe.registerChannel("logLevel",nt),fe.then($e=>$e.registerChannel("logLevel",nt));const rt=new _.LoggerChannel(he.get(u.ILoggerService));pe.registerChannel("logger",rt),fe.then($e=>$e.registerChannel("logger",rt));const st=new we.ElectronExtensionHostDebugBroadcastChannel(he.get(X.IWindowsMainService));pe.registerChannel("extensionhostdebugservice",st)}openFirstWindow(he,pe){const fe=this.windowsMainService=he.get(X.IWindowsMainService),ge=he.get(i.IURLService),Se=he.get(ve.INativeHostMainService);this.lifecycleMainService.phase=2;const Ae=[],De=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:te.URI.parse(Ce),url:Ce}}catch(Xe){return null}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Xe=this.getWindowOpenableFromProtocolLink(Ce.uri);return Xe?(Ae.push(Xe),!1):!0}),ke=this,Pe=this.environmentMainService;ge.registerHandler({async handleURL(Ce,Xe){if(ke.shouldBlockURI(Ce))return!0;const bt=ke.getWindowOpenableFromProtocolLink(Ce);if(bt){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),urisToOpen:[bt],gotoLineMode:!0});return gt.focus(),!0}if(y.isMacintosh&&fe.getWindowCount()===0){const[gt]=fe.open({context:5,cli:Object.assign({},Pe.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,de.getRemoteAuthority)(Ce)});return await gt.ready(),ge.open(Ce,Xe)}return!1}});const Ue=this._register(new dt.ActiveWindowManager({onDidOpenWindow:Se.onDidOpenWindow,onDidFocusWindow:Se.onDidFocusWindow,getActiveWindowId:()=>Se.getActiveWindowId(-1)})),ze=new S.StaticRouter(Ce=>Ue.getActiveClientId().then(Xe=>Ce===Xe)),Ge=new s.URLHandlerRouter(ze),Ye=pe.getChannel("urlHandler",Ge);ge.registerHandler(new s.URLHandlerChannelClient(Ye)),this._register(new O.ElectronURLListener(De,ge,fe,this.environmentMainService,this.productService));const Oe=this.environmentMainService.args,lt=global.macOpenFiles,xe=(0,ft.isLaunchedFromCli)(process.env)?0:4,it=Oe._.length,nt=!!Oe["folder-uri"],rt=!!Oe["file-uri"],st=Oe["skip-add-to-recently-opened"]===!0,$e=Oe.wait&&Oe.waitMarkerFilePath?te.URI.file(Oe.waitMarkerFilePath):void 0,St=Oe.remote||void 0;return Ae.length>0?fe.open({context:xe,cli:Oe,urisToOpen:Ae,gotoLineMode:!0,initialStartup:!0}):Oe["new-window"]&&!it&&!nt&&!rt?fe.open({context:xe,cli:Oe,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:st,waitMarkerFileURI:$e,initialStartup:!0,remoteAuthority:St}):lt.length&&!it&&!nt&&!rt?fe.open({context:1,cli:Oe,urisToOpen:lt.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:st,waitMarkerFileURI:$e,initialStartup:!0}):fe.open({context:xe,cli:Oe,forceNewWindow:Oe["new-window"]||!it&&Oe["unity-launch"],diffMode:Oe.diff,noRecentEntry:st,waitMarkerFileURI:$e,gotoLineMode:Oe.goto,initialStartup:!0,remoteAuthority:St})}shouldBlockURI(he){return!!(he.authority===Z.Schemas.file&&y.isWindows&&L.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,_e.mnemonicButtonLabel)((0,Y.localize)(0,null)),(0,_e.mnemonicButtonLabel)((0,Y.localize)(1,null))],cancelId:1,message:(0,Y.localize)(2,null,(0,_e.getPathLabel)(he.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,Y.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(he){if(!!he.path){if(he.authority===Z.Schemas.file)return{fileUri:te.URI.file(he.fsPath)};if(he.authority===Z.Schemas.vscodeRemote){const pe=he.path.indexOf(K.posix.sep,1);if(pe!==-1){const fe=he.path.substring(1,pe),ge=he.path.substring(pe),Se=te.URI.from({scheme:Z.Schemas.vscodeRemote,authority:fe,path:ge,query:he.query,fragment:he.fragment});return(0,oe.hasWorkspaceFileExtension)(ge)?{workspaceUri:Se}:/:[\d]+$/.test(ge)?{fileUri:Se}:{folderUri:Se}}}}}getWindowOpenableFromPathSync(he){try{if((0,R.statSync)(he).isDirectory())return{folderUri:te.URI.file(he)};if((0,oe.hasWorkspaceFileExtension)(he))return{workspaceUri:te.URI.file(he)}}catch(pe){}return{fileUri:te.URI.file(he)}}async afterWindowOpen(he,pe){var fe;this.lifecycleMainService.phase=3;let ge=!1;(0,le.once)(this.lifecycleMainService.onWillShutdown)(()=>ge=!0);const Se=he.get(a.ITelemetryService);this._register(pe.onDidError(({type:ke,details:Pe})=>{let Ue;typeof Pe=="string"?Ue=Pe:Ue=`SharedProcess: crashed (detail: ${Pe.reason}, code: ${Pe.exitCode})`,(0,A.onUnexpectedError)(new Error(Ue)),Se.publicLog2("sharedprocesserror",{type:ke,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:pe.isVisible(),shuttingdown:ge})}));const Ae=this.productService.win32MutexName;if(y.isWindows&&Ae)try{const ke=j.__$__nodeRequire("windows-mutex").Mutex,Pe=new ke(Ae);(0,le.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(ke){this.logService.error(ke)}L.protocol.registerHttpProtocol(Z.Schemas.vscodeRemoteResource,(ke,Pe)=>{Pe({url:ke.url.replace(/^vscode-remote-resource:/,"http:"),method:ke.method})});const De=he.get(p.IUpdateService);(De instanceof z.Win32UpdateService||De instanceof N.LinuxUpdateService||De instanceof H.DarwinUpdateService)&&De.initialize(),(async()=>{const ke=this._register(new q.RunOnceScheduler(()=>this.logService.warn("Resolving your shell environment is taking more than 10s. Please review your shell configuration. Learn more at https://go.microsoft.com/fwlink/?linkid=2149667."),1e4));ke.schedule(),await(0,w.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env),ke.dispose()})();try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,ht.stripComments)(Pe))["enable-crash-reporter"]===void 0){const ze=(fe=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&fe!==void 0?fe:!0,Ge=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],Ye=Pe.substring(0,Pe.length-2).concat(`,
`,Ge.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,ot.VSBuffer.fromString(Ye))}}catch(ke){this.logService.error(ke)}}stopTracingEventually(he,pe){this.logService.info("Tracing: waiting for windows to get ready...");const fe=he.get(Ie.IDialogMainService);let ge=!1;const Se=async De=>{if(!ge){ge=!0;const ke=await L.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);De?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${ke}`):fe.showMessageBox({type:"info",message:(0,Y.localize)(4,null),detail:(0,Y.localize)(5,null,ke),buttons:[(0,Y.localize)(6,null)]},(0,Re.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}},Ae=setTimeout(()=>Se(!0),3e4);Promise.all(pe.map(De=>De.ready())).then(()=>{clearTimeout(Ae),Se(!1)})}};We=ce([ee(2,M.IInstantiationService),ee(3,u.ILogService),ee(4,c.IEnvironmentMainService),ee(5,r.ILifecycleMainService),ee(6,t.IConfigurationService),ee(7,l.IStateMainService),ee(8,He.IFileService),ee(9,T.IProductService)],We),e.CodeApplication=We}),define(Q[239],J([0,1,14,20,11,3,72,47,54,160,18,33,56,172,71,69,6,224,38,17,186,49,222,235,39,93,92,19,60,42,75,193,196,180,181,10,24,74,220,21,30,22,7,35,25,67,96,178,32,55,183,202]),function(j,e,v,R,L,y,I,r,w,p,n,S,E,b,d,m,M,P,o,u,l,c,t,i,s,a,h,f,g,k,T,U,B,X,te,oe,W,$,z,N,H,V,_,A,O,D,F,C,K,G,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Z{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,f.setUnexpectedErrorHandler)(we=>console.error(we));const[x,ne,ue,be,me,Ee,Le]=this.createServices();try{try{await this.initServices(ue,be,me)}catch(we){throw this.handleStartupDataDirError(ue,Le.nameLong,we),we}await x.invokeFunction(async we=>{const ve=we.get(M.ILogService),Ie=we.get(n.ILifecycleMainService),Re=we.get(W.IFileService),_e=await this.claimInstance(ve,ue,Ie,x,Le,!0);return Ee.logger=new a.SpdLogLogger("main",(0,_.join)(ue.logsPath,"main.log"),!0,Ee.getLevel()),(0,k.once)(Ie.onWillShutdown)(()=>{Re.dispose(),be.dispose()}),x.createInstance(i.CodeApplication,_e,ne).startup()})}catch(we){x.invokeFunction(this.quit,we)}}createServices(){const x=new d.ServiceCollection,ne=Object.assign({_serviceBrand:void 0},r.default);x.set(N.IProductService,ne);const ue=new O.EnvironmentMainService(this.resolveArgs(),ne),be=this.patchEnvironment(ue);x.set(O.IEnvironmentMainService,ue);const me=new h.BufferLogService,Ee=new M.MultiplexLogService([new M.ConsoleMainLogger((0,M.getLogLevel)(ue)),me]);process.once("exit",()=>Ee.dispose()),x.set(M.ILogService,Ee);const Le=new X.FileService(Ee);x.set(W.IFileService,Le);const we=new te.DiskFileSystemProvider(Ee);Le.registerProvider(oe.Schemas.file,we),x.set(M.ILoggerService,new C.LoggerService(Ee,Le));const ve=new l.ConfigurationService(ue.settingsResource,Le);x.set(u.IConfigurationService,ve),x.set(n.ILifecycleMainService,new m.SyncDescriptor(n.LifecycleMainService));const Ie=new P.StateMainService(ue,Ee);return x.set(o.IStateMainService,Ie),x.set(c.IRequestService,new m.SyncDescriptor(t.RequestMainService)),x.set(g.IThemeMainService,new m.SyncDescriptor(g.ThemeMainService)),x.set(T.ISignService,new m.SyncDescriptor(U.SignService)),x.set($.ITunnelService,new m.SyncDescriptor(z.TunnelService)),x.set(G.IProtocolMainService,new m.SyncDescriptor(Y.ProtocolMainService)),[new b.InstantiationService(x,!0),be,ue,ve,Ie,me,ne]}patchEnvironment(x){const ne={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const be=process.env[ue];typeof be=="string"&&(ne[ue]=be)}),Object.assign(process.env,ne),ne}initServices(x,ne,ue){const be=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(Le=>Le?R.promises.mkdir(Le,{recursive:!0}):void 0)),me=ne.initialize(),Ee=ue.init();return Promise.all([be,me,Ee])}async claimInstance(x,ne,ue,be,me,Ee){let Le;try{(0,I.mark)("code/willStartMainServer"),Le=await(0,E.serve)(ne.mainIPCHandle),(0,I.mark)("code/didStartMainServer"),(0,k.once)(ue.onWillShutdown)(()=>Le.dispose())}catch(we){if(we.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ne,me.nameLong,we),we;let ve;try{ve=await(0,E.connect)(ne.mainIPCHandle,"main")}catch(_e){if(!Ee||y.isWindows||_e.code!=="ECONNREFUSED")throw _e.code==="EPERM"&&this.showStartupWarningDialog((0,L.localize)(0,null,me.nameShort),(0,L.localize)(1,null),me.nameLong),_e;try{(0,R.unlinkSync)(ne.mainIPCHandle)}catch(Ve){throw x.warn("Could not delete obsolete instance handle",Ve),Ve}return this.claimInstance(x,ne,ue,be,me,!1)}if(ne.extensionTestsLocationURI&&!ne.debugExtensionHost.break){const _e="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(_e),ve.dispose(),new Error(_e)}let Ie;!ne.args.wait&&!ne.args.status&&(Ie=setTimeout(()=>{this.showStartupWarningDialog((0,L.localize)(2,null,me.nameShort),(0,L.localize)(3,null),me.nameLong)},1e4));const Re=S.ProxyChannel.toService(ve.getChannel("launch"),{disableMarshalling:!0});if(ne.args.status)return be.invokeFunction(async()=>{const _e=new B.DiagnosticsService(F.NullTelemetryService,me),Ve=await Re.getMainProcessInfo(),Ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),He=await _e.getDiagnostics(Ve,Ze);throw console.log(He),new f.ExpectedError});throw y.isWindows&&await this.windowsAllowSetForegroundWindow(Re,x),x.trace("Sending env to running instance..."),await Re.start(ne.args,process.env),ve.dispose(),Ie&&clearTimeout(Ie),new f.ExpectedError("Sent env to running instance. Terminating...")}if(ne.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new f.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Le}handleStartupDataDirError(x,ne,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const be=(0,A.coalesce)([x.userDataPath,x.extensionsPath,E.XDG_RUNTIME_DIR]).map(me=>(0,s.getPathLabel)(me,x));this.showStartupWarningDialog((0,L.localize)(4,null),(0,L.localize)(5,null,(0,D.toErrorMessage)(ue),be.join(`
`)),ne)}}showStartupWarningDialog(x,ne,ue){v.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,s.mnemonicButtonLabel)((0,L.localize)(6,null))],message:x,detail:ne,noLink:!0})}async windowsAllowSetForegroundWindow(x,ne){if(y.isWindows){const ue=await x.getMainProcessId();ne.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((be,me)=>{j(["windows-foreground-love"],be,me)})).allowSetForegroundWindow(ue)}catch(be){ne.error(be)}}}quit(x,ne){const ue=x.get(M.ILogService),be=x.get(n.ILifecycleMainService);let me=0;ne&&(ne.isExpected?ne.message&&ue.trace(ne.message):(me=1,ne.stack?ue.error(ne.stack):ue.error(`Startup error: ${ne.toString()}`))),be.kill(me)}resolveArgs(){const x=this.validatePaths((0,w.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ne=(0,p.createWaitMarkerFile)(x.verbose);ne&&((0,w.addArg)(process.argv,"--waitMarkerFilePath",ne),x.waitMarkerFilePath=ne)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ne=this.doValidatePaths(x._,x.goto);x._=ne}return x}doValidatePaths(x,ne){const ue=(0,K.cwd)(),be=x.map(Le=>{let we=String(Le),ve;ne&&(ve=(0,H.parseLineAndColumnAware)(we),we=ve.path),we&&(we=this.preparePath(ue,we));const Ie=(0,H.sanitizeFilePath)(we,ue),Re=(0,_.basename)(Ie);return Re&&!(0,H.isValidBasename)(Re)?null:ne&&ve?(ve.path=Ie,this.toPath(ve)):Ie}),me=y.isWindows||y.isMacintosh,Ee=(0,A.distinct)(be,Le=>Le&&me?Le.toLowerCase():Le||"");return(0,A.coalesce)(Ee)}preparePath(x,ne){return y.isWindows&&(ne=(0,V.rtrim)(ne,'"')),ne=(0,V.trim)((0,V.trim)(ne," "),"	"),y.isWindows&&(ne=(0,_.resolve)(x,ne),ne=(0,V.rtrim)(ne,".")),ne}toPath(x){const ne=[x.path];return typeof x.line=="number"&&ne.push(String(x.line)),typeof x.column=="number"&&ne.push(String(x.column)),ne.join(":")}}new Z().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54d33cf14cf6c0e86880b5b74a5a3628de42bce9/core/vs/code/electron-main/main.js.map
