/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/buffer","vs/base/common/resources","fs","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/objects","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/registry/common/platform","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","os","child_process","vs/base/common/process","vs/base/common/stream","vs/base/common/extpath","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/performance","vs/base/common/iterator","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],Z=function(x){for(var t=[],p=0,T=x.length;p<T;p++)t[p]=Q[x[p]];return t};define(Q[57],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function p(T,P){if(!T)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}t.ok=p}),define(Q[44],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function p(F){return(D,f,c)=>{let R=null,m=null;if(typeof c.value=="function"?(R="value",m=c.value):typeof c.get=="function"&&(R="get",m=c.get),!m)throw new Error("not supported");c[R]=F(m,f)}}t.createDecorator=p;function T(F,D,f){let c=null,R=null;if(typeof f.value=="function"?(c="value",R=f.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(c="get",R=f.get),!R)throw new Error("not supported");const m=`$memoize$${D}`;f[c]=function(...w){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,w)}),this[m]}}t.memoize=T;function P(F,D,f){return p((c,R)=>{const m=`$debounce$${R}`,w=`$debounce$result$${R}`;return function(...O){this[w]||(this[w]=f?f():void 0),clearTimeout(this[m]),D&&(this[w]=D(this[w],...O),O=[this[w]]),this[m]=setTimeout(()=>{c.apply(this,O),this[w]=f?f():void 0},F)}})}t.debounce=P;function S(F,D,f){return p((c,R)=>{const m=`$throttle$timer$${R}`,w=`$throttle$result$${R}`,O=`$throttle$lastRun$${R}`,u=`$throttle$pending$${R}`;return function(...g){if(this[w]||(this[w]=f?f():void 0),(this[O]===null||this[O]===void 0)&&(this[O]=-Number.MAX_VALUE),D&&(this[w]=D(this[w],...g)),!this[u]){const I=this[O]+F;I<=Date.now()?(this[O]=Date.now(),c.apply(this,[this[w]]),this[w]=f?f():void 0):(this[u]=!0,this[m]=setTimeout(()=>{this[u]=!1,this[O]=Date.now(),c.apply(this,[this[w]]),this[w]=f?f():void 0},I-Date.now()))}}})}t.throttle=S}),define(Q[23],Z([0,1,12]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function T(_,q=0){return _[_.length-(1+q)]}t.tail=T;function P(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.tail2=P;function S(_,q,J=(h,o)=>h===o){if(_===q)return!0;if(!_||!q||_.length!==q.length)return!1;for(let h=0,o=_.length;h<o;h++)if(!J(_[h],q[h]))return!1;return!0}t.equals=S;function F(_,q,J){let h=0,o=_.length-1;for(;h<=o;){const b=(h+o)/2|0,y=J(_[b],q);if(y<0)h=b+1;else if(y>0)o=b-1;else return b}return-(h+1)}t.binarySearch=F;function D(_,q){let J=0,h=_.length;if(h===0)return 0;for(;J<h;){const o=Math.floor((J+h)/2);q(_[o])?h=o:J=o+1}return J}t.findFirstInSorted=D;function f(_,q,J){if(_=_|0,_>=q.length)throw new TypeError("invalid index");let h=q[Math.floor(q.length*Math.random())],o=[],b=[],y=[];for(let A of q){const M=J(A,h);M<0?o.push(A):M>0?b.push(A):y.push(A)}return _<o.length?f(_,o,J):_<o.length+y.length?y[0]:f(_-(o.length+y.length),b,J)}t.quickSelect=f;function c(_,q){const J=[];let h;for(const o of _.slice(0).sort(q))!h||q(h[0],o)!==0?(h=[o],J.push(h)):h.push(o);return J}t.groupBy=c;function R(_,q,J){const h=[];function o(A,M,B){if(!(M===0&&B.length===0)){const V=h[h.length-1];V&&V.start+V.deleteCount===A?(V.deleteCount+=M,V.toInsert.push(...B)):h.push({start:A,deleteCount:M,toInsert:B})}}let b=0,y=0;for(;;){if(b===_.length){o(b,0,q.slice(y));break}if(y===q.length){o(b,_.length-b,[]);break}const A=_[b],M=q[y],B=J(A,M);B===0?(b+=1,y+=1):B<0?(o(b,1,[]),b+=1):B>0&&(o(b,0,[M]),y+=1)}return h}t.sortedDiff=R;function m(_,q,J){const h=R(_,q,J),o=[],b=[];for(const y of h)o.push(..._.slice(y.start,y.start+y.deleteCount)),b.push(...y.toInsert);return{removed:o,added:b}}t.delta=m;function w(_,q,J){if(J===0)return[];const h=_.slice(0,J).sort(q);return u(_,q,h,J,_.length),h}t.top=w;function O(_,q,J,h,o){return J===0?Promise.resolve([]):new Promise((b,y)=>{(async()=>{const A=_.length,M=_.slice(0,J).sort(q);for(let B=J,V=Math.min(J+h,A);B<A;B=V,V=Math.min(V+h,A)){if(B>J&&await new Promise($=>setTimeout($)),o&&o.isCancellationRequested)throw(0,p.canceled)();u(_,q,M,B,V)}return M})().then(b,y)})}t.topAsync=O;function u(_,q,J,h,o){for(const b=J.length;h<o;h++){const y=_[h];if(q(y,J[b-1])<0){J.pop();const A=D(J,M=>q(y,M)<0);J.splice(A,0,y)}}}function g(_){return _.filter(q=>!!q)}t.coalesce=g;function I(_){let q=0;for(let J=0;J<_.length;J++)_[J]&&(_[q]=_[J],q+=1);_.length=q}t.coalesceInPlace=I;function L(_,q,J){_.splice(J,0,_.splice(q,1)[0])}t.move=L;function C(_){return!Array.isArray(_)||_.length===0}t.isFalsyOrEmpty=C;function v(_){return Array.isArray(_)&&_.length>0}t.isNonEmptyArray=v;function s(_,q){if(!q)return _.filter((h,o)=>_.indexOf(h)===o);const J=Object.create(null);return _.filter(h=>{const o=q(h);return J[o]?!1:(J[o]=!0,!0)})}t.distinct=s;function r(_){const q=new Set;return _.filter(J=>q.has(J)?!1:(q.add(J),!0))}t.distinctES6=r;function e(_){const q=Object.create(null);return J=>{const h=_(J);return q[h]?!1:(q[h]=!0,!0)}}t.uniqueFilter=e;function i(_,q){for(let J=_.length-1;J>=0;J--){const h=_[J];if(q(h))return J}return-1}t.lastIndex=i;function n(_,q){return _.length>0?_[0]:q}t.firstOrDefault=n;function a(_,q,J=(h,o)=>h===o){let h=0;for(let o=0,b=Math.min(_.length,q.length);o<b&&J(_[o],q[o]);o++)h++;return h}t.commonPrefixLength=a;function l(_){return[].concat(..._)}t.flatten=l;function d(_,q){let J=typeof q=="number"?_:0;typeof q=="number"?J=_:(J=0,q=_);const h=[];if(J<=q)for(let o=J;o<q;o++)h.push(o);else for(let o=J;o>q;o--)h.push(o);return h}t.range=d;function E(_,q,J){return _.reduce((h,o)=>(h[q(o)]=J?J(o):o,h),Object.create(null))}t.index=E;function N(_,q){return _.push(q),()=>j(_,q)}t.insert=N;function j(_,q){const J=_.indexOf(q);if(J>-1)return _.splice(J,1),q}t.remove=j;function k(_,q,J){const h=_.slice(0,q),o=_.slice(q);return h.concat(J,o)}t.arrayInsert=k;function U(_,q){let J;if(typeof q=="number"){let h=q;J=()=>{const o=Math.sin(h++)*179426549;return o-Math.floor(o)}}else J=Math.random;for(let h=_.length-1;h>0;h-=1){const o=Math.floor(J()*(h+1)),b=_[h];_[h]=_[o],_[o]=b}}t.shuffle=U;function W(_,q){const J=_.indexOf(q);J>-1&&(_.splice(J,1),_.unshift(q))}t.pushToStart=W;function K(_,q){const J=_.indexOf(q);J>-1&&(_.splice(J,1),_.push(q))}t.pushToEnd=K;function ne(_,q){return Array.isArray(_)?_.map(q):q(_)}t.mapArrayOrNot=ne;function ee(_){return Array.isArray(_)?_:[_]}t.asArray=ee;function ie(_){return _[Math.floor(Math.random()*_.length)]}t.getRandomElement=ie;function oe(_,q){for(const J of _){const h=q(J);if(h!==void 0)return h}}t.mapFind=oe}),define(Q[58],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var p;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(p=t.ScanError||(t.ScanError={}));var T;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(T=t.SyntaxKind||(t.SyntaxKind={}));var P;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(P=t.ParseErrorCode||(t.ParseErrorCode={}));var S;(function(e){e.DEFAULT={allowTrailingComma:!0}})(S=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,a=e.length,l="",d=0,E=16,N=0;function j(ie){let oe=0,_=0;for(;oe<ie;){const q=e.charCodeAt(n);if(q>=48&&q<=57)_=_*16+q-48;else if(q>=65&&q<=70)_=_*16+q-65+10;else if(q>=97&&q<=102)_=_*16+q-97+10;else break;n++,oe++}return oe<ie&&(_=-1),_}function k(ie){n=ie,l="",d=0,E=16,N=0}function U(){const ie=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&c(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&c(e.charCodeAt(n)))for(n++;n<e.length&&c(e.charCodeAt(n));)n++;else return N=3,e.substring(ie,n);let oe=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&c(e.charCodeAt(n))){for(n++;n<e.length&&c(e.charCodeAt(n));)n++;oe=n}else N=3;return e.substring(ie,oe)}function W(){let ie="",oe=n;for(;;){if(n>=a){ie+=e.substring(oe,n),N=2;break}const _=e.charCodeAt(n);if(_===34){ie+=e.substring(oe,n),n++;break}if(_===92){if(ie+=e.substring(oe,n),n++,n>=a){N=2;break}switch(e.charCodeAt(n++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const J=j(4);J>=0?ie+=String.fromCharCode(J):N=4;break;default:N=5}oe=n;continue}if(_>=0&&_<=31)if(f(_)){ie+=e.substring(oe,n),N=2;break}else N=6;n++}return ie}function K(){if(l="",N=0,d=n,n>=a)return d=a,E=17;let ie=e.charCodeAt(n);if(D(ie)){do n++,l+=String.fromCharCode(ie),ie=e.charCodeAt(n);while(D(ie));return E=15}if(f(ie))return n++,l+=String.fromCharCode(ie),ie===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),E=14;switch(ie){case 123:return n++,E=1;case 125:return n++,E=2;case 91:return n++,E=3;case 93:return n++,E=4;case 58:return n++,E=6;case 44:return n++,E=5;case 34:return n++,l=W(),E=10;case 47:const oe=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<a&&!f(e.charCodeAt(n));)n++;return l=e.substring(oe,n),E=12}if(e.charCodeAt(n+1)===42){n+=2;const _=a-1;let q=!1;for(;n<_;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,q=!0;break}n++}return q||(n++,N=1),l=e.substring(oe,n),E=13}return l+=String.fromCharCode(ie),n++,E=16;case 45:if(l+=String.fromCharCode(ie),n++,n===a||!c(e.charCodeAt(n)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=U(),E=11;default:for(;n<a&&ne(ie);)n++,ie=e.charCodeAt(n);if(d!==n){switch(l=e.substring(d,n),l){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return l+=String.fromCharCode(ie),n++,E=16}}function ne(ie){if(D(ie)||f(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ee(){let ie;do ie=K();while(ie>=12&&ie<=15);return ie}return{setPosition:k,getPosition:()=>n,scan:i?ee:K,getToken:()=>E,getTokenValue:()=>l,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>N}}t.createScanner=F;function D(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function f(e){return e===10||e===13||e===8232||e===8233}function c(e){return e>=48&&e<=57}var R;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(R||(R={}));function m(e,i){const n=[],a=new Object;let l;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function N(j,k,U,W){d.value=j,d.offset=k,d.length=U,d.type=W,d.colonOffset=void 0,l=d}try{v(e,{onObjectBegin:(j,k)=>{if(i<=j)throw a;l=void 0,E=i>j,n.push("")},onObjectProperty:(j,k,U)=>{if(i<k||(N(j,k,U,"property"),n[n.length-1]=j,i<=k+U))throw a},onObjectEnd:(j,k)=>{if(i<=j)throw a;l=void 0,n.pop()},onArrayBegin:(j,k)=>{if(i<=j)throw a;l=void 0,n.push(0)},onArrayEnd:(j,k)=>{if(i<=j)throw a;l=void 0,n.pop()},onLiteralValue:(j,k,U)=>{if(i<k||(N(j,k,U,r(j)),i<=k+U))throw a},onSeparator:(j,k,U)=>{if(i<=k)throw a;if(j===":"&&l&&l.type==="property")l.colonOffset=k,E=!1,l=void 0;else if(j===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(E=!0,n[n.length-1]=""),l=void 0}}})}catch(j){if(j!==a)throw j}return{path:n,previousNode:l,isAtPropertyKey:E,matches:j=>{let k=0;for(let U=0;k<j.length&&U<n.length;U++)if(j[k]===n[U]||j[k]==="*")k++;else if(j[k]!=="**")return!1;return k===j.length}}}t.getLocation=m;function w(e,i=[],n=S.DEFAULT){let a=null,l=[];const d=[];function E(j){Array.isArray(l)?l.push(j):a!==null&&(l[a]=j)}return v(e,{onObjectBegin:()=>{const j={};E(j),d.push(l),l=j,a=null},onObjectProperty:j=>{a=j},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const j=[];E(j),d.push(l),l=j,a=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:E,onError:(j,k,U)=>{i.push({error:j,offset:k,length:U})}},n),l[0]}t.parse=w;function O(e,i=[],n=S.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(j){a.type==="property"&&(a.length=j-a.offset,a=a.parent)}function d(j){return a.children.push(j),j}v(e,{onObjectBegin:j=>{a=d({type:"object",offset:j,length:-1,parent:a,children:[]})},onObjectProperty:(j,k,U)=>{a=d({type:"property",offset:k,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:j,offset:k,length:U,parent:a})},onObjectEnd:(j,k)=>{a.length=j+k-a.offset,a=a.parent,l(j+k)},onArrayBegin:(j,k)=>{a=d({type:"array",offset:j,length:-1,parent:a,children:[]})},onArrayEnd:(j,k)=>{a.length=j+k-a.offset,a=a.parent,l(j+k)},onLiteralValue:(j,k,U)=>{d({type:r(j),offset:k,length:U,parent:a,value:j}),l(k+U)},onSeparator:(j,k,U)=>{a.type==="property"&&(j===":"?a.colonOffset=k:j===","&&l(k))},onError:(j,k,U)=>{i.push({error:j,offset:k,length:U})}},n);const N=a.children[0];return N&&delete N.parent,N}t.parseTree=O;function u(e,i){if(!!e){let n=e;for(let a of i)if(typeof a=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===a){n=d.children[1],l=!0;break}if(!l)return}else{const l=a;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}}t.findNodeAtLocation=u;function g(e){if(!e.parent||!e.parent.children)return[];const i=g(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=g;function I(e){switch(e.type){case"array":return e.children.map(I);case"object":const i=Object.create(null);for(let n of e.children){const a=n.children[1];a&&(i[n.children[0].value]=I(a))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=I;function L(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=L;function C(e,i,n=!1){if(L(e,i,n)){const a=e.children;if(Array.isArray(a))for(let l=0;l<a.length&&a[l].offset<=i;l++){const d=C(a[l],i,n);if(d)return d}return e}}t.findNodeAtOffset=C;function v(e,i,n=S.DEFAULT){const a=F(e,!1);function l(M){return M?()=>M(a.getTokenOffset(),a.getTokenLength()):()=>!0}function d(M){return M?B=>M(B,a.getTokenOffset(),a.getTokenLength()):()=>!0}const E=l(i.onObjectBegin),N=d(i.onObjectProperty),j=l(i.onObjectEnd),k=l(i.onArrayBegin),U=l(i.onArrayEnd),W=d(i.onLiteralValue),K=d(i.onSeparator),ne=l(i.onComment),ee=d(i.onError),ie=n&&n.disallowComments,oe=n&&n.allowTrailingComma;function _(){for(;;){const M=a.scan();switch(a.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:ie||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(M){case 12:case 13:ie?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return M}}}function q(M,B=[],V=[]){if(ee(M),B.length+V.length>0){let $=a.getToken();for(;$!==17;){if(B.indexOf($)!==-1){_();break}else if(V.indexOf($)!==-1)break;$=_()}}}function J(M){const B=a.getTokenValue();return M?W(B):N(B),_(),!0}function h(){switch(a.getToken()){case 11:let M=0;try{M=JSON.parse(a.getTokenValue()),typeof M!="number"&&(q(2),M=0)}catch(B){q(2)}W(M);break;case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return _(),!0}function o(){return a.getToken()!==10?(q(3,[],[2,5]),!1):(J(!1),a.getToken()===6?(K(":"),_(),A()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function b(){E(),_();let M=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(M||q(4,[],[]),K(","),_(),a.getToken()===2&&oe)break}else M&&q(6,[],[]);o()||q(4,[],[2,5]),M=!0}return j(),a.getToken()!==2?q(7,[2],[]):_(),!0}function y(){k(),_();let M=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(M||q(4,[],[]),K(","),_(),a.getToken()===4&&oe)break}else M&&q(6,[],[]);A()||q(4,[],[4,5]),M=!0}return U(),a.getToken()!==4?q(8,[4],[]):_(),!0}function A(){switch(a.getToken()){case 3:return y();case 1:return b();case 10:return J(!0);default:return h()}}return _(),a.getToken()===17?n.allowEmptyContent?!0:(q(4,[],[]),!1):A()?(a.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}t.visit=v;function s(e,i){let n=F(e),a=[],l,d=0,E;do switch(E=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:d!==E&&a.push(e.substring(d,E)),i!==void 0&&a.push(n.getTokenValue().replace(/[^\r\n]/g,i)),d=n.getPosition();break}while(l!==17);return a.join("")}t.stripComments=s;function r(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=r});"use strict";(function(){function x(P){const S=[];typeof P=="number"&&S.push("code/timeOrigin",P);function F(f){S.push(f,Date.now())}function D(){const f=[];for(let c=0;c<S.length;c+=2)f.push({name:S[c],startTime:S[c+1]});return f}return{mark:F,getMarks:D}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const F of performance.getEntriesByType("mark"))S.push({name:F.name,startTime:Math.round(P+F.startTime)});return S}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function p(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=t()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=p(T))})(),function(x,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var p=t();for(var T in p)(typeof exports=="object"?exports:x)[T]=p[T]}}(typeof self!="undefined"?self:this,function(){return function(x){var t={};function p(T){if(t[T])return t[T].exports;var P=t[T]={i:T,l:!1,exports:{}};return x[T].call(P.exports,P,P.exports,p),P.l=!0,P.exports}return p.m=x,p.c=t,p.d=function(T,P,S){p.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:S})},p.r=function(T){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},p.t=function(T,P){if(1&P&&(T=p(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var S=Object.create(null);if(p.r(S),Object.defineProperty(S,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var F in T)p.d(S,F,function(D){return T[D]}.bind(null,F));return S},p.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return p.d(P,"a",P),P},p.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},p.p="",p(p.s=0)}([function(x,t,p){(function(T){var P;t=x.exports=V,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var S=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,D=t.re=[],f=t.src=[],c=0,R=c++;f[R]="0|[1-9]\\d*";var m=c++;f[m]="[0-9]+";var w=c++;f[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var O=c++;f[O]="("+f[R]+")\\.("+f[R]+")\\.("+f[R]+")";var u=c++;f[u]="("+f[m]+")\\.("+f[m]+")\\.("+f[m]+")";var g=c++;f[g]="(?:"+f[R]+"|"+f[w]+")";var I=c++;f[I]="(?:"+f[m]+"|"+f[w]+")";var L=c++;f[L]="(?:-("+f[g]+"(?:\\."+f[g]+")*))";var C=c++;f[C]="(?:-?("+f[I]+"(?:\\."+f[I]+")*))";var v=c++;f[v]="[0-9A-Za-z-]+";var s=c++;f[s]="(?:\\+("+f[v]+"(?:\\."+f[v]+")*))";var r=c++,e="v?"+f[O]+f[L]+"?"+f[s]+"?";f[r]="^"+e+"$";var i="[v=\\s]*"+f[u]+f[C]+"?"+f[s]+"?",n=c++;f[n]="^"+i+"$";var a=c++;f[a]="((?:<|>)?=?)";var l=c++;f[l]=f[m]+"|x|X|\\*";var d=c++;f[d]=f[R]+"|x|X|\\*";var E=c++;f[E]="[v=\\s]*("+f[d]+")(?:\\.("+f[d]+")(?:\\.("+f[d]+")(?:"+f[L]+")?"+f[s]+"?)?)?";var N=c++;f[N]="[v=\\s]*("+f[l]+")(?:\\.("+f[l]+")(?:\\.("+f[l]+")(?:"+f[C]+")?"+f[s]+"?)?)?";var j=c++;f[j]="^"+f[a]+"\\s*"+f[E]+"$";var k=c++;f[k]="^"+f[a]+"\\s*"+f[N]+"$";var U=c++;f[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=c++;f[W]="(?:~>?)";var K=c++;f[K]="(\\s*)"+f[W]+"\\s+",D[K]=new RegExp(f[K],"g");var ne=c++;f[ne]="^"+f[W]+f[E]+"$";var ee=c++;f[ee]="^"+f[W]+f[N]+"$";var ie=c++;f[ie]="(?:\\^)";var oe=c++;f[oe]="(\\s*)"+f[ie]+"\\s+",D[oe]=new RegExp(f[oe],"g");var _=c++;f[_]="^"+f[ie]+f[E]+"$";var q=c++;f[q]="^"+f[ie]+f[N]+"$";var J=c++;f[J]="^"+f[a]+"\\s*("+i+")$|^$";var h=c++;f[h]="^"+f[a]+"\\s*("+e+")$|^$";var o=c++;f[o]="(\\s*)"+f[a]+"\\s*("+i+"|"+f[E]+")",D[o]=new RegExp(f[o],"g");var b=c++;f[b]="^\\s*("+f[E]+")\\s+-\\s+("+f[E]+")\\s*$";var y=c++;f[y]="^\\s*("+f[N]+")\\s+-\\s+("+f[N]+")\\s*$";var A=c++;f[A]="(<|>)?=?\\s*\\*";for(var M=0;M<35;M++)P(M,f[M]),D[M]||(D[M]=new RegExp(f[M]));function B(z,G){if(z instanceof V)return z;if(typeof z!="string"||z.length>S||!(G?D[n]:D[r]).test(z))return null;try{return new V(z,G)}catch(H){return null}}function V(z,G){if(z instanceof V){if(z.loose===G)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>S)throw new TypeError("version is longer than "+S+" characters");if(!(this instanceof V))return new V(z,G);P("SemVer",z,G),this.loose=G;var H=z.trim().match(G?D[n]:D[r]);if(!H)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+H[1],this.minor=+H[2],this.patch=+H[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");H[4]?this.prerelease=H[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ae=+se;if(ae>=0&&ae<F)return ae}return se}):this.prerelease=[],this.build=H[5]?H[5].split("."):[],this.format()}t.parse=B,t.valid=function(z,G){var H=B(z,G);return H?H.version:null},t.clean=function(z,G){var H=B(z.trim().replace(/^[=v]+/,""),G);return H?H.version:null},t.SemVer=V,V.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},V.prototype.toString=function(){return this.version},V.prototype.compare=function(z){return P("SemVer.compare",this.version,this.loose,z),z instanceof V||(z=new V(z,this.loose)),this.compareMain(z)||this.comparePre(z)},V.prototype.compareMain=function(z){return z instanceof V||(z=new V(z,this.loose)),X(this.major,z.major)||X(this.minor,z.minor)||X(this.patch,z.patch)},V.prototype.comparePre=function(z){if(z instanceof V||(z=new V(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var G=0;do{var H=this.prerelease[G],se=z.prerelease[G];if(P("prerelease compare",G,H,se),H===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(H===void 0)return-1;if(H!==se)return X(H,se)}while(++G)},V.prototype.inc=function(z,G){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var H=this.prerelease.length;--H>=0;)typeof this.prerelease[H]=="number"&&(this.prerelease[H]++,H=-2);H===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,G,H,se){typeof H=="string"&&(se=H,H=void 0);try{return new V(z,H).inc(G,se).version}catch(ae){return null}},t.diff=function(z,G){if(le(z,G))return null;var H=B(z),se=B(G);if(H.prerelease.length||se.prerelease.length){for(var ae in H)if((ae==="major"||ae==="minor"||ae==="patch")&&H[ae]!==se[ae])return"pre"+ae;return"prerelease"}for(var ae in H)if((ae==="major"||ae==="minor"||ae==="patch")&&H[ae]!==se[ae])return ae},t.compareIdentifiers=X;var $=/^[0-9]+$/;function X(z,G){var H=$.test(z),se=$.test(G);return H&&se&&(z=+z,G=+G),H&&!se?-1:se&&!H?1:z<G?-1:z>G?1:0}function Y(z,G,H){return new V(z,H).compare(new V(G,H))}function te(z,G,H){return Y(z,G,H)>0}function re(z,G,H){return Y(z,G,H)<0}function le(z,G,H){return Y(z,G,H)===0}function ge(z,G,H){return Y(z,G,H)!==0}function Ie(z,G,H){return Y(z,G,H)>=0}function Fe(z,G,H){return Y(z,G,H)<=0}function Le(z,G,H,se){var ae;switch(G){case"===":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ae=z===H;break;case"!==":typeof z=="object"&&(z=z.version),typeof H=="object"&&(H=H.version),ae=z!==H;break;case"":case"=":case"==":ae=le(z,H,se);break;case"!=":ae=ge(z,H,se);break;case">":ae=te(z,H,se);break;case">=":ae=Ie(z,H,se);break;case"<":ae=re(z,H,se);break;case"<=":ae=Fe(z,H,se);break;default:throw new TypeError("Invalid operator: "+G)}return ae}function Ee(z,G){if(z instanceof Ee){if(z.loose===G)return z;z=z.value}if(!(this instanceof Ee))return new Ee(z,G);P("comparator",z,G),this.loose=G,this.parse(z),this.semver===Me?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}t.rcompareIdentifiers=function(z,G){return X(G,z)},t.major=function(z,G){return new V(z,G).major},t.minor=function(z,G){return new V(z,G).minor},t.patch=function(z,G){return new V(z,G).patch},t.compare=Y,t.compareLoose=function(z,G){return Y(z,G,!0)},t.rcompare=function(z,G,H){return Y(G,z,H)},t.sort=function(z,G){return z.sort(function(H,se){return t.compare(H,se,G)})},t.rsort=function(z,G){return z.sort(function(H,se){return t.rcompare(H,se,G)})},t.gt=te,t.lt=re,t.eq=le,t.neq=ge,t.gte=Ie,t.lte=Fe,t.cmp=Le,t.Comparator=Ee;var Me={};function pe(z,G){if(z instanceof pe)return z.loose===G?z:new pe(z.raw,G);if(z instanceof Ee)return new pe(z.value,G);if(!(this instanceof pe))return new pe(z,G);if(this.loose=G,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(H){return this.parseRange(H.trim())},this).filter(function(H){return H.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function We(z,G,H,se,ae,be,de,Ce,we,Oe,ke,Se,Pe){return((G=Re(H)?"":Re(se)?">="+H+".0.0":Re(ae)?">="+H+"."+se+".0":">="+G)+" "+(Ce=Re(we)?"":Re(Oe)?"<"+(+we+1)+".0.0":Re(ke)?"<"+we+"."+(+Oe+1)+".0":Se?"<="+we+"."+Oe+"."+ke+"-"+Se:"<="+Ce)).trim()}function xe(z,G){for(var H=0;H<z.length;H++)if(!z[H].test(G))return!1;if(G.prerelease.length){for(H=0;H<z.length;H++)if(P(z[H].semver),z[H].semver!==Me&&z[H].semver.prerelease.length>0){var se=z[H].semver;if(se.major===G.major&&se.minor===G.minor&&se.patch===G.patch)return!0}return!1}return!0}function Ue(z,G,H){try{G=new pe(G,H)}catch(se){return!1}return G.test(z)}function ze(z,G,H,se){var ae,be,de,Ce,we;switch(z=new V(z,se),G=new pe(G,se),H){case">":ae=te,be=Fe,de=re,Ce=">",we=">=";break;case"<":ae=re,be=Ie,de=te,Ce="<",we="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,G,se))return!1;for(var Oe=0;Oe<G.set.length;++Oe){var ke=G.set[Oe],Se=null,Pe=null;if(ke.forEach(function(Te){Te.semver===Me&&(Te=new Ee(">=0.0.0")),Se=Se||Te,Pe=Pe||Te,ae(Te.semver,Se.semver,se)?Se=Te:de(Te.semver,Pe.semver,se)&&(Pe=Te)}),Se.operator===Ce||Se.operator===we||(!Pe.operator||Pe.operator===Ce)&&be(z,Pe.semver)||Pe.operator===we&&de(z,Pe.semver))return!1}return!0}Ee.prototype.parse=function(z){var G=this.loose?D[J]:D[h],H=z.match(G);if(!H)throw new TypeError("Invalid comparator: "+z);this.operator=H[1],this.operator==="="&&(this.operator=""),H[2]?this.semver=new V(H[2],this.loose):this.semver=Me},Ee.prototype.toString=function(){return this.value},Ee.prototype.test=function(z){return P("Comparator.test",z,this.loose),this.semver===Me||(typeof z=="string"&&(z=new V(z,this.loose)),Le(z,this.operator,this.semver,this.loose))},Ee.prototype.intersects=function(z,G){if(!(z instanceof Ee))throw new TypeError("a Comparator is required");var H;if(this.operator==="")return H=new pe(z.value,G),Ue(this.value,H,G);if(z.operator==="")return H=new pe(this.value,G),Ue(z.semver,H,G);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),be=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ce=Le(this.semver,"<",z.semver,G)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),we=Le(this.semver,">",z.semver,G)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||ae||be&&de||Ce||we},t.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(z){var G=this.loose;z=z.trim(),P("range",z,G);var H=G?D[y]:D[b];z=z.replace(H,We),P("hyphen replace",z),z=z.replace(D[o],"$1$2$3"),P("comparator trim",z,D[o]),z=(z=(z=z.replace(D[K],"$1~")).replace(D[oe],"$1^")).split(/\s+/).join(" ");var se=G?D[J]:D[h],ae=z.split(" ").map(function(be){return function(de,Ce){return P("comp",de),de=function(we,Oe){return we.trim().split(/\s+/).map(function(ke){return function(Se,Pe){P("caret",Se,Pe);var Te=Pe?D[q]:D[_];return Se.replace(Te,function(Ae,ce,he,me,ve){var De;return P("caret",Se,Ae,ce,he,me,ve),Re(ce)?De="":Re(he)?De=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(me)?De=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":ve?(P("replaceCaret pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=ce==="0"?he==="0"?">="+ce+"."+he+"."+me+ve+" <"+ce+"."+he+"."+(+me+1):">="+ce+"."+he+"."+me+ve+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+me+ve+" <"+(+ce+1)+".0.0"):(P("no pr"),De=ce==="0"?he==="0"?">="+ce+"."+he+"."+me+" <"+ce+"."+he+"."+(+me+1):">="+ce+"."+he+"."+me+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+me+" <"+(+ce+1)+".0.0"),P("caret return",De),De})}(ke,Oe)}).join(" ")}(de,Ce),P("caret",de),de=function(we,Oe){return we.trim().split(/\s+/).map(function(ke){return function(Se,Pe){var Te=Pe?D[ee]:D[ne];return Se.replace(Te,function(Ae,ce,he,me,ve){var De;return P("tilde",Se,Ae,ce,he,me,ve),Re(ce)?De="":Re(he)?De=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(me)?De=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":ve?(P("replaceTilde pr",ve),ve.charAt(0)!=="-"&&(ve="-"+ve),De=">="+ce+"."+he+"."+me+ve+" <"+ce+"."+(+he+1)+".0"):De=">="+ce+"."+he+"."+me+" <"+ce+"."+(+he+1)+".0",P("tilde return",De),De})}(ke,Oe)}).join(" ")}(de,Ce),P("tildes",de),de=function(we,Oe){return P("replaceXRanges",we,Oe),we.split(/\s+/).map(function(ke){return function(Se,Pe){Se=Se.trim();var Te=Pe?D[k]:D[j];return Se.replace(Te,function(Ae,ce,he,me,ve,De){P("xRange",Se,Ae,ce,he,me,ve,De);var _e=Re(he),Ne=_e||Re(me),je=Ne||Re(ve);return ce==="="&&je&&(ce=""),_e?Ae=ce===">"||ce==="<"?"<0.0.0":"*":ce&&je?(Ne&&(me=0),je&&(ve=0),ce===">"?(ce=">=",Ne?(he=+he+1,me=0,ve=0):je&&(me=+me+1,ve=0)):ce==="<="&&(ce="<",Ne?he=+he+1:me=+me+1),Ae=ce+he+"."+me+"."+ve):Ne?Ae=">="+he+".0.0 <"+(+he+1)+".0.0":je&&(Ae=">="+he+"."+me+".0 <"+he+"."+(+me+1)+".0"),P("xRange return",Ae),Ae})}(ke,Oe)}).join(" ")}(de,Ce),P("xrange",de),de=function(we,Oe){return P("replaceStars",we,Oe),we.trim().replace(D[A],"")}(de,Ce),P("stars",de),de}(be,G)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(be){return!!be.match(se)})),ae=ae.map(function(be){return new Ee(be,G)})},pe.prototype.intersects=function(z,G){if(!(z instanceof pe))throw new TypeError("a Range is required");return this.set.some(function(H){return H.every(function(se){return z.set.some(function(ae){return ae.every(function(be){return se.intersects(be,G)})})})})},t.toComparators=function(z,G){return new pe(z,G).set.map(function(H){return H.map(function(se){return se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new V(z,this.loose));for(var G=0;G<this.set.length;G++)if(xe(this.set[G],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,G,H){var se=null,ae=null;try{var be=new pe(G,H)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&ae.compare(de)!==-1||(ae=new V(se=de,H)))}),se},t.minSatisfying=function(z,G,H){var se=null,ae=null;try{var be=new pe(G,H)}catch(de){return null}return z.forEach(function(de){be.test(de)&&(se&&ae.compare(de)!==1||(ae=new V(se=de,H)))}),se},t.validRange=function(z,G){try{return new pe(z,G).range||"*"}catch(H){return null}},t.ltr=function(z,G,H){return ze(z,G,"<",H)},t.gtr=function(z,G,H){return ze(z,G,">",H)},t.outside=ze,t.prerelease=function(z,G){var H=B(z,G);return H&&H.prerelease.length?H.prerelease:null},t.intersects=function(z,G,H){return z=new pe(z,H),G=new pe(G,H),z.intersects(G)},t.coerce=function(z){if(z instanceof V)return z;if(typeof z!="string")return null;var G=z.match(D[U]);return G==null?null:B((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,p(1))},function(x,t){var p,T,P=x.exports={};function S(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function D(I){if(p===setTimeout)return setTimeout(I,0);if((p===S||!p)&&setTimeout)return p=setTimeout,setTimeout(I,0);try{return p(I,0)}catch(L){try{return p.call(null,I,0)}catch(C){return p.call(this,I,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:S}catch(I){p=S}try{T=typeof clearTimeout=="function"?clearTimeout:F}catch(I){T=F}})();var f,c=[],R=!1,m=-1;function w(){R&&f&&(R=!1,f.length?c=f.concat(c):m=-1,c.length&&O())}function O(){if(!R){var I=D(w);R=!0;for(var L=c.length;L;){for(f=c,c=[];++m<L;)f&&f[m].run();m=-1,L=c.length}f=null,R=!1,function(C){if(T===clearTimeout)return clearTimeout(C);if((T===F||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(C);try{T(C)}catch(v){try{return T.call(null,C)}catch(s){return T.call(this,C)}}}(I)}}function u(I,L){this.fun=I,this.array=L}function g(){}P.nextTick=function(I){var L=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)L[C-1]=arguments[C];c.push(new u(I,L)),c.length!==1||R||D(O)},u.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=g,P.addListener=g,P.once=g,P.off=g,P.removeListener=g,P.removeAllListeners=g,P.emit=g,P.prependListener=g,P.prependOnceListener=g,P.listeners=function(I){return[]},P.binding=function(I){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(I){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Q[35],Z([0,1,12,2]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function P(v){const s=v;return s?[s.on,s.pause,s.resume,s.destroy].every(r=>typeof r=="function"):!1}t.isReadableStream=P;function S(v){const s=v;return s?P(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=S;function F(v,s){return new D(v,s)}t.newWriteableStream=F;class D{constructor(s,r){this.reducer=s,this.options=r,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){var r;if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof((r=this.options)===null||r===void 0?void 0:r.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(r=>r(s))}emitError(s){this.listeners.error.length===0?(0,p.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(r=>r(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,r){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(r),this.resume();break;case"end":this.listeners.end.push(r),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(r),this.state.flowing&&this.flowErrors();break}}removeListener(s,r){if(!this.state.destroyed){let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(r);i>=0&&e.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const r=[...this.pendingWritePromises];this.pendingWritePromises.length=0,r.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function f(v,s){const r=[];let e;for(;(e=v.read())!==null;)r.push(e);return s(r)}t.consumeReadable=f;function c(v,s,r){const e=[];let i;for(;(i=v.read())!==null&&e.length<r;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return v.read()}}}t.peekReadable=c;function R(v,s){return new Promise((r,e)=>{const i=[];m(v,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):r(void 0)},onEnd:()=>{r(s?s(i):void 0)}})})}t.consumeStream=R;function m(v,s){v.on("error",r=>s.onError(r)),v.on("end",()=>s.onEnd()),v.on("data",r=>s.onData(r))}t.listenStream=m;function w(v,s){return new Promise((r,e)=>{const i=new T.DisposableStore,n=[],a=E=>{if(n.push(E),n.length>s)return i.dispose(),v.pause(),r({stream:v,buffer:n,ended:!1})},l=E=>e(E),d=()=>r({stream:v,buffer:n,ended:!0});i.add((0,T.toDisposable)(()=>v.removeListener("error",l))),v.on("error",l),i.add((0,T.toDisposable)(()=>v.removeListener("end",d))),v.on("end",d),i.add((0,T.toDisposable)(()=>v.removeListener("data",a))),v.on("data",a)})}t.peekStream=w;function O(v,s){const r=F(s);return r.end(v),r}t.toStream=O;function u(){const v=F(()=>{throw new Error("not supported")});return v.end(),v}t.emptyStream=u;function g(v){let s=!1;return{read:()=>s?null:(s=!0,v)}}t.toReadable=g;function I(v,s,r){const e=F(r);return m(v,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=I;function L(v,s,r){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?r([v,i]):v)}}}t.prefixedReadable=L;function C(v,s,r){let e=!1;const i=F(r);return m(s,{onData:n=>e?i.write(n):(e=!0,i.write(r([v,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(v)),i.end()}}),i}t.prefixedStream=C}),define(Q[16],Z([0,1,20,35]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const P=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",F=typeof TextDecoder!="undefined";let D,f;class c{constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}static alloc(E){return P?new c(Buffer.allocUnsafe(E)):new c(new Uint8Array(E))}static wrap(E){return P&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new c(E)}static fromString(E,N){return!((N==null?void 0:N.dontUseNodeBuffer)||!1)&&P?new c(Buffer.from(E)):S?(D||(D=new TextEncoder),new c(D.encode(E))):new c(p.encodeUTF8(E))}static concat(E,N){if(typeof N=="undefined"){N=0;for(let U=0,W=E.length;U<W;U++)N+=E[U].byteLength}const j=c.alloc(N);let k=0;for(let U=0,W=E.length;U<W;U++){const K=E[U];j.set(K,k),k+=K.byteLength}return j}toString(){return P?this.buffer.toString():F?(f||(f=new TextDecoder),f.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(E,N){return new c(this.buffer.subarray(E,N))}set(E,N){E instanceof c?this.buffer.set(E.buffer,N):this.buffer.set(E,N)}readUInt32BE(E){return w(this.buffer,E)}writeUInt32BE(E,N){O(this.buffer,E,N)}readUInt32LE(E){return u(this.buffer,E)}writeUInt32LE(E,N){g(this.buffer,E,N)}readUInt8(E){return I(this.buffer,E)}writeUInt8(E,N){L(this.buffer,E,N)}}t.VSBuffer=c;function R(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0}t.readUInt16LE=R;function m(d,E,N){d[N+0]=E&255,E=E>>>8,d[N+1]=E&255}t.writeUInt16LE=m;function w(d,E){return d[E]*2**24+d[E+1]*2**16+d[E+2]*2**8+d[E+3]}t.readUInt32BE=w;function O(d,E,N){d[N+3]=E,E=E>>>8,d[N+2]=E,E=E>>>8,d[N+1]=E,E=E>>>8,d[N]=E}t.writeUInt32BE=O;function u(d,E){return d[E+0]<<0>>>0|d[E+1]<<8>>>0|d[E+2]<<16>>>0|d[E+3]<<24>>>0}t.readUInt32LE=u;function g(d,E,N){d[N+0]=E&255,E=E>>>8,d[N+1]=E&255,E=E>>>8,d[N+2]=E&255,E=E>>>8,d[N+3]=E&255}t.writeUInt32LE=g;function I(d,E){return d[E]}t.readUInt8=I;function L(d,E,N){d[N]=E}t.writeUInt8=L;function C(d){return T.consumeReadable(d,E=>c.concat(E))}t.readableToBuffer=C;function v(d){return T.toReadable(d)}t.bufferToReadable=v;function s(d){return T.consumeStream(d,E=>c.concat(E))}t.streamToBuffer=s;async function r(d){return d.ended?c.concat(d.buffer):c.concat([...d.buffer,await s(d.stream)])}t.bufferedStreamToBuffer=r;function e(d){return T.toStream(d,E=>c.concat(E))}t.bufferToStream=e;function i(d){return T.transform(d,{data:E=>typeof E=="string"?c.fromString(E):c.wrap(E)},E=>c.concat(E))}t.streamToBufferReadableStream=i;function n(d){return T.newWriteableStream(E=>c.concat(E),d)}t.newWriteableBufferStream=n;function a(d,E){return T.prefixedReadable(d,E,N=>c.concat(N))}t.prefixedBufferReadable=a;function l(d,E){return T.prefixedStream(d,E,N=>c.concat(N))}t.prefixedBufferStream=l}),define(Q[21],Z([0,1,11]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function T(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const I=Array.isArray(g)?[]:{};return Object.keys(g).forEach(L=>{g[L]&&typeof g[L]=="object"?I[L]=T(g[L]):I[L]=g[L]}),I}t.deepClone=T;function P(g){if(!g||typeof g!="object")return g;const I=[g];for(;I.length>0;){const L=I.shift();Object.freeze(L);for(const C in L)if(S.call(L,C)){const v=L[C];typeof v=="object"&&!Object.isFrozen(v)&&I.push(v)}}return g}t.deepFreeze=P;const S=Object.prototype.hasOwnProperty;function F(g,I){return D(g,I,new Set)}t.cloneAndChange=F;function D(g,I,L){if((0,p.isUndefinedOrNull)(g))return g;const C=I(g);if(typeof C!="undefined")return C;if((0,p.isArray)(g)){const v=[];for(const s of g)v.push(D(s,I,L));return v}if((0,p.isObject)(g)){if(L.has(g))throw new Error("Cannot clone recursive data-structure");L.add(g);const v={};for(let s in g)S.call(g,s)&&(v[s]=D(g[s],I,L));return L.delete(g),v}return g}function f(g,I,L=!0){return(0,p.isObject)(g)?((0,p.isObject)(I)&&Object.keys(I).forEach(C=>{C in g?L&&((0,p.isObject)(g[C])&&(0,p.isObject)(I[C])?f(g[C],I[C],L):g[C]=I[C]):g[C]=I[C]}),g):I}t.mixin=f;function c(g,I){if(g===I)return!0;if(g==null||I===null||I===void 0||typeof g!=typeof I||typeof g!="object"||Array.isArray(g)!==Array.isArray(I))return!1;let L,C;if(Array.isArray(g)){if(g.length!==I.length)return!1;for(L=0;L<g.length;L++)if(!c(g[L],I[L]))return!1}else{const v=[];for(C in g)v.push(C);v.sort();const s=[];for(C in I)s.push(C);if(s.sort(),!c(v,s))return!1;for(L=0;L<v.length;L++)if(!c(g[v[L]],I[v[L]]))return!1}return!0}t.equals=c;function R(g){const I=new Set;return JSON.stringify(g,(L,C)=>{if((0,p.isObject)(C)||Array.isArray(C)){if(I.has(C))return"[Circular]";I.add(C)}return C})}t.safeStringify=R;function m(g,I,L){const C=I(g);return typeof C=="undefined"?L:C}t.getOrDefault=m;function w(g,I){const L=Object.create(null);return!g||!I||Object.keys(I).forEach(v=>{const s=g[v],r=I[v];c(s,r)||(L[v]=r)}),L}t.distinct=w;function O(g,I){const L=I.toLowerCase(),C=Object.keys(g).find(v=>v.toLowerCase()===L);return C?g[C]:g[I]}t.getCaseInsensitive=O;function u(g,I){const L=Object.create(null);for(const C of Object.keys(g))I(C,g[C])&&(L[C]=g[C]);return L}t.filter=u}),define(Q[59],Z([0,1,7]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function T(c){const R=c;return R&&typeof R.type=="string"&&typeof R.severity=="string"}t.isRemoteConsoleLog=T;function P(c){const R=[];let m;try{const w=JSON.parse(c.arguments),O=w[w.length-1];O&&O.__$stack&&(w.pop(),m=O.__$stack),R.push(...w)}catch(w){R.push("Unable to log remote console arguments",c.arguments)}return{args:R,stack:m}}t.parse=P;function S(c){if(typeof c!="string")return S(P(c).stack);const R=c;if(R){const m=F(R),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(w&&w.length===4)return{uri:p.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}t.getFirstFrame=S;function F(c){if(!c)return c;const R=c.indexOf(`
`);return R===-1?c:c.substring(0,R)}function D(c,R){const{args:m,stack:w}=P(c),O=typeof m[0]=="string"&&m.length===1;let u=F(w);u&&(u=`(${u.trim()})`);let g=[];if(typeof m[0]=="string"?u&&O?g=[`%c[${R}] %c${m[0]} %c${u}`,f("blue"),f(""),f("grey")]:g=[`%c[${R}] %c${m[0]}`,f("blue"),f(""),...m.slice(1)]:g=[`%c[${R}]%`,f("blue"),...m],u&&!O&&g.push(u),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,g)}t.log=D;function f(c){return`color: ${c}`}}),define(Q[60],Z([0,1,16,20,7]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function S(c){return JSON.stringify(c,D)}t.stringify=S;function F(c){let R=JSON.parse(c);return R=f(R),R}t.parse=F;function D(c,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,T.regExpFlags)(R)}:R}function f(c,R=0){if(!c||R>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return P.URI.revive(c);case 2:return new RegExp(c.source,c.flags)}if(c instanceof p.VSBuffer||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let m=0;m<c.length;++m)c[m]=f(c[m],R+1);else for(const m in c)Object.hasOwnProperty.call(c,m)&&(c[m]=f(c[m],R+1))}return c}t.revive=f}),define(Q[61],Z([0,1,20,36,3,45,4]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function D(){return Object.create(null)}t.getEmptyExpression=D;const f="**",c="/",R="[/\\\\]",m="[^/\\\\]",w=/\//g;function O(o){switch(o){case 0:return"";case 1:return`${m}*?`;default:return`(?:${R}|${m}+${R}|${R}${m}+)*?`}}function u(o,b){if(!o)return[];const y=[];let A=!1,M=!1,B="";for(const V of o){switch(V){case b:if(!A&&!M){y.push(B),B="";continue}break;case"{":A=!0;break;case"}":A=!1;break;case"[":M=!0;break;case"]":M=!1;break}B+=V}return B&&y.push(B),y}t.splitGlobAware=u;function g(o){if(!o)return"";let b="";const y=u(o,c);if(y.every(A=>A===f))b=".*";else{let A=!1;y.forEach((M,B)=>{if(M===f){A||(b+=O(2),A=!0);return}let V=!1,$="",X=!1,Y="";for(const te of M){if(te!=="}"&&V){$+=te;continue}if(X&&(te!=="]"||!Y)){let re;te==="-"?re=te:(te==="^"||te==="!")&&!Y?re="^":te===c?re="":re=p.escapeRegExpCharacters(te),Y+=re;continue}switch(te){case"{":V=!0;continue;case"[":X=!0;continue;case"}":b+=`(?:${u($,",").map(ge=>g(ge)).join("|")})`,V=!1,$="";break;case"]":b+="["+Y+"]",X=!1,Y="";break;case"?":b+=m;continue;case"*":b+=O(1);continue;default:b+=p.escapeRegExpCharacters(te)}}B<y.length-1&&(y[B+1]!==f||B+2<y.length)&&(b+=R),A=!1})}return b}const I=/^\*\*\/\*\.[\w\.-]+$/,L=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,r=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new S.LRUCache(1e4),i=function(){return!1},n=function(){return null};function a(o,b){if(!o)return n;let y;typeof o!="string"?y=o.pattern:y=o,y=y.trim();const A=`${y}_${!!b.trimForExclusions}`;let M=e.get(A);if(M)return l(M,o);let B;if(I.test(y)){const V=y.substr(4);M=function($,X){return typeof $=="string"&&$.endsWith(V)?y:null}}else(B=L.exec(d(y,b)))?M=E(B[1],y):(b.trimForExclusions?v:C).test(y)?M=N(y,b):(B=s.exec(d(y,b)))?M=j(B[1].substr(1),y,!0):(B=r.exec(d(y,b)))?M=j(B[1],y,!1):M=k(y);return e.set(A,M),l(M,o)}function l(o,b){return typeof b=="string"?o:function(y,A){return T.isEqualOrParent(y,b.base)?o(P.relative(b.base,y),A):null}}function d(o,b){return b.trimForExclusions&&o.endsWith("/**")?o.substr(0,o.length-2):o}function E(o,b){const y=`/${o}`,A=`\\${o}`,M=function(V,$){return typeof V!="string"?null:$?$===o?b:null:V===o||V.endsWith(y)||V.endsWith(A)?b:null},B=[o];return M.basenames=B,M.patterns=[b],M.allBasenames=B,M}function N(o,b){const y=h(o.slice(1,-1).split(",").map($=>a($,b)).filter($=>$!==n),o),A=y.length;if(!A)return n;if(A===1)return y[0];const M=function($,X){for(let Y=0,te=y.length;Y<te;Y++)if(y[Y]($,X))return o;return null},B=y.find($=>!!$.allBasenames);B&&(M.allBasenames=B.allBasenames);const V=y.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return V.length&&(M.allPaths=V),M}function j(o,b,y){const A=P.sep===P.posix.sep,M=A?o:o.replace(w,P.sep),B=P.sep+M,V=P.posix.sep+o,$=y?function(X,Y){return typeof X=="string"&&(X===M||X.endsWith(B)||!A&&(X===o||X.endsWith(V)))?b:null}:function(X,Y){return typeof X=="string"&&(X===M||!A&&X===o)?b:null};return $.allPaths=[(y?"*/":"./")+o],$}function k(o){try{const b=new RegExp(`^${g(o)}$`);return function(y){return b.lastIndex=0,typeof y=="string"&&b.test(y)?o:null}}catch(b){return n}}function U(o,b,y){return!o||typeof b!="string"?!1:W(o)(b,void 0,y)}t.match=U;function W(o,b={}){if(!o)return i;if(typeof o=="string"||ie(o)){const y=a(o,b);if(y===n)return i;const A=function(M,B){return!!y(M,B)};return y.allBasenames&&(A.allBasenames=y.allBasenames),y.allPaths&&(A.allPaths=y.allPaths),A}return q(o,b)}t.parse=W;function K(o){if(!!o){let b;return y=>(b||(b=(o()||Promise.resolve([])).then(A=>A?ee(A):{})),b.then(A=>!!A[y]))}}t.hasSiblingPromiseFn=K;function ne(o){if(!!o){let b;return y=>{if(!b){const A=o();b=A?ee(A):{}}return!!b[y]}}}t.hasSiblingFn=ne;function ee(o){const b={};for(const y of o)b[y]=!0;return b}function ie(o){const b=o;return b&&typeof b.base=="string"&&typeof b.pattern=="string"}t.isRelativePattern=ie;function oe(o){return o.allBasenames||[]}t.getBasenameTerms=oe;function _(o){return o.allPaths||[]}t.getPathTerms=_;function q(o,b){const y=h(Object.getOwnPropertyNames(o).map($=>J($,o[$],b)).filter($=>$!==n)),A=y.length;if(!A)return n;if(!y.some($=>!!$.requiresSiblings)){if(A===1)return y[0];const $=function(te,re){for(let le=0,ge=y.length;le<ge;le++){const Ie=y[le](te,re);if(Ie)return Ie}return null},X=y.find(te=>!!te.allBasenames);X&&($.allBasenames=X.allBasenames);const Y=y.reduce((te,re)=>re.allPaths?te.concat(re.allPaths):te,[]);return Y.length&&($.allPaths=Y),$}const M=function($,X,Y){let te;for(let re=0,le=y.length;re<le;re++){const ge=y[re];ge.requiresSiblings&&Y&&(X||(X=P.basename($)),te||(te=X.substr(0,X.length-P.extname($).length)));const Ie=ge($,X,te,Y);if(Ie)return Ie}return null},B=y.find($=>!!$.allBasenames);B&&(M.allBasenames=B.allBasenames);const V=y.reduce(($,X)=>X.allPaths?$.concat(X.allPaths):$,[]);return V.length&&(M.allPaths=V),M}function J(o,b,y){if(b===!1)return n;const A=a(o,y);if(A===n)return n;if(typeof b=="boolean")return A;if(b){const M=b.when;if(typeof M=="string"){const B=(V,$,X,Y)=>{if(!Y||!A(V,$))return null;const te=M.replace("$(basename)",X),re=Y(te);return(0,F.isThenable)(re)?re.then(le=>le?o:null):re?o:null};return B.requiresSiblings=!0,B}}return A}function h(o,b){const y=o.filter($=>!!$.basenames);if(y.length<2)return o;const A=y.reduce(($,X)=>{const Y=X.basenames;return Y?$.concat(Y):$},[]);let M;if(b){M=[];for(let $=0,X=A.length;$<X;$++)M.push(b)}else M=y.reduce(($,X)=>{const Y=X.patterns;return Y?$.concat(Y):$},[]);const B=function($,X){if(typeof $!="string")return null;if(!X){let te;for(te=$.length;te>0;te--){const re=$.charCodeAt(te-1);if(re===47||re===92)break}X=$.substr(te)}const Y=A.indexOf(X);return Y!==-1?M[Y]:null};B.basenames=A,B.patterns=M,B.allBasenames=A;const V=o.filter($=>!$.basenames);return V.push(B),V}}),define(Q[62],Z([0,1,7,3,20,8,13,17,36]),function(x,t,p,T,P,S,F,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function c(a,l,d){if(typeof a=="string"&&(a=p.URI.file(a)),d){const N=d.getWorkspaceFolder(a);if(N){const j=d.getWorkspace().folders.length>1;let k;if((0,D.isEqual)(N.uri,a)?k="":k=(0,D.relativePath)(N.uri,a),j){const U=N.name?N.name:(0,D.basename)(N.uri);k=k?U+" \u2022 "+k:U}return k}}if(a.scheme!==S.Schemas.file&&a.scheme!==S.Schemas.untitled)return a.with({query:null,fragment:null}).toString(!0);if((0,f.hasDriveLetter)(a.fsPath))return(0,T.normalize)(m(a.fsPath));let E=(0,T.normalize)(a.fsPath);return!F.isWindows&&(l==null?void 0:l.userHome)&&(E=O(E,l.userHome.fsPath)),E}t.getPathLabel=c;function R(a){if(!!a){typeof a=="string"&&(a=p.URI.file(a));const l=(0,D.basename)(a)||(a.scheme===S.Schemas.file?a.fsPath:a.path);return F.isWindows&&(0,f.isRootOrDriveLetter)(l)?m(l):l}}t.getBaseLabel=R;function m(a){return(0,f.hasDriveLetter)(a)?a.charAt(0).toUpperCase()+a.slice(1):a}t.normalizeDriveLetter=m;let w=Object.create(null);function O(a,l){if(F.isWindows||!a||!l)return a;let d=w.original===l?w.normalized:void 0;return d||(d=`${(0,P.rtrim)(l,T.posix.sep)}${T.posix.sep}`,w={original:l,normalized:d}),(F.isLinux?a.startsWith(d):(0,P.startsWithIgnoreCase)(a,d))&&(a=`~/${a.substr(d.length)}`),a}t.tildify=O;function u(a,l){return a.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=u;const g="\u2026",I="\\\\",L="~";function C(a,l=T.sep){const d=new Array(a.length);let E=!1;for(let N=0;N<a.length;N++){let j=a[N];if(j===""){d[N]=`.${l}`;continue}if(!j){d[N]=j;continue}E=!0;let k="";j.indexOf(I)===0?(k=j.substr(0,j.indexOf(I)+I.length),j=j.substr(j.indexOf(I)+I.length)):j.indexOf(l)===0?(k=j.substr(0,j.indexOf(l)+l.length),j=j.substr(j.indexOf(l)+l.length)):j.indexOf(L)===0&&(k=j.substr(0,j.indexOf(L)+L.length),j=j.substr(j.indexOf(L)+L.length));const U=j.split(l);for(let W=1;E&&W<=U.length;W++)for(let K=U.length-W;E&&K>=0;K--){E=!1;let ne=U.slice(K,K+W).join(l);for(let ee=0;!E&&ee<a.length;ee++)if(ee!==N&&a[ee]&&a[ee].indexOf(ne)>-1){const ie=K+W===U.length,oe=K>0&&a[ee].indexOf(l)>-1?l+ne:ne,_=a[ee].endsWith(oe);E=!ie||_}if(!E){let ee="";(U[0].endsWith(":")||k!=="")&&(K===1&&(K=0,W++,ne=U[0]+l+ne),K>0&&(ee=U[0]+l),ee=k+ee),K>0&&(ee=ee+g+l),ee=ee+ne,K+W<U.length&&(ee=ee+l+g),d[N]=ee}}E&&(d[N]=j)}return d}t.shorten=C;var v;(function(a){a[a.TEXT=0]="TEXT",a[a.VARIABLE=1]="VARIABLE",a[a.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function s(a,l=Object.create(null)){const d=[];let E=!1,N="";for(const j of a)if(j==="$"||E&&j==="{")N&&d.push({value:N,type:v.TEXT}),N="",E=!0;else if(j==="}"&&E){const k=l[N];if(typeof k=="string")k.length&&d.push({value:k,type:v.VARIABLE});else if(k){const U=d[d.length-1];(!U||U.type!==v.SEPARATOR)&&d.push({value:k.label,type:v.SEPARATOR})}N="",E=!1}else N+=j;return N&&!E&&d.push({value:N,type:v.TEXT}),d.filter((j,k)=>{if(j.type===v.SEPARATOR){const U=d[k-1],W=d[k+1];return[U,W].every(K=>K&&(K.type===v.VARIABLE||K.type===v.TEXT)&&K.value.length>0)}return!0}).map(j=>j.value).join("")}t.template=s;function r(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,"").replace(/&/g,F.isMacintosh?"&":"&&"):a.replace(/&&|&/g,d=>d==="&"?"&&":"&")}t.mnemonicMenuLabel=r;function e(a,l){return F.isMacintosh||l?a.replace(/\(&&\w\)|&&/g,""):F.isWindows?a.replace(/&&|&/g,d=>d==="&"?"&&":"&"):a.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(a){return a.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(a){const l=a.indexOf("/")!==-1?T.posix:T.win32,d=l.basename(a),E=l.dirname(a);return d.length?{name:d,parentPath:E}:{name:E,parentPath:""}}t.splitName=n}),define(Q[46],Z([0,1,125]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class T{constructor(S="utf8"){this.stringDecoder=new p.StringDecoder(S),this.remaining=null}write(S){const F=[],D=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(D.length<1)return F;let f=0,c,R=f;for(;R<D.length;)if(c=D.charCodeAt(R),c===13||c===10){if(F.push(D.substring(f,R)),R++,R<D.length){const m=c;c=D.charCodeAt(R),(m===13&&c===10||m===10&&c===13)&&R++}f=R}else R++;return this.remaining=f<D.length?D.substr(f):null,F}end(){return this.remaining}}t.LineDecoder=T}),define(Q[63],Z([0,1,18,64,20,3,14]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function D(m){const w=(0,S.dirname)(m);if(m===w)return m;const O=((0,S.basename)(m)||m).toLowerCase();try{const g=(0,F.readdirSync)(w).filter(I=>I.toLowerCase()===O);if(g.length===1){const I=D(w);if(I)return(0,S.join)(I,g[0])}else if(g.length>1){const I=g.indexOf(O);if(I>=0){const L=D(w);if(L)return(0,S.join)(L,g[I])}}}catch(u){}return null}t.realcaseSync=D;async function f(m){try{return await(0,T.promisify)(p.realpath)(m)}catch(w){const O=R(m);return await p.promises.access(O,p.constants.R_OK),O}}t.realpath=f;function c(m){try{return p.realpathSync(m)}catch(w){const O=R(m);return p.accessSync(O,p.constants.R_OK),O}}t.realpathSync=c;function R(m){return(0,P.rtrim)((0,S.normalize)(m),S.sep)}});var ye=this&&this.__await||function(x){return this instanceof ye?(this.v=x,this):new ye(x)},Ve=this&&this.__asyncGenerator||function(x,t,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var T=p.apply(x,t||[]),P,S=[];return P={},F("next"),F("throw"),F("return"),P[Symbol.asyncIterator]=function(){return this},P;function F(w){T[w]&&(P[w]=function(O){return new Promise(function(u,g){S.push([w,O,u,g])>1||D(w,O)})})}function D(w,O){try{f(T[w](O))}catch(u){m(S[0][3],u)}}function f(w){w.value instanceof ye?Promise.resolve(w.value.v).then(c,R):m(S[0][2],w)}function c(w){D("next",w)}function R(w){D("throw",w)}function m(w,O){w(O),S.shift(),S.length&&D(S[0][0],S[0][1])}},Be=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var t=x[Symbol.asyncIterator],p;return t?t.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),p={},T("next"),T("throw"),T("return"),p[Symbol.asyncIterator]=function(){return this},p);function T(S){p[S]=x[S]&&function(F){return new Promise(function(D,f){F=x[S](F),P(D,f,F.done,F.value)})}}function P(S,F,D,f){Promise.resolve(f).then(function(c){S({value:c,done:D})},F)}};define(Q[65],Z([0,1,14,32,3]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,F=/^Microsoft.PowerShell_.*/,D=/^Microsoft.PowerShellPreview_.*/;var f;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(f||(f={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class m{constructor(r,e,i){this.exePath=r,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function w({useAlternateBitness:s=!1}={}){return s?c===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function O({useAlternateBitness:s=!1,findPreview:r=!1}={}){const e=w({useAlternateBitness:s});if(!e)return null;const i=P.join(e,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(i))return null;let n=-1,a=null;for(const E of await p.readdir(i)){let N=-1;if(r){const k=E.indexOf("-");if(k<0)continue;const U=E.substring(0,k);if(!S.test(U)||E.substring(k+1)!=="preview")continue;N=parseInt(U,10)}else{if(!S.test(E))continue;N=parseInt(E,10)}if(!(N<=n)){const j=P.join(i,E,"pwsh.exe");!await p.SymlinkSupport.existsFile(j)||(a=j,n=N)}}if(!a)return null;const l=e.includes("x86")?" (x86)":"",d=r?" Preview":"";return new m(a,`PowerShell${d}${l}`,!0)}async function u({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const r=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(r))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:D,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await p.readdir(r))if(e.test(n)){const a=P.join(r,n,"pwsh.exe");return new m(a,i)}return null}function g(){const s=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new m(s,".NET Core PowerShell Global Tool")}function I(){const s=P.join(process.env.windir,c===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(s,"Windows PowerShell",!0)}function L(){return Ve(this,arguments,function*(){let r=yield ye(O());r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0})),r&&(yield yield ye(r)),r=yield ye(u()),r&&(yield yield ye(r)),r=g(),r&&(yield yield ye(r)),r=yield ye(O({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(u({findPreview:!0})),r&&(yield yield ye(r)),r=yield ye(O({useAlternateBitness:!0,findPreview:!0})),r&&(yield yield ye(r)),r=I(),r&&(yield yield ye(r))})}function C(){return Ve(this,arguments,function*(){var r,e;try{for(var i=Be(L()),n;n=yield ye(i.next()),!n.done;){const a=n.value;(yield ye(a.exists()))&&(yield yield ye(a))}}catch(a){r={error:a}}finally{try{n&&!n.done&&(e=i.return)&&(yield ye(e.call(i)))}finally{if(r)throw r.error}}})}t.enumeratePowerShellInstallations=C;async function v(){var s,r;try{for(var e=Be(C()),i;i=await e.next(),!i.done;)return i.value}catch(n){s={error:n}}finally{try{i&&!i.done&&(r=e.return)&&await r.call(e)}finally{if(s)throw s.error}}return null}t.getFirstAvailablePowerShellInstallation=v}),define(Q[66],Z([0,1,3,18,13,126,2,14]),function(x,t,p,T,P,S,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function f(m,w,O){return R({path:m,isDirectory:!1},w,O)}t.watchFile=f;function c(m,w,O){return R({path:m,isDirectory:!0},w,O)}t.watchFolder=c,t.CHANGE_BUFFER_DELAY=100;function R(m,w,O){const u=(0,p.basename)(m.path),g=new Map;let I=!1,L=[(0,F.toDisposable)(()=>{g.forEach(C=>(0,F.dispose)(C)),g.clear()})];try{const C=(0,T.watch)(m.path);L.push((0,F.toDisposable)(()=>{C.removeAllListeners(),C.close()}));const v=new Set;m.isDirectory&&(0,D.readdir)(m.path).then(s=>s.forEach(r=>v.add(r))),C.on("error",(s,r)=>{I||O(`Failed to watch ${m.path} for changes using fs.watch() (${s}, ${r})`)}),C.on("change",(s,r)=>{if(!I){let e="";if(r&&(e=r.toString(),P.isMacintosh&&(e=(0,S.normalizeNFC)(e))),!(!e||s!=="change"&&s!=="rename")){const i=m.isDirectory?(0,p.join)(m.path,e):m.path;if(m.isDirectory)if(s==="rename"){const n=g.get(i);n&&(0,F.dispose)(n);const a=setTimeout(async()=>{g.delete(i);const l=await(0,D.exists)(i);if(!I){let d;l?v.has(e)?d="changed":(d="added",v.add(e)):(v.delete(e),d="deleted"),w(d,i)}},t.CHANGE_BUFFER_DELAY);g.set(i,(0,F.toDisposable)(()=>clearTimeout(a)))}else{let n;v.has(e)?n="changed":(n="added",v.add(e)),w(n,i)}else if(s==="rename"||e!==u){const n=setTimeout(async()=>{const a=await(0,D.exists)(i);I||(a?(w("changed",i),L=[R(m,w,O)]):w("deleted",i))},t.CHANGE_BUFFER_DELAY);(0,F.dispose)(L),L=[(0,F.toDisposable)(()=>clearTimeout(n))]}else w("changed",i)}}})}catch(C){(0,D.exists)(m.path).then(v=>{v&&!I&&O(`Failed to watch ${m.path} for changes using fs.watch() (${C.toString()})`)})}return(0,F.toDisposable)(()=>{I=!0,L=(0,F.dispose)(L)})}});var ue=this&&this.__decorate||function(x,t,p,T){var P=arguments.length,S=P<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,p):T,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(x,t,p,T);else for(var D=x.length-1;D>=0;D--)(F=x[D])&&(S=(P<3?F(S):P>3?F(t,p,S):F(t,p))||S);return P>3&&S&&Object.defineProperty(t,p,S),S};define(Q[37],Z([0,1,9,2,4,28,12,16,23,11,60,20,44]),function(x,t,p,T,P,S,F,D,f,c,R,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var O;(function(h){h[h.Promise=100]="Promise",h[h.PromiseCancel=101]="PromiseCancel",h[h.EventListen=102]="EventListen",h[h.EventDispose=103]="EventDispose"})(O=t.RequestType||(t.RequestType={}));function u(h){switch(h){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(h){h[h.Initialize=200]="Initialize",h[h.PromiseSuccess=201]="PromiseSuccess",h[h.PromiseError=202]="PromiseError",h[h.PromiseErrorObj=203]="PromiseErrorObj",h[h.EventFire=204]="EventFire"})(g=t.ResponseType||(t.ResponseType={}));function I(h){switch(h){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var L;(function(h){h[h.Uninitialized=0]="Uninitialized",h[h.Idle=1]="Idle"})(L||(L={}));class C{constructor(o){this.buffer=o,this.pos=0}read(o){const b=this.buffer.slice(this.pos,this.pos+o);return this.pos+=b.byteLength,b}}class v{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(o){this.buffers.push(o)}}var s;(function(h){h[h.Undefined=0]="Undefined",h[h.String=1]="String",h[h.Buffer=2]="Buffer",h[h.VSBuffer=3]="VSBuffer",h[h.Array=4]="Array",h[h.Object=5]="Object"})(s||(s={}));function r(h){const o=D.VSBuffer.alloc(4);return o.writeUInt32BE(h,0),o}function e(h){return h.read(4).readUInt32BE(0)}function i(h){const o=D.VSBuffer.alloc(1);return o.writeUInt8(h,0),o}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object)},a=typeof Buffer!="undefined";function l(h,o){if(typeof o=="undefined")h.write(n.Undefined);else if(typeof o=="string"){const b=D.VSBuffer.fromString(o);h.write(n.String),h.write(r(b.byteLength)),h.write(b)}else if(a&&Buffer.isBuffer(o)){const b=D.VSBuffer.wrap(o);h.write(n.Buffer),h.write(r(b.byteLength)),h.write(b)}else if(o instanceof D.VSBuffer)h.write(n.VSBuffer),h.write(r(o.byteLength)),h.write(o);else if(Array.isArray(o)){h.write(n.Array),h.write(r(o.length));for(const b of o)l(h,b)}else{const b=D.VSBuffer.fromString(JSON.stringify(o));h.write(n.Object),h.write(r(b.byteLength)),h.write(b)}}function d(h){switch(h.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return h.read(e(h)).toString();case s.Buffer:return h.read(e(h)).buffer;case s.VSBuffer:return h.read(e(h));case s.Array:{const b=e(h),y=[];for(let A=0;A<b;A++)y.push(d(h));return y}case s.Object:return JSON.parse(h.read(e(h)).toString())}}class E{constructor(o,b,y=null,A=1e3){this.protocol=o,this.ctx=b,this.logger=y,this.timeoutDelay=A,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(M=>this.onRawMessage(M)),this.sendResponse({type:200})}registerChannel(o,b){this.channels.set(o,b),setTimeout(()=>this.flushPendingRequests(o),0)}sendResponse(o){switch(o.type){case 200:{const b=this.send([o.type]);this.logger&&this.logger.logOutgoing(b,0,1,I(o.type));return}case 201:case 202:case 204:case 203:{const b=this.send([o.type,o.id],o.data);this.logger&&this.logger.logOutgoing(b,o.id,1,I(o.type),o.data);return}}}send(o,b=void 0){const y=new v;return l(y,o),l(y,b),this.sendBuffer(y.buffer)}sendBuffer(o){try{return this.protocol.send(o),o.byteLength}catch(b){return 0}}onRawMessage(o){const b=new C(o),y=d(b),A=d(b),M=y[0];switch(M){case 100:return this.logger&&this.logger.logIncoming(o.byteLength,y[1],1,`${u(M)}: ${y[2]}.${y[3]}`,A),this.onPromise({type:M,id:y[1],channelName:y[2],name:y[3],arg:A});case 102:return this.logger&&this.logger.logIncoming(o.byteLength,y[1],1,`${u(M)}: ${y[2]}.${y[3]}`,A),this.onEventListen({type:M,id:y[1],channelName:y[2],name:y[3],arg:A});case 101:return this.logger&&this.logger.logIncoming(o.byteLength,y[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:y[1]});case 103:return this.logger&&this.logger.logIncoming(o.byteLength,y[1],1,`${u(M)}`),this.disposeActiveRequest({type:M,id:y[1]})}}onPromise(o){const b=this.channels.get(o.channelName);if(!b){this.collectPendingRequest(o);return}const y=new S.CancellationTokenSource;let A;try{A=b.call(this.ctx,o.name,o.arg,y.token)}catch(V){A=Promise.reject(V)}const M=o.id;A.then(V=>{this.sendResponse({id:M,data:V,type:201}),this.activeRequests.delete(o.id)},V=>{V instanceof Error?this.sendResponse({id:M,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.sendResponse({id:M,data:V,type:203}),this.activeRequests.delete(o.id)});const B=(0,T.toDisposable)(()=>y.cancel());this.activeRequests.set(o.id,B)}onEventListen(o){const b=this.channels.get(o.channelName);if(!b){this.collectPendingRequest(o);return}const y=o.id,M=b.listen(this.ctx,o.name,o.arg)(B=>this.sendResponse({id:y,data:B,type:204}));this.activeRequests.set(o.id,M)}disposeActiveRequest(o){const b=this.activeRequests.get(o.id);b&&(b.dispose(),this.activeRequests.delete(o.id))}collectPendingRequest(o){let b=this.pendingRequests.get(o.channelName);b||(b=[],this.pendingRequests.set(o.channelName,b));const y=setTimeout(()=>{console.error(`Unknown channel: ${o.channelName}`),o.type===100&&this.sendResponse({id:o.id,data:{name:"Unknown channel",message:`Channel name '${o.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);b.push({request:o,timeoutTimer:y})}flushPendingRequests(o){const b=this.pendingRequests.get(o);if(b){for(const y of b)switch(clearTimeout(y.timeoutTimer),y.request.type){case 100:this.onPromise(y.request);break;case 102:this.onEventListen(y.request);break}this.pendingRequests.delete(o)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(o=>o.dispose()),this.activeRequests.clear()}}t.ChannelServer=E;var N;(function(h){h[h.LocalSide=0]="LocalSide",h[h.OtherSide=1]="OtherSide"})(N=t.RequestInitiator||(t.RequestInitiator={}));class j{constructor(o,b=null){this.protocol=o,this.isDisposed=!1,this.state=L.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(y=>this.onBuffer(y)),this.logger=b}getChannel(o){const b=this;return{call(y,A,M){return b.isDisposed?Promise.reject(F.canceled()):b.requestPromise(o,y,A,M)},listen(y,A){return b.isDisposed?Promise.reject(F.canceled()):b.requestEvent(o,y,A)}}}requestPromise(o,b,y,A=S.CancellationToken.None){const M=this.lastRequestId++,V={id:M,type:100,channelName:o,name:b,arg:y};if(A.isCancellationRequested)return Promise.reject(F.canceled());let $;return new Promise((Y,te)=>{if(A.isCancellationRequested)return te(F.canceled());const re=()=>{const Fe=Le=>{switch(Le.type){case 201:this.handlers.delete(M),Y(Le.data);break;case 202:this.handlers.delete(M);const Ee=new Error(Le.data.message);Ee.stack=Le.data.stack,Ee.name=Le.data.name,te(Ee);break;case 203:this.handlers.delete(M),te(Le.data);break}};this.handlers.set(M,Fe),this.sendRequest(V)};let le=null;this.state===L.Idle?re():(le=(0,P.createCancelablePromise)(Fe=>this.whenInitialized()),le.then(()=>{le=null,re()}));const ge=()=>{le?(le.cancel(),le=null):this.sendRequest({id:M,type:101}),te(F.canceled())},Ie=A.onCancellationRequested(ge);$=(0,T.combinedDisposable)((0,T.toDisposable)(ge),Ie),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(o,b,y){const A=this.lastRequestId++,B={id:A,type:102,channelName:o,name:b,arg:y};let V=null;const $=new p.Emitter({onFirstListenerAdd:()=>{V=(0,P.createCancelablePromise)(Y=>this.whenInitialized()),V.then(()=>{V=null,this.activeRequests.add($),this.sendRequest(B)})},onLastListenerRemove:()=>{V?(V.cancel(),V=null):(this.activeRequests.delete($),this.sendRequest({id:A,type:103}))}}),X=Y=>$.fire(Y.data);return this.handlers.set(A,X),$.event}sendRequest(o){switch(o.type){case 100:case 102:{const b=this.send([o.type,o.id,o.channelName,o.name],o.arg);this.logger&&this.logger.logOutgoing(b,o.id,0,`${u(o.type)}: ${o.channelName}.${o.name}`,o.arg);return}case 101:case 103:{const b=this.send([o.type,o.id]);this.logger&&this.logger.logOutgoing(b,o.id,0,u(o.type));return}}}send(o,b=void 0){const y=new v;return l(y,o),l(y,b),this.sendBuffer(y.buffer)}sendBuffer(o){try{return this.protocol.send(o),o.byteLength}catch(b){return 0}}onBuffer(o){const b=new C(o),y=d(b),A=d(b),M=y[0];switch(M){case 200:return this.logger&&this.logger.logIncoming(o.byteLength,0,0,I(M)),this.onResponse({type:y[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(o.byteLength,y[1],0,I(M),A),this.onResponse({type:y[0],id:y[1],data:A})}}onResponse(o){if(o.type===200){this.state=L.Idle,this._onDidInitialize.fire();return}const b=this.handlers.get(o.id);b&&b(o)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===L.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(o=>o.dispose()),this.activeRequests.clear()}}ue([w.memoize],j.prototype,"onDidInitializePromise",null),t.ChannelClient=j;class k{constructor(o){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,o(({protocol:b,onDidClientDisconnect:y})=>{p.Event.once(b.onMessage)(M=>{const B=new C(M),V=d(B),$=new E(b,V),X=new j(b);this.channels.forEach((te,re)=>$.registerChannel(re,te));const Y={channelServer:$,channelClient:X,ctx:V};this._connections.add(Y),this._onDidAddConnection.fire(Y),y(()=>{$.dispose(),X.dispose(),this._connections.delete(Y),this._onDidRemoveConnection.fire(Y)})})})}get connections(){const o=[];return this._connections.forEach(b=>o.push(b)),o}getChannel(o,b){const y=this;return{call(A,M,B){let V;if((0,c.isFunction)(b)){let X=(0,f.getRandomElement)(y.connections.filter(b));V=X?Promise.resolve(X):p.Event.toPromise(p.Event.filter(y.onDidAddConnection,b))}else V=b.routeCall(y,A,M);const $=V.then(X=>X.channelClient.getChannel(o));return W($).call(A,M,B)},listen(A,M){if((0,c.isFunction)(b))return y.getMulticastEvent(o,b,A,M);const B=b.routeEvent(y,A,M).then(V=>V.channelClient.getChannel(o));return W(B).listen(A,M)}}}getMulticastEvent(o,b,y,A){const M=this;let B=new T.DisposableStore;const V=new p.Emitter({onFirstListenerAdd:()=>{B=new T.DisposableStore;const $=new p.EventMultiplexer,X=new Map,Y=re=>{const ge=re.channelClient.getChannel(o).listen(y,A),Ie=$.add(ge);X.set(re,Ie)},te=re=>{const le=X.get(re);!le||(le.dispose(),X.delete(re))};M.connections.filter(b).forEach(Y),p.Event.filter(M.onDidAddConnection,b)(Y,void 0,B),M.onDidRemoveConnection(te,void 0,B),$.event(V.fire,V,B),B.add($)},onLastListenerRemove:()=>{B.dispose()}});return V.event}registerChannel(o,b){this.channels.set(o,b),this._connections.forEach(y=>{y.channelServer.registerChannel(o,b)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class U{constructor(o,b,y=null){const A=new v;l(A,b),o.send(A.buffer),this.channelClient=new j(o,y),this.channelServer=new E(o,b,y)}getChannel(o){return this.channelClient.getChannel(o)}registerChannel(o,b){this.channelServer.registerChannel(o,b)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=U;function W(h){return{call(o,b,y){return h.then(A=>A.call(o,b,y))},listen(o,b){const y=new p.Relay;return h.then(A=>y.input=A.listen(o,b)),y.event}}}t.getDelayedChannel=W;function K(h){let o=!1;return{call(b,y,A){return o?h.call(b,y,A):(0,P.timeout)(0).then(()=>o=!0).then(()=>h.call(b,y,A))},listen(b,y){if(o)return h.listen(b,y);const A=new p.Relay;return(0,P.timeout)(0).then(()=>o=!0).then(()=>A.input=h.listen(b,y)),A.event}}}t.getNextTickChannel=K;class ne{constructor(o){this.fn=o}routeCall(o){return this.route(o)}routeEvent(o){return this.route(o)}async route(o){for(const b of o.connections)if(await Promise.resolve(this.fn(b.ctx)))return Promise.resolve(b);return await p.Event.toPromise(o.onDidAddConnection),await this.route(o)}}t.StaticRouter=ne;var ee;(function(h){function o(A,M){const B=A,V=M&&M.disableMarshalling,$=new Map;for(const X in B)y(X)&&$.set(X,p.Event.buffer(B[X],!0));return new class{listen(X,Y){const te=$.get(Y);if(te)return te;throw new Error(`Event not found: ${Y}`)}call(X,Y,te){const re=B[Y];if(typeof re=="function"){if(!V&&Array.isArray(te))for(let le=0;le<te.length;le++)te[le]=(0,R.revive)(te[le]);return re.apply(B,te)}throw new Error(`Method not found: ${Y}`)}}}h.fromService=o;function b(A,M){const B=M&&M.disableMarshalling;return new Proxy({},{get(V,$){var X;if(typeof $=="string")return((X=M==null?void 0:M.properties)===null||X===void 0?void 0:X.has($))?M.properties.get($):y($)?A.listen($):async function(...Y){let te;M&&!(0,c.isUndefinedOrNull)(M.context)?te=[M.context,...Y]:te=Y;const re=await A.call($,te);return B?re:(0,R.revive)(re)};throw new Error(`Property not found: ${String($)}`)}})}h.toService=b;function y(A){return A[0]==="o"&&A[1]==="n"&&m.isUpperAsciiLetter(A.charCodeAt(2))}})(ee=t.ProxyChannel||(t.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function oe(h){if(Array.isArray(h))return h;if(h&&typeof h=="object"&&typeof h.toString=="function"){let o=h.toString();if(o!=="[object Object]")return o}return h}function _(h){return Array.isArray(h)?h.map(oe):oe(h)}function q(h,o,b,y,A,M,B){B=_(B);const V=ie[A],$=V[y%V.length];let X=[`%c[${h}]%c[${String(o).padStart(7," ")}]%c[len: ${String(b).padStart(5," ")}]%c${String(y).padStart(5," ")} - ${M}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(M)?(X=X.concat(B),X.push(")")):X.push(B),console.log.apply(console,X)}t.logWithColors=q;class J{constructor(o,b){this._outgoingPrefix=o,this._incomingPrefix=b,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(o,b,y,A,M){this._totalOutgoing+=o,q(this._outgoingPrefix,this._totalOutgoing,o,b,y,A,M)}logIncoming(o,b,y,A,M){this._totalIncoming+=o,q(this._incomingPrefix,this._totalIncoming,o,b,y,A,M)}}t.IPCLogger=J}),define(Q[67],Z([0,1,2,9,4,11]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(R){R[R.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var D;(function(R){R[R.None=0]="None",R[R.Initialized=1]="Initialized",R[R.Closed=2]="Closed"})(D||(D={}));class f extends p.Disposable{constructor(m,w=Object.create(null)){super();this.database=m,this.options=w,this._onDidChangeStorage=this._register(new T.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=D.None,this.cache=new Map,this.flushDelayer=new P.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){var w,O;(w=m.changed)===null||w===void 0||w.forEach((u,g)=>this.accept(g,u)),(O=m.deleted)===null||O===void 0||O.forEach(u=>this.accept(u,void 0))}accept(m,w){if(this.state!==D.Closed){let O=!1;(0,S.isUndefinedOrNull)(w)?O=this.cache.delete(m):this.cache.get(m)!==w&&(this.cache.set(m,w),O=!0),O&&this._onDidChangeStorage.fire(m)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===D.None&&(this.state=D.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,w){const O=this.cache.get(m);return(0,S.isUndefinedOrNull)(O)?w:O}getBoolean(m,w){const O=this.get(m);return(0,S.isUndefinedOrNull)(O)?w:O==="true"}getNumber(m,w){const O=this.get(m);return(0,S.isUndefinedOrNull)(O)?w:parseInt(O,10)}async set(m,w){if(this.state!==D.Closed){if((0,S.isUndefinedOrNull)(w))return this.delete(m);const O=String(w);if(this.cache.get(m)!==O)return this.cache.set(m,O),this.pendingInserts.set(m,O),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(m){if(this.state!==D.Closed&&!!this.cache.delete(m))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=D.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{var w;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(w=this.whenFlushedCallbacks.pop())===null||w===void 0||w()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}t.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class c{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((w,O)=>this.items.set(O,w)),m.delete&&m.delete.forEach(w=>this.items.delete(w))}async close(){}}t.InMemoryStorageDatabase=c}),define(Q[68],Z([5,6]),function(x,t){return x.create("vs/base/common/date",t)}),define(Q[69],Z([0,1,68]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const T=60,P=T*60,S=P*24,F=S*7,D=S*30,f=S*365;function c(m,w){typeof m!="number"&&(m=m.getTime());const O=Math.round((new Date().getTime()-m)/1e3);if(O<-30)return(0,p.localize)(0,null,c(new Date().getTime()+O*1e3,!1));if(O<30)return(0,p.localize)(1,null);let u;return O<T?(u=O,w?u===1?(0,p.localize)(2,null,u):(0,p.localize)(3,null,u):u===1?(0,p.localize)(4,null,u):(0,p.localize)(5,null,u)):O<P?(u=Math.floor(O/T),w?u===1?(0,p.localize)(6,null,u):(0,p.localize)(7,null,u):u===1?(0,p.localize)(8,null,u):(0,p.localize)(9,null,u)):O<S?(u=Math.floor(O/P),w?u===1?(0,p.localize)(10,null,u):(0,p.localize)(11,null,u):u===1?(0,p.localize)(12,null,u):(0,p.localize)(13,null,u)):O<F?(u=Math.floor(O/S),w?u===1?(0,p.localize)(14,null,u):(0,p.localize)(15,null,u):u===1?(0,p.localize)(16,null,u):(0,p.localize)(17,null,u)):O<D?(u=Math.floor(O/F),w?u===1?(0,p.localize)(18,null,u):(0,p.localize)(19,null,u):u===1?(0,p.localize)(20,null,u):(0,p.localize)(21,null,u)):O<f?(u=Math.floor(O/D),w?u===1?(0,p.localize)(22,null,u):(0,p.localize)(23,null,u):u===1?(0,p.localize)(24,null,u):(0,p.localize)(25,null,u)):(u=Math.floor(O/f),w?u===1?(0,p.localize)(26,null,u):(0,p.localize)(27,null,u):u===1?(0,p.localize)(28,null,u):(0,p.localize)(29,null,u))}t.fromNow=c;function R(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=R}),define(Q[70],Z([5,6]),function(x,t){return x.create("vs/base/common/errorMessage",t)}),define(Q[29],Z([0,1,70,11,23]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function S(c,R){return R&&(c.stack||c.stacktrace)?p.localize(0,null,D(c),F(c.stack)||F(c.stacktrace)):D(c)}function F(c){return Array.isArray(c)?c.join(`
`):c}function D(c){return typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?p.localize(1,null,c.message):c.message||p.localize(2,null)}function f(c=null,R=!1){if(!c)return p.localize(3,null);if(Array.isArray(c)){const m=P.coalesce(c),w=f(m[0],R);return m.length>1?p.localize(4,null,w,m.length):w}if(T.isString(c))return c;if(c.detail){const m=c.detail;if(m.error)return S(m.error,R);if(m.exception)return S(m.exception,R)}return c.stack?S(c,R):c.message?c.message:p.localize(5,null)}t.toErrorMessage=f}),define(Q[71],Z([5,6]),function(x,t){return x.create("vs/base/node/processes",t)}),define(Q[47],Z([0,1,3,18,14,33,71,34,11,21,36,13,46,8]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function u(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(r,e){if(m.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};e&&(i.cwd=e);const n=S.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],i);return new Promise(a=>{n.once("error",l=>{a({success:!1,error:l})}),n.once("exit",(l,d)=>{a(l===0?{success:!0}:{success:!1,code:l!==null?l:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?u(i.status):1})}else if(m.isLinux||m.isMacintosh)try{const i=O.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{S.execFile(i,[r.pid.toString()],{encoding:"utf8",shell:!0},(a,l,d)=>{n(a?{success:!1,error:a}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function I(r=D.env){return r.comspec||"cmd.exe"}t.getWindowsShell=I;class L{constructor(e,i,n,a){if(i!==void 0&&n!==void 0&&a!==void 0)this.cmd=e,this.args=i,this.shell=n,this.options=a;else{const l=e;this.cmd=l.command,this.shell=l.isShellCommand,this.args=l.args.slice(0),this.options=l.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const l=Object.create(null);Object.keys(D.env).forEach(d=>{l[d]=D.env[d]}),Object.keys(this.options.env).forEach(d=>{l[d]=this.options.env[d]}),this.options.env=l}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const i=e.lastIndexOf(p.sep);return i!==-1&&(e=e.substring(i+1)),L.WellKnowCommands[e]?e:"other"}start(e){return m.isWindows&&(this.options&&this.options.cwd&&R.isUNC(this.options.cwd)||!this.options&&R.isUNC(D.cwd()))?Promise.reject(new Error(F.localize(0,null))):this.useExec().then(i=>{let n,a;const l=new Promise((d,E)=>{n=d,a=E});if(i){let d=this.cmd;this.args&&(d=d+" "+this.args.join(" ")),this.childProcess=S.exec(d,this.options,(E,N,j)=>{this.childProcess=null;const k=E;k&&k.killed?a({killed:this.terminateRequested,stdout:N.toString(),stderr:j.toString()}):this.handleExec(n,e,E,N,j)})}else{let d=null;const E=N=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(N,n,e,a);const j={terminated:this.terminateRequested};f.isNumber(N)&&(j.cmdCode=N),n(j)};if(this.shell&&m.isWindows){const N=c.deepClone(this.options);N.windowsVerbatimArguments=!0,N.detached=!1;let j=!1,k=!1;const U=[];let W=this.ensureQuotes(this.cmd);U.push(W.value),j=W.quoted,this.args&&this.args.forEach(ne=>{W=this.ensureQuotes(ne),U.push(W.value),k=k&&W.quoted});const K=["/s","/c"];j?k?K.push('"'+U.join(" ")+'"'):U.length>1?K.push('"'+U[0]+'" '+U.slice(1).join(" ")):K.push('"'+U[0]+'"'):K.push(U.join(" ")),d=S.spawn(I(),K,N)}else this.cmd&&(d=S.spawn(this.cmd,this.args,this.options));d&&(this.childProcess=d,this.childProcessPromise=Promise.resolve(d),this.pidResolve&&(this.pidResolve(f.isNumber(d.pid)?d.pid:-1),this.pidResolve=void 0),d.on("error",N=>{this.childProcess=null,a({terminated:this.terminateRequested,error:N})}),d.pid&&(this.childProcess.on("close",E),this.handleSpawn(d,n,e,a,!0)))}return l})}handleClose(e,i,n,a){}ensureQuotes(e){return L.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&e[0]==='"'&&e[e.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(e=>(this.terminateRequested=!0,g(e,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!m.isWindows)return e(!1);const i=S.spawn(I(),["/s","/c"]);i.on("error",n=>e(!0)),i.on("exit",n=>e(!1))})}}t.AbstractProcess=L,L.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},L.regexp=/^[^"].* .*[^"]/;class C extends L{constructor(e,i,n,a){super(e,i,n,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,i,n,a,l){[a,l].forEach((d,E)=>{const N=new w.LineDecoder;N.write(d).forEach(U=>{i({line:U,source:E===0?0:1})});const k=N.end();k&&i({line:k,source:E===0?0:1})}),e({terminated:this.terminateRequested,error:n})}handleSpawn(e,i,n,a,l){const d=new w.LineDecoder,E=new w.LineDecoder;e.stdout.on("data",N=>{d.write(N).forEach(k=>n({line:k,source:0}))}),e.stderr.on("data",N=>{E.write(N).forEach(k=>n({line:k,source:1}))}),this.stdoutLineDecoder=d,this.stderrLineDecoder=E}handleClose(e,i,n,a){const l=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;l&&n({line:l,source:0});const d=this.stderrLineDecoder?this.stderrLineDecoder.end():null;d&&n({line:d,source:1})}}t.LineProcess=C;function v(r){let e=[],i=!1;const n=function(a){if(i){e.push(a);return}(!r.send(a,d=>{if(d&&console.error(d),i=!1,e.length>0){const E=e.slice(0);e=[],E.forEach(N=>n(N))}})||m.isWindows)&&(i=!0)};return{send:n}}t.createQueuedSender=v;var s;(function(r){async function e(i,n,a){if(p.isAbsolute(i))return i;if(n===void 0&&(n=D.cwd()),p.dirname(i)!=="."||(a===void 0&&f.isString(D.env.PATH)&&(a=D.env.PATH.split(p.delimiter)),a===void 0||a.length===0))return p.join(n,i);async function d(E){return await P.exists(E)?!(await T.promises.stat(E)).isDirectory():!1}for(let E of a){let N;if(p.isAbsolute(E)?N=p.join(E,i):N=p.join(n,E,i),await d(N))return N;let j=N+".com";if(await d(j)||(j=N+".exe",await d(j)))return j}return p.join(n,i)}r.findExecutable=e})(s=t.win32||(t.win32={}))}),define(Q[72],Z([0,1,32,13,65,47]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(O,u){return O===1?T.isWindows?m():S.getWindowsShell(u):c(O,u)}t.getSystemShell=F;function D(O,u){return O===1?T.isWindows?w(u):S.getWindowsShell(u):c(O,u)}t.getSystemShellSync=D;let f=null;function c(O,u){if(T.isLinux&&O===2||T.isMacintosh&&O===3)return"/bin/bash";if(!f){let g;if(T.isWindows)g="/bin/bash";else{if(g=u.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(I){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}f=g}return f}let R=null;async function m(){return R||(R=(await(0,P.getFirstAvailablePowerShellInstallation)()).exePath),R}function w(O){if(R)return R;const u=T.isWindows&&parseFloat((0,p.release)())>=10,g=O.hasOwnProperty("PROCESSOR_ARCHITEW6432"),I=`${O.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?I:S.getWindowsShell(O)}}),define(Q[48],Z([0,1,33,2,4,21,9,47,37,59,28,12,16,13]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class u extends f.ChannelServer{constructor(L){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(v){}},onMessage:F.Event.fromNodeEventEmitter(process,"message",C=>w.VSBuffer.wrap(Buffer.from(C,"base64")))},L);process.once("disconnect",()=>this.dispose())}}t.Server=u;class g{constructor(L,C){this.modulePath=L,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new F.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const v=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new P.Delayer(v),this.child=null,this._client=null}getChannel(L){const C=this;return{call(v,s,r){return C.requestPromise(L,v,s,r)},listen(v,s){return C.requestEvent(L,v,s)}}}requestPromise(L,C,v,s=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const r=this.getCachedChannel(L),e=(0,P.createCancelablePromise)(a=>r.call(C,v,a)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,T.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(L,C,v){if(!this.disposeDelayer)return F.Event.None;this.disposeDelayer.cancel();let s;const r=new F.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(L).listen(C,v)(r.fire,r),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return r.event}get client(){if(!this._client){const L=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(C.env=Object.assign(Object.assign({},C.env),this.options.env)),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),O.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,L,C);const v=new F.Emitter;F.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,c.isRemoteConsoleLog)(l)){(0,c.log)(l,`IPC Library: ${this.options.serverName}`);return}v.fire(w.VSBuffer.wrap(Buffer.from(l,"base64")))});const r=this.options.useQueue?(0,D.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&r.send(l.buffer.toString("base64")),i=v.event,n={send:e,onMessage:i};this._client=new f.ChannelClient(n);const a=()=>this.disposeClient();process.once("exit",a),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,d)=>{process.removeListener("exit",a),this.activeRequests.forEach(E=>(0,T.dispose)(E)),this.activeRequests.clear(),l!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+d),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:d})})}return this._client}getCachedChannel(L){let C=this.channels.get(L);return C||(C=this.client.getChannel(L),this.channels.set(L,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=g}),define(Q[73],Z([5,6]),function(x,t){return x.create("vs/base/node/zip",t)}),define(Q[74],Z([5,6]),function(x,t){return x.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Q[75],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Q[76],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Q[77],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Q[78],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Q[79],Z([5,6]),function(x,t){return x.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Q[80],Z([5,6]),function(x,t){return x.create("vs/platform/extensions/common/extensionValidator",t)}),define(Q[81],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/fileService",t)}),define(Q[82],Z([5,6]),function(x,t){return x.create("vs/platform/files/common/io",t)}),define(Q[83],Z([5,6]),function(x,t){return x.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Q[84],Z([5,6]),function(x,t){return x.create("vs/platform/request/common/request",t)}),define(Q[85],Z([5,6]),function(x,t){return x.create("vs/platform/telemetry/common/telemetryService",t)}),define(Q[86],Z([0,1,3,17,44,69,8,7,34]),function(x,t,p,T,P,S,F,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class c{constructor(u,g,I){this._args=u,this.paths=g,this.productService=I}get appRoot(){return(0,p.dirname)(F.FileAccess.asFileUri("",x).fsPath)}get userHome(){return D.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return D.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return D.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,T.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const u=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",u)}return this.args.logsPath}get userDataSyncLogResource(){return D.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,T.joinPath)(D.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return D.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return D.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,T.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=f.env.VSCODE_PORTABLE;return u?D.URI.file((0,p.join)(u,"argv.json")):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,T.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return D.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,p.resolve)(u):(0,p.normalize)((0,p.join)(F.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const u=this.args["extensions-download-dir"];return u?(0,p.resolve)(u):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,p.resolve)(u);const g=f.env.VSCODE_EXTENSIONS;if(g)return g;const I=f.env.VSCODE_PORTABLE;return I?(0,p.join)(I,"extensions"):(0,T.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(g=>/^[^:/?#]+?:\/\//.test(g)?D.URI.parse(g):D.URI.file((0,p.normalize)(g)))}get extensionDevelopmentKind(){var u;return(u=this.args.extensionDevelopmentKind)===null||u===void 0?void 0:u.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?D.URI.parse(u):D.URI.file((0,p.normalize)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!f.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,T.joinPath)(D.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return D.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ue([P.memoize],c.prototype,"appRoot",null),ue([P.memoize],c.prototype,"userHome",null),ue([P.memoize],c.prototype,"userDataPath",null),ue([P.memoize],c.prototype,"appSettingsHome",null),ue([P.memoize],c.prototype,"tmpDir",null),ue([P.memoize],c.prototype,"userRoamingDataHome",null),ue([P.memoize],c.prototype,"settingsResource",null),ue([P.memoize],c.prototype,"userDataSyncHome",null),ue([P.memoize],c.prototype,"userDataSyncLogResource",null),ue([P.memoize],c.prototype,"sync",null),ue([P.memoize],c.prototype,"machineSettingsResource",null),ue([P.memoize],c.prototype,"globalStorageHome",null),ue([P.memoize],c.prototype,"workspaceStorageHome",null),ue([P.memoize],c.prototype,"keybindingsResource",null),ue([P.memoize],c.prototype,"keyboardLayoutResource",null),ue([P.memoize],c.prototype,"argvResource",null),ue([P.memoize],c.prototype,"snippetsHome",null),ue([P.memoize],c.prototype,"isExtensionDevelopment",null),ue([P.memoize],c.prototype,"untitledWorkspacesHome",null),ue([P.memoize],c.prototype,"installSourcePath",null),ue([P.memoize],c.prototype,"builtinExtensionsPath",null),ue([P.memoize],c.prototype,"extensionsPath",null),ue([P.memoize],c.prototype,"extensionDevelopmentLocationURI",null),ue([P.memoize],c.prototype,"extensionDevelopmentKind",null),ue([P.memoize],c.prototype,"extensionTestsLocationURI",null),ue([P.memoize],c.prototype,"debugExtensionHost",null),ue([P.memoize],c.prototype,"serviceMachineIdResource",null),ue([P.memoize],c.prototype,"telemetryLogResource",null),t.AbstractNativeEnvironmentService=c;function R(O,u){return w(O["inspect-extensions"],O["inspect-brk-extensions"],5870,u,O.debugId)}t.parseExtensionHostPort=R;function m(O,u){return w(O["inspect-search"],O["inspect-brk-search"],5876,u)}t.parseSearchPort=m;function w(O,u,g,I,L){const v=Number(u||O)||(I?null:g),s=v?Boolean(!!u):!1;return{port:v,break:s,debugId:L}}}),function(){"use strict";function x(t,p,T,P){function S(D){const f=F(D),c=[f];return t.isAbsolute(f)||c.unshift(P),t.resolve(...c)}function F(D){const f=process.env.VSCODE_PORTABLE;if(f)return t.join(f,"user-data");const c=D["user-data-dir"];if(c)return c;let R=process.env.VSCODE_APPDATA;if(!R)switch(process.platform){case"win32":if(R=process.env.APPDATA,!R){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");R=t.join(m,"AppData","Roaming")}break;case"darwin":R=t.join(p.homedir(),"Library","Application Support");break;case"linux":R=process.env.XDG_CONFIG_HOME||t.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(R,T)}return{getUserDataPath:S}}if(typeof define=="function")define(Q[87],Z([0,88,32,8,17,34]),function(t,p,T,P,S,F){const D=S.dirname(P.FileAccess.asFileUri("",t)),f=t.__$__nodeRequire(S.joinPath(D,"package.json").fsPath);return x(p,T,f.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),p=require("path"),T=require("os");module.exports=x(p,T,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[89],Z([0,1,32,87,86]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class S extends P.AbstractNativeEnvironmentService{constructor(D,f){super(D,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,T.getUserDataPath)(D)},f)}}t.NativeEnvironmentService=S}),define(Q[90],Z([0,1,21]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const T=/^%([\w\d.-]+)%$/i;function P(S,F){const D=f=>{if(typeof f=="string"){const c=T.exec(f);if(!!c)return F[c[1]]||f}};return(0,p.cloneAndChange)(S,D)}t.localizeManifest=P}),define(Q[49],Z([0,1,80]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(m){return m=m.trim(),m==="*"||T.test(m)}t.isValidVersionStr=P;function S(m){if(!P(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let w=m.match(T);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}t.parseVersion=S;function F(m){if(!m)return null;let w=m.majorBase,O=m.majorMustEqual,u=m.minorBase,g=m.minorMustEqual,I=m.patchBase,L=m.patchMustEqual;return m.hasCaret&&(w===0||(g=!1),L=!1),{majorBase:w,majorMustEqual:O,minorBase:u,minorMustEqual:g,patchBase:I,patchMustEqual:L,isMinimum:m.hasGreaterEquals}}t.normalizeVersion=F;function D(m,w){let O;typeof m=="string"?O=F(S(m)):O=m;let u;if(typeof w=="string"?u=F(S(w)):u=w,!O||!u)return!1;let g=O.majorBase,I=O.minorBase,L=O.patchBase,C=u.majorBase,v=u.minorBase,s=u.patchBase,r=u.majorMustEqual,e=u.minorMustEqual,i=u.patchMustEqual;return u.isMinimum?g>C?!0:g<C?!1:I>v?!0:I<v?!1:L>=s:(g===1&&C===0&&(!r||!e||!i)&&(C=1,v=0,s=0,r=!0,e=!1,i=!1),g<C?!1:g>C?!r:I<v?!1:I>v?!e:L<s?!1:L>s?!i:!0)}t.isValidVersion=D;function f(m,w,O){return w.isBuiltin||typeof w.main=="undefined"?!0:R(m,w.engines.vscode,O)}t.isValidExtensionVersion=f;function c(m,w){return m==="*"||R(w,m)}t.isEngineValid=c;function R(m,w,O=[]){let u=F(S(w));if(!u)return O.push(p.localize(0,null,w)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return O.push(p.localize(1,null,w)),!1}else if(!u.majorMustEqual)return O.push(p.localize(2,null,w)),!1;return D(m,u)?!0:(O.push(p.localize(3,null,m,w)),!1)}t.isVersionValid=R}),define(Q[91],Z([0,1,37,48,2,8]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends P.Disposable{constructor(f,c,R,m){super();this.folders=f,this.onDidFilesChange=c,this.onLogMessage=R,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(f.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(c=>!this.isDisposed&&this.onDidFilesChange(c))),this._register(this.service.onDidLogMessage(c=>this.onLogMessage(c))),this.setFolders(this.folders)}setVerboseLogging(f){this.verboseLogging=f,!this.isDisposed&&this.service&&this.service.setVerboseLogging(f)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${f}`})}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[92],Z([0,1,37,48,2,8]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends P.Disposable{constructor(f,c,R,m,w={}){super();this.folders=f,this.onDidFilesChange=c,this.onLogMessage=R,this.verboseLogging=m,this.watcherOptions=w,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const f=this._register(new T.Client(S.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(f.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(f.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(c=>!this.isDisposed&&this.onDidFilesChange(c))),this._register(this.service.onDidLogMessage(c=>this.onLogMessage(c))),this.service.setRoots(this.folders)}error(f){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${f}`})}setVerboseLogging(f){this.verboseLogging=f,this.service&&this.service.setVerboseLogging(f)}setFolders(f){this.folders=f,this.service&&this.service.setRoots(f)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Q[93],Z([0,1,33,46,61,8]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(f,c,R,m,w){this.watchedFolder=f,this.eventCallback=R,this.logCallback=m,this.verboseLogging=w,this.restartCounter=0,Array.isArray(c)?this.ignored=c.map(O=>P.parse(O)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${f}`),this.startWatcher()}startWatcher(){const f=[this.watchedFolder];this.verboseLogging&&f.push("-verbose"),this.handle=p.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,f);const c=new T.LineDecoder;this.handle.stdout.on("data",R=>{const m=[];c.write(R).forEach(w=>{const O=w.split("|");if(O.length===2){const u=Number(O[0]),g=O[1];if(u>=0&&u<3){if(this.ignored&&this.ignored.some(I=>I(g))){this.verboseLogging&&this.log(g);return}m.push({type:F.changeTypeMap[u],path:g})}else this.log(O[1])}}),m.length>0&&this.eventCallback(m)}),this.handle.on("error",R=>this.onError(R)),this.handle.stderr.on("data",R=>this.onError(R)),this.handle.on("exit",(R,m)=>this.onExit(R,m))}onError(f){this.error("process error: "+f.toString())}onExit(f,c){this.handle&&(this.error(`terminated unexpectedly (code: ${f}, signal: ${c})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(f){this.logCallback({type:"error",message:`[File Watcher (C#)] ${f}`})}log(f){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${f}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Q[94],Z([0,1,93,3,20]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class S{constructor(D,f,c,R){this.onDidFilesChange=f,this.onLogMessage=c,this.verboseLogging=R,this.service=void 0,this.folder=D[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(T.posix.sep)&&(this.folder.path=(0,P.rtrim)(this.folder.path,T.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,D=>this.onFileEvents(D),D=>this.onLogMessage(D),this.verboseLogging)}setVerboseLogging(D){this.verboseLogging=D,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(D){this.isDisposed||D.length>0&&this.onDidFilesChange(D)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=S}),define(Q[50],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class p{constructor(S,F=[],D=!1){this.ctor=S,this.staticArguments=F,this.supportsDelayedInstantiation=D}}t.SyncDescriptor=p;const T=(P,...S)=>new p(P,S);t.createSyncDescriptor=T}),define(Q[95],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class p{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}t.Node=p;class T{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let F of this._nodes.values())F.outgoing.size===0&&S.push(F);return S}insertEdge(S,F){const D=this.lookupOrInsertNode(S),f=this.lookupOrInsertNode(F);D.outgoing.set(this._hashFn(F),f),f.incoming.set(this._hashFn(S),D)}removeNode(S){const F=this._hashFn(S);this._nodes.delete(F);for(let D of this._nodes.values())D.outgoing.delete(F),D.incoming.delete(F)}lookupOrInsertNode(S){const F=this._hashFn(S);let D=this._nodes.get(F);return D||(D=new p(S),this._nodes.set(F,D)),D}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[F,D]of this._nodes)S.push(`${F}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,F]of this._nodes){const D=new Set([S]),f=this._findCycle(F,D);if(f)return f}}_findCycle(S,F){for(let[D,f]of S.outgoing){if(F.has(D))return[...F,D].join(" -> ");F.add(D);const c=this._findCycle(f,F);if(c)return c;F.delete(D)}}}t.Graph=T}),define(Q[96],Z([0,1,10]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Q[22],Z([0,1,10]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,p.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,p.refineServiceDecorator)(t.IEnvironmentService)}),define(Q[24],Z([0,1,75,10,8]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN);function S(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}t.isIExtensionIdentifier=S;var F;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var D;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(D=t.SortOrder||(t.SortOrder={}));var f;(function(m){m.Uninstall="uninstall"})(f=t.StatisticType||(t.StatisticType={}));var c;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(c=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,T.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class R extends Error{constructor(w,O){super(w);this.code=O}}t.ExtensionManagementError=R,t.IExtensionManagementService=(0,T.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,T.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,T.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=P.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),t.ExtensionsLabel=(0,p.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,p.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,T.createDecorator)("IExtensionManagementCLIService")}),define(Q[38],Z([0,1,20,10]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}t.isIExtensionIdentifier=P,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(S=t.ExtensionType||(t.ExtensionType={}));class F{constructor(R){this.value=R,this._lower=R.toLowerCase()}static equals(R,m){if(typeof R=="undefined"||R===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof R=="string"||typeof m=="string"){let w=typeof R=="string"?R:R.value,O=typeof m=="string"?m:m.value;return p.equalsIgnoreCase(w,O)}return R._lower===m._lower}static toKey(R){return typeof R=="string"?R.toLowerCase():R._lower}}t.ExtensionIdentifier=F;function D(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}t.isLanguagePackExtension=D;function f(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=f,t.IBuiltinExtensionsScannerService=(0,T.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[25],Z([0,1,20,38]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function P(O,u){return O.uuid&&u.uuid?O.uuid===u.uuid:O.id===u.id?!0:(0,p.compareIgnoreCase)(O.id,u.id)===0}t.areSameExtensions=P;class S{constructor(u,g){this.version=g,this.id=u.id,this.uuid=u.uuid}key(){return`${this.id}-${this.version}`}equals(u){return u instanceof S?P(this,u)&&this.version===u.version:!1}}t.ExtensionIdentifierWithVersion=S;function F(O,u){return`${O}.${u}`}t.getExtensionId=F;function D(O){return O.toLocaleLowerCase()}t.adoptToGalleryExtensionId=D;function f(O,u){return D(F(O,u))}t.getGalleryExtensionId=f;function c(O,u){const g=[],I=L=>{for(const C of g)if(C.some(v=>P(u(v),u(L))))return C;return null};for(const L of O){const C=I(L);C?C.push(L):g.push([L])}return g}t.groupByExtension=c;function R(O){return{id:O.identifier.id,name:O.manifest.name,galleryId:null,publisherId:O.publisherId,publisherName:O.manifest.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:O.manifest.extensionDependencies&&O.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=R;function m(O){return Object.assign({id:O.identifier.id,name:O.name,galleryId:O.identifier.uuid,publisherId:O.publisherId,publisherName:O.publisher,publisherDisplayName:O.publisherDisplayName,dependencies:!!(O.properties.dependencies&&O.properties.dependencies.length>0)},O.telemetryData)}t.getGalleryExtensionTelemetryData=m,t.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function w(O){const u=new Set;for(const g of O)g.malicious&&u.add(g.id.id);return u}t.getMaliciousExtensionsSet=w});var fe=this&&this.__param||function(x,t){return function(p,T){t(p,T,x)}};define(Q[97],Z([0,1,76,12,7,39,24,25,38,62,28,8]),function(x,t,p,T,P,S,F,D,f,c,R,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const w=C=>(0,p.localize)(0,null,C),O=(0,p.localize)(1,null,"ms-dotnettools.csharp");function u(C,v){return v?`${C.publisher}.${C.name}@${C.version}`:`${C.publisher}.${C.name}`}const g=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function I(C){const v=g.exec(C);return v&&v[1]?[(0,D.adoptToGalleryExtensionId)(v[1]),v[2]]:[(0,D.adoptToGalleryExtensionId)(C),void 0]}t.getIdAndVersion=I;let L=class{constructor(v,s){this.extensionManagementService=v,this.extensionGalleryService=s}get location(){}async listExtensions(v,s,r=console){let e=await this.extensionManagementService.getInstalled(1);const i=f.EXTENSION_CATEGORIES.map(a=>a.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){r.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(a=>a.manifest.categories?a.manifest.categories.map(d=>d.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){r.log("Possible Categories: "),i.forEach(a=>{r.log(a)});return}this.location&&r.log((0,p.localize)(2,null,this.location)),e=e.sort((a,l)=>a.identifier.id.localeCompare(l.identifier.id));let n;for(let a of e)n!==a.identifier.id&&(n=a.identifier.id,r.log(u(a.manifest,v)))}async installExtensions(v,s,r,e,i=console){const n=[],a=[];v.length&&i.log(this.location?(0,p.localize)(3,null,this.location):(0,p.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),d=(j,k)=>{const U=l.find(W=>(0,D.areSameExtensions)(W.identifier,{id:j}));if(U){if(!k&&!e)return i.log((0,p.localize)(5,null,j,U.manifest.version,j)),!1;if(k&&U.manifest.version===k)return i.log((0,p.localize)(6,null,`${j}@${k}`)),!1}return!0},E=[],N=[];for(const j of v)if(j instanceof P.URI)E.push(j);else{const[k,U]=I(j);d(k,U)&&N.push({id:k,version:U,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const j of s){const[k,U]=I(j);d(k,U)&&N.push({id:k,version:U,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(E.length&&await Promise.all(E.map(async j=>{try{const k=await this.installVSIX(j,{isBuiltin:!1,isMachineScoped:r},e,i);k&&a.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(j.toString())}})),N.length){const j=await this.getGalleryExtensions(N);await Promise.all(N.map(async k=>{const U=j.get(k.id.toLowerCase());if(U)try{const W=await this.installFromGallery(k,U,l,e,i);W&&a.push(W)}catch(W){i.error(W.message||W.stack||W),n.push(k.id)}else i.error(`${w(k.version?`${k.id}@${k.version}`:k.id)}
${O}`),n.push(k.id)}))}if(n.length)throw new Error((0,p.localize)(7,null,n.join(", ")))}async installVSIX(v,s,r,e){const i=await this.extensionManagementService.getManifest(v);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,r,e))try{return await this.extensionManagementService.install(v,s),e.log((0,p.localize)(8,null,(0,c.getBaseLabel)(v))),i}catch(a){if((0,T.isPromiseCanceledError)(a))return e.log((0,p.localize)(9,null,(0,c.getBaseLabel)(v))),null;throw a}return null}async getGalleryExtensions(v){const s=v.filter(({version:i})=>i===void 0).map(({id:i})=>i),r=v.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,R.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(r.map(async({id:i,version:n})=>{const a=await this.extensionGalleryService.getCompatibleExtension({id:i},n);a&&e.set(a.identifier.id.toLowerCase(),a)}))]),e}async installFromGallery({id:v,version:s,installOptions:r},e,i,n,a){const l=await this.extensionGalleryService.getManifest(e,R.CancellationToken.None);if(l&&!this.validateExtensionKind(l,a))return null;const d=i.find(E=>(0,D.areSameExtensions)(E.identifier,e.identifier));if(d){if(e.version===d.manifest.version)return a.log((0,p.localize)(10,null,s?`${v}@${s}`:v)),null;a.log((0,p.localize)(11,null,v,e.version))}try{return r.isBuiltin?a.log((0,p.localize)(12,null,v,e.version)):a.log((0,p.localize)(13,null,v,e.version)),await this.extensionManagementService.installFromGallery(e,r),a.log((0,p.localize)(14,null,v,e.version)),l}catch(E){if((0,T.isPromiseCanceledError)(E))return a.log((0,p.localize)(15,null,v)),null;throw E}}validateExtensionKind(v,s){return!0}async validateVSIX(v,s,r){const e={id:(0,D.getGalleryExtensionId)(v.publisher,v.name)},n=(await this.extensionManagementService.getInstalled(1)).find(a=>(0,D.areSameExtensions)(e,a.identifier)&&(0,S.gt)(a.manifest.version,v.version));return n&&!s?(r.log((0,p.localize)(16,null,n.identifier.id,n.manifest.version,v.version)),!1):this.validateExtensionKind(v,r)}async uninstallExtensions(v,s,r=console){const e=async n=>{if(n instanceof P.URI){const a=await this.extensionManagementService.getManifest(n);return u(a)}return n},i=[];for(const n of v){const a=await e(n),d=(await this.extensionManagementService.getInstalled()).filter(E=>(0,D.areSameExtensions)(E.identifier,{id:a}));if(!d.length)throw new Error(`${this.notInstalled(a)}
${O}`);if(d.some(E=>E.type===0)){r.log((0,p.localize)(17,null,a));return}if(!s&&d.some(E=>E.isBuiltin)){r.log((0,p.localize)(18,null,a));return}r.log((0,p.localize)(19,null,a));for(const E of d)await this.extensionManagementService.uninstall(E),i.push(E);this.location?r.log((0,p.localize)(20,null,a,this.location)):r.log((0,p.localize)(21,null,a))}}async locateExtension(v,s=console){const r=await this.extensionManagementService.getInstalled();v.forEach(e=>{r.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===m.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(v){return this.location?(0,p.localize)(22,null,v,this.location):(0,p.localize)(23,null,v)}};L=ue([fe(0,F.IExtensionManagementService),fe(1,F.IExtensionGalleryService)],L),t.ExtensionManagementCLIService=L}),define(Q[98],Z([0,1,2,3,38,14]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends p.Disposable{constructor(f,c){super();this.environmentService=f,this.extensionsManifestCache=(0,T.join)(this.environmentService.userDataPath,P.MANIFEST_CACHE_FOLDER,P.USER_MANIFEST_CACHE_FILE),this._register(c.onDidInstallExtension(R=>this.onDidInstallExtension(R))),this._register(c.onDidUninstallExtension(R=>this.onDidUnInstallExtension(R)))}onDidInstallExtension(f){f.error||this.invalidate()}onDidUnInstallExtension(f){f.error||this.invalidate()}invalidate(){S.rimraf(this.extensionsManifestCache,S.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Q[99],Z([0,1,88,33,30,13,127,29,72]),function(x,t,p,T,P,S,F,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function c(w,O,u){return O["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):S.isWindows?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,F.isLaunchedFromCli)(u)&&!O["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,F.isLaunchedFromCli)(u)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),R||(R=m(w)),R)}t.resolveShellEnv=c;let R;async function m(w){const O=new Promise(async(u,g)=>{const I=process.env.ELECTRON_RUN_AS_NODE;w.trace("getUnixShellEnvironment#runAsNode",I);const L=process.env.ELECTRON_NO_ATTACH_CONSOLE;w.trace("getUnixShellEnvironment#noAttach",L);const C=(0,P.generateUuid)().replace(/-/g,"").substr(0,12),v=new RegExp(C+"(.*)"+C),s=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});w.trace("getUnixShellEnvironment#env",s);const r=await(0,f.getSystemShell)(S.OS,s);w.trace("getUnixShellEnvironment#shell",r);const e=p.basename(r);let i,n;/^pwsh(-preview)?$/.test(e)?(i=`& '${process.execPath}' -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,n=["-ilc"]),w.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const a=(0,T.spawn)(r,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});a.on("error",E=>{w.error("getUnixShellEnvironment#errorChildProcess",(0,D.toErrorMessage)(E)),u({})});const l=[];a.stdout.on("data",E=>l.push(E));const d=[];a.stderr.on("data",E=>d.push(E)),a.on("close",(E,N)=>{const j=Buffer.concat(l).toString("utf8");w.trace("getUnixShellEnvironment#raw",j);const k=Buffer.concat(d).toString("utf8");if(k.trim()&&w.trace("getUnixShellEnvironment#stderr",k),E||N)return g(new Error(`Failed to get environment (code ${E}, signal ${N})`));const U=v.exec(j),W=U?U[1]:"{}";try{const K=JSON.parse(W);I?K.ELECTRON_RUN_AS_NODE=I:delete K.ELECTRON_RUN_AS_NODE,L?K.ELECTRON_NO_ATTACH_CONSOLE=L:delete K.ELECTRON_NO_ATTACH_CONSOLE,delete K.XDG_RUNTIME_DIR,w.trace("getUnixShellEnvironment#result",K),u(K)}catch(K){w.error("getUnixShellEnvironment#errorCaught",(0,D.toErrorMessage)(K)),g(K)}})});try{return await O}catch(u){return w.error("getUnixShellEnvironment#error",(0,D.toErrorMessage)(u)),{}}}}),define(Q[51],Z([0,1,7,19,13]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function S(f){return f.map(c=>({type:c.type,resource:p.URI.file(c.path)}))}t.toFileChanges=S;function F(f){const c=new D;for(const R of f)c.processEvent(R);return c.normalize()}t.normalizeFileChanges=F;class D{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(c){const R=this.mapPathToChange.get(c.path);if(R){const m=R.type,w=c.type;m===1&&w===2?(this.mapPathToChange.delete(c.path),this.normalized.splice(this.normalized.indexOf(R),1)):m===2&&w===1?R.type=0:m===1&&w===0||(R.type=w)}else this.normalized.push(c),this.mapPathToChange.set(c.path,c)}normalize(){const c=[],R=[];return this.normalized.filter(m=>m.type!==2?(c.push(m),!1):!0).sort((m,w)=>m.path.length-w.path.length).filter(m=>R.some(w=>(0,T.isParent)(m.path,w,!P.isLinux))?!1:(R.push(m.path),!0)).concat(c)}}}),define(Q[100],Z([0,1,51,2,14,63,66,4,3]),function(x,t,p,T,P,S,F,D,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class c extends T.Disposable{constructor(m,w,O,u){super();this.path=m,this.onDidFilesChange=w,this.onLogMessage=O,this.verboseLogging=u,this.fileChangesDelayer=this._register(new D.ThrottledDelayer(F.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:w}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let O=this.path;if(w)try{O=await(0,S.realpath)(O)}catch(u){if(this.onError(u),w.dangling)return}m.isDirectory()?this._register((0,F.watchFolder)(O,(u,g)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,f.join)(this.path,(0,f.basename)(g))})},u=>this.onError(u))):this._register((0,F.watchFile)(O,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const w=this.fileChangesBuffer;this.fileChangesBuffer=[];const O=(0,p.normalizeFileChanges)(w);this.verboseLogging&&O.forEach(u=>{this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`)}),O.length>0&&this.onDidFilesChange(O)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=c}),define(Q[52],Z([0,1]),function(x,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class p{constructor(...P){this._entries=new Map;for(let[S,F]of P)this.set(S,F)}set(P,S){const F=this._entries.get(P);return this._entries.set(P,S),F}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}t.ServiceCollection=p}),define(Q[101],Z([0,1,12,95,50,10,52,4]),function(x,t,p,T,P,S,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const f=!1;class c extends Error{constructor(u){var g;super("cyclic dependency between services");this.message=(g=u.findCycleSlow())!==null&&g!==void 0?g:`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class R{constructor(u=new F.ServiceCollection,g=!1,I){this._activeInstantiations=new Set,this._services=u,this._strict=g,this._parent=I,this._services.set(S.IInstantiationService,this)}createChild(u){return new R(u,this._strict,this)}invokeFunction(u,...g){let I=w.traceInvocation(u),L=!1;try{return u({get:(v,s)=>{if(L)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const r=this._getOrCreateServiceInstance(v,I);if(!r&&s!==S.optional)throw new Error(`[invokeFunction] unknown service '${v}'`);return r}},...g)}finally{L=!0,I.stop()}}createInstance(u,...g){let I,L;return u instanceof P.SyncDescriptor?(I=w.traceCreation(u.ctor),L=this._createInstance(u.ctor,u.staticArguments.concat(g),I)):(I=w.traceCreation(u),L=this._createInstance(u,g,I)),I.stop(),L}_createInstance(u,g=[],I){let L=S._util.getServiceDependencies(u).sort((s,r)=>s.index-r.index),C=[];for(const s of L){let r=this._getOrCreateServiceInstance(s.id,I);if(!r&&this._strict&&!s.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${s.id}.`);C.push(r)}let v=L.length>0?L[0].index:g.length;if(g.length!==v){console.warn(`[createInstance] First service dependency of ${u.name} at position ${v+1} conflicts with ${g.length} static arguments`);let s=v-g.length;s>0?g=g.concat(new Array(s)):g=g.slice(0,v)}return new u(...[...g,...C])}_setServiceInstance(u,g){if(this._services.get(u)instanceof P.SyncDescriptor)this._services.set(u,g);else if(this._parent)this._parent._setServiceInstance(u,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let g=this._services.get(u);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):g}_getOrCreateServiceInstance(u,g){let I=this._getServiceInstanceOrDescriptor(u);return I instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,I,g.branch(u,!0)):(g.branch(u,!1),I)}_safeCreateAndCacheServiceInstance(u,g,I){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,g,I)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,g,I){const L=new T.Graph(s=>s.id.toString());let C=0;const v=[{id:u,desc:g,_trace:I}];for(;v.length;){const s=v.pop();if(L.lookupOrInsertNode(s),C++>1e3)throw new c(L);for(let r of S._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(r.id);if(!e&&!r.optional&&console.warn(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`),e instanceof P.SyncDescriptor){const i={id:r.id,desc:e,_trace:s._trace.branch(r.id,!0)};L.insertEdge(s,i),v.push(i)}}}for(;;){const s=L.roots();if(s.length===0){if(!L.isEmpty())throw new c(L);break}for(const{data:r}of s){if(this._getServiceInstanceOrDescriptor(r.id)instanceof P.SyncDescriptor){const i=this._createServiceInstanceWithOwner(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this._setServiceInstance(r.id,i)}L.removeNode(r)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,g,I=[],L,C){if(this._services.get(u)instanceof P.SyncDescriptor)return this._createServiceInstance(g,I,L,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,g,I,L,C);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(u,g=[],I,L){if(I){const C=new D.IdleValue(()=>this._createInstance(u,g,L));return new Proxy(Object.create(null),{get(v,s){if(s in v)return v[s];let r=C.value,e=r[s];return typeof e!="function"||(e=e.bind(r),v[s]=e),e},set(v,s,r){return C.value[s]=r,!0}})}else return this._createInstance(u,g,L)}}t.InstantiationService=R;var m;(function(O){O[O.Creation=0]="Creation",O[O.Invocation=1]="Invocation",O[O.Branch=2]="Branch"})(m||(m={}));class w{constructor(u,g){this.type=u,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return f?new w(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):w._None}static traceCreation(u){return f?new w(0,u.name):w._None}branch(u,g){let I=new w(2,u.toString());return this._dep.push([u,g,I]),I}stop(){let u=Date.now()-this._start;w._totals+=u;let g=!1;function I(C,v){let s=[],r=new Array(C+1).join("	");for(const[e,i,n]of v._dep)if(i&&n){g=!0,s.push(`${r}CREATES -> ${e}`);let a=I(C+1,n);a&&s.push(a)}else s.push(`${r}uses -> ${e}`);return s.join(`
`)}let L=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${w._totals.toFixed(2)}ms)`];(u>2||g)&&console.log(L.join(`
`))}}w._None=new class extends w{constructor(){super(-1,null)}stop(){}branch(){return this}},w._totals=0}),define(Q[53],Z([0,1,10]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,p.createDecorator)("localizationsService");function T(P){if(typeof P.languageId!="string"||!Array.isArray(P.translations)||P.translations.length===0)return!1;for(const S of P.translations)if(typeof S.id!="string"||typeof S.path!="string")return!1;return!(P.languageName&&typeof P.languageName!="string"||P.localizedLanguageName&&typeof P.localizedLanguageName!="string")}t.isValidLocalization=T}),define(Q[15],Z([0,1,10,2,13,9,29]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,p.createDecorator)("logService"),t.ILoggerService=(0,p.createDecorator)("loggerService");function D(){return new Date().toISOString()}var f;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(f=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=f.Info;class c extends T.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=c;class R extends c{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(f.Trace)&&this.log(f.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(f.Debug)&&this.log(f.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(f.Info)&&this.log(f.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(f.Warning)&&this.log(f.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(f.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(f.Error,this.format(n))}else this.log(f.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(f.Critical)&&this.log(f.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let a=e[n];if(typeof a=="object")try{a=JSON.stringify(a)}catch(l){}i+=(n>0?" ":"")+a}return i}}t.AbstractMessageLogger=R;class m extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!P.isWindows}trace(e,...i){this.getLevel()<=f.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}debug(e,...i){this.getLevel()<=f.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}info(e,...i){this.getLevel()<=f.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,e,...i):console.log(`[main ${D()}]`,e,...i))}warn(e,...i){this.getLevel()<=f.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,e,...i):console.warn(`[main ${D()}]`,e,...i))}error(e,...i){this.getLevel()<=f.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}critical(e,...i){this.getLevel()<=f.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,e,...i):console.error(`[main ${D()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=m;class w extends c{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=f.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=f.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=f.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=f.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=f.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=f.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=w;class O extends c{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=f.Trace&&this.adapter.log(f.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=f.Debug&&this.adapter.log(f.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=f.Info&&this.adapter.log(f.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=f.Warning&&this.adapter.log(f.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=f.Error&&this.adapter.log(f.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=f.Critical&&this.adapter.log(f.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,F.toErrorMessage)(e,this.getLevel()<=f.Trace)}dispose(){}flush(){}}t.AdapterLogger=O;class u extends c{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=u;class g extends T.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=g;class I extends T.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(n))}))}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,(i==null?void 0:i.always)?f.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=I;class L{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(e){}getLevel(){return f.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=L;function C(r){if(r.verbose)return f.Trace;if(typeof r.logLevel=="string"){const e=v(r.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=C;function v(r){switch(r){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Critical;case"off":return f.Off}}t.parseLogLevel=v;function s(r){switch(r){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Critical:return"critical";case f.Off:return"off"}}t.LogLevelToString=s}),define(Q[102],Z([0,1,18,2,19,24,22,7,17,25,15,30,39,13,4,12]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let L=class extends T.Disposable{constructor(v,s,r,e){super();this.fileService=s,this.extensionGalleryService=r,this.logService=e,this.extensionsDownloadDir=D.URI.file(v.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(v,s){await this.cleanUpPromise;const r=this.getName(v),e=(0,f.joinPath)(this.extensionsDownloadDir,r);if(!await this.fileService.exists(e)){const i=(0,f.joinPath)(this.extensionsDownloadDir,`.${(0,m.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(v,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(a){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",v.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,g.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(v){}async rename(v,s,r){try{await p.promises.rename(v.fsPath,s.fsPath)}catch(e){if(O.isWindows&&e&&e.code==="EPERM"&&Date.now()<r)return this.logService.info(`Failed renaming ${v} to ${s} with 'EPERM' error. Trying again...`),this.rename(v,s,r);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const v=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(v.children){const s=[],r=[];for(const n of v.children){const a=this.parse(n.name);a&&r.push([a,n])}const e=(0,c.groupByExtension)(r,([n])=>n),i=[];for(const n of e)n.sort((a,l)=>w.rcompare(a[0].version,l[0].version)),s.push(...n.slice(1).map(a=>a[1].resource)),i.push(n[0][1]);i.sort((n,a)=>n.mtime-a.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await u.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(v){this.logService.error(v)}}getName(v){return this.cache?new c.ExtensionIdentifierWithVersion(v.identifier,v.version).key().toLowerCase():(0,m.generateUuid)()}parse(v){const s=I.exec(v);return s&&s[1]&&s[2]?new c.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};L=ue([fe(0,F.INativeEnvironmentService),fe(1,P.IFileService),fe(2,S.IExtensionGalleryService),fe(3,R.ILogService)],L),t.ExtensionsDownloader=L}),define(Q[103],Z([0,1,2,15,33,29,3,4,9,8,14,22]),function(x,t,p,T,P,S,F,D,f,c,R,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let w=class extends p.Disposable{constructor(u,g){super();this.environmentService=u,this.logService=g,this.processesLimiter=new D.Limiter(5)}async postUninstall(u){const g=this.parseScript(u,"uninstall");return g&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(g.script,"uninstall",g.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${I}`)))),(0,R.rimraf)(this.getExtensionStoragePath(u)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(u,g){const I=`vscode:${g}`;if(u.location.scheme===c.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[I]=="string"){const L=u.manifest.scripts[I].split(" ");return L.length<2||L[0]!=="node"||!L[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${I} should be a node script`),null):{script:(0,F.join)(u.location.fsPath,L[1]),args:L.slice(2)||[]}}return null}runLifecycleHook(u,g,I,L,C){return new Promise((v,s)=>{const r=this.start(u,g,I,C);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):v(void 0)};r.on("error",n=>{i((0,S.toErrorMessage)(n)||"Unknown")}),r.on("exit",(n,a)=>{i(n?`post-${g} process exited with code ${n}`:void 0)}),L&&(e=setTimeout(()=>{e=null,r.kill(),s("timed out")},5e3))})}start(u,g,I,L){const C={silent:!0,execArgv:void 0},v=(0,P.fork)(u,[`--type=extension-post-${g}`,...I],C);v.stdout.setEncoding("utf8"),v.stderr.setEncoding("utf8");const s=f.Event.fromNodeEventEmitter(v.stdout,"data"),r=f.Event.fromNodeEventEmitter(v.stderr,"data");s(n=>this.logService.info(L.identifier.id,L.manifest.version,`post-${g}`,n)),r(n=>this.logService.error(L.identifier.id,L.manifest.version,`post-${g}`,n));const e=f.Event.any(f.Event.map(s,n=>({data:`%c${n}`,format:[""]})),f.Event.map(r,n=>({data:`%c${n}`,format:["color: red"]})));return f.Event.debounce(e,(n,a)=>n?{data:n.data+a.data,format:[...n.format,...a.format]}:{data:a.data,format:a.format},100)(n=>{console.group(L.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),v}getExtensionStoragePath(u){return(0,F.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};w=ue([fe(0,m.IEnvironmentService),fe(1,T.ILogService)],w),t.ExtensionsLifecycle=w}),define(Q[104],Z([0,1,2,22,9,19,7,25,17,15]),function(x,t,p,T,P,S,F,D,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let R=class extends p.Disposable{constructor(w,O,u,g){super();this.extensionsManagementService=w,this.logService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new P.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(v=>v.identifier),this.startTimestamp=Date.now()}),this._register(w.onInstallExtension(C=>this.onInstallExtension(C))),this._register(w.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(w.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const I=F.URI.file(u.extensionsPath),L=new f.ExtUri(C=>!O.hasCapability(C,1024));this._register(O.watch(I)),this._register(P.Event.filter(O.onDidFilesChange,C=>C.changes.some(v=>this.doesChangeAffects(v,I,L)))(()=>this.onDidChange()))}doesChangeAffects(w,O,u){return u.isEqual(u.dirname(w.resource),O)?u.isEqual(w.resource,u.joinPath(O,".obsolete"))?!0:!(w.type!==1&&w.type!==2||u.basename(w.resource).startsWith(".")):!1}onInstallExtension(w){this.addInstallingExtension(w.identifier)}onDidInstallExtension(w){this.removeInstallingExtension(w.identifier),w.error||this.addInstalledExtension(w.identifier)}onDidUninstallExtension(w){w.error||this.removeInstalledExtension(w.identifier)}addInstallingExtension(w){this.removeInstallingExtension(w),this.installingExtensions.push(w)}removeInstallingExtension(w){this.installingExtensions=this.installingExtensions.filter(O=>!(0,D.areSameExtensions)(O,w))}addInstalledExtension(w){this.installedExtensions&&(this.removeInstalledExtension(w),this.installedExtensions.push(w))}removeInstalledExtension(w){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(O=>!(0,D.areSameExtensions)(O,w)))}async onDidChange(){if(this.installedExtensions){const w=await this.extensionsManagementService.getInstalled(1),O=w.filter(g=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,D.areSameExtensions)(I,g.identifier))?!1:g.installedTimestamp&&g.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",g.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",g.identifier.id),!1)),u=this.installedExtensions.filter(g=>this.installingExtensions.some(I=>(0,D.areSameExtensions)(I,g))?!1:w.every(I=>!(0,D.areSameExtensions)(I.identifier,g))?(this.logService.info("Detected extension removed from another source",g.id),!0):!1);this.installedExtensions=w.map(g=>g.identifier),(O.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:O,removed:u})}}};R=ue([fe(1,S.IFileService),fe(2,T.INativeEnvironmentService),fe(3,c.ILogService)],R),t.ExtensionsWatcher=R}),define(Q[105],Z([0,1,14,18,128,24,2,22,4,25,15,53,23,9,8,3]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let I=class extends F.Disposable{constructor(v,s,r){super();this.extensionManagementService=v,this.logService=r,this._onDidLanguagesChange=this._register(new O.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new L(s,r)),this._register(v.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(v.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(v=>{const s=["en",...Object.keys(v)];return(0,w.distinct)(s)})}onDidInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",v.identifier.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(v){this.cache.getLanguagePacks().then(s=>{Object.keys(s).some(r=>s[r]&&s[r].extensions.some(e=>(0,c.areSameExtensions)(e.extensionIdentifier,v)))&&(this.logService.debug("Removing language packs from the extension",v.id),this.update().then(r=>{r&&this._onDidLanguagesChange.fire()}))})}async update(){const[v,s]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),r=await this.cache.update(s);return!(0,w.equals)(Object.keys(v),Object.keys(r))}};I=ue([fe(0,S.IExtensionManagementService),fe(1,D.INativeEnvironmentService),fe(2,R.ILogService)],I),t.LocalizationsService=I;let L=class extends F.Disposable{constructor(v,s){super();this.logService=s,this.languagePacks={},this.languagePacksFilePath=(0,g.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new f.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(s=>{Object.keys(s).forEach(r=>delete s[r]),this.createLanguagePacksFromExtensions(s,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...s){for(const r of s)r&&r.manifest&&r.manifest.contributes&&r.manifest.contributes.localizations&&r.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,r);Object.keys(v).forEach(r=>this.updateHash(v[r]))}createLanguagePacksFromExtension(v,s){const r=s.identifier,e=s.manifest.contributes&&s.manifest.contributes.localizations?s.manifest.contributes.localizations:[];for(const i of e)if(s.location.scheme===u.Schemas.file&&(0,m.isValidLocalization)(i)){let n=v[i.languageId];n||(n={hash:"",extensions:[],translations:{}},v[i.languageId]=n);let a=n.extensions.filter(l=>(0,c.areSameExtensions)(l.extensionIdentifier,r))[0];a?a.version=s.manifest.version:n.extensions.push({extensionIdentifier:r,version:s.manifest.version});for(const l of i.translations)n.translations[l.id]=(0,g.join)(s.location.fsPath,l.path)}}updateHash(v){if(v){const s=(0,P.createHash)("md5");for(const r of v.extensions)s.update(r.extensionIdentifier.uuid||r.extensionIdentifier.id).update(r.version);v.hash=s.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let s=null;return T.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,r=>r.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(r)).then(r=>{try{return JSON.parse(r)}catch(e){return{}}}).then(r=>(s=v(r),r)).then(r=>{for(const i of Object.keys(r))r[i]||delete r[i];this.languagePacks=r,this.initializedCache=!0;const e=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",e),(0,p.writeFile)(this.languagePacksFilePath,e)}).then(()=>s,r=>this.logService.error(r))})}};L=ue([fe(0,D.INativeEnvironmentService),fe(1,R.ILogService)],L)}),define(Q[106],Z([0,1,15,19]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function P(f,c,R,m){try{const w=await new Promise((O,u)=>{x(["spdlog"],O,u)});return w.setAsyncMode(8192,500),w.createRotatingLoggerAsync(f,c,R,m)}catch(w){console.error(w)}return null}function S(f,c,R,m){return x.__$__nodeRequire("spdlog").createRotatingLogger(f,c,R,m)}t.createRotatingLogger=S;function F(f,c,R){switch(c){case p.LogLevel.Trace:f.trace(R);break;case p.LogLevel.Debug:f.debug(R);break;case p.LogLevel.Info:f.info(R);break;case p.LogLevel.Warning:f.warn(R);break;case p.LogLevel.Error:f.error(R);break;case p.LogLevel.Critical:f.critical(R);break;default:throw new Error("Invalid log level")}}class D extends p.AbstractMessageLogger{constructor(c,R,m,w){super();this.name=c,this.filepath=R,this.rotating=m,this.buffer=[],this.setLevel(w),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(O=>{this._logger&&this._logger.setLevel(O)}))}_createSpdLogLogger(){const c=this.rotating?6:1,R=30/c*T.ByteSize.MB;return P(this.name,this.filepath,R,c).then(m=>{if(m){this._logger=m,this._logger.setLevel(this.getLevel());for(const{level:w,message:O}of this.buffer)F(this._logger,w,O);this.buffer=[]}})}log(c,R){this._logger?F(this._logger,c,R):this.getLevel()<=c&&this.buffer.push({level:c,message:R})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=D}),define(Q[54],Z([0,1,82,16,19,12,40]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function D(m,w,O,u,g,I){let L;try{await f(m,w,O,u,g,I)}catch(C){L=C}finally{L&&g.errorTransformer&&(L=g.errorTransformer(L)),typeof L!="undefined"&&O.error(L),O.end()}}t.readFileIntoStream=D;async function f(m,w,O,u,g,I){c(I);const L=await m.open(w,{create:!1});try{c(I);let C=0,v=0,s=g&&typeof g.length=="number"?g.length:void 0,r=T.VSBuffer.alloc(Math.min(g.bufferSize,typeof s=="number"?s:g.bufferSize)),e=g&&typeof g.position=="number"?g.position:0,i=0;do v=await m.read(L,e,r.buffer,i,r.byteLength-i),e+=v,i+=v,C+=v,typeof s=="number"&&(s-=v),i===r.byteLength&&(await O.write(u(r)),r=T.VSBuffer.alloc(Math.min(g.bufferSize,typeof s=="number"?s:g.bufferSize)),i=0);while(v>0&&(typeof s!="number"||s>0)&&c(I)&&R(C,g));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),O.write(u(r.slice(0,n)))}}catch(C){throw(0,P.ensureFileSystemProviderError)(C)}finally{await m.close(L)}}function c(m){if(m.isCancellationRequested)throw(0,S.canceled)();return!0}function R(m,w){if(w==null?void 0:w.limits){if(typeof w.limits.memory=="number"&&m>w.limits.memory)throw(0,P.createFileSystemProviderError)((0,p.localize)(0,null,F.default.nameShort),P.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&m>w.limits.size)throw(0,P.createFileSystemProviderError)((0,p.localize)(1,null),P.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[107],Z([0,1,81,129,2,19,9,17,45,23,15,16,35,4,28,8,54,130]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let C=class extends P.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new O.ResourceQueue)}registerProvider(s,r){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,T.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,r),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:r});const e=new P.DisposableStore;return e.add(r.onDidChangeFile(i=>this._onDidFilesChange.fire(new S.FileChangesEvent(i,!this.isPathCaseSensitive(r))))),e.add(r.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:r,scheme:s}))),typeof r.onDidErrorOccur=="function"&&e.add(r.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,P.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:r}),this.provider.delete(s),(0,P.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const r=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){r.push(e)}}),!this.provider.has(s)&&await O.Promises.settled(r)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,r){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&r)}listCapabilities(){return L.Iterable.map(this.provider,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async withProvider(s){if(!(0,D.isAbsolutePath)(s))throw new S.FileOperationError((0,p.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const r=this.provider.get(s.scheme);if(!r){const e=new Error;throw e.name="ENOPRO",e.message=(0,p.localize)(1,null,s.toString()),e}return r}async withReadProvider(s){const r=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)||(0,S.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const r=await this.withProvider(s);if((0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.doResolveFile(s,r)}catch(e){throw(0,S.toFileSystemProviderErrorCode)(e)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,p.localize)(2,null,this.resourceForError(s)),1):(0,S.ensureFileSystemProviderError)(e)}}async doResolveFile(s,r){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=r==null?void 0:r.resolveTo,a=r==null?void 0:r.resolveSingleChildDescendants,l=r==null?void 0:r.resolveMetadata,d=await e.stat(s);let E;return this.toFileStat(e,s,d,void 0,!!l,(N,j)=>(E||(E=f.TernarySearchTree.forUris(()=>!i),E.set(s,!0),(0,c.isNonEmptyArray)(n)&&n.forEach(k=>E.set(k,!0))),Boolean(E.findSuperstr(N.resource)||E.get(N.resource))?!0:N.isDirectory&&a?j===1:!1))}async toFileStat(s,r,e,i,n,a){const{providerExtUri:l}=this.getExtUri(s),d={resource:r,name:l.basename(r),isFile:(e.type&S.FileType.File)!=0,isDirectory:(e.type&S.FileType.Directory)!=0,isSymbolicLink:(e.type&S.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,etag:(0,S.etag)({mtime:e.mtime,size:e.size})};if(d.isDirectory&&a(d,i)){try{const E=await s.readdir(r),N=await O.Promises.settled(E.map(async([j,k])=>{try{const U=l.joinPath(r,j),W=n?await s.stat(U):{type:k};return await this.toFileStat(s,U,W,E.length,n,a)}catch(U){return this.logService.trace(U),null}}));d.children=(0,c.coalesce)(N)}catch(E){this.logService.trace(E),d.children=[]}return d}return d}async resolveAll(s){return O.Promises.settled(s.map(async r=>{try{return{stat:await this.doResolveFile(r.resource,r.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const r=await this.withProvider(s);try{return!!await r.stat(s)}catch(e){return!1}}async canCreateFile(s,r){try{await this.doValidateCreateFile(s,r)}catch(e){return e}return!0}async doValidateCreateFile(s,r){if(!(r==null?void 0:r.overwrite)&&await this.exists(s))throw new S.FileOperationError((0,p.localize)(3,null,this.resourceForError(s)),3,r)}async createFile(s,r=m.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,r);return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,i)),i}async writeFile(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let l;if((0,S.hasReadWriteCapability)(i)&&!(r instanceof m.VSBuffer))if((0,w.isReadableStream)(r)){const d=await(0,w.peekStream)(r,3);d.ended?l=m.VSBuffer.concat(d.buffer):l=d}else l=(0,w.peekReadable)(r,d=>m.VSBuffer.concat(d),3);else l=r;!(0,S.hasOpenReadWriteCloseCapability)(i)||(0,S.hasReadWriteCapability)(i)&&l instanceof m.VSBuffer?await this.doWriteUnbuffered(i,s,e,l):await this.doWriteBuffered(i,s,e,l instanceof m.VSBuffer?(0,m.bufferToReadable)(l):l)}catch(a){throw new S.FileOperationError((0,p.localize)(4,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,r,e){if(!!(e==null?void 0:e.unlock)&&!(s.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(r)));let n;try{n=await s.stat(r)}catch(a){return}if((n.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,p.localize)(6,null,this.resourceForError(r)),0,e);if(e&&typeof e.mtime=="number"&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,S.etag)({mtime:e.mtime,size:n.size}))throw new S.FileOperationError((0,p.localize)(7,null),3,e);return n}async readFile(s,r){const e=await this.withReadProvider(s);return(r==null?void 0:r.atomic)?this.doReadFileAtomic(e,s,r):this.doReadFile(e,s,r)}async doReadFileAtomic(s,r,e){return new Promise((i,n)=>{this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(s,r,e);i(a)}catch(a){n(a)}})})}async doReadFile(s,r,e){const i=await this.doReadFileStream(s,r,Object.assign(Object.assign({},e),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,m.streamToBuffer)(i.value)})}async readFileStream(s,r){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,r)}async doReadFileStream(s,r,e){const i=new u.CancellationTokenSource,n=this.validateReadFile(r,e).then(l=>l,l=>{throw i.cancel(),l});let a;try{e&&typeof e.etag=="string"&&e.etag!==S.ETAG_DISABLED&&await n,!((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasFileReadStreamCapability)(s))||(0,S.hasReadWriteCapability)(s)&&(e==null?void 0:e.preferUnbuffered)?a=this.readFileUnbuffered(s,r,e):(0,S.hasFileReadStreamCapability)(s)?a=this.readFileStreamed(s,r,i.token,e):a=this.readFileBuffered(s,r,i.token,e);const l=await n;return Object.assign(Object.assign({},l),{value:a})}catch(l){throw a&&await(0,w.consumeStream)(a),new S.FileOperationError((0,p.localize)(8,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(l).toString()),(0,S.toFileOperationResult)(l),e)}}readFileStreamed(s,r,e,i=Object.create(null)){const n=s.readFileStream(r,i,e);return(0,w.transform)(n,{data:a=>a instanceof m.VSBuffer?a:m.VSBuffer.wrap(a),error:a=>new S.FileOperationError((0,p.localize)(9,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)},a=>m.VSBuffer.concat(a))}readFileBuffered(s,r,e,i=Object.create(null)){const n=(0,m.newWriteableBufferStream)();return(0,I.readFileIntoStream)(s,r,n,a=>a,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:a=>new S.FileOperationError((0,p.localize)(10,null,this.resourceForError(r),(0,S.ensureFileSystemProviderError)(a).toString()),(0,S.toFileOperationResult)(a),i)}),e),n}readFileUnbuffered(s,r,e){const i=(0,w.newWriteableStream)(n=>m.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(r);e&&typeof e.position=="number"&&(n=n.slice(e.position)),e&&typeof e.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(r,n.byteLength,e),i.end(m.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,r){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new S.FileOperationError((0,p.localize)(11,null,this.resourceForError(s)),0,r);if(r&&typeof r.etag=="string"&&r.etag!==S.ETAG_DISABLED&&r.etag===e.etag)throw new S.FileOperationError((0,p.localize)(12,null),2,r);return this.validateReadFileLimits(s,e.size,r),e}validateReadFileLimits(s,r,e){if(e==null?void 0:e.limits){let i;if(typeof e.limits.memory=="number"&&r>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&r>e.limits.size&&(i=7),typeof i=="number")throw new S.FileOperationError((0,p.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,r,e){return this.doCanMoveCopy(s,r,"move",e)}async canCopy(s,r,e){return this.doCanMoveCopy(s,r,"copy",e)}async doCanMoveCopy(s,r,e,i){if(s.toString()!==r.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r);await this.doValidateMoveCopy(n,s,a,r,e,i)}catch(n){return n}return!0}async move(s,r,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"move",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,a==="move"?2:3,l)),l}async copy(s,r,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(r),r),a=await this.doMoveCopy(i,s,n,r,"copy",!!e),l=await this.resolve(r,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,a==="copy"?3:2,l)),l}async doMoveCopy(s,r,e,i,n,a){if(r.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(s,r,e,i,n,a);if(l&&!d&&a&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,S.hasFileFolderCopyCapability)(s))await s.copy(r,i,{overwrite:a});else{const E=await this.resolve(r);E.isDirectory?await this.doCopyFolder(s,E,e,i):await this.doCopyFile(s,r,e,i)}return n}else return s===e?(await s.rename(r,i,{overwrite:a}),n):(await this.doMoveCopy(s,r,e,i,"copy",a),await this.del(r,{recursive:!0}),"copy")}async doCopyFile(s,r,e,i){if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,r,e,i);if((0,S.hasOpenReadWriteCloseCapability)(s)&&(0,S.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,r,e,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,r,e,i);if((0,S.hasReadWriteCapability)(s)&&(0,S.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,r,e,i)}async doCopyFolder(s,r,e,i){await e.mkdir(i),Array.isArray(r.children)&&await O.Promises.settled(r.children.map(async n=>{const a=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,a):this.doCopyFile(s,n.resource,e,a)}))}async doValidateMoveCopy(s,r,e,i,n,a){let l=!1;if(s===e){const{providerExtUri:E,isPathCaseSensitive:N}=this.getExtUri(s);if(N||(l=E.isEqual(r,i)),l&&n==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(r),this.resourceForError(i)));if(!l&&E.isEqualOrParent(i,r))throw new Error((0,p.localize)(15,null,this.resourceForError(r),this.resourceForError(i)))}const d=await this.exists(i);if(d&&!l){if(!a)throw new S.FileOperationError((0,p.localize)(16,null,this.resourceForError(r),this.resourceForError(i)),4);if(s===e){const{providerExtUri:E}=this.getExtUri(s);if(E.isEqualOrParent(r,i))throw new Error((0,p.localize)(17,null,this.resourceForError(r),this.resourceForError(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const r=this.isPathCaseSensitive(s);return{providerExtUri:r?D.extUri:D.extUriIgnorePathCase,isPathCaseSensitive:r}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(r,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(s,0,e)),e}async mkdirp(s,r){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(r,i.dirname(r));)try{if(((await s.stat(r)).type&S.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(r)));break}catch(n){if((0,S.toFileSystemProviderErrorCode)(n)!==S.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(r)),r=i.dirname(r)}for(let n=e.length-1;n>=0;n--){r=i.joinPath(r,e[n]);try{await s.mkdir(r)}catch(a){if((0,S.toFileSystemProviderErrorCode)(a)!==S.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(s,r){try{await this.doValidateDelete(s,r)}catch(e){return e}return!0}async doValidateDelete(s,r){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!(r==null?void 0:r.useTrash)&&!(e.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(s)));const n=await this.exists(s);if(!n)throw new S.FileOperationError((0,p.localize)(20,null,this.resourceForError(s)),1);if(!!!(r==null?void 0:r.recursive)&&n){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(s)))}return e}async del(s,r){const e=await this.doValidateDelete(s,r),i=!!(r==null?void 0:r.useTrash),n=!!(r==null?void 0:r.recursive);await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new S.FileOperationEvent(s,1))}watch(s,r={recursive:!1,excludes:[]}){let e=!1,i=()=>{e=!0};return this.doWatch(s,r).then(n=>{e?(0,P.dispose)(n):i=()=>(0,P.dispose)(n)},n=>this.logService.error(n)),(0,P.toDisposable)(()=>i())}async doWatch(s,r){const e=await this.withProvider(s),i=this.toWatchKey(e,s,r),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,r)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,P.toDisposable)(()=>{n.count--,n.count===0&&((0,P.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,r,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(r),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>(0,P.dispose)(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(async()=>{var n;const a=await s.open(r,{create:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1});try{(0,w.isReadableStream)(i)||(0,w.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,a,i):await this.doWriteReadableBufferedQueued(s,a,i)}catch(l){throw(0,S.ensureFileSystemProviderError)(l)}finally{await s.close(a)}})}async doWriteStreamBufferedQueued(s,r,e){let i=0,n;if((0,w.isReadableBufferedStream)(e)){if(e.buffer.length>0){const a=m.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,r,a,a.byteLength,i,0),i+=a.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(a,l)=>{(0,w.listenStream)(n,{onData:async d=>{n.pause();try{await this.doWriteBuffer(s,r,d,d.byteLength,i,0)}catch(E){return l(E)}i+=d.byteLength,setTimeout(()=>n.resume())},onError:d=>l(d),onEnd:()=>a()})})}async doWriteReadableBufferedQueued(s,r,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,r,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,r,e,i,n,a){let l=0;for(;l<i;)l+=await s.write(r,n+l,e.buffer,a+l,i-l)}async doWriteUnbuffered(s,r,e,i){return this.writeQueue.queueFor(r,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,r,e,i))}async doWriteUnbufferedQueued(s,r,e,i){var n;let a;i instanceof m.VSBuffer?a=i:(0,w.isReadableStream)(i)?a=await(0,m.streamToBuffer)(i):(0,w.isReadableBufferedStream)(i)?a=await(0,m.bufferedStreamToBuffer)(i):a=(0,m.readableToBuffer)(i),await s.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:(n=e==null?void 0:e.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,r,e,i))}async doPipeBufferedQueued(s,r,e,i){let n,a;try{n=await s.open(r,{create:!1}),a=await e.open(i,{create:!0,unlock:!1});const l=m.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,E=0,N=0;do N=await s.read(n,d,l.buffer,E,l.byteLength-E),await this.doWriteBuffer(e,a,l,N,d,E),d+=N,E+=N,E===l.byteLength&&(E=0);while(N>0)}catch(l){throw(0,S.ensureFileSystemProviderError)(l)}finally{await O.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof a=="number"?e.close(a):Promise.resolve()])}}async doPipeUnbuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,r,e,i))}async doPipeUnbufferedQueued(s,r,e,i){return e.writeFile(i,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,r,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,r,e,i))}async doPipeUnbufferedToBufferedQueued(s,r,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const a=await s.readFile(r);await this.doWriteBuffer(e,n,m.VSBuffer.wrap(a),a.byteLength,0,0)}catch(a){throw(0,S.ensureFileSystemProviderError)(a)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,r,e,i){const n=await(0,m.streamToBuffer)(this.readFileBuffered(s,r,u.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,r){if(s.capabilities&2048)throw new S.FileOperationError((0,p.localize)(22,null,this.resourceForError(r)),6);return s}resourceForError(s){return s.scheme===g.Schemas.file?s.fsPath:s.toString(!0)}};C=ue([fe(0,R.ILogService)],C),t.FileService=C}),define(Q[108],Z([0,1,18,64,2,19,9,13,14,3,17,36,4,15,83,51,92,94,91,100,35,54,23,16]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L,C,v,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class n extends P.Disposable{constructor(l,d){var E;super();this.logService=l,this.options=d,this.BUFFER_SIZE=((E=this.options)===null||E===void 0?void 0:E.bufferSize)||64*1024,this.onDidChangeCapabilities=F.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new F.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new F.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new w.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(l){try{const{stat:d,symbolicLink:E}=await f.SymlinkSupport.stat(this.toFilePath(l));return{type:this.toType(d,E),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size}}catch(d){throw this.toFileSystemProviderError(d)}}async readdir(l){try{const d=await(0,f.readdir)(this.toFilePath(l),{withFileTypes:!0}),E=[];return await Promise.all(d.map(async N=>{try{let j;N.isSymbolicLink()?j=(await this.stat((0,R.joinPath)(l,N.name))).type:j=this.toType(N),E.push([N.name,j])}catch(j){this.logService.trace(j)}})),E}catch(d){throw this.toFileSystemProviderError(d)}}toType(l,d){let E;return(d==null?void 0:d.dangling)?E=S.FileType.Unknown:l.isFile()?E=S.FileType.File:l.isDirectory()?E=S.FileType.Directory:E=S.FileType.Unknown,d&&(E|=S.FileType.SymbolicLink),E}async readFile(l){try{const d=this.toFilePath(l);return await p.promises.readFile(d)}catch(d){throw this.toFileSystemProviderError(d)}}readFileStream(l,d,E){const N=(0,s.newWriteableStream)(j=>i.VSBuffer.concat(j.map(k=>i.VSBuffer.wrap(k))).buffer);return(0,r.readFileIntoStream)(this,l,N,j=>j.buffer,Object.assign(Object.assign({},d),{bufferSize:this.BUFFER_SIZE}),E),N}async writeFile(l,d,E){let N;try{const j=this.toFilePath(l);if(!E.create||!E.overwrite){if(await(0,f.exists)(j)){if(!E.overwrite)throw(0,S.createFileSystemProviderError)((0,u.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!E.create)throw(0,S.createFileSystemProviderError)((0,u.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}N=await this.open(l,{create:!0,unlock:E.unlock}),await this.write(N,0,d,0,d.byteLength)}catch(j){throw await this.toFileSystemProviderWriteError(l,j)}finally{typeof N=="number"&&await this.close(N)}}async open(l,d){try{const E=this.toFilePath(l);if((0,S.isFileOpenForWriteOptions)(d)&&d.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(E);k.mode&128||await p.promises.chmod(E,k.mode|128)}catch(k){this.logService.trace(k)}let N;if((0,S.isFileOpenForWriteOptions)(d)){if(D.isWindows)try{await p.promises.truncate(E,0),N="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}N||(N="w")}else N="r";const j=await(0,T.promisify)(p.open)(E,N);return this.mapHandleToPos.set(j,0),(0,S.isFileOpenForWriteOptions)(d)&&this.writeHandles.set(j,l),j}catch(E){throw(0,S.isFileOpenForWriteOptions)(d)?await this.toFileSystemProviderWriteError(l,E):this.toFileSystemProviderError(E)}}async close(l){try{if(this.mapHandleToPos.delete(l),this.writeHandles.delete(l)&&this.canFlush)try{await(0,T.promisify)(p.fdatasync)(l)}catch(d){this.canFlush=!1,this.logService.error(d)}return await(0,T.promisify)(p.close)(l)}catch(d){throw this.toFileSystemProviderError(d)}}async read(l,d,E,N,j){const k=this.normalizePos(l,d);let U=null;try{const W=await(0,T.promisify)(p.read)(l,E,N,j,k);return typeof W=="number"?U=W:U=W.bytesRead,U}catch(W){throw this.toFileSystemProviderError(W)}finally{this.updatePos(l,k,U)}}normalizePos(l,d){return d===this.mapHandleToPos.get(l)?null:d}updatePos(l,d,E){const N=this.mapHandleToPos.get(l);typeof N=="number"&&(typeof d=="number"||(typeof E=="number"?this.mapHandleToPos.set(l,N+E):this.mapHandleToPos.delete(l)))}async write(l,d,E,N,j){return(0,w.retry)(()=>this.doWrite(l,d,E,N,j),100,3)}async doWrite(l,d,E,N,j){const k=this.normalizePos(l,d);let U=null;try{const W=await(0,T.promisify)(p.write)(l,E,N,j,k);return typeof W=="number"?U=W:U=W.bytesWritten,U}catch(W){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(l),W)}finally{this.updatePos(l,k,U)}}async mkdir(l){try{await p.promises.mkdir(this.toFilePath(l))}catch(d){throw this.toFileSystemProviderError(d)}}async delete(l,d){try{const E=this.toFilePath(l);await this.doDelete(E,d)}catch(E){throw this.toFileSystemProviderError(E)}}async doDelete(l,d){d.recursive?await(0,f.rimraf)(l,f.RimRafMode.MOVE):await p.promises.unlink(l)}async rename(l,d,E){const N=this.toFilePath(l),j=this.toFilePath(d);if(N!==j)try{await this.validateTargetDeleted(l,d,"move",E.overwrite),await(0,f.move)(N,j)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,u.localize)(2,null,(0,c.basename)(N),(0,c.basename)((0,c.dirname)(j)),k.toString()))),this.toFileSystemProviderError(k)}}async copy(l,d,E){const N=this.toFilePath(l),j=this.toFilePath(d);if(N!==j)try{await this.validateTargetDeleted(l,d,"copy",E.overwrite),await(0,f.copy)(N,j,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,u.localize)(3,null,(0,c.basename)(N),(0,c.basename)((0,c.dirname)(j)),k.toString()))),this.toFileSystemProviderError(k)}}async validateTargetDeleted(l,d,E,N){const j=this.toFilePath(l),k=this.toFilePath(d);let U=!1;if(!!(this.capabilities&1024)||(U=(0,m.isEqual)(j,k,!0)),U&&E==="copy")throw(0,S.createFileSystemProviderError)((0,u.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!U&&await(0,f.exists)(k)){if(!N)throw(0,S.createFileSystemProviderError)((0,u.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(d,{recursive:!0,useTrash:!1})}}watch(l,d){return d.recursive?this.watchRecursive(l,d.excludes):this.watchNonRecursive(l)}watchRecursive(l,d){const E={path:this.toFilePath(l),excludes:d},N=(0,e.insert)(this.recursiveFoldersToWatch,E);return this.refreshRecursiveWatchers(),(0,P.toDisposable)(()=>{N(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var l,d,E;if(this.recursiveWatcher instanceof C.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let N,j;((d=(l=this.options)===null||l===void 0?void 0:l.watcher)===null||d===void 0?void 0:d.usePolling)?(N=I.FileWatcher,j=(E=this.options)===null||E===void 0?void 0:E.watcher):this.recursiveFoldersToWatch.length===1?D.isWindows?N=L.FileWatcher:N=I.FileWatcher:N=C.FileWatcher,this.recursiveWatcher=new N(this.recursiveFoldersToWatch,k=>this._onDidChangeFile.fire((0,g.toFileChanges)(k)),k=>{k.type==="error"&&this._onDidWatchErrorOccur.fire(k.message),this.logService[k.type](k.message)},this.logService.getLevel()===O.LogLevel.Trace,j),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===O.LogLevel.Trace)}))}}watchNonRecursive(l){const d=new v.FileWatcher(this.toFilePath(l),N=>this._onDidChangeFile.fire((0,g.toFileChanges)(N)),N=>{N.type==="error"&&this._onDidWatchErrorOccur.fire(N.message),this.logService[N.type](N.message)},this.logService.getLevel()===O.LogLevel.Trace),E=this.logService.onDidChangeLogLevel(()=>{d.setVerboseLogging(this.logService.getLevel()===O.LogLevel.Trace)});return(0,P.combinedDisposable)(d,E)}toFilePath(l){return(0,c.normalize)(l.fsPath)}toFileSystemProviderError(l){if(l instanceof S.FileSystemProviderError)return l;let d;switch(l.code){case"ENOENT":d=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":d=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":d=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":d=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":d=S.FileSystemProviderErrorCode.NoPermissions;break;default:d=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(l,d)}async toFileSystemProviderWriteError(l,d){let E=this.toFileSystemProviderError(d);if(l&&E.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:N}=await f.SymlinkSupport.stat(this.toFilePath(l));N.mode&128||(E=(0,S.createFileSystemProviderError)(d,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(N){this.logService.trace(N)}return E}dispose(){super.dispose(),(0,P.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,P.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=n}),define(Q[41],Z([0,1,10]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,p.createDecorator)("productService")}),define(Q[26],Z([0,1,11,57]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(F,D){T.ok(p.isString(F)),T.ok(p.isObject(D)),T.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,D)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new P}),define(Q[109],Z([0,1,26,9]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class S{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(f,c){this.schemasById[P(f)]=c,this._onDidChangeSchema.fire(f)}notifySchemaChanged(f){this._onDidChangeSchema.fire(f)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new S;p.Registry.add(t.Extensions.JSONContribution,F)}),define(Q[31],Z([0,1,74,9,26,11,109]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"};var D;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const f=P.Registry.as(F.Extensions.JSONContribution);class c{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(L,C=!0){this.registerConfigurations([L],C)}registerConfigurations(L,C=!0){const v=[];L.forEach(s=>{v.push(...this.validateAndRegisterProperties(s,C,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(v)}deregisterConfigurations(L){const C=[],v=s=>{if(s.properties)for(const r in s.properties)C.push(r),delete this.configurationProperties[r],this.removeFromSchema(r,s.properties[r]);s.allOf&&s.allOf.forEach(r=>v(r))};for(const s of L){v(s);const r=this.configurationContributors.indexOf(s);r!==-1&&this.configurationContributors.splice(r,1)}f.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}registerDefaultConfigurations(L){const C=[],v=[];for(const s of L)for(const r in s)if(C.push(r),t.OVERRIDE_PROPERTY_PATTERN.test(r)){this.defaultValues[r]=Object.assign(Object.assign({},this.defaultValues[r]||{}),s[r]);const e={type:"object",default:this.defaultValues[r],description:p.localize(1,null,r),$ref:t.resourceLanguageSettingsSchemaId};v.push(m(r)),this.configurationProperties[r]=e,this.defaultLanguageConfigurationOverridesNode.properties[r]=e}else{this.defaultValues[r]=s[r];const e=this.configurationProperties[r];e&&(this.updatePropertyDefaultValue(r,e),this.updateSchema(r,e))}this.registerOverrideIdentifiers(v),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterDefaultConfigurations(L){const C=[];for(const v of L)for(const s in v)if(C.push(s),delete this.defaultValues[s],t.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const r=this.configurationProperties[s];r&&(this.updatePropertyDefaultValue(s,r),this.updateSchema(s,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}notifyConfigurationSchemaUpdated(...L){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(L){for(const C of L)this.overrideIdentifiers.add(C);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(L,C=!0,v,s=3){var r;s=S.isUndefinedOrNull(L.scope)?s:L.scope;let e=[],i=L.properties;if(i)for(let a in i){if(C&&u(a)){delete i[a];continue}const l=i[a];if(this.updatePropertyDefaultValue(a,l),t.OVERRIDE_PROPERTY_PATTERN.test(a)?l.scope=void 0:(l.scope=S.isUndefinedOrNull(l.scope)?s:l.scope,l.restricted=S.isUndefinedOrNull(l.restricted)?!!((r=v==null?void 0:v.restrictedConfigurations)===null||r===void 0?void 0:r.includes(a)):l.restricted),i[a].hasOwnProperty("included")&&!i[a].included){this.excludedConfigurationProperties[a]=i[a],delete i[a];continue}else this.configurationProperties[a]=i[a];!i[a].deprecationMessage&&i[a].markdownDeprecationMessage&&(i[a].deprecationMessage=i[a].markdownDeprecationMessage),e.push(a)}let n=L.allOf;if(n)for(let a of n)e.push(...this.validateAndRegisterProperties(a,C,v,s));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(L){const C=v=>{let s=v.properties;if(s)for(const e in s)this.updateSchema(e,s[e]);let r=v.allOf;r&&r.forEach(C)};C(L)}updateSchema(L,C){switch(t.allSettings.properties[L]=C,C.scope){case 1:t.applicationSettings.properties[L]=C;break;case 2:t.machineSettings.properties[L]=C;break;case 6:t.machineOverridableSettings.properties[L]=C;break;case 3:t.windowSettings.properties[L]=C;break;case 4:t.resourceSettings.properties[L]=C;break;case 5:t.resourceSettings.properties[L]=C,this.resourceLanguageSettingsSchema.properties[L]=C;break}}removeFromSchema(L,C){switch(delete t.allSettings.properties[L],C.scope){case 1:delete t.applicationSettings.properties[L];break;case 2:delete t.machineSettings.properties[L];break;case 6:delete t.machineOverridableSettings.properties[L];break;case 3:delete t.windowSettings.properties[L];break;case 4:case 5:delete t.resourceSettings.properties[L];break}}updateOverridePropertyPatternKey(){for(const L of this.overrideIdentifiers.values()){const C=`[${L}]`,v={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(C,v),t.allSettings.properties[C]=v,t.applicationSettings.properties[C]=v,t.machineSettings.properties[C]=v,t.machineOverridableSettings.properties[C]=v,t.windowSettings.properties[C]=v,t.resourceSettings.properties[C]=v}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(L,C){let v=this.defaultValues[L];S.isUndefined(v)&&(v=C.default),S.isUndefined(v)&&(v=w(C.type)),C.default=v}}const R="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(R);function m(I){return I.substring(1,I.length-1)}t.overrideIdentifierFromKey=m;function w(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=w;const O=new c;P.Registry.add(t.Extensions.Configuration,O);function u(I){return I.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(I)?p.localize(5,null,I):O.getConfigurationProperties()[I]!==void 0?p.localize(6,null,I):null:p.localize(4,null)}t.validateProperty=u;function g(){const I=[],L=O.getConfigurationProperties();for(const C of Object.keys(L))I.push([C,L[C].scope]);return I.push(["launch",4]),I.push(["task",4]),I}t.getScopes=g}),define(Q[27],Z([0,1,21,11,7,26,10,31]),function(x,t,p,T,P,S,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function f(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof P.URI)}t.isConfigurationOverrides=f;var c;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(c=t.ConfigurationTarget||(t.ConfigurationTarget={}));function R(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=R;function m(i,n){const a=n?i?n.keys.filter(U=>i.keys.indexOf(U)===-1):[...n.keys]:[],l=i?n?i.keys.filter(U=>n.keys.indexOf(U)===-1):[...i.keys]:[],d=[];if(n&&i){for(const U of i.keys)if(n.keys.indexOf(U)!==-1){const W=L(i.contents,U),K=L(n.contents,U);p.equals(W,K)||d.push(U)}}const E=[],N=U=>{const W={};for(const K of U)for(const ne of K.identifiers)W[r(ne)]=K;return W},j=n?N(n.overrides):{},k=i?N(i.overrides):{};if(Object.keys(j).length)for(const U of a){const W=j[U];W&&E.push([(0,D.overrideIdentifierFromKey)(U),W.keys])}if(Object.keys(k).length)for(const U of l){const W=k[U];W&&E.push([(0,D.overrideIdentifierFromKey)(U),W.keys])}if(Object.keys(j).length&&Object.keys(k).length)for(const U of d){const W=k[U],K=j[U];if(W&&K){const ne=m({contents:W.contents,keys:W.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});E.push([(0,D.overrideIdentifierFromKey)(U),[...ne.added,...ne.removed,...ne.updated]])}}return{added:a,removed:l,updated:d,overrides:E}}t.compare=m;function w(i,n){const a=[];for(const l of Object.keys(i))if(D.OVERRIDE_PROPERTY_PATTERN.test(l)){const d={};for(const E in i[l])d[E]=i[l][E];a.push({identifiers:[(0,D.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(d),contents:O(d,n)})}return a}t.toOverrides=w;function O(i,n){const a=Object.create(null);for(let l in i)u(a,l,i[l],n);return a}t.toValuesTree=O;function u(i,n,a,l){const d=n.split("."),E=d.pop();let N=i;for(let j=0;j<d.length;j++){let k=d[j],U=N[k];switch(typeof U){case"undefined":U=N[k]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${d.slice(0,j+1).join(".")} is ${JSON.stringify(U)}`);return}N=U}if(typeof N=="object"&&N!==null)try{N[E]=a}catch(j){l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(N)}`)}else l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(N)}`)}t.addToValueTree=u;function g(i,n){const a=n.split(".");I(i,a)}t.removeFromValueTree=g;function I(i,n){const a=n.shift();if(n.length===0){delete i[a];return}if(Object.keys(i).indexOf(a)!==-1){const l=i[a];typeof l=="object"&&!Array.isArray(l)&&(I(l,n),Object.keys(l).length===0&&delete i[a])}}function L(i,n,a){function l(N,j){let k=N;for(const U of j){if(typeof k!="object"||k===null)return;k=k[U]}return k}const d=n.split("."),E=l(i,d);return typeof E=="undefined"?a:E}t.getConfigurationValue=L;function C(i,n,a){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?T.isObject(i[l])&&T.isObject(n[l])?C(i[l],n[l],a):a&&(i[l]=n[l]):i[l]=n[l])})}t.merge=C;function v(){const i=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=v;function s(){const i=Object.create(null),n=S.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let a in n){let l=n[a].default;u(i,a,l,d=>console.error(`Conflict in default settings: ${d}`))}return i}t.getDefaultValues=s;function r(i){return`[${i}]`}t.keyFromOverrideIdentifier=r;function e(i,n,a){const l=i.inspect(n),d=i.inspect(a);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Q[110],Z([0,1,58,45,23,11,21,7,31,27,26,2,9]),function(x,t,p,T,P,S,F,D,f,c,R,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class O{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,c.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,c.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const a of P.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[a],d=i[a];d&&(typeof l=="object"&&typeof d=="object"?(l=F.deepClone(l),this.mergeContents(l,d)):l=d),n[a]=l}return new O(n,this.keys,this.overrides)}merge(...e){const i=F.deepClone(this.contents),n=F.deepClone(this.overrides),a=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const d of l.overrides){const[E]=n.filter(N=>P.equals(N.identifiers,d.identifiers));E?this.mergeContents(E.contents,d.contents):n.push(F.deepClone(d))}for(const d of l.keys)a.indexOf(d)===-1&&a.push(d)}return new O(i,a,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&S.isObject(e[n])&&S.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=F.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?F.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,c.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,c.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=O;class u extends O{constructor(){const e=(0,c.getDefaultValues)(),i=(0,c.getConfigurationKeys)(),n=[];for(const a of Object.keys(e))f.OVERRIDE_PROPERTY_PATTERN.test(a)&&n.push({identifiers:[(0,f.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(e[a]),contents:(0,c.toValuesTree)(e[a],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=u;class g{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new O}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!S.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:a,overrides:l,restricted:d}=this.doParseRaw(e,i);this._configurationModel=new O(n,a,l),this._restrictedConfigurations=d||[]}doParseContent(e){let i={},n=null,a=[],l=[],d=[];function E(j){Array.isArray(a)?a.push(j):n&&(a[n]=j)}let N={onObjectBegin:()=>{let j={};E(j),l.push(a),a=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{a=l.pop()},onArrayBegin:()=>{let j=[];E(j),l.push(a),a=j,n=null},onArrayEnd:()=>{a=l.pop()},onLiteralValue:E,onError:(j,k,U)=>{d.push({error:j,offset:k,length:U})}};if(e)try{p.visit(e,N),i=a[0]||{}}catch(j){console.error(`Error while parsing settings file ${this._name}: ${j}`),this._parseErrors=[j]}return i}doParseRaw(e,i){const n=R.Registry.as(f.Extensions.Configuration).getConfigurationProperties(),a=this.filter(e,n,!0,i);e=a.raw;const l=(0,c.toValuesTree)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`)),d=Object.keys(e),E=(0,c.toOverrides)(e,N=>console.error(`Conflict in settings file ${this._name}: ${N}`));return{contents:l,keys:d,overrides:E,restricted:a.restricted}}filter(e,i,n,a){if(!(a==null?void 0:a.scopes)&&!(a==null?void 0:a.skipRestricted))return{raw:e,restricted:[]};const l={},d=[];for(let E in e)if(f.OVERRIDE_PROPERTY_PATTERN.test(E)&&n){const N=this.filter(e[E],i,!1,a);l[E]=N.raw,d.push(...N.restricted)}else{const N=i[E],j=N?typeof N.scope!="undefined"?N.scope:3:void 0;(N==null?void 0:N.restricted)&&d.push(E),(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&(a.skipRestricted&&(N==null?void 0:N.restricted)||(l[E]=e[E]))}return{raw:l,restricted:d}}}t.ConfigurationModelParser=g;class I extends m.Disposable{constructor(e,i,n,a){super();this.userSettingsResource=e,this.scopes=i,this.fileService=a,this._onDidChange=this._register(new w.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(w.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new O}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=I;class L{constructor(e,i,n=new O,a=new O,l=new T.ResourceMap,d=new O,E=new T.ResourceMap,N=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=E,this._freeze=N,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let a;n.resource?(a=this._memoryConfigurationByResource.get(n.resource),a||(a=new O,this._memoryConfigurationByResource.set(n.resource,a))):a=this._memoryConfiguration,i===void 0?a.removeValue(e):a.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const a=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,E=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),N=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),j=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),U=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,W=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,K=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(e):d.getValue(e),ne=a.getValue(e),ee=P.distinct(P.flatten(a.overrides.map(ie=>ie.identifiers))).filter(ie=>a.getOverrideValue(e,ie)!==void 0);return{defaultValue:E,userValue:N,userLocalValue:j,userRemoteValue:k,workspaceValue:U,workspaceFolderValue:W,memoryValue:K,value:ne,default:E!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:N!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:j!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:W!==void 0?{value:l==null?void 0:l.freeze().getValue(e),override:i.overrideIdentifier?l==null?void 0:l.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:d.getValue(e),override:i.overrideIdentifier?d.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ee.length?ee:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(a=>f.OVERRIDE_PROPERTY_PATTERN.test(a)).map(a=>{const l=(0,f.overrideIdentifierFromKey)(a),d=this._defaultConfiguration.getKeysForOverrideIdentifier(l),E=e.getKeysForOverrideIdentifier(l),N=[...E.filter(j=>d.indexOf(j)===-1),...d.filter(j=>E.indexOf(j)===-1),...d.filter(j=>!F.equals(this._defaultConfiguration.override(l).getValue(j),e.override(l).getValue(j)))];return[l,N]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.localUserConfiguration,e),d=[...i,...n,...a];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.remoteUserConfiguration,e);let d=[...i,...n,...a];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:a,overrides:l}=(0,c.compare)(this.workspaceConfiguration,e);let d=[...i,...n,...a];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:a,updated:l,removed:d,overrides:E}=(0,c.compare)(n,i);let N=[...a,...l,...d];return(N.length||!n)&&this.updateFolderConfiguration(e,i),{keys:N,overrides:E}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:a,removed:l,overrides:d}=(0,c.compare)(i,void 0);return{keys:[...n,...a,...l],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const a=i.getFolder(e);a&&(n=this.getFolderConsolidatedConfiguration(a.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),a=this._folderConfigurations.get(e);a?(i=n.merge(a),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:a,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:a,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(a=>i.add(a))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),a=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((d,E)=>(d.set(D.URI.revive(E[0]),this.parseConfigurationModel(E[1])),d),new T.ResourceMap);return new L(i,n,new O,a,l,new O,new T.ResourceMap,!1)}static parseConfigurationModel(e){return new O(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=L;function C(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const e=new Set,i=new Map;for(const a of r)a.keys.forEach(l=>e.add(l)),a.overrides.forEach(([l,d])=>{const E=(0,T.getOrSet)(i,l,new Set);d.forEach(N=>E.add(N))});const n=[];return i.forEach((a,l)=>n.push([l,[...a.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=C;class v{constructor(e,i,n,a){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=a,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(E=>l.add(E)),e.overrides.forEach(([,E])=>E.forEach(N=>l.add(N))),this.affectedKeys=[...l.values()];const d=new O;this.affectedKeys.forEach(E=>d.setValue(E,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=L.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const a=this.previousConfiguration?this.previousConfiguration.getValue(e,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,l=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!F.equals(a,l)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,c.toValuesTree)({[i]:!0},()=>{}),a;for(;typeof n=="object"&&(a=Object.keys(n)[0]);){if(e=e[a],!e)return!1;n=n[a]}return!0}}t.ConfigurationChangeEvent=v;class s extends v{constructor(e,i,n,a){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=a}}t.AllKeysConfigurationChangeEvent=s}),define(Q[111],Z([0,1,26,31,2,27,110,9,4,17]),function(x,t,p,T,P,S,F,D,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class R extends P.Disposable{constructor(w,O){super();this.settingsResource=w,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new F.UserSettings(this.settingsResource,void 0,c.extUriBiasedIgnorePathCase,O)),this.configuration=new F.Configuration(new F.DefaultConfigurationModel,new F.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new f.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(T.Extensions.Configuration).onDidUpdateConfiguration(u=>this.onDidDefaultConfigurationChange(u))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const w=await this.userConfiguration.loadConfiguration();this.configuration=new F.Configuration(new F.DefaultConfigurationModel,w)}getConfigurationData(){return this.configuration.toData()}getValue(w,O){const u=typeof w=="string"?w:void 0,g=(0,S.isConfigurationOverrides)(w)?w:(0,S.isConfigurationOverrides)(O)?O:{};return this.configuration.getValue(u,g,void 0)}updateValue(w,O,u,g){return Promise.reject(new Error("not supported"))}inspect(w){return this.configuration.inspect(w,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const w=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(w)}onDidChangeUserConfiguration(w){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(w);this.trigger(u,O,1)}onDidDefaultConfigurationChange(w){const O=this.configuration.toData(),u=this.configuration.compareAndUpdateDefaultConfiguration(new F.DefaultConfigurationModel,w);this.trigger(u,O,6)}trigger(w,O,u){const g=new F.ConfigurationChangeEvent(w,{data:O},this.configuration);g.source=u,g.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(w){switch(w){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=R}),define(Q[55],Z([0,1,84,10,31,26,16]),function(x,t,p,T,P,S,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,T.createDecorator)("requestService");function D(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}t.isSuccess=D;function f(u){return u.res.statusCode===204}async function c(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);return f(u)?null:(await(0,F.streamToBuffer)(u.stream)).toString()}t.asText=c;async function R(u){if(!D(u))throw new Error("Server returned "+u.res.statusCode);if(f(u))return null;const I=(await(0,F.streamToBuffer)(u.stream)).toString();try{return JSON.parse(I)}catch(L){throw L.message+=`:
`+I,L}}t.asJson=R;function m(u){O(u)}t.updateProxyConfigurationsScope=m;let w;function O(u){const g=S.Registry.as(P.Extensions.Configuration);w&&g.deregisterConfigurations([w]),w={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},g.registerConfiguration(w)}O(2)}),define(Q[112],Z([0,1,113,11]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function P(F,D){return F.protocol==="http:"?D.HTTP_PROXY||D.http_proxy||null:F.protocol==="https:"&&(D.HTTPS_PROXY||D.https_proxy||D.HTTP_PROXY||D.http_proxy)||null}async function S(F,D,f={}){const c=(0,p.parse)(F),R=f.proxyUrl||P(c,D);if(!R)return null;const m=(0,p.parse)(R);if(!/^https?:$/.test(m.protocol||""))return null;const w={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,T.isBoolean)(f.strictSSL)?f.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((O,u)=>{x(["http-proxy-agent"],O,u)}))(w):new(await new Promise((O,u)=>{x(["https-proxy-agent"],O,u)}))(w)}t.getProxyAgent=S}),define(Q[114],Z([0,1,30,16]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function P(S,F,D){let f=D&&D.get("storage.serviceMachineId",0)||null;if(f)return f;try{const R=(await F.readFile(S.serviceMachineIdResource)).value.toString();f=(0,p.isUUID)(R)?R:null}catch(c){f=null}if(!f){f=(0,p.generateUuid)();try{await F.writeFile(S.serviceMachineIdResource,T.VSBuffer.fromString(f))}catch(c){}}return D&&D.store("storage.serviceMachineId",f,0,1),f}t.getServiceMachineId=P}),define(Q[115],Z([0,1,10,9,2,11,67,4]),function(x,t,p,T,P,S,F,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";t.IStorageService=(0,p.createDecorator)("storageService");var c;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(c=t.WillSaveStateReason||(t.WillSaveStateReason={}));var R;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(R=t.StorageScope||(t.StorageScope={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m=t.StorageTarget||(t.StorageTarget={}));class w extends P.Disposable{constructor(I={flushInterval:w.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new T.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new T.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new T.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new P.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,P.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,L){L===f?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:L,target:this.getKeyTargets(I)[L]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,L,C){var v;return(v=this.getStorage(L))===null||v===void 0?void 0:v.get(I,C)}getBoolean(I,L,C){var v;return(v=this.getStorage(L))===null||v===void 0?void 0:v.getBoolean(I,C)}getNumber(I,L,C){var v;return(v=this.getStorage(L))===null||v===void 0?void 0:v.getNumber(I,C)}store(I,L,C,v){if((0,S.isUndefinedOrNull)(L)){this.remove(I,C);return}this.withPausedEmitters(()=>{var s;this.updateKeyTarget(I,C,v),(s=this.getStorage(C))===null||s===void 0||s.set(I,L)})}remove(I,L){this.withPausedEmitters(()=>{var C;this.updateKeyTarget(I,L,void 0),(C=this.getStorage(L))===null||C===void 0||C.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,L){const C=[],v=this.getKeyTargets(I);for(const s of Object.keys(v))v[s]===L&&C.push(s);return C}updateKeyTarget(I,L,C){var v,s;const r=this.getKeyTargets(L);typeof C=="number"?r[I]!==C&&(r[I]=C,(v=this.getStorage(L))===null||v===void 0||v.set(f,JSON.stringify(r))):typeof r[I]=="number"&&(delete r[I],(s=this.getStorage(L))===null||s===void 0||s.set(f,JSON.stringify(r)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const L=this.get(f,I);if(L)try{return JSON.parse(L)}catch(C){}return Object.create(null)}isNew(I){return this.getBoolean(t.IS_NEW_KEY,I)===!0}async flush(){var I,L,C,v;this._onWillSaveState.fire({reason:c.NONE}),await D.Promises.settled([(L=(I=this.getStorage(0))===null||I===void 0?void 0:I.whenFlushed())!==null&&L!==void 0?L:Promise.resolve(),(v=(C=this.getStorage(1))===null||C===void 0?void 0:C.whenFlushed())!==null&&v!==void 0?v:Promise.resolve()])}async logStorage(){var I,L,C,v,s,r;const e=(L=(I=this.getStorage(0))===null||I===void 0?void 0:I.items)!==null&&L!==void 0?L:new Map,i=(v=(C=this.getStorage(1))===null||C===void 0?void 0:C.items)!==null&&v!==void 0?v:new Map;return u(e,i,(s=this.getLogDetails(0))!==null&&s!==void 0?s:"",(r=this.getLogDetails(1))!==null&&r!==void 0?r:"")}}t.AbstractStorageService=w,w.DEFAULT_FLUSH_INTERVAL=60*1e3;class O extends w{constructor(){super();this.globalStorage=new F.Storage(new F.InMemoryStorageDatabase),this.workspaceStorage=new F.Storage(new F.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}t.InMemoryStorageService=O;async function u(g,I,L,C){const v=l=>{try{return JSON.parse(l)}catch(d){return l}},s=new Map,r=new Map;g.forEach((l,d)=>{s.set(d,l),r.set(d,v(l))});const e=new Map,i=new Map;I.forEach((l,d)=>{e.set(d,l),i.set(d,v(l))}),console.group(`Storage: Global (path: ${L})`);let n=[];s.forEach((l,d)=>{n.push({key:d,value:l})}),console.table(n),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${C})`);let a=[];e.forEach((l,d)=>{a.push({key:d,value:l})}),console.table(a),console.groupEnd(),console.log(i)}t.logStorage=u}),define(Q[116],Z([0,1,13,34,30,7]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0;function F(c){if(p.platform===2&&/^penguin(\.|$)/i.test(c))return"chromebook"}async function D(c,R,m,w,O,u,g,I,L,C){const v=Object.create(null);v["common.machineId"]=g,v.sessionID=(0,P.generateUuid)()+Date.now(),v.commitHash=O,v.version=u,v["common.platformVersion"]=(R||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),v["common.platform"]=(0,p.PlatformToString)(p.platform),v["common.nodePlatform"]=T.platform,v["common.nodeArch"]=w,v["common.product"]=C||"desktop";const s=f(I||[]);s&&(v["common.msftInternal"]=s);let r=0;const e=Date.now();Object.defineProperties(v,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>r++,enumerable:!0}}),p.isLinuxSnap&&(v["common.snap"]="true");const i=F(m);i&&(v["common.platformDetail"]=i);try{const n=await c.readFile(S.URI.file(L));v["common.source"]=n.value.toString().slice(0,30)}catch(n){}return v}t.resolveCommonProperties=D;function f(c){const R=T.env.USERDNSDOMAIN;if(!R)return!1;const m=R.toLowerCase();return c.some(w=>m===w)}}),define(Q[42],Z([0,1,10]),function(x,t,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,p.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Q[117],Z([0,1,12,24,25,21,42,55,49,22,28,15,19,7,41,115,114,10,17]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var v;(function(h){h[h.None=0]="None",h[h.IncludeVersions=1]="IncludeVersions",h[h.IncludeFiles=2]="IncludeFiles",h[h.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",h[h.IncludeSharedAccounts=8]="IncludeSharedAccounts",h[h.IncludeVersionProperties=16]="IncludeVersionProperties",h[h.ExcludeNonValidated=32]="ExcludeNonValidated",h[h.IncludeInstallationTargets=64]="IncludeInstallationTargets",h[h.IncludeAssetUri=128]="IncludeAssetUri",h[h.IncludeStatistics=256]="IncludeStatistics",h[h.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",h[h.Unpublished=4096]="Unpublished"})(v||(v={}));function s(...h){return String(h.reduce((o,b)=>o|b,0))}var r;(function(h){h[h.Tag=1]="Tag",h[h.ExtensionId=4]="ExtensionId",h[h.Category=5]="Category",h[h.ExtensionName=7]="ExtensionName",h[h.Target=8]="Target",h[h.Featured=9]="Featured",h[h.SearchText=10]="SearchText",h[h.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const e={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:v.None,criteria:[],assetTypes:[]};class l{constructor(o=a){this.state=o}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(o,b=this.state.pageSize){return new l(Object.assign(Object.assign({},this.state),{pageNumber:o,pageSize:b}))}withFilter(o,...b){const y=[...this.state.criteria,...b.length?b.map(A=>({filterType:o,value:A})):[{filterType:o}]];return new l(Object.assign(Object.assign({},this.state),{criteria:y}))}withSortBy(o){return new l(Object.assign(Object.assign({},this.state),{sortBy:o}))}withSortOrder(o){return new l(Object.assign(Object.assign({},this.state),{sortOrder:o}))}withFlags(...o){return new l(Object.assign(Object.assign({},this.state),{flags:o.reduce((b,y)=>b|y,0)}))}withAssetTypes(...o){return new l(Object.assign(Object.assign({},this.state),{assetTypes:o}))}get raw(){const{criteria:o,pageNumber:b,pageSize:y,sortBy:A,sortOrder:M,flags:B,assetTypes:V}=this.state;return{filters:[{criteria:o,pageNumber:b,pageSize:y,sortBy:A,sortOrder:M}],assetTypes:V,flags:B}}get searchText(){const o=this.state.criteria.filter(b=>b.filterType===r.SearchText)[0];return o&&o.value?o.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(o=>String(o.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function d(h,o){const b=(h||[]).filter(y=>y.statisticName===o)[0];return b?b.value:0}function E(h){const o="Microsoft.VisualStudio.Code.Translation.";return h.files.filter(y=>y.assetType.indexOf(o)===0).reduce((y,A)=>{const M=U(h,A.assetType);return M&&y.push([A.assetType.substring(o.length),M]),y},[])}function N(h){if(h.properties){const o=h.properties.filter(A=>A.key===e.Repository),b=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),y=o.filter(A=>b.test(A.value))[0];return y?{uri:y.value,fallbackUri:y.value}:null}return U(h,e.Repository)}function j(h){return{uri:`${h.fallbackAssetUri}/${e.VSIX}?redirect=true`,fallbackUri:`${h.fallbackAssetUri}/${e.VSIX}`}}function k(h){const o=U(h,e.Icon);if(o)return o;const b=T.DefaultIconPath;return{uri:b,fallbackUri:b}}function U(h,o){return h.files.filter(y=>y.assetType===o)[0]?{uri:`${h.assetUri}/${o}`,fallbackUri:`${h.fallbackAssetUri}/${o}`}:null}function W(h,o){const b=h.properties?h.properties.filter(A=>A.key===o):[],y=b.length>0&&b[0].value;return y?y.split(",").map(A=>(0,P.adoptToGalleryExtensionId)(A)):[]}function K(h){const o=h.properties?h.properties.filter(b=>b.key===i.Engine):[];return o.length>0&&o[0].value||""}function ne(h){const o=h.properties?h.properties.filter(y=>y.key===i.LocalizedLanguages):[],b=o.length>0&&o[0].value||"";return b?b.split(","):[]}function ee(h){return h.indexOf("preview")!==-1}function ie(h){const o=h.properties?h.properties.find(b=>b.key===i.WebExtension):void 0;return!!o&&o.value==="true"}function oe(h){return h.files.some(o=>o.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,C.joinPath)(O.URI.parse(h.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function _(h,o,b,y,A){const M={manifest:U(o,e.Manifest),readme:U(o,e.Details),changelog:U(o,e.Changelog),license:U(o,e.License),repository:N(o),download:j(o),icon:k(o),coreTranslations:E(o)};return{identifier:{id:(0,P.getGalleryExtensionId)(h.publisher.publisherName,h.extensionName),uuid:h.extensionId},name:h.extensionName,version:o.version,date:o.lastUpdated,displayName:h.displayName,publisherId:h.publisher.publisherId,publisher:h.publisher.publisherName,publisherDisplayName:h.publisher.displayName,description:h.shortDescription||"",installCount:d(h.statistics,"install"),rating:d(h.statistics,"averagerating"),ratingCount:d(h.statistics,"ratingcount"),assetUri:O.URI.parse(o.assetUri),webResource:oe(o),assetTypes:o.files.map(({assetType:B})=>B),assets:M,properties:{dependencies:W(o,i.Dependency),extensionPack:W(o,i.ExtensionPack),engine:K(o),localizedLanguages:ne(o),webExtension:ie(o)},telemetryData:{index:(y.pageNumber-1)*y.pageSize+b,querySource:A},preview:ee(h.flags)}}let q=class{constructor(o,b,y,A,M,B,V){this.requestService=o,this.logService=b,this.environmentService=y,this.telemetryService=A,this.fileService=M,this.productService=B;const $=B.extensionsGallery;this.extensionsGalleryUrl=$&&$.serviceUrl,this.extensionsControlUrl=$&&$.controlUrl,this.commonHeadersPromise=J(B.version,this.environmentService,this.fileService,V)}api(o=""){return`${this.extensionsGalleryUrl}${o}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(o,b){const y=[];let{total:A,firstPage:M,getPage:B}=await this.query({names:o,pageSize:o.length},b);y.push(...M);for(let V=1;y.length<A&&(M=await B(V,b),M.length);V++)y.push(...M);return y}async getCompatibleExtension(o,b){const y=await this.getCompatibleExtensionByEngine(o,b);return(y==null?void 0:y.properties.webExtension)?y.webResource?y:null:y}async getCompatibleExtensionByEngine(o,b){const y=(0,T.isIExtensionIdentifier)(o)?null:o;if(y&&y.properties.engine&&(0,f.isEngineValid)(y.properties.engine,this.productService.version))return y;const{id:A,uuid:M}=y?y.identifier:o;let B=new l().withFlags(v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?B=B.withFilter(r.ExtensionId,M):B=B.withFilter(r.ExtensionName,A);const{galleryExtensions:V}=await this.queryGallery(B,R.CancellationToken.None),[$]=V;if(!$||!$.versions.length)return null;if(b){const Y=$.versions.filter(te=>te.version===b)[0];if(Y){const te=_($,Y,0,B);if(te.properties.engine&&(0,f.isEngineValid)(te.properties.engine,this.productService.version))return te}return null}const X=await this.getLastValidExtensionVersion($,$.versions);return X?_($,X,0,B):null}async query(o,b){const y=R.CancellationToken.isCancellationToken(o)?{}:o,A=R.CancellationToken.isCancellationToken(o)?o:b;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=y.text||"";const B=(0,S.getOrDefault)(y,re=>re.pageSize,50);let V=new l().withFlags(v.IncludeLatestVersionOnly,v.IncludeAssetUri,v.IncludeStatistics,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,B).withFilter(r.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,le,ge)=>(V=V.withFilter(r.Category,ge||le),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(re,le,ge)=>(V=V.withFilter(r.Tag,ge||le),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(r.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),V=V.withFilter(r.SearchText,M)),V=V.withSortBy(0)):y.ids?V=V.withFilter(r.ExtensionId,...y.ids):y.names?V=V.withFilter(r.ExtensionName,...y.names):V=V.withSortBy(4),typeof y.sortBy=="number"&&(V=V.withSortBy(y.sortBy)),typeof y.sortOrder=="number"&&(V=V.withSortOrder(y.sortOrder));const{galleryExtensions:$,total:X}=await this.queryGallery(V,A),Y=$.map((re,le)=>_(re,re.versions[0],le,V,y.source)),te=async(re,le)=>{if(le.isCancellationRequested)throw(0,p.canceled)();const ge=V.withPage(re+1),{galleryExtensions:Ie}=await this.queryGallery(ge,le);return Ie.map((Fe,Le)=>_(Fe,Fe.versions[0],Le,ge,y.source))};return{firstPage:Y,total:X,pageSize:V.pageSize,getPage:te}}async queryGallery(o,b){if(!this.isEnabled())throw new Error("No extension gallery service configured.");o=o.withFlags(o.flags,v.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(v.Unpublished));const y=await this.commonHeadersPromise,A=JSON.stringify(o.raw),M=Object.assign(Object.assign({},y),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(A.length)}),B=new Date().getTime();let V,$,X=0;try{if(V=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:A,headers:M},b),V.res.statusCode&&V.res.statusCode>=400&&V.res.statusCode<500)return{galleryExtensions:[],total:X};const Y=await(0,D.asJson)(V);if(Y){const te=Y.results[0],re=te.extensions,le=te.resultMetadata&&te.resultMetadata.filter(ge=>ge.metadataType==="ResultCount")[0];return X=le&&le.metadataItems.filter(ge=>ge.name==="TotalCount")[0].count||0,{galleryExtensions:re,total:X}}return{galleryExtensions:[],total:X}}catch(Y){throw $=Y,Y}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},o.telemetryData),{requestBodySize:String(A.length),duration:new Date().getTime()-B,success:!!V&&(0,D.isSuccess)(V),responseBodySize:V==null?void 0:V.res.headers["Content-Length"],statusCode:V?String(V.res.statusCode):void 0,errorCode:$?(0,p.isPromiseCanceledError)($)?"canceled":(0,p.getErrorMessage)($).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(X)}))}}async reportStatistic(o,b,y,A){if(!!this.isEnabled()){const M=await this.commonHeadersPromise,B=Object.assign(Object.assign({},M),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${o}/extensions/${b}/${y}/stats?statType=${A}`),headers:B},R.CancellationToken.None)}catch(V){}}}async download(o,b,y){this.logService.trace("ExtensionGalleryService#download",o.identifier.id);const A=(0,P.getGalleryExtensionTelemetryData)(o),M=new Date().getTime(),B=Y=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},A),{duration:Y})),V=y===1?"install":y===2?"update":"",$=V?{uri:`${o.assets.download.uri}&${V}=true`,fallbackUri:`${o.assets.download.fallbackUri}?${V}=true`}:o.assets.download,X=await this.getAsset($);await this.fileService.writeFile(b,X.stream),B(new Date().getTime()-M)}async getReadme(o,b){if(o.assets.readme){const y=await this.getAsset(o.assets.readme,{},b);return await(0,D.asText)(y)||""}return""}async getManifest(o,b){if(o.assets.manifest){const y=await this.getAsset(o.assets.manifest,{},b),A=await(0,D.asText)(y);return A?JSON.parse(A):null}return null}async getCoreTranslation(o,b){const y=o.assets.coreTranslations.filter(A=>A[0]===b.toUpperCase())[0];if(y){const A=await this.getAsset(y[1]),M=await(0,D.asText)(A);return M?JSON.parse(M):null}return null}async getChangelog(o,b){if(o.assets.changelog){const y=await this.getAsset(o.assets.changelog,{},b);return await(0,D.asText)(y)||""}return""}async getAllVersions(o,b){let y=new l().withFlags(v.IncludeVersions,v.IncludeFiles,v.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");o.identifier.uuid?y=y.withFilter(r.ExtensionId,o.identifier.uuid):y=y.withFilter(r.ExtensionName,o.identifier.id);const A=[],{galleryExtensions:M}=await this.queryGallery(y,R.CancellationToken.None);return M.length&&(b?await Promise.all(M[0].versions.map(async B=>{let V;try{V=await this.getEngine(B)}catch($){}V&&(0,f.isEngineValid)(V,this.productService.version)&&A.push({version:B.version,date:B.lastUpdated})})):A.push(...M[0].versions.map(B=>({version:B.version,date:B.lastUpdated})))),A}async getAsset(o,b={},y=R.CancellationToken.None){const A=await this.commonHeadersPromise,M={type:"GET"},B=Object.assign(Object.assign({},A),b.headers||{});b=Object.assign(Object.assign(Object.assign({},b),M),{headers:B});const V=o.uri,$=o.fallbackUri,X=Object.assign(Object.assign({},b),{url:V});try{const Y=await this.requestService.request(X,y);if(Y.res.statusCode===200)return Y;const te=await(0,D.asText)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${te}`)}catch(Y){if((0,p.isPromiseCanceledError)(Y))throw Y;const te=(0,p.getErrorMessage)(Y);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:V,message:te});const re=Object.assign(Object.assign({},b),{url:$});return this.requestService.request(re,y)}}async getLastValidExtensionVersion(o,b){const y=this.getLastValidExtensionVersionFromProperties(o,b);return y||this.getLastValidExtensionVersionRecursively(o,b)}getLastValidExtensionVersionFromProperties(o,b){for(const y of b){const A=K(y);if(!A)return null;if((0,f.isEngineValid)(A,this.productService.version))return y}return null}async getEngine(o){const b=K(o);if(b)return b;const y=U(o,e.Manifest);if(!y)throw new Error("Manifest was not found");const A={"Accept-Encoding":"gzip"},M=await this.getAsset(y,{headers:A}),B=await(0,D.asJson)(M);if(B)return B.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(o,b){if(!b.length)return null;const y=b[0],A=await this.getEngine(y);return(0,f.isEngineValid)(A,this.productService.version)?(y.properties=y.properties||[],y.properties.push({key:i.Engine,value:A}),y):this.getLastValidExtensionVersionRecursively(o,b.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const o=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},R.CancellationToken.None);if(o.res.statusCode!==200)throw new Error("Could not get extensions report.");const b=await(0,D.asJson)(o),y=new Map;if(b)for(const A of b.malicious){const M=y.get(A)||{id:{id:A},malicious:!0,slow:!1};M.malicious=!0,y.set(A,M)}return[...y.values()]}};q=ue([fe(0,D.IRequestService),fe(1,m.ILogService),fe(2,c.IEnvironmentService),fe(3,F.ITelemetryService),fe(4,w.IFileService),fe(5,u.IProductService),fe(6,(0,L.optional)(g.IStorageService))],q),t.ExtensionGalleryService=q;async function J(h,o,b,y){const A={"X-Market-Client-Id":`VSCode ${h}`,"User-Agent":`VSCode ${h}`},M=await(0,I.getServiceMachineId)(o,b,y);return A["X-Market-User-Id"]=M,A}t.resolveMarketplaceHeaders=J}),define(Q[118],Z([0,1,40,85,20,10,27,31,2,21,26]),function(x,t,p,T,P,S,F,D,f,c,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(u,g){this._configurationService=g,this._experimentProperties={},this._disposables=new f.DisposableStore,this._cleanupPatterns=[],this._appender=u.appender,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,P.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const L=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!L})}))}setExperimentProperty(u,g){this._experimentProperties[u]=g}setEnabled(u){this._enabled=u}_updateUserOptIn(){var u;const g=(u=this._configurationService)===null||u===void 0?void 0:u.getValue(w);this._userOptIn=g?g.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const u=await this._commonProperties;let g=u.sessionID,I=u["common.instanceId"],L=u["common.machineId"],C=u["common.firstSessionDate"],v=u["common.msftInternal"];return{sessionId:g,instanceId:I,machineId:L,firstSessionDate:C,msftInternal:v}}dispose(){this._disposables.dispose()}publicLog(u,g,I){return this.isOptedIn?this._commonProperties.then(L=>{g=(0,c.mixin)(g,L),g=(0,c.mixin)(g,this._experimentProperties),g=(0,c.cloneAndChange)(g,C=>{if(typeof C=="string")return this._cleanupInfo(C,I)}),this._appender.log(u,g)},L=>{console.error(L)}):Promise.resolve(void 0)}publicLog2(u,g,I){return this.publicLog(u,g,I)}publicLogError(u,g){return this.sendErrorTelemetry?this.publicLog(u,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_cleanupInfo(u,g){let I=u;if(g){const L=[];for(let r of this._cleanupPatterns)for(;;){const e=r.exec(u);if(!e)break;L.push([e.index,r.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(I="";;){const r=v.exec(u);if(!r)break;!C.test(r[0])&&L.every(([e,i])=>r.index<e||r.index>=i)&&(I+=u.substring(s,r.index)+"<REDACTED: user-file-path>",s=v.lastIndex)}s<u.length&&(I+=u.substr(s))}for(let L of this._cleanupPatterns)I=I.replace(L,"");return I}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=ue([fe(1,(0,S.optional)(F.IConfigurationService))],m),t.TelemetryService=m;const w="telemetry";R.Registry.as(D.Extensions.Configuration).registerConfiguration({id:w,order:110,type:"object",title:(0,T.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,T.localize)(2,null,p.default.privacyStatementUrl):(0,T.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Q[56],Z([0,1,27,21,11,4]),function(x,t,p,T,P,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(u,g){return Promise.resolve(void 0)}publicLog2(u,g){return this.publicLog(u,g)}publicLogError(u,g){return Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(g,I,L){}async publicLogError(g,I,L){}}t.NullEndpointTelemetryService=F;function D(...u){return{log:(g,I)=>u.forEach(L=>L.log(g,I)),flush:()=>S.Promises.settled(u.map(g=>g.flush()))}}t.combinedAppender=D,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function f(u,g){return g.onDidChangeConfiguration(I=>{I.source!==6&&u.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(I.source),configurationKeys:w(I.sourceConfig)})})}t.configurationTelemetry=f;function c(u){const g=Object.create(null),I=Object.create(null),L=Object.create(null);m(u,L);for(let C in L){C=C.length>150?C.substr(C.length-149):C;const v=L[C];typeof v=="number"?I[C]=v:typeof v=="boolean"?I[C]=v?1:0:typeof v=="string"?g[C]=v.substring(0,1023):typeof v!="undefined"&&v!==null&&(g[C]=v)}return{properties:g,measurements:I}}t.validateTelemetryData=c;function R(u){if(!u)return"none";let g="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(L=>{u.indexOf(`${L}+`)===0&&(g=L)}),g}t.cleanRemoteAuthority=R;function m(u,g,I=0,L){if(!!u)for(let C of Object.getOwnPropertyNames(u)){const v=u[C],s=L?L+C:C;Array.isArray(v)?g[s]=(0,T.safeStringify)(v):v instanceof Date?g[s]=v.toISOString():(0,P.isObject)(v)?I<2?m(v,g,I+1,s+"."):g[s]=(0,T.safeStringify)(v):g[s]=v}}function w(u){if(!u)return[];const g=[];return O(g,"",u),g}function O(u,g,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(L=>O(u,g?`${g}.${L}`:L,I[L])):u.push(g)}}),define(Q[119],Z([0,1,12,21,56]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function S(D){const f=await new Promise((R,m)=>{x(["applicationinsights"],R,m)});let c;return f.defaultClient?(c=new f.TelemetryClient(D),c.channel.setUseDiskRetryCaching(!0)):(f.setup(D).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),c=f.defaultClient),D.indexOf("AIF-")===0&&(c.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),c}class F{constructor(f,c,R){this._eventPrefix=f,this._defaultData=c,this._defaultData||(this._defaultData=Object.create(null)),typeof R=="function"?this._aiClient=R():this._aiClient=R,this._asyncAIClient=null}_withAIClient(f){if(!!this._aiClient){if(typeof this._aiClient!="string"){f(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=S(this._aiClient)),this._asyncAIClient.then(c=>{f(c)},c=>{(0,p.onUnexpectedError)(c),console.error(c)})}}log(f,c){!this._aiClient||(c=(0,T.mixin)(c,this._defaultData),c=(0,P.validateTelemetryData)(c),this._withAIClient(R=>R.trackEvent({name:this._eventPrefix+"/"+f,properties:c.properties,measurements:c.measurements})))}flush(){return this._aiClient?new Promise(f=>{this._withAIClient(c=>{c.flush({callback:()=>{this._aiClient=void 0,f(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Q[120],Z([0,1,14,18,3]),function(x,t,p,T,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;function S(F,D){const f=Object.create(null),c=(m,w)=>{const O=JSON.parse(m);f[w]=O};if(D){const m=(0,p.readdirSync)(D).filter(O=>{try{return(0,T.statSync)((0,P.join)(D,O)).isDirectory()}catch(u){return!1}}),w=[];m.forEach(O=>{(0,p.readdirSync)((0,P.join)(D,O)).filter(g=>g==="telemetry.json").length===1&&w.push(O)}),w.forEach(O=>{const u=(0,T.readFileSync)((0,P.join)(D,O,"telemetry.json")).toString();c(u,O)})}let R=(0,T.readFileSync)((0,P.join)(F,"telemetry-core.json")).toString();return c(R,"vscode-core"),R=(0,T.readFileSync)((0,P.join)(F,"telemetry-extensions.json")).toString(),c(R,"vscode-extensions"),JSON.stringify(f,null,4)}t.buildTelemetryMessage=S}),define(Q[43],Z([0,1,73,3,18,4,14,131,132,11]),function(x,t,p,T,P,S,F,D,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class R extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=R;function m(r){const e=r.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function w(r){if(r instanceof R)return r;let e;return/end of central directory record signature not found/.test(r.message)&&(e="CorruptZip"),new R(e,r)}function O(r,e,i,n,a,l){const d=T.dirname(e),E=T.join(n,d);if(!E.startsWith(n))return Promise.reject(new Error(p.localize(0,null,e)));const N=T.join(n,e);let j;return l.onCancellationRequested(()=>{j&&j.destroy()}),Promise.resolve(P.promises.mkdir(E,{recursive:!0})).then(()=>new Promise((k,U)=>{if(!l.isCancellationRequested)try{j=(0,P.createWriteStream)(N,{mode:i}),j.once("close",()=>k()),j.once("error",U),r.once("error",U),r.pipe(j)}catch(W){U(W)}}))}function u(r,e,i,n){let a=(0,S.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{a.cancel(),r.close()}),new Promise((d,E)=>{const N=new S.Sequencer,j=k=>{k.isCancellationRequested||(l++,r.readEntry())};r.once("error",E),r.once("close",()=>a.then(()=>{n.isCancellationRequested||r.entryCount===l?d():E(new R("Incomplete",new Error(p.localize(1,null,l,r.entryCount))))},E)),r.readEntry(),r.on("entry",k=>{if(!n.isCancellationRequested){if(!i.sourcePathRegex.test(k.fileName)){j(n);return}const U=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(U)){const ne=T.join(e,U);a=(0,S.createCancelablePromise)(ee=>P.promises.mkdir(ne,{recursive:!0}).then(()=>j(ee)).then(void 0,E));return}const W=I(r,k),K=m(k);a=(0,S.createCancelablePromise)(ne=>N.queue(()=>W.then(ee=>O(ee,U,K,e,i,ne).then(()=>j(ne)))).then(null,E))}})})}function g(r,e=!1){return new Promise((i,n)=>{(0,D.open)(r,e?{lazyEntries:!0}:void 0,(a,l)=>{a?n(w(a)):i((0,c.assertIsDefined)(l))})})}function I(r,e){return new Promise((i,n)=>{r.openReadStream(e,(a,l)=>{a?n(w(a)):i((0,c.assertIsDefined)(l))})})}function L(r,e){return new Promise((i,n)=>{const a=new f.ZipFile;e.forEach(d=>{d.contents?a.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&a.addFile(d.localPath,d.path)}),a.end();const l=(0,P.createWriteStream)(r);a.outputStream.pipe(l),a.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(r))})}t.zip=L;function C(r,e,i={},n){const a=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=g(r,!0);return i.overwrite&&(l=l.then(d=>(0,F.rimraf)(e).then(()=>d))),l.then(d=>u(d,e,{sourcePathRegex:a},n))}t.extract=C;function v(r,e){return g(r).then(i=>new Promise((n,a)=>{i.on("entry",l=>{l.fileName===e&&I(i,l).then(d=>n(d),d=>a(d))}),i.once("close",()=>a(new Error(p.localize(2,null,e))))}))}function s(r,e){return v(r,e).then(i=>new Promise((n,a)=>{const l=[];i.once("error",a),i.on("data",d=>l.push(d)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=s}),define(Q[121],Z([0,1,43,78]),function(x,t,p,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function P(S){return(0,p.buffer)(S,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(D){throw new Error((0,T.localize)(0,null))}})}t.getManifest=P}),define(Q[122],Z([0,1,18,39,2,14,3,15,24,25,4,7,22,90,79,41,43,13,23,8,19,17,30,12]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L,C,v,s,r,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const n="scanningSystem",a="scanningUser",l="extracting",d="deleting",E="renaming";let N=class extends P.Disposable{constructor(k,U,W,K,ne){super();this.beforeRemovingExtension=k,this.fileService=U,this.logService=W,this.environmentService=K,this.productService=ne,this._devSystemExtensionsPath=null,this.systemExtensionsPath=K.builtinExtensionsPath,this.extensionsPath=K.extensionsPath,this.uninstalledPath=F.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new R.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(k){const U=[];(k===null||k===0)&&U.push(this.scanSystemExtensions().then(null,W=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(W).message,n)))),(k===null||k===1)&&U.push(this.scanUserExtensions(!0).then(null,W=>Promise.reject(new f.ExtensionManagementError(this.joinErrors(W).message,a))));try{const W=await Promise.all(U);return(0,C.flatten)(W)}catch(W){throw this.joinErrors(W)}}async scanUserExtensions(k){this.logService.trace("Started scanning user extensions");let[U,W]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return W=W.filter(K=>!U[new c.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version).key()]),k&&(W=(0,c.groupByExtension)(W,ne=>ne.identifier).map(ne=>ne.sort((ee,ie)=>T.rcompare(ee.manifest.version,ie.manifest.version))[0])),this.logService.trace("Scanned user extensions:",W.length),W}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(k,U,W){const K=k.key(),ne=F.join(this.extensionsPath,`.${(0,e.generateUuid)()}`),ee=F.join(this.extensionsPath,K);try{await S.rimraf(ee)}catch(oe){try{await S.rimraf(ee)}catch(_){}throw new f.ExtensionManagementError((0,u.localize)(0,null,ee,k.id),d)}await this.extractAtLocation(k,U,ne,W);let ie=await this.scanExtension(m.URI.file(ne),1);if(!ie)throw new Error((0,u.localize)(1,null,ne));await this.storeMetadata(ie,{installedTimestamp:Date.now()});try{await this.rename(k,ne,ee,Date.now()+2*60*1e3),this.logService.info("Renamed to",ee)}catch(oe){try{await S.rimraf(ne)}catch(_){}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)(oe)}. Deleted from extracted location`,ne),oe}try{ie=await this.scanExtension(m.URI.file(ee),1)}catch(oe){}if(ie)return ie;throw new Error((0,u.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(k,U){return this.setMetadata(k,U),await this.storeMetadata(k,Object.assign(Object.assign({},U),{installedTimestamp:k.installedTimestamp})),k}async storeMetadata(k,U){U.isMachineScoped=U.isMachineScoped||void 0,U.isBuiltin=U.isBuiltin||void 0,U.installedTimestamp=U.installedTimestamp||void 0;const W=F.join(k.location.fsPath,"package.json"),K=await p.promises.readFile(W,"utf8"),{manifest:ne}=await this.parseManifest(K);return ne.__metadata=U,await S.writeFile(W,JSON.stringify(ne,null,"	")),k}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...k){const U=k.map(W=>new c.ExtensionIdentifierWithVersion(W.identifier,W.manifest.version));await this.withUninstalledExtensions(W=>{U.forEach(K=>W[K.key()]=!0)})}async setInstalled(k){await this.withUninstalledExtensions(K=>delete K[k.key()]);const W=(await this.scanExtensions(1)).find(K=>new c.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version).equals(k))||null;return W?(await this.storeMetadata(W,{installedTimestamp:Date.now()}),this.scanExtension(W.location,1)):null}async withUninstalledExtensions(k){return this.uninstalledFileLimiter.queue(async()=>{let U;try{U=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(K){if(K.code!=="ENOENT")throw K}let W={};if(U)try{W=JSON.parse(U)}catch(K){}return k&&(k(W),Object.keys(W).length?await S.writeFile(this.uninstalledPath,JSON.stringify(W)):await S.rimraf(this.uninstalledPath)),W})}async removeExtension(k,U){this.logService.trace(`Deleting ${U} extension from disk`,k.identifier.id,k.location.fsPath),await S.rimraf(k.location.fsPath),this.logService.info("Deleted from disk",k.identifier.id,k.location.fsPath)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.withUninstalledExtensions(U=>delete U[new c.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version).key()])}async extractAtLocation(k,U,W,K){this.logService.trace(`Started extracting the extension from ${U} to ${W}`);try{await S.rimraf(W)}catch(ne){throw new f.ExtensionManagementError(this.joinErrors(ne).message,d)}try{await(0,I.extract)(U,W,{sourcePath:"extension",overwrite:!0},K),this.logService.info(`Extracted extension to ${W}:`,k.id)}catch(ne){try{await S.rimraf(W)}catch(ee){}throw new f.ExtensionManagementError(ne.message,ne instanceof I.ExtractError&&ne.type?ne.type:l)}}async rename(k,U,W,K){try{await p.promises.rename(U,W)}catch(ne){if(L.isWindows&&ne&&ne.code==="EPERM"&&Date.now()<K)return this.logService.info(`Failed renaming ${U} to ${W} with 'EPERM' error. Trying again...`,k.id),this.rename(k,U,W,K);throw new f.ExtensionManagementError(ne.message||(0,u.localize)(3,null,U,W),ne.code||E)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const k=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return k;const U=this.scanDevSystemExtensions(),[W,K]=await Promise.all([k,U]);return[...W,...K]}async scanExtensionsInDir(k,U){const W=new R.Limiter(10),K=await this.fileService.resolve(m.URI.file(k));return K.children?(await Promise.all(K.children.filter(ee=>ee.isDirectory).map(ee=>W.queue(async()=>U===1&&(0,r.basename)(ee.resource).indexOf(".")===0?null:this.scanExtension(ee.resource,U))))).filter(ee=>ee&&ee.identifier):[]}async scanExtension(k,U){var W,K;try{const ne=await this.fileService.resolve(k);if(ne.children){const{manifest:ee,metadata:ie}=await this.readManifest(k.fsPath),oe=(W=ne.children.find(({name:h})=>/^readme(\.txt|\.md|)$/i.test(h)))===null||W===void 0?void 0:W.resource,_=(K=ne.children.find(({name:h})=>/^changelog(\.txt|\.md|)$/i.test(h)))===null||K===void 0?void 0:K.resource,q={id:(0,c.getGalleryExtensionId)(ee.publisher,ee.name)},J={type:U,identifier:q,manifest:ee,location:k,readmeUrl:oe,changelogUrl:_,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:U===0};return ie&&(this.setMetadata(J,ie),J.installedTimestamp=ie.installedTimestamp),J}}catch(ne){U!==0&&this.logService.trace(ne)}return null}async scanDefaultSystemExtensions(){const k=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",k.length),k}async scanDevSystemExtensions(){const k=this.getDevSystemExtensionsList();if(k.length){const U=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",U.length),U.filter(W=>k.some(K=>(0,c.areSameExtensions)(W.identifier,{id:K})))}else return[]}setMetadata(k,U){k.publisherDisplayName=U.publisherDisplayName||null,k.publisherId=U.publisherId||null,k.identifier.uuid=U.id,k.isMachineScoped=!!U.isMachineScoped,k.isBuiltin=k.type===0||!!U.isBuiltin}async removeUninstalledExtensions(){const k=await this.getUninstalledExtensions(),U=await this.scanAllUserExtensions(),W=new Set;for(const ee of U)k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]||W.add(ee.identifier.id.toLowerCase());const K=(0,c.groupByExtension)(U,ee=>ee.identifier);await R.Promises.settled(K.map(async ee=>{const ie=ee.sort((oe,_)=>T.rcompare(oe.manifest.version,_.manifest.version))[0];W.has(ie.identifier.id.toLowerCase())||await this.beforeRemovingExtension(ie)}));const ne=U.filter(ee=>k[new c.ExtensionIdentifierWithVersion(ee.identifier,ee.manifest.version).key()]);await R.Promises.settled(ne.map(ee=>this.removeUninstalledExtension(ee)))}async removeOutdatedExtensions(){const k=await this.scanAllUserExtensions(),U=[],W=(0,c.groupByExtension)(k,K=>K.identifier);U.push(...(0,C.flatten)(W.map(K=>K.sort((ne,ee)=>T.rcompare(ne.manifest.version,ee.manifest.version)).slice(1)))),await R.Promises.settled(U.map(K=>this.removeExtension(K,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(k=>k.name)}joinErrors(k){const U=Array.isArray(k)?k:[k];return U.length===1?U[0]instanceof Error?U[0]:new Error(U[0]):U.reduce((W,K)=>new Error(`${W.message}${W.message?",":""}${K instanceof Error?K.message:K}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=F.normalize(F.join(v.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(k){const U=[p.promises.readFile(F.join(k,"package.json"),"utf8").then(ee=>this.parseManifest(ee)),p.promises.readFile(F.join(k,"package.nls.json"),"utf8").then(void 0,ee=>ee.code!=="ENOENT"?Promise.reject(ee):"{}").then(ee=>JSON.parse(ee))],[{manifest:W,metadata:K},ne]=await Promise.all(U);return{manifest:(0,O.localizeManifest)(W,ne),metadata:K}}parseManifest(k){return new Promise((U,W)=>{try{const K=JSON.parse(k),ne=K.__metadata||null;U({manifest:K,metadata:ne})}catch(K){W(new Error((0,u.localize)(4,null)))}})}};N=ue([fe(1,s.IFileService),fe(2,D.ILogService),fe(3,w.INativeEnvironmentService),fe(4,g.IProductService)],N),t.ExtensionsScanner=N}),define(Q[123],Z([0,1,18,77,3,14,2,23,43,24,25,22,4,9,39,7,40,13,15,98,29,42,49,17,30,96,10,8,28,121,102,122,103,104,19]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L,C,v,s,r,e,i,n,a,l,d,E,N,j,k,U,W,K){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const ne="unsetUninstalled",ee="downloading",ie="validating",oe="local",_="unknown";let q=class extends F.Disposable{constructor(h,o,b,y,A,M,B){super();this.environmentService=h,this.galleryService=o,this.logService=b,this.downloadService=y,this.telemetryService=A,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new O.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new O.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new O.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new O.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const V=this._register(M.createInstance(U.ExtensionsLifecycle));this.extensionsScanner=this._register(M.createInstance(k.ExtensionsScanner,X=>V.postUninstall(X))),this.manifestCache=this._register(new v.ExtensionsManifestCache(h,this)),this.extensionsDownloader=this._register(M.createInstance(j.ExtensionsDownloader));const $=this._register(new W.ExtensionsWatcher(this,B,h,b));this._register($.onDidChangeExtensionsByAnotherSource(({added:X,removed:Y})=>{X.forEach(te=>this._onDidInstallExtension.fire({identifier:te.identifier,operation:0,local:te})),Y.forEach(te=>this._onDidUninstallExtension.fire({identifier:te}))})),this._register((0,F.toDisposable)(()=>{this.installingExtensions.forEach(X=>X.cancel()),this.uninstallingExtensions.forEach(X=>X.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(h){this.logService.trace("ExtensionManagementService#zip",h.identifier.id);const o=await this.collectFiles(h),b=await(0,f.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)()).fsPath,o);return g.URI.file(b)}async unzip(h){return this.logService.trace("ExtensionManagementService#unzip",h.toString()),(await this.install(h)).identifier}async getManifest(h){const o=await this.downloadVsix(h),b=P.resolve(o.fsPath);return(0,N.getManifest)(b)}async collectFiles(h){const o=async y=>{let A=await S.readdir(y);A=A.map(V=>P.join(y,V));const M=await Promise.all(A.map(V=>p.promises.stat(V)));let B=Promise.resolve([]);return M.forEach((V,$)=>{const X=A[$];V.isFile()&&(B=B.then(Y=>[...Y,X])),V.isDirectory()&&(B=B.then(Y=>o(X).then(te=>[...Y,...te])))}),B};return(await o(h.location.fsPath)).map(y=>({path:`extension/${P.relative(h.location.fsPath,y)}`,localPath:y}))}async install(h,o={}){return this.logService.trace("ExtensionManagementService#install",h.toString()),(0,w.createCancelablePromise)(async b=>{const y=await this.downloadVsix(h),A=P.resolve(y.fsPath),M=await(0,N.getManifest)(A),B={id:(0,R.getGalleryExtensionId)(M.publisher,M.name)};let V=1;if(M.engines&&M.engines.vscode&&!(0,e.isEngineValid)(M.engines.vscode,I.default.version))throw new Error(T.localize(0,null,B.id,I.default.version));const $=new R.ExtensionIdentifierWithVersion(B,M.version),Y=(await this.getInstalled(1)).find(re=>(0,R.areSameExtensions)(B,re.identifier));if(Y)if(o.isMachineScoped=o.isMachineScoped||Y.isMachineScoped,o.isBuiltin=o.isBuiltin||Y.isBuiltin,V=2,$.equals(new R.ExtensionIdentifierWithVersion(Y.identifier,Y.manifest.version)))try{await this.extensionsScanner.removeExtension(Y,"existing")}catch(re){throw new Error(T.localize(1,null,M.displayName||M.name))}else u.gt(Y.manifest.version,M.version)&&await this.uninstallExtension(Y);else{const re=await this.unsetUninstalledAndGetLocal($);if(re)try{await this.extensionsScanner.removeExtension(re,"existing")}catch(le){throw new Error(T.localize(2,null,M.displayName||M.name))}}this.logService.info("Installing the extension:",B.id),this._onInstallExtension.fire({identifier:B,zipPath:A});let te;try{te=await this.getGalleryMetadata((0,R.getGalleryExtensionId)(M.publisher,M.name))}catch(re){}try{const re=await this.installFromZipPath($,A,Object.assign(Object.assign({},te||{}),o),o,V,b);return this.logService.info("Successfully installed the extension:",B.id),re}catch(re){throw this.logService.error("Failed to install the extension:",B.id,re.message),re}})}async downloadVsix(h){if(h.scheme===d.Schemas.file)return h;if(!this.downloadService)throw new Error("Download service is not available");const o=(0,i.joinPath)(this.environmentService.tmpDir,(0,n.generateUuid)());return await this.downloadService.download(h,o),o}async installFromZipPath(h,o,b,y,A,M){try{const B=await this.installExtension({zipPath:o,identifierWithVersion:h,metadata:b},M);try{await this.installDependenciesAndPackExtensions(B,void 0,y)}catch(V){(0,D.isNonEmptyArray)(B.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",B.identifier.id,V.message),(0,D.isNonEmptyArray)(B.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",B.identifier.id,V.message)}return this._onDidInstallExtension.fire({identifier:h,zipPath:o,local:B,operation:A}),B}catch(B){throw this._onDidInstallExtension.fire({identifier:h,zipPath:o,operation:A,error:B}),B}}async canInstall(h){return!0}async installFromGallery(h,o={}){if(!this.galleryService.isEnabled())throw new Error(T.localize(3,null));try{h=await this.checkAndGetCompatibleVersion(h)}catch(A){const M=A&&A.code?A.code:_;throw this.logService.error("Failed to install extension:",h.identifier.id,A?A.message:M),this.reportTelemetry(this.getTelemetryEvent(1),(0,R.getGalleryExtensionTelemetryData)(h),void 0,A),A instanceof Error&&(A.name=M),A}const b=new R.ExtensionIdentifierWithVersion(h.identifier,h.version).key();let y=this.installingExtensions.get(b);return y||(y=(0,w.createCancelablePromise)(A=>this.doInstallFromGallery(h,o,A)),this.installingExtensions.set(b,y),y.finally(()=>this.installingExtensions.delete(b))),y}async doInstallFromGallery(h,o,b){const y=new Date().getTime();let A=1;this.logService.info("Installing extension:",h.identifier.id),this._onInstallExtension.fire({identifier:h.identifier,gallery:h});try{const B=(await this.getInstalled(1)).find(X=>(0,R.areSameExtensions)(X.identifier,h.identifier));B&&(A=2);const V=await this.downloadInstallableExtension(h,A);V.metadata.isMachineScoped=o.isMachineScoped||(B==null?void 0:B.isMachineScoped),V.metadata.isBuiltin=o.isBuiltin||(B==null?void 0:B.isBuiltin);const $=await this.installExtension(V,b);try{await this.extensionsDownloader.delete(g.URI.file(V.zipPath))}catch(X){}if(!o.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions($,B,o)}catch(X){try{await this.uninstall($)}catch(Y){}throw X}return B&&u.neq(B.manifest.version,h.version)&&await this.extensionsScanner.setUninstalled(B),this.logService.info("Extensions installed successfully:",h.identifier.id),this._onDidInstallExtension.fire({identifier:h.identifier,gallery:h,local:$,operation:A}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(h),new Date().getTime()-y,void 0),$}catch(M){const B=M&&M.code?M.code:_;throw this.logService.error("Failed to install extension:",h.identifier.id,M?M.message:B),this._onDidInstallExtension.fire({identifier:h.identifier,gallery:h,operation:A,error:B}),this.reportTelemetry(this.getTelemetryEvent(A),(0,R.getGalleryExtensionTelemetryData)(h),new Date().getTime()-y,M),M instanceof Error&&(M.name=B),M}}async checkAndGetCompatibleVersion(h){if(await this.isMalicious(h))throw new c.ExtensionManagementError(T.localize(4,null),c.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(h);if(!o)throw new c.ExtensionManagementError(T.localize(5,null,h.identifier.id,I.default.version),c.INSTALL_ERROR_INCOMPATIBLE);return o}async reinstallFromGallery(h){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",h.identifier.id),!this.galleryService.isEnabled())throw new Error(T.localize(6,null));const o=await this.findGalleryExtension(h);if(!o)throw new Error(T.localize(7,null));await this.extensionsScanner.setUninstalled(h);try{await this.extensionsScanner.removeUninstalledExtension(h)}catch(b){throw new Error(T.localize(8,null,(0,s.toErrorMessage)(b)))}await this.installFromGallery(o)}getTelemetryEvent(h){return h===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(h){const o=await this.getExtensionsReport();return(0,R.getMaliciousExtensionsSet)(o).has(h.identifier.id)}async downloadInstallableExtension(h,o){const b={id:h.identifier.uuid,publisherId:h.publisherId,publisherDisplayName:h.publisherDisplayName};let y;try{this.logService.trace("Started downloading extension:",h.identifier.id),y=(await this.extensionsDownloader.downloadExtension(h,o)).fsPath,this.logService.info("Downloaded extension:",h.identifier.id,y)}catch(A){throw new c.ExtensionManagementError(this.joinErrors(A).message,ee)}try{const A=await(0,N.getManifest)(y);return{zipPath:y,identifierWithVersion:new R.ExtensionIdentifierWithVersion(h.identifier,A.version),metadata:b}}catch(A){throw new c.ExtensionManagementError(this.joinErrors(A).message,ie)}}async installExtension(h,o){try{const b=await this.unsetUninstalledAndGetLocal(h.identifierWithVersion);if(b)return h.metadata?this.extensionsScanner.saveMetadataForLocalExtension(b,h.metadata):b}catch(b){throw L.isMacintosh?new c.ExtensionManagementError(T.localize(9,null),ne):new c.ExtensionManagementError(T.localize(10,null),ne)}return this.extractAndInstall(h,o)}async unsetUninstalledAndGetLocal(h){if(!await this.isUninstalled(h))return null;this.logService.trace("Removing the extension from uninstalled list:",h.id);const b=await this.extensionsScanner.setInstalled(h);return this.logService.info("Removed the extension from uninstalled list:",h.id),b}async extractAndInstall({zipPath:h,identifierWithVersion:o,metadata:b},y){let A=await this.extensionsScanner.extractUserExtension(o,h,y);return this.logService.info("Installation completed.",o.id),b&&(A=await this.extensionsScanner.saveMetadataForLocalExtension(A,b)),A}async installDependenciesAndPackExtensions(h,o,b){if(!!this.galleryService.isEnabled()){const y=h.manifest.extensionDependencies||[];if(h.manifest.extensionPack)for(const A of h.manifest.extensionPack)o&&o.manifest.extensionPack&&o.manifest.extensionPack.some(M=>(0,R.areSameExtensions)({id:M},{id:A}))||y.every(M=>!(0,R.areSameExtensions)({id:M},{id:A}))&&y.push(A);if(y.length){const A=await this.getInstalled(),M=y.filter(B=>A.every(({identifier:V})=>!(0,R.areSameExtensions)(V,{id:B})));if(M.length){const V=(await this.galleryService.query({names:M,pageSize:y.length},E.CancellationToken.None)).firstPage;try{await w.Promises.settled(V.map($=>this.installFromGallery($,b)))}catch($){try{await this.rollback(V)}catch(X){}throw $}}}}}async rollback(h){const b=(await this.getInstalled(1)).filter(y=>h.some(A=>new R.ExtensionIdentifierWithVersion(y.identifier,y.manifest.version).equals(new R.ExtensionIdentifierWithVersion(A.identifier,A.version))));await w.Promises.settled(b.map(y=>this.uninstall(y)))}async uninstall(h,o={}){this.logService.trace("ExtensionManagementService#uninstall",h.identifier.id);const b=await this.getInstalled(1),y=b.find(A=>(0,R.areSameExtensions)(A.identifier,h.identifier));if(!y)throw new Error(T.localize(11,null,h.manifest.displayName||h.manifest.name));try{await this.checkForDependenciesAndUninstall(y,b,o)}catch(A){throw this.joinErrors(A)}}async updateMetadata(h,o){return this.logService.trace("ExtensionManagementService#updateMetadata",h.identifier.id),h=await this.extensionsScanner.saveMetadataForLocalExtension(h,Object.assign(Object.assign({},h.manifest.__metadata||{}),o)),this.manifestCache.invalidate(),h}async updateExtensionScope(h,o){return this.logService.trace("ExtensionManagementService#updateExtensionScope",h.identifier.id),h=await this.extensionsScanner.saveMetadataForLocalExtension(h,Object.assign(Object.assign({},h.manifest.__metadata||{}),{isMachineScoped:o})),this.manifestCache.invalidate(),h}async getGalleryMetadata(h){const o=await this.findGalleryExtensionByName(h);return o?{id:o.identifier.uuid,publisherDisplayName:o.publisherDisplayName,publisherId:o.publisherId}:void 0}async findGalleryExtension(h){if(h.identifier.uuid){const o=await this.findGalleryExtensionById(h.identifier.uuid);return o||this.findGalleryExtensionByName(h.identifier.id)}return this.findGalleryExtensionByName(h.identifier.id)}async findGalleryExtensionById(h){return(await this.galleryService.query({ids:[h],pageSize:1},E.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(h){return(await this.galleryService.query({names:[h],pageSize:1},E.CancellationToken.None)).firstPage[0]}joinErrors(h){const o=Array.isArray(h)?h:[h];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((b,y)=>new Error(`${b.message}${b.message?",":""}${y instanceof Error?y.message:y}`),new Error(""))}async checkForDependenciesAndUninstall(h,o,b){try{await this.preUninstallExtension(h);const y=b.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(h,o);await this.uninstallExtensions(h,y,o,b)}catch(y){throw await this.postUninstallExtension(h,new c.ExtensionManagementError(y instanceof Error?y.message:y,oe)),y}await this.postUninstallExtension(h)}async uninstallExtensions(h,o,b,y){const A=[h,...o];if(!y.donotCheckDependents)for(const M of A)this.checkForDependents(M,A,b,h);await w.Promises.settled([this.uninstallExtension(h),...o.map(M=>this.doUninstall(M))])}checkForDependents(h,o,b,y){const A=this.getDependents(h,b);if(A.length){const M=A.filter(B=>o.indexOf(B)===-1);if(M.length)throw new Error(this.getDependentsErrorMessage(h,M,y))}}getDependentsErrorMessage(h,o,b){return b===h?o.length===1?T.localize(12,null,b.manifest.displayName||b.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(13,null,b.manifest.displayName||b.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(14,null,b.manifest.displayName||b.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?T.localize(15,null,b.manifest.displayName||b.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(16,null,b.manifest.displayName||b.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(17,null,b.manifest.displayName||b.manifest.name,h.manifest.displayName||h.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(h,o,b=[]){if(b.indexOf(h)!==-1)return[];b.push(h);const y=h.manifest.extensionPack?h.manifest.extensionPack:[];if(y.length){const A=o.filter(B=>!B.isBuiltin&&y.some(V=>(0,R.areSameExtensions)({id:V},B.identifier))),M=[];for(const B of A)M.push(...this.getAllPackExtensionsToUninstall(B,o,b));return[...A,...M]}return[]}getDependents(h,o){return o.filter(b=>b.manifest.extensionDependencies&&b.manifest.extensionDependencies.some(y=>(0,R.areSameExtensions)({id:y},h.identifier)))}async doUninstall(h){try{await this.preUninstallExtension(h),await this.uninstallExtension(h)}catch(o){throw await this.postUninstallExtension(h,new c.ExtensionManagementError(o instanceof Error?o.message:o,oe)),o}await this.postUninstallExtension(h)}async preUninstallExtension(h){if(!await S.exists(h.location.fsPath))throw new Error(T.localize(18,null));this.logService.info("Uninstalling extension:",h.identifier.id),this._onUninstallExtension.fire(h.identifier)}async uninstallExtension(h){let o=this.uninstallingExtensions.get(h.identifier.id);return o||(o=(0,w.createCancelablePromise)(async()=>{const b=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...b.filter(y=>(0,R.areSameExtensions)(y.identifier,h.identifier)))}),this.uninstallingExtensions.set(h.identifier.id,o),o.finally(()=>this.uninstallingExtensions.delete(h.identifier.id))),o}async postUninstallExtension(h,o){if(o)this.logService.error("Failed to uninstall extension:",h.identifier.id,o.message);else if(this.logService.info("Successfully uninstalled extension:",h.identifier.id),h.identifier.uuid)try{await this.galleryService.reportStatistic(h.manifest.publisher,h.manifest.name,h.manifest.version,"uninstall")}catch(y){}this.reportTelemetry("extensionGallery:uninstall",(0,R.getLocalExtensionTelemetryData)(h),void 0,o);const b=o?o instanceof c.ExtensionManagementError?o.code:_:void 0;this._onDidUninstallExtension.fire({identifier:h.identifier,error:b})}getInstalled(h=null){return this.extensionsScanner.scanExtensions(h)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(h){return(await this.filterUninstalled(h)).length===1}async filterUninstalled(...h){const o=[],b=await this.extensionsScanner.getUninstalledExtensions();for(const y of h)b[y.key()]&&o.push(y.key());return o}getExtensionsReport(){const h=new Date().getTime();return(!this.reportedExtensions||h-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=h),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const h=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${h.length} reported extensions from service`),h}catch(h){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(h,o,b,y){const A=y?y instanceof c.ExtensionManagementError?y.code:_:void 0;this.telemetryService.publicLogError(h,Object.assign(Object.assign({},o),{success:!y,duration:b,errorcode:A}))}};q=ue([fe(0,m.INativeEnvironmentService),fe(1,c.IExtensionGalleryService),fe(2,C.ILogService),fe(3,(0,l.optional)(a.IDownloadService)),fe(4,r.ITelemetryService),fe(5,l.IInstantiationService),fe(6,K.IFileService)],q),t.ExtensionManagementService=q}),define(Q[124],Z([0,1,133,113,2,11,12,112,27,15,16,22,99]),function(x,t,p,T,P,S,F,D,f,c,R,m,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let O=class extends P.Disposable{constructor(g,I,L){super();this.environmentService=I,this.logService=L,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,I){this.logService.trace("RequestService#request",g.url);const{proxyUrl:L,strictSSL:C}=this,v=Object.assign(Object.assign({},process.env),await(0,w.resolveShellEnv)(this.logService,this.environmentService.args,process.env)),s=g.agent?g.agent:await(0,D.getProxyAgent)(g.url||"",v,{proxyUrl:L,strictSSL:C});return g.agent=s,g.strictSSL=C,this.authorization&&(g.headers=Object.assign(Object.assign({},g.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(g,I)}async getNodeRequest(g){return((0,T.parse)(g.url).protocol==="https:"?await new Promise((C,v)=>{x(["https"],C,v)}):await new Promise((C,v)=>{x(["http"],C,v)})).request}_request(g,I){return new Promise(async(L,C)=>{let v;const s=(0,T.parse)(g.url),r=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,S.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(e.auth=g.user+":"+g.password),v=r(e,i=>{const n=(0,S.isNumber)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},g),{url:i.headers.location,followRedirects:n-1}),I).then(L,C);else{let a=i;i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,p.createGunzip)())),L({res:i,stream:(0,R.streamToBufferReadableStream)(a)})}}),v.on("error",C),g.timeout&&v.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&v.write(g.data),v.end(),I.onCancellationRequested(()=>{v.abort(),C((0,F.canceled)())})})}async resolveProxy(g){}};O=ue([fe(0,f.IConfigurationService),fe(1,m.INativeEnvironmentService),fe(2,c.ILogService)],O),t.RequestService=O}),define(Q[134],Z([0,1,32,18,135,3,4,40,52,50,101,22,89,24,123,117,42,56,118,116,55,124,27,111,119,15,8,106,120,107,19,108,2,41,97,7,105,53,12,29,16,34]),function(x,t,p,T,P,S,F,D,f,c,R,m,w,O,u,g,I,L,C,v,s,r,e,i,n,a,l,d,E,N,j,k,U,W,K,ne,ee,ie,oe,_,q,J){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class h extends U.Disposable{constructor(y){super();this.argv=y,(0,P.gracefulify)(T),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[y,A]=await this.initServices();return y.invokeFunction(async M=>{const B=M.get(a.ILogService),V=M.get(j.IFileService),$=M.get(m.INativeEnvironmentService),X=M.get(O.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun($,X,V),(0,F.raceTimeout)((0,L.combinedAppender)(...A).flush(),1e3)})}async initServices(){const y=new f.ServiceCollection,A=Object.assign({_serviceBrand:void 0},D.default);y.set(W.IProductService,A);const M=new w.NativeEnvironmentService(this.argv,A);y.set(m.INativeEnvironmentService,M),await Promise.all([M.appSettingsHome.fsPath,M.extensionsPath].map(le=>le?T.promises.mkdir(le,{recursive:!0}):void 0));const B=(0,a.getLogLevel)(M),V=[];V.push(new d.SpdLogLogger("cli",(0,S.join)(M.logsPath,"cli.log"),!0,B)),B===a.LogLevel.Trace&&V.push(new a.ConsoleLogger(B));const $=this._register(new a.MultiplexLogService(V));y.set(a.ILogService,$);const X=this._register(new N.FileService($));y.set(j.IFileService,X);const Y=this._register(new k.DiskFileSystemProvider($));X.registerProvider(l.Schemas.file,Y);const te=this._register(new i.ConfigurationService(M.settingsResource,X));y.set(e.IConfigurationService,te),await te.initialize(),y.set(s.IRequestService,new c.SyncDescriptor(r.RequestService)),y.set(O.IExtensionManagementService,new c.SyncDescriptor(u.ExtensionManagementService)),y.set(O.IExtensionGalleryService,new c.SyncDescriptor(g.ExtensionGalleryService)),y.set(O.IExtensionManagementCLIService,new c.SyncDescriptor(K.ExtensionManagementCLIService)),y.set(ie.ILocalizationsService,new c.SyncDescriptor(ee.LocalizationsService));const re=[];if(M.isBuilt&&!M.isExtensionDevelopment&&!M.disableTelemetry&&A.enableTelemetry){A.aiConfig&&A.aiConfig.asimovKey&&re.push(new n.AppInsightsAppender("monacoworkbench",null,A.aiConfig.asimovKey));const{appRoot:le,extensionsPath:ge,installSourcePath:Ie}=M,Fe={appender:(0,L.combinedAppender)(...re),sendErrorTelemetry:!1,commonProperties:(async()=>{let Le;try{const Ee=await T.promises.readFile((0,S.join)(M.userDataPath,"storage.json"));Le=JSON.parse(Ee.toString())[I.machineIdKey]}catch(Ee){Ee.code!=="ENOENT"&&$.error(Ee)}return(0,v.resolveCommonProperties)(X,(0,p.release)(),(0,p.hostname)(),process.arch,A.commit,A.version,Le,A.msftInternalDomains,Ie)})(),piiPaths:[le,ge]};y.set(I.ITelemetryService,new c.SyncDescriptor(C.TelemetryService,[Fe]))}else y.set(I.ITelemetryService,L.NullTelemetryService);return[new R.InstantiationService(y),re]}registerErrorHandler(y){(0,oe.setUnexpectedErrorHandler)(A=>{const M=(0,_.toErrorMessage)(A,!0);!M||y.error(`[uncaught exception in CLI]: ${M}`)})}async doRun(y,A,M){if(this.argv["install-source"])return this.setInstallSource(y,M,this.argv["install-source"]);if(this.argv["list-extensions"])return A.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return A.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return A.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return A.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log((0,E.buildTelemetryMessage)(y.appRoot,y.extensionsPath))}asExtensionIdOrVSIX(y){return y.map(A=>/\.vsix$/i.test(A)?ne.URI.file((0,S.isAbsolute)(A)?A:(0,S.join)((0,J.cwd)(),A)):A)}async setInstallSource(y,A,M){await A.writeFile(ne.URI.file(y.installSourcePath),q.VSBuffer.fromString(M.slice(0,30)))}}async function o(b){const y=new h(b);try{await y.run()}finally{y.dispose()}}t.main=o})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54d33cf14cf6c0e86880b5b74a5a3628de42bce9/core/vs/code/node/cliProcessMain.js.map
