/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/base/common/types","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/base/node/pfs","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/extpath","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/base/common/glob","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","fs","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/editor/common/core/range","vs/platform/files/common/files","vs/workbench/api/common/extHostDebugService","vs/base/common/stopwatch","os","vs/editor/common/core/position","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/base/common/assert","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/node/processes","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/processes","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","string_decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProfiles","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ge=function(G){for(var e=[],b=0,I=G.length;b<I;b++)e[b]=me[G[b]];return e};define(me[52],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(I,A){if(!I)throw new Error(A?`Assertion failed (${A})`:"Assertion Failed")}e.ok=b}),define(me[53],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function I(C){const g=[];for(let m in C)b.call(C,m)&&g.push(C[m]);return g}e.values=I;function A(C,g){for(let m in C)if(b.call(C,m)&&g({key:m,value:C[m]},function(){delete C[m]})===!1)return}e.forEach=A;function T(C,g){const m=Object.create(null);for(const l of C){const f=g(l);let E=m[f];E||(E=m[f]=[]),E.push(l)}return m}e.groupBy=T;function y(C,g){const m=new Map;for(const l of C){const f=g(l);let E=m.get(f);E||(E=[],m.set(f,E)),E.push(l)}return m}e.groupByNumber=y;function k(C){const g=Object.create(null);return C&&C.forEach((m,l)=>{g[l]=m}),g}e.fromMap=k;function D(C,g){const m=[],l=[];for(let f of C)g.has(f)||m.push(f);for(let f of g)C.has(f)||l.push(f);return{removed:m,added:l}}e.diffSets=D;function P(C,g){const m=[],l=[];for(let[f,E]of C)g.has(f)||m.push(E);for(let[f,E]of g)C.has(f)||l.push(E);return{removed:m,added:l}}e.diffMaps=P;class r{constructor(){this.map=new Map}add(g,m){let l=this.map.get(g);l||(l=new Set,this.map.set(g,l)),l.add(m)}delete(g,m){const l=this.map.get(g);!l||(l.delete(m),l.size===0&&this.map.delete(g))}forEach(g,m){const l=this.map.get(g);!l||l.forEach(m)}}e.SetMap=r}),define(me[54],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(k,D,P)=>{let r=null,C=null;if(typeof P.value=="function"?(r="value",C=P.value):typeof P.get=="function"&&(r="get",C=P.get),!C)throw new Error("not supported");P[r]=y(C,D)}}e.createDecorator=b;function I(y,k,D){let P=null,r=null;if(typeof D.value=="function"?(P="value",r=D.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(P="get",r=D.get),!r)throw new Error("not supported");const C=`$memoize$${k}`;D[P]=function(...g){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,g)}),this[C]}}e.memoize=I;function A(y,k,D){return b((P,r)=>{const C=`$debounce$${r}`,g=`$debounce$result$${r}`;return function(...m){this[g]||(this[g]=D?D():void 0),clearTimeout(this[C]),k&&(this[g]=k(this[g],...m),m=[this[g]]),this[C]=setTimeout(()=>{P.apply(this,m),this[g]=D?D():void 0},y)}})}e.debounce=A;function T(y,k,D){return b((P,r)=>{const C=`$throttle$timer$${r}`,g=`$throttle$result$${r}`,m=`$throttle$lastRun$${r}`,l=`$throttle$pending$${r}`;return function(...f){if(this[g]||(this[g]=D?D():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),k&&(this[g]=k(this[g],...f)),!this[l]){const E=this[m]+y;E<=Date.now()?(this[m]=Date.now(),P.apply(this,[this[g]]),this[g]=D?D():void 0):(this[l]=!0,this[C]=setTimeout(()=>{this[l]=!1,this[m]=Date.now(),P.apply(this,[this[g]]),this[g]=D?D():void 0},E-Date.now()))}}})}e.throttle=T}),define(me[17],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function I(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=I;function A(c){D(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=A;function T(c){D(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=T;function y(c){if(c instanceof Error){let{name:t,message:n}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:t,message:n,stack:s}}return c}e.transformErrorForSerialization=y;const k="Canceled";function D(c){return c instanceof Error&&c.name===k&&c.message===k}e.isPromiseCanceledError=D;class P extends Error{constructor(){super(k);this.name=this.message}}e.CancellationError=P;function r(){const c=new Error(k);return c.name=c.message,c}e.canceled=r;function C(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=C;function g(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=g;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function l(c){const t=new Error(`${c} has been disposed`);return t.name="DISPOSED",t}e.disposed=l;function f(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=f;class E extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=E;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=_;function d(c){const t=c;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=d;function o(c,t=Object.create(null)){const n=new Error(c);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=o}),define(me[16],ge([0,1,17]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function I(U,L=0){return U[U.length-(1+L)]}e.tail=I;function A(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=A;function T(U,L,O=(M,F)=>M===F){if(U===L)return!0;if(!U||!L||U.length!==L.length)return!1;for(let M=0,F=U.length;M<F;M++)if(!O(U[M],L[M]))return!1;return!0}e.equals=T;function y(U,L,O){let M=0,F=U.length-1;for(;M<=F;){const W=(M+F)/2|0,q=O(U[W],L);if(q<0)M=W+1;else if(q>0)F=W-1;else return W}return-(M+1)}e.binarySearch=y;function k(U,L){let O=0,M=U.length;if(M===0)return 0;for(;O<M;){const F=Math.floor((O+M)/2);L(U[F])?M=F:O=F+1}return O}e.findFirstInSorted=k;function D(U,L,O){if(U=U|0,U>=L.length)throw new TypeError("invalid index");let M=L[Math.floor(L.length*Math.random())],F=[],W=[],q=[];for(let Q of L){const le=O(Q,M);le<0?F.push(Q):le>0?W.push(Q):q.push(Q)}return U<F.length?D(U,F,O):U<F.length+q.length?q[0]:D(U-(F.length+q.length),W,O)}e.quickSelect=D;function P(U,L){const O=[];let M;for(const F of U.slice(0).sort(L))!M||L(M[0],F)!==0?(M=[F],O.push(M)):M.push(F);return O}e.groupBy=P;function r(U,L,O){const M=[];function F(Q,le,ve){if(!(le===0&&ve.length===0)){const Re=M[M.length-1];Re&&Re.start+Re.deleteCount===Q?(Re.deleteCount+=le,Re.toInsert.push(...ve)):M.push({start:Q,deleteCount:le,toInsert:ve})}}let W=0,q=0;for(;;){if(W===U.length){F(W,0,L.slice(q));break}if(q===L.length){F(W,U.length-W,[]);break}const Q=U[W],le=L[q],ve=O(Q,le);ve===0?(W+=1,q+=1):ve<0?(F(W,1,[]),W+=1):ve>0&&(F(W,0,[le]),q+=1)}return M}e.sortedDiff=r;function C(U,L,O){const M=r(U,L,O),F=[],W=[];for(const q of M)F.push(...U.slice(q.start,q.start+q.deleteCount)),W.push(...q.toInsert);return{removed:F,added:W}}e.delta=C;function g(U,L,O){if(O===0)return[];const M=U.slice(0,O).sort(L);return l(U,L,M,O,U.length),M}e.top=g;function m(U,L,O,M,F){return O===0?Promise.resolve([]):new Promise((W,q)=>{(async()=>{const Q=U.length,le=U.slice(0,O).sort(L);for(let ve=O,Re=Math.min(O+M,Q);ve<Q;ve=Re,Re=Math.min(Re+M,Q)){if(ve>O&&await new Promise(Se=>setTimeout(Se)),F&&F.isCancellationRequested)throw(0,b.canceled)();l(U,L,le,ve,Re)}return le})().then(W,q)})}e.topAsync=m;function l(U,L,O,M,F){for(const W=O.length;M<F;M++){const q=U[M];if(L(q,O[W-1])<0){O.pop();const Q=k(O,le=>L(q,le)<0);O.splice(Q,0,q)}}}function f(U){return U.filter(L=>!!L)}e.coalesce=f;function E(U){let L=0;for(let O=0;O<U.length;O++)U[O]&&(U[L]=U[O],L+=1);U.length=L}e.coalesceInPlace=E;function w(U,L,O){U.splice(O,0,U.splice(L,1)[0])}e.move=w;function _(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=_;function d(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=d;function o(U,L){if(!L)return U.filter((M,F)=>U.indexOf(M)===F);const O=Object.create(null);return U.filter(M=>{const F=L(M);return O[F]?!1:(O[F]=!0,!0)})}e.distinct=o;function c(U){const L=new Set;return U.filter(O=>L.has(O)?!1:(L.add(O),!0))}e.distinctES6=c;function t(U){const L=Object.create(null);return O=>{const M=U(O);return L[M]?!1:(L[M]=!0,!0)}}e.uniqueFilter=t;function n(U,L){for(let O=U.length-1;O>=0;O--){const M=U[O];if(L(M))return O}return-1}e.lastIndex=n;function s(U,L){return U.length>0?U[0]:L}e.firstOrDefault=s;function i(U,L,O=(M,F)=>M===F){let M=0;for(let F=0,W=Math.min(U.length,L.length);F<W&&O(U[F],L[F]);F++)M++;return M}e.commonPrefixLength=i;function a(U){return[].concat(...U)}e.flatten=a;function h(U,L){let O=typeof L=="number"?U:0;typeof L=="number"?O=U:(O=0,L=U);const M=[];if(O<=L)for(let F=O;F<L;F++)M.push(F);else for(let F=O;F>L;F--)M.push(F);return M}e.range=h;function p(U,L,O){return U.reduce((M,F)=>(M[L(F)]=O?O(F):F,M),Object.create(null))}e.index=p;function S(U,L){return U.push(L),()=>u(U,L)}e.insert=S;function u(U,L){const O=U.indexOf(L);if(O>-1)return U.splice(O,1),L}e.remove=u;function v(U,L,O){const M=U.slice(0,L),F=U.slice(L);return M.concat(O,F)}e.arrayInsert=v;function R(U,L){let O;if(typeof L=="number"){let M=L;O=()=>{const F=Math.sin(M++)*179426549;return F-Math.floor(F)}}else O=Math.random;for(let M=U.length-1;M>0;M-=1){const F=Math.floor(O()*(M+1)),W=U[M];U[M]=U[F],U[F]=W}}e.shuffle=R;function N(U,L){const O=U.indexOf(L);O>-1&&(U.splice(O,1),U.unshift(L))}e.pushToStart=N;function j(U,L){const O=U.indexOf(L);O>-1&&(U.splice(O,1),U.push(L))}e.pushToEnd=j;function ie(U,L){return Array.isArray(U)?U.map(L):L(U)}e.mapArrayOrNot=ie;function K(U){return Array.isArray(U)?U:[U]}e.asArray=K;function B(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=B;function $(U,L){for(const O of U){const M=L(O);if(M!==void 0)return M}}e.mapFind=$}),define(me[71],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(I){const A=this;let T=!1,y;return function(){return T||(T=!0,y=I.apply(A,arguments)),y}}e.once=b}),define(me[72],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(A){this._prefix=A,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(me[55],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(I){function A(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}I.is=A;const T=Object.freeze([]);function y(){return T}I.empty=y;function*k(c){yield c}I.single=k;function D(c){return c||T}I.from=D;function P(c){return!c||c[Symbol.iterator]().next().done===!0}I.isEmpty=P;function r(c){return c[Symbol.iterator]().next().value}I.first=r;function C(c,t){for(const n of c)if(t(n))return!0;return!1}I.some=C;function g(c,t){for(const n of c)if(t(n))return n}I.find=g;function*m(c,t){for(const n of c)t(n)&&(yield n)}I.filter=m;function*l(c,t){for(const n of c)yield t(n)}I.map=l;function*f(...c){for(const t of c)for(const n of t)yield n}I.concat=f;function*E(c){for(const t of c)for(const n of t)yield n}I.concatNested=E;function w(c,t,n){let s=n;for(const i of c)s=t(s,i);return s}I.reduce=w;function*_(c,t,n=c.length){for(t<0&&(t+=c.length),n<0?n+=c.length:n>c.length&&(n=c.length);t<n;t++)yield c[t]}I.slice=_;function d(c,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,c];const s=c[Symbol.iterator]();for(let i=0;i<t;i++){const a=s.next();if(a.done)return[n,I.empty()];n.push(a.value)}return[n,{[Symbol.iterator](){return s}}]}I.consume=d;function o(c,t,n=(s,i)=>s===i){const s=c[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const a=s.next(),h=i.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!n(a.value,h.value))return!1}}I.equals=o})(b=e.Iterable||(e.Iterable={}))}),define(me[56],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var I;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(I=e.SyntaxKind||(e.SyntaxKind={}));var A;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(A=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let s=0,i=t.length,a="",h=0,p=16,S=0;function u(B){let $=0,U=0;for(;$<B;){const L=t.charCodeAt(s);if(L>=48&&L<=57)U=U*16+L-48;else if(L>=65&&L<=70)U=U*16+L-65+10;else if(L>=97&&L<=102)U=U*16+L-97+10;else break;s++,$++}return $<B&&(U=-1),U}function v(B){s=B,a="",h=0,p=16,S=0}function R(){const B=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&P(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&P(t.charCodeAt(s)))for(s++;s<t.length&&P(t.charCodeAt(s));)s++;else return S=3,t.substring(B,s);let $=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&P(t.charCodeAt(s))){for(s++;s<t.length&&P(t.charCodeAt(s));)s++;$=s}else S=3;return t.substring(B,$)}function N(){let B="",$=s;for(;;){if(s>=i){B+=t.substring($,s),S=2;break}const U=t.charCodeAt(s);if(U===34){B+=t.substring($,s),s++;break}if(U===92){if(B+=t.substring($,s),s++,s>=i){S=2;break}switch(t.charCodeAt(s++)){case 34:B+='"';break;case 92:B+="\\";break;case 47:B+="/";break;case 98:B+="\b";break;case 102:B+="\f";break;case 110:B+=`
`;break;case 114:B+="\r";break;case 116:B+="	";break;case 117:const O=u(4);O>=0?B+=String.fromCharCode(O):S=4;break;default:S=5}$=s;continue}if(U>=0&&U<=31)if(D(U)){B+=t.substring($,s),S=2;break}else S=6;s++}return B}function j(){if(a="",S=0,h=s,s>=i)return h=i,p=17;let B=t.charCodeAt(s);if(k(B)){do s++,a+=String.fromCharCode(B),B=t.charCodeAt(s);while(k(B));return p=15}if(D(B))return s++,a+=String.fromCharCode(B),B===13&&t.charCodeAt(s)===10&&(s++,a+=`
`),p=14;switch(B){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,a=N(),p=10;case 47:const $=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!D(t.charCodeAt(s));)s++;return a=t.substring($,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const U=i-1;let L=!1;for(;s<U;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,L=!0;break}s++}return L||(s++,S=1),a=t.substring($,s),p=13}return a+=String.fromCharCode(B),s++,p=16;case 45:if(a+=String.fromCharCode(B),s++,s===i||!P(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=R(),p=11;default:for(;s<i&&ie(B);)s++,B=t.charCodeAt(s);if(h!==s){switch(a=t.substring(h,s),a){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return a+=String.fromCharCode(B),s++,p=16}}function ie(B){if(k(B)||D(B))return!1;switch(B){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let B;do B=j();while(B>=12&&B<=15);return B}return{setPosition:v,getPosition:()=>s,scan:n?K:j,getToken:()=>p,getTokenValue:()=>a,getTokenOffset:()=>h,getTokenLength:()=>s-h,getTokenError:()=>S}}e.createScanner=y;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function P(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function C(t,n){const s=[],i=new Object;let a;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function S(u,v,R,N){h.value=u,h.offset=v,h.length=R,h.type=N,h.colonOffset=void 0,a=h}try{d(t,{onObjectBegin:(u,v)=>{if(n<=u)throw i;a=void 0,p=n>u,s.push("")},onObjectProperty:(u,v,R)=>{if(n<v||(S(u,v,R,"property"),s[s.length-1]=u,n<=v+R))throw i},onObjectEnd:(u,v)=>{if(n<=u)throw i;a=void 0,s.pop()},onArrayBegin:(u,v)=>{if(n<=u)throw i;a=void 0,s.push(0)},onArrayEnd:(u,v)=>{if(n<=u)throw i;a=void 0,s.pop()},onLiteralValue:(u,v,R)=>{if(n<v||(S(u,v,R,c(u)),n<=v+R))throw i},onSeparator:(u,v,R)=>{if(n<=v)throw i;if(u===":"&&a&&a.type==="property")a.colonOffset=v,p=!1,a=void 0;else if(u===","){const N=s[s.length-1];typeof N=="number"?s[s.length-1]=N+1:(p=!0,s[s.length-1]=""),a=void 0}}})}catch(u){if(u!==i)throw u}return{path:s,previousNode:a,isAtPropertyKey:p,matches:u=>{let v=0;for(let R=0;v<u.length&&R<s.length;R++)if(u[v]===s[R]||u[v]==="*")v++;else if(u[v]!=="**")return!1;return v===u.length}}}e.getLocation=C;function g(t,n=[],s=T.DEFAULT){let i=null,a=[];const h=[];function p(u){Array.isArray(a)?a.push(u):i!==null&&(a[i]=u)}return d(t,{onObjectBegin:()=>{const u={};p(u),h.push(a),a=u,i=null},onObjectProperty:u=>{i=u},onObjectEnd:()=>{a=h.pop()},onArrayBegin:()=>{const u=[];p(u),h.push(a),a=u,i=null},onArrayEnd:()=>{a=h.pop()},onLiteralValue:p,onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s),a[0]}e.parse=g;function m(t,n=[],s=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(u){i.type==="property"&&(i.length=u-i.offset,i=i.parent)}function h(u){return i.children.push(u),u}d(t,{onObjectBegin:u=>{i=h({type:"object",offset:u,length:-1,parent:i,children:[]})},onObjectProperty:(u,v,R)=>{i=h({type:"property",offset:v,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:u,offset:v,length:R,parent:i})},onObjectEnd:(u,v)=>{i.length=u+v-i.offset,i=i.parent,a(u+v)},onArrayBegin:(u,v)=>{i=h({type:"array",offset:u,length:-1,parent:i,children:[]})},onArrayEnd:(u,v)=>{i.length=u+v-i.offset,i=i.parent,a(u+v)},onLiteralValue:(u,v,R)=>{h({type:c(u),offset:v,length:R,parent:i,value:u}),a(v+R)},onSeparator:(u,v,R)=>{i.type==="property"&&(u===":"?i.colonOffset=v:u===","&&a(v))},onError:(u,v,R)=>{n.push({error:u,offset:v,length:R})}},s);const S=i.children[0];return S&&delete S.parent,S}e.parseTree=m;function l(t,n){if(!!t){let s=t;for(let i of n)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const h of s.children)if(Array.isArray(h.children)&&h.children[0].value===i){s=h.children[1],a=!0;break}if(!a)return}else{const a=i;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}}e.findNodeAtLocation=l;function f(t){if(!t.parent||!t.parent.children)return[];const n=f(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;n.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&n.push(s)}return n}e.getNodePath=f;function E(t){switch(t.type){case"array":return t.children.map(E);case"object":const n=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(n[s.children[0].value]=E(i))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=E;function w(t,n,s=!1){return n>=t.offset&&n<t.offset+t.length||s&&n===t.offset+t.length}e.contains=w;function _(t,n,s=!1){if(w(t,n,s)){const i=t.children;if(Array.isArray(i))for(let a=0;a<i.length&&i[a].offset<=n;a++){const h=_(i[a],n,s);if(h)return h}return t}}e.findNodeAtOffset=_;function d(t,n,s=T.DEFAULT){const i=y(t,!1);function a(le){return le?()=>le(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(le){return le?ve=>le(ve,i.getTokenOffset(),i.getTokenLength()):()=>!0}const p=a(n.onObjectBegin),S=h(n.onObjectProperty),u=a(n.onObjectEnd),v=a(n.onArrayBegin),R=a(n.onArrayEnd),N=h(n.onLiteralValue),j=h(n.onSeparator),ie=a(n.onComment),K=h(n.onError),B=s&&s.disallowComments,$=s&&s.allowTrailingComma;function U(){for(;;){const le=i.scan();switch(i.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:B||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(le){case 12:case 13:B?L(10):ie();break;case 16:L(1);break;case 15:case 14:break;default:return le}}}function L(le,ve=[],Re=[]){if(K(le),ve.length+Re.length>0){let Se=i.getToken();for(;Se!==17;){if(ve.indexOf(Se)!==-1){U();break}else if(Re.indexOf(Se)!==-1)break;Se=U()}}}function O(le){const ve=i.getTokenValue();return le?N(ve):S(ve),U(),!0}function M(){switch(i.getToken()){case 11:let le=0;try{le=JSON.parse(i.getTokenValue()),typeof le!="number"&&(L(2),le=0)}catch(ve){L(2)}N(le);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return U(),!0}function F(){return i.getToken()!==10?(L(3,[],[2,5]),!1):(O(!1),i.getToken()===6?(j(":"),U(),Q()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function W(){p(),U();let le=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(le||L(4,[],[]),j(","),U(),i.getToken()===2&&$)break}else le&&L(6,[],[]);F()||L(4,[],[2,5]),le=!0}return u(),i.getToken()!==2?L(7,[2],[]):U(),!0}function q(){v(),U();let le=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(le||L(4,[],[]),j(","),U(),i.getToken()===4&&$)break}else le&&L(6,[],[]);Q()||L(4,[],[4,5]),le=!0}return R(),i.getToken()!==4?L(8,[4],[]):U(),!0}function Q(){switch(i.getToken()){case 3:return q();case 1:return W();case 10:return O(!0);default:return M()}}return U(),i.getToken()===17?s.allowEmptyContent?!0:(L(4,[],[]),!1):Q()?(i.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=d;function o(t,n){let s=y(t),i=[],a,h=0,p;do switch(p=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:h!==p&&i.push(t.substring(h,p)),n!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,n)),h=s.getPosition();break}while(a!==17);return i.join("")}e.stripComments=o;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(me[133],ge([0,1,56]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function I(D,P,r){let C,g,m,l,f;if(P){for(l=P.offset,f=l+P.length,m=l;m>0&&!k(D,m-1);)m--;let h=f;for(;h<D.length&&!k(D,h);)h++;g=D.substring(m,h),C=T(g,r)}else g=D,C=0,m=0,l=0,f=D.length;const E=y(r,D);let w=!1,_=0,d;r.insertSpaces?d=A(" ",r.tabSize||4):d="	";const o=(0,b.createScanner)(g,!1);let c=!1;function t(){return E+A(d,C+_)}function n(){let h=o.scan();for(w=!1;h===15||h===14;)w=w||h===14,h=o.scan();return c=h===16||o.getTokenError()!==0,h}const s=[];function i(h,p,S){!c&&p<f&&S>l&&D.substring(p,S)!==h&&s.push({offset:p,length:S-p,content:h})}let a=n();if(a!==17){const h=o.getTokenOffset()+m,p=A(d,C);i(p,m,h)}for(;a!==17;){let h=o.getTokenOffset()+o.getTokenLength()+m,p=n(),S="";for(;!w&&(p===12||p===13);){const v=o.getTokenOffset()+m;i(" ",h,v),h=o.getTokenOffset()+o.getTokenLength()+m,S=p===12?t():"",p=n()}if(p===2)a!==1&&(_--,S=t());else if(p===4)a!==3&&(_--,S=t());else{switch(a){case 3:case 1:_++,S=t();break;case 5:case 12:S=t();break;case 13:w?S=t():S=" ";break;case 6:S=" ";break;case 10:if(p===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:p===12||p===13?S=" ":p!==5&&p!==17&&(c=!0);break;case 16:c=!0;break}w&&(p===12||p===13)&&(S=t())}const u=o.getTokenOffset()+m;i(S,h,u),a=p}return s}e.format=I;function A(D,P){let r="";for(let C=0;C<P;C++)r+=D;return r}function T(D,P){let r=0,C=0;const g=P.tabSize||4;for(;r<D.length;){const m=D.charAt(r);if(m===" ")C++;else if(m==="	")C+=g;else break;r++}return Math.floor(C/g)}function y(D,P){for(let r=0;r<P.length;r++){const C=P.charAt(r);if(C==="\r")return r+1<P.length&&P.charAt(r+1)===`
`?`\r
`:"\r";if(C===`
`)return`
`}return D&&D.eol||`
`}e.getEOL=y;function k(D,P){return`\r
`.indexOf(D.charAt(P))!==-1}e.isEOL=k}),define(me[134],ge([0,1,56,133]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function A(P,r,C){return T(P,r,void 0,C)}e.removeProperty=A;function T(P,r,C,g,m){const l=r.slice(),f=[],E=(0,b.parseTree)(P,f);let w,_;for(;l.length>0&&(_=l.pop(),w=(0,b.findNodeAtLocation)(E,l),w===void 0&&C!==void 0);)typeof _=="string"?C={[_]:C}:C=[C];if(w)if(w.type==="object"&&typeof _=="string"&&Array.isArray(w.children)){const d=(0,b.findNodeAtLocation)(w,[_]);if(d!==void 0)if(C===void 0){if(!d.parent)throw new Error("Malformed AST");const o=w.children.indexOf(d.parent);let c,t=d.parent.offset+d.parent.length;if(o>0){const n=w.children[o-1];c=n.offset+n.length}else c=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return y(P,{offset:c,length:t-c,content:""},g)}else return y(P,{offset:d.offset,length:d.length,content:JSON.stringify(C)},g);else{if(C===void 0)return[];const o=`${JSON.stringify(_)}: ${JSON.stringify(C)}`,c=m?m(w.children.map(n=>n.children[0].value)):w.children.length;let t;if(c>0){const n=w.children[c-1];t={offset:n.offset+n.length,length:0,content:","+o}}else w.children.length===0?t={offset:w.offset+1,length:0,content:o}:t={offset:w.offset+1,length:0,content:o+","};return y(P,t,g)}}else if(w.type==="array"&&typeof _=="number"&&Array.isArray(w.children))if(C!==void 0){const d=`${JSON.stringify(C)}`;let o;if(w.children.length===0||_===0)o={offset:w.offset+1,length:0,content:w.children.length===0?d:d+","};else{const c=_===-1||_>w.children.length?w.children.length:_,t=w.children[c-1];o={offset:t.offset+t.length,length:0,content:","+d}}return y(P,o,g)}else{const d=_,o=w.children[d];let c;if(w.children.length===1)c={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===d){const t=w.children[d-1],n=t.offset+t.length,s=w.offset+w.length;c={offset:n,length:s-2-n,content:""}}else c={offset:o.offset,length:w.children[d+1].offset-o.offset,content:""};return y(P,c,g)}else throw new Error(`Can not add ${typeof _!="number"?"index":"property"} to parent of type ${w.type}`);else{if(C===void 0)throw new Error("Can not delete in empty document");return y(P,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(C)},g)}}e.setProperty=T;function y(P,r,C){let g=k(P,r),m=r.offset,l=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;m>0&&!(0,I.isEOL)(g,m-1);)m--;for(;l<g.length&&!(0,I.isEOL)(g,l);)l++}const f=(0,I.format)(g,{offset:m,length:l-m},C);for(let w=f.length-1;w>=0;w--){const _=f[w];g=k(g,_),m=Math.min(m,_.offset),l=Math.max(l,_.offset+_.length),l+=_.content.length-_.length}const E=P.length-(g.length-l)-m;return[{offset:m,length:E,content:g.substring(m,l)}]}e.withFormatting=y;function k(P,r){return P.substring(0,r.offset)+r.content+P.substring(r.offset+r.length)}e.applyEdit=k;function D(P,r){let C=r.slice(0).sort((m,l)=>{const f=m.offset-l.offset;return f===0?m.length-l.length:f}),g=P.length;for(let m=C.length-1;m>=0;m--){let l=C[m];if(l.offset+l.length<=g)P=k(P,l);else throw new Error("Overlapping edit");g=l.offset}return P}e.applyEdits=D}),define(me[135],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(A){this.executor=A,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(A){this._error=A}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(A){return new b(()=>A(this.getValue()))}}e.Lazy=b}),define(me[6],ge([0,1,71,55]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const A=!1;let T=null;function y(d){T=d}if(e.setDisposableTracker=y,A){const d="__is_disposable_tracked__";T=new class{trackDisposable(o){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[d]||console.log(c)},3e3)}markTracked(o){if(o&&o!==f.None)try{o[d]=!0}catch(c){}}}}function k(d){!T||T.markTracked(d)}function D(d){return T&&T.trackDisposable(d),d}e.trackDisposable=D;class P extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=P;function r(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=r;function C(d){if(I.Iterable.is(d)){let o=[];for(const c of d)if(c){k(c);try{c.dispose()}catch(t){o.push(t)}}if(o.length===1)throw o[0];if(o.length>1)throw new P(o);return Array.isArray(d)?[]:d}else if(d)return k(d),d.dispose(),d}e.dispose=C;function g(...d){return d.forEach(k),m(()=>C(d))}e.combinedDisposable=g;function m(d){const o=D({dispose:()=>{k(o),d()}});return o}e.toDisposable=m;class l{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(k(this),this._isDisposed=!0,this.clear())}clear(){try{C(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return k(o),this._isDisposed?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=l,l.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new l,D(this)}dispose(){k(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class E{constructor(){this._isDisposed=!1,D(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){var c;this._isDisposed||o===this._value||((c=this._value)===null||c===void 0||c.dispose(),o&&k(o),this._value=o)}clear(){this.value=void 0}dispose(){var o;this._isDisposed=!0,k(this),(o=this._value)===null||o===void 0||o.dispose(),this._value=void 0}}e.MutableDisposable=E;class w{constructor(){this.references=new Map}acquire(o,...c){let t=this.references.get(o);t||(t={counter:0,object:this.createReferencedObject(o,...c)},this.references.set(o,t));const{object:n}=t,s=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(o,t.object),this.references.delete(o))});return t.counter++,{object:n,dispose:s}}}e.ReferenceCollection=w;class _{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=_}),define(me[57],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(T){this.element=T,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class I{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let T=this._first;for(;T!==b.Undefined;){const y=T.next;T.prev=b.Undefined,T.next=b.Undefined,T=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const k=new b(T);if(this._first===b.Undefined)this._first=k,this._last=k;else if(y){const P=this._last;this._last=k,k.prev=P,P.next=k}else{const P=this._first;this._first=k,k.next=P,P.prev=k}this._size+=1;let D=!1;return()=>{D||(D=!0,this._remove(k))}}shift(){if(this._first!==b.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==b.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==b.Undefined&&T.next!==b.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===b.Undefined&&T.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):T.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):T.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==b.Undefined;)yield T.element,T=T.next}}e.LinkedList=I}),function(G,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(G=typeof globalThis!="undefined"?globalThis:G||self,G.marked=e())}(this,function(){"use strict";function G(De,ye){for(var Pe=0;Pe<ye.length;Pe++){var oe=ye[Pe];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function e(De,ye,Pe){return ye&&G(De.prototype,ye),Pe&&G(De,Pe),De}function b(De,ye){if(!!De){if(typeof De=="string")return I(De,ye);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return I(De,ye)}}function I(De,ye){(ye==null||ye>De.length)&&(ye=De.length);for(var Pe=0,oe=new Array(ye);Pe<ye;Pe++)oe[Pe]=De[Pe];return oe}function A(De,ye){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=b(De))||ye&&De&&typeof De.length=="number"){Pe&&(De=Pe);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function T(De){var ye={exports:{}};return De(ye,ye.exports),ye.exports}var y=T(function(De){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(oe){De.exports.defaults=oe}De.exports={defaults:ye(),getDefaults:ye,changeDefaults:Pe}}),k=/[&<>"']/,D=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,C={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(ye){return C[ye]};function m(De,ye){if(ye){if(k.test(De))return De.replace(D,g)}else if(P.test(De))return De.replace(r,g);return De}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(De){return De.replace(l,function(ye,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var E=/(^|[^\[])\^/g;function w(De,ye){De=De.source||De,ye=ye||"";var Pe={replace:function(ue,H){return H=H.source||H,H=H.replace(E,"$1"),De=De.replace(ue,H),Pe},getRegex:function(){return new RegExp(De,ye)}};return Pe}var _=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function o(De,ye,Pe){if(De){var oe;try{oe=decodeURIComponent(f(Pe)).replace(_,"").toLowerCase()}catch(ue){return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}ye&&!d.test(Pe)&&(Pe=i(ye,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(ue){return null}return Pe}var c={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(De,ye){c[" "+De]||(t.test(De)?c[" "+De]=De+"/":c[" "+De]=S(De,"/",!0)),De=c[" "+De];var Pe=De.indexOf(":")===-1;return ye.substring(0,2)==="//"?Pe?ye:De.replace(n,"$1")+ye:ye.charAt(0)==="/"?Pe?ye:De.replace(s,"$1")+ye:De+ye}var a={exec:function(){}};function h(De){for(var ye=1,Pe,oe;ye<arguments.length;ye++){Pe=arguments[ye];for(oe in Pe)Object.prototype.hasOwnProperty.call(Pe,oe)&&(De[oe]=Pe[oe])}return De}function p(De,ye){var Pe=De.replace(/\|/g,function(H,Z,ce){for(var Ie=!1,Ae=Z;--Ae>=0&&ce[Ae]==="\\";)Ie=!Ie;return Ie?"|":" |"}),oe=Pe.split(/ \|/),ue=0;if(oe.length>ye)oe.splice(ye);else for(;oe.length<ye;)oe.push("");for(;ue<oe.length;ue++)oe[ue]=oe[ue].trim().replace(/\\\|/g,"|");return oe}function S(De,ye,Pe){var oe=De.length;if(oe===0)return"";for(var ue=0;ue<oe;){var H=De.charAt(oe-ue-1);if(H===ye&&!Pe)ue++;else if(H!==ye&&Pe)ue++;else break}return De.substr(0,oe-ue)}function u(De,ye){if(De.indexOf(ye[1])===-1)return-1;for(var Pe=De.length,oe=0,ue=0;ue<Pe;ue++)if(De[ue]==="\\")ue++;else if(De[ue]===ye[0])oe++;else if(De[ue]===ye[1]&&(oe--,oe<0))return ue;return-1}function v(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(De,ye){if(ye<1)return"";for(var Pe="";ye>1;)ye&1&&(Pe+=De),ye>>=1,De+=De;return Pe+De}var N={escape:m,unescape:f,edit:w,cleanUrl:o,resolveUrl:i,noopTest:a,merge:h,splitCells:p,rtrim:S,findClosingBracket:u,checkSanitizeDeprecation:v,repeatString:R},j=y.defaults,ie=N.rtrim,K=N.splitCells,B=N.escape,$=N.findClosingBracket;function U(De,ye,Pe){var oe=ye.href,ue=ye.title?B(ye.title):null,H=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:oe,title:ue,text:H}:{type:"image",raw:Pe,href:oe,title:ue,text:B(H)}}function L(De,ye){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return ye;var oe=Pe[1];return ye.split(`
`).map(function(ue){var H=ue.match(/^\s+/);if(H===null)return ue;var Z=H[0];return Z.length>=oe.length?ue.slice(oe.length):ue}).join(`
`)}var O=function(){function De(Pe){this.options=Pe||j}var ye=De.prototype;return ye.space=function(oe){var ue=this.rules.block.newline.exec(oe);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(oe){var ue=this.rules.block.code.exec(oe);if(ue){var H=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?H:ie(H,`
`)}}},ye.fences=function(oe){var ue=this.rules.block.fences.exec(oe);if(ue){var H=ue[0],Z=L(H,ue[3]||"");return{type:"code",raw:H,lang:ue[2]?ue[2].trim():ue[2],text:Z}}},ye.heading=function(oe){var ue=this.rules.block.heading.exec(oe);if(ue){var H=ue[2].trim();if(/#$/.test(H)){var Z=ie(H,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(H=Z.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:H}}},ye.nptable=function(oe){var ue=this.rules.block.nptable.exec(oe);if(ue){var H={type:"table",header:K(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(H.header.length===H.align.length){var Z=H.align.length,ce;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(Z=H.cells.length,ce=0;ce<Z;ce++)H.cells[ce]=K(H.cells[ce],H.header.length);return H}}},ye.hr=function(oe){var ue=this.rules.block.hr.exec(oe);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(oe){var ue=this.rules.block.blockquote.exec(oe);if(ue){var H=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:H}}},ye.list=function(oe){var ue=this.rules.block.list.exec(oe);if(ue){var H=ue[0],Z=ue[2],ce=Z.length>1,Ie={type:"list",raw:H,ordered:ce,start:ce?+Z.slice(0,-1):"",loose:!1,items:[]},Ae=ue[0].match(this.rules.block.item),Le=!1,$e,Xe,rt,tt,Qe,mt,wt,be,he=Ae.length;rt=this.rules.block.listItemStart.exec(Ae[0]);for(var ae=0;ae<he;ae++){if($e=Ae[ae],H=$e,ae!==he-1){if(tt=this.rules.block.listItemStart.exec(Ae[ae+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ae.splice(ae,2,Ae[ae]+`
`+Ae[ae+1]),ae--,he--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Z[Z.length-1]:ce===(tt[2].length===1))&&(Qe=Ae.slice(ae+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Qe.length),ae=he-1);rt=tt}Xe=$e.length,$e=$e.replace(/^ *([*+-]|\d+[.)]) ?/,""),~$e.indexOf(`
 `)&&(Xe-=$e.length,$e=this.options.pedantic?$e.replace(/^ {1,4}/gm,""):$e.replace(new RegExp("^ {1,"+Xe+"}","gm"),"")),mt=Le||/\n\n(?!\s*$)/.test($e),ae!==he-1&&(Le=$e.charAt($e.length-1)===`
`,mt||(mt=Le)),mt&&(Ie.loose=!0),this.options.gfm&&(wt=/^\[[ xX]\] /.test($e),be=void 0,wt&&(be=$e[1]!==" ",$e=$e.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:H,task:wt,checked:be,loose:mt,text:$e})}return Ie}},ye.html=function(oe){var ue=this.rules.block.html.exec(oe);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):B(ue[0]):ue[0]}},ye.def=function(oe){var ue=this.rules.block.def.exec(oe);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var H=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:H,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(oe){var ue=this.rules.block.table.exec(oe);if(ue){var H={type:"table",header:K(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(H.header.length===H.align.length){H.raw=ue[0];var Z=H.align.length,ce;for(ce=0;ce<Z;ce++)/^ *-+: *$/.test(H.align[ce])?H.align[ce]="right":/^ *:-+: *$/.test(H.align[ce])?H.align[ce]="center":/^ *:-+ *$/.test(H.align[ce])?H.align[ce]="left":H.align[ce]=null;for(Z=H.cells.length,ce=0;ce<Z;ce++)H.cells[ce]=K(H.cells[ce].replace(/^ *\| *| *\| *$/g,""),H.header.length);return H}}},ye.lheading=function(oe){var ue=this.rules.block.lheading.exec(oe);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(oe){var ue=this.rules.block.paragraph.exec(oe);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(oe){var ue=this.rules.block.text.exec(oe);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(oe){var ue=this.rules.inline.escape.exec(oe);if(ue)return{type:"escape",raw:ue[0],text:B(ue[1])}},ye.tag=function(oe,ue,H){var Z=this.rules.inline.tag.exec(oe);if(Z)return!ue&&/^<a /i.test(Z[0])?ue=!0:ue&&/^<\/a>/i.test(Z[0])&&(ue=!1),!H&&/^<(pre|code|kbd|script)(\s|>)/i.test(Z[0])?H=!0:H&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Z[0])&&(H=!1),{type:this.options.sanitize?"text":"html",raw:Z[0],inLink:ue,inRawBlock:H,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):B(Z[0]):Z[0]}},ye.link=function(oe){var ue=this.rules.inline.link.exec(oe);if(ue){var H=ue[2].trim();if(!this.options.pedantic&&/^</.test(H)){if(!/>$/.test(H))return;var Z=ie(H.slice(0,-1),"\\");if((H.length-Z.length)%2==0)return}else{var ce=$(ue[2],"()");if(ce>-1){var Ie=ue[0].indexOf("!")===0?5:4,Ae=Ie+ue[1].length+ce;ue[2]=ue[2].substring(0,ce),ue[0]=ue[0].substring(0,Ae).trim(),ue[3]=""}}var Le=ue[2],$e="";if(this.options.pedantic){var Xe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Le);Xe&&(Le=Xe[1],$e=Xe[3])}else $e=ue[3]?ue[3].slice(1,-1):"";return Le=Le.trim(),/^</.test(Le)&&(this.options.pedantic&&!/>$/.test(H)?Le=Le.slice(1):Le=Le.slice(1,-1)),U(ue,{href:Le&&Le.replace(this.rules.inline._escapes,"$1"),title:$e&&$e.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(oe,ue){var H;if((H=this.rules.inline.reflink.exec(oe))||(H=this.rules.inline.nolink.exec(oe))){var Z=(H[2]||H[1]).replace(/\s+/g," ");if(Z=ue[Z.toLowerCase()],!Z||!Z.href){var ce=H[0].charAt(0);return{type:"text",raw:ce,text:ce}}return U(H,Z,H[0])}},ye.emStrong=function(oe,ue,H){H===void 0&&(H="");var Z=this.rules.inline.emStrong.lDelim.exec(oe);if(!!Z&&!(Z[3]&&H.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=Z[1]||Z[2]||"";if(!ce||ce&&(H===""||this.rules.inline.punctuation.exec(H))){var Ie=Z[0].length-1,Ae,Le,$e=Ie,Xe=0,rt=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*oe.length+Ie);(Z=rt.exec(ue))!=null;)if(Ae=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Ae){if(Le=Ae.length,Z[3]||Z[4]){$e+=Le;continue}else if((Z[5]||Z[6])&&Ie%3&&!((Ie+Le)%3)){Xe+=Le;continue}if($e-=Le,!($e>0)){if($e+Xe-Le<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Le=Math.min(Le,Le+$e+Xe)),Math.min(Ie,Le)%2)return{type:"em",raw:oe.slice(0,Ie+Z.index+Le+1),text:oe.slice(1,Ie+Z.index+Le)};if(Math.min(Ie,Le)%2==0)return{type:"strong",raw:oe.slice(0,Ie+Z.index+Le+1),text:oe.slice(2,Ie+Z.index+Le-1)}}}}}},ye.codespan=function(oe){var ue=this.rules.inline.code.exec(oe);if(ue){var H=ue[2].replace(/\n/g," "),Z=/[^ ]/.test(H),ce=/^ /.test(H)&&/ $/.test(H);return Z&&ce&&(H=H.substring(1,H.length-1)),H=B(H,!0),{type:"codespan",raw:ue[0],text:H}}},ye.br=function(oe){var ue=this.rules.inline.br.exec(oe);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(oe){var ue=this.rules.inline.del.exec(oe);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(oe,ue){var H=this.rules.inline.autolink.exec(oe);if(H){var Z,ce;return H[2]==="@"?(Z=B(this.options.mangle?ue(H[1]):H[1]),ce="mailto:"+Z):(Z=B(H[1]),ce=Z),{type:"link",raw:H[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.url=function(oe,ue){var H;if(H=this.rules.inline.url.exec(oe)){var Z,ce;if(H[2]==="@")Z=B(this.options.mangle?ue(H[0]):H[0]),ce="mailto:"+Z;else{var Ie;do Ie=H[0],H[0]=this.rules.inline._backpedal.exec(H[0])[0];while(Ie!==H[0]);Z=B(H[0]),H[1]==="www."?ce="http://"+Z:ce=Z}return{type:"link",raw:H[0],text:Z,href:ce,tokens:[{type:"text",raw:Z,text:Z}]}}},ye.inlineText=function(oe,ue,H){var Z=this.rules.inline.text.exec(oe);if(Z){var ce;return ue?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Z[0]):B(Z[0]):Z[0]:ce=B(this.options.smartypants?H(Z[0]):Z[0]),{type:"text",raw:Z[0],text:ce}}},De}(),M=N.noopTest,F=N.edit,W=N.merge,q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=F(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,q.item=F(q.item,"gm").replace(/bull/g,q.bullet).getRegex(),q.listItemStart=F(/^( *)(bull)/).replace("bull",q.bullet).getRegex(),q.list=F(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=F(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=F(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.blockquote=F(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=W({},q),q.gfm=W({},q.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.nptable=F(q.gfm.nptable).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.gfm.table=F(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",q._tag).getRegex(),q.pedantic=W({},q.normal,{html:F(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:F(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Q.punctuation=F(Q.punctuation).replace(/punctuation/g,Q._punctuation).getRegex(),Q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Q.escapedEmSt=/\\\*|\\_/g,Q._comment=F(q._comment).replace("(?:-->|$)","-->").getRegex(),Q.emStrong.lDelim=F(Q.emStrong.lDelim).replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimAst=F(Q.emStrong.rDelimAst,"g").replace(/punct/g,Q._punctuation).getRegex(),Q.emStrong.rDelimUnd=F(Q.emStrong.rDelimUnd,"g").replace(/punct/g,Q._punctuation).getRegex(),Q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Q.autolink=F(Q.autolink).replace("scheme",Q._scheme).replace("email",Q._email).getRegex(),Q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Q.tag=F(Q.tag).replace("comment",Q._comment).replace("attribute",Q._attribute).getRegex(),Q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Q.link=F(Q.link).replace("label",Q._label).replace("href",Q._href).replace("title",Q._title).getRegex(),Q.reflink=F(Q.reflink).replace("label",Q._label).getRegex(),Q.reflinkSearch=F(Q.reflinkSearch,"g").replace("reflink",Q.reflink).replace("nolink",Q.nolink).getRegex(),Q.normal=W({},Q),Q.pedantic=W({},Q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:F(/^!?\[(label)\]\((.*?)\)/).replace("label",Q._label).getRegex(),reflink:F(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Q._label).getRegex()}),Q.gfm=W({},Q.normal,{escape:F(Q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Q.gfm.url=F(Q.gfm.url,"i").replace("email",Q.gfm._extended_email).getRegex(),Q.breaks=W({},Q.gfm,{br:F(Q.br).replace("{2,}","*").getRegex(),text:F(Q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var le={block:q,inline:Q},ve=y.defaults,Re=le.block,Se=le.inline,Oe=N.repeatString;function z(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(De){var ye="",Pe,oe,ue=De.length;for(Pe=0;Pe<ue;Pe++)oe=De.charCodeAt(Pe),Math.random()>.5&&(oe="x"+oe.toString(16)),ye+="&#"+oe+";";return ye}var ee=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||ve,this.options.tokenizer=this.options.tokenizer||new O,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var oe={block:Re.normal,inline:Se.normal};this.options.pedantic?(oe.block=Re.pedantic,oe.inline=Se.pedantic):this.options.gfm&&(oe.block=Re.gfm,this.options.breaks?oe.inline=Se.breaks:oe.inline=Se.gfm),this.tokenizer.rules=oe}De.lex=function(oe,ue){var H=new De(ue);return H.lex(oe)},De.lexInline=function(oe,ue){var H=new De(ue);return H.inlineTokens(oe)};var ye=De.prototype;return ye.lex=function(oe){return oe=oe.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(oe,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(oe,ue,H){ue===void 0&&(ue=[]),H===void 0&&(H=!0),this.options.pedantic&&(oe=oe.replace(/^ +$/gm,""));for(var Z,ce,Ie,Ae;oe;){if(Z=this.tokenizer.space(oe)){oe=oe.substring(Z.raw.length),Z.type&&ue.push(Z);continue}if(Z=this.tokenizer.code(oe)){oe=oe.substring(Z.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="paragraph"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):ue.push(Z);continue}if(Z=this.tokenizer.fences(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.heading(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.nptable(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.hr(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.blockquote(oe)){oe=oe.substring(Z.raw.length),Z.tokens=this.blockTokens(Z.text,[],H),ue.push(Z);continue}if(Z=this.tokenizer.list(oe)){for(oe=oe.substring(Z.raw.length),Ie=Z.items.length,ce=0;ce<Ie;ce++)Z.items[ce].tokens=this.blockTokens(Z.items[ce].text,[],!1);ue.push(Z);continue}if(Z=this.tokenizer.html(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(H&&(Z=this.tokenizer.def(oe))){oe=oe.substring(Z.raw.length),this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.lheading(oe)){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(H&&(Z=this.tokenizer.paragraph(oe))){oe=oe.substring(Z.raw.length),ue.push(Z);continue}if(Z=this.tokenizer.text(oe)){oe=oe.substring(Z.raw.length),Ae=ue[ue.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+Z.raw,Ae.text+=`
`+Z.text):ue.push(Z);continue}if(oe){var Le="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(Le);break}else throw new Error(Le)}}return ue},ye.inline=function(oe){var ue,H,Z,ce,Ie,Ae,Le=oe.length;for(ue=0;ue<Le;ue++)switch(Ae=oe[ue],Ae.type){case"paragraph":case"text":case"heading":{Ae.tokens=[],this.inlineTokens(Ae.text,Ae.tokens);break}case"table":{for(Ae.tokens={header:[],cells:[]},ce=Ae.header.length,H=0;H<ce;H++)Ae.tokens.header[H]=[],this.inlineTokens(Ae.header[H],Ae.tokens.header[H]);for(ce=Ae.cells.length,H=0;H<ce;H++)for(Ie=Ae.cells[H],Ae.tokens.cells[H]=[],Z=0;Z<Ie.length;Z++)Ae.tokens.cells[H][Z]=[],this.inlineTokens(Ie[Z],Ae.tokens.cells[H][Z]);break}case"blockquote":{this.inline(Ae.tokens);break}case"list":{for(ce=Ae.items.length,H=0;H<ce;H++)this.inline(Ae.items[H].tokens);break}}return oe},ye.inlineTokens=function(oe,ue,H,Z){ue===void 0&&(ue=[]),H===void 0&&(H=!1),Z===void 0&&(Z=!1);var ce,Ie,Ae=oe,Le,$e,Xe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Le=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)rt.includes(Le[0].slice(Le[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Le=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"["+Oe("a",Le[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Le=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Le.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;){if($e||(Xe=""),$e=!1,ce=this.tokenizer.escape(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.tag(oe,H,Z)){oe=oe.substring(ce.raw.length),H=ce.inLink,Z=ce.inRawBlock;var tt=ue[ue.length-1];tt&&ce.type==="text"&&tt.type==="text"?(tt.raw+=ce.raw,tt.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.link(oe)){oe=oe.substring(ce.raw.length),ce.type==="link"&&(ce.tokens=this.inlineTokens(ce.text,[],!0,Z)),ue.push(ce);continue}if(ce=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ce.raw.length);var Qe=ue[ue.length-1];ce.type==="link"?(ce.tokens=this.inlineTokens(ce.text,[],!0,Z),ue.push(ce)):Qe&&ce.type==="text"&&Qe.type==="text"?(Qe.raw+=ce.raw,Qe.text+=ce.text):ue.push(ce);continue}if(ce=this.tokenizer.emStrong(oe,Ae,Xe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,Z),ue.push(ce);continue}if(ce=this.tokenizer.codespan(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.br(oe)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.del(oe)){oe=oe.substring(ce.raw.length),ce.tokens=this.inlineTokens(ce.text,[],H,Z),ue.push(ce);continue}if(ce=this.tokenizer.autolink(oe,Y)){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(!H&&(ce=this.tokenizer.url(oe,Y))){oe=oe.substring(ce.raw.length),ue.push(ce);continue}if(ce=this.tokenizer.inlineText(oe,Z,z)){oe=oe.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(Xe=ce.raw.slice(-1)),$e=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=ce.raw,Ie.text+=ce.text):ue.push(ce);continue}if(oe){var mt="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return ue},e(De,null,[{key:"rules",get:function(){return{block:Re,inline:Se}}}]),De}(),se=y.defaults,fe=N.cleanUrl,Ee=N.escape,Be=function(){function De(Pe){this.options=Pe||se}var ye=De.prototype;return ye.code=function(oe,ue,H){var Z=(ue||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(oe,Z);ce!=null&&ce!==oe&&(H=!0,oe=ce)}return oe=oe.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+Ee(Z,!0)+'">'+(H?oe:Ee(oe,!0))+`</code></pre>
`:"<pre><code>"+(H?oe:Ee(oe,!0))+`</code></pre>
`},ye.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},ye.html=function(oe){return oe},ye.heading=function(oe,ue,H,Z){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+Z.slug(H)+'">'+oe+"</h"+ue+`>
`:"<h"+ue+">"+oe+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(oe,ue,H){var Z=ue?"ol":"ul",ce=ue&&H!==1?' start="'+H+'"':"";return"<"+Z+ce+`>
`+oe+"</"+Z+`>
`},ye.listitem=function(oe){return"<li>"+oe+`</li>
`},ye.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(oe){return"<p>"+oe+`</p>
`},ye.table=function(oe,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ue+`</table>
`},ye.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},ye.tablecell=function(oe,ue){var H=ue.header?"th":"td",Z=ue.align?"<"+H+' align="'+ue.align+'">':"<"+H+">";return Z+oe+"</"+H+`>
`},ye.strong=function(oe){return"<strong>"+oe+"</strong>"},ye.em=function(oe){return"<em>"+oe+"</em>"},ye.codespan=function(oe){return"<code>"+oe+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(oe){return"<del>"+oe+"</del>"},ye.link=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var Z='<a href="'+Ee(oe)+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=">"+H+"</a>",Z},ye.image=function(oe,ue,H){if(oe=fe(this.options.sanitize,this.options.baseUrl,oe),oe===null)return H;var Z='<img src="'+oe+'" alt="'+H+'"';return ue&&(Z+=' title="'+ue+'"'),Z+=this.options.xhtml?"/>":">",Z},ye.text=function(oe){return oe},De}(),pe=function(){function De(){}var ye=De.prototype;return ye.strong=function(oe){return oe},ye.em=function(oe){return oe},ye.codespan=function(oe){return oe},ye.del=function(oe){return oe},ye.html=function(oe){return oe},ye.text=function(oe){return oe},ye.link=function(oe,ue,H){return""+H},ye.image=function(oe,ue,H){return""+H},ye.br=function(){return""},De}(),Ce=function(){function De(){this.seen={}}var ye=De.prototype;return ye.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(oe,ue){var H=oe,Z=0;if(this.seen.hasOwnProperty(H)){Z=this.seen[oe];do Z++,H=oe+"-"+Z;while(this.seen.hasOwnProperty(H))}return ue||(this.seen[oe]=Z,this.seen[H]=0),H},ye.slug=function(oe,ue){ue===void 0&&(ue={});var H=this.serialize(oe);return this.getNextSafeSlug(H,ue.dryrun)},De}(),Me=y.defaults,ze=N.unescape,_e=function(){function De(Pe){this.options=Pe||Me,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ce}De.parse=function(oe,ue){var H=new De(ue);return H.parse(oe)},De.parseInline=function(oe,ue){var H=new De(ue);return H.parseInline(oe)};var ye=De.prototype;return ye.parse=function(oe,ue){ue===void 0&&(ue=!0);var H="",Z,ce,Ie,Ae,Le,$e,Xe,rt,tt,Qe,mt,wt,be,he,ae,J,Ne,Fe,Ye=oe.length;for(Z=0;Z<Ye;Z++)switch(Qe=oe[Z],Qe.type){case"space":continue;case"hr":{H+=this.renderer.hr();continue}case"heading":{H+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,ze(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{H+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Xe="",Ae=Qe.header.length,ce=0;ce<Ae;ce++)Xe+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ce]),{header:!0,align:Qe.align[ce]});for(rt+=this.renderer.tablerow(Xe),tt="",Ae=Qe.cells.length,ce=0;ce<Ae;ce++){for($e=Qe.tokens.cells[ce],Xe="",Le=$e.length,Ie=0;Ie<Le;Ie++)Xe+=this.renderer.tablecell(this.parseInline($e[Ie]),{header:!1,align:Qe.align[Ie]});tt+=this.renderer.tablerow(Xe)}H+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),H+=this.renderer.blockquote(tt);continue}case"list":{for(mt=Qe.ordered,wt=Qe.start,be=Qe.loose,Ae=Qe.items.length,tt="",ce=0;ce<Ae;ce++)ae=Qe.items[ce],J=ae.checked,Ne=ae.task,he="",ae.task&&(Fe=this.renderer.checkbox(J),be?ae.tokens.length>0&&ae.tokens[0].type==="text"?(ae.tokens[0].text=Fe+" "+ae.tokens[0].text,ae.tokens[0].tokens&&ae.tokens[0].tokens.length>0&&ae.tokens[0].tokens[0].type==="text"&&(ae.tokens[0].tokens[0].text=Fe+" "+ae.tokens[0].tokens[0].text)):ae.tokens.unshift({type:"text",text:Fe}):he+=Fe),he+=this.parse(ae.tokens,be),tt+=this.renderer.listitem(he,Ne,J);H+=this.renderer.list(tt,mt,wt);continue}case"html":{H+=this.renderer.html(Qe.text);continue}case"paragraph":{H+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Z+1<Ye&&oe[Z+1].type==="text";)Qe=oe[++Z],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);H+=ue?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return H},ye.parseInline=function(oe,ue){ue=ue||this.renderer;var H="",Z,ce,Ie=oe.length;for(Z=0;Z<Ie;Z++)switch(ce=oe[Z],ce.type){case"escape":{H+=ue.text(ce.text);break}case"html":{H+=ue.html(ce.text);break}case"link":{H+=ue.link(ce.href,ce.title,this.parseInline(ce.tokens,ue));break}case"image":{H+=ue.image(ce.href,ce.title,ce.text);break}case"strong":{H+=ue.strong(this.parseInline(ce.tokens,ue));break}case"em":{H+=ue.em(this.parseInline(ce.tokens,ue));break}case"codespan":{H+=ue.codespan(ce.text);break}case"br":{H+=ue.br();break}case"del":{H+=ue.del(this.parseInline(ce.tokens,ue));break}case"text":{H+=ue.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}return H},De}(),Ke=N.merge,X=N.checkSanitizeDeprecation,ne=N.escape,we=y.getDefaults,xe=y.changeDefaults,je=y.defaults;function Ve(De,ye,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof ye=="function"&&(Pe=ye,ye=null),ye=Ke({},Ve.defaults,ye||{}),X(ye),Pe){var oe=ye.highlight,ue;try{ue=ee.lex(De,ye)}catch(Ie){return Pe(Ie)}var H=function(Ae){var Le;if(!Ae)try{Le=_e.parse(ue,ye)}catch($e){Ae=$e}return ye.highlight=oe,Ae?Pe(Ae):Pe(null,Le)};if(!oe||oe.length<3||(delete ye.highlight,!ue.length))return H();var Z=0;Ve.walkTokens(ue,function(Ie){Ie.type==="code"&&(Z++,setTimeout(function(){oe(Ie.text,Ie.lang,function(Ae,Le){if(Ae)return H(Ae);Le!=null&&Le!==Ie.text&&(Ie.text=Le,Ie.escaped=!0),Z--,Z===0&&H()})},0))}),Z===0&&H();return}try{var ce=ee.lex(De,ye);return ye.walkTokens&&Ve.walkTokens(ce,ye.walkTokens),_e.parse(ce,ye)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(Ie.message+"",!0)+"</pre>";throw Ie}}Ve.options=Ve.setOptions=function(De){return Ke(Ve.defaults,De),xe(Ve.defaults),Ve},Ve.getDefaults=we,Ve.defaults=je,Ve.use=function(De){var ye=Ke({},De);if(De.renderer&&function(){var oe=Ve.defaults.renderer||new Be,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.renderer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var H in De.renderer)ue(H);ye.renderer=oe}(),De.tokenizer&&function(){var oe=Ve.defaults.tokenizer||new O,ue=function(ce){var Ie=oe[ce];oe[ce]=function(){for(var Ae=arguments.length,Le=new Array(Ae),$e=0;$e<Ae;$e++)Le[$e]=arguments[$e];var Xe=De.tokenizer[ce].apply(oe,Le);return Xe===!1&&(Xe=Ie.apply(oe,Le)),Xe}};for(var H in De.tokenizer)ue(H);ye.tokenizer=oe}(),De.walkTokens){var Pe=Ve.defaults.walkTokens;ye.walkTokens=function(oe){De.walkTokens(oe),Pe&&Pe(oe)}}Ve.setOptions(ye)},Ve.walkTokens=function(De,ye){for(var Pe=A(De),oe;!(oe=Pe()).done;){var ue=oe.value;switch(ye(ue),ue.type){case"table":{for(var H=A(ue.tokens.header),Z;!(Z=H()).done;){var ce=Z.value;Ve.walkTokens(ce,ye)}for(var Ie=A(ue.tokens.cells),Ae;!(Ae=Ie()).done;)for(var Le=Ae.value,$e=A(Le),Xe;!(Xe=$e()).done;){var rt=Xe.value;Ve.walkTokens(rt,ye)}break}case"list":{Ve.walkTokens(ue.items,ye);break}default:ue.tokens&&Ve.walkTokens(ue.tokens,ye)}}},Ve.parseInline=function(De,ye){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");ye=Ke({},Ve.defaults,ye||{}),X(ye);try{var Pe=ee.lexInline(De,ye);return ye.walkTokens&&Ve.walkTokens(Pe,ye.walkTokens),_e.parseInline(Pe,ye)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+ne(oe.message+"",!0)+"</pre>";throw oe}},Ve.Parser=_e,Ve.parser=_e.parse,Ve.Renderer=Be,Ve.TextRenderer=pe,Ve.Lexer=ee,Ve.lexer=ee.lex,Ve.Tokenizer=O,Ve.Slugger=Ce,Ve.parse=Ve;var Ze=Ve;return Ze}),define(me[73],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,k,D){return Math.min(Math.max(y,k),D)}e.clamp=b;function I(y,k){return(k+y%k)%k}e.rot=I;class A{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=A;class T{constructor(){this._n=1,this._val=0}update(k){return this._val=this._val+(k-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function G(A){const T=[];typeof A=="number"&&T.push("code/timeOrigin",A);function y(D){T.push(D,Date.now())}function k(){const D=[];for(let P=0;P<T.length;P+=2)D.push({name:T[P],startTime:T[P+1]});return D}return{mark:y,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(A+y.startTime)});return T}};if(typeof process=="object"){const A=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function b(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var I;typeof global=="object"?I=global:typeof self=="object"?I=self:I={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(I)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(I):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),I.perf=b(I))})(),define(me[10],ge([0,1]),function(G,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const I="en";let A=!1,T=!1,y=!1,k=!1,D=!1,P=!1,r=!1,C,g=I,m,l;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const E=typeof((b=f==null?void 0:f.versions)===null||b===void 0?void 0:b.electron)=="string"&&f.type==="renderer";if(e.isElectronSandboxed=E&&(f==null?void 0:f.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=f==null?void 0:f.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!E)l=navigator.userAgent,A=l.indexOf("Windows")>=0,T=l.indexOf("Macintosh")>=0,r=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=l.indexOf("Linux")>=0,P=!0,C=navigator.language,g=C;else if(typeof f=="object"){A=f.platform==="win32",T=f.platform==="darwin",y=f.platform==="linux",k=y&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,C=I,g=I;const i=f.env.VSCODE_NLS_CONFIG;if(i)try{const a=JSON.parse(i),h=a.availableLanguages["*"];C=a.locale,g=h||I,m=a._translationsConfigFile}catch(a){}D=!0}else console.error("Unable to resolve platform.");var w;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function _(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=_;let d=0;T?d=1:A?d=3:y&&(d=2),e.isWindows=A,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=k,e.isNative=D,e.isWeb=P,e.isIOS=r,e.platform=d,e.userAgent=l,e.language=g;var o;(function(i){function a(){return e.language}i.value=a;function h(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=h;function p(){return e.language==="en"}i.isDefault=p})(o=e.Language||(e.Language={})),e.locale=C,e.translationsConfigFile=m,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let h=[];e.globals.addEventListener("message",S=>{if(S.data&&S.data.vscodeSetImmediateId)for(let u=0,v=h.length;u<v;u++){const R=h[u];if(R.id===S.data.vscodeSetImmediateId){h.splice(u,1),R.callback();return}}});let p=0;return S=>{const u=++p;h.push({id:u,callback:S}),e.globals.postMessage({vscodeSetImmediateId:u},"*")}}if(typeof(f==null?void 0:f.nextTick)=="function")return f.nextTick.bind(f);const a=Promise.resolve();return h=>a.then(h)}();var c;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(c=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||r?2:A?1:3;let t=!0,n=!1;function s(){if(!n){n=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(me[36],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let I;if(typeof b.globals.vscode!="undefined"){const A=b.globals.vscode.process;I={get platform(){return A.platform},get env(){return A.env},cwd(){return A.cwd()},nextTick(T){return(0,b.setImmediate)(T)}}}else typeof process!="undefined"?I={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(A){return process.nextTick(A)}}:I={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(A){return(0,b.setImmediate)(A)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=I.cwd,e.env=I.env,e.platform=I.platform,e.nextTick=I.nextTick}),define(me[8],ge([0,1,36]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const I=65,A=97,T=90,y=122,k=46,D=47,P=92,r=58,C=63;class g extends Error{constructor(o,c,t){let n;typeof c=="string"&&c.indexOf("not ")===0?(n="must not be",c=c.replace(/^not /,"")):n="must be";const s=o.indexOf(".")!==-1?"property":"argument";let i=`The "${o}" ${s} ${n} of type ${c}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function m(d,o){if(typeof d!="string")throw new g(o,"string",d)}function l(d){return d===D||d===P}function f(d){return d===D}function E(d){return d>=I&&d<=T||d>=A&&d<=y}function w(d,o,c,t){let n="",s=0,i=-1,a=0,h=0;for(let p=0;p<=d.length;++p){if(p<d.length)h=d.charCodeAt(p);else{if(t(h))break;h=D}if(t(h)){if(!(i===p-1||a===1))if(a===2){if(n.length<2||s!==2||n.charCodeAt(n.length-1)!==k||n.charCodeAt(n.length-2)!==k){if(n.length>2){const S=n.lastIndexOf(c);S===-1?(n="",s=0):(n=n.slice(0,S),s=n.length-1-n.lastIndexOf(c)),i=p,a=0;continue}else if(n.length!==0){n="",s=0,i=p,a=0;continue}}o&&(n+=n.length>0?`${c}..`:"..",s=2)}else n.length>0?n+=`${c}${d.slice(i+1,p)}`:n=d.slice(i+1,p),s=p-i-1;i=p,a=0}else h===k&&a!==-1?++a:a=-1}return n}function _(d,o){if(o===null||typeof o!="object")throw new g("pathObject","Object",o);const c=o.dir||o.root,t=o.base||`${o.name||""}${o.ext||""}`;return c?c===o.root?`${c}${t}`:`${c}${d}${t}`:t}e.win32={resolve(...d){let o="",c="",t=!1;for(let n=d.length-1;n>=-1;n--){let s;if(n>=0){if(s=d[n],m(s,"path"),s.length===0)continue}else o.length===0?s=b.cwd():(s=b.env[`=${o}`]||b.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==o.toLowerCase()&&s.charCodeAt(2)===P)&&(s=`${o}\\`));const i=s.length;let a=0,h="",p=!1;const S=s.charCodeAt(0);if(i===1)l(S)&&(a=1,p=!0);else if(l(S))if(p=!0,l(s.charCodeAt(1))){let u=2,v=u;for(;u<i&&!l(s.charCodeAt(u));)u++;if(u<i&&u!==v){const R=s.slice(v,u);for(v=u;u<i&&l(s.charCodeAt(u));)u++;if(u<i&&u!==v){for(v=u;u<i&&!l(s.charCodeAt(u));)u++;(u===i||u!==v)&&(h=`\\\\${R}\\${s.slice(v,u)}`,a=u)}}}else a=1;else E(S)&&s.charCodeAt(1)===r&&(h=s.slice(0,2),a=2,i>2&&l(s.charCodeAt(2))&&(p=!0,a=3));if(h.length>0)if(o.length>0){if(h.toLowerCase()!==o.toLowerCase())continue}else o=h;if(t){if(o.length>0)break}else if(c=`${s.slice(a)}\\${c}`,t=p,p&&o.length>0)break}return c=w(c,!t,"\\",l),t?`${o}\\${c}`:`${o}${c}`||"."},normalize(d){m(d,"path");const o=d.length;if(o===0)return".";let c=0,t,n=!1;const s=d.charCodeAt(0);if(o===1)return f(s)?"\\":d;if(l(s))if(n=!0,l(d.charCodeAt(1))){let a=2,h=a;for(;a<o&&!l(d.charCodeAt(a));)a++;if(a<o&&a!==h){const p=d.slice(h,a);for(h=a;a<o&&l(d.charCodeAt(a));)a++;if(a<o&&a!==h){for(h=a;a<o&&!l(d.charCodeAt(a));)a++;if(a===o)return`\\\\${p}\\${d.slice(h)}\\`;a!==h&&(t=`\\\\${p}\\${d.slice(h,a)}`,c=a)}}}else c=1;else E(s)&&d.charCodeAt(1)===r&&(t=d.slice(0,2),c=2,o>2&&l(d.charCodeAt(2))&&(n=!0,c=3));let i=c<o?w(d.slice(c),!n,"\\",l):"";return i.length===0&&!n&&(i="."),i.length>0&&l(d.charCodeAt(o-1))&&(i+="\\"),t===void 0?n?`\\${i}`:i:n?`${t}\\${i}`:`${t}${i}`},isAbsolute(d){m(d,"path");const o=d.length;if(o===0)return!1;const c=d.charCodeAt(0);return l(c)||o>2&&E(c)&&d.charCodeAt(1)===r&&l(d.charCodeAt(2))},join(...d){if(d.length===0)return".";let o,c;for(let s=0;s<d.length;++s){const i=d[s];m(i,"path"),i.length>0&&(o===void 0?o=c=i:o+=`\\${i}`)}if(o===void 0)return".";let t=!0,n=0;if(typeof c=="string"&&l(c.charCodeAt(0))){++n;const s=c.length;s>1&&l(c.charCodeAt(1))&&(++n,s>2&&(l(c.charCodeAt(2))?++n:t=!1))}if(t){for(;n<o.length&&l(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.win32.normalize(o)},relative(d,o){if(m(d,"from"),m(o,"to"),d===o)return"";const c=e.win32.resolve(d),t=e.win32.resolve(o);if(c===t||(d=c.toLowerCase(),o=t.toLowerCase(),d===o))return"";let n=0;for(;n<d.length&&d.charCodeAt(n)===P;)n++;let s=d.length;for(;s-1>n&&d.charCodeAt(s-1)===P;)s--;const i=s-n;let a=0;for(;a<o.length&&o.charCodeAt(a)===P;)a++;let h=o.length;for(;h-1>a&&o.charCodeAt(h-1)===P;)h--;const p=h-a,S=i<p?i:p;let u=-1,v=0;for(;v<S;v++){const N=d.charCodeAt(n+v);if(N!==o.charCodeAt(a+v))break;N===P&&(u=v)}if(v!==S){if(u===-1)return t}else{if(p>S){if(o.charCodeAt(a+v)===P)return t.slice(a+v+1);if(v===2)return t.slice(a+v)}i>S&&(d.charCodeAt(n+v)===P?u=v:v===2&&(u=3)),u===-1&&(u=0)}let R="";for(v=n+u+1;v<=s;++v)(v===s||d.charCodeAt(v)===P)&&(R+=R.length===0?"..":"\\..");return a+=u,R.length>0?`${R}${t.slice(a,h)}`:(t.charCodeAt(a)===P&&++a,t.slice(a,h))},toNamespacedPath(d){if(typeof d!="string")return d;if(d.length===0)return"";const o=e.win32.resolve(d);if(o.length<=2)return d;if(o.charCodeAt(0)===P){if(o.charCodeAt(1)===P){const c=o.charCodeAt(2);if(c!==C&&c!==k)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(E(o.charCodeAt(0))&&o.charCodeAt(1)===r&&o.charCodeAt(2)===P)return`\\\\?\\${o}`;return d},dirname(d){m(d,"path");const o=d.length;if(o===0)return".";let c=-1,t=0;const n=d.charCodeAt(0);if(o===1)return l(n)?d:".";if(l(n)){if(c=t=1,l(d.charCodeAt(1))){let a=2,h=a;for(;a<o&&!l(d.charCodeAt(a));)a++;if(a<o&&a!==h){for(h=a;a<o&&l(d.charCodeAt(a));)a++;if(a<o&&a!==h){for(h=a;a<o&&!l(d.charCodeAt(a));)a++;if(a===o)return d;a!==h&&(c=t=a+1)}}}}else E(n)&&d.charCodeAt(1)===r&&(c=o>2&&l(d.charCodeAt(2))?3:2,t=c);let s=-1,i=!0;for(let a=o-1;a>=t;--a)if(l(d.charCodeAt(a))){if(!i){s=a;break}}else i=!1;if(s===-1){if(c===-1)return".";s=c}return d.slice(0,s)},basename(d,o){o!==void 0&&m(o,"ext"),m(d,"path");let c=0,t=-1,n=!0,s;if(d.length>=2&&E(d.charCodeAt(0))&&d.charCodeAt(1)===r&&(c=2),o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let i=o.length-1,a=-1;for(s=d.length-1;s>=c;--s){const h=d.charCodeAt(s);if(l(h)){if(!n){c=s+1;break}}else a===-1&&(n=!1,a=s+1),i>=0&&(h===o.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=d.length),d.slice(c,t)}for(s=d.length-1;s>=c;--s)if(l(d.charCodeAt(s))){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(c,t)},extname(d){m(d,"path");let o=0,c=-1,t=0,n=-1,s=!0,i=0;d.length>=2&&d.charCodeAt(1)===r&&E(d.charCodeAt(0))&&(o=t=2);for(let a=d.length-1;a>=o;--a){const h=d.charCodeAt(a);if(l(h)){if(!s){t=a+1;break}continue}n===-1&&(s=!1,n=a+1),h===k?c===-1?c=a:i!==1&&(i=1):c!==-1&&(i=-1)}return c===-1||n===-1||i===0||i===1&&c===n-1&&c===t+1?"":d.slice(c,n)},format:_.bind(null,"\\"),parse(d){m(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const c=d.length;let t=0,n=d.charCodeAt(0);if(c===1)return l(n)?(o.root=o.dir=d,o):(o.base=o.name=d,o);if(l(n)){if(t=1,l(d.charCodeAt(1))){let u=2,v=u;for(;u<c&&!l(d.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&l(d.charCodeAt(u));)u++;if(u<c&&u!==v){for(v=u;u<c&&!l(d.charCodeAt(u));)u++;u===c?t=u:u!==v&&(t=u+1)}}}}else if(E(n)&&d.charCodeAt(1)===r){if(c<=2)return o.root=o.dir=d,o;if(t=2,l(d.charCodeAt(2))){if(c===3)return o.root=o.dir=d,o;t=3}}t>0&&(o.root=d.slice(0,t));let s=-1,i=t,a=-1,h=!0,p=d.length-1,S=0;for(;p>=t;--p){if(n=d.charCodeAt(p),l(n)){if(!h){i=p+1;break}continue}a===-1&&(h=!1,a=p+1),n===k?s===-1?s=p:S!==1&&(S=1):s!==-1&&(S=-1)}return a!==-1&&(s===-1||S===0||S===1&&s===a-1&&s===i+1?o.base=o.name=d.slice(i,a):(o.name=d.slice(i,s),o.base=d.slice(i,a),o.ext=d.slice(s,a))),i>0&&i!==t?o.dir=d.slice(0,i-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...d){let o="",c=!1;for(let t=d.length-1;t>=-1&&!c;t--){const n=t>=0?d[t]:b.cwd();m(n,"path"),n.length!==0&&(o=`${n}/${o}`,c=n.charCodeAt(0)===D)}return o=w(o,!c,"/",f),c?`/${o}`:o.length>0?o:"."},normalize(d){if(m(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===D,c=d.charCodeAt(d.length-1)===D;return d=w(d,!o,"/",f),d.length===0?o?"/":c?"./":".":(c&&(d+="/"),o?`/${d}`:d)},isAbsolute(d){return m(d,"path"),d.length>0&&d.charCodeAt(0)===D},join(...d){if(d.length===0)return".";let o;for(let c=0;c<d.length;++c){const t=d[c];m(t,"path"),t.length>0&&(o===void 0?o=t:o+=`/${t}`)}return o===void 0?".":e.posix.normalize(o)},relative(d,o){if(m(d,"from"),m(o,"to"),d===o||(d=e.posix.resolve(d),o=e.posix.resolve(o),d===o))return"";const c=1,t=d.length,n=t-c,s=1,i=o.length-s,a=n<i?n:i;let h=-1,p=0;for(;p<a;p++){const u=d.charCodeAt(c+p);if(u!==o.charCodeAt(s+p))break;u===D&&(h=p)}if(p===a)if(i>a){if(o.charCodeAt(s+p)===D)return o.slice(s+p+1);if(p===0)return o.slice(s+p)}else n>a&&(d.charCodeAt(c+p)===D?h=p:p===0&&(h=0));let S="";for(p=c+h+1;p<=t;++p)(p===t||d.charCodeAt(p)===D)&&(S+=S.length===0?"..":"/..");return`${S}${o.slice(s+h)}`},toNamespacedPath(d){return d},dirname(d){if(m(d,"path"),d.length===0)return".";const o=d.charCodeAt(0)===D;let c=-1,t=!0;for(let n=d.length-1;n>=1;--n)if(d.charCodeAt(n)===D){if(!t){c=n;break}}else t=!1;return c===-1?o?"/":".":o&&c===1?"//":d.slice(0,c)},basename(d,o){o!==void 0&&m(o,"ext"),m(d,"path");let c=0,t=-1,n=!0,s;if(o!==void 0&&o.length>0&&o.length<=d.length){if(o===d)return"";let i=o.length-1,a=-1;for(s=d.length-1;s>=0;--s){const h=d.charCodeAt(s);if(h===D){if(!n){c=s+1;break}}else a===-1&&(n=!1,a=s+1),i>=0&&(h===o.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=a))}return c===t?t=a:t===-1&&(t=d.length),d.slice(c,t)}for(s=d.length-1;s>=0;--s)if(d.charCodeAt(s)===D){if(!n){c=s+1;break}}else t===-1&&(n=!1,t=s+1);return t===-1?"":d.slice(c,t)},extname(d){m(d,"path");let o=-1,c=0,t=-1,n=!0,s=0;for(let i=d.length-1;i>=0;--i){const a=d.charCodeAt(i);if(a===D){if(!n){c=i+1;break}continue}t===-1&&(n=!1,t=i+1),a===k?o===-1?o=i:s!==1&&(s=1):o!==-1&&(s=-1)}return o===-1||t===-1||s===0||s===1&&o===t-1&&o===c+1?"":d.slice(o,t)},format:_.bind(null,"/"),parse(d){m(d,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(d.length===0)return o;const c=d.charCodeAt(0)===D;let t;c?(o.root="/",t=1):t=0;let n=-1,s=0,i=-1,a=!0,h=d.length-1,p=0;for(;h>=t;--h){const S=d.charCodeAt(h);if(S===D){if(!a){s=h+1;break}continue}i===-1&&(a=!1,i=h+1),S===k?n===-1?n=h:p!==1&&(p=1):n!==-1&&(p=-1)}if(i!==-1){const S=s===0&&c?1:s;n===-1||p===0||p===1&&n===i-1&&n===s+1?o.base=o.name=d.slice(S,i):(o.name=d.slice(S,n),o.base=d.slice(S,i),o.ext=d.slice(n,i))}return s>0?o.dir=d.slice(0,s-1):c&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(me[95],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var b;(function(T){T[T.stdout=0]="stdout",T[T.stderr=1]="stderr"})(b=e.Source||(e.Source={}));var I;(function(T){T[T.Success=0]="Success",T[T.Unknown=1]="Unknown",T[T.AccessDenied=2]="AccessDenied",T[T.ProcessNotFound=3]="ProcessNotFound"})(I=e.TerminateResponseCode||(e.TerminateResponseCode={}));function A(T,...y){const k=y.reduce((r,C)=>(r[C]=!0,r),{}),D=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(T).filter(r=>!k[r]).forEach(r=>{for(let C=0;C<D.length;C++)if(r.search(D[C])!==-1){delete T[r];break}})}e.sanitizeProcessEnvironment=A}),define(me[47],ge([0,1,10]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const I=b.globals.performance&&typeof b.globals.performance.now=="function";class A{constructor(y){this._highResolution=I&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new A(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=A}),define(me[3],ge([0,1,17,71,6,57,47]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var k;(function(w){w.None=()=>A.Disposable.None;function _(K){return(B,$=null,U)=>{let L=!1,O;return O=K(M=>{if(!L)return O?O.dispose():L=!0,B.call($,M)},null,U),L&&O.dispose(),O}}w.once=_;function d(K,B){return i(($,U=null,L)=>K(O=>$.call(U,B(O)),null,L))}w.map=d;function o(K,B){return i(($,U=null,L)=>K(O=>{B(O),$.call(U,O)},null,L))}w.forEach=o;function c(K,B){return i(($,U=null,L)=>K(O=>B(O)&&$.call(U,O),null,L))}w.filter=c;function t(K){return K}w.signal=t;function n(...K){return(B,$=null,U)=>(0,A.combinedDisposable)(...K.map(L=>L(O=>B.call($,O),null,U)))}w.any=n;function s(K,B,$){let U=$;return d(K,L=>(U=B(U,L),U))}w.reduce=s;function i(K){let B;const $=new g({onFirstListenerAdd(){B=K($.fire,$)},onLastListenerRemove(){B.dispose()}});return $.event}w.snapshot=i;function a(K,B,$=100,U=!1,L){let O,M,F,W=0;const q=new g({leakWarningThreshold:L,onFirstListenerAdd(){O=K(Q=>{W++,M=B(M,Q),U&&!F&&(q.fire(M),M=void 0),clearTimeout(F),F=setTimeout(()=>{const le=M;M=void 0,F=void 0,(!U||W>1)&&q.fire(le),W=0},$)})},onLastListenerRemove(){O.dispose()}});return q.event}w.debounce=a;function h(K){const B=new Date().getTime();return d(_(K),$=>new Date().getTime()-B)}w.stopwatch=h;function p(K){let B=!0,$;return c(K,U=>{const L=B||U!==$;return B=!1,$=U,L})}w.latch=p;function S(K,B=!1,$=[]){let U=$.slice(),L=K(F=>{U?U.push(F):M.fire(F)});const O=()=>{U&&U.forEach(F=>M.fire(F)),U=null},M=new g({onFirstListenerAdd(){L||(L=K(F=>M.fire(F)))},onFirstListenerDidAdd(){U&&(B?setTimeout(O):O())},onLastListenerRemove(){L&&L.dispose(),L=null}});return M.event}w.buffer=S;class u{constructor(B){this.event=B}map(B){return new u(d(this.event,B))}forEach(B){return new u(o(this.event,B))}filter(B){return new u(c(this.event,B))}reduce(B,$){return new u(s(this.event,B,$))}latch(){return new u(p(this.event))}debounce(B,$=100,U=!1,L){return new u(a(this.event,B,$,U,L))}on(B,$,U){return this.event(B,$,U)}once(B,$,U){return _(this.event)(B,$,U)}}function v(K){return new u(K)}w.chain=v;function R(K,B,$=U=>U){const U=(...F)=>M.fire($(...F)),L=()=>K.on(B,U),O=()=>K.removeListener(B,U),M=new g({onFirstListenerAdd:L,onLastListenerRemove:O});return M.event}w.fromNodeEventEmitter=R;function N(K,B,$=U=>U){const U=(...F)=>M.fire($(...F)),L=()=>K.addEventListener(B,U),O=()=>K.removeEventListener(B,U),M=new g({onFirstListenerAdd:L,onLastListenerRemove:O});return M.event}w.fromDOMEventEmitter=N;function j(K){const B=new g;let $=!1;return K.then(void 0,()=>null).then(()=>{$?B.fire(void 0):setTimeout(()=>B.fire(void 0),0)}),$=!0,B.event}w.fromPromise=j;function ie(K){return new Promise(B=>_(K)(B))}w.toPromise=ie})(k=e.Event||(e.Event={}));class D{constructor(_){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${_}_${D._idPool++}`}start(_){this._stopWatch=new y.StopWatch(!0),this._listenerCount=_}stop(){if(this._stopWatch){const _=this._stopWatch.elapsed();this._elapsedOverall+=_,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${_.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}D._idPool=0;let P=-1;function r(w){const _=P;return P=w,{dispose(){P=_}}}e.setGlobalLeakWarningThreshold=r;class C{constructor(_,d=Math.random().toString(18).slice(2,5)){this.customThreshold=_,this.name=d,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(_){let d=P;if(typeof this.customThreshold=="number"&&(d=this.customThreshold),!(d<=0||_<d)){this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),c=this._stacks.get(o)||0;if(this._stacks.set(o,c+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=d*.5;let t,n=0;for(const[s,i]of this._stacks)(!t||n<i)&&(t=s,n=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${_} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(o)||0;this._stacks.set(o,t-1)}}}}class g{constructor(_){var d;this._disposed=!1,this._options=_,this._leakageMon=P>0?new C(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((d=this._options)===null||d===void 0?void 0:d._profName)?new D(this._options._profName):void 0}get event(){return this._event||(this._event=(_,d,o)=>{var c;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(d?[_,d]:_);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,_,d);const s=(c=this._leakageMon)===null||c===void 0?void 0:c.check(this._listeners.size);let i;return i={dispose:()=>{s&&s(),i.dispose=g._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},o instanceof A.DisposableStore?o.add(i):Array.isArray(o)&&o.push(i),i}),this._event}fire(_){var d,o;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let c of this._listeners)this._deliveryQueue.push([c,_]);for((d=this._perfMon)===null||d===void 0||d.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[c,t]=this._deliveryQueue.shift();try{typeof c=="function"?c.call(void 0,t):c[0].call(c[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(o=this._perfMon)===null||o===void 0||o.stop()}}dispose(){var _,d,o;(_=this._listeners)===null||_===void 0||_.clear(),(d=this._deliveryQueue)===null||d===void 0||d.clear(),(o=this._leakageMon)===null||o===void 0||o.dispose(),this._disposed=!0}}e.Emitter=g,g._noop=function(){};class m extends g{constructor(_){super(_);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=_==null?void 0:_.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const _=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(_))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(_){this._listeners&&(this._isPaused!==0?this._eventQueue.push(_):super.fire(_))}}e.PauseableEmitter=m;class l{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(_){const d={event:_,listener:null};this.events.push(d),this.hasListeners&&this.hook(d);const o=()=>{this.hasListeners&&this.unhook(d);const c=this.events.indexOf(d);this.events.splice(c,1)};return(0,A.toDisposable)((0,I.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(_=>this.hook(_))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(_=>this.unhook(_))}hook(_){_.listener=_.event(d=>this.emitter.fire(d))}unhook(_){_.listener&&_.listener.dispose(),_.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=l;class f{constructor(){this.buffers=[]}wrapEvent(_){return(d,o,c)=>_(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>d.call(o,t)):d.call(o,t)},void 0,c)}bufferEvents(_){const d=[];this.buffers.push(d);const o=_();return this.buffers.pop(),d.forEach(c=>c()),o}}e.EventBufferer=f;class E{constructor(){this.listening=!1,this.inputEvent=k.None,this.inputEventListener=A.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(_){this.inputEvent=_,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=_(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=E}),define(me[21],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const I=Object.freeze(function(k,D){const P=setTimeout(k.bind(D),0);return{dispose(){clearTimeout(P)}}});var A;(function(k){function D(P){return P===k.None||P===k.Cancelled||P instanceof T?!0:!P||typeof P!="object"?!1:typeof P.isCancellationRequested=="boolean"&&typeof P.onCancellationRequested=="function"}k.isCancellationToken=D,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:I})})(A=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?I:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(D){this._token=void 0,this._parentListener=void 0,this._parentListener=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=A.Cancelled}dispose(D=!1){D&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=A.None}}e.CancellationTokenSource=y}),define(me[43],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class I{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(C){const g=this._icons.get(C.id);g?C.description?g.description=C.description:console.error(`Duplicate registration of codicon ${C.id}`):(this._icons.set(C.id,C),this._onDidRegister.fire(C))}get(C){return this._icons.get(C)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const A=new I;e.iconRegistry=A;function T(r,C){return new k(r,C)}e.registerCodicon=T;function y(r){return r?r.replace(/\$\((.*?)\)/g,(C,g)=>` ${g} `).trim():""}e.getCodiconAriaLabel=y;class k{constructor(C,g,m){this.id=C,this.definition=g,this.description=m,A.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function D(r,C){const g=["codicon","codicon-"+r];return C&&g.push("codicon-modifier-"+C),g}e.getClassNamesArray=D;var P;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const C=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function g(f){if(f instanceof k)return["codicon","codicon-"+f.id];const E=C.exec(f.id);if(!E)return g(k.error);let[,w,_]=E;const d=["codicon","codicon-"+w];return _&&d.push("codicon-modifier-"+_.substr(1)),d}r.asClassNameArray=g;function m(f){return g(f).join(" ")}r.asClassName=m;function l(f){return"."+g(f).join(".")}r.asCSSSelector=l})(P=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(me[96],ge([0,1,17,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function A(d){const o=d;return o?[o.on,o.pause,o.resume,o.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=A;function T(d){const o=d;return o?A(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(d,o){return new k(d,o)}e.newWriteableStream=y;class k{constructor(o,c){this.reducer=o,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){var c;if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof((c=this.options)===null||c===void 0?void 0:c.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(c=>c(o))}emitError(o){this.listeners.error.length===0?(0,b.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(c=>c(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,c){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(o,c){if(!this.state.destroyed){let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(c);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function D(d,o){const c=[];let t;for(;(t=d.read())!==null;)c.push(t);return o(c)}e.consumeReadable=D;function P(d,o,c){const t=[];let n;for(;(n=d.read())!==null&&t.length<c;)t.push(n);return n===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const s=n;return n=void 0,s}return d.read()}}}e.peekReadable=P;function r(d,o){return new Promise((c,t)=>{const n=[];C(d,{onData:s=>{o&&n.push(s)},onError:s=>{o?t(s):c(void 0)},onEnd:()=>{c(o?o(n):void 0)}})})}e.consumeStream=r;function C(d,o){d.on("error",c=>o.onError(c)),d.on("end",()=>o.onEnd()),d.on("data",c=>o.onData(c))}e.listenStream=C;function g(d,o){return new Promise((c,t)=>{const n=new I.DisposableStore,s=[],i=p=>{if(s.push(p),s.length>o)return n.dispose(),d.pause(),c({stream:d,buffer:s,ended:!1})},a=p=>t(p),h=()=>c({stream:d,buffer:s,ended:!0});n.add((0,I.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),n.add((0,I.toDisposable)(()=>d.removeListener("end",h))),d.on("end",h),n.add((0,I.toDisposable)(()=>d.removeListener("data",i))),d.on("data",i)})}e.peekStream=g;function m(d,o){const c=y(o);return c.end(d),c}e.toStream=m;function l(){const d=y(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=l;function f(d){let o=!1;return{read:()=>o?null:(o=!0,d)}}e.toReadable=f;function E(d,o,c){const t=y(c);return C(d,{onData:n=>t.write(o.data(n)),onError:n=>t.error(o.error?o.error(n):n),onEnd:()=>t.end()}),t}e.transform=E;function w(d,o,c){let t=!1;return{read:()=>{const n=o.read();return t?n:(t=!0,n!==null?c([d,n]):d)}}}e.prefixedReadable=w;function _(d,o,c){let t=!1;const n=y(c);return C(o,{onData:s=>t?n.write(s):(t=!0,n.write(c([d,s]))),onError:s=>n.error(s),onEnd:()=>{t||(t=!0,n.write(d)),n.end()}}),n}e.prefixedStream=_}),define(me[9],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=b;const I=/{(\d+)}/g;function A(H,...Z){return Z.length===0?H:H.replace(I,function(ce,Ie){const Ae=parseInt(Ie,10);return isNaN(Ae)||Ae<0||Ae>=Z.length?ce:Z[Ae]})}e.format=A;function T(H){return H.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.escape=T;function y(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function k(H,Z){let ce=0;const Ie=Z.charCodeAt(0);for(let Ae=H.length-1;Ae>=0;Ae--)H.charCodeAt(Ae)===Ie&&ce++;return ce}e.count=k;function D(H,Z,ce="\u2026"){return H.length<=Z?H:`${H.substr(0,Z)}${ce}`}e.truncate=D;function P(H,Z=" "){const ce=r(H,Z);return C(ce,Z)}e.trim=P;function r(H,Z){if(!H||!Z)return H;const ce=Z.length;if(ce===0||H.length===0)return H;let Ie=0;for(;H.indexOf(Z,Ie)===Ie;)Ie=Ie+ce;return H.substring(Ie)}e.ltrim=r;function C(H,Z){if(!H||!Z)return H;const ce=Z.length,Ie=H.length;if(ce===0||Ie===0)return H;let Ae=Ie,Le=-1;for(;Le=H.lastIndexOf(Z,Ae-1),!(Le===-1||Le+ce!==Ae);){if(Le===0)return"";Ae=Le}return H.substring(0,Ae)}e.rtrim=C;function g(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function m(H){return H.replace(/\*/g,"")}e.stripWildcards=m;function l(H,Z,ce={}){if(!H)throw new Error("Cannot create regex from empty string");Z||(H=y(H)),ce.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let Ie="";return ce.global&&(Ie+="g"),ce.matchCase||(Ie+="i"),ce.multiline&&(Ie+="m"),ce.unicode&&(Ie+="u"),new RegExp(H,Ie)}e.createRegExp=l;function f(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function E(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=E;function w(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=w;function _(H){return H.split(/\r\n|\r|\n/)}e.splitLines=_;function d(H){for(let Z=0,ce=H.length;Z<ce;Z++){const Ie=H.charCodeAt(Z);if(Ie!==32&&Ie!==9)return Z}return-1}e.firstNonWhitespaceIndex=d;function o(H,Z=0,ce=H.length){for(let Ie=Z;Ie<ce;Ie++){const Ae=H.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return H.substring(Z,Ie)}return H.substring(Z,ce)}e.getLeadingWhitespace=o;function c(H,Z=H.length-1){for(let ce=Z;ce>=0;ce--){const Ie=H.charCodeAt(ce);if(Ie!==32&&Ie!==9)return ce}return-1}e.lastNonWhitespaceIndex=c;function t(H,Z){return H<Z?-1:H>Z?1:0}e.compare=t;function n(H,Z,ce=0,Ie=H.length,Ae=0,Le=Z.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=H.charCodeAt(ce),tt=Z.charCodeAt(Ae);if(rt<tt)return-1;if(rt>tt)return 1}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstring=n;function s(H,Z){return i(H,Z,0,H.length,0,Z.length)}e.compareIgnoreCase=s;function i(H,Z,ce=0,Ie=H.length,Ae=0,Le=Z.length){for(;ce<Ie&&Ae<Le;ce++,Ae++){let rt=H.charCodeAt(ce),tt=Z.charCodeAt(Ae);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&h(tt))&&!(Qe===-32&&h(rt)))return a(rt)&&a(tt)?Qe:n(H.toLowerCase(),Z.toLowerCase(),ce,Ie,Ae,Le)}}const $e=Ie-ce,Xe=Le-Ae;return $e<Xe?-1:$e>Xe?1:0}e.compareSubstringIgnoreCase=i;function a(H){return H>=97&&H<=122}e.isLowerAsciiLetter=a;function h(H){return H>=65&&H<=90}e.isUpperAsciiLetter=h;function p(H){return a(H)||h(H)}function S(H,Z){return H.length===Z.length&&u(H,Z)}e.equalsIgnoreCase=S;function u(H,Z,ce=H.length){for(let Ie=0;Ie<ce;Ie++){const Ae=H.charCodeAt(Ie),Le=Z.charCodeAt(Ie);if(Ae!==Le){if(p(Ae)&&p(Le)){const $e=Math.abs(Ae-Le);if($e!==0&&$e!==32)return!1}else if(String.fromCharCode(Ae).toLowerCase()!==String.fromCharCode(Le).toLowerCase())return!1}}return!0}function v(H,Z){const ce=Z.length;return Z.length>H.length?!1:u(H,Z,ce)}e.startsWithIgnoreCase=v;function R(H,Z){let ce,Ie=Math.min(H.length,Z.length);for(ce=0;ce<Ie;ce++)if(H.charCodeAt(ce)!==Z.charCodeAt(ce))return ce;return Ie}e.commonPrefixLength=R;function N(H,Z){let ce,Ie=Math.min(H.length,Z.length);const Ae=H.length-1,Le=Z.length-1;for(ce=0;ce<Ie;ce++)if(H.charCodeAt(Ae-ce)!==Z.charCodeAt(Le-ce))return ce;return Ie}e.commonSuffixLength=N;function j(H){return 55296<=H&&H<=56319}e.isHighSurrogate=j;function ie(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ie;function K(H,Z){return(H-55296<<10)+(Z-56320)+65536}e.computeCodePoint=K;function B(H,Z,ce){const Ie=H.charCodeAt(ce);if(j(Ie)&&ce+1<Z){const Ae=H.charCodeAt(ce+1);if(ie(Ae))return K(Ie,Ae)}return Ie}e.getNextCodePoint=B;function $(H,Z){const ce=H.charCodeAt(Z-1);if(ie(ce)&&Z>1){const Ie=H.charCodeAt(Z-2);if(j(Ie))return K(Ie,ce)}return ce}function U(H,Z){const ce=Ve.getInstance(),Ie=Z,Ae=H.length,Le=B(H,Ae,Z);Z+=Le>=65536?2:1;let $e=ce.getGraphemeBreakType(Le);for(;Z<Ae;){const Xe=B(H,Ae,Z),rt=ce.getGraphemeBreakType(Xe);if(xe($e,rt))break;Z+=Xe>=65536?2:1,$e=rt}return Z-Ie}e.nextCharLength=U;function L(H,Z){const ce=Ve.getInstance(),Ie=Z,Ae=$(H,Z);Z-=Ae>=65536?2:1;let Le=ce.getGraphemeBreakType(Ae);for(;Z>0;){const $e=$(H,Z),Xe=ce.getGraphemeBreakType($e);if(xe(Xe,Le))break;Z-=$e>=65536?2:1,Le=Xe}return Ie-Z}e.prevCharLength=L;function O(H,Z){const ce=Ve.getInstance(),Ie=H.length,Ae=Z,Le=B(H,Ie,Z),$e=ce.getGraphemeBreakType(Le);Z+=Le>=65536?2:1;let Xe=$e;for(;Z<Ie;){const tt=B(H,Ie,Z),Qe=ce.getGraphemeBreakType(tt);if(xe(Xe,Qe))break;Z+=tt>=65536?2:1,Xe=Qe}const rt=Z;for(Z=Ae,Xe=$e;Z>0;){const tt=$(H,Z),Qe=ce.getGraphemeBreakType(tt);if(xe(Qe,Xe))break;Z-=tt>=65536?2:1,Xe=Qe}return[Z,rt]}function M(H,Z){return Z>0&&ie(H.charCodeAt(Z))?O(H,Z-1):O(H,Z)}e.getCharContainingOffset=M;function F(H){const Z=H.length;let ce=0,Ie=0;for(;Ie<Z;){const $e=B(H,Z,Ie);Ie+=$e>=65536?2:1,$e<128?ce+=1:$e<2048?ce+=2:$e<65536?ce+=3:ce+=4}const Ae=new Uint8Array(ce);Ie=0;let Le=0;for(;Ie<Z;){const $e=B(H,Z,Ie);Ie+=$e>=65536?2:1,$e<128?Ae[Le++]=$e:$e<2048?(Ae[Le++]=192|($e&1984)>>>6,Ae[Le++]=128|($e&63)>>>0):$e<65536?(Ae[Le++]=224|($e&61440)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0):(Ae[Le++]=240|($e&1835008)>>>18,Ae[Le++]=128|($e&258048)>>>12,Ae[Le++]=128|($e&4032)>>>6,Ae[Le++]=128|($e&63)>>>0)}return Ae}e.encodeUTF8=F;function W(H){const Z=H.byteLength,ce=[];let Ie=0;for(;Ie<Z;){const Ae=H[Ie];let Le;if(Ae>=240&&Ie+3<Z?Le=(H[Ie++]&7)<<18>>>0|(H[Ie++]&63)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ae>=224&&Ie+2<Z?Le=(H[Ie++]&15)<<12>>>0|(H[Ie++]&63)<<6>>>0|(H[Ie++]&63)<<0>>>0:Ae>=192&&Ie+1<Z?Le=(H[Ie++]&31)<<6>>>0|(H[Ie++]&63)<<0>>>0:Le=H[Ie++],Le>=0&&Le<=55295||Le>=57344&&Le<=65535)ce.push(String.fromCharCode(Le));else if(Le>=65536&&Le<=1114111){const $e=Le-65536,Xe=55296+(($e&1047552)>>>10),rt=56320+(($e&1023)>>>0);ce.push(String.fromCharCode(Xe)),ce.push(String.fromCharCode(rt))}else ce.push(String.fromCharCode(65533))}return ce.join("")}e.decodeUTF8=W;const q=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(H){return q.test(H)}e.containsRTL=Q;const le=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ve(H){return le.test(H)}e.containsEmoji=ve;const Re=/^[\t\n\r\x20-\x7E]*$/;function Se(H){return Re.test(H)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Oe(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=Oe;function z(H){for(let Z=0,ce=H.length;Z<ce;Z++)if(Y(H.charCodeAt(Z)))return!0;return!1}e.containsFullWidthCharacter=z;function Y(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=Y;function ee(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ee;function se(H,Z){if(H.length<Z)return H;const ce=/\b/g;let Ie=0;for(;ce.test(H)&&!(H.length-ce.lastIndex<Z);)Ie=ce.lastIndex,ce.lastIndex+=1;return H.substring(Ie).replace(/^\s/,"")}e.lcut=se;const fe=/\x1B\x5B[12]?K/g,Ee=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function pe(H){return H&&(H=H.replace(fe,""),H=H.replace(Ee,""),H=H.replace(Be,"")),H}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function Me(H){return Ce(H)?H.substr(1):H}e.stripUTF8BOM=Me;function ze(H,Z){if(!H||!Z||H.length<Z.length)return!1;const ce=Z.length,Ie=H.toLowerCase();let Ae=0,Le=-1;for(;Ae<ce;){const $e=Ie.indexOf(Z[Ae],Le+1);if($e<0)return!1;Le=$e,Ae++}return!0}e.fuzzyContains=ze;function _e(H,Z=!1){return H?(Z&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=_e;function Ke(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ke;function X(H,Z=1){if(Z===0)return"";let ce=-1;do ce=H.indexOf(`
`,ce+1),Z--;while(Z>0&&ce>=0);return ce===-1?H:(H[ce-1]==="\r"&&ce--,H.substr(0,ce))}e.getNLines=X;function ne(H){const Z=90-65+1;return H=H%(2*Z),H<Z?String.fromCharCode(97+H):String.fromCharCode(65+H-Z)}e.singleLetterHash=ne;function we(H){return Ve.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=we;function xe(H,Z){return H===0?Z!==5&&Z!==7:H===2&&Z===3?!1:H===4||H===2||H===3||Z===4||Z===2||Z===3?!0:!(H===8&&(Z===8||Z===9||Z===11||Z===12)||(H===11||H===9)&&(Z===9||Z===10)||(H===12||H===10)&&Z===10||Z===5||Z===13||Z===7||H===1||H===13&&Z===14||H===6&&Z===6)}e.breakBetweenGraphemeBreakType=xe;var je;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ve{constructor(){this._data=Ze()}static getInstance(){return Ve._INSTANCE||(Ve._INSTANCE=new Ve),Ve._INSTANCE}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ce=this._data,Ie=ce.length/3;let Ae=1;for(;Ae<=Ie;)if(Z<ce[3*Ae])Ae=2*Ae;else if(Z>ce[3*Ae+1])Ae=2*Ae+1;else return ce[3*Ae+2];return 0}}Ve._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(H,Z){if(H===0)return 0;const ce=ye(H,Z);if(ce!==void 0)return ce;const Ie=$(Z,H);return H-=Pe(Ie),H}e.getLeftDeleteOffset=De;function ye(H,Z){let ce=$(Z,H);for(H-=Pe(ce);oe(ce)||ce===65039||ce===8419;){if(H===0)return;ce=$(Z,H),H-=Pe(ce)}if(!!ee(ce)){if(H>=0){const Ie=$(Z,H);Ie===8205&&(H-=Pe(Ie))}return H}}function Pe(H){return H>=65536?2:1}function oe(H){return 127995<=H&&H<=127999}var ue;(function(H){H[H.zwj=8205]="zwj",H[H.emojiVariantSelector=65039]="emojiVariantSelector",H[H.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(me[23],ge([0,1,9,96]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let k,D;class P{constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}static alloc(p){return A?new P(Buffer.allocUnsafe(p)):new P(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new P(p)}static fromString(p,S){return!((S==null?void 0:S.dontUseNodeBuffer)||!1)&&A?new P(Buffer.from(p)):T?(k||(k=new TextEncoder),new P(k.encode(p))):new P(b.encodeUTF8(p))}static concat(p,S){if(typeof S=="undefined"){S=0;for(let R=0,N=p.length;R<N;R++)S+=p[R].byteLength}const u=P.alloc(S);let v=0;for(let R=0,N=p.length;R<N;R++){const j=p[R];u.set(j,v),v+=j.byteLength}return u}toString(){return A?this.buffer.toString():y?(D||(D=new TextDecoder),D.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(p,S){return new P(this.buffer.subarray(p,S))}set(p,S){p instanceof P?this.buffer.set(p.buffer,S):this.buffer.set(p,S)}readUInt32BE(p){return g(this.buffer,p)}writeUInt32BE(p,S){m(this.buffer,p,S)}readUInt32LE(p){return l(this.buffer,p)}writeUInt32LE(p,S){f(this.buffer,p,S)}readUInt8(p){return E(this.buffer,p)}writeUInt8(p,S){w(this.buffer,p,S)}}e.VSBuffer=P;function r(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0}e.readUInt16LE=r;function C(h,p,S){h[S+0]=p&255,p=p>>>8,h[S+1]=p&255}e.writeUInt16LE=C;function g(h,p){return h[p]*2**24+h[p+1]*2**16+h[p+2]*2**8+h[p+3]}e.readUInt32BE=g;function m(h,p,S){h[S+3]=p,p=p>>>8,h[S+2]=p,p=p>>>8,h[S+1]=p,p=p>>>8,h[S]=p}e.writeUInt32BE=m;function l(h,p){return h[p+0]<<0>>>0|h[p+1]<<8>>>0|h[p+2]<<16>>>0|h[p+3]<<24>>>0}e.readUInt32LE=l;function f(h,p,S){h[S+0]=p&255,p=p>>>8,h[S+1]=p&255,p=p>>>8,h[S+2]=p&255,p=p>>>8,h[S+3]=p&255}e.writeUInt32LE=f;function E(h,p){return h[p]}e.readUInt8=E;function w(h,p,S){h[S]=p}e.writeUInt8=w;function _(h){return I.consumeReadable(h,p=>P.concat(p))}e.readableToBuffer=_;function d(h){return I.toReadable(h)}e.bufferToReadable=d;function o(h){return I.consumeStream(h,p=>P.concat(p))}e.streamToBuffer=o;async function c(h){return h.ended?P.concat(h.buffer):P.concat([...h.buffer,await o(h.stream)])}e.bufferedStreamToBuffer=c;function t(h){return I.toStream(h,p=>P.concat(p))}e.bufferToStream=t;function n(h){return I.transform(h,{data:p=>typeof p=="string"?P.fromString(p):P.wrap(p)},p=>P.concat(p))}e.streamToBufferReadableStream=n;function s(h){return I.newWriteableStream(p=>P.concat(p),h)}e.newWriteableBufferStream=s;function i(h,p){return I.prefixedReadable(h,p,S=>P.concat(S))}e.prefixedBufferReadable=i;function a(h,p){return I.prefixedStream(h,p,S=>P.concat(S))}e.prefixedBufferStream=a}),define(me[74],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function I(w){return A(w,0)}e.hash=I;function A(w,_){switch(typeof w){case"object":return w===null?T(349,_):Array.isArray(w)?D(w,_):P(w,_);case"string":return k(w,_);case"boolean":return y(w,_);case"number":return T(w,_);case"undefined":return T(937,_);default:return T(617,_)}}e.doHash=A;function T(w,_){return(_<<5)-_+w|0}function y(w,_){return T(w?433:863,_)}function k(w,_){_=T(149417,_);for(let d=0,o=w.length;d<o;d++)_=T(w.charCodeAt(d),_);return _}e.stringHash=k;function D(w,_){return _=T(104579,_),w.reduce((d,o)=>A(o,d),_)}function P(w,_){return _=T(181387,_),Object.keys(w).sort().reduce((d,o)=>(d=k(o,d),A(w[o],d)),_)}class r{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=A(_,this._value),this._value}}e.Hasher=r;var C;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function g(w,_,d=32){const o=d-_,c=~((1<<o)-1);return(w<<_|(c&w)>>>o)>>>0}function m(w,_=0,d=w.byteLength,o=0){for(let c=0;c<d;c++)w[_+c]=o}function l(w,_,d="0"){for(;w.length<_;)w=d+w;return w}function f(w,_=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(d=>d.toString(16).padStart(2,"0")).join(""):l((w>>>0).toString(16),_/4)}e.toHexString=f;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const d=_.length;if(d!==0){const o=this._buff;let c=this._buffLen,t=this._leftoverHighSurrogate,n,s;for(t!==0?(n=t,s=-1,t=0):(n=_.charCodeAt(0),s=0);;){let i=n;if(b.isHighSurrogate(n))if(s+1<d){const a=_.charCodeAt(s+1);b.isLowSurrogate(a)?(s++,i=b.computeCodePoint(n,a)):i=65533}else{t=n;break}else b.isLowSurrogate(n)&&(i=65533);if(c=this._push(o,c,i),s++,s<d)n=_.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=t}}_push(_,d,o){return o<128?_[d++]=o:o<2048?(_[d++]=192|(o&1984)>>>6,_[d++]=128|(o&63)>>>0):o<65536?(_[d++]=224|(o&61440)>>>12,_[d++]=128|(o&4032)>>>6,_[d++]=128|(o&63)>>>0):(_[d++]=240|(o&1835008)>>>18,_[d++]=128|(o&258048)>>>12,_[d++]=128|(o&4032)>>>6,_[d++]=128|(o&63)>>>0),d>=64&&(this._step(),d-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),d}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=E._bigBlock32,d=this._buffDV;for(let p=0;p<64;p+=4)_.setUint32(p,d.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)_.setUint32(p,g(_.getUint32(p-12,!1)^_.getUint32(p-32,!1)^_.getUint32(p-56,!1)^_.getUint32(p-64,!1),1),!1);let o=this._h0,c=this._h1,t=this._h2,n=this._h3,s=this._h4,i,a,h;for(let p=0;p<80;p++)p<20?(i=c&t|~c&n,a=1518500249):p<40?(i=c^t^n,a=1859775393):p<60?(i=c&t|c&n|t&n,a=2400959708):(i=c^t^n,a=3395469782),h=g(o,5)+i+s+a+_.getUint32(p*4,!1)&4294967295,s=n,n=t,t=g(c,30),c=o,o=h;this._h0=this._h0+o&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[58],ge([0,1,9]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var I;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(I||(I={})),function(A){const T="error",y="warning",k="warn",D="info",P="ignore";function r(g){return g?b.equalsIgnoreCase(T,g)?A.Error:b.equalsIgnoreCase(y,g)||b.equalsIgnoreCase(k,g)?A.Warning:b.equalsIgnoreCase(D,g)?A.Info:A.Ignore:A.Ignore}A.fromValue=r;function C(g){switch(g){case A.Error:return T;case A.Warning:return y;case A.Info:return D;default:return P}}A.toString=C}(I||(I={})),e.default=I}),define(me[11],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(p){return Array.isArray(p)}e.isArray=b;function I(p){return typeof p=="string"}e.isString=I;function A(p){return Array.isArray(p)&&p.every(S=>I(S))}e.isStringArray=A;function T(p){return typeof p=="object"&&p!==null&&!Array.isArray(p)&&!(p instanceof RegExp)&&!(p instanceof Date)}e.isObject=T;function y(p){return typeof p=="number"&&!isNaN(p)}e.isNumber=y;function k(p){return!!p&&typeof p[Symbol.iterator]=="function"}e.isIterable=k;function D(p){return p===!0||p===!1}e.isBoolean=D;function P(p){return typeof p=="undefined"}e.isUndefined=P;function r(p){return!C(p)}e.isDefined=r;function C(p){return P(p)||p===null}e.isUndefinedOrNull=C;function g(p,S){if(!p)throw new Error(S?`Unexpected type, expected '${S}'`:"Unexpected type")}e.assertType=g;function m(p){if(C(p))throw new Error("Assertion Failed: argument is undefined or null");return p}e.assertIsDefined=m;function l(...p){const S=[];for(let u=0;u<p.length;u++){const v=p[u];if(C(v))throw new Error(`Assertion Failed: argument at index ${u} is undefined or null`);S.push(v)}return S}e.assertAllDefined=l;const f=Object.prototype.hasOwnProperty;function E(p){if(!T(p))return!1;for(let S in p)if(f.call(p,S))return!1;return!0}e.isEmptyObject=E;function w(p){return typeof p=="function"}e.isFunction=w;function _(...p){return p.length>0&&p.every(w)}e.areFunctions=_;function d(p,S){const u=Math.min(p.length,S.length);for(let v=0;v<u;v++)o(p[v],S[v])}e.validateConstraints=d;function o(p,S){if(I(S)){if(typeof p!==S)throw new Error(`argument does not match constraint: typeof ${S}`)}else if(w(S)){try{if(p instanceof S)return}catch(u){}if(!C(p)&&p.constructor===S||S.length===1&&S.call(void 0,p)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=o;function c(p){let S=[],u=Object.getPrototypeOf(p);for(;Object.prototype!==u;)S=S.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return S}e.getAllPropertyNames=c;function t(p){const S=[];for(const u of c(p))typeof p[u]=="function"&&S.push(u);return S}e.getAllMethodNames=t;function n(p,S){const u=R=>function(){const N=Array.prototype.slice.call(arguments,0);return S(R,N)};let v={};for(const R of p)v[R]=u(R);return v}e.createProxyObject=n;function s(p){return p===null?void 0:p}e.withNullAsUndefined=s;function i(p){return typeof p=="undefined"?null:p}e.withUndefinedAsNull=i;function a(p){return class{constructor(){return new Proxy({},{get(S,u){if(S[u])return S[u];throw new Error(`Not Implemented: ${p}->${String(u)}`)}})}}}e.NotImplementedProxy=a;function h(p){throw new Error("Unreachable")}e.assertNever=h}),define(me[29],ge([0,1,10,9,8,11]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function k(n){return n.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=k;function D(n,s=A.posix.sep){if(!n)return"";const i=n.length,a=n.charCodeAt(0);if(y(a)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let p=3;const S=p;for(;p<i&&!y(n.charCodeAt(p));p++);if(S!==p&&!y(n.charCodeAt(p+1))){for(p+=1;p<i;p++)if(y(n.charCodeAt(p)))return n.slice(0,p+1).replace(/[\\/]/g,s)}}return s}else if(E(a)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let h=n.indexOf("://");if(h!==-1){for(h+=3;h<i;h++)if(y(n.charCodeAt(h)))return n.slice(0,h+1)}return""}e.getRoot=D;function P(n){if(!b.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let i=2;const a=i;for(;i<n.length&&(s=n.charCodeAt(i),s!==92);i++);return!(a===i||(s=n.charCodeAt(i+1),isNaN(s)||s===92))}e.isUNC=P;const r=/[\\/:\*\?"<>\|]/g,C=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(n,s=b.isWindows){const i=s?r:C;return!(!n||n.length===0||/^\s+$/.test(n)||(i.lastIndex=0,i.test(n))||s&&g.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=m;function l(n,s,i){const a=n===s;return!i||a?a:!n||!s?!1:(0,I.equalsIgnoreCase)(n,s)}e.isEqual=l;function f(n,s,i,a=A.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(i){if(!(0,I.startsWithIgnoreCase)(n,s))return!1;if(s.length===n.length)return!0;let p=s.length;return s.charAt(s.length-1)===a&&p--,n.charAt(p)===a}return s.charAt(s.length-1)!==a&&(s+=a),n.indexOf(s)===0}e.isEqualOrParent=f;function E(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=E;function w(n,s){return b.isWindows&&n.endsWith(":")&&(n+=A.sep),(0,A.isAbsolute)(n)||(n=(0,A.join)(s,n)),n=(0,A.normalize)(n),b.isWindows?(n=(0,I.rtrim)(n,A.sep),n.endsWith(":")&&(n+=A.sep)):(n=(0,I.rtrim)(n,A.sep),n||(n=A.sep)),n}e.sanitizeFilePath=w;function _(n){const s=(0,A.normalize)(n);return b.isWindows?n.length>3?!1:d(s)&&(n.length===2||s.charCodeAt(2)===92):s===A.posix.sep}e.isRootOrDriveLetter=_;function d(n){return b.isWindows?E(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function o(n){return d(n)?n[0]:void 0}e.getDriveLetter=o;function c(n,s,i){return s.length>n.length?-1:n===s?0:(i&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=c;function t(n){const s=n.split(":");let i,a,h;if(s.forEach(p=>{const S=Number(p);(0,T.isNumber)(S)?a===void 0?a=S:h===void 0&&(h=S):i=i?[i,p].join(":"):p}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:a!==void 0?a:void 0,column:h!==void 0?h:a!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(me[24],ge([0,1,11]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function I(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const E=Array.isArray(f)?[]:{};return Object.keys(f).forEach(w=>{f[w]&&typeof f[w]=="object"?E[w]=I(f[w]):E[w]=f[w]}),E}e.deepClone=I;function A(f){if(!f||typeof f!="object")return f;const E=[f];for(;E.length>0;){const w=E.shift();Object.freeze(w);for(const _ in w)if(T.call(w,_)){const d=w[_];typeof d=="object"&&!Object.isFrozen(d)&&E.push(d)}}return f}e.deepFreeze=A;const T=Object.prototype.hasOwnProperty;function y(f,E){return k(f,E,new Set)}e.cloneAndChange=y;function k(f,E,w){if((0,b.isUndefinedOrNull)(f))return f;const _=E(f);if(typeof _!="undefined")return _;if((0,b.isArray)(f)){const d=[];for(const o of f)d.push(k(o,E,w));return d}if((0,b.isObject)(f)){if(w.has(f))throw new Error("Cannot clone recursive data-structure");w.add(f);const d={};for(let o in f)T.call(f,o)&&(d[o]=k(f[o],E,w));return w.delete(f),d}return f}function D(f,E,w=!0){return(0,b.isObject)(f)?((0,b.isObject)(E)&&Object.keys(E).forEach(_=>{_ in f?w&&((0,b.isObject)(f[_])&&(0,b.isObject)(E[_])?D(f[_],E[_],w):f[_]=E[_]):f[_]=E[_]}),f):E}e.mixin=D;function P(f,E){if(f===E)return!0;if(f==null||E===null||E===void 0||typeof f!=typeof E||typeof f!="object"||Array.isArray(f)!==Array.isArray(E))return!1;let w,_;if(Array.isArray(f)){if(f.length!==E.length)return!1;for(w=0;w<f.length;w++)if(!P(f[w],E[w]))return!1}else{const d=[];for(_ in f)d.push(_);d.sort();const o=[];for(_ in E)o.push(_);if(o.sort(),!P(d,o))return!1;for(w=0;w<d.length;w++)if(!P(f[d[w]],E[d[w]]))return!1}return!0}e.equals=P;function r(f){const E=new Set;return JSON.stringify(f,(w,_)=>{if((0,b.isObject)(_)||Array.isArray(_)){if(E.has(_))return"[Circular]";E.add(_)}return _})}e.safeStringify=r;function C(f,E,w){const _=E(f);return typeof _=="undefined"?w:_}e.getOrDefault=C;function g(f,E){const w=Object.create(null);return!f||!E||Object.keys(E).forEach(d=>{const o=f[d],c=E[d];P(o,c)||(w[d]=c)}),w}e.distinct=g;function m(f,E){const w=E.toLowerCase(),_=Object.keys(f).find(d=>d.toLowerCase()===w);return _?f[_]:f[E]}e.getCaseInsensitive=m;function l(f,E){const w=Object.create(null);for(const _ of Object.keys(f))E(_,f[_])&&(w[_]=f[_]);return w}e.filter=l}),define(me[97],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function I(T){return T<0?0:T>255?255:T|0}e.toUint8=I;function A(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=A}),define(me[2],ge([0,1,10,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function k(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!A.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!T.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(s,i){return!s&&!i?"file":s}function P(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==C&&(i=C+i):i=C;break}return i}const r="",C="/",g=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(i,a,h,p,S,u=!1){typeof i=="object"?(this.scheme=i.scheme||r,this.authority=i.authority||r,this.path=i.path||r,this.query=i.query||r,this.fragment=i.fragment||r):(this.scheme=D(i,u),this.authority=a||r,this.path=P(this.scheme,h||r),this.query=p||r,this.fragment=S||r,k(this,u))}static isUri(i){return i instanceof m?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:h,path:p,query:S,fragment:u}=i;return a===void 0?a=this.scheme:a===null&&(a=r),h===void 0?h=this.authority:h===null&&(h=r),p===void 0?p=this.path:p===null&&(p=r),S===void 0?S=this.query:S===null&&(S=r),u===void 0?u=this.fragment:u===null&&(u=r),a===this.scheme&&h===this.authority&&p===this.path&&S===this.query&&u===this.fragment?this:new f(a,h,p,S,u)}static parse(i,a=!1){const h=g.exec(i);return h?new f(h[2]||r,n(h[4]||r),n(h[5]||r),n(h[7]||r),n(h[9]||r),a):new f(r,r,r,r,r)}static file(i){let a=r;if(b.isWindows&&(i=i.replace(/\\/g,C)),i[0]===C&&i[1]===C){const h=i.indexOf(C,2);h===-1?(a=i.substring(2),i=C):(a=i.substring(2,h),i=i.substring(h)||C)}return new f("file",a,i,r,r)}static from(i){return new f(i.scheme,i.authority,i.path,i.query,i.fragment)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return b.isWindows&&i.scheme==="file"?h=m.file(I.win32.join(d(i,!0),...a)).path:h=I.posix.join(i.path,...a),i.with({path:h})}toString(i=!1){return o(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof m)return i;{const a=new f(i);return a._formatted=i.external,a._fsPath=i._sep===l?i.fsPath:null,a}}else return i}}e.URI=m;const l=b.isWindows?1:void 0;class f extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=l),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(s,i){let a,h=-1;for(let p=0;p<s.length;p++){const S=s.charCodeAt(p);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||i&&S===47)h!==-1&&(a+=encodeURIComponent(s.substring(h,p)),h=-1),a!==void 0&&(a+=s.charAt(p));else{a===void 0&&(a=s.substr(0,p));const u=E[S];u!==void 0?(h!==-1&&(a+=encodeURIComponent(s.substring(h,p)),h=-1),a+=u):h===-1&&(h=p)}}return h!==-1&&(a+=encodeURIComponent(s.substring(h))),a!==void 0?a:s}function _(s){let i;for(let a=0;a<s.length;a++){const h=s.charCodeAt(a);h===35||h===63?(i===void 0&&(i=s.substr(0,a)),i+=E[h]):i!==void 0&&(i+=s[a])}return i!==void 0?i:s}function d(s,i){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,b.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=d;function o(s,i){const a=i?_:w;let h="",{scheme:p,authority:S,path:u,query:v,fragment:R}=s;if(p&&(h+=p,h+=":"),(S||p==="file")&&(h+=C,h+=C),S){let N=S.indexOf("@");if(N!==-1){const j=S.substr(0,N);S=S.substr(N+1),N=j.indexOf(":"),N===-1?h+=a(j,!1):(h+=a(j.substr(0,N),!1),h+=":",h+=a(j.substr(N+1),!1)),h+="@"}S=S.toLowerCase(),N=S.indexOf(":"),N===-1?h+=a(S,!1):(h+=a(S.substr(0,N),!1),h+=S.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const N=u.charCodeAt(1);N>=65&&N<=90&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const N=u.charCodeAt(0);N>=65&&N<=90&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}h+=a(u,!0)}return v&&(h+="?",h+=a(v,!1)),R&&(h+="#",h+=i?R:w(R,!1)),h}function c(s){try{return decodeURIComponent(s)}catch(i){return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(t)?s.replace(t,i=>c(i)):s}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[22],ge([0,1,2,9]),function(G,e,b,I){"use strict";var A,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(t,n,s){let i=t.get(n);return i===void 0&&(i=s,t.set(n,i)),i}e.getOrSet=k;function D(t){const n=[];return t.forEach((s,i)=>{n.push(`${i} => ${s}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=D;function P(t){const n=[];return t.forEach(s=>{n.push(s)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=P;class r{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=r;class C{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=C;class g{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,I.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,I.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var m;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(m||(m={}));class l{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,I.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,I.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,I.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,I.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=l;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class E{constructor(n){this._iter=n}static forUris(n=()=>!1){return new E(new l(n))}static forPaths(){return new E(new g)}static forStrings(){return new E(new r)}static forConfigKeys(){return new E(new C)}clear(){this._root=void 0}set(n,s){const i=this._iter.reset(n);let a;for(this._root||(this._root=new f,this._root.segment=i.value()),a=this._root;;){const p=i.cmp(a.segment);if(p>0)a.left||(a.left=new f,a.left.segment=i.value()),a=a.left;else if(p<0)a.right||(a.right=new f,a.right.segment=i.value()),a=a.right;else if(i.hasNext())i.next(),a.mid||(a.mid=new f,a.mid.segment=i.value()),a=a.mid;else break}const h=a.value;return a.value=s,a.key=n,h}get(n){var s;return(s=this._getNode(n))===null||s===void 0?void 0:s.value}_getNode(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const a=s.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(n){const s=this._getNode(n);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const i=this._iter.reset(n),a=[];let h=this._root;for(;h;){const p=i.cmp(h.segment);if(p>0)a.push([1,h]),h=h.left;else if(p<0)a.push([-1,h]),h=h.right;else if(i.hasNext())i.next(),a.push([0,h]),h=h.mid;else{for(s?(h.left=void 0,h.mid=void 0,h.right=void 0):h.value=void 0;a.length>0&&h.isEmpty();){let[S,u]=a.pop();switch(S){case 1:u.left=void 0;break;case 0:u.mid=void 0;break;case-1:u.right=void 0;break}h=u}break}}}findSubstr(n){const s=this._iter.reset(n);let i=this._root,a;for(;i;){const h=s.cmp(i.segment);if(h>0)i=i.left;else if(h<0)i=i.right;else if(s.hasNext())s.next(),a=i.value||a,i=i.mid;else break}return i&&i.value||a}findSuperstr(n){const s=this._iter.reset(n);let i=this._root;for(;i;){const a=s.cmp(i.segment);if(a>0)i=i.left;else if(a<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(n){for(const[s,i]of this)n(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=E;class w{constructor(n,s){this[A]="ResourceMap",n instanceof w?(this.map=new Map(n.map),this.toKey=s!=null?s:w.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:w.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),s),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(let[i,a]of this.map)n(a,b.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var _;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class d{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,s=0){const i=this._map.get(n);if(!!i)return s!==0&&this.touch(i,s),i.value}set(n,s,i=0){let a=this._map.get(n);if(a)a.value=s,i!==0&&this.touch(a,i);else{switch(a={key:n,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(n,a),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,s){const i=this._state;let a=this._head;for(;a;){if(s?n.bind(s)(a.value,a.key,this):n(a.value,a.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.key,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}values(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:i.value,done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}entries(){const n=this,s=this._state;let i=this._head;const a={[Symbol.iterator](){return a},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const h={value:[i.key,i.value],done:!1};return i=i.next,h}else return{value:void 0,done:!0}}};return a}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>n;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,i=n.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const i=n.next,a=n.previous;n===this._tail?(a.next=void 0,this._tail=a):(i.previous=a,a.next=i),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const i=n.next,a=n.previous;n===this._head?(i.previous=void 0,this._head=i):(i.previous=a,a.next=i),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,i)=>{n.push([i,s])}),n}fromJSON(n){this.clear();for(const[s,i]of n)this.set(s,i)}}e.LinkedMap=d;class o extends d{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=o;class c{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return We(this,y,"f").size}forEach(n,s){We(this,y,"f").forEach(n,s)}get(n){return We(this,y,"f").get(n)}has(n){return We(this,y,"f").has(n)}entries(){return We(this,y,"f").entries()}keys(){return We(this,y,"f").keys()}values(){return We(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return We(this,y,"f").entries()}}e.ReadonlyMapView=c}),define(me[98],ge([0,1,22,9]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function A(...pe){return function(Ce,Me){for(let ze=0,_e=pe.length;ze<_e;ze++){const Ke=pe[ze](Ce,Me);if(Ke)return Ke}return null}}e.or=A,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(pe,Ce,Me){if(!Me||Me.length<Ce.length)return null;let ze;return pe?ze=I.startsWithIgnoreCase(Me,Ce):ze=Me.indexOf(Ce)===0,ze?Ce.length>0?[{start:0,end:Ce.length}]:[]:null}function y(pe,Ce){const Me=Ce.toLowerCase().indexOf(pe.toLowerCase());return Me===-1?null:[{start:Me,end:Me+pe.length}]}e.matchesContiguousSubString=y;function k(pe,Ce){return D(pe.toLowerCase(),Ce.toLowerCase(),0,0)}e.matchesSubString=k;function D(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]===Ce[ze]){let _e=null;return(_e=D(pe,Ce,Me+1,ze+1))?w({start:ze,end:ze+1},_e):null}return D(pe,Ce,Me,ze+1)}function P(pe){return 97<=pe&&pe<=122}function r(pe){return 65<=pe&&pe<=90}e.isUpper=r;function C(pe){return 48<=pe&&pe<=57}function g(pe){return pe===32||pe===9||pe===10||pe===13}const m=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(pe=>m.add(pe.charCodeAt(0)));function l(pe){return g(pe)||m.has(pe)}function f(pe,Ce){return pe===Ce||l(pe)&&l(Ce)}function E(pe){return P(pe)||r(pe)||C(pe)}function w(pe,Ce){return Ce.length===0?Ce=[pe]:pe.end===Ce[0].start?Ce[0].start=pe.start:Ce.unshift(pe),Ce}function _(pe,Ce){for(let Me=Ce;Me<pe.length;Me++){const ze=pe.charCodeAt(Me);if(r(ze)||C(ze)||Me>0&&!E(pe.charCodeAt(Me-1)))return Me}return pe.length}function d(pe,Ce,Me,ze){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(pe[Me]!==Ce[ze].toLowerCase())return null;{let _e=null,Ke=ze+1;for(_e=d(pe,Ce,Me+1,ze+1);!_e&&(Ke=_(Ce,Ke))<Ce.length;)_e=d(pe,Ce,Me+1,Ke),Ke++;return _e===null?null:w({start:ze,end:ze+1},_e)}}function o(pe){let Ce=0,Me=0,ze=0,_e=0,Ke=0;for(let je=0;je<pe.length;je++)Ke=pe.charCodeAt(je),r(Ke)&&Ce++,P(Ke)&&Me++,E(Ke)&&ze++,C(Ke)&&_e++;const X=Ce/pe.length,ne=Me/pe.length,we=ze/pe.length,xe=_e/pe.length;return{upperPercent:X,lowerPercent:ne,alphaPercent:we,numericPercent:xe}}function c(pe){const{upperPercent:Ce,lowerPercent:Me}=pe;return Me===0&&Ce>.6}function t(pe){const{upperPercent:Ce,lowerPercent:Me,alphaPercent:ze,numericPercent:_e}=pe;return Me>.2&&Ce<.8&&ze>.6&&_e<.2}function n(pe){let Ce=0,Me=0,ze=0,_e=0;for(let Ke=0;Ke<pe.length;Ke++)ze=pe.charCodeAt(Ke),r(ze)&&Ce++,P(ze)&&Me++,g(ze)&&_e++;return(Ce===0||Me===0)&&_e===0?pe.length<=30:Ce<=5}function s(pe,Ce){if(!Ce||(Ce=Ce.trim(),Ce.length===0)||!n(pe)||Ce.length>60)return null;const Me=o(Ce);if(!t(Me)){if(!c(Me))return null;Ce=Ce.toLowerCase()}let ze=null,_e=0;for(pe=pe.toLowerCase();_e<Ce.length&&(ze=d(pe,Ce,0,_e))===null;)_e=_(Ce,_e+1);return ze}e.matchesCamelCase=s;function i(pe,Ce,Me=!1){if(!Ce||Ce.length===0)return null;let ze=null,_e=0;for(pe=pe.toLowerCase(),Ce=Ce.toLowerCase();_e<Ce.length&&(ze=a(pe,Ce,0,_e,Me))===null;)_e=h(Ce,_e+1);return ze}e.matchesWords=i;function a(pe,Ce,Me,ze,_e){if(Me===pe.length)return[];if(ze===Ce.length)return null;if(f(pe.charCodeAt(Me),Ce.charCodeAt(ze))){let Ke=null,X=ze+1;if(Ke=a(pe,Ce,Me+1,ze+1,_e),!_e)for(;!Ke&&(X=h(Ce,X))<Ce.length;)Ke=a(pe,Ce,Me+1,X,_e),X++;return Ke===null?null:w({start:ze,end:ze+1},Ke)}else return null}function h(pe,Ce){for(let Me=Ce;Me<pe.length;Me++)if(l(pe.charCodeAt(Me))||Me>0&&l(pe.charCodeAt(Me-1)))return Me;return pe.length}const p=A(e.matchesPrefix,s,y),S=A(e.matchesPrefix,s,k),u=new b.LRUCache(1e4);function v(pe,Ce,Me=!1){if(typeof pe!="string"||typeof Ce!="string")return null;let ze=u.get(pe);ze||(ze=new RegExp(I.convertSimple2RegExpPattern(pe),"i"),u.set(pe,ze));const _e=ze.exec(Ce);return _e?[{start:_e.index,end:_e.index+_e[0].length}]:Me?S(pe,Ce):p(pe,Ce)}e.matchesFuzzy=v;function R(pe,Ce){const Me=z(pe,pe.toLowerCase(),0,Ce,Ce.toLowerCase(),0,!0);return Me?j(Me):null}e.matchesFuzzy2=R;function N(pe,Ce,Me,ze,_e,Ke){const X=Math.min(13,pe.length);for(;Me<X;Me++){const ne=z(pe,Ce,Me,ze,_e,Ke,!1);if(ne)return ne}return[0,Ke]}e.anyScore=N;function j(pe){if(typeof pe=="undefined")return[];const Ce=[],Me=pe[1];for(let ze=pe.length-1;ze>1;ze--){const _e=pe[ze]+Me,Ke=Ce[Ce.length-1];Ke&&Ke.end===_e?Ke.end=_e+1:Ce.push({start:_e,end:_e+1})}return Ce}e.createMatches=j;const ie=128;function K(){const pe=[],Ce=[];for(let Me=0;Me<=ie;Me++)Ce[Me]=0;for(let Me=0;Me<=ie;Me++)pe.push(Ce.slice(0));return pe}function B(pe){const Ce=[];for(let Me=0;Me<=pe;Me++)Ce[Me]=0;return Ce}const $=B(2*ie),U=B(2*ie),L=K(),O=K(),M=K(),F=!1;function W(pe,Ce,Me,ze,_e){function Ke(ne,we,xe=" "){for(;ne.length<we;)ne=xe+ne;return ne}let X=` |   |${ze.split("").map(ne=>Ke(ne,3)).join("|")}
`;for(let ne=0;ne<=Me;ne++)ne===0?X+=" |":X+=`${Ce[ne-1]}|`,X+=pe[ne].slice(0,_e+1).map(we=>Ke(we.toString(),3)).join("|")+`
`;return X}function q(pe,Ce,Me,ze){pe=pe.substr(Ce),Me=Me.substr(ze),console.log(W(O,pe,pe.length,Me,Me.length)),console.log(W(M,pe,pe.length,Me,Me.length)),console.log(W(L,pe,pe.length,Me,Me.length))}function Q(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;const Me=pe.codePointAt(Ce);switch(Me){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!I.isEmojiImprecise(Me)}}function le(pe,Ce){if(Ce<0||Ce>=pe.length)return!1;switch(pe.charCodeAt(Ce)){case 32:case 9:return!0;default:return!1}}function ve(pe,Ce,Me){return Ce[pe]!==Me[pe]}function Re(pe,Ce,Me,ze,_e,Ke,X=!1){for(;Ce<Me&&_e<Ke;)pe[Ce]===ze[_e]&&(X&&($[Ce]=_e),Ce+=1),_e+=1;return Ce===Me}e.isPatternInWord=Re;var Se;(function(pe){pe[pe.Diag=1]="Diag",pe[pe.Left=2]="Left",pe[pe.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var Oe;(function(pe){pe.Default=[-100,0];function Ce(Me){return!Me||Me.length===2&&Me[0]===-100&&Me[1]===0}pe.isDefault=Ce})(Oe=e.FuzzyScore||(e.FuzzyScore={}));function z(pe,Ce,Me,ze,_e,Ke,X){const ne=pe.length>ie?ie:pe.length,we=ze.length>ie?ie:ze.length;if(!(Me>=ne||Ke>=we||ne-Me>we-Ke)&&!!Re(Ce,Me,ne,_e,Ke,we,!0)){Y(ne,we,Me,Ke,Ce,_e);let xe=1,je=1,Ve=Me,Ze=Ke;const De=[!1];for(xe=1,Ve=Me;Ve<ne;xe++,Ve++){const H=$[Ve],Z=U[Ve],ce=Ve+1<ne?U[Ve+1]:we;for(je=H-Ke+1,Ze=H;Ze<ce;je++,Ze++){let Ie=Number.MIN_SAFE_INTEGER,Ae=!1;Ze<=Z&&(Ie=ee(pe,Ce,Ve,Me,ze,_e,Ze,we,Ke,L[xe-1][je-1]===0,De));let Le=0;Ie!==Number.MAX_SAFE_INTEGER&&(Ae=!0,Le=Ie+O[xe-1][je-1]);const $e=Ze>H,Xe=$e?O[xe][je-1]+(L[xe][je-1]>0?-5:0):0,rt=Ze>H+1&&L[xe][je-1]>0,tt=rt?O[xe][je-2]+(L[xe][je-2]>0?-5:0):0;if(rt&&(!$e||tt>=Xe)&&(!Ae||tt>=Le))O[xe][je]=tt,M[xe][je]=3,L[xe][je]=0;else if($e&&(!Ae||Xe>=Le))O[xe][je]=Xe,M[xe][je]=2,L[xe][je]=0;else if(Ae)O[xe][je]=Le,M[xe][je]=1,L[xe][je]=L[xe-1][je-1]+1;else throw new Error("not possible")}}if(F&&q(pe,Me,ze,Ke),!(!De[0]&&!X)){xe--,je--;const ye=[O[xe][je],Ke];let Pe=0,oe=0;for(;xe>=1;){let H=je;do{const Z=M[xe][H];if(Z===3)H=H-2;else if(Z===2)H=H-1;else break}while(H>=1);Pe>1&&Ce[Me+xe-1]===_e[Ke+je-1]&&!ve(H+Ke-1,ze,_e)&&Pe+1>L[xe][H]&&(H=je),H===je?Pe++:Pe=1,oe||(oe=H),xe--,je=H-1,ye.push(je)}we===ne&&(ye[0]+=2);const ue=oe-ne;return ye[0]-=ue,ye}}}e.fuzzyScore=z;function Y(pe,Ce,Me,ze,_e,Ke){let X=pe-1,ne=Ce-1;for(;X>=Me&&ne>=ze;)_e[X]===Ke[ne]&&(U[X]=ne,X--),ne--}function ee(pe,Ce,Me,ze,_e,Ke,X,ne,we,xe,je){if(Ce[Me]!==Ke[X])return Number.MIN_SAFE_INTEGER;let Ve=1,Ze=!1;return X===Me-ze?Ve=pe[Me]===_e[X]?7:5:ve(X,_e,Ke)&&(X===0||!ve(X-1,_e,Ke))?(Ve=pe[Me]===_e[X]?7:5,Ze=!0):Q(Ke,X)&&(X===0||!Q(Ke,X-1))?Ve=5:(Q(Ke,X-1)||le(Ke,X-1))&&(Ve=5,Ze=!0),Ve>1&&Me===ze&&(je[0]=!0),Ze||(Ze=ve(X,_e,Ke)||Q(Ke,X-1)||le(Ke,X-1)),Me===ze?X>we&&(Ve-=Ze?3:5):xe?Ve+=Ze?2:0:Ve+=Ze?0:1,X+1===ne&&(Ve-=Ze?3:5),Ve}function se(pe,Ce,Me,ze,_e,Ke,X){return Ee(pe,Ce,Me,ze,_e,Ke,!0,X)}e.fuzzyScoreGracefulAggressive=se;function fe(pe,Ce,Me,ze,_e,Ke,X){return Ee(pe,Ce,Me,ze,_e,Ke,!1,X)}e.fuzzyScoreGraceful=fe;function Ee(pe,Ce,Me,ze,_e,Ke,X,ne){let we=z(pe,Ce,Me,ze,_e,Ke,ne);if(we&&!X)return we;if(pe.length>=3){const xe=Math.min(7,pe.length-1);for(let je=Me+1;je<xe;je++){const Ve=Be(pe,je);if(Ve){const Ze=z(Ve,Ve.toLowerCase(),Me,ze,_e,Ke,ne);Ze&&(Ze[0]-=3,(!we||Ze[0]>we[0])&&(we=Ze))}}}return we}function Be(pe,Ce){if(!(Ce+1>=pe.length)){const Me=pe[Ce],ze=pe[Ce+1];if(Me!==ze)return pe.slice(0,Ce)+ze+Me+pe.slice(Ce+2)}}}),define(me[136],ge([0,1,43,98,9]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function k(f){return f.replace(y,(E,w)=>w?E:`\\${E}`)}e.escapeIcons=k;const D=new RegExp(`\\\\${T.source}`,"g");function P(f){return f.replace(D,E=>`\\${E}`)}e.markdownEscapeEscapedIcons=P;const r=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function C(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(r,(E,w,_,d)=>_?E:w||d||"")}e.stripIcons=C;function g(f){const E=f.indexOf(e.iconStartMarker);return E===-1?{text:f}:m(f,E)}e.parseLabelWithIcons=g;function m(f,E){const w=[];let _="";function d(h){if(h){_+=h;for(const p of h)w.push(t)}}let o=-1,c="",t=0,n,s,i=E;const a=f.length;for(d(f.substr(0,E));i<a;)n=f[i],s=f[i+1],n===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(o=i,d(c),c=e.iconStartMarker,i++):n===")"&&o!==-1?(t+=i-o+1,o=-1,c=""):o!==-1?/^[a-z0-9\-]$/i.test(n)?c+=n:(d(c),o=-1,c=""):d(n),i++;return d(c),{text:_,iconOffsets:w}}function l(f,E,w=!1){const{text:_,iconOffsets:d}=E;if(!d||d.length===0)return(0,I.matchesFuzzy)(f,_,w);const o=(0,A.ltrim)(_," "),c=_.length-o.length,t=(0,I.matchesFuzzy)(f,o,w);if(t)for(const n of t){const s=d[n.start+c]+c;n.start+=s,n.end+=s}return t}e.matchesFuzzyIconAware=l}),define(me[99],ge([0,1,16,136,17]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(f="",E=!1){var w,_;if(this.value=f,typeof this.value!="string")throw(0,A.illegalArgument)("value");typeof E=="boolean"?(this.isTrusted=E,this.supportThemeIcons=!1):(this.isTrusted=(w=E.isTrusted)!==null&&w!==void 0?w:void 0,this.supportThemeIcons=(_=E.supportThemeIcons)!==null&&_!==void 0?_:!1)}appendText(f,E=0){return this.value+=C(this.supportThemeIcons?(0,I.escapeIcons)(f):f).replace(/([ \t]+)/g,(w,_)=>"&nbsp;".repeat(_.length)).replace(/^>/gm,"\\>").replace(/\n/g,E===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,E){return this.value+="\n```",this.value+=f,this.value+=`
`,this.value+=E,this.value+="\n```\n",this}}e.MarkdownString=y;function k(l){return D(l)?!l.value:Array.isArray(l)?l.every(k):!0}e.isEmptyMarkdownString=k;function D(l){return l instanceof y?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function P(l,f){return!l&&!f?!0:!l||!f?!1:Array.isArray(l)&&Array.isArray(f)?(0,b.equals)(l,f,r):D(l)&&D(f)?r(l,f):!1}e.markedStringsEquals=P;function r(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons}function C(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function g(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function m(l){const f=[],E=l.split("|").map(_=>_.trim());l=E[0];const w=E[1];if(w){const _=/height=(\d+)/.exec(w),d=/width=(\d+)/.exec(w),o=_?_[1]:"",c=d?d[1]:"",t=isFinite(parseInt(c)),n=isFinite(parseInt(o));t&&f.push(`width="${c}"`),n&&f.push(`height="${o}"`)}return{href:l,dimensions:f}}e.parseHrefAndDimensions=m}),define(me[59],ge([0,1,23,9,2]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(P){return JSON.stringify(P,k)}e.stringify=T;function y(P){let r=JSON.parse(P);return r=D(r),r}e.parse=y;function k(P,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:(0,I.regExpFlags)(r)}:r}function D(P,r=0){if(!P||r>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return A.URI.revive(P);case 2:return new RegExp(P.source,P.flags)}if(P instanceof b.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let C=0;C<P.length;++C)P[C]=D(P[C],r+1);else for(const C in P)Object.hasOwnProperty.call(P,C)&&(P[C]=D(P[C],r+1))}return P}e.revive=D}),define(me[12],ge([0,1,2,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var A;(function(k){k.inMemory="inmemory",k.vscode="vscode",k.internal="private",k.walkThrough="walkThrough",k.walkThroughSnippet="walkThroughSnippet",k.http="http",k.https="https",k.file="file",k.mailto="mailto",k.untitled="untitled",k.data="data",k.command="command",k.vscodeRemote="vscode-remote",k.vscodeRemoteResource="vscode-remote-resource",k.userData="vscode-userdata",k.vscodeCustomEditor="vscode-custom-editor",k.vscodeNotebook="vscode-notebook",k.vscodeNotebookCell="vscode-notebook-cell",k.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",k.vscodeNotebookCellOutput="vscode-notebook-cell-output",k.vscodeSettings="vscode-settings",k.vscodeWorkspaceTrust="vscode-workspace-trust",k.vscodeTerminal="vscode-terminal",k.webviewPanel="webview-panel",k.vscodeWebview="vscode-webview",k.extension="extension",k.vscodeFileResource="vscode-file",k.tmp="tmp"})(A=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,P,r){this._hosts[D]=P,this._ports[D]=r}setConnectionToken(D,P){this._connectionTokens[D]=P}rewrite(D){if(this._delegate)return this._delegate(D);const P=D.authority;let r=this._hosts[P];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const C=this._ports[P],g=this._connectionTokens[P];let m=`path=${encodeURIComponent(D.path)}`;return typeof g=="string"&&(m+=`&tkn=${encodeURIComponent(g)}`),b.URI.from({scheme:I.isWeb?this._preferredWebSchema:A.vscodeRemoteResource,authority:`${r}:${C}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(D,P,r){const C=this.toUri(D,P);return C.scheme===A.vscodeRemote?e.RemoteAuthorities.rewrite(C):I.isNative&&(r||I.isPreferringBrowserCodeLoad)&&C.scheme===A.file?C.with({scheme:A.vscodeFileResource,authority:C.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(D,P){const r=this.toUri(D,P);return r.scheme===A.vscodeFileResource?r.with({scheme:A.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(D,P){return b.URI.isUri(D)?D:b.URI.parse(P.toUrl(D))}}e.FileAccess=new y}),define(me[75],ge([0,1,22]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const I=new b.LRUCache(1e4);function A(P){return D(P,"NFC",I)}e.normalizeNFC=A;const T=new b.LRUCache(1e4);function y(P){return D(P,"NFD",T)}e.normalizeNFD=y;const k=/[^\u0000-\u0080]/;function D(P,r,C){if(!e.canNormalize||!P)return P;const g=C.get(P);if(g)return g;let m;return k.test(P)?m=P.normalize(r):m=P,C.set(P,m),m}e.removeAccents=function(){if(e.canNormalize){const P=/[\u0300-\u036f]/g;return function(r){return y(r).replace(P,"")}}else return function(P){return P}}()}),define(me[25],ge([0,1,29,8,2,9,12,10]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(m){return(0,A.uriToFsPath)(m,!0)}e.originalFSPath=D;class P{constructor(l){this._ignorePathCasing=l}compare(l,f,E=!1){return l===f?0:(0,T.compare)(this.getComparisonKey(l,E),this.getComparisonKey(f,E))}isEqual(l,f,E=!1){return l===f?!0:!l||!f?!1:this.getComparisonKey(l,E)===this.getComparisonKey(f,E)}getComparisonKey(l,f=!1){return l.with({path:this._ignorePathCasing(l)?l.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(l){return this._ignorePathCasing(l)}isEqualOrParent(l,f,E=!1){if(l.scheme===f.scheme){if(l.scheme===y.Schemas.file)return b.isEqualOrParent(D(l),D(f),this._ignorePathCasing(l))&&l.query===f.query&&(E||l.fragment===f.fragment);if((0,e.isEqualAuthority)(l.authority,f.authority))return b.isEqualOrParent(l.path,f.path,this._ignorePathCasing(l),"/")&&l.query===f.query&&(E||l.fragment===f.fragment)}return!1}joinPath(l,...f){return A.URI.joinPath(l,...f)}basenameOrAuthority(l){return(0,e.basename)(l)||l.authority}basename(l){return I.posix.basename(l.path)}extname(l){return I.posix.extname(l.path)}dirname(l){if(l.path.length===0)return l;let f;return l.scheme===y.Schemas.file?f=A.URI.file(I.dirname(D(l))).path:(f=I.posix.dirname(l.path),l.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${l.toString})) resulted in a relative path`),f="/")),l.with({path:f})}normalizePath(l){if(!l.path.length)return l;let f;return l.scheme===y.Schemas.file?f=A.URI.file(I.normalize(D(l))).path:f=I.posix.normalize(l.path),l.with({path:f})}relativePath(l,f){if(!(l.scheme!==f.scheme||!(0,e.isEqualAuthority)(l.authority,f.authority))){if(l.scheme===y.Schemas.file){const _=I.relative(D(l),D(f));return k.isWindows?b.toSlashes(_):_}let E=l.path||"/",w=f.path||"/";if(this._ignorePathCasing(l)){let _=0;for(const d=Math.min(E.length,w.length);_<d&&!(E.charCodeAt(_)!==w.charCodeAt(_)&&E.charAt(_).toLowerCase()!==w.charAt(_).toLowerCase());_++);E=w.substr(0,_)+E.substr(_)}return I.posix.relative(E,w)}}resolvePath(l,f){if(l.scheme===y.Schemas.file){const E=A.URI.file(I.resolve(D(l),f));return l.with({authority:E.authority,path:E.path})}return f.indexOf("/")===-1&&(f=b.toSlashes(f),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f)),l.with({path:I.posix.resolve(l.path,f)})}isAbsolutePath(l){return!!l.path&&l.path[0]==="/"}isEqualAuthority(l,f){return l===f||(0,T.equalsIgnoreCase)(l,f)}hasTrailingPathSeparator(l,f=I.sep){if(l.scheme===y.Schemas.file){const E=D(l);return E.length>b.getRoot(E).length&&E[E.length-1]===f}else{const E=l.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(l.fsPath)}}removeTrailingPathSeparator(l,f=I.sep){return(0,e.hasTrailingPathSeparator)(l,f)?l.with({path:l.path.substr(0,l.path.length-1)}):l}addTrailingPathSeparator(l,f=I.sep){let E=!1;if(l.scheme===y.Schemas.file){const w=D(l);E=w!==void 0&&w.length===b.getRoot(w).length&&w[w.length-1]===f}else{f="/";const w=l.path;E=w.length===1&&w.charCodeAt(w.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(l,f)?l.with({path:l.path+"/"}):l}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(m=>m.scheme===y.Schemas.file?!k.isLinux:!0),e.extUriIgnorePathCase=new P(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(m,l){const f=[];for(let E=0;E<m.length;E++){const w=l(m[E]);m.some((_,d)=>d===E?!1:(0,e.isEqualOrParent)(w,l(_)))||f.push(m[E])}return f}e.distinctParents=r;var C;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function l(f){const E=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(d=>{const[o,c]=d.split(":");o&&c&&E.set(o,c)});const _=f.path.substring(0,f.path.indexOf(";"));return _&&E.set(m.META_DATA_MIME,_),E}m.parseMetaData=l})(C=e.DataUri||(e.DataUri={}));function g(m,l,f){if(l){let E=m.path;return E&&E[0]!==I.posix.sep&&(E=I.posix.sep+E),m.with({scheme:f,authority:l,path:E})}return m.with({scheme:f})}e.toLocalResource=g}),define(me[13],ge([0,1,21,17,3,6,57,25]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(O){return!!O&&typeof O.then=="function"}e.isThenable=D;function P(O){const M=new b.CancellationTokenSource,F=O(M.token),W=new Promise((q,Q)=>{M.token.onCancellationRequested(()=>{Q((0,I.canceled)())}),Promise.resolve(F).then(le=>{M.dispose(),q(le)},le=>{M.dispose(),Q(le)})});return new class{cancel(){M.cancel()}then(q,Q){return W.then(q,Q)}catch(q){return this.then(void 0,q)}finally(q){return W.finally(q)}}}e.createCancelablePromise=P;function r(O,M,F){return Promise.race([O,new Promise(W=>M.onCancellationRequested(()=>W(F)))])}e.raceCancellation=r;async function C(O){let M=-1;const F=O.map((q,Q)=>q.then(le=>(M=Q,le))),W=await Promise.race(F);return O.forEach((q,Q)=>{Q!==M&&q.cancel()}),W}e.raceCancellablePromises=C;function g(O,M,F){let W;const q=setTimeout(()=>{W==null||W(void 0),F==null||F()},M);return Promise.race([O.finally(()=>clearTimeout(q)),new Promise(Q=>W=Q)])}e.raceTimeout=g;function m(O){return new Promise((M,F)=>{const W=O();D(W)?W.then(M,F):M(W)})}e.asPromise=m;class l{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const F=()=>{this.queuedPromise=null;const W=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,W};this.queuedPromise=new Promise(W=>{this.activePromise.then(F,F).then(W)})}return new Promise((F,W)=>{this.queuedPromise.then(F,W)})}return this.activePromise=M(),new Promise((F,W)=>{this.activePromise.then(q=>{this.activePromise=null,F(q)},q=>{this.activePromise=null,W(q)})})}}e.Throttler=l;class f{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=f;class E{constructor(){this.promiseMap=new Map}queue(M,F){var W;const Q=((W=this.promiseMap.get(M))!==null&&W!==void 0?W:Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.promiseMap.get(M)===Q&&this.promiseMap.delete(M)});return this.promiseMap.set(M,Q),Q}}e.SequencerByKey=E;class w{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,F=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((W,q)=>{this.doResolve=W,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const W=this.task;return this.task=null,W()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},F),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,I.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class _{constructor(M){this.delayer=new w(M),this.throttler=new l}trigger(M,F){return this.delayer.trigger(()=>this.throttler.queue(M),F)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class d{constructor(){this._isOpen=!1,this._promise=new Promise((M,F)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=d;class o extends d{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=o;function c(O,M){return M?new Promise((F,W)=>{const q=setTimeout(F,O);M.onCancellationRequested(()=>{clearTimeout(q),W((0,I.canceled)())})}):P(F=>c(O,F))}e.timeout=c;function t(O,M=0){const F=setTimeout(O,M);return(0,T.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=t;function n(O){return O.then(void 0,M=>{})}e.ignoreErrors=n;function s(O){const M=[];let F=0;const W=O.length;function q(){return F<W?O[F++]():null}function Q(le){le!=null&&M.push(le);const ve=q();return ve?ve.then(Q):Promise.resolve(M)}return Promise.resolve(null).then(Q)}e.sequence=s;function i(O,M=W=>!!W,F=null){let W=0;const q=O.length,Q=()=>{if(W>=q)return Promise.resolve(F);const le=O[W++];return Promise.resolve(le()).then(Re=>M(Re)?Promise.resolve(Re):Q())};return Q()}e.first=i;function a(O,M=W=>!!W,F=null){if(O.length===0)return Promise.resolve(F);let W=O.length;const q=()=>{var Q,le;W=-1;for(const ve of O)(le=(Q=ve).cancel)===null||le===void 0||le.call(Q)};return new Promise((Q,le)=>{for(const ve of O)ve.then(Re=>{--W>=0&&M(Re)?(q(),Q(Re)):W===0&&Q(F)}).catch(Re=>{--W>=0&&(q(),le(Re))})})}e.firstParallel=a;class h{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new A.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((F,W)=>{this.outstandingPromises.push({factory:M,c:F,e:W}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const F=M.factory();F.then(M.c,M.e),F.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=h;class p extends h{constructor(){super(1)}}e.Queue=p;class S{constructor(){this.queues=new Map}queueFor(M,F=k.extUri){const W=F.getComparisonKey(M);let q=this.queues.get(W);return q||(q=new p,A.Event.once(q.onFinished)(()=>{q==null||q.dispose(),this.queues.delete(W)}),this.queues.set(W,q)),q}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=S;class u{constructor(M,F){this._token=-1,typeof M=="function"&&typeof F=="number"&&this.setIfNotSet(M,F)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},F)}setIfNotSet(M,F){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},F))}}e.TimeoutTimer=u;class v{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,F){this.cancel(),this._token=setInterval(()=>{M()},F)}}e.IntervalTimer=v;class R{constructor(M,F){this.timeoutToken=-1,this.runner=M,this.timeout=F,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class N extends R{constructor(M,F){super(M,F);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const O=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const F=setTimeout(()=>M(O));let W=!1;return{dispose(){W||(W=!0,clearTimeout(F))}}}}else e.runWhenIdle=(O,M)=>{const F=requestIdleCallback(O,typeof M=="number"?{timeout:M}:void 0);let W=!1;return{dispose(){W||(W=!0,cancelIdleCallback(F))}}}}();class j{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(F){this._error=F}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function ie(O,M,F){let W;for(let q=0;q<F;q++)try{return await O()}catch(Q){W=Q,await c(M)}throw W}e.retry=ie;class K{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,F,W){return this._pending={taskId:M,cancel:()=>W==null?void 0:W(),promise:F},F.then(()=>this.donePending(M),()=>this.donePending(M)),F}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let F,W;const q=new Promise((Q,le)=>{F=Q,W=le});this._next={run:M,promise:q,promiseResolve:F,promiseReject:W}}return this._next.promise}}e.TaskSequentializer=K;class B{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=B;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,F)=>{this.completeCallback=M,this.errorCallback=F})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(F=>{this.completeCallback(M),this.resolved=!0,F()})}error(M){return new Promise(F=>{this.errorCallback(M),this.rejected=!0,F()})}cancel(){new Promise(M=>{this.errorCallback((0,I.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=$;class U extends A.Emitter{async fireAsync(M,F,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const q of this._listeners)this._asyncDeliveryQueue.push([q,M]);for(;this._asyncDeliveryQueue.size>0&&!F.isCancellationRequested;){const[q,Q]=this._asyncDeliveryQueue.shift(),le=[],ve=Object.assign(Object.assign({},Q),{waitUntil:Re=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");W&&(Re=W(Re,typeof q=="function"?q:q[0])),le.push(Re)}});try{typeof q=="function"?q.call(void 0,ve):q[0].call(q[1],ve)}catch(Re){(0,I.onUnexpectedError)(Re);continue}Object.freeze(le),await L.settled(le).catch(Re=>(0,I.onUnexpectedError)(Re))}}}}e.AsyncEmitter=U;var L;(function(O){async function M(Q){return typeof Promise.allSettled=="function"?F(Q):W(Q)}O.allSettled=M;async function F(Q){return Promise.allSettled(Q)}async function W(Q){return Promise.all(Q.map(le=>le.then(ve=>({status:"fulfilled",value:ve}),ve=>({status:"rejected",reason:ve}))))}async function q(Q){let le;const ve=await Promise.all(Q.map(Re=>Re.then(Se=>Se,Se=>{le||(le=Se)})));if(typeof le!="undefined")throw le;return ve}O.settled=q})(L=e.Promises||(e.Promises={}))}),define(me[100],ge([0,1,8,13]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const A=new I.IdleValue(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),T=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new I.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function k(u,v,R=!1){const N=u||"",j=v||"",ie=A.value.collator.compare(N,j);return A.value.collatorIsNumeric&&ie===0&&N!==j?N<j?-1:1:ie}e.compareFileNames=k;function D(u,v){const R=T.value.collator;return u=u||"",v=v||"",c(R,u,v)}e.compareFileNamesDefault=D;function P(u,v){const R=T.value.collator;return u=u||"",v=v||"",i(u,v)||c(R,u,v)}e.compareFileNamesUpper=P;function r(u,v){const R=T.value.collator;return u=u||"",v=v||"",s(u,v)||c(R,u,v)}e.compareFileNamesLower=r;function C(u,v){return u=u||"",v=v||"",u===v?0:u<v?-1:1}e.compareFileNamesUnicode=C;function g(u,v,R=!1){R||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase());const[N,j]=d(u),[ie,K]=d(v);return N!==ie?N<ie?-1:1:j===K?0:j<K?-1:1}e.noIntlCompareFileNames=g;function m(u,v){const[R,N]=d(u),[j,ie]=d(v);let K=A.value.collator.compare(N,ie);if(K===0){if(A.value.collatorIsNumeric&&N!==ie)return N<ie?-1:1;if(K=A.value.collator.compare(R,j),A.value.collatorIsNumeric&&K===0&&R!==j)return R<j?-1:1}return K}e.compareFileExtensions=m;function l(u,v){u=u||"",v=v||"";const R=o(u),N=o(v),j=T.value.collator,ie=y.value.collator;return c(ie,R,N)||c(j,u,v)}e.compareFileExtensionsDefault=l;function f(u,v){u=u||"",v=v||"";const R=o(u),N=o(v),j=T.value.collator,ie=y.value.collator;return c(ie,R,N)||i(u,v)||c(j,u,v)}e.compareFileExtensionsUpper=f;function E(u,v){u=u||"",v=v||"";const R=o(u),N=o(v),j=T.value.collator,ie=y.value.collator;return c(ie,R,N)||s(u,v)||c(j,u,v)}e.compareFileExtensionsLower=E;function w(u,v){u=u||"",v=v||"";const R=o(u).toLowerCase(),N=o(v).toLowerCase();return R!==N?R<N?-1:1:u!==v?u<v?-1:1:0}e.compareFileExtensionsUnicode=w;const _=/^(.*?)(\.([^.]*))?$/;function d(u,v=!1){const R=u?_.exec(u):[];let N=[R&&R[1]||"",R&&R[3]||""];return v&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function o(u){const v=u?_.exec(u):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function c(u,v,R){let N=u.compare(v,R);return N!==0?N:v.length!==R.length?v.length<R.length?-1:1:0}function t(u){const v=u.charAt(0);return v.toLocaleUpperCase()!==v}function n(u){const v=u.charAt(0);return v.toLocaleLowerCase()!==v}function s(u,v){return t(u)&&n(v)?-1:n(u)&&t(v)?1:0}function i(u,v){return n(u)&&t(v)?-1:t(u)&&n(v)?1:0}function a(u,v,R=!1){return R||(u=u&&u.toLowerCase(),v=v&&v.toLowerCase()),u===v?0:u<v?-1:1}function h(u,v,R=!1){const N=u.split(b.sep),j=v.split(b.sep),ie=N.length-1,K=j.length-1;let B,$;for(let U=0;;U++){if(B=ie===U,$=K===U,B&&$)return k(N[U],j[U],R);if(B)return-1;if($)return 1;const L=a(N[U],j[U],R);if(L!==0)return L}}e.comparePaths=h;function p(u,v,R){const N=u.toLowerCase(),j=v.toLowerCase(),ie=S(u,v,R);if(ie)return ie;const K=N.endsWith(R),B=j.endsWith(R);if(K!==B)return K?-1:1;const $=k(N,j);return $!==0?$:N.localeCompare(j)}e.compareAnything=p;function S(u,v,R){const N=u.toLowerCase(),j=v.toLowerCase(),ie=N.startsWith(R),K=j.startsWith(R);if(ie!==K)return ie?-1:1;if(ie&&K){if(N.length<j.length)return-1;if(N.length>j.length)return 1}return 0}e.compareByPrefix=S}),define(me[101],ge([0,1,100,98,8,10,9]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const k=0,D=[k,[]];function P(B,$,U,L){if(!B||!$)return D;const O=B.length,M=$.length;if(O<M)return D;const F=B.toLowerCase();return!L&&!F.includes(U)?D:r($,U,M,B,F,O)}e.scoreFuzzy=P;function r(B,$,U,L,O,M){const F=[],W=[];for(let ve=0;ve<U;ve++){const Re=ve*M,Se=Re-M,Oe=ve>0,z=B[ve],Y=$[ve];for(let ee=0;ee<M;ee++){const se=ee>0,fe=Re+ee,Ee=fe-1,Be=Se+ee-1,pe=se?F[Ee]:0,Ce=Oe&&se?F[Be]:0,Me=Oe&&se?W[Be]:0;let ze;!Ce&&Oe?ze=0:ze=C(z,Y,L,O,ee,Me),ze&&Ce+ze>=pe?(W[fe]=Me+1,F[fe]=Ce+ze):(W[fe]=k,F[fe]=pe)}}const q=[];let Q=U-1,le=M-1;for(;Q>=0&&le>=0;){const ve=Q*M+le;W[ve]===k||(q.push(le),Q--),le--}return[F[U*M-1],q.reverse()]}function C(B,$,U,L,O,M){let F=0;if(!g($,L[O]))return F;if(F+=1,M>0&&(F+=M*5),B===U[O]&&(F+=1),O===0)F+=8;else{const W=m(U.charCodeAt(O-1));W?F+=W:(0,I.isUpper)(U.charCodeAt(O))&&(F+=2)}return F}function g(B,$){return B===$?!0:B==="/"||B==="\\"?$==="/"||$==="\\":!1}function m(B){switch(B){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const l=[void 0,[]];function f(B,$,U=0,L=0){const O=$;return O.values&&O.values.length>1?E(B,O.values,U,L):w(B,$,U,L)}e.scoreFuzzy2=f;function E(B,$,U,L){let O=0;const M=[];for(const F of $){const[W,q]=w(B,F,U,L);if(typeof W!="number")return l;O+=W,M.push(...q)}return[O,h(M)]}function w(B,$,U,L){const O=(0,I.fuzzyScore)($.original,$.originalLowercase,U,B,B.toLowerCase(),L,!0);return O?[O[0],(0,I.createMatches)(O)]:l}const _=Object.freeze({score:0}),d=1<<18,o=1<<17,c=1<<16;function t(B,$,U,L,O){if(!B||!$.normalized)return _;const M=L.getItemLabel(B);if(!M)return _;const F=L.getItemDescription(B);let W;F?W=`${M}${F}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`:W=`${M}${$.normalized}${Array.isArray($.values)?$.values.length:""}${U}`;const q=O[W];if(q)return q;const Q=n(M,F,L.getItemPath(B),$,U);return O[W]=Q,Q}e.scoreItemFuzzy=t;function n(B,$,U,L,O){const M=!U||!L.containsPathSeparator;return U&&(T.isLinux?L.pathNormalized===U:(0,y.equalsIgnoreCase)(L.pathNormalized,U))?{score:d,labelMatch:[{start:0,end:B.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:L.values&&L.values.length>1?s(B,$,U,L.values,M,O):i(B,$,U,L,M,O)}function s(B,$,U,L,O,M){let F=0;const W=[],q=[];for(const Q of L){const{score:le,labelMatch:ve,descriptionMatch:Re}=i(B,$,U,Q,O,M);if(le===k)return _;F+=le,ve&&W.push(...ve),Re&&q.push(...Re)}return{score:F,labelMatch:h(W),descriptionMatch:h(q)}}function i(B,$,U,L,O,M){if(O||!$){const[F,W]=P(B,L.normalized,L.normalizedLowercase,M);if(F){const q=(0,I.matchesPrefix)(L.normalized,B);let Q;return q?(Q=o,Q+=Math.round(L.normalized.length/B.length*100)):Q=c,{score:Q+F,labelMatch:q||a(W)}}}if($){let F=$;U&&(F=`${$}${A.sep}`);const W=F.length,q=`${F}${B}`,[Q,le]=P(q,L.normalized,L.normalizedLowercase,M);if(Q){const ve=a(le),Re=[],Se=[];return ve.forEach(Oe=>{Oe.start<W&&Oe.end>W?(Re.push({start:0,end:Oe.end-W}),Se.push({start:Oe.start,end:W})):Oe.start>=W?Re.push({start:Oe.start-W,end:Oe.end-W}):Se.push(Oe)}),{score:Q,labelMatch:Re,descriptionMatch:Se}}}return _}function a(B){const $=[];if(!B)return $;let U;for(const L of B)U&&U.end===L?U.end+=1:(U={start:L,end:L+1},$.push(U));return $}function h(B){const $=B.sort((O,M)=>O.start-M.start),U=[];let L;for(const O of $)!L||!p(L,O)?(L=O,U.push(O)):(L.start=Math.min(L.start,O.start),L.end=Math.max(L.end,O.end));return U}function p(B,$){return!(B.end<$.start||$.end<B.start)}function S(B,$,U,L,O,M){const F=t(B,U,L,O,M),W=t($,U,L,O,M),q=F.score,Q=W.score;if((q===d||Q===d)&&q!==Q)return q===d?-1:1;if(q>c||Q>c){if(q!==Q)return q>Q?-1:1;if(q<o&&Q<o){const Y=v(F.labelMatch,W.labelMatch);if(Y!==0)return Y}const Oe=O.getItemLabel(B)||"",z=O.getItemLabel($)||"";if(Oe.length!==z.length)return Oe.length-z.length}if(q!==Q)return q>Q?-1:1;const le=Array.isArray(F.labelMatch)&&F.labelMatch.length>0,ve=Array.isArray(W.labelMatch)&&W.labelMatch.length>0;if(le&&!ve)return-1;if(ve&&!le)return 1;const Re=u(B,F,O),Se=u($,W,O);return Re&&Se&&Re!==Se?Se>Re?-1:1:R(B,$,U,O)}e.compareItemsByFuzzyScore=S;function u(B,$,U){let L=-1,O=-1;if($.descriptionMatch&&$.descriptionMatch.length?L=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(L=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(O=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const M=U.getItemDescription(B);M&&(O+=M.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(O=$.descriptionMatch[$.descriptionMatch.length-1].end);return O-L}function v(B,$){if(!B&&!$||(!B||!B.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!B||!B.length)return 1;const U=B[0].start,O=B[B.length-1].end-U,M=$[0].start,W=$[$.length-1].end-M;return O===W?0:W<O?1:-1}function R(B,$,U,L){const O=L.getItemLabel(B)||"",M=L.getItemLabel($)||"",F=L.getItemDescription(B),W=L.getItemDescription($),q=O.length+(F?F.length:0),Q=M.length+(W?W.length:0);if(q!==Q)return q-Q;const le=L.getItemPath(B),ve=L.getItemPath($);return le&&ve&&le.length!==ve.length?le.length-ve.length:O!==M?(0,b.compareAnything)(O,M,U.normalized):F&&W&&F!==W?(0,b.compareAnything)(F,W,U.normalized):le&&ve&&le!==ve?(0,b.compareAnything)(le,ve,U.normalized):0}const N=" ";function j(B){typeof B!="string"&&(B="");const $=B.toLowerCase(),{pathNormalized:U,normalized:L,normalizedLowercase:O}=ie(B),M=U.indexOf(A.sep)>=0;let F;const W=B.split(N);if(W.length>1)for(const q of W){const{pathNormalized:Q,normalized:le,normalizedLowercase:ve}=ie(q);le&&(F||(F=[]),F.push({original:q,originalLowercase:q.toLowerCase(),pathNormalized:Q,normalized:le,normalizedLowercase:ve}))}return{original:B,originalLowercase:$,pathNormalized:U,normalized:L,normalizedLowercase:O,values:F,containsPathSeparator:M}}e.prepareQuery=j;function ie(B){let $;T.isWindows?$=B.replace(/\//g,A.sep):$=B.replace(/\\/g,A.sep);const U=(0,y.stripWildcards)($).replace(/\s/g,"");return{pathNormalized:$,normalized:U,normalizedLowercase:U.toLowerCase()}}function K(B){return Array.isArray(B)?j(B.map($=>$.original).join(N)):j(B.original)}e.pieceToQuery=K}),define(me[33],ge([0,1,9,29,8,22,13]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function k(){return Object.create(null)}e.getEmptyExpression=k;const D="**",P="/",r="[/\\\\]",C="[^/\\\\]",g=/\//g;function m(F){switch(F){case 0:return"";case 1:return`${C}*?`;default:return`(?:${r}|${C}+${r}|${r}${C}+)*?`}}function l(F,W){if(!F)return[];const q=[];let Q=!1,le=!1,ve="";for(const Re of F){switch(Re){case W:if(!Q&&!le){q.push(ve),ve="";continue}break;case"{":Q=!0;break;case"}":Q=!1;break;case"[":le=!0;break;case"]":le=!1;break}ve+=Re}return ve&&q.push(ve),q}e.splitGlobAware=l;function f(F){if(!F)return"";let W="";const q=l(F,P);if(q.every(Q=>Q===D))W=".*";else{let Q=!1;q.forEach((le,ve)=>{if(le===D){Q||(W+=m(2),Q=!0);return}let Re=!1,Se="",Oe=!1,z="";for(const Y of le){if(Y!=="}"&&Re){Se+=Y;continue}if(Oe&&(Y!=="]"||!z)){let ee;Y==="-"?ee=Y:(Y==="^"||Y==="!")&&!z?ee="^":Y===P?ee="":ee=b.escapeRegExpCharacters(Y),z+=ee;continue}switch(Y){case"{":Re=!0;continue;case"[":Oe=!0;continue;case"}":W+=`(?:${l(Se,",").map(fe=>f(fe)).join("|")})`,Re=!1,Se="";break;case"]":W+="["+z+"]",Oe=!1,z="";break;case"?":W+=C;continue;case"*":W+=m(1);continue;default:W+=b.escapeRegExpCharacters(Y)}}ve<q.length-1&&(q[ve+1]!==D||ve+2<q.length)&&(W+=r),Q=!1})}return W}const E=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,d=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},s=function(){return null};function i(F,W){if(!F)return s;let q;typeof F!="string"?q=F.pattern:q=F,q=q.trim();const Q=`${q}_${!!W.trimForExclusions}`;let le=t.get(Q);if(le)return a(le,F);let ve;if(E.test(q)){const Re=q.substr(4);le=function(Se,Oe){return typeof Se=="string"&&Se.endsWith(Re)?q:null}}else(ve=w.exec(h(q,W)))?le=p(ve[1],q):(W.trimForExclusions?d:_).test(q)?le=S(q,W):(ve=o.exec(h(q,W)))?le=u(ve[1].substr(1),q,!0):(ve=c.exec(h(q,W)))?le=u(ve[1],q,!1):le=v(q);return t.set(Q,le),a(le,F)}function a(F,W){return typeof W=="string"?F:function(q,Q){return I.isEqualOrParent(q,W.base)?F(A.relative(W.base,q),Q):null}}function h(F,W){return W.trimForExclusions&&F.endsWith("/**")?F.substr(0,F.length-2):F}function p(F,W){const q=`/${F}`,Q=`\\${F}`,le=function(Re,Se){return typeof Re!="string"?null:Se?Se===F?W:null:Re===F||Re.endsWith(q)||Re.endsWith(Q)?W:null},ve=[F];return le.basenames=ve,le.patterns=[W],le.allBasenames=ve,le}function S(F,W){const q=M(F.slice(1,-1).split(",").map(Se=>i(Se,W)).filter(Se=>Se!==s),F),Q=q.length;if(!Q)return s;if(Q===1)return q[0];const le=function(Se,Oe){for(let z=0,Y=q.length;z<Y;z++)if(q[z](Se,Oe))return F;return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function u(F,W,q){const Q=A.sep===A.posix.sep,le=Q?F:F.replace(g,A.sep),ve=A.sep+le,Re=A.posix.sep+F,Se=q?function(Oe,z){return typeof Oe=="string"&&(Oe===le||Oe.endsWith(ve)||!Q&&(Oe===F||Oe.endsWith(Re)))?W:null}:function(Oe,z){return typeof Oe=="string"&&(Oe===le||!Q&&Oe===F)?W:null};return Se.allPaths=[(q?"*/":"./")+F],Se}function v(F){try{const W=new RegExp(`^${f(F)}$`);return function(q){return W.lastIndex=0,typeof q=="string"&&W.test(q)?F:null}}catch(W){return s}}function R(F,W,q){return!F||typeof W!="string"?!1:N(F)(W,void 0,q)}e.match=R;function N(F,W={}){if(!F)return n;if(typeof F=="string"||B(F)){const q=i(F,W);if(q===s)return n;const Q=function(le,ve){return!!q(le,ve)};return q.allBasenames&&(Q.allBasenames=q.allBasenames),q.allPaths&&(Q.allPaths=q.allPaths),Q}return L(F,W)}e.parse=N;function j(F){if(!!F){let W;return q=>(W||(W=(F()||Promise.resolve([])).then(Q=>Q?K(Q):{})),W.then(Q=>!!Q[q]))}}e.hasSiblingPromiseFn=j;function ie(F){if(!!F){let W;return q=>{if(!W){const Q=F();W=Q?K(Q):{}}return!!W[q]}}}e.hasSiblingFn=ie;function K(F){const W={};for(const q of F)W[q]=!0;return W}function B(F){const W=F;return W&&typeof W.base=="string"&&typeof W.pattern=="string"}e.isRelativePattern=B;function $(F){return F.allBasenames||[]}e.getBasenameTerms=$;function U(F){return F.allPaths||[]}e.getPathTerms=U;function L(F,W){const q=M(Object.getOwnPropertyNames(F).map(Se=>O(Se,F[Se],W)).filter(Se=>Se!==s)),Q=q.length;if(!Q)return s;if(!q.some(Se=>!!Se.requiresSiblings)){if(Q===1)return q[0];const Se=function(Y,ee){for(let se=0,fe=q.length;se<fe;se++){const Ee=q[se](Y,ee);if(Ee)return Ee}return null},Oe=q.find(Y=>!!Y.allBasenames);Oe&&(Se.allBasenames=Oe.allBasenames);const z=q.reduce((Y,ee)=>ee.allPaths?Y.concat(ee.allPaths):Y,[]);return z.length&&(Se.allPaths=z),Se}const le=function(Se,Oe,z){let Y;for(let ee=0,se=q.length;ee<se;ee++){const fe=q[ee];fe.requiresSiblings&&z&&(Oe||(Oe=A.basename(Se)),Y||(Y=Oe.substr(0,Oe.length-A.extname(Se).length)));const Ee=fe(Se,Oe,Y,z);if(Ee)return Ee}return null},ve=q.find(Se=>!!Se.allBasenames);ve&&(le.allBasenames=ve.allBasenames);const Re=q.reduce((Se,Oe)=>Oe.allPaths?Se.concat(Oe.allPaths):Se,[]);return Re.length&&(le.allPaths=Re),le}function O(F,W,q){if(W===!1)return s;const Q=i(F,q);if(Q===s)return s;if(typeof W=="boolean")return Q;if(W){const le=W.when;if(typeof le=="string"){const ve=(Re,Se,Oe,z)=>{if(!z||!Q(Re,Se))return null;const Y=le.replace("$(basename)",Oe),ee=z(Y);return(0,y.isThenable)(ee)?ee.then(se=>se?F:null):ee?F:null};return ve.requiresSiblings=!0,ve}}return Q}function M(F,W){const q=F.filter(Se=>!!Se.basenames);if(q.length<2)return F;const Q=q.reduce((Se,Oe)=>{const z=Oe.basenames;return z?Se.concat(z):Se},[]);let le;if(W){le=[];for(let Se=0,Oe=Q.length;Se<Oe;Se++)le.push(W)}else le=q.reduce((Se,Oe)=>{const z=Oe.patterns;return z?Se.concat(z):Se},[]);const ve=function(Se,Oe){if(typeof Se!="string")return null;if(!Oe){let Y;for(Y=Se.length;Y>0;Y--){const ee=Se.charCodeAt(Y-1);if(ee===47||ee===92)break}Oe=Se.substr(Y)}const z=Q.indexOf(Oe);return z!==-1?le[z]:null};ve.basenames=Q,ve.patterns=le,ve.allBasenames=Q;const Re=F.filter(Se=>!Se.basenames);return Re.push(ve),Re}}),define(me[76],ge([0,1,2,8,9,12,10,25,29]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function P(i,a,h){if(typeof i=="string"&&(i=b.URI.file(i)),h){const S=h.getWorkspaceFolder(i);if(S){const u=h.getWorkspace().folders.length>1;let v;if((0,k.isEqual)(S.uri,i)?v="":v=(0,k.relativePath)(S.uri,i),u){const R=S.name?S.name:(0,k.basename)(S.uri);v=v?R+" \u2022 "+v:R}return v}}if(i.scheme!==T.Schemas.file&&i.scheme!==T.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,D.hasDriveLetter)(i.fsPath))return(0,I.normalize)(C(i.fsPath));let p=(0,I.normalize)(i.fsPath);return!y.isWindows&&(a==null?void 0:a.userHome)&&(p=m(p,a.userHome.fsPath)),p}e.getPathLabel=P;function r(i){if(!!i){typeof i=="string"&&(i=b.URI.file(i));const a=(0,k.basename)(i)||(i.scheme===T.Schemas.file?i.fsPath:i.path);return y.isWindows&&(0,D.isRootOrDriveLetter)(a)?C(a):a}}e.getBaseLabel=r;function C(i){return(0,D.hasDriveLetter)(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=C;let g=Object.create(null);function m(i,a){if(y.isWindows||!i||!a)return i;let h=g.original===a?g.normalized:void 0;return h||(h=`${(0,A.rtrim)(a,I.posix.sep)}${I.posix.sep}`,g={original:a,normalized:h}),(y.isLinux?i.startsWith(h):(0,A.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=m;function l(i,a){return i.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=l;const f="\u2026",E="\\\\",w="~";function _(i,a=I.sep){const h=new Array(i.length);let p=!1;for(let S=0;S<i.length;S++){let u=i[S];if(u===""){h[S]=`.${a}`;continue}if(!u){h[S]=u;continue}p=!0;let v="";u.indexOf(E)===0?(v=u.substr(0,u.indexOf(E)+E.length),u=u.substr(u.indexOf(E)+E.length)):u.indexOf(a)===0?(v=u.substr(0,u.indexOf(a)+a.length),u=u.substr(u.indexOf(a)+a.length)):u.indexOf(w)===0&&(v=u.substr(0,u.indexOf(w)+w.length),u=u.substr(u.indexOf(w)+w.length));const R=u.split(a);for(let N=1;p&&N<=R.length;N++)for(let j=R.length-N;p&&j>=0;j--){p=!1;let ie=R.slice(j,j+N).join(a);for(let K=0;!p&&K<i.length;K++)if(K!==S&&i[K]&&i[K].indexOf(ie)>-1){const B=j+N===R.length,$=j>0&&i[K].indexOf(a)>-1?a+ie:ie,U=i[K].endsWith($);p=!B||U}if(!p){let K="";(R[0].endsWith(":")||v!=="")&&(j===1&&(j=0,N++,ie=R[0]+a+ie),j>0&&(K=R[0]+a),K=v+K),j>0&&(K=K+f+a),K=K+ie,j+N<R.length&&(K=K+a+f),h[S]=K}}p&&(h[S]=u)}return h}e.shorten=_;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function o(i,a=Object.create(null)){const h=[];let p=!1,S="";for(const u of i)if(u==="$"||p&&u==="{")S&&h.push({value:S,type:d.TEXT}),S="",p=!0;else if(u==="}"&&p){const v=a[S];if(typeof v=="string")v.length&&h.push({value:v,type:d.VARIABLE});else if(v){const R=h[h.length-1];(!R||R.type!==d.SEPARATOR)&&h.push({value:v.label,type:d.SEPARATOR})}S="",p=!1}else S+=u;return S&&!p&&h.push({value:S,type:d.TEXT}),h.filter((u,v)=>{if(u.type===d.SEPARATOR){const R=h[v-1],N=h[v+1];return[R,N].every(j=>j&&(j.type===d.VARIABLE||j.type===d.TEXT)&&j.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=o;function c(i,a){return y.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function t(i,a){return y.isMacintosh||a?i.replace(/\(&&\w\)|&&/g,""):y.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=n;function s(i){const a=i.indexOf("/")!==-1?I.posix:I.win32,h=a.basename(i),p=a.dirname(i);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}e.splitName=s}),define(me[102],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(r){return r.toJSON()}class A{constructor(C){this._uriTransformer=C}transformIncoming(C){const g=this._uriTransformer.transformIncoming(C);return g===C?C:I(b.URI.from(g))}transformOutgoing(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:I(b.URI.from(g))}transformOutgoingURI(C){const g=this._uriTransformer.transformOutgoing(C);return g===C?C:b.URI.from(g)}transformOutgoingScheme(C){return this._uriTransformer.transformOutgoingScheme(C)}}e.URITransformer=A,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function T(r,C,g){if(!r||g>200)return null;if(typeof r=="object"){if(r instanceof b.URI)return C.transformOutgoing(r);for(let m in r)if(Object.hasOwnProperty.call(r,m)){const l=T(r[m],C,g+1);l!==null&&(r[m]=l)}}return null}function y(r,C){const g=T(r,C,0);return g===null?r:g}e.transformOutgoingURIs=y;function k(r,C,g,m){if(!r||m>200)return null;if(typeof r=="object"){if(r.$mid===1)return g?b.URI.revive(C.transformIncoming(r)):C.transformIncoming(r);for(let l in r)if(Object.hasOwnProperty.call(r,l)){const f=k(r[l],C,g,m+1);f!==null&&(r[l]=f)}}return null}function D(r,C){const g=k(r,C,!1,0);return g===null?r:g}e.transformIncomingURIs=D;function P(r,C){const g=k(r,C,!0,0);return g===null?r:g}e.transformAndReviveIncomingURIs=P}),define(me[30],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function I(D){return b.test(D)}e.isUUID=I;const A=new Uint8Array(16),T=[];for(let D=0;D<256;D++)T.push(D.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(D){for(let P=0;P<D.length;P++)D[P]=Math.floor(Math.random()*256);return D};function k(){y(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let D=0,P="";return P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P+="-",P+=T[A[D++]],P+=T[A[D++]],P+="-",P+=T[A[D++]],P+=T[A[D++]],P+="-",P+=T[A[D++]],P+=T[A[D++]],P+="-",P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P+=T[A[D++]],P}e.generateUuid=k}),define(me[137],ge([0,1,103]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class I{constructor(T="utf8"){this.stringDecoder=new b.StringDecoder(T),this.remaining=null}write(T){const y=[],k=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(k.length<1)return y;let D=0,P,r=D;for(;r<k.length;)if(P=k.charCodeAt(r),P===13||P===10){if(y.push(k.substring(D,r)),r++,r<k.length){const C=P;P=k.charCodeAt(r),(C===13&&P===10||C===10&&P===13)&&r++}D=r}else r++;return this.remaining=D<k.length?k.substr(D):null,y}end(){return this.remaining}}e.LineDecoder=I}),define(me[26],ge([0,1,37,48,8,13,10,29,30,75,25,2]),function(G,e,b,I,A,T,y,k,D,P,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var g;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function m($,U=g.UNLINK){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return U===g.UNLINK?f($):l($)}e.rimraf=m;async function l($){try{const U=(0,A.join)((0,I.tmpdir)(),(0,D.generateUuid)());try{await b.promises.rename($,U)}catch(L){return f($)}f(U).catch(L=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function f($){return b.promises.rmdir($,{recursive:!0,maxRetries:3})}function E($){if((0,k.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");b.rmdirSync($,{recursive:!0})}e.rimrafSync=E;async function w($,U){return o(await(U?_($):b.promises.readdir($)))}e.readdir=w;async function _($){try{return await b.promises.readdir($,{withFileTypes:!0})}catch(O){console.warn("[node.js fs] readdir with filetypes failed with error: ",O)}const U=[],L=await w($);for(const O of L){let M=!1,F=!1,W=!1;try{const q=await b.promises.lstat((0,A.join)($,O));M=q.isFile(),F=q.isDirectory(),W=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:O,isFile:()=>M,isDirectory:()=>F,isSymbolicLink:()=>W})}return U}function d($){return o(b.readdirSync($))}e.readdirSync=d;function o($){return $.map(U=>typeof U=="string"?y.isMacintosh?(0,P.normalizeNFC)(U):U:(U.name=y.isMacintosh?(0,P.normalizeNFC)(U.name):U.name,U))}async function c($){const U=await w($),L=[];for(const O of U)await n.existsDirectory((0,A.join)($,O))&&L.push(O);return L}e.readDirsInDir=c;function t($,U=1e3){return new Promise(L=>{let O=!1;const M=setInterval(()=>{O||(O=!0,b.access($,F=>{O=!1,F&&(clearInterval(M),L(void 0))}))},U)})}e.whenDeleted=t;var n;(function($){async function U(M){let F;try{if(F=await b.promises.lstat(M),!F.isSymbolicLink())return{stat:F}}catch(W){}try{return{stat:await b.promises.stat(M),symbolicLink:(F==null?void 0:F.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(y.isWindows&&W.code==="EACCES")try{return{stat:await b.promises.stat(await b.promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw q}throw W}}$.stat=U;async function L(M){try{const{stat:F,symbolicLink:W}=await $.stat(M);return F.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(F){}return!1}$.existsFile=L;async function O(M){try{const{stat:F,symbolicLink:W}=await $.stat(M);return F.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(F){}return!1}$.existsDirectory=O})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new T.ResourceQueue;function i($,U,L){return s.queueFor(C.URI.file($),r.extUriBiasedIgnorePathCase).queue(()=>{const O=S(L);return new Promise((M,F)=>h($,U,O,W=>W?F(W):M()))})}e.writeFile=i;let a=!0;function h($,U,L,O){if(!a)return b.writeFile($,U,{mode:L.mode,flag:L.flag},O);b.open($,L.flag,L.mode,(M,F)=>{if(M)return O(M);b.writeFile(F,U,W=>{if(W)return b.close(F,()=>O(W));b.fdatasync(F,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),a=!1),b.close(F,Q=>O(Q))))})})}function p($,U,L){const O=S(L);if(!a)return b.writeFileSync($,U,{mode:O.mode,flag:O.flag});const M=b.openSync($,O.flag,O.mode);try{b.writeFileSync(M,U);try{b.fdatasyncSync(M)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a=!1}}finally{b.closeSync(M)}}e.writeFileSync=p;function S($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function u($,U){if($!==U){async function L(O){try{const M=await b.promises.lstat(O);if(M.isDirectory()||M.isSymbolicLink())return;const F=await b.promises.open(O,"a");try{await F.utimes(M.atime,new Date)}finally{await F.close()}}catch(M){}}try{await b.promises.rename($,U),await L(U)}catch(O){if($.toLowerCase()!==U.toLowerCase()&&O.code==="EXDEV"||$.endsWith("."))await v($,U,{preserveSymlinks:!1}),await m($,g.MOVE),await L(U);else throw O}}}e.move=u;async function v($,U,L){return N($,U,{root:{source:$,target:U},options:L,handledSourcePaths:new Set})}e.copy=v;const R=511;async function N($,U,L){if(!L.handledSourcePaths.has($)){L.handledSourcePaths.add($);const{stat:O,symbolicLink:M}=await n.stat($);if(M){if(L.options.preserveSymlinks)try{return await K($,U,L)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(M.dangling)return}return O.isDirectory()?j($,U,O.mode&R,L):ie($,U,O.mode&R)}}async function j($,U,L,O){await b.promises.mkdir(U,{recursive:!0,mode:L});const M=await w($);for(const F of M)await N((0,A.join)($,F),(0,A.join)(U,F),O)}async function ie($,U,L){await b.promises.copyFile($,U),await b.promises.chmod(U,L)}async function K($,U,L){let O=await b.promises.readlink($);(0,k.isEqualOrParent)(O,L.root.source,!y.isLinux)&&(O=(0,A.join)(L.root.target,O.substr(L.root.source.length+1))),await b.promises.symlink(O,U)}async function B($){try{return await b.promises.access($),!0}catch(U){return!1}}e.exists=B}),define(me[104],ge([0,1,37,284,9,8,26]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function k(C){const g=(0,T.dirname)(C);if(C===g)return C;const m=((0,T.basename)(C)||C).toLowerCase();try{const f=(0,y.readdirSync)(g).filter(E=>E.toLowerCase()===m);if(f.length===1){const E=k(g);if(E)return(0,T.join)(E,f[0])}else if(f.length>1){const E=f.indexOf(m);if(E>=0){const w=k(g);if(w)return(0,T.join)(w,f[E])}}}catch(l){}return null}e.realcaseSync=k;async function D(C){try{return await(0,I.promisify)(b.realpath)(C)}catch(g){const m=r(C);return await b.promises.access(m,b.constants.R_OK),m}}e.realpath=D;function P(C){try{return b.realpathSync(C)}catch(g){const m=r(C);return b.accessSync(m,b.constants.R_OK),m}}e.realpathSync=P;function r(C){return(0,A.rtrim)((0,T.normalize)(C),T.sep)}});var Et=this&&this.__await||function(G){return this instanceof Et?(this.v=G,this):new Et(G)},Mn=this&&this.__asyncGenerator||function(G,e,b){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var I=b.apply(G,e||[]),A,T=[];return A={},y("next"),y("throw"),y("return"),A[Symbol.asyncIterator]=function(){return this},A;function y(g){I[g]&&(A[g]=function(m){return new Promise(function(l,f){T.push([g,m,l,f])>1||k(g,m)})})}function k(g,m){try{D(I[g](m))}catch(l){C(T[0][3],l)}}function D(g){g.value instanceof Et?Promise.resolve(g.value.v).then(P,r):C(T[0][2],g)}function P(g){k("next",g)}function r(g){k("throw",g)}function C(g,m){g(m),T.shift(),T.length&&k(T[0][0],T[0][1])}},mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(T){b[T]=G[T]&&function(y){return new Promise(function(k,D){y=G[T](y),A(k,D,y.done,y.value)})}}function A(T,y,k,D){Promise.resolve(D).then(function(P){T({value:P,done:k})},y)}};define(me[105],ge([0,1,26,48,8]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,y=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var D;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(D||(D={}));let P;switch(process.arch){case"ia32":case"x32":P=1;break;case"arm":case"arm64":P=2;break;default:P=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class C{constructor(c,t,n){this.exePath=c,this.displayName=t,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function g({useAlternateBitness:o=!1}={}){return o?P===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:o=!1,findPreview:c=!1}={}){const t=g({useAlternateBitness:o});if(!t)return null;const n=A.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(n))return null;let s=-1,i=null;for(const p of await b.readdir(n)){let S=-1;if(c){const v=p.indexOf("-");if(v<0)continue;const R=p.substring(0,v);if(!T.test(R)||p.substring(v+1)!=="preview")continue;S=parseInt(R,10)}else{if(!T.test(p))continue;S=parseInt(p,10)}if(!(S<=s)){const u=A.join(n,p,"pwsh.exe");!await b.SymlinkSupport.existsFile(u)||(i=u,s=S)}}if(!i)return null;const a=t.includes("x86")?" (x86)":"",h=c?" Preview":"";return new C(i,`PowerShell${h}${a}`,!0)}async function l({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const c=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:n}=o?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:y,pwshMsixName:"PowerShell (Store)"};for(const s of await b.readdir(c))if(t.test(s)){const i=A.join(c,s,"pwsh.exe");return new C(i,n)}return null}function f(){const o=A.join(I.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function E(){const o=A.join(process.env.windir,P===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}function w(){return Mn(this,arguments,function*(){let c=yield Et(m());c&&(yield yield Et(c)),c=yield Et(m({useAlternateBitness:!0})),c&&(yield yield Et(c)),c=yield Et(l()),c&&(yield yield Et(c)),c=f(),c&&(yield yield Et(c)),c=yield Et(m({findPreview:!0})),c&&(yield yield Et(c)),c=yield Et(l({findPreview:!0})),c&&(yield yield Et(c)),c=yield Et(m({useAlternateBitness:!0,findPreview:!0})),c&&(yield yield Et(c)),c=E(),c&&(yield yield Et(c))})}function _(){return Mn(this,arguments,function*(){var c,t;try{for(var n=mn(w()),s;s=yield Et(n.next()),!s.done;){const i=s.value;(yield Et(i.exists()))&&(yield yield Et(i))}}catch(i){c={error:i}}finally{try{s&&!s.done&&(t=n.return)&&(yield Et(t.call(n)))}finally{if(c)throw c.error}}})}e.enumeratePowerShellInstallations=_;async function d(){var o,c;try{for(var t=mn(_()),n;n=await t.next(),!n.done;)return n.value}catch(s){o={error:s}}finally{try{n&&!n.done&&(c=t.return)&&await c.call(t)}finally{if(o)throw o.error}}return null}e.getFirstAvailablePowerShellInstallation=d});var qe=this&&this.__decorate||function(G,e,b,I){var A=arguments.length,T=A<3?e:I===null?I=Object.getOwnPropertyDescriptor(e,b):I,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(G,e,b,I);else for(var k=G.length-1;k>=0;k--)(y=G[k])&&(T=(A<3?y(T):A>3?y(e,b,T):y(e,b))||T);return A>3&&T&&Object.defineProperty(e,b,T),T};define(me[106],ge([0,1,3,6,13,21,17,23,16,11,59,9,54]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function l(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function E(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(w||(w={}));class _{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class d{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function c(M){const F=k.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function t(M){return M.read(4).readUInt32BE(0)}function n(M){const F=k.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object)},i=typeof Buffer!="undefined";function a(M,F){if(typeof F=="undefined")M.write(s.Undefined);else if(typeof F=="string"){const W=k.VSBuffer.fromString(F);M.write(s.String),M.write(c(W.byteLength)),M.write(W)}else if(i&&Buffer.isBuffer(F)){const W=k.VSBuffer.wrap(F);M.write(s.Buffer),M.write(c(W.byteLength)),M.write(W)}else if(F instanceof k.VSBuffer)M.write(s.VSBuffer),M.write(c(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(s.Array),M.write(c(F.length));for(const W of F)a(M,W)}else{const W=k.VSBuffer.fromString(JSON.stringify(F));M.write(s.Object),M.write(c(W.byteLength)),M.write(W)}}function h(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(t(M)).toString();case o.Buffer:return M.read(t(M)).buffer;case o.VSBuffer:return M.read(t(M));case o.Array:{const W=t(M),q=[];for(let Q=0;Q<W;Q++)q.push(h(M));return q}case o.Object:return JSON.parse(M.read(t(M)).toString())}}class p{constructor(F,W,q=null,Q=1e3){this.protocol=F,this.ctx=W,this.logger=q,this.timeoutDelay=Q,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(le=>this.onRawMessage(le)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger&&this.logger.logOutgoing(W,0,1,E(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger&&this.logger.logOutgoing(W,F.id,1,E(F.type),F.data);return}}}send(F,W=void 0){const q=new d;return a(q,F),a(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onRawMessage(F){const W=new _(F),q=h(W),Q=h(W),le=q[0];switch(le){case 100:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}: ${q[2]}.${q[3]}`,Q),this.onPromise({type:le,id:q[1],channelName:q[2],name:q[3],arg:Q});case 102:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}: ${q[2]}.${q[3]}`,Q),this.onEventListen({type:le,id:q[1],channelName:q[2],name:q[3],arg:Q});case 101:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}`),this.disposeActiveRequest({type:le,id:q[1]});case 103:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],1,`${l(le)}`),this.disposeActiveRequest({type:le,id:q[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=new T.CancellationTokenSource;let Q;try{Q=W.call(this.ctx,F.name,F.arg,q.token)}catch(Re){Q=Promise.reject(Re)}const le=F.id;Q.then(Re=>{this.sendResponse({id:le,data:Re,type:201}),this.activeRequests.delete(F.id)},Re=>{Re instanceof Error?this.sendResponse({id:le,data:{message:Re.message,name:Re.name,stack:Re.stack?Re.stack.split?Re.stack.split(`
`):Re.stack:void 0},type:202}):this.sendResponse({id:le,data:Re,type:203}),this.activeRequests.delete(F.id)});const ve=(0,I.toDisposable)(()=>q.cancel());this.activeRequests.set(F.id,ve)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=F.id,le=W.listen(this.ctx,F.name,F.arg)(ve=>this.sendResponse({id:q,data:ve,type:204}));this.activeRequests.set(F.id,le)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:q})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}e.ChannelServer=p;var S;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(S=e.RequestInitiator||(e.RequestInitiator={}));class u{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(F){const W=this;return{call(q,Q,le){return W.isDisposed?Promise.reject(y.canceled()):W.requestPromise(F,q,Q,le)},listen(q,Q){return W.isDisposed?Promise.reject(y.canceled()):W.requestEvent(F,q,Q)}}}requestPromise(F,W,q,Q=T.CancellationToken.None){const le=this.lastRequestId++,Re={id:le,type:100,channelName:F,name:W,arg:q};if(Q.isCancellationRequested)return Promise.reject(y.canceled());let Se;return new Promise((z,Y)=>{if(Q.isCancellationRequested)return Y(y.canceled());const ee=()=>{const Be=pe=>{switch(pe.type){case 201:this.handlers.delete(le),z(pe.data);break;case 202:this.handlers.delete(le);const Ce=new Error(pe.data.message);Ce.stack=pe.data.stack,Ce.name=pe.data.name,Y(Ce);break;case 203:this.handlers.delete(le),Y(pe.data);break}};this.handlers.set(le,Be),this.sendRequest(Re)};let se=null;this.state===w.Idle?ee():(se=(0,A.createCancelablePromise)(Be=>this.whenInitialized()),se.then(()=>{se=null,ee()}));const fe=()=>{se?(se.cancel(),se=null):this.sendRequest({id:le,type:101}),Y(y.canceled())},Ee=Q.onCancellationRequested(fe);Se=(0,I.combinedDisposable)((0,I.toDisposable)(fe),Ee),this.activeRequests.add(Se)}).finally(()=>{this.activeRequests.delete(Se)})}requestEvent(F,W,q){const Q=this.lastRequestId++,ve={id:Q,type:102,channelName:F,name:W,arg:q};let Re=null;const Se=new b.Emitter({onFirstListenerAdd:()=>{Re=(0,A.createCancelablePromise)(z=>this.whenInitialized()),Re.then(()=>{Re=null,this.activeRequests.add(Se),this.sendRequest(ve)})},onLastListenerRemove:()=>{Re?(Re.cancel(),Re=null):(this.activeRequests.delete(Se),this.sendRequest({id:Q,type:103}))}}),Oe=z=>Se.fire(z.data);return this.handlers.set(Q,Oe),Se.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger&&this.logger.logOutgoing(W,F.id,0,`${l(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger&&this.logger.logOutgoing(W,F.id,0,l(F.type));return}}}send(F,W=void 0){const q=new d;return a(q,F),a(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch(W){return 0}}onBuffer(F){const W=new _(F),q=h(W),Q=h(W),le=q[0];switch(le){case 200:return this.logger&&this.logger.logIncoming(F.byteLength,0,0,E(le)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(F.byteLength,q[1],0,E(le),Q),this.onResponse({type:q[0],id:q[1],data:Q})}}onResponse(F){if(F.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const W=this.handlers.get(F.id);W&&W(F)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(F=>F.dispose()),this.activeRequests.clear()}}qe([g.memoize],u.prototype,"onDidInitializePromise",null),e.ChannelClient=u;class v{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:q})=>{b.Event.once(W.onMessage)(le=>{const ve=new _(le),Re=h(ve),Se=new p(W,Re),Oe=new u(W);this.channels.forEach((Y,ee)=>Se.registerChannel(ee,Y));const z={channelServer:Se,channelClient:Oe,ctx:Re};this._connections.add(z),this._onDidAddConnection.fire(z),q(()=>{Se.dispose(),Oe.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const q=this;return{call(Q,le,ve){let Re;if((0,P.isFunction)(W)){let Oe=(0,D.getRandomElement)(q.connections.filter(W));Re=Oe?Promise.resolve(Oe):b.Event.toPromise(b.Event.filter(q.onDidAddConnection,W))}else Re=W.routeCall(q,Q,le);const Se=Re.then(Oe=>Oe.channelClient.getChannel(F));return N(Se).call(Q,le,ve)},listen(Q,le){if((0,P.isFunction)(W))return q.getMulticastEvent(F,W,Q,le);const ve=W.routeEvent(q,Q,le).then(Re=>Re.channelClient.getChannel(F));return N(ve).listen(Q,le)}}}getMulticastEvent(F,W,q,Q){const le=this;let ve=new I.DisposableStore;const Re=new b.Emitter({onFirstListenerAdd:()=>{ve=new I.DisposableStore;const Se=new b.EventMultiplexer,Oe=new Map,z=ee=>{const fe=ee.channelClient.getChannel(F).listen(q,Q),Ee=Se.add(fe);Oe.set(ee,Ee)},Y=ee=>{const se=Oe.get(ee);!se||(se.dispose(),Oe.delete(ee))};le.connections.filter(W).forEach(z),b.Event.filter(le.onDidAddConnection,W)(z,void 0,ve),le.onDidRemoveConnection(Y,void 0,ve),Se.event(Re.fire,Re,ve),ve.add(Se)},onLastListenerRemove:()=>{ve.dispose()}});return Re.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(q=>{q.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=v;class R{constructor(F,W,q=null){const Q=new d;a(Q,W),F.send(Q.buffer),this.channelClient=new u(F,q),this.channelServer=new p(F,W,q)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=R;function N(M){return{call(F,W,q){return M.then(Q=>Q.call(F,W,q))},listen(F,W){const q=new b.Relay;return M.then(Q=>q.input=Q.listen(F,W)),q.event}}}e.getDelayedChannel=N;function j(M){let F=!1;return{call(W,q,Q){return F?M.call(W,q,Q):(0,A.timeout)(0).then(()=>F=!0).then(()=>M.call(W,q,Q))},listen(W,q){if(F)return M.listen(W,q);const Q=new b.Relay;return(0,A.timeout)(0).then(()=>F=!0).then(()=>Q.input=M.listen(W,q)),Q.event}}}e.getNextTickChannel=j;class ie{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await b.Event.toPromise(F.onDidAddConnection),await this.route(F)}}e.StaticRouter=ie;var K;(function(M){function F(Q,le){const ve=Q,Re=le&&le.disableMarshalling,Se=new Map;for(const Oe in ve)q(Oe)&&Se.set(Oe,b.Event.buffer(ve[Oe],!0));return new class{listen(Oe,z){const Y=Se.get(z);if(Y)return Y;throw new Error(`Event not found: ${z}`)}call(Oe,z,Y){const ee=ve[z];if(typeof ee=="function"){if(!Re&&Array.isArray(Y))for(let se=0;se<Y.length;se++)Y[se]=(0,r.revive)(Y[se]);return ee.apply(ve,Y)}throw new Error(`Method not found: ${z}`)}}}M.fromService=F;function W(Q,le){const ve=le&&le.disableMarshalling;return new Proxy({},{get(Re,Se){var Oe;if(typeof Se=="string")return((Oe=le==null?void 0:le.properties)===null||Oe===void 0?void 0:Oe.has(Se))?le.properties.get(Se):q(Se)?Q.listen(Se):async function(...z){let Y;le&&!(0,P.isUndefinedOrNull)(le.context)?Y=[le.context,...z]:Y=z;const ee=await Q.call(Se,Y);return ve?ee:(0,r.revive)(ee)};throw new Error(`Property not found: ${String(Se)}`)}})}M.toService=W;function q(Q){return Q[0]==="o"&&Q[1]==="n"&&C.isUpperAsciiLetter(Q.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const B=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let F=M.toString();if(F!=="[object Object]")return F}return M}function U(M){return Array.isArray(M)?M.map($):$(M)}function L(M,F,W,q,Q,le,ve){ve=U(ve);const Re=B[Q],Se=Re[q%Re.length];let Oe=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${Se}`];/\($/.test(le)?(Oe=Oe.concat(ve),Oe.push(")")):Oe.push(ve),console.log.apply(console,Oe)}e.logWithColors=L;class O{constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,q,Q,le){this._totalOutgoing+=F,L(this._outgoingPrefix,this._totalOutgoing,F,W,q,Q,le)}logIncoming(F,W,q,Q,le){this._totalIncoming+=F,L(this._incomingPrefix,this._totalIncoming,F,W,q,Q,le)}}e.IPCLogger=O}),define(me[107],ge([0,1,3,106,6,23,10,36]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let D=null;function P(){return D||(D=T.VSBuffer.alloc(0)),D}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,i){if(s===0)return P();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const S=this._chunks[0];return i&&(this._chunks.shift(),this._totalLength-=s),S}if(this._chunks[0].byteLength>s){const S=this._chunks[0].slice(0,s);return i&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),S}let a=T.VSBuffer.alloc(s),h=0,p=0;for(;s>0;){const S=this._chunks[p];if(S.byteLength>s){const u=S.slice(0,s);a.set(u,h),h+=s,i&&(this._chunks[p]=S.slice(s),this._totalLength-=s),s-=s}else a.set(S,h),h+=S.byteLength,i?(this._chunks.shift(),this._totalLength-=S.byteLength):p++,s-=S.byteLength}return a}}e.ChunkStream=r;var C;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.KeepAlive=4]="KeepAlive",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest"})(C||(C={}));var g;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",n[n.KeepAliveTime=5e3]="KeepAliveTime",n[n.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(g=e.ProtocolConstants||(e.ProtocolConstants={}));class m{constructor(s,i,a,h){this.type=s,this.id=i,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class l extends A.Disposable{constructor(s){super();this._onMessage=this._register(new b.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(i=>this.acceptChunk(i))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const i=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=i.readUInt32BE(9),this._state.messageType=i.readUInt8(0),this._state.id=i.readUInt32BE(1),this._state.ack=i.readUInt32BE(5);else{const a=this._state.messageType,h=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new m(a,h,p,i)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class f{constructor(s){this._isDisposed=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(s){if(!this._isDisposed){s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const i=T.VSBuffer.alloc(13);i.writeUInt8(s.type,0),i.writeUInt32BE(s.id,1),i.writeUInt32BE(s.ack,5),i.writeUInt32BE(s.data.byteLength,9),this._writeSoon(i,s.data)}}_bufferAdd(s,i){const a=this._totalLength===0;return this._data.push(s,i),this._totalLength+=s.byteLength+i.byteLength,a}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,i){this._bufferAdd(s,i)&&y.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class E extends A.Disposable{constructor(s){super();this._onMessage=new b.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new b.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new f(this._socket)),this._socketReader=this._register(new l(this._socket)),this._register(this._socketReader.onMessage(i=>{i.type===1&&this._onMessage.fire(i.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new m(1,0,0,s))}}e.Protocol=E;class w extends I.IPCClient{constructor(s,i,a=null){super(s,i,a);this.protocol=s}static fromSocket(s,i){return new w(new E(s),i)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=w;class _{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new b.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,k.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=_;class d{constructor(s){this.data=s,this.next=null}}class o{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],i=0,a=this._first;for(;a;)s[i++]=a.data,a=a.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const i=new d(s);if(!this._first){this._first=i,this._last=i;return}this._last.next=i,this._last=i}}class c{constructor(){this.lastRuns=[];const s=Date.now();for(let i=0;i<c._HISTORY_LENGTH;i++)this.lastRuns[i]=s-1e3*i;setInterval(()=>{for(let i=c._HISTORY_LENGTH;i>=1;i--)this.lastRuns[i]=this.lastRuns[i-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return c._INSTANCE||(c._INSTANCE=new c),c._INSTANCE}load(){const s=Date.now(),i=(1+c._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<c._HISTORY_LENGTH;h++)s-this.lastRuns[h]<=i&&a++;return 1-a/c._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}c._HISTORY_LENGTH=10,c._INSTANCE=null;class t{constructor(s,i=null){this._loadEstimator=c.getInstance(),this._onControlMessage=new _,this.onControlMessage=this._onControlMessage.event,this._onMessage=new _,this.onMessage=this._onMessage.event,this._onDidDispose=new _,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new _,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new _,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new o,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=s,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),i&&this._socketReader.acceptChunk(i),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,A.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new m(5,0,0,P());this._socketWriter.write(s),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const s=Date.now()-this._socketWriter.lastWriteTime;if(s>=5e3){const i=new m(4,0,0,P());this._socketWriter.write(i),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-s+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const s=Date.now()-this._socketReader.lastReadTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-s,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,i){this._isReconnecting=!0,this._socketDisposables=(0,A.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=s,this._socketWriter=new f(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new l(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(i)}endAcceptReconnection(){this._isReconnecting=!1;const s=this._outgoingUnackMsg.toArray();for(let i=0,a=s.length;i<a;i++)this._socketWriter.write(s[i]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const i=this._outgoingUnackMsg.peek();if(i&&i.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(s.type===1){if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const i=Date.now();i-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=i,this._socketWriter.write(new m(6,0,0,P())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data)}else if(s.type===2)this._onControlMessage.fire(s.data);else if(s.type===5)this._onDidDispose.fire();else if(s.type===6){const i=this._outgoingUnackMsg.toArray();for(let a=0,h=i.length;a<h;a++)this._socketWriter.write(i[a]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const i=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new m(1,i,this._incomingAckId,s);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(s){const i=new m(2,0,0,s);this._socketWriter.write(i)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const s=this._outgoingUnackMsg.peek(),i=Date.now()-s.writtenTime;if(i>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-i,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const s=new m(3,0,this._incomingAckId,P());this._socketWriter.write(s)}}}e.PersistentProtocol=t}),define(me[108],ge([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class I{constructor(k){let D=(0,b.toUint8)(k);this._defaultValue=D,this._asciiMap=I._createAsciiMap(D),this._map=new Map}static _createAsciiMap(k){let D=new Uint8Array(256);for(let P=0;P<256;P++)D[P]=k;return D}set(k,D){let P=(0,b.toUint8)(D);k>=0&&k<256?this._asciiMap[k]=P:this._map.set(k,P)}get(k){return k>=0&&k<256?this._asciiMap[k]:this._map.get(k)||this._defaultValue}}e.CharacterClassifier=I;var A;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(A||(A={}));class T{constructor(){this._actual=new I(0)}add(k){this._actual.set(k,1)}has(k){return this._actual.get(k)===1}}e.CharacterSet=T}),define(me[138],ge([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var I;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(I=e.WordCharacterClass||(e.WordCharacterClass={}));class A extends b.CharacterClassifier{constructor(k){super(0);for(let D=0,P=k.length;D<P;D++)this.set(k.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=A;function T(y){let k={};return D=>(k.hasOwnProperty(D)||(k[D]=y(D)),k[D])}e.getMapForWordSeparators=T(y=>new A(y))}),define(me[49],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(A,T){this.lineNumber=A,this.column=T}with(A=this.lineNumber,T=this.column){return A===this.lineNumber&&T===this.column?this:new b(A,T)}delta(A=0,T=0){return this.with(this.lineNumber+A,this.column+T)}equals(A){return b.equals(this,A)}static equals(A,T){return!A&&!T?!0:!!A&&!!T&&A.lineNumber===T.lineNumber&&A.column===T.column}isBefore(A){return b.isBefore(this,A)}static isBefore(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<T.column}isBeforeOrEqual(A){return b.isBeforeOrEqual(this,A)}static isBeforeOrEqual(A,T){return A.lineNumber<T.lineNumber?!0:T.lineNumber<A.lineNumber?!1:A.column<=T.column}static compare(A,T){let y=A.lineNumber|0,k=T.lineNumber|0;if(y===k){let D=A.column|0,P=T.column|0;return D-P}return y-k}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(A){return new b(A.lineNumber,A.column)}static isIPosition(A){return A&&typeof A.lineNumber=="number"&&typeof A.column=="number"}}e.Position=b}),define(me[44],ge([0,1,49]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class I{constructor(T,y,k,D){T>k||T===k&&y>D?(this.startLineNumber=k,this.startColumn=D,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=k,this.endColumn=D)}isEmpty(){return I.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return I.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return I.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return I.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return I.plusRange(this,T)}static plusRange(T,y){let k,D,P,r;return y.startLineNumber<T.startLineNumber?(k=y.startLineNumber,D=y.startColumn):y.startLineNumber===T.startLineNumber?(k=y.startLineNumber,D=Math.min(y.startColumn,T.startColumn)):(k=T.startLineNumber,D=T.startColumn),y.endLineNumber>T.endLineNumber?(P=y.endLineNumber,r=y.endColumn):y.endLineNumber===T.endLineNumber?(P=y.endLineNumber,r=Math.max(y.endColumn,T.endColumn)):(P=T.endLineNumber,r=T.endColumn),new I(k,D,P,r)}intersectRanges(T){return I.intersectRanges(this,T)}static intersectRanges(T,y){let k=T.startLineNumber,D=T.startColumn,P=T.endLineNumber,r=T.endColumn,C=y.startLineNumber,g=y.startColumn,m=y.endLineNumber,l=y.endColumn;return k<C?(k=C,D=g):k===C&&(D=Math.max(D,g)),P>m?(P=m,r=l):P===m&&(r=Math.min(r,l)),k>P||k===P&&D>r?null:new I(k,D,P,r)}equalsRange(T){return I.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return I.getEndPosition(this)}static getEndPosition(T){return new b.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return I.getStartPosition(this)}static getStartPosition(T){return new b.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new I(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new I(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return I.collapseToStart(this)}static collapseToStart(T){return new I(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new I(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new I(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const P=T.startLineNumber|0,r=y.startLineNumber|0;if(P===r){const C=T.startColumn|0,g=y.startColumn|0;if(C===g){const m=T.endLineNumber|0,l=y.endLineNumber|0;if(m===l){const f=T.endColumn|0,E=y.endColumn|0;return f-E}return m-l}return C-g}return P-r}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=I}),define(me[139],ge([0,1,49,44]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var A;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(A=e.SelectionDirection||(e.SelectionDirection={}));class T extends I.Range{constructor(k,D,P,r){super(k,D,P,r);this.selectionStartLineNumber=k,this.selectionStartColumn=D,this.positionLineNumber=P,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(k){return T.selectionsEqual(this,k)}static selectionsEqual(k,D){return k.selectionStartLineNumber===D.selectionStartLineNumber&&k.selectionStartColumn===D.selectionStartColumn&&k.positionLineNumber===D.positionLineNumber&&k.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(k,D){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,k,D):new T(k,D,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(k,D){return this.getDirection()===0?new T(k,D,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,k,D)}static fromPositions(k,D=k){return new T(k.lineNumber,k.column,D.lineNumber,D.column)}static liftSelection(k){return new T(k.selectionStartLineNumber,k.selectionStartColumn,k.positionLineNumber,k.positionColumn)}static selectionsArrEqual(k,D){if(k&&!D||!k&&D)return!1;if(!k&&!D)return!0;if(k.length!==D.length)return!1;for(let P=0,r=k.length;P<r;P++)if(!this.selectionsEqual(k[P],D[P]))return!1;return!0}static isISelection(k){return k&&typeof k.selectionStartLineNumber=="number"&&typeof k.selectionStartColumn=="number"&&typeof k.positionLineNumber=="number"&&typeof k.positionColumn=="number"}static createWithDirection(k,D,P,r,C){return C===0?new T(k,D,P,r):new T(P,r,k,D)}}e.Selection=T}),define(me[109],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(m){m[m.Left=1]="Left",m[m.Center=2]="Center",m[m.Right=4]="Right",m[m.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var I;(function(m){m[m.Inline=1]="Inline",m[m.Gutter=2]="Gutter"})(I=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(m){m[m.TextDefined=0]="TextDefined",m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(m){m[m.LF=1]="LF",m[m.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(m){m[m.LF=0]="LF",m[m.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class k{constructor(l){this.tabSize=Math.max(1,l.tabSize|0),this.indentSize=l.tabSize|0,this.insertSpaces=Boolean(l.insertSpaces),this.defaultEOL=l.defaultEOL|0,this.trimAutoWhitespace=Boolean(l.trimAutoWhitespace)}equals(l){return this.tabSize===l.tabSize&&this.indentSize===l.indentSize&&this.insertSpaces===l.insertSpaces&&this.defaultEOL===l.defaultEOL&&this.trimAutoWhitespace===l.trimAutoWhitespace}createChangeEvent(l){return{tabSize:this.tabSize!==l.tabSize,indentSize:this.indentSize!==l.indentSize,insertSpaces:this.insertSpaces!==l.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==l.trimAutoWhitespace}}}e.TextModelResolvedOptions=k;class D{constructor(l,f){this.range=l,this.matches=f}}e.FindMatch=D;var P;(function(m){m[m.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",m[m.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",m[m.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",m[m.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(m){m[m.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class C{constructor(l,f,E,w,_,d){this.identifier=l,this.range=f,this.text=E,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=_,this._isTracked=d}}e.ValidAnnotatedEditOperation=C;class g{constructor(l,f,E){this.reverseEdits=l,this.changes=f,this.trimAutoWhitespaceLineNumbers=E}}e.ApplyEditsResult=g}),define(me[140],ge([0,1,9,138,49,44,109]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const k=999;class D{constructor(d,o,c,t){this.searchString=d,this.isRegex=o,this.matchCase=c,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let d;this.isRegex?d=P(this.searchString):d=this.searchString.indexOf(`
`)>=0;let o=null;try{o=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:d,global:!0,unicode:!0})}catch(t){return null}if(!o)return null;let c=!this.isRegex&&!d;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new r(o,this.wordSeparators?(0,I.getMapForWordSeparators)(this.wordSeparators):null,c?this.searchString:null)}}e.SearchParams=D;function P(_){if(!_||_.length===0)return!1;for(let d=0,o=_.length;d<o;d++)if(_.charCodeAt(d)===92){if(d++,d>=o)break;const t=_.charCodeAt(d);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=P;class r{constructor(d,o,c){this.regex=d,this.wordSeparators=o,this.simpleSearch=c}}e.SearchData=r;function C(_,d,o){if(!o)return new y.FindMatch(_,null);let c=[];for(let t=0,n=d.length;t<n;t++)c[t]=d[t];return new y.FindMatch(_,c)}e.createFindMatch=C;class g{constructor(d){let o=[],c=0;for(let t=0,n=d.length;t<n;t++)d.charCodeAt(t)===10&&(o[c++]=t);this._lineFeedsOffsets=o}findLineFeedCountBeforeOffset(d){const o=this._lineFeedsOffsets;let c=0,t=o.length-1;if(t===-1||d<=o[0])return 0;for(;c<t;){const n=c+((t-c)/2>>0);o[n]>=d?t=n-1:o[n+1]>=d?(c=n,t=n):c=n+1}return c+1}}class m{static findMatches(d,o,c,t,n){const s=o.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(d,c,new w(s.wordSeparators,s.regex),t,n):this._doFindMatchesLineByLine(d,c,s,t,n):[]}static _getMultilineMatchRange(d,o,c,t,n,s){let i,a=0;t?(a=t.findLineFeedCountBeforeOffset(n),i=o+n+a):i=o+n;let h;if(t){let v=t.findLineFeedCountBeforeOffset(n+s.length)-a;h=i+s.length+v}else h=i+s.length;const p=d.getPositionAt(i),S=d.getPositionAt(h);return new T.Range(p.lineNumber,p.column,S.lineNumber,S.column)}static _doFindMatchesMultiline(d,o,c,t,n){const s=d.getOffsetAt(o.getStartPosition()),i=d.getValueInRange(o,1),a=d.getEOL()===`\r
`?new g(i):null,h=[];let p=0,S;for(c.reset(0);S=c.next(i);)if(h[p++]=C(this._getMultilineMatchRange(d,s,i,a,S.index,S[0]),S,t),p>=n)return h;return h}static _doFindMatchesLineByLine(d,o,c,t,n){const s=[];let i=0;if(o.startLineNumber===o.endLineNumber){const h=d.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return i=this._findMatchesInLine(c,h,o.startLineNumber,o.startColumn-1,i,s,t,n),s}const a=d.getLineContent(o.startLineNumber).substring(o.startColumn-1);i=this._findMatchesInLine(c,a,o.startLineNumber,o.startColumn-1,i,s,t,n);for(let h=o.startLineNumber+1;h<o.endLineNumber&&i<n;h++)i=this._findMatchesInLine(c,d.getLineContent(h),h,0,i,s,t,n);if(i<n){const h=d.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);i=this._findMatchesInLine(c,h,o.endLineNumber,0,i,s,t,n)}return s}static _findMatchesInLine(d,o,c,t,n,s,i,a){const h=d.wordSeparators;if(!i&&d.simpleSearch){const u=d.simpleSearch,v=u.length,R=o.length;let N=-v;for(;(N=o.indexOf(u,N+v))!==-1;)if((!h||E(h,o,R,N,v))&&(s[n++]=new y.FindMatch(new T.Range(c,N+1+t,c,N+1+v+t),null),n>=a))return n;return n}const p=new w(d.wordSeparators,d.regex);let S;p.reset(0);do if(S=p.next(o),S&&(s[n++]=C(new T.Range(c,S.index+1+t,c,S.index+1+S[0].length+t),S,i),n>=a))return n;while(S);return n}static findNextMatch(d,o,c,t){const n=o.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(d,c,s,t):this._doFindNextMatchLineByLine(d,c,s,t)}static _doFindNextMatchMultiline(d,o,c,t){const n=new A.Position(o.lineNumber,1),s=d.getOffsetAt(n),i=d.getLineCount(),a=d.getValueInRange(new T.Range(n.lineNumber,n.column,i,d.getLineMaxColumn(i)),1),h=d.getEOL()===`\r
`?new g(a):null;c.reset(o.column-1);let p=c.next(a);return p?C(this._getMultilineMatchRange(d,s,a,h,p.index,p[0]),p,t):o.lineNumber!==1||o.column!==1?this._doFindNextMatchMultiline(d,new A.Position(1,1),c,t):null}static _doFindNextMatchLineByLine(d,o,c,t){const n=d.getLineCount(),s=o.lineNumber,i=d.getLineContent(s),a=this._findFirstMatchInLine(c,i,s,o.column,t);if(a)return a;for(let h=1;h<=n;h++){const p=(s+h-1)%n,S=d.getLineContent(p+1),u=this._findFirstMatchInLine(c,S,p+1,1,t);if(u)return u}return null}static _findFirstMatchInLine(d,o,c,t,n){d.reset(t-1);const s=d.next(o);return s?C(new T.Range(c,s.index+1,c,s.index+1+s[0].length),s,n):null}static findPreviousMatch(d,o,c,t){const n=o.parseSearchRequest();if(!n)return null;const s=new w(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(d,c,s,t):this._doFindPreviousMatchLineByLine(d,c,s,t)}static _doFindPreviousMatchMultiline(d,o,c,t){const n=this._doFindMatchesMultiline(d,new T.Range(1,1,o.lineNumber,o.column),c,t,10*k);if(n.length>0)return n[n.length-1];const s=d.getLineCount();return o.lineNumber!==s||o.column!==d.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(d,new A.Position(s,d.getLineMaxColumn(s)),c,t):null}static _doFindPreviousMatchLineByLine(d,o,c,t){const n=d.getLineCount(),s=o.lineNumber,i=d.getLineContent(s).substring(0,o.column-1),a=this._findLastMatchInLine(c,i,s,t);if(a)return a;for(let h=1;h<=n;h++){const p=(n+s-h-1)%n,S=d.getLineContent(p+1),u=this._findLastMatchInLine(c,S,p+1,t);if(u)return u}return null}static _findLastMatchInLine(d,o,c,t){let n=null,s;for(d.reset(0);s=d.next(o);)n=C(new T.Range(c,s.index+1,c,s.index+1+s[0].length),s,t);return n}}e.TextModelSearch=m;function l(_,d,o,c,t){if(c===0)return!0;const n=d.charCodeAt(c-1);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(c);if(_.get(s)!==0)return!0}return!1}function f(_,d,o,c,t){if(c+t===o)return!0;const n=d.charCodeAt(c+t);if(_.get(n)!==0||n===13||n===10)return!0;if(t>0){const s=d.charCodeAt(c+t-1);if(_.get(s)!==0)return!0}return!1}function E(_,d,o,c,t){return l(_,d,o,c,t)&&f(_,d,o,c,t)}e.isValidMatch=E;class w{constructor(d,o){this._wordSeparators=d,this._searchRegex=o,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(d){this._searchRegex.lastIndex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(d){const o=d.length;let c;do{if(this._prevMatchStartIndex+this._prevMatchLength===o||(c=this._searchRegex.exec(d),!c))return null;const t=c.index,n=c[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(d,o,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||E(this._wordSeparators,d,o,t,n))return c}while(c);return null}}e.Searcher=w}),define(me[110],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(k=""){let D="(-?\\d*\\.\\d\\w*)|([^";for(const P of e.USUAL_WORD_SEPARATORS)k.indexOf(P)>=0||(D+="\\"+P);return D+="\\s]+)",new RegExp(D,"g")}e.DEFAULT_WORD_REGEXP=b();function I(k){let D=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)D=k;else{let P="g";k.ignoreCase&&(P+="i"),k.multiline&&(P+="m"),k.unicode&&(P+="u"),D=new RegExp(k.source,P)}return D.lastIndex=0,D}e.ensureValidWordDefinition=I;const A={maxLen:1e3,windowSize:15,timeBudget:150};function T(k,D,P,r,C=A){if(P.length>C.maxLen){let E=k-C.maxLen/2;return E<0?E=0:r+=E,P=P.substring(E,k+C.maxLen/2),T(k,D,P,r,C)}const g=Date.now(),m=k-1-r;let l=-1,f=null;for(let E=1;!(Date.now()-g>=C.timeBudget);E++){const w=m-C.windowSize*E;D.lastIndex=Math.max(0,w);const _=y(D,P,m,l);if(!_&&f||(f=_,w<=0))break;l=w}if(f){let E={word:f[0],startColumn:r+1+f.index,endColumn:r+1+f.index+f[0].length};return D.lastIndex=0,E}return null}e.getWordAtText=T;function y(k,D,P,r){let C;for(;C=k.exec(D);){const g=C.index||0;if(g<=P&&k.lastIndex>=P)return C;if(r>0&&g>r)return null}return null}}),define(me[141],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class I{constructor(k){if(this.open=k.open,this.close=k.close,this._standardTokenMask=0,Array.isArray(k.notIn))for(let D=0,P=k.notIn.length;D<P;D++)switch(k.notIn[D]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(k){return(this._standardTokenMask&k)==0}}e.StandardAutoClosingPairConditional=I;class A{constructor(k){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of k)T(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),T(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),T(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),T(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&T(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=A;function T(y,k,D){y.has(k)?y.get(k).push(D):y.set(k,[D])}}),define(me[77],ge([0,1,33,8]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function A(T,y,k,D){if(Array.isArray(T)){let P=0;for(const r of T){const C=A(r,y,k,D);if(C===10)return C;C>P&&(P=C)}return P}else{if(typeof T=="string")return D?T==="*"?5:T===k?10:0:0;if(T){const{language:P,pattern:r,scheme:C,hasAccessToAllModels:g}=T;if(!D&&!g)return 0;let m=0;if(C)if(C===y.scheme)m=10;else if(C==="*")m=5;else return 0;if(P)if(P===k)m=10;else if(P==="*")m=Math.max(m,5);else return 0;if(r){let l;if(typeof r=="string"?l=r:l=Object.assign(Object.assign({},r),{base:(0,I.normalize)(r.base)}),l===y.fsPath||(0,b.match)(l,y.fsPath))m=10;else return 0}return m}else return 0}}e.score=A}),define(me[142],ge([0,1,108]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var I;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(I=e.State||(e.State={}));class A{constructor(l,f,E){const w=new Uint8Array(l*f);for(let _=0,d=l*f;_<d;_++)w[_]=E;this._data=w,this.rows=l,this.cols=f}get(l,f){return this._data[l*this.cols+f]}set(l,f,E){this._data[l*this.cols+f]=E}}e.Uint8Matrix=A;class T{constructor(l){let f=0,E=0;for(let _=0,d=l.length;_<d;_++){let[o,c,t]=l[_];c>f&&(f=c),o>E&&(E=o),t>E&&(E=t)}f++,E++;let w=new A(E,f,0);for(let _=0,d=l.length;_<d;_++){let[o,c,t]=l[_];w.set(o,c,t)}this._states=w,this._maxCharCode=f}nextState(l,f){return f<0||f>=this._maxCharCode?0:this._states.get(l,f)}}e.StateMachine=T;let y=null;function k(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var D;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let P=null;function r(){if(P===null){P=new b.CharacterClassifier(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<m.length;f++)P.set(m.charCodeAt(f),1);const l=".,;";for(let f=0;f<l.length;f++)P.set(l.charCodeAt(f),2)}return P}class C{static _createLink(l,f,E,w,_){let d=_-1;do{const o=f.charCodeAt(d);if(l.get(o)!==2)break;d--}while(d>w);if(w>0){const o=f.charCodeAt(w-1),c=f.charCodeAt(d);(o===40&&c===41||o===91&&c===93||o===123&&c===125)&&d--}return{range:{startLineNumber:E,startColumn:w+1,endLineNumber:E,endColumn:d+2},url:f.substring(w,d+1)}}static computeLinks(l,f=k()){const E=r();let w=[];for(let _=1,d=l.getLineCount();_<=d;_++){const o=l.getLineContent(_),c=o.length;let t=0,n=0,s=0,i=1,a=!1,h=!1,p=!1,S=!1;for(;t<c;){let u=!1;const v=o.charCodeAt(t);if(i===13){let R;switch(v){case 40:a=!0,R=0;break;case 41:R=a?0:1;break;case 91:p=!0,h=!0,R=0;break;case 93:p=!1,R=h?0:1;break;case 123:S=!0,R=0;break;case 125:R=S?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=p?0:1;break;default:R=E.get(v)}R===1&&(w.push(C._createLink(E,o,_,n,t)),u=!0)}else if(i===12){let R;v===91?(h=!0,R=0):R=E.get(v),R===1?u=!0:i=13}else i=f.nextState(i,v),i===0&&(u=!0);u&&(i=1,a=!1,h=!1,S=!1,n=t+1,s=v),t++}i===13&&w.push(C._createLink(E,o,_,n,c))}return w}}e.LinkComputer=C;function g(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:C.computeLinks(m)}e.computeLinks=g}),define(me[143],ge([0,1,3,6]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class A{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,k){return this._map.set(y,k),this.fire([y]),(0,I.toDisposable)(()=>{this._map.get(y)===k&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,k){let D=null,P=!1;return this._promises.set(y,k.then(r=>{this._promises.delete(y),!(P||!r)&&(D=this.register(y,r))})),(0,I.toDisposable)(()=>{P=!0,D&&D.dispose()})}getPromise(y){const k=this.get(y);if(k)return Promise.resolve(k);const D=this._promises.get(y);return D?D.then(P=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=A}),define(me[111],ge([0,1,23,10]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var A;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(A||(A={}));function T(C){for(let g=0,m=C.length;g<m;g+=4){const l=C[g+0],f=C[g+1],E=C[g+2],w=C[g+3];C[g+0]=w,C[g+1]=E,C[g+2]=f,C[g+3]=l}}function y(C){const g=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return I.isLittleEndian()||T(g),b.VSBuffer.wrap(g)}function k(C){const g=C.buffer;if(I.isLittleEndian()||T(g),g.byteOffset%4==0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const m=new Uint8Array(g.byteLength);return m.set(g),new Uint32Array(m.buffer,m.byteOffset,m.length/4)}}function D(C){const g=new Uint32Array(P(C));let m=0;if(g[m++]=C.id,C.type==="full")g[m++]=1,g[m++]=C.data.length,g.set(C.data,m),m+=C.data.length;else{g[m++]=2,g[m++]=C.deltas.length;for(const l of C.deltas)g[m++]=l.start,g[m++]=l.deleteCount,l.data?(g[m++]=l.data.length,g.set(l.data,m),m+=l.data.length):g[m++]=0}return y(g)}e.encodeSemanticTokensDto=D;function P(C){let g=0;if(g+=1+1,C.type==="full")g+=1+C.data.length;else{g+=1,g+=(1+1+1)*C.deltas.length;for(const m of C.deltas)m.data&&(g+=m.data.length)}return g}function r(C){const g=k(C);let m=0;const l=g[m++];if(g[m++]===1){const _=g[m++],d=g.subarray(m,m+_);return m+=_,{id:l,type:"full",data:d}}const E=g[m++];let w=[];for(let _=0;_<E;_++){const d=g[m++],o=g[m++],c=g[m++];let t;c>0&&(t=g.subarray(m,m+c),m+=c),w[_]={start:d,deleteCount:o,data:t}}return{id:l,type:"delta",deltas:w}}e.decodeSemanticTokensDto=r}),define(me[112],ge([0,1,97]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class I{constructor(y,k){this.index=y,this.remainder=k}}e.PrefixSumIndexOfResult=I;class A{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,k){y=(0,b.toUint32)(y);const D=this.values,P=this.prefixSum,r=k.length;return r===0?!1:(this.values=new Uint32Array(D.length+r),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y),y+r),this.values.set(k,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,k){return y=(0,b.toUint32)(y),k=(0,b.toUint32)(k),this.values[y]===k?!1:(this.values[y]=k,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,k){y=(0,b.toUint32)(y),k=(0,b.toUint32)(k);const D=this.values,P=this.prefixSum;if(y>=D.length)return!1;let r=D.length-y;return k>=r&&(k=r),k===0?!1:(this.values=new Uint32Array(D.length-k),this.values.set(D.subarray(0,y),0),this.values.set(D.subarray(y+k),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(P.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let k=this.prefixSumValidIndex[0]+1;k===0&&(this.prefixSum[0]=this.values[0],k++),y>=this.values.length&&(y=this.values.length-1);for(let D=k;D<=y;D++)this.prefixSum[D]=this.prefixSum[D-1]+this.values[D];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let k=0,D=this.values.length-1,P=0,r=0,C=0;for(;k<=D;)if(P=k+(D-k)/2|0,r=this.prefixSum[P],C=r-this.values[P],y<C)D=P-1;else if(y>=r)k=P+1;else break;return new I(P,y-C)}}e.PrefixSumComputer=A}),define(me[144],ge([0,1,9,49,112]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(k,D,P,r){this._uri=k,this._lines=D,this._eol=P,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(k){k.eol&&k.eol!==this._eol&&(this._eol=k.eol,this._lineStarts=null);const D=k.changes;for(const P of D)this._acceptDeleteRange(P.range),this._acceptInsertText(new I.Position(P.range.startLineNumber,P.range.startColumn),P.text);this._versionId=k.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const k=this._eol.length,D=this._lines.length,P=new Uint32Array(D);for(let r=0;r<D;r++)P[r]=this._lines[r].length+k;this._lineStarts=new A.PrefixSumComputer(P)}}_setLineText(k,D){this._lines[k]=D,this._lineStarts&&this._lineStarts.changeValue(k,this._lines[k].length+this._eol.length)}_acceptDeleteRange(k){if(k.startLineNumber===k.endLineNumber){if(k.startColumn===k.endColumn)return;this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.startLineNumber-1].substring(k.endColumn-1));return}this._setLineText(k.startLineNumber-1,this._lines[k.startLineNumber-1].substring(0,k.startColumn-1)+this._lines[k.endLineNumber-1].substring(k.endColumn-1)),this._lines.splice(k.startLineNumber,k.endLineNumber-k.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(k.startLineNumber,k.endLineNumber-k.startLineNumber)}_acceptInsertText(k,D){if(D.length!==0){let P=(0,b.splitLines)(D);if(P.length===1){this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]+this._lines[k.lineNumber-1].substring(k.column-1));return}P[P.length-1]+=this._lines[k.lineNumber-1].substring(k.column-1),this._setLineText(k.lineNumber-1,this._lines[k.lineNumber-1].substring(0,k.column-1)+P[0]);let r=new Uint32Array(P.length-1);for(let C=1;C<P.length;C++)this._lines.splice(k.lineNumber+C-1,0,P[C]),r[C-1]=P[C].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(k.lineNumber,r)}}}e.MirrorTextModel=T}),define(me[145],ge([18,19]),function(G,e){return G.create("vs/base/common/date",e)}),define(me[146],ge([0,1,145]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const I=60,A=I*60,T=A*24,y=T*7,k=T*30,D=T*365;function P(C,g){typeof C!="number"&&(C=C.getTime());const m=Math.round((new Date().getTime()-C)/1e3);if(m<-30)return(0,b.localize)(0,null,P(new Date().getTime()+m*1e3,!1));if(m<30)return(0,b.localize)(1,null);let l;return m<I?(l=m,g?l===1?(0,b.localize)(2,null,l):(0,b.localize)(3,null,l):l===1?(0,b.localize)(4,null,l):(0,b.localize)(5,null,l)):m<A?(l=Math.floor(m/I),g?l===1?(0,b.localize)(6,null,l):(0,b.localize)(7,null,l):l===1?(0,b.localize)(8,null,l):(0,b.localize)(9,null,l)):m<T?(l=Math.floor(m/A),g?l===1?(0,b.localize)(10,null,l):(0,b.localize)(11,null,l):l===1?(0,b.localize)(12,null,l):(0,b.localize)(13,null,l)):m<y?(l=Math.floor(m/T),g?l===1?(0,b.localize)(14,null,l):(0,b.localize)(15,null,l):l===1?(0,b.localize)(16,null,l):(0,b.localize)(17,null,l)):m<k?(l=Math.floor(m/y),g?l===1?(0,b.localize)(18,null,l):(0,b.localize)(19,null,l):l===1?(0,b.localize)(20,null,l):(0,b.localize)(21,null,l)):m<D?(l=Math.floor(m/k),g?l===1?(0,b.localize)(22,null,l):(0,b.localize)(23,null,l):l===1?(0,b.localize)(24,null,l):(0,b.localize)(25,null,l)):(l=Math.floor(m/D),g?l===1?(0,b.localize)(26,null,l):(0,b.localize)(27,null,l):l===1?(0,b.localize)(28,null,l):(0,b.localize)(29,null,l))}e.fromNow=P;function r(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(me[147],ge([18,19]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(me[60],ge([0,1,147,11,16]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(P,r){return r&&(P.stack||P.stacktrace)?b.localize(0,null,k(P),y(P.stack)||y(P.stacktrace)):k(P)}function y(P){return Array.isArray(P)?P.join(`
`):P}function k(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?b.localize(1,null,P.message):P.message||b.localize(2,null)}function D(P=null,r=!1){if(!P)return b.localize(3,null);if(Array.isArray(P)){const C=A.coalesce(P),g=D(C[0],r);return C.length>1?b.localize(4,null,g,C.length):g}if(I.isString(P))return P;if(P.detail){const C=P.detail;if(C.error)return T(C.error,r);if(C.exception)return T(C.exception,r)}return P.stack?T(P,r):P.message?P.message:b.localize(5,null)}e.toErrorMessage=D}),define(me[148],ge([18,19]),function(G,e){return G.create("vs/base/node/processes",e)}),define(me[78],ge([0,1,8,37,26,38,148,36,11,24,29,10,137,12]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function l(c){switch(c){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(c,t){if(C.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};t&&(n.cwd=t);const s=T.execFile("taskkill",["/T","/F","/PID",c.pid.toString()],n);return new Promise(i=>{s.once("error",a=>{i({success:!1,error:a})}),s.once("exit",(a,h)=>{i(a===0?{success:!0}:{success:!1,code:a!==null?a:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?l(n.status):1})}else if(C.isLinux||C.isMacintosh)try{const n=m.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(s=>{T.execFile(n,[c.pid.toString()],{encoding:"utf8",shell:!0},(i,a,h)=>{s(i?{success:!1,error:i}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else c.kill("SIGKILL");return Promise.resolve({success:!0})}function E(c=k.env){return c.comspec||"cmd.exe"}e.getWindowsShell=E;class w{constructor(t,n,s,i){if(n!==void 0&&s!==void 0&&i!==void 0)this.cmd=t,this.args=n,this.shell=s,this.options=i;else{const a=t;this.cmd=a.command,this.shell=a.isShellCommand,this.args=a.args.slice(0),this.options=a.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const a=Object.create(null);Object.keys(k.env).forEach(h=>{a[h]=k.env[h]}),Object.keys(this.options.env).forEach(h=>{a[h]=this.options.env[h]}),this.options.env=a}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const n=t.lastIndexOf(b.sep);return n!==-1&&(t=t.substring(n+1)),w.WellKnowCommands[t]?t:"other"}start(t){return C.isWindows&&(this.options&&this.options.cwd&&r.isUNC(this.options.cwd)||!this.options&&r.isUNC(k.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(n=>{let s,i;const a=new Promise((h,p)=>{s=h,i=p});if(n){let h=this.cmd;this.args&&(h=h+" "+this.args.join(" ")),this.childProcess=T.exec(h,this.options,(p,S,u)=>{this.childProcess=null;const v=p;v&&v.killed?i({killed:this.terminateRequested,stdout:S.toString(),stderr:u.toString()}):this.handleExec(s,t,p,S,u)})}else{let h=null;const p=S=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(S,s,t,i);const u={terminated:this.terminateRequested};D.isNumber(S)&&(u.cmdCode=S),s(u)};if(this.shell&&C.isWindows){const S=P.deepClone(this.options);S.windowsVerbatimArguments=!0,S.detached=!1;let u=!1,v=!1;const R=[];let N=this.ensureQuotes(this.cmd);R.push(N.value),u=N.quoted,this.args&&this.args.forEach(ie=>{N=this.ensureQuotes(ie),R.push(N.value),v=v&&N.quoted});const j=["/s","/c"];u?v?j.push('"'+R.join(" ")+'"'):R.length>1?j.push('"'+R[0]+'" '+R.slice(1).join(" ")):j.push('"'+R[0]+'"'):j.push(R.join(" ")),h=T.spawn(E(),j,S)}else this.cmd&&(h=T.spawn(this.cmd,this.args,this.options));h&&(this.childProcess=h,this.childProcessPromise=Promise.resolve(h),this.pidResolve&&(this.pidResolve(D.isNumber(h.pid)?h.pid:-1),this.pidResolve=void 0),h.on("error",S=>{this.childProcess=null,i({terminated:this.terminateRequested,error:S})}),h.pid&&(this.childProcess.on("close",p),this.handleSpawn(h,s,t,i,!0)))}return a})}handleClose(t,n,s,i){}ensureQuotes(t){return w.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,f(t,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!C.isWindows)return t(!1);const n=T.spawn(E(),["/s","/c"]);n.on("error",s=>t(!0)),n.on("exit",s=>t(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class _ extends w{constructor(t,n,s,i){super(t,n,s,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,n,s,i,a){[i,a].forEach((h,p)=>{const S=new g.LineDecoder;S.write(h).forEach(R=>{n({line:R,source:p===0?0:1})});const v=S.end();v&&n({line:v,source:p===0?0:1})}),t({terminated:this.terminateRequested,error:s})}handleSpawn(t,n,s,i,a){const h=new g.LineDecoder,p=new g.LineDecoder;t.stdout.on("data",S=>{h.write(S).forEach(v=>s({line:v,source:0}))}),t.stderr.on("data",S=>{p.write(S).forEach(v=>s({line:v,source:1}))}),this.stdoutLineDecoder=h,this.stderrLineDecoder=p}handleClose(t,n,s,i){const a=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;a&&s({line:a,source:0});const h=this.stderrLineDecoder?this.stderrLineDecoder.end():null;h&&s({line:h,source:1})}}e.LineProcess=_;function d(c){let t=[],n=!1;const s=function(i){if(n){t.push(i);return}(!c.send(i,h=>{if(h&&console.error(h),n=!1,t.length>0){const p=t.slice(0);t=[],p.forEach(S=>s(S))}})||C.isWindows)&&(n=!0)};return{send:s}}e.createQueuedSender=d;var o;(function(c){async function t(n,s,i){if(b.isAbsolute(n))return n;if(s===void 0&&(s=k.cwd()),b.dirname(n)!=="."||(i===void 0&&D.isString(k.env.PATH)&&(i=k.env.PATH.split(b.delimiter)),i===void 0||i.length===0))return b.join(s,n);async function h(p){return await A.exists(p)?!(await I.promises.stat(p)).isDirectory():!1}for(let p of i){let S;if(b.isAbsolute(p)?S=b.join(p,n):S=b.join(s,p,n),await h(S))return S;let u=S+".com";if(await h(u)||(u=S+".exe",await h(u)))return u}return b.join(s,n)}c.findExecutable=t})(o=e.win32||(e.win32={}))}),define(me[149],ge([0,1,48,10,105,78]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function y(m,l){return m===1?I.isWindows?C():T.getWindowsShell(l):P(m,l)}e.getSystemShell=y;function k(m,l){return m===1?I.isWindows?g(l):T.getWindowsShell(l):P(m,l)}e.getSystemShellSync=k;let D=null;function P(m,l){if(I.isLinux&&m===2||I.isMacintosh&&m===3)return"/bin/bash";if(!D){let f;if(I.isWindows)f="/bin/bash";else{if(f=l.SHELL,!f)try{f=(0,b.userInfo)().shell}catch(E){}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}D=f}return D}let r=null;async function C(){return r||(r=(await(0,A.getFirstAvailablePowerShellInstallation)()).exePath),r}function g(m){if(r)return r;const l=I.isWindows&&parseFloat((0,b.release)())>=10,f=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${m.windir}\\${f?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return l?E:T.getWindowsShell(m)}}),define(me[150],ge([18,19]),function(G,e){return G.create("vs/editor/common/config/editorOptions",e)}),define(me[151],ge([0,1,150,10,110]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=y;class k{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,we){this._values[ne]=we}}e.ValidatedEditorOptions=k;class D{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=D;class P{constructor(ne,we,xe,je){this.id=ne,this.name=we,this.defaultValue=xe,this.schema=je}compute(ne,we,xe){return xe}}class r{constructor(ne,we=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(ne){return this.defaultValue}}class C{constructor(ne,we,xe,je){this.id=ne,this.name=we,this.defaultValue=xe,this.schema=je}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,we,xe){return xe}}function g(X,ne){return typeof X=="undefined"?ne:X==="false"?!1:Boolean(X)}e.boolean=g;class m extends C{constructor(ne,we,xe,je=void 0){typeof je!="undefined"&&(je.type="boolean",je.default=xe),super(ne,we,xe,je)}validate(ne){return g(ne,this.defaultValue)}}class l extends C{constructor(ne,we,xe,je,Ve,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=xe,Ze.minimum=je,Ze.maximum=Ve),super(ne,we,xe,Ze),this.minimum=je,this.maximum=Ve}static clampedInt(ne,we,xe,je){if(typeof ne=="undefined")return we;let Ve=parseInt(ne,10);return isNaN(Ve)?we:(Ve=Math.max(xe,Ve),Ve=Math.min(je,Ve),Ve|0)}validate(ne){return l.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class f extends C{constructor(ne,we,xe,je,Ve){typeof Ve!="undefined"&&(Ve.type="number",Ve.default=xe),super(ne,we,xe,Ve),this.validationFn=je}static clamp(ne,we,xe){return ne<we?we:ne>xe?xe:ne}static float(ne,we){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return we;const xe=parseFloat(ne);return isNaN(xe)?we:xe}validate(ne){return this.validationFn(f.float(ne,this.defaultValue))}}class E extends C{static string(ne,we){return typeof ne!="string"?we:ne}constructor(ne,we,xe,je=void 0){typeof je!="undefined"&&(je.type="string",je.default=xe),super(ne,we,xe,je)}validate(ne){return E.string(ne,this.defaultValue)}}function w(X,ne,we){return typeof X!="string"||we.indexOf(X)===-1?ne:X}e.stringSet=w;class _ extends C{constructor(ne,we,xe,je,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.enum=je,Ve.default=xe),super(ne,we,xe,Ve),this._allowedValues=je}validate(ne){return w(ne,this.defaultValue,this._allowedValues)}}class d extends P{constructor(ne,we,xe,je,Ve,Ze,De=void 0){typeof De!="undefined"&&(De.type="string",De.enum=Ve,De.default=je),super(ne,we,xe,De),this._allowedValues=Ve,this._convert=Ze}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function o(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,we,xe){return xe===0?ne.accessibilitySupport:xe}}class t extends P{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{insertSpace:g(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function a(X){switch(X){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=a;function h(X){switch(X){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class p extends r{constructor(){super(123,[62,31])}compute(ne,we,xe){const je=["monaco-editor"];return we.get(31)&&je.push(we.get(31)),ne.extraEditorClassName&&je.push(ne.extraEditorClassName),we.get(62)==="default"?je.push("mouse-default"):we.get(62)==="copy"&&je.push("mouse-copy"),we.get(97)&&je.push("showUnused"),we.get(121)&&je.push("showDeprecated"),je.join(" ")}}class S extends m{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ne,we,xe){return xe&&ne.emptySelectionClipboard}}class u extends P{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:b.localize(13,null),included:I.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:b.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{cursorMoveOnType:g(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:g(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":w(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(we.loop,this.defaultValue.loop)}}}class v extends P{constructor(){super(41,"fontLigatures",v.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?v.OFF:ne==="true"?v.ON:ne:Boolean(ne)?v.ON:v.OFF}}e.EditorFontLigatures=v,v.OFF='"liga" off, "calt" off',v.ON='"liga" on, "calt" on';class R extends r{constructor(){super(40)}compute(ne,we,xe){return ne.fontInfo}}class N extends C{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ne){let we=f.float(ne,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(we,6,100)}compute(ne,we,xe){return ne.fontInfo.fontSize}}class j extends P{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.MINIMUM_VALUE,maximum:j.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(l.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,j.MINIMUM_VALUE,j.MAXIMUM_VALUE))}}j.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],j.MINIMUM_VALUE=1,j.MAXIMUM_VALUE=1e3;class ie extends P{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:xe,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:xe,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:xe,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:xe,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:xe,description:b.localize(35,null)}})}validate(ne){var we,xe,je,Ve,Ze;if(!ne||typeof ne!="object")return this.defaultValue;const De=ne;return{multiple:w(De.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=De.multipleDefinitions)!==null&&we!==void 0?we:w(De.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(xe=De.multipleTypeDefinitions)!==null&&xe!==void 0?xe:w(De.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(je=De.multipleDeclarations)!==null&&je!==void 0?je:w(De.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ve=De.multipleImplementations)!==null&&Ve!==void 0?Ve:w(De.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=De.multipleReferences)!==null&&Ze!==void 0?Ze:w(De.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(De.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(De.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(De.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(De.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(De.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class K extends P{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:b.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:g(we.enabled,this.defaultValue.enabled),delay:l.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:g(we.sticky,this.defaultValue.sticky)}}}var B;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(B=e.RenderMinimap||(e.RenderMinimap={}));class $ extends r{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ne,we,xe){return $.computeLayout(we,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const we=ne.height/ne.lineHeight,xe=ne.scrollBeyondLastLine?we-1:0,je=(ne.viewLineCount+xe)/(ne.pixelRatio*ne.height),Ve=Math.floor(ne.viewLineCount/je);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:xe,desiredRatio:je,minimapLineCount:Ve}}static _computeMinimapLayout(ne,we){const xe=ne.outerWidth,je=ne.outerHeight,Ve=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ve*je),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:je};const Ze=we.stableMinimapLayoutInput,De=Ze&&ne.outerHeight===Ze.outerHeight&&ne.lineHeight===Ze.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ze.pixelRatio&&ne.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&ne.minimap.enabled===Ze.minimap.enabled&&ne.minimap.side===Ze.minimap.side&&ne.minimap.size===Ze.minimap.size&&ne.minimap.showSlider===Ze.minimap.showSlider&&ne.minimap.renderCharacters===Ze.minimap.renderCharacters&&ne.minimap.maxColumn===Ze.minimap.maxColumn&&ne.minimap.scale===Ze.minimap.scale&&ne.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&ne.isViewportWrapping===Ze.isViewportWrapping,ye=ne.lineHeight,Pe=ne.typicalHalfwidthCharacterWidth,oe=ne.scrollBeyondLastLine,ue=ne.minimap.renderCharacters;let H=Ve>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const Z=ne.minimap.maxColumn,ce=ne.minimap.size,Ie=ne.minimap.side,Ae=ne.verticalScrollbarWidth,Le=ne.viewLineCount,$e=ne.remainingWidth,Xe=ne.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Ve*je);const Qe=tt/Ve;let mt=!1,wt=!1,be=rt*H,he=H/Ve,ae=1;if(ce==="fill"||ce==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Je,desiredRatio:at,minimapLineCount:ft}=$.computeContainedMinimapLineCount({viewLineCount:Le,scrollBeyondLastLine:oe,height:je,lineHeight:ye,pixelRatio:Ve});if(Le/ft>1)mt=!0,wt=!0,H=1,be=1,he=H/Ve;else{let St=!1,vt=H+1;if(ce==="fit"){const Pt=Math.ceil((Le+Je)*be);Xe&&De&&$e<=we.stableFitRemainingWidth?(St=!0,vt=we.stableFitMaxMinimapScale):(St=Pt>tt,Xe&&St?(we.stableMinimapLayoutInput=ne,we.stableFitRemainingWidth=$e):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0))}if(ce==="fill"||St){mt=!0;const Pt=H;be=Math.min(ye*Ve,Math.max(1,Math.floor(1/at))),H=Math.min(vt,Math.max(1,Math.floor(be/rt))),H>Pt&&(ae=Math.min(2,H/Pt)),he=H/Ve/ae,tt=Math.ceil(Math.max(ht,Le+Je)*be),Xe&&St&&(we.stableFitMaxMinimapScale=H)}}}const J=Math.floor(Z*he),Ne=Math.min(J,Math.max(0,Math.floor(($e-Ae-2)*he/(Pe+he)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Ve*Ne);const Ye=Fe/Ve;Fe=Math.floor(Fe*ae);const et=ue?1:2,ut=Ie==="left"?0:xe-Ne-Ae;return{renderMinimap:et,minimapLeft:ut,minimapWidth:Ne,minimapHeightIsEditorHeight:mt,minimapIsSampling:wt,minimapScale:H,minimapLineHeight:be,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Ye,minimapCanvasOuterHeight:Qe}}static computeLayout(ne,we){const xe=we.outerWidth|0,je=we.outerHeight|0,Ve=we.lineHeight|0,Ze=we.lineNumbersDigitCount|0,De=we.typicalHalfwidthCharacterWidth,ye=we.maxDigitWidth,Pe=we.pixelRatio,oe=we.viewLineCount,ue=ne.get(118),H=ue==="inherit"?ne.get(117):ue,Z=H==="inherit"?ne.get(113):H,ce=ne.get(116),Ie=ne.get(2),Ae=we.isDominatedByLongLines,Le=ne.get(46),$e=ne.get(56).renderType!==0,Xe=ne.get(57),rt=ne.get(91),tt=ne.get(61),Qe=ne.get(89),mt=Qe.verticalScrollbarSize,wt=Qe.verticalHasArrows,be=Qe.arrowSize,he=Qe.horizontalScrollbarSize,ae=ne.get(54),J=ne.get(35);let Ne;if(typeof ae=="string"&&/^\d+(\.\d+)?ch$/.test(ae)){const _t=parseFloat(ae.substr(0,ae.length-2));Ne=l.clampedInt(_t*De,0,0,1e3)}else Ne=l.clampedInt(ae,0,0,1e3);J&&(Ne+=16);let Fe=0;if($e){const _t=Math.max(Ze,Xe);Fe=Math.round(_t*ye)}let Ye=0;Le&&(Ye=Ve);let et=0,ut=et+Ye,ht=ut+Fe,Je=ht+Ne;const at=xe-Ye-Fe-Ne;let ft=!1,lt=!1,St=-1;Ie!==2&&(H==="inherit"&&Ae?(ft=!0,lt=!0):Z==="on"||Z==="bounded"?lt=!0:Z==="wordWrapColumn"&&(St=ce));const vt=$._computeMinimapLayout({outerWidth:xe,outerHeight:je,lineHeight:Ve,typicalHalfwidthCharacterWidth:De,pixelRatio:Pe,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:mt,viewLineCount:oe,remainingWidth:at,isViewportWrapping:lt},we.memory||new D);vt.renderMinimap!==0&&vt.minimapLeft===0&&(et+=vt.minimapWidth,ut+=vt.minimapWidth,ht+=vt.minimapWidth,Je+=vt.minimapWidth);const Pt=at-vt.minimapWidth,Tt=Math.max(1,Math.floor((Pt-mt-2)/De)),Rt=wt?be:0;return lt&&(St=Math.max(1,Tt),Z==="bounded"&&(St=Math.min(St,ce))),{width:xe,height:je,glyphMarginLeft:et,glyphMarginWidth:Ye,lineNumbersLeft:ut,lineNumbersWidth:Fe,decorationsLeft:ht,decorationsWidth:Ne,contentLeft:Je,contentWidth:Pt,minimap:vt,viewportColumn:Tt,isWordWrapMinified:ft,isViewportWrapping:lt,wrappingColumn:St,verticalScrollbarWidth:mt,horizontalScrollbarHeight:he,overviewRuler:{top:Rt,width:mt,height:je-2*Rt,right:0}}}}e.EditorLayoutInfoComputer=$;class U extends P{constructor(){const ne={enabled:!0};super(53,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:b.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:g(ne.enabled,this.defaultValue.enabled)}}}class L extends P{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:b.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:g(we.enabled,this.defaultValue.enabled),fontSize:l.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(we.fontFamily,this.defaultValue.fontFamily)}}}class O extends l{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ne,we,xe){return ne.fontInfo.lineHeight}}class M extends P{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ne.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:b.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:g(we.enabled,this.defaultValue.enabled),size:w(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:w(we.side,this.defaultValue.side,["right","left"]),showSlider:w(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(we.renderCharacters,this.defaultValue.renderCharacters),scale:l.clampedInt(we.scale,1,1,3),maxColumn:l.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function F(X){return X==="ctrlCmd"?I.isMacintosh?"metaKey":"ctrlKey":"altKey"}class W extends P{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{top:l.clampedInt(we.top,0,0,1e3),bottom:l.clampedInt(we.bottom,0,0,1e3)}}}class q extends P{constructor(){const ne={enabled:!0,cycle:!1};super(72,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:b.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{enabled:g(we.enabled,this.defaultValue.enabled),cycle:g(we.cycle,this.defaultValue.cycle)}}}class Q extends r{constructor(){super(124)}compute(ne,we,xe){return ne.pixelRatio}}class le extends P{constructor(){const ne={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:b.localize(59,null)},other:{type:"boolean",default:ne.other,description:b.localize(60,null)}}}],default:ne,description:b.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const we=ne,xe={other:g(we.other,this.defaultValue.other),comments:g(we.comments,this.defaultValue.comments),strings:g(we.strings,this.defaultValue.strings)};return xe.other&&xe.comments&&xe.strings?!0:!xe.other&&!xe.comments&&!xe.strings?!1:xe}return this.defaultValue}}var ve;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends P{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ne){let we=this.defaultValue.renderType,xe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(we=4,xe=ne):ne==="interval"?we=3:ne==="relative"?we=2:ne==="on"?we=1:we=0),{renderType:we,renderFn:xe}}}function Se(X){const ne=X.get(84);return ne==="editable"?X.get(77):ne!=="on"}e.filterValidationDecorations=Se;class Oe extends P{constructor(){const ne=[],we={type:"number",description:b.localize(67,null)};super(88,"rulers",ne,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ne,description:b.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let we=[];for(let xe of ne)if(typeof xe=="number")we.push({column:l.clampedInt(xe,0,0,1e4),color:null});else if(xe&&typeof xe=="object"){const je=xe;we.push({column:l.clampedInt(je.column,0,0,1e4),color:je.color})}return we.sort((xe,je)=>xe.column-je.column),we}return this.defaultValue}}function z(X,ne){if(typeof X!="string")return ne;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class Y extends P{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne,xe=l.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),je=l.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:l.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:z(we.vertical,this.defaultValue.vertical),horizontal:z(we.horizontal,this.defaultValue.horizontal),useShadows:g(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:xe,horizontalSliderSize:l.clampedInt(we.horizontalSliderSize,xe,0,1e3),verticalScrollbarSize:je,verticalSliderSize:l.clampedInt(we.verticalSliderSize,je,0,1e3),scrollByPage:g(we.scrollByPage,this.defaultValue.scrollByPage)}}}class ee extends P{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ne.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const we=ne;return{insertMode:w(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:g(we.showIcons,this.defaultValue.showIcons),showStatusBar:g(we.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:g(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(we.showMethods,this.defaultValue.showMethods),showFunctions:g(we.showFunctions,this.defaultValue.showFunctions),showConstructors:g(we.showConstructors,this.defaultValue.showConstructors),showFields:g(we.showFields,this.defaultValue.showFields),showVariables:g(we.showVariables,this.defaultValue.showVariables),showClasses:g(we.showClasses,this.defaultValue.showClasses),showStructs:g(we.showStructs,this.defaultValue.showStructs),showInterfaces:g(we.showInterfaces,this.defaultValue.showInterfaces),showModules:g(we.showModules,this.defaultValue.showModules),showProperties:g(we.showProperties,this.defaultValue.showProperties),showEvents:g(we.showEvents,this.defaultValue.showEvents),showOperators:g(we.showOperators,this.defaultValue.showOperators),showUnits:g(we.showUnits,this.defaultValue.showUnits),showValues:g(we.showValues,this.defaultValue.showValues),showConstants:g(we.showConstants,this.defaultValue.showConstants),showEnums:g(we.showEnums,this.defaultValue.showEnums),showEnumMembers:g(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(we.showKeywords,this.defaultValue.showKeywords),showWords:g(we.showWords,this.defaultValue.showWords),showColors:g(we.showColors,this.defaultValue.showColors),showFiles:g(we.showFiles,this.defaultValue.showFiles),showReferences:g(we.showReferences,this.defaultValue.showReferences),showFolders:g(we.showFolders,this.defaultValue.showFolders),showTypeParameters:g(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(we.showSnippets,this.defaultValue.showSnippets),showUsers:g(we.showUsers,this.defaultValue.showUsers),showIssues:g(we.showIssues,this.defaultValue.showIssues)}}}class se extends P{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class fe extends r{constructor(){super(125,[77])}compute(ne,we,xe){return we.get(77)?!0:ne.tabFocusMode}}var Ee;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Ee=e.WrappingIndent||(e.WrappingIndent={}));function Be(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class pe extends r{constructor(){super(127,[126])}compute(ne,we,xe){const je=we.get(126);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:je.isWordWrapMinified,isViewportWrapping:je.isViewportWrapping,wrappingColumn:je.wrappingColumn}}}const Ce="Consolas, 'Courier New', monospace",Me="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:I.isMacintosh?Me:I.isLinux?ze:Ce,fontWeight:"normal",fontSize:I.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function _e(X){return e.editorOptionsRegistry[X.id]=X,X}var Ke;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.codeLens=12]="codeLens",X[X.codeLensFontFamily=13]="codeLensFontFamily",X[X.codeLensFontSize=14]="codeLensFontSize",X[X.colorDecorators=15]="colorDecorators",X[X.columnSelection=16]="columnSelection",X[X.comments=17]="comments",X[X.contextmenu=18]="contextmenu",X[X.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",X[X.cursorBlinking=20]="cursorBlinking",X[X.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",X[X.cursorStyle=22]="cursorStyle",X[X.cursorSurroundingLines=23]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",X[X.cursorWidth=25]="cursorWidth",X[X.disableLayerHinting=26]="disableLayerHinting",X[X.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",X[X.domReadOnly=28]="domReadOnly",X[X.dragAndDrop=29]="dragAndDrop",X[X.emptySelectionClipboard=30]="emptySelectionClipboard",X[X.extraEditorClassName=31]="extraEditorClassName",X[X.fastScrollSensitivity=32]="fastScrollSensitivity",X[X.find=33]="find",X[X.fixedOverflowWidgets=34]="fixedOverflowWidgets",X[X.folding=35]="folding",X[X.foldingStrategy=36]="foldingStrategy",X[X.foldingHighlight=37]="foldingHighlight",X[X.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=39]="fontFamily",X[X.fontInfo=40]="fontInfo",X[X.fontLigatures=41]="fontLigatures",X[X.fontSize=42]="fontSize",X[X.fontWeight=43]="fontWeight",X[X.formatOnPaste=44]="formatOnPaste",X[X.formatOnType=45]="formatOnType",X[X.glyphMargin=46]="glyphMargin",X[X.gotoLocation=47]="gotoLocation",X[X.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",X[X.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",X[X.hover=50]="hover",X[X.inDiffEditor=51]="inDiffEditor",X[X.letterSpacing=52]="letterSpacing",X[X.lightbulb=53]="lightbulb",X[X.lineDecorationsWidth=54]="lineDecorationsWidth",X[X.lineHeight=55]="lineHeight",X[X.lineNumbers=56]="lineNumbers",X[X.lineNumbersMinChars=57]="lineNumbersMinChars",X[X.linkedEditing=58]="linkedEditing",X[X.links=59]="links",X[X.matchBrackets=60]="matchBrackets",X[X.minimap=61]="minimap",X[X.mouseStyle=62]="mouseStyle",X[X.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=64]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",X[X.multiCursorModifier=66]="multiCursorModifier",X[X.multiCursorPaste=67]="multiCursorPaste",X[X.occurrencesHighlight=68]="occurrencesHighlight",X[X.overviewRulerBorder=69]="overviewRulerBorder",X[X.overviewRulerLanes=70]="overviewRulerLanes",X[X.padding=71]="padding",X[X.parameterHints=72]="parameterHints",X[X.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",X[X.quickSuggestions=75]="quickSuggestions",X[X.quickSuggestionsDelay=76]="quickSuggestionsDelay",X[X.readOnly=77]="readOnly",X[X.renameOnType=78]="renameOnType",X[X.renderControlCharacters=79]="renderControlCharacters",X[X.renderIndentGuides=80]="renderIndentGuides",X[X.renderFinalNewline=81]="renderFinalNewline",X[X.renderLineHighlight=82]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=84]="renderValidationDecorations",X[X.renderWhitespace=85]="renderWhitespace",X[X.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",X[X.roundedSelection=87]="roundedSelection",X[X.rulers=88]="rulers",X[X.scrollbar=89]="scrollbar",X[X.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=91]="scrollBeyondLastLine",X[X.scrollPredominantAxis=92]="scrollPredominantAxis",X[X.selectionClipboard=93]="selectionClipboard",X[X.selectionHighlight=94]="selectionHighlight",X[X.selectOnLineNumbers=95]="selectOnLineNumbers",X[X.showFoldingControls=96]="showFoldingControls",X[X.showUnused=97]="showUnused",X[X.snippetSuggestions=98]="snippetSuggestions",X[X.smartSelect=99]="smartSelect",X[X.smoothScrolling=100]="smoothScrolling",X[X.stickyTabStops=101]="stickyTabStops",X[X.stopRenderingLineAfter=102]="stopRenderingLineAfter",X[X.suggest=103]="suggest",X[X.suggestFontSize=104]="suggestFontSize",X[X.suggestLineHeight=105]="suggestLineHeight",X[X.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",X[X.suggestSelection=107]="suggestSelection",X[X.tabCompletion=108]="tabCompletion",X[X.tabIndex=109]="tabIndex",X[X.unusualLineTerminators=110]="unusualLineTerminators",X[X.useTabStops=111]="useTabStops",X[X.wordSeparators=112]="wordSeparators",X[X.wordWrap=113]="wordWrap",X[X.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=116]="wordWrapColumn",X[X.wordWrapOverride1=117]="wordWrapOverride1",X[X.wordWrapOverride2=118]="wordWrapOverride2",X[X.wrappingIndent=119]="wrappingIndent",X[X.wrappingStrategy=120]="wrappingStrategy",X[X.showDeprecated=121]="showDeprecated",X[X.inlayHints=122]="inlayHints",X[X.editorClassName=123]="editorClassName",X[X.pixelRatio=124]="pixelRatio",X[X.tabFocusMode=125]="tabFocusMode",X[X.layoutInfo=126]="layoutInfo",X[X.wrappingInfo=127]="wrappingInfo"})(Ke=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:_e(new m(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:_e(new _(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:_e(new c),accessibilityPageSize:_e(new l(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:_e(new E(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:_e(new _(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:_e(new _(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:_e(new _(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:_e(new _(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:_e(new d(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:_e(new m(10,"automaticLayout",!1)),autoSurround:_e(new _(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:_e(new m(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:_e(new m(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:_e(new E(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:_e(new l(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:_e(new m(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:_e(new m(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:_e(new t),contextmenu:_e(new m(18,"contextmenu",!0)),copyWithSyntaxHighlighting:_e(new m(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:_e(new d(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:_e(new m(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:_e(new d(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],h,{description:b.localize(145,null)})),cursorSurroundingLines:_e(new l(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:_e(new _(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:_e(new l(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:_e(new m(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:_e(new m(27,"disableMonospaceOptimizations",!1)),domReadOnly:_e(new m(28,"domReadOnly",!1)),dragAndDrop:_e(new m(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:_e(new S),extraEditorClassName:_e(new E(31,"extraEditorClassName","")),fastScrollSensitivity:_e(new f(32,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:b.localize(152,null)})),find:_e(new u),fixedOverflowWidgets:_e(new m(34,"fixedOverflowWidgets",!1)),folding:_e(new m(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:_e(new _(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:_e(new m(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:_e(new m(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:_e(new E(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:_e(new R),fontLigatures2:_e(new v),fontSize:_e(new N),fontWeight:_e(new j),formatOnPaste:_e(new m(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:_e(new m(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:_e(new m(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:_e(new ie),hideCursorInOverviewRuler:_e(new m(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:_e(new m(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:_e(new K),inDiffEditor:_e(new m(51,"inDiffEditor",!1)),letterSpacing:_e(new f(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>f.clamp(X,-5,20),{description:b.localize(165,null)})),lightbulb:_e(new U),lineDecorationsWidth:_e(new C(54,"lineDecorationsWidth",10)),lineHeight:_e(new O),lineNumbers:_e(new Re),lineNumbersMinChars:_e(new l(57,"lineNumbersMinChars",5,1,300)),linkedEditing:_e(new m(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:_e(new m(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:_e(new _(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:_e(new M),mouseStyle:_e(new _(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:_e(new f(63,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:_e(new m(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:_e(new m(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:_e(new d(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],F,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:_e(new _(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:_e(new m(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:_e(new m(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:_e(new l(70,"overviewRulerLanes",3,0,3)),padding:_e(new W),parameterHints:_e(new q),peekWidgetDefaultFocus:_e(new _(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:_e(new m(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:_e(new le),quickSuggestionsDelay:_e(new l(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:_e(new m(77,"readOnly",!1)),renameOnType:_e(new m(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:_e(new m(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:_e(new m(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:_e(new m(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:_e(new _(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:_e(new m(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:_e(new _(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:_e(new _(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:_e(new l(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:_e(new m(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:_e(new Oe),scrollbar:_e(new Y),scrollBeyondLastColumn:_e(new l(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:_e(new m(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:_e(new m(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:_e(new m(93,"selectionClipboard",!0,{description:b.localize(201,null),included:I.isLinux})),selectionHighlight:_e(new m(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:_e(new m(95,"selectOnLineNumbers",!0)),showFoldingControls:_e(new _(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:_e(new m(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:_e(new m(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:_e(new L),snippetSuggestions:_e(new _(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:_e(new se),smoothScrolling:_e(new m(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:_e(new l(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:_e(new ee),suggestFontSize:_e(new l(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:_e(new l(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:_e(new m(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:_e(new _(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:_e(new _(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:_e(new l(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:_e(new _(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:_e(new m(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:_e(new E(112,"wordSeparators",A.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:_e(new _(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:_e(new E(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:_e(new E(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:_e(new l(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:_e(new _(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:_e(new _(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:_e(new d(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:_e(new _(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:_e(new p),pixelRatio:_e(new Q),tabFocusMode:_e(new fe),layoutInfo:_e(new $),wrappingInfo:_e(new pe)}}),define(me[152],ge([18,19]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(me[153],ge([18,19]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(me[154],ge([18,19]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(me[155],ge([18,19]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(me[156],ge([18,19]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(me[157],ge([18,19]),function(G,e){return G.create("vs/platform/markers/common/markers",e)}),define(me[158],ge([18,19]),function(G,e){return G.create("vs/platform/theme/common/iconRegistry",e)}),define(me[159],ge([18,19]),function(G,e){return G.create("vs/platform/workspaces/common/workspaces",e)}),define(me[160],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHost.api.impl",e)}),define(me[161],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(me[162],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostExtensionService",e)}),define(me[163],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostProgress",e)}),define(me[164],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostStatusBar",e)}),define(me[165],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTerminalService",e)}),define(me[166],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostTreeViews",e)}),define(me[167],ge([18,19]),function(G,e){return G.create("vs/workbench/api/common/extHostWorkspace",e)}),define(me[168],ge([18,19]),function(G,e){return G.create("vs/workbench/api/node/extHostDebugService",e)}),define(me[169],ge([18,19]),function(G,e){return G.create("vs/workbench/common/views",e)}),define(me[170],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(me[171],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(me[172],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(me[173],ge([18,19]),function(G,e){return G.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(me[174],ge([18,19]),function(G,e){return G.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(me[175],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var I;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(I=e.EditorOverride||(e.EditorOverride={}));var A;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(A=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(me[176],ge([0,1,154]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function A(C){return C=C.trim(),C==="*"||I.test(C)}e.isValidVersionStr=A;function T(C){if(!A(C))return null;if(C=C.trim(),C==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=C.match(I);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=T;function y(C){if(!C)return null;let g=C.majorBase,m=C.majorMustEqual,l=C.minorBase,f=C.minorMustEqual,E=C.patchBase,w=C.patchMustEqual;return C.hasCaret&&(g===0||(f=!1),w=!1),{majorBase:g,majorMustEqual:m,minorBase:l,minorMustEqual:f,patchBase:E,patchMustEqual:w,isMinimum:C.hasGreaterEquals}}e.normalizeVersion=y;function k(C,g){let m;typeof C=="string"?m=y(T(C)):m=C;let l;if(typeof g=="string"?l=y(T(g)):l=g,!m||!l)return!1;let f=m.majorBase,E=m.minorBase,w=m.patchBase,_=l.majorBase,d=l.minorBase,o=l.patchBase,c=l.majorMustEqual,t=l.minorMustEqual,n=l.patchMustEqual;return l.isMinimum?f>_?!0:f<_?!1:E>d?!0:E<d?!1:w>=o:(f===1&&_===0&&(!c||!t||!n)&&(_=1,d=0,o=0,c=!0,t=!1,n=!1),f<_?!1:f>_?!c:E<d?!1:E>d?!t:w<o?!1:w>o?!n:!0)}e.isValidVersion=k;function D(C,g,m){return g.isBuiltin||typeof g.main=="undefined"?!0:r(C,g.engines.vscode,m)}e.isValidExtensionVersion=D;function P(C,g){return C==="*"||r(g,C)}e.isEngineValid=P;function r(C,g,m=[]){let l=y(T(g));if(!l)return m.push(b.localize(0,null,g)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return m.push(b.localize(1,null,g)),!1}else if(!l.majorMustEqual)return m.push(b.localize(2,null,g)),!1;return k(C,l)?!0:(m.push(b.localize(3,null,C,g)),!1)}e.isVersionValid=r}),define(me[113],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(T,y=[],k=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=k}}e.SyncDescriptor=b;const I=(A,...T)=>new b(A,T);e.createSyncDescriptor=I}),define(me[79],ge([0,1,113]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const I=[];function A(y,k,D){k instanceof b.SyncDescriptor||(k=new b.SyncDescriptor(k,[],D)),I.push([y,k])}e.registerSingleton=A;function T(){return I}e.getSingletonServiceDescriptors=T}),define(me[177],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=b;class I{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const k=this.lookupOrInsertNode(T),D=this.lookupOrInsertNode(y);k.outgoing.set(this._hashFn(y),D),D.incoming.set(this._hashFn(T),k)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let k of this._nodes.values())k.outgoing.delete(y),k.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let k=this._nodes.get(y);return k||(k=new b(T),this._nodes.set(y,k)),k}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,k]of this._nodes)T.push(`${y}, (incoming)[${[...k.incoming.keys()].join(", ")}], (outgoing)[${[...k.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const k=new Set([T]),D=this._findCycle(y,k);if(D)return D}}_findCycle(T,y){for(let[k,D]of T.outgoing){if(y.has(k))return[...y,k].join(" -> ");y.add(k);const P=this._findCycle(D,y);if(P)return P;y.delete(k)}}}e.Graph=I}),define(me[4],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(k){k.serviceIds=new Map,k.DI_TARGET="$di$target",k.DI_DEPENDENCIES="$di$dependencies";function D(P){return P[k.DI_DEPENDENCIES]||[]}k.getServiceDependencies=D})(b=e._util||(e._util={})),e.IInstantiationService=A("instantiationService");function I(k,D,P,r){D[b.DI_TARGET]===D?D[b.DI_DEPENDENCIES].push({id:k,index:P,optional:r}):(D[b.DI_DEPENDENCIES]=[{id:k,index:P,optional:r}],D[b.DI_TARGET]=D)}function A(k){if(b.serviceIds.has(k))return b.serviceIds.get(k);const D=function(P,r,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");I(D,P,C,!1)};return D.toString=()=>k,b.serviceIds.set(k,D),D}e.createDecorator=A;function T(k){return k}e.refineServiceDecorator=T;function y(k){return function(D,P,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");I(k,D,r,!0)}}e.optional=y}),define(me[178],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function I(A){return!A.isTooLargeForSyncing()&&!A.isForSimpleWidget}e.shouldSynchronizeModel=I}),define(me[179],ge([0,1,3,74,6,22,73,77,178]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function P(g){return typeof g=="string"?!1:Array.isArray(g)?g.every(P):!!g.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(m,l){let f={selector:m,provider:l,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,A.toDisposable)(()=>{if(f){let E=this._entries.indexOf(f);E>=0&&(this._entries.splice(E,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(m){return this.all(m).length>0}all(m){if(!m)return[];this._updateScores(m);const l=[];for(let f of this._entries)f._score>0&&l.push(f.provider);return l}ordered(m){const l=[];return this._orderedForEach(m,f=>l.push(f.provider)),l}orderedGroups(m){const l=[];let f,E;return this._orderedForEach(m,w=>{f&&E===w._score?f.push(w.provider):(E=w._score,f=[w.provider],l.push(f))}),l}_orderedForEach(m,l){if(!!m){this._updateScores(m);for(const f of this._entries)f._score>0&&l(f)}}_updateScores(m){let l={uri:m.uri.toString(),language:m.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===l.language&&this._lastCandidate.uri===l.uri)){this._lastCandidate=l;for(let f of this._entries)if(f._score=(0,k.score)(f.selector,m.uri,m.getLanguageIdentifier().language,(0,D.shouldSynchronizeModel)(m)),P(f.selector)&&f._score>0){for(let E of this._entries)E._score=0;f._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(m,l){return m._score<l._score?1:m._score>l._score?-1:m._time<l._time?1:m._time>l._time?-1:0}}e.LanguageFeatureRegistry=r;class C{constructor(m,l,f=Number.MAX_SAFE_INTEGER){this._registry=m,this.min=l,this.max=f,this._cache=new T.LRUCache(50,.7)}_key(m){return m.id+(0,I.hash)(this._registry.all(m))}_clamp(m){return m===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(m*1.3)))}get(m){const l=this._key(m),f=this._cache.get(l);return this._clamp(f==null?void 0:f.value)}update(m,l){const f=this._key(m);let E=this._cache.get(f);return E||(E=new y.MovingAverage,this._cache.set(f,E)),E.update(l),this.get(m)}}e.LanguageFeatureRequestDelays=C}),define(me[80],ge([0,1,2,44,179,143,43]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var k;(function(u){u[u.Null=0]="Null",u[u.PlainText=1]="PlainText"})(k=e.LanguageId||(e.LanguageId={}));class D{constructor(v,R){this.language=v,this.id=R}}e.LanguageIdentifier=D;var P;(function(u){u[u.NotSet=-1]="NotSet",u[u.None=0]="None",u[u.Italic=1]="Italic",u[u.Bold=2]="Bold",u[u.Underline=4]="Underline"})(P=e.FontStyle||(e.FontStyle={}));var r;(function(u){u[u.None=0]="None",u[u.DefaultForeground=1]="DefaultForeground",u[u.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var C;(function(u){u[u.Other=0]="Other",u[u.Comment=1]="Comment",u[u.String=2]="String",u[u.RegEx=4]="RegEx"})(C=e.StandardTokenType||(e.StandardTokenType={}));var g;(function(u){u[u.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",u[u.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",u[u.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",u[u.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",u[u.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",u[u.ITALIC_MASK=2048]="ITALIC_MASK",u[u.BOLD_MASK=4096]="BOLD_MASK",u[u.UNDERLINE_MASK=8192]="UNDERLINE_MASK",u[u.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",u[u.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",u[u.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",u[u.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",u[u.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",u[u.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",u[u.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",u[u.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",u[u.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",u[u.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(g=e.MetadataConsts||(e.MetadataConsts={}));class m{static getLanguageId(v){return(v&255)>>>0}static getTokenType(v){return(v&1792)>>>8}static getFontStyle(v){return(v&14336)>>>11}static getForeground(v){return(v&8372224)>>>14}static getBackground(v){return(v&4286578688)>>>23}static getClassNameFromMetadata(v){let R=this.getForeground(v),N="mtk"+R,j=this.getFontStyle(v);return j&1&&(N+=" mtki"),j&2&&(N+=" mtkb"),j&4&&(N+=" mtku"),N}static getInlineStyleFromMetadata(v,R){const N=this.getForeground(v),j=this.getFontStyle(v);let ie=`color: ${R[N]};`;return j&1&&(ie+="font-style: italic;"),j&2&&(ie+="font-weight: bold;"),j&4&&(ie+="text-decoration: underline;"),ie}}e.TokenMetadata=m;var l;(function(u){u[u.Method=0]="Method",u[u.Function=1]="Function",u[u.Constructor=2]="Constructor",u[u.Field=3]="Field",u[u.Variable=4]="Variable",u[u.Class=5]="Class",u[u.Struct=6]="Struct",u[u.Interface=7]="Interface",u[u.Module=8]="Module",u[u.Property=9]="Property",u[u.Event=10]="Event",u[u.Operator=11]="Operator",u[u.Unit=12]="Unit",u[u.Value=13]="Value",u[u.Constant=14]="Constant",u[u.Enum=15]="Enum",u[u.EnumMember=16]="EnumMember",u[u.Keyword=17]="Keyword",u[u.Text=18]="Text",u[u.Color=19]="Color",u[u.File=20]="File",u[u.Reference=21]="Reference",u[u.Customcolor=22]="Customcolor",u[u.Folder=23]="Folder",u[u.TypeParameter=24]="TypeParameter",u[u.User=25]="User",u[u.Issue=26]="Issue",u[u.Snippet=27]="Snippet"})(l=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let u=Object.create(null);return u[0]="symbol-method",u[1]="symbol-function",u[2]="symbol-constructor",u[3]="symbol-field",u[4]="symbol-variable",u[5]="symbol-class",u[6]="symbol-struct",u[7]="symbol-interface",u[8]="symbol-module",u[9]="symbol-property",u[10]="symbol-event",u[11]="symbol-operator",u[12]="symbol-unit",u[13]="symbol-value",u[14]="symbol-constant",u[15]="symbol-enum",u[16]="symbol-enum-member",u[17]="symbol-keyword",u[27]="symbol-snippet",u[18]="symbol-text",u[19]="symbol-color",u[20]="symbol-file",u[21]="symbol-reference",u[22]="symbol-customcolor",u[23]="symbol-folder",u[24]="symbol-type-parameter",u[25]="account",u[26]="issues",function(v){const R=u[v];let N=R&&y.iconRegistry.get(R);return N||(console.info("No codicon found for CompletionItemKind "+v),N=y.Codicon.symbolProperty),N.classNames}}(),e.completionKindFromString=function(){let u=Object.create(null);return u.method=0,u.function=1,u.constructor=2,u.field=3,u.variable=4,u.class=5,u.struct=6,u.interface=7,u.module=8,u.property=9,u.event=10,u.operator=11,u.unit=12,u.value=13,u.constant=14,u.enum=15,u["enum-member"]=16,u.enumMember=16,u.keyword=17,u.snippet=27,u.text=18,u.color=19,u.file=20,u.reference=21,u.customcolor=22,u.folder=23,u["type-parameter"]=24,u.typeParameter=24,u.account=25,u.issue=26,function(v,R){let N=u[v];return typeof N=="undefined"&&!R&&(N=9),N}}();var f;(function(u){u[u.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var E;(function(u){u[u.KeepWhitespace=1]="KeepWhitespace",u[u.InsertAsSnippet=4]="InsertAsSnippet"})(E=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(u){u[u.Invoke=0]="Invoke",u[u.TriggerCharacter=1]="TriggerCharacter",u[u.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var _;(function(u){u[u.Invoke=1]="Invoke",u[u.Auto=2]="Auto"})(_=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(u){u[u.Invoke=1]="Invoke",u[u.TriggerCharacter=2]="TriggerCharacter",u[u.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var o;(function(u){u[u.Text=0]="Text",u[u.Read=1]="Read",u[u.Write=2]="Write"})(o=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function c(u){return u&&b.URI.isUri(u.uri)&&I.Range.isIRange(u.range)&&(I.Range.isIRange(u.originSelectionRange)||I.Range.isIRange(u.targetSelectionRange))}e.isLocationLink=c;var t;(function(u){u[u.File=0]="File",u[u.Module=1]="Module",u[u.Namespace=2]="Namespace",u[u.Package=3]="Package",u[u.Class=4]="Class",u[u.Method=5]="Method",u[u.Property=6]="Property",u[u.Field=7]="Field",u[u.Constructor=8]="Constructor",u[u.Enum=9]="Enum",u[u.Interface=10]="Interface",u[u.Function=11]="Function",u[u.Variable=12]="Variable",u[u.Constant=13]="Constant",u[u.String=14]="String",u[u.Number=15]="Number",u[u.Boolean=16]="Boolean",u[u.Array=17]="Array",u[u.Object=18]="Object",u[u.Key=19]="Key",u[u.Null=20]="Null",u[u.EnumMember=21]="EnumMember",u[u.Struct=22]="Struct",u[u.Event=23]="Event",u[u.Operator=24]="Operator",u[u.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(u){u[u.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(u){const v=new Map;v.set("file",0),v.set("module",1),v.set("namespace",2),v.set("package",3),v.set("class",4),v.set("method",5),v.set("property",6),v.set("field",7),v.set("constructor",8),v.set("enum",9),v.set("interface",10),v.set("function",11),v.set("variable",12),v.set("constant",13),v.set("string",14),v.set("number",15),v.set("boolean",16),v.set("array",17),v.set("object",18),v.set("key",19),v.set("null",20),v.set("enum-member",21),v.set("struct",22),v.set("event",23),v.set("operator",24),v.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function N(K){return v.get(K)}u.fromString=N;function j(K){return R.get(K)}u.toString=j;function ie(K,B){const $=R.get(K);let U=$&&y.iconRegistry.get("symbol-"+$);return U||(console.info("No codicon found for SymbolKind "+K),U=y.Codicon.symbolProperty),`${B?"inline":"block"} ${U.classNames}`}u.toCssClassName=ie})(s=e.SymbolKinds||(e.SymbolKinds={}));class i{constructor(v){this.value=v}}e.FoldingRangeKind=i,i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region");var a;(function(u){u[u.Collapsed=0]="Collapsed",u[u.Expanded=1]="Expanded"})(a=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var h;(function(u){u[u.Editing=0]="Editing",u[u.Preview=1]="Preview"})(h=e.CommentMode||(e.CommentMode={}));var p;(function(u){u[u.Other=0]="Other",u[u.Type=1]="Type",u[u.Parameter=2]="Parameter"})(p=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new A.LanguageFeatureRegistry,e.RenameProviderRegistry=new A.LanguageFeatureRegistry,e.CompletionProviderRegistry=new A.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new A.LanguageFeatureRegistry,e.HoverProviderRegistry=new A.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new A.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new A.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new A.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new A.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new A.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new A.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new A.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new A.LanguageFeatureRegistry,e.LinkProviderRegistry=new A.LanguageFeatureRegistry,e.ColorProviderRegistry=new A.LanguageFeatureRegistry,e.SelectionRangeRegistry=new A.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new A.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var S;(function(u){u[u.None=0]="None",u[u.Option=1]="Option",u[u.Default=2]="Default",u[u.Preferred=3]="Preferred"})(S=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(me[180],ge([0,1,6,11,4,3,57,55]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,A.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(D,P){if(!D)throw new Error("invalid command");if(typeof D=="string"){if(!P)throw new Error("invalid command");return this.registerCommand({id:D,handler:P})}if(D.description){const l=[];for(let E of D.description.args)l.push(E.constraint);const f=D.handler;D.handler=function(E,...w){return(0,I.validateConstraints)(w,l),f(E,...w)}}const{id:r}=D;let C=this._commands.get(r);C||(C=new y.LinkedList,this._commands.set(r,C));let g=C.unshift(D),m=(0,b.toDisposable)(()=>{g();const l=this._commands.get(r);(l==null?void 0:l.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),m}registerCommandAlias(D,P){return e.CommandsRegistry.registerCommand(D,(r,...C)=>r.get(e.ICommandService).executeCommand(P,...C))}getCommand(D){const P=this._commands.get(D);if(!(!P||P.isEmpty()))return k.Iterable.first(P)}getCommands(){const D=new Map;for(const P of this._commands.keys()){const r=this.getCommand(P);r&&D.set(P,r)}return D}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(me[81],ge([0,1,9,4,10]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=A.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",A.isMacintosh),y.set("isLinux",A.isLinux),y.set("isWindows",A.isWindows),y.set("isWeb",A.isWeb),y.set("isMacNative",A.isMacintosh&&!A.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const k=Object.prototype.hasOwnProperty;var D;(function(u){u[u.False=0]="False",u[u.True=1]="True",u[u.Defined=2]="Defined",u[u.Not=3]="Not",u[u.Equals=4]="Equals",u[u.NotEquals=5]="NotEquals",u[u.And=6]="And",u[u.Regex=7]="Regex",u[u.NotRegex=8]="NotRegex",u[u.Or=9]="Or",u[u.In=10]="In",u[u.NotIn=11]="NotIn",u[u.Greater=12]="Greater",u[u.GreaterEquals=13]="GreaterEquals",u[u.Smaller=14]="Smaller",u[u.SmallerEquals=15]="SmallerEquals"})(D=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return C.INSTANCE}static true(){return g.INSTANCE}static has(v){return m.create(v)}static equals(v,R){return l.create(v,R)}static notEquals(v,R){return w.create(v,R)}static regex(v,R){return n.create(v,R)}static in(v,R){return f.create(v,R)}static not(v){return _.create(v)}static and(...v){return i.create(v)}static or(...v){return a.create(v)}static greater(v,R){return d.create(v,R)}static less(v,R){return c.create(v,R)}static deserialize(v,R=!1){if(!!v)return this._deserializeOrExpression(v,R)}static _deserializeOrExpression(v,R){let N=v.split("||");return a.create(N.map(j=>this._deserializeAndExpression(j,R)))}static _deserializeAndExpression(v,R){let N=v.split("&&");return i.create(N.map(j=>this._deserializeOne(j,R)))}static _deserializeOne(v,R){if(v=v.trim(),v.indexOf("!=")>=0){let N=v.split("!=");return w.create(N[0].trim(),this._deserializeValue(N[1],R))}if(v.indexOf("==")>=0){let N=v.split("==");return l.create(N[0].trim(),this._deserializeValue(N[1],R))}if(v.indexOf("=~")>=0){let N=v.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],R))}if(v.indexOf(" in ")>=0){let N=v.split(" in ");return f.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const N=v.split(">=");return o.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const N=v.split(">");return d.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const N=v.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const N=v.split("<");return c.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(v)?_.create(v.substr(1).trim()):m.create(v)}static _deserializeValue(v,R){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let N=/^'([^']*)'$/.exec(v);return N?N[1].trim():v}static _deserializeRegexValue(v,R){if((0,b.isFalsyOrWhitespace)(v)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=v.indexOf("/"),j=v.lastIndexOf("/");if(N===j||N<0){if(R)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let ie=v.slice(N+1,j),K=v[j+1]==="i"?"i":"";try{return new RegExp(ie,K)}catch(B){if(R)throw new Error(`bad regexp-value '${v}', parse error: ${B}`);return console.warn(`bad regexp-value '${v}', parse error: ${B}`),null}}}e.ContextKeyExpr=P;function r(u,v){return u.cmp(v)}class C{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return g.INSTANCE}}e.ContextKeyFalseExpr=C,C.INSTANCE=new C;class g{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return C.INSTANCE}}e.ContextKeyTrueExpr=g,g.INSTANCE=new g;class m{constructor(v){this.key=v,this.type=2}static create(v){const R=y.get(v);return typeof R=="boolean"?R?g.INSTANCE:C.INSTANCE:new m(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return _.create(this.key)}}e.ContextKeyDefinedExpr=m;class l{constructor(v,R){this.key=v,this.value=R,this.type=4}static create(v,R){if(typeof R=="boolean")return R?m.create(v):_.create(v);const N=y.get(v);return typeof N=="boolean"?R===(N?"true":"false")?g.INSTANCE:C.INSTANCE:new l(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=l;class f{constructor(v,R){this.key=v,this.valueKey=R,this.type=10}static create(v,R){return new f(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}evaluate(v){const R=v.getValue(this.valueKey),N=v.getValue(this.key);return Array.isArray(R)?R.indexOf(N)>=0:typeof N=="string"&&typeof R=="object"&&R!==null?k.call(R,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return E.create(this)}}e.ContextKeyInExpr=f;class E{constructor(v){this._actual=v,this.type=11}static create(v){return new E(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new E(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=E;class w{constructor(v,R){this.key=v,this.value=R,this.type=5}static create(v,R){if(typeof R=="boolean")return R?_.create(v):m.create(v);const N=y.get(v);return typeof N=="boolean"?R===(N?"true":"false")?C.INSTANCE:g.INSTANCE:new w(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class _{constructor(v){this.key=v,this.type=3}static create(v){const R=y.get(v);return typeof R=="boolean"?R?C.INSTANCE:g.INSTANCE:new _(v)}cmp(v){return v.type!==this.type?this.type-v.type:p(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return m.create(this.key)}}e.ContextKeyNotExpr=_;class d{constructor(v,R){this.key=v,this.value=R,this.type=12}static create(v,R){return new d(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=d;class o{constructor(v,R){this.key=v,this.value=R,this.type=13}static create(v,R){return new o(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=o;class c{constructor(v,R){this.key=v,this.value=R,this.type=14}static create(v,R){return new c(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeySmallerExpr=c;class t{constructor(v,R){this.key=v,this.value=R,this.type=15}static create(v,R){return new t(v,R)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}evaluate(v){return parseFloat(v.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(v,R){this.key=v,this.regexp=R,this.type=7}static create(v,R){return new n(v,R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const R=this.regexp?this.regexp.source:"",N=v.regexp?v.regexp.source:"";return R<N?-1:R>N?1:0}equals(v){if(v.type===this.type){const R=this.regexp?this.regexp.source:"",N=v.regexp?v.regexp.source:"";return this.key===v.key&&R===N}return!1}evaluate(v){let R=v.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=n;class s{constructor(v){this._actual=v,this.type=8}static create(v){return new s(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new s(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(v){this.expr=v,this.type=6}static create(v){return i._normalizeArr(v)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=r(this.expr[R],v.expr[R]);if(j!==0)return j}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].evaluate(v))return!1;return!0}static _normalizeArr(v){const R=[];let N=!1;for(const j of v)if(!!j){if(j.type===1){N=!0;continue}if(j.type===0)return C.INSTANCE;if(j.type===6){R.push(...j.expr);continue}R.push(j)}if(R.length===0&&N)return g.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(r);R.length>1;){const j=R[R.length-1];if(j.type!==9)break;R.pop();const ie=R.pop(),K=a.create(j.expr.map(B=>i.create([B,ie])));K&&(R.push(K),R.sort(r))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new i(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let R of this.expr)v.push(R.negate());return a.create(v)}}e.ContextKeyAndExpr=i;class a{constructor(v){this.expr=v,this.type=9}static create(v){const R=a._normalizeArr(v);if(R.length!==0)return R.length===1?R[0]:new a(R)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let R=0,N=this.expr.length;R<N;R++){const j=r(this.expr[R],v.expr[R]);if(j!==0)return j}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let R=0,N=this.expr.length;R<N;R++)if(!this.expr[R].equals(v.expr[R]))return!1;return!0}return!1}evaluate(v){for(let R=0,N=this.expr.length;R<N;R++)if(this.expr[R].evaluate(v))return!0;return!1}static _normalizeArr(v){let R=[],N=!1;if(v){for(let j=0,ie=v.length;j<ie;j++){const K=v[j];if(!!K){if(K.type===0){N=!0;continue}if(K.type===1)return[g.INSTANCE];if(K.type===9){R=R.concat(K.expr);continue}R.push(K)}}if(R.length===0&&N)return[C.INSTANCE];R.sort(r)}return R}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let R of this.expr)v.push(...R.keys());return v}map(v){return new a(this.expr.map(R=>R.map(v)))}negate(){let v=[];for(let N of this.expr)v.push(N.negate());const R=N=>N.type===9?N.expr:[N];for(;v.length>1;){const N=v.shift(),j=v.shift(),ie=[];for(const K of R(N))for(const B of R(j))ie.push(P.and(K,B));v.unshift(P.or(...ie))}return v[0]}}e.ContextKeyOrExpr=a;class h extends m{constructor(v,R,N){super(v);this._defaultValue=R,typeof N=="object"?h._info.push(Object.assign(Object.assign({},N),{key:v})):N!==!0&&h._info.push({key:v,description:N,type:R!=null?typeof R:void 0})}static all(){return h._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return P.not(this.key)}isEqualTo(v){return P.equals(this.key,v)}notEqualsTo(v){return P.notEquals(this.key,v)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,I.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(u,v){return u<v?-1:u>v?1:0}function S(u,v,R,N){return u<R?-1:u>R?1:v<N?-1:v>N?1:0}}),define(me[181],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(me[182],ge([0,1,153,4,12]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function T(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=T;var y;(function(C){C[C.NoneOrRelevance=0]="NoneOrRelevance",C[C.LastUpdatedDate=1]="LastUpdatedDate",C[C.Title=2]="Title",C[C.PublisherName=3]="PublisherName",C[C.InstallCount=4]="InstallCount",C[C.PublishedDate=5]="PublishedDate",C[C.AverageRating=6]="AverageRating",C[C.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var k;(function(C){C[C.Default=0]="Default",C[C.Ascending=1]="Ascending",C[C.Descending=2]="Descending"})(k=e.SortOrder||(e.SortOrder={}));var D;(function(C){C.Uninstall="uninstall"})(D=e.StatisticType||(e.StatisticType={}));var P;(function(C){C[C.None=0]="None",C[C.Install=1]="Install",C[C.Update=2]="Update"})(P=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,I.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(g,m){super(g);this.code=m}}e.ExtensionManagementError=r,e.IExtensionManagementService=(0,I.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,I.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,I.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=A.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,b.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,b.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,I.createDecorator)("IExtensionManagementCLIService")}),define(me[27],ge([0,1,9,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function A(P){return P&&typeof P=="object"&&typeof P.id=="string"&&(!P.uuid||typeof P.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(P){P[P.System=0]="System",P[P.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,C){if(typeof r=="undefined"||r===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof r=="string"||typeof C=="string"){let g=typeof r=="string"?r:r.value,m=typeof C=="string"?C:C.value;return b.equalsIgnoreCase(g,m)}return r._lower===C._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.ExtensionIdentifier=y;function k(P){return P.contributes&&P.contributes.localizations?P.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function D(P){return P.contributes&&P.contributes.authentication?P.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=(0,I.createDecorator)("IBuiltinExtensionsScannerService")}),define(me[183],ge([0,1,9,27]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function A(m,l){return m.uuid&&l.uuid?m.uuid===l.uuid:m.id===l.id?!0:(0,b.compareIgnoreCase)(m.id,l.id)===0}e.areSameExtensions=A;class T{constructor(l,f){this.version=f,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof T?A(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(m,l){return`${m}.${l}`}e.getExtensionId=y;function k(m){return m.toLocaleLowerCase()}e.adoptToGalleryExtensionId=k;function D(m,l){return k(y(m,l))}e.getGalleryExtensionId=D;function P(m,l){const f=[],E=w=>{for(const _ of f)if(_.some(d=>A(l(d),l(w))))return _;return null};for(const w of m){const _=E(w);_?_.push(w):f.push([w])}return f}e.groupByExtension=P;function r(m){return{id:m.identifier.id,name:m.manifest.name,galleryId:null,publisherId:m.publisherId,publisherName:m.manifest.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:m.manifest.extensionDependencies&&m.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function C(m){return Object.assign({id:m.identifier.id,name:m.name,galleryId:m.identifier.uuid,publisherId:m.publisherId,publisherName:m.publisher,publisherDisplayName:m.publisherDisplayName,dependencies:!!(m.properties.dependencies&&m.properties.dependencies.length>0)},m.telemetryData)}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function g(m){const l=new Set;for(const f of m)f.malicious&&l.add(f.id.id);return l}e.getMaliciousExtensionsSet=g}),define(me[184],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,b.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,b.createDecorator)("externalTerminal")}),define(me[45],ge([0,1,156,8,2,4,9,11,22]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function P(K){return K.create===!0}e.isFileOpenForWriteOptions=P;var r;(function(K){K[K.Unknown=0]="Unknown",K[K.File=1]="File",K[K.Directory=2]="Directory",K[K.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var C;(function(K){K[K.FileReadWrite=2]="FileReadWrite",K[K.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",K[K.FileReadStream=16]="FileReadStream",K[K.FileFolderCopy=8]="FileFolderCopy",K[K.PathCaseSensitive=1024]="PathCaseSensitive",K[K.Readonly=2048]="Readonly",K[K.Trash=4096]="Trash",K[K.FileWriteUnlock=8192]="FileWriteUnlock"})(C=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(K){return!!(K.capabilities&2)}e.hasReadWriteCapability=g;function m(K){return!!(K.capabilities&8)}e.hasFileFolderCopyCapability=m;function l(K){return!!(K.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function f(K){return!!(K.capabilities&16)}e.hasFileReadStreamCapability=f;var E;(function(K){K.FileExists="EntryExists",K.FileNotFound="EntryNotFound",K.FileNotADirectory="EntryNotADirectory",K.FileIsADirectory="EntryIsADirectory",K.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",K.FileTooLarge="EntryTooLarge",K.FileWriteLocked="EntryWriteLocked",K.NoPermissions="NoPermissions",K.Unavailable="Unavailable",K.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(B,$){super(B);this.code=$}}e.FileSystemProviderError=w;function _(K,B){const $=new w(K.toString(),B);return o($,B),$}e.createFileSystemProviderError=_;function d(K){return K||_((0,b.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=d;function o(K,B){return K.name=B?`${B} (FileSystemError)`:"FileSystemError",K}e.markAsFileSystemProviderError=o;function c(K){if(!K)return E.Unknown;if(K instanceof w)return K.code;const B=/^(.+) \(FileSystemError\)$/.exec(K.name);if(!B)return E.Unknown;switch(B[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=c;function t(K){if(K instanceof p)return K.fileOperationResult;switch(c(K)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(K){K[K.CREATE=0]="CREATE",K[K.DELETE=1]="DELETE",K[K.MOVE=2]="MOVE",K[K.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(B,$,U){this.resource=B,this.operation=$,this.target=U}isOperation(B){return this.operation===B}}e.FileOperationEvent=s;var i;(function(K){K[K.UPDATED=0]="UPDATED",K[K.ADDED=1]="ADDED",K[K.DELETED=2]="DELETED"})(i=e.FileChangeType||(e.FileChangeType={}));class a{constructor(B,$){this.ignorePathCasing=$,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=B;for(const U of B)switch(U.type){case 1:this.added||(this.added=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=D.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(B,...$){return this.doContains(B,{includeChildren:!1},...$)}affects(B,...$){return this.doContains(B,{includeChildren:!0},...$)}doContains(B,$,...U){var L,O,M,F,W,q;if(!B)return!1;const Q=U.length>0;return!!((!Q||U.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(B))||$.includeChildren&&((O=this.added)===null||O===void 0?void 0:O.findSuperstr(B)))||(!Q||U.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(B))||$.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr(B)))||(!Q||U.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(B))||$.includeChildren&&((q=this.deleted)===null||q===void 0?void 0:q.findSuperstr(B))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(B){const $=[],U=B===1?this.added:B===0?this.updated:this.deleted;if(U)for(const[,L]of U)$.push(L);return $}filter(B){return new a(this.changes.filter($=>B($)),this.ignorePathCasing)}}e.FileChangesEvent=a;function h(K,B,$){return!K||!B||K===B||B.length>K.length?!1:(B.charAt(B.length-1)!==I.sep&&(B+=I.sep),$?(0,y.startsWithIgnoreCase)(K,B):K.indexOf(B)===0)}e.isParent=h;class p extends Error{constructor(B,$,U){super(B);this.fileOperationResult=$,this.options=U}static isFileOperationError(B){return B instanceof Error&&!(0,k.isUndefinedOrNull)(B.fileOperationResult)}}e.FileOperationError=p;var S;(function(K){K[K.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",K[K.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",K[K.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",K[K.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",K[K.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",K[K.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",K[K.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",K[K.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",K[K.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",K[K.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",K[K.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",K[K.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(S=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var u;(function(K){K[K.FILE=0]="FILE",K[K.FOLDER=1]="FOLDER",K[K.ROOT_FOLDER=2]="ROOT_FOLDER"})(u=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(K){if(!(typeof K.size!="number"||typeof K.mtime!="number"))return K.mtime.toString(29)+K.size.toString(31)}e.etag=v;async function R(K,B){if(!B.canHandleResource(A.URI.from({scheme:K.scheme})))return new Promise($=>{const U=B.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===K.scheme&&L.added&&(U.dispose(),$())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class N{static formatSize(B){return(0,k.isNumber)(B)||(B=0),B<N.KB?(0,b.localize)(1,null,B.toFixed(0)):B<N.MB?(0,b.localize)(2,null,(B/N.KB).toFixed(2)):B<N.GB?(0,b.localize)(3,null,(B/N.MB).toFixed(2)):B<N.TB?(0,b.localize)(4,null,(B/N.GB).toFixed(2)):(0,b.localize)(5,null,(B/N.TB).toFixed(2))}}e.ByteSize=N,N.KB=1024,N.MB=N.KB*N.KB,N.GB=N.MB*N.KB,N.TB=N.GB*N.KB;var j;(function(K){K[K.IA32=0]="IA32",K[K.OTHER=1]="OTHER"})(j=e.Arch||(e.Arch={}));function ie(K){return{maxFileSize:K===0?300*N.MB:16*N.GB,maxHeapSize:K===0?700*N.MB:2*700*N.MB}}e.getPlatformLimits=ie}),define(me[82],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...A){this._entries=new Map;for(let[T,y]of A)this.set(T,y)}set(A,T){const y=this._entries.get(A);return this._entries.set(A,T),y}has(A){return this._entries.has(A)}get(A){return this._entries.get(A)}}e.ServiceCollection=b}),define(me[185],ge([0,1,17,177,113,4,82,13]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const D=!1;class P extends Error{constructor(l){var f;super("cyclic dependency between services");this.message=(f=l.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${l.toString()}`}}class r{constructor(l=new y.ServiceCollection,f=!1,E){this._activeInstantiations=new Set,this._services=l,this._strict=f,this._parent=E,this._services.set(T.IInstantiationService,this)}createChild(l){return new r(l,this._strict,this)}invokeFunction(l,...f){let E=g.traceInvocation(l),w=!1;try{return l({get:(d,o)=>{if(w)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(d,E);if(!c&&o!==T.optional)throw new Error(`[invokeFunction] unknown service '${d}'`);return c}},...f)}finally{w=!0,E.stop()}}createInstance(l,...f){let E,w;return l instanceof A.SyncDescriptor?(E=g.traceCreation(l.ctor),w=this._createInstance(l.ctor,l.staticArguments.concat(f),E)):(E=g.traceCreation(l),w=this._createInstance(l,f,E)),E.stop(),w}_createInstance(l,f=[],E){let w=T._util.getServiceDependencies(l).sort((o,c)=>o.index-c.index),_=[];for(const o of w){let c=this._getOrCreateServiceInstance(o.id,E);if(!c&&this._strict&&!o.optional)throw new Error(`[createInstance] ${l.name} depends on UNKNOWN service ${o.id}.`);_.push(c)}let d=w.length>0?w[0].index:f.length;if(f.length!==d){console.warn(`[createInstance] First service dependency of ${l.name} at position ${d+1} conflicts with ${f.length} static arguments`);let o=d-f.length;o>0?f=f.concat(new Array(o)):f=f.slice(0,d)}return new l(...[...f,..._])}_setServiceInstance(l,f){if(this._services.get(l)instanceof A.SyncDescriptor)this._services.set(l,f);else if(this._parent)this._parent._setServiceInstance(l,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(l){let f=this._services.get(l);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(l):f}_getOrCreateServiceInstance(l,f){let E=this._getServiceInstanceOrDescriptor(l);return E instanceof A.SyncDescriptor?this._safeCreateAndCacheServiceInstance(l,E,f.branch(l,!0)):(f.branch(l,!1),E)}_safeCreateAndCacheServiceInstance(l,f,E){if(this._activeInstantiations.has(l))throw new Error(`illegal state - RECURSIVELY instantiating service '${l}'`);this._activeInstantiations.add(l);try{return this._createAndCacheServiceInstance(l,f,E)}finally{this._activeInstantiations.delete(l)}}_createAndCacheServiceInstance(l,f,E){const w=new I.Graph(o=>o.id.toString());let _=0;const d=[{id:l,desc:f,_trace:E}];for(;d.length;){const o=d.pop();if(w.lookupOrInsertNode(o),_++>1e3)throw new P(w);for(let c of T._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(c.id);if(!t&&!c.optional&&console.warn(`[createInstance] ${l} depends on ${c.id} which is NOT registered.`),t instanceof A.SyncDescriptor){const n={id:c.id,desc:t,_trace:o._trace.branch(c.id,!0)};w.insertEdge(o,n),d.push(n)}}}for(;;){const o=w.roots();if(o.length===0){if(!w.isEmpty())throw new P(w);break}for(const{data:c}of o){if(this._getServiceInstanceOrDescriptor(c.id)instanceof A.SyncDescriptor){const n=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,n)}w.removeNode(c)}}return this._getServiceInstanceOrDescriptor(l)}_createServiceInstanceWithOwner(l,f,E=[],w,_){if(this._services.get(l)instanceof A.SyncDescriptor)return this._createServiceInstance(f,E,w,_);if(this._parent)return this._parent._createServiceInstanceWithOwner(l,f,E,w,_);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(l,f=[],E,w){if(E){const _=new k.IdleValue(()=>this._createInstance(l,f,w));return new Proxy(Object.create(null),{get(d,o){if(o in d)return d[o];let c=_.value,t=c[o];return typeof t!="function"||(t=t.bind(c),d[o]=t),t},set(d,o,c){return _.value[o]=c,!0}})}else return this._createInstance(l,f,w)}}e.InstantiationService=r;var C;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(C||(C={}));class g{constructor(l,f){this.type=l,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(l){return D?new g(1,l.name||l.toString().substring(0,42).replace(/\n/g,"")):g._None}static traceCreation(l){return D?new g(0,l.name):g._None}branch(l,f){let E=new g(2,l.toString());return this._dep.push([l,f,E]),E}stop(){let l=Date.now()-this._start;g._totals+=l;let f=!1;function E(_,d){let o=[],c=new Array(_+1).join("	");for(const[t,n,s]of d._dep)if(n&&s){f=!0,o.push(`${c}CREATES -> ${t}`);let i=E(_+1,s);i&&o.push(i)}else o.push(`${c}uses -> ${t}`);return o.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${l.toFixed(2)}ms (grand total ${g._totals.toFixed(2)}ms)`];(l>2||f)&&console.log(w.join(`
`))}}g._None=new class extends g{constructor(){super(-1,null)}stop(){}branch(){return this}},g._totals=0}),define(me[14],ge([0,1,4,6,10,3,60]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function k(){return new Date().toISOString()}var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;class P extends I.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class r extends P{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(D.Trace)&&this.log(D.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(D.Debug)&&this.log(D.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(D.Info)&&this.log(D.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(D.Warning)&&this.log(D.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(D.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(D.Error,this.format(s))}else this.log(D.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(D.Critical)&&this.log(D.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(a){}n+=(s>0?" ":"")+i}return n}}e.AbstractMessageLogger=r;class C extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!A.isWindows}trace(t,...n){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}debug(t,...n){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}info(t,...n){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${k()}][0m`,t,...n):console.log(`[main ${k()}]`,t,...n))}warn(t,...n){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${k()}][0m`,t,...n):console.warn(`[main ${k()}]`,t,...n))}error(t,...n){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}critical(t,...n){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${k()}][0m`,t,...n):console.error(`[main ${k()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=C;class g extends P{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=g;class m extends P{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class l extends P{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const s of this.logServices)s.trace(t,...n)}debug(t,...n){for(const s of this.logServices)s.debug(t,...n)}info(t,...n){for(const s of this.logServices)s.info(t,...n)}warn(t,...n){for(const s of this.logServices)s.warn(t,...n)}error(t,...n){for(const s of this.logServices)s.error(t,...n)}critical(t,...n){for(const s of this.logServices)s.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=l;class f extends I.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=f;class E extends I.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}createLogger(t,n){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(n==null?void 0:n.always)?D.Trace:this.logLevel,n),this.loggers.set(t.toString(),s),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class w{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return D.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=w;function _(c){if(c.verbose)return D.Trace;if(typeof c.logLevel=="string"){const t=d(c.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=_;function d(c){switch(c){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=d;function o(c){switch(c){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=o}),define(me[114],ge([0,1,14,45]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function A(D,P,r,C){try{const g=await new Promise((m,l)=>{G(["spdlog"],m,l)});return g.setAsyncMode(8192,500),g.createRotatingLoggerAsync(D,P,r,C)}catch(g){console.error(g)}return null}function T(D,P,r,C){return G.__$__nodeRequire("spdlog").createRotatingLogger(D,P,r,C)}e.createRotatingLogger=T;function y(D,P,r){switch(P){case b.LogLevel.Trace:D.trace(r);break;case b.LogLevel.Debug:D.debug(r);break;case b.LogLevel.Info:D.info(r);break;case b.LogLevel.Warning:D.warn(r);break;case b.LogLevel.Error:D.error(r);break;case b.LogLevel.Critical:D.critical(r);break;default:throw new Error("Invalid log level")}}class k extends b.AbstractMessageLogger{constructor(P,r,C,g){super();this.name=P,this.filepath=r,this.rotating=C,this.buffer=[],this.setLevel(g),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const P=this.rotating?6:1,r=30/P*I.ByteSize.MB;return A(this.name,this.filepath,r,P).then(C=>{if(C){this._logger=C,this._logger.setLevel(this.getLevel());for(const{level:g,message:m}of this.buffer)y(this._logger,g,m);this.buffer=[]}})}log(P,r){this._logger?y(this._logger,P,r):this.getLevel()<=P&&this.buffer.push({level:P,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=k}),define(me[115],ge([0,1,4,157,58]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function P(l,f){return f-l}D.compare=P;const r=Object.create(null);r[D.Error]=(0,I.localize)(0,null),r[D.Warning]=(0,I.localize)(1,null),r[D.Info]=(0,I.localize)(2,null);function C(l){return r[l]||""}D.toString=C;function g(l){switch(l){case A.default.Error:return D.Error;case A.default.Warning:return D.Warning;case A.default.Info:return D.Info;case A.default.Ignore:return D.Hint}}D.fromSeverity=g;function m(l){switch(l){case D.Error:return A.default.Error;case D.Warning:return A.default.Warning;case D.Info:return A.default.Info;case D.Hint:return A.default.Ignore}}D.toSeverity=m}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var k;(function(D){const P="";function r(g){return C(g,!0)}D.makeKey=r;function C(g,m){let l=[P];return g.source?l.push(g.source.replace("\xA6","\\\xA6")):l.push(P),g.code?typeof g.code=="string"?l.push(g.code.replace("\xA6","\\\xA6")):l.push(g.code.value.replace("\xA6","\\\xA6")):l.push(P),g.severity!==void 0&&g.severity!==null?l.push(y.toString(g.severity)):l.push(P),g.message&&m?l.push(g.message.replace("\xA6","\\\xA6")):l.push(P),g.startLineNumber!==void 0&&g.startLineNumber!==null?l.push(g.startLineNumber.toString()):l.push(P),g.startColumn!==void 0&&g.startColumn!==null?l.push(g.startColumn.toString()):l.push(P),g.endLineNumber!==void 0&&g.endLineNumber!==null?l.push(g.endLineNumber.toString()):l.push(P),g.endColumn!==void 0&&g.endColumn!==null?l.push(g.endColumn.toString()):l.push(P),l.push(P),l.join("\xA6")}D.makeKeyOptionalMessage=C})(k=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(me[186],ge([0,1,58,4,3]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,I.createDecorator)("notificationService");var T;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class k{constructor(){this.progress=new D,this.onDidClose=A.Event.None,this.onDidChangeVisibility=A.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=k;class D{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=D}),define(me[187],ge([0,1,12,10,36,25]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let y;if(typeof I.globals.vscode!="undefined"){const k=I.globals.vscode.context.configuration();if(k)y=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const k=(0,T.dirname)(b.FileAccess.asFileUri("",G));y=G.__$__nodeRequire((0,T.joinPath)(k,"product.json").fsPath);const D=G.__$__nodeRequire((0,T.joinPath)(k,"package.json").fsPath);A.env.VSCODE_DEV&&Object.assign(y,{nameShort:`${y.nameShort} Dev`,nameLong:`${y.nameLong} Dev`,dataFolderName:`${y.dataFolderName}-dev`}),Object.assign(y,{version:D.version})}else y={},Object.keys(y).length===0&&Object.assign(y,{version:"1.57.0-dev",nameShort:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:I.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=y});var He=this&&this.__param||function(G,e){return function(b,I){e(b,I,G)}};define(me[116],ge([0,1,4,21,6,13]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class k{constructor(C){this.callback=C}get value(){return this._value}report(C){this._value=C,this.callback(this._value)}}e.Progress=k,k.None=Object.freeze({report(){}});let D=class extends A.Disposable{constructor(C,g){super();this.deferred=new T.DeferredPromise,g.withProgress(C,m=>(this.reporter=m,this.lastStep&&m.report(this.lastStep),this.deferred.p)),this._register((0,A.toDisposable)(()=>this.deferred.complete()))}report(C){this.reporter?this.reporter.report(C):this.lastStep=C}};D=qe([He(1,e.IProgressService)],D),e.UnmanagedProgress=D;class P extends A.Disposable{constructor(C){super();this.progressIndicator=C,this.currentOperationId=0,this.currentOperationDisposables=this._register(new A.DisposableStore)}start(C){this.stop();const g=++this.currentOperationId,m=new I.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{g===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},C),this.currentOperationDisposables.add((0,A.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,A.toDisposable)(()=>m.cancel())),this.currentOperationDisposables.add((0,A.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:g,token:m.token,stop:()=>this.doStop(g),isCurrent:()=>this.currentOperationId===g}}stop(){this.doStop(this.currentOperationId)}doStop(C){this.currentOperationId===C&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(me[40],ge([0,1,11,52]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class A{constructor(){this.data=new Map}add(y,k){I.ok(b.isString(y)),I.ok(b.isObject(k)),I.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,k)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new A}),define(me[117],ge([0,1,40,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function A(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class T{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,P){this.schemasById[A(D)]=P,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;b.Registry.add(e.Extensions.JSONContribution,y)}),define(me[83],ge([0,1,152,3,40,11,117]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const D=A.Registry.as(y.Extensions.JSONContribution);class P{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new I.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new I.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,_=!0){this.registerConfigurations([w],_)}registerConfigurations(w,_=!0){const d=[];w.forEach(o=>{d.push(...this.validateAndRegisterProperties(o,_,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(d)}deregisterConfigurations(w){const _=[],d=o=>{if(o.properties)for(const c in o.properties)_.push(c),delete this.configurationProperties[c],this.removeFromSchema(c,o.properties[c]);o.allOf&&o.allOf.forEach(c=>d(c))};for(const o of w){d(o);const c=this.configurationContributors.indexOf(o);c!==-1&&this.configurationContributors.splice(c,1)}D.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}registerDefaultConfigurations(w){const _=[],d=[];for(const o of w)for(const c in o)if(_.push(c),e.OVERRIDE_PROPERTY_PATTERN.test(c)){this.defaultValues[c]=Object.assign(Object.assign({},this.defaultValues[c]||{}),o[c]);const t={type:"object",default:this.defaultValues[c],description:b.localize(1,null,c),$ref:e.resourceLanguageSettingsSchemaId};d.push(C(c)),this.configurationProperties[c]=t,this.defaultLanguageConfigurationOverridesNode.properties[c]=t}else{this.defaultValues[c]=o[c];const t=this.configurationProperties[c];t&&(this.updatePropertyDefaultValue(c,t),this.updateSchema(c,t))}this.registerOverrideIdentifiers(d),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}deregisterDefaultConfigurations(w){const _=[];for(const d of w)for(const o in d)if(_.push(o),delete this.defaultValues[o],e.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const c=this.configurationProperties[o];c&&(this.updatePropertyDefaultValue(o,c),this.updateSchema(o,c))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(_)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const _ of w)this.overrideIdentifiers.add(_);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,_=!0,d,o=3){var c;o=T.isUndefinedOrNull(w.scope)?o:w.scope;let t=[],n=w.properties;if(n)for(let i in n){if(_&&l(i)){delete n[i];continue}const a=n[i];if(this.updatePropertyDefaultValue(i,a),e.OVERRIDE_PROPERTY_PATTERN.test(i)?a.scope=void 0:(a.scope=T.isUndefinedOrNull(a.scope)?o:a.scope,a.restricted=T.isUndefinedOrNull(a.restricted)?!!((c=d==null?void 0:d.restrictedConfigurations)===null||c===void 0?void 0:c.includes(i)):a.restricted),n[i].hasOwnProperty("included")&&!n[i].included){this.excludedConfigurationProperties[i]=n[i],delete n[i];continue}else this.configurationProperties[i]=n[i];!n[i].deprecationMessage&&n[i].markdownDeprecationMessage&&(n[i].deprecationMessage=n[i].markdownDeprecationMessage),t.push(i)}let s=w.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,_,d,o));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const _=d=>{let o=d.properties;if(o)for(const t in o)this.updateSchema(t,o[t]);let c=d.allOf;c&&c.forEach(_)};_(w)}updateSchema(w,_){switch(e.allSettings.properties[w]=_,_.scope){case 1:e.applicationSettings.properties[w]=_;break;case 2:e.machineSettings.properties[w]=_;break;case 6:e.machineOverridableSettings.properties[w]=_;break;case 3:e.windowSettings.properties[w]=_;break;case 4:e.resourceSettings.properties[w]=_;break;case 5:e.resourceSettings.properties[w]=_,this.resourceLanguageSettingsSchema.properties[w]=_;break}}removeFromSchema(w,_){switch(delete e.allSettings.properties[w],_.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const _=`[${w}]`,d={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(_,d),e.allSettings.properties[_]=d,e.applicationSettings.properties[_]=d,e.machineSettings.properties[_]=d,e.machineOverridableSettings.properties[_]=d,e.windowSettings.properties[_]=d,e.resourceSettings.properties[_]=d}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,_){let d=this.defaultValues[w];T.isUndefined(d)&&(d=_.default),T.isUndefined(d)&&(d=g(_.type)),_.default=d}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function C(E){return E.substring(1,E.length-1)}e.overrideIdentifierFromKey=C;function g(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const m=new P;A.Registry.add(e.Extensions.Configuration,m);function l(E){return E.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(E)?b.localize(5,null,E):m.getConfigurationProperties()[E]!==void 0?b.localize(6,null,E):null:b.localize(4,null)}e.validateProperty=l;function f(){const E=[],w=m.getConfigurationProperties();for(const _ of Object.keys(w))E.push([_,w[_].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.getScopes=f}),define(me[84],ge([0,1,24,11,2,40,4,83]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function D(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof A.URI)}e.isConfigurationOverrides=D;var P;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function C(n,s){const i=s?n?s.keys.filter(R=>n.keys.indexOf(R)===-1):[...s.keys]:[],a=n?s?n.keys.filter(R=>s.keys.indexOf(R)===-1):[...n.keys]:[],h=[];if(s&&n){for(const R of n.keys)if(s.keys.indexOf(R)!==-1){const N=w(n.contents,R),j=w(s.contents,R);b.equals(N,j)||h.push(R)}}const p=[],S=R=>{const N={};for(const j of R)for(const ie of j.identifiers)N[c(ie)]=j;return N},u=s?S(s.overrides):{},v=n?S(n.overrides):{};if(Object.keys(u).length)for(const R of i){const N=u[R];N&&p.push([(0,k.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(v).length)for(const R of a){const N=v[R];N&&p.push([(0,k.overrideIdentifierFromKey)(R),N.keys])}if(Object.keys(u).length&&Object.keys(v).length)for(const R of h){const N=v[R],j=u[R];if(N&&j){const ie=C({contents:N.contents,keys:N.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});p.push([(0,k.overrideIdentifierFromKey)(R),[...ie.added,...ie.removed,...ie.updated]])}}return{added:i,removed:a,updated:h,overrides:p}}e.compare=C;function g(n,s){const i=[];for(const a of Object.keys(n))if(k.OVERRIDE_PROPERTY_PATTERN.test(a)){const h={};for(const p in n[a])h[p]=n[a][p];i.push({identifiers:[(0,k.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(h),contents:m(h,s)})}return i}e.toOverrides=g;function m(n,s){const i=Object.create(null);for(let a in n)l(i,a,n[a],s);return i}e.toValuesTree=m;function l(n,s,i,a){const h=s.split("."),p=h.pop();let S=n;for(let u=0;u<h.length;u++){let v=h[u],R=S[v];switch(typeof R){case"undefined":R=S[v]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(R)}`);return}S=R}if(typeof S=="object"&&S!==null)try{S[p]=i}catch(u){a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(S)}`)}else a(`Ignoring ${s} as ${h.join(".")} is ${JSON.stringify(S)}`)}e.addToValueTree=l;function f(n,s){const i=s.split(".");E(n,i)}e.removeFromValueTree=f;function E(n,s){const i=s.shift();if(s.length===0){delete n[i];return}if(Object.keys(n).indexOf(i)!==-1){const a=n[i];typeof a=="object"&&!Array.isArray(a)&&(E(a,s),Object.keys(a).length===0&&delete n[i])}}function w(n,s,i){function a(S,u){let v=S;for(const R of u){if(typeof v!="object"||v===null)return;v=v[R]}return v}const h=s.split("."),p=a(n,h);return typeof p=="undefined"?i:p}e.getConfigurationValue=w;function _(n,s,i){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in n?I.isObject(n[a])&&I.isObject(s[a])?_(n[a],s[a],i):i&&(n[a]=s[a]):n[a]=s[a])})}e.merge=_;function d(){const n=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=d;function o(){const n=Object.create(null),s=T.Registry.as(k.Extensions.Configuration).getConfigurationProperties();for(let i in s){let a=s[i].default;l(n,i,a,h=>console.error(`Conflict in default settings: ${h}`))}return n}e.getDefaultValues=o;function c(n){return`[${n}]`}e.keyFromOverrideIdentifier=c;function t(n,s,i){const a=n.inspect(s),h=n.inspect(i);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:a.defaultValue}e.getMigratedSettingValue=t}),define(me[188],ge([0,1,56,22,16,11,24,2,83,84,40,6,3]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(t={},n=[],s=[]){this._contents=t,this._keys=n,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,P.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const s=this.getContentsForOverrideIdentifer(n);return s?t?(0,P.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let s={};for(const i of A.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[i],h=n[i];h&&(typeof a=="object"&&typeof h=="object"?(a=y.deepClone(a),this.mergeContents(a,h)):a=h),s[i]=a}return new m(s,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),s=y.deepClone(this.overrides),i=[...this.keys];for(const a of t){this.mergeContents(n,a.contents);for(const h of a.overrides){const[p]=s.filter(S=>A.equals(S.identifiers,h.identifiers));p?this.mergeContents(p.contents,h.contents):s.push(y.deepClone(h))}for(const h of a.keys)i.indexOf(h)===-1&&i.push(h)}return new m(n,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const s of Object.keys(n)){if(s in t&&T.isObject(t[s])&&T.isObject(n[s])){this.mergeContents(t[s],n[s]);continue}t[s]=y.deepClone(n[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,P.addToValueTree)(this.contents,t,n,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&(0,P.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let s=0;s<n;s++)t.indexOf(this.keys[s])===0&&(n=s);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=m;class l extends m{constructor(){const t=(0,P.getDefaultValues)(),n=(0,P.getConfigurationKeys)(),s=[];for(const i of Object.keys(t))D.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[(0,D.overrideIdentifierFromKey)(i).trim()],keys:Object.keys(t[i]),contents:(0,P.toValuesTree)(t[i],a=>console.error(`Conflict in default settings file: ${a}`))});super(t,n,s)}}e.DefaultConfigurationModel=l;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:s,keys:i,overrides:a,restricted:h}=this.doParseRaw(t,n);this._configurationModel=new m(s,i,a),this._restrictedConfigurations=h||[]}doParseContent(t){let n={},s=null,i=[],a=[],h=[];function p(u){Array.isArray(i)?i.push(u):s&&(i[s]=u)}let S={onObjectBegin:()=>{let u={};p(u),a.push(i),i=u,s=null},onObjectProperty:u=>{s=u},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{let u=[];p(u),a.push(i),i=u,s=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:p,onError:(u,v,R)=>{h.push({error:u,offset:v,length:R})}};if(t)try{b.visit(t,S),n=i[0]||{}}catch(u){console.error(`Error while parsing settings file ${this._name}: ${u}`),this._parseErrors=[u]}return n}doParseRaw(t,n){const s=r.Registry.as(D.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,n);t=i.raw;const a=(0,P.toValuesTree)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),h=Object.keys(t),p=(0,P.toOverrides)(t,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:a,keys:h,overrides:p,restricted:i.restricted}}filter(t,n,s,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const a={},h=[];for(let p in t)if(D.OVERRIDE_PROPERTY_PATTERN.test(p)&&s){const S=this.filter(t[p],n,!1,i);a[p]=S.raw,h.push(...S.restricted)}else{const S=n[p],u=S?typeof S.scope!="undefined"?S.scope:3:void 0;(S==null?void 0:S.restricted)&&h.push(p),(u===void 0||i.scopes===void 0||i.scopes.includes(u))&&(i.skipRestricted&&(S==null?void 0:S.restricted)||(a[p]=t[p]))}return{raw:a,restricted:h}}}e.ConfigurationModelParser=f;class E extends C.Disposable{constructor(t,n,s,i){super();this.userSettingsResource=t,this.scopes=n,this.fileService=i,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(g.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class w{constructor(t,n,s=new m,i=new m,a=new I.ResourceMap,h=new m,p=new I.ResourceMap,S=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=a,this._memoryConfiguration=h,this._memoryConfigurationByResource=p,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new I.ResourceMap,this._userConfiguration=null}getValue(t,n,s){return this.getConsolidateConfigurationModel(n,s).getValue(t)}updateValue(t,n,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new m,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,n===void 0?i.removeValue(t):i.setValue(t,n),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,s){const i=this.getConsolidateConfigurationModel(n,s),a=this.getFolderConfigurationModelForResource(n.resource,s),h=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,p=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),S=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),u=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),v=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(t):a.freeze().getValue(t):void 0,j=n.overrideIdentifier?h.override(n.overrideIdentifier).getValue(t):h.getValue(t),ie=i.getValue(t),K=A.distinct(A.flatten(i.overrides.map(B=>B.identifiers))).filter(B=>i.getOverrideValue(t,B)!==void 0);return{defaultValue:p,userValue:S,userLocalValue:u,userRemoteValue:v,workspaceValue:R,workspaceFolderValue:N,memoryValue:j,value:ie,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:u!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:v!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:a==null?void 0:a.freeze().getValue(t),override:n.overrideIdentifier?a==null?void 0:a.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:h.getValue(t),override:n.overrideIdentifier?h.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=n.filter(i=>D.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const a=(0,D.overrideIdentifierFromKey)(i),h=this._defaultConfiguration.getKeysForOverrideIdentifier(a),p=t.getKeysForOverrideIdentifier(a),S=[...p.filter(u=>h.indexOf(u)===-1),...h.filter(u=>p.indexOf(u)===-1),...h.filter(u=>!y.equals(this._defaultConfiguration.override(a).getValue(u),t.override(a).getValue(u)))];return[a,S]});return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,P.compare)(this.localUserConfiguration,t),h=[...n,...s,...i];return h.length&&this.updateLocalUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,P.compare)(this.remoteUserConfiguration,t);let h=[...n,...s,...i];return h.length&&this.updateRemoteUserConfiguration(t),{keys:h,overrides:a}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:i,overrides:a}=(0,P.compare)(this.workspaceConfiguration,t);let h=[...n,...s,...i];return h.length&&this.updateWorkspaceConfiguration(t),{keys:h,overrides:a}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:i,updated:a,removed:h,overrides:p}=(0,P.compare)(s,n);let S=[...i,...a,...h];return(S.length||!s)&&this.updateFolderConfiguration(t,n),{keys:S,overrides:p}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:a,overrides:h}=(0,P.compare)(n,void 0);return{keys:[...s,...i,...a],overrides:h}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let s=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},n){let s=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const i=n.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const a=this._memoryConfigurationByResource.get(t);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(n=s.merge(i),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=s}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:s,overrides:i,keys:a}=this._folderConfigurations.get(n);return t.push([n,{contents:s,overrides:i,keys:a}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>n.add(i))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),a=t.folders.reduce((h,p)=>(h.set(k.URI.revive(p[0]),this.parseConfigurationModel(p[1])),h),new I.ResourceMap);return new w(n,s,new m,i,a,new m,new I.ResourceMap,!1)}static parseConfigurationModel(t){return new m(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function _(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const t=new Set,n=new Map;for(const i of c)i.keys.forEach(a=>t.add(a)),i.overrides.forEach(([a,h])=>{const p=(0,I.getOrSet)(n,a,new Set);h.forEach(S=>p.add(S))});const s=[];return n.forEach((i,a)=>s.push([a,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=_;class d{constructor(t,n,s,i){this.change=t,this.previous=n,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const a=new Set;t.keys.forEach(p=>a.add(p)),t.overrides.forEach(([,p])=>p.forEach(S=>a.add(S))),this.affectedKeys=[...a.values()];const h=new m;this.affectedKeys.forEach(p=>h.setValue(p,{})),this.affectedKeysTree=h.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,a=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(i,a)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let s=(0,P.toValuesTree)({[n]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=d;class o extends d{constructor(t,n,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=o}),define(me[189],ge([0,1,38,8,78,155,26,10,184,84,4,12,95]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=T.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const t=await w.getDefaultTerminalLinuxReady();return{windows:f.getDefaultTerminalWindows(),linux:t,osx:"xterm"}}}let f=class jt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,A.getWindowsShell(),t)}spawnTerminal(t,n,s,i){const a=n.terminal.external,h=(a==null?void 0:a.windowsExec)||jt.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const p=I.basename(h).toLowerCase();if(p==="cmder"||p==="cmder.exe")return t.spawn(h,i?[i]:void 0),Promise.resolve(void 0);const S=["/c","start","/wait"];return h.indexOf(" ")>=0&&S.push('""'),S.push(h),(p==="wt"||p==="wt.exe")&&S.push("-d ."),new Promise((u,v)=>{const R=_(process),N=t.spawn(s,S,{cwd:i,env:R});N.on("error",v),N.on("exit",()=>u())})}runInTerminal(t,n,s,i,a){const h=a.windowsExec||jt.getDefaultTerminalWindows();return new Promise((p,S)=>{const u=`"${n} - ${m}"`,v=`""${s.join('" "')}" & pause"`,R=["/c","start",u,"/wait",h,"/c",v],N=Object.assign({},_(process),i);Object.keys(N).filter(K=>N[K]===null).forEach(K=>delete N[K]);const j={cwd:n,env:N,windowsVerbatimArguments:!0};b.spawn(jt.CMD,R,j).on("error",K=>{S(d(K))}),p(void 0)})}static getDefaultTerminalWindows(){if(!jt._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");jt._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return jt._DEFAULT_TERMINAL_WINDOWS}};f.CMD="cmd.exe",f=qe([He(0,(0,r.optional)(P.IConfigurationService))],f),e.WindowsExternalTerminalService=f;let E=class Nn extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,i,a){const h=a.osxExec||D.DEFAULT_TERMINAL_OSX;return new Promise((p,S)=>{if(h===D.DEFAULT_TERMINAL_OSX||h==="iTerm.app"){const u=h===D.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[C.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`,G).fsPath,"-t",t||m,"-w",n];for(let ie of s)R.push("-a"),R.push(ie);if(i)for(let ie in i){const K=i[ie];K===null?(R.push("-u"),R.push(ie)):(R.push("-e"),R.push(`${ie}=${K}`))}let N="";const j=b.spawn(Nn.OSASCRIPT,R);j.on("error",ie=>{S(d(ie))}),j.stderr.on("data",ie=>{N+=ie.toString()}),j.on("exit",ie=>{if(ie===0)p(void 0);else if(N){const K=N.split(`
`,1);S(new Error(K[0]))}else S(new Error(T.localize(1,null,u,ie)))})}else S(new Error(T.localize(2,null,h)))})}spawnTerminal(t,n,s){const i=n.terminal.external,a=(i==null?void 0:i.osxExec)||D.DEFAULT_TERMINAL_OSX;return new Promise((h,p)=>{const S=["-a",a];s&&S.push(s);const u=t.spawn("/usr/bin/open",S);u.on("error",p),u.on("exit",()=>h())})}};E.OSASCRIPT="/usr/bin/osascript",E=qe([He(0,(0,r.optional)(P.IConfigurationService))],E),e.MacExternalTerminalService=E;let w=class qt extends l{constructor(t){super();this._configurationService=t}openTerminal(t){const n=this._configurationService.getValue();return this.spawnTerminal(b,n,t)}runInTerminal(t,n,s,i,a){const h=a.linuxExec?Promise.resolve(a.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((p,S)=>{let u=[];h.then(v=>{v.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const R=`${o(s)}; echo; read -p "${qt.WAIT_MESSAGE}" -n1;`;u.push(`''${R}''`);const N=Object.assign({},process.env,i);Object.keys(N).filter(B=>N[B]===null).forEach(B=>delete N[B]);const j={cwd:n,env:N};let ie="";const K=b.spawn(v,u,j);K.on("error",B=>{S(d(B))}),K.stderr.on("data",B=>{ie+=B.toString()}),K.on("exit",B=>{if(B===0)p(void 0);else if(ie){const $=ie.split(`
`,1);S(new Error($[0]))}else S(new Error(T.localize(4,null,v,B)))})})})}static async getDefaultTerminalLinuxReady(){return qt._DEFAULT_TERMINAL_LINUX_READY||(qt._DEFAULT_TERMINAL_LINUX_READY=new Promise(async t=>{k.isLinux?await y.exists("/etc/debian_version")?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm"):t("xterm")})),qt._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(t,n,s){const i=n.terminal.external,a=(i==null?void 0:i.linuxExec)?Promise.resolve(i.linuxExec):qt.getDefaultTerminalLinuxReady();return new Promise((h,p)=>{a.then(S=>{const u=_(process),v=t.spawn(S,[],{cwd:s,env:u});v.on("error",p),v.on("exit",()=>h())})})}};w.WAIT_MESSAGE=T.localize(3,null),w=qe([He(0,(0,r.optional)(P.IConfigurationService))],w),e.LinuxExternalTerminalService=w;function _(c){const t=c.env;return(0,g.sanitizeProcessEnvironment)(t),t}function d(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(T.localize(5,null,c.path)):c}function o(c){let t="";for(let n of c)n.indexOf(" ")>=0?t+='"'+n+'"':t+=n,t+=" ";return t}}),define(me[85],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var I;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(I=e.RemoteTrustOption||(e.RemoteTrustOption={}));var A;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(A=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(k,D=A.Unknown,P){super(k);this._message=k,this._code=D,this._detail=P,this.isHandled=D===A.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(k){return k instanceof T&&k._code===A.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof T&&k._code===A.NoResolverFound}static isHandled(k){return k instanceof T&&k.isHandled}}e.RemoteAuthorityResolverError=T}),define(me[118],ge([0,1,12]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function I(D){return D.scheme===b.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=I;function A(D){if(!!D){const P=D.indexOf("+");return P<0?D:D.substr(0,P)}}e.getRemoteName=A;function T(D){return D.scheme!==b.Schemas.file&&D.scheme!==b.Schemas.vscodeRemote}function y(D){if(D.folders.length)return D.folders.every(P=>T(P.uri))?D.folders[0].uri:void 0;if(D.configuration&&T(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=y;function k(D){var P;return(P=y(D))===null||P===void 0?void 0:P.scheme}e.getVirtualWorkspaceScheme=k}),define(me[190],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class b{vsda(){return new Promise((A,T)=>G(["vsda"],A,T))}async sign(A){try{const T=await this.vsda(),y=new T.signer;if(y)return y.sign(A)}catch(T){}return A}}e.SignService=b}),define(me[191],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(A){this._callback=A,this._terminalBufferMap=new Map}dispose(){for(const A of this._terminalBufferMap.values())A.dispose()}startBuffering(A,T,y=5){let k;return k=T(D=>{const P=typeof D=="string"?D:D.data;let r=this._terminalBufferMap.get(A);if(r){r.data.push(P);return}const C=setTimeout(()=>this.flushBuffer(A),y);r={data:[P],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(A),k.dispose()}},this._terminalBufferMap.set(A,r)}),k}stopBuffering(A){const T=this._terminalBufferMap.get(A);T&&T.dispose()}flushBuffer(A){const T=this._terminalBufferMap.get(A);T&&(this._terminalBufferMap.delete(A),this._callback(A,T.data.join("")))}}e.TerminalDataBufferer=b}),define(me[192],ge([0,1,48,8,36,26,11,24,10]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function P(){const C=/(\d+)\.(\d+)\.(\d+)/g.exec(b.release());let g=0;return C&&C.length===4&&(g=parseInt(C[3])),g}e.getWindowsBuildNumber=P;async function r(C,g,m,l=A.env,f=T.exists){if(I.isAbsolute(C))return await f(C)?C:void 0;if(g===void 0&&(g=A.cwd()),I.dirname(C)!=="."){const d=I.join(g,C);return await f(d)?d:void 0}const w=(0,k.getCaseInsensitive)(l,"PATH");if(m===void 0&&(0,y.isString)(w)&&(m=w.split(I.delimiter)),m===void 0||m.length===0){const d=I.join(g,C);return await f(d)?d:void 0}for(let d of m){let o;if(I.isAbsolute(d)?o=I.join(d,C):o=I.join(g,d,C),await f(o))return o;if(D.isWindows){let c=o+".com";if(await f(c)||(c=o+".exe",await f(c)))return c}}const _=I.join(g,C);return await f(_)?_:void 0}e.findExecutable=r}),define(me[193],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(I){I.DARK="dark",I.LIGHT="light",I.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(me[194],ge([0,1,4,6,40,3,193,43]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var D;(function(E){function w(_){return _&&typeof _=="object"&&typeof _.id=="string"}E.isThemeColor=w})(D=e.ThemeColor||(e.ThemeColor={}));function P(E){return{id:E}}e.themeColorFromId=P;var r;(function(E){function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||D.isThemeColor(t.color))}E.isThemeIcon=w;const _=new RegExp(`^\\$\\((${k.CSSIcon.iconNameExpression}(?:${k.CSSIcon.iconModifierExpression})?)\\)$`);function d(t){const n=_.exec(t);if(!!n){let[,s]=n;return{id:s}}}E.fromString=d;function o(t,n){let s=t.id;const i=s.lastIndexOf("~");return i!==-1&&(s=s.substring(0,i)),n&&(s=`${s}~${n}`),{id:s}}E.modify=o;function c(t,n){var s,i;return t.id===n.id&&((s=t.color)===null||s===void 0?void 0:s.id)===((i=n.color)===null||i===void 0?void 0:i.id)}E.isEqual=c,E.asClassNameArray=k.CSSIcon.asClassNameArray,E.asClassName=k.CSSIcon.asClassName,E.asCSSSelector=k.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=k.Codicon.file,e.FolderThemeIcon=k.Codicon.folder;function C(E){switch(E){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=C,e.Extensions={ThemingContribution:"base.contributions.theming"};class g{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),(0,I.toDisposable)(()=>{const _=this.themingParticipants.indexOf(w);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new g;A.Registry.add(e.Extensions.ThemingContribution,m);function l(E){return m.onColorThemeChange(E)}e.registerThemingParticipant=l;class f extends I.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,_){let d=this.theme.getColor(w);return d&&_&&(d=_(d,this.theme)),d?d.toString():null}}e.Themable=f}),define(me[195],ge([0,1,40,194,3,158,117,13,43]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class P{constructor(){this._onDidChange=new A.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${D.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,_,d,o){const c=this.iconsById[w];if(c){if(d&&!c.description){c.description=d,this.iconSchema.properties[w].markdownDescription=`${d} $(${w})`;const s=this.iconReferenceSchema.enum.indexOf(w);s!==-1&&(this.iconReferenceSchema.enumDescriptions[s]=d),this._onDidChange.fire()}return c}let t={id:w,description:d,defaults:_,deprecationMessage:o};this.iconsById[w]=t;let n={$ref:"#/definitions/icons"};return o&&(n.deprecationMessage=o),d&&(n.markdownDescription=`${d}: $(${w})`),this.iconSchema.properties[w]=n,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(d||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const _=this.iconReferenceSchema.enum.indexOf(w);_!==-1&&(this.iconReferenceSchema.enum.splice(_,1),this.iconReferenceSchema.enumDescriptions.splice(_,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,_){const d=this.iconFontsById[w];if(d)return d;let o={id:w,definition:_};return this.iconFontsById[w]=o,this._onDidChange.fire(),o}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFonts(){return Object.keys(this.iconFontsById).map(w=>this.iconFontsById[w])}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(c,t)=>c.id.localeCompare(t.id),_=c=>{for(;I.ThemeIcon.isThemeIcon(c.defaults);)c=this.iconsById[c.defaults.id];return`codicon codicon-${c?c.id:""}`};let d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const o=Object.keys(this.iconsById).map(c=>this.iconsById[c]);for(const c of o.filter(t=>!!t.description).sort(w))d.push(`|<i class="${_(c)}"></i>|${c.id}|${I.ThemeIcon.isThemeIcon(c.defaults)?c.defaults.id:c.id}|${c.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const c of o.filter(t=>!I.ThemeIcon.isThemeIcon(t.defaults)).sort(w))d.push(`|<i class="${_(c)}"></i>|${c.id}|`);return d.join(`
`)}}const r=new P;b.Registry.add(e.Extensions.IconContribution,r);function C(E,w,_,d){return r.registerIcon(E,w,_,d)}e.registerIcon=C;function g(){return r}e.getIconRegistry=g;function m(){for(const E of D.iconRegistry.all)r.registerIcon(E.id,E.definition,E.description);D.iconRegistry.onDidRegister(E=>r.registerIcon(E.id,E.definition,E.description))}m(),e.iconsSchemaId="vscode://schemas/icons";let l=b.Registry.as(y.Extensions.JSONContribution);l.registerSchema(e.iconsSchemaId,r.getIconSchema());const f=new k.RunOnceScheduler(()=>l.notifySchemaChanged(e.iconsSchemaId),200);r.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.widgetClose=C("widget-close",D.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=C("goto-previous-location",D.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=C("goto-next-location",D.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=I.ThemeIcon.modify(D.Codicon.sync,"spin")}),define(me[61],ge([0,1,2,25,4,22]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var y;(function(g){g[g.EMPTY=1]="EMPTY",g[g.FOLDER=2]="FOLDER",g[g.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function k(g){const m=g;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=k;function D(g){const m=g;return!!(m&&typeof m=="object"&&b.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=D;class P{constructor(m,l,f,E){this._id=m,this._configuration=f,this._ignorePathCasing=E,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=l}update(m){this._id=m.id,this._configuration=m.configuration,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=P;class r{constructor(m,l){this.raw=l,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,I.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function C(g){return new r({uri:g,index:0,name:(0,I.basenameOrAuthority)(g)},{uri:g.toString()})}e.toWorkspaceFolder=C}),define(me[119],ge([0,1,4,159,61,2,10,8,25,134,56,12,76,29,118]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E($){return(typeof $=="string"?(0,k.extname)($):(0,D.extname)($))===f}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function w($){return $.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function _($){return $.hasOwnProperty("folderUri")}e.isRecentFolder=_;function d($){return $.hasOwnProperty("fileUri")}e.isRecentFile=d;function o($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=o;function c($){if($.configuration)return{id:$.id,configPath:$.configuration};if($.folders.length===1)return{id:$.id,uri:$.folders[0].uri}}e.toWorkspaceIdentifier=c;function t($){const U=$;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n($){const U=$;if(U==null?void 0:U.uri)return{id:U.id,uri:T.URI.revive(U.uri)};const L=$;if(L==null?void 0:L.configPath)return{id:L.id,configPath:T.URI.revive(L.configPath)};if($==null?void 0:$.id)return{id:$.id}}e.reviveIdentifier=n;function s($,U){return D.extUriBiasedIgnorePathCase.isEqualOrParent($,U.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function i($){return a($)||h($)}e.isStoredWorkspaceFolder=i;function a($){const U=$;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=a;function h($){const U=$;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=h;function p($,U,L,O,M=!y.isWindows,F){if($.scheme!==O.scheme)return{name:L,uri:$.toString(!0)};let W=U?void 0:F.relativePath(O,$);if(W!==void 0)W.length===0?W=".":y.isWindows&&$.scheme===C.Schemas.file&&!M&&(W=W.replace(/\//g,"\\"));else if($.scheme===C.Schemas.file)W=$.fsPath,y.isWindows&&(W=(0,g.normalizeDriveLetter)(W),M&&(W=(0,m.toSlashes)(W)));else{if(!F.isEqualAuthority($.authority,O.authority))return{name:L,uri:$.toString(!0)};W=$.path}return{name:L,path:W}}e.getStoredWorkspaceFolder=p;function S($,U,L){let O=[],M=new Set;const F=L.dirname(U);for(let W of $){let q;if(a(W))W.path&&(q=L.resolvePath(F,W.path));else if(h(W))try{q=T.URI.parse(W.uri),q.path[0]!=="/"&&(q=q.with({path:"/"+q.path}))}catch(Q){console.warn(Q)}if(q){let Q=L.getComparisonKey(q);if(!M.has(Q)){M.add(Q);const le=W.name||L.basenameOrAuthority(q);O.push(new A.WorkspaceFolder({uri:q,name:le,index:O.length},W))}}}return O}e.toWorkspaceFolders=S;function u($,U,L,O,M){let F=v(U,$);const W=M.dirname(U),q=M.dirname(O),Q=[],le=R(F.folders);for(const Oe of F.folders){const z=a(Oe)?M.resolvePath(W,Oe.path):T.URI.parse(Oe.uri);let Y;L?Y=!1:Y=!a(Oe)||(0,k.isAbsolute)(Oe.path),Q.push(p(z,Y,Oe.name,q,le,M))}const ve={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},Re=P.setProperty($,["folders"],Q,ve);let Se=P.applyEdits($,Re);return F.remoteAuthority===(0,l.getRemoteAuthority)(O)&&(Se=P.applyEdits(Se,P.removeProperty(Se,["remoteAuthority"],ve))),Se}e.rewriteWorkspaceFileForNewLocation=u;function v($,U){let L=r.parse(U);if(L&&Array.isArray(L.folders))L.folders=L.folders.filter(O=>i(O));else throw new Error(`${$} looks like an invalid workspace file.`);return L}function R($){return y.isWindows?$.some(U=>a(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function N($){return $.workspace&&typeof $.workspace=="object"&&typeof $.workspace.id=="string"&&typeof $.workspace.configPath=="string"}function j($){return typeof $.folderUri=="string"}function ie($){return typeof $.fileUri=="string"}function K($,U){const L={workspaces:[],files:[]};if($){const O=function(F,W){for(let q=0;q<F.length;q++)try{W(F[q],q)}catch(Q){U.warn(`Error restoring recent entry ${JSON.stringify(F[q])}: ${Q.toString()}. Skip entry.`)}},M=$;if(Array.isArray(M.entries))O(M.entries,F=>{const W=F.label,q=F.remoteAuthority;N(F)?L.workspaces.push({label:W,remoteAuthority:q,workspace:{id:F.workspace.id,configPath:T.URI.parse(F.workspace.configPath)}}):j(F)?L.workspaces.push({label:W,remoteAuthority:q,folderUri:T.URI.parse(F.folderUri)}):ie(F)&&L.files.push({label:W,remoteAuthority:q,fileUri:T.URI.parse(F.fileUri)})});else{const F=$;Array.isArray(F.workspaces3)&&O(F.workspaces3,(W,q)=>{const Q=Array.isArray(F.workspaceLabels)&&F.workspaceLabels[q]||void 0;typeof W=="object"&&typeof W.id=="string"&&typeof W.configURIPath=="string"?L.workspaces.push({label:Q,workspace:{id:W.id,configPath:T.URI.parse(W.configURIPath)}}):typeof W=="string"&&L.workspaces.push({label:Q,folderUri:T.URI.parse(W)})}),Array.isArray(F.files2)&&O(F.files2,(W,q)=>{const Q=Array.isArray(F.fileLabels)&&F.fileLabels[q]||void 0;typeof W=="string"&&L.files.push({label:Q,fileUri:T.URI.parse(W)})})}}return L}e.restoreRecentlyOpened=K;function B($){const U={entries:[]};for(const L of $.workspaces)_(L)?U.entries.push({folderUri:L.folderUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority}):U.entries.push({workspace:{id:L.workspace.id,configPath:L.workspace.configPath.toString()},label:L.label,remoteAuthority:L.remoteAuthority});for(const L of $.files)U.entries.push({fileUri:L.fileUri.toString(),label:L.label,remoteAuthority:L.remoteAuthority});return U}e.toStoreData=B}),define(me[86],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(A){this.id=A,this._data=new Map,this._idPool=1}add(A){const T=this._idPool++;return this._data.set(T,A),this.logDebugInfo(),T}get(A,T){return this._data.has(A)?this._data.get(A)[T]:void 0}delete(A){this._data.delete(A),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(me[196],ge([0,1,2,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class A{constructor(){this._onDidChangeTabs=new I.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(k=>({name:k.name,group:k.group,resource:b.URI.revive(k.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(me[62],ge([0,1,12,4]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class A{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,k){k===null?this._providerInfo.delete(y):this._providerInfo.set(y,k)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=A,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(me[28],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(me[197],ge([0,1,13]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class I{constructor(y,k,D){this._deferredPromises=new Map,this._id=y,this._shared=k,this._storage=D,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of P.values())r.complete()}catch(r){for(const C of P.values())C.error(r)}})()},0)}get whenReady(){return this._init}get(y,k){let D=this._value[y];return typeof D=="undefined"&&(D=k),D}update(y,k){this._value[y]=k;let D=this._deferredPromises.get(y);if(D!==void 0)return D.p;const P=new b.DeferredPromise;return this._deferredPromises.set(y,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=I;class A extends I{constructor(y,k){super(y.identifier.value,!0,k);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=A}),define(me[15],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class I{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=I});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[198],ge([0,1,27,3]),function(G,e,b,I){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(k,D){A.set(this,void 0),this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(k.identifier),it(this,A,D,"f"),We(this,A,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(k){return We(this,A,"f").get(this._id,k)}store(k,D){return We(this,A,"f").store(this._id,k,D)}delete(k){return We(this,A,"f").delete(this._id,k)}}e.ExtensionSecrets=T,A=new WeakMap}),define(me[120],ge([0,1,4,3]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class A{constructor(){this._onDidChangeTelemetryEnabled=new I.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=A,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(me[87],ge([0,1,3]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var I;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(I=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const A=new WeakMap,T=y=>{let k=A.get(y);return k||(k={children:new Map,bus:new b.Emitter},A.set(y,k)),k};e.getPrivateApiFor=T}),define(me[50],ge([0,1,4,3,15]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(k){function D(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}k.fromApiTunnel=D;function P(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}k.fromServiceTunnel=P})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(D){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(D){return D}async openTunnel(D,P){}async getTunnels(){return[]}async setTunnelExtensionFunctions(D){return{dispose:()=>{}}}registerPortsAttributesProvider(D,P){return{dispose:()=>{}}}async $providePortAttributes(D,P,r,C,g){return[]}async $forwardPort(D,P){}async $closeTunnel(D){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=qe([He(0,A.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(b[I[A]]=G[I[A]]);return b};define(me[7],ge([0,1,16,17,99,22,9,11,2,30,45,85,87]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";var m,l,f,E,w,_,d,o,c,t,n,s,i,a,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function S(V){function x(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(x,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(x,V),Object.setPrototypeOf(x.prototype,V.prototype),x}let u=f=class{constructor(x){m.set(this,void 0),it(this,m,x,"f")}static from(...x){let re=x;return new f(function(){if(re){for(const ke of re)ke&&typeof ke.dispose=="function"&&ke.dispose();re=void 0}})}dispose(){typeof We(this,m,"f")=="function"&&(We(this,m,"f").call(this),it(this,m,void 0,"f"))}};m=new WeakMap,u=f=qe([S],u),e.Disposable=u;let v=E=class{constructor(x,re){if(x<0)throw(0,I.illegalArgument)("line must be non-negative");if(re<0)throw(0,I.illegalArgument)("character must be non-negative");this._line=x,this._character=re}static Min(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let ke=1;ke<x.length;ke++){const Ge=x[ke];Ge.isBefore(re)&&(re=Ge)}return re}static Max(...x){if(x.length===0)throw new TypeError;let re=x[0];for(let ke=1;ke<x.length;ke++){const Ge=x[ke];Ge.isAfter(re)&&(re=Ge)}return re}static isPosition(x){if(!x)return!1;if(x instanceof E)return!0;let{line:re,character:ke}=x;return typeof re=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<x._character}isBeforeOrEqual(x){return this._line<x._line?!0:x._line<this._line?!1:this._character<=x._character}isAfter(x){return!this.isBeforeOrEqual(x)}isAfterOrEqual(x){return!this.isBefore(x)}isEqual(x){return this._line===x._line&&this._character===x._character}compareTo(x){return this._line<x._line?-1:this._line>x.line?1:this._character<x._character?-1:this._character>x._character?1:0}translate(x,re=0){if(x===null||re===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=0:typeof x=="number"?ke=x:(ke=typeof x.lineDelta=="number"?x.lineDelta:0,re=typeof x.characterDelta=="number"?x.characterDelta:0),ke===0&&re===0?this:new E(this.line+ke,this.character+re)}with(x,re=this.character){if(x===null||re===null)throw(0,I.illegalArgument)();let ke;return typeof x=="undefined"?ke=this.line:typeof x=="number"?ke=x:(ke=typeof x.line=="number"?x.line:this.line,re=typeof x.character=="number"?x.character:this.character),ke===this.line&&re===this.character?this:new E(ke,re)}toJSON(){return{line:this.line,character:this.character}}};v=E=qe([S],v),e.Position=v;let R=w=class{constructor(x,re,ke,Ge){let nt,ot;if(typeof x=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new v(x,re),ot=new v(ke,Ge)):x instanceof v&&re instanceof v&&(nt=x,ot=re),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(x){return x instanceof w?!0:x?v.isPosition(x.start)&&v.isPosition(x.end):!1}get start(){return this._start}get end(){return this._end}contains(x){return x instanceof w?this.contains(x._start)&&this.contains(x._end):x instanceof v?!(x.isBefore(this._start)||this._end.isBefore(x)):!1}isEqual(x){return this._start.isEqual(x._start)&&this._end.isEqual(x._end)}intersection(x){const re=v.Max(x.start,this._start),ke=v.Min(x.end,this._end);if(!re.isAfter(ke))return new w(re,ke)}union(x){if(this.contains(x))return this;if(x.contains(this))return x;const re=v.Min(x.start,this._start),ke=v.Max(x.end,this.end);return new w(re,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(x,re=this.end){if(x===null||re===null)throw(0,I.illegalArgument)();let ke;return x?v.isPosition(x)?ke=x:(ke=x.start||this.start,re=x.end||this.end):ke=this.start,ke.isEqual(this._start)&&re.isEqual(this.end)?this:new w(ke,re)}toJSON(){return[this.start,this.end]}};R=w=qe([S],R),e.Range=R;let N=_=class extends R{constructor(x,re,ke,Ge){let nt,ot;if(typeof x=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"?(nt=new v(x,re),ot=new v(ke,Ge)):x instanceof v&&re instanceof v&&(nt=x,ot=re),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(x){return x instanceof _?!0:x?R.isRange(x)&&v.isPosition(x.anchor)&&v.isPosition(x.active)&&typeof x.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};N=_=qe([S],N),e.Selection=N;class j{constructor(x,re,ke){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,I.illegalArgument)("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw(0,I.illegalArgument)("connectionToken");this.host=x,this.port=Math.round(re),this.connectionToken=ke}}e.ResolvedAuthority=j;class ie extends Error{constructor(x,re=C.RemoteAuthorityResolverErrorCode.Unknown,ke){super(x);this._message=x,this._code=re,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ie.prototype)}static NotAvailable(x,re){return new ie(x,C.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(x){return new ie(x,C.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ie;var K;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(K=e.EndOfLine||(e.EndOfLine={}));var B;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(B=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let $=d=class{constructor(x,re){this._range=x,this._newText=re}static isTextEdit(x){return x instanceof d?!0:x?R.isRange(x)&&typeof x.newText=="string":!1}static replace(x,re){return new d(x,re)}static insert(x,re){return d.replace(new R(x,x),re)}static delete(x){return d.replace(x,"")}static setEndOfLine(x){const re=new d(new R(new v(0,0),new v(0,0)),"");return re.newEol=x,re}get range(){return this._range}set range(x){if(x&&!R.isRange(x))throw(0,I.illegalArgument)("range");this._range=x}get newText(){return this._newText||""}set newText(x){if(x&&typeof x!="string")throw(0,I.illegalArgument)("newText");this._newText=x}get newEol(){return this._newEol}set newEol(x){if(x&&typeof x!="number")throw(0,I.illegalArgument)("newEol");this._newEol=x}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};$=d=qe([S],$),e.TextEdit=$;var U;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellOutput=4]="CellOutput",V[V.CellReplace=5]="CellReplace",V[V.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(x,re,ke,Ge){this._edits.push({_type:1,from:x,to:re,options:ke,metadata:Ge})}createFile(x,re,ke){this._edits.push({_type:1,from:void 0,to:x,options:re,metadata:ke})}deleteFile(x,re,ke){this._edits.push({_type:1,from:x,to:void 0,options:re,metadata:ke})}replaceNotebookMetadata(x,re,ke){this._edits.push({_type:3,metadata:ke,uri:x,edit:{editType:5,metadata:re},notebookMetadata:re})}replaceNotebookCells(x,re,ke,Ge,nt){let ot,dt,yt=[],kt;if($t.isNotebookRange(re)&&Mt.isNotebookCellDataArray(ke)&&!Mt.isNotebookCellDataArray(Ge)?(ot=re.start,dt=re.end,yt=ke,kt=Ge):typeof re=="number"&&typeof ke=="number"&&Mt.isNotebookCellDataArray(Ge)&&(ot=re,dt=ke,yt=Ge,kt=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||yt.length>0)&&this._edits.push({_type:5,uri:x,index:ot,count:dt-ot,cells:yt,metadata:kt})}replaceNotebookCellMetadata(x,re,ke,Ge){this._edits.push({_type:3,metadata:Ge,uri:x,edit:{editType:8,index:re,metadata:ke}})}replace(x,re,ke,Ge){this._edits.push({_type:2,uri:x,edit:new $(re,ke),metadata:Ge})}insert(x,re,ke,Ge){this.replace(x,new R(re,re),ke,Ge)}delete(x,re,ke){this.replace(x,re,"",ke)}has(x){return this._edits.some(re=>re._type===2&&re.uri.toString()===x.toString())}set(x,re){if(re)for(const ke of re)ke&&this._edits.push({_type:2,uri:x,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ge=this._edits[ke];Ge._type===2&&Ge.uri.toString()===x.toString()&&(this._edits[ke]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(x){const re=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===x.toString()&&re.push(ke.edit);return re}entries(){const x=new T.ResourceMap;for(let re of this._edits)if(re._type===2){let ke=x.get(re.uri);ke||(ke=[re.uri,[]],x.set(re.uri,ke)),ke[1].push(re.edit)}return[...x.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=qe([S],L),e.WorkspaceEdit=L;let O=o=class{constructor(x){this._tabstop=1,this.value=x||""}static isSnippetString(x){return x instanceof o?!0:x?typeof x.value=="string":!1}static _escape(x){return x.replace(/\$|}|\\/g,"\\$&")}appendText(x){return this.value+=o._escape(x),this}appendTabstop(x=this._tabstop++){return this.value+="$",this.value+=x,this}appendPlaceholder(x,re=this._tabstop++){if(typeof x=="function"){const ke=new o;ke._tabstop=this._tabstop,x(ke),this._tabstop=ke._tabstop,x=ke.value}else x=o._escape(x);return this.value+="${",this.value+=re,this.value+=":",this.value+=x,this.value+="}",this}appendChoice(x,re=this._tabstop++){const ke=x.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(x,re){if(typeof re=="function"){const ke=new o;ke._tabstop=this._tabstop,re(ke),this._tabstop=ke._tabstop,re=ke.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=x,re&&(this.value+=":",this.value+=re),this.value+="}",this}};O=o=qe([S],O),e.SnippetString=O;var M;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var F;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(F=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let W=c=class{constructor(x,re){if(this.uri=x,re)if(re instanceof R)this.range=re;else if(re instanceof v)this.range=new R(re,re);else throw new Error("Illegal argument")}static isLocation(x){return x instanceof c?!0:x?R.isRange(x.range)&&D.URI.isUri(x.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};W=c=qe([S],W),e.Location=W;let q=class{constructor(x,re){this.location=x,this.message=re}static is(x){return x?typeof x.message=="string"&&x.location&&R.isRange(x.location.range)&&D.URI.isUri(x.location.uri):!1}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.location.range.isEqual(re.location.range)&&x.location.uri.toString()===re.location.uri.toString()}};q=qe([S],q),e.DiagnosticRelatedInformation=q;let Q=class{constructor(x,re,ke=F.Error){if(!R.isRange(x))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=x,this.message=re,this.severity=ke}toJSON(){return{severity:F[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(x,re){return x===re?!0:!x||!re?!1:x.message===re.message&&x.severity===re.severity&&x.code===re.code&&x.severity===re.severity&&x.source===re.source&&x.range.isEqual(re.range)&&(0,b.equals)(x.tags,re.tags)&&(0,b.equals)(x.relatedInformation,re.relatedInformation,q.isEqual)}};Q=qe([S],Q),e.Diagnostic=Q;let le=class{constructor(x,re){if(!x)throw new Error("Illegal argument, contents must be defined");Array.isArray(x)?this.contents=x:(0,A.isMarkdownString)(x)?this.contents=[x]:this.contents=[x],this.range=re}};le=qe([S],le),e.Hover=le;var ve;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ve=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Re=class{constructor(x,re=ve.Text){this.range=x,this.kind=re}toJSON(){return{range:this.range,kind:ve[this.kind]}}};Re=qe([S],Re),e.DocumentHighlight=Re;var Se;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(Se=e.SymbolKind||(e.SymbolKind={}));var Oe;(function(V){V[V.Deprecated=1]="Deprecated"})(Oe=e.SymbolTag||(e.SymbolTag={}));let z=t=class{constructor(x,re,ke,Ge,nt){this.name=x,this.kind=re,this.containerName=nt,typeof ke=="string"&&(this.containerName=ke),Ge instanceof W?this.location=Ge:ke instanceof R&&(this.location=new W(Ge,ke)),t.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Se[this.kind],location:this.location,containerName:this.containerName}}};z=t=qe([S],z),e.SymbolInformation=z;let Y=n=class{constructor(x,re,ke,Ge,nt){this.name=x,this.detail=re,this.kind=ke,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(x){if(!x.name)throw new Error("name must not be falsy");if(!x.range.contains(x.selectionRange))throw new Error("selectionRange must be contained in fullRange");x.children&&x.children.forEach(n.validate)}};Y=n=qe([S],Y),e.DocumentSymbol=Y;var ee;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(ee=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(x,re){this.title=x,this.kind=re}};se=qe([S],se),e.CodeAction=se;let fe=s=class{constructor(x){this.value=x}append(x){return new s(this.value?this.value+s.sep+x:x)}intersects(x){return this.contains(x)||x.contains(this)}contains(x){return this.value===x.value||x.value.startsWith(this.value+s.sep)}};fe.sep=".",fe=s=qe([S],fe),e.CodeActionKind=fe,fe.Empty=new fe(""),fe.QuickFix=fe.Empty.append("quickfix"),fe.Refactor=fe.Empty.append("refactor"),fe.RefactorExtract=fe.Refactor.append("extract"),fe.RefactorInline=fe.Refactor.append("inline"),fe.RefactorRewrite=fe.Refactor.append("rewrite"),fe.Source=fe.Empty.append("source"),fe.SourceOrganizeImports=fe.Source.append("organizeImports"),fe.SourceFixAll=fe.Source.append("fixAll");let Ee=class{constructor(x,re){if(this.range=x,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};Ee=qe([S],Ee),e.SelectionRange=Ee;class Be{constructor(x,re,ke,Ge,nt,ot){this.kind=x,this.name=re,this.detail=ke,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class pe{constructor(x,re){this.fromRanges=re,this.from=x}}e.CallHierarchyIncomingCall=pe;class Ce{constructor(x,re){this.fromRanges=re,this.to=x}}e.CallHierarchyOutgoingCall=Ce;let Me=class{constructor(x,re){this.range=x,this.command=re}get isResolved(){return!!this.command}};Me=qe([S],Me),e.CodeLens=Me;let ze=i=class{constructor(x,re=!1){l.set(this,void 0),it(this,l,new A.MarkdownString(x,{supportThemeIcons:re}),"f")}static isMarkdownString(x){return x instanceof i?!0:x&&x.appendCodeblock&&x.appendMarkdown&&x.appendText&&x.value!==void 0}get value(){return We(this,l,"f").value}set value(x){We(this,l,"f").value=x}get isTrusted(){return We(this,l,"f").isTrusted}set isTrusted(x){We(this,l,"f").isTrusted=x}get supportThemeIcons(){return We(this,l,"f").supportThemeIcons}appendText(x){return We(this,l,"f").appendText(x),this}appendMarkdown(x){return We(this,l,"f").appendMarkdown(x),this}appendCodeblock(x,re){return We(this,l,"f").appendCodeblock(re!=null?re:"",x),this}};l=new WeakMap,ze=i=qe([S],ze),e.MarkdownString=ze;let _e=class{constructor(x,re){this.label=x,this.documentation=re}};_e=qe([S],_e),e.ParameterInformation=_e;let Ke=class{constructor(x,re){this.label=x,this.documentation=re,this.parameters=[]}};Ke=qe([S],Ke),e.SignatureInformation=Ke;let X=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};X=qe([S],X),e.SignatureHelp=X;var ne;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(ne=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var we;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(we=e.InlayHintKind||(e.InlayHintKind={}));let xe=class{constructor(x,re,ke){this.text=x,this.position=re,this.kind=ke}};xe=qe([S],xe),e.InlayHint=xe;var je;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(Ve=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(V){V[V.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(x,re){this.label=x,this.kind=re}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=qe([S],De),e.CompletionItem=De;let ye=class{constructor(x=[],re=!1){this.items=x,this.isIncomplete=re}};ye=qe([S],ye),e.CompletionList=ye;var Pe;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(Pe=e.ViewColumn||(e.ViewColumn={}));var oe;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ue;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(ue=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var H;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(H=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Z;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(Z=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ce;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ie;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ie=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function x(re){switch(re){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=x}(ce=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ae=class{constructor(x,re){if(re&&!D.URI.isUri(re))throw(0,I.illegalArgument)("target");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.target=re}};Ae=qe([S],Ae),e.DocumentLink=Ae;let Le=class{constructor(x,re,ke,Ge){this.red=x,this.green=re,this.blue=ke,this.alpha=Ge}};Le=qe([S],Le),e.Color=Le;let $e=class{constructor(x,re){if(re&&!(re instanceof Le))throw(0,I.illegalArgument)("color");if(!R.isRange(x)||x.isEmpty)throw(0,I.illegalArgument)("range");this.range=x,this.color=re}};$e=qe([S],$e),e.ColorInformation=$e;let Xe=class{constructor(x){if(!x||typeof x!="string")throw(0,I.illegalArgument)("label");this.label=x}};Xe=qe([S],Xe),e.ColorPresentation=Xe;var rt;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let wt=a=class{constructor(x,re){if(typeof x!="string"||typeof re!="string")throw(0,I.illegalArgument)("name");this._id=x}static from(x){switch(x){case"clean":return a.Clean;case"build":return a.Build;case"rebuild":return a.Rebuild;case"test":return a.Test;default:return}}get id(){return this._id}};wt.Clean=new a("clean","Clean"),wt.Build=new a("build","Build"),wt.Rebuild=new a("rebuild","Rebuild"),wt.Test=new a("test","Test"),wt=a=qe([S],wt),e.TaskGroup=wt;function be(V){let x="";for(let re=0;re<V.length;re++)x+=V[re].replace(/,/g,",,")+",";return x}let he=class{constructor(x,re,ke){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._args=[],this._process=x,re!==void 0&&(Array.isArray(re)?(this._args=re,this._options=ke):this._options=re)}get process(){return this._process}set process(x){if(typeof x!="string")throw(0,I.illegalArgument)("process");this._process=x}get args(){return this._args}set args(x){Array.isArray(x)||(x=[]),this._args=x}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("process"),this._process!==void 0&&x.push(this._process),this._args&&this._args.length>0)for(let re of this._args)x.push(re);return be(x)}};he=qe([S],he),e.ProcessExecution=he;let ae=class{constructor(x,re,ke){if(this._args=[],Array.isArray(re)){if(!x)throw(0,I.illegalArgument)("command can't be undefined or null");if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x,this._args=re,this._options=ke}else{if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x,this._options=re}}get commandLine(){return this._commandLine}set commandLine(x){if(typeof x!="string")throw(0,I.illegalArgument)("commandLine");this._commandLine=x}get command(){return this._command?this._command:""}set command(x){if(typeof x!="string"&&typeof x.value!="string")throw(0,I.illegalArgument)("command");this._command=x}get args(){return this._args}set args(x){this._args=x||[]}get options(){return this._options}set options(x){this._options=x}computeId(){const x=[];if(x.push("shell"),this._commandLine!==void 0&&x.push(this._commandLine),this._command!==void 0&&x.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let re of this._args)x.push(typeof re=="string"?re:re.value);return be(x)}};ae=qe([S],ae),e.ShellExecution=ae;var J;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(J=e.ShellQuoting||(e.ShellQuoting={}));var Ne;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(Ne=e.TaskScope||(e.TaskScope={}));class Fe{constructor(x){this._callback=x}computeId(){return"customExecution"+(0,P.generateUuid)()}set callback(x){this._callback=x}get callback(){return this._callback}}e.CustomExecution=Fe;let Ye=h=class{constructor(x,re,ke,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=x;let dt;typeof re=="string"?(this._name=this.name=re,this._source=this.source=ke,this.execution=Ge,dt=nt,this.__deprecated=!0):re===Ne.Global||re===Ne.Workspace?(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=re,this._name=this.name=ke,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(x){this.__id=x}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof he?this._definition={type:h.ProcessType,id:this._execution.computeId()}:this._execution instanceof ae?this._definition={type:h.ShellType,id:this._execution.computeId()}:this._execution instanceof Fe?this._definition={type:h.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:h.EmptyType,id:(0,P.generateUuid)()}}get definition(){return this._definition}set definition(x){if(x==null)throw(0,I.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=x}get scope(){return this._scope}set target(x){this.clear(),this._scope=x}get name(){return this._name}set name(x){if(typeof x!="string")throw(0,I.illegalArgument)("name");this.clear(),this._name=x}get execution(){return this._execution}set execution(x){x===null&&(x=void 0),this.clear(),this._execution=x;const re=this._definition.type;(h.EmptyType===re||h.ProcessType===re||h.ShellType===re||h.ExtensionCallbackType===re)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(x){if(Array.isArray(x))this.clear(),this._problemMatchers=x,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(x){x!==!0&&x!==!1&&(x=!1),this.clear(),this._isBackground=x}get source(){return this._source}set source(x){if(typeof x!="string"||x.length===0)throw(0,I.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=x}get group(){return this._group}set group(x){x===null&&(x=void 0),this.clear(),this._group=x}get detail(){return this._detail}set detail(x){x===null&&(x=void 0),this._detail=x}get presentationOptions(){return this._presentationOptions}set presentationOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._presentationOptions=x}get runOptions(){return this._runOptions}set runOptions(x){x==null&&(x=Object.create(null)),this.clear(),this._runOptions=x}};Ye.ExtensionCallbackType="customExecution",Ye.ProcessType="process",Ye.ShellType="shell",Ye.EmptyType="$empty",Ye=h=qe([S],Ye),e.Task=Ye;var et;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(x,re=ht.None){this.collapsibleState=re,D.URI.isUri(x)?this.resourceUri=x:this.label=x}};ut=qe([S],ut),e.TreeItem=ut;var ht;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Je=class{constructor(x,re){this.id=x,this.color=re}};Je=qe([S],Je),e.ThemeIcon=Je,Je.File=new Je("file"),Je.Folder=new Je("folder");let at=class{constructor(x){this.id=x}};at=qe([S],at),e.ThemeColor=at;var ft;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let lt=class{constructor(x,re){if(typeof x!="string"&&(!x||!D.URI.isUri(x)&&!D.URI.isUri(x.uri)))throw(0,I.illegalArgument)("base");if(typeof re!="string")throw(0,I.illegalArgument)("pattern");typeof x=="string"?(this.baseFolder=D.URI.file(x),this.base=x):D.URI.isUri(x)?(this.baseFolder=x,this.base=x.fsPath):(this.baseFolder=x.uri,this.base=x.uri.fsPath),this.pattern=re}};lt=qe([S],lt),e.RelativePattern=lt;let St=class{constructor(x,re,ke,Ge){this.enabled=typeof x=="boolean"?x:!0,typeof re=="string"&&(this.condition=re),typeof ke=="string"&&(this.hitCondition=ke),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,P.generateUuid)()),this._id}};St=qe([S],St),e.Breakpoint=St;let vt=class extends St{constructor(x,re,ke,Ge,nt){super(re,ke,Ge,nt);if(x===null)throw(0,I.illegalArgument)("location");this.location=x}};vt=qe([S],vt),e.SourceBreakpoint=vt;let Pt=class extends St{constructor(x,re,ke,Ge,nt){super(re,ke,Ge,nt);this.functionName=x}};Pt=qe([S],Pt),e.FunctionBreakpoint=Pt;let Tt=class extends St{constructor(x,re,ke,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!re)throw(0,I.illegalArgument)("dataId");this.label=x,this.dataId=re,this.canPersist=ke}};Tt=qe([S],Tt),e.DataBreakpoint=Tt;let Rt=class{constructor(x,re,ke){this.command=x,this.args=re||[],this.options=ke}};Rt=qe([S],Rt),e.DebugAdapterExecutable=Rt;let _t=class{constructor(x,re){this.port=x,this.host=re}};_t=qe([S],_t),e.DebugAdapterServer=_t;let Zt=class{constructor(x){this.path=x}};Zt=qe([S],Zt),e.DebugAdapterNamedPipeServer=Zt;let en=class{constructor(x){this.implementation=x}};en=qe([S],en),e.DebugAdapterInlineImplementation=en;let gt=class{constructor(x,re){this.range=x,this.expression=re}};gt=qe([S],gt),e.EvaluatableExpression=gt;let tn=class{constructor(x,re){this.range=x,this.text=re}};tn=qe([S],tn),e.InlineValueText=tn;let Dt=class{constructor(x,re,ke=!0){this.range=x,this.variableName=re,this.caseSensitiveLookup=ke}};Dt=qe([S],Dt),e.InlineValueVariableLookup=Dt;let Gt=class{constructor(x,re){this.range=x,this.expression=re}};Gt=qe([S],Gt),e.InlineValueEvaluatableExpression=Gt;let nn=class{constructor(x,re){this.frameId=x,this.stoppedLocation=re}};nn=qe([S],nn),e.InlineValueContext=nn;var Qt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let ct=p=class extends Error{constructor(x,re=r.FileSystemProviderErrorCode.Unknown,ke){var Ge;super(D.URI.isUri(x)?x.toString(!0):x);this.code=(Ge=ke==null?void 0:ke.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,r.markAsFileSystemProviderError)(this,re),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(x){return new p(x,r.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(x){return new p(x,r.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(x){return new p(x,r.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(x){return new p(x,r.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(x){return new p(x,r.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(x){return new p(x,r.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}};ct=p=qe([S],ct),e.FileSystemError=ct;let rn=class{constructor(x,re,ke){this.start=x,this.end=re,this.kind=ke}};rn=qe([S],rn),e.FoldingRange=rn;var Lt;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Lt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var gn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(gn=e.CommentMode||(e.CommentMode={}));class Dn{constructor(x,re=[]){this.tokenTypes=x,this.tokenModifiers=re}}e.SemanticTokensLegend=Dn;function pn(V){return typeof V=="undefined"||(0,k.isStringArray)(V)}class sn{constructor(x){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,x){this._hasLegend=!0;for(let re=0,ke=x.tokenTypes.length;re<ke;re++)this._tokenTypeStrToInt.set(x.tokenTypes[re],re);for(let re=0,ke=x.tokenModifiers.length;re<ke;re++)this._tokenModifierStrToInt.set(x.tokenModifiers[re],re)}}push(x,re,ke,Ge,nt){if(typeof x=="number"&&typeof re=="number"&&typeof ke=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(x,re,ke,Ge,nt);if(R.isRange(x)&&typeof re=="string"&&pn(ke))return this._push(x,re,ke);throw(0,I.illegalArgument)()}_push(x,re,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(x.start.line!==x.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(re))throw new Error("`tokenType` is not in the provided legend");const Ge=x.start.line,nt=x.start.character,ot=x.end.character-x.start.character,dt=this._tokenTypeStrToInt.get(re);let yt=0;if(ke)for(const kt of ke){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(kt);yt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,yt)}_pushEncoded(x,re,ke,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(x<this._prevLine||x===this._prevLine&&re<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let kt=0,It=0;for(let At=0;At<yt;At++){let Ot=this._data[5*At],hn=this._data[5*At+1];Ot===0?(Ot=kt,hn+=It):Ot+=kt,this._data[5*At]=Ot,this._data[5*At+1]=hn,kt=Ot,It=hn}}let ot=x,dt=re;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=x,this._prevChar=re}static _sortAndDeltaEncode(x){let re=[];const ke=x.length/5|0;for(let dt=0;dt<ke;dt++)re[dt]=dt;re.sort((dt,yt)=>{const kt=x[5*dt],It=x[5*yt];if(kt===It){const At=x[5*dt+1],Ot=x[5*yt+1];return At-Ot}return kt-It});const Ge=new Uint32Array(x.length);let nt=0,ot=0;for(let dt=0;dt<ke;dt++){const yt=5*re[dt],kt=x[yt+0],It=x[yt+1],At=x[yt+2],Ot=x[yt+3],hn=x[yt+4],On=kt-nt,Wn=On===0?It-ot:It,fn=5*dt;Ge[fn+0]=On,Ge[fn+1]=Wn,Ge[fn+2]=At,Ge[fn+3]=Ot,Ge[fn+4]=hn,nt=kt,ot=It}return Ge}build(x){return this._dataIsSortedAndDeltaEncoded?new Xt(new Uint32Array(this._data),x):new Xt(sn._sortAndDeltaEncode(this._data),x)}}e.SemanticTokensBuilder=sn;class Xt{constructor(x,re){this.resultId=re,this.data=x}}e.SemanticTokens=Xt;class Ut{constructor(x,re,ke){this.start=x,this.deleteCount=re,this.data=ke}}e.SemanticTokensEdit=Ut;class Cn{constructor(x,re){this.resultId=re,this.edits=x}}e.SemanticTokensEdits=Cn;var on;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(on=e.DebugConsoleMode||(e.DebugConsoleMode={}));var an;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(an=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Yt=class{constructor(){}};Yt.Back={iconPath:new Je("arrow-left")},Yt=qe([S],Yt),e.QuickInputButtons=Yt;var kn;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(kn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(x,re,ke){this.badge=x,this.tooltip=re,this.color=ke}static validate(x){if(x.badge&&x.badge.length!==1&&x.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!x.color&&!x.badge&&!x.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let ln=class{constructor(x){this.kind=x}};ln=qe([S],ln),e.ColorTheme=ln;var Pn;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(Pn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(x,re){if(x<0)throw(0,I.illegalArgument)("start must be positive");if(re<0)throw(0,I.illegalArgument)("end must be positive");x<=re?(this._start=x,this._end=re):(this._start=re,this._end=x)}static isNotebookRange(x){return x instanceof $t?!0:x?typeof x.start=="number"&&typeof x.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(x){let re=this._start,ke=this._end;return x.start!==void 0&&(re=x.start),x.end!==void 0&&(ke=x.end),re===this._start&&ke===this._end?this:new $t(re,ke)}}e.NotebookRange=$t;class cn{constructor(x,re){typeof x=="object"?Object.assign(this,x):(this.inputCollapsed=x,this.outputCollapsed=re)}with(x){let{inputCollapsed:re,outputCollapsed:ke}=x,Ge=Jt(x,["inputCollapsed","outputCollapsed"]);return re===void 0?re=this.inputCollapsed:re===null&&(re=void 0),ke===void 0?ke=this.outputCollapsed:ke===null&&(ke=void 0),re===this.inputCollapsed&&ke===this.outputCollapsed&&Object.keys(Ge).length===0?this:new cn(Object.assign({inputCollapsed:re,outputCollapsed:ke},Ge))}}e.NotebookCellMetadata=cn;class xt{constructor(x={}){Object.assign(this,x)}with(x){return new xt(x)}}e.NotebookDocumentMetadata=xt;class Mt{constructor(x,re,ke,Ge,nt,ot){this.kind=x,this.source=re,this.language=ke,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.latestExecutionSummary=ot}static isNotebookCellDataArray(x){return Array.isArray(x)&&x.every(re=>Mt.isNotebookCellData(re))}static isNotebookCellData(x){return!0}}e.NotebookCellData=Mt;class vn{constructor(x,re){this.cells=x,this.metadata=re!=null?re:new xt}}e.NotebookData=vn;class Ht{constructor(x,re,ke){if(this.mime=x,this.value=re,this.metadata=ke,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(x){return x instanceof Ht}}e.NotebookCellOutputItem=Ht;class Ue{constructor(x,re,ke){this.outputs=x,typeof re=="string"?(this.id=re,this.metadata=ke):(this.id=(0,P.generateUuid)(),this.metadata=re!=null?re:ke)}}e.NotebookCellOutput=Ue;var un;(function(V){V[V.Markdown=1]="Markdown",V[V.Code=2]="Code"})(un=e.NotebookCellKind||(e.NotebookCellKind={}));var dn;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(dn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var In;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(In=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class An{constructor(x,re,ke,Ge,nt,ot){this.text=x,this.alignment=re,this.command=ke,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=An;var wn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(wn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class bn{constructor(x,re=[]){this.uri=x,this.provides=typeof re=="string"?[re]:re}}e.NotebookKernelPreload=bn;let zt=class{constructor(x,re){this.label=x,this.timestamp=re}};zt=qe([S],zt),e.TimelineItem=zt;var Tn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(Tn=e.ExtensionMode||(e.ExtensionMode={}));var Rn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(Rn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class _n{constructor(x,re){this.ranges=x,this.wordPattern=re}}e.LinkedEditingRanges=_n;var Fn;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(Fn=e.TestResultState||(e.TestResultState={}));var En;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(En=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Sn;(function(V){V[V.Pending=0]="Pending",V[V.Resolved=1]="Resolved"})(Sn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(V,x,re,ke)=>{let Ge=re;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){ke(Ge,nt)||(Ge=nt,V.bus.fire([3,x,nt]))}}},Vt=(V,x)=>V===x,te=(V,x)=>V===x?!0:!V||!x?!1:V.isEqual(x);class de{constructor(x,re,ke,Ge){this.label=re,this.data=Ge;const nt=(0,g.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:x,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new T.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,te),description:Bt(nt,"description",void 0,Vt),runnable:Bt(nt,"runnable",!0,Vt),debuggable:Bt(nt,"debuggable",!1,Vt),status:Bt(nt,"status",Sn.Resolved,Vt),error:Bt(nt,"error",void 0,Vt)})}invalidate(){(0,g.getPrivateApiFor)(this).bus.fire([2])}dispose(){const x=(0,g.getPrivateApiFor)(this);x.parent&&(0,g.getPrivateApiFor)(x.parent).children.delete(this.id),x.bus.fire([1])}addChild(x){if(!(x instanceof de))throw new Error("Test child must be created through vscode.test.createTestItem()");const re=(0,g.getPrivateApiFor)(this);if(re.children.has(x.id))throw new Error(`Attempted to insert a duplicate test item ID ${x.id}`);re.children.set(x.id,x),re.bus.fire([0,x])}}e.TestItemImpl=de;class Te{constructor(x){this.message=x,this.severity=En.Error}static diff(x,re,ke){const Ge=new Te(x);return Ge.expectedOutput=re,Ge.actualOutput=ke,Ge}}e.TestMessage=Te;var st;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(st=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var bt;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(bt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ct;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore"})(Ct=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(me[121],ge([0,1,52,12,9,144,110,7,16]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function r(l,f){f?P.set(l,f):P.delete(l)}e.setWordDefinitionFor=r;function C(l){return P.get(l)}e.getWordDefinitionFor=C;class g extends T.MirrorTextModel{constructor(f,E,w,_,d,o,c,t){super(E,w,_,d);this._proxy=f,this._languageId=o,this._isDirty=c,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return(0,D.equals)(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===I.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(E){return E?f._getTextInRange(E):f.getText()},get eol(){return f._eol===`
`?k.EndOfLine.LF:k.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(E){return f._lineAt(E)},offsetAt(E){return f._offsetAt(E)},positionAt(E){return f._positionAt(E)},validateRange(E){return f._validateRange(E)},validatePosition(E){return f._validatePosition(E)},getWordRangeAtPosition(E,w){return f._getWordRangeAtPosition(E,w)}}}return Object.freeze(this._document)}_acceptLanguageId(f){(0,b.ok)(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){(0,b.ok)(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const E=this._validateRange(f);if(E.isEmpty)return"";if(E.isSingleLine)return this._lines[E.start.line].substring(E.start.character,E.end.character);const w=this._eol,_=E.start.line,d=E.end.line,o=[];o.push(this._lines[_].substring(E.start.character));for(let c=_+1;c<d;c++)o.push(this._lines[c]);return o.push(this._lines[d].substring(0,E.end.character)),o.join(w)}_lineAt(f){let E;if(f instanceof k.Position?E=f.line:typeof f=="number"&&(E=f),typeof E!="number"||E<0||E>=this._lines.length||Math.floor(E)!==E)throw new Error("Illegal value for `line`");return new m(E,this._lines[E],E===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const E=this._lineStarts.getIndexOf(f),w=this._lines[E.index].length;return new k.Position(E.index,Math.min(E.remainder,w))}_validateRange(f){if(!(f instanceof k.Range))throw new Error("Invalid argument");const E=this._validatePosition(f.start),w=this._validatePosition(f.end);return E===f.start&&w===f.end?f:new k.Range(E.line,E.character,w.line,w.character)}_validatePosition(f){if(!(f instanceof k.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:E,character:w}=f,_=!1;if(E<0)E=0,w=0,_=!0;else if(E>=this._lines.length)E=this._lines.length-1,w=this._lines[E].length,_=!0;else{const d=this._lines[E].length;w<0?(w=0,_=!0):w>d&&(w=d,_=!0)}return _?new k.Position(E,w):f}_getWordRangeAtPosition(f,E){const w=this._validatePosition(f);if(!E)E=C(this._languageId);else if((0,A.regExpLeadsToEndlessLoop)(E))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${E.source}' because it matches the empty string.`);const _=(0,y.getWordAtText)(w.character+1,(0,y.ensureValidWordDefinition)(E),this._lines[w.line],0);if(_)return new k.Range(w.line,_.startColumn-1,w.line,_.endColumn-1)}}e.ExtHostDocumentData=g;class m{constructor(f,E,w){this._line=f,this._text=E,this._isLastLine=w}get lineNumber(){return this._line}get text(){return this._text}get range(){return new k.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new k.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=m}),define(me[199],ge([0,1,7,3,112,6,77,22,2,30]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(g,m,l,f){this._notebook=l,this._selector=f,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,P.generateUuid)()}),this._init(),this._disposables.add(m.onDidChangeDocument(w=>{const _=this._cellUris.get(w.document.uri);_!==void 0&&(this._cellLengths.changeValue(_,this._cells[_].document.getText().length+1),this._cellLines.changeValue(_,this._cells[_].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const E=w=>{w===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(g.onDidChangeNotebookCells(w=>E(w.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new k.ResourceMap;const g=[],m=[];for(const l of this._notebook.getCells())l.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,l.document.uri,l.document.languageId,!0))&&(this._cellUris.set(l.document.uri,this._cells.length),this._cells.push(l),g.push(l.document.getText().length+1),m.push(l.document.lineCount));this._cellLengths=new A.PrefixSumComputer(new Uint32Array(g)),this._cellLines=new A.PrefixSumComputer(new Uint32Array(m))}get version(){return this._versionId}getText(g){var m,l;if(!g){let d="";for(const o of this._cells)d+=o.document.getText()+`
`;return d=d.slice(0,-1),d}if(g.isEmpty)return"";const f=this.locationAt(g.start),E=this.locationAt(g.end),w=this._cells[(m=this._cellUris.get(f.uri))!==null&&m!==void 0?m:-1],_=this._cells[(l=this._cellUris.get(E.uri))!==null&&l!==void 0?l:-1];if(!w||!_)return"";if(w===_)return w.document.getText(new b.Range(f.range.start,E.range.end));{const d=w.document.getText(new b.Range(f.range.start,new b.Position(w.document.lineCount,0))),o=_.document.getText(new b.Range(new b.Position(0,0),E.range.end));return d+`
`+o}}offsetAt(g){const m=this._cellLines.getIndexOf(g.line),l=this._cellLengths.getAccumulatedValue(m.index-1),f=this._cells[m.index].document.offsetAt(g.with(m.remainder));return l+f}positionAt(g){if(typeof g=="number"){const l=this._cellLengths.getIndexOf(g),f=this._cellLines.getAccumulatedValue(l.index-1);return this._cells[l.index].document.positionAt(l.remainder).translate(f)}const m=this._cellUris.get(g.uri);if(m!==void 0){const l=this._cellLines.getAccumulatedValue(m-1);return new b.Position(l+g.range.start.line,g.range.start.character)}return new b.Position(0,0)}locationAt(g){b.Range.isRange(g)||(g=new b.Range(g,g));const m=this._cellLines.getIndexOf(g.start.line);let l=m;g.isEmpty||(l=this._cellLines.getIndexOf(g.end.line));const f=new b.Position(m.remainder,g.start.character),E=new b.Position(l.remainder,g.end.character),w=new b.Range(f,E),_=this._cells[m.index];return new b.Location(_.document.uri,_.document.validateRange(w))}contains(g){return this._cellUris.has(g)}validateRange(g){const m=this.validatePosition(g.start),l=this.validatePosition(g.end);return g.with(m,l)}validatePosition(g){const m=this._cellLines.getIndexOf(g.line),l=new b.Position(m.remainder,g.character),f=this._cells[m.index].document.validatePosition(l),E=this._cellLines.getAccumulatedValue(m.index-1);return new b.Position(E+f.line,f.character)}}e.ExtHostNotebookConcatDocument=r}),define(me[200],ge([0,1,7,15,3]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(k){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new A.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(k){let D=k==="light"?b.ColorThemeKind.Light:k==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=qe([He(0,I.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(me[63],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class I{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=I}),define(me[201],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class I{constructor(){this.buffers=[]}add(D){let P=this.buffers.indexOf(D);return P<0&&(P=this.buffers.length,this.buffers.push(D)),P}}function A(k,D){if(D.serializeBuffersForPostMessage){const P=new I,r=(m,l)=>{if(l instanceof ArrayBuffer){const f=P.add(l);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(l)){const f=T(l);if(f){const E=P.add(l.buffer);return{$$vscode_array_buffer_reference$$:!0,index:E,view:{type:f,byteLength:l.byteLength,byteOffset:l.byteOffset}}}}return l},C=JSON.stringify(k,r),g=P.buffers.map(m=>{const l=new Uint8Array(m);return b.VSBuffer.wrap(l)});return{message:C,buffers:g}}else return{message:JSON.stringify(k),buffers:[]}}e.serializeWebviewMessage=A;function T(k){switch(k.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(k,D){const P=D.map(g=>{const m=new ArrayBuffer(g.byteLength);return new Uint8Array(m).set(g.buffer),m}),r=D.length?(g,m)=>{if(typeof m=="object"&&m.$$vscode_array_buffer_reference$$){const l=m,{index:f}=l,E=P[f];if(l.view)switch(l.view.type){case 1:return new Int8Array(E,l.view.byteOffset,l.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(E,l.view.byteOffset,l.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(E,l.view.byteOffset,l.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(E,l.view.byteOffset,l.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(E,l.view.byteOffset,l.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(E,l.view.byteOffset,l.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(E,l.view.byteOffset,l.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(E,l.view.byteOffset,l.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(E,l.view.byteOffset,l.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(E,l.view.byteOffset,l.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(E,l.view.byteOffset,l.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return E}return m}:void 0;return{message:JSON.parse(k,r),arrayBuffers:P}}e.deserializeWebviewMessage=y}),define(me[88],ge([0,1,2]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function I(T,y,k){const D=T.webviewResourceRoot.replace("{{resource}}",k.scheme+A(k)).replace("{{uuid}}",y);return b.URI.parse(D)}e.asWebviewUri=I;function A(T){return T.toString().replace(/^\S+?:/,"")}}),define(me[202],ge([0,1,3,6,88,30]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(D,P,r){this._proxy=D,this._editors=P,this._initData=r,this._handlePool=0,this._disposables=new I.DisposableStore,this._insets=new Map,this._disposables.add(P.onDidChangeVisibleTextEditors(()=>{const C=P.getVisibleTextEditors();for(const g of this._insets.values())C.indexOf(g.editor)<0&&g.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,P,r,C,g){let m;for(const o of this._editors.getVisibleTextEditors(!0))if(o.value===D){m=o;break}if(!m)throw new Error("not a visible editor");const l=this,f=this._handlePool++,E=new b.Emitter,w=new b.Emitter,_=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(o){return(0,A.asWebviewUri)(l._initData,this._uuid,o)}get cspSource(){return l._initData.webviewCspSource}set options(o){this._options=o,l._proxy.$setOptions(f,o)}get options(){return this._options}set html(o){this._html=o,l._proxy.$setHtml(f,o)}get html(){return this._html}get onDidReceiveMessage(){return E.event}postMessage(o){return l._proxy.$postMessage(f,o)}},d=new class{constructor(){this.editor=D,this.line=P,this.height=r,this.webview=_,this.onDidDispose=w.event}dispose(){l._insets.has(f)&&(l._insets.delete(f),l._proxy.$disposeEditorInset(f),w.fire(),w.dispose(),E.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,P+1,r,C||{},g.identifier,g.extensionLocation),this._insets.set(f,{editor:D,inset:d,onDidReceiveMessage:E}),d}$onDidDispose(D){const P=this._insets.get(D);P&&P.inset.dispose()}$onDidReceiveMessage(D,P){const r=this._insets.get(D);r&&r.onDidReceiveMessage.fire(P)}}e.ExtHostEditorInsets=y}),define(me[203],ge([0,1,3,81,169,4,6,22,40,16,53,24,43,195]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,m.registerIcon)("default-view-icon",g.Codicon.window,(0,A.localize)(0,null));var l;(function(a){a.ViewContainersRegistry="workbench.registry.view.containers",a.ViewsRegistry="workbench.registry.view"})(l=e.Extensions||(e.Extensions={}));var f;(function(a){a[a.Sidebar=0]="Sidebar",a[a.Panel=1]="Panel"})(f=e.ViewContainerLocation||(e.ViewContainerLocation={}));function E(a){switch(a){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=E;function w(a){return`viewContainer.${a}.enabled`}e.getEnabledViewContainerContextKey=w;class _ extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,P.flatten)([...this.viewContainers.values()])}registerViewContainer(h,p,S){var u;const v=this.get(h.id);if(v)return v;const R=h;return R.openCommandActionDescriptor=(S==null?void 0:S.donotRegisterOpenCommand)?void 0:(u=R.openCommandActionDescriptor)!==null&&u!==void 0?u:{id:R.id},(0,k.getOrSet)(this.viewContainers,p,[]).push(R),(S==null?void 0:S.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:p}),R}deregisterViewContainer(h){for(const p of this.viewContainers.keys()){const S=this.viewContainers.get(p),u=S==null?void 0:S.indexOf(h);if(u!==-1){S==null||S.splice(u,1),S.length===0&&this.viewContainers.delete(p),this._onDidDeregister.fire({viewContainer:h,viewContainerLocation:p});return}}}get(h){return this.all.filter(p=>p.id===h)[0]}getViewContainers(h){return[...this.viewContainers.get(h)||[]]}getViewContainerLocation(h){return[...this.viewContainers.keys()].filter(p=>this.getViewContainers(p).filter(S=>(S==null?void 0:S.id)===h.id).length>0)[0]}getDefaultViewContainer(h){return this.defaultViewContainers.find(p=>this.getViewContainerLocation(p)===h)}}D.Registry.add(l.ViewContainersRegistry,new _);var d;(function(a){a.Open="2_open",a.Debug="4_debug",a.SCM="5_scm",a.More="9_more"})(d=e.ViewContentGroups||(e.ViewContentGroups={}));function o(a,h){var p,S,u,v;const R=(p=a.group)!==null&&p!==void 0?p:d.More,N=(S=h.group)!==null&&S!==void 0?S:d.More;return R!==N?R.localeCompare(N):((u=a.order)!==null&&u!==void 0?u:5)-((v=h.order)!==null&&v!==void 0?v:5)}class c extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new r.SetMap}registerViews(h,p){this.registerViews2([{views:h,viewContainer:p}])}registerViews2(h){h.forEach(({views:p,viewContainer:S})=>this.addViews(p,S)),this._onViewsRegistered.fire(h)}deregisterViews(h,p){const S=this.removeViews(h,p);S.length&&this._onViewsDeregistered.fire({views:S,viewContainer:p})}moveViews(h,p){for(const S of this._views.keys())if(S!==p){const u=this.removeViews(h,S);u.length&&(this.addViews(u,p),this._onDidChangeContainer.fire({views:u,from:S,to:p}))}}getViews(h){return this._views.get(h)||[]}getView(h){for(const p of this._viewContainers){const S=(this._views.get(p)||[]).filter(u=>u.id===h)[0];if(S)return S}return null}getViewContainer(h){for(const p of this._viewContainers)if((this._views.get(p)||[]).filter(u=>u.id===h)[0])return p;return null}registerViewWelcomeContent(h,p){return this._viewWelcomeContents.add(h,p),this._onDidChangeViewWelcomeContent.fire(h),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(h,p),this._onDidChangeViewWelcomeContent.fire(h)})}registerViewWelcomeContent2(h,p){const S=new Map;for(const[u,v]of p)this._viewWelcomeContents.add(h,v),S.set(u,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(h,v),this._onDidChangeViewWelcomeContent.fire(h)}));return this._onDidChangeViewWelcomeContent.fire(h),S}getViewWelcomeContent(h){const p=[];return this._viewWelcomeContents.forEach(h,S=>p.push(S)),p.sort(o)}addViews(h,p){let S=this._views.get(p);S||(S=[],this._views.set(p,S),this._viewContainers.push(p));for(const u of h){if(this.getView(u.id)!==null)throw new Error((0,A.localize)(1,null,u.id));S.push(u)}}removeViews(h,p){const S=this._views.get(p);if(!S)return[];const u=[],v=[];for(const R of S)h.includes(R)?u.push(R):v.push(R);return u.length&&(v.length?this._views.set(p,v):(this._views.delete(p),this._viewContainers.splice(this._viewContainers.indexOf(p),1))),u}}D.Registry.add(l.ViewsRegistry,new c),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new I.RawContextKey("focusedView","",(0,A.localize)(2,null));function t(a){return`view.${a}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(a){a[a.Default=0]="Default",a[a.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var s;(function(a){a[a.None=0]="None",a[a.Collapsed=1]="Collapsed",a[a.Expanded=2]="Expanded"})(s=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(h,p){this.resolved=!1,this._hasResolve=!1,(0,C.mixin)(this,h),this._hasResolve=!!p,this.resolve=async S=>{var u,v;if(p&&!this.resolved){const R=await p(S);R&&(this.tooltip=(u=this.tooltip)!==null&&u!==void 0?u:R.tooltip,this.command=(v=this.command)!==null&&v!==void 0?v:R.command)}S.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i}),define(me[204],ge([0,1,2,180,119,14,181,203]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function D(f){return(E,...w)=>f(E.get(I.ICommandService),...w)}class P{static execute(E,w){const _={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return E.executeCommand("_files.newWindow",_)}}e.NewWindowAPICommand=P,P.ID="vscode.newWindow",I.CommandsRegistry.registerCommand({id:P.ID,handler:D(P.execute),description:{description:"Opens an new window",args:[]}}),I.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(f,E){return f.get(A.IWorkspacesService).removeRecentlyOpened([E])});class r{static execute(E,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?b.URI.parse(w):b.URI.file(w):w=b.URI.revive(w),E.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=r,r.ID="vscode.removeFromRecentlyOpened",I.CommandsRegistry.registerCommand(r.ID,D(r.execute));class C{static execute(E,w){const _=typeof w=="string"?{extensionId:w}:w;return E.executeCommand("workbench.action.openIssueReporter",_)}}e.OpenIssueReporter=C,C.ID="vscode.openIssueReporter",I.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(f,E){const w=f.get(A.IWorkspacesService);let _;const d=E.uri,o=E.label,c=E.remoteAuthority;return E.type==="workspace"?_={workspace:await w.getWorkspaceIdentifier(d),label:o,remoteAuthority:c}:E.type==="folder"?_={folderUri:d,label:o,remoteAuthority:c}:_={fileUri:d,label:o,remoteAuthority:c},w.addRecentlyOpened([_])}),I.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(f){return f.get(A.IWorkspacesService).getRecentlyOpened()}),I.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(f,E){const w=f.get(T.ILogService),_=f.get(y.IEnvironmentService);_.isExtensionDevelopment&&!!_.extensionTestsLocationURI&&w.setLevel(E)}),I.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(f){return f.get(T.ILogService).getLevel()}),I.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(f,E){const w=f.get(k.IViewDescriptorService),_=w.getViewContainerById(E.destinationId);if(!!_){for(const d of E.viewIds){const o=w.getViewDescriptorById(d);(o==null?void 0:o.canMoveView)&&w.moveViewsToContainer([o],_,k.ViewVisibilityState.Default)}await f.get(k.IViewsService).openViewContainer(_.id,!0)}});class g{static execute(E,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):E.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=g,g.ID="vscode.moveViews",I.CommandsRegistry.registerCommand({id:g.ID,handler:D(g.execute),description:{description:"Move Views",args:[]}});class m{static execute(E,w){return E.executeCommand("_workbench.open",w)}}m.ID="vscode.open",I.CommandsRegistry.registerCommand(m.ID,D(m.execute));class l{static execute(E,w,_,d,o){return E.executeCommand("_workbench.diff",[w,_,d])}}l.ID="vscode.diff",I.CommandsRegistry.registerCommand(l.ID,D(l.execute))}),define(me[122],ge([0,1,3,13,170]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(k){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=k}onEvent(k){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=k}onRequest(k){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=k}sendResponse(k){k.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${k.command}`)):this.internalSend("response",k)}sendRequest(k,D,P,r){const C={command:k};if(D&&Object.keys(D).length>0&&(C.arguments=D),this.internalSend("request",C),typeof r=="number"){const g=setTimeout(()=>{clearTimeout(g);const m=this.pendingRequests.get(C.seq);if(m){this.pendingRequests.delete(C.seq);const l={type:"response",seq:0,request_seq:C.seq,success:!1,command:k,message:(0,A.localize)(0,null,r,k)};m(l)}},r)}return P&&this.pendingRequests.set(C.seq,P),C.seq}acceptMessage(k){this.messageCallback?this.messageCallback(k):(this.queue.push(k),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(k,D){return k.type!=="event"||D.type!=="event"}async processQueue(){let k;for(;this.queue.length;){if((!k||this.needsTaskBoundaryBetween(this.queue[0],k))&&await(0,I.timeout)(0),k=this.queue.shift(),!k)return;switch(k.type){case"event":this.eventCallback&&this.eventCallback(k);break;case"request":this.requestCallback&&this.requestCallback(k);break;case"response":const D=k,P=this.pendingRequests.get(D.request_seq);P&&(this.pendingRequests.delete(D.request_seq),P(D));break}}}internalSend(k,D){D.type=k,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const k=new Map;this.pendingRequests.forEach((D,P)=>k.set(P,D)),await(0,I.timeout)(500),k.forEach((D,P)=>{D({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(me[205],ge([0,1,9,2,8,24,12]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const k=/{([^}]+)}/g;function D(n,s,i){return n.replace(k,function(a,h){return s&&h.length>0&&h[0]!=="_"?a:i&&i.hasOwnProperty(h)?i[h]:a})}e.formatPII=D;function P(n){const s={};for(const i of Object.keys(n))i.startsWith("!")||(s[i]=n[i]);return s}e.filterExceptionsFromTelemetry=P;function r(n){return n.configuration.request==="attach"&&!C(n)}e.isSessionAttach=r;function C(n){let s=n.configuration.type;if(!!s)return s==="vslsShare"&&(s=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(s,"extensionhost")||(0,b.equalsIgnoreCase)(s,"pwa-extensionhost")?n:n.parentSession?C(n.parentSession):void 0}e.getExtensionHostDebugSession=C;function g(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=g;function m(n,s,i){let a,h=0,p=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,S=null;for(;S=p.exec(n);){let u=S.index+1,v=u+S[0].length;if(u<=s&&v>=i){a=S[0],h=u;break}}if(a){let u=/\w+/g,v=null;for(;(v=u.exec(a))&&!(v.index+1+h+v[0].length>=i););v&&(a=a.substring(0,u.lastIndex))}return a?{start:h,end:h+a.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=m;const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(n){return!!(n&&n.match(l))}e.isUri=f;function E(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(f(n.path))return I.URI.parse(n.path);if((0,A.isAbsolute)(n.path))return I.URI.file(n.path)}return n.path}function w(n){if(typeof n.path=="object"){const s=I.URI.revive(n.path);if(s)return s.scheme===y.Schemas.file?s.fsPath:s.toString()}return n.path}function _(n,s){const i=s?E:w,a=(0,T.deepClone)(n);return o(a,(h,p)=>{h&&p&&(p.path=i(p))}),a}e.convertToDAPaths=_;function d(n,s){const i=s?E:w,a=(0,T.deepClone)(n);return o(a,(h,p)=>{!h&&p&&(p.path=i(p))}),a}e.convertToVSCPaths=d;function o(n,s){switch(n.type){case"event":const i=n;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const a=n;switch(a.command){case"setBreakpoints":s(!0,a.arguments.source);break;case"breakpointLocations":s(!0,a.arguments.source);break;case"source":s(!0,a.arguments.source);break;case"gotoTargets":s(!0,a.arguments.source);break;case"launchVSCode":a.arguments.args.forEach(p=>s(!1,p));break;default:break}break;case"response":const h=n;if(h.success&&h.body)switch(h.command){case"stackTrace":h.body.stackFrames.forEach(p=>s(!1,p.source));break;case"loadedSources":h.body.sources.forEach(p=>s(!1,p));break;case"scopes":h.body.scopes.forEach(p=>s(!1,p.source));break;case"setFunctionBreakpoints":h.body.breakpoints.forEach(p=>s(!1,p.source));break;case"setBreakpoints":h.body.breakpoints.forEach(p=>s(!1,p.source));break;default:break}break}}function c(n){return n.filter(s=>{var i;return!((i=s.presentation)===null||i===void 0?void 0:i.hidden)}).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=c;function t(n,s){return typeof n!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:n-s}}),define(me[206],ge([0,1,26,38,171,123,8,9,24,10,182,122]),function(G,e,b,I,A,T,y,k,D,P,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class g extends C.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(_,d){this.outputStream=d,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,_.on("data",o=>this.handleData(o))}sendMessage(_){if(this.outputStream){const d=JSON.stringify(_);this.outputStream.write(`Content-Length: ${Buffer.byteLength(d,"utf8")}${g.TWO_CRLF}${d}`,"utf8")}}handleData(_){for(this.rawData=Buffer.concat([this.rawData,_]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const d=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,d.length>0)try{this.acceptMessage(JSON.parse(d))}catch(o){this._onError.fire(new Error((o.message||o)+`
`+d))}continue}}else{const d=this.rawData.indexOf(g.TWO_CRLF);if(d!==-1){const c=this.rawData.toString("utf8",0,d).split(g.HEADER_LINESEPARATOR);for(const t of c){const n=t.split(g.HEADER_FIELDSEPARATOR);n[0]==="Content-Length"&&(this.contentLength=Number(n[1]))}this.rawData=this.rawData.slice(d+g.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=g,g.TWO_CRLF=`\r
\r
`,g.HEADER_LINESEPARATOR=/\r?\n/,g.HEADER_FIELDSEPARATOR=/: */;class m extends g{startSession(){return new Promise((_,d)=>{let o=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),_(),o=!0}),this.socket.on("close",()=>{o?this._onError.fire(new Error("connection closed")):d(new Error("connection closed"))}),this.socket.on("error",c=>{o?this._onError.fire(c):d(c)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=m;class l extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",_)}}e.SocketDebugAdapter=l;class f extends m{constructor(_){super();this.adapterServer=_}createConnection(_){return T.createConnection(this.adapterServer.path,_)}}e.NamedPipeDebugAdapter=f;class E extends g{constructor(_,d,o){super();this.adapterExecutable=_,this.debugType=d,this.outputService=o}async startSession(){const _=this.adapterExecutable.command,d=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(_)if(y.isAbsolute(_)){if(!await(0,b.exists)(_))throw new Error(A.localize(0,null,_))}else _.indexOf("/")<0&&_.indexOf("\\")<0;else throw new Error(A.localize(1,null,this.debugType));let c=process.env;if(o.env&&Object.keys(o.env).length>0&&(c=D.mixin(D.deepClone(process.env),o.env)),_==="node")if(Array.isArray(d)&&d.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:c,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(s.cwd=o.cwd);const i=I.fork(d[0],d.slice(1),s);if(!i.pid)throw new Error(A.localize(2,null,d[0]));this.serverProcess=i}else throw new Error(A.localize(3,null));else{const n={env:c};o.cwd&&(n.cwd=o.cwd),this.serverProcess=I.spawn(_,d,n)}this.serverProcess.on("error",n=>{this._onError.fire(n)}),this.serverProcess.on("exit",(n,s)=>{this._onExit.fire(n)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",n=>{this._onError.fire(n)}),this.serverProcess.stdin.on("error",n=>{this._onError.fire(n)});const t=this.outputService;if(t){const n=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const i=t.getChannel(r.ExtensionsChannelId);i&&i.append(n(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(c){this._onError.fire(c)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),P.isWindows?new Promise((_,d)=>{const o=I.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(c,t,n){if(c)return d(c)});o.on("exit",_),o.on("error",d)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(_,d){if(!!_){const o=Object.create(null);_.runtime&&(_.runtime.indexOf("./")===0?o.runtime=y.join(d,_.runtime):o.runtime=_.runtime),_.runtimeArgs&&(o.runtimeArgs=_.runtimeArgs),_.program&&(y.isAbsolute(_.program)?o.program=_.program:o.program=y.join(d,_.program)),_.args&&(o.args=_.args);const c=_;return c.win&&(o.win=E.extract(c.win,d)),c.winx86&&(o.winx86=E.extract(c.winx86,d)),c.windows&&(o.windows=E.extract(c.windows,d)),c.osx&&(o.osx=E.extract(c.osx,d)),c.linux&&(o.linux=E.extract(c.linux,d)),o}}static platformAdapterExecutable(_,d){let o=Object.create(null);d=d.toLowerCase();for(const a of _)if(a.contributes){const h=a.contributes.debuggers;h&&h.length>0&&h.filter(p=>typeof p.type=="string"&&k.equalsIgnoreCase(p.type,d)).forEach(p=>{const S=E.extract(p,a.extensionLocation.fsPath);o=D.mixin(o,S,a.isBuiltin)})}let c;P.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?c=o.winx86||o.win||o.windows:P.isWindows?c=o.win||o.windows:P.isMacintosh?c=o.osx:P.isLinux&&(c=o.linux),c=c||o;let t=c.program||o.program;const n=c.args||o.args;let s=c.runtime||o.runtime;const i=c.runtimeArgs||o.runtimeArgs;if(s)return{type:"executable",command:s,args:(i||[]).concat(typeof t=="string"?[t]:[]).concat(n||[])};if(t)return{type:"executable",command:t,args:n||[]}}}e.ExecutableDebugAdapter=E}),define(me[207],ge([0,1,38,10,29,189]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function y(g,m){return new Promise((l,f)=>{let E="";const w=b.spawn(g,m);w.pid&&w.stdout.on("data",_=>{E+=_.toString()}),w.on("error",_=>{f(_)}),w.on("close",_=>{l(E)})})}let k;function D(g,m){if(!k)if(I.isWindows)k=new T.WindowsExternalTerminalService(void 0);else if(I.isMacintosh)k=new T.MacExternalTerminalService(void 0);else if(I.isLinux)k=new T.LinuxExternalTerminalService(void 0);else throw new Error("external terminals not supported on this platform");const l=m.getConfiguration("terminal");return k.runInTerminal(g.title,g.cwd,g.args,g.env||{},l.external||{})}e.runInExternalTerminal=D;function P(g){return g?I.isWindows?y("wmic",["process","get","ParentProcessId"]).then(m=>m.split(`\r
`).some(f=>parseInt(f)===g),m=>!0):y("/usr/bin/pgrep",["-lP",String(g)]).then(m=>{const l=m.trim();return!(l.length===0||l.indexOf(" tmux")>=0)},m=>!0):Promise.resolve(!0)}e.hasChildProcesses=P;var r;(function(g){g[g.cmd=0]="cmd",g[g.powershell=1]="powershell",g[g.bash=2]="bash"})(r||(r={}));function C(g,m,l,f){g=g.trim().toLowerCase();let E;g.indexOf("powershell")>=0||g.indexOf("pwsh")>=0?E=1:g.indexOf("cmd.exe")>=0?E=0:g.indexOf("bash")>=0?E=2:I.isWindows?E=0:E=2;let w,_=" ";switch(E){case 1:if(w=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),l){const o=(0,A.getDriveLetter)(l);o&&(_+=`${o}:; `),_+=`cd ${w(l)}; `}if(f)for(let o in f){const c=f[o];c===null?_+=`Remove-Item env:${o}; `:_+=`\${env:${o}}='${c}'; `}if(m.length>0){const o=w(m.shift());_+=o[0]==="'"?`& ${o} `:`${o} `;for(let c of m)_+=`${w(c)} `}break;case 0:if(w=o=>(o=o.replace(/\"/g,'""'),o.indexOf(" ")>=0||o.indexOf('"')>=0||o.length===0?`"${o}"`:o),l){const o=(0,A.getDriveLetter)(l);o&&(_+=`${o}: && `),_+=`cd ${w(l)} && `}if(f){_+='cmd /C "';for(let o in f){let c=f[o];c===null?_+=`set "${o}=" && `:(c=c.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),_+=`set "${o}=${c}" && `)}}for(let o of m)_+=`${w(o)} `;f&&(_+='"');break;case 2:w=o=>(o=o.replace(/(["'\\\$])/g,"\\$1"),o.indexOf(" ")>=0||o.indexOf(";")>=0||o.length===0?`"${o}"`:o);const d=o=>/[^\w@%\/+=,.:^-]/.test(o)?`'${o.replace(/'/g,"'\\''")}'`:o;if(l&&(_+=`cd ${w(l)} ; `),f){_+="/usr/bin/env";for(let o in f){const c=f[o];c===null?_+=` -u ${d(o)}`:_+=` ${d(`${o}=${c}`)}`}_+=" "}for(let o of m)_+=`${w(o)} `;break}return _}e.prepareCommand=C}),define(me[89],ge([0,1,33,12,8,10,81]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var k;(function(u){u[u.Markdown=1]="Markdown",u[u.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(u){u[u.Running=1]="Running",u[u.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var P;(function(u){u[u.Idle=1]="Idle",u[u.Pending=2]="Pending",u[u.Executing=3]="Executing"})(P=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(u){u[u.WithHardKernelDependency=0]="WithHardKernelDependency",u[u.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",u[u.Pure=2]="Pure",u[u.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var C;(function(u){u[u.ModelChange=1]="ModelChange",u[u.Move=2]="Move",u[u.CellClearOutput=3]="CellClearOutput",u[u.CellsClearOutput=4]="CellsClearOutput",u[u.ChangeLanguage=5]="ChangeLanguage",u[u.Initialize=6]="Initialize",u[u.ChangeCellMetadata=7]="ChangeCellMetadata",u[u.Output=8]="Output",u[u.OutputItem=9]="OutputItem",u[u.ChangeCellContent=10]="ChangeCellContent",u[u.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",u[u.Unknown=12]="Unknown"})(C=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var g;(function(u){u[u.Handle=0]="Handle",u[u.Index=1]="Index"})(g=e.SelectionStateType||(e.SelectionStateType={}));var m;(function(u){u[u.Replace=1]="Replace",u[u.Output=2]="Output",u[u.Metadata=3]="Metadata",u[u.CellLanguage=4]="CellLanguage",u[u.DocumentMetadata=5]="DocumentMetadata",u[u.Move=6]="Move",u[u.OutputItems=7]="OutputItems",u[u.PartialMetadata=8]="PartialMetadata"})(m=e.CellEditType||(e.CellEditType={}));function l(u){const v=f.parse(u);return v?v.notebook.toString():u.toString()}e.getCellUndoRedoComparisonKey=l;var f;(function(u){u.scheme=I.Schemas.vscodeNotebookCell;const v=/^ch(\d{7,})/;function R(B,$){return B.with({scheme:u.scheme,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}u.generate=R;function N(B){if(B.scheme===u.scheme){const $=v.exec(B.fragment);if(!!$)return{handle:Number($[1]),notebook:B.with({scheme:B.fragment.substr($[0].length)||I.Schemas.file,fragment:null})}}}u.parse=N;function j(B){if(B.scheme===I.Schemas.vscodeNotebookCellMetadata){const $=v.exec(B.fragment);if(!!$)return{handle:Number($[1]),notebook:B.with({scheme:B.fragment.substr($[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellMetadataUri=j;function ie(B,$,U){return B.with({scheme:U,fragment:`ch${$.toString().padStart(7,"0")}${B.scheme!==I.Schemas.file?B.scheme:""}`})}u.generateCellUri=ie;function K(B,$){if(B.scheme===$){const U=v.exec(B.fragment);if(!!U)return{handle:Number(U[1]),notebook:B.with({scheme:B.fragment.substr(U[0].length)||I.Schemas.file,fragment:null})}}}u.parseCellUri=K})(f=e.CellUri||(e.CellUri={}));const E=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(u){var v,R;return(R=(v=E.get(u))===null||v===void 0?void 0:v.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=w;function _(u){var v,R;return(R=(v=E.get(u))===null||v===void 0?void 0:v.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=_;function d(u){var v,R;return(R=(v=E.get(u))===null||v===void 0?void 0:v.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=d;function o(u,v){return T.isWindows&&(u=u.replace(/\//g,"\\"),v=v.replace(/\//g,"\\")),b.match(u,v)}function c(u,v,R){let N=0;for(let j=0;j<v.length;j++){if(o(v[j],u))return N;N++}for(let j=0;j<R.length;j++){if(o(R[j],u))return N;N++}return N}function t(u,v,R){return u.sort((N,j)=>c(N,v,R)-c(j,v,R))}e.sortMimeTypes=t;function n(u,v,R,N=(j,ie)=>j===ie){const j=[];function ie($,U,L){if(!(U===0&&L.length===0)){const O=j[j.length-1];O&&O.start+O.deleteCount===$?(O.deleteCount+=U,O.toInsert.push(...L)):j.push({start:$,deleteCount:U,toInsert:L})}}let K=0,B=0;for(;;){if(K===u.length){ie(K,0,v.slice(B));break}if(B===v.length){ie(K,u.length-K,[]);break}const $=u[K],U=v[B];if(N($,U)){K+=1,B+=1;continue}R(U)?(ie(K,1,[]),K+=1):(ie(K,0,[U]),B+=1)}return j}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(u){u.default="default",u.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function i(u){const v=u;return!!((typeof v.include=="string"||b.isRelativePattern(v.include))&&(typeof v.exclude=="string"||b.isRelativePattern(v.exclude)))}e.isDocumentExcludePattern=i;function a(u,v,R){if(Array.isArray(u.viewType)&&u.viewType.indexOf(v)>=0||u.viewType===v)return!0;if(u.filenamePattern){let N=i(u.filenamePattern)?u.filenamePattern.include:u.filenamePattern,j=i(u.filenamePattern)?u.filenamePattern.exclude:void 0;if(b.match(N,(0,A.basename)(R.fsPath).toLowerCase()))return!(j&&b.match(j,(0,A.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a;class h{constructor(v){this.textModel=v}getElements(){const v=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)v[R]=this.textModel.cells[R].getHashValue();return v}}e.CellSequence=h,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var p;(function(u){u[u.Left=1]="Left",u[u.Right=2]="Right"})(p=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class S{static create(v){return`${S._prefix}/${v}`}static parse(v){if(v.startsWith(S._prefix))return v.substr(S._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S._prefix="notebook/"}),define(me[208],ge([0,1,173,4,81]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new A.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new A.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new A.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,I.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(me[209],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(A){return[...A.entries()]}e.serializeEnvironmentVariableCollection=b;function I(A){return new Map(A)}e.deserializeEnvironmentVariableCollection=I}),define(me[210],ge([0,1,8,95,10]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function T(o,c){if(!!c)if(A.isWindows)for(const t in c){let n=t;for(const i in o)if(t.toLowerCase()===i.toLowerCase()){n=i;break}const s=c[t];s!==void 0&&y(o,n,s)}else Object.keys(c).forEach(t=>{const n=c[t];n!==void 0&&y(o,t,n)})}e.mergeEnvironments=T;function y(o,c,t){typeof t=="string"?o[c]=t:delete o[c]}function k(o,c,t,n){o.TERM_PROGRAM="vscode",c&&(o.TERM_PROGRAM_VERSION=c),r(o,n)&&(o.LANG=C(t)),o.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=k;function D(o,c){if(!!c)for(const t of Object.keys(c)){const n=c[t];n&&(o[t]=n)}}function P(o,c){return Object.keys(c).forEach(t=>{const n=c[t];if(typeof n=="string")try{c[t]=o(n)}catch(s){c[t]=n}}),c}function r(o,c){if(c==="on")return!0;if(c==="auto"){const t=o.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=r;function C(o){const c=o?o.split("-"):[],t=c.length;if(t===0)return"en_US.UTF-8";if(t===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};c[0]in n&&c.push(n[c[0]])}else c[1]=c[1].toUpperCase();return c.join("_")+".UTF-8"}e.getLangEnvVariable=C;function g(o,c,t,n,s,i){if(o.cwd){const h=typeof o.cwd=="object"?o.cwd.fsPath:o.cwd,p=m(h,t);return l(p||h)}let a;return!o.ignoreConfigurationCwd&&s&&(t&&(s=m(s,t,i)),s&&(b.isAbsolute(s)?a=s:n&&(a=b.join(n.fsPath,s)))),a||(a=n?n.fsPath:c||""),l(a)}e.getCwd=g;function m(o,c,t){if(c)try{return c(o)}catch(n){t==null||t.error("Could not resolve terminal cwd",n);return}return o}function l(o){return A.OS===1&&o&&o[1]===":"?o[0].toUpperCase()+o.substr(1):o}function f(o,c,t){if(!!t)return n=>t.resolveWithEnvironment(c,o,n)}e.createVariableResolver=f;function E(o,c,t,n,s,i,a,h=A.platform){let p;a&&(p=_(o,"automationShell",h)),p||(p=_(o,"shell",h));let S=p||c;if(h===3&&!t&&n){const u=b.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();S&&S.toLowerCase().indexOf(u)===0&&(S=b.join(n,"System32",S.substr(u.length+1)))}if(S&&h===3&&(S=S.replace(/\//g,"\\")),s)try{S=s(S)}catch(u){i.error("Could not resolve shell",u)}return S}e.getDefaultShell=E;function w(o,c,t,n,s=A.platform){if(c&&_(o,"automationShell",s))return[];const i=s===3?"windows":s===1?"osx":"linux";let a=o(`terminal.integrated.shellArgs.${i}`);if(!a)return[];if(typeof a=="string"&&s===3)return t?t(a):a;if(t){const h=[];for(const p of a)try{h.push(t(p))}catch(S){n.error(`Could not resolve terminal.integrated.shellArgs.${i}`,S),h.push(p)}a=h}return a}e.getDefaultShellArgs=w;function _(o,c,t=A.platform){return o(`terminal.integrated.${c}.${t===3?"windows":t===1?"osx":"linux"}`)}function d(o,c,t,n,s,i){const a={};if(o.strictEnv)D(a,o.env);else{D(a,i);const h=Object.assign({},c);t&&(h&&P(t,h),o.env&&P(t,o.env)),(0,I.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI"),T(a,h),T(a,o.env),k(a,n,A.locale,s)}return a}e.createTerminalEnvironment=d});var mn=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],b;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),b={},I("next"),I("throw"),I("return"),b[Symbol.asyncIterator]=function(){return this},b);function I(T){b[T]=G[T]&&function(y){return new Promise(function(k,D){y=G[T](y),A(k,D,y.done,y.value)})}}function A(T,y,k,D){Promise.resolve(D).then(function(P){T({value:P,done:k})},y)}};define(me[211],ge([0,1,37,8,105,192,38,26,43,10]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let r;function C(o,c,t,n,s,i,a){return t=t||{existsFile:k.SymlinkSupport.existsFile,readFile:b.promises.readFile},P.isWindows?g(o,t,n,c("terminal.integrated.useWslProfiles")||!0,c("terminal.integrated.profiles.windows"),c("terminal.integrated.defaultProfile.windows"),s,i):w(t,n,o,c(P.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),c(P.isMacintosh?"terminal.integrated.defaultProfile.osx":"terminal.integrated.defaultProfile.linux"),a,s,i)}e.detectAvailableProfiles=C;async function g(o,c,t,n,s,i,a,h){const p=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${process.env.windir}\\${p?"Sysnative":"System32"}`;let u=!1;(0,T.getWindowsBuildNumber)()>=16299&&(u=!0),await l();const v=new Map;o||(v.set("PowerShell",{source:"PowerShell",icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),v.set("Windows PowerShell",{path:`${S}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:D.Codicon.terminalPowershell.id,isAutoDetected:!0}),v.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),v.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),v.set("Command Prompt",{path:`${S}\\cmd.exe`,icon:D.Codicon.terminalCmd.id,isAutoDetected:!0})),_(s,v);const R=await m(v.entries(),i,c,t,a,h);if(!o||o&&n)try{const N=await E(`${S}\\${u?"wsl":"bash"}.exe`,i);N&&R.push(...N)}catch(N){t==null||t.info("WSL is not installed, so could not detect WSL profiles")}return R}async function m(o,c,t,n,s,i){const a=[];for(const[h,p]of o)if(p!==null){let S,u,v;if("source"in p){const j=r==null?void 0:r.get(p.source);if(!j)continue;S=j.paths,u=p.args||j.args,v=p.icon||j.icon}else S=Array.isArray(p.path)?p.path:[p.path],u=P.isWindows||Array.isArray(p.args)?p.args:void 0,v=p.icon;const R=S.slice();for(let j=0;j<R.length;j++)R[j]=await(s==null?void 0:s.resolveAsync(i,R[j]))||R[j];const N=await d(h,c,R,t,u,p.env,p.overrideName,p.isAutoDetected,n);N?(N.isAutoDetected=p.isAutoDetected,N.icon=v,a.push(N)):n==null||n.trace("profile not validated",h,S)}return a}async function l(){r||(r=new Map,r.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`],args:["--login"]}),r.set("PowerShell",{profileName:"PowerShell",paths:await f(),icon:"terminal-powershell"}))}async function f(){var o,c;const t=[];try{for(var n=mn((0,A.enumeratePowerShellInstallations)()),s;s=await n.next(),!s.done;){const i=s.value;t.push(i.exePath)}}catch(i){o={error:i}}finally{try{s&&!s.done&&(c=n.return)&&await c.call(n)}finally{if(o)throw o.error}}return t}async function E(o,c){const t=[],n=await new Promise((a,h)=>{y.exec("wsl.exe -l -q",{encoding:"utf16le"},(p,S)=>{if(p)return h("Problem occurred when getting wsl distros");a(S)})});if(!n)return[];const s=new RegExp(/[\r?\n]/),i=n.split(s).filter(a=>a.trim().length>0&&a!=="");for(const a of i)if(a!==""&&!a.startsWith("docker-desktop")){const h=`${a} (WSL)`,p={profileName:h,path:o,args:["-d",`${a}`],isDefault:h===c};a.includes("Ubuntu")?p.icon="terminal-ubuntu":a.includes("Debian")?p.icon="terminal-debian":p.icon="terminal-linux",t.push(p)}return t}async function w(o,c,t,n,s,i,a,h){const p=new Map;if(!t){const S=await o.readFile("/etc/shells","utf8"),u=i||S.split(`
`).filter(R=>R.trim().indexOf("#")!==0&&R.trim().length>0),v=new Map;for(const R of u){let N=(0,I.basename)(R),j=v.get(N)||0;j++,j>1&&(N=`${N} (${j})`),v.set(N,j),p.set(N,{path:R,isAutoDetected:!0})}}return _(n,p),await m(p.entries(),s,o,c,a,h)}function _(o,c){if(!!o)for(const[t,n]of Object.entries(o))n===null||!("path"in n)&&!("source"in n)?c.delete(t):c.set(t,n)}async function d(o,c,t,n,s,i,a,h,p){if(t.length===0)return Promise.resolve(void 0);const S=t.shift();if(S==="")return d(o,c,t,n,s,i,a,h);const u={profileName:o,path:S,args:s,env:i,overrideName:a,isAutoDetected:h,isDefault:o===c};if((0,I.basename)(S)===S){const R=process.env.PATH?process.env.PATH.split(I.delimiter):void 0;return await(0,T.findExecutable)(S,void 0,R,void 0,n.existsFile)?u:d(o,c,t,n,s)}return await n.existsFile((0,I.normalize)(S))?u:d(o,c,t,n,s,i,a,h)}}),define(me[124],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(D){D[D.NotExpandable=0]="NotExpandable",D[D.Expandable=1]="Expandable",D[D.BusyExpanding=2]="BusyExpanding",D[D.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const I=(D,P)=>{P.expand!==void 0&&(D.expand=P.expand),P.item!==void 0&&(D.item=D.item?Object.assign(D.item,P.item):P.item)};e.applyTestItemUpdate=I;var A;(function(D){D[D.Add=0]="Add",D[D.Update=1]="Update",D[D.Remove=2]="Remove",D[D.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",D[D.Retire=4]="Retire"})(A=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(D,P)=>`${D}:${P.toString()}`;e.getTestSubscriptionKey=T;class y{add(P){}update(P){}remove(P,r){}complete(){}}e.IncrementalChangeCollector=y;class k{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(P){const r=this.createChangeCollector();for(const C of P)switch(C[0]){case 0:{const g=C[1];if(g.parent){if(this.items.has(g.parent)){const m=this.items.get(g.parent);m.children.add(g.item.extId);const l=this.createItem(g,m);this.items.set(g.item.extId,l),r.add(l)}}else{this.roots.add(g.item.extId);const m=this.createItem(g);this.items.set(g.item.extId,m),r.add(m)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=C[1],m=this.items.get(g.extId);if(!m)break;g.expand!==void 0&&(m.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(m,g),r.update(m);break}case 2:{const g=this.items.get(C[1]);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g.item.extId);const m=[[C[1]]];for(;m.length;)for(const l of m.pop()){const f=this.items.get(l);f&&(m.push(f.children),this.items.delete(l),r.remove(f,f!==g),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(C[1]);break;case 3:this.updatePendingRoots(C[1]);break}r.complete()}retireTest(P){}updatePendingRoots(P){this.pendingRootCount+=P}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=k}),define(me[212],ge([0,1,8,36,11,24,10,76,174]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(C,g,m){this._contributedVariables=new Map,this._context=C,this._labelService=g,m&&(this._envVariablesPromise=m.then(l=>this.prepareEnv(l)))}prepareEnv(C){if(y.isWindows){const g=Object.create(null);return Object.keys(C).forEach(m=>{g[m.toLowerCase()]=C[m]}),g}return C}resolveWithEnvironment(C,g,m){return this.recursiveResolve(this.prepareEnv(C),g?g.uri:void 0,m)}async resolveAsync(C,g){return this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,g)}async resolveAnyBase(C,g,m,l){const f=T.deepClone(g);return y.isWindows&&f.windows?Object.keys(f.windows).forEach(E=>f[E]=f.windows[E]):y.isMacintosh&&f.osx?Object.keys(f.osx).forEach(E=>f[E]=f.osx[E]):y.isLinux&&f.linux&&Object.keys(f.linux).forEach(E=>f[E]=f.linux[E]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,C?C.uri:void 0,f,m,l)}async resolveAnyAsync(C,g,m){return this.resolveAnyBase(C,g,m)}async resolveAnyMap(C,g,m){const l=new Map;return{newConfig:await this.resolveAnyBase(C,g,m,l),resolvedVariables:l}}resolveWithInteractionReplace(C,g,m,l){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(C,g,m,l){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(C,g){if(this._contributedVariables.has(C))throw new Error("Variable "+C+" is contributed twice.");this._contributedVariables.set(C,g)}recursiveResolve(C,g,m,l,f){if(A.isString(m))return this.resolveString(C,g,m,l,f);if(A.isArray(m))return m.map(E=>this.recursiveResolve(C,g,E,l,f));if(A.isObject(m)){let E=Object.create(null);return Object.keys(m).forEach(w=>{const _=this.resolveString(C,g,w,l,f);E[_]=this.recursiveResolve(C,g,m[w],l,f)}),E}return m}resolveString(C,g,m,l,f){return m.replace(P.VARIABLE_REGEXP,(w,_)=>{if(_.includes(P.VARIABLE_LHS))return w;let d=this.evaluateSingleVariable(C,w,_,g,l);return f&&f.set(_,d),d})}fsPath(C){return this._labelService?this._labelService.getUriLabel(C,{noPrefix:!0}):C.fsPath}evaluateSingleVariable(C,g,m,l,f){let E;const w=m.split(":");w.length>1&&(m=w[0],E=w[1]);const _=()=>{const c=this._context.getFilePath();if(c)return c;throw new Error((0,D.localize)(0,null,g))},d=()=>{const c=_();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,D.localize)(1,null,g,b.basename(c)))},o=()=>{if(E){const c=this._context.getFolderUri(E);if(c)return c;throw new Error((0,D.localize)(2,null,g,E))}if(l)return l;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,g)):new Error((0,D.localize)(4,null,g))};switch(m){case"env":if(E){if(C){const c=C[y.isWindows?E.toLowerCase():E];if(A.isString(c))return c}return""}throw new Error((0,D.localize)(5,null,g));case"config":if(E){const c=this._context.getConfigurationValue(l,E);if(A.isUndefinedOrNull(c))throw new Error((0,D.localize)(6,null,g,E));if(A.isObject(c))throw new Error((0,D.localize)(7,null,g,E));return c}throw new Error((0,D.localize)(8,null,g));case"command":return this.resolveFromMap(g,E,f,"command");case"input":return this.resolveFromMap(g,E,f,"input");default:switch(m){case"workspaceRoot":case"workspaceFolder":return(0,k.normalizeDriveLetter)(this.fsPath(o()));case"cwd":return l||E?(0,k.normalizeDriveLetter)(this.fsPath(o())):I.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(o()));case"lineNumber":const c=this._context.getLineNumber();if(c)return c;throw new Error((0,D.localize)(9,null,g));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,D.localize)(10,null,g));case"file":return _();case"fileWorkspaceFolder":return d();case"relativeFile":return l||E?b.relative(this.fsPath(o()),_()):_();case"relativeFileDirname":const n=b.dirname(_());if(l||E){const h=b.relative(this.fsPath(o()),n);return h.length===0?".":h}return n;case"fileDirname":return b.dirname(_());case"fileExtname":return b.extname(_());case"fileBasename":return b.basename(_());case"fileBasenameNoExtension":const s=b.basename(_());return s.slice(0,s.length-b.extname(s).length);case"fileDirnameBasename":return b.basename(b.dirname(_()));case"execPath":const i=this._context.getExecPath();return i||g;case"execInstallFolder":const a=this._context.getAppRoot();return a||g;case"pathSeparator":return b.sep;default:try{const h=E?`${m}:${E}`:m;return this.resolveFromMap(g,h,f,void 0)}catch(h){return g}}}}resolveFromMap(C,g,m,l){if(g&&m){const f=l===void 0?m[g]:m[l+":"+g];if(typeof f=="string")return f;throw new Error((0,D.localize)(11,null,C))}return C}}e.AbstractVariableResolverService=P,P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(me[213],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var I;(function(g){g[g.UP=0]="UP",g[g.DOWN=1]="DOWN",g[g.LEFT=2]="LEFT",g[g.RIGHT=3]="RIGHT"})(I=e.GroupDirection||(e.GroupDirection={}));var A;(function(g){g[g.HORIZONTAL=0]="HORIZONTAL",g[g.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(g){g[g.FIRST=0]="FIRST",g[g.LAST=1]="LAST",g[g.NEXT=2]="NEXT",g[g.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(g){g[g.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",g[g.EVEN=1]="EVEN",g[g.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var k;(function(g){g[g.COPY_EDITORS=0]="COPY_EDITORS",g[g.MOVE_EDITORS=1]="MOVE_EDITORS"})(k=e.MergeGroupMode||(e.MergeGroupMode={}));var D;(function(g){g[g.CREATION_TIME=0]="CREATION_TIME",g[g.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",g[g.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(D=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(g){g[g.GROUP_ACTIVE=0]="GROUP_ACTIVE",g[g.GROUP_INDEX=1]="GROUP_INDEX",g[g.EDITOR_OPEN=2]="EDITOR_OPEN",g[g.EDITOR_CLOSE=3]="EDITOR_CLOSE",g[g.EDITOR_MOVE=4]="EDITOR_MOVE",g[g.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",g[g.EDITOR_LABEL=6]="EDITOR_LABEL",g[g.EDITOR_PIN=7]="EDITOR_PIN",g[g.EDITOR_STICKY=8]="EDITOR_STICKY",g[g.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(P=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(g){g[g.NEW_EDITOR=1]="NEW_EDITOR",g[g.MOVE_EDITOR=2]="MOVE_EDITOR",g[g.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function C(g){return g.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=C}),define(me[214],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(me[20],ge([0,1,16,99,285,59,24,11,2,44,80,175,115,89,214,7]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var E;(function(be){function he(J){const{selectionStartLineNumber:Ne,selectionStartColumn:Fe,positionLineNumber:Ye,positionColumn:et}=J,ut=new f.Position(Ne-1,Fe-1),ht=new f.Position(Ye-1,et-1);return new f.Selection(ut,ht)}be.to=he;function ae(J){const{anchor:Ne,active:Fe}=J;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}be.from=ae})(E=e.Selection||(e.Selection={}));var w;(function(be){function he(J){if(!!J){const{start:Ne,end:Fe}=J;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}}be.from=he;function ae(J){if(!!J){const{startLineNumber:Ne,startColumn:Fe,endLineNumber:Ye,endColumn:et}=J;return new f.Range(Ne-1,Fe-1,Ye-1,et-1)}}be.to=ae})(w=e.Range||(e.Range={}));var _;(function(be){function he(ae){switch(ae){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}be.to=he})(_=e.TokenType||(e.TokenType={}));var d;(function(be){function he(J){return new f.Position(J.lineNumber-1,J.column-1)}be.to=he;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=ae})(d=e.Position||(e.Position={}));var o;(function(be){function he(J){switch(J){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}be.from=he;function ae(J){switch(J){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}be.to=ae})(o=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(be){function he(J){let Ne;return J.code&&((0,k.isString)(J.code)||(0,k.isNumber)(J.code)?Ne=String(J.code):Ne={value:String(J.code.value),target:J.code.target}),Object.assign(Object.assign({},w.from(J.range)),{message:J.message,source:J.source,code:Ne,severity:n.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(t.from),tags:Array.isArray(J.tags)?(0,b.coalesce)(J.tags.map(o.from)):void 0})}be.from=he;function ae(J){var Ne;const Fe=new f.Diagnostic(w.to(J),J.message,n.to(J.severity));return Fe.source=J.source,Fe.code=(0,k.isString)(J.code)?J.code:(Ne=J.code)===null||Ne===void 0?void 0:Ne.value,Fe.relatedInformation=J.relatedInformation&&J.relatedInformation.map(t.to),Fe.tags=J.tags&&(0,b.coalesce)(J.tags.map(o.to)),Fe}be.to=ae})(c=e.Diagnostic||(e.Diagnostic={}));var t;(function(be){function he(J){return Object.assign(Object.assign({},w.from(J.location.range)),{message:J.message,resource:J.location.uri})}be.from=he;function ae(J){return new f.DiagnosticRelatedInformation(new f.Location(J.resource,w.to(J)),J.message)}be.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(be){function he(J){switch(J){case f.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}be.from=he;function ae(J){switch(J){case g.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}be.to=ae})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(be){function he(J){return typeof J=="number"&&J>=f.ViewColumn.One?J-1:J===f.ViewColumn.Beside?l.SIDE_GROUP:l.ACTIVE_GROUP}be.from=he;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function i(be){return typeof be.range!="undefined"}function a(be){return be.length===0?!0:!!i(be[0])}e.isDecorationOptionsArr=a;var h;(function(be){function he(et){return et.map(be.from)}be.fromMany=he;function ae(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function J(et){let ut;if(ae(et)){const{language:ft,value:lt}=et;ut={value:"```"+ft+`
`+lt+"\n```\n"}}else f.MarkdownString.isMarkdownString(et)?ut={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ut={value:et}:ut={value:""};const ht=Object.create(null);ut.uris=ht;const Je=ft=>{try{let lt=D.URI.parse(ft,!0);lt=lt.with({query:Ne(lt.query,ht)}),ht[ft]=lt}catch(lt){}return""},at=new A.Renderer;return at.link=Je,at.image=ft=>Je(I.parseHrefAndDimensions(ft).href),A(ut.value,{renderer:at}),ut}be.from=J;function Ne(et,ut){if(!et)return et;let ht;try{ht=(0,T.parse)(et)}catch(at){}if(!ht)return et;let Je=!1;return ht=(0,y.cloneAndChange)(ht,at=>{if(D.URI.isUri(at)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ft]=at,Je=!0,ft}else return}),Je?JSON.stringify(ht):et}function Fe(et){const ut=new f.MarkdownString(et.value,et.supportThemeIcons);return ut.isTrusted=et.isTrusted,ut}be.to=Fe;function Ye(et){if(!!et)return typeof et=="string"?et:be.from(et)}be.fromStrict=Ye})(h=e.MarkdownString||(e.MarkdownString={}));function p(be){return a(be)?be.map(he=>({range:w.from(he.range),hoverMessage:Array.isArray(he.hoverMessage)?h.fromMany(he.hoverMessage):he.hoverMessage?h.from(he.hoverMessage):void 0,renderOptions:he.renderOptions})):be.map(he=>({range:w.from(he)}))}e.fromRangeOrRangeWithMessage=p;function S(be){return typeof be=="undefined"?be:typeof be=="string"?D.URI.file(be):be}e.pathOrURIToURI=S;var u;(function(be){function he(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?S(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}be.from=he})(u=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var v;(function(be){function he(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?S(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(v=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(be){function he(ae){if(typeof ae=="undefined")return ae;switch(ae){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=he})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(be){function he(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?v.from(ae.light):void 0,dark:ae.dark?v.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?S(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?u.from(ae.before):void 0,after:ae.after?u.from(ae.after):void 0}}be.from=he})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var j;(function(be){function he(J){return{text:J.newText,eol:J.newEol&&ne.from(J.newEol),range:w.from(J.range)}}be.from=he;function ae(J){const Ne=new f.TextEdit(w.to(J.range),J.text);return Ne.newEol=typeof J.eol=="undefined"?void 0:ne.to(J.eol),Ne}be.to=ae})(j=e.TextEdit||(e.TextEdit={}));var ie;(function(be){function he(J,Ne,Fe){var Ye,et,ut;const ht={edits:[]};if(J instanceof f.WorkspaceEdit)for(let Je of J._allEntries())if(Je._type===1)ht.edits.push({_type:1,oldUri:Je.from,newUri:Je.to,options:Je.options,metadata:Je.metadata});else if(Je._type===2){const at=Ne==null?void 0:Ne.getDocument(Je.uri);ht.edits.push({_type:2,resource:Je.uri,edit:j.from(Je.edit),modelVersionId:at==null?void 0:at.version,metadata:Je.metadata})}else Je._type===3?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:(Ye=Fe==null?void 0:Fe.getNotebookDocument(Je.uri,!0))===null||Ye===void 0?void 0:Ye.apiNotebook.version}):Je._type===4?(Je.newOutputs&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:2,index:Je.index,append:Je.append,outputs:Je.newOutputs.map(Ie.from)}}),Je.newMetadata&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:8,index:Je.index,metadata:Je.newMetadata}})):Je._type===5?ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,notebookVersionId:(et=Fe==null?void 0:Fe.getNotebookDocument(Je.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Z.from)}}):Je._type===6&&ht.edits.push({_type:3,metadata:Je.metadata,resource:Je.uri,edit:{editType:7,outputId:Je.outputId,items:((ut=Je.newOutputItems)===null||ut===void 0?void 0:ut.map(ce.from))||[],append:Je.append}});return ht}be.from=he;function ae(J){const Ne=new f.WorkspaceEdit;for(const Fe of J.edits)Fe.edit?Ne.replace(D.URI.revive(Fe.resource),w.to(Fe.edit.range),Fe.edit.text):Ne.renameFile(D.URI.revive(Fe.oldUri),D.URI.revive(Fe.newUri),Fe.options);return Ne}be.to=ae})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var K;(function(be){const he=Object.create(null);he[f.SymbolKind.File]=0,he[f.SymbolKind.Module]=1,he[f.SymbolKind.Namespace]=2,he[f.SymbolKind.Package]=3,he[f.SymbolKind.Class]=4,he[f.SymbolKind.Method]=5,he[f.SymbolKind.Property]=6,he[f.SymbolKind.Field]=7,he[f.SymbolKind.Constructor]=8,he[f.SymbolKind.Enum]=9,he[f.SymbolKind.Interface]=10,he[f.SymbolKind.Function]=11,he[f.SymbolKind.Variable]=12,he[f.SymbolKind.Constant]=13,he[f.SymbolKind.String]=14,he[f.SymbolKind.Number]=15,he[f.SymbolKind.Boolean]=16,he[f.SymbolKind.Array]=17,he[f.SymbolKind.Object]=18,he[f.SymbolKind.Key]=19,he[f.SymbolKind.Null]=20,he[f.SymbolKind.EnumMember]=21,he[f.SymbolKind.Struct]=22,he[f.SymbolKind.Event]=23,he[f.SymbolKind.Operator]=24,he[f.SymbolKind.TypeParameter]=25;function ae(Ne){return typeof he[Ne]=="number"?he[Ne]:6}be.from=ae;function J(Ne){for(const Fe in he)if(he[Fe]===Ne)return Number(Fe);return f.SymbolKind.Property}be.to=J})(K=e.SymbolKind||(e.SymbolKind={}));var B;(function(be){function he(J){switch(J){case f.SymbolTag.Deprecated:return 1}}be.from=he;function ae(J){switch(J){case 1:return f.SymbolTag.Deprecated}}be.to=ae})(B=e.SymbolTag||(e.SymbolTag={}));var $;(function(be){function he(J){return{name:J.name,kind:K.from(J.kind),tags:J.tags&&J.tags.map(B.from),containerName:J.containerName,location:F.from(J.location)}}be.from=he;function ae(J){const Ne=new f.SymbolInformation(J.name,K.to(J.kind),J.containerName,F.to(J.location));return Ne.tags=J.tags&&J.tags.map(B.to),Ne}be.to=ae})($=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(be){function he(J){var Ne,Fe;const Ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:w.from(J.range),selectionRange:w.from(J.selectionRange),kind:K.from(J.kind),tags:(Fe=(Ne=J.tags)===null||Ne===void 0?void 0:Ne.map(B.from))!==null&&Fe!==void 0?Fe:[]};return J.children&&(Ye.children=J.children.map(he)),Ye}be.from=he;function ae(J){const Ne=new f.DocumentSymbol(J.name,J.detail,K.to(J.kind),w.to(J.range),w.to(J.selectionRange));return(0,b.isNonEmptyArray)(J.tags)&&(Ne.tags=J.tags.map(B.to)),J.children&&(Ne.children=J.children.map(ae)),Ne}be.to=ae})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var L;(function(be){function he(ae){const J=new f.CallHierarchyItem(K.to(ae.kind),ae.name,ae.detail||"",D.URI.revive(ae.uri),w.to(ae.range),w.to(ae.selectionRange));return J._sessionId=ae._sessionId,J._itemId=ae._itemId,J}be.to=he})(L=e.CallHierarchyItem||(e.CallHierarchyItem={}));var O;(function(be){function he(ae){return new f.CallHierarchyIncomingCall(L.to(ae.from),ae.fromRanges.map(J=>w.to(J)))}be.to=he})(O=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(be){function he(ae){return new f.CallHierarchyOutgoingCall(L.to(ae.to),ae.fromRanges.map(J=>w.to(J)))}be.to=he})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var F;(function(be){function he(J){return{range:J.range&&w.from(J.range),uri:J.uri}}be.from=he;function ae(J){return new f.Location(D.URI.revive(J.uri),w.to(J.range))}be.to=ae})(F=e.location||(e.location={}));var W;(function(be){function he(J){const Ne=J,Fe=J;return{originSelectionRange:Ne.originSelectionRange?w.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Fe.uri,range:w.from(Ne.targetRange?Ne.targetRange:Fe.range),targetSelectionRange:Ne.targetSelectionRange?w.from(Ne.targetSelectionRange):void 0}}be.from=he;function ae(J){return{targetUri:D.URI.revive(J.uri),targetRange:w.to(J.range),targetSelectionRange:J.targetSelectionRange?w.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?w.to(J.originSelectionRange):void 0}}be.to=ae})(W=e.DefinitionLink||(e.DefinitionLink={}));var q;(function(be){function he(J){return{range:w.from(J.range),contents:h.fromMany(J.contents)}}be.from=he;function ae(J){return new f.Hover(J.contents.map(h.to),w.to(J.range))}be.to=ae})(q=e.Hover||(e.Hover={}));var Q;(function(be){function he(J){return{range:w.from(J.range),expression:J.expression}}be.from=he;function ae(J){return new f.EvaluatableExpression(w.to(J.range),J.expression)}be.to=ae})(Q=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(be){function he(J){if(J instanceof f.InlineValueText)return{type:"text",range:w.from(J.range),text:J.text};if(J instanceof f.InlineValueVariableLookup)return{type:"variable",range:w.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:w.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=he;function ae(J){switch(J.type){case"text":return{range:w.to(J.range),text:J.text};case"variable":return{range:w.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:w.to(J.range),expression:J.expression}}}be.to=ae})(le=e.InlineValue||(e.InlineValue={}));var ve;(function(be){function he(J){return{frameId:J.frameId,stoppedLocation:w.from(J.stoppedLocation)}}be.from=he;function ae(J){return new f.InlineValueContext(J.frameId,w.to(J.stoppedLocation))}be.to=ae})(ve=e.InlineValueContext||(e.InlineValueContext={}));var Re;(function(be){function he(J){return{range:w.from(J.range),kind:J.kind}}be.from=he;function ae(J){return new f.DocumentHighlight(w.to(J.range),J.kind)}be.to=ae})(Re=e.DocumentHighlight||(e.DocumentHighlight={}));var Se;(function(be){function he(ae){switch(ae){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}be.to=he})(Se=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Oe;(function(be){function he(ae){return{triggerKind:Se.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}be.to=he})(Oe=e.CompletionContext||(e.CompletionContext={}));var z;(function(be){function he(J){switch(J){case f.CompletionItemTag.Deprecated:return 1}}be.from=he;function ae(J){switch(J){case 1:return f.CompletionItemTag.Deprecated}}be.to=ae})(z=e.CompletionItemTag||(e.CompletionItemTag={}));var Y;(function(be){const he=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ae(Fe){var Ye;return(Ye=he.get(Fe))!==null&&Ye!==void 0?Ye:9}be.from=ae;const J=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Ne(Fe){var Ye;return(Ye=J.get(Fe))!==null&&Ye!==void 0?Ye:f.CompletionItemKind.Property}be.to=Ne})(Y=e.CompletionItemKind||(e.CompletionItemKind={}));var ee;(function(be){function he(ae,J){var Ne;const Fe=new f.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Fe.label2=ae.label),Fe.insertText=ae.insertText,Fe.kind=Y.to(ae.kind),Fe.tags=(Ne=ae.tags)===null||Ne===void 0?void 0:Ne.map(z.to),Fe.detail=ae.detail,Fe.documentation=I.isMarkdownString(ae.documentation)?h.to(ae.documentation):ae.documentation,Fe.sortText=ae.sortText,Fe.filterText=ae.filterText,Fe.preselect=ae.preselect,Fe.commitCharacters=ae.commitCharacters,P.Range.isIRange(ae.range)?Fe.range=w.to(ae.range):typeof ae.range=="object"&&(Fe.range={inserting:w.to(ae.range.insert),replacing:w.to(ae.range.replace)}),Fe.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Fe.insertText=new f.SnippetString(ae.insertText):(Fe.insertText=ae.insertText,Fe.textEdit=Fe.range instanceof f.Range?new f.TextEdit(Fe.range,Fe.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ae.additionalTextEdits.map(Ye=>j.to(Ye))),Fe.command=J&&ae.command?J.fromInternal(ae.command):void 0,Fe}be.to=he})(ee=e.CompletionItem||(e.CompletionItem={}));var se;(function(be){function he(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0}}be.from=he;function ae(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation}}be.to=ae})(se=e.ParameterInformation||(e.ParameterInformation={}));var fe;(function(be){function he(J){return{label:J.label,documentation:J.documentation?h.fromStrict(J.documentation):void 0,parameters:Array.isArray(J.parameters)?J.parameters.map(se.from):[],activeParameter:J.activeParameter}}be.from=he;function ae(J){return{label:J.label,documentation:I.isMarkdownString(J.documentation)?h.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(se.to):[],activeParameter:J.activeParameter}}be.to=ae})(fe=e.SignatureInformation||(e.SignatureInformation={}));var Ee;(function(be){function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.from):[]}}be.from=he;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(fe.to):[]}}be.to=ae})(Ee=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(be){function he(J){var Ne;return{text:J.text,position:d.from(J.position),kind:pe.from((Ne=J.kind)!==null&&Ne!==void 0?Ne:f.InlayHintKind.Other),whitespaceBefore:J.whitespaceBefore,whitespaceAfter:J.whitespaceAfter}}be.from=he;function ae(J){const Ne=new f.InlayHint(J.text,d.to(J.position),pe.to(J.kind));return Ne.whitespaceAfter=J.whitespaceAfter,Ne.whitespaceBefore=J.whitespaceBefore,Ne}be.to=ae})(Be=e.InlayHint||(e.InlayHint={}));var pe;(function(be){function he(J){return J}be.from=he;function ae(J){return J}be.to=ae})(pe=e.InlayHintKind||(e.InlayHintKind={}));var Ce;(function(be){function he(J){return{range:w.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=he;function ae(J){let Ne;if(J.url)try{Ne=typeof J.url=="string"?D.URI.parse(J.url,!0):D.URI.revive(J.url)}catch(Fe){}return new f.DocumentLink(w.to(J.range),Ne)}be.to=ae})(Ce=e.DocumentLink||(e.DocumentLink={}));var Me;(function(be){function he(J){const Ne=new f.ColorPresentation(J.label);return J.textEdit&&(Ne.textEdit=j.to(J.textEdit)),J.additionalTextEdits&&(Ne.additionalTextEdits=J.additionalTextEdits.map(Fe=>j.to(Fe))),Ne}be.to=he;function ae(J){return{label:J.label,textEdit:J.textEdit?j.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ne=>j.from(Ne)):void 0}}be.from=ae})(Me=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(be){function he(J){return new f.Color(J[0],J[1],J[2],J[3])}be.to=he;function ae(J){return[J.red,J.green,J.blue,J.alpha]}be.from=ae})(ze=e.Color||(e.Color={}));var _e;(function(be){function he(J){return{range:w.from(J.range)}}be.from=he;function ae(J){return new f.SelectionRange(w.to(J.range))}be.to=ae})(_e=e.SelectionRange||(e.SelectionRange={}));var Ke;(function(be){function he(ae){switch(ae){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}be.to=he})(Ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var X;(function(be){function he(J){switch(J){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}be.from=he;function ae(J){switch(J){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}be.to=ae})(X=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ne;(function(be){function he(J){if(J===f.EndOfLine.CRLF)return 1;if(J===f.EndOfLine.LF)return 0}be.from=he;function ae(J){if(J===1)return f.EndOfLine.CRLF;if(J===0)return f.EndOfLine.LF}be.to=ae})(ne=e.EndOfLine||(e.EndOfLine={}));var we;(function(be){function he(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=he})(we=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(be){function he(ae){const J={start:ae.start+1,end:ae.end+1};return ae.kind&&(J.kind=je.from(ae.kind)),J}be.from=he})(xe=e.FoldingRange||(e.FoldingRange={}));var je;(function(be){function he(ae){if(ae)switch(ae){case f.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}be.from=he})(je=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ve;(function(be){function he(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?w.from(ae.selection):void 0,override:typeof ae.override=="boolean"?C.EditorOverride.DISABLED:void 0}}be.from=he})(Ve=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(be){function he(J){return J instanceof f.RelativePattern||typeof J=="string"?J:ae(J)?new f.RelativePattern(J.base,J.pattern):J}be.from=he;function ae(J){const Ne=J;return Ne&&typeof Ne.base=="string"&&typeof Ne.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var De;(function(be){function he(ae){if(ae){if(Array.isArray(ae))return ae.map(he);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:typeof J.pattern=="undefined"?void 0:Ze.from(J.pattern),exclusive:J.exclusive}}}else return}be.from=he})(De=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(be){function he(J){return{start:J.start,end:J.end}}be.from=he;function ae(J){return new f.NotebookRange(J.start,J.end)}be.to=ae})(ye=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(be){function he(ae){return new f.NotebookCellMetadata().with(Object.assign(Object.assign({},ae),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}be.to=he})(Pe=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var oe;(function(be){function he(J){return J}be.from=he;function ae(J){return new f.NotebookDocumentMetadata().with(J)}be.to=ae})(oe=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(be){function he(J){return{startTime:J.runStartTime,endTime:J.runEndTime,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=he;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.startTime,runEndTime:J.endTime,executionOrder:J.executionOrder}}be.from=ae})(ue=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var H;(function(be){function he(J){switch(J){case f.NotebookCellKind.Markdown:return m.CellKind.Markdown;case f.NotebookCellKind.Code:default:return m.CellKind.Code}}be.from=he;function ae(J){switch(J){case m.CellKind.Markdown:return f.NotebookCellKind.Markdown;case m.CellKind.Code:default:return f.NotebookCellKind.Code}}be.to=ae})(H=e.NotebookCellKind||(e.NotebookCellKind={}));var Z;(function(be){function he(J){var Ne;return{cellKind:H.from(J.kind),language:J.language,source:J.source,metadata:Object.assign(Object.assign({},J.metadata),ue.from((Ne=J.latestExecutionSummary)!==null&&Ne!==void 0?Ne:{})),outputs:J.outputs?J.outputs.map(Ie.from):[]}}be.from=he;function ae(J){return new f.NotebookCellData(H.to(J.cellKind),J.source,J.language,J.outputs?J.outputs.map(Ie.to):void 0,J.metadata?Pe.to(J.metadata):void 0)}be.to=ae})(Z=e.NotebookCellData||(e.NotebookCellData={}));var ce;(function(be){function he(J){return{mime:J.mime,value:J.value,metadata:J.metadata}}be.from=he;function ae(J){return new f.NotebookCellOutputItem(J.mime,J.value,J.metadata)}be.to=ae})(ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ie;(function(be){function he(J){return{outputId:J.id,outputs:J.outputs.map(ce.from),metadata:J.metadata}}be.from=he;function ae(J){const Ne=J.outputs.map(ce.to);return new f.NotebookCellOutput(Ne,J.outputId,J.metadata)}be.to=ae})(Ie=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ae;(function(be){function he(Fe){if(Fe!=null){if(Fe instanceof f.RelativePattern||typeof Fe=="string")return Fe;if(Ne(Fe))return new f.RelativePattern(Fe.base,Fe.pattern);if(J(Fe))return{include:Ze.from(Fe.include)||void 0,exclude:Ze.from(Fe.exclude)||void 0}}}be.from=he;function ae(Fe){return typeof Fe=="string"?Fe:Ne(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}be.to=ae;function J(Fe){const Ye=Fe,et=Ze.from(Ye.include);if(!(et&&et instanceof f.RelativePattern||typeof et=="string"))return!1;const ut=Ze.from(Ye.exclude);return!!(ut&&ut instanceof f.RelativePattern||typeof ut=="string")}function Ne(Fe){const Ye=Fe;return Ye&&typeof Ye.base=="string"&&typeof Ye.pattern=="string"}})(Ae=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Le;(function(be){function he(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?u.from(ae.top):void 0}}be.from=he})(Le=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var $e;(function(be){function he(ae,J,Ne){const Fe=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Fe,Ne),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}be.from=he})($e=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Xe;(function(be){function he(ae){var J,Ne;return{transientOutputs:(J=ae==null?void 0:ae.transientOutputs)!==null&&J!==void 0?J:!1,transientCellMetadata:Object.assign(Object.assign({},ae==null?void 0:ae.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Ne=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Ne!==void 0?Ne:{}}}be.from=he})(Xe=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(be){function he(J){var Ne;return{uri:J.uri,provides:typeof J.provides=="string"?[J.provides]:(Ne=J.provides)!==null&&Ne!==void 0?Ne:[]}}be.from=he;function ae(J){return new f.NotebookKernelPreload(D.URI.revive(J.uri),J.provides)}be.to=ae})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(be){function he(J){return{message:h.fromStrict(J.message)||"",severity:J.severity,expectedOutput:J.expectedOutput,actualOutput:J.actualOutput,location:J.location?F.from(J.location):void 0}}be.from=he;function ae(J){const Ne=new f.TestMessage(typeof J.message=="string"?J.message:h.to(J.message));return Ne.severity=J.severity,Ne.actualOutput=J.actualOutput,Ne.expectedOutput=J.expectedOutput,Ne}be.to=ae})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(be){function he(Fe){var Ye,et;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:(Ye=Fe.debuggable)!==null&&Ye!==void 0?Ye:!1,description:Fe.description||null,runnable:(et=Fe.runnable)!==null&&et!==void 0?et:!0,error:Fe.error&&h.fromStrict(Fe.error)||null}}be.from=he;function ae(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:w.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}be.fromResultSnapshot=ae;function J(Fe){return{id:Fe.extId,label:Fe.label,uri:D.URI.revive(Fe.uri),range:w.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:f.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}be.toPlain=J;function Ne(Fe){const Ye=new f.TestItemImpl(Fe.extId,Fe.label,D.URI.revive(Fe.uri),void 0);return Ye.range=w.to(Fe.range||void 0),Ye.debuggable=Fe.debuggable,Ye.description=Fe.description||void 0,Ye.runnable=Fe.runnable,Ye}be.to=Ne})(Qe=e.TestItem||(e.TestItem={}));var mt;(function(be){const he=(J,Ne)=>Object.assign(Object.assign({},Qe.toPlain(J.item)),{taskStates:J.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(tt.to)})),children:J.children.map(Fe=>Ne.get(Fe)).filter(k.isDefined).map(Fe=>he(Fe,Ne))});function ae(J){const Ne=[],Fe=new Map;for(const Ye of J.items)Fe.set(Ye.item.extId,Ye),Ye.direct&&Ne.push(Ye);return{completedAt:J.completedAt,results:Ne.map(Ye=>he(Ye,Fe))}}be.to=ae})(mt=e.TestResults||(e.TestResults={}));var wt;(function(be){function he(ae){switch(ae){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}be.to=he})(wt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(me[215],ge([0,1,2,17,7,20,57]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class k{constructor(P,r,C,g={timeout:1500,errors:3}){this._logService=P,this._documents=r,this._mainThreadBulkEdits=C,this._thresholds=g,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(r,C,g)=>{const l={dispose:this._callbacks.push([r,C,P])};return Array.isArray(g)&&g.push(l),l}}async $participateInSave(P,r){const C=b.URI.revive(P);let g=!1;const m=setTimeout(()=>g=!0,this._thresholds.timeout),l=[];try{for(let f of[...this._callbacks]){if(g)break;const E=this._documents.getDocument(C),w=await this._deliverEventAsyncAndBlameBadListeners(f,{document:E,reason:T.TextDocumentSaveReason.to(r)});l.push(w)}}finally{clearTimeout(m)}return l}_deliverEventAsyncAndBlameBadListeners([P,r,C],g){const m=this._badListeners.get(P);return typeof m=="number"&&m>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(C,P,r,g).then(()=>!0,l=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this._logService.error(l),!(l instanceof Error)||l.message!=="concurrent_edits"){const f=this._badListeners.get(P);this._badListeners.set(P,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,r,C,g){const m=[],l=Date.now(),{document:f,reason:E}=g,{version:w}=f,_=Object.freeze({document:f,reason:E,waitUntil(d){if(Object.isFrozen(m))throw(0,I.illegalState)("waitUntil can not be called async");m.push(Promise.resolve(d))}});try{r.apply(C,[_])}catch(d){return Promise.reject(d)}return Object.freeze(m),new Promise((d,o)=>{const c=setTimeout(()=>o(new Error("timeout")),this._thresholds.timeout);return Promise.all(m).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-l}ms`),clearTimeout(c),d(t)}).catch(t=>{clearTimeout(c),o(t)})}).then(d=>{const o={edits:[]};for(const c of d)if(Array.isArray(c)&&c.every(t=>t instanceof A.TextEdit))for(const{newText:t,newEol:n,range:s}of c)o.edits.push({_type:2,resource:f.uri,edit:{range:s&&T.Range.from(s),text:t,eol:n&&T.EndOfLine.from(n)}});if(o.edits.length!==0)return w===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=k}),define(me[216],ge([0,1,3,13,33,2,20,7]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(C,g,m,l,f){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,m&&(this._config+=1),l&&(this._config+=2),f&&(this._config+=4);const E=(0,A.parse)(g),w=C(_=>{if(!m)for(let d of _.created){const o=T.URI.revive(d);E(o.fsPath)&&this._onDidCreate.fire(o)}if(!l)for(let d of _.changed){const o=T.URI.revive(d);E(o.fsPath)&&this._onDidChange.fire(o)}if(!f)for(let d of _.deleted){const o=T.URI.revive(d);E(o.fsPath)&&this._onDidDelete.fire(o)}});this._disposable=k.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,w)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class P{constructor(C,g,m){this._logService=g,this._extHostDocumentsAndEditors=m,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new I.AsyncEmitter,this._onWillCreateFile=new I.AsyncEmitter,this._onWillDeleteFile=new I.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(C,g,m,l){return new D(this._onFileSystemEvent.event,C,g,m,l)}$onFileEvent(C){this._onFileSystemEvent.fire(C)}$onDidRunFileOperation(C,g){switch(C){case 2:this._onDidRenameFile.fire(Object.freeze({files:g.map(m=>({oldUri:T.URI.revive(m.source),newUri:T.URI.revive(m.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:g.map(m=>T.URI.revive(m.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:g.map(m=>T.URI.revive(m.target))}));break;default:}}getOnWillRenameFileEvent(C){return this._createWillExecuteEvent(C,this._onWillRenameFile)}getOnWillCreateFileEvent(C){return this._createWillExecuteEvent(C,this._onWillCreateFile)}getOnWillDeleteFileEvent(C){return this._createWillExecuteEvent(C,this._onWillDeleteFile)}_createWillExecuteEvent(C,g){return(m,l,f)=>{const E=function(_){m.call(l,_)};return E.extension=C,g.event(E,void 0,f)}}async $onWillRunFileOperation(C,g,m,l){switch(C){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:g.map(f=>({oldUri:T.URI.revive(f.source),newUri:T.URI.revive(f.target)}))},m,l);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:g.map(f=>T.URI.revive(f.target))},m,l);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:g.map(f=>T.URI.revive(f.target))},m,l)}}async _fireWillEvent(C,g,m,l){const f=new Set,E=[];if(await C.fireAsync(g,l,async(_,d)=>{var o;const c=Date.now(),t=await Promise.resolve(_);t instanceof k.WorkspaceEdit&&(E.push(t),f.add((o=d.extension.displayName)!==null&&o!==void 0?o:d.extension.identifier.value)),Date.now()-c>m&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),!l.isCancellationRequested&&E.length!==0){const w={edits:[]};for(let _ of E){let{edits:d}=y.WorkspaceEdit.from(_,this._extHostDocumentsAndEditors);w.edits=w.edits.concat(d)}return{edit:w,extensionNames:Array.from(f)}}}}e.ExtHostFileSystemEventService=P}),define(me[217],ge([0,1,12,24,2,20,7,89]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(g,m,l,f){this.start=g,this.deletedCount=m,this.deletedItems=l,this.items=f}static asApiEvents(g){return g.map(m=>({start:m.start,deletedCount:m.deletedCount,deletedItems:m.deletedItems,items:m.items.map(l=>l.apiCell)}))}}class P{constructor(g,m,l){var f;this.notebook=g,this._extHostDocument=m,this._cellData=l,this.handle=l.handle,this.uri=A.URI.revive(l.uri),this.cellKind=l.cellKind,this._outputs=l.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(f=l.metadata)!==null&&f!==void 0?f:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(g,m){return{EOL:m.eol,lines:m.source,modeId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:g}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const g=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return g.notebook.getCellIndex(g)},notebook:g.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get outputs(){return g._outputs.slice(0)},get metadata(){return g._metadata},get latestExecutionSummary(){return g._previousResult}})}return this._apiCell}setOutputs(g){this._outputs=g.map(T.NotebookCellOutput.to)}setOutputItems(g,m,l){const f=l.map(T.NotebookCellOutputItem.to),E=this._outputs.find(w=>w.id===g);E&&(m||(E.outputs.length=0),E.outputs.push(...f))}setMetadata(g){this._internalMetadata=g,this._metadata=T.NotebookCellMetadata.to(g),this._previousResult=T.NotebookCellPreviousExecutionResult.to(g)}}e.ExtHostCell=P;class r{constructor(g,m,l,f,E,w,_){this._proxy=g,this._textDocumentsAndEditors=m,this._textDocuments=l,this._emitter=f,this._viewType=E,this._metadata=w,this.uri=_,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const g=this;this._notebook={get uri(){return g.uri},get version(){return g._versionId},get viewType(){return g._viewType},get isDirty(){return g._isDirty},get isUntitled(){return g.uri.scheme===b.Schemas.untitled},get isClosed(){return g._disposed},get metadata(){return g._metadata},get cellCount(){return g._cells.length},cellAt(m){return m=g._validateIndex(m),g._cells[m].apiCell},getCells(m){return(m?g._getCells(m):g._cells).map(f=>f.apiCell)},save(){return g._save()}}}return this._notebook}updateBackup(g){var m;(m=this._backup)===null||m===void 0||m.delete(),this._backup=g}disposeBackup(){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(g){g.metadata&&(this._metadata=this._metadata.with(g.metadata))}acceptModelChanged(g,m){this._versionId=g.versionId,this._isDirty=m;for(const l of g.rawEvents)l.kind===k.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(l.changes,!0),l.kind===k.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(l.changes,!1):l.kind===k.NotebookCellsChangeType.Move?this._moveCell(l.index,l.newIdx):l.kind===k.NotebookCellsChangeType.Output?this._setCellOutputs(l.index,l.outputs):l.kind===k.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(l.index,l.outputId,l.append,l.outputItems):l.kind===k.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(l.index,l.language):l.kind===k.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(l.index,l.metadata)}_validateIndex(g){return g=g|0,g<0?0:g>=this._cells.length?this._cells.length-1:g}_validateRange(g){let m=g.start|0,l=g.end|0;return m<0&&(m=0),l>this._cells.length&&(l=this._cells.length),g.with({start:m,end:l})}_getCells(g){g=this._validateRange(g);const m=[];for(let l=g.start;l<g.end;l++)m.push(this._cells[l]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(g,m){if(!this._disposed){const l=[],f=[],E=[];g.reverse().forEach(w=>{const d=w[2].map(t=>{const n=new P(this,this._textDocumentsAndEditors,t);return m||f.push(P.asModelAddData(this.apiNotebook,t)),n}),o=new D(w[0],w[1],[],d),c=this._cells.splice(w[0],w[1],...d);for(const t of c)E.push(t.uri),o.deletedItems.push(t.apiCell);l.push(o)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:E}),m||this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(l)}))}}_moveCell(g,m){const l=this._cells.splice(g,1);this._cells.splice(m,0,...l);const f=[new D(g,1,l.map(E=>E.apiCell),[]),new D(m,0,[],l)];this._emitter.emitModelChange((0,I.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(f)}))}_setCellOutputs(g,m){const l=this._cells[g];l.setOutputs(m),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[l.apiCell]}))}_setCellOutputItems(g,m,l,f){const E=this._cells[g];E.setOutputItems(m,l,f),this._emitter.emitCellOutputsChange((0,I.deepFreeze)({document:this.apiNotebook,cells:[E.apiCell]}))}_changeCellLanguage(g,m){const l=this._cells[g];l.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelModeChanged(l.uri,m)}_changeCellMetadata(g,m){var l;const f=this._cells[g],E=f.internalMetadata,w=f.apiCell.metadata;f.setMetadata(m);const _=f.apiCell.metadata;if((0,I.equals)(w,_)||this._emitter.emitCellMetadataChange((0,I.deepFreeze)({document:this.apiNotebook,cell:f.apiCell})),E.runState!==m.runState){const d=(l=m.runState)!==null&&l!==void 0?l:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,I.deepFreeze)({document:this.apiNotebook,cell:f.apiCell,executionState:d}))}}getCellFromApiCell(g){return this._cells.find(m=>m.apiCell===g)}getCellFromIndex(g){return this._cells[g]}getCell(g){return this._cells.find(m=>m.handle===g)}getCellIndex(g){return this._cells.indexOf(g)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(me[218],ge([0,1,7,20]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(k){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=k}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(k){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:k})}replaceCellMetadata(k,D){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:k,metadata:D})}replaceCells(k,D,P){this._throwIfFinalized(),!(k===D&&P.length===0)&&this._collectedEdits.push({editType:1,index:k,count:D-k,cells:P.map(I.NotebookCellData.from)})}}class T{constructor(k,D,P,r,C,g){this.id=k,this._proxy=D,this.notebookData=P,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=C,this._visibleRanges=r,this._viewColumn=g}get apiEditor(){if(!this._editor){const k=this;this._editor={get document(){return k.notebookData.apiNotebook},get selections(){return k._selections},get visibleRanges(){return k._visibleRanges},revealRange(D,P){k._proxy.$tryRevealRange(k.id,I.NotebookRange.from(D),P!=null?P:b.NotebookEditorRevealType.Default)},get viewColumn(){return k._viewColumn},edit(D){const P=new A(this.document.version);return D(P),k._applyEdit(P.finalize())},setDecorations(D,P){return k.setDecorations(D,P)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(k){this._visible=k}_acceptVisibleRanges(k){this._visibleRanges=k}_acceptSelections(k){this._selections=k}_acceptViewColumn(k){this._viewColumn=k}_applyEdit(k){if(k.cellEdits.length===0)return Promise.resolve(!0);const D=[];let P=-1;for(let r=0;r<k.cellEdits.length;r++){if(P<0){D.push(k.cellEdits[r]),P++;continue}const g=D[P],m=k.cellEdits[r];if(g.editType===1&&m.editType===1&&g.index===m.index){g.cells.push(...k.cellEdits[r].cells),g.count+=k.cellEdits[r].count;continue}D.push(k.cellEdits[r]),P++}return this._proxy.$tryApplyEdits(this.id,k.documentVersionId,D)}setDecorations(k,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(k.key)))return D.isEmpty?this._hasDecorationsForKey.delete(k.key):this._hasDecorationsForKey.add(k.key),this._proxy.$trySetDecorations(this.id,I.NotebookRange.from(D),k.key)}}e.ExtHostNotebookEditor=T}),define(me[219],ge([0,1,20,116,163,21,54]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class k{constructor(C){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=C}withProgress(C,g,m){const l=this._handles++,{title:f,location:E,cancellable:w}=g,_={label:(0,A.localize)(0,null,C.displayName||C.name),id:C.identifier.value};return this._proxy.$startProgress(l,{location:b.ProgressLocation.from(E),title:f,source:_,cancellable:w},C),this._withProgress(l,m,!!w)}_withProgress(C,g,m){let l;m&&(l=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(C,l));const f=w=>{this._proxy.$progressEnd(w),this._mapHandleToCancellationSource.delete(w),l&&l.dispose()};let E;try{E=g(new P(this._proxy,C),m&&l?l.token:T.CancellationToken.None)}catch(w){throw f(C),w}return E.then(w=>f(C),w=>f(C)),E}$acceptProgressCanceled(C){const g=this._mapHandleToCancellationSource.get(C);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(C))}}e.ExtHostProgress=k;function D(r,C){return r.message=C.message,typeof C.increment=="number"&&(typeof r.increment=="number"?r.increment+=C.increment:r.increment=C.increment),r}class P extends I.Progress{constructor(C,g){super(m=>this.throttledReport(m));this._proxy=C,this._handle=g}throttledReport(C){this._proxy.$progressReport(this._handle,C)}}qe([(0,y.throttle)(100,(r,C)=>D(r,C),()=>Object.create(null))],P.prototype,"throttledReport",null)}),define(me[125],ge([0,1,52,17,72,20,7]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class k{constructor(g,m){const l=k._Keys.nextId();g.$registerTextEditorDecorationType(l,T.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:l,dispose(){g.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=k,k._Keys=new A.IdGenerator("TextEditorDecorationType");class D{constructor(g,m){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=g,this._documentVersionId=g.version,this._undoStopBefore=m.undoStopBefore,this._undoStopAfter=m.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(g,m){this._throwIfFinalized();let l=null;if(g instanceof y.Position)l=new y.Range(g,g);else if(g instanceof y.Range)l=g;else throw new Error("Unrecognized location");this._pushEdit(l,m,!1)}insert(g,m){this._throwIfFinalized(),this._pushEdit(new y.Range(g,g),m,!0)}delete(g){this._throwIfFinalized();let m=null;if(g instanceof y.Range)m=g;else throw new Error("Unrecognized location");this._pushEdit(m,null,!0)}_pushEdit(g,m,l){const f=this._document.validateRange(g);this._collectedEdits.push({range:f,text:m,forceMoveMarkers:l})}setEndOfLine(g){if(this._throwIfFinalized(),g!==y.EndOfLine.LF&&g!==y.EndOfLine.CRLF)throw(0,I.illegalArgument)("endOfLine");this._setEndOfLine=g}}e.TextEditorEdit=D;class P{constructor(g,m,l,f){this._proxy=g,this._id=m,this._accept(l),this._logService=f;const E=this;this.value={get tabSize(){return E._tabSize},set tabSize(w){E._setTabSize(w)},get insertSpaces(){return E._insertSpaces},set insertSpaces(w){E._setInsertSpaces(w)},get cursorStyle(){return E._cursorStyle},set cursorStyle(w){E._setCursorStyle(w)},get lineNumbers(){return E._lineNumbers},set lineNumbers(w){E._setLineNumbers(w)}}}_accept(g){this._tabSize=g.tabSize,this._insertSpaces=g.insertSpaces,this._cursorStyle=g.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(g.lineNumbers)}_validateTabSize(g){if(g==="auto")return"auto";if(typeof g=="number"){const m=Math.floor(g);return m>0?m:null}if(typeof g=="string"){const m=parseInt(g,10);return isNaN(m)?null:m>0?m:null}return null}_setTabSize(g){const m=this._validateTabSize(g);if(m!==null){if(typeof m=="number"){if(this._tabSize===m)return;this._tabSize=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:m}))}}_validateInsertSpaces(g){return g==="auto"?"auto":g==="false"?!1:Boolean(g)}_setInsertSpaces(g){const m=this._validateInsertSpaces(g);if(typeof m=="boolean"){if(this._insertSpaces===m)return;this._insertSpaces=m}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:m}))}_setCursorStyle(g){this._cursorStyle!==g&&(this._cursorStyle=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:g})))}_setLineNumbers(g){this._lineNumbers!==g&&(this._lineNumbers=g,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(g)})))}assign(g){const m={};let l=!1;if(typeof g.tabSize!="undefined"){const f=this._validateTabSize(g.tabSize);f==="auto"?(l=!0,m.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,l=!0,m.tabSize=f)}if(typeof g.insertSpaces!="undefined"){const f=this._validateInsertSpaces(g.insertSpaces);f==="auto"?(l=!0,m.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,l=!0,m.insertSpaces=f)}typeof g.cursorStyle!="undefined"&&this._cursorStyle!==g.cursorStyle&&(this._cursorStyle=g.cursorStyle,l=!0,m.cursorStyle=g.cursorStyle),typeof g.lineNumbers!="undefined"&&this._lineNumbers!==g.lineNumbers&&(this._lineNumbers=g.lineNumbers,l=!0,m.lineNumbers=T.TextEditorLineNumbersStyle.from(g.lineNumbers)),l&&this._warnOnError(this._proxy.$trySetOptions(this._id,m))}_warnOnError(g){g.catch(m=>this._logService.warn(m))}}e.ExtHostTextEditorOptions=P;class r{constructor(g,m,l,f,E,w,_,d){this.id=g,this._proxy=m,this._logService=l,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=E,this._options=new P(this._proxy,this.id,w,l),this._visibleRanges=_,this._viewColumn=d;const o=this;this.value=Object.freeze({get document(){return f.getValue()},set document(c){throw(0,I.readonly)("document")},get selection(){return o._selections&&o._selections[0]},set selection(c){if(!(c instanceof y.Selection))throw(0,I.illegalArgument)("selection");o._selections=[c],o._trySetSelection()},get selections(){return o._selections},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof y.Selection)))throw(0,I.illegalArgument)("selections");o._selections=c,o._trySetSelection()},get visibleRanges(){return o._visibleRanges},set visibleRanges(c){throw(0,I.readonly)("visibleRanges")},get options(){return o._options.value},set options(c){o._disposed||o._options.assign(c)},get viewColumn(){return o._viewColumn},set viewColumn(c){throw(0,I.readonly)("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new D(f.getValue(),t);return c(n),o._applyEdit(n)},insertSnippet(c,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(o._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=o._selections.map(i=>T.Range.from(i));else if(t instanceof y.Position){const{lineNumber:i,column:a}=T.Position.from(t);s=[{startLineNumber:i,startColumn:a,endLineNumber:i,endColumn:a}]}else if(t instanceof y.Range)s=[T.Range.from(t)];else{s=[];for(const i of t)if(i instanceof y.Range)s.push(T.Range.from(i));else{const{lineNumber:a,column:h}=T.Position.from(i);s.push({startLineNumber:a,startColumn:h,endLineNumber:a,endColumn:h})}}return m.$tryInsertSnippet(g,c.value,s,n)},setDecorations(c,t){const n=t.length===0;n&&!o._hasDecorationsForKey.has(c.key)||(n?o._hasDecorationsForKey.delete(c.key):o._hasDecorationsForKey.add(c.key),o._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return m.$trySetDecorations(g,c.key,T.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,a=t.length;i<a;i++){const h=t[i];s[4*i]=h.start.line+1,s[4*i+1]=h.start.character+1,s[4*i+2]=h.end.line+1,s[4*i+3]=h.end.character+1}return m.$trySetDecorationsFast(g,c.key,s)}}))},revealRange(c,t){o._runOnProxy(()=>m.$tryRevealRange(g,T.Range.from(c),t||y.TextEditorRevealType.Default))},show(c){m.$tryShowEditor(g,T.ViewColumn.from(c))},hide(){m.$tryHideEditor(g)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(g){(0,b.ok)(!this._disposed),this._options._accept(g)}_acceptVisibleRanges(g){(0,b.ok)(!this._disposed),this._visibleRanges=g}_acceptViewColumn(g){(0,b.ok)(!this._disposed),this._viewColumn=g}_acceptSelections(g){(0,b.ok)(!this._disposed),this._selections=g}async _trySetSelection(){const g=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,g)),this.value}_applyEdit(g){const m=g.finalize();if(m.edits.length===0&&!m.setEndOfLine)return Promise.resolve(!0);const l=m.edits.map(E=>E.range);l.sort((E,w)=>E.end.line===w.end.line?E.end.character===w.end.character?E.start.line===w.start.line?E.start.character-w.start.character:E.start.line-w.start.line:E.end.character-w.end.character:E.end.line-w.end.line);for(let E=0,w=l.length-1;E<w;E++){const _=l[E].end;if(l[E+1].start.isBefore(_))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=m.edits.map(E=>({range:T.Range.from(E.range),text:E.text,forceMoveMarkers:E.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,m.documentVersionId,f,{setEndOfLine:typeof m.setEndOfLine=="number"?T.EndOfLine.from(m.setEndOfLine):void 0,undoStopBefore:m.undoStopBefore,undoStopAfter:m.undoStopAfter})}_runOnProxy(g){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,m=>(m instanceof Error&&m.name==="DISPOSED"||this._logService.warn(m),null))}}e.ExtHostTextEditor=r}),define(me[220],ge([0,1,166,25,2,3,6,13,7,11,16,20,21]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function m(E,w){if((0,P.isString)(E))return{label:E};if(E&&typeof E=="object"&&typeof E.label=="string"){let _;return Array.isArray(E.highlights)&&(_=E.highlights.filter(d=>d.length===2&&typeof d[0]=="number"&&typeof d[1]=="number"),_=_.length?_:void 0),{label:E.label,highlights:_}}}class l{constructor(w,_,d){this._proxy=w,this.commands=_,this.logService=d,this.treeViews=new Map;function o(c){return c&&c.$treeViewId&&c.$treeItemHandle}_.registerArgumentProcessor({processArgument:c=>o(c)?this.convertArgument(c):Array.isArray(c)&&c.length>0?c.map(t=>o(t)?this.convertArgument(t):t):c})}registerTreeDataProvider(w,_,d){const o=this.createTreeView(w,{treeDataProvider:_},d);return{dispose:()=>o.dispose()}}createTreeView(w,_,d){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const o=this._proxy.$registerTreeViewDataProvider(w,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,canDragAndDrop:!!_.canDragAndDrop}),c=this.createExtHostTreeView(w,_,d);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(t){c.message=t},get title(){return c.title},set title(t){c.title=t},get description(){return c.description},set description(t){c.description=t},reveal:(t,n)=>c.reveal(t,n),dispose:async()=>{await o,this.treeViews.delete(w),c.dispose()}}}$getChildren(w,_){const d=this.treeViews.get(w);return d?d.getChildren(_):Promise.reject(new Error((0,b.localize)(0,null,w)))}$setParent(w,_,d){const o=this.treeViews.get(w);return o?o.setParent(_,d):Promise.reject(new Error((0,b.localize)(1,null,w)))}async $hasResolve(w){const _=this.treeViews.get(w);if(!_)throw new Error((0,b.localize)(2,null,w));return _.hasResolve}$resolve(w,_,d){const o=this.treeViews.get(w);if(!o)throw new Error((0,b.localize)(3,null,w));return o.resolveTreeItem(_,d)}$setExpanded(w,_,d){const o=this.treeViews.get(w);if(!o)throw new Error((0,b.localize)(4,null,w));o.setExpanded(_,d)}$setSelection(w,_){const d=this.treeViews.get(w);if(!d)throw new Error((0,b.localize)(5,null,w));d.setSelection(_)}$setVisible(w,_){const d=this.treeViews.get(w);if(!d)throw new Error((0,b.localize)(6,null,w));d.setVisible(_)}createExtHostTreeView(w,_,d){const o=new f(w,_,this._proxy,this.commands.converter,this.logService,d);return this.treeViews.set(w,o),o}convertArgument(w){const _=this.treeViews.get(w.$treeViewId);return _?_.getExtensionElement(w.$treeItemHandle):null}}e.ExtHostTreeViews=l;class f extends y.Disposable{constructor(w,_,d,o,c,t){super();if(this.viewId=w,this.proxy=d,this.commands=o,this.logService=c,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new g.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const a of t.contributes.views[i])a.id===w&&(this._title=a.name);this.dataProvider=_.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let n,s;this._register(T.Event.debounce(this._onDidChangeData.event,(i,a)=>(i||(i={message:!1,elements:[]}),a.element!==!1&&(n||(n=new Promise(h=>s=h),this.refreshPromise=this.refreshPromise.then(()=>n)),i.elements.push(a.element)),a.message&&(i.message=!0),i),200,!0)(({message:i,elements:a})=>{a.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const h=s;return n=null,this.refresh(a).then(()=>h())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(w=>this.getExtensionElement(w)).filter(w=>!(0,P.isUndefinedOrNull)(w))}getChildren(w){const _=w?this.getExtensionElement(w):void 0;if(w&&!_)return this.logService.error(`No tree item with id '${w}' found.`),Promise.resolve([]);const d=this.getChildrenNodes(w);return(d?Promise.resolve(d):this.fetchChildrenNodes(_)).then(o=>o.map(c=>c.item))}getExtensionElement(w){return this.elements.get(w)}reveal(w,_){_=_||{select:!0,focus:!1};const d=(0,P.isUndefinedOrNull)(_.select)?!0:_.select,o=(0,P.isUndefinedOrNull)(_.focus)?!1:_.focus,c=(0,P.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):w?this.refreshPromise.then(()=>this.resolveUnknownParentChain(w)).then(t=>this.resolveTreeNode(w,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(s=>s.item)},{select:d,focus:o,expand:c})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:d,focus:o,expand:c})}get message(){return this._message}set message(w){this._message=w,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(w){this._title=w,this.proxy.$setTitle(this.viewId,w,this._description)}get description(){return this._description}set description(w){this._description=w,this.proxy.$setTitle(this.viewId,this._title,w)}setExpanded(w,_){const d=this.getExtensionElement(w);d&&(_?this._onDidExpandElement.fire(Object.freeze({element:d})):this._onDidCollapseElement.fire(Object.freeze({element:d})))}setSelection(w){(0,r.equals)(this._selectedHandles,w)||(this._selectedHandles=w,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(w){w!==this._visible&&(this._visible=w,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(w,_){const d=w.map(c=>this.getExtensionElement(c)).filter(c=>!(0,P.isUndefinedOrNull)(c)),o=this.getExtensionElement(_);return this.dataProvider.setParent&&d&&o?(0,k.asPromise)(()=>this.dataProvider.setParent(d,o)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(w,_){var d;if(!!this.dataProvider.resolveTreeItem){const o=this.elements.get(w);if(o){const c=this.nodes.get(o);if(c){const t=(d=await this.dataProvider.resolveTreeItem(c.extensionItem,o,_))!==null&&d!==void 0?d:c.extensionItem;return c.item.tooltip=this.getTooltip(t.tooltip),c.item.command=this.getCommand(c.disposableStore,t.command),c.item}}}}resolveUnknownParentChain(w){return this.resolveParent(w).then(_=>_?this.resolveUnknownParentChain(_).then(d=>this.resolveTreeNode(_,d[d.length-1]).then(o=>(d.push(o),d))):Promise.resolve([]))}resolveParent(w){const _=this.nodes.get(w);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,k.asPromise)(()=>this.dataProvider.getParent(w))}resolveTreeNode(w,_){const d=this.nodes.get(w);return d?Promise.resolve(d):(0,k.asPromise)(()=>this.dataProvider.getTreeItem(w)).then(o=>this.createHandle(w,o,_,!0)).then(o=>this.getChildren(_?_.item.handle:void 0).then(()=>{const c=this.getExtensionElement(o);if(c){const t=this.nodes.get(c);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${o}`)}))}getChildrenNodes(w){if(w){let _;if(typeof w=="string"){const d=this.getExtensionElement(w);_=d?this.nodes.get(d):void 0}else _=w;return _&&_.children||null}return this.roots}async fetchChildrenNodes(w){this.clearChildren(w);const _=new g.CancellationTokenSource(this._refreshCancellationSource.token);try{const d=w?this.nodes.get(w):void 0,o=await this.dataProvider.getChildren(w);if(_.token.isCancellationRequested)return[];const c=await Promise.all((0,r.coalesce)(o||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,d):null}));return _.token.isCancellationRequested?[]:(0,r.coalesce)(c)}finally{_.dispose()}}refresh(w){if(w.some(d=>!d))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new g.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const d=this.getHandlesToRefresh(w);if(d.length)return this.refreshHandles(d)}return Promise.resolve(void 0)}getHandlesToRefresh(w){const _=new Set,d=w.map(c=>this.nodes.get(c));for(const c of d)if(c&&!_.has(c.item.handle)){let t=c;for(;t&&t.parent&&d.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&_.add(c.item.handle)}const o=[];return _.forEach(c=>{const t=this.elements.get(c);if(t){const n=this.nodes.get(t);n&&(!n.parent||!_.has(n.parent.item.handle))&&o.push(c)}}),o}refreshHandles(w){const _={};return Promise.all(w.map(d=>this.refreshNode(d).then(o=>{o&&(_[d]=o.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(w){const _=this.getExtensionElement(w);if(_){const d=this.nodes.get(_);if(d)return this.clearChildren(_),(0,k.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(o=>{if(o){const c=this.createTreeNode(_,o,d.parent);return this.updateNodeCache(_,c,d,d.parent),d.dispose(),c}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(w,_,d){const o=this.createTreeNode(w,_,d);if(_.id&&this.elements.has(o.item.handle))throw new Error((0,b.localize)(7,null,_.id));return this.addNodeToCache(w,o),this.addNodeToParentCache(o,d),o}getTooltip(w){return D.MarkdownString.isMarkdownString(w)?C.MarkdownString.from(w):w}getCommand(w,_){return _?this.commands.toInternal(_,w):void 0}createTreeNode(w,_,d){const o=new y.DisposableStore,c=this.createHandle(w,_,d),t=this.getLightIconPath(_);return{item:{handle:c,parentHandle:d?d.item.handle:void 0,label:m(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(o,_.command),contextValue:_.contextValue,icon:t,iconDark:this.getDarkIconPath(_)||t,themeIcon:this.getThemeIcon(_),collapsibleState:(0,P.isUndefinedOrNull)(_.collapsibleState)?D.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:d,children:void 0,disposableStore:o,dispose(){o.dispose()}}}getThemeIcon(w){return w.iconPath instanceof D.ThemeIcon?w.iconPath:void 0}createHandle(w,{id:_,label:d,resourceUri:o},c,t){if(_)return`${f.ID_HANDLE_PREFIX}/${_}`;const n=m(d,this.extension),s=c?c.item.handle:f.LABEL_HANDLE_PREFIX;let i=n?n.label:o?(0,I.basename)(o):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const a=this.nodes.has(w)?this.nodes.get(w).item.handle:void 0,h=this.getChildrenNodes(c)||[];let p,S=0;do{if(p=`${s}/${S}:${i}`,t||!this.elements.has(p)||a===p)break;S++}while(S<=h.length);return p}getLightIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon))return typeof w.iconPath=="string"||A.URI.isUri(w.iconPath)?this.getIconPath(w.iconPath):this.getIconPath(w.iconPath.light)}getDarkIconPath(w){if(w.iconPath&&!(w.iconPath instanceof D.ThemeIcon)&&w.iconPath.dark)return this.getIconPath(w.iconPath.dark)}getIconPath(w){return A.URI.isUri(w)?w:A.URI.file(w)}addNodeToCache(w,_){this.elements.set(_.item.handle,w),this.nodes.set(w,_)}updateNodeCache(w,_,d,o){this.elements.delete(_.item.handle),this.nodes.delete(w),_.item.handle!==d.item.handle&&this.elements.delete(d.item.handle),this.addNodeToCache(w,_);const c=this.getChildrenNodes(o)||[],t=c.filter(n=>n.item.handle===d.item.handle)[0];t&&c.splice(c.indexOf(t),1,_)}addNodeToParentCache(w,_){_?(_.children||(_.children=[]),_.children.push(w)):(this.roots||(this.roots=[]),this.roots.push(w))}clearChildren(w){if(w){const _=this.nodes.get(w);if(_){if(_.children)for(const d of _.children){const o=this.elements.get(d.item.handle);o&&this.clear(o)}_.children=void 0}}else this.clearAll()}clear(w){const _=this.nodes.get(w);if(_){if(_.children)for(const d of _.children){const o=this.elements.get(d.item.handle);o&&this.clear(o)}this.nodes.delete(w),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(w=>w.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(me[221],ge([0,1,16,13,21,11,87,20,7,124]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class r{constructor(){this.testIdsToInternal=new Map}getTestById(E,w){if(w!==void 0){const _=this.testIdsToInternal.get(w),d=_==null?void 0:_.get(E);if(d)return[_,d]}return(0,b.mapFind)(this.testIdsToInternal.values(),_=>{const d=_.get(E);return d&&[_,d]})}createForHierarchy(E=()=>{}){return new l(this.createIdMap(g++),E)}createIdMap(E){const w=new m(E);return this.testIdsToInternal.set(w.id,w),{object:w,dispose:()=>this.testIdsToInternal.delete(w.id)}}}e.OwnedTestCollection=r;var C;(function(f){f[f.Disconnected=0]="Disconnected",f[f.IsChild=1]="IsChild",f[f.IsParent=2]="IsParent",f[f.IsSame=3]="IsSame"})(C=e.TestPosition||(e.TestPosition={}));let g=0;class m{constructor(E){this.id=E,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(E){if(this.map.has(E.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${E.item.extId}`);this.map.set(E.item.extId,E),E.parent||this._roots.add(E)}has(E){return this.map.has(E)}delete(E){const w=this.map.get(E);return w?(this.map.delete(E),this._roots.delete(w),!0):!1}get(E){return this.map.get(E)}comparePositions(E,w){const _=typeof E=="string"?this.map.get(E):E,d=typeof w=="string"?this.map.get(w):w;if(!_||!d)return 0;if(_===d)return 3;for(let o=this.map.get(d.parent);o;o=this.map.get(o.parent))if(o===_)return 1;for(let o=this.map.get(_.parent);o;o=this.map.get(o.parent))if(o===d)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=m;class l{constructor(E,w){this.testIdToInternal=E,this.publishDiff=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new I.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(E,w){this.addItem(E,w,null)}getTestByReference(E){return this.testItemToInternal.get(E)}collectDiff(){const E=this.diff;return this.diff=[],E}pushDiff(E){const w=this.diff[this.diff.length-1];if(w&&E[0]===1){if(w[0]===1&&w[1].extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}if(w[0]===0&&w[1].item.extId===E[1].extId){(0,P.applyTestItemUpdate)(w[1],E[1]);return}}this.diff.push(E),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(E,w){var _;const d=this.testIdToInternal.object.get(E);if(!!d){if((d.expandLevels===void 0||w>d.expandLevels)&&(d.expandLevels=w),d.expand===1){const o=this.refreshChildren(d);return o.isSettled?this.expandChildren(d,w-1):o.p.then(()=>this.expandChildren(d,w-1))}else if(d.expand===3)return((_=d.initialExpand)===null||_===void 0?void 0:_.isSettled)===!1?d.initialExpand.p.then(()=>this.expandChildren(d,w-1)):this.expandChildren(d,w-1)}}dispose(){var E;for(const w of this.testItemToInternal.values())(E=w.discoverCts)===null||E===void 0||E.dispose(!0),(0,y.getPrivateApiFor)(w.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(E,w){const _=E==null?void 0:E.actual.id;switch(w[0]){case 2:this.pushDiff([4,_]);break;case 1:this.removeItem(E);break;case 0:this.addItem(w[1],E.src.controller,E);break;case 3:const[d,o,c]=w;switch(o){case"status":this.updateExpandability(E);break;case"range":this.pushDiff([1,{extId:_,item:{range:k.Range.from(c)}}]);break;case"error":this.pushDiff([1,{extId:_,item:{error:k.MarkdownString.fromStrict(c)||null}}]);break;default:this.pushDiff([1,{extId:_,item:{[o]:c!=null?c:null}}]);break}break;default:(0,T.assertNever)(w[0])}}addItem(E,w,_){if(!(E instanceof D.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${E.id} did not`);if(this.testItemToInternal.has(E))throw new Error(`Attempted to add a single TestItem ${E.id} multiple times to the tree`);if(this.testIdToInternal.object.has(E.id))throw new Error(`Attempted to insert a duplicate test item ID ${E.id}`);const d=_?_.item.extId:null,o=E.resolveHandler?1:0,c=_?_.expandLevels:1,t={controller:w,tree:this.testIdToInternal.object.id},n={actual:E,parent:d,item:k.TestItem.from(E),expandLevels:c?c-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(E,n),this.pushDiff([0,{parent:d,src:t,expand:o,item:n.item}]);const s=(0,y.getPrivateApiFor)(E);s.parent=_==null?void 0:_.actual,s.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const i of s.children.values())this.testItemToInternal.has(i)||this.addItem(i,w,n)}updateExpandability(E){var w;let _;E.actual.resolveHandler?E.actual.status===D.TestItemStatus.Pending?_=E.discoverCts?2:1:((w=E.initialExpand)===null||w===void 0||w.complete(),_=3):_=0,_!==E.expand&&(E.expand=_,this.pushDiff([1,{extId:E.actual.id,expand:_}]),_===1&&E.expandLevels!==void 0&&this.refreshChildren(E))}expandChildren(E,w){if(!(w<0)){const _=[...E.actual.children.values()].map(d=>this.expand(d.id,w)).filter(I.isThenable);if(_.length)return Promise.all(_).then(()=>{})}}refreshChildren(E){if(E.discoverCts&&E.discoverCts.dispose(!0),!E.actual.resolveHandler){const w=new I.DeferredPromise;return w.complete(),w}return E.expand=2,E.discoverCts=new A.CancellationTokenSource,this.pushExpandStateUpdate(E),E.initialExpand=new I.DeferredPromise,E.actual.resolveHandler(E.discoverCts.token),E.initialExpand}pushExpandStateUpdate(E){this.pushDiff([1,{extId:E.actual.id,expand:E.expand}])}removeItem(E){var w;this.pushDiff([2,E.actual.id]);const _=[E];for(;_.length;){const d=_.pop();if(!!d){(w=d.discoverCts)===null||w===void 0||w.dispose(!0),this.testIdToInternal.object.delete(d.item.extId),this.testItemToInternal.delete(d.actual);for(const o of d.actual.children.values())_.push(this.testIdToInternal.object.get(o.id))}}}flushDiff(){const E=this.collectDiff();E.length&&this.publishDiff(E)}}e.SingleUseTestCollection=l}),define(me[222],ge([0,1,27,3,8]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=T;class y{constructor(r){this._onDidChange=new I.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let C of r.activationEvents)C==="onUri"&&(C=`onUri:${b.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(C)||this._activationMap.set(C,[]),this._activationMap.get(C).push(r)}}keepOnly(r){const C=new Set;r.forEach(g=>C.add(b.ExtensionIdentifier.toKey(g))),this._extensionDescriptions=this._extensionDescriptions.filter(g=>C.has(b.ExtensionIdentifier.toKey(g.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,C){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const g=y._findLoopingExtensions(this._extensionDescriptions);if(C=C.concat(g.map(m=>m.identifier)),C.length>0){const m=new Set;C.forEach(l=>m.add(b.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>!m.has(b.ExtensionIdentifier.toKey(l.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(g)}static _findLoopingExtensions(r){const C=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(E){this._nodesSet.has(E)||(this._nodesSet.add(E),this._nodesArr.push(E))}addArc(E,w){this.addNode(E),this.addNode(w),this._arcs.has(E)?this._arcs.get(E).push(w):this._arcs.set(E,[w])}getArcs(E){return this._arcs.has(E)?this._arcs.get(E):[]}hasOnlyGoodArcs(E,w){const _=C.getArcs(E);for(let d=0;d<_.length;d++)if(!w.has(_[d]))return!1;return!0}getNodes(){return this._nodesArr}};let g=new Map;for(let E of r){const w=b.ExtensionIdentifier.toKey(E.identifier);if(g.set(w,E),E.extensionDependencies)for(let _ of E.extensionDependencies){const d=b.ExtensionIdentifier.toKey(_);C.addArc(w,d)}}let m=new Set;C.getNodes().filter(E=>C.getArcs(E).length===0).forEach(E=>m.add(E));let l=C.getNodes().filter(E=>!m.has(E)),f;do{f=!1;for(let E=0;E<l.length;E++){const w=l[E];C.hasOnlyGoodArcs(w,m)&&(l.splice(E,1),E--,m.add(w),f=!0)}}while(f);return l.map(E=>g.get(E))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const C=this._activationMap.get(r);return C?C.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const C=this._extensionsMap.get(b.ExtensionIdentifier.toKey(r));return C||void 0}}e.ExtensionDescriptionRegistry=y;var k;(function(P){P[P.Builtin=0]="Builtin",P[P.User=1]="User",P[P.Dev=2]="Dev"})(k||(k={}));function D(P,r){const C=P.isBuiltin?0:P.isUnderDevelopment?2:1,g=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(C!==g)return C-g;const m=A.posix.basename(P.extensionLocation.path),l=A.posix.basename(r.extensionLocation.path);return m<l?-1:m>l?1:0}}),define(me[223],ge([0,1,23]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var I;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(I=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var A;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(A=e.MessageType||(e.MessageType={}));function T(k){const D=b.VSBuffer.alloc(1);switch(k){case 0:D.writeUInt8(1,0);break;case 1:D.writeUInt8(2,0);break;case 2:D.writeUInt8(3,0);break}return D}e.createMessageOfType=T;function y(k,D){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return D===0;case 2:return D===1;case 3:return D===2;default:return!1}}e.isMessageOfType=y}),define(me[41],ge([0,1,3,2,4,27,183]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:I.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class k{constructor(_){this.dependency=_}}e.MissingExtensionDependency=k;var D;(function(w){w[w.LocalProcess=0]="LocalProcess",w[w.LocalWebWorker=1]="LocalWebWorker",w[w.Remote=2]="Remote"})(D=e.ExtensionHostKind||(e.ExtensionHostKind={}));class P{constructor(_,d,o,c){this.codeLoadingTime=_,this.activateCallTime=d,this.activateResolvedTime=o,this.activationReason=c}}e.ActivationTimes=P;class r{constructor(_,d){this.description=_,this.value=d}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var C;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(C=e.ActivationKind||(e.ActivationKind={}));function g(w){w.enableProposedApi||m(w)}e.checkProposedApiEnabled=g;function m(w){throw new Error(`[${w.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.throwProposedApiError=m;function l(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation}}e.toExtension=l;function f(w){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(w.identifier.id),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!1,extensionLocation:w.location},w.manifest),{uuid:w.identifier.uuid})}e.toExtensionDescription=f;class E{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(_){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(_){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(_){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(_){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(_,d){return Promise.resolve()}_onWillActivateExtension(_){}_onDidActivateExtension(_,d,o,c,t){}_onDidActivateExtensionError(_,d){}_onExtensionRuntimeError(_,d){}_onExtensionHostExit(_){}}e.NullExtensionService=E}),define(me[224],ge([0,1,27,41,14]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(l,f,E,w){this.startup=l,this.codeLoadingTime=f,this.activateCallTime=E,this.activateResolvedTime=w}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class k{constructor(l){this._startup=l,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(l,f){return l===-1||f===-1?-1:f-l}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=k;class D{constructor(l,f,E,w,_,d){this.activationFailed=l,this.activationFailedError=f,this.activationTimes=E,this.module=w,this.exports=_,this.subscriptions=d}}e.ActivatedExtension=D;class P extends D{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class r extends D{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class C extends D{constructor(l){super(!0,l,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=C;let g=class{constructor(l,f,E,w,_){this._logService=_,this._registry=l,this._resolvedExtensionsSet=new Set,f.forEach(d=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(d))),this._hostExtensionsMap=new Map,E.forEach(d=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(d),d)),this._host=w,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(l){const f=b.ExtensionIdentifier.toKey(l);return this._activatedExtensions.has(f)}getActivatedExtension(l){const f=b.ExtensionIdentifier.toKey(l),E=this._activatedExtensions.get(f);if(!E)throw new Error("Extension `"+l.value+"` is not known or not activated");return E}activateByEvent(l,f){if(this._alreadyActivatedEvents[l])return T;const E=this._registry.getExtensionDescriptionsForActivationEvent(l);return this._activateExtensions(E.map(w=>({id:w.identifier,reason:{startup:f,extensionId:w.identifier,activationEvent:l}}))).then(()=>{this._alreadyActivatedEvents[l]=!0})}activateById(l,f){const E=this._registry.getExtensionDescription(l);if(!E)throw new Error("Extension `"+l+"` is not known");return this._activateExtensions([{id:E.identifier,reason:f}])}_handleActivateRequest(l,f,E){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(l.id))){f[b.ExtensionIdentifier.toKey(l.id)]=l;return}const w=this._registry.getExtensionDescription(l.id);if(!w){const o=new Error(`Cannot activate unknown extension '${l.id.value}'`);this._host.onExtensionActivationError(l.id,o,new I.MissingExtensionDependency(l.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(l.id),new C(o));return}const _=typeof w.extensionDependencies=="undefined"?[]:w.extensionDependencies;let d=!0;for(let o=0,c=_.length;o<c;o++){const t=_[o];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const h=w.displayName||w.identifier.value,p=this._registry.getExtensionDescription(t),S=p&&p.displayName||t,u=new Error(`Cannot activate the '${h}' extension because its dependency '${S}' failed to activate`);u.detail=n.activationFailedError,this._host.onExtensionActivationError(w.identifier,u,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(u));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){d=!1,f[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:l.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){d=!1,f[b.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:l.reason};continue}const i=w.displayName||w.identifier.value,a=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(w.identifier,a,new I.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(w.identifier),new C(a));return}}}d?f[b.ExtensionIdentifier.toKey(w.identifier)]=l:E.push(l)}_activateExtensions(l){if(l.length===0||(l=l.filter(_=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(_.id))),l.length===0))return Promise.resolve(void 0);const f=Object.create(null),E=[];for(let _=0,d=l.length;_<d;_++)this._handleActivateRequest(l[_],f,E);for(let _=0,d=E.length;_<d;_++){const o=b.ExtensionIdentifier.toKey(E[_].id);f[o]&&delete f[o]}const w=Object.keys(f).map(_=>f[_]);return E.length===0?Promise.all(w.map(_=>this._activateExtension(_.id,_.reason))).then(_=>{}):this._activateExtensions(w).then(_=>this._activateExtensions(E))}_activateExtension(l,f){const E=b.ExtensionIdentifier.toKey(l);if(this._activatedExtensions.has(E))return Promise.resolve(void 0);const w=this._activatingExtensions.get(E);if(w)return w;const _=this._host.actualActivateExtension(l,f).then(void 0,d=>{const o=new Error;return d&&d.name&&(o.name=d.name),d&&d.message?o.message=`Activating extension '${l.value}' failed: ${d.message}.`:o.message=`Activating extension '${l.value}' failed: ${d}.`,d&&d.stack&&(o.stack=d.stack),this._host.onExtensionActivationError(l,o,null),this._logService.error(`Activating extension ${l.value} failed due to an error:`),this._logService.error(d),new C(d)}).then(d=>{this._activatedExtensions.set(E,d),this._activatingExtensions.delete(E)});return this._activatingExtensions.set(E,_),_}};g=qe([He(4,A.ILogService)],g),e.ExtensionsActivator=g}),define(me[225],ge([0,1,14,41,28,12,114]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends b.LogService{constructor(P){if(P.logFile.scheme!==T.Schemas.file)throw new Error("Only file-logging supported");super(new y.SpdLogLogger(I.ExtensionHostLogFileName,P.logFile.fsPath,!0,P.logLevel))}$setLevel(P){this.setLevel(P)}};k=qe([He(0,A.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(me[226],ge([0,1,17]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class I{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,b.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=I}),define(me[126],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(D,P){this.isMain=D,this.sid=P,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const I=[];function A(k){const D=new b(!0,k);return I[D.nid]=D,D}e.createMainContextProxyIdentifier=A;function T(k){const D=new b(!1,k);return I[D.nid]=D,D}e.createExtHostContextProxyIdentifier=T;function y(k){return I[k].sid}e.getStringIdentifierForProxy=y}),define(me[5],ge([0,1,2,126,59]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var k;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(k=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(o){o[o.Markdown=1]="Markdown",o[o.Code=2]="Code"})(P=e.CellKind||(e.CellKind={}));var r;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(r=e.CellOutputKind||(e.CellOutputKind={}));var C;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(C=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var g;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(g=e.CandidatePortSource||(e.CandidatePortSource={}));var m;(function(o){o.name="$ident";function c(n,s){return Object.defineProperty(n,o.name,{value:s,enumerable:!0}),n}o.mixin=c;function t(n){return n[o.name]}o.of=t})(m=e.ObjectIdentifier||(e.ObjectIdentifier={}));class l{static mixin(c){return c._id=l._n++,c}}e.IdObject=l,l._n=0;var f;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.command="m",o.kindModifier="n",o.label2="o"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var E;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(E=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(o){o[o.File=1]="File",o[o.Text=2]="Text",o[o.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function _(o){if(o&&o.edits)for(const c of o.edits)typeof c.resource=="object"?c.resource=b.URI.revive(c.resource):(c.newUri=b.URI.revive(c.newUri),c.oldUri=b.URI.revive(c.oldUri)),c.metadata&&c.metadata.iconPath&&(c.metadata=(0,A.revive)(c.metadata));return o}e.reviveWorkspaceEditDto=_;var d;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,I.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,I.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,I.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,I.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,I.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,I.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,I.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,I.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,I.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,I.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,I.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,I.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,I.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,I.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,I.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,I.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,I.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,I.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,I.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,I.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,I.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,I.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,I.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,I.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,I.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,I.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,I.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,I.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,I.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,I.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,I.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,I.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,I.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,I.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,I.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,I.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,I.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,I.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,I.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,I.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,I.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,I.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,I.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,I.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,I.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,I.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,I.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,I.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,I.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,I.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,I.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,I.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,I.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,I.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,I.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,I.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,I.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,I.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,I.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,I.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,I.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,I.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,I.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,I.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,I.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,I.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,I.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,I.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,I.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,I.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,I.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,I.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,I.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,I.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,I.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,I.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,I.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,I.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,I.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,I.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,I.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,I.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,I.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,I.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,I.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(me[90],ge([0,1,5,3,4]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(k){this._onDidChangePassword=new I.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=k.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(k){this._onDidChangePassword.fire(k)}get(k,D){return this._proxy.$getPassword(k,D)}store(k,D,P){return this._proxy.$setPassword(k,D,P)}delete(k,D){return this._proxy.$deletePassword(k,D)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,A.createDecorator)("IExtHostSecretState")}),define(me[64],ge([0,1,4,14,5,15]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(D,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(A.MainContext.MainThreadTelemetry)}report(D,P,r){const C=this.getUsageKey(D,P);this._reportedUsages.has(C)||(this._reportedUsages.add(C),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:D}))}getUsageKey(D,P){return`${D}-${P.identifier.value}`}};y=qe([He(0,T.IExtHostRpcService),He(1,I.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(k,D,P){}})}),define(me[227],ge([0,1,3,5,7,27]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(I.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(D,P,r,C={}){const g=T.ExtensionIdentifier.toKey(D.identifier),m=this._inFlightRequests.get(g)||[],l=r.sort().join(" ");let f=m.find(E=>E.scopes===l);if(f)return f.result;{const E=this._getSession(D,g,P,r,C);f={scopes:l,result:E},m.push(f),this._inFlightRequests.set(g,m);try{await E}finally{const w=m.findIndex(_=>_.scopes===l);w>-1&&(m.splice(w),this._inFlightRequests.set(g,m))}return E}}async _getSession(D,P,r,C,g={}){await this._proxy.$ensureProvider(r);const m=D.displayName||D.name;return this._proxy.$getSession(r,C,P,m,g)}async removeSession(D,P){const r=this._authenticationProviders.get(D);return r?r.provider.removeSession(P):this._proxy.$removeSession(D,P)}registerAuthenticationProvider(D,P,r,C){var g;if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:P,provider:r,options:C!=null?C:{supportsMultipleAccounts:!1}}),this._providers.find(l=>l.id===D)||this._providers.push({id:D,label:P});const m=r.onDidChangeSessions(l=>{var f,E,w;this._proxy.$sendDidChangeSessions(D,{added:(f=l.added)!==null&&f!==void 0?f:[],changed:(E=l.changed)!==null&&E!==void 0?E:[],removed:(w=l.removed)!==null&&w!==void 0?w:[]})});return this._proxy.$registerAuthenticationProvider(D,P,(g=C==null?void 0:C.supportsMultipleAccounts)!==null&&g!==void 0?g:!1),new A.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(D);const l=this._providers.findIndex(f=>f.id===D);l>-1&&this._providers.splice(l),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,P){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,P){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,P){const r=this._authenticationProviders.get(D);if(r)return Promise.resolve(r.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,P){return this._onDidChangeSessions.fire({provider:{id:D,label:P}}),Promise.resolve()}$onDidChangeAuthenticationProviders(D,P){return D.forEach(r=>{this._providers.some(C=>C.id===r.id)||this._providers.push(r)}),P.forEach(r=>{const C=this._providers.findIndex(g=>g.id===r.id);C>-1&&this._providers.splice(C)}),this._onDidChangeAuthenticationProviders.fire({added:D,removed:P}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(me[228],ge([0,1,5,15,20]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(k,D){this._extHostDocumentsAndEditors=D,this._proxy=k.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(k){const D=A.WorkspaceEdit.from(k,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(D)}};T=qe([He(0,I.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(me[229],ge([0,1,5]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class I{constructor(T){const y=T.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(k){return y.$writeText(k)}})}}e.ExtHostClipboard=I}),define(me[51],ge([0,1,11,7,20,24,5,16,14,59,44,49,2,6,4,15]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new w(this,s=>{const i=this._apiCommands.get(s);return(i==null?void 0:i.result)===d.Void?i:void 0},n),this._argumentProcessors=[{processArgument(s){return(0,P.revive)(s)}},{processArgument(s){return(0,T.cloneAndChange)(s,function(i){if(r.Range.isIRange(i))return A.Range.to(i);if(C.Position.isIPosition(i))return A.Position.to(i);if(r.Range.isIRange(i.range)&&g.URI.isUri(i.uri))return A.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((h,p)=>{if(!h.validate(s[p]))throw new Error(`Invalid argument '${h.name}' when running '${t.id}', received: ${s[p]}`);return h.convert(s[p])}),a=await this.executeCommand(t.internalId,...i);return t.result.convert(a,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new I.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,s,i,a){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:s,thisArg:i,description:a}),t&&this._proxy.$registerCommand(n),new I.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,s){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const i=(0,T.cloneAndChange)(n,function(a){if(a instanceof I.Position)return A.Position.from(a);if(a instanceof I.Range)return A.Range.from(a);if(a instanceof I.Location)return A.location.from(a);if(I.NotebookRange.isNotebookRange(a))return A.NotebookRange.from(a);if(!Array.isArray(a))return a});try{const a=await this._proxy.$executeCommand(t,i,s);return(0,P.revive)(a)}catch(a){if(a instanceof Error&&a.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw a}}}async _executeContributedCommand(t,n){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:a,description:h}=s;if(h)for(let p=0;p<h.args.length;p++)try{(0,b.validateConstraint)(n[p],h.args[p].constraint)}catch(S){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${h.args[p].name}' - ${h.args[p].description}`)}try{return await i.apply(a,n)}catch(p){if(t===this.converter.delegatingCommandId){const S=this.converter.getActualCommand(...n);S&&(t=S.command)}throw this._logService.error(p,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(s=>this._argumentProcessors.reduce((i,a)=>a.processArgument(i),s)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(s=>s[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,s]of this._commands){let{description:i}=s;i&&(t[n]=i)}return Promise.resolve(t)}};E=qe([He(0,f.IExtHostRpcService),He(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,l.createDecorator)("IExtHostCommands");class w{constructor(t,n,s){this._commands=t,this._lookupApiCommand=n,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((a,h)=>a.convert(t.arguments&&t.arguments[h]));else if((0,k.isNonEmptyArray)(t.arguments)){const a=++this._cachIdPool;this._cache.set(a,t),n.add((0,m.toDisposable)(()=>{this._cache.delete(a),this._logService.trace("CommandsConverter#DISPOSE",a)})),s.$ident=a,s.id=this.delegatingCommandId,s.arguments=[a],this._logService.trace("CommandsConverter#CREATE",t.command,a)}return s}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class _{constructor(t,n,s,i){this.name=t,this.description=n,this.validate=s,this.convert=i}optional(){return new _(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new _(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=_,_.Uri=new _("uri","Uri of a text document",c=>g.URI.isUri(c),c=>c),_.Position=new _("position","A position in a text document",c=>I.Position.isPosition(c),A.Position.from),_.Range=new _("range","A range in a text document",c=>I.Range.isRange(c),A.Range.from),_.Selection=new _("selection","A selection in a text document",c=>I.Selection.isSelection(c),A.Selection.from),_.Number=new _("number","",c=>typeof c=="number",c=>c),_.String=new _("string","",c=>typeof c=="string",c=>c),_.CallHierarchyItem=new _("item","A call hierarchy item",c=>c instanceof I.CallHierarchyItem,A.CallHierarchyItem.to);class d{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=d,d.Void=new d("no result",c=>c);class o{constructor(t,n,s,i,a){this.id=t,this.internalId=n,this.description=s,this.args=i,this.result=a}}e.ApiCommand=o}),define(me[230],ge([0,1,6,20,7,80,51,204,16,111]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const r=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(I.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,f)=>{if(!(0,D.isFalsyOrEmpty)(l)){class E extends A.SymbolInformation{static to(_){const d=new E(_.name,I.SymbolKind.to(_.kind),_.containerName||"",new A.Location(f[0],I.Range.to(_.range)));return d.detail=_.detail,d.range=d.location.range,d.selectionRange=I.Range.to(_.selectionRange),d.children=_.children?_.children.map(E.to):[],d}}return l.map(E.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new y.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(I.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",m)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(I.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(I.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(f=>A.Position.isPosition(f)),l=>l.map(I.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(f=>{let E;for(const w of f.reverse())E=new A.SelectionRange(I.Range.to(w),E);return E}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const f=[];if(Array.isArray(l))for(let E of l)f.push(...E[1].map(I.WorkspaceSymbol.to));return f})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(I.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return I.WorkspaceEdit.to(l)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(I.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new A.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const f=(0,P.decodeSemanticTokensDto)(l);if(f.type==="full")return new A.SemanticTokens(f.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new A.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!!l){const f=(0,P.decodeSemanticTokensDto)(l);if(f.type==="full")return new A.SemanticTokens(f.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,f,E)=>{if(!l)return new A.CompletionList([]);const w=l.suggestions.map(_=>I.CompletionItem.to(_,E));return new A.CompletionList(w,l.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return I.SignatureHelp.to(l)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,f,E)=>g(w=>new A.CodeLens(I.Range.to(w.range),w.command&&E.fromInternal(w.command)))(l))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>A.Range.isRange(l),l=>A.Selection.isSelection(l)?I.Selection.from(l):I.Range.from(l)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,f,E)=>g(w=>{if(w._isSynthetic){if(!w.command)throw new Error("Synthetic code actions must have a command");return E.fromInternal(w.command)}else{const _=new A.CodeAction(w.title,w.kind?new A.CodeActionKind(w.kind):void 0);return w.edit&&(_.edit=I.WorkspaceEdit.to(w.edit)),w.command&&(_.command=E.fromInternal(w.command)),_.isPreferred=w.isPreferred,_}})(l))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(f=>new A.ColorInformation(I.Range.to(f.range),I.Color.to(f.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",l=>l instanceof A.Color,I.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:I.Range.from(l.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(I.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(I.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(f=>I.NotebookExclusiveDocumentPattern.to(f))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(I.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[I.ViewColumn.from(l.viewColumn),I.TextEditorOpenOptions.from(l)]).optional()],y.ApiCommandResult.Void)];class C{constructor(f){this._disposables=new b.DisposableStore,this._commands=f}static register(f){return r.forEach(f.registerApiCommand,f),new C(f).registerCommands()}registerCommands(){const f=E=>(...w)=>E(this._commands,...w);this._register(k.RemoveFromRecentlyOpenedAPICommand.ID,f(k.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:E=>typeof E=="string"}]}),this._register(k.OpenIssueReporter.ID,f(k.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:E=>typeof E=="string"||typeof E=="object"&&typeof E.extensionId=="string"}]})}_register(f,E,w){const _=this._commands.registerCommand(!1,f,E,this,w);this._disposables.add(_)}}e.ExtHostApiCommands=C;function g(l){return f=>{if(Array.isArray(f))return f.map(l)}}function m(l){if(!!Array.isArray(l)){const f=[];for(const E of l)T.isLocationLink(E)?f.push(I.DefinitionLink.to(E)):f.push(I.location.to(E));return f}}}),define(me[231],ge([0,1,13,54,3,6,2,80,27,20,7,5]),function(G,e,b,I,A,T,y,k,D,P,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class g{constructor(o,c,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=o.getProxy(C.MainContext.MainThreadComments),c.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const s=this._commentControllers.get(n.handle);return s||n}else if(n&&n.$mid===7){const s=this._commentControllers.get(n.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.commentThreadHandle);return i||n}else if(n&&n.$mid===8){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);return i?{thread:i,text:n.text}:n}else if(n&&n.$mid===9){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let a=n.commentUniqueId,h=i.getCommentByUniqueId(a);return h||n}else if(n&&n.$mid===10){const s=this._commentControllers.get(n.thread.commentControlHandle);if(!s)return n;const i=s.getCommentThread(n.thread.commentThreadHandle);if(!i)return n;let a=n.text,h=n.commentUniqueId,p=i.getCommentByUniqueId(h);return p?(p.body=a,p):n}return n}})}createCommentController(o,c,t){const n=g.handlePool++,s=new l(o,n,this._proxy,c,t);this._commentControllers.set(s.handle,s);const i=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(o.identifier))||[];return i.push(s),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(o.identifier),i),s}$createCommentThreadTemplate(o,c,t){const n=this._commentControllers.get(o);!n||n.$createCommentThreadTemplate(c,t)}async $updateCommentThreadTemplate(o,c,t){const n=this._commentControllers.get(o);!n||n.$updateCommentThreadTemplate(c,t)}$deleteCommentThread(o,c){const t=this._commentControllers.get(o);t&&t.$deleteCommentThread(c)}$provideCommentingRanges(o,c,t){const n=this._commentControllers.get(o);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(y.URI.revive(c));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(s,t)).then(i=>i?i.map(a=>P.Range.from(a)):void 0)}$toggleReaction(o,c,t,n,s){const i=this._commentControllers.get(o);return!i||!i.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const a=i.getCommentThread(c);if(a){const h=a.getCommentByUniqueId(n.uniqueIdInThread);if(i!==void 0&&h&&i.reactionHandler)return i.reactionHandler(h,w(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=g,g.handlePool=0;class m{constructor(o,c,t,n,s,i,a){this._proxy=o,this._commentController=c,this._id=t,this._uri=n,this._range=s,this._comments=i,this.handle=m._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new A.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${c.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,P.Range.from(this._range),a),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const o=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),c={};o("range")&&(c.range=P.Range.from(this._range)),o("label")&&(c.label=this.label),o("contextValue")&&(c.contextValue=this.contextValue),o("comments")&&(c.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),o("collapsibleState")&&(c.collapseState=_(this._collapseState)),o("canReply")&&(c.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,c)}}getCommentByUniqueId(o){for(let c of this._commentsMap){let t=c[0],n=c[1];if(o===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}m._handlePool=0,qe([(0,I.debounce)(100)],m.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=m;class l{constructor(o,c,t,n,s){this._extension=o,this._handle=c,this._proxy=t,this._id=n,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,c,t,n){if(typeof o=="string"){const s=new m(this._proxy,this,o,c,t,n,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new m(this._proxy,this,void 0,o,c,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(o,c){const t=new m(this._proxy,this,void 0,y.URI.revive(o),P.Range.to(c),[],this._extension.identifier);return t.collapsibleState=k.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(o,c){let t=this._threads.get(o);t&&(t.range=P.Range.to(c))}$deleteCommentThread(o){let c=this._threads.get(o);c&&c.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(d,o,c,t){let n=t.get(c);n||(n=++d.commentHandle,t.set(c,n));const s=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:P.MarkdownString.from(c.body),userName:c.author.name,userIconPath:s,label:c.label,commentReactions:c.reactions?c.reactions.map(i=>E(i)):void 0}}function E(d){return{label:d.label,iconPath:d.iconPath?P.pathOrURIToURI(d.iconPath):void 0,count:d.count,hasReacted:d.authorHasReacted}}function w(d){return{label:d.label||"",count:d.count||0,iconPath:d.iconPath?y.URI.revive(d.iconPath):"",authorHasReacted:d.hasReacted||!1}}function _(d){if(d!==void 0)switch(d){case r.CommentThreadCollapsibleState.Expanded:return k.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return k.CommentThreadCollapsibleState.Collapsed}return k.CommentThreadCollapsibleState.Collapsed}}),define(me[127],ge([0,1,2,5,7,4,15,14,16,9,8]),function(G,e,b,I,A,T,y,k,D,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let C=class yn{constructor(m,l){this._logService=l,this._provider=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadDecorations)}registerFileDecorationProvider(m,l){const f=yn._handlePool++;this._provider.set(f,{provider:m,extensionId:l}),this._proxy.$registerDecorationProvider(f,l.value);const E=m.onDidChangeFileDecorations&&m.onDidChangeFileDecorations(w=>{if(!w){this._proxy.$onDidChange(f,null);return}let _=(0,D.asArray)(w);if(_.length<=yn._maxEventSize){this._proxy.$onDidChange(f,_);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",l.value,_.length);const d=_.map(t=>({uri:t,rank:(0,P.count)(t.path,"/")})),o=(0,D.groupBy)(d,(t,n)=>t.rank-n.rank||(0,P.compare)(t.uri.path,n.uri.path));let c=[];e:for(let t of o){let n;for(let s of t){let i=(0,r.dirname)(s.uri.path);if(n!==i&&(n=i,c.push(s.uri)>=yn._maxEventSize))break e}}this._proxy.$onDidChange(f,c)});return new A.Disposable(()=>{E==null||E.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(m,l,f){if(!this._provider.has(m))return Object.create(null);const E=Object.create(null),{provider:w,extensionId:_}=this._provider.get(m);return await Promise.all(l.map(async d=>{try{const{uri:o,id:c}=d,t=await Promise.resolve(w.provideFileDecoration(b.URI.revive(o),f));if(!t)return;try{A.FileDecoration.validate(t),E[c]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${_.value}': ${n}`)}}catch(o){this._logService.error(o)}})),E}};C._handlePool=0,C._maxEventSize=250,C=qe([He(0,y.IExtHostRpcService),He(1,k.ILogService)],C),e.ExtHostDecorations=C,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(me[232],ge([0,1,161,115,2,5,7,20,3,14,22]),function(G,e,b,I,A,T,y,k,D,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class C{constructor(l,f,E,w,_){this._name=l,this._owner=f,this._maxDiagnosticsPerFile=E,this._proxy=w,this._onDidChangeDiagnostics=_,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(l,f){if(!l){this.clear();return}this._checkDisposed();let E=[];if(A.URI.isUri(l)){if(!f){this.delete(l);return}this._data.set(l,f.slice()),E=[l]}else if(Array.isArray(l)){E=[];let _;l=[...l].sort(C._compareIndexedTuplesByUri);for(const d of l){const[o,c]=d;if((!_||o.toString()!==_.toString())&&(_&&this._data.get(_).length===0&&this._data.delete(_),_=o,E.push(o),this._data.set(o,[])),c){const t=this._data.get(o);t&&t.push(...c)}else{const t=this._data.get(o);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(E),!!this._proxy){const w=[];for(let _ of E){let d=[];const o=this._data.get(_);if(o)if(o.length>this._maxDiagnosticsPerFile){d=[];const c=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of o)if(n.severity===c[t]&&d.push(k.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;d.push({severity:I.MarkerSeverity.Info,message:(0,b.localize)(0,null,o.length-this._maxDiagnosticsPerFile),startLineNumber:d[d.length-1].startLineNumber,startColumn:d[d.length-1].startColumn,endLineNumber:d[d.length-1].endLineNumber,endColumn:d[d.length-1].endColumn})}else d=o.map(c=>k.Diagnostic.from(c));w.push([_,d])}this._proxy.$changeMany(this._owner,w)}}delete(l){this._checkDisposed(),this._onDidChangeDiagnostics.fire([l]),this._data.delete(l),this._proxy&&this._proxy.$changeMany(this._owner,[[l,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(l,f){this._checkDisposed();for(let E of this._data.keys())l.apply(f,[E,this.get(E),this])}get(l){this._checkDisposed();const f=this._data.get(l);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(l){return this._checkDisposed(),Array.isArray(this._data.get(l))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(l,f){return l[0].toString()<f[0].toString()?-1:l[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=C;let g=class Kt{constructor(l,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new D.Emitter,this.onDidChangeDiagnostics=D.Event.map(D.Event.debounce(this._onDidChangeDiagnostics.event,Kt._debouncer,50),Kt._mapper),this._proxy=l.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(l,f){return l?l.concat(f):f}static _mapper(l){const f=[],E=new Set;for(const w of l)typeof w=="string"?E.has(w)||(E.add(w),f.push(A.URI.parse(w))):E.has(w.toString())||(E.add(w.toString()),f.push(w));return Object.freeze(f),{uris:f}}createDiagnosticCollection(l,f){const{_collections:E,_proxy:w,_onDidChangeDiagnostics:_,_logService:d}=this,o=new class{$changeMany(n,s){w.$changeMany(n,s),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",l.value,n,s.length===0?"CLEARING":s)}$clear(n){w.$clear(n),d.trace("[DiagnosticCollection] remove all (extension, owner)",l.value,n)}dispose(){w.dispose()}};let c;if(!f)f="_generated_diagnostic_collection_name_#"+Kt._idPool++,c=f;else if(!E.has(f))c=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do c=f+Kt._idPool++;while(E.has(c))}return new class extends C{constructor(){super(f,c,Kt._maxDiagnosticsPerFile,o,_);E.set(c,this)}dispose(){super.dispose(),E.delete(c)}}}getDiagnostics(l){if(l)return this._getDiagnostics(l);{const f=new Map,E=[];for(const w of this._collections.values())w.forEach((_,d)=>{let o=f.get(_.toString());typeof o=="undefined"&&(o=E.length,f.set(_.toString(),o),E.push([_,[]])),E[o][1]=E[o][1].concat(...d)});return E}}_getDiagnostics(l){let f=[];for(let E of this._collections.values())E.has(l)&&(f=f.concat(E.get(l)));return f}$acceptMarkersChange(l){if(!this._mirrorCollection){const f="_generated_mirror",E=new C(f,f,Kt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,E),this._mirrorCollection=E}for(const[f,E]of l)this._mirrorCollection.set(A.URI.revive(f),E.map(k.Diagnostic.to))}};g._idPool=0,g._maxDiagnosticsPerFile=1e3,g=qe([He(1,P.ILogService)],g),e.ExtHostDiagnostics=g}),define(me[233],ge([0,1,2,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class A{constructor(y){this._proxy=y.getProxy(I.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(k=>k?k.map(D=>b.URI.revive(D)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(k=>k?b.URI.revive(k):void 0)}}e.ExtHostDialogs=A}),define(me[234],ge([0,1,17,2,7,5,12,21,9]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(C,g,m){this._documentsAndEditors=g,this._logService=m,this._documentContentProviders=new Map,this._proxy=C.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,g){if(Object.keys(y.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const m=P._handlePool++;this._documentContentProviders.set(m,g),this._proxy.$registerTextContentProvider(m,C);let l;return typeof g.onDidChange=="function"&&(l=g.onDidChange(f=>{if(f.scheme!==C){this._logService.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(m,f).then(E=>{if(!(!E&&typeof E!="string")){const w=this._documentsAndEditors.getDocument(f);if(!!w){const _=(0,D.splitLines)(E);if(!w.equalLines(_))return this._proxy.$onVirtualDocumentChange(f,E)}}},b.onUnexpectedError)})),new A.Disposable(()=>{this._documentContentProviders.delete(m)&&this._proxy.$unregisterTextContentProvider(m),l&&(l.dispose(),l=void 0)})}$provideTextDocumentContent(C,g){const m=this._documentContentProviders.get(C);return m?Promise.resolve(m.provideTextDocumentContent(I.URI.revive(g),k.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(me[235],ge([0,1,3,6,2,5,121,20,11,24]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(g,m){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new I.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=m,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const f of l)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const f of l)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!!g){const m=this._documentsAndEditors.getDocument(g);if(m)return m}}getDocument(g){const m=this.getDocumentData(g);if(!(m==null?void 0:m.document))throw new Error(`Unable to retrieve document from URI '${g}'`);return m.document}ensureDocumentData(g){const m=this._documentsAndEditors.getDocument(g);if(m)return Promise.resolve(m);let l=this._documentLoader.get(g.toString());return l||(l=this._proxy.$tryOpenDocument(g).then(f=>{this._documentLoader.delete(g.toString());const E=A.URI.revive(f);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(E))},f=>(this._documentLoader.delete(g.toString()),Promise.reject(f))),this._documentLoader.set(g.toString(),l)),l}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(m=>A.URI.revive(m))}$acceptModelModeChanged(g,m){const l=A.URI.revive(g),f=this._documentsAndEditors.getDocument(l);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(m),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(g){const m=A.URI.revive(g),l=this._documentsAndEditors.getDocument(m);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(g,m){const l=A.URI.revive(g),f=this._documentsAndEditors.getDocument(l);if(!f)throw new Error("unknown document");f._acceptIsDirty(m),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(g,m,l){const f=A.URI.revive(g),E=this._documentsAndEditors.getDocument(f);if(!E)throw new Error("unknown document");E._acceptIsDirty(l),E.onEvents(m),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:E.document,contentChanges:m.changes.map(w=>({range:k.Range.to(w.range),rangeOffset:w.rangeOffset,rangeLength:w.rangeLength,text:w.text}))}))}setWordDefinitionFor(g,m){(0,y.setWordDefinitionFor)(g,m)}}e.ExtHostDocuments=r}),define(me[39],ge([0,1,52,3,6,2,4,5,121,15,125,20,14,22,12,55,135]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class w{constructor(o){this.value=o,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let _=class{constructor(o,c){this._extHostRpc=o,this._logService=c,this._activeEditorId=null,this._editors=new Map,this._documents=new m.ResourceMap,this._onDidAddDocuments=new I.Emitter,this._onDidRemoveDocuments=new I.Emitter,this._onDidChangeVisibleTextEditors=new I.Emitter,this._onDidChangeActiveTextEditor=new I.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const c=[],t=[],n=[];if(o.removedDocuments)for(const s of o.removedDocuments){const i=T.URI.revive(s),a=this._documents.get(i);(a==null?void 0:a.unref())&&(this._documents.delete(i),c.push(a.value))}if(o.addedDocuments)for(const s of o.addedDocuments){const i=T.URI.revive(s.uri);let a=this._documents.get(i);if(a&&i.scheme!==l.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);a||(a=new w(new D.ExtHostDocumentData(this._extHostRpc.getProxy(k.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,a),t.push(a.value)),a.ref()}if(o.removedEditors)for(const s of o.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&n.push(i)}if(o.addedEditors)for(const s of o.addedEditors){const i=T.URI.revive(s.documentUri);b.ok(this._documents.has(i),`document '${i}' does not exist`),b.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const a=this._documents.get(i).value,h=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(k.MainContext.MainThreadTextEditors),this._logService,new E.Lazy(()=>a.document),s.selections.map(C.Selection.to),s.options,s.visibleRanges.map(p=>C.Range.to(p)),typeof s.editorPosition=="number"?C.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,h)}o.newActiveEditor!==void 0&&(b.ok(o.newActiveEditor===null||this._editors.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this._activeEditorId=o.newActiveEditor),(0,A.dispose)(c),(0,A.dispose)(n),o.removedDocuments&&this._onDidRemoveDocuments.fire(c),o.addedDocuments&&this._onDidAddDocuments.fire(t),(o.removedEditors||o.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),o.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(o){var c;return(c=this._documents.get(o))===null||c===void 0?void 0:c.value}allDocuments(){return f.Iterable.map(this._documents.values(),o=>o.value)}getEditor(o){return this._editors.get(o)}activeEditor(o){if(!!this._activeEditorId){const c=this._editors.get(this._activeEditorId);return o?c:c==null?void 0:c.value}}allEditors(){return[...this._editors.values()]}};_=qe([He(0,P.IExtHostRpcService),He(1,g.ILogService)],_),e.ExtHostDocumentsAndEditors=_,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(me[236],ge([0,1,2,5,6,7,20,142,9,23]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(m){this._stateMachine=void 0,this._schemes.push(m)}delete(m){const l=this._schemes.indexOf(m);l>=0&&(this._schemes.splice(l,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const m=this._schemes.sort(),l=[];let f,E,w=14,_=14;for(const d of m){let o=f?(0,D.commonPrefixLength)(f,d):0;for(o===0?E=1:E=_;o<d.length;o++)o+1===d.length?(w=_,_=9):_+=1,l.push([E,d.toUpperCase().charCodeAt(o),_]),l.push([E,d.toLowerCase().charCodeAt(o),_]),E=_;f=d,_=w}l.push([9,58,10]),l.push([10,47,12]),this._stateMachine=new k.StateMachine(l)}}provideDocumentLinks(m){this._initStateMachine();const l=[],f=k.LinkComputer.computeLinks({getLineContent(E){return m.lineAt(E-1).text},getLineCount(){return m.lineCount}},this._stateMachine);for(const E of f){const w=y.DocumentLink.to(E);w.target&&l.push(w)}return l}}class C{constructor(m,l){this._extHostLanguageFeatures=l,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=m.getProxy(I.MainContext.MainThreadFileSystem)}dispose(){var m;(m=this._linkProviderRegistration)===null||m===void 0||m.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(m,l,f,E={}){if(this._registeredSchemes.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(l),this._registeredSchemes.add(l),this._fsProvider.set(w,f);let _=2;E.isCaseSensitive&&(_+=1024),E.isReadonly&&(_+=2048),typeof f.copy=="function"&&(_+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(_+=4),this._proxy.$registerFileSystemProvider(w,l,_).catch(o=>{console.error(`FAILED to register filesystem provider of ${m.value}-extension for the scheme ${l}`),console.error(o)});const d=f.onDidChangeFile(o=>{const c=[];for(const t of o){let{uri:n,type:s}=t;if(n.scheme===l){let i;switch(s){case T.FileChangeType.Changed:i=0;break;case T.FileChangeType.Created:i=1;break;case T.FileChangeType.Deleted:i=2;break;default:throw new Error("Unknown FileChangeType")}c.push({resource:n,type:i})}}this._proxy.$onFileSystemChange(w,c)});return(0,A.toDisposable)(()=>{d.dispose(),this._linkProvider.delete(l),this._registeredSchemes.delete(l),this._fsProvider.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(m){const{type:l,ctime:f,mtime:E,size:w}=m;return{type:l,ctime:f,mtime:E,size:w}}$stat(m,l){return Promise.resolve(this._getFsProvider(m).stat(b.URI.revive(l))).then(C._asIStat)}$readdir(m,l){return Promise.resolve(this._getFsProvider(m).readDirectory(b.URI.revive(l)))}$readFile(m,l){return Promise.resolve(this._getFsProvider(m).readFile(b.URI.revive(l))).then(f=>P.VSBuffer.wrap(f))}$writeFile(m,l,f,E){return Promise.resolve(this._getFsProvider(m).writeFile(b.URI.revive(l),f.buffer,E))}$delete(m,l,f){return Promise.resolve(this._getFsProvider(m).delete(b.URI.revive(l),f))}$rename(m,l,f,E){return Promise.resolve(this._getFsProvider(m).rename(b.URI.revive(l),b.URI.revive(f),E))}$copy(m,l,f,E){const w=this._getFsProvider(m);if(!w.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(w.copy(b.URI.revive(l),b.URI.revive(f),E))}$mkdir(m,l){return Promise.resolve(this._getFsProvider(m).createDirectory(b.URI.revive(l)))}$watch(m,l,f,E){const w=this._getFsProvider(m).watch(b.URI.revive(f),E);this._watches.set(l,w)}$unwatch(m,l){const f=this._watches.get(l);f&&(f.dispose(),this._watches.delete(l))}$open(m,l,f){const E=this._getFsProvider(m);if(!E.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(E.open(b.URI.revive(l),f))}$close(m,l){const f=this._getFsProvider(m);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(l))}$read(m,l,f,E){const w=this._getFsProvider(m);if(!w.read)throw new Error('FileSystemProvider does not implement "read"');const _=P.VSBuffer.alloc(E);return Promise.resolve(w.read(l,f,_.buffer,0,E)).then(d=>_.slice(0,d))}$write(m,l,f,E){const w=this._getFsProvider(m);if(!w.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(w.write(l,f,E.buffer,0,E.byteLength))}_getFsProvider(m){const l=this._fsProvider.get(m);if(!l){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return l}}e.ExtHostFileSystem=C}),define(me[91],ge([0,1,5,45,7,23,4,15,62]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let P=class Nt{constructor(C,g){const m=C.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(l){return m.$stat(l).catch(Nt._handleError)},readDirectory(l){return m.$readdir(l).catch(Nt._handleError)},createDirectory(l){return m.$mkdir(l).catch(Nt._handleError)},async readFile(l){return m.$readFile(l).then(f=>f.buffer).catch(Nt._handleError)},writeFile(l,f){return m.$writeFile(l,T.VSBuffer.wrap(f)).catch(Nt._handleError)},delete(l,f){return m.$delete(l,Object.assign({recursive:!1,useTrash:!1},f)).catch(Nt._handleError)},rename(l,f,E){return m.$rename(l,f,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},copy(l,f,E){return m.$copy(l,f,Object.assign({overwrite:!1},E)).catch(Nt._handleError)},isWritableFileSystem(l){const f=g.getCapabilities(l);if(typeof f=="number")return!(f&2048)}})}static _handleError(C){if(!(C instanceof Error))throw new A.FileSystemError(String(C));if(C.name==="ENOPRO")throw A.FileSystemError.Unavailable(C.message);switch(C.name){case I.FileSystemProviderErrorCode.FileExists:throw A.FileSystemError.FileExists(C.message);case I.FileSystemProviderErrorCode.FileNotFound:throw A.FileSystemError.FileNotFound(C.message);case I.FileSystemProviderErrorCode.FileNotADirectory:throw A.FileSystemError.FileNotADirectory(C.message);case I.FileSystemProviderErrorCode.FileIsADirectory:throw A.FileSystemError.FileIsADirectory(C.message);case I.FileSystemProviderErrorCode.NoPermissions:throw A.FileSystemError.NoPermissions(C.message);case I.FileSystemProviderErrorCode.Unavailable:throw A.FileSystemError.Unavailable(C.message);default:throw new A.FileSystemError(C.message,C.name)}}};P=qe([He(0,k.IExtHostRpcService),He(1,D.IExtHostFileSystemInfo)],P),e.ExtHostConsumerFileSystem=P,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(me[237],ge([0,1,6,5]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class A{constructor(y){this._handlePool=0,this._proxy=y.getProxy(I.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const k=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(k,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(k)})}}e.ExtHostLabelService=A}),define(me[238],ge([0,1,2,24,20,7,13,5,9,44,16,11,139,6,111,72,86,47,17]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentSymbols(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(ee,Y)).then(se=>{if(!(0,r.isFalsyOrEmpty)(se))return se[0]instanceof T.DocumentSymbol?se.map(A.DocumentSymbol.from):d._asDocumentSymbolTree(se)})}static _asDocumentSymbolTree(z){var Y;z=z.slice(0).sort((fe,Ee)=>{let Be=fe.location.range.start.compareTo(Ee.location.range.start);return Be===0&&(Be=Ee.location.range.end.compareTo(fe.location.range.end)),Be});const ee=[],se=[];for(const fe of z){const Ee={name:fe.name||"!!MISSING: name!!",kind:A.SymbolKind.from(fe.kind),tags:((Y=fe.tags)===null||Y===void 0?void 0:Y.map(A.SymbolTag.from))||[],detail:"",containerName:fe.containerName,range:A.Range.from(fe.location.range),selectionRange:A.Range.from(fe.location.range),children:[]};for(;;){if(se.length===0){se.push(Ee),ee.push(Ee);break}const Be=se[se.length-1];if(P.Range.containsRange(Be.range,Ee.range)&&!P.Range.equalsRange(Be.range,Ee.range)){Be.children&&Be.children.push(Ee),se.push(Ee);break}se.pop()}}return ee}}class o{constructor(z,Y,ee){this._documents=z,this._commands=Y,this._provider=ee,this._cache=new E.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(z,Y){const ee=this._documents.getDocument(z),se=await this._provider.provideCodeLenses(ee,Y);if(!(!se||Y.isCancellationRequested)){const fe=this._cache.add(se),Ee=new m.DisposableStore;this._disposables.set(fe,Ee);const Be={cacheId:fe,lenses:[]};for(let pe=0;pe<se.length;pe++)Be.lenses.push({cacheId:[fe,pe],range:A.Range.from(se[pe].range),command:this._commands.toInternal(se[pe].command,Ee)});return Be}}async resolveCodeLens(z,Y){var ee;const se=z.cacheId&&this._cache.get(...z.cacheId);if(!!se){let fe;if(typeof this._provider.resolveCodeLens!="function"||se.isResolved?fe=se:fe=await this._provider.resolveCodeLens(se,Y),fe||(fe=se),!Y.isCancellationRequested){const Ee=z.cacheId&&this._disposables.get(z.cacheId[0]);if(!!Ee)return z.command=this._commands.toInternal((ee=fe.command)!==null&&ee!==void 0?ee:o._badCmd,Ee),z}}}releaseCodeLenses(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}}o._badCmd={command:"missing",title:"!!MISSING: command!!"};function c(Oe){return Array.isArray(Oe)?Oe.map(A.DefinitionLink.from):Oe?[A.DefinitionLink.from(Oe)]:[]}class t{constructor(z,Y){this._documents=z,this._provider=Y}provideDefinition(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDefinition(se,fe,ee)).then(c)}}class n{constructor(z,Y){this._documents=z,this._provider=Y}provideDeclaration(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDeclaration(se,fe,ee)).then(c)}}class s{constructor(z,Y){this._documents=z,this._provider=Y}provideImplementation(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideImplementation(se,fe,ee)).then(c)}}class i{constructor(z,Y){this._documents=z,this._provider=Y}provideTypeDefinition(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(se,fe,ee)).then(c)}}class a{constructor(z,Y){this._documents=z,this._provider=Y}provideHover(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideHover(se,fe,ee)).then(Ee=>{if(!(!Ee||(0,r.isFalsyOrEmpty)(Ee.contents)))return Ee.range||(Ee.range=se.getWordRangeAtPosition(fe)),Ee.range||(Ee.range=new T.Range(fe,fe)),A.Hover.from(Ee)})}}class h{constructor(z,Y){this._documents=z,this._provider=Y}provideEvaluatableExpression(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(se,fe,ee)).then(Ee=>{if(Ee)return A.EvaluatableExpression.from(Ee)})}}class p{constructor(z,Y){this._documents=z,this._provider=Y}provideInlineValues(z,Y,ee,se){const fe=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlineValues(fe,A.Range.to(Y),A.InlineValueContext.to(ee),se)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(Be=>A.InlineValue.from(Be))})}}class S{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentHighlights(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(se,fe,ee)).then(Ee=>{if(Array.isArray(Ee))return Ee.map(A.DocumentHighlight.from)})}}class u{constructor(z,Y){this._documents=z,this._provider=Y}provideLinkedEditingRanges(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(se,fe,ee)).then(Ee=>{if(Ee&&Array.isArray(Ee.ranges))return{ranges:(0,r.coalesce)(Ee.ranges.map(A.Range.from)),wordPattern:Ee.wordPattern}})}}class v{constructor(z,Y){this._documents=z,this._provider=Y}provideReferences(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideReferences(fe,Ee,ee,se)).then(Be=>{if(Array.isArray(Be))return Be.map(A.location.from)})}}class R{constructor(z,Y,ee,se,fe,Ee,Be){this._documents=z,this._commands=Y,this._diagnostics=ee,this._provider=se,this._logService=fe,this._extension=Ee,this._apiDeprecation=Be,this._cache=new E.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=g.Selection.isISelection(Y)?A.Selection.to(Y):A.Range.to(Y),Be=[];for(const Ce of this._diagnostics.getDiagnostics(z))if(Ee.intersection(Ce.range)&&Be.push(Ce)>R._maxCodeActionsPerFile)break;const pe={diagnostics:Be,only:ee.only?new T.CodeActionKind(ee.only):void 0,triggerKind:A.CodeActionTriggerKind.to(ee.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(fe,Ee,pe,se)).then(Ce=>{var Me;if(!(!(0,r.isNonEmptyArray)(Ce)||se.isCancellationRequested)){const ze=this._cache.add(Ce),_e=new m.DisposableStore;this._disposables.set(ze,_e);const Ke=[];for(let X=0;X<Ce.length;X++){const ne=Ce[X];!ne||(R._isCommand(ne)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:ne.title,command:this._commands.toInternal(ne,_e)})):(pe.only&&(ne.kind?pe.only.contains(ne.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ne.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[ze,X],title:ne.title,command:ne.command&&this._commands.toInternal(ne.command,_e),diagnostics:ne.diagnostics&&ne.diagnostics.map(A.Diagnostic.from),edit:ne.edit&&A.WorkspaceEdit.from(ne.edit),kind:ne.kind&&ne.kind.value,isPreferred:ne.isPreferred,disabled:(Me=ne.disabled)===null||Me===void 0?void 0:Me.reason})))}return{cacheId:ze,actions:Ke}}})}async resolveCodeAction(z,Y){var ee;const[se,fe]=z,Ee=this._cache.get(se,fe);if(!(!Ee||R._isCommand(Ee))&&!!this._provider.resolveCodeAction){const Be=(ee=await this._provider.resolveCodeAction(Ee,Y))!==null&&ee!==void 0?ee:Ee;return(Be==null?void 0:Be.edit)?A.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}static _isCommand(z){return typeof z.command=="string"&&typeof z.title=="string"}}R._maxCodeActionsPerFile=1e3;class N{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentFormattingEdits(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(se,Y,ee)).then(fe=>{if(Array.isArray(fe))return fe.map(A.TextEdit.from)})}}class j{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeFormattingEdits(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=A.Range.to(Y);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(fe,Ee,ee,se)).then(Be=>{if(Array.isArray(Be))return Be.map(A.TextEdit.from)})}}class ie{constructor(z,Y){this._documents=z,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(z,Y,ee,se,fe){const Ee=this._documents.getDocument(z),Be=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(Ee,Be,ee,se,fe)).then(pe=>{if(Array.isArray(pe))return pe.map(A.TextEdit.from)})}}class K{constructor(z,Y){this._provider=z,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(z,Y){const ee=k.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(z,Y)).then(se=>{if((0,r.isNonEmptyArray)(se)){for(const fe of se)if(!!fe){if(!fe.name){this._logService.warn("INVALID SymbolInformation, lacks name",fe);continue}const Ee=k.IdObject.mixin(A.WorkspaceSymbol.from(fe));this._symbolCache.set(Ee._id,fe),ee.symbols.push(Ee)}}}).then(()=>(ee.symbols.length>0&&this._resultCache.set(ee._id,[ee.symbols[0]._id,ee.symbols[ee.symbols.length-1]._id]),ee))}async resolveWorkspaceSymbol(z,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return z;const ee=this._symbolCache.get(z._id);if(ee){const se=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ee,Y));return se&&(0,I.mixin)(z,A.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(z){const Y=this._resultCache.get(z);if(Y){for(let[ee,se]=Y;ee<=se;ee++)this._symbolCache.delete(ee);this._resultCache.delete(z)}}}class B{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}static supportsResolving(z){return typeof z.prepareRename=="function"}provideRenameEdits(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(fe,Ee,ee,se)).then(Be=>{if(!!Be)return A.WorkspaceEdit.from(Be)},Be=>{const pe=B._asMessage(Be);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation(z,Y,ee){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(z),fe=A.Position.to(Y);return(0,y.asPromise)(()=>this._provider.prepareRename(se,fe,ee)).then(Ee=>{let Be,pe;if(T.Range.isRange(Ee)?(Be=Ee,pe=se.getText(Ee)):(0,C.isObject)(Ee)&&(Be=Ee.range,pe=Ee.placeholder),!!Be){if(Be.start.line>fe.line||Be.end.line<fe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:A.Range.from(Be),text:pe}}},Ee=>{const Be=B._asMessage(Ee);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(Ee)})}static _asMessage(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ${constructor(z,Y){this.resultId=z,this.tokens=Y}}class U{constructor(z,Y){this._documents=z,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(z,Y,ee){const se=this._documents.getDocument(z),fe=Y!==0?this._previousResults.get(Y):null;return(0,y.asPromise)(()=>fe&&typeof fe.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(se,fe.resultId,ee):this._provider.provideDocumentSemanticTokens(se,ee)).then(Ee=>(fe&&this._previousResults.delete(Y),Ee?(Ee=U._fixProvidedSemanticTokens(Ee),this._send(U._convertToEdits(fe,Ee),Ee)):null))}async releaseDocumentSemanticColoring(z){this._previousResults.delete(z)}static _fixProvidedSemanticTokens(z){return U._isSemanticTokens(z)?U._isCorrectSemanticTokens(z)?z:new T.SemanticTokens(new Uint32Array(z.data),z.resultId):U._isSemanticTokensEdits(z)?U._isCorrectSemanticTokensEdits(z)?z:new T.SemanticTokensEdits(z.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),z.resultId):z}static _isSemanticTokens(z){return z&&!!z.data}static _isCorrectSemanticTokens(z){return z.data instanceof Uint32Array}static _isSemanticTokensEdits(z){return z&&Array.isArray(z.edits)}static _isCorrectSemanticTokensEdits(z){for(const Y of z.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(z,Y){if(!U._isSemanticTokens(Y)||!z||!z.tokens)return Y;const ee=z.tokens,se=ee.length,fe=Y.data,Ee=fe.length;let Be=0;const pe=Math.min(se,Ee);for(;Be<pe&&ee[Be]===fe[Be];)Be++;if(Be===se&&Be===Ee)return new T.SemanticTokensEdits([],Y.resultId);let Ce=0;const Me=pe-Be;for(;Ce<Me&&ee[se-Ce-1]===fe[Ee-Ce-1];)Ce++;return new T.SemanticTokensEdits([{start:Be,deleteCount:se-Be-Ce,data:fe.subarray(Be,Ee-Ce)}],Y.resultId)}_send(z,Y){if(U._isSemanticTokens(z)){const ee=this._nextResultId++;return this._previousResults.set(ee,new $(z.resultId,z.data)),(0,l.encodeSemanticTokensDto)({id:ee,type:"full",data:z.data})}if(U._isSemanticTokensEdits(z)){const ee=this._nextResultId++;return U._isSemanticTokens(Y)?this._previousResults.set(ee,new $(Y.resultId,Y.data)):this._previousResults.set(ee,new $(z.resultId)),(0,l.encodeSemanticTokensDto)({id:ee,type:"delta",deltas:(z.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class L{constructor(z,Y){this._documents=z,this._provider=Y}provideDocumentRangeSemanticTokens(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(se,A.Range.to(Y),ee)).then(fe=>fe?this._send(fe):null)}_send(z){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:z.data})}}e.DocumentRangeSemanticTokensAdapter=L;class O{constructor(z,Y,ee,se,fe){this._documents=z,this._commands=Y,this._provider=ee,this._apiDeprecation=se,this._extension=fe,this._cache=new E.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}async provideCompletionItems(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=A.Position.to(Y),Be=fe.getWordRangeAtPosition(Ee)||new T.Range(Ee,Ee),pe=Be.with({end:Ee}),Ce=new w.StopWatch(!0),Me=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(fe,Ee,se,A.CompletionContext.to(ee)));if(!!Me&&!se.isCancellationRequested){const ze=Array.isArray(Me)?new T.CompletionList(Me):Me,_e=O.supportsResolving(this._provider)?this._cache.add(ze.items):this._cache.add([]),Ke=new m.DisposableStore;this._disposables.set(_e,Ke);const X=[],ne={x:_e,b:X,a:{replace:A.Range.from(Be),insert:A.Range.from(pe)},c:ze.isIncomplete||void 0,d:Ce.elapsed()};for(let we=0;we<ze.items.length;we++){const xe=ze.items[we],je=this._convertCompletionItem(xe,[_e,we],pe,Be);X.push(je)}return ne}}async resolveCompletionItem(z,Y){if(typeof this._provider.resolveCompletionItem=="function"){const ee=this._cache.get(...z);if(!!ee){const se=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(ee,Y));if(!!se)return this._convertCompletionItem(se,z)}}}releaseCompletionItems(z){var Y;(Y=this._disposables.get(z))===null||Y===void 0||Y.dispose(),this._disposables.delete(z),this._cache.delete(z)}_convertCompletionItem(z,Y,ee,se){var fe;const Ee=this._disposables.get(Y[0]);if(!Ee)throw Error("DisposableStore is missing...");const Be={x:Y,a:(fe=z.label)!==null&&fe!==void 0?fe:"",o:z.label2,b:z.kind!==void 0?A.CompletionItemKind.from(z.kind):void 0,n:z.tags&&z.tags.map(A.CompletionItemTag.from),c:z.detail,d:typeof z.documentation=="undefined"?void 0:A.MarkdownString.fromStrict(z.documentation),e:z.sortText!==z.label?z.sortText:void 0,f:z.filterText!==z.label?z.filterText:void 0,g:z.preselect||void 0,i:z.keepWhitespace?1:0,k:z.commitCharacters,l:z.additionalTextEdits&&z.additionalTextEdits.map(A.TextEdit.from),m:this._commands.toInternal(z.command,Ee)};z.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=z.textEdit.newText):typeof z.insertText=="string"?Be.h=z.insertText:z.insertText instanceof T.SnippetString&&(Be.h=z.insertText.value,Be.i|=4);let pe;return z.textEdit?pe=z.textEdit.range:z.range&&(pe=z.range),T.Range.isRange(pe)?Be.j=A.Range.from(pe):pe&&(!(ee==null?void 0:ee.isEqual(pe.inserting))||!(se==null?void 0:se.isEqual(pe.replacing)))&&(Be.j={insert:A.Range.from(pe.inserting),replace:A.Range.from(pe.replacing)}),Be}}class M{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("SignatureHelp")}provideSignatureHelp(z,Y,ee,se){const fe=this._documents.getDocument(z),Ee=A.Position.to(Y),Be=this.reviveContext(ee);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(fe,Ee,se,Be)).then(pe=>{if(pe){const Ce=this._cache.add([pe]);return Object.assign(Object.assign({},A.SignatureHelp.from(pe)),{id:Ce})}})}reviveContext(z){let Y;if(z.activeSignatureHelp){const ee=A.SignatureHelp.to(z.activeSignatureHelp),se=this._cache.get(z.activeSignatureHelp.id,0);se?(Y=se,Y.activeSignature=ee.activeSignature,Y.activeParameter=ee.activeParameter):Y=ee}return Object.assign(Object.assign({},z),{activeSignatureHelp:Y})}releaseSignatureHelp(z){this._cache.delete(z)}}class F{constructor(z,Y){this._documents=z,this._provider=Y}provideInlayHints(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideInlayHints(se,A.Range.to(Y),ee)).then(fe=>fe?{hints:fe.map(A.InlayHint.from)}:void 0)}}class W{constructor(z,Y){this._documents=z,this._provider=Y,this._cache=new E.Cache("DocumentLink")}provideLinks(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(ee,Y)).then(se=>{if(!(!Array.isArray(se)||se.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.map(A.DocumentLink.from)};{const fe=this._cache.add(se),Ee={links:[],id:fe};for(let Be=0;Be<se.length;Be++){const pe=A.DocumentLink.from(se[Be]);pe.cacheId=[fe,Be],Ee.links.push(pe)}return Ee}}})}resolveLink(z,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ee=this._cache.get(...z);return ee?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(ee,Y)).then(se=>se&&A.DocumentLink.from(se)||void 0):Promise.resolve(void 0)}releaseLinks(z){this._cache.delete(z)}}class q{constructor(z,Y){this._documents=z,this._provider=Y}provideColors(z,Y){const ee=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(ee,Y)).then(se=>Array.isArray(se)?se.map(Ee=>({color:A.Color.from(Ee.color),range:A.Range.from(Ee.range)})):[])}provideColorPresentations(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Range.to(Y.range),Ee=A.Color.to(Y.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(Ee,{document:se,range:fe},ee)).then(Be=>{if(!!Array.isArray(Be))return Be.map(A.ColorPresentation.from)})}}class Q{constructor(z,Y){this._documents=z,this._provider=Y}provideFoldingRanges(z,Y,ee){const se=this._documents.getDocument(z);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(se,Y,ee)).then(fe=>{if(!!Array.isArray(fe))return fe.map(A.FoldingRange.from)})}}class le{constructor(z,Y,ee){this._documents=z,this._provider=Y,this._logService=ee}provideSelectionRanges(z,Y,ee){const se=this._documents.getDocument(z),fe=Y.map(A.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(se,fe,ee)).then(Ee=>{if(!(0,r.isNonEmptyArray)(Ee))return[];if(Ee.length!==fe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let pe=0;pe<fe.length;pe++){const Ce=[];Be.push(Ce);let Me=fe[pe],ze=Ee[pe];for(;;){if(!ze.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(A.SelectionRange.from(ze)),!ze.parent)break;Me=ze.range,ze=ze.parent}}return Be})}}class ve{constructor(z,Y){this._documents=z,this._provider=Y,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(z,Y,ee){const se=this._documents.getDocument(z),fe=A.Position.to(Y),Ee=await this._provider.prepareCallHierarchy(se,fe,ee);if(!!Ee){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(Ee)?Ee.map(pe=>this._cacheAndConvertItem(Be,pe)):[this._cacheAndConvertItem(Be,Ee)]}}async provideCallsTo(z,Y,ee){const se=this._itemFromCache(z,Y);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyIncomingCalls(se,ee);if(!!fe)return fe.map(Ee=>({from:this._cacheAndConvertItem(z,Ee.from),fromRanges:Ee.fromRanges.map(Be=>A.Range.from(Be))}))}async provideCallsFrom(z,Y,ee){const se=this._itemFromCache(z,Y);if(!se)throw new Error("missing call hierarchy item");const fe=await this._provider.provideCallHierarchyOutgoingCalls(se,ee);if(!!fe)return fe.map(Ee=>({to:this._cacheAndConvertItem(z,Ee.to),fromRanges:Ee.fromRanges.map(Be=>A.Range.from(Be))}))}releaseSession(z){this._cache.delete(z)}_cacheAndConvertItem(z,Y){var ee;const se=this._cache.get(z),fe={_sessionId:z,_itemId:se.size.toString(36),name:Y.name,detail:Y.detail,kind:A.SymbolKind.from(Y.kind),uri:Y.uri,range:A.Range.from(Y.range),selectionRange:A.Range.from(Y.selectionRange),tags:(ee=Y.tags)===null||ee===void 0?void 0:ee.map(A.SymbolTag.from)};return se.set(fe._itemId,Y),fe}_itemFromCache(z,Y){const ee=this._cache.get(z);return ee==null?void 0:ee.get(Y)}}class Re{constructor(z,Y){this.adapter=z,this.extension=Y}}class Se{constructor(z,Y,ee,se,fe,Ee,Be){this._adapter=new Map,this._uriTransformer=Y,this._proxy=z.getProxy(k.MainContext.MainThreadLanguageFeatures),this._documents=ee,this._commands=se,this._diagnostics=fe,this._logService=Ee,this._apiDeprecation=Be}_transformDocumentSelector(z){return(0,r.coalesce)((0,r.asArray)(z).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(z){if(typeof z=="string")return{$serialized:!0,language:z};if(z)return{$serialized:!0,language:z.language,scheme:this._transformScheme(z.scheme),pattern:typeof z.pattern=="undefined"?void 0:A.GlobPattern.from(z.pattern),exclusive:z.exclusive}}_transformScheme(z){return this._uriTransformer&&typeof z=="string"?this._uriTransformer.transformOutgoingScheme(z):z}_createDisposable(z){return new T.Disposable(()=>{this._adapter.delete(z),this._proxy.$unregister(z)})}_nextHandle(){return Se._handlePool++}_withAdapter(z,Y,ee,se,fe=!1){const Ee=this._adapter.get(z);if(!Ee)return Promise.resolve(se);if(Ee.adapter instanceof Y){let Be;Ee.extension&&(Be=Date.now(),this._logService.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${Y.name}'`));const pe=ee(Ee.adapter,Ee.extension),Ce=Ee.extension;return Ce&&Promise.resolve(pe).then(()=>this._logService.trace(`[${Ce.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Me=>{fe&&Me instanceof _.CancellationError||(this._logService.error(`[${Ce.identifier.value}] provider FAILED`),this._logService.error(Me))}),pe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(z,Y){const ee=this._nextHandle();return this._adapter.set(ee,new Re(z,Y)),ee}static _extLabel(z){return z.displayName||z.name}registerDocumentSymbolProvider(z,Y,ee,se){const fe=this._addNewAdapter(new d(this._documents,ee),z),Ee=se&&se.label||Se._extLabel(z);return this._proxy.$registerDocumentSymbolProvider(fe,this._transformDocumentSelector(Y),Ee),this._createDisposable(fe)}$provideDocumentSymbols(z,Y,ee){return this._withAdapter(z,d,se=>se.provideDocumentSymbols(b.URI.revive(Y),ee),void 0)}registerCodeLensProvider(z,Y,ee){const se=this._nextHandle(),fe=typeof ee.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new o(this._documents,this._commands.converter,ee),z)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(Y),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=ee.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(fe));Ee=T.Disposable.from(Ee,Be)}return Ee}$provideCodeLenses(z,Y,ee){return this._withAdapter(z,o,se=>se.provideCodeLenses(b.URI.revive(Y),ee),void 0)}$resolveCodeLens(z,Y,ee){return this._withAdapter(z,o,se=>se.resolveCodeLens(Y,ee),void 0)}$releaseCodeLenses(z,Y){this._withAdapter(z,o,ee=>Promise.resolve(ee.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(z,Y,ee){const se=this._addNewAdapter(new t(this._documents,ee),z);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDefinition(z,Y,ee,se){return this._withAdapter(z,t,fe=>fe.provideDefinition(b.URI.revive(Y),ee,se),[])}registerDeclarationProvider(z,Y,ee){const se=this._addNewAdapter(new n(this._documents,ee),z);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDeclaration(z,Y,ee,se){return this._withAdapter(z,n,fe=>fe.provideDeclaration(b.URI.revive(Y),ee,se),[])}registerImplementationProvider(z,Y,ee){const se=this._addNewAdapter(new s(this._documents,ee),z);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideImplementation(z,Y,ee,se){return this._withAdapter(z,s,fe=>fe.provideImplementation(b.URI.revive(Y),ee,se),[])}registerTypeDefinitionProvider(z,Y,ee){const se=this._addNewAdapter(new i(this._documents,ee),z);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideTypeDefinition(z,Y,ee,se){return this._withAdapter(z,i,fe=>fe.provideTypeDefinition(b.URI.revive(Y),ee,se),[])}registerHoverProvider(z,Y,ee,se){const fe=this._addNewAdapter(new a(this._documents,ee),z);return this._proxy.$registerHoverProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideHover(z,Y,ee,se){return this._withAdapter(z,a,fe=>fe.provideHover(b.URI.revive(Y),ee,se),void 0)}registerEvaluatableExpressionProvider(z,Y,ee,se){const fe=this._addNewAdapter(new h(this._documents,ee),z);return this._proxy.$registerEvaluatableExpressionProvider(fe,this._transformDocumentSelector(Y)),this._createDisposable(fe)}$provideEvaluatableExpression(z,Y,ee,se){return this._withAdapter(z,h,fe=>fe.provideEvaluatableExpression(b.URI.revive(Y),ee,se),void 0)}registerInlineValuesProvider(z,Y,ee,se){const fe=typeof ee.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Ee=this._addNewAdapter(new p(this._documents,ee),z);this._proxy.$registerInlineValuesProvider(Ee,this._transformDocumentSelector(Y),fe);let Be=this._createDisposable(Ee);if(fe!==void 0){const pe=ee.onDidChangeInlineValues(Ce=>this._proxy.$emitInlineValuesEvent(fe));Be=T.Disposable.from(Be,pe)}return Be}$provideInlineValues(z,Y,ee,se,fe){return this._withAdapter(z,p,Ee=>Ee.provideInlineValues(b.URI.revive(Y),ee,se,fe),void 0)}registerDocumentHighlightProvider(z,Y,ee){const se=this._addNewAdapter(new S(this._documents,ee),z);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDocumentHighlights(z,Y,ee,se){return this._withAdapter(z,S,fe=>fe.provideDocumentHighlights(b.URI.revive(Y),ee,se),void 0)}registerLinkedEditingRangeProvider(z,Y,ee){const se=this._addNewAdapter(new u(this._documents,ee),z);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideLinkedEditingRanges(z,Y,ee,se){return this._withAdapter(z,u,async fe=>{const Ee=await fe.provideLinkedEditingRanges(b.URI.revive(Y),ee,se);if(Ee)return{ranges:Ee.ranges,wordPattern:Ee.wordPattern?Se._serializeRegExp(Ee.wordPattern):void 0}},void 0)}registerReferenceProvider(z,Y,ee){const se=this._addNewAdapter(new v(this._documents,ee),z);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideReferences(z,Y,ee,se,fe){return this._withAdapter(z,v,Ee=>Ee.provideReferences(b.URI.revive(Y),ee,se,fe),void 0)}registerCodeActionProvider(z,Y,ee,se){var fe,Ee;const Be=new m.DisposableStore,pe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,ee,this._logService,z,this._apiDeprecation),z);return this._proxy.$registerQuickFixSupport(pe,this._transformDocumentSelector(Y),{providedKinds:(fe=se==null?void 0:se.providedCodeActionKinds)===null||fe===void 0?void 0:fe.map(Ce=>Ce.value),documentation:(Ee=se==null?void 0:se.documentation)===null||Ee===void 0?void 0:Ee.map(Ce=>({kind:Ce.kind.value,command:this._commands.converter.toInternal(Ce.command,Be)}))},Se._extLabel(z),Boolean(ee.resolveCodeAction)),Be.add(this._createDisposable(pe)),Be}$provideCodeActions(z,Y,ee,se,fe){return this._withAdapter(z,R,Ee=>Ee.provideCodeActions(b.URI.revive(Y),ee,se,fe),void 0)}$resolveCodeAction(z,Y,ee){return this._withAdapter(z,R,se=>se.resolveCodeAction(Y,ee),void 0)}$releaseCodeActions(z,Y){this._withAdapter(z,R,ee=>Promise.resolve(ee.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(z,Y,ee){const se=this._addNewAdapter(new N(this._documents,ee),z);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentFormattingEdits(z,Y,ee,se){return this._withAdapter(z,N,fe=>fe.provideDocumentFormattingEdits(b.URI.revive(Y),ee,se),void 0)}registerDocumentRangeFormattingEditProvider(z,Y,ee){const se=this._addNewAdapter(new j(this._documents,ee),z);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(Y),z.identifier,z.displayName||z.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(z,Y,ee,se,fe){return this._withAdapter(z,j,Ee=>Ee.provideDocumentRangeFormattingEdits(b.URI.revive(Y),ee,se,fe),void 0)}registerOnTypeFormattingEditProvider(z,Y,ee,se){const fe=this._addNewAdapter(new ie(this._documents,ee),z);return this._proxy.$registerOnTypeFormattingSupport(fe,this._transformDocumentSelector(Y),se,z.identifier),this._createDisposable(fe)}$provideOnTypeFormattingEdits(z,Y,ee,se,fe,Ee){return this._withAdapter(z,ie,Be=>Be.provideOnTypeFormattingEdits(b.URI.revive(Y),ee,se,fe,Ee),void 0)}registerWorkspaceSymbolProvider(z,Y){const ee=this._addNewAdapter(new K(Y,this._logService),z);return this._proxy.$registerNavigateTypeSupport(ee),this._createDisposable(ee)}$provideWorkspaceSymbols(z,Y,ee){return this._withAdapter(z,K,se=>se.provideWorkspaceSymbols(Y,ee),{symbols:[]})}$resolveWorkspaceSymbol(z,Y,ee){return this._withAdapter(z,K,se=>se.resolveWorkspaceSymbol(Y,ee),void 0)}$releaseWorkspaceSymbols(z,Y){this._withAdapter(z,K,ee=>ee.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(z,Y,ee){const se=this._addNewAdapter(new B(this._documents,ee,this._logService),z);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(Y),B.supportsResolving(ee)),this._createDisposable(se)}$provideRenameEdits(z,Y,ee,se,fe){return this._withAdapter(z,B,Ee=>Ee.provideRenameEdits(b.URI.revive(Y),ee,se,fe),void 0)}$resolveRenameLocation(z,Y,ee,se){return this._withAdapter(z,B,fe=>fe.resolveRenameLocation(b.URI.revive(Y),ee,se),void 0)}registerDocumentSemanticTokensProvider(z,Y,ee,se){const fe=this._nextHandle(),Ee=typeof ee.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(fe,new Re(new U(this._documents,ee),z)),this._proxy.$registerDocumentSemanticTokensProvider(fe,this._transformDocumentSelector(Y),se,Ee);let Be=this._createDisposable(fe);if(Ee){const pe=ee.onDidChangeSemanticTokens(Ce=>this._proxy.$emitDocumentSemanticTokensEvent(Ee));Be=T.Disposable.from(Be,pe)}return Be}$provideDocumentSemanticTokens(z,Y,ee,se){return this._withAdapter(z,U,fe=>fe.provideDocumentSemanticTokens(b.URI.revive(Y),ee,se),null,!0)}$releaseDocumentSemanticTokens(z,Y){this._withAdapter(z,U,ee=>ee.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(z,Y,ee,se){const fe=this._addNewAdapter(new L(this._documents,ee),z);return this._proxy.$registerDocumentRangeSemanticTokensProvider(fe,this._transformDocumentSelector(Y),se),this._createDisposable(fe)}$provideDocumentRangeSemanticTokens(z,Y,ee,se){return this._withAdapter(z,L,fe=>fe.provideDocumentRangeSemanticTokens(b.URI.revive(Y),ee,se),null,!0)}registerCompletionItemProvider(z,Y,ee,se){const fe=this._addNewAdapter(new O(this._documents,this._commands.converter,ee,this._apiDeprecation,z),z);return this._proxy.$registerSuggestSupport(fe,this._transformDocumentSelector(Y),se,O.supportsResolving(ee),`${z.identifier.value}(${se.join("")})`),this._createDisposable(fe)}$provideCompletionItems(z,Y,ee,se,fe){return this._withAdapter(z,O,Ee=>Ee.provideCompletionItems(b.URI.revive(Y),ee,se,fe),void 0)}$resolveCompletionItem(z,Y,ee){return this._withAdapter(z,O,se=>se.resolveCompletionItem(Y,ee),void 0)}$releaseCompletionItems(z,Y){this._withAdapter(z,O,ee=>ee.releaseCompletionItems(Y),void 0)}registerSignatureHelpProvider(z,Y,ee,se){const fe=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,Ee=this._addNewAdapter(new M(this._documents,ee),z);return this._proxy.$registerSignatureHelpProvider(Ee,this._transformDocumentSelector(Y),fe),this._createDisposable(Ee)}$provideSignatureHelp(z,Y,ee,se,fe){return this._withAdapter(z,M,Ee=>Ee.provideSignatureHelp(b.URI.revive(Y),ee,se,fe),void 0)}$releaseSignatureHelp(z,Y){this._withAdapter(z,M,ee=>ee.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(z,Y,ee){const se=typeof ee.onDidChangeInlayHints=="function"?this._nextHandle():void 0,fe=this._addNewAdapter(new F(this._documents,ee),z);this._proxy.$registerInlayHintsProvider(fe,this._transformDocumentSelector(Y),se);let Ee=this._createDisposable(fe);if(se!==void 0){const Be=ee.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(se));Ee=T.Disposable.from(Ee,Be)}return Ee}$provideInlayHints(z,Y,ee,se){return this._withAdapter(z,F,fe=>fe.provideInlayHints(b.URI.revive(Y),ee,se),void 0)}registerDocumentLinkProvider(z,Y,ee){const se=this._addNewAdapter(new W(this._documents,ee),z);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(Y),typeof ee.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(z,Y,ee){return this._withAdapter(z,W,se=>se.provideLinks(b.URI.revive(Y),ee),void 0)}$resolveDocumentLink(z,Y,ee){return this._withAdapter(z,W,se=>se.resolveLink(Y,ee),void 0)}$releaseDocumentLinks(z,Y){this._withAdapter(z,W,ee=>ee.releaseLinks(Y),void 0)}registerColorProvider(z,Y,ee){const se=this._addNewAdapter(new q(this._documents,ee),z);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideDocumentColors(z,Y,ee){return this._withAdapter(z,q,se=>se.provideColors(b.URI.revive(Y),ee),[])}$provideColorPresentations(z,Y,ee,se){return this._withAdapter(z,q,fe=>fe.provideColorPresentations(b.URI.revive(Y),ee,se),void 0)}registerFoldingRangeProvider(z,Y,ee){const se=this._nextHandle(),fe=typeof ee.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Re(new Q(this._documents,ee),z)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(Y),fe);let Ee=this._createDisposable(se);if(fe!==void 0){const Be=ee.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(fe));Ee=T.Disposable.from(Ee,Be)}return Ee}$provideFoldingRanges(z,Y,ee,se){return this._withAdapter(z,Q,fe=>fe.provideFoldingRanges(b.URI.revive(Y),ee,se),void 0)}registerSelectionRangeProvider(z,Y,ee){const se=this._addNewAdapter(new le(this._documents,ee,this._logService),z);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$provideSelectionRanges(z,Y,ee,se){return this._withAdapter(z,le,fe=>fe.provideSelectionRanges(b.URI.revive(Y),ee,se),[])}registerCallHierarchyProvider(z,Y,ee){const se=this._addNewAdapter(new ve(this._documents,ee),z);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(Y)),this._createDisposable(se)}$prepareCallHierarchy(z,Y,ee,se){return this._withAdapter(z,ve,fe=>Promise.resolve(fe.prepareSession(b.URI.revive(Y),ee,se)),void 0)}$provideCallHierarchyIncomingCalls(z,Y,ee,se){return this._withAdapter(z,ve,fe=>fe.provideCallsTo(Y,ee,se),void 0)}$provideCallHierarchyOutgoingCalls(z,Y,ee,se){return this._withAdapter(z,ve,fe=>fe.provideCallsFrom(Y,ee,se),void 0)}$releaseCallHierarchy(z,Y){this._withAdapter(z,ve,ee=>Promise.resolve(ee.releaseSession(Y)),void 0)}static _serializeRegExp(z){return{pattern:z.source,flags:(0,D.regExpFlags)(z)}}static _serializeIndentationRule(z){return{decreaseIndentPattern:Se._serializeRegExp(z.decreaseIndentPattern),increaseIndentPattern:Se._serializeRegExp(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Se._serializeRegExp(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Se._serializeRegExp(z.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(z){return{beforeText:Se._serializeRegExp(z.beforeText),afterText:z.afterText?Se._serializeRegExp(z.afterText):void 0,previousLineText:z.previousLineText?Se._serializeRegExp(z.previousLineText):void 0,action:z.action}}static _serializeOnEnterRules(z){return z.map(Se._serializeOnEnterRule)}setLanguageConfiguration(z,Y,ee){let{wordPattern:se}=ee;if(se&&(0,D.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(Y,se):this._documents.setWordDefinitionFor(Y,void 0),ee.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),ee.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const fe=this._nextHandle(),Ee={comments:ee.comments,brackets:ee.brackets,wordPattern:ee.wordPattern?Se._serializeRegExp(ee.wordPattern):void 0,indentationRules:ee.indentationRules?Se._serializeIndentationRule(ee.indentationRules):void 0,onEnterRules:ee.onEnterRules?Se._serializeOnEnterRules(ee.onEnterRules):void 0,__electricCharacterSupport:ee.__electricCharacterSupport,__characterPairSupport:ee.__characterPairSupport};return this._proxy.$setLanguageConfiguration(fe,Y,Ee),this._createDisposable(fe)}$setWordDefinitions(z){for(const Y of z)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Se,Se._handlePool=0}),define(me[239],ge([0,1,5,20,7]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(k,D){this._proxy=k.getProxy(b.MainContext.MainThreadLanguages),this._documents=D}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,D){await this._proxy.$changeLanguage(k,D);const P=this._documents.getDocumentData(k);if(!P)throw new Error(`document '${k.toString}' NOT found`);return P.document}async tokenAtPosition(k,D){var P;const r=k.version,C=I.Position.from(D),g=await this._proxy.$tokensAtPosition(k.uri,C),m={type:A.StandardTokenType.Other,range:(P=k.getWordRangeAtPosition(D))!==null&&P!==void 0?P:new A.Range(D.line,D.character,D.line,D.character)};if(!g)return m;const l={range:I.Range.to(g.range),type:I.TokenType.to(g.type)};return!l.range.contains(D)||r!==k.version?m:l}}e.ExtHostLanguages=T}),define(me[240],ge([0,1,5,14,41]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(k){return k&&k.title}let y=class{constructor(D,P){this._logService=P,this._proxy=D.getProxy(b.MainContext.MainThreadMessageService)}showMessage(D,P,r,C,g){const m={extension:D};let l;typeof C=="string"||T(C)?l=[C,...g]:(m.modal=C&&C.modal,m.useCustom=C&&C.useCustom,l=g),m.useCustom&&(0,A.checkProposedApiEnabled)(D);const f=[];for(let E=0;E<l.length;E++){const w=l[E];if(typeof w=="string")f.push({title:w,handle:E,isCloseAffordance:!1});else if(typeof w=="object"){let{title:_,isCloseAffordance:d}=w;f.push({title:_,isCloseAffordance:!!d,handle:E})}else this._logService.warn("Invalid message item:",w)}return this._proxy.$showMessage(P,r,m,f).then(E=>{if(typeof E=="number")return l[E]})}};y=qe([He(1,I.ILogService)],y),e.ExtHostMessageService=y}),define(me[241],ge([0,1,23,3,74,72,6,22,9,11,2,86,5,20,7,89,217,218]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class _{constructor(c,t){const n=_._Keys.nextId();c.$registerNotebookEditorDecorationType(n,m.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){c.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=_,_._Keys=new T.IdGenerator("NotebookEditorDecorationType");class d{constructor(c,t,n,s,i,a){this._textDocumentsAndEditors=n,this._textDocuments=s,this.logService=i,this._extensionStoragePaths=a,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new I.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new I.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new I.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new I.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new I.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new I.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new I.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new I.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new I.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new I.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new I.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new I.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new C.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(g.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(g.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(g.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:h=>{var p;if(h&&h.$mid===12){const S=(p=h.notebookEditor)===null||p===void 0?void 0:p.notebookUri,u=h.cell.handle,v=this._documents.get(S),R=v==null?void 0:v.getCell(u);if(R)return R.apiCell}return h}})}get activeNotebookEditor(){var c;return(c=this._activeNotebookEditor)===null||c===void 0?void 0:c.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){return this._editors.get(c)}getIdByEditor(c){for(const[t,n]of this._editors)if(n.apiEditor===c)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,t){const n=this._documents.get(c);if(!n&&!t)throw new Error(`NO notebook document for '${c}'`);return n}_getProviderData(c){const t=this._notebookContentProviders.get(c);if(!t)throw new Error(`NO provider for '${c}'`);return t}registerNotebookContentProvider(c,t,n,s,i){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:c,provider:n});let a;return n.onDidChangeNotebookContentOptions&&(a=n.onDidChangeNotebookContentOptions(()=>{const h=m.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,h)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},t,m.NotebookDocumentContentOptions.from(s),d._convertNotebookRegistrationData(c,i)),new l.Disposable(()=>{a==null||a.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(c,t){if(!!t){const n=t.filenamePattern.map(s=>m.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(c,t,n){const s=d._notebookStatusBarItemProviderHandlePool++,i=typeof n.onDidChangeCellStatusBarItems=="function"?d._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(s,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(s,i,t);let a;return i!==void 0&&(a=n.onDidChangeCellStatusBarItems(h=>this._notebookProxy.$emitCellStatusBarEvent(i))),new l.Disposable(()=>{this._notebookStatusBarItemProviders.delete(s),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(s,i),a&&a.dispose()})}createNotebookEditorDecorationType(c){return new _(this._notebookEditorsProxy,c).value}async openNotebookDocument(c){const t=this._documents.get(c);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(c),s=this._documents.get(r.URI.revive(n));return(0,P.assertIsDefined)(s==null?void 0:s.apiNotebook)}async showNotebookDocument(c,t){var n;r.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let s;typeof t=="object"?s={position:m.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(m.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:s={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.viewType,s),a=i&&((n=this._editors.get(i))===null||n===void 0?void 0:n.apiEditor);if(a)return a;throw i?new Error(`Could NOT open editor for "${c.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.toString()}".`)}async $provideNotebookCellStatusBarItems(c,t,n,s){var i;const a=this._notebookStatusBarItemProviders.get(c),h=r.URI.revive(t),p=this._documents.get(h);if(!(!p||!a)){const S=p.getCellFromIndex(n);if(!!S){const u=await a.provideCellStatusBarItems(S.apiCell,s);if(!!u){const v=new y.DisposableStore,R=this._statusBarCache.add([v]),N=(i=u&&u.map(j=>m.NotebookStatusBarItem.from(j,this._commandsConverter,v)))!==null&&i!==void 0?i:void 0;return{cacheId:R,items:N}}}}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,t,n,s,i){if((0,D.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const a=this._handlePool++;return this._notebookSerializer.set(a,n),this._notebookProxy.$registerNotebookSerializer(a,{id:c.identifier,location:c.extensionLocation},t,m.NotebookDocumentContentOptions.from(s),d._convertNotebookRegistrationData(c,i)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(a)})}async $dataToNotebook(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const i=await s.deserializeNotebook(t.buffer,n);return{metadata:m.NotebookDocumentMetadata.from(i.metadata),cells:i.cells.map(m.NotebookCellData.from)}}async $notebookToData(c,t,n){const s=this._notebookSerializer.get(c);if(!s)throw new Error("NO serializer found");const i=await s.serializeNotebook({metadata:m.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(m.NotebookCellData.to)},n);return b.VSBuffer.wrap(i)}async $openNotebook(c,t,n,s,i){const{provider:a}=this._getProviderData(c),h=await a.openNotebook(r.URI.revive(t),{backupId:n,untitledDocumentData:s==null?void 0:s.buffer},i);return{metadata:m.NotebookDocumentMetadata.from(h.metadata),cells:h.cells.map(m.NotebookCellData.from)}}async $saveNotebook(c,t,n){const s=this.getNotebookDocument(r.URI.revive(t)),{provider:i}=this._getProviderData(c);return await i.saveNotebook(s.apiNotebook,n),!0}async $saveNotebookAs(c,t,n,s){const i=this.getNotebookDocument(r.URI.revive(t)),{provider:a}=this._getProviderData(c);return await a.saveNotebookAs(r.URI.revive(n),i.apiNotebook,s),!0}async $backupNotebook(c,t,n){var s;const i=this.getNotebookDocument(r.URI.revive(t)),a=this._getProviderData(c),h=(s=this._extensionStoragePaths.workspaceValue(a.extension))!==null&&s!==void 0?s:this._extensionStoragePaths.globalValue(a.extension),p=String((0,A.hash)([i.uri.toString(),this._backupIdPool++])),S=r.URI.joinPath(h,p),u=await a.provider.backupNotebook(i.apiNotebook,{destination:S},n);return i.updateBackup(u),u.id}$acceptModelChanged(c,t,n){this.getNotebookDocument(r.URI.revive(c)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(c,t){const n=this.getNotebookDocument(r.URI.revive(c));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(c){const t=this.getNotebookDocument(r.URI.revive(c));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",c,t);const n=this._editors.get(c);if(!n)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(m.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(m.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(c){for(const t in c){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(m.ViewColumn.to(c[t]))}}$acceptDocumentPropertiesChanged(c,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",c.path,t);const n=this.getNotebookDocument(r.URI.revive(c));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(c,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const s=new w.ExtHostNotebookEditor(t,this._notebookEditorsProxy,c,n.visibleRanges.map(m.NotebookRange.to),n.selections.map(m.NotebookRange.to),typeof n.viewColumn=="number"?m.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,s)}$acceptDocumentAndEditorsDelta(c){var t,n,s;if(c.removedDocuments)for(const a of c.removedDocuments){const h=r.URI.revive(a),p=this._documents.get(h);p&&(p.dispose(),this._documents.delete(h),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(S=>S.document.uri)}),this._onDidCloseNotebookDocument.fire(p.apiNotebook));for(const S of this._editors.values())S.notebookData.uri.toString()===h.toString()&&this._editors.delete(S.id)}if(c.addedDocuments){const a=[];for(const h of c.addedDocuments){const p=r.URI.revive(h.uri),S=h.viewType;if(this._documents.has(p))throw new Error(`adding EXISTING notebook ${p} `);const u=this,v=new E.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(R){u._onDidChangeNotebookCells.fire(R)},emitCellOutputsChange(R){u._onDidChangeCellOutputs.fire(R)},emitCellMetadataChange(R){u._onDidChangeCellMetadata.fire(R)},emitCellExecutionStateChange(R){u._onDidChangeCellExecutionState.fire(R)}},S,h.metadata?m.NotebookDocumentMetadata.to(h.metadata):new l.NotebookDocumentMetadata,p);v.acceptModelChanged({versionId:h.versionId,rawEvents:[{kind:f.NotebookCellsChangeType.Initialize,changes:[[0,0,h.cells]]}]},!1),a.push(...h.cells.map(R=>E.ExtHostCell.asModelAddData(v.apiNotebook,R))),(t=this._documents.get(p))===null||t===void 0||t.dispose(),this._documents.set(p,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:a}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(c.addedEditors)for(const a of c.addedEditors){if(this._editors.has(a.id))return;const h=r.URI.revive(a.documentUri),p=this._documents.get(h);p&&this._createExtHostEditor(p,a.id,a)}const i=[];if(c.removedEditors)for(const a of c.removedEditors){const h=this._editors.get(a);h&&(this._editors.delete(a),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===h.id&&(this._activeNotebookEditor=void 0),i.push(h))}if(c.visibleEditors){this._visibleNotebookEditors=c.visibleEditors.map(h=>this._editors.get(h)).filter(h=>!!h);const a=new Set;this._visibleNotebookEditors.forEach(h=>a.add(h.id));for(const h of this._editors.values()){const p=a.has(h.id);h._acceptVisibility(p)}this._visibleNotebookEditors=[...this._editors.values()].map(h=>h).filter(h=>h.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.newActiveEditor===null?this._activeNotebookEditor=void 0:c.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.newActiveEditor)),c.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((s=this._activeNotebookEditor)===null||s===void 0?void 0:s.apiEditor)}}e.ExtHostNotebookController=d,d._notebookStatusBarItemProviderHandlePool=0}),define(me[242],ge([0,1,3,6,5,27,2,20,88,22,13,21,7,16]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class l{constructor(d,o,c){this._mainContext=d,this._initData=o,this._extHostNotebook=c,this._activeExecutions=new P.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=d.getProxy(A.MainContext.MainThreadNotebookKernels)}createNotebookController(d,o,c,t,n,s){for(let U of this._kernelData.values())if(U.controller.id===o&&T.ExtensionIdentifier.equals(d.identifier,U.extensionId))throw new Error(`notebook controller with id '${o}' ALREADY exist`);const i=this._handlePool++,a=this,h=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${d.identifier}'`);let p=!1;const S=new I.DisposableStore,u=new b.Emitter,v=new b.Emitter,R={id:`${d.identifier.value}/${o}`,viewType:c,extensionId:d.identifier,extensionLocation:d.extensionLocation,label:t||d.identifier.value,preloads:s?s.map(k.NotebookKernelPreload.from):[]};let N=n!=null?n:h,j;this._proxy.$addKernel(i,R).catch(U=>{console.log(U),p=!0});let ie=0;const K=()=>{if(!p){const U=++ie;Promise.resolve().then(()=>{U===ie&&this._proxy.$updateKernel(i,R)})}},B=new P.ResourceMap,$={get id(){return o},get viewType(){return R.viewType},onDidChangeNotebookAssociation:u.event,get label(){return R.label},set label(U){var L;R.label=(L=U!=null?U:d.displayName)!==null&&L!==void 0?L:d.name,K()},get detail(){var U;return(U=R.detail)!==null&&U!==void 0?U:""},set detail(U){R.detail=U,K()},get description(){var U;return(U=R.description)!==null&&U!==void 0?U:""},set description(U){R.description=U,K()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(U){R.supportedLanguages=U,K()},get hasExecutionOrder(){var U;return(U=R.hasExecutionOrder)!==null&&U!==void 0?U:!1},set hasExecutionOrder(U){R.hasExecutionOrder=U,K()},get preloads(){return R.preloads?R.preloads.map(k.NotebookKernelPreload.to):[]},get executeHandler(){return N},set executeHandler(U){N=U!=null?U:h},get interruptHandler(){return j},set interruptHandler(U){j=U,R.supportsInterrupt=Boolean(U),K()},createNotebookCellExecutionTask(U){if(p)throw new Error("notebook controller is DISPOSED");if(!B.has(U.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return a._createNotebookCellExecution(U)},dispose:()=>{p||(p=!0,this._kernelData.delete(i),S.dispose(),u.dispose(),v.dispose(),this._proxy.$removeKernel(i))},onDidReceiveMessage:v.event,postMessage(U,L){return a._proxy.$postMessage(i,L&&a._extHostNotebook.getIdByEditor(L),U)},asWebviewUri(U){return(0,D.asWebviewUri)(a._initData.environment,String(i),U)},updateNotebookAffinity(U,L){a._proxy.$updateNotebookPriority(i,U.uri,L)}};return this._kernelData.set(i,{extensionId:d.identifier,controller:$,onDidReceiveMessage:v,onDidChangeSelection:u,associatedNotebooks:B}),$}$acceptNotebookAssociation(d,o,c){const t=this._kernelData.get(d);if(t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));c?t.associatedNotebooks.set(n.uri,!0):t.associatedNotebooks.delete(n.uri),t.onDidChangeSelection.fire({selected:c,notebook:n.apiNotebook})}}async $executeCells(d,o,c){const t=this._kernelData.get(d);if(!!t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(o)),s=[];for(let i of c){const a=n.getCell(i);a&&s.push(a.apiCell)}try{await t.controller.executeHandler.call(t.controller,s,n.apiNotebook,t.controller)}catch(i){console.error(i)}}}async $cancelCells(d,o,c){var t;const n=this._kernelData.get(d);if(!!n){const s=this._extHostNotebook.getNotebookDocument(y.URI.revive(o));n.controller.interruptHandler&&await n.controller.interruptHandler.call(n.controller,s.apiNotebook);for(let i of c){const a=s.getCell(i);a&&((t=this._activeExecutions.get(a.uri))===null||t===void 0||t.cancel())}}}$acceptKernelMessageFromRenderer(d,o,c){const t=this._kernelData.get(d);if(!!t){const n=this._extHostNotebook.getEditorById(o);if(!n)throw new Error(`send message for UNKNOWN editor: ${o}`);t.onDidReceiveMessage.fire(Object.freeze({editor:n.apiEditor,message:c}))}}_createNotebookCellExecution(d){if(d.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(d.notebook.uri).getCellFromApiCell(d);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const t=new E(c.notebook,c,this._mainContext.getProxy(A.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(c.uri,t);const n=t.onDidChangeState(()=>{t.state===f.Resolved&&(t.dispose(),n.dispose(),this._activeExecutions.delete(c.uri))});return t.asApiObject()}}e.ExtHostNotebookKernels=l;var f;(function(_){_[_.Init=0]="Init",_[_.Started=1]="Started",_[_.Resolved=2]="Resolved"})(f||(f={}));class E extends I.Disposable{constructor(d,o,c){super();this._document=d,this._cell=o,this._proxy=c,this._onDidChangeState=new b.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new C.CancellationTokenSource),this._collector=new w(10,t=>this.applyEdits(t)),this._executionOrder=o.internalMetadata.executionOrder,this.mixinMetadata({runState:g.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(d){await this._collector.addItem(d)}async applyEdits(d){return this._proxy.$applyEdits(this._document.uri,d,!1)}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(d){const o={editType:8,handle:this._cell.handle,metadata:d};this.applyEdits([o])}cellIndexToHandle(d){if(typeof d!="number")return this._cell.handle;const o=this._document.getCellFromIndex(d);if(!o)throw new Error("INVALID cell index");return o.handle}asApiObject(){const d=this;return Object.freeze({get document(){return d._document.apiNotebook},get cell(){return d._cell.apiCell},get executionOrder(){return d._executionOrder},set executionOrder(o){d._executionOrder=o,d.mixinMetadata({executionOrder:o})},start(o){var c;if(d._state===f.Resolved||d._state===f.Started)throw new Error("Cannot call start again");d._state=f.Started,d._onDidChangeState.fire(),d.mixinMetadata({runState:g.NotebookCellExecutionState.Executing,runStartTime:(c=o==null?void 0:o.startTime)!==null&&c!==void 0?c:null})},end(o){var c,t;if(d._state===f.Resolved)throw new Error("Cannot call resolve twice");d._state=f.Resolved,d._onDidChangeState.fire(),d.mixinMetadata({runState:g.NotebookCellExecutionState.Idle,lastRunSuccess:(c=o==null?void 0:o.success)!==null&&c!==void 0?c:null,runEndTime:(t=o==null?void 0:o.endTime)!==null&&t!==void 0?t:null})},clearOutput(o){return d.verifyStateForOutput(),this.replaceOutput([],o)},async appendOutput(o,c){d.verifyStateForOutput();const t=d.cellIndexToHandle(c);return o=(0,m.asArray)(o),d.applyEditSoon({editType:2,handle:t,append:!0,outputs:o.map(k.NotebookCellOutput.from)})},async replaceOutput(o,c){d.verifyStateForOutput();const t=d.cellIndexToHandle(c);return o=(0,m.asArray)(o),d.applyEditSoon({editType:2,handle:t,outputs:o.map(k.NotebookCellOutput.from)})},async appendOutputItems(o,c){return d.verifyStateForOutput(),o=(0,m.asArray)(o),d.applyEditSoon({editType:7,append:!0,items:o.map(k.NotebookCellOutputItem.from),outputId:c})},async replaceOutputItems(o,c){return d.verifyStateForOutput(),o=(0,m.asArray)(o),d.applyEditSoon({editType:7,items:o.map(k.NotebookCellOutputItem.from),outputId:c})},token:d._tokenSource.token})}}class w{constructor(d,o){this.delay=d,this.callback=o,this.batch=[]}addItem(d){return this.batch.push(d),this.waitPromise||(this.waitPromise=(0,r.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const o=this.batch;return this.batch=[],this.callback(o)})),this.waitPromise}}}),define(me[65],ge([0,1,5,3,6,23,4,15]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class D extends A.Disposable{constructor(l,f,E,w){super();this._onDidAppend=this._register(new I.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=l,this._proxy=w,this._id=w.$register(this.name,f,E),this._disposed=!1,this._offset=0}get name(){return this._name}append(l){this.validate(),this._offset+=l?T.VSBuffer.fromString(l).byteLength:0}update(){this._id.then(l=>this._proxy.$update(l))}appendLine(l){this.validate(),this.append(l+`
`)}clear(){this.validate();const l=this._offset;this._id.then(f=>this._proxy.$clear(f,l))}show(l,f){this.validate(),this._id.then(E=>this._proxy.$reveal(E,!!(typeof l=="boolean"?l:f)))}hide(){this.validate(),this._id.then(l=>this._proxy.$close(l))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(l=>this._proxy.$dispose(l)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=D;class P extends D{constructor(l,f){super(l,!1,void 0,f)}append(l){super.append(l),this._id.then(f=>this._proxy.$append(f,l)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=P;class r extends D{constructor(l,f,E){super(l,!0,f,E)}append(l){throw new Error("Not supported")}}class C{constructor(l,f){this.name=l,this._channel=f}append(l){this._channel.then(f=>f.append(l))}appendLine(l){this._channel.then(f=>f.appendLine(l))}clear(){this._channel.then(l=>l.clear())}show(l,f){this._channel.then(E=>E.show(l,f))}hide(){this._channel.then(l=>l.hide())}dispose(){this._channel.then(l=>l.dispose())}}e.LazyOutputChannel=C;let g=class{constructor(l){this._proxy=l.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(l){}createOutputChannel(l){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");return new P(l,this._proxy)}createOutputChannelFromLogFile(l,f){if(l=l.trim(),!l)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new r(l,f,this._proxy)}};g=qe([He(0,k.IExtHostRpcService)],g),e.ExtHostOutputService=g,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(me[243],ge([0,1,13,21,3,6,5,2,7,17,16,58]),function(G,e,b,I,A,T,y,k,D,P,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(m,l,f){const E=m.getProxy(y.MainContext.MainThreadQuickOpen);class w{constructor(i,a){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=a}showQuickPick(i,a,h,p=I.CancellationToken.None){this._onDidSelectItem=void 0;const S=Promise.resolve(i),u=++this._instances,v=E.$show(u,{title:h==null?void 0:h.title,placeHolder:h==null?void 0:h.placeHolder,matchOnDescription:h==null?void 0:h.matchOnDescription,matchOnDetail:h==null?void 0:h.matchOnDetail,ignoreFocusLost:h==null?void 0:h.ignoreFocusOut,canPickMany:h==null?void 0:h.canPickMany},p),R={},N=v.then(()=>R);return Promise.race([N,S]).then(j=>{if(j!==R)return S.then(ie=>{const K=[];for(let B=0;B<ie.length;B++){const $=ie[B];let U,L,O,M,F;typeof $=="string"?U=$:(U=$.label,L=$.description,O=$.detail,M=$.picked,F=$.alwaysShow),K.push({label:U,description:L,handle:B,detail:O,picked:M,alwaysShow:F})}return h&&typeof h.onDidSelectItem=="function"&&(this._onDidSelectItem=B=>{h.onDidSelectItem(ie[B])}),E.$setItems(u,K),v.then(B=>{if(typeof B=="number")return ie[B];if(Array.isArray(B))return B.map($=>ie[$])})})}).then(void 0,j=>{if(!(0,P.isPromiseCanceledError)(j))return E.$setError(u,j),Promise.reject(j)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,a=I.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,E.$input(i,typeof this._validateInput=="function",a).then(void 0,h=>{if(!(0,P.isPromiseCanceledError)(h))return Promise.reject(h)})}$validateInput(i){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,a=I.CancellationToken.None){const h=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!!h){const p=await this._workspace.getWorkspaceFolders2();if(!!p)return p.find(S=>S.uri.toString()===h.uri.toString())}}createQuickPick(i,a){const h=new t(i,a,()=>this._sessions.delete(h._id));return this._sessions.set(h._id,h),h}createInputBox(i){const a=new n(i,()=>this._sessions.delete(a._id));return this._sessions.set(a._id,a),a}$onDidChangeValue(i,a){const h=this._sessions.get(i);h&&h._fireDidChangeValue(a)}$onDidAccept(i){const a=this._sessions.get(i);a&&a._fireDidAccept()}$onDidChangeActive(i,a){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeActive(a)}$onDidChangeSelection(i,a){const h=this._sessions.get(i);h instanceof t&&h._fireDidChangeSelection(a)}$onDidTriggerButton(i,a){const h=this._sessions.get(i);h&&h._fireDidTriggerButton(a)}$onDidHide(i){const a=this._sessions.get(i);a&&a._fireDidHide()}}class _{constructor(i,a){this._extensionId=i,this._onDidDispose=a,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new A.Emitter,this._onDidChangeValueEmitter=new A.Emitter,this._onDidTriggerButtonEmitter=new A.Emitter,this._onDidHideEmitter=new A.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((a,h)=>{const p=a===D.QuickInputButtons.Back?-1:h;this._handlesToButtons.set(p,a)}),this.update({buttons:i.map((a,h)=>({iconPath:d(a.iconPath),tooltip:a.tooltip,handle:a===D.QuickInputButtons.Back?-1:h}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const a=this._handlesToButtons.get(i);a&&this._onDidTriggerButtonEmitter.fire(a)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),E.$dispose(this._id))}update(i){if(!this._disposed){for(const a of Object.keys(i)){const h=i[a];this._pendingUpdate[a]=h===void 0?null:h}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){E.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}_._nextId=1;function d(s){if(s instanceof D.ThemeIcon)return{id:s.id};const i=c(s),a=o(s);return{dark:typeof i=="string"?k.URI.file(i):i,light:typeof a=="string"?k.URI.file(a):a}}function o(s){return typeof s=="object"&&"light"in s?s.light:s}function c(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends _{constructor(i,a,h){super(i,h);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new A.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new A.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((a,h)=>{this._handlesToItems.set(h,a),this._itemsToHandles.set(a,h)}),this.update({items:i.map((a,h)=>({label:a.label,description:a.description,handle:h,detail:a.detail,picked:a.picked,alwaysShow:a.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({activeItems:this._activeItems.map(a=>this._itemsToHandles.get(a))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(a=>this._itemsToHandles.has(a)),this.update({selectedItems:this._selectedItems.map(a=>this._itemsToHandles.get(a))})}_fireDidChangeActive(i){const a=(0,r.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._activeItems=a,this._onDidChangeActiveEmitter.fire(a)}_fireDidChangeSelection(i){const a=(0,r.coalesce)(i.map(h=>this._handlesToItems.get(h)));this._selectedItems=a,this._onDidChangeSelectionEmitter.fire(a)}}class n extends _{constructor(i,a){super(i,a);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?C.default.Error:C.default.Ignore})}}return new w(l,f)}e.createExtHostQuickOpen=g}),define(me[244],ge([0,1,2,3,54,6,13,5,16,100,14,27,41]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function m(i){if(i)return typeof i.iconPath=="string"?b.URI.file(i.iconPath):i.iconPath}function l(i,a){if(!i.iconPath&&!a.iconPath)return 0;if(i.iconPath){if(!a.iconPath)return 1}else return-1;const h=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,p=typeof a.iconPath=="string"?a.iconPath:a.iconPath.fsPath;return(0,P.comparePaths)(h,p)}function f(i,a){let h=0;if(i.strikeThrough!==a.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==a.faded)return i.faded?1:-1;if(i.tooltip!==a.tooltip)return(i.tooltip||"").localeCompare(a.tooltip||"");if(h=l(i,a),h!==0)return h;if(i.light&&a.light)h=l(i.light,a.light);else{if(i.light)return 1;if(a.light)return-1}if(h!==0)return h;if(i.dark&&a.dark)h=l(i.dark,a.dark);else{if(i.dark)return 1;if(a.dark)return-1}return h}function E(i,a){if(i.command!==a.command)return i.command<a.command?-1:1;if(i.title!==a.title)return i.title<a.title?-1:1;if(i.tooltip!==a.tooltip){if(i.tooltip!==void 0&&a.tooltip!==void 0)return i.tooltip<a.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(a.tooltip!==void 0)return-1}if(i.arguments===a.arguments)return 0;if(i.arguments)if(a.arguments){if(i.arguments.length!==a.arguments.length)return i.arguments.length-a.arguments.length}else return 1;else return-1;for(let h=0;h<i.arguments.length;h++){const p=i.arguments[h],S=a.arguments[h];if(p!==S)return p<S?-1:1}return 0}function w(i,a){let h=(0,P.comparePaths)(i.resourceUri.fsPath,a.resourceUri.fsPath,!0);if(h!==0)return h;if(i.command&&a.command)h=E(i.command,a.command);else{if(i.command)return 1;if(a.command)return-1}if(h!==0)return h;if(i.decorations&&a.decorations)h=f(i.decorations,a.decorations);else{if(i.decorations)return 1;if(a.decorations)return-1}return h}function _(i,a){for(let h=0;h<i.length;h++)if(i[h]!==a[h])return!1;return!0}function d(i,a){return i.command===a.command&&i.title===a.title&&i.tooltip===a.tooltip&&(i.arguments&&a.arguments?_(i.arguments,a.arguments):i.arguments===a.arguments)}function o(i,a){return(0,D.equals)(i,a,d)}class c{constructor(a,h,p){this._extension=a,this._proxy=h,this._sourceControlHandle=p,this._value="",this._onDidChange=new I.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(a){this._proxy.$setInputBoxValue(this._sourceControlHandle,a),this.updateValue(a)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(a){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,a),this._placeholder=a}get validateInput(){return(0,g.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(a){if((0,g.checkProposedApiEnabled)(this._extension),a&&typeof a!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=a,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!a)}get visible(){return this._visible}set visible(a){a=!!a,this._visible!==a&&(this._visible=a,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,a))}focus(){(0,g.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(a,h){(0,g.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,a,h)}$onInputBoxValueChange(a){this.updateValue(a)}updateValue(a){this._value=a,this._onDidChange.fire(a)}}e.ExtHostSCMInputBox=c;class t{constructor(a,h,p,S,u){this._proxy=a,this._commands=h,this._sourceControlHandle=p,this._id=S,this._label=u,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new I.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new I.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(a){this._label=a,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,a)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(a){this._hideWhenEmpty=a,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(a){this._resourceStates=[...a],this._onDidUpdateResourceStates.fire()}getResourceState(a){return this._resourceStatesMap.get(a)}$executeResourceCommand(a,h){const p=this._resourceStatesCommandsMap.get(a);return p?(0,y.asPromise)(()=>this._commands.executeCommand(p.command,...p.arguments||[],h)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var a;const h=[...this._resourceStates].sort(w),S=(0,D.sortedDiff)(this._resourceSnapshot,h,w).map(R=>{const N=R.toInsert.map(j=>{const ie=this._resourceHandlePool++;this._resourceStatesMap.set(ie,j);const K=j.resourceUri,B=m(j.decorations),$=j.decorations&&m(j.decorations.light)||B,U=j.decorations&&m(j.decorations.dark)||B,L=[];let O;if(j.command)if(j.command.command==="vscode.open"||j.command.command==="vscode.diff"){const le=new T.DisposableStore;O=this._commands.converter.toInternal(j.command,le),this._resourceStatesDisposablesMap.set(ie,le)}else this._resourceStatesCommandsMap.set(ie,j.command);$&&L.push($),U&&U.toString()!==($==null?void 0:$.toString())&&L.push(U);const M=j.decorations&&j.decorations.tooltip||"",F=j.decorations&&!!j.decorations.strikeThrough,W=j.decorations&&!!j.decorations.faded,q=j.contextValue||"";return{rawResource:[ie,K,L,M,F,W,q,O],handle:ie}});return{start:R.start,deleteCount:R.deleteCount,toInsert:N}}),u=S.map(({start:R,deleteCount:N,toInsert:j})=>[R,N,j.map(ie=>ie.rawResource)]),v=S.reverse();for(const{start:R,deleteCount:N,toInsert:j}of v){const ie=j.map(B=>B.handle),K=this._handlesSnapshot.splice(R,N,...ie);for(const B of K)this._resourceStatesMap.delete(B),this._resourceStatesCommandsMap.delete(B),(a=this._resourceStatesDisposablesMap.get(B))===null||a===void 0||a.dispose(),this._resourceStatesDisposablesMap.delete(B)}return this._resourceSnapshot=h,u}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(a,h,p,S,u,v){this._proxy=h,this._commands=p,this._id=S,this._label=u,this._rootUri=v,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new I.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new c(a,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,S,u,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(a){this._count!==a&&(this._count=a,this._proxy.$updateSourceControl(this.handle,{count:a}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(a){this._quickDiffProvider=a,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!a})}get commitTemplate(){return this._commitTemplate}set commitTemplate(a){a!==this._commitTemplate&&(this._commitTemplate=a,this._proxy.$updateSourceControl(this.handle,{commitTemplate:a}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(a){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=a;const h=this._commands.converter.toInternal(a,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:h})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(a){if(!(this._statusBarCommands&&a&&o(this._statusBarCommands,a))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=a;const h=(a||[]).map(p=>this._commands.converter.toInternal(p,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:h})}}get selected(){return this._selected}createResourceGroup(a,h){const p=new t(this._proxy,this._commands,this.handle,a,h),S=I.Event.once(p.onDidDispose)(()=>this.createdResourceGroups.delete(p));return this.createdResourceGroups.set(p,S),this.eventuallyAddResourceGroups(),p}eventuallyAddResourceGroups(){const a=[],h=[];for(const[p,S]of this.createdResourceGroups){S.dispose();const u=p.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(p),this.eventuallyUpdateResourceStates()});I.Event.once(p.onDidDispose)(()=>{this.updatedResourceGroups.delete(p),u.dispose(),this._groups.delete(p.handle),this._proxy.$unregisterGroup(this.handle,p.handle)}),a.push([p.handle,p.id,p.label,p.features]);const v=p._takeResourceStateSnapshot();v.length>0&&h.push([p.handle,v]),this._groups.set(p.handle,p)}this._proxy.$registerGroups(this.handle,a,h),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const a=[];this.updatedResourceGroups.forEach(h=>{const p=h._takeResourceStateSnapshot();p.length!==0&&a.push([h.handle,p])}),a.length>0&&this._proxy.$spliceResourceStates(this.handle,a),this.updatedResourceGroups.clear()}getResourceGroup(a){return this._groups.get(a)}setSelectionState(a){this._selected=a,this._onDidChangeSelection.fire(a)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(a=>a.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,qe([(0,A.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),qe([(0,A.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(a,h,p){this._commands=h,this.logService=p,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new I.Emitter,this._proxy=a.getProxy(k.MainContext.MainThreadSCM),this._telemetry=a.getProxy(k.MainContext.MainThreadTelemetry),h.registerArgumentProcessor({processArgument:S=>{if(S&&S.$mid===3){const u=this._sourceControls.get(S.sourceControlHandle);if(!u)return S;const v=u.getResourceGroup(S.groupHandle);return v?v.getResourceState(S.handle):S}else if(S&&S.$mid===4){const u=this._sourceControls.get(S.sourceControlHandle);return u?u.getResourceGroup(S.groupHandle):S}else if(S&&S.$mid===5){const u=this._sourceControls.get(S.handle);return u||S}return S}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(a,h,p,S){this.logService.trace("ExtHostSCM#createSourceControl",a.identifier.value,h,p,S),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:a.identifier.value});const u=Un._handlePool++,v=new n(a,this._proxy,this._commands,h,p,S);this._sourceControls.set(u,v);const R=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier))||[];return R.push(v),this._sourceControlsByExtension.set(C.ExtensionIdentifier.toKey(a.identifier),R),v}getLastInputBox(a){this.logService.trace("ExtHostSCM#getLastInputBox",a.identifier.value);const h=this._sourceControlsByExtension.get(C.ExtensionIdentifier.toKey(a.identifier)),p=h&&h[h.length-1];return p&&p.inputBox}$provideOriginalResource(a,h,p){const S=b.URI.revive(h);this.logService.trace("ExtHostSCM#$provideOriginalResource",a,S.toString());const u=this._sourceControls.get(a);return!u||!u.quickDiffProvider||!u.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>u.quickDiffProvider.provideOriginalResource(S,p)).then(v=>v||null)}$onInputBoxValueChange(a,h){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",a);const p=this._sourceControls.get(a);return p&&p.inputBox.$onInputBoxValueChange(h),Promise.resolve(void 0)}$executeResourceCommand(a,h,p,S){this.logService.trace("ExtHostSCM#$executeResourceCommand",a,h,p);const u=this._sourceControls.get(a);if(!u)return Promise.resolve(void 0);const v=u.getResourceGroup(h);return v?v.$executeResourceCommand(p,S):Promise.resolve(void 0)}$validateInput(a,h,p){this.logService.trace("ExtHostSCM#$validateInput",a);const S=this._sourceControls.get(a);return!S||!S.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>S.inputBox.validateInput(h,p)).then(u=>u?Promise.resolve([u.message,u.type]):Promise.resolve(void 0))}$setSelectedSourceControl(a){var h,p;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",a),a!==void 0&&((h=this._sourceControls.get(a))===null||h===void 0||h.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((p=this._sourceControls.get(this._selectedSourceControlHandle))===null||p===void 0||p.setSelectionState(!1)),this._selectedSourceControlHandle=a,Promise.resolve(void 0)}};s._handlePool=0,s=qe([He(2,r.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[245],ge([0,1,7,5,164,6]),function(G,e,b,I,A,T){"use strict";var y,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(g,m,l,f,E=b.StatusBarAlignment.Left,w,_){y.set(this,void 0),k.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,it(this,y,g,"f"),it(this,k,m,"f"),this._id=D.ID_GEN++,this._statusId=l,this._statusName=f,this._alignment=E,this._priority=w,this._accessibilityInformation=_}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var g;return(g=this._command)===null||g===void 0?void 0:g.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(g){this._text=g,this.update()}set tooltip(g){this._tooltip=g,this.update()}set color(g){this._color=g,this.update()}set backgroundColor(g){g&&!D.ALLOWED_BACKGROUND_COLORS.has(g.id)&&(g=void 0),this._backgroundColor=g,this.update()}set command(g){var m;((m=this._command)===null||m===void 0?void 0:m.fromApi)!==g&&(this._internalCommandRegistration.clear(),typeof g=="string"?this._command={fromApi:g,internal:We(this,k,"f").toInternal({title:"",command:g},this._internalCommandRegistration)}:g?this._command={fromApi:g,internal:We(this,k,"f").toInternal(g,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(g){this._accessibilityInformation=g,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,We(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var g;this._timeoutHandle=void 0;let m=this._color;this._backgroundColor&&(m=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),We(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(g=this._command)===null||g===void 0?void 0:g.internal,m,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,y=new WeakMap,k=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class P{constructor(g){this._messages=[],this._item=g.createStatusBarEntry("status.extensionMessage",(0,A.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(g){const m={message:g};return this._messages.unshift(m),this._update(),new b.Disposable(()=>{const l=this._messages.indexOf(m);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class r{constructor(g,m){this._proxy=g.getProxy(I.MainContext.MainThreadStatusBar),this._commands=m,this._statusMessage=new P(this)}createStatusBarEntry(g,m,l,f,E){return new D(this._proxy,this._commands,g,m,l,f,E)}setStatusBarMessage(g,m){const l=this._statusMessage.setMessage(g);let f;return typeof m=="number"?f=setTimeout(()=>l.dispose(),m):typeof m!="undefined"&&m.then(()=>l.dispose(),()=>l.dispose()),new b.Disposable(()=>{l.dispose(),clearTimeout(f)})}}e.ExtHostStatusBar=r}),define(me[92],ge([0,1,5,3,4]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(k){this._onDidChangeStorage=new I.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=k.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(k,D){this._proxy.$registerExtensionStorageKeysToSync(k,D)}getValue(k,D,P){return this._proxy.$getValue(k,D).then(r=>r||P)}setValue(k,D,P){return this._proxy.$setValue(k,D,P)}$acceptValue(k,D,P){this._onDidChangeStorage.fire({shared:k,key:D,value:P})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,A.createDecorator)("IExtHostStorage")}),define(me[93],ge([0,1,4,28,14,91,2]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let k=class{constructor(P,r,C){var g;this._logService=r,this._extHostFileSystem=C,this._workspace=(g=P.workspace)!==null&&g!==void 0?g:void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getOrCreateWorkspaceStoragePath(){var P;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,C=y.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(C),this._logService.trace("[ExtHostStorage] storage dir already exists",C),C}catch(g){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",C),await this._extHostFileSystem.value.createDirectory(C),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(C,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(P=y.URI.revive(this._workspace.configuration))===null||P===void 0?void 0:P.toString(),name:this._workspace.name},void 0,2))),C}catch(g){this._logService.error("[ExtHostStorage]",g);return}}workspaceValue(P){if(this._value)return y.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return y.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}};k=qe([He(0,I.IExtHostInitDataService),He(1,A.ILogService),He(2,T.IExtHostConsumerFileSystem)],k),e.ExtensionStoragePaths=k}),define(me[34],ge([0,1,3,5,4,2,15,6,7,165,17,209,21,30,191]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,A.createDecorator)("IExtHostTerminalService");class f{constructor(t,n,s,i){this._proxy=t,this._id=n,this._creationOptions=s,this._name=i,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(h=>this._pidPromiseComplete=h);const a=this;this.value={get name(){return a._name||""},get processId(){return a._pidPromise},get creationOptions(){return a._creationOptions},get exitStatus(){return a._exitStatus},sendText(h,p=!0){a._checkDisposed(),a._proxy.$sendText(a._id,h,p)},show(h){a._checkDisposed(),a._proxy.$show(a._id,h)},hide(){a._checkDisposed(),a._proxy.$hide(a._id)},dispose(){a._disposed||(a._disposed=!0,a._proxy.$dispose(a._id))},get dimensions(){if(!(a._cols===void 0||a._rows===void 0))return{columns:a._cols,rows:a._rows}}}}async create(t,n,s,i,a,h,p,S,u,v,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:s,env:i,icon:a,initialText:h,waitOnExit:p,strictEnv:S,hideFromUser:u,isFeatureTerminal:v,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=f;class E{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=E;let w=1,_=class extends k.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(I.MainContext.MainThreadTerminalService),this._bufferer=new l.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[s,i]of this._terminalProcesses)i.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new f(this._proxy,(0,m.generateUuid)(),t,t.name),s=new E(t.pty);return n.createExtensionTerminal().then(i=>{const a=this._setupExtHostProcessListeners(i,s);this._terminalProcessDisposables[i]=a}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const i=new E(n),a=this._setupExtHostProcessListeners(t,i);this._terminalProcessDisposables[t]=a}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(t);s&&(this._activeTerminal=s,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const s=this._getTerminalById(t);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:n})}async $acceptTerminalDimensions(t,n,s){const i=this._getTerminalById(t);i&&i.setDimensions(n,s)&&this._onDidChangeTerminalDimensions.fire({terminal:i.value,dimensions:i.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,s){var i;(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}async $acceptTerminalTitleChange(t,n){const s=this._getTerminalById(t);s&&(s.name=n)}async $acceptTerminalClosed(t,n){const s=this._getTerminalObjectIndexById(this._terminals,t);if(s!==null){const i=this._terminals.splice(s,1)[0];i.setExitCode(n),this._onDidCloseTerminal.fire(i.value)}}$acceptTerminalOpened(t,n,s,i){if(n){const p=this._getTerminalObjectIndexById(this._terminals,n);if(p!==null){this._terminals[p]._id=t,this._onDidOpenTerminal.fire(this.terminals[p]),this._terminals[p].isOpen=!0;return}}const a={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:typeof i.cwd=="string"?i.cwd:T.URI.revive(i.cwd),env:i.env,hideFromUser:i.hideFromUser},h=new f(this._proxy,t,a,s);this._terminals.push(h),this._onDidOpenTerminal.fire(h.value),h.isOpen=!0}async $acceptTerminalProcessId(t,n){const s=this._getTerminalById(t);s&&s._setProcessId(n)}async $startExtensionTerminal(t,n){const s=this._getTerminalById(t);if(!s)return{message:(0,P.localize)(0,null,t)};s.isOpen||await new Promise(a=>{const h=this.onDidOpenTerminal(async p=>{p===s.value&&(h.dispose(),a())})});const i=this._terminalProcesses.get(t);i?i.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const s=new k.DisposableStore;s.add(n.onProcessReady(a=>this._proxy.$sendProcessReady(t,a.pid,a.cwd))),s.add(n.onProcessTitleChanged(a=>this._proxy.$sendProcessTitle(t,a))),this._bufferer.startBuffering(t,n.onProcessData),s.add(n.onProcessExit(a=>this._onProcessExit(t,a))),n.onProcessOverrideDimensions&&s.add(n.onProcessOverrideDimensions(a=>this._proxy.$sendOverrideDimensions(t,a))),this._terminalProcesses.set(t,n);const i=this._extensionTerminalAwaitingStart[t];return i&&n instanceof E&&(n.startSendingEvents(i.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),s}$acceptProcessAckDataEvent(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.input(n)}$acceptProcessResize(t,n,s){var i;try{(i=this._terminalProcesses.get(t))===null||i===void 0||i.resize(n,s)}catch(a){if(a.code!=="EPIPE"&&a.code!=="ERR_IPC_CHANNEL_CLOSED")throw a}}$acceptProcessShutdown(t,n){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(t,s))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(s=>this._proxy.$sendProcessCwd(t,s))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const s=this._getTerminalById(t);if(!s)return[];this._terminalLinkCache.delete(t);const i=this._terminalLinkCancellationSource.get(t);i&&i.dispose(!0);const a=new g.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,a);const h=[],p={terminal:s.value,line:n},S=[];for(const R of this._linkProviders)S.push(new Promise(async N=>{a.token.onCancellationRequested(()=>N({provider:R,links:[]}));const j=await R.provideTerminalLinks(p,a.token)||[];a.token.isCancellationRequested||N({provider:R,links:j})}));const u=await Promise.all(S);if(a.token.isCancellationRequested)return[];const v=new Map;for(const R of u)R&&R.links.length>0&&h.push(...R.links.map(N=>{const j={id:w++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return v.set(j.id,{provider:R.provider,link:N}),j}));return this._terminalLinkCache.set(t,v),h}$activateLink(t,n){var s;const i=(s=this._terminalLinkCache.get(t))===null||s===void 0?void 0:s.get(n);!i||i.provider.handleTerminalLink(i.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const s=this._terminalProcessDisposables[t];s&&(s.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const s=this._getTerminalObjectIndexById(t,n);return s!==null?t[s]:null}_getTerminalObjectIndexById(t,n){let s=null;return t.some((i,a)=>i._id===n?(s=a,!0):!1),s}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const s=(0,C.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const s=n[0],i=new d(n[1]);this._setEnvironmentVariableCollection(s,i)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};_=qe([He(1,y.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class d{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const s=this.map.get(t);(!s||s.value!==n.value||s.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((s,i)=>t.call(n,i,s,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let o=class extends _{constructor(t){super(!1,t)}createTerminal(t,n,s){throw new r.NotSupportedError}createTerminalFromOptions(t){throw new r.NotSupportedError}getDefaultShell(t,n){throw new r.NotSupportedError}getDefaultShellArgs(t,n){throw new r.NotSupportedError}async getDefaultShellAndArgs(t){throw new r.NotSupportedError}$getAvailableProfiles(t){throw new r.NotSupportedError}};o=qe([He(0,y.IExtHostRpcService)],o),e.WorkerExtHostTerminalService=o}),define(me[246],ge([0,1,3,16,5,125,20,7]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(r,C){this._extHostDocumentsAndEditors=C,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(A.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(g=>this._onDidChangeVisibleTextEditors.fire(g)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(g=>this._onDidChangeActiveTextEditor.fire(g))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const C=this._extHostDocumentsAndEditors.allEditors();return r?C:C.map(g=>g.value)}async showTextDocument(r,C,g){let m;typeof C=="number"?m={position:y.ViewColumn.from(C),preserveFocus:g}:typeof C=="object"?m={position:y.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?y.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:m={preserveFocus:!1};const l=await this._proxy.$tryShowTextDocument(r.uri,m),f=l&&this._extHostDocumentsAndEditors.getEditor(l);if(f)return f.value;throw l?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r){return new T.TextEditorDecorationType(this._proxy,r).value}$acceptEditorPropertiesChanged(r,C){const g=this._extHostDocumentsAndEditors.getEditor(r);if(!g)throw new Error("unknown text editor");if(C.options&&g._acceptOptions(C.options),C.selections){const m=C.selections.selections.map(y.Selection.to);g._acceptSelections(m)}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));g._acceptVisibleRanges(m)}if(C.options&&this._onDidChangeTextEditorOptions.fire({textEditor:g.value,options:Object.assign(Object.assign({},C.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(C.options.lineNumbers)})}),C.selections){const m=k.TextEditorSelectionChangeKind.fromValue(C.selections.source),l=C.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:g.value,selections:l,kind:m})}if(C.visibleRanges){const m=I.coalesce(C.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:g.value,visibleRanges:m})}}$acceptEditorPositionData(r){for(const C in r){const g=this._extHostDocumentsAndEditors.getEditor(C);if(!g)throw new Error("Unknown text editor");const m=y.ViewColumn.to(r[C]);g.value.viewColumn!==m&&(g._acceptViewColumn(m),this._onDidChangeTextEditorViewColumn.fire({textEditor:g.value,viewColumn:m}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=D});var Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(b[I[A]]=G[I[A]]);return b};define(me[247],ge([0,1,2,4,5,6,7]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,I.createDecorator)("IExtHostTimeline");class k{constructor(r,C){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(A.MainContext.MainThreadTimeline),C.registerArgumentProcessor({processArgument:g=>{var m,l;if(g&&g.$mid===11){const f=g.uri===void 0?void 0:b.URI.revive(g.uri);return(l=(m=this._itemsBySourceAndUriMap.get(g.source))===null||m===void 0?void 0:m.get(D(f)))===null||l===void 0?void 0:l.get(g.handle)}return g}})}async $getTimeline(r,C,g,m,l){const f=this._providers.get(r);return f==null?void 0:f.provideTimeline(b.URI.revive(C),g,m,l)}registerTimelineProvider(r,C,g,m){const l=new T.DisposableStore,f=this.convertTimelineItem(C.id,m,l).bind(this);let E;C.onDidChange&&(E=C.onDidChange(_=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},_),{id:C.id})),this));const w=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},C),{scheme:r,onDidChange:void 0,async provideTimeline(_,d,o,c){var t;(c==null?void 0:c.resetCache)&&(l.clear(),(t=w.get(C.id))===null||t===void 0||t.clear());const n=await C.provideTimeline(_,d,o);if(n!=null){const s=f(_,c);return Object.assign(Object.assign({},n),{source:C.id,items:n.items.map(s)})}},dispose(){var _;for(const d of w.values())(_=d.get(C.id))===null||_===void 0||_.clear();E==null||E.dispose(),l.dispose()}}))}convertTimelineItem(r,C,g){return(m,l)=>{let f;if(l==null?void 0:l.cacheResults){let E=this._itemsBySourceAndUriMap.get(r);E===void 0&&(E=new Map,this._itemsBySourceAndUriMap.set(r,E));const w=D(m);f=E.get(w),f===void 0&&(f=new Map,E.set(w,f))}return E=>{var w,_;const{iconPath:d}=E,o=Jt(E,["iconPath"]),c=`${r}|${(w=E.id)!==null&&w!==void 0?w:E.timestamp}`;f==null||f.set(c,E);let t,n,s;return E.iconPath&&(d instanceof y.ThemeIcon?s={id:d.id}:b.URI.isUri(d)?(t=d,n=d):{light:t,dark:n}=d),Object.assign(Object.assign({},o),{id:(_=o.id)!==null&&_!==void 0?_:void 0,handle:c,source:r,command:E.command?C.toInternal(E.command,g):void 0,icon:t,iconDark:n,themeIcon:s,accessibilityInformation:E.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),(0,T.toDisposable)(()=>{var g;for(const m of this._itemsBySourceAndUriMap.values())(g=m.get(r.id))===null||g===void 0||g.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=k;function D(P){return P==null?void 0:P.toString()}}),define(me[248],ge([0,1,6,12,2,5]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(D){this._openers=new Map,this._proxy=D.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,P,r,C){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const g=C.schemes.find(m=>!y.supportedSchemes.has(m));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,r),this._proxy.$registerUriOpener(P,C.schemes,D,C.label),(0,b.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(D,P,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener with id: ${D}`);const g=A.URI.revive(P);return C.canOpenExternalUri(g,r)}async $openUri(D,P,r){const C=this._openers.get(D);if(!C)throw new Error(`Unknown opener id: '${D}'`);return C.openExternalUri(A.URI.revive(P.resolvedUri),{sourceUri:A.URI.revive(P.sourceUri)},r)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([I.Schemas.http,I.Schemas.https])}),define(me[249],ge([0,1,5,2,6,17,27]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class k{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(P,r){if(this.handles.has(y.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const C=k.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(P)),this.handlers.set(C,r),this._proxy.$registerUriHandler(C,P),(0,A.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(P)),this.handlers.delete(C),this._proxy.$unregisterUriHandler(C)})}$handleExternalUri(P,r){const C=this.handlers.get(P);if(!C)return Promise.resolve(void 0);try{C.handleUri(I.URI.revive(r))}catch(g){(0,T.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(P){return I.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=k,k.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[66],ge([0,1,3,2,176,201,88,5]),function(G,e,b,I,A,T,y,k){"use strict";var D,P,r,C,g,m,l,f,E,w,_,d;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class o{constructor(p,S,u,v,R,N,j){D.set(this,void 0),P.set(this,void 0),r.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),l.set(this,""),f.set(this,void 0),E.set(this,!1),w.set(this,!1),_.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,d.set(this,new b.Emitter),this._onDidDispose=We(this,d,"f").event,it(this,D,p,"f"),it(this,P,S,"f"),it(this,f,u,"f"),it(this,C,v,"f"),it(this,g,R,"f"),it(this,m,N,"f"),it(this,_,c(N),"f"),it(this,r,j,"f")}dispose(){it(this,E,!0,"f"),We(this,d,"f").fire(),We(this,d,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(p){return it(this,w,!0,"f"),(0,y.asWebviewUri)(We(this,C,"f"),We(this,D,"f"),p)}get cspSource(){return We(this,C,"f").webviewCspSource.replace("{{uuid}}",We(this,D,"f"))}get html(){return this.assertNotDisposed(),We(this,l,"f")}set html(p){this.assertNotDisposed(),We(this,l,"f")!==p&&(it(this,l,p,"f"),!We(this,w,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(p)&&(it(this,w,!0,"f"),We(this,r,"f").report("Webview vscode-resource: uris",We(this,m,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),We(this,P,"f").$setHtml(We(this,D,"f"),p))}get options(){return this.assertNotDisposed(),We(this,f,"f")}set options(p){this.assertNotDisposed(),We(this,P,"f").$setOptions(We(this,D,"f"),s(We(this,m,"f"),We(this,g,"f"),p)),it(this,f,p,"f")}async postMessage(p){if(We(this,E,"f"))return!1;const S=(0,T.serializeWebviewMessage)(p,{serializeBuffersForPostMessage:We(this,_,"f")});return We(this,P,"f").$postMessage(We(this,D,"f"),S.message,...S.buffers)}assertNotDisposed(){if(We(this,E,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=o,D=new WeakMap,P=new WeakMap,r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,l=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,_=new WeakMap,d=new WeakMap;function c(h){try{const p=(0,A.normalizeVersion)((0,A.parseVersion)(h.engines.vscode));return!!p&&p.majorBase>=1&&p.minorBase>=57}catch(p){return!1}}e.shouldSerializeBuffersForPostMessage=c;class t{constructor(p,S,u,v,R){this.initData=S,this.workspace=u,this._logService=v,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=p.getProxy(k.MainContext.MainThreadWebviews)}$onMessage(p,S,...u){const v=this.getWebview(p);if(v){const{message:R}=(0,T.deserializeWebviewMessage)(S,u);v._onMessageEmitter.fire(R)}}$onMissingCsp(p,S){this._logService.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(p,S,u){const v=new o(p,this._webviewProxy,i(S),this.initData,this.workspace,u,this._deprecationService);return this._webviews.set(p,v),v._onDidDispose(()=>{this._webviews.delete(p)}),v}deleteWebview(p){this._webviews.delete(p)}getWebview(p){return this._webviews.get(p)}}e.ExtHostWebviews=t;function n(h){return{id:h.identifier,location:h.extensionLocation}}e.toExtensionData=n;function s(h,p,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||a(h,p)}}e.serializeWebviewOptions=s;function i(h){var p;return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,portMapping:h.portMapping,localResourceRoots:(p=h.localResourceRoots)===null||p===void 0?void 0:p.map(S=>I.URI.from(S))}}e.reviveOptions=i;function a(h,p){return[...((p==null?void 0:p.getWorkspaceFolders())||[]).map(S=>S.uri),h.extensionLocation]}}),define(me[250],ge([0,1,21,74,6,12,25,2,20,66,86,5,7]),function(G,e,b,I,A,T,y,k,D,P,r,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class m{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=o(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class l{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,s){const i=this.key(t,n.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const a=new m(n,s);return this._documents.set(i,a),a}delete(t,n){const s=this.key(t,n.uri);this._documents.delete(s)}key(t,n){return`${t}@@@${n}`}}var f;(function(c){c[c.Text=0]="Text",c[c.Custom=1]="Custom"})(f||(f={}));class E{constructor(){this._providers=new Map}addTextProvider(t,n,s){return this.add(0,t,n,s)}addCustomProvider(t,n,s){return this.add(1,t,n,s)}get(t){return this._providers.get(t)}add(t,n,s,i){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:s,provider:i}),new g.Disposable(()=>this._providers.delete(n))}}class w{constructor(t,n,s,i,a){this._extHostDocuments=n,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=a,this._editorProviders=new E,this._documents=new l,this._proxy=t.getProxy(C.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,s,i){const a=new A.DisposableStore;return _(s)?(a.add(this._editorProviders.addTextProvider(n,t,s)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(t),n,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(t))):(a.add(this._editorProviders.addCustomProvider(n,t,s)),this.supportEditing(s)&&a.add(s.onDidChangeCustomDocument(h=>{const p=this.getCustomDocumentEntry(n,h.document.uri);if(d(h)){const S=p.addEdit(h);this._proxy.$onDidEdit(h.document.uri,n,S,h.label)}else this._proxy.$onContentChange(h.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(t),n,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(t))),g.Disposable.from(a,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,s,i,a){var h;const p=this._editorProviders.get(n);if(!p)throw new Error(`No provider found for '${n}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${n}'`);const S=k.URI.revive(t),u=await p.provider.openCustomDocument(S,{backupId:s,untitledDocumentData:i==null?void 0:i.buffer},a);let v;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(v=(h=this._extensionStoragePaths.workspaceValue(p.extension))!==null&&h!==void 0?h:this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(n,u,v),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(t,n){const s=this._editorProviders.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const i=k.URI.revive(t),{document:a}=this.getCustomDocumentEntry(n,i);this._documents.delete(n,a),a.dispose()}async $resolveWebviewEditor(t,n,s,i,a,h){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);const S=D.ViewColumn.to(a),u=this._extHostWebview.createNewWebview(n,i.webviewOptions,p.extension),v=this._extHostWebviewPanels.createNewWebviewPanel(n,s,i.title,S,i.panelOptions,u),R=k.URI.revive(t);switch(p.type){case 1:{const{document:N}=this.getCustomDocumentEntry(s,R);return p.provider.resolveCustomEditor(N,v,h)}case 0:{const N=this._extHostDocuments.getDocument(R);return p.provider.resolveCustomTextEditor(N,v,h)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,s){this.getCustomDocumentEntry(n,t).disposeEdits(s)}async $onMoveCustomEditor(t,n,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const a=this._extHostWebviewPanels.getWebviewPanel(t);if(!a)throw new Error("No webview found");const h=k.URI.revive(n),p=this._extHostDocuments.getDocument(h);await i.provider.moveCustomTextEditor(p,a,b.CancellationToken.None)}async $undo(t,n,s,i){return this.getCustomDocumentEntry(n,t).undo(s,i)}async $redo(t,n,s,i){return this.getCustomDocumentEntry(n,t).redo(s,i)}async $revert(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,n,s){const i=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,n,s,i){const a=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(a.document,k.URI.revive(s),i)}async $backup(t,n,s){const i=this.getCustomDocumentEntry(n,t),h=await this.getCustomEditorProvider(n).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(h),h.id}getCustomDocumentEntry(t,n){const s=this._documents.get(t,k.URI.revive(n));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const n=this._editorProviders.get(t),s=n==null?void 0:n.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=w;function _(c){return typeof c.resolveCustomTextEditor=="function"}function d(c){return typeof c.undo=="function"&&typeof c.redo=="function"}function o(c){const t=c.scheme===T.Schemas.file||c.scheme===T.Schemas.untitled?c.fsPath:c.toString();return(0,I.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[251],ge([0,1,3,6,2,30,20,66,5,7]),function(G,e,b,I,A,T,y,k,D,P){"use strict";var r,C,g,m,l,f,E,w,_,d,o,c,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends I.Disposable{constructor(h,p,S,u,v,R,N){super();r.set(this,void 0),C.set(this,void 0),g.set(this,void 0),m.set(this,void 0),l.set(this,void 0),f.set(this,void 0),E.set(this,void 0),w.set(this,void 0),_.set(this,!0),d.set(this,!0),o.set(this,!1),c.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,c,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=We(this,t,"f").event,it(this,r,h,"f"),it(this,C,p,"f"),it(this,g,S,"f"),it(this,l,R,"f"),it(this,w,v,"f"),it(this,f,u,"f"),it(this,m,N,"f")}dispose(){We(this,o,"f")||(it(this,o,!0,"f"),We(this,c,"f").fire(),We(this,C,"f").$disposeWebview(We(this,r,"f")),We(this,m,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),We(this,m,"f")}get viewType(){return this.assertNotDisposed(),We(this,g,"f")}get title(){return this.assertNotDisposed(),We(this,f,"f")}set title(h){this.assertNotDisposed(),We(this,f,"f")!==h&&(it(this,f,h,"f"),We(this,C,"f").$setTitle(We(this,r,"f"),h))}get iconPath(){return this.assertNotDisposed(),We(this,E,"f")}set iconPath(h){this.assertNotDisposed(),We(this,E,"f")!==h&&(it(this,E,h,"f"),We(this,C,"f").$setIconPath(We(this,r,"f"),A.URI.isUri(h)?{light:h,dark:h}:h))}get options(){return We(this,l,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof We(this,w,"f")=="number"&&We(this,w,"f")<0))return We(this,w,"f")}get active(){return this.assertNotDisposed(),We(this,d,"f")}get visible(){return this.assertNotDisposed(),We(this,_,"f")}_updateViewState(h){We(this,o,"f")||(this.active!==h.active||this.visible!==h.visible||this.viewColumn!==h.viewColumn)&&(it(this,d,h.active,"f"),it(this,_,h.visible,"f"),it(this,w,h.viewColumn,"f"),We(this,t,"f").fire({webviewPanel:this}))}reveal(h,p){this.assertNotDisposed(),We(this,C,"f").$reveal(We(this,r,"f"),{viewColumn:h?y.ViewColumn.from(h):void 0,preserveFocus:!!p})}assertNotDisposed(){if(We(this,o,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,l=new WeakMap,f=new WeakMap,E=new WeakMap,w=new WeakMap,_=new WeakMap,d=new WeakMap,o=new WeakMap,c=new WeakMap,t=new WeakMap;class s{constructor(h,p,S){this.webviews=p,this.workspace=S,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=h.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(h,p,S,u,v={}){const R=typeof u=="object"?u.viewColumn:u,N={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof u=="object"&&!!u.preserveFocus},j=(0,k.shouldSerializeBuffersForPostMessage)(h),ie=s.newHandle();this._proxy.$createWebviewPanel((0,k.toExtensionData)(h),ie,p,{title:S,panelOptions:i(v),webviewOptions:(0,k.serializeWebviewOptions)(h,this.workspace,v),serializeBuffersForPostMessage:j},N);const K=this.webviews.createNewWebview(ie,v,h);return this.createNewWebviewPanel(ie,p,S,R,v,K)}$onDidChangeWebviewPanelViewStates(h){const p=Object.keys(h);p.sort((S,u)=>{const v=h[S],R=h[u];return v.active?1:R.active?-1:+v.visible-+R.visible});for(const S of p){const u=this.getWebviewPanel(S);if(!!u){const v=h[S];u._updateViewState({active:v.active,visible:v.visible,viewColumn:y.ViewColumn.to(v.position)})}}}async $onDidDisposeWebviewPanel(h){const p=this.getWebviewPanel(h);p==null||p.dispose(),this._webviewPanels.delete(h),this.webviews.deleteWebview(h)}registerWebviewPanelSerializer(h,p,S){if(this._serializers.has(p))throw new Error(`Serializer for '${p}' already registered`);return this._serializers.set(p,{serializer:S,extension:h}),this._proxy.$registerSerializer(p,{serializeBuffersForPostMessage:(0,k.shouldSerializeBuffersForPostMessage)(h)}),new P.Disposable(()=>{this._serializers.delete(p),this._proxy.$unregisterSerializer(p)})}async $deserializeWebviewPanel(h,p,S,u){const v=this._serializers.get(p);if(!v)throw new Error(`No serializer found for '${p}'`);const{serializer:R,extension:N}=v,j=this.webviews.createNewWebview(h,S.webviewOptions,N),ie=this.createNewWebviewPanel(h,p,S.title,u,S.panelOptions,j);await R.deserializeWebviewPanel(ie,S.state)}createNewWebviewPanel(h,p,S,u,v,R){const N=new n(h,this._proxy,p,S,u,v,R);return this._webviewPanels.set(h,N),N}getWebviewPanel(h){return this._webviewPanels.get(h)}}e.ExtHostWebviewPanels=s;function i(a){return{enableFindWidget:a.enableFindWidget,retainContextWhenHidden:a.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[252],ge([0,1,3,6,66,5,7]),function(G,e,b,I,A,T,y){"use strict";var k,D,P,r,C,g,m,l,f,E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class w extends I.Disposable{constructor(o,c,t,n,s,i){super();k.set(this,void 0),D.set(this,void 0),P.set(this,void 0),r.set(this,void 0),C.set(this,!1),g.set(this,void 0),m.set(this,void 0),l.set(this,void 0),f.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=We(this,f,"f").event,E.set(this,this._register(new b.Emitter)),this.onDidDispose=We(this,E,"f").event,it(this,P,t,"f"),it(this,m,n,"f"),it(this,k,o,"f"),it(this,D,c,"f"),it(this,r,s,"f"),it(this,g,i,"f")}dispose(){We(this,C,"f")||(it(this,C,!0,"f"),We(this,E,"f").fire(),We(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),We(this,m,"f")}set title(o){this.assertNotDisposed(),We(this,m,"f")!==o&&(it(this,m,o,"f"),We(this,D,"f").$setWebviewViewTitle(We(this,k,"f"),o))}get description(){return this.assertNotDisposed(),We(this,l,"f")}set description(o){this.assertNotDisposed(),We(this,l,"f")!==o&&(it(this,l,o,"f"),We(this,D,"f").$setWebviewViewDescription(We(this,k,"f"),o))}get visible(){return We(this,g,"f")}get webview(){return We(this,r,"f")}get viewType(){return We(this,P,"f")}_setVisible(o){o===We(this,g,"f")||We(this,C,"f")||(it(this,g,o,"f"),We(this,f,"f").fire())}show(o){this.assertNotDisposed(),We(this,D,"f").$show(We(this,k,"f"),!!o)}assertNotDisposed(){if(We(this,C,"f"))throw new Error("Webview is disposed")}}k=new WeakMap,D=new WeakMap,P=new WeakMap,r=new WeakMap,C=new WeakMap,g=new WeakMap,m=new WeakMap,l=new WeakMap,f=new WeakMap,E=new WeakMap;class _{constructor(o,c){this._extHostWebview=c,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=o.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(o,c,t,n){if(this._viewProviders.has(c))throw new Error(`View provider for '${c}' already registered`);return this._viewProviders.set(c,{provider:t,extension:o}),this._proxy.$registerWebviewViewProvider((0,A.toExtensionData)(o),c,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(c),this._proxy.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(o,c,t,n,s){const i=this._viewProviders.get(c);if(!i)throw new Error(`No view provider found for '${c}'`);const{provider:a,extension:h}=i,p=this._extHostWebview.createNewWebview(o,{},h),S=new w(o,this._proxy,c,t,p,!0);this._webviewViews.set(o,S),await a.resolveWebviewView(S,{state:n},s)}async $onDidChangeWebviewViewVisibility(o,c){this.getWebviewView(o)._setVisible(c)}async $disposeWebviewView(o){const c=this.getWebviewView(o);this._webviewViews.delete(o),c.dispose(),this._extHostWebview.deleteWebview(o)}getWebviewView(o){const c=this._webviewViews.get(o);if(!c)throw new Error("No webview found");return c}}e.ExtHostWebviewViews=_}),define(me[128],ge([0,1,3,5,2,12,9,4,15]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class xn{constructor(C){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=C.getProxy(I.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}get state(){return this._state}$onDidChangeWindowFocus(C){C!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:C}),this._onDidChangeWindowState.fire(this._state))}openUri(C,g){let m;if(typeof C=="string"){m=C;try{C=A.URI.parse(C)}catch(l){return Promise.reject(`Invalid uri - '${C}'`)}}return(0,y.isFalsyOrWhitespace)(C.scheme)?Promise.reject("Invalid scheme - cannot be empty"):C.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${C.scheme}'`):this._proxy.$openUri(C,m,g)}async asExternalUri(C,g){if((0,y.isFalsyOrWhitespace)(C.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(C.scheme))return Promise.reject(`Invalid scheme '${C.scheme}'`);const m=await this._proxy.$asExternalUri(C,g);return A.URI.from(m)}};P.InitialState={focused:!0},P=qe([He(0,D.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,k.createDecorator)("IExtHostWindow")}),define(me[253],ge([0,1,8,48,30,51,6,5,2,15]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends y.Disposable{constructor(g,m){super();const l=g.getProxy(k.MainContext.MainThreadDownloadService);m.registerCommand(!1,"_workbench.downloadResource",async f=>{const E=D.URI.file((0,b.join)((0,I.tmpdir)(),(0,A.generateUuid)()));return await l.$download(f,E),E})}};r=qe([He(0,P.IExtHostRpcService),He(1,T.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(me[254],ge([0,1,2,8,146,26,37,65,28,15,6,14,114,45]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=e.ExtHostOutputChannelBackedByFile=void 0;class l{constructor(_,d){this.file=d,this.appender=(0,g.createRotatingLogger)(_,d,30*m.ByteSize.MB,1),this.appender.clearFormatters()}append(_){this.appender.critical(_)}flush(){this.appender.flush()}}class f extends k.AbstractExtHostOutputChannel{constructor(_,d,o){super(_,!1,b.URI.file(d.file),o);this._appender=d}append(_){super.append(_),this._appender.append(_),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(_,d){this._appender.flush(),super.show(_,d)}clear(){this._appender.flush(),super.clear()}}e.ExtHostOutputChannelBackedByFile=f;let E=class extends k.ExtHostOutputService{constructor(_,d,o){super(_);this.logService=d,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new r.MutableDisposable,this._logsLocation=o.logsLocation}$setVisibleChannel(_){if(_){const d=this._channels.get(_);d&&(this._visibleChannelDisposable.value=d.onDidAppend(()=>d.update()))}}createOutputChannel(_){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");const d=this._doCreateOutChannel(_);return d.then(o=>o._id.then(c=>this._channels.set(c,o))),new k.LazyOutputChannel(_,d)}async _doCreateOutChannel(_){try{const d=(0,I.join)(this._logsLocation.fsPath,`output_logging_${(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await T.SymlinkSupport.existsDirectory(d)||await y.promises.mkdir(d,{recursive:!0});const c=`${this._namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}`,t=b.URI.file((0,I.join)(d,`${c}.log`)),n=new l(c,t.fsPath);return new f(_,n,this._proxy)}catch(d){return this.logService.error(d),new k.ExtHostPushOutputChannel(_,this._proxy)}}};E=qe([He(0,P.IExtHostRpcService),He(1,C.ILogService),He(2,D.IExtHostInitDataService)],E),e.ExtHostOutputService2=E}),define(me[255],ge([0,1,5,15,6,28,2,38,25,37,26,7,10,50,3,73,14]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class w{constructor(p,S,u){this.remoteAddress=p,this.localAddress=S,this._dispose=u,this._onDispose=new l.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function _(h){const p=h.trim().split(`
`),S=[];return p.forEach(v=>{const R=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(v);R&&R.length>=3&&S.push({pid:parseInt(R[1],10),socket:parseInt(R[2],10)})}),S.reduce((v,R)=>(v[R.socket]=R,v),{})}e.getSockets=_;function d(...h){const p=[].concat(...h.map(c));return[...new Map(p.filter(S=>S.st==="0A").map(S=>{const u=S.local_address.split(":");return{socket:parseInt(S.inode,10),ip:o(u[0]),port:parseInt(u[1],16)}}).map(S=>[S.ip+":"+S.port,S])).values()]}e.loadListeningPorts=d;function o(h){let p="";if(h.length===8)for(let S=h.length-2;S>=0;S-=2)p+=parseInt(h.substr(S,2),16),S!==0&&(p+=".");else for(let S=h.length-4;S>=0;S-=4)p+=parseInt(h.substr(S,4),16).toString(16),S!==0&&(p+=":");return p}e.parseIpAddress=o;function c(h){const p=h.trim().split(`
`),S=p.shift().trim().split(/\s+/).filter(v=>v!=="rx_queue"&&v!=="tm->when");return p.map(v=>v.trim().split(/\s+/).reduce((R,N,j)=>(R[S[j]||j]=N,R),{}))}e.loadConnectionTable=c;function t(h){return!!h.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||h.indexOf("out/vs/server/main.js")!==-1||h.indexOf("_productName=VSCode")!==-1}function n(h){const p=h.trim().split(`
`),S=[];return p.forEach(u=>{const v=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(u);v&&v.length>=4&&S.push({pid:parseInt(v[1],10),ppid:parseInt(v[2]),cmd:v[3]})}),S}e.getRootProcesses=n;async function s(h,p,S){const u=S.reduce((R,N)=>(R[N.pid]=N,R),{}),v=[];return h.forEach(({socket:R,ip:N,port:j})=>{var ie;const K=p[R]?p[R].pid:void 0,B=K?(ie=u[K])===null||ie===void 0?void 0:ie.cmd:void 0;K&&B&&!t(B)&&v.push({host:N,port:j,detail:B,pid:K})}),v}e.findPorts=s;function i(h,p,S){const u=new Map,v=n(p);for(const R of h){const N=S.get(R.port);if(N){u.set(R.port,N);continue}const j=v.find(ie=>ie.cmd.includes(`${R.port}`));if(j){let ie=j,K;do K=v.find(B=>B.ppid===ie.pid),K&&(ie=K);while(K);u.set(R.port,{host:R.ip,port:R.port,pid:ie.pid,detail:ie.cmd,ppid:ie.ppid})}else u.set(R.port,{host:R.ip,port:R.port,ppid:Number.MAX_VALUE})}return u}e.tryFindRootPorts=i;let a=class extends A.Disposable{constructor(p,S,u){super();this.logService=u,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new l.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=p.getProxy(b.MainContext.MainThreadTunnelService),g.isLinux&&S.remote.isRemote&&S.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(p,S){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${p.identifier.value} called openTunnel API for ${S.remoteAddress.host}:${S.remoteAddress.port}.`);const u=await this._proxy.$openTunnel(S,p.displayName);if(u){const v=new w(u.remoteAddress,u.localAddress,()=>this._proxy.$closeTunnel(u.remoteAddress));return this._register(v),v}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(p){return Math.max(p*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(p,S){const u=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(u,{selector:p,provider:S}),this._proxy.$registerPortsAttributesProvider(p,u),new C.Disposable(()=>{this._portAttributesProviders.delete(u),this._proxy.$unregisterPortsAttributesProvider(u)})}async $providePortAttributes(p,S,u,v,R){const N=[];for(const ie of p){const K=this._portAttributesProviders.get(ie);if(!K)return[];N.push(...await Promise.all(S.map(async B=>K.provider.providePortAttributes(B,u,v,R))))}const j=N.filter(ie=>!!ie);return j.length>0?j.map(ie=>({autoForwardAction:ie.autoForwardAction,port:ie.port})):[]}async $registerCandidateFinder(p){if(!(p&&this._candidateFindingEnabled)){this._candidateFindingEnabled=p;let S=new f.MovingAverage,u;for(;this._candidateFindingEnabled;){const v=new Date().getTime(),R=await this.findCandidatePorts();this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${R.map(j=>j.port).join(", ")}`);const N=new Date().getTime()-v;S.update(N),(!u||JSON.stringify(u)!==JSON.stringify(R))&&(u=R,await this._proxy.$onFoundNewCandidates(u)),await new Promise(j=>setTimeout(()=>j(),this.calculateDelay(S.value)))}}}async setTunnelExtensionFunctions(p){var S;return p?(p.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(p.candidatePortSource),p.showCandidatePort&&(this._showCandidatePort=p.showCandidatePort,this._proxy.$setCandidateFilter()),p.tunnelFactory&&(this._forwardPortProvider=p.tunnelFactory,this._proxy.$setTunnelProvider((S=p.tunnelFeatures)!==null&&S!==void 0?S:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,(0,A.toDisposable)(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(p,S){if(this._extensionTunnels.has(p.host)){const u=this._extensionTunnels.get(p.host);u.has(p.port)&&(S&&u.get(p.port).disposeListener.dispose(),await u.get(p.port).tunnel.dispose(),u.delete(p.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(p,S){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const u=this._forwardPortProvider(p,S);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),u!==void 0){const v=await u;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(p.remoteAddress.host)||this._extensionTunnels.set(p.remoteAddress.host,new Map);const R=this._register(v.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(v.remoteAddress))));return this._extensionTunnels.get(p.remoteAddress.host).set(p.remoteAddress.port,{tunnel:v,disposeListener:R}),m.TunnelDto.fromApiTunnel(v)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(u){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(p){const S=await Promise.all(p.map(v=>{var R;return this._showCandidatePort(v.host,v.port,(R=v.detail)!==null&&R!==void 0?R:"")})),u=p.filter((v,R)=>S[R]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${p.map(v=>v.port).join(", ")} to ${u.map(v=>v.port).join(", ")}`),u}async findCandidatePorts(){let p="",S="";try{p=await P.promises.readFile("/proc/net/tcp","utf8"),S=await P.promises.readFile("/proc/net/tcp6","utf8")}catch(U){}const u=d(p,S),v=await new Promise(U=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(L,O,M)=>{U(O)})}),R=_(v),N=await r.readdir("/proc"),j=[];for(let U of N)try{const L=Number(U),O=D.joinPath(y.URI.file("/proc"),U);if((await P.promises.stat(O.fsPath)).isDirectory()&&!isNaN(L)){const F=await P.promises.readlink(D.joinPath(O,"cwd").fsPath),W=await P.promises.readFile(D.joinPath(O,"cmdline").fsPath,"utf8");j.push({pid:L,cwd:F,cmd:W})}}catch(L){}const ie=[],K=u.filter(U=>{const L=R[U.socket];return L||ie.push(U),L}),B=s(K,R,j);let $;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${ie.length}`),ie.length>0){const U=await new Promise(L=>{(0,k.exec)("ps -F -A -l | grep root",(O,M,F)=>{L(M)})});this._foundRootPorts=i(ie,U,this._foundRootPorts),$=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${$.join(", ")}`)}return B.then(U=>$?U.concat($):U)}};a=qe([He(0,I.IExtHostRpcService),He(1,T.IExtHostInitDataService),He(2,E.ILogService)],a),e.ExtHostTunnelService=a}),define(me[256],ge([0,1,13,21,17,3,6,102,226,126,23]),function(G,e,b,I,A,T,y,k,D,P,r){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function g(i,a){try{return JSON.stringify(i,a)}catch(h){return"null"}}function m(i,a){return JSON.stringify(i,a)}function l(i){return i?(a,h)=>h&&h.$mid===1?i.transformOutgoing(h):h:null}var f;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const w=()=>{},_=Symbol.for("rpcProtocol"),d=Symbol.for("rpcProxy");class o extends y.Disposable{constructor(a,h=null,p=null){super();this[C]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=a,this._logger=h,this._uriTransformer=p,this._uriReplacer=l(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,u=P.ProxyIdentifier.count;S<u;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(a=>{this._pendingRPCReplies[a].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(a){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(a){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(a){this._responsiveState!==a&&(this._responsiveState=a,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(a){return this._uriTransformer?(0,k.transformIncomingURIs)(a,this._uriTransformer):a}getProxy(a){const{nid:h,sid:p}=a;return this._proxies[h]||(this._proxies[h]=this._createProxy(h,p)),this._proxies[h]}_createProxy(a,h){let p={get:(S,u)=>(typeof u=="string"&&!S[u]&&u.charCodeAt(0)===36&&(S[u]=(...v)=>this._remoteCall(a,u,v)),u===d?h:S[u])};return new Proxy(Object.create(null),p)}set(a,h){return this._locals[a.nid]=h,h}assertRegistered(a){for(let h=0,p=a.length;h<p;h++){const S=a[h];if(!this._locals[S.nid])throw new Error(`Missing actor ${S.sid} (isMain: ${S.isMain})`)}}_receiveOneMessage(a){if(!this._isDisposed){const h=a.byteLength,p=c.read(a,0),S=p.readUInt8(),u=p.readUInt32();switch(S){case 1:case 2:{let{rpcId:v,method:R,args:N}=t.deserializeRequestJSONArgs(p);this._uriTransformer&&(N=(0,k.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(h,u,v,R,N,S===2);break}case 3:case 4:{let{rpcId:v,method:R,args:N}=t.deserializeRequestMixedArgs(p);this._uriTransformer&&(N=(0,k.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(h,u,v,R,N,S===4);break}case 5:{this._logger&&this._logger.logIncoming(h,u,0,"ack"),this._onDidReceiveAcknowledge(u);break}case 6:{this._receiveCancel(h,u);break}case 7:{this._receiveReply(h,u,void 0);break}case 9:{let v=t.deserializeReplyOKJSON(p);this._uriTransformer&&(v=(0,k.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReply(h,u,v);break}case 8:{let v=t.deserializeReplyOKVSBuffer(p);this._receiveReply(h,u,v);break}case 10:{let v=t.deserializeReplyErrError(p);this._uriTransformer&&(v=(0,k.transformIncomingURIs)(v,this._uriTransformer)),this._receiveReplyErr(h,u,v);break}case 11:{this._receiveReplyErr(h,u,void 0);break}default:console.error("received unexpected message"),console.error(a)}}}_receiveRequest(a,h,p,S,u,v){this._logger&&this._logger.logIncoming(a,h,1,`receiveRequest ${(0,P.getStringIdentifierForProxy)(p)}.${S}(`,u);const R=String(h);let N,j;if(v){const K=new I.CancellationTokenSource;u.push(K.token),N=this._invokeHandler(p,S,u),j=()=>K.cancel()}else N=this._invokeHandler(p,S,u),j=w;this._cancelInvokedHandlers[R]=j;const ie=t.serializeAcknowledged(h);this._logger&&this._logger.logOutgoing(ie.byteLength,h,1,"ack"),this._protocol.send(ie),N.then(K=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyOK(h,K,this._uriReplacer);this._logger&&this._logger.logOutgoing(B.byteLength,h,1,"reply:",K),this._protocol.send(B)},K=>{delete this._cancelInvokedHandlers[R];const B=t.serializeReplyErr(h,K);this._logger&&this._logger.logOutgoing(B.byteLength,h,1,"replyErr:",K),this._protocol.send(B)})}_receiveCancel(a,h){this._logger&&this._logger.logIncoming(a,h,1,"receiveCancel");const p=String(h);this._cancelInvokedHandlers[p]&&this._cancelInvokedHandlers[p]()}_receiveReply(a,h,p){this._logger&&this._logger.logIncoming(a,h,0,"receiveReply:",p);const S=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const u=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],u.resolveOk(p)}}_receiveReplyErr(a,h,p){this._logger&&this._logger.logIncoming(a,h,0,"receiveReplyErr:",p);const S=String(h);if(!!this._pendingRPCReplies.hasOwnProperty(S)){const u=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let v;p&&(p.$isError?(v=new Error,v.name=p.name,v.message=p.message,v.stack=p.stack):v=p),u.resolveErr(v)}}_invokeHandler(a,h,p){try{return Promise.resolve(this._doInvokeHandler(a,h,p))}catch(S){return Promise.reject(S)}}_doInvokeHandler(a,h,p){const S=this._locals[a];if(!S)throw new Error("Unknown actor "+(0,P.getStringIdentifierForProxy)(a));let u=S[h];if(typeof u!="function")throw new Error("Unknown method "+h+" on actor "+(0,P.getStringIdentifierForProxy)(a));return u.apply(S,p)}_remoteCall(a,h,p){if(this._isDisposed)return Promise.reject(A.canceled());let S=null;if(p.length>0&&I.CancellationToken.isCancellationToken(p[p.length-1])&&(S=p.pop()),S&&S.isCancellationRequested)return Promise.reject(A.canceled());const u=t.serializeRequestArguments(p,this._uriReplacer),v=++this._lastMessageId,R=String(v),N=new D.LazyPromise;S&&S.onCancellationRequested(()=>{const ie=t.serializeCancel(v);this._logger&&this._logger.logOutgoing(ie.byteLength,v,0,"cancel"),this._protocol.send(t.serializeCancel(v))}),this._pendingRPCReplies[R]=N,this._onWillSendRequest(v);const j=t.serializeRequest(v,a,h,u,!!S);return this._logger&&this._logger.logOutgoing(j.byteLength,v,0,`request: ${(0,P.getStringIdentifierForProxy)(a)}.${h}(`,p),this._protocol.send(j),N}}e.RPCProtocol=o,C=_,o.UNRESPONSIVE_TIME=3*1e3;class c{constructor(a,h){this._buff=a,this._offset=h}static alloc(a,h,p){let S=new c(r.VSBuffer.alloc(p+1+4),0);return S.writeUInt8(a),S.writeUInt32(h),S}static read(a,h){return new c(a,h)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(a){this._buff.writeUInt8(a,this._offset),this._offset+=1}readUInt8(){const a=this._buff.readUInt8(this._offset);return this._offset+=1,a}writeUInt32(a){this._buff.writeUInt32BE(a,this._offset),this._offset+=4}readUInt32(){const a=this._buff.readUInt32BE(this._offset);return this._offset+=4,a}static sizeShortString(a){return 1+a.byteLength}writeShortString(a){this._buff.writeUInt8(a.byteLength,this._offset),this._offset+=1,this._buff.set(a,this._offset),this._offset+=a.byteLength}readShortString(){const a=this._buff.readUInt8(this._offset);this._offset+=1;const p=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,p}static sizeLongString(a){return 4+a.byteLength}writeLongString(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readLongString(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const p=this._buff.slice(this._offset,this._offset+a).toString();return this._offset+=a,p}writeBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}static sizeVSBuffer(a){return 4+a.byteLength}writeVSBuffer(a){this._buff.writeUInt32BE(a.byteLength,this._offset),this._offset+=4,this._buff.set(a,this._offset),this._offset+=a.byteLength}readVSBuffer(){const a=this._buff.readUInt32BE(this._offset);this._offset+=4;const h=this._buff.slice(this._offset,this._offset+a);return this._offset+=a,h}static sizeMixedArray(a,h){let p=0;p+=1;for(let S=0,u=a.length;S<u;S++){const v=a[S],R=h[S];switch(p+=1,R){case 1:p+=this.sizeLongString(v);break;case 2:p+=this.sizeVSBuffer(v);break;case 3:break}}return p}writeMixedArray(a,h){this._buff.writeUInt8(a.length,this._offset),this._offset+=1;for(let p=0,S=a.length;p<S;p++){const u=a[p];switch(h[p]){case 1:this.writeUInt8(1),this.writeLongString(u);break;case 2:this.writeUInt8(2),this.writeVSBuffer(u);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const a=this._buff.readUInt8(this._offset);this._offset+=1;let h=new Array(a);for(let p=0;p<a;p++)switch(this.readUInt8()){case 1:h[p]=this.readLongString();break;case 2:h[p]=this.readVSBuffer();break;case 3:h[p]=void 0;break}return h}}class t{static _arrayContainsBufferOrUndefined(a){for(let h=0,p=a.length;h<p;h++)if(a[h]instanceof r.VSBuffer||typeof a[h]=="undefined")return!0;return!1}static serializeRequestArguments(a,h){if(this._arrayContainsBufferOrUndefined(a)){let p=[],S=[];for(let u=0,v=a.length;u<v;u++){const R=a[u];R instanceof r.VSBuffer?(p[u]=R,S[u]=2):typeof R=="undefined"?(p[u]=r.VSBuffer.alloc(0),S[u]=3):(p[u]=r.VSBuffer.fromString(m(R,h)),S[u]=1)}return{type:"mixed",args:p,argsType:S}}return{type:"simple",args:m(a,h)}}static serializeRequest(a,h,p,S,u){return S.type==="mixed"?this._requestMixedArgs(a,h,p,S.args,S.argsType,u):this._requestJSONArgs(a,h,p,S.args,u)}static _requestJSONArgs(a,h,p,S,u){const v=r.VSBuffer.fromString(p),R=r.VSBuffer.fromString(S);let N=0;N+=c.sizeUInt8(),N+=c.sizeShortString(v),N+=c.sizeLongString(R);let j=c.alloc(u?2:1,a,N);return j.writeUInt8(h),j.writeShortString(v),j.writeLongString(R),j.buffer}static deserializeRequestJSONArgs(a){const h=a.readUInt8(),p=a.readShortString(),S=a.readLongString();return{rpcId:h,method:p,args:JSON.parse(S)}}static _requestMixedArgs(a,h,p,S,u,v){const R=r.VSBuffer.fromString(p);let N=0;N+=c.sizeUInt8(),N+=c.sizeShortString(R),N+=c.sizeMixedArray(S,u);let j=c.alloc(v?4:3,a,N);return j.writeUInt8(h),j.writeShortString(R),j.writeMixedArray(S,u),j.buffer}static deserializeRequestMixedArgs(a){const h=a.readUInt8(),p=a.readShortString(),S=a.readMixedArray(),u=new Array(S.length);for(let v=0,R=S.length;v<R;v++){const N=S[v];typeof N=="string"?u[v]=JSON.parse(N):u[v]=N}return{rpcId:h,method:p,args:u}}static serializeAcknowledged(a){return c.alloc(5,a,0).buffer}static serializeCancel(a){return c.alloc(6,a,0).buffer}static serializeReplyOK(a,h,p){return typeof h=="undefined"?this._serializeReplyOKEmpty(a):h instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(a,h):this._serializeReplyOKJSON(a,g(h,p))}static _serializeReplyOKEmpty(a){return c.alloc(7,a,0).buffer}static _serializeReplyOKVSBuffer(a,h){let p=0;p+=c.sizeVSBuffer(h);let S=c.alloc(8,a,p);return S.writeVSBuffer(h),S.buffer}static deserializeReplyOKVSBuffer(a){return a.readVSBuffer()}static _serializeReplyOKJSON(a,h){const p=r.VSBuffer.fromString(h);let S=0;S+=c.sizeLongString(p);let u=c.alloc(9,a,S);return u.writeLongString(p),u.buffer}static deserializeReplyOKJSON(a){const h=a.readLongString();return JSON.parse(h)}static serializeReplyErr(a,h){return h?this._serializeReplyErrEror(a,h):this._serializeReplyErrEmpty(a)}static _serializeReplyErrEror(a,h){const p=r.VSBuffer.fromString(g(A.transformErrorForSerialization(h),null));let S=0;S+=c.sizeLongString(p);let u=c.alloc(10,a,S);return u.writeLongString(p),u.buffer}static deserializeReplyErrError(a){const h=a.readLongString();return JSON.parse(h)}static _serializeReplyErrEmpty(a){return c.alloc(11,a,0).buffer}}var n;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(me[257],ge([0,1,4]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(me[258],ge([0,1,12,8,10,2,4,257]),function(G,e,b,I,A,T,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let D=class{constructor(r,C){this.localUserHome=r,this.remoteAgentService=C,this.resolveOS=(async()=>{const g=await this.remoteAgentService.getEnvironment();return(g==null?void 0:g.os)||A.OS})(),this.resolveUserHome=(async()=>{const g=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(g==null?void 0:g.userHome)||r})()}async userHome(r){return(r==null?void 0:r.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(r=>r===1?I.win32:I.posix)}async fileURI(r){let C="";if(await this.resolveOS===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const m=r.indexOf("/",2);m===-1?(C=r.substring(2),r="/"):(C=r.substring(2,m),r=r.substring(m)||"/")}return T.URI.from({scheme:b.Schemas.file,authority:C,path:r,query:"",fragment:""})}};D=qe([He(1,k.IRemoteAgentService)],D),e.AbstractPathService=D}),define(me[67],ge([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,k){this.line=y,this.character=k}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,k){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class I{constructor(y,k,D,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,k),this.end=new b(D,P)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new I(0,0,0,0)}with(y){return new I(0,0,0,0)}}e.Range=I;var A;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(A=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(me[31],ge([0,1,16,33,24,29,9,4,8,17,67]),function(G,e,b,I,A,T,y,k,D,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const C="\u27EA ",g=" characters skipped \u27EB",m=(C.length+g.length+5)*2;e.ISearchService=(0,k.createDecorator)("searchService");var l;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(l=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function E(L){return!!L.preview}e.resultIsMatch=E;function w(L){return!!L.resource}e.isFileMatch=w;function _(L){return!!L.message}e.isProgressMessage=_;var d;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(d=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class o{constructor(O){this.resource=O,this.results=[]}}e.FileMatch=o;class c{constructor(O,M,F){this.ranges=M;const W=Array.isArray(M)?M:[M];if(F&&F.matchLines===1&&t(W)){O=(0,y.getNLines)(O,F.matchLines);let q="",Q=0,le=0;const ve=Math.floor(F.charsPerLine/5),Re=[];for(const Se of W){const Oe=Math.max(Se.startColumn-ve,0),z=Se.startColumn+F.charsPerLine;if(Oe>le+ve+m){const Y=C+(Oe-le)+g;q+=Y+O.slice(Oe,z),Q+=Oe-(le+Y.length)}else q+=O.slice(le,z);Re.push(new s(0,Se.startColumn-Q,Se.endColumn-Q)),le=z}this.preview={text:q,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const q=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:O,matches:(0,b.mapArrayOrNot)(M,Q=>new n(Q.startLineNumber-q,Q.startColumn,Q.endLineNumber-q,Q.endColumn))}}}}e.TextSearchMatch=c;function t(L){const O=L[0].startLineNumber;for(const M of L)if(M.startLineNumber!==O||M.endLineNumber!==O)return!1;return!0}class n{constructor(O,M,F,W){this.startLineNumber=O,this.startColumn=M,this.endLineNumber=F,this.endColumn=W}}e.SearchRange=n;class s extends n{constructor(O,M,F){super(O,M,O,F)}}e.OneLineRange=s;var i;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function a(L,O=!0){const M=L&&L.files&&L.files.exclude,F=O&&L&&L.search&&L.search.exclude;if(!(!M&&!F)){if(!M||!F)return M||F;let W=Object.create(null);return W=A.mixin(W,A.deepClone(M)),W=A.mixin(W,A.deepClone(F),!0),W}}e.getExcludes=a;function h(L,O){return L.excludePattern&&I.match(L.excludePattern,O)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&I.match(L.includePattern,O)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(M=>{const F=M.folder.fsPath;if(T.isEqualOrParent(O,F)){const W=D.relative(F,O);return!M.includePattern||!!I.match(M.includePattern,W)}else return!1}):!1:!0}e.pathIncludedInQuery=h;var p;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(p=e.SearchErrorCode||(e.SearchErrorCode={}));class S extends Error{constructor(O,M){super(O);this.code=M}}e.SearchError=S;function u(L){const O=L.message;if((0,P.isPromiseCanceledError)(L))return new S(O,p.canceled);try{const M=JSON.parse(O);return new S(M.message,M.code)}catch(M){return new S(O,p.other)}}e.deserializeSearchError=u;function v(L){const O={message:L.message,code:L.code};return new Error(JSON.stringify(O))}e.serializeSearchError=v;function R(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=R;function N(L){return L.type==="success"}e.isSerializedSearchSuccess=N;function j(L){return!!L.path}e.isSerializedFileMatch=j;function ie(L,O){const M=L.searchPath?L.searchPath:L.relativePath;return(0,y.fuzzyContains)(M,O)}e.isFilePatternMatch=ie;class K{constructor(O){this.path=O,this.results=[]}addMatch(O){this.results.push(O)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=K;function B(L,O){const M=Object.assign(Object.assign({},L||{}),O||{});return Object.keys(M).filter(F=>{const W=M[F];return typeof W=="boolean"&&W})}e.resolvePatternsForProvider=B;class ${constructor(O,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},O.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=I.parse(this._excludeExpression);let F=O.includePattern;M.includePattern&&(F?F=Object.assign(Object.assign({},F),M.includePattern):F=M.includePattern),F&&(this._parsedIncludeExpression=I.parse(F))}includedInQuerySync(O,M,F){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(O,M,F)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(O,M,F))}includedInQuery(O,M,F){return Promise.resolve(this._parsedExcludeExpression(O,M,F)).then(q=>!!q).then(q=>q?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(O,M,F)).then(Q=>!!Q):Promise.resolve(!0)).then(q=>q)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=$;function U(L){for(const O in L)if(typeof L[O]!="boolean")return!0;return!1}}),define(me[32],ge([0,1,16,13,21,3,22,12,73,25,9,11,2,167,4,14,186,61,62,28,15,7,31,5]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o,c,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,N,j){return new P.ExtUri(ie=>p(ie,j)).isEqual(R,N)}function i(R,N,j){return s(R.uri,N.uri,j)?0:(0,r.compare)(R.uri.toString(),N.uri.toString())}function a(R,N,j){return R.index!==N.index?R.index<N.index?-1:1:s(R.uri,N.uri,j)?(0,r.compare)(R.name,N.name):(0,r.compare)(R.uri.toString(),N.uri.toString())}function h(R,N,j,ie){const K=R.slice(0).sort(($,U)=>j($,U,ie)),B=N.slice(0).sort(($,U)=>j($,U,ie));return(0,b.delta)(K,B,($,U)=>j($,U,ie))}function p(R,N){const j=N.getCapabilities(R.scheme);return!(j&&j&1024)}class S extends w.Workspace{constructor(N,j,ie,K,B,$){super(N,ie.map(U=>new w.WorkspaceFolder(U)),K,$);this._name=j,this._isUntitled=B,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris($),ie.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace(N,j,ie,K){if(!N)return{workspace:null,added:[],removed:[]};const{id:B,name:$,folders:U,configuration:L,isUntitled:O}=N,M=[],F=j;j?U.forEach((le,ve)=>{const Re=g.URI.revive(le.uri),Se=S._findFolder(ie||j,Re,K);Se?(Se.name=le.name,Se.index=le.index,M.push(Se)):M.push({uri:Re,name:le.name,index:ve})}):M.push(...U.map(({uri:le,name:ve,index:Re})=>({uri:g.URI.revive(le),name:ve,index:Re}))),M.sort((le,ve)=>le.index<ve.index?-1:1);const W=new S(B,$,M,L?g.URI.revive(L):null,!!O,le=>p(le,K)),{added:q,removed:Q}=h(F?F.workspaceFolders:[],W.workspaceFolders,i,K);return{workspace:W,added:q,removed:Q}}static _findFolder(N,j,ie){for(let K=0;K<N.folders.length;K++){const B=N.workspaceFolders[K];if(s(B.uri,j,ie))return B}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,j){return j&&this._structure.get(N)&&(N=(0,P.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let u=class{constructor(N,j,ie,K){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=K,this._extHostFileSystemInfo=ie,this._requestIdProvider=new D.Counter,this._barrier=new I.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const B=j.workspace;this._confirmedWorkspace=B?new S(B.id,B.name,[],B.configuration?g.URI.revive(B.configuration):null,!!B.isUntitled,$=>p($,ie)):void 0}$initializeWorkspace(N,j){this._trusted=j,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?g.URI.from({scheme:k.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,j,ie,...K){const B=[];if(Array.isArray(K)&&K.forEach(M=>{g.URI.isUri(M.uri)&&!B.some(F=>s(F.uri,M.uri,this._extHostFileSystemInfo))&&B.push({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[j,ie].some(M=>typeof M!="number"||M<0)||ie===0&&B.length===0)return!1;const $=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(j+ie>$.length)return!1;const U=$.slice(0);U.splice(j,ie,...B.map(M=>({uri:M.uri,name:M.name||(0,P.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<U.length;M++){const F=U[M];if(U.some((W,q)=>q!==M&&s(F.uri,W.uri,this._extHostFileSystemInfo)))return!1}U.forEach((M,F)=>M.index=F);const{added:L,removed:O}=h($,U,a,this._extHostFileSystemInfo);if(L.length===0&&O.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,j,ie,B).then(void 0,F=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(E.Severity.Error,(0,m.localize)(0,null,M,F.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder(N,j){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async getWorkspaceFolder2(N,j){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,j)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!!this._actualWorkspace){const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}}getRelativePath(N,j){let ie,K="";if(typeof N=="string"?(ie=g.URI.file(N),K=N):typeof N!="undefined"&&(ie=N,K=N.fsPath),!ie)return K;const B=this.getWorkspaceFolder(ie,!0);if(!B)return K;typeof j=="undefined"&&this._actualWorkspace&&(j=this._actualWorkspace.folders.length>1);let $=(0,P.relativePath)(B.uri,ie);return j&&B.name&&($=`${B.name}/${$}`),$}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=S.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:j,added:ie,removed:K}=S.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=j||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ie,removed:K}))}findFiles(N,j,ie,K,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${K.value}, entryPoint: findFiles`);let $;if(j===null?$=!1:j&&(typeof j=="string"?$=j:$=j.pattern),B&&B.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:L}=v(N);return this._proxy.$startFileSearch((0,C.withUndefinedAsNull)(U),(0,C.withUndefinedAsNull)(L),(0,C.withUndefinedAsNull)($),(0,C.withUndefinedAsNull)(ie),B).then(O=>Array.isArray(O)?O.map(M=>g.URI.revive(M)):[])}async findTextInFiles(N,j,ie,K,B=A.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${K.value}, entryPoint: findTextInFiles`);const $=this._requestIdProvider.getNext(),U=typeof j.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:j.previewOptions,{includePattern:L,folder:O}=v(j.include),M=typeof j.exclude=="string"?j.exclude:j.exclude?j.exclude.pattern:void 0,F={ignoreSymlinks:typeof j.followSymlinks=="boolean"?!j.followSymlinks:void 0,disregardIgnoreFiles:typeof j.useIgnoreFiles=="boolean"?!j.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof j.useGlobalIgnoreFiles=="boolean"?!j.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof j.useDefaultExcludes=="boolean"?!j.useDefaultExcludes:!0,fileEncoding:j.encoding,maxResults:j.maxResults,previewOptions:U,afterContext:j.afterContext,beforeContext:j.beforeContext,includePattern:L,excludePattern:M},W=!1;if(this._activeSearchCallbacks[$]=q=>{if(!W){const Q=g.URI.revive(q.resource);q.results.forEach(le=>{(0,t.resultIsMatch)(le)?ie({uri:Q,preview:{text:le.preview.text,matches:(0,b.mapArrayOrNot)(le.preview.matches,ve=>new c.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,b.mapArrayOrNot)(le.ranges,ve=>new c.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):ie({uri:Q,text:le.text,lineNumber:le.lineNumber})})}},B.isCancellationRequested)return{};try{const q=await this._proxy.$startTextSearch(N,(0,C.withUndefinedAsNull)(O),F,$,B);return delete this._activeSearchCallbacks[$],q||{}}catch(q){throw delete this._activeSearchCallbacks[$],q}}$handleTextSearchResult(N,j){this._activeSearchCallbacks[j]&&this._activeSearchCallbacks[j](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};u=qe([He(0,o.IExtHostRpcService),He(1,d.IExtHostInitDataService),He(2,_.IExtHostFileSystemInfo),He(3,f.ILogService)],u),e.ExtHostWorkspace=u,e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function v(R){let N,j;return R&&(typeof R=="string"?N=R:(N=R.pattern,j=R.baseFolder||g.URI.file(R.base))),{includePattern:N,folder:j}}}),define(me[35],ge([0,1,24,3,32,5,7,188,83,11,13,4,15,14,2]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(n,s){if(s){const i=s.split(".");let a=n;for(let h=0;a&&h<i.length;h++)a=a[i[h]];return a}}function E(n){return n instanceof l.URI}function w(n){return n&&n.uri instanceof l.URI&&n.languageId&&typeof n.languageId=="string"}function _(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function d(n){return n&&n.uri instanceof l.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function o(n){if(E(n))return{resource:n};if(w(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(_(n))return{overrideIdentifier:n.languageId};if(d(n))return{resource:n.uri};if(n===null)return{resource:null}}let c=class{constructor(s,i,a){this._proxy=s.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=a,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(s,i))}};c=qe([He(0,g.IExtHostRpcService),He(1,A.IExtHostWorkspace),He(2,m.ILogService)],c),e.ExtHostConfiguration=c;class t{constructor(s,i,a,h){this._onDidChangeConfiguration=new I.Emitter,this._proxy=s,this._logService=h,this._extHostWorkspace=i,this._configuration=k.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const a={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=k.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,a))}getConfiguration(s,i,a){const h=o(i)||{},p=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,h,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,h,a==null?void 0:a.identifier);function S(v){if(v==null)return null;if(typeof v=="boolean")return v?1:4;switch(v){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const u={has(v){return typeof f(p,v)!="undefined"},get:(v,R)=>{this._validateConfigurationAccess(s?`${s}.${v}`:v,h,a==null?void 0:a.identifier);let N=f(p,v);if(typeof N=="undefined")N=R;else{let j;const ie=(K,B)=>{let $;const U=()=>{j=j||(0,b.deepClone)(p),$=$||f(j,B)};return(0,P.isObject)(K)?new Proxy(K,{get:(L,O)=>{if(typeof O=="string"&&O.toLowerCase()==="tojson")return U(),()=>$;if(j)return $=$||f(j,B),$[O];const M=L[O];return typeof O=="string"?ie(M,`${B}.${O}`):M},set:(L,O,M)=>(U(),$&&($[O]=M),!0),deleteProperty:(L,O)=>(U(),$&&delete $[O],!0),defineProperty:(L,O,M)=>(U(),$&&Object.defineProperty($,O,M),!0)}):K};N=ie(N,v)}return N},update:(v,R,N,j)=>{v=s?`${s}.${v}`:v;const ie=S(N);return R!==void 0?this._proxy.$updateConfigurationOption(ie,v,R,h,j):this._proxy.$removeConfigurationOption(ie,v,h,j)},inspect:v=>{var R,N,j,ie,K,B,$,U;v=s?`${s}.${v}`:v;const L=(0,b.deepClone)(this._configuration.inspect(v,h,this._extHostWorkspace.workspace));if(L)return{key:v,defaultValue:(R=L.default)===null||R===void 0?void 0:R.value,globalValue:(N=L.user)===null||N===void 0?void 0:N.value,workspaceValue:(j=L.workspace)===null||j===void 0?void 0:j.value,workspaceFolderValue:(ie=L.workspaceFolder)===null||ie===void 0?void 0:ie.value,defaultLanguageValue:(K=L.default)===null||K===void 0?void 0:K.override,globalLanguageValue:(B=L.user)===null||B===void 0?void 0:B.override,workspaceLanguageValue:($=L.workspace)===null||$===void 0?void 0:$.override,workspaceFolderLanguageValue:(U=L.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:L.overrideIdentifiers}}};return typeof p=="object"&&(0,b.mixin)(u,p,!1),Object.freeze(u)}_toReadonlyValue(s){const i=a=>(0,P.isObject)(a)?new Proxy(a,{get:(h,p)=>i(h[p]),set:(h,p,S)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(h,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(h,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return i(s)}_validateConfigurationAccess(s,i,a){const h=D.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),p=a?`[${a.value}] `:"";if(h===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){(i==null?void 0:i.resource)&&this._logService.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const a=new k.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(h,p)=>a.affectsConfiguration(h,o(p))})}_toMap(s){return s.reduce((i,a)=>(i.set(a[0],a[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,C.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[68],ge([0,1,2,13,3,5,7,32,39,35,21,34,15,28,4,12,10,14,64,208,17]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(K){function B(U){if(U!=null)return U}K.from=B;function $(U){if(U!=null)return U}K.to=$})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(K){function B(U){if(U!=null)return U}K.from=B;function $(U){if(U!=null)return U}K.to=$})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(K){function B(U){if(U!=null)return U}K.from=B;function $(U){if(U!=null)return U}K.to=$})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(K){function B(L){if(L){const O=L;return O&&!!O.process}else return!1}K.is=B;function $(L){if(L!=null){const O={process:L.process,args:L.args};return L.options&&(O.options=s.from(L.options)),O}}K.from=$;function U(L){if(L!=null)return new y.ProcessExecution(L.process,L.args,L.options)}K.to=U})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var a;(function(K){function B(U){if(U!=null)return U}K.from=B;function $(U){if(U!=null)return U}K.to=$})(a=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var h;(function(K){function B(L){if(L){const O=L;return O&&(!!O.commandLine||!!O.command)}else return!1}K.is=B;function $(L){if(L!=null){const O={};return L.commandLine!==void 0?O.commandLine=L.commandLine:(O.command=L.command,O.args=L.args),L.options&&(O.options=a.from(L.options)),O}}K.from=$;function U(L){if(!(L==null||L.command===void 0&&L.commandLine===void 0))return L.commandLine?new y.ShellExecution(L.commandLine,L.options):new y.ShellExecution(L.command,L.args?L.args:[],L.options)}K.to=U})(h=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var p;(function(K){function B(L){if(L){let O=L;return O&&O.customExecution==="customExecution"}else return!1}K.is=B;function $(L){return{customExecution:"customExecution"}}K.from=$;function U(L,O){return O.get(L)}K.to=U})(p=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var S;(function(K){function B($,U){let L;return $.scope!==void 0&&typeof $.scope!="number"?L=$.scope.uri:$.scope!==void 0&&typeof $.scope=="number"&&($.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?L=U.workspaceFile:L=d.USER_TASKS_GROUP_KEY),{id:$._id,workspaceFolder:L}}K.from=B})(S=e.TaskHandleDTO||(e.TaskHandleDTO={}));var u;(function(K){function B(L,O){if(L==null)return[];const M=[];for(let F of L){const W=$(F,O);W&&M.push(W)}return M}K.fromMany=B;function $(L,O){if(L!=null){let M;L.execution instanceof y.ProcessExecution?M=i.from(L.execution):L.execution instanceof y.ShellExecution?M=h.from(L.execution):L.execution&&L.execution instanceof y.CustomExecution&&(M=p.from(L.execution));const F=t.from(L.definition);let W;if(L.scope?typeof L.scope=="number"?W=L.scope:W=L.scope.uri:W=y.TaskScope.Workspace,!(!F||!W)){const q=L.group?L.group.id:void 0;return{_id:L._id,definition:F,name:L.name,source:{extensionId:O.identifier.value,label:L.source,scope:W},execution:M,isBackground:L.isBackground,group:q,presentationOptions:n.from(L.presentationOptions),problemMatchers:L.problemMatchers,hasDefinedMatchers:L.hasDefinedMatchers,runOptions:L.runOptions?L.runOptions:{reevaluateOnRerun:!0},detail:L.detail}}}}K.from=$;async function U(L,O,M){if(L!=null){let F;i.is(L.execution)?F=i.to(L.execution):h.is(L.execution)?F=h.to(L.execution):p.is(L.execution)&&(F=p.to(L._id,M));const W=t.to(L.definition);let q;if(L.source&&(L.source.scope!==void 0?typeof L.source.scope=="number"?q=L.source.scope:q=await O.resolveWorkspaceFolder(b.URI.revive(L.source.scope)):q=y.TaskScope.Workspace),!(!W||!q)){const Q=new y.Task(W,q,L.name,L.source.label,F,L.problemMatchers);return L.isBackground!==void 0&&(Q.isBackground=L.isBackground),L.group!==void 0&&(Q.group=y.TaskGroup.from(L.group)),L.presentationOptions&&(Q.presentationOptions=n.to(L.presentationOptions)),L._id&&(Q._id=L._id),L.detail&&(Q.detail=L.detail),Q}}}K.to=U})(u=e.TaskDTO||(e.TaskDTO={}));var v;(function(K){function B(U){return U}K.from=B;function $(U){if(!!U)return Object.assign(Object.create(null),U)}K.to=$})(v=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(B,$,U){this._id=$,this._task=U,c.set(this,void 0),it(this,c,B,"f")}get task(){return this._task}terminate(){We(this,c,"f").terminateTask(this)}fireDidStartProcess(B){}fireDidEndProcess(B){}}c=new WeakMap;var N;(function(K){function B($){return{id:$._id,task:void 0}}K.from=B})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let j=class{constructor(B,$,U,L,O,M,F,W){this._onDidExecuteTask=new A.Emitter,this._onDidTerminateTask=new A.Emitter,this._onDidTaskProcessStarted=new A.Emitter,this._onDidTaskProcessEnded=new A.Emitter,this._proxy=B.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=L,this._configurationService=O,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=F,this._deprecationService=W,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(B,$,U){if(!U)return new y.Disposable(()=>{});const L=this.nextHandle();return this._handlers.set(L,{type:$,provider:U,extension:B}),this._proxy.$registerTaskProvider(L,$),new y.Disposable(()=>{this._handlers.delete(L),this._proxy.$unregisterTaskProvider(L)})}registerTaskSystem(B,$){this._proxy.$registerTaskSystem(B,$)}fetchTasks(B){return this._proxy.$fetchTasks(v.from(B)).then(async $=>{const U=[];for(let L of $){const O=await u.to(L,this._workspaceProvider,this._providedCustomExecutions2);O&&U.push(O)}return U})}get taskExecutions(){const B=[];return this._taskExecutions.forEach($=>B.push($)),B}terminateTask(B){if(!(B instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(B._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(B,$,U){const L=this._providedCustomExecutions2.get(B.id);if(L){if(this._activeCustomExecutions2.get(B.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(B.id,L),this._terminalService.attachPtyToTerminal($,await L.callback(U))}this._lastStartedTask=B.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(B)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(B){const $=await this.getTaskExecution(B);this._taskExecutionPromises.delete(B.id),this._taskExecutions.delete(B.id),this.customExecutionComplete(B),this._onDidTerminateTask.fire({execution:$})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessStarted.fire({execution:$,processId:B.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(B){const $=await this.getTaskExecution(B.id);this._onDidTaskProcessEnded.fire({execution:$,exitCode:B.exitCode})}$provideTasks(B,$){const U=this._handlers.get(B);if(!U)return Promise.reject(new Error("no handler found"));const L=[],O=(0,I.asPromise)(()=>U.provider.provideTasks(r.CancellationToken.None)).then(M=>this.provideTasksInternal($,L,U,M));return new Promise(M=>{O.then(F=>{Promise.all(L).then(()=>{M(F)})})})}async $resolveTask(B,$){const U=this._handlers.get(B);if(!U)return Promise.reject(new Error("no handler found"));if($.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${$.definition.type}] cannot be resolved by provider of type [${U.type}].`);const L=await u.to($,this._workspaceProvider,this._providedCustomExecutions2);if(!L)throw new Error("Unexpected: Task cannot be resolved.");const O=await U.provider.resolveTask(L,r.CancellationToken.None);if(!!O){this.checkDeprecation(O,U);const M=u.from(O,U.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(O.definition!==L.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return p.is(M.execution)&&await this.addCustomExecution(M,O,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(B,$,U){const L=await this._proxy.$createTaskId(B);!U&&!this._providedCustomExecutions2.has(L)&&this._notProvidedCustomExecutions.add(L),this._providedCustomExecutions2.set(L,$.execution)}async getTaskExecution(B,$){if(typeof B=="string"){const O=this._taskExecutionPromises.get(B);if(!O)throw new Error("Unexpected: The specified task is missing an execution");return O}let U=this._taskExecutionPromises.get(B.id);if(U)return U;const L=new Promise(async(O,M)=>{const F=$||await u.to(B.task,this._workspaceProvider,this._providedCustomExecutions2);F?O(new R(this,B.id,F)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(B.id,L),L.then(O=>(this._taskExecutions.set(B.id,O),O),O=>Promise.reject(O))}checkDeprecation(B,$){B._deprecated&&this._deprecationService.report("Task.constructor",$.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(B){this._activeCustomExecutions2.get(B.id)&&this._activeCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.has(B.id)&&this._lastStartedTask!==B.id&&(this._providedCustomExecutions2.delete(B.id),this._notProvidedCustomExecutions.delete(B.id));let U=this._notProvidedCustomExecutions.values(),L=U.next();for(;!L.done;)!this._activeCustomExecutions2.has(L.value)&&this._lastStartedTask!==L.value&&(this._providedCustomExecutions2.delete(L.value),this._notProvidedCustomExecutions.delete(L.value)),L=U.next()}};j=qe([He(0,g.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let ie=class extends j{constructor(B,$,U,L,O,M,F,W){super(B,$,U,L,O,M,F,W);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:E.PlatformToString(0)})}async executeTask(B,$){if(!$.execution)throw new Error("Tasks to execute must include an execution");const U=u.from($,B);if(U===void 0)throw new Error("Task is not valid");if(p.is(U.execution))await this.addCustomExecution(U,$,!1);else throw new o.NotSupportedError;const L=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),$);return this._proxy.$executeTask(U).catch(O=>{throw new Error(O)}),L}provideTasksInternal(B,$,U,L){const O=[];if(L)for(let M of L){this.checkDeprecation(M,U),(!M.definition||!B[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const F=u.from(M,U.extension);F&&p.is(F.execution)?(O.push(F),$.push(this.addCustomExecution(F,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:O,extension:U.extension}}async resolveTaskInternal(B){if(p.is(B.execution))return B;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(B,$){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(B,$,U){}};ie=qe([He(0,g.IExtHostRpcService),He(1,m.IExtHostInitDataService),He(2,k.IExtHostWorkspace),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,C.IExtHostTerminalService),He(6,w.ILogService),He(7,_.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)},Jt=this&&this.__rest||function(G,e){var b={};for(var I in G)Object.prototype.hasOwnProperty.call(G,I)&&e.indexOf(I)<0&&(b[I]=G[I]);if(G!=null&&typeof Object.getOwnPropertySymbols=="function")for(var A=0,I=Object.getOwnPropertySymbols(G);A<I.length;A++)e.indexOf(I[A])<0&&Object.prototype.propertyIsEnumerable.call(G,I[A])&&(b[I[A]]=G[I[A]]);return b};define(me[259],ge([0,1,16,13,23,21,3,71,55,6,24,11,2,30,5,39,15,87,20,7,32,221,124]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o,c,t){"use strict";var n,s,i,a;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const h=(U,L)=>`${U}:${L.toString()}`;let p=class{constructor(L,O,M){this.documents=O,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new c.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(l.MainContext.MainThreadTesting),this.runQueue=new S(this.proxy),this.workspaceObservers=new B(this.proxy),this.textDocumentObservers=new $(this.proxy,O)}registerTestController(L,O){const M=(0,m.generateUuid)();this.controllers.set(M,{instance:O,extensionId:L}),this.proxy.$registerTestController(M);const F=[...this.testControllers.keys()];return setTimeout(()=>{var W;for(const q of F)(W=this.testControllers.get(q))===null||W===void 0||W.subscribeFn(M,O)},0),new d.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,O=T.CancellationToken.None){const M=F=>F.map(this.getInternalTestForReference,this).filter(C.isDefined).map(W=>({src:W.src,testId:W.item.extId}));await this.proxy.$runTests({exclude:L.exclude?M(L.exclude).map(F=>F.testId):void 0,tests:M(L.tests),debug:L.debug},O)}createTestRun(L,O,M,F=!0){return this.runQueue.createTestRun(L,O,M,F)}$publishTestResults(L){this.results=Object.freeze(L.map(O=>(0,r.deepFreeze)(_.TestResults.to(O))).concat(this.results).sort((O,M)=>M.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,O){const M=g.URI.revive(O),F=h(L,M);if(!this.testControllers.has(F)){const W=new T.CancellationTokenSource;let q;if(L===1){let Se=this.documents.getDocument(M);if(!Se){const Oe=new P.DisposableStore;Se=await new Promise(z=>{Oe.add((0,I.disposableTimeout)(()=>z(void 0),5e3)),Oe.add(this.documents.onDidAddDocuments(Y=>{const ee=Y.find(se=>se.document.uri.toString()===M.toString());ee&&z(ee)}))}).finally(()=>Oe.dispose())}if(Se){const Oe=await this.workspace.getWorkspaceFolder2(M,!1);q=z=>z.createDocumentTestRoot?z.createDocumentTestRoot(Se.document,W.token):(0,e.createDefaultDocumentTestRoot)(z,Se.document,Oe,W.token)}}else{const Se=await this.workspace.getWorkspaceFolder2(M,!1);Se&&(q=Oe=>Oe.createWorkspaceTestRoot(Se,W.token))}if(!!q){const Q=async(Se,Oe)=>{try{const z=await q(Oe);z&&ve.addRoot(z,Se)}catch(z){console.error(z)}},le=new P.DisposableStore,ve=le.add(this.ownedTests.createForHierarchy(Se=>this.proxy.$publishDiff(L,O,Se)));le.add((0,P.toDisposable)(()=>W.dispose(!0)));const Re=[];for(const[Se,Oe]of this.controllers)Re.push(Q(Se,Oe.instance));Promise.all(Re).then(()=>ve.pushDiff([3,-1])),this.testControllers.set(F,{store:le,collection:ve,subscribeFn:Q})}}}async $expandTest(L,O){const M=(0,b.mapFind)(this.testControllers.values(),F=>F.collection.treeId===L.src.tree?F:void 0);await(M==null?void 0:M.collection.expand(L.testId,O<0?Infinity:O)),this.flushCollectionDiffs()}$unsubscribeFromTests(L,O){var M;const F=g.URI.revive(O),W=h(L,F);(M=this.testControllers.get(W))===null||M===void 0||M.store.dispose(),this.testControllers.delete(W)}$acceptDiff(L,O,M){L===1?this.textDocumentObservers.acceptDiff(g.URI.revive(O),M):this.workspaceObservers.acceptDiff(g.URI.revive(O),M)}async $runTestsForProvider(L,O){const M=this.controllers.get(L.tests[0].src.controller);if(!!M){const F=L.tests.map(({testId:Q,src:le})=>this.ownedTests.getTestById(Q,le==null?void 0:le.tree)).filter(C.isDefined).map(([Q,le])=>le),W=L.excludeExtIds.map(Q=>this.ownedTests.getTestById(Q)).filter(C.isDefined).filter(([Q,le])=>F.some(ve=>Q.comparePositions(ve,le)===1));if(!!F.length){const q={tests:F.map(Q=>N.unwrap(Q.actual)),exclude:W.map(([,Q])=>N.unwrap(Q.actual)),debug:L.debug};await this.runQueue.enqueueRun({dto:u.fromInternal(L),token:O,extensionId:M.extensionId,req:q,doRun:()=>M.instance.runTests(q,O)})}}}$lookupTest(L){const O=this.ownedTests.getTestById(L.testId);if(!O)return Promise.resolve(void 0);const M=O[1],{actual:F,discoverCts:W,expandLevels:q}=M,Q=Jt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(Q)}flushCollectionDiffs(){for(const{collection:L}of this.testControllers.values())L.flushDiff()}getInternalTestForReference(L){var O,M;return(M=(O=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&O!==void 0?O:(0,b.mapFind)(this.testControllers.values(),F=>F.collection.getTestByReference(L)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(L)}};p=qe([He(0,E.IExtHostRpcService),He(1,f.IExtHostDocumentsAndEditors),He(2,o.IExtHostWorkspace)],p),e.ExtHostTesting=p;class S{constructor(L){this.proxy=L,this.state=new Map}enqueueRun(L){let O=this.state.get(L.extensionId);O||(O={queue:[],current:void 0},this.state.set(L.extensionId,O));const M=new I.DeferredPromise,F=()=>{const W=[],q=new Set;O.current={publicReq:L.req,factory:Q=>{const le=new v(Q,L.dto,q,this.proxy);return W.push(le),L.token.onCancellationRequested(()=>le.end()),le}},this.invokeRunner(L.extensionId,L.dto.id,L.doRun,W).finally(()=>M.complete())};return O.queue.push(F),O.queue.length===1&&F(),M.p}createTestRun(L,O,M,F){var W,q;const Q=this.state.get(L);if((Q==null?void 0:Q.current.publicReq)===O)return Q.current.factory(M);const le=u.fromPublic(O),ve=new v(M,le,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:O.debug,exclude:(q=(W=O.exclude)===null||W===void 0?void 0:W.map(Re=>Re.id))!==null&&q!==void 0?q:[],id:le.id,tests:O.tests.map(Re=>Re.id),persist:F}),ve.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(le.id)),ve}invokeRunner(L,O,M,F){try{const W=M();return(0,I.isThenable)(W)?W.then(()=>this.handleInvokeResult(L,O,F,void 0)).catch(q=>this.handleInvokeResult(L,O,F,q)):this.handleInvokeResult(L,O,F,void 0)}catch(W){return this.handleInvokeResult(L,O,F,W)}}async handleInvokeResult(L,O,M,F){const W=this.state.get(L);!W||(W.queue.shift(),W.queue.length>0?W.queue[0]():this.state.delete(L),await Promise.all(M.map(q=>q.onEnd.wait())))}}class u{constructor(L,O,M){this.id=L,this.include=O,this.exclude=M}static fromPublic(L){var O,M;return new u((0,m.generateUuid)(),new Set(L.tests.map(F=>F.id)),new Set((M=(O=L.exclude)===null||O===void 0?void 0:O.map(F=>F.id))!==null&&M!==void 0?M:D.Iterable.empty()))}static fromInternal(L){return new u(L.runId,new Set(L.tests.map(O=>O.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let O=L;O;O=O.parent){if(this.include.has(O.id))return!0;if(this.exclude.has(O.id))return!1}return!0}}class v{constructor(L,O,M,F){this.name=L,n.set(this,void 0),s.set(this,void 0),i.set(this,(0,m.generateUuid)()),a.set(this,void 0),this.onEnd=new I.Barrier,it(this,n,F,"f"),it(this,s,O,"f"),it(this,a,M,"f"),F.$startedTestRunTask(O.id,{id:We(this,i,"f"),name:L,running:!0})}setState(L,O,M){We(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$updateTestStateInRun(We(this,s,"f").id,We(this,i,"f"),L.id,O,M))}appendMessage(L,O){We(this,s,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),We(this,n,"f").$appendTestMessageInRun(We(this,s,"f").id,We(this,i,"f"),L.id,_.TestMessage.from(O)))}appendOutput(L){We(this,n,"f").$appendOutputToRun(We(this,s,"f").id,We(this,i,"f"),A.VSBuffer.fromString(L))}end(){We(this,n,"f").$finishedTestRunTask(We(this,s,"f").id,We(this,i,"f")),this.onEnd.open()}ensureTestIsKnown(L){const O=We(this,a,"f");if(!O.has(L.id)){const M=[];for(;M.unshift(_.TestItem.from(L)),!(O.has(L.id)||(O.add(L.id),!L.parent));)L=L.parent;We(this,n,"f").$addTestsToRun(We(this,s,"f").id,M)}}}n=new WeakMap,s=new WeakMap,i=new WeakMap,a=new WeakMap;const R=async(U,L,O,M)=>{if(!!O){const F=await U.createWorkspaceTestRoot(O,M);if(!!F){M.onCancellationRequested(()=>{N.removeFilter(L)});const W=N.getWrapperForTestItem(F,L);return W.refreshMatch(),W}}};e.createDefaultDocumentTestRoot=R;class N extends d.TestItemImpl{constructor(L,O,M){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=O,this.actualParent=M,!(L instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range,this.resolveHandler=L.resolveHandler;const F=(0,w.getPrivateApiFor)(this);(0,w.getPrivateApiFor)(L).bus.event(q=>{switch(q[0]){case 3:this[q[1]]=q[2];break;case 0:const Q=N.getWrapperForTestItem(q[1],this.filterDocument,this);(0,w.getPrivateApiFor)(Q).parent=L,Q.refreshMatch();break;default:F.bus.fire(q)}})}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,O,M){let F=this.wrapperMap.get(O);if(F==null?void 0:F.has(L))return F.get(L);F||(F=new WeakMap,this.wrapperMap.set(O,F));const W=new N(L,O,M);return F.set(L,W),W}static unwrap(L){return L instanceof N?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L,O;const M=this._cachedMatchesFilter;for(const W of this.actual.children.values()){const q=N.getWrapperForTestItem(W,this.filterDocument,this);q.hasNodeMatchingFilter?this.children.has(q.id)||this.addChild(q):q.dispose()}const F=this.children.size>0||((L=this.actual.uri)===null||L===void 0?void 0:L.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=F,F!==M&&((O=this.actualParent)===null||O===void 0||O.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,w.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,w.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class j extends t.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,_.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:O,removed:M}=this;return{get added(){return[...L].map(F=>F.revived)},get updated(){return[...O].map(F=>F.revived)},get removed(){return[...M].map(F=>F.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class ie extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let O=[];for(const M of L){const F=this.items.get(M);F&&O.push(F.revived)}return O}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,O){return Object.assign(Object.assign({},L),{revived:_.TestItem.toPlain(L.item),depth:O?O.depth+1:0,children:new Set})}createChangeCollector(){return new j(this.changeEmitter)}}e.MirroredTestCollection=ie;class K{constructor(){this.resources=new Map}checkout(L){var O,M;const F=L.toString(),W=(O=this.resources.get(F))!==null&&O!==void 0?O:this.createObserverData(L);return(M=W.pendingDeletion)===null||M===void 0||M.dispose(),W.observers++,{onDidChangeTest:W.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return W.tests.rootTestItems},dispose:(0,k.once)(()=>{--W.observers||(W.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:O}of this.resources.values()){const M=O.getMirroredTestDataByReference(L);if(M)return M}}eventuallyDispose(L){return(0,I.disposableTimeout)(()=>this.unlisten(L),10*1e3)}createObserverData(L){const O=new ie,M=this.listen(L,W=>O.apply(W)),F={observers:0,tests:O,listener:M};return this.resources.set(L.toString(),F),F}unlisten(L){var O;const M=L.toString(),F=this.resources.get(M);F&&(F.observers=-1,(O=F.pendingDeletion)===null||O===void 0||O.dispose(),F.listener.dispose(),this.resources.delete(M))}}class B extends K{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,O){var M;(M=this.diffListeners.get(L.toString()))===null||M===void 0||M(O)}listen(L,O){this.proxy.$subscribeToDiffs(0,L);const M=L.toString();return this.diffListeners.set(M,O),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(M)})}}class $ extends K{constructor(L,O){super();this.proxy=L,this.documents=O,this.diffListeners=new Map}acceptDiff(L,O){var M;(M=this.diffListeners.get(L.toString()))===null||M===void 0||M(O)}listen(L,O){if(!this.documents.getDocument(L))return new d.Disposable(()=>{});const F=L.toString();return this.diffListeners.set(F,O),this.proxy.$subscribeToDiffs(1,L),new d.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(F)})}}}),define(me[260],ge([0,1,16,53,33,76,22,12,8,25,9,11,2,140,172,84,61,213,258,31]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let o=class{constructor(S,u,v,R){this.configurationService=S,this.workspaceContextService=u,this.editorGroupsService=v,this.pathService=R}text(S,u,v={}){S=this.getContentPattern(S,v);const R=this.configurationService.getValue(),N=u&&u.some(ie=>!this.configurationService.getValue({resource:ie}).search.useRipgrep),j=this.commonQuery(u==null?void 0:u.map(E.toWorkspaceFolder),v);return Object.assign(Object.assign({},j),{type:2,contentPattern:S,previewOptions:v.previewOptions,maxFileSize:v.maxFileSize,usePCRE2:R.search.usePCRE2||N||!1,beforeContext:v.beforeContext,afterContext:v.afterContext,userDisabledExcludesAndIgnoreFiles:v.disregardExcludeSettings&&v.disregardIgnoreFiles})}getContentPattern(S,u){const v=this.configurationService.getValue();S.isRegExp&&(S.pattern=S.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},S),{wordSeparators:v.editor.wordSeparators});return this.isCaseSensitive(S,u)&&(R.isCaseSensitive=!0),this.isMultiline(S)&&(R.isMultiline=!0),R}file(S,u={}){const v=this.commonQuery(S,u);return Object.assign(Object.assign({},v),{type:1,filePattern:u.filePattern?u.filePattern.trim():u.filePattern,exists:u.exists,sortByScore:u.sortByScore,cacheKey:u.cacheKey})}handleIncludeExclude(S,u){return S?(S=Array.isArray(S)?S.map(i):i(S),u?this.parseSearchPaths(S):{pattern:t(...Array.isArray(S)?S:[S])}):{}}commonQuery(S=[],u={}){const v=this.handleIncludeExclude(u.includePattern,u.expandPatterns),R=this.handleIncludeExclude(u.excludePattern,u.expandPatterns),N=S.length>1,j=(v.searchPaths&&v.searchPaths.length?v.searchPaths.map(B=>this.getFolderQueryForSearchPath(B,u,R)):S.map(B=>this.getFolderQueryForRoot(B,u,R,N))).filter(B=>!!B),ie={_reason:u._reason,folderQueries:j,usingSearchPaths:!!(v.searchPaths&&v.searchPaths.length),extraFileResources:u.extraFileResources,excludePattern:R.pattern,includePattern:v.pattern,onlyOpenEditors:u.onlyOpenEditors,maxResults:u.maxResults};if(u.onlyOpenEditors){const $=b.coalesce(b.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(O=>O.resource)))).filter(L=>(0,d.pathIncludedInQuery)(ie,L.fsPath)),U=this.commonQueryFromFileList($);return Object.assign(Object.assign({},ie),U)}const K=u.extraFileResources&&u.extraFileResources.filter(B=>(0,d.pathIncludedInQuery)(ie,B.fsPath));return ie.extraFileResources=K&&K.length?K:void 0,ie}commonQueryFromFileList(S){const u=[],v=new y.ResourceMap,R={};let N=!1;return S.forEach(j=>{var ie,K;if(j.scheme!==k.Schemas.walkThrough)if((0,P.isAbsolutePath)(j)){const $=(K=(ie=this.workspaceContextService.getWorkspaceFolder(j))===null||ie===void 0?void 0:ie.uri)!==null&&K!==void 0?K:j.with({path:D.dirname(j.fsPath)});let U=v.get($);U||(N=!0,U={folder:$,includePattern:{}},u.push(U),v.set($,U));const L=D.relative($.fsPath,j.fsPath);(0,C.assertIsDefined)(U.includePattern)[L.replace(/\\/g,"/")]=!0}else j.fsPath&&(N=!0,R[j.fsPath]=!0)}),{folderQueries:u,includePattern:R,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(S,u){if(u.isSmartCase){if(S.isRegExp){if(r.containsUppercaseCharacter(S.pattern,!0))return!0}else if(r.containsUppercaseCharacter(S.pattern))return!0}return!!S.isCaseSensitive}isMultiline(S){return S.isMultiline||S.isRegExp&&(0,m.isMultilineRegexSource)(S.pattern)||S.pattern.indexOf(`
`)>=0?!0:!!S.isMultiline}parseSearchPaths(S){const u=U=>D.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(S)?S:n(S)).map(U=>{const L=this.pathService.resolvedUserHome;return L?(0,T.untildify)(U,L.scheme===k.Schemas.file?L.fsPath:L.path):U}),N=I.groupBy(R,U=>u(U)?"searchPaths":"exprSegments"),j=(N.exprSegments||[]).map(U=>r.rtrim(U,"/")).map(U=>r.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),s(U))),ie={},K=this.expandSearchPathPatterns(N.searchPaths||[]);K&&K.length&&(ie.searchPaths=K);const B=b.flatten(j),$=t(...B);return $&&(ie.pattern=$),ie}getExcludesForFolder(S,u){return u.disregardExcludeSettings?void 0:(0,d.getExcludes)(S,!u.disregardSearchExcludeSettings)}expandSearchPathPatterns(S){if(!S||!S.length)return[];const u=b.flatten(S.map(R=>{let{pathPortion:N,globPortion:j}=c(R);j&&(j=a(j));const ie=this.expandOneSearchPath(N);return b.flatten(ie.map(K=>this.resolveOneSearchPathPattern(K,j)))})),v=new Map;return u.forEach(R=>{const N=R.searchPath.toString(),j=v.get(N);j?R.pattern&&(j.pattern=j.pattern||{},j.pattern[R.pattern]=!0):v.set(N,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(v.values())}expandOneSearchPath(S){if(D.isAbsolute(S)){const u=this.workspaceContextService.getWorkspace().folders;return u[0]&&u[0].uri.scheme!==k.Schemas.file?[{searchPath:u[0].uri.with({path:S})}]:[{searchPath:g.URI.file(D.normalize(S))}]}if(this.workspaceContextService.getWorkbenchState()===2){const u=this.workspaceContextService.getWorkspace().folders[0].uri;if(S=i(S),S.startsWith("../")||S===".."){const R=D.posix.resolve(u.path,S);return[{searchPath:u.with({path:R})}]}const v=a(S);return[{searchPath:u,pattern:v}]}else{if(S==="./"||S===".\\")return[];{const u=S.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(N=>{const j=u.match(new RegExp(`^${N.name}(?:/(.*))?`));return j?{match:j,folder:N}:null}).filter(C.isDefined);if(R.length)return R.map(N=>{const j=N.match[1];return{searchPath:N.folder.uri,pattern:j&&a(j)}});{const N=S.match(/\.[\/\\](.+)[\/\\]?/),j=N?N[1]:S,ie=l.localize(0,null,j);throw new Error(ie)}}}}resolveOneSearchPathPattern(S,u){const v=S.pattern&&u?`${S.pattern}/${u}`:S.pattern||u,R=[{searchPath:S.searchPath,pattern:v}];return v&&!v.endsWith("**")&&R.push({searchPath:S.searchPath,pattern:v+"/**"}),R}getFolderQueryForSearchPath(S,u,v){const R=this.getFolderQueryForRoot((0,E.toWorkspaceFolder)(S.searchPath),u,v,!1);return R?Object.assign(Object.assign({},R),{includePattern:S.pattern}):null}getFolderQueryForRoot(S,u,v,R){let N;const j=g.URI.isUri(S)?S:S.uri;if(v.searchPaths){const U=v.searchPaths.filter(L=>(0,P.isEqual)(L.searchPath,j))[0];if(U&&!U.pattern)return null;U&&(N=U.pattern)}const ie=this.configurationService.getValue({resource:j}),K=this.getExcludesForFolder(ie,u),B=Object.assign(Object.assign({},K||{}),N||{}),$=g.URI.isUri(S)?(0,P.basename)(S):S.name;return{folder:j,folderName:R?$:void 0,excludePattern:Object.keys(B).length>0?B:void 0,fileEncoding:ie.files&&ie.files.encoding,disregardIgnoreFiles:typeof u.disregardIgnoreFiles=="boolean"?u.disregardIgnoreFiles:!ie.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof u.disregardGlobalIgnoreFiles=="boolean"?u.disregardGlobalIgnoreFiles:!ie.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof u.ignoreSymlinks=="boolean"?u.ignoreSymlinks:!ie.search.followSymlinks}}};o=qe([He(0,f.IConfigurationService),He(1,E.IWorkspaceContextService),He(2,w.IEditorGroupsService),He(3,_.IPathService)],o),e.QueryBuilder=o;function c(p){const S=p.match(/[\*\{\}\(\)\[\]\?]/);if(S){const u=S.index,v=p.substr(0,u).match(/[/|\\][^/\\]*$/);if(v){let R=p.substr(0,v.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:p.substr((v.index||0)+1)}}}return{pathPortion:p}}function t(...p){return p.length?p.reduce((S,u)=>(S[u]=!0,S),Object.create(null)):void 0}function n(p){return A.splitGlobAware(p,",").map(S=>S.trim()).filter(S=>!!S.length)}function s(p){return[`**/${p}/**`,`**/${p}`].map(u=>u.replace(/\*\*\/\*\*/g,"**"))}function i(p){return p.replace(/\\/g,"/")}function a(p){return i(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function h(p,S){p=b.distinct(p,R=>R.toString());const u=[],v=S.getWorkspace();return p&&p.forEach(R=>{let N;if(S.getWorkbenchState()===2)N=(0,P.relativePath)(v.folders[0].uri,R),N&&N!=="."&&(N="./"+N);else{const j=S.getWorkspaceFolder(R);if(j){const ie=j.name;if(v.folders.filter(B=>B.name===ie).length===1){const B=(0,P.relativePath)(j.uri,R);B===""?N=`./${j.name}`:N=`./${j.name}/${B}`}else N=R.fsPath}}N&&u.push(N)}),u}e.resolveResourcesForSearchIncludes=h}),define(me[261],ge([0,1,25,2,21,17,4,260,31,61]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function C(f,E){const w=E.activationEvents;if(!w)return Promise.resolve(void 0);const _=[],d=[];for(const i of w)if(/^workspaceContains:/.test(i)){const a=i.substr("workspaceContains:".length);a.indexOf("*")>=0||a.indexOf("?")>=0||f.forceUsingSearch?d.push(a):_.push(a)}if(_.length===0&&d.length===0)return Promise.resolve(void 0);let o;const c=new Promise((i,a)=>{o=i}),t=i=>o({activationEvent:i}),n=Promise.all(_.map(i=>g(f,i,t))).then(()=>{}),s=m(f,E.identifier,d,t);return Promise.all([n,s]).then(()=>{o(void 0)}),c}e.checkActivateWorkspaceContainsExtension=C;async function g(f,E,w){for(const _ of f.folders)if(await f.exists(b.joinPath(I.URI.revive(_),E))){w(`workspaceContains:${E}`);return}}async function m(f,E,w,_){if(w.length===0)return Promise.resolve(void 0);const d=new A.CancellationTokenSource,o=f.checkExists(f.folders,w,d.token),c=setTimeout(async()=>{d.cancel(),_(`workspaceContainsTimeout:${w.join(",")}`)},r);let t=!1;try{t=await o}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}d.dispose(),clearTimeout(c),t&&_(`workspaceContains:${w.join(",")}`)}function l(f,E,w,_){const d=f.get(y.IInstantiationService),o=f.get(D.ISearchService),t=d.createInstance(k.QueryBuilder).file(E.map(n=>(0,P.toWorkspaceFolder)(I.URI.revive(n))),{_reason:"checkExists",includePattern:w,exists:!0});return o.fileSearch(t,_).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=l});var it=this&&this.__classPrivateFieldSet||function(G,e,b,I,A){if(I==="m")throw new TypeError("Private method is not writable");if(I==="a"&&!A)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!A:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return I==="a"?A.call(G,b):A?A.value=b:e.set(G,b),b},We=this&&this.__classPrivateFieldGet||function(G,e,b,I){if(b==="a"&&!I)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!I:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?I:b==="a"?I.call(G):I?I.value:e.get(G)};define(me[42],ge([0,1,162,8,69,25,13,6,22,2,14,5,35,224,92,32,41,222,17,27,23,197,7,85,4,28,93,15,82,50,34,3,261,90,198]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o,c,t,n,s,i,a,h,p,S,u,v,R,N,j){"use strict";var ie,K,B;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,s.createDecorator)("IHostUtils");let $=class Bn extends k.Disposable{constructor(M,F,W,q,Q,le,ve,Re,Se,Oe){super();this._onDidChangeRemoteConnectionData=this._register(new v.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=F,this._extHostContext=W,this._initData=ve,this._extHostWorkspace=q,this._extHostConfiguration=Q,this._logService=le,this._extHostTunnelService=Se,this._extHostTerminalService=Oe,this._disposables=new k.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(C.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(C.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(C.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new w.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new l.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=M.createChild(new p.ServiceCollection([l.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const z=new Set;this._initData.hostExtensions.forEach(Y=>z.add(d.ExtensionIdentifier.toKey(Y))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Y,ee,se)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Y,_.transformErrorForSerialization(ee),se)},actualActivateExtension:async(Y,ee)=>{if(z.has(d.ExtensionIdentifier.toKey(Y)))return await this._mainThreadExtensionsProxy.$activateExtension(Y,ee),new m.HostExtension;const se=this._registry.getExtensionDescription(Y);return this._activateExtension(se,ee)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),A.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){_.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(Q=>Q.identifier).filter(Q=>this.isActivated(Q)).map(Q=>this._deactivate(Q))}catch(F){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,F){return this._activator.activateByEvent(M,F)}_activateById(M,F){return this._activator.activateById(M,F)}activateByIdWithErrors(M,F){return this._activateById(M,F).then(()=>{const W=this._activator.getActivatedExtension(M);if(W.activationFailed)return Promise.reject(W.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=D.TernarySearchTree.forPaths(),F=this._registry.getAllExtensionDescriptions().map(W=>{if(!!this._getEntryPoint(W))return this._hostUtils.realpath(W.extensionLocation.fsPath).then(q=>M.set(P.URI.file(q).fsPath,W))});this._extensionPathIndex=Promise.all(F).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let F=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return F;const W=this._activator.getActivatedExtension(M);if(!W)return F;try{typeof W.module.deactivate=="function"&&(F=Promise.resolve(W.module.deactivate()).then(void 0,q=>Promise.resolve(void 0)))}catch(q){}try{(0,k.dispose)(W.subscriptions)}catch(q){}return F}async _activateExtension(M,F){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,F).then(W=>{const q=W.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,q.codeLoadingTime,q.activateCallTime,q.activateResolvedTime,F),this._logExtensionActivationTimes(M,F,"success",q),W},W=>{throw this._logExtensionActivationTimes(M,F,"failure"),W})}_logExtensionActivationTimes(M,F,W,q){const Q=U(M,F);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Q),q||{}),{outcome:W}))}_doActivateExtension(M,F){const W=U(M,F);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",W);const q=this._getEntryPoint(M);if(!q)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(F)}`),this._logService.flush();const Q=new m.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,q),Q),this._loadExtensionContext(M)]).then(le=>(A.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Bn._callActivate(this._logService,M.identifier,le[0],le[1],Q))).then(le=>(A.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),le))}_loadExtensionContext(M){const F=new c.ExtensionGlobalMemento(M,this._storage),W=new c.ExtensionMemento(M.identifier.value,!1,this._storage),q=new j.ExtensionSecrets(M,this._secretState),Q=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,le=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([F.whenReady,W.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:F,workspaceState:W,secrets:q,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Se){return I.join(M.extensionLocation.fsPath,Se)},get storagePath(){var Se;return(Se=ve._storagePath.workspaceValue(M))===null||Se===void 0?void 0:Se.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(M).fsPath},get logPath(){return I.join(ve._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return P.URI.joinPath(ve._initData.logsLocation,M.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(M)},get globalStorageUri(){return ve._storagePath.globalValue(M)},get extensionMode(){return Q},get extension(){return Re===void 0&&(Re=new L(ve,M.identifier,M,le)),Re},get extensionRuntime(){return(0,E.checkProposedApiEnabled)(M),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,F,W,q,Q){return W=W||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,F,W,q,Q).then(le=>new m.ActivatedExtension(!1,null,Q.build(),W,le,q.subscriptions))}static _callActivateOptional(M,F,W,q,Q){if(typeof W.activate=="function")try{Q.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${F.value}`);const le=typeof global=="object"?global:self,ve=W.activate.apply(le,[q]);return Q.activateCallStop(),Q.activateResolveStart(),Promise.resolve(ve).then(Re=>(Q.activateResolveStop(),Re))}catch(le){return Promise.reject(le)}else return Promise.resolve(W)}_activateOneStartupFinished(M,F){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:F}).then(void 0,W=>{this._logService.error(W)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(A.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const F of M.activationEvents)F==="onStartupFinished"&&this._activateOneStartupFinished(M,F)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,Q=>{this._logService.error(Q)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Q=>this._handleWorkspaceContainsEagerExtensions(Q.added)));const F=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],W=this._handleWorkspaceContainsEagerExtensions(F),q=Promise.all([M,W]).then(()=>{});return Promise.race([q,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),q}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(F=>this._handleWorkspaceContainsEagerExtension(M,F))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,F){if(!this.isActivated(F.identifier)){const W=!this._initData.remote.isRemote&&!!this._initData.remote.authority,q={folders:M.map(le=>le.uri),forceUsingSearch:W,exists:le=>this._hostUtils.exists(le.fsPath),checkExists:(le,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(le,ve,Re)},Q=await(0,R.checkActivateWorkspaceContainsExtension)(q,F);if(!!Q)return this._activateById(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Q.activationEvent}).then(void 0,le=>this._logService.error(le))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:F}=this._initData.environment;if(!M||!F)throw new Error(b.localize(0,null));const W=await this._loadCommonJSModule(null,F,new m.ExtensionActivationTimesBuilder(!1));if(!W||typeof W.run!="function")throw new Error(b.localize(1,null,F.toString()));return new Promise((q,Q)=>{const le=(Se,Oe)=>{Se?Q(Se):q(typeof Oe=="number"&&Oe>0?1:0)},ve=(0,T.originalFSPath)(F),Re=W.run(ve,le);Re&&Re.then&&Re.then(()=>{q(0)}).catch(Se=>{Q(Se.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,F){return this._resolvers[M]=F,(0,k.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,F){const W=M.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const q=M.substr(0,W);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${q}`,!1);const Q=this._resolvers[q];if(!Q)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${q}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(Q)),A.mark(`code/extHost/willResolveAuthority/${q}`);const le=await Q.resolve(M,{resolveAttempt:F});A.mark(`code/extHost/didResolveAuthorityOK/${q}`);const ve={authority:M,host:le.host,port:le.port,connectionToken:le.connectionToken},Re={extensionHostEnv:le.extensionHostEnv,trust:le.trust};return{type:"ok",value:{authority:ve,options:Re,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(A.mark(`code/extHost/didResolveAuthorityError/${q}`),le instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,F){return F===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(W=>this._activateByEvent(M,!1))}async $activate(M,F){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,F),!0):!1}async $deltaExtensions(M,F){M.forEach(q=>q.extensionLocation=P.URI.revive(q.extensionLocation));const W=await this.getExtensionPathIndex();return await Promise.all(F.map(async q=>{const Q=this._registry.getExtensionDescription(q);if(!!Q){const le=await this._hostUtils.realpath(Q.extensionLocation.fsPath);W.delete(P.URI.file(le).fsPath)}})),await Promise.all(M.map(async q=>{const Q=await this._hostUtils.realpath(q.extensionLocation.fsPath);W.set(P.URI.file(Q).fsPath,q)})),this._registry.deltaExtensions(M,F),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let F=o.VSBuffer.alloc(M),W=Math.random()%256;for(let q=0;q<M;q++)F.writeUInt8(W,q);return F}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};$=qe([He(0,s.IInstantiationService),He(1,e.IHostUtils),He(2,h.IExtHostRpcService),He(3,f.IExtHostWorkspace),He(4,g.IExtHostConfiguration),He(5,r.ILogService),He(6,i.IExtHostInitDataService),He(7,a.IExtensionStoragePaths),He(8,S.IExtHostTunnelService),He(9,u.IExtHostTerminalService)],$),e.AbstractExtHostExtensionService=$;function U(O,M){return{id:O.identifier.value,name:O.name,extensionVersion:O.version,publisherDisplayName:O.publisher,activationEvents:O.activationEvents?O.activationEvents.join(","):null,isBuiltin:O.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,s.createDecorator)("IExtHostExtensionService");class L{constructor(M,F,W,q){ie.set(this,void 0),K.set(this,void 0),B.set(this,void 0),it(this,ie,M,"f"),it(this,K,F,"f"),it(this,B,W.identifier,"f"),this.id=W.identifier.value,this.extensionUri=W.extensionLocation,this.extensionPath=I.normalize((0,T.originalFSPath)(W.extensionLocation)),this.packageJSON=W,this.extensionKind=q}get isActive(){return We(this,ie,"f").isActivated(We(this,B,"f"))}get exports(){if(this.packageJSON.api!=="none")return We(this,ie,"f").getExtensionExports(We(this,B,"f"))}activate(){return We(this,ie,"f").activateByIdWithErrors(We(this,B,"f"),{startup:!1,extensionId:We(this,K,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,ie=new WeakMap,K=new WeakMap,B=new WeakMap}),define(me[46],ge([0,1,8,2,3,13,5,7,122,32,42,39,212,35,205,15,4,11,36]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,E.createDecorator)("IExtHostDebugService");let d=class{constructor(h,p,S,u,v){this._workspaceService=p,this._extensionService=S,this._editorsService=u,this._configurationService=v,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new A.Emitter,this._onDidTerminateDebugSession=new A.Emitter,this._onDidChangeActiveDebugSession=new A.Emitter,this._onDidReceiveDebugSessionCustomEvent=new A.Emitter,this._debugServiceProxy=h.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new A.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new c(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange(N=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(h,p){const S=h;if(typeof S.sourceReference=="number"&&S.sourceReference>0){let u=`debug:${encodeURIComponent(S.path||"")}`,v="?";return p&&(u+=`${v}session=${encodeURIComponent(p.id)}`,v="&"),u+=`${v}ref=${S.sourceReference}`,I.URI.parse(u)}else{if(S.path)return I.URI.file(S.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(h){const p=[];for(const S of h.getAllExtensionDescriptions())if(S.contributes){const u=S.contributes.debuggers;if(u&&u.length>0)for(const v of u)(0,l.isDebuggerMainContribution)(v)&&p.push(v.type)}this._debugServiceProxy.$registerDebugTypes(p)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const h=[];return this._breakpoints.forEach(p=>h.push(p)),h}addBreakpoints(h){this.startBreakpoints();const p=h.filter(v=>{const R=v.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,v),!0)});this.fireBreakpointChanges(p,[],[]);const S=[],u=new Map;for(const v of p)if(v instanceof k.SourceBreakpoint){let R=u.get(v.location.uri.toString());R||(R={type:"sourceMulti",uri:v.location.uri,lines:[]},u.set(v.location.uri.toString(),R),S.push(R)),R.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof k.FunctionBreakpoint&&S.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this._debugServiceProxy.$registerBreakpoints(S)}removeBreakpoints(h){this.startBreakpoints();const p=h.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],p,[]);const S=p.filter(R=>R instanceof k.SourceBreakpoint).map(R=>R.id),u=p.filter(R=>R instanceof k.FunctionBreakpoint).map(R=>R.id),v=p.filter(R=>R instanceof k.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(S,u,v)}startDebugging(h,p,S){return this._debugServiceProxy.$startDebugging(h?h.uri:void 0,p,{parentSessionID:S.parentSession?S.parentSession.id:void 0,repl:S.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:S.noDebug,compact:S.compact})}stopDebugging(h){return this._debugServiceProxy.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,p,S){if(!p)return new k.Disposable(()=>{});const u=this._configProviderHandleCounter++;return this._configProviders.push({type:h,handle:u,provider:p}),this._debugServiceProxy.$registerDebugConfigurationProvider(h,S,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,u),new k.Disposable(()=>{this._configProviders=this._configProviders.filter(v=>v.provider!==p),this._debugServiceProxy.$unregisterDebugConfigurationProvider(u)})}registerDebugAdapterDescriptorFactory(h,p,S){if(!S)return new k.Disposable(()=>{});if(!this.definesDebugType(h,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.getAdapterDescriptorFactoryByType(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const u=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:p,handle:u,factory:S}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(p,u),new k.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(v=>v.factory!==S),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(u)})}registerDebugAdapterTrackerFactory(h,p){if(!p)return new k.Disposable(()=>{});const S=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:h,handle:S,factory:p}),new k.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(u=>u.factory!==p)})}async $runInTerminal(h,p){return Promise.resolve(void 0)}async $substituteVariables(h,p){if(!this._variableResolver){const[v,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(v||[],this._editorsService,R)}let S;const u=await this.getFolder(h);return u&&(S={uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(S,p)}createDebugAdapter(h,p){if(h.type==="implementation")return new s(h.implementation)}createSignService(){}async $startDASession(h,p){const S=this,u=await this.getSession(p);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(u.type),u).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}' (extension might have failed to activate)`);const R=this.convertToDto(v),N=this.createDebugAdapter(R,u);if(!N)throw new Error(`Couldn't create a debug adapter for type '${u.type}'.`);const j=N;return this._debugAdapters.set(h,j),this.getDebugAdapterTrackers(u).then(ie=>(ie&&this._debugAdaptersTrackers.set(h,ie),j.onMessage(async K=>{if(K.type==="request"&&K.command==="handshake"){const B=K,$={type:"response",seq:0,command:B.command,request_seq:B.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(B.arguments.value);$.body={signature:U},j.sendResponse($)}else throw new Error("no signer")}catch(U){$.success=!1,$.message=U.message,j.sendResponse($)}}else ie&&ie.onDidSendMessage&&ie.onDidSendMessage(K),K=(0,l.convertToVSCPaths)(K,!0),S._debugServiceProxy.$acceptDAMessage(h,K)}),j.onError(K=>{ie&&ie.onError&&ie.onError(K),this._debugServiceProxy.$acceptDAError(h,K.name,K.message,K.stack)}),j.onExit(K=>{ie&&ie.onExit&&ie.onExit((0,w.withNullAsUndefined)(K),void 0),this._debugServiceProxy.$acceptDAExit(h,(0,w.withNullAsUndefined)(K),void 0)}),ie&&ie.onWillStartSession&&ie.onWillStartSession(),j.startSession()))})}$sendDAMessage(h,p){p=(0,l.convertToDAPaths)(p,!1);const S=this._debugAdaptersTrackers.get(h);S&&S.onWillReceiveMessage&&S.onWillReceiveMessage(p);const u=this._debugAdapters.get(h);u&&u.sendMessage(p)}$stopDASession(h){const p=this._debugAdaptersTrackers.get(h);this._debugAdaptersTrackers.delete(h),p&&p.onWillStopSession&&p.onWillStopSession();const S=this._debugAdapters.get(h);return this._debugAdapters.delete(h),S?S.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const p=[],S=[],u=[];if(h.added)for(const v of h.added){const R=v.id;if(R&&!this._breakpoints.has(R)){let N;if(v.type==="function")N=new k.FunctionBreakpoint(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")N=new k.DataBreakpoint(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const j=I.URI.revive(v.uri);N=new k.SourceBreakpoint(new k.Location(j,new k.Position(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}N._id=R,this._breakpoints.set(R,N),p.push(N)}}if(h.removed)for(const v of h.removed){const R=this._breakpoints.get(v);R&&(this._breakpoints.delete(v),S.push(R))}if(h.changed){for(const v of h.changed)if(v.id){const R=this._breakpoints.get(v.id);if(R){if(R instanceof k.FunctionBreakpoint&&v.type==="function"){const N=R;N.enabled=v.enabled,N.condition=v.condition,N.hitCondition=v.hitCondition,N.logMessage=v.logMessage,N.functionName=v.functionName}else if(R instanceof k.SourceBreakpoint&&v.type==="source"){const N=R;N.enabled=v.enabled,N.condition=v.condition,N.hitCondition=v.hitCondition,N.logMessage=v.logMessage,N.location=new k.Location(I.URI.revive(v.uri),new k.Position(v.line,v.character))}u.push(R)}}}this.fireBreakpointChanges(p,S,u)}$provideDebugConfigurations(h,p,S){return(0,T.asPromise)(async()=>{const u=this.getConfigProviderByHandle(h);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.getFolder(p);return u.provideDebugConfigurations(v,S)}).then(u=>{if(!u)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return u})}$resolveDebugConfiguration(h,p,S,u){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(p);return v.resolveDebugConfiguration(R,S,u)})}$resolveDebugConfigurationWithSubstitutedVariables(h,p,S,u){return(0,T.asPromise)(async()=>{const v=this.getConfigProviderByHandle(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(p);return v.resolveDebugConfigurationWithSubstitutedVariables(R,S,u)})}async $provideDebugAdapter(h,p){const S=this.getAdapterDescriptorFactoryByHandle(h);if(!S)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const u=await this.getSession(p);return this.getAdapterDescriptor(S,u).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${u.type}'`);return this.convertToDto(v)})}async $acceptDebugSessionStarted(h){const p=await this.getSession(h);this._onDidStartDebugSession.fire(p)}async $acceptDebugSessionTerminated(h){const p=await this.getSession(h);p&&(this._onDidTerminateDebugSession.fire(p),this._debugSessions.delete(p.id))}async $acceptDebugSessionActiveChanged(h){this._activeDebugSession=h?await this.getSession(h):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(h,p){const S=await this.getSession(h);S&&S._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(h,p){const u={session:await this.getSession(h),event:p.event,body:p.body};this._onDidReceiveDebugSessionCustomEvent.fire(u)}convertToDto(h){if(h instanceof k.DebugAdapterExecutable)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof k.DebugAdapterServer)return{type:"server",port:h.port,host:h.host};if(h instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:h.path};if(h instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(h){const p=this._adapterFactories.filter(S=>S.type===h);if(p.length>0)return p[0].factory}getAdapterDescriptorFactoryByHandle(h){const p=this._adapterFactories.filter(S=>S.handle===h);if(p.length>0)return p[0].factory}getConfigProviderByHandle(h){const p=this._configProviders.filter(S=>S.handle===h);if(p.length>0)return p[0].provider}definesDebugType(h,p){if(h.contributes){const S=h.contributes.debuggers;if(S&&S.length>0){for(const u of S)if(u.label&&u.type&&u.type===p)return!0}}return!1}getDebugAdapterTrackers(h){const S=h.configuration.type,u=this._trackerFactories.filter(v=>v.type===S||v.type==="*").map(v=>(0,T.asPromise)(()=>v.factory.createDebugAdapterTracker(h)).then(R=>R,R=>null));return Promise.race([Promise.all(u).then(v=>{const R=v.filter(N=>!!N);if(R.length>0)return new n(R)}),new Promise((v,R)=>{const N=setTimeout(()=>{clearTimeout(N),R(new Error("timeout"))},1e3)})]).catch(v=>{})}async getAdapterDescriptor(h,p){const S=p.configuration.debugServer;if(typeof S=="number")return Promise.resolve(new k.DebugAdapterServer(S));if(h){const v=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>h.createDebugAdapterDescriptor(p,this.daExecutableFromPackage(p,v))).then(R=>{if(R)return R})}const u=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(p,u))}daExecutableFromPackage(h,p){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(h,p,S){(h.length>0||p.length>0||S.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:h,removed:p,changed:S}))}async getSession(h){if(h)if(typeof h=="string"){const p=this._debugSessions.get(h);if(p)return p}else{let p=this._debugSessions.get(h.id);if(!p){const S=await this.getFolder(h.folderUri);p=new o(this._debugServiceProxy,h.id,h.type,h.name,S,h.configuration),this._debugSessions.set(p.id,p),this._debugServiceProxy.$sessionCached(p.id)}return p}throw new Error("cannot find session")}getFolder(h){if(h){const p=I.URI.revive(h);return this._workspaceService.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}};d=qe([He(0,f.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,r.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration)],d),e.ExtHostDebugServiceBase=d;class o{constructor(h,p,S,u,v,R){this._debugServiceProxy=h,this._id=p,this._type=S,this._name=u,this._workspaceFolder=v,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(h){this._name=h,this._debugServiceProxy.$setDebugSessionName(this._id,h)}_acceptNameChanged(h){this._name=h}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(h,p){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,h,p)}getDebugProtocolBreakpoint(h){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,h.id)}}e.ExtHostDebugSession=o;class c{constructor(h){this.value=Object.freeze({append(p){h.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.ExtHostDebugConsole=c;class t extends g.AbstractVariableResolverService{constructor(h,p,S,u){super({getFolderUri:v=>{const R=h.filter(N=>N.name===v);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>h.length,getConfigurationValue:(v,R)=>S.getConfiguration(void 0,v).get(R),getAppRoot:()=>_.cwd(),getExecPath:()=>_.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(p){const v=p.activeEditor();if(v)return b.normalize(v.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(p&&u){const v=p.activeEditor();if(v){const R=u.getWorkspaceFolder(v.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(p){const v=p.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(p){const v=p.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,Promise.resolve(_.env))}}e.ExtHostVariableResolverService=t;class n{constructor(h){this.trackers=h}onWillStartSession(){this.trackers.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.trackers.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.trackers.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(h):void 0)}onWillStopSession(){this.trackers.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.trackers.forEach(p=>p.onError?p.onError(h):void 0)}onExit(h,p){this.trackers.forEach(S=>S.onExit?S.onExit(h,p):void 0)}}class s extends D.AbstractDebugAdapter{constructor(h){super();this.implementation=h,h.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.implementation.handleMessage(h)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let i=class extends d{constructor(h,p,S,u,v){super(h,p,S,u,v)}createVariableResolver(h,p,S){return new t(h,p,S)}};i=qe([He(0,f.IExtHostRpcService),He(1,P.IExtHostWorkspace),He(2,r.IExtHostExtensionService),He(3,C.IExtHostDocumentsAndEditors),He(4,m.IExtHostConfiguration)],i),e.WorkerExtHostDebugService=i}),define(me[262],ge([0,1,69,2,5,35,41,27,15,28,4,42,36,14]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=class{constructor(d,o,c,t,n,s,i){this._apiFactory=d,this._extensionRegistry=o,this._instaService=c,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const d=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const o=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,o,this._extensionRegistry,d,this._logService)),this.register(this._instaService.createInstance(E)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(w,o,this._initData.environment.appUriScheme))}register(d){if(Array.isArray(d.nodeModuleName))for(let o of d.nodeModuleName)this._factories.set(o,d);else this._factories.set(d.nodeModuleName,d);typeof d.alternativeModuleName=="function"&&this._alternatives.push(o=>d.alternativeModuleName(o))}};l=qe([He(2,r.IInstantiationService),He(3,T.IExtHostConfiguration),He(4,C.IExtHostExtensionService),He(5,P.IExtHostInitDataService),He(6,m.ILogService)],l),e.RequireInterceptor=l;class f{constructor(d,o,c,t,n){this._apiFactory=d,this._extensionPaths=o,this._extensionRegistry=c,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(d,o){const c=this._extensionPaths.findSubstr(o.fsPath);if(c){let t=this._extApiImpl.get(k.ExtensionIdentifier.toKey(c.identifier));return t||(t=this._apiFactory(c,this._extensionRegistry,this._configProvider),this._extApiImpl.set(k.ExtensionIdentifier.toKey(c.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,s)=>t+=`	${s} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${o.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let E=class{constructor(d,o){this.nodeModuleName="keytar";const{environment:c}=o,t=d.getProxy(A.MainContext.MainThreadKeytar);if(c.appRoot){let n=c.appRoot.fsPath;g.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,s)=>t.$getPassword(n,s),setPassword:(n,s,i)=>t.$setPassword(n,s,i),deletePassword:(n,s)=>t.$deletePassword(n,s),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(d,o){return this._impl}alternativeModuleName(d){const o=d.length;if(!(o<=7||!this.alternativeNames)){const c=o-7;if((d.charAt(c)==="/"||d.charAt(c)==="\\")&&d.endsWith("keytar")&&(d=d.replace(/\\/g,"/"),this.alternativeNames.has(d)))return"keytar"}}};E=qe([He(0,D.IExtHostRpcService),He(1,P.IExtHostInitDataService)],E);let w=class{constructor(d,o,c){this._extensionPaths=d,this._appUriScheme=o,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=c.getProxy(A.MainContext.MainThreadTelemetry);const t=c.getProxy(A.MainContext.MainThreadWindow);this._impl=(n,s)=>{const i=I.URI.parse(n);return s?this.callOriginal(n,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,n,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,n,{}):this.callOriginal(n,s)}}load(d,o,c){const t=this._extensionPaths.findSubstr(o.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=c(d),this._impl}callOriginal(d,o){return this.sendNoForwardTelemetry(),this._original(d,o)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};w=qe([He(2,D.IExtHostRpcService)],w)}),define(me[263],ge([0,1,168,10,7,206,32,42,39,35,34,15,46,190,13,207]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let E=class extends g.ExtHostDebugServiceBase{constructor(d,o,c,t,n,s){super(d,o,c,t,n);this._terminalService=s,this._integratedTerminalInstances=new w}createDebugAdapter(d,o){switch(d.type){case"server":return new T.SocketDebugAdapter(d);case"pipeServer":return new T.NamedPipeDebugAdapter(d);case"executable":return new T.ExecutableDebugAdapter(d,o.type)}return super.createDebugAdapter(d,o)}daExecutableFromPackage(d,o){const c=T.ExecutableDebugAdapter.platformAdapterExecutable(o.getAllExtensionDescriptions(),d.type);if(c)return new A.DebugAdapterExecutable(c.command,c.args,c.options)}createSignService(){return new m.SignService}async $runInTerminal(d,o){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(v=>{this._integratedTerminalInstances.onTerminalClosed(v)}));const c=await this._configurationService.getConfigProvider(),t=this._terminalService.getDefaultShell(!0,c),n=this._terminalService.getDefaultShellArgs(!0,c),s=JSON.stringify({shell:t,shellArgs:n});let i=await this._integratedTerminalInstances.checkout(s),a,h=!1;if(i)a=d.cwd;else{const v={shellPath:t,shellArgs:n,cwd:d.cwd,name:d.title||b.localize(0,null)};h=!0,i=this._terminalService.createTerminalFromOptions(v,!0),this._integratedTerminalInstances.insert(i,s)}i.show(!0);const p=await i.processId;h?await new Promise(v=>setTimeout(v,1e3)):c.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(t.indexOf("powershell")>=0||t.indexOf("pwsh")>=0||t.indexOf("cmd.exe")>=0?i.sendText("cls"):t.indexOf("bash")>=0?i.sendText("clear"):I.isWindows?i.sendText("cls"):i.sendText("clear"));const S=(0,f.prepareCommand)(t,d.args,a,d.env);i.sendText(S);const u=this.onDidTerminateDebugSession(v=>{v.id===o&&(this._integratedTerminalInstances.free(i),u.dispose())});return p}else if(d.kind==="external")return(0,f.runInExternalTerminal)(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,o)}createVariableResolver(d,o,c){return new g.ExtHostVariableResolverService(d,o,c,this._workspaceService)}};E=qe([He(0,C.IExtHostRpcService),He(1,y.IExtHostWorkspace),He(2,k.IExtHostExtensionService),He(3,D.IExtHostDocumentsAndEditors),He(4,P.IExtHostConfiguration),He(5,r.IExtHostTerminalService)],E),e.ExtHostDebugService=E;class w{constructor(){this._terminalInstances=new Map}async checkout(d){const c=[...this._terminalInstances.entries()].map(([t,n])=>(0,l.createCancelablePromise)(async s=>{if(n.lastUsedAt!==-1&&await(0,f.hasChildProcesses)(await t.processId))return null;const i=Date.now();return n.lastUsedAt+w.minUseDelay>i||s.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=i,t)}));return await(0,l.firstParallel)(c,t=>!!t)}insert(d,o){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:o})}free(d){const o=this._terminalInstances.get(d);o&&(o.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}w.minUseDelay=1e3}),define(me[264],ge([0,1,8,2,78,32,46,39,35,34,15,28,68,12,14,64]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let E=class extends g.ExtHostTaskBase{constructor(_,d,o,c,t,n,s,i){super(_,d,o,c,t,n,s,i);this.workspaceService=o,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(m.Schemas.vscodeRemote,{scheme:m.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(m.Schemas.file,{scheme:m.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(_,d){const o=d;if(!d.execution&&o._id===void 0)throw new Error("Tasks to execute must include an execution");if(o._id!==void 0){const c=g.TaskHandleDTO.from(o,this.workspaceService),t=await this._proxy.$getTaskExecution(c);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const n=await this.getTaskExecution(t,d);return this._proxy.$executeTask(c).catch(()=>{}),n}else{const c=g.TaskDTO.from(d,_);if(c===void 0)return Promise.reject(new Error("Task is not valid"));g.CustomExecutionDTO.is(c.execution)&&await this.addCustomExecution(c,d,!1);const t=await this.getTaskExecution(await this._proxy.$getTaskExecution(c),d);return this._proxy.$executeTask(c).catch(()=>{}),t}}provideTasksInternal(_,d,o,c){const t=[];if(c)for(let n of c){this.checkDeprecation(n,o),(!n.definition||!_[n.definition.type])&&this._logService.warn(`The task [${n.source}, ${n.name}] uses an undefined task type. The task will be ignored in the future.`);const s=g.TaskDTO.from(n,o.extension);s&&(t.push(s),g.CustomExecutionDTO.is(s.execution)&&d.push(this.addCustomExecution(s,n,!0)))}return{tasks:t,extension:o.extension}}async resolveTaskInternal(_){return _}async getVariableResolver(_){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new y.ExtHostVariableResolverService(_,this._editorService,d,this.workspaceService)}return this._variableResolver}async $resolveVariables(_,d){const o=I.URI.revive(_),c={process:void 0,variables:Object.create(null)},t=await this._workspaceProvider.resolveWorkspaceFolder(o),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!t)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const s=await this.getVariableResolver(n),i={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}};for(let a of d.variables)c.variables[a]=await s.resolveAsync(i,a);if(d.process!==void 0){let a;if(d.process.path!==void 0){a=d.process.path.split(b.delimiter);for(let h=0;h<a.length;h++)a[h]=await s.resolveAsync(i,a[h])}c.process=await A.win32.findExecutable(await s.resolveAsync(i,d.process.name),d.process.cwd!==void 0?await s.resolveAsync(i,d.process.cwd):void 0,a)}return c}$getDefaultShellAndArgs(){return this._terminalService.getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}async $findExecutable(_,d,o){return A.win32.findExecutable(_,d,o)}};E=qe([He(0,r.IExtHostRpcService),He(1,C.IExtHostInitDataService),He(2,T.IExtHostWorkspace),He(3,k.IExtHostDocumentsAndEditors),He(4,D.IExtHostConfiguration),He(5,P.IExtHostTerminalService),He(6,l.ILogService),He(7,f.IExtHostApiDeprecationService)],E),e.ExtHostTask=E}),define(me[265],ge([0,1,10,11,30,149,14,35,46,39,15,34,32,210,211]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let f=class extends C.BaseExtHostTerminalService{constructor(w,_,d,o,c){super(!0,w);this._extHostConfiguration=_,this._extHostWorkspace=d,this._extHostDocumentsAndEditors=o,this._logService=c,(0,T.getSystemShell)(b.OS,process.env).then(t=>this._defaultShell=t),this._updateLastActiveWorkspace(),this._variableResolverPromise=this._updateVariableResolver(),this._registerListeners()}createTerminal(w,_,d){const o=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),{name:w,shellPath:_,shellArgs:d},w);return this._terminals.push(o),o.create(_,d),o.value}createTerminalFromOptions(w,_){const d=new C.ExtHostTerminal(this._proxy,(0,A.generateUuid)(),w,w.name);return this._terminals.push(d),d.create((0,I.withNullAsUndefined)(w.shellPath),(0,I.withNullAsUndefined)(w.shellArgs),(0,I.withNullAsUndefined)(w.cwd),(0,I.withNullAsUndefined)(w.env),(0,I.withNullAsUndefined)(w.icon),(0,I.withNullAsUndefined)(w.message),void 0,(0,I.withNullAsUndefined)(w.strictEnv),(0,I.withNullAsUndefined)(w.hideFromUser),(0,I.withNullAsUndefined)(_),!0),d.value}getDefaultShell(w,_){var d;return m.getDefaultShell(this._buildSafeConfigProvider(_),(d=this._defaultShell)!==null&&d!==void 0?d:(0,T.getSystemShellSync)(b.OS,process.env),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,m.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService,w)}getDefaultShellArgs(w,_){return m.getDefaultShellArgs(this._buildSafeConfigProvider(_),w,m.createVariableResolver(this._lastActiveWorkspace,process.env,this._variableResolver),this._logService)}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>{this._variableResolverPromise=this._updateVariableResolver()})}_updateLastActiveWorkspace(){const w=this._extHostDocumentsAndEditors.activeEditor();w&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(w.document.uri))}async _updateVariableResolver(){const w=await this._extHostConfiguration.getConfigProvider(),_=await this._extHostWorkspace.getWorkspaceFolders2();return this._variableResolver=new D.ExtHostVariableResolverService(_||[],this._extHostDocumentsAndEditors,w),this._variableResolver}async $getAvailableProfiles(w){const _=this._buildSafeConfigProvider(await this._extHostConfiguration.getConfigProvider());return(0,l.detectAvailableProfiles)(w,_,void 0,this._logService,await this._variableResolverPromise,this._lastActiveWorkspace)}async getDefaultShellAndArgs(w){const _=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(w,_),args:this.getDefaultShellArgs(w,_)}}_buildSafeConfigProvider(w){const _=w.getConfiguration();return d=>{if(_.get("terminal.integrated.allowWorkspaceConfiguration"))return _.get(d);const c=_.inspect(d);return(c==null?void 0:c.globalValue)||(c==null?void 0:c.defaultValue)}}};f=qe([He(0,r.IExtHostRpcService),He(1,k.IExtHostConfiguration),He(2,g.IExtHostWorkspace),He(3,P.IExtHostDocumentsAndEditors),He(4,y.ILogService)],f),e.ExtHostTerminalService=f}),define(me[266],ge([0,1,13,17,69,6,2,5,256,14,79,82,28,185,15,63,42,34]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class _{constructor(o,c,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const s=new D.RPCProtocol(o,null,n);c=_._transform(c,s);const i=new C.ServiceCollection(...(0,r.getSingletonServiceDescriptors)());i.set(g.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},c)),i.set(l.IExtHostRpcService,new l.ExtHostRpcService(s)),i.set(f.IURITransformerService,new f.URITransformerService(n)),i.set(E.IHostUtils,t);const a=new m.InstantiationService(i,!0),h=a.invokeFunction(v=>v.get(w.IExtHostTerminalService));this._disposables.add(h),this._logService=a.invokeFunction(v=>v.get(P.ILogService)),A.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",c),this._extensionService=a.invokeFunction(v=>v.get(E.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(v=>{Error.prepareStackTrace=(R,N)=>{let j="",ie,K;for(const B of N)j+=`
	at ${B.toString()}`,K=B.getFileName(),!ie&&K&&(ie=v.findSubstr(K));return p.set(R,ie),`${R.name||"Error"}: ${R.message||""}${j}`}});const S=s.getProxy(k.MainContext.MainThreadExtensionService),u=s.getProxy(k.MainContext.MainThreadErrors);I.setUnexpectedErrorHandler(v=>{const R=I.transformErrorForSerialization(v),N=p.get(v);N?S.$onExtensionRuntimeError(N.identifier,R):u.$onUnexpectedError(R)})}terminate(o){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${o}`),this._logService.flush(),this._disposables.dispose(),I.setUnexpectedErrorHandler(t=>{});const c=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),c]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(o,c){o.extensions.forEach(n=>n.extensionLocation=y.URI.revive(c.transformIncomingURIs(n.extensionLocation))),o.environment.appRoot=y.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const t=o.environment.extensionDevelopmentLocationURI;return t&&(o.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(c.transformIncomingURIs(n)))),o.environment.extensionTestsLocationURI=y.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=y.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=y.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.logsLocation=y.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.logFile=y.URI.revive(c.transformIncomingURIs(o.logFile)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.ExtensionHostMain=_}),define(me[267],ge([0,1,8,21,60,33,25,47,31]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(g,m,l){this.config=g,this.provider=m,this.sessionToken=l,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=g.filePattern,this.includePattern=g.includePattern&&T.parse(g.includePattern),this.maxResults=g.maxResults||void 0,this.exists=g.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=g.excludePattern&&T.parse(g.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(g=>g.cancel()),this.activeCancellationTokens=new Set}search(g){const m=this.config.folderQueries||[];return new Promise((l,f)=>{const E=w=>{this.resultCount++,g(w)};if(this.isCanceled)return l({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(w=>{const _=w.toString(),d=b.basename(_);this.globalExcludePattern&&this.globalExcludePattern(_,d)||this.matchFile(E,{base:w,basename:d})}),Promise.all(m.map(w=>this.searchInFolder(w,E))).then(w=>{l({limitHit:this.isLimitHit,stats:w[0]||void 0})},w=>{f(new Error((0,A.toErrorMessage)(w)))})})}async searchInFolder(g,m){const l=new I.CancellationTokenSource,f=this.getSearchOptionsForFolder(g),E=this.initDirectoryTree(),w=new D.QueryGlobTester(this.config,g),_=!w.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(l),d=k.StopWatch.create();const o=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,l.token),c=d.elapsed(),t=k.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(o&&o.forEach(n=>{const s=b.posix.relative(g.folder.path,n.path);if(_){const i=b.basename(n.path);this.matchFile(m,{base:g.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(E,g.folder,s,m)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(E,w,m),{providerTime:c,postProcessTime:t.elapsed()})}finally{l.dispose(),this.activeCancellationTokens.delete(l)}}getSearchOptionsForFolder(g){const m=(0,D.resolvePatternsForProvider)(this.config.includePattern,g.includePattern),l=(0,D.resolvePatternsForProvider)(this.config.excludePattern,g.excludePattern);return{folder:g.folder,excludes:l,includes:m,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}addDirectoryEntries({pathToEntries:g},m,l,f){if(l===this.filePattern){const w=b.basename(this.filePattern);this.matchFile(f,{base:m,relativePath:this.filePattern,basename:w})}function E(w){const _=b.basename(w),d=b.dirname(w);let o=g[d];o||(o=g[d]=[],E(d)),o.push({base:m,relativePath:w,basename:_})}E(l)}matchDirectoryTree({rootEntries:g,pathToEntries:m},l,f){const E=this,w=this.filePattern;function _(d){const o=T.hasSiblingFn(()=>d.map(c=>c.basename));for(let c=0,t=d.length;c<t;c++){const n=d[c],{relativePath:s,basename:i}=n;if(!!l.includedInQuerySync(s,i,w!==i?o:void 0)){const a=m[s];if(a)_(a);else{if(s===w)continue;E.matchFile(f,n)}if(E.isLimitHit)break}}}_(g)}matchFile(g,m){(!this.includePattern||m.relativePath&&this.includePattern(m.relativePath,m.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||g(m))}}class r{constructor(){this.sessions=new Map}fileSearch(g,m,l,f){const E=this.getSessionTokenSource(g.cacheKey),w=new P(g,m,E&&E.token);let _=0;const d=o=>{_+=o.length,l(o.map(c=>this.rawMatchToSearchItem(c)))};return this.doSearch(w,r.BATCH_SIZE,d,f).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:_,detailStats:o.stats}}))}clearCache(g){const m=this.getSessionTokenSource(g);m&&m.cancel()}getSessionTokenSource(g){if(!!g)return this.sessions.has(g)||this.sessions.set(g,new I.CancellationTokenSource),this.sessions.get(g)}rawMatchToSearchItem(g){return g.relativePath?{resource:y.joinPath(g.base,g.relativePath)}:{resource:g.base}}doSearch(g,m,l,f){f.onCancellationRequested(()=>{g.cancel()});const E=_=>{_&&(w.push(_),m>0&&w.length>=m&&(l(w),w=[]))};let w=[];return g.search(E).then(_=>(w.length&&l(w),_),_=>(w.length&&l(w),Promise.reject(_)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(me[129],ge([0,1,8,16,21,60,25,33,2,31,12,11]),function(G,e,b,I,A,T,y,k,D,P,r,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class g{constructor(d,o,c){this.query=d,this.provider=o,this.fileUtils=c,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,o){const c=this.query.folderQueries||[],t=new A.CancellationTokenSource;return o.onCancellationRequested(()=>t.cancel()),new Promise((n,s)=>{this.collector=new l(d);let i=!1;const a=(h,p)=>{if(!i&&!this.isLimitHit){const S=this.resultSize(h);E(h)&&typeof this.query.maxResults=="number"&&this.resultCount+S>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),h=this.trimResultToSize(h,this.query.maxResults-this.resultCount));const u=this.resultSize(h);this.resultCount+=u,(u>0||!E(h))&&this.collector.add(h,p)}};Promise.all(c.map((h,p)=>this.searchInFolder(h,S=>a(S,p),t.token))).then(h=>{t.dispose(),this.collector.flush();const p=h.some(S=>!!S&&!!S.limitHit);n({limitHit:this.isLimitHit||p,messages:(0,I.flatten)(h.map(S=>(S==null?void 0:S.message)?(0,C.isArray)(S.message)?S.message:[S.message]:[])),stats:{type:"textSearchProvider"}})},h=>{t.dispose();const p=(0,T.toErrorMessage)(h);s(new Error(p))})})}resultSize(d){return E(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,o){const c=Array.isArray(d.ranges)?d.ranges:[d.ranges],t=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:c.slice(0,o),preview:{matches:t.slice(0,o),text:d.preview.text},uri:d.uri}}async searchInFolder(d,o,c){const t=new P.QueryGlobTester(this.query,d),n=[],s={report:h=>{if(!!this.validateProviderResult(h)){const p=d.folder.scheme===r.Schemas.file?k.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(h.uri))):void 0,S=y.relativePath(d.folder,h.uri);S&&n.push(t.includedInQuery(S,b.basename(S),p).then(u=>{u&&o(h)}))}}},i=this.getSearchOptionsForFolder(d),a=await this.provider.provideTextSearchResults(m(this.query.contentPattern),i,s,c);return await Promise.all(n),a}validateProviderResult(d){if(E(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const o=(0,P.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),c=(0,P.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),t={folder:D.URI.from(d.folder),excludes:c,includes:o,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=g;function m(_){return{isCaseSensitive:_.isCaseSensitive||!1,isRegExp:_.isRegExp||!1,isWordMatch:_.isWordMatch||!1,isMultiline:_.isMultiline||!1,pattern:_.pattern}}class l{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new w(512,o=>this.sendItems(o))}add(d,o){this._currentFileMatch&&(this._currentFolderIdx!==o||!y.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=o,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(f(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=l;function f(_){return E(_)?{preview:{matches:(0,I.mapArrayOrNot)(_.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:_.preview.text},ranges:(0,I.mapArrayOrNot)(_.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:_.text,lineNumber:_.lineNumber}}function E(_){return!!_.preview}e.extensionResultIsMatch=E;class w{constructor(d,o){this.maxBatchSize=d,this.cb=o,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,o){!d||this.addItemToBatch(d,o)}addItems(d,o){!d||this.addItemsToBatch(d,o)}addItemToBatch(d,o){this.batch.push(d),this.batchSize+=o,this.onUpdate()}addItemsToBatch(d,o){this.batch=this.batch.concat(d),this.batchSize+=o,this.onUpdate()}onUpdate(){this.totalNumberCompleted<w.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},w.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=w,w.TIMEOUT=4e3,w.START_BATCH_AFTER_COUNT=50}),define(me[70],ge([0,1,6,5,4,267,15,63,14,2,129]),function(G,e,b,I,A,T,y,k,D,P,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,A.createDecorator)("IExtHostSearch");let C=class{constructor(f,E,w){this.extHostRpc=f,this._uriTransformer=E,this._logService=w,this._proxy=this.extHostRpc.getProxy(I.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,E){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const w=this._handlePool++;return this._textSearchProvider.set(w,E),this._proxy.$registerTextSearchProvider(w,this._transformScheme(f)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}registerFileSearchProvider(f,E){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const w=this._handlePool++;return this._fileSearchProvider.set(w,E),this._proxy.$registerFileSearchProvider(w,this._transformScheme(f)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(w),this._proxy.$unregisterProvider(w)})}$provideFileSearchResults(f,E,w,_){const d=g(w),o=this._fileSearchProvider.get(f);if(o)return this._fileSearchManager.fileSearch(d,o,c=>{this._proxy.$handleFileMatch(f,E,c.map(t=>t.resource))},_);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,E,w,_){const d=this._textSearchProvider.get(f);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const o=g(w);return this.createTextSearchManager(o,d).search(t=>this._proxy.$handleTextMatch(f,E,t),_)}createTextSearchManager(f,E){return new r.TextSearchManager(f,E,{readdir:w=>Promise.resolve([]),toCanonicalName:w=>w})}};C=qe([He(0,y.IExtHostRpcService),He(1,k.IURITransformerService),He(2,D.ILogService)],C),e.ExtHostSearch=C;function g(l){return Object.assign(Object.assign({},l),{folderQueries:l.folderQueries&&l.folderQueries.map(m),extraFileResources:l.extraFileResources&&l.extraFileResources.map(f=>P.URI.revive(f))})}e.reviveQuery=g;function m(l){return Object.assign(Object.assign({},l),{folder:P.URI.revive(l.folder)})}}),define(me[268],ge([0,1,160,21,17,3,58,2,151,109,141,77,45,5,230,229,51,231,35,232,233,234,215,235,39,42,236,216,238,239,240,65,219,243,244,245,92,34,246,220,20,7,249,66,128,32,41,53,202,237,118,127,68,46,70,14,63,15,28,241,200,50,64,227,247,199,93,91,252,250,251,228,62,259,248,90,196,120,242,85,67]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o,c,t,n,s,i,a,h,p,S,u,v,R,N,j,ie,K,B,$,U,L,O,M,F,W,q,Q,le,ve,Re,Se,Oe,z,Y,ee,se,fe,Ee,Be,pe,Ce,Me,ze,_e,Ke,X,ne,we,xe,je,Ve,Ze,De,ye,Pe,oe,ue,H,Z,ce,Ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ae(Le){const $e=Le.get(Be.IExtHostInitDataService),Xe=Le.get(De.IExtHostFileSystemInfo),rt=Le.get(we.IExtHostConsumerFileSystem),tt=Le.get(i.IExtHostExtensionService),Qe=Le.get(q.IExtHostWorkspace),mt=Le.get(H.IExtHostTelemetry),wt=Le.get(_.IExtHostConfiguration),be=Le.get(fe.IURITransformerService),he=Le.get(Ee.IExtHostRpcService),ae=Le.get(K.IExtHostStorage),J=Le.get(ne.IExtensionStoragePaths),Ne=Le.get(se.ILogService),Fe=Le.get(Me.IExtHostTunnelService),Ye=Le.get(ze.IExtHostApiDeprecationService),et=Le.get(W.IExtHostWindow),ut=Le.get(oe.IExtHostSecretState);he.set(m.ExtHostContext.ExtHostFileSystemInfo,Xe),he.set(m.ExtHostContext.ExtHostLogService,Ne),he.set(m.ExtHostContext.ExtHostWorkspace,Qe),he.set(m.ExtHostContext.ExtHostConfiguration,wt),he.set(m.ExtHostContext.ExtHostExtensionService,tt),he.set(m.ExtHostContext.ExtHostStorage,ae),he.set(m.ExtHostContext.ExtHostTunnelService,Fe),he.set(m.ExtHostContext.ExtHostWindow,et),he.set(m.ExtHostContext.ExtHostSecretState,ut),he.set(m.ExtHostContext.ExtHostTelemetry,mt);const ht=he.set(m.ExtHostContext.ExtHostDecorations,Le.get(Oe.IExtHostDecorations)),Je=he.set(m.ExtHostContext.ExtHostDocumentsAndEditors,Le.get(s.IExtHostDocumentsAndEditors)),at=he.set(m.ExtHostContext.ExtHostCommands,Le.get(E.IExtHostCommands)),ft=he.set(m.ExtHostContext.ExtHostTerminalService,Le.get(B.IExtHostTerminalService)),lt=he.set(m.ExtHostContext.ExtHostDebugService,Le.get(Y.IExtHostDebugService)),St=he.set(m.ExtHostContext.ExtHostSearch,Le.get(ee.IExtHostSearch)),vt=he.set(m.ExtHostContext.ExtHostTask,Le.get(z.IExtHostTask)),Pt=he.set(m.ExtHostContext.ExtHostOutputService,Le.get(v.IExtHostOutputService)),Tt=he.set(m.ExtHostContext.ExtHostEditorTabs,new ue.ExtHostEditorTabs),Rt=he.set(m.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(he)),_t=he.set(m.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(he,Je)),Zt=he.set(m.ExtHostContext.ExtHostDocumentContentProviders,new c.ExtHostDocumentContentProvider(he,Je,Ne)),en=he.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Ne,_t,he.getProxy(m.MainContext.MainThreadBulkEdits))),gt=he.set(m.ExtHostContext.ExtHostNotebook,new pe.ExtHostNotebookController(he,at,Je,_t,Ne,J)),tn=he.set(m.ExtHostContext.ExtHostNotebookKernels,new Z.ExtHostNotebookKernels(he,$e,gt)),Dt=he.set(m.ExtHostContext.ExtHostEditors,new $.ExtHostEditors(he,Je)),Gt=he.set(m.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(he.getProxy(m.MainContext.MainThreadTreeViews),at,Ne)),nn=he.set(m.ExtHostContext.ExtHostEditorInsets,new ve.ExtHostEditorInsets(he.getProxy(m.MainContext.MainThreadEditorInsets),Dt,$e.environment)),Qt=he.set(m.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(he,Ne)),ct=he.set(m.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(he,be,_t,at,Qt,Ne,Ye)),rn=he.set(m.ExtHostContext.ExtHostFileSystem,new a.ExtHostFileSystem(he,ct)),Lt=he.set(m.ExtHostContext.ExtHostFileSystemEventService,new h.ExtHostFileSystemEventService(he,Ne,Je)),Wt=he.set(m.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(he,Qe,at)),gn=he.set(m.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(he,at,Ne)),Dn=he.set(m.ExtHostContext.ExtHostComments,new w.ExtHostComments(he,at,_t)),pn=he.set(m.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(he.getProxy(m.MainContext.MainThreadProgress))),sn=he.set(m.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(he)),Xt=he.set(m.ExtHostContext.ExtHostTheming,new Ce.ExtHostTheming(he)),Ut=he.set(m.ExtHostContext.ExtHostAuthentication,new _e.ExtHostAuthentication(he)),Cn=he.set(m.ExtHostContext.ExtHostTimeline,new Ke.ExtHostTimeline(he,at)),on=he.set(m.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(he,$e.environment,Qe,Ne,Ye)),an=he.set(m.ExtHostContext.ExtHostWebviewPanels,new Ve.ExtHostWebviewPanels(he,on,Qe)),Yt=he.set(m.ExtHostContext.ExtHostCustomEditors,new je.ExtHostCustomEditors(he,_t,J,on,an)),kn=he.set(m.ExtHostContext.ExtHostWebviewViews,new xe.ExtHostWebviewViews(he,on)),Ft=he.set(m.ExtHostContext.ExtHostTesting,new ye.ExtHostTesting(he,Je,Qe)),ln=he.set(m.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(he)),Pn=(0,le.values)(m.ExtHostContext);he.assertRegistered(Pn);const $t=new Ze.ExtHostBulkEdits(he,Je),cn=new f.ExtHostClipboard(he),xt=new u.ExtHostMessageService(he,Ne),Mt=new o.ExtHostDialogs(he),vn=new ie.ExtHostStatusBar(he,at.converter),Ht=new S.ExtHostLanguages(he,_t);return l.ExtHostApiCommands.register(at),function(Ue,un,dn){const pt=function(){let te=!Ue.isUnderDevelopment;function de(Te){te||(Ne.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de(st);else{const bt=st;typeof bt.scheme=="undefined"&&de(st),!Ue.enableProposedApi&&typeof bt.exclusive=="boolean"&&(0,Q.throwProposedApiError)(Ue)}return st}}(),In={getSession(te,de,Te){return Ut.getSession(Ue,te,de,Te)},get onDidChangeSessions(){return Ut.onDidChangeSessions},registerAuthenticationProvider(te,de,Te,st){return Ut.registerAuthenticationProvider(te,de,Te,st)},get onDidChangeAuthenticationProviders(){return(0,Q.checkProposedApiEnabled)(Ue),Ut.onDidChangeAuthenticationProviders},get providers(){return(0,Q.checkProposedApiEnabled)(Ue),Ut.providers},logout(te,de){return(0,Q.checkProposedApiEnabled)(Ue),Ut.removeSession(te,de)}},An={registerCommand(te,de,Te){return at.registerCommand(!0,te,de,Te)},registerTextEditorCommand(te,de,Te){return at.registerCommand(!0,te,(...st)=>{const bt=Dt.getActiveTextEditor();if(!bt){Ne.warn("Cannot execute "+te+" because there is no active text editor.");return}return bt.edit(Ct=>{de.apply(Te,[bt,Ct,...st])}).then(Ct=>{Ct||Ne.warn("Edits from command "+te+" were not applied.")},Ct=>{Ne.warn("An error occurred while running command "+te,Ct)})})},registerDiffInformationCommand:(te,de,Te)=>((0,Q.checkProposedApiEnabled)(Ue),at.registerCommand(!0,te,async(...st)=>{const bt=Je.activeEditor(!0);if(!bt){Ne.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await Dt.getDiffInformation(bt.id);de.apply(Te,[Ct,...st])})),executeCommand(te,...de){return at.executeCommand(te,...de)},getCommands(te=!1){return at.getCommands(te)}},wn={get machineId(){return $e.telemetryInfo.machineId},get sessionId(){return $e.telemetryInfo.sessionId},get language(){return $e.environment.appLanguage},get appName(){return $e.environment.appName},get appRoot(){var te,de;return(de=(te=$e.environment.appRoot)===null||te===void 0?void 0:te.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return $e.environment.appUriScheme},get clipboard(){return cn.value},get shell(){return ft.getDefaultShell(!1,dn)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const te=Date.now()-new Date($e.telemetryInfo.firstSessionDate).getTime();return isNaN(te)?!1:te<1e3*60*60*24},openExternal(te,de){return et.openUri(te,{allowTunneling:!!$e.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},asExternalUri(te){return te.scheme===$e.environment.appUriScheme?Rt.createAppUri(te):et.asExternalUri(te,{allowTunneling:!!$e.remote.authority})},get remoteName(){return(0,Se.getRemoteName)($e.remote.authority)},get uiKind(){return $e.uiKind}};$e.environment.extensionTestsLocationURI||Object.freeze(wn);const bn=$e.remote.isRemote?O.ExtensionKind.Workspace:O.ExtensionKind.UI,zt={registerTestController(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.registerTestController(Ue.identifier.value,te)},createDocumentTestObserver(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createTextDocumentTestObserver(te)},createWorkspaceTestObserver(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createWorkspaceTestObserver(te)},runTests(te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.runTests(te)},createTestItem(te,de){return new O.TestItemImpl(te.id,te.label,te.uri,de)},createTestRun(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),Ft.createTestRun(Ue.identifier.value,te,de,Te)},get onDidChangeTestResults(){return(0,Q.checkProposedApiEnabled)(Ue),Ft.onResultsChanged},get testResults(){return(0,Q.checkProposedApiEnabled)(Ue),Ft.results}};zt.createTestRunTask=zt.createTestRun;const Tn={getExtension(te){const de=un.getExtensionDescription(te);if(de)return new i.Extension(tt,Ue.identifier,de,bn)},get all(){return un.getAllExtensionDescriptions().map(te=>new i.Extension(tt,Ue.identifier,te,bn))},get onDidChange(){return un.onDidChange}},Rn={createDiagnosticCollection(te){return Qt.createDiagnosticCollection(Ue.identifier,te)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:te=>Qt.getDiagnostics(te),getLanguages(){return Ht.getLanguages()},setTextDocumentLanguage(te,de){return Ht.changeLanguage(te.uri,de)},match(te,de){return(0,C.score)(L.LanguageSelector.from(te),de.uri,de.languageId,!0)},registerCodeActionsProvider(te,de,Te){return ct.registerCodeActionProvider(Ue,pt(te),de,Te)},registerCodeLensProvider(te,de){return ct.registerCodeLensProvider(Ue,pt(te),de)},registerDefinitionProvider(te,de){return ct.registerDefinitionProvider(Ue,pt(te),de)},registerDeclarationProvider(te,de){return ct.registerDeclarationProvider(Ue,pt(te),de)},registerImplementationProvider(te,de){return ct.registerImplementationProvider(Ue,pt(te),de)},registerTypeDefinitionProvider(te,de){return ct.registerTypeDefinitionProvider(Ue,pt(te),de)},registerHoverProvider(te,de){return ct.registerHoverProvider(Ue,pt(te),de,Ue.identifier)},registerEvaluatableExpressionProvider(te,de){return ct.registerEvaluatableExpressionProvider(Ue,pt(te),de,Ue.identifier)},registerInlineValuesProvider(te,de){return ct.registerInlineValuesProvider(Ue,pt(te),de,Ue.identifier)},registerDocumentHighlightProvider(te,de){return ct.registerDocumentHighlightProvider(Ue,pt(te),de)},registerLinkedEditingRangeProvider(te,de){return ct.registerLinkedEditingRangeProvider(Ue,pt(te),de)},registerReferenceProvider(te,de){return ct.registerReferenceProvider(Ue,pt(te),de)},registerRenameProvider(te,de){return ct.registerRenameProvider(Ue,pt(te),de)},registerDocumentSymbolProvider(te,de,Te){return ct.registerDocumentSymbolProvider(Ue,pt(te),de,Te)},registerWorkspaceSymbolProvider(te){return ct.registerWorkspaceSymbolProvider(Ue,te)},registerDocumentFormattingEditProvider(te,de){return ct.registerDocumentFormattingEditProvider(Ue,pt(te),de)},registerDocumentRangeFormattingEditProvider(te,de){return ct.registerDocumentRangeFormattingEditProvider(Ue,pt(te),de)},registerOnTypeFormattingEditProvider(te,de,Te,...st){return ct.registerOnTypeFormattingEditProvider(Ue,pt(te),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(te,de,Te){return ct.registerDocumentSemanticTokensProvider(Ue,pt(te),de,Te)},registerDocumentRangeSemanticTokensProvider(te,de,Te){return ct.registerDocumentRangeSemanticTokensProvider(Ue,pt(te),de,Te)},registerSignatureHelpProvider(te,de,Te,...st){return typeof Te=="object"?ct.registerSignatureHelpProvider(Ue,pt(te),de,Te):ct.registerSignatureHelpProvider(Ue,pt(te),de,typeof Te=="undefined"?[]:[Te,...st])},registerCompletionItemProvider(te,de,...Te){return ct.registerCompletionItemProvider(Ue,pt(te),de,Te)},registerDocumentLinkProvider(te,de){return ct.registerDocumentLinkProvider(Ue,pt(te),de)},registerColorProvider(te,de){return ct.registerColorProvider(Ue,pt(te),de)},registerFoldingRangeProvider(te,de){return ct.registerFoldingRangeProvider(Ue,pt(te),de)},registerSelectionRangeProvider(te,de){return ct.registerSelectionRangeProvider(Ue,te,de)},registerCallHierarchyProvider(te,de){return ct.registerCallHierarchyProvider(Ue,te,de)},setLanguageConfiguration:(te,de)=>ct.setLanguageConfiguration(Ue,te,de),getTokenInformationAtPosition(te,de){return(0,Q.checkProposedApiEnabled)(Ue),Ht.tokenAtPosition(te,de)},registerInlayHintsProvider(te,de){return(0,Q.checkProposedApiEnabled)(Ue),ct.registerInlayHintsProvider(Ue,te,de)}},Ln={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(te,de,Te){const st=await(k.URI.isUri(te)?Promise.resolve(_n.openTextDocument(te)):Promise.resolve(te));return Dt.showTextDocument(st,de,Te)},createTextEditorDecorationType(te){return Dt.createTextEditorDecorationType(te)},onDidChangeActiveTextEditor(te,de,Te){return Dt.onDidChangeActiveTextEditor(te,de,Te)},onDidChangeVisibleTextEditors(te,de,Te){return Dt.onDidChangeVisibleTextEditors(te,de,Te)},onDidChangeTextEditorSelection(te,de,Te){return Dt.onDidChangeTextEditorSelection(te,de,Te)},onDidChangeTextEditorOptions(te,de,Te){return Dt.onDidChangeTextEditorOptions(te,de,Te)},onDidChangeTextEditorVisibleRanges(te,de,Te){return Dt.onDidChangeTextEditorVisibleRanges(te,de,Te)},onDidChangeTextEditorViewColumn(te,de,Te){return Dt.onDidChangeTextEditorViewColumn(te,de,Te)},onDidCloseTerminal(te,de,Te){return ft.onDidCloseTerminal(te,de,Te)},onDidOpenTerminal(te,de,Te){return ft.onDidOpenTerminal(te,de,Te)},onDidChangeActiveTerminal(te,de,Te){return ft.onDidChangeActiveTerminal(te,de,Te)},onDidChangeTerminalDimensions(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ft.onDidChangeTerminalDimensions(te,de,Te)},onDidWriteTerminalData(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ft.onDidWriteTerminalData(te,de,Te)},get state(){return et.state},onDidChangeWindowState(te,de,Te){return et.onDidChangeWindowState(te,de,Te)},showInformationMessage(te,...de){return xt.showMessage(Ue,y.default.Info,te,de[0],de.slice(1))},showWarningMessage(te,...de){return xt.showMessage(Ue,y.default.Warning,te,de[0],de.slice(1))},showErrorMessage(te,...de){return xt.showMessage(Ue,y.default.Error,te,de[0],de.slice(1))},showQuickPick(te,de,Te){return Wt.showQuickPick(te,!!Ue.enableProposedApi,de,Te)},showWorkspaceFolderPick(te){return Wt.showWorkspaceFolderPick(te)},showInputBox(te,de){return Wt.showInput(te,de)},showOpenDialog(te){return Mt.showOpenDialog(te)},showSaveDialog(te){return Mt.showSaveDialog(te)},createStatusBarItem(te,de){let Te,st,bt,Ct;return te&&typeof te!="number"?(Te=te.id,st=te.name,bt=te.alignment,de=te.priority,Ct=te.accessibilityInformation):(Te=Ue.identifier.value,st=b.localize(0,null,Ue.displayName||Ue.name),bt=te),vn.createStatusBarEntry(Te,st,bt,de,Ct)},setStatusBarMessage(te,de){return vn.setStatusBarMessage(te,de)},withScmProgress(te){return Ye.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pn.withProgress(Ue,{location:O.ProgressLocation.SourceControl},(de,Te)=>te({report(st){}}))},withProgress(te,de){return pn.withProgress(Ue,te,de)},createOutputChannel(te){return Pt.createOutputChannel(te)},createWebviewPanel(te,de,Te,st){return an.createWebviewPanel(Ue,te,de,Te,st)},createWebviewTextEditorInset(te,de,Te,st){return(0,Q.checkProposedApiEnabled)(Ue),nn.createWebviewEditorInset(te,de,Te,st,Ue)},createTerminal(te,de,Te){return typeof te=="object"?"pty"in te?ft.createExtensionTerminal(te):(te.icon&&(0,Q.checkProposedApiEnabled)(Ue),ft.createTerminalFromOptions(te)):ft.createTerminal(te,de,Te)},registerTerminalLinkProvider(te){return ft.registerLinkProvider(te)},registerTreeDataProvider(te,de){return Gt.registerTreeDataProvider(te,de,Ue)},createTreeView(te,de){return Gt.createTreeView(te,de,Ue)},registerWebviewPanelSerializer:(te,de)=>an.registerWebviewPanelSerializer(Ue,te,de),registerCustomEditorProvider:(te,de,Te={})=>Yt.registerCustomEditorProvider(Ue,te,de,Te),registerFileDecorationProvider(te){return ht.registerFileDecorationProvider(te,Ue.identifier)},registerUriHandler(te){return Rt.registerUriHandler(Ue.identifier,te)},createQuickPick(){return Wt.createQuickPick(Ue.identifier,!!Ue.enableProposedApi)},createInputBox(){return Wt.createInputBox(Ue.identifier)},get activeColorTheme(){return Xt.activeColorTheme},onDidChangeActiveColorTheme(te,de,Te){return Xt.onDidChangeActiveColorTheme(te,de,Te)},registerWebviewViewProvider(te,de,Te){return kn.registerWebviewViewProvider(Ue,te,de,Te==null?void 0:Te.webviewOptions)},get activeNotebookEditor(){return(0,Q.checkProposedApiEnabled)(Ue),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeActiveNotebookEditor(te,de,Te)},get visibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Ue),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookEditorSelection(te,de,Te)},onDidChangeNotebookEditorVisibleRanges(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookEditorVisibleRanges(te,de,Te)},showNotebookDocument(te,de){return(0,Q.checkProposedApiEnabled)(Ue),gt.showNotebookDocument(te,de)},registerExternalUriOpener(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),ln.registerExternalUriOpener(Ue.identifier,te,de,Te)},get openEditors(){return(0,Q.checkProposedApiEnabled)(Ue),Tt.tabs},get onDidChangeOpenEditors(){return(0,Q.checkProposedApiEnabled)(Ue),Tt.onDidChangeTabs}},_n={get rootPath(){return Ye.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(te){throw A.readonly()},getWorkspaceFolder(te){return Qe.getWorkspaceFolder(te)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(te){throw A.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(te){throw A.readonly()},updateWorkspaceFolders:(te,de,...Te)=>Qe.updateWorkspaceFolders(Ue,te,de||0,...Te),onDidChangeWorkspaceFolders:function(te,de,Te){return Qe.onDidChangeWorkspace(te,de,Te)},asRelativePath:(te,de)=>Qe.getRelativePath(te,de),findFiles:(te,de,Te,st)=>Qe.findFiles(L.GlobPattern.from(te),L.GlobPattern.from(de),Te,Ue.identifier,st),findTextInFiles:(te,de,Te,st)=>{let bt,Ct;return typeof de=="object"?(bt=de,Ct=Te):(bt={},Ct=de,st=Te),Qe.findTextInFiles(te,bt||{},Ct,Ue.identifier,st)},saveAll:te=>Qe.saveAll(te),applyEdit(te){return $t.applyWorkspaceEdit(te)},createFileSystemWatcher:(te,de,Te,st)=>Lt.createFileSystemWatcher(L.GlobPattern.from(te),de,Te,st),get textDocuments(){return _t.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw A.readonly()},openTextDocument(te){let de;const Te=te;if(typeof te=="string")de=Promise.resolve(k.URI.file(te));else if(k.URI.isUri(te))de=Promise.resolve(te);else if(!Te||typeof Te=="object")de=_t.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>_t.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(te,de,Te)=>_t.onDidAddDocument(te,de,Te),onDidCloseTextDocument:(te,de,Te)=>_t.onDidRemoveDocument(te,de,Te),onDidChangeTextDocument:(te,de,Te)=>_t.onDidChangeDocument(te,de,Te),onDidSaveTextDocument:(te,de,Te)=>_t.onDidSaveDocument(te,de,Te),onWillSaveTextDocument:(te,de,Te)=>en.getOnWillSaveTextDocumentEvent(Ue)(te,de,Te),onDidChangeConfiguration:(te,de,Te)=>dn.onDidChangeConfiguration(te,de,Te),getConfiguration(te,de){return de=arguments.length===1?void 0:de,dn.getConfiguration(te,de,Ue)},registerTextDocumentContentProvider(te,de){return Zt.registerTextDocumentContentProvider(te,de)},registerTaskProvider:(te,de)=>(Ye.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Ue,te,de)),registerFileSystemProvider(te,de,Te){return rn.registerFileSystemProvider(Ue.identifier,te,de,Te)},get fs(){return rt.value},registerFileSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),St.registerFileSearchProvider(te,de)),registerTextSearchProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),St.registerTextSearchProvider(te,de)),registerRemoteAuthorityResolver:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),tt.registerRemoteAuthorityResolver(te,de)),registerResourceLabelFormatter:te=>((0,Q.checkProposedApiEnabled)(Ue),sn.$registerResourceLabelFormatter(te)),onDidCreateFiles:(te,de,Te)=>Lt.onDidCreateFile(te,de,Te),onDidDeleteFiles:(te,de,Te)=>Lt.onDidDeleteFile(te,de,Te),onDidRenameFiles:(te,de,Te)=>Lt.onDidRenameFile(te,de,Te),onWillCreateFiles:(te,de,Te)=>Lt.getOnWillCreateFileEvent(Ue)(te,de,Te),onWillDeleteFiles:(te,de,Te)=>Lt.getOnWillDeleteFileEvent(Ue)(te,de,Te),onWillRenameFiles:(te,de,Te)=>Lt.getOnWillRenameFileEvent(Ue)(te,de,Te),openTunnel:te=>((0,Q.checkProposedApiEnabled)(Ue),Fe.openTunnel(Ue,te).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Q.checkProposedApiEnabled)(Ue),Fe.getTunnels()},onDidChangeTunnels:(te,de,Te)=>((0,Q.checkProposedApiEnabled)(Ue),Fe.onDidChangeTunnels(te,de,Te)),registerPortAttributesProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),Fe.registerPortsAttributesProvider(te,de)),registerTimelineProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),Cn.registerTimelineProvider(te,de,Ue.identifier,at.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:te=>((0,Q.checkProposedApiEnabled)(Ue),Qe.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,de,Te)=>Qe.onDidGrantWorkspaceTrust(te,de,Te)},Fn={get inputBox(){return Ye.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),gn.getLastInputBox(Ue)},createSourceControl(te,de,Te){return gn.createSourceControl(Ue,te,de,Te)}},En={createCommentController(te,de){return Dn.createCommentController(Ue,te,de)}},Sn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(te,de,Te){return lt.onDidStartDebugSession(te,de,Te)},onDidTerminateDebugSession(te,de,Te){return lt.onDidTerminateDebugSession(te,de,Te)},onDidChangeActiveDebugSession(te,de,Te){return lt.onDidChangeActiveDebugSession(te,de,Te)},onDidReceiveDebugSessionCustomEvent(te,de,Te){return lt.onDidReceiveDebugSessionCustomEvent(te,de,Te)},onDidChangeBreakpoints(te,de,Te){return lt.onDidChangeBreakpoints(te,de,Te)},registerDebugConfigurationProvider(te,de,Te){return lt.registerDebugConfigurationProvider(te,de,Te||O.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,de){return lt.registerDebugAdapterDescriptorFactory(Ue,te,de)},registerDebugAdapterTrackerFactory(te,de){return lt.registerDebugAdapterTrackerFactory(te,de)},startDebugging(te,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?lt.startDebugging(te,de,{parentSession:Te}):lt.startDebugging(te,de,Te||{})},stopDebugging(te){return lt.stopDebugging(te)},addBreakpoints(te){return lt.addBreakpoints(te)},removeBreakpoints(te){return lt.removeBreakpoints(te)},asDebugSourceUri(te,de){return lt.asDebugSourceUri(te,de)}},Bt={registerTaskProvider:(te,de)=>vt.registerTaskProvider(Ue,te,de),fetchTasks:te=>vt.fetchTasks(te),executeTask:te=>vt.executeTask(Ue,te),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(te,de,Te)=>vt.onDidStartTask(te,de,Te),onDidEndTask:(te,de,Te)=>vt.onDidEndTask(te,de,Te),onDidStartTaskProcess:(te,de,Te)=>vt.onDidStartTaskProcess(te,de,Te),onDidEndTaskProcess:(te,de,Te)=>vt.onDidEndTaskProcess(te,de,Te)},Vt={openNotebookDocument:te=>((0,Q.checkProposedApiEnabled)(Ue),gt.openNotebookDocument(te)),get onDidOpenNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,Q.checkProposedApiEnabled)(Ue),gt.notebookDocuments.map(te=>te.apiNotebook)},registerNotebookSerializer(te,de,Te,st){return(0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookSerializer(Ue,te,de,Te,Ue.enableProposedApi?st:void 0)},registerNotebookContentProvider:(te,de,Te,st)=>((0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookContentProvider(Ue,te,de,Te,Ue.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(te,de)=>((0,Q.checkProposedApiEnabled)(Ue),gt.registerNotebookCellStatusBarItemProvider(Ue,te,de)),createNotebookEditorDecorationType(te){return(0,Q.checkProposedApiEnabled)(Ue),gt.createNotebookEditorDecorationType(te)},onDidChangeNotebookDocumentMetadata(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookDocumentMetadata(te,de,Te)},onDidChangeNotebookCells(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookCells(te,de,Te)},onDidChangeCellExecutionState(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeNotebookCellExecutionState(te,de,Te)},onDidChangeCellOutputs(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeCellOutputs(te,de,Te)},onDidChangeCellMetadata(te,de,Te){return(0,Q.checkProposedApiEnabled)(Ue),gt.onDidChangeCellMetadata(te,de,Te)},createConcatTextDocument(te,de){return(0,Q.checkProposedApiEnabled)(Ue),new X.ExtHostNotebookConcatDocument(gt,_t,te,de)},createNotebookController(te,de,Te,st,bt){return(0,Q.checkProposedApiEnabled)(Ue),tn.createNotebookController(Ue,te,de,Te,st,bt)}};return{version:$e.version,authentication:In,commands:An,comments:En,debug:Sn,env:wn,extensions:Tn,languages:Rn,notebook:Vt,scm:Fn,tasks:Bt,test:zt,window:Ln,workspace:_n,Breakpoint:O.Breakpoint,CallHierarchyIncomingCall:O.CallHierarchyIncomingCall,CallHierarchyItem:O.CallHierarchyItem,CallHierarchyOutgoingCall:O.CallHierarchyOutgoingCall,CancellationError:A.CancellationError,CancellationTokenSource:I.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:O.CodeAction,CodeActionKind:O.CodeActionKind,CodeActionTriggerKind:O.CodeActionTriggerKind,CodeLens:O.CodeLens,Color:O.Color,ColorInformation:O.ColorInformation,ColorPresentation:O.ColorPresentation,ColorThemeKind:O.ColorThemeKind,CommentMode:O.CommentMode,CommentThreadCollapsibleState:O.CommentThreadCollapsibleState,CompletionItem:O.CompletionItem,CompletionItemKind:O.CompletionItemKind,CompletionItemTag:O.CompletionItemTag,CompletionList:O.CompletionList,CompletionTriggerKind:O.CompletionTriggerKind,ConfigurationTarget:O.ConfigurationTarget,CustomExecution:O.CustomExecution,DebugAdapterExecutable:O.DebugAdapterExecutable,DebugAdapterInlineImplementation:O.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:O.DebugAdapterNamedPipeServer,DebugAdapterServer:O.DebugAdapterServer,DebugConfigurationProviderTriggerKind:O.DebugConfigurationProviderTriggerKind,DebugConsoleMode:O.DebugConsoleMode,DecorationRangeBehavior:O.DecorationRangeBehavior,Diagnostic:O.Diagnostic,DiagnosticRelatedInformation:O.DiagnosticRelatedInformation,DiagnosticSeverity:O.DiagnosticSeverity,DiagnosticTag:O.DiagnosticTag,Disposable:O.Disposable,DocumentHighlight:O.DocumentHighlight,DocumentHighlightKind:O.DocumentHighlightKind,DocumentLink:O.DocumentLink,DocumentSymbol:O.DocumentSymbol,EndOfLine:O.EndOfLine,EnvironmentVariableMutatorType:O.EnvironmentVariableMutatorType,EvaluatableExpression:O.EvaluatableExpression,InlineValueText:O.InlineValueText,InlineValueVariableLookup:O.InlineValueVariableLookup,InlineValueEvaluatableExpression:O.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:O.ExtensionKind,ExtensionMode:O.ExtensionMode,ExternalUriOpenerPriority:O.ExternalUriOpenerPriority,FileChangeType:O.FileChangeType,FileDecoration:O.FileDecoration,FileSystemError:O.FileSystemError,FileType:g.FileType,FoldingRange:O.FoldingRange,FoldingRangeKind:O.FoldingRangeKind,FunctionBreakpoint:O.FunctionBreakpoint,Hover:O.Hover,IndentAction:r.IndentAction,Location:O.Location,MarkdownString:O.MarkdownString,OverviewRulerLane:P.OverviewRulerLane,ParameterInformation:O.ParameterInformation,PortAutoForwardAction:O.PortAutoForwardAction,Position:O.Position,ProcessExecution:O.ProcessExecution,ProgressLocation:O.ProgressLocation,QuickInputButtons:O.QuickInputButtons,Range:O.Range,RelativePattern:O.RelativePattern,Selection:O.Selection,SelectionRange:O.SelectionRange,SemanticTokens:O.SemanticTokens,SemanticTokensBuilder:O.SemanticTokensBuilder,SemanticTokensEdit:O.SemanticTokensEdit,SemanticTokensEdits:O.SemanticTokensEdits,SemanticTokensLegend:O.SemanticTokensLegend,ShellExecution:O.ShellExecution,ShellQuoting:O.ShellQuoting,SignatureHelp:O.SignatureHelp,SignatureHelpTriggerKind:O.SignatureHelpTriggerKind,SignatureInformation:O.SignatureInformation,SnippetString:O.SnippetString,SourceBreakpoint:O.SourceBreakpoint,StandardTokenType:O.StandardTokenType,StatusBarAlignment:O.StatusBarAlignment,SymbolInformation:O.SymbolInformation,SymbolKind:O.SymbolKind,SymbolTag:O.SymbolTag,Task:O.Task,TaskGroup:O.TaskGroup,TaskPanelKind:O.TaskPanelKind,TaskRevealKind:O.TaskRevealKind,TaskScope:O.TaskScope,TextDocumentSaveReason:O.TextDocumentSaveReason,TextEdit:O.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:O.TextEditorLineNumbersStyle,TextEditorRevealType:O.TextEditorRevealType,TextEditorSelectionChangeKind:O.TextEditorSelectionChangeKind,ThemeColor:O.ThemeColor,ThemeIcon:O.ThemeIcon,TreeItem:O.TreeItem,TreeItemCollapsibleState:O.TreeItemCollapsibleState,UIKind:m.UIKind,Uri:k.URI,ViewColumn:O.ViewColumn,WorkspaceEdit:O.WorkspaceEdit,InlayHint:O.InlayHint,InlayHintKind:O.InlayHintKind,RemoteAuthorityResolverError:O.RemoteAuthorityResolverError,RemoteTrustOption:ce.RemoteTrustOption,ResolvedAuthority:O.ResolvedAuthority,SourceControlInputBoxValidationType:O.SourceControlInputBoxValidationType,ExtensionRuntime:O.ExtensionRuntime,TimelineItem:O.TimelineItem,NotebookRange:O.NotebookRange,NotebookCellKind:O.NotebookCellKind,NotebookCellExecutionState:O.NotebookCellExecutionState,NotebookDocumentMetadata:O.NotebookDocumentMetadata,NotebookCellMetadata:O.NotebookCellMetadata,NotebookCellData:O.NotebookCellData,NotebookData:O.NotebookData,NotebookKernelPreload:O.NotebookKernelPreload,NotebookCellStatusBarAlignment:O.NotebookCellStatusBarAlignment,NotebookEditorRevealType:O.NotebookEditorRevealType,NotebookCellOutput:O.NotebookCellOutput,NotebookCellOutputItem:O.NotebookCellOutputItem,NotebookCellStatusBarItem:O.NotebookCellStatusBarItem,NotebookControllerAffinity:O.NotebookControllerAffinity,LinkedEditingRanges:O.LinkedEditingRanges,TestItemStatus:O.TestItemStatus,TestResultState:O.TestResultState,TestMessage:O.TestMessage,TextSearchCompleteMessageType:Ie.TextSearchCompleteMessageType,TestMessageSeverity:O.TestMessageSeverity,WorkspaceTrustState:O.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ae}),define(me[269],ge([0,1,79,65,32,127,35,51,39,34,68,46,70,93,92,50,64,128,91,62,90,120]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_,d,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(m.IExtensionStoragePaths,m.ExtensionStoragePaths),(0,b.registerSingleton)(E.IExtHostApiDeprecationService,E.ExtHostApiDeprecationService),(0,b.registerSingleton)(k.IExtHostCommands,k.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,b.registerSingleton)(C.IExtHostDebugService,C.WorkerExtHostDebugService),(0,b.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,b.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo),(0,b.registerSingleton)(I.IExtHostOutputService,I.ExtHostOutputService),(0,b.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch),(0,b.registerSingleton)(l.IExtHostStorage,l.ExtHostStorage),(0,b.registerSingleton)(r.IExtHostTask,r.WorkerExtHostTask),(0,b.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,b.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,b.registerSingleton)(w.IExtHostWindow,w.ExtHostWindow),(0,b.registerSingleton)(A.IExtHostWorkspace,A.ExtHostWorkspace),(0,b.registerSingleton)(o.IExtHostSecretState,o.ExtHostSecretState),(0,b.registerSingleton)(c.IExtHostTelemetry,c.ExtHostTelemetry)}),define(me[94],ge([0,1,16,14,31,67]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function y(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.anchorGlob=y;function k(C,g,m,l){const f=(0,b.mapArrayOrNot)(m,D),E=new A.TextSearchMatch(g,f,l),w=E.preview.matches;return{ranges:(0,b.mapArrayOrNot)(f,P),uri:C,preview:{text:E.preview.text,matches:(0,b.mapArrayOrNot)(w,P)}}}e.createTextSearchResult=k;function D(C){return new A.SearchRange(C.start.line,C.start.character,C.end.line,C.end.character)}function P(C){return new T.Range(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let r=class{constructor(g,m){this.prefix=g,this.logService=m}appendLine(g){this.logService.debug(`${this.prefix}#search`,g)}};r=qe([He(1,I.ILogService)],r),e.OutputChannel=r}),define(me[270],ge([0,1,96,23]),function(G,e,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function A(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(n=>n===t)}e.isUTFEncoding=A,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const T=512,y=512,k=512*8,D=512*128;class P{constructor(n){this.iconvLiteDecoder=n}static async create(n){let s;if(n!==e.UTF8)s=(await new Promise((a,h)=>{G(["iconv-lite-umd"],a,h)})).getDecoder(m(n));else{const i=new TextDecoder;s={write(a){return i.decode(a,{stream:!0})},end(){return i.decode()}}}return new P(s)}write(n){return this.iconvLiteDecoder.write(n)}end(){return this.iconvLiteDecoder.end()}}function r(t,n){var s;const i=((s=n.minBytesRequiredForDetection)!==null&&s!==void 0?s:n.guessEncoding)?k:y;return new Promise((a,h)=>{const p=(0,b.newWriteableStream)(N=>N.join("")),S=[];let u=0,v;const R=async()=>{try{const N=await c({buffer:I.VSBuffer.concat(S),bytesRead:u},n.guessEncoding);N.encoding=await n.overwriteEncoding(N.encoding),v=await P.create(N.encoding);const j=v.write(I.VSBuffer.concat(S).buffer);p.write(j),S.length=0,u=0,a({stream:p,detected:N})}catch(N){h(N)}};(0,b.listenStream)(t,{onData:async N=>{v?p.write(v.write(N.buffer)):(S.push(N),u+=N.byteLength,u>=i&&(t.pause(),await R(),setTimeout(()=>t.resume())))},onError:N=>p.error(N),onEnd:async()=>{v||await R(),p.end(v==null?void 0:v.end())}})})}e.toDecodeStream=r;async function C(t,n,s){const a=(await new Promise((S,u)=>{G(["iconv-lite-umd"],S,u)})).getEncoder(m(n),s);let h=!1,p=!1;return{read(){if(p)return null;const S=t.read();if(typeof S!="string"){if(p=!0,!h&&(s==null?void 0:s.addBOM))switch(n){case e.UTF8:case e.UTF8_with_bom:return I.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return I.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const u=a.end();return u&&u.length>0?(h=!0,I.VSBuffer.wrap(u)):null}return h=!0,I.VSBuffer.wrap(a.write(S))}}}e.toEncodeReadable=C;async function g(t){return(await new Promise((s,i)=>{G(["iconv-lite-umd"],s,i)})).encodingExists(m(t))}e.encodingExists=g;function m(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=m;function l(t,n){if(!t||n<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),i=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&i===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&i===e.UTF16le_BOM[1])return e.UTF16le;if(n<e.UTF8_BOM.length)return null;const a=t.readUInt8(2);return s===e.UTF8_BOM[0]&&i===e.UTF8_BOM[1]&&a===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=l;const f=["ascii","utf-16","utf-32"];async function E(t){const n=await new Promise((p,S)=>{G(["jschardet"],p,S)}),s=t.slice(0,D),i=d(s.buffer),a=n.detect(i);if(!a||!a.encoding)return null;const h=a.encoding.toLowerCase();return 0<=f.indexOf(h)?null:_(a.encoding)}const w={ibm866:"cp866",big5:"cp950"};function _(t){const n=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return w[n]||n}function d(t){let n="";for(let s=0;s<t.length;s++)n+=String.fromCharCode(t[s]);return n}function o(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const n=t.match(/windows(\d+)/);return n?"windows-"+n[1]:t}}e.toCanonicalName=o;function c({buffer:t,bytesRead:n},s){let i=l(t,n),a=!1;if(i!==e.UTF16be&&i!==e.UTF16le&&t){let h=!0,p=!0,S=!1;for(let u=0;u<n&&u<T;u++){const v=u%2==1,R=t.readUInt8(u)===0;if(R&&(S=!0),h&&(v&&!R||!v&&R)&&(h=!1),p&&(v&&R||!v&&!R)&&(p=!1),R&&!h&&!p)break}S&&(h?i=e.UTF16le:p?i=e.UTF16be:a=!0)}return s&&!a&&!i&&t?E(t.slice(0,n)).then(h=>({seemsBinary:!1,encoding:h})):{seemsBinary:a,encoding:i}}e.detectEncodingFromBuffer=c,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(me[130],ge([0,1,270,26,129]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class T extends A.TextSearchManager{constructor(k,D,P=I){super(k,D,{readdir:r=>P.readdir(r.fsPath),toCanonicalName:r=>(0,b.toCanonicalName)(r)})}}e.NativeTextSearchManager=T}),define(me[271],ge([0,1,272,286,287,2,288]),function(G,e,b,I,A,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function k(C,g,m,l,f,E){const w=E.environment.useHostProxy,_=typeof w=="boolean"?w:!E.remote.isRemote,d=(0,y.createProxyResolver)({resolveProxy:c=>C.resolveProxy(c),getHttpProxySetting:()=>g.getConfiguration("http").get("proxy"),log:(c,t,...n)=>{switch(c){case y.LogLevel.Trace:l.trace(t,...n);break;case y.LogLevel.Debug:l.debug(t,...n);break;case y.LogLevel.Info:l.info(t,...n);break;case y.LogLevel.Warning:l.warn(t,...n);break;case y.LogLevel.Error:l.error(t,...n);break;case y.LogLevel.Critical:l.critical(t,...n);break;case y.LogLevel.Off:break;default:s(c,t,n);break}function s(i,a,...h){l.error("Unknown log level",i),l.error(a,...h)}},getLogLevel:()=>l.getLevel(),proxyResolveTelemetry:c=>{f.$publicLog2("resolveProxy",c)},useHostProxy:_,env:process.env}),o=D(g,d);return r(m,o)}e.connectProxyResolver=k;function D(C,g){const m={config:C.getConfiguration("http").get("proxySupport")||"off"};C.onDidChangeConfiguration(f=>{m.config=C.getConfiguration("http").get("proxySupport")||"off"});const l={config:!!C.getConfiguration("http").get("systemCertificates")};return C.onDidChangeConfiguration(f=>{l.config=!!C.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},b,(0,y.createHttpPatch)(b,g,{config:"off"},l,!0)),on:Object.assign({},b,(0,y.createHttpPatch)(b,g,{config:"on"},l,!0)),override:Object.assign({},b,(0,y.createHttpPatch)(b,g,{config:"override"},l,!0)),onRequest:Object.assign({},b,(0,y.createHttpPatch)(b,g,m,l,!0)),default:Object.assign(b,(0,y.createHttpPatch)(b,g,m,l,!1))},https:{off:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"off"},l,!0)),on:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"on"},l,!0)),override:Object.assign({},I,(0,y.createHttpPatch)(I,g,{config:"override"},l,!0)),onRequest:Object.assign({},I,(0,y.createHttpPatch)(I,g,m,l,!0)),default:Object.assign(I,(0,y.createHttpPatch)(I,g,m,l,!1))},tls:Object.assign(A,(0,y.createTlsPatch)(A))}}const P=new Map;function r(C,g){return C.getExtensionPathIndex().then(m=>{const l=G.__$__nodeRequire("module"),f=l._load;l._load=function(w,_,d){if(w==="tls")return g.tls;if(w!=="http"&&w!=="https")return f.apply(this,arguments);const o=g[w],c=m.findSubstr(T.URI.file(_.filename).fsPath);let t=P.get(c);if(t||P.set(c,t={}),!t[w]){let n=o.default;c&&c.enableProposedApi&&(n=o[c.proxySupport]||o.onRequest),t[w]=Object.assign({},n)}return t[w]}})}}),define(me[273],ge([0,1,38,8,75,29,10,9,94,274]),function(G,e,b,I,A,T,y,k,D,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=P.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(d,o,c,t){const n=g(d,o,c,t),s=o.folder.fsPath;return{cmd:b.spawn(r,n.args,{cwd:s}),rgDiskPath:r,siblingClauses:n.siblingClauses,rgArgs:n,cwd:s}}e.spawnRipgrepCmd=C;function g(d,o,c,t){const n=["--files","--hidden","--case-sensitive"];l([o],c,!1).forEach(i=>{const a=(0,D.anchorGlob)(i);if(n.push("-g",a),y.isMacintosh){const h=(0,A.normalizeNFD)(a);h!==a&&n.push("-g",h)}});const s=m([o],t,void 0,!1);return s.globArgs.forEach(i=>{const a=`!${(0,D.anchorGlob)(i)}`;if(n.push("-g",a),y.isMacintosh){const h=(0,A.normalizeNFD)(a);h!==a&&n.push("-g",h)}}),o.disregardIgnoreFiles!==!1?n.push("--no-ignore"):n.push("--no-ignore-parent"),o.ignoreSymlinks||n.push("--follow"),d.exists&&n.push("--quiet"),n.push("--no-config"),o.disregardGlobalIgnoreFiles&&n.push("--no-ignore-global"),{args:n,siblingClauses:s.siblingClauses}}function m(d,o,c,t=!0){const n=[];let s={};return d.forEach(i=>{const a=Object.assign({},i.excludePattern||{},o||{}),h=f(a,t?i.folder.fsPath:void 0,c);n.push(...h.globArgs),h.siblingClauses&&(s=Object.assign(s,h.siblingClauses))}),{globArgs:n,siblingClauses:s}}e.foldersToRgExcludeGlobs=m;function l(d,o,c=!0){const t=[];return d.forEach(n=>{const s=Object.assign({},o||{},n.includePattern||{}),i=f(s,c?n.folder.fsPath:void 0);t.push(...i.globArgs)}),t}e.foldersToIncludeGlobs=l;function f(d,o,c){const t=[],n={};return Object.keys(d).forEach(s=>{if(!(c&&c.has(s))&&!!s){const i=d[s];s=w(o?E(o,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof i=="boolean"&&i?(s.startsWith("\\\\")&&(s+="**"),t.push(_(s))):i&&i.when&&(n[s]=i)}}),{globArgs:t,siblingClauses:n}}function E(d,o){return I.isAbsolute(o)?o:I.join(d,o)}e.getAbsoluteGlob=E;function w(d){return d=k.rtrim(d,"\\"),k.rtrim(d,"/")}function _(d){return T.getRoot(d).toLowerCase()==="c:/"?d.replace(/^c:[/\\]/i,"/"):d}e.fixDriveC=_}),define(me[275],ge([0,1,38,37,8,103,16,60,33,75,29,10,47,9,11,26,31,273,101]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const d=new Set;process.on("exit",()=>{d.forEach(s=>s())});class o{constructor(i){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=i,this.filePattern=i.filePattern||"",this.includePattern=i.includePattern&&D.parse(i.includePattern),this.maxResults=i.maxResults||null,this.exists=!!i.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=(0,_.prepareQuery)(this.filePattern).normalizedLowercase),this.globalExcludePattern=i.excludePattern&&D.parse(i.excludePattern),this.folderExcludePatterns=new Map,i.folderQueries.forEach(a=>{const h=Object.assign({},a.excludePattern||{},this.config.excludePattern||{}),p=a.folder.fsPath;i.folderQueries.map(S=>S.folder.fsPath).filter(S=>S!==p).forEach(S=>{(0,r.isEqualOrParent)(S,p)&&(h[A.relative(p,S)]=!0)}),this.folderExcludePatterns.set(p,new t(h,p))})}cancel(){this.isCanceled=!0}walk(i,a,h,p,S){if(this.fileWalkSW=g.StopWatch.create(!1),this.isCanceled)return S(null,this.isLimitHit);a.forEach(u=>{const v=A.basename(u.fsPath);this.globalExcludePattern&&this.globalExcludePattern(u.fsPath,v)||this.matchFile(h,{relativePath:u.fsPath,searchPath:void 0})}),this.cmdSW=g.StopWatch.create(!1),this.parallel(i,(u,v)=>{this.call(this.cmdTraversal,this,u,h,p,R=>{if(R){const N=(0,k.toErrorMessage)(R);console.error(N),this.errors.push(N),v(R,void 0)}else v(null,void 0)})},(u,v)=>{this.fileWalkSW.stop();const R=u?y.coalesce(u)[0]:null;S(R,this.isLimitHit)})}parallel(i,a,h){const p=new Array(i.length),S=new Array(i.length);let u=!1,v=0;if(i.length===0)return h(null,[]);i.forEach((R,N)=>{a(R,(j,ie)=>{if(j?(u=!0,p[N]=null,S[N]=j):(p[N]=ie,S[N]=null),++v===i.length)return h(u?S:null,p)})})}call(i,a,...h){try{i.apply(a,h)}catch(p){h[h.length-1](p)}}cmdTraversal(i,a,h,p){const S=i.folder.fsPath,u=C.isMacintosh;let v;const R=()=>v&&v.kill();d.add(R);let N=L=>{d.delete(R),N=()=>{},p(L)},j="";const ie=this.initDirectoryTree();let K;const B=(0,w.spawnRipgrepCmd)(this.config,i,this.config.includePattern,this.folderExcludePatterns.get(i.folder.fsPath).expression);v=B.cmd,K=!Object.keys(B.siblingClauses).length;const $=B.rgArgs.args.map(L=>L.match(/^-/)?L:`'${L}'`).join(" ");let U=`${B.rgDiskPath} ${$}
 - cwd: ${B.cwd}`;B.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(B.rgArgs.siblingClauses)}`),h({message:U}),this.cmdResultCount=0,this.collectStdout(v,"utf8",h,(L,O,M)=>{if(L){N(L);return}if(this.isLimitHit){N();return}const W=(j+(u?P.normalizeNFC(O||""):O)).split(`
`);if(M){const q=W.length;W[q-1]=W[q-1].trim(),W[q-1]||W.pop()}else j=W.pop()||"";if(W.length&&W[0].indexOf(`
`)!==-1){N(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=W.length,K){for(const q of W)if(this.matchFile(a,{base:S,relativePath:q,searchPath:this.getSearchPath(i,q)}),this.isLimitHit){R();break}(M||this.isLimitHit)&&N();return}this.addDirectoryEntries(i,ie,S,W,a),M&&(this.matchDirectoryTree(ie,S,a),N())})}spawnFindCmd(i){const a=this.folderExcludePatterns.get(i.folder.fsPath),h=a.getBasenameTerms(),p=a.getPathTerms(),S=["-L","."];if(h.length||p.length){S.push("-not","(","(");for(const u of h)S.push("-name",u),S.push("-o");for(const u of p)S.push("-path",u),S.push("-o");S.pop(),S.push(")","-prune",")")}return S.push("-type","f"),b.spawn("find",S,{cwd:i.folder.fsPath})}readStdout(i,a,h){let p="";this.collectStdout(i,a,()=>{},(S,u,v)=>{if(S){h(S);return}p+=u,v&&h(null,p)})}collectStdout(i,a,h,p){let S=(R,N,j)=>{(R||j)&&(S=()=>{},this.cmdSW&&this.cmdSW.stop()),p(R,N,j)},u=!1;i.stdout?(this.forwardData(i.stdout,a,S),i.stdout.once("data",()=>u=!0)):h({message:"stdout is null"});let v;i.stderr?v=this.collectData(i.stderr):h({message:"stderr is null"}),i.on("error",R=>{S(R)}),i.on("close",R=>{let N;!u&&(N=this.decodeData(v,a))&&n(N)?S(new Error(`command failed with error code ${R}: ${this.decodeData(v,a)}`)):(this.exists&&R===0&&(this.isLimitHit=!0),S(null,"",!0))})}forwardData(i,a,h){const p=new T.StringDecoder(a);return i.on("data",S=>{h(null,p.write(S))}),p}collectData(i){const a=[];return i.on("data",h=>{a.push(h)}),a}decodeData(i,a){const h=new T.StringDecoder(a);return i.map(p=>h.write(p)).join("")}initDirectoryTree(){const i={rootEntries:[],pathToEntries:Object.create(null)};return i.pathToEntries["."]=i.rootEntries,i}addDirectoryEntries(i,{pathToEntries:a},h,p,S){p.indexOf(this.filePattern)!==-1&&this.matchFile(S,{base:h,relativePath:this.filePattern,searchPath:this.getSearchPath(i,this.filePattern)});const u=v=>{const R=A.basename(v),N=A.dirname(v);let j=a[N];j||(j=a[N]=[],u(N)),j.push({base:h,relativePath:v,basename:R,searchPath:this.getSearchPath(i,v)})};p.forEach(u)}matchDirectoryTree({rootEntries:i,pathToEntries:a},h,p){const S=this,u=this.folderExcludePatterns.get(h),v=this.filePattern;function R(N){S.directoriesWalked++;const j=D.hasSiblingFn(()=>N.map(ie=>ie.basename));for(let ie=0,K=N.length;ie<K;ie++){const B=N[ie],{relativePath:$,basename:U}=B;if(!u.test($,U,v!==U?j:void 0)){const L=a[$];if(L)R(L);else{if(S.filesWalked++,$===v)continue;S.matchFile(p,B)}if(S.isLimitHit)break}}}R(i)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(i,a,h,p,S){const u=i.folder,v=D.hasSiblingFn(()=>h);this.parallel(h,(R,N)=>{if(this.isCanceled||this.isLimitHit)return N(null);const j=a?[a,R].join(A.sep):R;if(this.folderExcludePatterns.get(i.folder.fsPath).test(j,R,this.config.filePattern!==R?v:void 0))return N(null);const ie=[u.fsPath,j].join(A.sep);I.lstat(ie,(K,B)=>{if(K||this.isCanceled||this.isLimitHit)return N(null);this.statLinkIfNeeded(ie,B,($,U)=>$||this.isCanceled||this.isLimitHit?N(null):U.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(ie,B,(L,O)=>L||this.isCanceled||this.isLimitHit||(O=O||"",this.walkedPaths[O])?N(null):(this.walkedPaths[O]=!0,(0,f.readdir)(ie).then(M=>{if(this.isCanceled||this.isLimitHit)return N(null);this.doWalk(i,j,M,p,F=>N(F||null))},M=>{N(null)})))):(this.filesWalked++,j===this.filePattern||this.maxFilesize&&l.isNumber(U.size)&&U.size>this.maxFilesize||this.matchFile(p,{base:u.fsPath,relativePath:j,searchPath:this.getSearchPath(i,j)}),N(null,void 0)))})},R=>{const N=R&&y.coalesce(R);return S(N&&N.length>0?N[0]:void 0)})}matchFile(i,a){this.isFileMatch(a)&&(!this.includePattern||this.includePattern(a.relativePath,A.basename(a.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||i(a))}isFileMatch(i){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return(0,E.isFilePatternMatch)(i,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(i,a,h){return a.isSymbolicLink()?I.stat(i,h):h(null,a)}realPathIfNeeded(i,a,h){return a.isSymbolicLink()?I.realpath(i,(p,S)=>p?h(p):h(null,S)):h(null,i)}getSearchPath(i,a){return i.folderName?A.join(i.folderName,a):a}}e.FileWalker=o;class c{constructor(i){this.folderQueries=i.folderQueries,this.extraFiles=i.extraFileResources||[],this.walker=new o(i)}search(i,a,h){this.walker.walk(this.folderQueries,this.extraFiles,i,a,(p,S)=>{h(p,{limitHit:S,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=c;class t{constructor(i,a){this.expression=i,this.root=a,this.init(i)}init(i){let a,h;Object.keys(i).filter(p=>i[p]).forEach(p=>{A.isAbsolute(p)?(a=a||D.getEmptyExpression(),a[p]=i[p]):(h=h||D.getEmptyExpression(),h[p]=i[p])}),this.absoluteParsedExpr=a&&D.parse(a,{trimForExclusions:!0}),this.relativeParsedExpr=h&&D.parse(h,{trimForExclusions:!0})}test(i,a,h){return this.relativeParsedExpr&&this.relativeParsedExpr(i,a,h)||this.absoluteParsedExpr&&this.absoluteParsedExpr(A.join(this.root,i),a,h)}getBasenameTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getBasenameTerms(this.relativeParsedExpr)),i}getPathTerms(){const i=[];return this.absoluteParsedExpr&&i.push(...D.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&i.push(...D.getPathTerms(this.relativeParsedExpr)),i}}function n(s){const i=s.trim().split(`
`),a=i[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return m.uppercaseFirstLetter(i[i.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}e.rgErrorMsgForDisplay=n}),define(me[131],ge([0,1,38,289,103,16,53,33,8,9,2,31,67,290,274,94]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const E=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class w{constructor(u){this.outputChannel=u}provideTextSearchResults(u,v,R,N){return this.outputChannel.appendLine(`provideTextSearchResults ${u.pattern}, ${JSON.stringify(Object.assign(Object.assign({},v),{folder:v.folder.toString()}))}`),new Promise((j,ie)=>{N.onCancellationRequested(()=>F());const K=n(u,v),B=v.folder.fsPath,$=K.map(ve=>ve.match(/^-/)?ve:`'${ve}'`).join(" ");this.outputChannel.appendLine(`${E} ${$}
 - cwd: ${B}`);let U=b.spawn(E,K,{cwd:B});U.on("error",ve=>{console.error(ve),this.outputChannel.appendLine("Error: "+(ve&&ve.message)),ie((0,C.serializeSearchError)(new C.SearchError(ve&&ve.message,C.SearchErrorCode.rgProcessError)))});let L=!1;const O=new o(v.maxResults,B,v.previewOptions);O.on("result",ve=>{L=!0,q="",R.report(ve)});let M=!1;const F=()=>{M=!0,U&&U.kill(),O&&O.cancel()};let W=!1;O.on("hitLimit",()=>{W=!0,F()});let q="";U.stdout.on("data",ve=>{O.handleData(ve),L||(q+=ve)});let Q=!1;U.stdout.once("data",()=>Q=!0);let le="";U.stderr.on("data",ve=>{const Re=ve.toString();this.outputChannel.appendLine(Re),le+=Re}),U.on("close",()=>{if(this.outputChannel.appendLine(Q?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(L?"Got result from parser":"No result from parser"),q&&this.outputChannel.appendLine(`Got data without result: ${q}`),this.outputChannel.appendLine(""),M)j({limitHit:W});else{O.flush(),U=null;let ve;le&&!Q&&(ve=_(le))?ie((0,C.serializeSearchError)(new C.SearchError(ve.message,ve.code))):j({limitHit:W})}})})}}e.RipgrepTextSearchEngine=w;function _(S){const u=S.split(`
`),v=u[0].trim();if(u.some(N=>N.startsWith("regex parse error")))return new C.SearchError(d(u),C.SearchErrorCode.regexParseError);const R=v.match(/grep config error: unknown encoding: (.*)/);if(R)return new C.SearchError(`Unknown encoding: ${R[1]}`,C.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new C.SearchError(v.charAt(0).toUpperCase()+v.substr(1),C.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new C.SearchError(v,C.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=_;function d(S){const u=["Regex parse error"],v=S.filter(R=>R.startsWith("PCRE2:"));if(v.length>=1){const R=v[0].replace("PCRE2:","");if(R.indexOf(":")!==-1&&R.split(":").length>=2){const N=R.split(":")[1];u.push(":"+N)}}return u.join("")}e.buildRegexParseError=d;class o extends I.EventEmitter{constructor(u,v,R){super();this.maxResults=u,this.rootFolder=v,this.previewOptions=R,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new A.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(u,v){return super.on(u,v),this}handleData(u){if(!this.isDone){const v=typeof u=="string"?u:this.stringDecoder.write(u);this.handleDecodedData(v)}}handleDecodedData(u){let v=u.indexOf(`
`);const R=this.remainder+u;if(v>=0)v+=this.remainder.length;else{this.remainder=R;return}let N=0;for(;v>=0;)this.handleLine(R.substring(N,v).trim()),N=v+1,v=R.indexOf(`
`,N);this.remainder=R.substring(N)}handleLine(u){if(!(this.isDone||!u)){let v;try{v=JSON.parse(u)}catch(R){throw new Error(`malformed line from rg: ${u}`)}if(v.type==="match"){const R=c(v.data.path),N=r.URI.file(D.join(this.rootFolder,R)),j=this.createTextSearchMatch(v.data,N);this.onResult(j),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const R=c(v.data.path),N=r.URI.file(D.join(this.rootFolder,R));this.createTextSearchContext(v.data,N).forEach(ie=>this.onResult(ie))}}}createTextSearchMatch(u,v){const R=u.line_number-1;let N=!1,j=c(u.lines);R===0&&(0,P.startsWithUTF8BOM)(j)&&(N=!0,j=(0,P.stripUTF8BOM)(j));const ie=Buffer.from(j);let K=0,B=0,$=R;u.submatches.length===0&&u.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const U=(0,T.coalesce)(u.submatches.map((L,O)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let M=c(L.match);R===0&&O===0&&N&&(M=(0,P.stripUTF8BOM)(M),L.start=L.start<=3?0:L.start-3,L.end=L.end<=3?0:L.end-3);const F=ie.slice(K,L.start).toString().length,W=B+F,q=t(M),Q=$,le=q.numLines+Q,ve=q.numLines>0?q.lastLineLength:q.lastLineLength+W;return K=L.end,B=ve,$=le,new g.Range(Q,W,le,ve)}));return(0,f.createTextSearchResult)(v,j,U,this.previewOptions)}createTextSearchContext(u,v){const R=c(u.lines),N=u.line_number;return R.replace(/\r?\n$/,"").split(`
`).map((j,ie)=>({text:j,uri:v,lineNumber:N+ie}))}onResult(u){this.emit("result",u)}}e.RipgrepParser=o;function c(S){return S.bytes?Buffer.from(S.bytes,"base64").toString():S.text}function t(S){const u=/\n/g;let v=0,R=-1,N;for(;N=u.exec(S);)v++,R=N.index;const j=R>=0?S.length-R-1:S.length;return{numLines:v,lastLineLength:j}}function n(S,u){const v=["--hidden"];v.push(S.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:R,otherIncludes:N}=(0,y.groupBy)(u.includes,ie=>ie.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const ie=new Set;N.forEach(K=>{ie.add(K)}),v.push("-g","!*"),ie.forEach(K=>{s(K).map(f.anchorGlob).forEach(B=>{v.push("-g",B)})})}R&&R.length&&R.forEach(ie=>{v.push("-g",ie)}),u.excludes.map(f.anchorGlob).forEach(ie=>v.push("-g",`!${ie}`)),u.maxFileSize&&v.push("--max-filesize",u.maxFileSize+""),u.useIgnoreFiles?v.push("--no-ignore-parent"):v.push("--no-ignore"),u.followSymlinks&&v.push("--follow"),u.encoding&&u.encoding!=="utf8"&&v.push("--encoding",u.encoding),S.pattern==="--"&&(S.isRegExp=!0,S.pattern="\\-\\-"),S.isMultiline&&!S.isRegExp&&(S.pattern=(0,P.escapeRegExpCharacters)(S.pattern),S.isRegExp=!0),u.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),S.isRegExp&&(S.pattern=i(S.pattern),v.push("--auto-hybrid-regex"));let j;if(S.isWordMatch){const K=(0,P.createRegExp)(S.pattern,!!S.isRegExp,{wholeWord:S.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",K)}else if(S.isRegExp){let ie=h(S.pattern);ie=p(ie),v.push("--regexp",ie)}else j=S.pattern,v.push("--fixed-strings");return v.push("--no-config"),u.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),S.isMultiline&&v.push("--multiline"),u.beforeContext&&v.push("--before-context",u.beforeContext+""),u.afterContext&&v.push("--after-context",u.afterContext+""),v.push("--"),j&&v.push(j),v.push("."),v}function s(S){const u=(0,k.splitGlobAware)(S,"/");return u.map((v,R)=>u.slice(0,R+1).join("/"))}e.spreadGlobComponents=s;function i(S){const u=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;S.match(u);)S=S.replace(u,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;S.match(v);)S=S.replace(v,"$1\\x{$2}");return S}e.unicodeEscapesToPCRE2=i;const a=S=>S.type==="Assertion"&&S.kind==="lookbehind";function h(S){let u;try{u=new m.RegExpParser().parsePattern(S)}catch(K){return S}let v="",R=0;const N=(K,B,$)=>{v+=S.slice(R,K)+$,R=B},j=[];return new m.RegExpVisitor({onCharacterEnter(K){if(K.raw==="\\n"){const B=j[0];if(!B)N(K.start,K.end,"\\r?\\n");else if(!j.some(a))if(B.type==="CharacterClass")if(B.negate){const $=S.slice(B.start+2,K.start)+S.slice(K.end,B.end-1);N(B.start,B.end,"(?!\\r?\\n"+($?`|[${$}]`:"")+")")}else{const $=S.slice(B.start+1,K.start)+S.slice(K.end,B.end-1);N(B.start,B.end,$===""?"\\r?\\n":`(?:[${$}]|\\r?\\n)`)}else B.type==="Quantifier"&&N(K.start,K.end,"(?:\\r?\\n)")}},onQuantifierEnter(K){j.unshift(K)},onQuantifierLeave(){j.shift()},onCharacterClassRangeEnter(K){j.unshift(K)},onCharacterClassRangeLeave(){j.shift()},onCharacterClassEnter(K){j.unshift(K)},onCharacterClassLeave(){j.shift()},onAssertionEnter(K){a(K)&&j.push(K)},onAssertionLeave(K){j[0]===K&&j.shift()}}).visit(u),v+=S.slice(R),v}e.fixRegexNewline=h;function p(S){return S.replace(/\n/g,"\\r?\\n")}e.fixNewline=p}),define(me[276],ge([0,1,21,131,116,12]),function(G,e,b,I,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class y{constructor(P){this.outputChannel=P,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(P,r,C,g){const m=new I.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===T.Schemas.userData){const l=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:T.Schemas.file})}),f=new A.Progress(E=>C.report(Object.assign(Object.assign({},E),{uri:E.uri.with({scheme:r.folder.scheme})})));return this.withToken(g,E=>m.provideTextSearchResults(P,l,f,E))}else return this.withToken(g,l=>m.provideTextSearchResults(P,r,C,l))}async withToken(P,r){const C=k(P);this.inProgress.add(C);const g=await r(C.token);return this.inProgress.delete(C),g}dispose(){this.inProgress.forEach(P=>P.cancel())}}e.RipgrepSearchProvider=y;function k(D){const P=new b.CancellationTokenSource;return D.onCancellationRequested(()=>P.cancel()),P}}),define(me[277],ge([0,1,26,131,130]),function(G,e,b,I,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class T{constructor(D){this.query=D}search(D,P,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(m){r({message:m})}},g=new A.NativeTextSearchManager(this.query,new I.RipgrepTextSearchEngine(C),b);return new Promise((m,l)=>g.search(f=>{P(f.map(y))},D).then(f=>m({limitHit:f.limitHit,type:"success"}),l))}}e.TextSearchEngineAdapter=T;function y(k){return{path:k.resource&&k.resource.fsPath,results:k.results,numMatches:(k.results||[]).reduce((D,P)=>{if(P.ranges){const r=P;return D+(Array.isArray(r.ranges)?r.ranges.length:1)}else return D+1},0)}}}),define(me[278],ge([0,1,37,291,16,13,17,3,101,8,47,2,45,31,275,277]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,I.gracefulify(b);class E{constructor(){this.caches=Object.create(null)}fileSearch(t){let n;const s=d(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(a=>this.doFileSearchWithEngine(l.Engine,s,h=>i.fire(h),a)),n.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}textSearch(t){let n;const s=d(t),i=new k.Emitter({onFirstListenerDidAdd:()=>{n=(0,T.createCancelablePromise)(a=>this.ripgrepTextSearch(s,h=>i.fire(h),a)),n.then(a=>i.fire(a),a=>i.fire({type:"error",error:{message:a.message,stack:a.stack}}))},onLastListenerRemove:()=>{n.cancel()}});return i.event}ripgrepTextSearch(t,n,s){return t.maxFileSize=(0,g.getPlatformLimits)(process.arch==="ia32"?0:1).maxFileSize,new f.TextSearchEngineAdapter(t).search(s,n,n)}doFileSearch(t,n,s){return this.doFileSearchWithEngine(l.Engine,t,n,s)}doFileSearchWithEngine(t,n,s,i,a=E.BATCH_SIZE){let h=0;const p=u=>{Array.isArray(u)?(h+=u.length,s(u.map(v=>this.rawMatchToSearchItem(v)))):u.relativePath?(h++,s(this.rawMatchToSearchItem(u))):s(u)};if(n.sortByScore){let u=this.trySortedSearchFromCache(n,p,i);if(!u){const v=n.maxResults?Object.assign({},n,{maxResults:null}):n,R=new t(v);u=this.doSortedSearch(R,n,s,p,i)}return new Promise((v,R)=>{u.then(([N,j])=>{const ie=j.map(K=>this.rawMatchToSearchItem(K));this.sendProgress(ie,s,a),v(N)},R)})}const S=new t(n);return this.doSearch(S,p,a,i).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:"searchProcess",fromCache:!1,resultCount:h,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?(0,P.join)(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,n,s,i,a){const h=new k.Emitter;let p=(0,T.createCancelablePromise)(u=>{let v=[];const R=N=>{Array.isArray(N)?v=N:(i(N),h.fire(N))};return this.doSearch(t,R,-1,u).then(N=>[N,v])}),S;if(n.cacheKey){S=this.getOrCreateCache(n.cacheKey);const u={promise:p,event:h.event,resolved:!1};S.resultsToSearchCache[n.filePattern||""]=u,p.then(()=>{u.resolved=!0},v=>{delete S.resultsToSearchCache[n.filePattern||""]}),p=this.preventCancellation(p)}return p.then(([u,v])=>{const R=S?S.scorerCache:Object.create(null),N=(typeof n.maxResults!="number"||n.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(n,v,R,a).then(j=>{const ie=N?N.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:ie,fromCache:!1,type:"searchProcess",workspaceFolderCount:n.folderQueries.length,resultCount:j.length},messages:u.messages,limitHit:u.limitHit||typeof n.maxResults=="number"&&v.length>n.maxResults},j]})})}getOrCreateCache(t){const n=this.caches[t];return n||(this.caches[t]=new w)}trySortedSearchFromCache(t,n,s){const i=t.cacheKey&&this.caches[t.cacheKey];if(!!i){const a=this.getResultsFromCache(i,t.filePattern||"",n,s);if(a)return a.then(([h,p,S])=>{const u=r.StopWatch.create(!1);return this.sortResults(t,p,i.scorerCache,s).then(v=>{const R=u.elapsed(),N={fromCache:!0,detailStats:S,type:"searchProcess",resultCount:p.length,sortingTime:R};return[{type:"success",limitHit:h.limitHit||typeof t.maxResults=="number"&&p.length>t.maxResults,stats:N},v]})})}}sortResults(t,n,s,i){const a=(0,D.prepareQuery)(t.filePattern||""),h=(S,u)=>(0,D.compareItemsByFuzzyScore)(S,u,a,!0,_,s),p=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return A.topAsync(n,h,p,1e4,i)}sendProgress(t,n,s){if(s&&s>0)for(let i=0;i<t.length;i+=s)n(t.slice(i,i+s));else n(t)}getResultsFromCache(t,n,s,i){const a=r.StopWatch.create(!1),h=n.indexOf(P.sep)>=0;let p;for(const R in t.resultsToSearchCache)if(n.startsWith(R)){if(h&&R.indexOf(P.sep)<0&&R!=="")continue;const N=t.resultsToSearchCache[R];p={promise:this.preventCancellation(N.promise),event:N.event,resolved:N.resolved};break}if(!p)return null;const S=a.elapsed(),u=r.StopWatch.create(!1),v=p.event(s);return i&&i.onCancellationRequested(()=>{v.dispose()}),p.promise.then(([R,N])=>{if(i&&i.isCancellationRequested)throw(0,y.canceled)();const j=[],ie=(0,D.prepareQuery)(n).normalizedLowercase;for(const K of N)!(0,m.isFilePatternMatch)(K,ie)||j.push(K);return[R,j,{cacheWasResolved:p.resolved,cacheLookupTime:S,cacheFilterTime:u.elapsed(),cacheEntryCount:N.length}]})}doSearch(t,n,s,i){return new Promise((a,h)=>{let p=[];i&&i.onCancellationRequested(()=>t.cancel()),t.search(S=>{S&&(s?(p.push(S),s>0&&p.length>=s&&(n(p),p=[])):n(S))},S=>{n(S)},(S,u)=>{p.length&&n(p),S?h(S):a(u)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,s){return t.then(n,s)}catch(n){return this.then(void 0,n)}finally(n){return t.finally(n)}}}}e.SearchService=E,E.BATCH_SIZE=512;class w{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const _=new class{getItemLabel(c){return(0,P.basename)(c.relativePath)}getItemDescription(c){return(0,P.dirname)(c.relativePath)}getItemPath(c){return c.relativePath}};function d(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(o),extraFileResources:c.extraFileResources&&c.extraFileResources.map(t=>C.URI.revive(t))})}function o(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(me[279],ge([0,1,6,2,26,14,31,278,276,94,15,63,28,70,12,130]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let E=class extends m.ExtHostSearch{constructor(_,d,o,c){super(_,o,c);this._pfs=A,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new P.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(l.Schemas.userData,new D.RipgrepSearchProvider(t)),d.remote.isRemote&&d.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const _=new P.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(l.Schemas.file,new D.RipgrepSearchProvider(_)),this.registerInternalFileSearchProvider(l.Schemas.file,new k.SearchService)}registerInternalFileSearchProvider(_,d){const o=this._handlePool++;return this._internalFileSearchProvider=d,this._internalFileSearchHandle=o,this._proxy.$registerFileSearchProvider(o,this._transformScheme(_)),(0,b.toDisposable)(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(o)})}$provideFileSearchResults(_,d,o,c){const t=(0,m.reviveQuery)(o);return _===this._internalFileSearchHandle?this.doInternalFileSearch(_,d,t,c):super.$provideFileSearchResults(_,d,o,c)}doInternalFileSearch(_,d,o,c){const t=n=>{if((0,y.isSerializedFileMatch)(n)&&(n=[n]),Array.isArray(n)){this._proxy.$handleFileMatch(_,d,n.map(s=>I.URI.file(s.path)));return}n.message&&this._logService.debug("ExtHostSearch",n.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(o,t,c)}$clearCache(_){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(_),super.$clearCache(_)}createTextSearchManager(_,d){return new f.NativeTextSearchManager(_,d)}};E=qe([He(0,r.IExtHostRpcService),He(1,g.IExtHostInitDataService),He(2,C.IURITransformerService),He(3,T.ILogService)],E),e.NativeExtHostSearch=E}),define(me[132],ge([0,1,292,123,293,3,106,8,48,30,6,23,107,17,10]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(p){this.socket=p,this._errorListener=S=>{if(S){if(S.code==="EPIPE")return;(0,m.onUnexpectedError)(S)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(p){const S=u=>p(C.VSBuffer.wrap(u));return this.socket.on("data",S),{dispose:()=>this.socket.off("data",S)}}onClose(p){return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(p){return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(p){if(!this.socket.destroyed)try{this.socket.write(p.buffer,S=>{if(S){if(S.code==="EPIPE")return;(0,m.onUnexpectedError)(S)}})}catch(S){if(S.code==="EPIPE")return;(0,m.onUnexpectedError)(S)}}end(){this.socket.end()}drain(){return new Promise((p,S)=>{if(this.socket.bufferSize===0){p();return}const u=()=>{this.socket.off("close",u),this.socket.off("end",u),this.socket.off("error",u),this.socket.off("timeout",u),this.socket.off("drain",u),p()};this.socket.on("close",u),this.socket.on("end",u),this.socket.on("error",u),this.socket.on("timeout",u),this.socket.on("drain",u)})}}e.NodeSocket=f;var E;(function(h){h[h.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var w;(function(h){h[h.PeekHeader=1]="PeekHeader",h[h.ReadHeader=2]="ReadHeader",h[h.ReadBody=3]="ReadBody",h[h.Fin=4]="Fin"})(w||(w={}));class _ extends r.Disposable{constructor(p,S,u,v){super();this._onDidZlibFlush=this._register(new T.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new T.Emitter),this._onClose=this._register(new T.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=p,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=S,this._recordInflateBytes=v,S?(this._zlibInflate=A.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibInflate.on("data",R=>{this._pendingInflateData.push(R)}),u&&(this._zlibInflate.write(u.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=A.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",R=>{console.error(R),(0,m.onUnexpectedError)(R),this._onClose.fire()}),this._zlibDeflate.on("data",R=>{this._pendingDeflateData.push(R)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new g.ChunkStream,this._register(this.socket.onData(R=>this._acceptChunk(R))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?C.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):C.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this._onData.event(p)}onClose(p){return this._onClose.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){this._totalOutgoingDataBytes+=p.byteLength,this._zlibDeflate?(this._zlibDeflate.write(p.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let S=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,S=S.slice(0,S.length-4),this._isEnded||this._write(C.VSBuffer.wrap(S),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(p,!1)}_write(p,S){let u=2;p.byteLength<126?u+=0:p.byteLength<2**16?u+=2:u+=8;const v=C.VSBuffer.alloc(u);if(S?v.writeUInt8(194,0):v.writeUInt8(130,0),p.byteLength<126)v.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){v.writeUInt8(126,1);let R=1;v.writeUInt8(p.byteLength>>>8&255,++R),v.writeUInt8(p.byteLength>>>0&255,++R)}else{v.writeUInt8(127,1);let R=1;v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(0,++R),v.writeUInt8(p.byteLength>>>24&255,++R),v.writeUInt8(p.byteLength>>>16&255,++R),v.writeUInt8(p.byteLength>>>8&255,++R),v.writeUInt8(p.byteLength>>>0&255,++R)}this._totalOutgoingWireBytes+=v.byteLength+p.byteLength,this.socket.write(C.VSBuffer.concat([v,p]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(p){if(p.byteLength!==0){for(this._totalIncomingWireBytes+=p.byteLength,this._incomingData.acceptChunk(p);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const S=this._incomingData.peek(this._state.readLen),v=(S.readUInt8(0)&128)>>>7,R=S.readUInt8(1),N=(R&128)>>>7,j=R&127;this._state.state=2,this._state.readLen=2+(N?4:0)+(j===126?2:0)+(j===127?8:0),this._state.fin=v,this._state.mask=0}else if(this._state.state===2){const S=this._incomingData.read(this._state.readLen),u=S.readUInt8(1),v=(u&128)>>>7;let R=u&127,N=1;R===126?R=S.readUInt8(++N)*2**8+S.readUInt8(++N):R===127&&(R=S.readUInt8(++N)*0+S.readUInt8(++N)*0+S.readUInt8(++N)*0+S.readUInt8(++N)*0+S.readUInt8(++N)*2**24+S.readUInt8(++N)*2**16+S.readUInt8(++N)*2**8+S.readUInt8(++N));let j=0;v&&(j=S.readUInt8(++N)*2**24+S.readUInt8(++N)*2**16+S.readUInt8(++N)*2**8+S.readUInt8(++N)),this._state.state=3,this._state.readLen=R,this._state.mask=j}else if(this._state.state===3){const S=this._incomingData.read(this._state.readLen);d(S,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(S.buffer)),this._zlibInflate.write(S.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const u=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=u.length,this._onData.fire(C.VSBuffer.wrap(u))})):(this._totalIncomingDataBytes+=S.byteLength,this._onData.fire(S))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await T.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=_;function d(h,p){if(p!==0){let S=h.byteLength>>>2;for(let ie=0;ie<S;ie++){const K=h.readUInt32BE(ie*4);h.writeUInt32BE(K^p,ie*4)}let u=S*4,v=h.byteLength-u;const R=p>>>24&255,N=p>>>16&255,j=p>>>8&255;v>=1&&h.writeUInt8(h.readUInt8(u)^R,u),v>=2&&h.writeUInt8(h.readUInt8(u+1)^N,u+1),v>=3&&h.writeUInt8(h.readUInt8(u+2)^j,u+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function c(){const h=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${h}-sock`;let p;return e.XDG_RUNTIME_DIR?p=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${h}.sock`):p=(0,k.join)((0,D.tmpdir)(),`vscode-ipc-${h}.sock`),n(p),p}e.createRandomIPCHandle=c;function t(h,p,S){const u=(0,b.createHash)("md5").update(h).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${u}-${S}-${p}-sock`;let v;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?v=(0,k.join)(e.XDG_RUNTIME_DIR,`vscode-${u.substr(0,8)}-${S}-${p}.sock`):v=(0,k.join)(h,`${S}-${p}.sock`),n(v),v}e.createStaticIPCHandle=t;function n(h){const p=o[l.platform];typeof p=="number"&&h.length>=p&&console.warn(`WARNING: IPC handle "${h}" is longer than ${p} chars, try a shorter --user-data-dir`)}class s extends y.IPCServer{constructor(p){super(s.toClientConnectionEvent(p));this.server=p}static toClientConnectionEvent(p){const S=T.Event.fromNodeEventEmitter(p,"connection");return T.Event.map(S,u=>({protocol:new g.Protocol(new f(u)),onDidClientDisconnect:T.Event.once(T.Event.fromNodeEventEmitter(u,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function i(h){return new Promise((p,S)=>{const u=(0,I.createServer)();u.on("error",S),u.listen(h,()=>{u.removeListener("error",S),p(new s(u))})})}e.serve=i;function a(h,p){return new Promise((S,u)=>{const v=(0,I.createConnection)(h,()=>{v.removeListener("error",u),S(g.Client.fromSocket(new f(v),p))});v.once("error",u)})}e.connect=a}),define(me[280],ge([0,1,132,272,37,51,2,119,14]),function(G,e,b,I,A,T,y,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class P{constructor(g,m,l){this._commands=g,this.logService=m,this._ipcHandlePath=l,this._server=I.createServer((f,E)=>this.onRequest(f,E)),this.setup().catch(f=>(m.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",g=>this.logService.error(g))}catch(g){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(g,m){const l=[];g.setEncoding("utf8"),g.on("data",f=>l.push(f)),g.on("end",()=>{const f=JSON.parse(l.join(""));switch(f.type){case"open":this.open(f,m);break;case"openExternal":this.openExternal(f,m);break;case"status":this.getStatus(f,m);break;case"extensionManagement":this.manageExtensions(f,m).catch(this.logService.error);break;default:m.writeHead(404),m.write(`Unknown message type: ${f.type}`,E=>{E&&this.logService.error(E)}),m.end();break}})}open(g,m){let{fileURIs:l,folderURIs:f,forceNewWindow:E,diffMode:w,addMode:_,forceReuseWindow:d,gotoLineMode:o,waitMarkerFilePath:c}=g;const t=[];if(Array.isArray(f))for(const n of f)try{t.push({folderUri:y.URI.parse(n)})}catch(s){}if(Array.isArray(l))for(const n of l)try{(0,k.hasWorkspaceFileExtension)(n)?t.push({workspaceUri:y.URI.parse(n)}):t.push({fileUri:y.URI.parse(n)})}catch(s){}if(t.length){const n=c?y.URI.file(c):void 0,i={forceNewWindow:E,diffMode:w,addMode:_,gotoLineMode:o,forceReuseWindow:d,preferNewWindow:!d&&!n&&!_,waitMarkerFileURI:n};this._commands.executeCommand("_remoteCLI.windowOpen",t,i)}m.writeHead(200),m.end()}async openExternal(g,m){for(const l of g.uris){const f=y.URI.parse(l),E=f.scheme==="file"?f:l;await this._commands.executeCommand("_remoteCLI.openExternal",E)}m.writeHead(200),m.end()}async manageExtensions(g,m){try{const l=w=>w==null?void 0:w.map(_=>/\.vsix$/i.test(_)?y.URI.parse(_):_),f={list:g.list,install:l(g.install),uninstall:l(g.uninstall),force:g.force},E=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);m.writeHead(200),m.write(E)}catch(l){m.writeHead(500),m.write(String(l),f=>{f&&this.logService.error(f)})}m.end()}async getStatus(g,m){try{const l=await this._commands.executeCommand("_remoteCLI.getSystemStatus");m.writeHead(200),m.write(l),m.end()}catch(l){m.writeHead(500),m.write(String(l),f=>{f&&this.logService.error(f)}),m.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&A.existsSync(this._ipcHandlePath)&&A.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=P;let r=class extends P{constructor(g,m){super(g,m,(0,b.createRandomIPCHandle)())}};r=qe([He(0,T.IExtHostCommands),He(1,D.ILogService)],r),e.CLIServer=r}),define(me[281],ge([0,1,69,268,262,5,271,42,253,2,12,7,280,104]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class l extends A.RequireInterceptor{_installInterceptor(){const w=this,_=G.__$__nodeRequire("module"),d=_._load;_._load=function(c,t,n){for(let s of w._alternatives){let i=s(c);if(i){c=i;break}}return w._factories.has(c)?w._factories.get(c).load(c,P.URI.file((0,m.realpathSync)(t.filename)),s=>d.apply(this,[s,t,n])):d.apply(this,arguments)}}}class f extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const w=this._instaService.invokeFunction(I.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(D.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(g.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(l,w,this._registry).install(),b.mark("code/extHost/didInitAPI");const d=await this._extHostConfiguration.getConfigProvider();await(0,y.connectProxyResolver)(this._extHostWorkspace,d,this,this._logService,this._mainThreadTelemetryProxy,this._initData),b.mark("code/extHost/didInitProxyResolver");const o=process.send,c=this._extHostContext.getProxy(T.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?o.apply(process,t):(c.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(w){return w.main}_loadCommonJSModule(w,_,d){if(_.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${_}', must be of file-scheme`);let o=null;d.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${_.toString(!0)}`),this._logService.flush();try{w&&b.mark(`code/extHost/willLoadExtensionCode/${w.value}`),o=G.__$__nodeRequire(_.fsPath)}catch(c){return Promise.reject(c)}finally{w&&b.mark(`code/extHost/didLoadExtensionCode/${w.value}`),d.codeLoadingStop()}return Promise.resolve(o)}async $setRemoteEnvironment(w){if(!!this._initData.remote.isRemote)for(const _ in w){const d=w[_];d===null?delete process.env[_]:process.env[_]=d}}}e.ExtHostExtensionService=f}),define(me[282],ge([0,1,79,254,265,264,263,279,281,225,255,46,42,65,70,68,34,50,14]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f,E,w,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(g.IExtHostExtensionService,D.ExtHostExtensionService),(0,b.registerSingleton)(_.ILogService,P.ExtHostLogService),(0,b.registerSingleton)(C.IExtHostDebugService,y.ExtHostDebugService),(0,b.registerSingleton)(m.IExtHostOutputService,I.ExtHostOutputService2),(0,b.registerSingleton)(l.IExtHostSearch,k.NativeExtHostSearch),(0,b.registerSingleton)(f.IExtHostTask,T.ExtHostTask),(0,b.registerSingleton)(E.IExtHostTerminalService,A.ExtHostTerminalService),(0,b.registerSingleton)(w.IExtHostTunnelService,r.ExtHostTunnelService)}),define(me[283],ge([0,1,123,294,69,17,107,132,187,223,266,23,102,26,104,13,269,282]),function(G,e,b,I,A,T,y,k,D,P,r,C,g,m,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let i=0;i<process.execArgv.length;i++)process.execArgv[i]==="--inspect-port=0"&&(process.execArgv.splice(i,1),i--)}();const E=I(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=G.__$__nodeRequire("module"),i=s._load;s._load=function(a){if(a==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}})();const w=process.exit.bind(process);function _(s){process.exit=function(i){if(s)w(i);else{const a=new Error("An extension called process.exit() and this was prevented.");console.warn(a.stack)}},process.crash=function(){const i=new Error("An extension called process.crash() and this was prevented.");console.warn(i.stack)}}let d=function(s){w()};function o(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,i)=>{let a=null,h=setTimeout(()=>{d("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const p=108e5,S=3e5,u=new f.RunOnceScheduler(()=>d("renderer disconnected for too long (1)"),p),v=new f.RunOnceScheduler(()=>d("renderer disconnected for too long (2)"),S);process.on("message",(N,j)=>{if(N&&N.type==="VSCODE_EXTHOST_IPC_SOCKET"){const ie=C.VSBuffer.wrap(Buffer.from(N.initialDataChunk,"base64"));let K;if(N.skipWebSocketFrames)K=new k.NodeSocket(j);else{const B=C.VSBuffer.wrap(Buffer.from(N.inflateBytes,"base64"));K=new k.WebSocketNodeSocket(new k.NodeSocket(j),N.permessageDeflate,B,!1)}a?(u.cancel(),v.cancel(),a.beginAcceptReconnection(K,ie),a.endAcceptReconnection()):(clearTimeout(h),a=new y.PersistentProtocol(K,ie),a.onDidDispose(()=>d("renderer disconnected")),s(a),a.onSocketClose(()=>{u.schedule()}))}if(N&&N.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(v.isScheduled())return;u.isScheduled()&&v.schedule()}});const R={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(R)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((i,a)=>{const h=b.createConnection(s,()=>{h.removeListener("error",a),i(new y.PersistentProtocol(new k.NodeSocket(h)))});h.once("error",a)})}}async function c(){const s=await o();return new class{constructor(){this._onMessage=new y.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(i=>{(0,P.isMessageOfType)(i,2)?(this._terminating=!0,d("received terminate message from renderer")):this._onMessage.fire(i)})}send(i){this._terminating||s.send(i)}drain(){return s.drain()}}}function t(s){return new Promise(i=>{const a=s.onMessage(h=>{a.dispose();const p=JSON.parse(h.toString()),S=p.commit,u=D.default.commit;S&&u&&S!==u&&w(55);const v=[];process.on("unhandledRejection",(j,ie)=>{v.push(ie),setTimeout(()=>{const K=v.indexOf(ie);K>=0&&ie.catch(B=>{v.splice(K,1),console.warn(`rejected promise not handled within 1 second: ${B}`),B&&B.stack&&console.warn(`stack trace: ${B.stack}`),(0,T.onUnexpectedError)(j)})},1e3)}),process.on("rejectionHandled",j=>{const ie=v.indexOf(j);ie>=0&&v.splice(ie,1)}),process.on("uncaughtException",function(j){(0,T.onUnexpectedError)(j)});let R=0;setInterval(function(){try{process.kill(p.parentPid,0),R=0}catch(j){j&&j.code==="EPERM"?(R++,R>=3&&d(`parent process ${p.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):d(`parent process ${p.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let N;try{N=G.__$__nodeRequire("native-watchdog"),N.start(p.parentPid)}catch(j){(0,T.onUnexpectedError)(j)}s.send((0,P.createMessageOfType)(0)),i({protocol:s,initData:p})});s.send((0,P.createMessageOfType)(1))})}async function n(){A.mark("code/extHost/willConnectToRenderer");const s=await c();A.mark("code/extHost/didConnectToRenderer");const i=await t(s);A.mark("code/extHost/didWaitForInitData");const{initData:a}=i;_(!!a.environment.extensionTestsLocationURI),a.environment.useHostProxy=E.useHostProxy!==void 0?E.useHostProxy!=="false":void 0;const h=new class{exit(v){w(v)}exists(v){return(0,m.exists)(v)}realpath(v){return(0,l.realpath)(v)}};let p=null;if(a.remote.authority&&E.uriTransformerPath)try{const v=G.__$__nodeRequire(E.uriTransformerPath)(a.remote.authority);p=new g.URITransformer(v)}catch(u){console.error(u)}const S=new r.ExtensionHostMain(i.protocol,a,h,p);d=u=>S.terminate(u)}e.startExtensionHostProcess=n}),define(me[295],ge([0,1,283]),function(G,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.startExtensionHostProcess)().catch(I=>console.log(I))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54d33cf14cf6c0e86880b5b74a5a3628de42bce9/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
