/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/async","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/platform/log/common/log","vs/base/common/network","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/base/common/uuid","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],be=function(J){for(var e=[],b=0,k=J.length;b<k;b++)e[b]=ve[J[b]];return e};define(ve[42],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function b(k,P){if(!k)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}e.ok=b}),define(ve[51],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupByNumber=e.groupBy=e.forEach=e.values=void 0;const b=Object.prototype.hasOwnProperty;function k(I){const h=[];for(let d in I)b.call(I,d)&&h.push(I[d]);return h}e.values=k;function P(I,h){for(let d in I)if(b.call(I,d)&&h({key:d,value:I[d]},function(){delete I[d]})===!1)return}e.forEach=P;function T(I,h){const d=Object.create(null);for(const r of I){const o=h(r);let v=d[o];v||(v=d[o]=[]),v.push(r)}return d}e.groupBy=T;function y(I,h){const d=new Map;for(const r of I){const o=h(r);let v=d.get(o);v||(v=[],d.set(o,v)),v.push(r)}return d}e.groupByNumber=y;function D(I){const h=Object.create(null);return I&&I.forEach((d,r)=>{h[r]=d}),h}e.fromMap=D;function S(I,h){const d=[],r=[];for(let o of I)h.has(o)||d.push(o);for(let o of h)I.has(o)||r.push(o);return{removed:d,added:r}}e.diffSets=S;function C(I,h){const d=[],r=[];for(let[o,v]of I)h.has(o)||d.push(v);for(let[o,v]of h)I.has(o)||r.push(v);return{removed:d,added:r}}e.diffMaps=C;class i{constructor(){this.map=new Map}add(h,d){let r=this.map.get(h);r||(r=new Set,this.map.set(h,r)),r.add(d)}delete(h,d){const r=this.map.get(h);!r||(r.delete(d),r.size===0&&this.map.delete(h))}forEach(h,d){const r=this.map.get(h);!r||r.forEach(d)}}e.SetMap=i}),define(ve[52],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function b(y){return(D,S,C)=>{let i=null,I=null;if(typeof C.value=="function"?(i="value",I=C.value):typeof C.get=="function"&&(i="get",I=C.get),!I)throw new Error("not supported");C[i]=y(I,S)}}e.createDecorator=b;function k(y,D,S){let C=null,i=null;if(typeof S.value=="function"?(C="value",i=S.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(C="get",i=S.get),!i)throw new Error("not supported");const I=`$memoize$${D}`;S[C]=function(...h){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,h)}),this[I]}}e.memoize=k;function P(y,D,S){return b((C,i)=>{const I=`$debounce$${i}`,h=`$debounce$result$${i}`;return function(...d){this[h]||(this[h]=S?S():void 0),clearTimeout(this[I]),D&&(this[h]=D(this[h],...d),d=[this[h]]),this[I]=setTimeout(()=>{C.apply(this,d),this[h]=S?S():void 0},y)}})}e.debounce=P;function T(y,D,S){return b((C,i)=>{const I=`$throttle$timer$${i}`,h=`$throttle$result$${i}`,d=`$throttle$lastRun$${i}`,r=`$throttle$pending$${i}`;return function(...o){if(this[h]||(this[h]=S?S():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),D&&(this[h]=D(this[h],...o)),!this[r]){const v=this[d]+y;v<=Date.now()?(this[d]=Date.now(),C.apply(this,[this[h]]),this[h]=S?S():void 0):(this[r]=!0,this[I]=setTimeout(()=>{this[r]=!1,this[d]=Date.now(),C.apply(this,[this[h]]),this[h]=S?S():void 0},v-Date.now()))}}})}e.throttle=T}),define(ve[12],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class b{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=b,e.errorHandler=new b;function k(f){e.errorHandler.setUnexpectedErrorHandler(f)}e.setUnexpectedErrorHandler=k;function P(f){S(f)||e.errorHandler.onUnexpectedError(f)}e.onUnexpectedError=P;function T(f){S(f)||e.errorHandler.onUnexpectedExternalError(f)}e.onUnexpectedExternalError=T;function y(f){if(f instanceof Error){let{name:t,message:n}=f;const a=f.stacktrace||f.stack;return{$isError:!0,name:t,message:n,stack:a}}return f}e.transformErrorForSerialization=y;const D="Canceled";function S(f){return f instanceof Error&&f.name===D&&f.message===D}e.isPromiseCanceledError=S;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function i(){const f=new Error(D);return f.name=f.message,f}e.canceled=i;function I(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}e.illegalArgument=I;function h(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}e.illegalState=h;function d(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=d;function r(f){const t=new Error(`${f} has been disposed`);return t.name="DISPOSED",t}e.disposed=r;function o(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}e.getErrorMessage=o;class v extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=v;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class E extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=E;function c(f){const t=f;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function l(f,t=Object.create(null)){const n=new Error(f);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=l}),define(ve[13],be([0,1,12]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(U,F=0){return U[U.length-(1+F)]}e.tail=k;function P(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=P;function T(U,F,L=(M,x)=>M===x){if(U===F)return!0;if(!U||!F||U.length!==F.length)return!1;for(let M=0,x=U.length;M<x;M++)if(!L(U[M],F[M]))return!1;return!0}e.equals=T;function y(U,F,L){let M=0,x=U.length-1;for(;M<=x;){const G=(M+x)/2|0,X=L(U[G],F);if(X<0)M=G+1;else if(X>0)x=G-1;else return G}return-(M+1)}e.binarySearch=y;function D(U,F){let L=0,M=U.length;if(M===0)return 0;for(;L<M;){const x=Math.floor((L+M)/2);F(U[x])?M=x:L=x+1}return L}e.findFirstInSorted=D;function S(U,F,L){if(U=U|0,U>=F.length)throw new TypeError("invalid index");let M=F[Math.floor(F.length*Math.random())],x=[],G=[],X=[];for(let ne of F){const me=L(ne,M);me<0?x.push(ne):me>0?G.push(ne):X.push(ne)}return U<x.length?S(U,x,L):U<x.length+X.length?X[0]:S(U-(x.length+X.length),G,L)}e.quickSelect=S;function C(U,F){const L=[];let M;for(const x of U.slice(0).sort(F))!M||F(M[0],x)!==0?(M=[x],L.push(M)):M.push(x);return L}e.groupBy=C;function i(U,F,L){const M=[];function x(ne,me,Le){if(!(me===0&&Le.length===0)){const We=M[M.length-1];We&&We.start+We.deleteCount===ne?(We.deleteCount+=me,We.toInsert.push(...Le)):M.push({start:ne,deleteCount:me,toInsert:Le})}}let G=0,X=0;for(;;){if(G===U.length){x(G,0,F.slice(X));break}if(X===F.length){x(G,U.length-G,[]);break}const ne=U[G],me=F[X],Le=L(ne,me);Le===0?(G+=1,X+=1):Le<0?(x(G,1,[]),G+=1):Le>0&&(x(G,0,[me]),X+=1)}return M}e.sortedDiff=i;function I(U,F,L){const M=i(U,F,L),x=[],G=[];for(const X of M)x.push(...U.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:x,added:G}}e.delta=I;function h(U,F,L){if(L===0)return[];const M=U.slice(0,L).sort(F);return r(U,F,M,L,U.length),M}e.top=h;function d(U,F,L,M,x){return L===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const ne=U.length,me=U.slice(0,L).sort(F);for(let Le=L,We=Math.min(L+M,ne);Le<ne;Le=We,We=Math.min(We+M,ne)){if(Le>L&&await new Promise(Fe=>setTimeout(Fe)),x&&x.isCancellationRequested)throw(0,b.canceled)();r(U,F,me,Le,We)}return me})().then(G,X)})}e.topAsync=d;function r(U,F,L,M,x){for(const G=L.length;M<x;M++){const X=U[M];if(F(X,L[G-1])<0){L.pop();const ne=D(L,me=>F(X,me)<0);L.splice(ne,0,X)}}}function o(U){return U.filter(F=>!!F)}e.coalesce=o;function v(U){let F=0;for(let L=0;L<U.length;L++)U[L]&&(U[F]=U[L],F+=1);U.length=F}e.coalesceInPlace=v;function p(U,F,L){U.splice(L,0,U.splice(F,1)[0])}e.move=p;function E(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=E;function c(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=c;function l(U,F){if(!F)return U.filter((M,x)=>U.indexOf(M)===x);const L=Object.create(null);return U.filter(M=>{const x=F(M);return L[x]?!1:(L[x]=!0,!0)})}e.distinct=l;function f(U){const F=new Set;return U.filter(L=>F.has(L)?!1:(F.add(L),!0))}e.distinctES6=f;function t(U){const F=Object.create(null);return L=>{const M=U(L);return F[M]?!1:(F[M]=!0,!0)}}e.uniqueFilter=t;function n(U,F){for(let L=U.length-1;L>=0;L--){const M=U[L];if(F(M))return L}return-1}e.lastIndex=n;function a(U,F){return U.length>0?U[0]:F}e.firstOrDefault=a;function s(U,F,L=(M,x)=>M===x){let M=0;for(let x=0,G=Math.min(U.length,F.length);x<G&&L(U[x],F[x]);x++)M++;return M}e.commonPrefixLength=s;function u(U){return[].concat(...U)}e.flatten=u;function g(U,F){let L=typeof F=="number"?U:0;typeof F=="number"?L=U:(L=0,F=U);const M=[];if(L<=F)for(let x=L;x<F;x++)M.push(x);else for(let x=L;x>F;x--)M.push(x);return M}e.range=g;function _(U,F,L){return U.reduce((M,x)=>(M[F(x)]=L?L(x):x,M),Object.create(null))}e.index=_;function A(U,F){return U.push(F),()=>m(U,F)}e.insert=A;function m(U,F){const L=U.indexOf(F);if(L>-1)return U.splice(L,1),F}e.remove=m;function w(U,F,L){const M=U.slice(0,F),x=U.slice(F);return M.concat(L,x)}e.arrayInsert=w;function R(U,F){let L;if(typeof F=="number"){let M=F;L=()=>{const x=Math.sin(M++)*179426549;return x-Math.floor(x)}}else L=Math.random;for(let M=U.length-1;M>0;M-=1){const x=Math.floor(L()*(M+1)),G=U[M];U[M]=U[x],U[x]=G}}e.shuffle=R;function $(U,F){const L=U.indexOf(F);L>-1&&(U.splice(L,1),U.unshift(F))}e.pushToStart=$;function K(U,F){const L=U.indexOf(F);L>-1&&(U.splice(L,1),U.push(F))}e.pushToEnd=K;function he(U,F){return Array.isArray(U)?U.map(F):F(U)}e.mapArrayOrNot=he;function V(U){return Array.isArray(U)?U:[U]}e.asArray=V;function H(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=H;function Y(U,F){for(const L of U){const M=F(L);if(M!==void 0)return M}}e.mapFind=Y}),define(ve[53],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function b(k){const P=this;let T=!1,y;return function(){return T||(T=!0,y=k.apply(P,arguments)),y}}e.once=b}),define(ve[54],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class b{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=b,e.defaultGenerator=new b("id#")}),define(ve[43],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var b;(function(k){function P(f){return f&&typeof f=="object"&&typeof f[Symbol.iterator]=="function"}k.is=P;const T=Object.freeze([]);function y(){return T}k.empty=y;function*D(f){yield f}k.single=D;function S(f){return f||T}k.from=S;function C(f){return!f||f[Symbol.iterator]().next().done===!0}k.isEmpty=C;function i(f){return f[Symbol.iterator]().next().value}k.first=i;function I(f,t){for(const n of f)if(t(n))return!0;return!1}k.some=I;function h(f,t){for(const n of f)if(t(n))return n}k.find=h;function*d(f,t){for(const n of f)t(n)&&(yield n)}k.filter=d;function*r(f,t){for(const n of f)yield t(n)}k.map=r;function*o(...f){for(const t of f)for(const n of t)yield n}k.concat=o;function*v(f){for(const t of f)for(const n of t)yield n}k.concatNested=v;function p(f,t,n){let a=n;for(const s of f)a=t(a,s);return a}k.reduce=p;function*E(f,t,n=f.length){for(t<0&&(t+=f.length),n<0?n+=f.length:n>f.length&&(n=f.length);t<n;t++)yield f[t]}k.slice=E;function c(f,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,f];const a=f[Symbol.iterator]();for(let s=0;s<t;s++){const u=a.next();if(u.done)return[n,k.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return a}}]}k.consume=c;function l(f,t,n=(a,s)=>a===s){const a=f[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=a.next(),g=s.next();if(u.done!==g.done)return!1;if(u.done)return!0;if(!n(u.value,g.value))return!1}}k.equals=l})(b=e.Iterable||(e.Iterable={}))}),define(ve[44],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var b;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(b=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function y(t,n=!1){let a=0,s=t.length,u="",g=0,_=16,A=0;function m(H){let Y=0,U=0;for(;Y<H;){const F=t.charCodeAt(a);if(F>=48&&F<=57)U=U*16+F-48;else if(F>=65&&F<=70)U=U*16+F-65+10;else if(F>=97&&F<=102)U=U*16+F-97+10;else break;a++,Y++}return Y<H&&(U=-1),U}function w(H){a=H,u="",g=0,_=16,A=0}function R(){const H=a;if(t.charCodeAt(a)===48)a++;else for(a++;a<t.length&&C(t.charCodeAt(a));)a++;if(a<t.length&&t.charCodeAt(a)===46)if(a++,a<t.length&&C(t.charCodeAt(a)))for(a++;a<t.length&&C(t.charCodeAt(a));)a++;else return A=3,t.substring(H,a);let Y=a;if(a<t.length&&(t.charCodeAt(a)===69||t.charCodeAt(a)===101))if(a++,(a<t.length&&t.charCodeAt(a)===43||t.charCodeAt(a)===45)&&a++,a<t.length&&C(t.charCodeAt(a))){for(a++;a<t.length&&C(t.charCodeAt(a));)a++;Y=a}else A=3;return t.substring(H,Y)}function $(){let H="",Y=a;for(;;){if(a>=s){H+=t.substring(Y,a),A=2;break}const U=t.charCodeAt(a);if(U===34){H+=t.substring(Y,a),a++;break}if(U===92){if(H+=t.substring(Y,a),a++,a>=s){A=2;break}switch(t.charCodeAt(a++)){case 34:H+='"';break;case 92:H+="\\";break;case 47:H+="/";break;case 98:H+="\b";break;case 102:H+="\f";break;case 110:H+=`
`;break;case 114:H+="\r";break;case 116:H+="	";break;case 117:const L=m(4);L>=0?H+=String.fromCharCode(L):A=4;break;default:A=5}Y=a;continue}if(U>=0&&U<=31)if(S(U)){H+=t.substring(Y,a),A=2;break}else A=6;a++}return H}function K(){if(u="",A=0,g=a,a>=s)return g=s,_=17;let H=t.charCodeAt(a);if(D(H)){do a++,u+=String.fromCharCode(H),H=t.charCodeAt(a);while(D(H));return _=15}if(S(H))return a++,u+=String.fromCharCode(H),H===13&&t.charCodeAt(a)===10&&(a++,u+=`
`),_=14;switch(H){case 123:return a++,_=1;case 125:return a++,_=2;case 91:return a++,_=3;case 93:return a++,_=4;case 58:return a++,_=6;case 44:return a++,_=5;case 34:return a++,u=$(),_=10;case 47:const Y=a-1;if(t.charCodeAt(a+1)===47){for(a+=2;a<s&&!S(t.charCodeAt(a));)a++;return u=t.substring(Y,a),_=12}if(t.charCodeAt(a+1)===42){a+=2;const U=s-1;let F=!1;for(;a<U;){if(t.charCodeAt(a)===42&&t.charCodeAt(a+1)===47){a+=2,F=!0;break}a++}return F||(a++,A=1),u=t.substring(Y,a),_=13}return u+=String.fromCharCode(H),a++,_=16;case 45:if(u+=String.fromCharCode(H),a++,a===s||!C(t.charCodeAt(a)))return _=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=R(),_=11;default:for(;a<s&&he(H);)a++,H=t.charCodeAt(a);if(g!==a){switch(u=t.substring(g,a),u){case"true":return _=8;case"false":return _=9;case"null":return _=7}return _=16}return u+=String.fromCharCode(H),a++,_=16}}function he(H){if(D(H)||S(H))return!1;switch(H){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let H;do H=K();while(H>=12&&H<=15);return H}return{setPosition:w,getPosition:()=>a,scan:n?V:K,getToken:()=>_,getTokenValue:()=>u,getTokenOffset:()=>g,getTokenLength:()=>a-g,getTokenError:()=>A}}e.createScanner=y;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const a=[],s=new Object;let u;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let _=!1;function A(m,w,R,$){g.value=m,g.offset=w,g.length=R,g.type=$,g.colonOffset=void 0,u=g}try{c(t,{onObjectBegin:(m,w)=>{if(n<=m)throw s;u=void 0,_=n>m,a.push("")},onObjectProperty:(m,w,R)=>{if(n<w||(A(m,w,R,"property"),a[a.length-1]=m,n<=w+R))throw s},onObjectEnd:(m,w)=>{if(n<=m)throw s;u=void 0,a.pop()},onArrayBegin:(m,w)=>{if(n<=m)throw s;u=void 0,a.push(0)},onArrayEnd:(m,w)=>{if(n<=m)throw s;u=void 0,a.pop()},onLiteralValue:(m,w,R)=>{if(n<w||(A(m,w,R,f(m)),n<=w+R))throw s},onSeparator:(m,w,R)=>{if(n<=w)throw s;if(m===":"&&u&&u.type==="property")u.colonOffset=w,_=!1,u=void 0;else if(m===","){const $=a[a.length-1];typeof $=="number"?a[a.length-1]=$+1:(_=!0,a[a.length-1]=""),u=void 0}}})}catch(m){if(m!==s)throw m}return{path:a,previousNode:u,isAtPropertyKey:_,matches:m=>{let w=0;for(let R=0;w<m.length&&R<a.length;R++)if(m[w]===a[R]||m[w]==="*")w++;else if(m[w]!=="**")return!1;return w===m.length}}}e.getLocation=I;function h(t,n=[],a=T.DEFAULT){let s=null,u=[];const g=[];function _(m){Array.isArray(u)?u.push(m):s!==null&&(u[s]=m)}return c(t,{onObjectBegin:()=>{const m={};_(m),g.push(u),u=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const m=[];_(m),g.push(u),u=m,s=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:_,onError:(m,w,R)=>{n.push({error:m,offset:w,length:R})}},a),u[0]}e.parse=h;function d(t,n=[],a=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function g(m){return s.children.push(m),m}c(t,{onObjectBegin:m=>{s=g({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,w,R)=>{s=g({type:"property",offset:w,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:w,length:R,parent:s})},onObjectEnd:(m,w)=>{s.length=m+w-s.offset,s=s.parent,u(m+w)},onArrayBegin:(m,w)=>{s=g({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,w)=>{s.length=m+w-s.offset,s=s.parent,u(m+w)},onLiteralValue:(m,w,R)=>{g({type:f(m),offset:w,length:R,parent:s,value:m}),u(w+R)},onSeparator:(m,w,R)=>{s.type==="property"&&(m===":"?s.colonOffset=w:m===","&&u(w))},onError:(m,w,R)=>{n.push({error:m,offset:w,length:R})}},a);const A=s.children[0];return A&&delete A.parent,A}e.parseTree=d;function r(t,n){if(!!t){let a=t;for(let s of n)if(typeof s=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let u=!1;for(const g of a.children)if(Array.isArray(g.children)&&g.children[0].value===s){a=g.children[1],u=!0;break}if(!u)return}else{const u=s;if(a.type!=="array"||u<0||!Array.isArray(a.children)||u>=a.children.length)return;a=a.children[u]}return a}}e.findNodeAtLocation=r;function o(t){if(!t.parent||!t.parent.children)return[];const n=o(t.parent);if(t.parent.type==="property"){const a=t.parent.children[0].value;n.push(a)}else if(t.parent.type==="array"){const a=t.parent.children.indexOf(t);a!==-1&&n.push(a)}return n}e.getNodePath=o;function v(t){switch(t.type){case"array":return t.children.map(v);case"object":const n=Object.create(null);for(let a of t.children){const s=a.children[1];s&&(n[a.children[0].value]=v(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=v;function p(t,n,a=!1){return n>=t.offset&&n<t.offset+t.length||a&&n===t.offset+t.length}e.contains=p;function E(t,n,a=!1){if(p(t,n,a)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=n;u++){const g=E(s[u],n,a);if(g)return g}return t}}e.findNodeAtOffset=E;function c(t,n,a=T.DEFAULT){const s=y(t,!1);function u(me){return me?()=>me(s.getTokenOffset(),s.getTokenLength()):()=>!0}function g(me){return me?Le=>me(Le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const _=u(n.onObjectBegin),A=g(n.onObjectProperty),m=u(n.onObjectEnd),w=u(n.onArrayBegin),R=u(n.onArrayEnd),$=g(n.onLiteralValue),K=g(n.onSeparator),he=u(n.onComment),V=g(n.onError),H=a&&a.disallowComments,Y=a&&a.allowTrailingComma;function U(){for(;;){const me=s.scan();switch(s.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:H||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(me){case 12:case 13:H?F(10):he();break;case 16:F(1);break;case 15:case 14:break;default:return me}}}function F(me,Le=[],We=[]){if(V(me),Le.length+We.length>0){let Fe=s.getToken();for(;Fe!==17;){if(Le.indexOf(Fe)!==-1){U();break}else if(We.indexOf(Fe)!==-1)break;Fe=U()}}}function L(me){const Le=s.getTokenValue();return me?$(Le):A(Le),U(),!0}function M(){switch(s.getToken()){case 11:let me=0;try{me=JSON.parse(s.getTokenValue()),typeof me!="number"&&(F(2),me=0)}catch(Le){F(2)}$(me);break;case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return U(),!0}function x(){return s.getToken()!==10?(F(3,[],[2,5]),!1):(L(!1),s.getToken()===6?(K(":"),U(),ne()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function G(){_(),U();let me=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(me||F(4,[],[]),K(","),U(),s.getToken()===2&&Y)break}else me&&F(6,[],[]);x()||F(4,[],[2,5]),me=!0}return m(),s.getToken()!==2?F(7,[2],[]):U(),!0}function X(){w(),U();let me=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(me||F(4,[],[]),K(","),U(),s.getToken()===4&&Y)break}else me&&F(6,[],[]);ne()||F(4,[],[4,5]),me=!0}return R(),s.getToken()!==4?F(8,[4],[]):U(),!0}function ne(){switch(s.getToken()){case 3:return X();case 1:return G();case 10:return L(!0);default:return M()}}return U(),s.getToken()===17?a.allowEmptyContent?!0:(F(4,[],[]),!1):ne()?(s.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=c;function l(t,n){let a=y(t),s=[],u,g=0,_;do switch(_=a.getPosition(),u=a.scan(),u){case 12:case 13:case 17:g!==_&&s.push(t.substring(g,_)),n!==void 0&&s.push(a.getTokenValue().replace(/[^\r\n]/g,n)),g=a.getPosition();break}while(u!==17);return s.join("")}e.stripComments=l;function f(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=f}),define(ve[106],be([0,1,44]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(S,C,i){let I,h,d,r,o;if(C){for(r=C.offset,o=r+C.length,d=r;d>0&&!D(S,d-1);)d--;let g=o;for(;g<S.length&&!D(S,g);)g++;h=S.substring(d,g),I=T(h,i)}else h=S,I=0,d=0,r=0,o=S.length;const v=y(i,S);let p=!1,E=0,c;i.insertSpaces?c=P(" ",i.tabSize||4):c="	";const l=(0,b.createScanner)(h,!1);let f=!1;function t(){return v+P(c,I+E)}function n(){let g=l.scan();for(p=!1;g===15||g===14;)p=p||g===14,g=l.scan();return f=g===16||l.getTokenError()!==0,g}const a=[];function s(g,_,A){!f&&_<o&&A>r&&S.substring(_,A)!==g&&a.push({offset:_,length:A-_,content:g})}let u=n();if(u!==17){const g=l.getTokenOffset()+d,_=P(c,I);s(_,d,g)}for(;u!==17;){let g=l.getTokenOffset()+l.getTokenLength()+d,_=n(),A="";for(;!p&&(_===12||_===13);){const w=l.getTokenOffset()+d;s(" ",g,w),g=l.getTokenOffset()+l.getTokenLength()+d,A=_===12?t():"",_=n()}if(_===2)u!==1&&(E--,A=t());else if(_===4)u!==3&&(E--,A=t());else{switch(u){case 3:case 1:E++,A=t();break;case 5:case 12:A=t();break;case 13:p?A=t():A=" ";break;case 6:A=" ";break;case 10:if(_===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:_===12||_===13?A=" ":_!==5&&_!==17&&(f=!0);break;case 16:f=!0;break}p&&(_===12||_===13)&&(A=t())}const m=l.getTokenOffset()+d;s(A,g,m),u=_}return a}e.format=k;function P(S,C){let i="";for(let I=0;I<C;I++)i+=S;return i}function T(S,C){let i=0,I=0;const h=C.tabSize||4;for(;i<S.length;){const d=S.charAt(i);if(d===" ")I++;else if(d==="	")I+=h;else break;i++}return Math.floor(I/h)}function y(S,C){for(let i=0;i<C.length;i++){const I=C.charAt(i);if(I==="\r")return i+1<C.length&&C.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=y;function D(S,C){return`\r
`.indexOf(S.charAt(C))!==-1}e.isEOL=D}),define(ve[107],be([0,1,44,106]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function P(C,i,I){return T(C,i,void 0,I)}e.removeProperty=P;function T(C,i,I,h,d){const r=i.slice(),o=[],v=(0,b.parseTree)(C,o);let p,E;for(;r.length>0&&(E=r.pop(),p=(0,b.findNodeAtLocation)(v,r),p===void 0&&I!==void 0);)typeof E=="string"?I={[E]:I}:I=[I];if(p)if(p.type==="object"&&typeof E=="string"&&Array.isArray(p.children)){const c=(0,b.findNodeAtLocation)(p,[E]);if(c!==void 0)if(I===void 0){if(!c.parent)throw new Error("Malformed AST");const l=p.children.indexOf(c.parent);let f,t=c.parent.offset+c.parent.length;if(l>0){const n=p.children[l-1];f=n.offset+n.length}else f=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return y(C,{offset:f,length:t-f,content:""},h)}else return y(C,{offset:c.offset,length:c.length,content:JSON.stringify(I)},h);else{if(I===void 0)return[];const l=`${JSON.stringify(E)}: ${JSON.stringify(I)}`,f=d?d(p.children.map(n=>n.children[0].value)):p.children.length;let t;if(f>0){const n=p.children[f-1];t={offset:n.offset+n.length,length:0,content:","+l}}else p.children.length===0?t={offset:p.offset+1,length:0,content:l}:t={offset:p.offset+1,length:0,content:l+","};return y(C,t,h)}}else if(p.type==="array"&&typeof E=="number"&&Array.isArray(p.children))if(I!==void 0){const c=`${JSON.stringify(I)}`;let l;if(p.children.length===0||E===0)l={offset:p.offset+1,length:0,content:p.children.length===0?c:c+","};else{const f=E===-1||E>p.children.length?p.children.length:E,t=p.children[f-1];l={offset:t.offset+t.length,length:0,content:","+c}}return y(C,l,h)}else{const c=E,l=p.children[c];let f;if(p.children.length===1)f={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===c){const t=p.children[c-1],n=t.offset+t.length,a=p.offset+p.length;f={offset:n,length:a-2-n,content:""}}else f={offset:l.offset,length:p.children[c+1].offset-l.offset,content:""};return y(C,f,h)}else throw new Error(`Can not add ${typeof E!="number"?"index":"property"} to parent of type ${p.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return y(C,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(I)},h)}}e.setProperty=T;function y(C,i,I){let h=D(C,i),d=i.offset,r=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;d>0&&!(0,k.isEOL)(h,d-1);)d--;for(;r<h.length&&!(0,k.isEOL)(h,r);)r++}const o=(0,k.format)(h,{offset:d,length:r-d},I);for(let p=o.length-1;p>=0;p--){const E=o[p];h=D(h,E),d=Math.min(d,E.offset),r=Math.max(r,E.offset+E.length),r+=E.content.length-E.length}const v=C.length-(h.length-r)-d;return[{offset:d,length:v,content:h.substring(d,r)}]}e.withFormatting=y;function D(C,i){return C.substring(0,i.offset)+i.content+C.substring(i.offset+i.length)}e.applyEdit=D;function S(C,i){let I=i.slice(0).sort((d,r)=>{const o=d.offset-r.offset;return o===0?d.length-r.length:o}),h=C.length;for(let d=I.length-1;d>=0;d--){let r=I[d];if(r.offset+r.length<=h)C=D(C,r);else throw new Error("Overlapping edit");h=r.offset}return C}e.applyEdits=S}),define(ve[108],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class b{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new b(()=>P(this.getValue()))}}e.Lazy=b}),define(ve[6],be([0,1,53,43]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const P=!1;let T=null;function y(c){T=c}if(e.setDisposableTracker=y,P){const c="__is_disposable_tracked__";T=new class{trackDisposable(l){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(f)},3e3)}markTracked(l){if(l&&l!==o.None)try{l[c]=!0}catch(f){}}}}function D(c){!T||T.markTracked(c)}function S(c){return T&&T.trackDisposable(c),c}e.trackDisposable=S;class C extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=C;function i(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=i;function I(c){if(k.Iterable.is(c)){let l=[];for(const f of c)if(f){D(f);try{f.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new C(l);return Array.isArray(c)?[]:c}else if(c)return D(c),c.dispose(),c}e.dispose=I;function h(...c){return c.forEach(D),d(()=>I(c))}e.combinedDisposable=h;function d(c){const l=S({dispose:()=>{D(l),c()}});return l}e.toDisposable=d;class r{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return D(l),this._isDisposed?r.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=r,r.DISABLE_DISPOSED_WARNING=!1;class o{constructor(){this._store=new r,S(this)}dispose(){D(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=o,o.None=Object.freeze({dispose(){}});class v{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var f;this._isDisposed||l===this._value||((f=this._value)===null||f===void 0||f.dispose(),l&&D(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,D(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=v;class p{constructor(){this.references=new Map}acquire(l,...f){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...f)},this.references.set(l,t));const{object:n}=t,a=(0,b.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:n,dispose:a}}}e.ReferenceCollection=p;class E{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=E}),define(ve[45],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class b{constructor(T){this.element=T,this.next=b.Undefined,this.prev=b.Undefined}}b.Undefined=new b(void 0);class k{constructor(){this._first=b.Undefined,this._last=b.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===b.Undefined}clear(){let T=this._first;for(;T!==b.Undefined;){const y=T.next;T.prev=b.Undefined,T.next=b.Undefined,T=y}this._first=b.Undefined,this._last=b.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,y){const D=new b(T);if(this._first===b.Undefined)this._first=D,this._last=D;else if(y){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(D))}}shift(){if(this._first!==b.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==b.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==b.Undefined&&T.next!==b.Undefined){const y=T.prev;y.next=T.next,T.next.prev=y}else T.prev===b.Undefined&&T.next===b.Undefined?(this._first=b.Undefined,this._last=b.Undefined):T.next===b.Undefined?(this._last=this._last.prev,this._last.next=b.Undefined):T.prev===b.Undefined&&(this._first=this._first.next,this._first.prev=b.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==b.Undefined;)yield T.element,T=T.next}}e.LinkedList=k}),function(J,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(J=typeof globalThis!="undefined"?globalThis:J||self,J.marked=e())}(this,function(){"use strict";function J(ye,Ee){for(var Ce=0;Ce<Ee.length;Ce++){var re=Ee[Ce];re.enumerable=re.enumerable||!1,re.configurable=!0,"value"in re&&(re.writable=!0),Object.defineProperty(ye,re.key,re)}}function e(ye,Ee,Ce){return Ee&&J(ye.prototype,Ee),Ce&&J(ye,Ce),ye}function b(ye,Ee){if(!!ye){if(typeof ye=="string")return k(ye,Ee);var Ce=Object.prototype.toString.call(ye).slice(8,-1);if(Ce==="Object"&&ye.constructor&&(Ce=ye.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(ye);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return k(ye,Ee)}}function k(ye,Ee){(Ee==null||Ee>ye.length)&&(Ee=ye.length);for(var Ce=0,re=new Array(Ee);Ce<Ee;Ce++)re[Ce]=ye[Ce];return re}function P(ye,Ee){var Ce;if(typeof Symbol=="undefined"||ye[Symbol.iterator]==null){if(Array.isArray(ye)||(Ce=b(ye))||Ee&&ye&&typeof ye.length=="number"){Ce&&(ye=Ce);var re=0;return function(){return re>=ye.length?{done:!0}:{done:!1,value:ye[re++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=ye[Symbol.iterator](),Ce.next.bind(Ce)}function T(ye){var Ee={exports:{}};return ye(Ee,Ee.exports),Ee.exports}var y=T(function(ye){function Ee(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(re){ye.exports.defaults=re}ye.exports={defaults:Ee(),getDefaults:Ee,changeDefaults:Ce}}),D=/[&<>"']/,S=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(Ee){return I[Ee]};function d(ye,Ee){if(Ee){if(D.test(ye))return ye.replace(S,h)}else if(C.test(ye))return ye.replace(i,h);return ye}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(ye){return ye.replace(r,function(Ee,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var v=/(^|[^\[])\^/g;function p(ye,Ee){ye=ye.source||ye,Ee=Ee||"";var Ce={replace:function(le,N){return N=N.source||N,N=N.replace(v,"$1"),ye=ye.replace(le,N),Ce},getRegex:function(){return new RegExp(ye,Ee)}};return Ce}var E=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(ye,Ee,Ce){if(ye){var re;try{re=decodeURIComponent(o(Ce)).replace(E,"").toLowerCase()}catch(le){return null}if(re.indexOf("javascript:")===0||re.indexOf("vbscript:")===0||re.indexOf("data:")===0)return null}Ee&&!c.test(Ce)&&(Ce=s(Ee,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(le){return null}return Ce}var f={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(ye,Ee){f[" "+ye]||(t.test(ye)?f[" "+ye]=ye+"/":f[" "+ye]=A(ye,"/",!0)),ye=f[" "+ye];var Ce=ye.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ce?Ee:ye.replace(n,"$1")+Ee:Ee.charAt(0)==="/"?Ce?Ee:ye.replace(a,"$1")+Ee:ye+Ee}var u={exec:function(){}};function g(ye){for(var Ee=1,Ce,re;Ee<arguments.length;Ee++){Ce=arguments[Ee];for(re in Ce)Object.prototype.hasOwnProperty.call(Ce,re)&&(ye[re]=Ce[re])}return ye}function _(ye,Ee){var Ce=ye.replace(/\|/g,function(N,Q,ae){for(var ke=!1,Ie=Q;--Ie>=0&&ae[Ie]==="\\";)ke=!ke;return ke?"|":" |"}),re=Ce.split(/ \|/),le=0;if(re.length>Ee)re.splice(Ee);else for(;re.length<Ee;)re.push("");for(;le<re.length;le++)re[le]=re[le].trim().replace(/\\\|/g,"|");return re}function A(ye,Ee,Ce){var re=ye.length;if(re===0)return"";for(var le=0;le<re;){var N=ye.charAt(re-le-1);if(N===Ee&&!Ce)le++;else if(N!==Ee&&Ce)le++;else break}return ye.substr(0,re-le)}function m(ye,Ee){if(ye.indexOf(Ee[1])===-1)return-1;for(var Ce=ye.length,re=0,le=0;le<Ce;le++)if(ye[le]==="\\")le++;else if(ye[le]===Ee[0])re++;else if(ye[le]===Ee[1]&&(re--,re<0))return le;return-1}function w(ye){ye&&ye.sanitize&&!ye.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(ye,Ee){if(Ee<1)return"";for(var Ce="";Ee>1;)Ee&1&&(Ce+=ye),Ee>>=1,ye+=ye;return Ce+ye}var $={escape:d,unescape:o,edit:p,cleanUrl:l,resolveUrl:s,noopTest:u,merge:g,splitCells:_,rtrim:A,findClosingBracket:m,checkSanitizeDeprecation:w,repeatString:R},K=y.defaults,he=$.rtrim,V=$.splitCells,H=$.escape,Y=$.findClosingBracket;function U(ye,Ee,Ce){var re=Ee.href,le=Ee.title?H(Ee.title):null,N=ye[1].replace(/\\([\[\]])/g,"$1");return ye[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:re,title:le,text:N}:{type:"image",raw:Ce,href:re,title:le,text:H(N)}}function F(ye,Ee){var Ce=ye.match(/^(\s+)(?:```)/);if(Ce===null)return Ee;var re=Ce[1];return Ee.split(`
`).map(function(le){var N=le.match(/^\s+/);if(N===null)return le;var Q=N[0];return Q.length>=re.length?le.slice(re.length):le}).join(`
`)}var L=function(){function ye(Ce){this.options=Ce||K}var Ee=ye.prototype;return Ee.space=function(re){var le=this.rules.block.newline.exec(re);if(le)return le[0].length>1?{type:"space",raw:le[0]}:{raw:`
`}},Ee.code=function(re){var le=this.rules.block.code.exec(re);if(le){var N=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?N:he(N,`
`)}}},Ee.fences=function(re){var le=this.rules.block.fences.exec(re);if(le){var N=le[0],Q=F(N,le[3]||"");return{type:"code",raw:N,lang:le[2]?le[2].trim():le[2],text:Q}}},Ee.heading=function(re){var le=this.rules.block.heading.exec(re);if(le){var N=le[2].trim();if(/#$/.test(N)){var Q=he(N,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(N=Q.trim())}return{type:"heading",raw:le[0],depth:le[1].length,text:N}}},Ee.nptable=function(re){var le=this.rules.block.nptable.exec(re);if(le){var N={type:"table",header:V(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[],raw:le[0]};if(N.header.length===N.align.length){var Q=N.align.length,ae;for(ae=0;ae<Q;ae++)/^ *-+: *$/.test(N.align[ae])?N.align[ae]="right":/^ *:-+: *$/.test(N.align[ae])?N.align[ae]="center":/^ *:-+ *$/.test(N.align[ae])?N.align[ae]="left":N.align[ae]=null;for(Q=N.cells.length,ae=0;ae<Q;ae++)N.cells[ae]=V(N.cells[ae],N.header.length);return N}}},Ee.hr=function(re){var le=this.rules.block.hr.exec(re);if(le)return{type:"hr",raw:le[0]}},Ee.blockquote=function(re){var le=this.rules.block.blockquote.exec(re);if(le){var N=le[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:le[0],text:N}}},Ee.list=function(re){var le=this.rules.block.list.exec(re);if(le){var N=le[0],Q=le[2],ae=Q.length>1,ke={type:"list",raw:N,ordered:ae,start:ae?+Q.slice(0,-1):"",loose:!1,items:[]},Ie=le[0].match(this.rules.block.item),Ae=!1,xe,Ye,rt,tt,Qe,mt,bt,pe,ce=Ie.length;rt=this.rules.block.listItemStart.exec(Ie[0]);for(var se=0;se<ce;se++){if(xe=Ie[se],N=xe,se!==ce-1){if(tt=this.rules.block.listItemStart.exec(Ie[se+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){Ie.splice(se,2,Ie[se]+`
`+Ie[se+1]),se--,ce--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==Q[Q.length-1]:ae===(tt[2].length===1))&&(Qe=Ie.slice(se+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Qe.length),se=ce-1);rt=tt}Ye=xe.length,xe=xe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~xe.indexOf(`
 `)&&(Ye-=xe.length,xe=this.options.pedantic?xe.replace(/^ {1,4}/gm,""):xe.replace(new RegExp("^ {1,"+Ye+"}","gm"),"")),mt=Ae||/\n\n(?!\s*$)/.test(xe),se!==ce-1&&(Ae=xe.charAt(xe.length-1)===`
`,mt||(mt=Ae)),mt&&(ke.loose=!0),this.options.gfm&&(bt=/^\[[ xX]\] /.test(xe),pe=void 0,bt&&(pe=xe[1]!==" ",xe=xe.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:N,task:bt,checked:pe,loose:mt,text:xe})}return ke}},Ee.html=function(re){var le=this.rules.block.html.exec(re);if(le)return{type:this.options.sanitize?"paragraph":"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):H(le[0]):le[0]}},Ee.def=function(re){var le=this.rules.block.def.exec(re);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var N=le[1].toLowerCase().replace(/\s+/g," ");return{tag:N,raw:le[0],href:le[2],title:le[3]}}},Ee.table=function(re){var le=this.rules.block.table.exec(re);if(le){var N={type:"table",header:V(le[1].replace(/^ *| *\| *$/g,"")),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:le[3]?le[3].replace(/\n$/,"").split(`
`):[]};if(N.header.length===N.align.length){N.raw=le[0];var Q=N.align.length,ae;for(ae=0;ae<Q;ae++)/^ *-+: *$/.test(N.align[ae])?N.align[ae]="right":/^ *:-+: *$/.test(N.align[ae])?N.align[ae]="center":/^ *:-+ *$/.test(N.align[ae])?N.align[ae]="left":N.align[ae]=null;for(Q=N.cells.length,ae=0;ae<Q;ae++)N.cells[ae]=V(N.cells[ae].replace(/^ *\| *| *\| *$/g,""),N.header.length);return N}}},Ee.lheading=function(re){var le=this.rules.block.lheading.exec(re);if(le)return{type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1]}},Ee.paragraph=function(re){var le=this.rules.block.paragraph.exec(re);if(le)return{type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1]}},Ee.text=function(re){var le=this.rules.block.text.exec(re);if(le)return{type:"text",raw:le[0],text:le[0]}},Ee.escape=function(re){var le=this.rules.inline.escape.exec(re);if(le)return{type:"escape",raw:le[0],text:H(le[1])}},Ee.tag=function(re,le,N){var Q=this.rules.inline.tag.exec(re);if(Q)return!le&&/^<a /i.test(Q[0])?le=!0:le&&/^<\/a>/i.test(Q[0])&&(le=!1),!N&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?N=!0:N&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(N=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:le,inRawBlock:N,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):H(Q[0]):Q[0]}},Ee.link=function(re){var le=this.rules.inline.link.exec(re);if(le){var N=le[2].trim();if(!this.options.pedantic&&/^</.test(N)){if(!/>$/.test(N))return;var Q=he(N.slice(0,-1),"\\");if((N.length-Q.length)%2==0)return}else{var ae=Y(le[2],"()");if(ae>-1){var ke=le[0].indexOf("!")===0?5:4,Ie=ke+le[1].length+ae;le[2]=le[2].substring(0,ae),le[0]=le[0].substring(0,Ie).trim(),le[3]=""}}var Ae=le[2],xe="";if(this.options.pedantic){var Ye=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);Ye&&(Ae=Ye[1],xe=Ye[3])}else xe=le[3]?le[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(N)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),U(le,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:xe&&xe.replace(this.rules.inline._escapes,"$1")},le[0])}},Ee.reflink=function(re,le){var N;if((N=this.rules.inline.reflink.exec(re))||(N=this.rules.inline.nolink.exec(re))){var Q=(N[2]||N[1]).replace(/\s+/g," ");if(Q=le[Q.toLowerCase()],!Q||!Q.href){var ae=N[0].charAt(0);return{type:"text",raw:ae,text:ae}}return U(N,Q,N[0])}},Ee.emStrong=function(re,le,N){N===void 0&&(N="");var Q=this.rules.inline.emStrong.lDelim.exec(re);if(!!Q&&!(Q[3]&&N.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Q[1]||Q[2]||"";if(!ae||ae&&(N===""||this.rules.inline.punctuation.exec(N))){var ke=Q[0].length-1,Ie,Ae,xe=ke,Ye=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,le=le.slice(-1*re.length+ke);(Q=rt.exec(le))!=null;)if(Ie=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Ie){if(Ae=Ie.length,Q[3]||Q[4]){xe+=Ae;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ae)%3)){Ye+=Ae;continue}if(xe-=Ae,!(xe>0)){if(xe+Ye-Ae<=0&&!le.slice(rt.lastIndex).match(rt)&&(Ae=Math.min(Ae,Ae+xe+Ye)),Math.min(ke,Ae)%2)return{type:"em",raw:re.slice(0,ke+Q.index+Ae+1),text:re.slice(1,ke+Q.index+Ae)};if(Math.min(ke,Ae)%2==0)return{type:"strong",raw:re.slice(0,ke+Q.index+Ae+1),text:re.slice(2,ke+Q.index+Ae-1)}}}}}},Ee.codespan=function(re){var le=this.rules.inline.code.exec(re);if(le){var N=le[2].replace(/\n/g," "),Q=/[^ ]/.test(N),ae=/^ /.test(N)&&/ $/.test(N);return Q&&ae&&(N=N.substring(1,N.length-1)),N=H(N,!0),{type:"codespan",raw:le[0],text:N}}},Ee.br=function(re){var le=this.rules.inline.br.exec(re);if(le)return{type:"br",raw:le[0]}},Ee.del=function(re){var le=this.rules.inline.del.exec(re);if(le)return{type:"del",raw:le[0],text:le[2]}},Ee.autolink=function(re,le){var N=this.rules.inline.autolink.exec(re);if(N){var Q,ae;return N[2]==="@"?(Q=H(this.options.mangle?le(N[1]):N[1]),ae="mailto:"+Q):(Q=H(N[1]),ae=Q),{type:"link",raw:N[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.url=function(re,le){var N;if(N=this.rules.inline.url.exec(re)){var Q,ae;if(N[2]==="@")Q=H(this.options.mangle?le(N[0]):N[0]),ae="mailto:"+Q;else{var ke;do ke=N[0],N[0]=this.rules.inline._backpedal.exec(N[0])[0];while(ke!==N[0]);Q=H(N[0]),N[1]==="www."?ae="http://"+Q:ae=Q}return{type:"link",raw:N[0],text:Q,href:ae,tokens:[{type:"text",raw:Q,text:Q}]}}},Ee.inlineText=function(re,le,N){var Q=this.rules.inline.text.exec(re);if(Q){var ae;return le?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):H(Q[0]):Q[0]:ae=H(this.options.smartypants?N(Q[0]):Q[0]),{type:"text",raw:Q[0],text:ae}}},ye}(),M=$.noopTest,x=$.edit,G=$.merge,X={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};X._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,X._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,X.def=x(X.def).replace("label",X._label).replace("title",X._title).getRegex(),X.bullet=/(?:[*+-]|\d{1,9}[.)])/,X.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,X.item=x(X.item,"gm").replace(/bull/g,X.bullet).getRegex(),X.listItemStart=x(/^( *)(bull)/).replace("bull",X.bullet).getRegex(),X.list=x(X.list).replace(/bull/g,X.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+X.def.source+")").getRegex(),X._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",X._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,X.html=x(X.html,"i").replace("comment",X._comment).replace("tag",X._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),X.paragraph=x(X._paragraph).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.blockquote=x(X.blockquote).replace("paragraph",X.paragraph).getRegex(),X.normal=G({},X),X.gfm=G({},X.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),X.gfm.nptable=x(X.gfm.nptable).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.gfm.table=x(X.gfm.table).replace("hr",X.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",X._tag).getRegex(),X.pedantic=G({},X.normal,{html:x(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",X._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:x(X.normal._paragraph).replace("hr",X.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",X.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=x(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=x(X._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=x(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=x(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=x(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=x(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=x(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=x(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=x(ne.reflink).replace("label",ne._label).getRegex(),ne.reflinkSearch=x(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=G({},ne),ne.pedantic=G({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:x(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:x(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=G({},ne.normal,{escape:x(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ne.gfm.url=x(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=G({},ne.gfm,{br:x(ne.br).replace("{2,}","*").getRegex(),text:x(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var me={block:X,inline:ne},Le=y.defaults,We=me.block,Fe=me.inline,ze=$.repeatString;function W(ye){return ye.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ye){var Ee="",Ce,re,le=ye.length;for(Ce=0;Ce<le;Ce++)re=ye.charCodeAt(Ce),Math.random()>.5&&(re="x"+re.toString(16)),Ee+="&#"+re+";";return Ee}var te=function(){function ye(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||Le,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var re={block:We.normal,inline:Fe.normal};this.options.pedantic?(re.block=We.pedantic,re.inline=Fe.pedantic):this.options.gfm&&(re.block=We.gfm,this.options.breaks?re.inline=Fe.breaks:re.inline=Fe.gfm),this.tokenizer.rules=re}ye.lex=function(re,le){var N=new ye(le);return N.lex(re)},ye.lexInline=function(re,le){var N=new ye(le);return N.inlineTokens(re)};var Ee=ye.prototype;return Ee.lex=function(re){return re=re.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(re,this.tokens,!0),this.inline(this.tokens),this.tokens},Ee.blockTokens=function(re,le,N){le===void 0&&(le=[]),N===void 0&&(N=!0),this.options.pedantic&&(re=re.replace(/^ +$/gm,""));for(var Q,ae,ke,Ie;re;){if(Q=this.tokenizer.space(re)){re=re.substring(Q.raw.length),Q.type&&le.push(Q);continue}if(Q=this.tokenizer.code(re)){re=re.substring(Q.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="paragraph"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):le.push(Q);continue}if(Q=this.tokenizer.fences(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.heading(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.nptable(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.hr(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.blockquote(re)){re=re.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],N),le.push(Q);continue}if(Q=this.tokenizer.list(re)){for(re=re.substring(Q.raw.length),ke=Q.items.length,ae=0;ae<ke;ae++)Q.items[ae].tokens=this.blockTokens(Q.items[ae].text,[],!1);le.push(Q);continue}if(Q=this.tokenizer.html(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(N&&(Q=this.tokenizer.def(re))){re=re.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.lheading(re)){re=re.substring(Q.raw.length),le.push(Q);continue}if(N&&(Q=this.tokenizer.paragraph(re))){re=re.substring(Q.raw.length),le.push(Q);continue}if(Q=this.tokenizer.text(re)){re=re.substring(Q.raw.length),Ie=le[le.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+Q.raw,Ie.text+=`
`+Q.text):le.push(Q);continue}if(re){var Ae="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return le},Ee.inline=function(re){var le,N,Q,ae,ke,Ie,Ae=re.length;for(le=0;le<Ae;le++)switch(Ie=re[le],Ie.type){case"paragraph":case"text":case"heading":{Ie.tokens=[],this.inlineTokens(Ie.text,Ie.tokens);break}case"table":{for(Ie.tokens={header:[],cells:[]},ae=Ie.header.length,N=0;N<ae;N++)Ie.tokens.header[N]=[],this.inlineTokens(Ie.header[N],Ie.tokens.header[N]);for(ae=Ie.cells.length,N=0;N<ae;N++)for(ke=Ie.cells[N],Ie.tokens.cells[N]=[],Q=0;Q<ke.length;Q++)Ie.tokens.cells[N][Q]=[],this.inlineTokens(ke[Q],Ie.tokens.cells[N][Q]);break}case"blockquote":{this.inline(Ie.tokens);break}case"list":{for(ae=Ie.items.length,N=0;N<ae;N++)this.inline(Ie.items[N].tokens);break}}return re},Ee.inlineTokens=function(re,le,N,Q){le===void 0&&(le=[]),N===void 0&&(N=!1),Q===void 0&&(Q=!1);var ae,ke,Ie=re,Ae,xe,Ye;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)rt.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"["+ze("a",Ae[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Ae.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;re;){if(xe||(Ye=""),xe=!1,ae=this.tokenizer.escape(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.tag(re,N,Q)){re=re.substring(ae.raw.length),N=ae.inLink,Q=ae.inRawBlock;var tt=le[le.length-1];tt&&ae.type==="text"&&tt.type==="text"?(tt.raw+=ae.raw,tt.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.link(re)){re=re.substring(ae.raw.length),ae.type==="link"&&(ae.tokens=this.inlineTokens(ae.text,[],!0,Q)),le.push(ae);continue}if(ae=this.tokenizer.reflink(re,this.tokens.links)){re=re.substring(ae.raw.length);var Qe=le[le.length-1];ae.type==="link"?(ae.tokens=this.inlineTokens(ae.text,[],!0,Q),le.push(ae)):Qe&&ae.type==="text"&&Qe.type==="text"?(Qe.raw+=ae.raw,Qe.text+=ae.text):le.push(ae);continue}if(ae=this.tokenizer.emStrong(re,Ie,Ye)){re=re.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],N,Q),le.push(ae);continue}if(ae=this.tokenizer.codespan(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.br(re)){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.del(re)){re=re.substring(ae.raw.length),ae.tokens=this.inlineTokens(ae.text,[],N,Q),le.push(ae);continue}if(ae=this.tokenizer.autolink(re,j)){re=re.substring(ae.raw.length),le.push(ae);continue}if(!N&&(ae=this.tokenizer.url(re,j))){re=re.substring(ae.raw.length),le.push(ae);continue}if(ae=this.tokenizer.inlineText(re,Q,W)){re=re.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(Ye=ae.raw.slice(-1)),xe=!0,ke=le[le.length-1],ke&&ke.type==="text"?(ke.raw+=ae.raw,ke.text+=ae.text):le.push(ae);continue}if(re){var mt="Infinite loop on byte: "+re.charCodeAt(0);if(this.options.silent){console.error(mt);break}else throw new Error(mt)}}return le},e(ye,null,[{key:"rules",get:function(){return{block:We,inline:Fe}}}]),ye}(),oe=y.defaults,de=$.cleanUrl,_e=$.escape,Be=function(){function ye(Ce){this.options=Ce||oe}var Ee=ye.prototype;return Ee.code=function(re,le,N){var Q=(le||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(re,Q);ae!=null&&ae!==re&&(N=!0,re=ae)}return re=re.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+_e(Q,!0)+'">'+(N?re:_e(re,!0))+`</code></pre>
`:"<pre><code>"+(N?re:_e(re,!0))+`</code></pre>
`},Ee.blockquote=function(re){return`<blockquote>
`+re+`</blockquote>
`},Ee.html=function(re){return re},Ee.heading=function(re,le,N,Q){return this.options.headerIds?"<h"+le+' id="'+this.options.headerPrefix+Q.slug(N)+'">'+re+"</h"+le+`>
`:"<h"+le+">"+re+"</h"+le+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(re,le,N){var Q=le?"ol":"ul",ae=le&&N!==1?' start="'+N+'"':"";return"<"+Q+ae+`>
`+re+"</"+Q+`>
`},Ee.listitem=function(re){return"<li>"+re+`</li>
`},Ee.checkbox=function(re){return"<input "+(re?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(re){return"<p>"+re+`</p>
`},Ee.table=function(re,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+re+`</thead>
`+le+`</table>
`},Ee.tablerow=function(re){return`<tr>
`+re+`</tr>
`},Ee.tablecell=function(re,le){var N=le.header?"th":"td",Q=le.align?"<"+N+' align="'+le.align+'">':"<"+N+">";return Q+re+"</"+N+`>
`},Ee.strong=function(re){return"<strong>"+re+"</strong>"},Ee.em=function(re){return"<em>"+re+"</em>"},Ee.codespan=function(re){return"<code>"+re+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(re){return"<del>"+re+"</del>"},Ee.link=function(re,le,N){if(re=de(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var Q='<a href="'+_e(re)+'"';return le&&(Q+=' title="'+le+'"'),Q+=">"+N+"</a>",Q},Ee.image=function(re,le,N){if(re=de(this.options.sanitize,this.options.baseUrl,re),re===null)return N;var Q='<img src="'+re+'" alt="'+N+'"';return le&&(Q+=' title="'+le+'"'),Q+=this.options.xhtml?"/>":">",Q},Ee.text=function(re){return re},ye}(),fe=function(){function ye(){}var Ee=ye.prototype;return Ee.strong=function(re){return re},Ee.em=function(re){return re},Ee.codespan=function(re){return re},Ee.del=function(re){return re},Ee.html=function(re){return re},Ee.text=function(re){return re},Ee.link=function(re,le,N){return""+N},Ee.image=function(re,le,N){return""+N},Ee.br=function(){return""},ye}(),De=function(){function ye(){this.seen={}}var Ee=ye.prototype;return Ee.serialize=function(re){return re.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(re,le){var N=re,Q=0;if(this.seen.hasOwnProperty(N)){Q=this.seen[re];do Q++,N=re+"-"+Q;while(this.seen.hasOwnProperty(N))}return le||(this.seen[re]=Q,this.seen[N]=0),N},Ee.slug=function(re,le){le===void 0&&(le={});var N=this.serialize(re);return this.getNextSafeSlug(N,le.dryrun)},ye}(),Re=y.defaults,He=$.unescape,we=function(){function ye(Ce){this.options=Ce||Re,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new fe,this.slugger=new De}ye.parse=function(re,le){var N=new ye(le);return N.parse(re)},ye.parseInline=function(re,le){var N=new ye(le);return N.parseInline(re)};var Ee=ye.prototype;return Ee.parse=function(re,le){le===void 0&&(le=!0);var N="",Q,ae,ke,Ie,Ae,xe,Ye,rt,tt,Qe,mt,bt,pe,ce,se,q,Me,Te,Je=re.length;for(Q=0;Q<Je;Q++)switch(Qe=re[Q],Qe.type){case"space":continue;case"hr":{N+=this.renderer.hr();continue}case"heading":{N+=this.renderer.heading(this.parseInline(Qe.tokens),Qe.depth,He(this.parseInline(Qe.tokens,this.textRenderer)),this.slugger);continue}case"code":{N+=this.renderer.code(Qe.text,Qe.lang,Qe.escaped);continue}case"table":{for(rt="",Ye="",Ie=Qe.header.length,ae=0;ae<Ie;ae++)Ye+=this.renderer.tablecell(this.parseInline(Qe.tokens.header[ae]),{header:!0,align:Qe.align[ae]});for(rt+=this.renderer.tablerow(Ye),tt="",Ie=Qe.cells.length,ae=0;ae<Ie;ae++){for(xe=Qe.tokens.cells[ae],Ye="",Ae=xe.length,ke=0;ke<Ae;ke++)Ye+=this.renderer.tablecell(this.parseInline(xe[ke]),{header:!1,align:Qe.align[ke]});tt+=this.renderer.tablerow(Ye)}N+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Qe.tokens),N+=this.renderer.blockquote(tt);continue}case"list":{for(mt=Qe.ordered,bt=Qe.start,pe=Qe.loose,Ie=Qe.items.length,tt="",ae=0;ae<Ie;ae++)se=Qe.items[ae],q=se.checked,Me=se.task,ce="",se.task&&(Te=this.renderer.checkbox(q),pe?se.tokens.length>0&&se.tokens[0].type==="text"?(se.tokens[0].text=Te+" "+se.tokens[0].text,se.tokens[0].tokens&&se.tokens[0].tokens.length>0&&se.tokens[0].tokens[0].type==="text"&&(se.tokens[0].tokens[0].text=Te+" "+se.tokens[0].tokens[0].text)):se.tokens.unshift({type:"text",text:Te}):ce+=Te),ce+=this.parse(se.tokens,pe),tt+=this.renderer.listitem(ce,Me,q);N+=this.renderer.list(tt,mt,bt);continue}case"html":{N+=this.renderer.html(Qe.text);continue}case"paragraph":{N+=this.renderer.paragraph(this.parseInline(Qe.tokens));continue}case"text":{for(tt=Qe.tokens?this.parseInline(Qe.tokens):Qe.text;Q+1<Je&&re[Q+1].type==="text";)Qe=re[++Q],tt+=`
`+(Qe.tokens?this.parseInline(Qe.tokens):Qe.text);N+=le?this.renderer.paragraph(tt):tt;continue}default:{var et='Token with "'+Qe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return N},Ee.parseInline=function(re,le){le=le||this.renderer;var N="",Q,ae,ke=re.length;for(Q=0;Q<ke;Q++)switch(ae=re[Q],ae.type){case"escape":{N+=le.text(ae.text);break}case"html":{N+=le.html(ae.text);break}case"link":{N+=le.link(ae.href,ae.title,this.parseInline(ae.tokens,le));break}case"image":{N+=le.image(ae.href,ae.title,ae.text);break}case"strong":{N+=le.strong(this.parseInline(ae.tokens,le));break}case"em":{N+=le.em(this.parseInline(ae.tokens,le));break}case"codespan":{N+=le.codespan(ae.text);break}case"br":{N+=le.br();break}case"del":{N+=le.del(this.parseInline(ae.tokens,le));break}case"text":{N+=le.text(ae.text);break}default:{var Ie='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}return N},ye}(),qe=$.merge,z=$.checkSanitizeDeprecation,ee=$.escape,ge=y.getDefaults,Ne=y.changeDefaults,Ve=y.defaults;function $e(ye,Ee,Ce){if(typeof ye=="undefined"||ye===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");if(typeof Ee=="function"&&(Ce=Ee,Ee=null),Ee=qe({},$e.defaults,Ee||{}),z(Ee),Ce){var re=Ee.highlight,le;try{le=te.lex(ye,Ee)}catch(ke){return Ce(ke)}var N=function(Ie){var Ae;if(!Ie)try{Ae=we.parse(le,Ee)}catch(xe){Ie=xe}return Ee.highlight=re,Ie?Ce(Ie):Ce(null,Ae)};if(!re||re.length<3||(delete Ee.highlight,!le.length))return N();var Q=0;$e.walkTokens(le,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){re(ke.text,ke.lang,function(Ie,Ae){if(Ie)return N(Ie);Ae!=null&&Ae!==ke.text&&(ke.text=Ae,ke.escaped=!0),Q--,Q===0&&N()})},0))}),Q===0&&N();return}try{var ae=te.lex(ye,Ee);return Ee.walkTokens&&$e.walkTokens(ae,Ee.walkTokens),we.parse(ae,Ee)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+ee(ke.message+"",!0)+"</pre>";throw ke}}$e.options=$e.setOptions=function(ye){return qe($e.defaults,ye),Ne($e.defaults),$e},$e.getDefaults=ge,$e.defaults=Ve,$e.use=function(ye){var Ee=qe({},ye);if(ye.renderer&&function(){var re=$e.defaults.renderer||new Be,le=function(ae){var ke=re[ae];re[ae]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),xe=0;xe<Ie;xe++)Ae[xe]=arguments[xe];var Ye=ye.renderer[ae].apply(re,Ae);return Ye===!1&&(Ye=ke.apply(re,Ae)),Ye}};for(var N in ye.renderer)le(N);Ee.renderer=re}(),ye.tokenizer&&function(){var re=$e.defaults.tokenizer||new L,le=function(ae){var ke=re[ae];re[ae]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),xe=0;xe<Ie;xe++)Ae[xe]=arguments[xe];var Ye=ye.tokenizer[ae].apply(re,Ae);return Ye===!1&&(Ye=ke.apply(re,Ae)),Ye}};for(var N in ye.tokenizer)le(N);Ee.tokenizer=re}(),ye.walkTokens){var Ce=$e.defaults.walkTokens;Ee.walkTokens=function(re){ye.walkTokens(re),Ce&&Ce(re)}}$e.setOptions(Ee)},$e.walkTokens=function(ye,Ee){for(var Ce=P(ye),re;!(re=Ce()).done;){var le=re.value;switch(Ee(le),le.type){case"table":{for(var N=P(le.tokens.header),Q;!(Q=N()).done;){var ae=Q.value;$e.walkTokens(ae,Ee)}for(var ke=P(le.tokens.cells),Ie;!(Ie=ke()).done;)for(var Ae=Ie.value,xe=P(Ae),Ye;!(Ye=xe()).done;){var rt=Ye.value;$e.walkTokens(rt,Ee)}break}case"list":{$e.walkTokens(le.items,Ee);break}default:le.tokens&&$e.walkTokens(le.tokens,Ee)}}},$e.parseInline=function(ye,Ee){if(typeof ye=="undefined"||ye===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ye!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ye)+", string expected");Ee=qe({},$e.defaults,Ee||{}),z(Ee);try{var Ce=te.lexInline(ye,Ee);return Ee.walkTokens&&$e.walkTokens(Ce,Ee.walkTokens),we.parseInline(Ce,Ee)}catch(re){if(re.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+ee(re.message+"",!0)+"</pre>";throw re}},$e.Parser=we,$e.parser=we.parse,$e.Renderer=Be,$e.TextRenderer=fe,$e.Lexer=te,$e.lexer=te.lex,$e.Tokenizer=L,$e.Slugger=De,$e.parse=$e;var Ze=$e;return Ze}),define(ve[81],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function b(y,D,S){return Math.min(Math.max(y,D),S)}e.clamp=b;function k(y,D){return(D+y%D)%D}e.rot=k;class P{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=P;class T{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T});"use strict";(function(){function J(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function y(S){T.push(S,Date.now())}function D(){const S=[];for(let C=0;C<T.length;C+=2)S.push({name:T[C],startTime:T[C+1]});return S}return{mark:y,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const y of performance.getEntriesByType("mark"))T.push({name:y.name,startTime:Math.round(P+y.startTime)});return T}};if(typeof process=="object"){const P=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function b(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=b(k))})(),define(ve[21],be([0,1]),function(J,e){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const k="en";let P=!1,T=!1,y=!1,D=!1,S=!1,C=!1,i=!1,I,h=k,d,r;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let o;typeof e.globals.vscode!="undefined"?o=e.globals.vscode.process:typeof process!="undefined"&&(o=process);const v=typeof((b=o==null?void 0:o.versions)===null||b===void 0?void 0:b.electron)=="string"&&o.type==="renderer";if(e.isElectronSandboxed=v&&(o==null?void 0:o.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=o==null?void 0:o.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!v)r=navigator.userAgent,P=r.indexOf("Windows")>=0,T=r.indexOf("Macintosh")>=0,i=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=r.indexOf("Linux")>=0,C=!0,I=navigator.language,h=I;else if(typeof o=="object"){P=o.platform==="win32",T=o.platform==="darwin",y=o.platform==="linux",D=y&&!!o.env.SNAP&&!!o.env.SNAP_REVISION,I=k,h=k;const s=o.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),g=u.availableLanguages["*"];I=u.locale,h=g||k,d=u._translationsConfigFile}catch(u){}S=!0}else console.error("Unable to resolve platform.");var p;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function E(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=E;let c=0;T?c=1:P?c=3:y&&(c=2),e.isWindows=P,e.isMacintosh=T,e.isLinux=y,e.isLinuxSnap=D,e.isNative=S,e.isWeb=C,e.isIOS=i,e.platform=c,e.userAgent=r,e.language=h;var l;(function(s){function u(){return e.language}s.value=u;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=g;function _(){return e.language==="en"}s.isDefault=_})(l=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let m=0,w=g.length;m<w;m++){const R=g[m];if(R.id===A.data.vscodeSetImmediateId){g.splice(m,1),R.callback();return}}});let _=0;return A=>{const m=++_;g.push({id:m,callback:A}),e.globals.postMessage({vscodeSetImmediateId:m},"*")}}if(typeof(o==null?void 0:o.nextTick)=="function")return o.nextTick.bind(o);const u=Promise.resolve();return g=>u.then(g)}();var f;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(f=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:P?1:3;let t=!0,n=!1;function a(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=a}),define(ve[46],be([0,1,21]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof b.globals.vscode!="undefined"){const P=b.globals.vscode.process;k={get platform(){return P.platform},get env(){return P.env},cwd(){return P.cwd()},nextTick(T){return(0,b.setImmediate)(T)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(P){return process.nextTick(P)}}:k={get platform(){return b.isWindows?"win32":b.isMacintosh?"darwin":"linux"},nextTick(P){return(0,b.setImmediate)(P)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(ve[14],be([0,1,46]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,P=97,T=90,y=122,D=46,S=47,C=92,i=58,I=63;class h extends Error{constructor(l,f,t){let n;typeof f=="string"&&f.indexOf("not ")===0?(n="must not be",f=f.replace(/^not /,"")):n="must be";const a=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${a} ${n} of type ${f}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function d(c,l){if(typeof c!="string")throw new h(l,"string",c)}function r(c){return c===S||c===C}function o(c){return c===S}function v(c){return c>=k&&c<=T||c>=P&&c<=y}function p(c,l,f,t){let n="",a=0,s=-1,u=0,g=0;for(let _=0;_<=c.length;++_){if(_<c.length)g=c.charCodeAt(_);else{if(t(g))break;g=S}if(t(g)){if(!(s===_-1||u===1))if(u===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==D||n.charCodeAt(n.length-2)!==D){if(n.length>2){const A=n.lastIndexOf(f);A===-1?(n="",a=0):(n=n.slice(0,A),a=n.length-1-n.lastIndexOf(f)),s=_,u=0;continue}else if(n.length!==0){n="",a=0,s=_,u=0;continue}}l&&(n+=n.length>0?`${f}..`:"..",a=2)}else n.length>0?n+=`${f}${c.slice(s+1,_)}`:n=c.slice(s+1,_),a=_-s-1;s=_,u=0}else g===D&&u!==-1?++u:u=-1}return n}function E(c,l){if(l===null||typeof l!="object")throw new h("pathObject","Object",l);const f=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return f?f===l.root?`${f}${t}`:`${f}${c}${t}`:t}e.win32={resolve(...c){let l="",f="",t=!1;for(let n=c.length-1;n>=-1;n--){let a;if(n>=0){if(a=c[n],d(a,"path"),a.length===0)continue}else l.length===0?a=b.cwd():(a=b.env[`=${l}`]||b.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===C)&&(a=`${l}\\`));const s=a.length;let u=0,g="",_=!1;const A=a.charCodeAt(0);if(s===1)r(A)&&(u=1,_=!0);else if(r(A))if(_=!0,r(a.charCodeAt(1))){let m=2,w=m;for(;m<s&&!r(a.charCodeAt(m));)m++;if(m<s&&m!==w){const R=a.slice(w,m);for(w=m;m<s&&r(a.charCodeAt(m));)m++;if(m<s&&m!==w){for(w=m;m<s&&!r(a.charCodeAt(m));)m++;(m===s||m!==w)&&(g=`\\\\${R}\\${a.slice(w,m)}`,u=m)}}}else u=1;else v(A)&&a.charCodeAt(1)===i&&(g=a.slice(0,2),u=2,s>2&&r(a.charCodeAt(2))&&(_=!0,u=3));if(g.length>0)if(l.length>0){if(g.toLowerCase()!==l.toLowerCase())continue}else l=g;if(t){if(l.length>0)break}else if(f=`${a.slice(u)}\\${f}`,t=_,_&&l.length>0)break}return f=p(f,!t,"\\",r),t?`${l}\\${f}`:`${l}${f}`||"."},normalize(c){d(c,"path");const l=c.length;if(l===0)return".";let f=0,t,n=!1;const a=c.charCodeAt(0);if(l===1)return o(a)?"\\":c;if(r(a))if(n=!0,r(c.charCodeAt(1))){let u=2,g=u;for(;u<l&&!r(c.charCodeAt(u));)u++;if(u<l&&u!==g){const _=c.slice(g,u);for(g=u;u<l&&r(c.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&!r(c.charCodeAt(u));)u++;if(u===l)return`\\\\${_}\\${c.slice(g)}\\`;u!==g&&(t=`\\\\${_}\\${c.slice(g,u)}`,f=u)}}}else f=1;else v(a)&&c.charCodeAt(1)===i&&(t=c.slice(0,2),f=2,l>2&&r(c.charCodeAt(2))&&(n=!0,f=3));let s=f<l?p(c.slice(f),!n,"\\",r):"";return s.length===0&&!n&&(s="."),s.length>0&&r(c.charCodeAt(l-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(c){d(c,"path");const l=c.length;if(l===0)return!1;const f=c.charCodeAt(0);return r(f)||l>2&&v(f)&&c.charCodeAt(1)===i&&r(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,f;for(let a=0;a<c.length;++a){const s=c[a];d(s,"path"),s.length>0&&(l===void 0?l=f=s:l+=`\\${s}`)}if(l===void 0)return".";let t=!0,n=0;if(typeof f=="string"&&r(f.charCodeAt(0))){++n;const a=f.length;a>1&&r(f.charCodeAt(1))&&(++n,a>2&&(r(f.charCodeAt(2))?++n:t=!1))}if(t){for(;n<l.length&&r(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.win32.normalize(l)},relative(c,l){if(d(c,"from"),d(l,"to"),c===l)return"";const f=e.win32.resolve(c),t=e.win32.resolve(l);if(f===t||(c=f.toLowerCase(),l=t.toLowerCase(),c===l))return"";let n=0;for(;n<c.length&&c.charCodeAt(n)===C;)n++;let a=c.length;for(;a-1>n&&c.charCodeAt(a-1)===C;)a--;const s=a-n;let u=0;for(;u<l.length&&l.charCodeAt(u)===C;)u++;let g=l.length;for(;g-1>u&&l.charCodeAt(g-1)===C;)g--;const _=g-u,A=s<_?s:_;let m=-1,w=0;for(;w<A;w++){const $=c.charCodeAt(n+w);if($!==l.charCodeAt(u+w))break;$===C&&(m=w)}if(w!==A){if(m===-1)return t}else{if(_>A){if(l.charCodeAt(u+w)===C)return t.slice(u+w+1);if(w===2)return t.slice(u+w)}s>A&&(c.charCodeAt(n+w)===C?m=w:w===2&&(m=3)),m===-1&&(m=0)}let R="";for(w=n+m+1;w<=a;++w)(w===a||c.charCodeAt(w)===C)&&(R+=R.length===0?"..":"\\..");return u+=m,R.length>0?`${R}${t.slice(u,g)}`:(t.charCodeAt(u)===C&&++u,t.slice(u,g))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===C){if(l.charCodeAt(1)===C){const f=l.charCodeAt(2);if(f!==I&&f!==D)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===C)return`\\\\?\\${l}`;return c},dirname(c){d(c,"path");const l=c.length;if(l===0)return".";let f=-1,t=0;const n=c.charCodeAt(0);if(l===1)return r(n)?c:".";if(r(n)){if(f=t=1,r(c.charCodeAt(1))){let u=2,g=u;for(;u<l&&!r(c.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&r(c.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&!r(c.charCodeAt(u));)u++;if(u===l)return c;u!==g&&(f=t=u+1)}}}}else v(n)&&c.charCodeAt(1)===i&&(f=l>2&&r(c.charCodeAt(2))?3:2,t=f);let a=-1,s=!0;for(let u=l-1;u>=t;--u)if(r(c.charCodeAt(u))){if(!s){a=u;break}}else s=!1;if(a===-1){if(f===-1)return".";a=f}return c.slice(0,a)},basename(c,l){l!==void 0&&d(l,"ext"),d(c,"path");let f=0,t=-1,n=!0,a;if(c.length>=2&&v(c.charCodeAt(0))&&c.charCodeAt(1)===i&&(f=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let s=l.length-1,u=-1;for(a=c.length-1;a>=f;--a){const g=c.charCodeAt(a);if(r(g)){if(!n){f=a+1;break}}else u===-1&&(n=!1,u=a+1),s>=0&&(g===l.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=u))}return f===t?t=u:t===-1&&(t=c.length),c.slice(f,t)}for(a=c.length-1;a>=f;--a)if(r(c.charCodeAt(a))){if(!n){f=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":c.slice(f,t)},extname(c){d(c,"path");let l=0,f=-1,t=0,n=-1,a=!0,s=0;c.length>=2&&c.charCodeAt(1)===i&&v(c.charCodeAt(0))&&(l=t=2);for(let u=c.length-1;u>=l;--u){const g=c.charCodeAt(u);if(r(g)){if(!a){t=u+1;break}continue}n===-1&&(a=!1,n=u+1),g===D?f===-1?f=u:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||n===-1||s===0||s===1&&f===n-1&&f===t+1?"":c.slice(f,n)},format:E.bind(null,"\\"),parse(c){d(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const f=c.length;let t=0,n=c.charCodeAt(0);if(f===1)return r(n)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(r(n)){if(t=1,r(c.charCodeAt(1))){let m=2,w=m;for(;m<f&&!r(c.charCodeAt(m));)m++;if(m<f&&m!==w){for(w=m;m<f&&r(c.charCodeAt(m));)m++;if(m<f&&m!==w){for(w=m;m<f&&!r(c.charCodeAt(m));)m++;m===f?t=m:m!==w&&(t=m+1)}}}}else if(v(n)&&c.charCodeAt(1)===i){if(f<=2)return l.root=l.dir=c,l;if(t=2,r(c.charCodeAt(2))){if(f===3)return l.root=l.dir=c,l;t=3}}t>0&&(l.root=c.slice(0,t));let a=-1,s=t,u=-1,g=!0,_=c.length-1,A=0;for(;_>=t;--_){if(n=c.charCodeAt(_),r(n)){if(!g){s=_+1;break}continue}u===-1&&(g=!1,u=_+1),n===D?a===-1?a=_:A!==1&&(A=1):a!==-1&&(A=-1)}return u!==-1&&(a===-1||A===0||A===1&&a===u-1&&a===s+1?l.base=l.name=c.slice(s,u):(l.name=c.slice(s,a),l.base=c.slice(s,u),l.ext=c.slice(a,u))),s>0&&s!==t?l.dir=c.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",f=!1;for(let t=c.length-1;t>=-1&&!f;t--){const n=t>=0?c[t]:b.cwd();d(n,"path"),n.length!==0&&(l=`${n}/${l}`,f=n.charCodeAt(0)===S)}return l=p(l,!f,"/",o),f?`/${l}`:l.length>0?l:"."},normalize(c){if(d(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===S,f=c.charCodeAt(c.length-1)===S;return c=p(c,!l,"/",o),c.length===0?l?"/":f?"./":".":(f&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return d(c,"path"),c.length>0&&c.charCodeAt(0)===S},join(...c){if(c.length===0)return".";let l;for(let f=0;f<c.length;++f){const t=c[f];d(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(d(c,"from"),d(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const f=1,t=c.length,n=t-f,a=1,s=l.length-a,u=n<s?n:s;let g=-1,_=0;for(;_<u;_++){const m=c.charCodeAt(f+_);if(m!==l.charCodeAt(a+_))break;m===S&&(g=_)}if(_===u)if(s>u){if(l.charCodeAt(a+_)===S)return l.slice(a+_+1);if(_===0)return l.slice(a+_)}else n>u&&(c.charCodeAt(f+_)===S?g=_:_===0&&(g=0));let A="";for(_=f+g+1;_<=t;++_)(_===t||c.charCodeAt(_)===S)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(a+g)}`},toNamespacedPath(c){return c},dirname(c){if(d(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===S;let f=-1,t=!0;for(let n=c.length-1;n>=1;--n)if(c.charCodeAt(n)===S){if(!t){f=n;break}}else t=!1;return f===-1?l?"/":".":l&&f===1?"//":c.slice(0,f)},basename(c,l){l!==void 0&&d(l,"ext"),d(c,"path");let f=0,t=-1,n=!0,a;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let s=l.length-1,u=-1;for(a=c.length-1;a>=0;--a){const g=c.charCodeAt(a);if(g===S){if(!n){f=a+1;break}}else u===-1&&(n=!1,u=a+1),s>=0&&(g===l.charCodeAt(s)?--s==-1&&(t=a):(s=-1,t=u))}return f===t?t=u:t===-1&&(t=c.length),c.slice(f,t)}for(a=c.length-1;a>=0;--a)if(c.charCodeAt(a)===S){if(!n){f=a+1;break}}else t===-1&&(n=!1,t=a+1);return t===-1?"":c.slice(f,t)},extname(c){d(c,"path");let l=-1,f=0,t=-1,n=!0,a=0;for(let s=c.length-1;s>=0;--s){const u=c.charCodeAt(s);if(u===S){if(!n){f=s+1;break}continue}t===-1&&(n=!1,t=s+1),u===D?l===-1?l=s:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||t===-1||a===0||a===1&&l===t-1&&l===f+1?"":c.slice(l,t)},format:E.bind(null,"/"),parse(c){d(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const f=c.charCodeAt(0)===S;let t;f?(l.root="/",t=1):t=0;let n=-1,a=0,s=-1,u=!0,g=c.length-1,_=0;for(;g>=t;--g){const A=c.charCodeAt(g);if(A===S){if(!u){a=g+1;break}continue}s===-1&&(u=!1,s=g+1),A===D?n===-1?n=g:_!==1&&(_=1):n!==-1&&(_=-1)}if(s!==-1){const A=a===0&&f?1:a;n===-1||_===0||_===1&&n===s-1&&n===a+1?l.base=l.name=c.slice(A,s):(l.name=c.slice(A,n),l.base=c.slice(A,s),l.ext=c.slice(n,s))}return a>0?l.dir=c.slice(0,a-1):f&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=b.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=b.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=b.platform==="win32"?e.win32.join:e.posix.join,e.resolve=b.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=b.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=b.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=b.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=b.platform==="win32"?e.win32.extname:e.posix.extname,e.format=b.platform==="win32"?e.win32.format:e.posix.format,e.parse=b.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=b.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=b.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=b.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ve[55],be([0,1,21]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=b.globals.performance&&typeof b.globals.performance.now=="function";class P{constructor(y){this._highResolution=k&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new P(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?b.globals.performance.now():Date.now()}}e.StopWatch=P}),define(ve[3],be([0,1,12,53,6,45,55]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(p){p.None=()=>P.Disposable.None;function E(V){return(H,Y=null,U)=>{let F=!1,L;return L=V(M=>{if(!F)return L?L.dispose():F=!0,H.call(Y,M)},null,U),F&&L.dispose(),L}}p.once=E;function c(V,H){return s((Y,U=null,F)=>V(L=>Y.call(U,H(L)),null,F))}p.map=c;function l(V,H){return s((Y,U=null,F)=>V(L=>{H(L),Y.call(U,L)},null,F))}p.forEach=l;function f(V,H){return s((Y,U=null,F)=>V(L=>H(L)&&Y.call(U,L),null,F))}p.filter=f;function t(V){return V}p.signal=t;function n(...V){return(H,Y=null,U)=>(0,P.combinedDisposable)(...V.map(F=>F(L=>H.call(Y,L),null,U)))}p.any=n;function a(V,H,Y){let U=Y;return c(V,F=>(U=H(U,F),U))}p.reduce=a;function s(V){let H;const Y=new h({onFirstListenerAdd(){H=V(Y.fire,Y)},onLastListenerRemove(){H.dispose()}});return Y.event}p.snapshot=s;function u(V,H,Y=100,U=!1,F){let L,M,x,G=0;const X=new h({leakWarningThreshold:F,onFirstListenerAdd(){L=V(ne=>{G++,M=H(M,ne),U&&!x&&(X.fire(M),M=void 0),clearTimeout(x),x=setTimeout(()=>{const me=M;M=void 0,x=void 0,(!U||G>1)&&X.fire(me),G=0},Y)})},onLastListenerRemove(){L.dispose()}});return X.event}p.debounce=u;function g(V){const H=new Date().getTime();return c(E(V),Y=>new Date().getTime()-H)}p.stopwatch=g;function _(V){let H=!0,Y;return f(V,U=>{const F=H||U!==Y;return H=!1,Y=U,F})}p.latch=_;function A(V,H=!1,Y=[]){let U=Y.slice(),F=V(x=>{U?U.push(x):M.fire(x)});const L=()=>{U&&U.forEach(x=>M.fire(x)),U=null},M=new h({onFirstListenerAdd(){F||(F=V(x=>M.fire(x)))},onFirstListenerDidAdd(){U&&(H?setTimeout(L):L())},onLastListenerRemove(){F&&F.dispose(),F=null}});return M.event}p.buffer=A;class m{constructor(H){this.event=H}map(H){return new m(c(this.event,H))}forEach(H){return new m(l(this.event,H))}filter(H){return new m(f(this.event,H))}reduce(H,Y){return new m(a(this.event,H,Y))}latch(){return new m(_(this.event))}debounce(H,Y=100,U=!1,F){return new m(u(this.event,H,Y,U,F))}on(H,Y,U){return this.event(H,Y,U)}once(H,Y,U){return E(this.event)(H,Y,U)}}function w(V){return new m(V)}p.chain=w;function R(V,H,Y=U=>U){const U=(...x)=>M.fire(Y(...x)),F=()=>V.on(H,U),L=()=>V.removeListener(H,U),M=new h({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}p.fromNodeEventEmitter=R;function $(V,H,Y=U=>U){const U=(...x)=>M.fire(Y(...x)),F=()=>V.addEventListener(H,U),L=()=>V.removeEventListener(H,U),M=new h({onFirstListenerAdd:F,onLastListenerRemove:L});return M.event}p.fromDOMEventEmitter=$;function K(V){const H=new h;let Y=!1;return V.then(void 0,()=>null).then(()=>{Y?H.fire(void 0):setTimeout(()=>H.fire(void 0),0)}),Y=!0,H.event}p.fromPromise=K;function he(V){return new Promise(H=>E(V)(H))}p.toPromise=he})(D=e.Event||(e.Event={}));class S{constructor(E){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${E}_${S._idPool++}`}start(E){this._stopWatch=new y.StopWatch(!0),this._listenerCount=E}stop(){if(this._stopWatch){const E=this._stopWatch.elapsed();this._elapsedOverall+=E,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${E.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let C=-1;function i(p){const E=C;return C=p,{dispose(){C=E}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(E,c=Math.random().toString(18).slice(2,5)){this.customThreshold=E,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(E){let c=C;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||E<c)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),f=this._stacks.get(l)||0;if(this._stacks.set(l,f+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,n=0;for(const[a,s]of this._stacks)(!t||n<s)&&(t=a,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class h{constructor(E){var c;this._disposed=!1,this._options=E,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(E,c,l)=>{var f;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(c?[E,c]:E);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,E,c);const a=(f=this._leakageMon)===null||f===void 0?void 0:f.check(this._listeners.size);let s;return s={dispose:()=>{a&&a(),s.dispose=h._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof P.DisposableStore?l.add(s):Array.isArray(l)&&l.push(s),s}),this._event}fire(E){var c,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let f of this._listeners)this._deliveryQueue.push([f,E]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[f,t]=this._deliveryQueue.shift();try{typeof f=="function"?f.call(void 0,t):f[0].call(f[1],t)}catch(n){(0,b.onUnexpectedError)(n)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var E,c,l;(E=this._listeners)===null||E===void 0||E.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=h,h._noop=function(){};class d extends h{constructor(E){super(E);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=E==null?void 0:E.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const E=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(E))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(E){this._listeners&&(this._isPaused!==0?this._eventQueue.push(E):super.fire(E))}}e.PauseableEmitter=d;class r{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new h({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(E){const c={event:E,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const l=()=>{this.hasListeners&&this.unhook(c);const f=this.events.indexOf(c);this.events.splice(f,1)};return(0,P.toDisposable)((0,k.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(E=>this.hook(E))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(E=>this.unhook(E))}hook(E){E.listener=E.event(c=>this.emitter.fire(c))}unhook(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.buffers=[]}wrapEvent(E){return(c,l,f)=>E(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>c.call(l,t)):c.call(l,t)},void 0,f)}bufferEvents(E){const c=[];this.buffers.push(c);const l=E();return this.buffers.pop(),c.forEach(f=>f()),l}}e.EventBufferer=o;class v{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=P.Disposable.None,this.emitter=new h({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(E){this.inputEvent=E,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=E(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=v}),define(ve[20],be([0,1,3]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(D,S){const C=setTimeout(D.bind(S),0);return{dispose(){clearTimeout(C)}}});var P;(function(D){function S(C){return C===D.None||C===D.Cancelled||C instanceof T?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=S,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:b.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(P=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new b.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=P.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=P.None}}e.CancellationTokenSource=y}),define(ve[36],be([0,1,3]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new b.Emitter}add(I){const h=this._icons.get(I.id);h?I.description?h.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const P=new k;e.iconRegistry=P;function T(i,I){return new D(i,I)}e.registerCodicon=T;function y(i){return i?i.replace(/\$\((.*?)\)/g,(I,h)=>` ${h} `).trim():""}e.getCodiconAriaLabel=y;class D{constructor(I,h,d){this.id=I,this.definition=h,this.description=d,P.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function S(i,I){const h=["codicon","codicon-"+i];return I&&h.push("codicon-modifier-"+I),h}e.getClassNamesArray=S;var C;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function h(o){if(o instanceof D)return["codicon","codicon-"+o.id];const v=I.exec(o.id);if(!v)return h(D.error);let[,p,E]=v;const c=["codicon","codicon-"+p];return E&&c.push("codicon-modifier-"+E.substr(1)),c}i.asClassNameArray=h;function d(o){return h(o).join(" ")}i.asClassName=d;function r(o){return"."+h(o).join(".")}i.asCSSSelector=r})(C=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(ve[109],be([0,1,12,6]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function P(c){const l=c;return l?[l.on,l.pause,l.resume,l.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=P;function T(c){const l=c;return l?P(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=T;function y(c,l){return new D(c,l)}e.newWriteableStream=y;class D{constructor(l,f){this.reducer=l,this.options=f,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var f;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((f=this.options)===null||f===void 0?void 0:f.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(f=>f(l))}emitError(l){this.listeners.error.length===0?(0,b.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(f=>f(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,f){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(f),this.resume();break;case"end":this.listeners.end.push(f),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(f),this.state.flowing&&this.flowErrors();break}}removeListener(l,f){if(!this.state.destroyed){let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(f);n>=0&&t.splice(n,1)}}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const f=[...this.pendingWritePromises];this.pendingWritePromises.length=0,f.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(c,l){const f=[];let t;for(;(t=c.read())!==null;)f.push(t);return l(f)}e.consumeReadable=S;function C(c,l,f){const t=[];let n;for(;(n=c.read())!==null&&t.length<f;)t.push(n);return n===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const a=n;return n=void 0,a}return c.read()}}}e.peekReadable=C;function i(c,l){return new Promise((f,t)=>{const n=[];I(c,{onData:a=>{l&&n.push(a)},onError:a=>{l?t(a):f(void 0)},onEnd:()=>{f(l?l(n):void 0)}})})}e.consumeStream=i;function I(c,l){c.on("error",f=>l.onError(f)),c.on("end",()=>l.onEnd()),c.on("data",f=>l.onData(f))}e.listenStream=I;function h(c,l){return new Promise((f,t)=>{const n=new k.DisposableStore,a=[],s=_=>{if(a.push(_),a.length>l)return n.dispose(),c.pause(),f({stream:c,buffer:a,ended:!1})},u=_=>t(_),g=()=>f({stream:c,buffer:a,ended:!0});n.add((0,k.toDisposable)(()=>c.removeListener("error",u))),c.on("error",u),n.add((0,k.toDisposable)(()=>c.removeListener("end",g))),c.on("end",g),n.add((0,k.toDisposable)(()=>c.removeListener("data",s))),c.on("data",s)})}e.peekStream=h;function d(c,l){const f=y(l);return f.end(c),f}e.toStream=d;function r(){const c=y(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=r;function o(c){let l=!1;return{read:()=>l?null:(l=!0,c)}}e.toReadable=o;function v(c,l,f){const t=y(f);return I(c,{onData:n=>t.write(l.data(n)),onError:n=>t.error(l.error?l.error(n):n),onEnd:()=>t.end()}),t}e.transform=v;function p(c,l,f){let t=!1;return{read:()=>{const n=l.read();return t?n:(t=!0,n!==null?f([c,n]):c)}}}e.prefixedReadable=p;function E(c,l,f){let t=!1;const n=y(f);return I(l,{onData:a=>t?n.write(a):(t=!0,n.write(f([c,a]))),onError:a=>n.error(a),onEnd:()=>{t||(t=!0,n.write(c)),n.end()}}),n}e.prefixedStream=E}),define(ve[8],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function b(N){return!N||typeof N!="string"?!0:N.trim().length===0}e.isFalsyOrWhitespace=b;const k=/{(\d+)}/g;function P(N,...Q){return Q.length===0?N:N.replace(k,function(ae,ke){const Ie=parseInt(ke,10);return isNaN(Ie)||Ie<0||Ie>=Q.length?ae:Q[Ie]})}e.format=P;function T(N){return N.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=T;function y(N){return N.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=y;function D(N,Q){let ae=0;const ke=Q.charCodeAt(0);for(let Ie=N.length-1;Ie>=0;Ie--)N.charCodeAt(Ie)===ke&&ae++;return ae}e.count=D;function S(N,Q,ae="\u2026"){return N.length<=Q?N:`${N.substr(0,Q)}${ae}`}e.truncate=S;function C(N,Q=" "){const ae=i(N,Q);return I(ae,Q)}e.trim=C;function i(N,Q){if(!N||!Q)return N;const ae=Q.length;if(ae===0||N.length===0)return N;let ke=0;for(;N.indexOf(Q,ke)===ke;)ke=ke+ae;return N.substring(ke)}e.ltrim=i;function I(N,Q){if(!N||!Q)return N;const ae=Q.length,ke=N.length;if(ae===0||ke===0)return N;let Ie=ke,Ae=-1;for(;Ae=N.lastIndexOf(Q,Ie-1),!(Ae===-1||Ae+ae!==Ie);){if(Ae===0)return"";Ie=Ae}return N.substring(0,Ie)}e.rtrim=I;function h(N){return N.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function d(N){return N.replace(/\*/g,"")}e.stripWildcards=d;function r(N,Q,ae={}){if(!N)throw new Error("Cannot create regex from empty string");Q||(N=y(N)),ae.wholeWord&&(/\B/.test(N.charAt(0))||(N="\\b"+N),/\B/.test(N.charAt(N.length-1))||(N=N+"\\b"));let ke="";return ae.global&&(ke+="g"),ae.matchCase||(ke+="i"),ae.multiline&&(ke+="m"),ae.unicode&&(ke+="u"),new RegExp(N,ke)}e.createRegExp=r;function o(N){return N.source==="^"||N.source==="^$"||N.source==="$"||N.source==="^\\s*$"?!1:!!(N.exec("")&&N.lastIndex===0)}e.regExpLeadsToEndlessLoop=o;function v(N){return!!N.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=v;function p(N){return(N.global?"g":"")+(N.ignoreCase?"i":"")+(N.multiline?"m":"")+(N.unicode?"u":"")}e.regExpFlags=p;function E(N){return N.split(/\r\n|\r|\n/)}e.splitLines=E;function c(N){for(let Q=0,ae=N.length;Q<ae;Q++){const ke=N.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=c;function l(N,Q=0,ae=N.length){for(let ke=Q;ke<ae;ke++){const Ie=N.charCodeAt(ke);if(Ie!==32&&Ie!==9)return N.substring(Q,ke)}return N.substring(Q,ae)}e.getLeadingWhitespace=l;function f(N,Q=N.length-1){for(let ae=Q;ae>=0;ae--){const ke=N.charCodeAt(ae);if(ke!==32&&ke!==9)return ae}return-1}e.lastNonWhitespaceIndex=f;function t(N,Q){return N<Q?-1:N>Q?1:0}e.compare=t;function n(N,Q,ae=0,ke=N.length,Ie=0,Ae=Q.length){for(;ae<ke&&Ie<Ae;ae++,Ie++){let rt=N.charCodeAt(ae),tt=Q.charCodeAt(Ie);if(rt<tt)return-1;if(rt>tt)return 1}const xe=ke-ae,Ye=Ae-Ie;return xe<Ye?-1:xe>Ye?1:0}e.compareSubstring=n;function a(N,Q){return s(N,Q,0,N.length,0,Q.length)}e.compareIgnoreCase=a;function s(N,Q,ae=0,ke=N.length,Ie=0,Ae=Q.length){for(;ae<ke&&Ie<Ae;ae++,Ie++){let rt=N.charCodeAt(ae),tt=Q.charCodeAt(Ie);if(rt!==tt){const Qe=rt-tt;if(!(Qe===32&&g(tt))&&!(Qe===-32&&g(rt)))return u(rt)&&u(tt)?Qe:n(N.toLowerCase(),Q.toLowerCase(),ae,ke,Ie,Ae)}}const xe=ke-ae,Ye=Ae-Ie;return xe<Ye?-1:xe>Ye?1:0}e.compareSubstringIgnoreCase=s;function u(N){return N>=97&&N<=122}e.isLowerAsciiLetter=u;function g(N){return N>=65&&N<=90}e.isUpperAsciiLetter=g;function _(N){return u(N)||g(N)}function A(N,Q){return N.length===Q.length&&m(N,Q)}e.equalsIgnoreCase=A;function m(N,Q,ae=N.length){for(let ke=0;ke<ae;ke++){const Ie=N.charCodeAt(ke),Ae=Q.charCodeAt(ke);if(Ie!==Ae){if(_(Ie)&&_(Ae)){const xe=Math.abs(Ie-Ae);if(xe!==0&&xe!==32)return!1}else if(String.fromCharCode(Ie).toLowerCase()!==String.fromCharCode(Ae).toLowerCase())return!1}}return!0}function w(N,Q){const ae=Q.length;return Q.length>N.length?!1:m(N,Q,ae)}e.startsWithIgnoreCase=w;function R(N,Q){let ae,ke=Math.min(N.length,Q.length);for(ae=0;ae<ke;ae++)if(N.charCodeAt(ae)!==Q.charCodeAt(ae))return ae;return ke}e.commonPrefixLength=R;function $(N,Q){let ae,ke=Math.min(N.length,Q.length);const Ie=N.length-1,Ae=Q.length-1;for(ae=0;ae<ke;ae++)if(N.charCodeAt(Ie-ae)!==Q.charCodeAt(Ae-ae))return ae;return ke}e.commonSuffixLength=$;function K(N){return 55296<=N&&N<=56319}e.isHighSurrogate=K;function he(N){return 56320<=N&&N<=57343}e.isLowSurrogate=he;function V(N,Q){return(N-55296<<10)+(Q-56320)+65536}e.computeCodePoint=V;function H(N,Q,ae){const ke=N.charCodeAt(ae);if(K(ke)&&ae+1<Q){const Ie=N.charCodeAt(ae+1);if(he(Ie))return V(ke,Ie)}return ke}e.getNextCodePoint=H;function Y(N,Q){const ae=N.charCodeAt(Q-1);if(he(ae)&&Q>1){const ke=N.charCodeAt(Q-2);if(K(ke))return V(ke,ae)}return ae}function U(N,Q){const ae=$e.getInstance(),ke=Q,Ie=N.length,Ae=H(N,Ie,Q);Q+=Ae>=65536?2:1;let xe=ae.getGraphemeBreakType(Ae);for(;Q<Ie;){const Ye=H(N,Ie,Q),rt=ae.getGraphemeBreakType(Ye);if(Ne(xe,rt))break;Q+=Ye>=65536?2:1,xe=rt}return Q-ke}e.nextCharLength=U;function F(N,Q){const ae=$e.getInstance(),ke=Q,Ie=Y(N,Q);Q-=Ie>=65536?2:1;let Ae=ae.getGraphemeBreakType(Ie);for(;Q>0;){const xe=Y(N,Q),Ye=ae.getGraphemeBreakType(xe);if(Ne(Ye,Ae))break;Q-=xe>=65536?2:1,Ae=Ye}return ke-Q}e.prevCharLength=F;function L(N,Q){const ae=$e.getInstance(),ke=N.length,Ie=Q,Ae=H(N,ke,Q),xe=ae.getGraphemeBreakType(Ae);Q+=Ae>=65536?2:1;let Ye=xe;for(;Q<ke;){const tt=H(N,ke,Q),Qe=ae.getGraphemeBreakType(tt);if(Ne(Ye,Qe))break;Q+=tt>=65536?2:1,Ye=Qe}const rt=Q;for(Q=Ie,Ye=xe;Q>0;){const tt=Y(N,Q),Qe=ae.getGraphemeBreakType(tt);if(Ne(Qe,Ye))break;Q-=tt>=65536?2:1,Ye=Qe}return[Q,rt]}function M(N,Q){return Q>0&&he(N.charCodeAt(Q))?L(N,Q-1):L(N,Q)}e.getCharContainingOffset=M;function x(N){const Q=N.length;let ae=0,ke=0;for(;ke<Q;){const xe=H(N,Q,ke);ke+=xe>=65536?2:1,xe<128?ae+=1:xe<2048?ae+=2:xe<65536?ae+=3:ae+=4}const Ie=new Uint8Array(ae);ke=0;let Ae=0;for(;ke<Q;){const xe=H(N,Q,ke);ke+=xe>=65536?2:1,xe<128?Ie[Ae++]=xe:xe<2048?(Ie[Ae++]=192|(xe&1984)>>>6,Ie[Ae++]=128|(xe&63)>>>0):xe<65536?(Ie[Ae++]=224|(xe&61440)>>>12,Ie[Ae++]=128|(xe&4032)>>>6,Ie[Ae++]=128|(xe&63)>>>0):(Ie[Ae++]=240|(xe&1835008)>>>18,Ie[Ae++]=128|(xe&258048)>>>12,Ie[Ae++]=128|(xe&4032)>>>6,Ie[Ae++]=128|(xe&63)>>>0)}return Ie}e.encodeUTF8=x;function G(N){const Q=N.byteLength,ae=[];let ke=0;for(;ke<Q;){const Ie=N[ke];let Ae;if(Ie>=240&&ke+3<Q?Ae=(N[ke++]&7)<<18>>>0|(N[ke++]&63)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=224&&ke+2<Q?Ae=(N[ke++]&15)<<12>>>0|(N[ke++]&63)<<6>>>0|(N[ke++]&63)<<0>>>0:Ie>=192&&ke+1<Q?Ae=(N[ke++]&31)<<6>>>0|(N[ke++]&63)<<0>>>0:Ae=N[ke++],Ae>=0&&Ae<=55295||Ae>=57344&&Ae<=65535)ae.push(String.fromCharCode(Ae));else if(Ae>=65536&&Ae<=1114111){const xe=Ae-65536,Ye=55296+((xe&1047552)>>>10),rt=56320+((xe&1023)>>>0);ae.push(String.fromCharCode(Ye)),ae.push(String.fromCharCode(rt))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=G;const X=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ne(N){return X.test(N)}e.containsRTL=ne;const me=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Le(N){return me.test(N)}e.containsEmoji=Le;const We=/^[\t\n\r\x20-\x7E]*$/;function Fe(N){return We.test(N)}e.isBasicASCII=Fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ze(N){return e.UNUSUAL_LINE_TERMINATORS.test(N)}e.containsUnusualLineTerminators=ze;function W(N){for(let Q=0,ae=N.length;Q<ae;Q++)if(j(N.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=W;function j(N){return N=+N,N>=11904&&N<=55215||N>=63744&&N<=64255||N>=65281&&N<=65374}e.isFullWidthCharacter=j;function te(N){return N>=127462&&N<=127487||N===8986||N===8987||N===9200||N===9203||N>=9728&&N<=10175||N===11088||N===11093||N>=127744&&N<=128591||N>=128640&&N<=128764||N>=128992&&N<=129003||N>=129280&&N<=129535||N>=129648&&N<=129750}e.isEmojiImprecise=te;function oe(N,Q){if(N.length<Q)return N;const ae=/\b/g;let ke=0;for(;ae.test(N)&&!(N.length-ae.lastIndex<Q);)ke=ae.lastIndex,ae.lastIndex+=1;return N.substring(ke).replace(/^\s/,"")}e.lcut=oe;const de=/\x1B\x5B[12]?K/g,_e=/\x1b\[\d+m/g,Be=/\x1b\[0?m/g;function fe(N){return N&&(N=N.replace(de,""),N=N.replace(_e,""),N=N.replace(Be,"")),N}e.removeAnsiEscapeCodes=fe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function De(N){return!!(N&&N.length>0&&N.charCodeAt(0)===65279)}e.startsWithUTF8BOM=De;function Re(N){return De(N)?N.substr(1):N}e.stripUTF8BOM=Re;function He(N,Q){if(!N||!Q||N.length<Q.length)return!1;const ae=Q.length,ke=N.toLowerCase();let Ie=0,Ae=-1;for(;Ie<ae;){const xe=ke.indexOf(Q[Ie],Ae+1);if(xe<0)return!1;Ae=xe,Ie++}return!0}e.fuzzyContains=He;function we(N,Q=!1){return N?(Q&&(N=N.replace(/\\./g,"")),N.toLowerCase()!==N):!1}e.containsUppercaseCharacter=we;function qe(N){return N.charAt(0).toUpperCase()+N.slice(1)}e.uppercaseFirstLetter=qe;function z(N,Q=1){if(Q===0)return"";let ae=-1;do ae=N.indexOf(`
`,ae+1),Q--;while(Q>0&&ae>=0);return ae===-1?N:(N[ae-1]==="\r"&&ae--,N.substr(0,ae))}e.getNLines=z;function ee(N){const Q=90-65+1;return N=N%(2*Q),N<Q?String.fromCharCode(97+N):String.fromCharCode(65+N-Q)}e.singleLetterHash=ee;function ge(N){return $e.getInstance().getGraphemeBreakType(N)}e.getGraphemeBreakType=ge;function Ne(N,Q){return N===0?Q!==5&&Q!==7:N===2&&Q===3?!1:N===4||N===2||N===3||Q===4||Q===2||Q===3?!0:!(N===8&&(Q===8||Q===9||Q===11||Q===12)||(N===11||N===9)&&(Q===9||Q===10)||(N===12||N===10)&&Q===10||Q===5||Q===13||Q===7||N===1||N===13&&Q===14||N===6&&Q===6)}e.breakBetweenGraphemeBreakType=Ne;var Ve;(function(N){N[N.Other=0]="Other",N[N.Prepend=1]="Prepend",N[N.CR=2]="CR",N[N.LF=3]="LF",N[N.Control=4]="Control",N[N.Extend=5]="Extend",N[N.Regional_Indicator=6]="Regional_Indicator",N[N.SpacingMark=7]="SpacingMark",N[N.L=8]="L",N[N.V=9]="V",N[N.T=10]="T",N[N.LV=11]="LV",N[N.LVT=12]="LVT",N[N.ZWJ=13]="ZWJ",N[N.Extended_Pictographic=14]="Extended_Pictographic"})(Ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class $e{constructor(){this._data=Ze()}static getInstance(){return $e._INSTANCE||($e._INSTANCE=new $e),$e._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const ae=this._data,ke=ae.length/3;let Ie=1;for(;Ie<=ke;)if(Q<ae[3*Ie])Ie=2*Ie;else if(Q>ae[3*Ie+1])Ie=2*Ie+1;else return ae[3*Ie+2];return 0}}$e._INSTANCE=null;function Ze(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function ye(N,Q){if(N===0)return 0;const ae=Ee(N,Q);if(ae!==void 0)return ae;const ke=Y(Q,N);return N-=Ce(ke),N}e.getLeftDeleteOffset=ye;function Ee(N,Q){let ae=Y(Q,N);for(N-=Ce(ae);re(ae)||ae===65039||ae===8419;){if(N===0)return;ae=Y(Q,N),N-=Ce(ae)}if(!!te(ae)){if(N>=0){const ke=Y(Q,N);ke===8205&&(N-=Ce(ke))}return N}}function Ce(N){return N>=65536?2:1}function re(N){return 127995<=N&&N<=127999}var le;(function(N){N[N.zwj=8205]="zwj",N[N.emojiVariantSelector=65039]="emojiVariantSelector",N[N.enclosingKeyCap=8419]="enclosingKeyCap"})(le||(le={}))}),define(ve[24],be([0,1,8,109]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",y=typeof TextDecoder!="undefined";let D,S;class C{constructor(_){this.buffer=_,this.byteLength=this.buffer.byteLength}static alloc(_){return P?new C(Buffer.allocUnsafe(_)):new C(new Uint8Array(_))}static wrap(_){return P&&!Buffer.isBuffer(_)&&(_=Buffer.from(_.buffer,_.byteOffset,_.byteLength)),new C(_)}static fromString(_,A){return!((A==null?void 0:A.dontUseNodeBuffer)||!1)&&P?new C(Buffer.from(_)):T?(D||(D=new TextEncoder),new C(D.encode(_))):new C(b.encodeUTF8(_))}static concat(_,A){if(typeof A=="undefined"){A=0;for(let R=0,$=_.length;R<$;R++)A+=_[R].byteLength}const m=C.alloc(A);let w=0;for(let R=0,$=_.length;R<$;R++){const K=_[R];m.set(K,w),w+=K.byteLength}return m}toString(){return P?this.buffer.toString():y?(S||(S=new TextDecoder),S.decode(this.buffer)):b.decodeUTF8(this.buffer)}slice(_,A){return new C(this.buffer.subarray(_,A))}set(_,A){_ instanceof C?this.buffer.set(_.buffer,A):this.buffer.set(_,A)}readUInt32BE(_){return h(this.buffer,_)}writeUInt32BE(_,A){d(this.buffer,_,A)}readUInt32LE(_){return r(this.buffer,_)}writeUInt32LE(_,A){o(this.buffer,_,A)}readUInt8(_){return v(this.buffer,_)}writeUInt8(_,A){p(this.buffer,_,A)}}e.VSBuffer=C;function i(g,_){return g[_+0]<<0>>>0|g[_+1]<<8>>>0}e.readUInt16LE=i;function I(g,_,A){g[A+0]=_&255,_=_>>>8,g[A+1]=_&255}e.writeUInt16LE=I;function h(g,_){return g[_]*2**24+g[_+1]*2**16+g[_+2]*2**8+g[_+3]}e.readUInt32BE=h;function d(g,_,A){g[A+3]=_,_=_>>>8,g[A+2]=_,_=_>>>8,g[A+1]=_,_=_>>>8,g[A]=_}e.writeUInt32BE=d;function r(g,_){return g[_+0]<<0>>>0|g[_+1]<<8>>>0|g[_+2]<<16>>>0|g[_+3]<<24>>>0}e.readUInt32LE=r;function o(g,_,A){g[A+0]=_&255,_=_>>>8,g[A+1]=_&255,_=_>>>8,g[A+2]=_&255,_=_>>>8,g[A+3]=_&255}e.writeUInt32LE=o;function v(g,_){return g[_]}e.readUInt8=v;function p(g,_,A){g[A]=_}e.writeUInt8=p;function E(g){return k.consumeReadable(g,_=>C.concat(_))}e.readableToBuffer=E;function c(g){return k.toReadable(g)}e.bufferToReadable=c;function l(g){return k.consumeStream(g,_=>C.concat(_))}e.streamToBuffer=l;async function f(g){return g.ended?C.concat(g.buffer):C.concat([...g.buffer,await l(g.stream)])}e.bufferedStreamToBuffer=f;function t(g){return k.toStream(g,_=>C.concat(_))}e.bufferToStream=t;function n(g){return k.transform(g,{data:_=>typeof _=="string"?C.fromString(_):C.wrap(_)},_=>C.concat(_))}e.streamToBufferReadableStream=n;function a(g){return k.newWriteableStream(_=>C.concat(_),g)}e.newWriteableBufferStream=a;function s(g,_){return k.prefixedReadable(g,_,A=>C.concat(A))}e.prefixedBufferReadable=s;function u(g,_){return k.prefixedStream(g,_,A=>C.concat(A))}e.prefixedBufferStream=u}),define(ve[56],be([0,1,8]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function k(p){return P(p,0)}e.hash=k;function P(p,E){switch(typeof p){case"object":return p===null?T(349,E):Array.isArray(p)?S(p,E):C(p,E);case"string":return D(p,E);case"boolean":return y(p,E);case"number":return T(p,E);case"undefined":return T(937,E);default:return T(617,E)}}e.doHash=P;function T(p,E){return(E<<5)-E+p|0}function y(p,E){return T(p?433:863,E)}function D(p,E){E=T(149417,E);for(let c=0,l=p.length;c<l;c++)E=T(p.charCodeAt(c),E);return E}e.stringHash=D;function S(p,E){return E=T(104579,E),p.reduce((c,l)=>P(l,c),E)}function C(p,E){return E=T(181387,E),Object.keys(p).sort().reduce((c,l)=>(c=D(l,c),P(p[l],c)),E)}class i{constructor(){this._value=0}get value(){return this._value}hash(E){return this._value=P(E,this._value),this._value}}e.Hasher=i;var I;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function h(p,E,c=32){const l=c-E,f=~((1<<l)-1);return(p<<E|(f&p)>>>l)>>>0}function d(p,E=0,c=p.byteLength,l=0){for(let f=0;f<c;f++)p[E+f]=l}function r(p,E,c="0"){for(;p.length<E;)p=c+p;return p}function o(p,E=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(c=>c.toString(16).padStart(2,"0")).join(""):r((p>>>0).toString(16),E/4)}e.toHexString=o;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(E){const c=E.length;if(c!==0){const l=this._buff;let f=this._buffLen,t=this._leftoverHighSurrogate,n,a;for(t!==0?(n=t,a=-1,t=0):(n=E.charCodeAt(0),a=0);;){let s=n;if(b.isHighSurrogate(n))if(a+1<c){const u=E.charCodeAt(a+1);b.isLowSurrogate(u)?(a++,s=b.computeCodePoint(n,u)):s=65533}else{t=n;break}else b.isLowSurrogate(n)&&(s=65533);if(f=this._push(l,f,s),a++,a<c)n=E.charCodeAt(a);else break}this._buffLen=f,this._leftoverHighSurrogate=t}}_push(E,c,l){return l<128?E[c++]=l:l<2048?(E[c++]=192|(l&1984)>>>6,E[c++]=128|(l&63)>>>0):l<65536?(E[c++]=224|(l&61440)>>>12,E[c++]=128|(l&4032)>>>6,E[c++]=128|(l&63)>>>0):(E[c++]=240|(l&1835008)>>>18,E[c++]=128|(l&258048)>>>12,E[c++]=128|(l&4032)>>>6,E[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,E[0]=E[64+0],E[1]=E[64+1],E[2]=E[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),o(this._h0)+o(this._h1)+o(this._h2)+o(this._h3)+o(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,d(this._buff,this._buffLen),this._buffLen>56&&(this._step(),d(this._buff));const E=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(E/4294967296),!1),this._buffDV.setUint32(60,E%4294967296,!1),this._step()}_step(){const E=v._bigBlock32,c=this._buffDV;for(let _=0;_<64;_+=4)E.setUint32(_,c.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)E.setUint32(_,h(E.getUint32(_-12,!1)^E.getUint32(_-32,!1)^E.getUint32(_-56,!1)^E.getUint32(_-64,!1),1),!1);let l=this._h0,f=this._h1,t=this._h2,n=this._h3,a=this._h4,s,u,g;for(let _=0;_<80;_++)_<20?(s=f&t|~f&n,u=1518500249):_<40?(s=f^t^n,u=1859775393):_<60?(s=f&t|f&n|t&n,u=2400959708):(s=f^t^n,u=3395469782),g=h(l,5)+s+a+u+E.getUint32(_*4,!1)&4294967295,a=n,n=t,t=h(f,30),f=l,l=g;this._h0=this._h0+l&4294967295,this._h1=this._h1+f&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+a&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ve[47],be([0,1,8]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(k||(k={})),function(P){const T="error",y="warning",D="warn",S="info",C="ignore";function i(h){return h?b.equalsIgnoreCase(T,h)?P.Error:b.equalsIgnoreCase(y,h)||b.equalsIgnoreCase(D,h)?P.Warning:b.equalsIgnoreCase(S,h)?P.Info:P.Ignore:P.Ignore}P.fromValue=i;function I(h){switch(h){case P.Error:return T;case P.Warning:return y;case P.Info:return S;default:return C}}P.toString=I}(k||(k={})),e.default=k}),define(ve[10],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function b(_){return Array.isArray(_)}e.isArray=b;function k(_){return typeof _=="string"}e.isString=k;function P(_){return Array.isArray(_)&&_.every(A=>k(A))}e.isStringArray=P;function T(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}e.isObject=T;function y(_){return typeof _=="number"&&!isNaN(_)}e.isNumber=y;function D(_){return!!_&&typeof _[Symbol.iterator]=="function"}e.isIterable=D;function S(_){return _===!0||_===!1}e.isBoolean=S;function C(_){return typeof _=="undefined"}e.isUndefined=C;function i(_){return!I(_)}e.isDefined=i;function I(_){return C(_)||_===null}e.isUndefinedOrNull=I;function h(_,A){if(!_)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=h;function d(_){if(I(_))throw new Error("Assertion Failed: argument is undefined or null");return _}e.assertIsDefined=d;function r(..._){const A=[];for(let m=0;m<_.length;m++){const w=_[m];if(I(w))throw new Error(`Assertion Failed: argument at index ${m} is undefined or null`);A.push(w)}return A}e.assertAllDefined=r;const o=Object.prototype.hasOwnProperty;function v(_){if(!T(_))return!1;for(let A in _)if(o.call(_,A))return!1;return!0}e.isEmptyObject=v;function p(_){return typeof _=="function"}e.isFunction=p;function E(..._){return _.length>0&&_.every(p)}e.areFunctions=E;function c(_,A){const m=Math.min(_.length,A.length);for(let w=0;w<m;w++)l(_[w],A[w])}e.validateConstraints=c;function l(_,A){if(k(A)){if(typeof _!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(p(A)){try{if(_ instanceof A)return}catch(m){}if(!I(_)&&_.constructor===A||A.length===1&&A.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function f(_){let A=[],m=Object.getPrototypeOf(_);for(;Object.prototype!==m;)A=A.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return A}e.getAllPropertyNames=f;function t(_){const A=[];for(const m of f(_))typeof _[m]=="function"&&A.push(m);return A}e.getAllMethodNames=t;function n(_,A){const m=R=>function(){const $=Array.prototype.slice.call(arguments,0);return A(R,$)};let w={};for(const R of _)w[R]=m(R);return w}e.createProxyObject=n;function a(_){return _===null?void 0:_}e.withNullAsUndefined=a;function s(_){return typeof _=="undefined"?null:_}e.withUndefinedAsNull=s;function u(_){return class{constructor(){return new Proxy({},{get(A,m){if(A[m])return A[m];throw new Error(`Not Implemented: ${_}->${String(m)}`)}})}}}e.NotImplementedProxy=u;function g(_){throw new Error("Unreachable")}e.assertNever=g}),define(ve[37],be([0,1,21,8,14,10]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function y(n){return n===47||n===92}e.isPathSeparator=y;function D(n){return n.replace(/[\\/]/g,P.posix.sep)}e.toSlashes=D;function S(n,a=P.posix.sep){if(!n)return"";const s=n.length,u=n.charCodeAt(0);if(y(u)){if(y(n.charCodeAt(1))&&!y(n.charCodeAt(2))){let _=3;const A=_;for(;_<s&&!y(n.charCodeAt(_));_++);if(A!==_&&!y(n.charCodeAt(_+1))){for(_+=1;_<s;_++)if(y(n.charCodeAt(_)))return n.slice(0,_+1).replace(/[\\/]/g,a)}}return a}else if(v(u)&&n.charCodeAt(1)===58)return y(n.charCodeAt(2))?n.slice(0,2)+a:n.slice(0,2);let g=n.indexOf("://");if(g!==-1){for(g+=3;g<s;g++)if(y(n.charCodeAt(g)))return n.slice(0,g+1)}return""}e.getRoot=S;function C(n){if(!b.isWindows||!n||n.length<5)return!1;let a=n.charCodeAt(0);if(a!==92||(a=n.charCodeAt(1),a!==92))return!1;let s=2;const u=s;for(;s<n.length&&(a=n.charCodeAt(s),a!==92);s++);return!(u===s||(a=n.charCodeAt(s+1),isNaN(a)||a===92))}e.isUNC=C;const i=/[\\/:\*\?"<>\|]/g,I=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(n,a=b.isWindows){const s=a?i:I;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||a&&h.test(n)||n==="."||n===".."||a&&n[n.length-1]==="."||a&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=d;function r(n,a,s){const u=n===a;return!s||u?u:!n||!a?!1:(0,k.equalsIgnoreCase)(n,a)}e.isEqual=r;function o(n,a,s,u=P.sep){if(n===a)return!0;if(!n||!a||a.length>n.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(n,a))return!1;if(a.length===n.length)return!0;let _=a.length;return a.charAt(a.length-1)===u&&_--,n.charAt(_)===u}return a.charAt(a.length-1)!==u&&(a+=u),n.indexOf(a)===0}e.isEqualOrParent=o;function v(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=v;function p(n,a){return b.isWindows&&n.endsWith(":")&&(n+=P.sep),(0,P.isAbsolute)(n)||(n=(0,P.join)(a,n)),n=(0,P.normalize)(n),b.isWindows?(n=(0,k.rtrim)(n,P.sep),n.endsWith(":")&&(n+=P.sep)):(n=(0,k.rtrim)(n,P.sep),n||(n=P.sep)),n}e.sanitizeFilePath=p;function E(n){const a=(0,P.normalize)(n);return b.isWindows?n.length>3?!1:c(a)&&(n.length===2||a.charCodeAt(2)===92):a===P.posix.sep}e.isRootOrDriveLetter=E;function c(n){return b.isWindows?v(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(n){return c(n)?n[0]:void 0}e.getDriveLetter=l;function f(n,a,s){return a.length>n.length?-1:n===a?0:(s&&(n=n.toLowerCase(),a=a.toLowerCase()),n.indexOf(a))}e.indexOfPath=f;function t(n){const a=n.split(":");let s,u,g;if(a.forEach(_=>{const A=Number(_);(0,T.isNumber)(A)?u===void 0?u=A:g===void 0&&(g=A):s=s?[s,_].join(":"):_}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:u!==void 0?u:void 0,column:g!==void 0?g:u!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(ve[23],be([0,1,10]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const v=Array.isArray(o)?[]:{};return Object.keys(o).forEach(p=>{o[p]&&typeof o[p]=="object"?v[p]=k(o[p]):v[p]=o[p]}),v}e.deepClone=k;function P(o){if(!o||typeof o!="object")return o;const v=[o];for(;v.length>0;){const p=v.shift();Object.freeze(p);for(const E in p)if(T.call(p,E)){const c=p[E];typeof c=="object"&&!Object.isFrozen(c)&&v.push(c)}}return o}e.deepFreeze=P;const T=Object.prototype.hasOwnProperty;function y(o,v){return D(o,v,new Set)}e.cloneAndChange=y;function D(o,v,p){if((0,b.isUndefinedOrNull)(o))return o;const E=v(o);if(typeof E!="undefined")return E;if((0,b.isArray)(o)){const c=[];for(const l of o)c.push(D(l,v,p));return c}if((0,b.isObject)(o)){if(p.has(o))throw new Error("Cannot clone recursive data-structure");p.add(o);const c={};for(let l in o)T.call(o,l)&&(c[l]=D(o[l],v,p));return p.delete(o),c}return o}function S(o,v,p=!0){return(0,b.isObject)(o)?((0,b.isObject)(v)&&Object.keys(v).forEach(E=>{E in o?p&&((0,b.isObject)(o[E])&&(0,b.isObject)(v[E])?S(o[E],v[E],p):o[E]=v[E]):o[E]=v[E]}),o):v}e.mixin=S;function C(o,v){if(o===v)return!0;if(o==null||v===null||v===void 0||typeof o!=typeof v||typeof o!="object"||Array.isArray(o)!==Array.isArray(v))return!1;let p,E;if(Array.isArray(o)){if(o.length!==v.length)return!1;for(p=0;p<o.length;p++)if(!C(o[p],v[p]))return!1}else{const c=[];for(E in o)c.push(E);c.sort();const l=[];for(E in v)l.push(E);if(l.sort(),!C(c,l))return!1;for(p=0;p<c.length;p++)if(!C(o[c[p]],v[c[p]]))return!1}return!0}e.equals=C;function i(o){const v=new Set;return JSON.stringify(o,(p,E)=>{if((0,b.isObject)(E)||Array.isArray(E)){if(v.has(E))return"[Circular]";v.add(E)}return E})}e.safeStringify=i;function I(o,v,p){const E=v(o);return typeof E=="undefined"?p:E}e.getOrDefault=I;function h(o,v){const p=Object.create(null);return!o||!v||Object.keys(v).forEach(c=>{const l=o[c],f=v[c];C(l,f)||(p[c]=f)}),p}e.distinct=h;function d(o,v){const p=v.toLowerCase(),E=Object.keys(o).find(c=>c.toLowerCase()===p);return E?o[E]:o[v]}e.getCaseInsensitive=d;function r(o,v){const p=Object.create(null);for(const E of Object.keys(o))v(E,o[E])&&(p[E]=o[E]);return p}e.filter=r}),define(ve[82],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var b;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(b=e.Constants||(e.Constants={}));function k(T){return T<0?0:T>255?255:T|0}e.toUint8=k;function P(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=P}),define(ve[2],be([0,1,21,14]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const P=/^\w[\w\d+.-]*$/,T=/^\//,y=/^\/\//;function D(a,s){if(!a.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${a.authority}", path: "${a.path}", query: "${a.query}", fragment: "${a.fragment}"}`);if(a.scheme&&!P.test(a.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(a.path){if(a.authority){if(!T.test(a.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(a.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(a,s){return!a&&!s?"file":a}function C(a,s){switch(a){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const i="",I="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{constructor(s,u,g,_,A,m=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=S(s,m),this.authority=u||i,this.path=C(this.scheme,g||i),this.query=_||i,this.fragment=A||i,D(this,m))}static isUri(s){return s instanceof d?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return c(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:g,path:_,query:A,fragment:m}=s;return u===void 0?u=this.scheme:u===null&&(u=i),g===void 0?g=this.authority:g===null&&(g=i),_===void 0?_=this.path:_===null&&(_=i),A===void 0?A=this.query:A===null&&(A=i),m===void 0?m=this.fragment:m===null&&(m=i),u===this.scheme&&g===this.authority&&_===this.path&&A===this.query&&m===this.fragment?this:new o(u,g,_,A,m)}static parse(s,u=!1){const g=h.exec(s);return g?new o(g[2]||i,n(g[4]||i),n(g[5]||i),n(g[7]||i),n(g[9]||i),u):new o(i,i,i,i,i)}static file(s){let u=i;if(b.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const g=s.indexOf(I,2);g===-1?(u=s.substring(2),s=I):(u=s.substring(2,g),s=s.substring(g)||I)}return new o("file",u,s,i,i)}static from(s){return new o(s.scheme,s.authority,s.path,s.query,s.fragment)}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return b.isWindows&&s.scheme==="file"?g=d.file(k.win32.join(c(s,!0),...u)).path:g=k.posix.join(s.path,...u),s.with({path:g})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof d)return s;{const u=new o(s);return u._formatted=s.external,u._fsPath=s._sep===r?s.fsPath:null,u}}else return s}}e.URI=d;const r=b.isWindows?1:void 0;class o extends d{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=r),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(a,s){let u,g=-1;for(let _=0;_<a.length;_++){const A=a.charCodeAt(_);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||s&&A===47)g!==-1&&(u+=encodeURIComponent(a.substring(g,_)),g=-1),u!==void 0&&(u+=a.charAt(_));else{u===void 0&&(u=a.substr(0,_));const m=v[A];m!==void 0?(g!==-1&&(u+=encodeURIComponent(a.substring(g,_)),g=-1),u+=m):g===-1&&(g=_)}}return g!==-1&&(u+=encodeURIComponent(a.substring(g))),u!==void 0?u:a}function E(a){let s;for(let u=0;u<a.length;u++){const g=a.charCodeAt(u);g===35||g===63?(s===void 0&&(s=a.substr(0,u)),s+=v[g]):s!==void 0&&(s+=a[u])}return s!==void 0?s:a}function c(a,s){let u;return a.authority&&a.path.length>1&&a.scheme==="file"?u=`//${a.authority}${a.path}`:a.path.charCodeAt(0)===47&&(a.path.charCodeAt(1)>=65&&a.path.charCodeAt(1)<=90||a.path.charCodeAt(1)>=97&&a.path.charCodeAt(1)<=122)&&a.path.charCodeAt(2)===58?s?u=a.path.substr(1):u=a.path[1].toLowerCase()+a.path.substr(2):u=a.path,b.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=c;function l(a,s){const u=s?E:p;let g="",{scheme:_,authority:A,path:m,query:w,fragment:R}=a;if(_&&(g+=_,g+=":"),(A||_==="file")&&(g+=I,g+=I),A){let $=A.indexOf("@");if($!==-1){const K=A.substr(0,$);A=A.substr($+1),$=K.indexOf(":"),$===-1?g+=u(K,!1):(g+=u(K.substr(0,$),!1),g+=":",g+=u(K.substr($+1),!1)),g+="@"}A=A.toLowerCase(),$=A.indexOf(":"),$===-1?g+=u(A,!1):(g+=u(A.substr(0,$),!1),g+=A.substr($))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const $=m.charCodeAt(1);$>=65&&$<=90&&(m=`/${String.fromCharCode($+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const $=m.charCodeAt(0);$>=65&&$<=90&&(m=`${String.fromCharCode($+32)}:${m.substr(2)}`)}g+=u(m,!0)}return w&&(g+="?",g+=u(w,!1)),R&&(g+="#",g+=s?R:p(R,!1)),g}function f(a){try{return decodeURIComponent(a)}catch(s){return a.length>3?a.substr(0,3)+f(a.substr(3)):a}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(a){return a.match(t)?a.replace(t,s=>f(s)):a}});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[22],be([0,1,2,8]),function(J,e,b,k){"use strict";var P,T,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,n,a){let s=t.get(n);return s===void 0&&(s=a,t.set(n,s)),s}e.getOrSet=D;function S(t){const n=[];return t.forEach((a,s)=>{n.push(`${s} => ${a}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=S;function C(t){const n=[];return t.forEach(a=>{n.push(a)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=C;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const a=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return a-s}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class h{constructor(n=!0,a=!0){this._splitOnBackslash=n,this._caseSensitive=a}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,k.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=h;var d;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(d||(d={}));class r{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new h(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,k.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=r;class o{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(n){this._iter=n}static forUris(n=()=>!1){return new v(new r(n))}static forPaths(){return new v(new h)}static forStrings(){return new v(new i)}static forConfigKeys(){return new v(new I)}clear(){this._root=void 0}set(n,a){const s=this._iter.reset(n);let u;for(this._root||(this._root=new o,this._root.segment=s.value()),u=this._root;;){const _=s.cmp(u.segment);if(_>0)u.left||(u.left=new o,u.left.segment=s.value()),u=u.left;else if(_<0)u.right||(u.right=new o,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new o,u.mid.segment=s.value()),u=u.mid;else break}const g=u.value;return u.value=a,u.key=n,g}get(n){var a;return(a=this._getNode(n))===null||a===void 0?void 0:a.value}_getNode(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else break}return s}has(n){const a=this._getNode(n);return!((a==null?void 0:a.value)===void 0&&(a==null?void 0:a.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,a){const s=this._iter.reset(n),u=[];let g=this._root;for(;g;){const _=s.cmp(g.segment);if(_>0)u.push([1,g]),g=g.left;else if(_<0)u.push([-1,g]),g=g.right;else if(s.hasNext())s.next(),u.push([0,g]),g=g.mid;else{for(a?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;u.length>0&&g.isEmpty();){let[A,m]=u.pop();switch(A){case 1:m.left=void 0;break;case 0:m.mid=void 0;break;case-1:m.right=void 0;break}g=m}break}}}findSubstr(n){const a=this._iter.reset(n);let s=this._root,u;for(;s;){const g=a.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(a.hasNext())a.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(n){const a=this._iter.reset(n);let s=this._root;for(;s;){const u=a.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[a,s]of this)n(s,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=v;class p{constructor(n,a){this[P]="ResourceMap",n instanceof p?(this.map=new Map(n.map),this.toKey=a!=null?a:p.defaultToKey):(this.map=new Map,this.toKey=n!=null?n:p.defaultToKey)}set(n,a){return this.map.set(this.toKey(n),a),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,a){typeof a!="undefined"&&(n=n.bind(a));for(let[s,u]of this.map)n(u,b.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield b.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[b.URI.parse(n[0]),n[1]]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[b.URI.parse(n[0]),n[1]]}}e.ResourceMap=p,p.defaultToKey=t=>t.toString();var E;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(E=e.Touch||(e.Touch={}));class c{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,a=0){const s=this._map.get(n);if(!!s)return a!==0&&this.touch(s,a),s.value}set(n,a,s=0){let u=this._map.get(n);if(u)u.value=a,s!==0&&this.touch(u,s);else{switch(u={key:n,value:a,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this._map.get(n);if(!!a)return this._map.delete(n),this.removeItem(a),this._size--,a.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}}forEach(n,a){const s=this._state;let u=this._head;for(;u;){if(a?n.bind(a)(u.value,u.key,this):n(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.key,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}values(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.value,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}entries(){const n=this,a=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==a)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:[s.key,s.value],done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(!(n>=this.size)){if(n===0){this.clear();return}let a=this._head,s=this.size;for(;a&&s>n;)this._map.delete(a.key),a=a.next,s--;this._head=a,this._size=s,a&&(a.previous=void 0),this._state++}}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const a=n.next,s=n.previous;if(!a||!s)throw new Error("Invalid list");a.previous=s,s.next=a}n.next=void 0,n.previous=void 0,this._state++}touch(n,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this._head)return;const s=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(a===2){if(n===this._tail)return;const s=n.next,u=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((a,s)=>{n.push([s,a])}),n}fromJSON(n){this.clear();for(const[a,s]of n)this.set(a,s)}}e.LinkedMap=c;class l extends c{constructor(n,a=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class f{constructor(n){y.set(this,void 0),it(this,y,n,"f")}get size(){return Ue(this,y,"f").size}forEach(n,a){Ue(this,y,"f").forEach(n,a)}get(n){return Ue(this,y,"f").get(n)}has(n){return Ue(this,y,"f").has(n)}entries(){return Ue(this,y,"f").entries()}keys(){return Ue(this,y,"f").keys()}values(){return Ue(this,y,"f").values()}[(y=new WeakMap,Symbol.iterator)](){return Ue(this,y,"f").entries()}}e.ReadonlyMapView=f}),define(ve[110],be([0,1,22,8]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function P(...fe){return function(De,Re){for(let He=0,we=fe.length;He<we;He++){const qe=fe[He](De,Re);if(qe)return qe}return null}}e.or=P,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(fe,De,Re){if(!Re||Re.length<De.length)return null;let He;return fe?He=k.startsWithIgnoreCase(Re,De):He=Re.indexOf(De)===0,He?De.length>0?[{start:0,end:De.length}]:[]:null}function y(fe,De){const Re=De.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}e.matchesContiguousSubString=y;function D(fe,De){return S(fe.toLowerCase(),De.toLowerCase(),0,0)}e.matchesSubString=D;function S(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]===De[He]){let we=null;return(we=S(fe,De,Re+1,He+1))?p({start:He,end:He+1},we):null}return S(fe,De,Re,He+1)}function C(fe){return 97<=fe&&fe<=122}function i(fe){return 65<=fe&&fe<=90}e.isUpper=i;function I(fe){return 48<=fe&&fe<=57}function h(fe){return fe===32||fe===9||fe===10||fe===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(fe=>d.add(fe.charCodeAt(0)));function r(fe){return h(fe)||d.has(fe)}function o(fe,De){return fe===De||r(fe)&&r(De)}function v(fe){return C(fe)||i(fe)||I(fe)}function p(fe,De){return De.length===0?De=[fe]:fe.end===De[0].start?De[0].start=fe.start:De.unshift(fe),De}function E(fe,De){for(let Re=De;Re<fe.length;Re++){const He=fe.charCodeAt(Re);if(i(He)||I(He)||Re>0&&!v(fe.charCodeAt(Re-1)))return Re}return fe.length}function c(fe,De,Re,He){if(Re===fe.length)return[];if(He===De.length)return null;if(fe[Re]!==De[He].toLowerCase())return null;{let we=null,qe=He+1;for(we=c(fe,De,Re+1,He+1);!we&&(qe=E(De,qe))<De.length;)we=c(fe,De,Re+1,qe),qe++;return we===null?null:p({start:He,end:He+1},we)}}function l(fe){let De=0,Re=0,He=0,we=0,qe=0;for(let Ve=0;Ve<fe.length;Ve++)qe=fe.charCodeAt(Ve),i(qe)&&De++,C(qe)&&Re++,v(qe)&&He++,I(qe)&&we++;const z=De/fe.length,ee=Re/fe.length,ge=He/fe.length,Ne=we/fe.length;return{upperPercent:z,lowerPercent:ee,alphaPercent:ge,numericPercent:Ne}}function f(fe){const{upperPercent:De,lowerPercent:Re}=fe;return Re===0&&De>.6}function t(fe){const{upperPercent:De,lowerPercent:Re,alphaPercent:He,numericPercent:we}=fe;return Re>.2&&De<.8&&He>.6&&we<.2}function n(fe){let De=0,Re=0,He=0,we=0;for(let qe=0;qe<fe.length;qe++)He=fe.charCodeAt(qe),i(He)&&De++,C(He)&&Re++,h(He)&&we++;return(De===0||Re===0)&&we===0?fe.length<=30:De<=5}function a(fe,De){if(!De||(De=De.trim(),De.length===0)||!n(fe)||De.length>60)return null;const Re=l(De);if(!t(Re)){if(!f(Re))return null;De=De.toLowerCase()}let He=null,we=0;for(fe=fe.toLowerCase();we<De.length&&(He=c(fe,De,0,we))===null;)we=E(De,we+1);return He}e.matchesCamelCase=a;function s(fe,De,Re=!1){if(!De||De.length===0)return null;let He=null,we=0;for(fe=fe.toLowerCase(),De=De.toLowerCase();we<De.length&&(He=u(fe,De,0,we,Re))===null;)we=g(De,we+1);return He}e.matchesWords=s;function u(fe,De,Re,He,we){if(Re===fe.length)return[];if(He===De.length)return null;if(o(fe.charCodeAt(Re),De.charCodeAt(He))){let qe=null,z=He+1;if(qe=u(fe,De,Re+1,He+1,we),!we)for(;!qe&&(z=g(De,z))<De.length;)qe=u(fe,De,Re+1,z,we),z++;return qe===null?null:p({start:He,end:He+1},qe)}else return null}function g(fe,De){for(let Re=De;Re<fe.length;Re++)if(r(fe.charCodeAt(Re))||Re>0&&r(fe.charCodeAt(Re-1)))return Re;return fe.length}const _=P(e.matchesPrefix,a,y),A=P(e.matchesPrefix,a,D),m=new b.LRUCache(1e4);function w(fe,De,Re=!1){if(typeof fe!="string"||typeof De!="string")return null;let He=m.get(fe);He||(He=new RegExp(k.convertSimple2RegExpPattern(fe),"i"),m.set(fe,He));const we=He.exec(De);return we?[{start:we.index,end:we.index+we[0].length}]:Re?A(fe,De):_(fe,De)}e.matchesFuzzy=w;function R(fe,De){const Re=W(fe,fe.toLowerCase(),0,De,De.toLowerCase(),0,!0);return Re?K(Re):null}e.matchesFuzzy2=R;function $(fe,De,Re,He,we,qe){const z=Math.min(13,fe.length);for(;Re<z;Re++){const ee=W(fe,De,Re,He,we,qe,!1);if(ee)return ee}return[0,qe]}e.anyScore=$;function K(fe){if(typeof fe=="undefined")return[];const De=[],Re=fe[1];for(let He=fe.length-1;He>1;He--){const we=fe[He]+Re,qe=De[De.length-1];qe&&qe.end===we?qe.end=we+1:De.push({start:we,end:we+1})}return De}e.createMatches=K;const he=128;function V(){const fe=[],De=[];for(let Re=0;Re<=he;Re++)De[Re]=0;for(let Re=0;Re<=he;Re++)fe.push(De.slice(0));return fe}function H(fe){const De=[];for(let Re=0;Re<=fe;Re++)De[Re]=0;return De}const Y=H(2*he),U=H(2*he),F=V(),L=V(),M=V(),x=!1;function G(fe,De,Re,He,we){function qe(ee,ge,Ne=" "){for(;ee.length<ge;)ee=Ne+ee;return ee}let z=` |   |${He.split("").map(ee=>qe(ee,3)).join("|")}
`;for(let ee=0;ee<=Re;ee++)ee===0?z+=" |":z+=`${De[ee-1]}|`,z+=fe[ee].slice(0,we+1).map(ge=>qe(ge.toString(),3)).join("|")+`
`;return z}function X(fe,De,Re,He){fe=fe.substr(De),Re=Re.substr(He),console.log(G(L,fe,fe.length,Re,Re.length)),console.log(G(M,fe,fe.length,Re,Re.length)),console.log(G(F,fe,fe.length,Re,Re.length))}function ne(fe,De){if(De<0||De>=fe.length)return!1;const Re=fe.codePointAt(De);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(Re)}}function me(fe,De){if(De<0||De>=fe.length)return!1;switch(fe.charCodeAt(De)){case 32:case 9:return!0;default:return!1}}function Le(fe,De,Re){return De[fe]!==Re[fe]}function We(fe,De,Re,He,we,qe,z=!1){for(;De<Re&&we<qe;)fe[De]===He[we]&&(z&&(Y[De]=we),De+=1),we+=1;return De===Re}e.isPatternInWord=We;var Fe;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var ze;(function(fe){fe.Default=[-100,0];function De(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=De})(ze=e.FuzzyScore||(e.FuzzyScore={}));function W(fe,De,Re,He,we,qe,z){const ee=fe.length>he?he:fe.length,ge=He.length>he?he:He.length;if(!(Re>=ee||qe>=ge||ee-Re>ge-qe)&&!!We(De,Re,ee,we,qe,ge,!0)){j(ee,ge,Re,qe,De,we);let Ne=1,Ve=1,$e=Re,Ze=qe;const ye=[!1];for(Ne=1,$e=Re;$e<ee;Ne++,$e++){const N=Y[$e],Q=U[$e],ae=$e+1<ee?U[$e+1]:ge;for(Ve=N-qe+1,Ze=N;Ze<ae;Ve++,Ze++){let ke=Number.MIN_SAFE_INTEGER,Ie=!1;Ze<=Q&&(ke=te(fe,De,$e,Re,He,we,Ze,ge,qe,F[Ne-1][Ve-1]===0,ye));let Ae=0;ke!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ae=ke+L[Ne-1][Ve-1]);const xe=Ze>N,Ye=xe?L[Ne][Ve-1]+(F[Ne][Ve-1]>0?-5:0):0,rt=Ze>N+1&&F[Ne][Ve-1]>0,tt=rt?L[Ne][Ve-2]+(F[Ne][Ve-2]>0?-5:0):0;if(rt&&(!xe||tt>=Ye)&&(!Ie||tt>=Ae))L[Ne][Ve]=tt,M[Ne][Ve]=3,F[Ne][Ve]=0;else if(xe&&(!Ie||Ye>=Ae))L[Ne][Ve]=Ye,M[Ne][Ve]=2,F[Ne][Ve]=0;else if(Ie)L[Ne][Ve]=Ae,M[Ne][Ve]=1,F[Ne][Ve]=F[Ne-1][Ve-1]+1;else throw new Error("not possible")}}if(x&&X(fe,Re,He,qe),!(!ye[0]&&!z)){Ne--,Ve--;const Ee=[L[Ne][Ve],qe];let Ce=0,re=0;for(;Ne>=1;){let N=Ve;do{const Q=M[Ne][N];if(Q===3)N=N-2;else if(Q===2)N=N-1;else break}while(N>=1);Ce>1&&De[Re+Ne-1]===we[qe+Ve-1]&&!Le(N+qe-1,He,we)&&Ce+1>F[Ne][N]&&(N=Ve),N===Ve?Ce++:Ce=1,re||(re=N),Ne--,Ve=N-1,Ee.push(Ve)}ge===ee&&(Ee[0]+=2);const le=re-ee;return Ee[0]-=le,Ee}}}e.fuzzyScore=W;function j(fe,De,Re,He,we,qe){let z=fe-1,ee=De-1;for(;z>=Re&&ee>=He;)we[z]===qe[ee]&&(U[z]=ee,z--),ee--}function te(fe,De,Re,He,we,qe,z,ee,ge,Ne,Ve){if(De[Re]!==qe[z])return Number.MIN_SAFE_INTEGER;let $e=1,Ze=!1;return z===Re-He?$e=fe[Re]===we[z]?7:5:Le(z,we,qe)&&(z===0||!Le(z-1,we,qe))?($e=fe[Re]===we[z]?7:5,Ze=!0):ne(qe,z)&&(z===0||!ne(qe,z-1))?$e=5:(ne(qe,z-1)||me(qe,z-1))&&($e=5,Ze=!0),$e>1&&Re===He&&(Ve[0]=!0),Ze||(Ze=Le(z,we,qe)||ne(qe,z-1)||me(qe,z-1)),Re===He?z>ge&&($e-=Ze?3:5):Ne?$e+=Ze?2:0:$e+=Ze?0:1,z+1===ee&&($e-=Ze?3:5),$e}function oe(fe,De,Re,He,we,qe,z){return _e(fe,De,Re,He,we,qe,!0,z)}e.fuzzyScoreGracefulAggressive=oe;function de(fe,De,Re,He,we,qe,z){return _e(fe,De,Re,He,we,qe,!1,z)}e.fuzzyScoreGraceful=de;function _e(fe,De,Re,He,we,qe,z,ee){let ge=W(fe,De,Re,He,we,qe,ee);if(ge&&!z)return ge;if(fe.length>=3){const Ne=Math.min(7,fe.length-1);for(let Ve=Re+1;Ve<Ne;Ve++){const $e=Be(fe,Ve);if($e){const Ze=W($e,$e.toLowerCase(),Re,He,we,qe,ee);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function Be(fe,De){if(!(De+1>=fe.length)){const Re=fe[De],He=fe[De+1];if(Re!==He)return fe.slice(0,De)+He+Re+fe.slice(De+2)}}}),define(ve[111],be([0,1,36,110,8]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${b.CSSIcon.iconNameExpression}(?:${b.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${T.source}`,"g");function D(o){return o.replace(y,(v,p)=>p?v:`\\${v}`)}e.escapeIcons=D;const S=new RegExp(`\\\\${T.source}`,"g");function C(o){return o.replace(S,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=C;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function I(o){return o.indexOf(e.iconStartMarker)===-1?o:o.replace(i,(v,p,E,c)=>E?v:p||c||"")}e.stripIcons=I;function h(o){const v=o.indexOf(e.iconStartMarker);return v===-1?{text:o}:d(o,v)}e.parseLabelWithIcons=h;function d(o,v){const p=[];let E="";function c(g){if(g){E+=g;for(const _ of g)p.push(t)}}let l=-1,f="",t=0,n,a,s=v;const u=o.length;for(c(o.substr(0,v));s<u;)n=o[s],a=o[s+1],n===e.iconStartMarker[0]&&a===e.iconStartMarker[1]?(l=s,c(f),f=e.iconStartMarker,s++):n===")"&&l!==-1?(t+=s-l+1,l=-1,f=""):l!==-1?/^[a-z0-9\-]$/i.test(n)?f+=n:(c(f),l=-1,f=""):c(n),s++;return c(f),{text:E,iconOffsets:p}}function r(o,v,p=!1){const{text:E,iconOffsets:c}=v;if(!c||c.length===0)return(0,k.matchesFuzzy)(o,E,p);const l=(0,P.ltrim)(E," "),f=E.length-l.length,t=(0,k.matchesFuzzy)(o,l,p);if(t)for(const n of t){const a=c[n.start+f]+f;n.start+=a,n.end+=a}return t}e.matchesFuzzyIconAware=r}),define(ve[83],be([0,1,13,111,12]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(o="",v=!1){var p,E;if(this.value=o,typeof this.value!="string")throw(0,P.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1):(this.isTrusted=(p=v.isTrusted)!==null&&p!==void 0?p:void 0,this.supportThemeIcons=(E=v.supportThemeIcons)!==null&&E!==void 0?E:!1)}appendText(o,v=0){return this.value+=I(this.supportThemeIcons?(0,k.escapeIcons)(o):o).replace(/([ \t]+)/g,(p,E)=>"&nbsp;".repeat(E.length)).replace(/^>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,v){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}}e.MarkdownString=y;function D(r){return S(r)?!r.value:Array.isArray(r)?r.every(D):!0}e.isEmptyMarkdownString=D;function S(r){return r instanceof y?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=S;function C(r,o){return!r&&!o?!0:!r||!o?!1:Array.isArray(r)&&Array.isArray(o)?(0,b.equals)(r,o,i):S(r)&&S(o)?i(r,o):!1}e.markedStringsEquals=C;function i(r,o){return r===o?!0:!r||!o?!1:r.value===o.value&&r.isTrusted===o.isTrusted&&r.supportThemeIcons===o.supportThemeIcons}function I(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function h(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=h;function d(r){const o=[],v=r.split("|").map(E=>E.trim());r=v[0];const p=v[1];if(p){const E=/height=(\d+)/.exec(p),c=/width=(\d+)/.exec(p),l=E?E[1]:"",f=c?c[1]:"",t=isFinite(parseInt(f)),n=isFinite(parseInt(l));t&&o.push(`width="${f}"`),n&&o.push(`height="${l}"`)}return{href:r,dimensions:o}}e.parseHrefAndDimensions=d}),define(ve[57],be([0,1,24,8,2]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(C){return JSON.stringify(C,D)}e.stringify=T;function y(C){let i=JSON.parse(C);return i=S(i),i}e.parse=y;function D(C,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,k.regExpFlags)(i)}:i}function S(C,i=0){if(!C||i>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return P.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof b.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=S(C[I],i+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=S(C[I],i+1))}return C}e.revive=S}),define(ve[19],be([0,1,2,21]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var P;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(P=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,C,i){this._hosts[S]=C,this._ports[S]=i}setConnectionToken(S,C){this._connectionTokens[S]=C}rewrite(S){if(this._delegate)return this._delegate(S);const C=S.authority;let i=this._hosts[C];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[C],h=this._connectionTokens[C];let d=`path=${encodeURIComponent(S.path)}`;return typeof h=="string"&&(d+=`&tkn=${encodeURIComponent(h)}`),b.URI.from({scheme:k.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new T;class y{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,C,i){const I=this.toUri(S,C);return I.scheme===P.vscodeRemote?e.RemoteAuthorities.rewrite(I):k.isNative&&(i||k.isPreferringBrowserCodeLoad)&&I.scheme===P.file?I.with({scheme:P.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(S,C){const i=this.toUri(S,C);return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(S,C){return b.URI.isUri(S)?S:b.URI.parse(C.toUrl(S))}}e.FileAccess=new y}),define(ve[25],be([0,1,37,14,2,8,19,21]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=S;class C{constructor(r){this._ignorePathCasing=r}compare(r,o,v=!1){return r===o?0:(0,T.compare)(this.getComparisonKey(r,v),this.getComparisonKey(o,v))}isEqual(r,o,v=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,v)===this.getComparisonKey(o,v)}getComparisonKey(r,o=!1){return r.with({path:this._ignorePathCasing(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this._ignorePathCasing(r)}isEqualOrParent(r,o,v=!1){if(r.scheme===o.scheme){if(r.scheme===y.Schemas.file)return b.isEqualOrParent(S(r),S(o),this._ignorePathCasing(r))&&r.query===o.query&&(v||r.fragment===o.fragment);if((0,e.isEqualAuthority)(r.authority,o.authority))return b.isEqualOrParent(r.path,o.path,this._ignorePathCasing(r),"/")&&r.query===o.query&&(v||r.fragment===o.fragment)}return!1}joinPath(r,...o){return P.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.basename)(r)||r.authority}basename(r){return k.posix.basename(r.path)}extname(r){return k.posix.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===y.Schemas.file?o=P.URI.file(k.dirname(S(r))).path:(o=k.posix.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===y.Schemas.file?o=P.URI.file(k.normalize(S(r))).path:o=k.posix.normalize(r.path),r.with({path:o})}relativePath(r,o){if(!(r.scheme!==o.scheme||!(0,e.isEqualAuthority)(r.authority,o.authority))){if(r.scheme===y.Schemas.file){const E=k.relative(S(r),S(o));return D.isWindows?b.toSlashes(E):E}let v=r.path||"/",p=o.path||"/";if(this._ignorePathCasing(r)){let E=0;for(const c=Math.min(v.length,p.length);E<c&&!(v.charCodeAt(E)!==p.charCodeAt(E)&&v.charAt(E).toLowerCase()!==p.charAt(E).toLowerCase());E++);v=p.substr(0,E)+v.substr(E)}return k.posix.relative(v,p)}}resolvePath(r,o){if(r.scheme===y.Schemas.file){const v=P.URI.file(k.resolve(S(r),o));return r.with({authority:v.authority,path:v.path})}return o.indexOf("/")===-1&&(o=b.toSlashes(o),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o)),r.with({path:k.posix.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||(0,T.equalsIgnoreCase)(r,o)}hasTrailingPathSeparator(r,o=k.sep){if(r.scheme===y.Schemas.file){const v=S(r);return v.length>b.getRoot(v).length&&v[v.length-1]===o}else{const v=r.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=k.sep){return(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=k.sep){let v=!1;if(r.scheme===y.Schemas.file){const p=S(r);v=p!==void 0&&p.length===b.getRoot(p).length&&p[p.length-1]===o}else{o="/";const p=r.path;v=p.length===1&&p.charCodeAt(p.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(r,o)?r.with({path:r.path+"/"}):r}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(d=>d.scheme===y.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(d,r){const o=[];for(let v=0;v<d.length;v++){const p=r(d[v]);d.some((E,c)=>c===v?!1:(0,e.isEqualOrParent)(p,r(E)))||o.push(d[v])}return o}e.distinctParents=i;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(o){const v=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,f]=c.split(":");l&&f&&v.set(l,f)});const E=o.path.substring(0,o.path.indexOf(";"));return E&&v.set(d.META_DATA_MIME,E),v}d.parseMetaData=r})(I=e.DataUri||(e.DataUri={}));function h(d,r,o){if(r){let v=d.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),d.with({scheme:o,authority:r,path:v})}return d.with({scheme:o})}e.toLocalResource=h}),define(ve[11],be([0,1,20,12,3,6,45,25]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(L){return!!L&&typeof L.then=="function"}e.isThenable=S;function C(L){const M=new b.CancellationTokenSource,x=L(M.token),G=new Promise((X,ne)=>{M.token.onCancellationRequested(()=>{ne((0,k.canceled)())}),Promise.resolve(x).then(me=>{M.dispose(),X(me)},me=>{M.dispose(),ne(me)})});return new class{cancel(){M.cancel()}then(X,ne){return G.then(X,ne)}catch(X){return this.then(void 0,X)}finally(X){return G.finally(X)}}}e.createCancelablePromise=C;function i(L,M,x){return Promise.race([L,new Promise(G=>M.onCancellationRequested(()=>G(x)))])}e.raceCancellation=i;async function I(L){let M=-1;const x=L.map((X,ne)=>X.then(me=>(M=ne,me))),G=await Promise.race(x);return L.forEach((X,ne)=>{ne!==M&&X.cancel()}),G}e.raceCancellablePromises=I;function h(L,M,x){let G;const X=setTimeout(()=>{G==null||G(void 0),x==null||x()},M);return Promise.race([L.finally(()=>clearTimeout(X)),new Promise(ne=>G=ne)])}e.raceTimeout=h;function d(L){return new Promise((M,x)=>{const G=L();S(G)?G.then(M,x):M(G)})}e.asPromise=d;class r{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const x=()=>{this.queuedPromise=null;const G=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,G};this.queuedPromise=new Promise(G=>{this.activePromise.then(x,x).then(G)})}return new Promise((x,G)=>{this.queuedPromise.then(x,G)})}return this.activePromise=M(),new Promise((x,G)=>{this.activePromise.then(X=>{this.activePromise=null,x(X)},X=>{this.activePromise=null,G(X)})})}}e.Throttler=r;class o{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=o;class v{constructor(){this.promiseMap=new Map}queue(M,x){var G;const ne=((G=this.promiseMap.get(M))!==null&&G!==void 0?G:Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.promiseMap.get(M)===ne&&this.promiseMap.delete(M)});return this.promiseMap.set(M,ne),ne}}e.SequencerByKey=v;class p{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,x=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((G,X)=>{this.doResolve=G,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const G=this.task;return this.task=null,G()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},x),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,k.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class E{constructor(M){this.delayer=new p(M),this.throttler=new r}trigger(M,x){return this.delayer.trigger(()=>this.throttler.queue(M),x)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class c{constructor(){this._isOpen=!1,this._promise=new Promise((M,x)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function f(L,M){return M?new Promise((x,G)=>{const X=setTimeout(x,L);M.onCancellationRequested(()=>{clearTimeout(X),G((0,k.canceled)())})}):C(x=>f(L,x))}e.timeout=f;function t(L,M=0){const x=setTimeout(L,M);return(0,T.toDisposable)(()=>clearTimeout(x))}e.disposableTimeout=t;function n(L){return L.then(void 0,M=>{})}e.ignoreErrors=n;function a(L){const M=[];let x=0;const G=L.length;function X(){return x<G?L[x++]():null}function ne(me){me!=null&&M.push(me);const Le=X();return Le?Le.then(ne):Promise.resolve(M)}return Promise.resolve(null).then(ne)}e.sequence=a;function s(L,M=G=>!!G,x=null){let G=0;const X=L.length,ne=()=>{if(G>=X)return Promise.resolve(x);const me=L[G++];return Promise.resolve(me()).then(We=>M(We)?Promise.resolve(We):ne())};return ne()}e.first=s;function u(L,M=G=>!!G,x=null){if(L.length===0)return Promise.resolve(x);let G=L.length;const X=()=>{var ne,me;G=-1;for(const Le of L)(me=(ne=Le).cancel)===null||me===void 0||me.call(ne)};return new Promise((ne,me)=>{for(const Le of L)Le.then(We=>{--G>=0&&M(We)?(X(),ne(We)):G===0&&ne(x)}).catch(We=>{--G>=0&&(X(),me(We))})})}e.firstParallel=u;class g{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new P.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise((x,G)=>{this.outstandingPromises.push({factory:M,c:x,e:G}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const x=M.factory();x.then(M.c,M.e),x.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class _ extends g{constructor(){super(1)}}e.Queue=_;class A{constructor(){this.queues=new Map}queueFor(M,x=D.extUri){const G=x.getComparisonKey(M);let X=this.queues.get(G);return X||(X=new _,P.Event.once(X.onFinished)(()=>{X==null||X.dispose(),this.queues.delete(G)}),this.queues.set(G,X)),X}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=A;class m{constructor(M,x){this._token=-1,typeof M=="function"&&typeof x=="number"&&this.setIfNotSet(M,x)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},x)}setIfNotSet(M,x){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},x))}}e.TimeoutTimer=m;class w{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,x){this.cancel(),this._token=setInterval(()=>{M()},x)}}e.IntervalTimer=w;class R{constructor(M,x){this.timeoutToken=-1,this.runner=M,this.timeout=x,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class $ extends R{constructor(M,x){super(M,x);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=$,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const L=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const x=setTimeout(()=>M(L));let G=!1;return{dispose(){G||(G=!0,clearTimeout(x))}}}}else e.runWhenIdle=(L,M)=>{const x=requestIdleCallback(L,typeof M=="number"?{timeout:M}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(x))}}}}();class K{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch(x){this._error=x}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=K;async function he(L,M,x){let G;for(let X=0;X<x;X++)try{return await L()}catch(ne){G=ne,await f(M)}throw G}e.retry=he;class V{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,x,G){return this._pending={taskId:M,cancel:()=>G==null?void 0:G(),promise:x},x.then(()=>this.donePending(M),()=>this.donePending(M)),x}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let x,G;const X=new Promise((ne,me)=>{x=ne,G=me});this._next={run:M,promise:X,promiseResolve:x,promiseReject:G}}return this._next.promise}}e.TaskSequentializer=V;class H{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=H;class Y{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,x)=>{this.completeCallback=M,this.errorCallback=x})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise(x=>{this.completeCallback(M),this.resolved=!0,x()})}error(M){return new Promise(x=>{this.errorCallback(M),this.rejected=!0,x()})}cancel(){new Promise(M=>{this.errorCallback((0,k.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=Y;class U extends P.Emitter{async fireAsync(M,x,G){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new y.LinkedList);for(const X of this._listeners)this._asyncDeliveryQueue.push([X,M]);for(;this._asyncDeliveryQueue.size>0&&!x.isCancellationRequested;){const[X,ne]=this._asyncDeliveryQueue.shift(),me=[],Le=Object.assign(Object.assign({},ne),{waitUntil:We=>{if(Object.isFrozen(me))throw new Error("waitUntil can NOT be called asynchronous");G&&(We=G(We,typeof X=="function"?X:X[0])),me.push(We)}});try{typeof X=="function"?X.call(void 0,Le):X[0].call(X[1],Le)}catch(We){(0,k.onUnexpectedError)(We);continue}Object.freeze(me),await F.settled(me).catch(We=>(0,k.onUnexpectedError)(We))}}}}e.AsyncEmitter=U;var F;(function(L){async function M(ne){return typeof Promise.allSettled=="function"?x(ne):G(ne)}L.allSettled=M;async function x(ne){return Promise.allSettled(ne)}async function G(ne){return Promise.all(ne.map(me=>me.then(Le=>({status:"fulfilled",value:Le}),Le=>({status:"rejected",reason:Le}))))}async function X(ne){let me;const Le=await Promise.all(ne.map(We=>We.then(Fe=>Fe,Fe=>{me||(me=Fe)})));if(typeof me!="undefined")throw me;return Le}L.settled=X})(F=e.Promises||(e.Promises={}))}),define(ve[112],be([0,1,14,11]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const P=new k.IdleValue(()=>{const m=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:m,collatorIsNumeric:m.resolvedOptions().numeric}}),T=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),y=new k.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(m,w,R=!1){const $=m||"",K=w||"",he=P.value.collator.compare($,K);return P.value.collatorIsNumeric&&he===0&&$!==K?$<K?-1:1:he}e.compareFileNames=D;function S(m,w){const R=T.value.collator;return m=m||"",w=w||"",f(R,m,w)}e.compareFileNamesDefault=S;function C(m,w){const R=T.value.collator;return m=m||"",w=w||"",s(m,w)||f(R,m,w)}e.compareFileNamesUpper=C;function i(m,w){const R=T.value.collator;return m=m||"",w=w||"",a(m,w)||f(R,m,w)}e.compareFileNamesLower=i;function I(m,w){return m=m||"",w=w||"",m===w?0:m<w?-1:1}e.compareFileNamesUnicode=I;function h(m,w,R=!1){R||(m=m&&m.toLowerCase(),w=w&&w.toLowerCase());const[$,K]=c(m),[he,V]=c(w);return $!==he?$<he?-1:1:K===V?0:K<V?-1:1}e.noIntlCompareFileNames=h;function d(m,w){const[R,$]=c(m),[K,he]=c(w);let V=P.value.collator.compare($,he);if(V===0){if(P.value.collatorIsNumeric&&$!==he)return $<he?-1:1;if(V=P.value.collator.compare(R,K),P.value.collatorIsNumeric&&V===0&&R!==K)return R<K?-1:1}return V}e.compareFileExtensions=d;function r(m,w){m=m||"",w=w||"";const R=l(m),$=l(w),K=T.value.collator,he=y.value.collator;return f(he,R,$)||f(K,m,w)}e.compareFileExtensionsDefault=r;function o(m,w){m=m||"",w=w||"";const R=l(m),$=l(w),K=T.value.collator,he=y.value.collator;return f(he,R,$)||s(m,w)||f(K,m,w)}e.compareFileExtensionsUpper=o;function v(m,w){m=m||"",w=w||"";const R=l(m),$=l(w),K=T.value.collator,he=y.value.collator;return f(he,R,$)||a(m,w)||f(K,m,w)}e.compareFileExtensionsLower=v;function p(m,w){m=m||"",w=w||"";const R=l(m).toLowerCase(),$=l(w).toLowerCase();return R!==$?R<$?-1:1:m!==w?m<w?-1:1:0}e.compareFileExtensionsUnicode=p;const E=/^(.*?)(\.([^.]*))?$/;function c(m,w=!1){const R=m?E.exec(m):[];let $=[R&&R[1]||"",R&&R[3]||""];return w&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function l(m){const w=m?E.exec(m):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function f(m,w,R){let $=m.compare(w,R);return $!==0?$:w.length!==R.length?w.length<R.length?-1:1:0}function t(m){const w=m.charAt(0);return w.toLocaleUpperCase()!==w}function n(m){const w=m.charAt(0);return w.toLocaleLowerCase()!==w}function a(m,w){return t(m)&&n(w)?-1:n(m)&&t(w)?1:0}function s(m,w){return n(m)&&t(w)?-1:t(m)&&n(w)?1:0}function u(m,w,R=!1){return R||(m=m&&m.toLowerCase(),w=w&&w.toLowerCase()),m===w?0:m<w?-1:1}function g(m,w,R=!1){const $=m.split(b.sep),K=w.split(b.sep),he=$.length-1,V=K.length-1;let H,Y;for(let U=0;;U++){if(H=he===U,Y=V===U,H&&Y)return D($[U],K[U],R);if(H)return-1;if(Y)return 1;const F=u($[U],K[U],R);if(F!==0)return F}}e.comparePaths=g;function _(m,w,R){const $=m.toLowerCase(),K=w.toLowerCase(),he=A(m,w,R);if(he)return he;const V=$.endsWith(R),H=K.endsWith(R);if(V!==H)return V?-1:1;const Y=D($,K);return Y!==0?Y:$.localeCompare(K)}e.compareAnything=_;function A(m,w,R){const $=m.toLowerCase(),K=w.toLowerCase(),he=$.startsWith(R),V=K.startsWith(R);if(he!==V)return he?-1:1;if(he&&V){if($.length<K.length)return-1;if($.length>K.length)return 1}return 0}e.compareByPrefix=A}),define(ve[28],be([0,1,8,37,14,22,11]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const S="**",C="/",i="[/\\\\]",I="[^/\\\\]",h=/\//g;function d(x){switch(x){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function r(x,G){if(!x)return[];const X=[];let ne=!1,me=!1,Le="";for(const We of x){switch(We){case G:if(!ne&&!me){X.push(Le),Le="";continue}break;case"{":ne=!0;break;case"}":ne=!1;break;case"[":me=!0;break;case"]":me=!1;break}Le+=We}return Le&&X.push(Le),X}e.splitGlobAware=r;function o(x){if(!x)return"";let G="";const X=r(x,C);if(X.every(ne=>ne===S))G=".*";else{let ne=!1;X.forEach((me,Le)=>{if(me===S){ne||(G+=d(2),ne=!0);return}let We=!1,Fe="",ze=!1,W="";for(const j of me){if(j!=="}"&&We){Fe+=j;continue}if(ze&&(j!=="]"||!W)){let te;j==="-"?te=j:(j==="^"||j==="!")&&!W?te="^":j===C?te="":te=b.escapeRegExpCharacters(j),W+=te;continue}switch(j){case"{":We=!0;continue;case"[":ze=!0;continue;case"}":G+=`(?:${r(Fe,",").map(de=>o(de)).join("|")})`,We=!1,Fe="";break;case"]":G+="["+W+"]",ze=!1,W="";break;case"?":G+=I;continue;case"*":G+=d(1);continue;default:G+=b.escapeRegExpCharacters(j)}}Le<X.length-1&&(X[Le+1]!==S||Le+2<X.length)&&(G+=i),ne=!1})}return G}const v=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,E=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,f=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},a=function(){return null};function s(x,G){if(!x)return a;let X;typeof x!="string"?X=x.pattern:X=x,X=X.trim();const ne=`${X}_${!!G.trimForExclusions}`;let me=t.get(ne);if(me)return u(me,x);let Le;if(v.test(X)){const We=X.substr(4);me=function(Fe,ze){return typeof Fe=="string"&&Fe.endsWith(We)?X:null}}else(Le=p.exec(g(X,G)))?me=_(Le[1],X):(G.trimForExclusions?c:E).test(X)?me=A(X,G):(Le=l.exec(g(X,G)))?me=m(Le[1].substr(1),X,!0):(Le=f.exec(g(X,G)))?me=m(Le[1],X,!1):me=w(X);return t.set(ne,me),u(me,x)}function u(x,G){return typeof G=="string"?x:function(X,ne){return k.isEqualOrParent(X,G.base)?x(P.relative(G.base,X),ne):null}}function g(x,G){return G.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function _(x,G){const X=`/${x}`,ne=`\\${x}`,me=function(We,Fe){return typeof We!="string"?null:Fe?Fe===x?G:null:We===x||We.endsWith(X)||We.endsWith(ne)?G:null},Le=[x];return me.basenames=Le,me.patterns=[G],me.allBasenames=Le,me}function A(x,G){const X=M(x.slice(1,-1).split(",").map(Fe=>s(Fe,G)).filter(Fe=>Fe!==a),x),ne=X.length;if(!ne)return a;if(ne===1)return X[0];const me=function(Fe,ze){for(let W=0,j=X.length;W<j;W++)if(X[W](Fe,ze))return x;return null},Le=X.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=X.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function m(x,G,X){const ne=P.sep===P.posix.sep,me=ne?x:x.replace(h,P.sep),Le=P.sep+me,We=P.posix.sep+x,Fe=X?function(ze,W){return typeof ze=="string"&&(ze===me||ze.endsWith(Le)||!ne&&(ze===x||ze.endsWith(We)))?G:null}:function(ze,W){return typeof ze=="string"&&(ze===me||!ne&&ze===x)?G:null};return Fe.allPaths=[(X?"*/":"./")+x],Fe}function w(x){try{const G=new RegExp(`^${o(x)}$`);return function(X){return G.lastIndex=0,typeof X=="string"&&G.test(X)?x:null}}catch(G){return a}}function R(x,G,X){return!x||typeof G!="string"?!1:$(x)(G,void 0,X)}e.match=R;function $(x,G={}){if(!x)return n;if(typeof x=="string"||H(x)){const X=s(x,G);if(X===a)return n;const ne=function(me,Le){return!!X(me,Le)};return X.allBasenames&&(ne.allBasenames=X.allBasenames),X.allPaths&&(ne.allPaths=X.allPaths),ne}return F(x,G)}e.parse=$;function K(x){if(!!x){let G;return X=>(G||(G=(x()||Promise.resolve([])).then(ne=>ne?V(ne):{})),G.then(ne=>!!ne[X]))}}e.hasSiblingPromiseFn=K;function he(x){if(!!x){let G;return X=>{if(!G){const ne=x();G=ne?V(ne):{}}return!!G[X]}}}e.hasSiblingFn=he;function V(x){const G={};for(const X of x)G[X]=!0;return G}function H(x){const G=x;return G&&typeof G.base=="string"&&typeof G.pattern=="string"}e.isRelativePattern=H;function Y(x){return x.allBasenames||[]}e.getBasenameTerms=Y;function U(x){return x.allPaths||[]}e.getPathTerms=U;function F(x,G){const X=M(Object.getOwnPropertyNames(x).map(Fe=>L(Fe,x[Fe],G)).filter(Fe=>Fe!==a)),ne=X.length;if(!ne)return a;if(!X.some(Fe=>!!Fe.requiresSiblings)){if(ne===1)return X[0];const Fe=function(j,te){for(let oe=0,de=X.length;oe<de;oe++){const _e=X[oe](j,te);if(_e)return _e}return null},ze=X.find(j=>!!j.allBasenames);ze&&(Fe.allBasenames=ze.allBasenames);const W=X.reduce((j,te)=>te.allPaths?j.concat(te.allPaths):j,[]);return W.length&&(Fe.allPaths=W),Fe}const me=function(Fe,ze,W){let j;for(let te=0,oe=X.length;te<oe;te++){const de=X[te];de.requiresSiblings&&W&&(ze||(ze=P.basename(Fe)),j||(j=ze.substr(0,ze.length-P.extname(Fe).length)));const _e=de(Fe,ze,j,W);if(_e)return _e}return null},Le=X.find(Fe=>!!Fe.allBasenames);Le&&(me.allBasenames=Le.allBasenames);const We=X.reduce((Fe,ze)=>ze.allPaths?Fe.concat(ze.allPaths):Fe,[]);return We.length&&(me.allPaths=We),me}function L(x,G,X){if(G===!1)return a;const ne=s(x,X);if(ne===a)return a;if(typeof G=="boolean")return ne;if(G){const me=G.when;if(typeof me=="string"){const Le=(We,Fe,ze,W)=>{if(!W||!ne(We,Fe))return null;const j=me.replace("$(basename)",ze),te=W(j);return(0,y.isThenable)(te)?te.then(oe=>oe?x:null):te?x:null};return Le.requiresSiblings=!0,Le}}return ne}function M(x,G){const X=x.filter(Fe=>!!Fe.basenames);if(X.length<2)return x;const ne=X.reduce((Fe,ze)=>{const W=ze.basenames;return W?Fe.concat(W):Fe},[]);let me;if(G){me=[];for(let Fe=0,ze=ne.length;Fe<ze;Fe++)me.push(G)}else me=X.reduce((Fe,ze)=>{const W=ze.patterns;return W?Fe.concat(W):Fe},[]);const Le=function(Fe,ze){if(typeof Fe!="string")return null;if(!ze){let j;for(j=Fe.length;j>0;j--){const te=Fe.charCodeAt(j-1);if(te===47||te===92)break}ze=Fe.substr(j)}const W=ne.indexOf(ze);return W!==-1?me[W]:null};Le.basenames=ne,Le.patterns=me,Le.allBasenames=ne;const We=x.filter(Fe=>!Fe.basenames);return We.push(Le),We}}),define(ve[58],be([0,1,2,14,8,19,21,25,37]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(s,u,g){if(typeof s=="string"&&(s=b.URI.file(s)),g){const A=g.getWorkspaceFolder(s);if(A){const m=g.getWorkspace().folders.length>1;let w;if((0,D.isEqual)(A.uri,s)?w="":w=(0,D.relativePath)(A.uri,s),m){const R=A.name?A.name:(0,D.basename)(A.uri);w=w?R+" \u2022 "+w:R}return w}}if(s.scheme!==T.Schemas.file&&s.scheme!==T.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,S.hasDriveLetter)(s.fsPath))return(0,k.normalize)(I(s.fsPath));let _=(0,k.normalize)(s.fsPath);return!y.isWindows&&(u==null?void 0:u.userHome)&&(_=d(_,u.userHome.fsPath)),_}e.getPathLabel=C;function i(s){if(!!s){typeof s=="string"&&(s=b.URI.file(s));const u=(0,D.basename)(s)||(s.scheme===T.Schemas.file?s.fsPath:s.path);return y.isWindows&&(0,S.isRootOrDriveLetter)(u)?I(u):u}}e.getBaseLabel=i;function I(s){return(0,S.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let h=Object.create(null);function d(s,u){if(y.isWindows||!s||!u)return s;let g=h.original===u?h.normalized:void 0;return g||(g=`${(0,P.rtrim)(u,k.posix.sep)}${k.posix.sep}`,h={original:u,normalized:g}),(y.isLinux?s.startsWith(g):(0,P.startsWithIgnoreCase)(s,g))&&(s=`~/${s.substr(g.length)}`),s}e.tildify=d;function r(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=r;const o="\u2026",v="\\\\",p="~";function E(s,u=k.sep){const g=new Array(s.length);let _=!1;for(let A=0;A<s.length;A++){let m=s[A];if(m===""){g[A]=`.${u}`;continue}if(!m){g[A]=m;continue}_=!0;let w="";m.indexOf(v)===0?(w=m.substr(0,m.indexOf(v)+v.length),m=m.substr(m.indexOf(v)+v.length)):m.indexOf(u)===0?(w=m.substr(0,m.indexOf(u)+u.length),m=m.substr(m.indexOf(u)+u.length)):m.indexOf(p)===0&&(w=m.substr(0,m.indexOf(p)+p.length),m=m.substr(m.indexOf(p)+p.length));const R=m.split(u);for(let $=1;_&&$<=R.length;$++)for(let K=R.length-$;_&&K>=0;K--){_=!1;let he=R.slice(K,K+$).join(u);for(let V=0;!_&&V<s.length;V++)if(V!==A&&s[V]&&s[V].indexOf(he)>-1){const H=K+$===R.length,Y=K>0&&s[V].indexOf(u)>-1?u+he:he,U=s[V].endsWith(Y);_=!H||U}if(!_){let V="";(R[0].endsWith(":")||w!=="")&&(K===1&&(K=0,$++,he=R[0]+u+he),K>0&&(V=R[0]+u),V=w+V),K>0&&(V=V+o+u),V=V+he,K+$<R.length&&(V=V+u+o),g[A]=V}}_&&(g[A]=m)}return g}e.shorten=E;var c;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function l(s,u=Object.create(null)){const g=[];let _=!1,A="";for(const m of s)if(m==="$"||_&&m==="{")A&&g.push({value:A,type:c.TEXT}),A="",_=!0;else if(m==="}"&&_){const w=u[A];if(typeof w=="string")w.length&&g.push({value:w,type:c.VARIABLE});else if(w){const R=g[g.length-1];(!R||R.type!==c.SEPARATOR)&&g.push({value:w.label,type:c.SEPARATOR})}A="",_=!1}else A+=m;return A&&!_&&g.push({value:A,type:c.TEXT}),g.filter((m,w)=>{if(m.type===c.SEPARATOR){const R=g[w-1],$=g[w+1];return[R,$].every(K=>K&&(K.type===c.VARIABLE||K.type===c.TEXT)&&K.value.length>0)}return!0}).map(m=>m.value).join("")}e.template=l;function f(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,y.isMacintosh?"&":"&&"):s.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=f;function t(s,u){return y.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):y.isWindows?s.replace(/&&|&/g,g=>g==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function a(s){const u=s.indexOf("/")!==-1?k.posix:k.win32,g=u.basename(s),_=u.dirname(s);return g.length?{name:g,parentPath:_}:{name:_,parentPath:""}}e.splitName=a}),define(ve[113],be([0,1,2]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(i){return i.toJSON()}class P{constructor(I){this._uriTransformer=I}transformIncoming(I){const h=this._uriTransformer.transformIncoming(I);return h===I?I:k(b.URI.from(h))}transformOutgoing(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:k(b.URI.from(h))}transformOutgoingURI(I){const h=this._uriTransformer.transformOutgoing(I);return h===I?I:b.URI.from(h)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=P,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,I,h){if(!i||h>200)return null;if(typeof i=="object"){if(i instanceof b.URI)return I.transformOutgoing(i);for(let d in i)if(Object.hasOwnProperty.call(i,d)){const r=T(i[d],I,h+1);r!==null&&(i[d]=r)}}return null}function y(i,I){const h=T(i,I,0);return h===null?i:h}e.transformOutgoingURIs=y;function D(i,I,h,d){if(!i||d>200)return null;if(typeof i=="object"){if(i.$mid===1)return h?b.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let r in i)if(Object.hasOwnProperty.call(i,r)){const o=D(i[r],I,h,d+1);o!==null&&(i[r]=o)}}return null}function S(i,I){const h=D(i,I,!1,0);return h===null?i:h}e.transformIncomingURIs=S;function C(i,I){const h=D(i,I,!0,0);return h===null?i:h}e.transformAndReviveIncomingURIs=C}),define(ve[31],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(S){return b.test(S)}e.isUUID=k;const P=new Uint8Array(16),T=[];for(let S=0;S<256;S++)T.push(S.toString(16).padStart(2,"0"));let y;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?y=crypto.getRandomValues.bind(crypto):y=function(S){for(let C=0;C<S.length;C++)S[C]=Math.floor(Math.random()*256);return S};function D(){y(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let S=0,C="";return C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C+="-",C+=T[P[S++]],C+=T[P[S++]],C+="-",C+=T[P[S++]],C+=T[P[S++]],C+="-",C+=T[P[S++]],C+=T[P[S++]],C+="-",C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C+=T[P[S++]],C}e.generateUuid=D}),define(ve[84],be([0,1,82]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class k{constructor(D){let S=(0,b.toUint8)(D);this._defaultValue=S,this._asciiMap=k._createAsciiMap(S),this._map=new Map}static _createAsciiMap(D){let S=new Uint8Array(256);for(let C=0;C<256;C++)S[C]=D;return S}set(D,S){let C=(0,b.toUint8)(S);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=k;var P;(function(y){y[y.False=0]="False",y[y.True=1]="True"})(P||(P={}));class T{constructor(){this._actual=new k(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=T}),define(ve[114],be([0,1,84]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var k;(function(y){y[y.Regular=0]="Regular",y[y.Whitespace=1]="Whitespace",y[y.WordSeparator=2]="WordSeparator"})(k=e.WordCharacterClass||(e.WordCharacterClass={}));class P extends b.CharacterClassifier{constructor(D){super(0);for(let S=0,C=D.length;S<C;S++)this.set(D.charCodeAt(S),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=P;function T(y){let D={};return S=>(D.hasOwnProperty(S)||(D[S]=y(S)),D[S])}e.getMapForWordSeparators=T(y=>new P(y))}),define(ve[38],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class b{constructor(P,T){this.lineNumber=P,this.column=T}with(P=this.lineNumber,T=this.column){return P===this.lineNumber&&T===this.column?this:new b(P,T)}delta(P=0,T=0){return this.with(this.lineNumber+P,this.column+T)}equals(P){return b.equals(this,P)}static equals(P,T){return!P&&!T?!0:!!P&&!!T&&P.lineNumber===T.lineNumber&&P.column===T.column}isBefore(P){return b.isBefore(this,P)}static isBefore(P,T){return P.lineNumber<T.lineNumber?!0:T.lineNumber<P.lineNumber?!1:P.column<T.column}isBeforeOrEqual(P){return b.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,T){return P.lineNumber<T.lineNumber?!0:T.lineNumber<P.lineNumber?!1:P.column<=T.column}static compare(P,T){let y=P.lineNumber|0,D=T.lineNumber|0;if(y===D){let S=P.column|0,C=T.column|0;return S-C}return y-D}clone(){return new b(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new b(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}}e.Position=b}),define(ve[32],be([0,1,38]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(T,y,D,S){T>D||T===D&&y>S?(this.startLineNumber=D,this.startColumn=S,this.endLineNumber=T,this.endColumn=y):(this.startLineNumber=T,this.startColumn=y,this.endLineNumber=D,this.endColumn=S)}isEmpty(){return k.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return k.containsPosition(this,T)}static containsPosition(T,y){return!(y.lineNumber<T.startLineNumber||y.lineNumber>T.endLineNumber||y.lineNumber===T.startLineNumber&&y.column<T.startColumn||y.lineNumber===T.endLineNumber&&y.column>T.endColumn)}containsRange(T){return k.containsRange(this,T)}static containsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>T.endColumn)}strictContainsRange(T){return k.strictContainsRange(this,T)}static strictContainsRange(T,y){return!(y.startLineNumber<T.startLineNumber||y.endLineNumber<T.startLineNumber||y.startLineNumber>T.endLineNumber||y.endLineNumber>T.endLineNumber||y.startLineNumber===T.startLineNumber&&y.startColumn<=T.startColumn||y.endLineNumber===T.endLineNumber&&y.endColumn>=T.endColumn)}plusRange(T){return k.plusRange(this,T)}static plusRange(T,y){let D,S,C,i;return y.startLineNumber<T.startLineNumber?(D=y.startLineNumber,S=y.startColumn):y.startLineNumber===T.startLineNumber?(D=y.startLineNumber,S=Math.min(y.startColumn,T.startColumn)):(D=T.startLineNumber,S=T.startColumn),y.endLineNumber>T.endLineNumber?(C=y.endLineNumber,i=y.endColumn):y.endLineNumber===T.endLineNumber?(C=y.endLineNumber,i=Math.max(y.endColumn,T.endColumn)):(C=T.endLineNumber,i=T.endColumn),new k(D,S,C,i)}intersectRanges(T){return k.intersectRanges(this,T)}static intersectRanges(T,y){let D=T.startLineNumber,S=T.startColumn,C=T.endLineNumber,i=T.endColumn,I=y.startLineNumber,h=y.startColumn,d=y.endLineNumber,r=y.endColumn;return D<I?(D=I,S=h):D===I&&(S=Math.max(S,h)),C>d?(C=d,i=r):C===d&&(i=Math.min(i,r)),D>C||D===C&&S>i?null:new k(D,S,C,i)}equalsRange(T){return k.equalsRange(this,T)}static equalsRange(T,y){return!!T&&!!y&&T.startLineNumber===y.startLineNumber&&T.startColumn===y.startColumn&&T.endLineNumber===y.endLineNumber&&T.endColumn===y.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(T){return new b.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(T){return new b.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,y){return new k(this.startLineNumber,this.startColumn,T,y)}setStartPosition(T,y){return new k(T,y,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(T){return new k(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,y=T){return new k(T.lineNumber,T.column,y.lineNumber,y.column)}static lift(T){return T?new k(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<T.startColumn)}static areIntersecting(T,y){return!(T.endLineNumber<y.startLineNumber||T.endLineNumber===y.startLineNumber&&T.endColumn<=y.startColumn||y.endLineNumber<T.startLineNumber||y.endLineNumber===T.startLineNumber&&y.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,y){if(T&&y){const C=T.startLineNumber|0,i=y.startLineNumber|0;if(C===i){const I=T.startColumn|0,h=y.startColumn|0;if(I===h){const d=T.endLineNumber|0,r=y.endLineNumber|0;if(d===r){const o=T.endColumn|0,v=y.endColumn|0;return o-v}return d-r}return I-h}return C-i}return(T?1:0)-(y?1:0)}static compareRangesUsingEnds(T,y){return T.endLineNumber===y.endLineNumber?T.endColumn===y.endColumn?T.startLineNumber===y.startLineNumber?T.startColumn-y.startColumn:T.startLineNumber-y.startLineNumber:T.endColumn-y.endColumn:T.endLineNumber-y.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=k}),define(ve[115],be([0,1,38,32]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var P;(function(y){y[y.LTR=0]="LTR",y[y.RTL=1]="RTL"})(P=e.SelectionDirection||(e.SelectionDirection={}));class T extends k.Range{constructor(D,S,C,i){super(D,S,C,i);this.selectionStartLineNumber=D,this.selectionStartColumn=S,this.positionLineNumber=C,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return T.selectionsEqual(this,D)}static selectionsEqual(D,S){return D.selectionStartLineNumber===S.selectionStartLineNumber&&D.selectionStartColumn===S.selectionStartColumn&&D.positionLineNumber===S.positionLineNumber&&D.positionColumn===S.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,S){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,D,S):new T(D,S,this.startLineNumber,this.startColumn)}getPosition(){return new b.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,S){return this.getDirection()===0?new T(D,S,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,D,S)}static fromPositions(D,S=D){return new T(D.lineNumber,D.column,S.lineNumber,S.column)}static liftSelection(D){return new T(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,S){if(D&&!S||!D&&S)return!1;if(!D&&!S)return!0;if(D.length!==S.length)return!1;for(let C=0,i=D.length;C<i;C++)if(!this.selectionsEqual(D[C],S[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,S,C,i,I){return I===0?new T(D,S,C,i):new T(C,i,D,S)}}e.Selection=T}),define(ve[85],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var b;(function(d){d[d.Left=1]="Left",d[d.Center=2]="Center",d[d.Right=4]="Right",d[d.Full=7]="Full"})(b=e.OverviewRulerLane||(e.OverviewRulerLane={}));var k;(function(d){d[d.Inline=1]="Inline",d[d.Gutter=2]="Gutter"})(k=e.MinimapPosition||(e.MinimapPosition={}));var P;(function(d){d[d.TextDefined=0]="TextDefined",d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(P=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(d){d[d.LF=1]="LF",d[d.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(d){d[d.LF=0]="LF",d[d.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(r){this.tabSize=Math.max(1,r.tabSize|0),this.indentSize=r.tabSize|0,this.insertSpaces=Boolean(r.insertSpaces),this.defaultEOL=r.defaultEOL|0,this.trimAutoWhitespace=Boolean(r.trimAutoWhitespace)}equals(r){return this.tabSize===r.tabSize&&this.indentSize===r.indentSize&&this.insertSpaces===r.insertSpaces&&this.defaultEOL===r.defaultEOL&&this.trimAutoWhitespace===r.trimAutoWhitespace}createChangeEvent(r){return{tabSize:this.tabSize!==r.tabSize,indentSize:this.indentSize!==r.indentSize,insertSpaces:this.insertSpaces!==r.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==r.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class S{constructor(r,o){this.range=r,this.matches=o}}e.FindMatch=S;var C;(function(d){d[d.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",d[d.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",d[d.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",d[d.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(d){d[d.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(i=e.ModelConstants||(e.ModelConstants={}));class I{constructor(r,o,v,p,E,c){this.identifier=r,this.range=o,this.text=v,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=E,this._isTracked=c}}e.ValidAnnotatedEditOperation=I;class h{constructor(r,o,v){this.reverseEdits=r,this.changes=o,this.trimAutoWhitespaceLineNumbers=v}}e.ApplyEditsResult=h}),define(ve[116],be([0,1,8,114,38,32,85]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class S{constructor(c,l,f,t){this.searchString=c,this.isRegex=l,this.matchCase=f,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=C(this.searchString):c=this.searchString.indexOf(`
`)>=0;let l=null;try{l=b.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(t){return null}if(!l)return null;let f=!this.isRegex&&!c;return f&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(f=this.matchCase),new i(l,this.wordSeparators?(0,k.getMapForWordSeparators)(this.wordSeparators):null,f?this.searchString:null)}}e.SearchParams=S;function C(E){if(!E||E.length===0)return!1;for(let c=0,l=E.length;c<l;c++)if(E.charCodeAt(c)===92){if(c++,c>=l)break;const t=E.charCodeAt(c);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class i{constructor(c,l,f){this.regex=c,this.wordSeparators=l,this.simpleSearch=f}}e.SearchData=i;function I(E,c,l){if(!l)return new y.FindMatch(E,null);let f=[];for(let t=0,n=c.length;t<n;t++)f[t]=c[t];return new y.FindMatch(E,f)}e.createFindMatch=I;class h{constructor(c){let l=[],f=0;for(let t=0,n=c.length;t<n;t++)c.charCodeAt(t)===10&&(l[f++]=t);this._lineFeedsOffsets=l}findLineFeedCountBeforeOffset(c){const l=this._lineFeedsOffsets;let f=0,t=l.length-1;if(t===-1||c<=l[0])return 0;for(;f<t;){const n=f+((t-f)/2>>0);l[n]>=c?t=n-1:l[n+1]>=c?(f=n,t=n):f=n+1}return f+1}}class d{static findMatches(c,l,f,t,n){const a=l.parseSearchRequest();return a?a.regex.multiline?this._doFindMatchesMultiline(c,f,new p(a.wordSeparators,a.regex),t,n):this._doFindMatchesLineByLine(c,f,a,t,n):[]}static _getMultilineMatchRange(c,l,f,t,n,a){let s,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),s=l+n+u):s=l+n;let g;if(t){let w=t.findLineFeedCountBeforeOffset(n+a.length)-u;g=s+a.length+w}else g=s+a.length;const _=c.getPositionAt(s),A=c.getPositionAt(g);return new T.Range(_.lineNumber,_.column,A.lineNumber,A.column)}static _doFindMatchesMultiline(c,l,f,t,n){const a=c.getOffsetAt(l.getStartPosition()),s=c.getValueInRange(l,1),u=c.getEOL()===`\r
`?new h(s):null,g=[];let _=0,A;for(f.reset(0);A=f.next(s);)if(g[_++]=I(this._getMultilineMatchRange(c,a,s,u,A.index,A[0]),A,t),_>=n)return g;return g}static _doFindMatchesLineByLine(c,l,f,t,n){const a=[];let s=0;if(l.startLineNumber===l.endLineNumber){const g=c.getLineContent(l.startLineNumber).substring(l.startColumn-1,l.endColumn-1);return s=this._findMatchesInLine(f,g,l.startLineNumber,l.startColumn-1,s,a,t,n),a}const u=c.getLineContent(l.startLineNumber).substring(l.startColumn-1);s=this._findMatchesInLine(f,u,l.startLineNumber,l.startColumn-1,s,a,t,n);for(let g=l.startLineNumber+1;g<l.endLineNumber&&s<n;g++)s=this._findMatchesInLine(f,c.getLineContent(g),g,0,s,a,t,n);if(s<n){const g=c.getLineContent(l.endLineNumber).substring(0,l.endColumn-1);s=this._findMatchesInLine(f,g,l.endLineNumber,0,s,a,t,n)}return a}static _findMatchesInLine(c,l,f,t,n,a,s,u){const g=c.wordSeparators;if(!s&&c.simpleSearch){const m=c.simpleSearch,w=m.length,R=l.length;let $=-w;for(;($=l.indexOf(m,$+w))!==-1;)if((!g||v(g,l,R,$,w))&&(a[n++]=new y.FindMatch(new T.Range(f,$+1+t,f,$+1+w+t),null),n>=u))return n;return n}const _=new p(c.wordSeparators,c.regex);let A;_.reset(0);do if(A=_.next(l),A&&(a[n++]=I(new T.Range(f,A.index+1+t,f,A.index+1+A[0].length+t),A,s),n>=u))return n;while(A);return n}static findNextMatch(c,l,f,t){const n=l.parseSearchRequest();if(!n)return null;const a=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(c,f,a,t):this._doFindNextMatchLineByLine(c,f,a,t)}static _doFindNextMatchMultiline(c,l,f,t){const n=new P.Position(l.lineNumber,1),a=c.getOffsetAt(n),s=c.getLineCount(),u=c.getValueInRange(new T.Range(n.lineNumber,n.column,s,c.getLineMaxColumn(s)),1),g=c.getEOL()===`\r
`?new h(u):null;f.reset(l.column-1);let _=f.next(u);return _?I(this._getMultilineMatchRange(c,a,u,g,_.index,_[0]),_,t):l.lineNumber!==1||l.column!==1?this._doFindNextMatchMultiline(c,new P.Position(1,1),f,t):null}static _doFindNextMatchLineByLine(c,l,f,t){const n=c.getLineCount(),a=l.lineNumber,s=c.getLineContent(a),u=this._findFirstMatchInLine(f,s,a,l.column,t);if(u)return u;for(let g=1;g<=n;g++){const _=(a+g-1)%n,A=c.getLineContent(_+1),m=this._findFirstMatchInLine(f,A,_+1,1,t);if(m)return m}return null}static _findFirstMatchInLine(c,l,f,t,n){c.reset(t-1);const a=c.next(l);return a?I(new T.Range(f,a.index+1,f,a.index+1+a[0].length),a,n):null}static findPreviousMatch(c,l,f,t){const n=l.parseSearchRequest();if(!n)return null;const a=new p(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(c,f,a,t):this._doFindPreviousMatchLineByLine(c,f,a,t)}static _doFindPreviousMatchMultiline(c,l,f,t){const n=this._doFindMatchesMultiline(c,new T.Range(1,1,l.lineNumber,l.column),f,t,10*D);if(n.length>0)return n[n.length-1];const a=c.getLineCount();return l.lineNumber!==a||l.column!==c.getLineMaxColumn(a)?this._doFindPreviousMatchMultiline(c,new P.Position(a,c.getLineMaxColumn(a)),f,t):null}static _doFindPreviousMatchLineByLine(c,l,f,t){const n=c.getLineCount(),a=l.lineNumber,s=c.getLineContent(a).substring(0,l.column-1),u=this._findLastMatchInLine(f,s,a,t);if(u)return u;for(let g=1;g<=n;g++){const _=(n+a-g-1)%n,A=c.getLineContent(_+1),m=this._findLastMatchInLine(f,A,_+1,t);if(m)return m}return null}static _findLastMatchInLine(c,l,f,t){let n=null,a;for(c.reset(0);a=c.next(l);)n=I(new T.Range(f,a.index+1,f,a.index+1+a[0].length),a,t);return n}}e.TextModelSearch=d;function r(E,c,l,f,t){if(f===0)return!0;const n=c.charCodeAt(f-1);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=c.charCodeAt(f);if(E.get(a)!==0)return!0}return!1}function o(E,c,l,f,t){if(f+t===l)return!0;const n=c.charCodeAt(f+t);if(E.get(n)!==0||n===13||n===10)return!0;if(t>0){const a=c.charCodeAt(f+t-1);if(E.get(a)!==0)return!0}return!1}function v(E,c,l,f,t){return r(E,c,l,f,t)&&o(E,c,l,f,t)}e.isValidMatch=v;class p{constructor(c,l){this._wordSeparators=c,this._searchRegex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const l=c.length;let f;do{if(this._prevMatchStartIndex+this._prevMatchLength===l||(f=this._searchRegex.exec(c),!f))return null;const t=f.index,n=f[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){b.getNextCodePoint(c,l,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||v(this._wordSeparators,c,l,t,n))return f}while(f);return null}}e.Searcher=p}),define(ve[86],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function b(D=""){let S="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(S+="\\"+C);return S+="\\s]+)",new RegExp(S,"g")}e.DEFAULT_WORD_REGEXP=b();function k(D){let S=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)S=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),S=new RegExp(D.source,C)}return S.lastIndex=0,S}e.ensureValidWordDefinition=k;const P={maxLen:1e3,windowSize:15,timeBudget:150};function T(D,S,C,i,I=P){if(C.length>I.maxLen){let v=D-I.maxLen/2;return v<0?v=0:i+=v,C=C.substring(v,D+I.maxLen/2),T(D,S,C,i,I)}const h=Date.now(),d=D-1-i;let r=-1,o=null;for(let v=1;!(Date.now()-h>=I.timeBudget);v++){const p=d-I.windowSize*v;S.lastIndex=Math.max(0,p);const E=y(S,C,d,r);if(!E&&o||(o=E,p<=0))break;r=p}if(o){let v={word:o[0],startColumn:i+1+o.index,endColumn:i+1+o.index+o[0].length};return S.lastIndex=0,v}return null}e.getWordAtText=T;function y(D,S,C,i){let I;for(;I=D.exec(S);){const h=I.index||0;if(h<=C&&D.lastIndex>=C)return I;if(i>0&&h>i)return null}return null}}),define(ve[117],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var b;(function(y){y[y.None=0]="None",y[y.Indent=1]="Indent",y[y.IndentOutdent=2]="IndentOutdent",y[y.Outdent=3]="Outdent"})(b=e.IndentAction||(e.IndentAction={}));class k{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let S=0,C=D.notIn.length;S<C;S++)switch(D.notIn[S]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=k;class P{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const S of D)T(this.autoClosingPairsOpenByStart,S.open.charAt(0),S),T(this.autoClosingPairsOpenByEnd,S.open.charAt(S.open.length-1),S),T(this.autoClosingPairsCloseByStart,S.close.charAt(0),S),T(this.autoClosingPairsCloseByEnd,S.close.charAt(S.close.length-1),S),S.close.length===1&&S.open.length===1&&T(this.autoClosingPairsCloseSingleChar,S.close,S)}}e.AutoClosingPairs=P;function T(y,D,S){y.has(D)?y.get(D).push(S):y.set(D,[S])}}),define(ve[59],be([0,1,28,14]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function P(T,y,D,S){if(Array.isArray(T)){let C=0;for(const i of T){const I=P(i,y,D,S);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof T=="string")return S?T==="*"?5:T===D?10:0:0;if(T){const{language:C,pattern:i,scheme:I,hasAccessToAllModels:h}=T;if(!S&&!h)return 0;let d=0;if(I)if(I===y.scheme)d=10;else if(I==="*")d=5;else return 0;if(C)if(C===D)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(i){let r;if(typeof i=="string"?r=i:r=Object.assign(Object.assign({},i),{base:(0,k.normalize)(i.base)}),r===y.fsPath||(0,b.match)(r,y.fsPath))d=10;else return 0}return d}else return 0}}e.score=P}),define(ve[118],be([0,1,84]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var k;(function(d){d[d.Invalid=0]="Invalid",d[d.Start=1]="Start",d[d.H=2]="H",d[d.HT=3]="HT",d[d.HTT=4]="HTT",d[d.HTTP=5]="HTTP",d[d.F=6]="F",d[d.FI=7]="FI",d[d.FIL=8]="FIL",d[d.BeforeColon=9]="BeforeColon",d[d.AfterColon=10]="AfterColon",d[d.AlmostThere=11]="AlmostThere",d[d.End=12]="End",d[d.Accept=13]="Accept",d[d.LastKnownState=14]="LastKnownState"})(k=e.State||(e.State={}));class P{constructor(r,o,v){const p=new Uint8Array(r*o);for(let E=0,c=r*o;E<c;E++)p[E]=v;this._data=p,this.rows=r,this.cols=o}get(r,o){return this._data[r*this.cols+o]}set(r,o,v){this._data[r*this.cols+o]=v}}e.Uint8Matrix=P;class T{constructor(r){let o=0,v=0;for(let E=0,c=r.length;E<c;E++){let[l,f,t]=r[E];f>o&&(o=f),l>v&&(v=l),t>v&&(v=t)}o++,v++;let p=new P(v,o,0);for(let E=0,c=r.length;E<c;E++){let[l,f,t]=r[E];p.set(l,f,t)}this._states=p,this._maxCharCode=o}nextState(r,o){return o<0||o>=this._maxCharCode?0:this._states.get(r,o)}}e.StateMachine=T;let y=null;function D(){return y===null&&(y=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),y}var S;(function(d){d[d.None=0]="None",d[d.ForceTermination=1]="ForceTermination",d[d.CannotEndIn=2]="CannotEndIn"})(S||(S={}));let C=null;function i(){if(C===null){C=new b.CharacterClassifier(0);const d=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u3011\u300F\u300D\u300B\u3009\u201D\u2019\uFF40\uFF5E\u2026`;for(let o=0;o<d.length;o++)C.set(d.charCodeAt(o),1);const r=".,;";for(let o=0;o<r.length;o++)C.set(r.charCodeAt(o),2)}return C}class I{static _createLink(r,o,v,p,E){let c=E-1;do{const l=o.charCodeAt(c);if(r.get(l)!==2)break;c--}while(c>p);if(p>0){const l=o.charCodeAt(p-1),f=o.charCodeAt(c);(l===40&&f===41||l===91&&f===93||l===123&&f===125)&&c--}return{range:{startLineNumber:v,startColumn:p+1,endLineNumber:v,endColumn:c+2},url:o.substring(p,c+1)}}static computeLinks(r,o=D()){const v=i();let p=[];for(let E=1,c=r.getLineCount();E<=c;E++){const l=r.getLineContent(E),f=l.length;let t=0,n=0,a=0,s=1,u=!1,g=!1,_=!1,A=!1;for(;t<f;){let m=!1;const w=l.charCodeAt(t);if(s===13){let R;switch(w){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:_=!0,g=!0,R=0;break;case 93:_=!1,R=g?0:1;break;case 123:A=!0,R=0;break;case 125:R=A?0:1;break;case 39:R=a===34||a===96?0:1;break;case 34:R=a===39||a===96?0:1;break;case 96:R=a===39||a===34?0:1;break;case 42:R=a===42?1:0;break;case 124:R=a===124?1:0;break;case 32:R=_?0:1;break;default:R=v.get(w)}R===1&&(p.push(I._createLink(v,l,E,n,t)),m=!0)}else if(s===12){let R;w===91?(g=!0,R=0):R=v.get(w),R===1?m=!0:s=13}else s=o.nextState(s,w),s===0&&(m=!0);m&&(s=1,u=!1,g=!1,A=!1,n=t+1,a=w),t++}s===13&&p.push(I._createLink(v,l,E,n,f))}return p}}e.LinkComputer=I;function h(d){return!d||typeof d.getLineCount!="function"||typeof d.getLineContent!="function"?[]:I.computeLinks(d)}e.computeLinks=h}),define(ve[119],be([0,1,3,6]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class P{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new b.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(y){this._onDidChange.fire({changedLanguages:y,changedColorMap:!1})}register(y,D){return this._map.set(y,D),this.fire([y]),(0,k.toDisposable)(()=>{this._map.get(y)===D&&(this._map.delete(y),this.fire([y]))})}registerPromise(y,D){let S=null,C=!1;return this._promises.set(y,D.then(i=>{this._promises.delete(y),!(C||!i)&&(S=this.register(y,i))})),(0,k.toDisposable)(()=>{C=!0,S&&S.dispose()})}getPromise(y){const D=this.get(y);if(D)return Promise.resolve(D);const S=this._promises.get(y);return S?S.then(C=>this.get(y)):null}get(y){return this._map.get(y)||null}setColorMap(y){this._colorMap=y,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=P}),define(ve[87],be([0,1,24,21]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var P;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(P||(P={}));function T(I){for(let h=0,d=I.length;h<d;h+=4){const r=I[h+0],o=I[h+1],v=I[h+2],p=I[h+3];I[h+0]=p,I[h+1]=v,I[h+2]=o,I[h+3]=r}}function y(I){const h=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return k.isLittleEndian()||T(h),b.VSBuffer.wrap(h)}function D(I){const h=I.buffer;if(k.isLittleEndian()||T(h),h.byteOffset%4==0)return new Uint32Array(h.buffer,h.byteOffset,h.length/4);{const d=new Uint8Array(h.byteLength);return d.set(h),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function S(I){const h=new Uint32Array(C(I));let d=0;if(h[d++]=I.id,I.type==="full")h[d++]=1,h[d++]=I.data.length,h.set(I.data,d),d+=I.data.length;else{h[d++]=2,h[d++]=I.deltas.length;for(const r of I.deltas)h[d++]=r.start,h[d++]=r.deleteCount,r.data?(h[d++]=r.data.length,h.set(r.data,d),d+=r.data.length):h[d++]=0}return y(h)}e.encodeSemanticTokensDto=S;function C(I){let h=0;if(h+=1+1,I.type==="full")h+=1+I.data.length;else{h+=1,h+=(1+1+1)*I.deltas.length;for(const d of I.deltas)d.data&&(h+=d.data.length)}return h}function i(I){const h=D(I);let d=0;const r=h[d++];if(h[d++]===1){const E=h[d++],c=h.subarray(d,d+E);return d+=E,{id:r,type:"full",data:c}}const v=h[d++];let p=[];for(let E=0;E<v;E++){const c=h[d++],l=h[d++],f=h[d++];let t;f>0&&(t=h.subarray(d,d+f),d+=f),p[E]={start:c,deleteCount:l,data:t}}return{id:r,type:"delta",deltas:p}}e.decodeSemanticTokensDto=i}),define(ve[88],be([0,1,82]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class k{constructor(y,D){this.index=y,this.remainder=D}}e.PrefixSumIndexOfResult=k;class P{constructor(y){this.values=y,this.prefixSum=new Uint32Array(y.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(y,D){y=(0,b.toUint32)(y);const S=this.values,C=this.prefixSum,i=D.length;return i===0?!1:(this.values=new Uint32Array(S.length+i),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y),y+i),this.values.set(D,y),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(y,D){return y=(0,b.toUint32)(y),D=(0,b.toUint32)(D),this.values[y]===D?!1:(this.values[y]=D,y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),!0)}removeValues(y,D){y=(0,b.toUint32)(y),D=(0,b.toUint32)(D);const S=this.values,C=this.prefixSum;if(y>=S.length)return!1;let i=S.length-y;return D>=i&&(D=i),D===0?!1:(this.values=new Uint32Array(S.length-D),this.values.set(S.subarray(0,y),0),this.values.set(S.subarray(y+D),y),this.prefixSum=new Uint32Array(this.values.length),y-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=y-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(y){return y<0?0:(y=(0,b.toUint32)(y),this._getAccumulatedValue(y))}_getAccumulatedValue(y){if(y<=this.prefixSumValidIndex[0])return this.prefixSum[y];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),y>=this.values.length&&(y=this.values.length-1);for(let S=D;S<=y;S++)this.prefixSum[S]=this.prefixSum[S-1]+this.values[S];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],y),this.prefixSum[y]}getIndexOf(y){y=Math.floor(y),this.getTotalValue();let D=0,S=this.values.length-1,C=0,i=0,I=0;for(;D<=S;)if(C=D+(S-D)/2|0,i=this.prefixSum[C],I=i-this.values[C],y<I)S=C-1;else if(y>=i)D=C+1;else break;return new k(C,y-I)}}e.PrefixSumComputer=P}),define(ve[120],be([0,1,8,38,88]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(D,S,C,i){this._uri=D,this._lines=S,this._eol=C,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const S=D.changes;for(const C of S)this._acceptDeleteRange(C.range),this._acceptInsertText(new k.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,S=this._lines.length,C=new Uint32Array(S);for(let i=0;i<S;i++)C[i]=this._lines[i].length+D;this._lineStarts=new P.PrefixSumComputer(C)}}_setLineText(D,S){this._lines[D]=S,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,S){if(S.length!==0){let C=(0,b.splitLines)(S);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let i=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),i[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,i)}}}e.MirrorTextModel=T}),define(ve[121],be([16,17]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ve[60],be([0,1,121,10,13]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(C,i){return i&&(C.stack||C.stacktrace)?b.localize(0,null,D(C),y(C.stack)||y(C.stacktrace)):D(C)}function y(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?b.localize(1,null,C.message):C.message||b.localize(2,null)}function S(C=null,i=!1){if(!C)return b.localize(3,null);if(Array.isArray(C)){const I=P.coalesce(C),h=S(I[0],i);return I.length>1?b.localize(4,null,h,I.length):h}if(k.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return T(I.error,i);if(I.exception)return T(I.exception,i)}return C.stack?T(C,i):C.message?C.message:b.localize(5,null)}e.toErrorMessage=S}),define(ve[122],be([16,17]),function(J,e){return J.create("vs/editor/common/config/editorOptions",e)}),define(ve[123],be([0,1,122,21,86]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(ee){this._values=ee}hasChanged(ee){return this._values[ee]}}e.ConfigurationChangedEvent=y;class D{constructor(){this._values=[]}_read(ee){return this._values[ee]}get(ee){return this._values[ee]}_write(ee,ge){this._values[ee]=ge}}e.ValidatedEditorOptions=D;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class C{constructor(ee,ge,Ne,Ve){this.id=ee,this.name=ge,this.defaultValue=Ne,this.schema=Ve}compute(ee,ge,Ne){return Ne}}class i{constructor(ee,ge=null){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(ee){return this.defaultValue}}class I{constructor(ee,ge,Ne,Ve){this.id=ee,this.name=ge,this.defaultValue=Ne,this.schema=Ve}validate(ee){return typeof ee=="undefined"?this.defaultValue:ee}compute(ee,ge,Ne){return Ne}}function h(z,ee){return typeof z=="undefined"?ee:z==="false"?!1:Boolean(z)}e.boolean=h;class d extends I{constructor(ee,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Ne),super(ee,ge,Ne,Ve)}validate(ee){return h(ee,this.defaultValue)}}class r extends I{constructor(ee,ge,Ne,Ve,$e,Ze=void 0){typeof Ze!="undefined"&&(Ze.type="integer",Ze.default=Ne,Ze.minimum=Ve,Ze.maximum=$e),super(ee,ge,Ne,Ze),this.minimum=Ve,this.maximum=$e}static clampedInt(ee,ge,Ne,Ve){if(typeof ee=="undefined")return ge;let $e=parseInt(ee,10);return isNaN($e)?ge:($e=Math.max(Ne,$e),$e=Math.min(Ve,$e),$e|0)}validate(ee){return r.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}class o extends I{constructor(ee,ge,Ne,Ve,$e){typeof $e!="undefined"&&($e.type="number",$e.default=Ne),super(ee,ge,Ne,$e),this.validationFn=Ve}static clamp(ee,ge,Ne){return ee<ge?ge:ee>Ne?Ne:ee}static float(ee,ge){if(typeof ee=="number")return ee;if(typeof ee=="undefined")return ge;const Ne=parseFloat(ee);return isNaN(Ne)?ge:Ne}validate(ee){return this.validationFn(o.float(ee,this.defaultValue))}}class v extends I{static string(ee,ge){return typeof ee!="string"?ge:ee}constructor(ee,ge,Ne,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Ne),super(ee,ge,Ne,Ve)}validate(ee){return v.string(ee,this.defaultValue)}}function p(z,ee,ge){return typeof z!="string"||ge.indexOf(z)===-1?ee:z}e.stringSet=p;class E extends I{constructor(ee,ge,Ne,Ve,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.enum=Ve,$e.default=Ne),super(ee,ge,Ne,$e),this._allowedValues=Ve}validate(ee){return p(ee,this.defaultValue,this._allowedValues)}}class c extends C{constructor(ee,ge,Ne,Ve,$e,Ze,ye=void 0){typeof ye!="undefined"&&(ye.type="string",ye.enum=$e,ye.default=Ve),super(ee,ge,Ne,ye),this._allowedValues=$e,this._convert=Ze}validate(ee){return typeof ee!="string"?this.defaultValue:this._allowedValues.indexOf(ee)===-1?this.defaultValue:this._convert(ee)}}function l(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",description:b.localize(3,null)})}validate(ee){switch(ee){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ee,ge,Ne){return Ne===0?ee.accessibilitySupport:Ne}}class t extends C{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:b.localize(5,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{insertSpace:h(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function a(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(z){switch(z){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function g(z){switch(z){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class _ extends i{constructor(){super(123,[62,31])}compute(ee,ge,Ne){const Ve=["monaco-editor"];return ge.get(31)&&Ve.push(ge.get(31)),ee.extraEditorClassName&&Ve.push(ee.extraEditorClassName),ge.get(62)==="default"?Ve.push("mouse-default"):ge.get(62)==="copy"&&Ve.push("mouse-copy"),ge.get(97)&&Ve.push("showUnused"),ge.get(121)&&Ve.push("showDeprecated"),Ve.join(" ")}}class A extends d{constructor(){super(30,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(ee,ge,Ne){return Ne&&ee.emptySelectionClipboard}}class m extends C{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ee.seedSearchStringFromSelection,description:b.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[b.localize(9,null),b.localize(10,null),b.localize(11,null)],description:b.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:b.localize(13,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:b.localize(14,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:b.localize(15,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{cursorMoveOnType:h(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:h(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":p(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(ge.loop,this.defaultValue.loop)}}}class w extends C{constructor(){super(41,"fontLigatures",w.OFF,{anyOf:[{type:"boolean",description:b.localize(16,null)},{type:"string",description:b.localize(17,null)}],description:b.localize(18,null),default:!1})}validate(ee){return typeof ee=="undefined"?this.defaultValue:typeof ee=="string"?ee==="false"?w.OFF:ee==="true"?w.ON:ee:Boolean(ee)?w.ON:w.OFF}}e.EditorFontLigatures=w,w.OFF='"liga" off, "calt" off',w.ON='"liga" on, "calt" on';class R extends i{constructor(){super(40)}compute(ee,ge,Ne){return ee.fontInfo}}class $ extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(19,null)})}validate(ee){let ge=o.float(ee,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:o.clamp(ge,6,100)}compute(ee,ge,Ne){return ee.fontInfo.fontSize}}class K extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:b.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(21,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(r.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class he extends C{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[b.localize(22,null),b.localize(23,null),b.localize(24,null)]},Ne=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:b.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:b.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:b.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:b.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:b.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Ne,description:b.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Ne,description:b.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Ne,description:b.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Ne,description:b.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Ne,description:b.localize(35,null)}})}validate(ee){var ge,Ne,Ve,$e,Ze;if(!ee||typeof ee!="object")return this.defaultValue;const ye=ee;return{multiple:p(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=ye.multipleDefinitions)!==null&&ge!==void 0?ge:p(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Ne=ye.multipleTypeDefinitions)!==null&&Ne!==void 0?Ne:p(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ve=ye.multipleDeclarations)!==null&&Ve!==void 0?Ve:p(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:($e=ye.multipleImplementations)!==null&&$e!==void 0?$e:p(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ze=ye.multipleReferences)!==null&&Ze!==void 0?Ze:p(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class V extends C{constructor(){const ee={enabled:!0,delay:300,sticky:!0};super(50,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:b.localize(36,null)},"editor.hover.delay":{type:"number",default:ee.delay,description:b.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:b.localize(38,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:h(ge.enabled,this.defaultValue.enabled),delay:r.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:h(ge.sticky,this.defaultValue.sticky)}}}var H;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(H=e.RenderMinimap||(e.RenderMinimap={}));class Y extends i{constructor(){super(126,[46,54,35,61,89,56,57,91,113,116,117,118,2])}compute(ee,ge,Ne){return Y.computeLayout(ge,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio})}static computeContainedMinimapLineCount(ee){const ge=ee.height/ee.lineHeight,Ne=ee.scrollBeyondLastLine?ge-1:0,Ve=(ee.viewLineCount+Ne)/(ee.pixelRatio*ee.height),$e=Math.floor(ee.viewLineCount/Ve);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Ne,desiredRatio:Ve,minimapLineCount:$e}}static _computeMinimapLayout(ee,ge){const Ne=ee.outerWidth,Ve=ee.outerHeight,$e=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor($e*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const Ze=ge.stableMinimapLayoutInput,ye=Ze&&ee.outerHeight===Ze.outerHeight&&ee.lineHeight===Ze.lineHeight&&ee.typicalHalfwidthCharacterWidth===Ze.typicalHalfwidthCharacterWidth&&ee.pixelRatio===Ze.pixelRatio&&ee.scrollBeyondLastLine===Ze.scrollBeyondLastLine&&ee.minimap.enabled===Ze.minimap.enabled&&ee.minimap.side===Ze.minimap.side&&ee.minimap.size===Ze.minimap.size&&ee.minimap.showSlider===Ze.minimap.showSlider&&ee.minimap.renderCharacters===Ze.minimap.renderCharacters&&ee.minimap.maxColumn===Ze.minimap.maxColumn&&ee.minimap.scale===Ze.minimap.scale&&ee.verticalScrollbarWidth===Ze.verticalScrollbarWidth&&ee.isViewportWrapping===Ze.isViewportWrapping,Ee=ee.lineHeight,Ce=ee.typicalHalfwidthCharacterWidth,re=ee.scrollBeyondLastLine,le=ee.minimap.renderCharacters;let N=$e>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Q=ee.minimap.maxColumn,ae=ee.minimap.size,ke=ee.minimap.side,Ie=ee.verticalScrollbarWidth,Ae=ee.viewLineCount,xe=ee.remainingWidth,Ye=ee.isViewportWrapping,rt=le?2:3;let tt=Math.floor($e*Ve);const Qe=tt/$e;let mt=!1,bt=!1,pe=rt*N,ce=N/$e,se=1;if(ae==="fill"||ae==="fit"){const{typicalViewportLineCount:ht,extraLinesBeyondLastLine:Xe,desiredRatio:at,minimapLineCount:ft}=Y.computeContainedMinimapLineCount({viewLineCount:Ae,scrollBeyondLastLine:re,height:Ve,lineHeight:Ee,pixelRatio:$e});if(Ae/ft>1)mt=!0,bt=!0,N=1,pe=1,ce=N/$e;else{let Et=!1,vt=N+1;if(ae==="fit"){const kt=Math.ceil((Ae+Xe)*pe);Ye&&ye&&xe<=ge.stableFitRemainingWidth?(Et=!0,vt=ge.stableFitMaxMinimapScale):(Et=kt>tt,Ye&&Et?(ge.stableMinimapLayoutInput=ee,ge.stableFitRemainingWidth=xe):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0))}if(ae==="fill"||Et){mt=!0;const kt=N;pe=Math.min(Ee*$e,Math.max(1,Math.floor(1/at))),N=Math.min(vt,Math.max(1,Math.floor(pe/rt))),N>kt&&(se=Math.min(2,N/kt)),ce=N/$e/se,tt=Math.ceil(Math.max(ht,Ae+Xe)*pe),Ye&&Et&&(ge.stableFitMaxMinimapScale=N)}}}const q=Math.floor(Q*ce),Me=Math.min(q,Math.max(0,Math.floor((xe-Ie-2)*ce/(Ce+ce)))+e.MINIMAP_GUTTER_WIDTH);let Te=Math.floor($e*Me);const Je=Te/$e;Te=Math.floor(Te*se);const et=le?1:2,ct=ke==="left"?0:Ne-Me-Ie;return{renderMinimap:et,minimapLeft:ct,minimapWidth:Me,minimapHeightIsEditorHeight:mt,minimapIsSampling:bt,minimapScale:N,minimapLineHeight:pe,minimapCanvasInnerWidth:Te,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Je,minimapCanvasOuterHeight:Qe}}static computeLayout(ee,ge){const Ne=ge.outerWidth|0,Ve=ge.outerHeight|0,$e=ge.lineHeight|0,Ze=ge.lineNumbersDigitCount|0,ye=ge.typicalHalfwidthCharacterWidth,Ee=ge.maxDigitWidth,Ce=ge.pixelRatio,re=ge.viewLineCount,le=ee.get(118),N=le==="inherit"?ee.get(117):le,Q=N==="inherit"?ee.get(113):N,ae=ee.get(116),ke=ee.get(2),Ie=ge.isDominatedByLongLines,Ae=ee.get(46),xe=ee.get(56).renderType!==0,Ye=ee.get(57),rt=ee.get(91),tt=ee.get(61),Qe=ee.get(89),mt=Qe.verticalScrollbarSize,bt=Qe.verticalHasArrows,pe=Qe.arrowSize,ce=Qe.horizontalScrollbarSize,se=ee.get(54),q=ee.get(35);let Me;if(typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)){const _t=parseFloat(se.substr(0,se.length-2));Me=r.clampedInt(_t*ye,0,0,1e3)}else Me=r.clampedInt(se,0,0,1e3);q&&(Me+=16);let Te=0;if(xe){const _t=Math.max(Ze,Ye);Te=Math.round(_t*Ee)}let Je=0;Ae&&(Je=$e);let et=0,ct=et+Je,ht=ct+Te,Xe=ht+Me;const at=Ne-Je-Te-Me;let ft=!1,lt=!1,Et=-1;ke!==2&&(N==="inherit"&&Ie?(ft=!0,lt=!0):Q==="on"||Q==="bounded"?lt=!0:Q==="wordWrapColumn"&&(Et=ae));const vt=Y._computeMinimapLayout({outerWidth:Ne,outerHeight:Ve,lineHeight:$e,typicalHalfwidthCharacterWidth:ye,pixelRatio:Ce,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:mt,viewLineCount:re,remainingWidth:at,isViewportWrapping:lt},ge.memory||new S);vt.renderMinimap!==0&&vt.minimapLeft===0&&(et+=vt.minimapWidth,ct+=vt.minimapWidth,ht+=vt.minimapWidth,Xe+=vt.minimapWidth);const kt=at-vt.minimapWidth,At=Math.max(1,Math.floor((kt-mt-2)/ye)),Tt=bt?pe:0;return lt&&(Et=Math.max(1,At),Q==="bounded"&&(Et=Math.min(Et,ae))),{width:Ne,height:Ve,glyphMarginLeft:et,glyphMarginWidth:Je,lineNumbersLeft:ct,lineNumbersWidth:Te,decorationsLeft:ht,decorationsWidth:Me,contentLeft:Xe,contentWidth:kt,minimap:vt,viewportColumn:At,isWordWrapMinified:ft,isViewportWrapping:lt,wrappingColumn:Et,verticalScrollbarWidth:mt,horizontalScrollbarHeight:ce,overviewRuler:{top:Tt,width:mt,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=Y;class U extends C{constructor(){const ee={enabled:!0};super(53,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"boolean",default:ee.enabled,description:b.localize(39,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:h(ee.enabled,this.defaultValue.enabled)}}}class F extends C{constructor(){const ee={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(122,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"boolean",default:ee.enabled,description:b.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,description:b.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,description:b.localize(42,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:h(ge.enabled,this.defaultValue.enabled),fontSize:r.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class L extends r{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:b.localize(43,null)})}compute(ee,ge,Ne){return ee.fontInfo.lineHeight}}class M extends C{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:b.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(45,null),b.localize(46,null),b.localize(47,null)],default:ee.size,description:b.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:b.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:b.localize(50,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:b.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:b.localize(53,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:h(ge.enabled,this.defaultValue.enabled),size:p(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(ge.side,this.defaultValue.side,["right","left"]),showSlider:p(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(ge.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(ge.scale,1,1,3),maxColumn:r.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function x(z){return z==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class G extends C{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(55,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{top:r.clampedInt(ge.top,0,0,1e3),bottom:r.clampedInt(ge.bottom,0,0,1e3)}}}class X extends C{constructor(){const ee={enabled:!0,cycle:!1};super(72,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:b.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:b.localize(57,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{enabled:h(ge.enabled,this.defaultValue.enabled),cycle:h(ge.cycle,this.defaultValue.cycle)}}}class ne extends i{constructor(){super(124)}compute(ee,ge,Ne){return ee.pixelRatio}}class me extends C{constructor(){const ee={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",ee,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ee.strings,description:b.localize(58,null)},comments:{type:"boolean",default:ee.comments,description:b.localize(59,null)},other:{type:"boolean",default:ee.other,description:b.localize(60,null)}}}],default:ee,description:b.localize(61,null)});this.defaultValue=ee}validate(ee){if(typeof ee=="boolean")return ee;if(ee&&typeof ee=="object"){const ge=ee,Ne={other:h(ge.other,this.defaultValue.other),comments:h(ge.comments,this.defaultValue.comments),strings:h(ge.strings,this.defaultValue.strings)};return Ne.other&&Ne.comments&&Ne.strings?!0:!Ne.other&&!Ne.comments&&!Ne.strings?!1:Ne}return this.defaultValue}}var Le;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(Le=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class We extends C{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(62,null),b.localize(63,null),b.localize(64,null),b.localize(65,null)],default:"on",description:b.localize(66,null)})}validate(ee){let ge=this.defaultValue.renderType,Ne=this.defaultValue.renderFn;return typeof ee!="undefined"&&(typeof ee=="function"?(ge=4,Ne=ee):ee==="interval"?ge=3:ee==="relative"?ge=2:ee==="on"?ge=1:ge=0),{renderType:ge,renderFn:Ne}}}function Fe(z){const ee=z.get(84);return ee==="editable"?z.get(77):ee!=="on"}e.filterValidationDecorations=Fe;class ze extends C{constructor(){const ee=[],ge={type:"number",description:b.localize(67,null)};super(88,"rulers",ee,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:b.localize(68,null),format:"color-hex"}}}]},default:ee,description:b.localize(69,null)})}validate(ee){if(Array.isArray(ee)){let ge=[];for(let Ne of ee)if(typeof Ne=="number")ge.push({column:r.clampedInt(Ne,0,0,1e4),color:null});else if(Ne&&typeof Ne=="object"){const Ve=Ne;ge.push({column:r.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ge.sort((Ne,Ve)=>Ne.column-Ve.column),ge}return this.defaultValue}}function W(z,ee){if(typeof z!="string")return ee;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class j extends C{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee,Ne=r.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=r.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:W(ge.vertical,this.defaultValue.vertical),horizontal:W(ge.horizontal,this.defaultValue.horizontal),useShadows:h(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ne,horizontalSliderSize:r.clampedInt(ge.horizontalSliderSize,Ne,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:r.clampedInt(ge.verticalSliderSize,Ve,0,1e3),scrollByPage:h(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class te extends C{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(70,null),b.localize(71,null)],default:ee.insertMode,description:b.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:b.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:b.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:b.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:b.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:b.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:b.localize(78,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:b.localize(79,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(80,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(81,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(82,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(83,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(84,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(85,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(86,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(87,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(88,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(89,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(90,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(91,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(92,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(93,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(94,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(95,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(96,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(97,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(98,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(99,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(100,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(101,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(102,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(103,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(104,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(105,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(106,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(107,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(108,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(109,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const ge=ee;return{insertMode:p(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(ge.showIcons,this.defaultValue.showIcons),showStatusBar:h(ge.showStatusBar,this.defaultValue.showStatusBar),showInlineDetails:h(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(ge.showMethods,this.defaultValue.showMethods),showFunctions:h(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:h(ge.showConstructors,this.defaultValue.showConstructors),showFields:h(ge.showFields,this.defaultValue.showFields),showVariables:h(ge.showVariables,this.defaultValue.showVariables),showClasses:h(ge.showClasses,this.defaultValue.showClasses),showStructs:h(ge.showStructs,this.defaultValue.showStructs),showInterfaces:h(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:h(ge.showModules,this.defaultValue.showModules),showProperties:h(ge.showProperties,this.defaultValue.showProperties),showEvents:h(ge.showEvents,this.defaultValue.showEvents),showOperators:h(ge.showOperators,this.defaultValue.showOperators),showUnits:h(ge.showUnits,this.defaultValue.showUnits),showValues:h(ge.showValues,this.defaultValue.showValues),showConstants:h(ge.showConstants,this.defaultValue.showConstants),showEnums:h(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:h(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(ge.showKeywords,this.defaultValue.showKeywords),showWords:h(ge.showWords,this.defaultValue.showWords),showColors:h(ge.showColors,this.defaultValue.showColors),showFiles:h(ge.showFiles,this.defaultValue.showFiles),showReferences:h(ge.showReferences,this.defaultValue.showReferences),showFolders:h(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:h(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(ge.showSnippets,this.defaultValue.showSnippets),showUsers:h(ge.showUsers,this.defaultValue.showUsers),showIssues:h(ge.showIssues,this.defaultValue.showIssues)}}}class oe extends C{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(110,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class de extends i{constructor(){super(125,[77])}compute(ee,ge,Ne){return ge.get(77)?!0:ee.tabFocusMode}}var _e;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(_e=e.WrappingIndent||(e.WrappingIndent={}));function Be(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends i{constructor(){super(127,[126])}compute(ee,ge,Ne){const Ve=ge.get(126);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const De="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Re:k.isLinux?He:De,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var qe;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.codeLens=12]="codeLens",z[z.codeLensFontFamily=13]="codeLensFontFamily",z[z.codeLensFontSize=14]="codeLensFontSize",z[z.colorDecorators=15]="colorDecorators",z[z.columnSelection=16]="columnSelection",z[z.comments=17]="comments",z[z.contextmenu=18]="contextmenu",z[z.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",z[z.cursorBlinking=20]="cursorBlinking",z[z.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",z[z.cursorStyle=22]="cursorStyle",z[z.cursorSurroundingLines=23]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",z[z.cursorWidth=25]="cursorWidth",z[z.disableLayerHinting=26]="disableLayerHinting",z[z.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",z[z.domReadOnly=28]="domReadOnly",z[z.dragAndDrop=29]="dragAndDrop",z[z.emptySelectionClipboard=30]="emptySelectionClipboard",z[z.extraEditorClassName=31]="extraEditorClassName",z[z.fastScrollSensitivity=32]="fastScrollSensitivity",z[z.find=33]="find",z[z.fixedOverflowWidgets=34]="fixedOverflowWidgets",z[z.folding=35]="folding",z[z.foldingStrategy=36]="foldingStrategy",z[z.foldingHighlight=37]="foldingHighlight",z[z.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=39]="fontFamily",z[z.fontInfo=40]="fontInfo",z[z.fontLigatures=41]="fontLigatures",z[z.fontSize=42]="fontSize",z[z.fontWeight=43]="fontWeight",z[z.formatOnPaste=44]="formatOnPaste",z[z.formatOnType=45]="formatOnType",z[z.glyphMargin=46]="glyphMargin",z[z.gotoLocation=47]="gotoLocation",z[z.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",z[z.hover=50]="hover",z[z.inDiffEditor=51]="inDiffEditor",z[z.letterSpacing=52]="letterSpacing",z[z.lightbulb=53]="lightbulb",z[z.lineDecorationsWidth=54]="lineDecorationsWidth",z[z.lineHeight=55]="lineHeight",z[z.lineNumbers=56]="lineNumbers",z[z.lineNumbersMinChars=57]="lineNumbersMinChars",z[z.linkedEditing=58]="linkedEditing",z[z.links=59]="links",z[z.matchBrackets=60]="matchBrackets",z[z.minimap=61]="minimap",z[z.mouseStyle=62]="mouseStyle",z[z.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=64]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",z[z.multiCursorModifier=66]="multiCursorModifier",z[z.multiCursorPaste=67]="multiCursorPaste",z[z.occurrencesHighlight=68]="occurrencesHighlight",z[z.overviewRulerBorder=69]="overviewRulerBorder",z[z.overviewRulerLanes=70]="overviewRulerLanes",z[z.padding=71]="padding",z[z.parameterHints=72]="parameterHints",z[z.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",z[z.quickSuggestions=75]="quickSuggestions",z[z.quickSuggestionsDelay=76]="quickSuggestionsDelay",z[z.readOnly=77]="readOnly",z[z.renameOnType=78]="renameOnType",z[z.renderControlCharacters=79]="renderControlCharacters",z[z.renderIndentGuides=80]="renderIndentGuides",z[z.renderFinalNewline=81]="renderFinalNewline",z[z.renderLineHighlight=82]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=84]="renderValidationDecorations",z[z.renderWhitespace=85]="renderWhitespace",z[z.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",z[z.roundedSelection=87]="roundedSelection",z[z.rulers=88]="rulers",z[z.scrollbar=89]="scrollbar",z[z.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=91]="scrollBeyondLastLine",z[z.scrollPredominantAxis=92]="scrollPredominantAxis",z[z.selectionClipboard=93]="selectionClipboard",z[z.selectionHighlight=94]="selectionHighlight",z[z.selectOnLineNumbers=95]="selectOnLineNumbers",z[z.showFoldingControls=96]="showFoldingControls",z[z.showUnused=97]="showUnused",z[z.snippetSuggestions=98]="snippetSuggestions",z[z.smartSelect=99]="smartSelect",z[z.smoothScrolling=100]="smoothScrolling",z[z.stickyTabStops=101]="stickyTabStops",z[z.stopRenderingLineAfter=102]="stopRenderingLineAfter",z[z.suggest=103]="suggest",z[z.suggestFontSize=104]="suggestFontSize",z[z.suggestLineHeight=105]="suggestLineHeight",z[z.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",z[z.suggestSelection=107]="suggestSelection",z[z.tabCompletion=108]="tabCompletion",z[z.tabIndex=109]="tabIndex",z[z.unusualLineTerminators=110]="unusualLineTerminators",z[z.useTabStops=111]="useTabStops",z[z.wordSeparators=112]="wordSeparators",z[z.wordWrap=113]="wordWrap",z[z.wordWrapBreakAfterCharacters=114]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=115]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=116]="wordWrapColumn",z[z.wordWrapOverride1=117]="wordWrapOverride1",z[z.wordWrapOverride2=118]="wordWrapOverride2",z[z.wrappingIndent=119]="wrappingIndent",z[z.wrappingStrategy=120]="wrappingStrategy",z[z.showDeprecated=121]="showDeprecated",z[z.inlayHints=122]="inlayHints",z[z.editorClassName=123]="editorClassName",z[z.pixelRatio=124]="pixelRatio",z[z.tabFocusMode=125]="tabFocusMode",z[z.layoutInfo=126]="layoutInfo",z[z.wrappingInfo=127]="wrappingInfo"})(qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(111,null)})),acceptSuggestionOnEnter:we(new E(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(112,null),""],markdownDescription:b.localize(113,null)})),accessibilitySupport:we(new f),accessibilityPageSize:we(new r(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(114,null)})),ariaLabel:we(new v(4,"ariaLabel",b.localize(115,null))),autoClosingBrackets:we(new E(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(116,null),b.localize(117,null),""],description:b.localize(118,null)})),autoClosingDelete:we(new E(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(119,null),""],description:b.localize(120,null)})),autoClosingOvertype:we(new E(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(121,null),""],description:b.localize(122,null)})),autoClosingQuotes:we(new E(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(123,null),b.localize(124,null),""],description:b.localize(125,null)})),autoIndent:we(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],l,{enumDescriptions:[b.localize(126,null),b.localize(127,null),b.localize(128,null),b.localize(129,null),b.localize(130,null)],description:b.localize(131,null)})),automaticLayout:we(new d(10,"automaticLayout",!1)),autoSurround:we(new E(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(132,null),b.localize(133,null),b.localize(134,null),""],description:b.localize(135,null)})),stickyTabStops:we(new d(101,"stickyTabStops",!1,{description:b.localize(136,null)})),codeLens:we(new d(12,"codeLens",!0,{description:b.localize(137,null)})),codeLensFontFamily:we(new v(13,"codeLensFontFamily","",{description:b.localize(138,null)})),codeLensFontSize:we(new r(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:b.localize(139,null)})),colorDecorators:we(new d(15,"colorDecorators",!0,{description:b.localize(140,null)})),columnSelection:we(new d(16,"columnSelection",!1,{description:b.localize(141,null)})),comments:we(new t),contextmenu:we(new d(18,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new d(19,"copyWithSyntaxHighlighting",!0,{description:b.localize(142,null)})),cursorBlinking:we(new c(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],a,{description:b.localize(143,null)})),cursorSmoothCaretAnimation:we(new d(21,"cursorSmoothCaretAnimation",!1,{description:b.localize(144,null)})),cursorStyle:we(new c(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],g,{description:b.localize(145,null)})),cursorSurroundingLines:we(new r(23,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(146,null)})),cursorSurroundingLinesStyle:we(new E(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(147,null),b.localize(148,null)],description:b.localize(149,null)})),cursorWidth:we(new r(25,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(150,null)})),disableLayerHinting:we(new d(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new d(27,"disableMonospaceOptimizations",!1)),domReadOnly:we(new d(28,"domReadOnly",!1)),dragAndDrop:we(new d(29,"dragAndDrop",!0,{description:b.localize(151,null)})),emptySelectionClipboard:we(new A),extraEditorClassName:we(new v(31,"extraEditorClassName","")),fastScrollSensitivity:we(new o(32,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:b.localize(152,null)})),find:we(new m),fixedOverflowWidgets:we(new d(34,"fixedOverflowWidgets",!1)),folding:we(new d(35,"folding",!0,{description:b.localize(153,null)})),foldingStrategy:we(new E(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(154,null),b.localize(155,null)],description:b.localize(156,null)})),foldingHighlight:we(new d(37,"foldingHighlight",!0,{description:b.localize(157,null)})),unfoldOnClickAfterEndOfLine:we(new d(38,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(158,null)})),fontFamily:we(new v(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(159,null)})),fontInfo:we(new R),fontLigatures2:we(new w),fontSize:we(new $),fontWeight:we(new K),formatOnPaste:we(new d(44,"formatOnPaste",!1,{description:b.localize(160,null)})),formatOnType:we(new d(45,"formatOnType",!1,{description:b.localize(161,null)})),glyphMargin:we(new d(46,"glyphMargin",!0,{description:b.localize(162,null)})),gotoLocation:we(new he),hideCursorInOverviewRuler:we(new d(48,"hideCursorInOverviewRuler",!1,{description:b.localize(163,null)})),highlightActiveIndentGuide:we(new d(49,"highlightActiveIndentGuide",!0,{description:b.localize(164,null)})),hover:we(new V),inDiffEditor:we(new d(51,"inDiffEditor",!1)),letterSpacing:we(new o(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>o.clamp(z,-5,20),{description:b.localize(165,null)})),lightbulb:we(new U),lineDecorationsWidth:we(new I(54,"lineDecorationsWidth",10)),lineHeight:we(new L),lineNumbers:we(new We),lineNumbersMinChars:we(new r(57,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new d(58,"linkedEditing",!1,{description:b.localize(166,null)})),links:we(new d(59,"links",!0,{description:b.localize(167,null)})),matchBrackets:we(new E(60,"matchBrackets","always",["always","near","never"],{description:b.localize(168,null)})),minimap:we(new M),mouseStyle:we(new E(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new o(63,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:b.localize(169,null)})),mouseWheelZoom:we(new d(64,"mouseWheelZoom",!1,{markdownDescription:b.localize(170,null)})),multiCursorMergeOverlapping:we(new d(65,"multiCursorMergeOverlapping",!0,{description:b.localize(171,null)})),multiCursorModifier:we(new c(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],x,{markdownEnumDescriptions:[b.localize(172,null),b.localize(173,null)],markdownDescription:b.localize(174,null)})),multiCursorPaste:we(new E(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(175,null),b.localize(176,null)],markdownDescription:b.localize(177,null)})),occurrencesHighlight:we(new d(68,"occurrencesHighlight",!0,{description:b.localize(178,null)})),overviewRulerBorder:we(new d(69,"overviewRulerBorder",!0,{description:b.localize(179,null)})),overviewRulerLanes:we(new r(70,"overviewRulerLanes",3,0,3)),padding:we(new G),parameterHints:we(new X),peekWidgetDefaultFocus:we(new E(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(180,null),b.localize(181,null)],description:b.localize(182,null)})),definitionLinkOpensInPeek:we(new d(74,"definitionLinkOpensInPeek",!1,{description:b.localize(183,null)})),quickSuggestions:we(new me),quickSuggestionsDelay:we(new r(76,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(184,null)})),readOnly:we(new d(77,"readOnly",!1)),renameOnType:we(new d(78,"renameOnType",!1,{description:b.localize(185,null),markdownDeprecationMessage:b.localize(186,null)})),renderControlCharacters:we(new d(79,"renderControlCharacters",!1,{description:b.localize(187,null)})),renderIndentGuides:we(new d(80,"renderIndentGuides",!0,{description:b.localize(188,null)})),renderFinalNewline:we(new d(81,"renderFinalNewline",!0,{description:b.localize(189,null)})),renderLineHighlight:we(new E(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(190,null)],description:b.localize(191,null)})),renderLineHighlightOnlyWhenFocus:we(new d(83,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(192,null)})),renderValidationDecorations:we(new E(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new E(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(193,null),b.localize(194,null),b.localize(195,null),""],description:b.localize(196,null)})),revealHorizontalRightPadding:we(new r(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new d(87,"roundedSelection",!0,{description:b.localize(197,null)})),rulers:we(new ze),scrollbar:we(new j),scrollBeyondLastColumn:we(new r(90,"scrollBeyondLastColumn",5,0,1073741824,{description:b.localize(198,null)})),scrollBeyondLastLine:we(new d(91,"scrollBeyondLastLine",!0,{description:b.localize(199,null)})),scrollPredominantAxis:we(new d(92,"scrollPredominantAxis",!0,{description:b.localize(200,null)})),selectionClipboard:we(new d(93,"selectionClipboard",!0,{description:b.localize(201,null),included:k.isLinux})),selectionHighlight:we(new d(94,"selectionHighlight",!0,{description:b.localize(202,null)})),selectOnLineNumbers:we(new d(95,"selectOnLineNumbers",!0)),showFoldingControls:we(new E(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[b.localize(203,null),b.localize(204,null)],description:b.localize(205,null)})),showUnused:we(new d(97,"showUnused",!0,{description:b.localize(206,null)})),showDeprecated:we(new d(121,"showDeprecated",!0,{description:b.localize(207,null)})),inlayHints:we(new F),snippetSuggestions:we(new E(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(208,null),b.localize(209,null),b.localize(210,null),b.localize(211,null)],description:b.localize(212,null)})),smartSelect:we(new oe),smoothScrolling:we(new d(100,"smoothScrolling",!1,{description:b.localize(213,null)})),stopRenderingLineAfter:we(new r(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new te),suggestFontSize:we(new r(104,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(214,null)})),suggestLineHeight:we(new r(105,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(215,null)})),suggestOnTriggerCharacters:we(new d(106,"suggestOnTriggerCharacters",!0,{description:b.localize(216,null)})),suggestSelection:we(new E(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null)],description:b.localize(220,null)})),tabCompletion:we(new E(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(221,null),b.localize(222,null),b.localize(223,null)],description:b.localize(224,null)})),tabIndex:we(new r(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new E(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(225,null),b.localize(226,null),b.localize(227,null)],description:b.localize(228,null)})),useTabStops:we(new d(111,"useTabStops",!0,{description:b.localize(229,null)})),wordSeparators:we(new v(112,"wordSeparators",P.USUAL_WORD_SEPARATORS,{description:b.localize(230,null)})),wordWrap:we(new E(113,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(231,null),b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),wordWrapBreakAfterCharacters:we(new v(114,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new v(115,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new r(116,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(236,null)})),wordWrapOverride1:we(new E(117,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new E(118,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new c(119,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],Be,{enumDescriptions:[b.localize(237,null),b.localize(238,null),b.localize(239,null),b.localize(240,null)],description:b.localize(241,null)})),wrappingStrategy:we(new E(120,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[b.localize(242,null),b.localize(243,null)],description:b.localize(244,null)})),editorClassName:we(new _),pixelRatio:we(new ne),tabFocusMode:we(new de),layoutInfo:we(new Y),wrappingInfo:we(new fe)}}),define(ve[124],be([16,17]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[125],be([16,17]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[126],be([16,17]),function(J,e){return J.create("vs/platform/files/common/files",e)}),define(ve[127],be([16,17]),function(J,e){return J.create("vs/platform/markers/common/markers",e)}),define(ve[128],be([16,17]),function(J,e){return J.create("vs/platform/theme/common/iconRegistry",e)}),define(ve[129],be([16,17]),function(J,e){return J.create("vs/platform/workspaces/common/workspaces",e)}),define(ve[130],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHost.api.impl",e)}),define(ve[131],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ve[132],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ve[133],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostProgress",e)}),define(ve[134],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ve[135],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ve[136],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ve[137],be([16,17]),function(J,e){return J.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ve[138],be([16,17]),function(J,e){return J.create("vs/workbench/common/views",e)}),define(ve[139],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ve[140],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(ve[141],be([16,17]),function(J,e){return J.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(ve[142],be([16,17]),function(J,e){return J.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[143],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var b;(function(y){y[y.ACTIVATE=0]="ACTIVATE",y[y.RESTORE=1]="RESTORE",y[y.PRESERVE=2]="PRESERVE"})(b=e.EditorActivation||(e.EditorActivation={}));var k;(function(y){y[y.PICK=1]="PICK",y[y.DISABLED=2]="DISABLED"})(k=e.EditorOverride||(e.EditorOverride={}));var P;(function(y){y[y.API=0]="API",y[y.USER=1]="USER"})(P=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(y){y[y.Center=0]="Center",y[y.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",y[y.NearTop=2]="NearTop",y[y.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(ve[144],be([0,1,125]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function P(I){return I=I.trim(),I==="*"||k.test(I)}e.isValidVersionStr=P;function T(I){if(!P(I))return null;if(I=I.trim(),I==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=I.match(k);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=T;function y(I){if(!I)return null;let h=I.majorBase,d=I.majorMustEqual,r=I.minorBase,o=I.minorMustEqual,v=I.patchBase,p=I.patchMustEqual;return I.hasCaret&&(h===0||(o=!1),p=!1),{majorBase:h,majorMustEqual:d,minorBase:r,minorMustEqual:o,patchBase:v,patchMustEqual:p,isMinimum:I.hasGreaterEquals}}e.normalizeVersion=y;function D(I,h){let d;typeof I=="string"?d=y(T(I)):d=I;let r;if(typeof h=="string"?r=y(T(h)):r=h,!d||!r)return!1;let o=d.majorBase,v=d.minorBase,p=d.patchBase,E=r.majorBase,c=r.minorBase,l=r.patchBase,f=r.majorMustEqual,t=r.minorMustEqual,n=r.patchMustEqual;return r.isMinimum?o>E?!0:o<E?!1:v>c?!0:v<c?!1:p>=l:(o===1&&E===0&&(!f||!t||!n)&&(E=1,c=0,l=0,f=!0,t=!1,n=!1),o<E?!1:o>E?!f:v<c?!1:v>c?!t:p<l?!1:p>l?!n:!0)}e.isValidVersion=D;function S(I,h,d){return h.isBuiltin||typeof h.main=="undefined"?!0:i(I,h.engines.vscode,d)}e.isValidExtensionVersion=S;function C(I,h){return I==="*"||i(h,I)}e.isEngineValid=C;function i(I,h,d=[]){let r=y(T(h));if(!r)return d.push(b.localize(0,null,h)),!1;if(r.majorBase===0){if(!r.majorMustEqual||!r.minorMustEqual)return d.push(b.localize(1,null,h)),!1}else if(!r.majorMustEqual)return d.push(b.localize(2,null,h)),!1;return D(I,r)?!0:(d.push(b.localize(3,null,I,h)),!1)}e.isVersionValid=i}),define(ve[89],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class b{constructor(T,y=[],D=!1){this.ctor=T,this.staticArguments=y,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=b;const k=(P,...T)=>new b(P,T);e.createSyncDescriptor=k}),define(ve[61],be([0,1,89]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function P(y,D,S){D instanceof b.SyncDescriptor||(D=new b.SyncDescriptor(D,[],S)),k.push([y,D])}e.registerSingleton=P;function T(){return k}e.getSingletonServiceDescriptors=T}),define(ve[145],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class b{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=b;class k{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let y of this._nodes.values())y.outgoing.size===0&&T.push(y);return T}insertEdge(T,y){const D=this.lookupOrInsertNode(T),S=this.lookupOrInsertNode(y);D.outgoing.set(this._hashFn(y),S),S.incoming.set(this._hashFn(T),D)}removeNode(T){const y=this._hashFn(T);this._nodes.delete(y);for(let D of this._nodes.values())D.outgoing.delete(y),D.incoming.delete(y)}lookupOrInsertNode(T){const y=this._hashFn(T);let D=this._nodes.get(y);return D||(D=new b(T),this._nodes.set(y,D)),D}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[y,D]of this._nodes)T.push(`${y}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,y]of this._nodes){const D=new Set([T]),S=this._findCycle(y,D);if(S)return S}}_findCycle(T,y){for(let[D,S]of T.outgoing){if(y.has(D))return[...y,D].join(" -> ");y.add(D);const C=this._findCycle(S,y);if(C)return C;y.delete(D)}}}e.Graph=k}),define(ve[4],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var b;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(b=e._util||(e._util={})),e.IInstantiationService=P("instantiationService");function k(D,S,C,i){S[b.DI_TARGET]===S?S[b.DI_DEPENDENCIES].push({id:D,index:C,optional:i}):(S[b.DI_DEPENDENCIES]=[{id:D,index:C,optional:i}],S[b.DI_TARGET]=S)}function P(D){if(b.serviceIds.has(D))return b.serviceIds.get(D);const S=function(C,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(S,C,I,!1)};return S.toString=()=>D,b.serviceIds.set(D,S),S}e.createDecorator=P;function T(D){return D}e.refineServiceDecorator=T;function y(D){return function(S,C,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(D,S,i,!0)}}e.optional=y}),define(ve[146],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,b.createDecorator)("modelService");function k(P){return!P.isTooLargeForSyncing()&&!P.isForSimpleWidget}e.shouldSynchronizeModel=k}),define(ve[147],be([0,1,3,56,6,22,81,59,146]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(h){return typeof h=="string"?!1:Array.isArray(h)?h.every(C):!!h.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new b.Emitter}get onDidChange(){return this._onDidChange.event}register(d,r){let o={selector:d,provider:r,_score:-1,_time:this._clock++};return this._entries.push(o),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,P.toDisposable)(()=>{if(o){let v=this._entries.indexOf(o);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),o=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const r=[];for(let o of this._entries)o._score>0&&r.push(o.provider);return r}ordered(d){const r=[];return this._orderedForEach(d,o=>r.push(o.provider)),r}orderedGroups(d){const r=[];let o,v;return this._orderedForEach(d,p=>{o&&v===p._score?o.push(p.provider):(v=p._score,o=[p.provider],r.push(o))}),r}_orderedForEach(d,r){if(!!d){this._updateScores(d);for(const o of this._entries)o._score>0&&r(o)}}_updateScores(d){let r={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===r.language&&this._lastCandidate.uri===r.uri)){this._lastCandidate=r;for(let o of this._entries)if(o._score=(0,D.score)(o.selector,d.uri,d.getLanguageIdentifier().language,(0,S.shouldSynchronizeModel)(d)),C(o.selector)&&o._score>0){for(let v of this._entries)v._score=0;o._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(d,r){return d._score<r._score?1:d._score>r._score?-1:d._time<r._time?1:d._time>r._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(d,r,o=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=r,this.max=o,this._cache=new T.LRUCache(50,.7)}_key(d){return d.id+(0,k.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const r=this._key(d),o=this._cache.get(r);return this._clamp(o==null?void 0:o.value)}update(d,r){const o=this._key(d);let v=this._cache.get(o);return v||(v=new y.MovingAverage,this._cache.set(o,v)),v.update(r),this.get(d)}}e.LanguageFeatureRequestDelays=I}),define(ve[62],be([0,1,2,32,147,119,36]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(m){m[m.Null=0]="Null",m[m.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class S{constructor(w,R){this.language=w,this.id=R}}e.LanguageIdentifier=S;var C;(function(m){m[m.NotSet=-1]="NotSet",m[m.None=0]="None",m[m.Italic=1]="Italic",m[m.Bold=2]="Bold",m[m.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var i;(function(m){m[m.None=0]="None",m[m.DefaultForeground=1]="DefaultForeground",m[m.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(m){m[m.Other=0]="Other",m[m.Comment=1]="Comment",m[m.String=2]="String",m[m.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var h;(function(m){m[m.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",m[m.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",m[m.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",m[m.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",m[m.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",m[m.ITALIC_MASK=2048]="ITALIC_MASK",m[m.BOLD_MASK=4096]="BOLD_MASK",m[m.UNDERLINE_MASK=8192]="UNDERLINE_MASK",m[m.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",m[m.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",m[m.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",m[m.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",m[m.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",m[m.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",m[m.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",m[m.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",m[m.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",m[m.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(h=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(w){return(w&255)>>>0}static getTokenType(w){return(w&1792)>>>8}static getFontStyle(w){return(w&14336)>>>11}static getForeground(w){return(w&8372224)>>>14}static getBackground(w){return(w&4286578688)>>>23}static getClassNameFromMetadata(w){let R=this.getForeground(w),$="mtk"+R,K=this.getFontStyle(w);return K&1&&($+=" mtki"),K&2&&($+=" mtkb"),K&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(w,R){const $=this.getForeground(w),K=this.getFontStyle(w);let he=`color: ${R[$]};`;return K&1&&(he+="font-style: italic;"),K&2&&(he+="font-weight: bold;"),K&4&&(he+="text-decoration: underline;"),he}}e.TokenMetadata=d;var r;(function(m){m[m.Method=0]="Method",m[m.Function=1]="Function",m[m.Constructor=2]="Constructor",m[m.Field=3]="Field",m[m.Variable=4]="Variable",m[m.Class=5]="Class",m[m.Struct=6]="Struct",m[m.Interface=7]="Interface",m[m.Module=8]="Module",m[m.Property=9]="Property",m[m.Event=10]="Event",m[m.Operator=11]="Operator",m[m.Unit=12]="Unit",m[m.Value=13]="Value",m[m.Constant=14]="Constant",m[m.Enum=15]="Enum",m[m.EnumMember=16]="EnumMember",m[m.Keyword=17]="Keyword",m[m.Text=18]="Text",m[m.Color=19]="Color",m[m.File=20]="File",m[m.Reference=21]="Reference",m[m.Customcolor=22]="Customcolor",m[m.Folder=23]="Folder",m[m.TypeParameter=24]="TypeParameter",m[m.User=25]="User",m[m.Issue=26]="Issue",m[m.Snippet=27]="Snippet"})(r=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let m=Object.create(null);return m[0]="symbol-method",m[1]="symbol-function",m[2]="symbol-constructor",m[3]="symbol-field",m[4]="symbol-variable",m[5]="symbol-class",m[6]="symbol-struct",m[7]="symbol-interface",m[8]="symbol-module",m[9]="symbol-property",m[10]="symbol-event",m[11]="symbol-operator",m[12]="symbol-unit",m[13]="symbol-value",m[14]="symbol-constant",m[15]="symbol-enum",m[16]="symbol-enum-member",m[17]="symbol-keyword",m[27]="symbol-snippet",m[18]="symbol-text",m[19]="symbol-color",m[20]="symbol-file",m[21]="symbol-reference",m[22]="symbol-customcolor",m[23]="symbol-folder",m[24]="symbol-type-parameter",m[25]="account",m[26]="issues",function(w){const R=m[w];let $=R&&y.iconRegistry.get(R);return $||(console.info("No codicon found for CompletionItemKind "+w),$=y.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let m=Object.create(null);return m.method=0,m.function=1,m.constructor=2,m.field=3,m.variable=4,m.class=5,m.struct=6,m.interface=7,m.module=8,m.property=9,m.event=10,m.operator=11,m.unit=12,m.value=13,m.constant=14,m.enum=15,m["enum-member"]=16,m.enumMember=16,m.keyword=17,m.snippet=27,m.text=18,m.color=19,m.file=20,m.reference=21,m.customcolor=22,m.folder=23,m["type-parameter"]=24,m.typeParameter=24,m.account=25,m.issue=26,function(w,R){let $=m[w];return typeof $=="undefined"&&!R&&($=9),$}}();var o;(function(m){m[m.Deprecated=1]="Deprecated"})(o=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(m){m[m.KeepWhitespace=1]="KeepWhitespace",m[m.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var p;(function(m){m[m.Invoke=0]="Invoke",m[m.TriggerCharacter=1]="TriggerCharacter",m[m.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var E;(function(m){m[m.Invoke=1]="Invoke",m[m.Auto=2]="Auto"})(E=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(m){m[m.Invoke=1]="Invoke",m[m.TriggerCharacter=2]="TriggerCharacter",m[m.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var l;(function(m){m[m.Text=0]="Text",m[m.Read=1]="Read",m[m.Write=2]="Write"})(l=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function f(m){return m&&b.URI.isUri(m.uri)&&k.Range.isIRange(m.range)&&(k.Range.isIRange(m.originSelectionRange)||k.Range.isIRange(m.targetSelectionRange))}e.isLocationLink=f;var t;(function(m){m[m.File=0]="File",m[m.Module=1]="Module",m[m.Namespace=2]="Namespace",m[m.Package=3]="Package",m[m.Class=4]="Class",m[m.Method=5]="Method",m[m.Property=6]="Property",m[m.Field=7]="Field",m[m.Constructor=8]="Constructor",m[m.Enum=9]="Enum",m[m.Interface=10]="Interface",m[m.Function=11]="Function",m[m.Variable=12]="Variable",m[m.Constant=13]="Constant",m[m.String=14]="String",m[m.Number=15]="Number",m[m.Boolean=16]="Boolean",m[m.Array=17]="Array",m[m.Object=18]="Object",m[m.Key=19]="Key",m[m.Null=20]="Null",m[m.EnumMember=21]="EnumMember",m[m.Struct=22]="Struct",m[m.Event=23]="Event",m[m.Operator=24]="Operator",m[m.TypeParameter=25]="TypeParameter"})(t=e.SymbolKind||(e.SymbolKind={}));var n;(function(m){m[m.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var a;(function(m){const w=new Map;w.set("file",0),w.set("module",1),w.set("namespace",2),w.set("package",3),w.set("class",4),w.set("method",5),w.set("property",6),w.set("field",7),w.set("constructor",8),w.set("enum",9),w.set("interface",10),w.set("function",11),w.set("variable",12),w.set("constant",13),w.set("string",14),w.set("number",15),w.set("boolean",16),w.set("array",17),w.set("object",18),w.set("key",19),w.set("null",20),w.set("enum-member",21),w.set("struct",22),w.set("event",23),w.set("operator",24),w.set("type-parameter",25);const R=new Map;R.set(0,"file"),R.set(1,"module"),R.set(2,"namespace"),R.set(3,"package"),R.set(4,"class"),R.set(5,"method"),R.set(6,"property"),R.set(7,"field"),R.set(8,"constructor"),R.set(9,"enum"),R.set(10,"interface"),R.set(11,"function"),R.set(12,"variable"),R.set(13,"constant"),R.set(14,"string"),R.set(15,"number"),R.set(16,"boolean"),R.set(17,"array"),R.set(18,"object"),R.set(19,"key"),R.set(20,"null"),R.set(21,"enum-member"),R.set(22,"struct"),R.set(23,"event"),R.set(24,"operator"),R.set(25,"type-parameter");function $(V){return w.get(V)}m.fromString=$;function K(V){return R.get(V)}m.toString=K;function he(V,H){const Y=R.get(V);let U=Y&&y.iconRegistry.get("symbol-"+Y);return U||(console.info("No codicon found for SymbolKind "+V),U=y.Codicon.symbolProperty),`${H?"inline":"block"} ${U.classNames}`}m.toCssClassName=he})(a=e.SymbolKinds||(e.SymbolKinds={}));class s{constructor(w){this.value=w}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var u;(function(m){m[m.Collapsed=0]="Collapsed",m[m.Expanded=1]="Expanded"})(u=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var g;(function(m){m[m.Editing=0]="Editing",m[m.Preview=1]="Preview"})(g=e.CommentMode||(e.CommentMode={}));var _;(function(m){m[m.Other=0]="Other",m[m.Type=1]="Type",m[m.Parameter=2]="Parameter"})(_=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new P.LanguageFeatureRegistry,e.RenameProviderRegistry=new P.LanguageFeatureRegistry,e.CompletionProviderRegistry=new P.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new P.LanguageFeatureRegistry,e.HoverProviderRegistry=new P.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new P.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new P.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new P.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new P.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new P.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new P.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new P.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new P.LanguageFeatureRegistry,e.LinkProviderRegistry=new P.LanguageFeatureRegistry,e.ColorProviderRegistry=new P.LanguageFeatureRegistry,e.SelectionRangeRegistry=new P.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new P.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var A;(function(m){m[m.None=0]="None",m[m.Option=1]="Option",m[m.Default=2]="Default",m[m.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[148],be([0,1,6,10,4,3,45,43]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,P.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(S,C){if(!S)throw new Error("invalid command");if(typeof S=="string"){if(!C)throw new Error("invalid command");return this.registerCommand({id:S,handler:C})}if(S.description){const r=[];for(let v of S.description.args)r.push(v.constraint);const o=S.handler;S.handler=function(v,...p){return(0,k.validateConstraints)(p,r),o(v,...p)}}const{id:i}=S;let I=this._commands.get(i);I||(I=new y.LinkedList,this._commands.set(i,I));let h=I.unshift(S),d=(0,b.toDisposable)(()=>{h();const r=this._commands.get(i);(r==null?void 0:r.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),d}registerCommandAlias(S,C){return e.CommandsRegistry.registerCommand(S,(i,...I)=>i.get(e.ICommandService).executeCommand(C,...I))}getCommand(S){const C=this._commands.get(S);if(!(!C||C.isEmpty()))return D.Iterable.first(C)}getCommands(){const S=new Map;for(const C of this._commands.keys()){const i=this.getCommand(C);i&&S.set(C,i)}return S}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>b.Disposable.None,onDidExecuteCommand:()=>b.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(ve[63],be([0,1,8,4,21]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=P.userAgent||"";const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",P.isMacintosh),y.set("isLinux",P.isLinux),y.set("isWindows",P.isWindows),y.set("isWeb",P.isWeb),y.set("isMacNative",P.isMacintosh&&!P.isWeb),y.set("isEdge",T.indexOf("Edg/")>=0),y.set("isFirefox",T.indexOf("Firefox")>=0),y.set("isChrome",T.indexOf("Chrome")>=0),y.set("isSafari",T.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var S;(function(m){m[m.False=0]="False",m[m.True=1]="True",m[m.Defined=2]="Defined",m[m.Not=3]="Not",m[m.Equals=4]="Equals",m[m.NotEquals=5]="NotEquals",m[m.And=6]="And",m[m.Regex=7]="Regex",m[m.NotRegex=8]="NotRegex",m[m.Or=9]="Or",m[m.In=10]="In",m[m.NotIn=11]="NotIn",m[m.Greater=12]="Greater",m[m.GreaterEquals=13]="GreaterEquals",m[m.Smaller=14]="Smaller",m[m.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return h.INSTANCE}static has(w){return d.create(w)}static equals(w,R){return r.create(w,R)}static notEquals(w,R){return p.create(w,R)}static regex(w,R){return n.create(w,R)}static in(w,R){return o.create(w,R)}static not(w){return E.create(w)}static and(...w){return s.create(w)}static or(...w){return u.create(w)}static greater(w,R){return c.create(w,R)}static less(w,R){return f.create(w,R)}static deserialize(w,R=!1){if(!!w)return this._deserializeOrExpression(w,R)}static _deserializeOrExpression(w,R){let $=w.split("||");return u.create($.map(K=>this._deserializeAndExpression(K,R)))}static _deserializeAndExpression(w,R){let $=w.split("&&");return s.create($.map(K=>this._deserializeOne(K,R)))}static _deserializeOne(w,R){if(w=w.trim(),w.indexOf("!=")>=0){let $=w.split("!=");return p.create($[0].trim(),this._deserializeValue($[1],R))}if(w.indexOf("==")>=0){let $=w.split("==");return r.create($[0].trim(),this._deserializeValue($[1],R))}if(w.indexOf("=~")>=0){let $=w.split("=~");return n.create($[0].trim(),this._deserializeRegexValue($[1],R))}if(w.indexOf(" in ")>=0){let $=w.split(" in ");return o.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(w)){const $=w.split(">=");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(w)){const $=w.split(">");return c.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(w)){const $=w.split("<=");return t.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(w)){const $=w.split("<");return f.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(w)?E.create(w.substr(1).trim()):d.create(w)}static _deserializeValue(w,R){if(w=w.trim(),w==="true")return!0;if(w==="false")return!1;let $=/^'([^']*)'$/.exec(w);return $?$[1].trim():w}static _deserializeRegexValue(w,R){if((0,b.isFalsyOrWhitespace)(w)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let $=w.indexOf("/"),K=w.lastIndexOf("/");if($===K||$<0){if(R)throw new Error(`bad regexp-value '${w}', missing /-enclosure`);return console.warn(`bad regexp-value '${w}', missing /-enclosure`),null}let he=w.slice($+1,K),V=w[K+1]==="i"?"i":"";try{return new RegExp(he,V)}catch(H){if(R)throw new Error(`bad regexp-value '${w}', parse error: ${H}`);return console.warn(`bad regexp-value '${w}', parse error: ${H}`),null}}}e.ContextKeyExpr=C;function i(m,w){return m.cmp(w)}class I{constructor(){this.type=0}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!1}serialize(){return"false"}keys(){return[]}map(w){return this}negate(){return h.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class h{constructor(){this.type=1}cmp(w){return this.type-w.type}equals(w){return w.type===this.type}evaluate(w){return!0}serialize(){return"true"}keys(){return[]}map(w){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=h,h.INSTANCE=new h;class d{constructor(w){this.key=w,this.type=2}static create(w){const R=y.get(w);return typeof R=="boolean"?R?h.INSTANCE:I.INSTANCE:new d(w)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!!w.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(w){return w.mapDefined(this.key)}negate(){return E.create(this.key)}}e.ContextKeyDefinedExpr=d;class r{constructor(w,R){this.key=w,this.value=R,this.type=4}static create(w,R){if(typeof R=="boolean")return R?d.create(w):E.create(w);const $=y.get(w);return typeof $=="boolean"?R===($?"true":"false")?h.INSTANCE:I.INSTANCE:new r(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(w){return w.mapEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeyEqualsExpr=r;class o{constructor(w,R){this.key=w,this.valueKey=R,this.type=10}static create(w,R){return new o(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.valueKey,w.key,w.valueKey)}equals(w){return w.type===this.type?this.key===w.key&&this.valueKey===w.valueKey:!1}evaluate(w){const R=w.getValue(this.valueKey),$=w.getValue(this.key);return Array.isArray(R)?R.indexOf($)>=0:typeof $=="string"&&typeof R=="object"&&R!==null?D.call(R,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(w){return w.mapIn(this.key,this.valueKey)}negate(){return v.create(this)}}e.ContextKeyInExpr=o;class v{constructor(w){this._actual=w,this.type=11}static create(w){return new v(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new v(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class p{constructor(w,R){this.key=w,this.value=R,this.type=5}static create(w,R){if(typeof R=="boolean")return R?E.create(w):d.create(w);const $=y.get(w);return typeof $=="boolean"?R===($?"true":"false")?I.INSTANCE:h.INSTANCE:new p(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return w.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(w){return w.mapNotEquals(this.key,this.value)}negate(){return r.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=p;class E{constructor(w){this.key=w,this.type=3}static create(w){const R=y.get(w);return typeof R=="boolean"?R?I.INSTANCE:h.INSTANCE:new E(w)}cmp(w){return w.type!==this.type?this.type-w.type:_(this.key,w.key)}equals(w){return w.type===this.type?this.key===w.key:!1}evaluate(w){return!w.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(w){return w.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=E;class c{constructor(w,R){this.key=w,this.value=R,this.type=12}static create(w,R){return new c(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class l{constructor(w,R){this.key=w,this.value=R,this.type=13}static create(w,R){return new l(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(w){return w.mapGreaterEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class f{constructor(w,R){this.key=w,this.value=R,this.type=14}static create(w,R){return new f(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=f;class t{constructor(w,R){this.key=w,this.value=R,this.type=15}static create(w,R){return new t(w,R)}cmp(w){return w.type!==this.type?this.type-w.type:A(this.key,this.value,w.key,w.value)}equals(w){return w.type===this.type?this.key===w.key&&this.value===w.value:!1}evaluate(w){return parseFloat(w.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(w){return w.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(w,R){this.key=w,this.regexp=R,this.type=7}static create(w,R){return new n(w,R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.key<w.key)return-1;if(this.key>w.key)return 1;const R=this.regexp?this.regexp.source:"",$=w.regexp?w.regexp.source:"";return R<$?-1:R>$?1:0}equals(w){if(w.type===this.type){const R=this.regexp?this.regexp.source:"",$=w.regexp?w.regexp.source:"";return this.key===w.key&&R===$}return!1}evaluate(w){let R=w.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const w=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${w}`}keys(){return[this.key]}map(w){return w.mapRegex(this.key,this.regexp)}negate(){return a.create(this)}}e.ContextKeyRegexExpr=n;class a{constructor(w){this._actual=w,this.type=8}static create(w){return new a(w)}cmp(w){return w.type!==this.type?this.type-w.type:this._actual.cmp(w._actual)}equals(w){return w.type===this.type?this._actual.equals(w._actual):!1}evaluate(w){return!this._actual.evaluate(w)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(w){return new a(this._actual.map(w))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=a;class s{constructor(w){this.expr=w,this.type=6}static create(w){return s._normalizeArr(w)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,$=this.expr.length;R<$;R++){const K=i(this.expr[R],w.expr[R]);if(K!==0)return K}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,$=this.expr.length;R<$;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,$=this.expr.length;R<$;R++)if(!this.expr[R].evaluate(w))return!1;return!0}static _normalizeArr(w){const R=[];let $=!1;for(const K of w)if(!!K){if(K.type===1){$=!0;continue}if(K.type===0)return I.INSTANCE;if(K.type===6){R.push(...K.expr);continue}R.push(K)}if(R.length===0&&$)return h.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(i);R.length>1;){const K=R[R.length-1];if(K.type!==9)break;R.pop();const he=R.pop(),V=u.create(K.expr.map(H=>s.create([H,he])));V&&(R.push(V),R.sort(i))}return R.length===1?R[0]:new s(R)}}serialize(){return this.expr.map(w=>w.serialize()).join(" && ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new s(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let R of this.expr)w.push(R.negate());return u.create(w)}}e.ContextKeyAndExpr=s;class u{constructor(w){this.expr=w,this.type=9}static create(w){const R=u._normalizeArr(w);if(R.length!==0)return R.length===1?R[0]:new u(R)}cmp(w){if(w.type!==this.type)return this.type-w.type;if(this.expr.length<w.expr.length)return-1;if(this.expr.length>w.expr.length)return 1;for(let R=0,$=this.expr.length;R<$;R++){const K=i(this.expr[R],w.expr[R]);if(K!==0)return K}return 0}equals(w){if(w.type===this.type){if(this.expr.length!==w.expr.length)return!1;for(let R=0,$=this.expr.length;R<$;R++)if(!this.expr[R].equals(w.expr[R]))return!1;return!0}return!1}evaluate(w){for(let R=0,$=this.expr.length;R<$;R++)if(this.expr[R].evaluate(w))return!0;return!1}static _normalizeArr(w){let R=[],$=!1;if(w){for(let K=0,he=w.length;K<he;K++){const V=w[K];if(!!V){if(V.type===0){$=!0;continue}if(V.type===1)return[h.INSTANCE];if(V.type===9){R=R.concat(V.expr);continue}R.push(V)}}if(R.length===0&&$)return[I.INSTANCE];R.sort(i)}return R}serialize(){return this.expr.map(w=>w.serialize()).join(" || ")}keys(){const w=[];for(let R of this.expr)w.push(...R.keys());return w}map(w){return new u(this.expr.map(R=>R.map(w)))}negate(){let w=[];for(let $ of this.expr)w.push($.negate());const R=$=>$.type===9?$.expr:[$];for(;w.length>1;){const $=w.shift(),K=w.shift(),he=[];for(const V of R($))for(const H of R(K))he.push(C.and(V,H));w.unshift(C.or(...he))}return w[0]}}e.ContextKeyOrExpr=u;class g extends d{constructor(w,R,$){super(w);this._defaultValue=R,typeof $=="object"?g._info.push(Object.assign(Object.assign({},$),{key:w})):$!==!0&&g._info.push({key:w,description:$,type:R!=null?typeof R:void 0})}static all(){return g._info.values()}bindTo(w){return w.createKey(this.key,this._defaultValue)}getValue(w){return w.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(w){return C.equals(this.key,w)}notEqualsTo(w){return C.notEquals(this.key,w)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function _(m,w){return m<w?-1:m>w?1:0}function A(m,w,R,$){return m<R?-1:m>R?1:w<$?-1:w>$?1:0}}),define(ve[149],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,b.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,b.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[26],be([0,1,8,4]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function P(C){return C&&typeof C=="object"&&typeof C.id=="string"&&(!C.uuid||typeof C.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(C){C[C.System=0]="System",C[C.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));class y{constructor(i){this.value=i,this._lower=i.toLowerCase()}static equals(i,I){if(typeof i=="undefined"||i===null)return typeof I=="undefined"||I===null;if(typeof I=="undefined"||I===null)return!1;if(typeof i=="string"||typeof I=="string"){let h=typeof i=="string"?i:i.value,d=typeof I=="string"?I:I.value;return b.equalsIgnoreCase(h,d)}return i._lower===I._lower}static toKey(i){return typeof i=="string"?i.toLowerCase():i._lower}}e.ExtensionIdentifier=y;function D(C){return C.contributes&&C.contributes.localizations?C.contributes.localizations.length>0:!1}e.isLanguagePackExtension=D;function S(C){return C.contributes&&C.contributes.authentication?C.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[150],be([0,1,8,26]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function P(d,r){return d.uuid&&r.uuid?d.uuid===r.uuid:d.id===r.id?!0:(0,b.compareIgnoreCase)(d.id,r.id)===0}e.areSameExtensions=P;class T{constructor(r,o){this.version=o,this.id=r.id,this.uuid=r.uuid}key(){return`${this.id}-${this.version}`}equals(r){return r instanceof T?P(this,r)&&this.version===r.version:!1}}e.ExtensionIdentifierWithVersion=T;function y(d,r){return`${d}.${r}`}e.getExtensionId=y;function D(d){return d.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function S(d,r){return D(y(d,r))}e.getGalleryExtensionId=S;function C(d,r){const o=[],v=p=>{for(const E of o)if(E.some(c=>P(r(c),r(p))))return E;return null};for(const p of d){const E=v(p);E?E.push(p):o.push([p])}return o}e.groupByExtension=C;function i(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(d){return Object.assign({id:d.identifier.id,name:d.name,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0)},d.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function h(d){const r=new Set;for(const o of d)o.malicious&&r.add(o.id.id);return r}e.getMaliciousExtensionsSet=h}),define(ve[64],be([0,1,126,14,2,4,8,10,22]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function C(V){return V.create===!0}e.isFileOpenForWriteOptions=C;var i;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(I=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=h;function d(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=d;function r(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=r;function o(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=o;var v;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(H,Y){super(H);this.code=Y}}e.FileSystemProviderError=p;function E(V,H){const Y=new p(V.toString(),H);return l(Y,H),Y}e.createFileSystemProviderError=E;function c(V){return V||E((0,b.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=c;function l(V,H){return V.name=H?`${H} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function f(V){if(!V)return v.Unknown;if(V instanceof p)return V.code;const H=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!H)return v.Unknown;switch(H[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=f;function t(V){if(V instanceof _)return V.fileOperationResult;switch(f(V)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var n;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class a{constructor(H,Y,U){this.resource=H,this.operation=Y,this.target=U}isOperation(H){return this.operation===H}}e.FileOperationEvent=a;var s;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class u{constructor(H,Y){this.ignorePathCasing=Y,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=H;for(const U of H)switch(U.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(H,...Y){return this.doContains(H,{includeChildren:!1},...Y)}affects(H,...Y){return this.doContains(H,{includeChildren:!0},...Y)}doContains(H,Y,...U){var F,L,M,x,G,X;if(!H)return!1;const ne=U.length>0;return!!((!ne||U.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(H))||Y.includeChildren&&((L=this.added)===null||L===void 0?void 0:L.findSuperstr(H)))||(!ne||U.includes(0))&&(((M=this.updated)===null||M===void 0?void 0:M.get(H))||Y.includeChildren&&((x=this.updated)===null||x===void 0?void 0:x.findSuperstr(H)))||(!ne||U.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(H))||Y.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(H))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(H){const Y=[],U=H===1?this.added:H===0?this.updated:this.deleted;if(U)for(const[,F]of U)Y.push(F);return Y}filter(H){return new u(this.changes.filter(Y=>H(Y)),this.ignorePathCasing)}}e.FileChangesEvent=u;function g(V,H,Y){return!V||!H||V===H||H.length>V.length?!1:(H.charAt(H.length-1)!==k.sep&&(H+=k.sep),Y?(0,y.startsWithIgnoreCase)(V,H):V.indexOf(H)===0)}e.isParent=g;class _ extends Error{constructor(H,Y,U){super(H);this.fileOperationResult=Y,this.options=U}static isFileOperationError(H){return H instanceof Error&&!(0,D.isUndefinedOrNull)(H.fileOperationResult)}}e.FileOperationError=_;var A;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var m;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(m=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function w(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=w;async function R(V,H){if(!H.canHandleResource(P.URI.from({scheme:V.scheme})))return new Promise(Y=>{const U=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===V.scheme&&F.added&&(U.dispose(),Y())})})}e.whenProviderRegistered=R,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(H){return(0,D.isNumber)(H)||(H=0),H<$.KB?(0,b.localize)(1,null,H.toFixed(0)):H<$.MB?(0,b.localize)(2,null,(H/$.KB).toFixed(2)):H<$.GB?(0,b.localize)(3,null,(H/$.MB).toFixed(2)):H<$.TB?(0,b.localize)(4,null,(H/$.GB).toFixed(2)):(0,b.localize)(5,null,(H/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var K;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function he(V){return{maxFileSize:V===0?300*$.MB:16*$.GB,maxHeapSize:V===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=he}),define(ve[65],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class b{constructor(...P){this._entries=new Map;for(let[T,y]of P)this.set(T,y)}set(P,T){const y=this._entries.get(P);return this._entries.set(P,T),y}has(P){return this._entries.has(P)}get(P){return this._entries.get(P)}}e.ServiceCollection=b}),define(ve[151],be([0,1,12,145,89,4,65,11]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class C extends Error{constructor(r){var o;super("cyclic dependency between services");this.message=(o=r.findCycleSlow())!==null&&o!==void 0?o:`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class i{constructor(r=new y.ServiceCollection,o=!1,v){this._activeInstantiations=new Set,this._services=r,this._strict=o,this._parent=v,this._services.set(T.IInstantiationService,this)}createChild(r){return new i(r,this._strict,this)}invokeFunction(r,...o){let v=h.traceInvocation(r),p=!1;try{return r({get:(c,l)=>{if(p)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(c,v);if(!f&&l!==T.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return f}},...o)}finally{p=!0,v.stop()}}createInstance(r,...o){let v,p;return r instanceof P.SyncDescriptor?(v=h.traceCreation(r.ctor),p=this._createInstance(r.ctor,r.staticArguments.concat(o),v)):(v=h.traceCreation(r),p=this._createInstance(r,o,v)),v.stop(),p}_createInstance(r,o=[],v){let p=T._util.getServiceDependencies(r).sort((l,f)=>l.index-f.index),E=[];for(const l of p){let f=this._getOrCreateServiceInstance(l.id,v);if(!f&&this._strict&&!l.optional)throw new Error(`[createInstance] ${r.name} depends on UNKNOWN service ${l.id}.`);E.push(f)}let c=p.length>0?p[0].index:o.length;if(o.length!==c){console.warn(`[createInstance] First service dependency of ${r.name} at position ${c+1} conflicts with ${o.length} static arguments`);let l=c-o.length;l>0?o=o.concat(new Array(l)):o=o.slice(0,c)}return new r(...[...o,...E])}_setServiceInstance(r,o){if(this._services.get(r)instanceof P.SyncDescriptor)this._services.set(r,o);else if(this._parent)this._parent._setServiceInstance(r,o);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(r){let o=this._services.get(r);return!o&&this._parent?this._parent._getServiceInstanceOrDescriptor(r):o}_getOrCreateServiceInstance(r,o){let v=this._getServiceInstanceOrDescriptor(r);return v instanceof P.SyncDescriptor?this._safeCreateAndCacheServiceInstance(r,v,o.branch(r,!0)):(o.branch(r,!1),v)}_safeCreateAndCacheServiceInstance(r,o,v){if(this._activeInstantiations.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this._activeInstantiations.add(r);try{return this._createAndCacheServiceInstance(r,o,v)}finally{this._activeInstantiations.delete(r)}}_createAndCacheServiceInstance(r,o,v){const p=new k.Graph(l=>l.id.toString());let E=0;const c=[{id:r,desc:o,_trace:v}];for(;c.length;){const l=c.pop();if(p.lookupOrInsertNode(l),E++>1e3)throw new C(p);for(let f of T._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(f.id);if(!t&&!f.optional&&console.warn(`[createInstance] ${r} depends on ${f.id} which is NOT registered.`),t instanceof P.SyncDescriptor){const n={id:f.id,desc:t,_trace:l._trace.branch(f.id,!0)};p.insertEdge(l,n),c.push(n)}}}for(;;){const l=p.roots();if(l.length===0){if(!p.isEmpty())throw new C(p);break}for(const{data:f}of l){if(this._getServiceInstanceOrDescriptor(f.id)instanceof P.SyncDescriptor){const n=this._createServiceInstanceWithOwner(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this._setServiceInstance(f.id,n)}p.removeNode(f)}}return this._getServiceInstanceOrDescriptor(r)}_createServiceInstanceWithOwner(r,o,v=[],p,E){if(this._services.get(r)instanceof P.SyncDescriptor)return this._createServiceInstance(o,v,p,E);if(this._parent)return this._parent._createServiceInstanceWithOwner(r,o,v,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}_createServiceInstance(r,o=[],v,p){if(v){const E=new D.IdleValue(()=>this._createInstance(r,o,p));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];let f=E.value,t=f[l];return typeof t!="function"||(t=t.bind(f),c[l]=t),t},set(c,l,f){return E.value[l]=f,!0}})}else return this._createInstance(r,o,p)}}e.InstantiationService=i;var I;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(I||(I={}));class h{constructor(r,o){this.type=r,this.name=o,this._start=Date.now(),this._dep=[]}static traceInvocation(r){return S?new h(1,r.name||r.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(r){return S?new h(0,r.name):h._None}branch(r,o){let v=new h(2,r.toString());return this._dep.push([r,o,v]),v}stop(){let r=Date.now()-this._start;h._totals+=r;let o=!1;function v(E,c){let l=[],f=new Array(E+1).join("	");for(const[t,n,a]of c._dep)if(n&&a){o=!0,l.push(`${f}CREATES -> ${t}`);let s=v(E+1,a);s&&l.push(s)}else l.push(`${f}uses -> ${t}`);return l.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(r>2||o)&&console.log(p.join(`
`))}}h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0}),define(ve[18],be([0,1,4,6,21,3,60]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function D(){return new Date().toISOString()}var S;(function(f){f[f.Trace=0]="Trace",f[f.Debug=1]="Debug",f[f.Info=2]="Info",f[f.Warning=3]="Warning",f[f.Error=4]="Error",f[f.Critical=5]="Critical",f[f.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class C extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class i extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(S.Error))if(t instanceof Error){const a=Array.prototype.slice.call(arguments);a[0]=t.stack,this.log(S.Error,this.format(a))}else this.log(S.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let a=0;a<t.length;a++){let s=t[a];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}n+=(a>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!P.isWindows}trace(t,...n){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}debug(t,...n){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}info(t,...n){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...n):console.log(`[main ${D()}]`,t,...n))}warn(t,...n){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...n):console.warn(`[main ${D()}]`,t,...n))}error(t,...n){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}critical(t,...n){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...n):console.error(`[main ${D()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class h extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=h;class d extends C{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,y.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class r extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const a of this.logServices)a.trace(t,...n)}debug(t,...n){for(const a of this.logServices)a.debug(t,...n)}info(t,...n){for(const a of this.logServices)a.info(t,...n)}warn(t,...n){for(const a of this.logServices)a.warn(t,...n)}error(t,...n){for(const a of this.logServices)a.error(t,...n)}critical(t,...n){for(const a of this.logServices)a.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=r;class o extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=o;class v extends k.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(a=>{this.logLevel=a,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(a))}))}createLogger(t,n){let a=this.loggers.get(t.toString());return a||(a=this.doCreateLogger(t,(n==null?void 0:n.always)?S.Trace:this.logLevel,n),this.loggers.set(t.toString(),a),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(a)),a}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class p{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=p;function E(f){if(f.verbose)return S.Trace;if(typeof f.logLevel=="string"){const t=c(f.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=E;function c(f){switch(f){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=c;function l(f){switch(f){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=l}),define(ve[90],be([0,1,4,127,47]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(S){S[S.Unnecessary=1]="Unnecessary",S[S.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var y;(function(S){S[S.Hint=1]="Hint",S[S.Info=2]="Info",S[S.Warning=4]="Warning",S[S.Error=8]="Error"})(y=e.MarkerSeverity||(e.MarkerSeverity={})),function(S){function C(r,o){return o-r}S.compare=C;const i=Object.create(null);i[S.Error]=(0,k.localize)(0,null),i[S.Warning]=(0,k.localize)(1,null),i[S.Info]=(0,k.localize)(2,null);function I(r){return i[r]||""}S.toString=I;function h(r){switch(r){case P.default.Error:return S.Error;case P.default.Warning:return S.Warning;case P.default.Info:return S.Info;case P.default.Ignore:return S.Hint}}S.fromSeverity=h;function d(r){switch(r){case S.Error:return P.default.Error;case S.Warning:return P.default.Warning;case S.Info:return P.default.Info;case S.Hint:return P.default.Ignore}}S.toSeverity=d}(y=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(S){const C="";function i(h){return I(h,!0)}S.makeKey=i;function I(h,d){let r=[C];return h.source?r.push(h.source.replace("\xA6","\\\xA6")):r.push(C),h.code?typeof h.code=="string"?r.push(h.code.replace("\xA6","\\\xA6")):r.push(h.code.value.replace("\xA6","\\\xA6")):r.push(C),h.severity!==void 0&&h.severity!==null?r.push(y.toString(h.severity)):r.push(C),h.message&&d?r.push(h.message.replace("\xA6","\\\xA6")):r.push(C),h.startLineNumber!==void 0&&h.startLineNumber!==null?r.push(h.startLineNumber.toString()):r.push(C),h.startColumn!==void 0&&h.startColumn!==null?r.push(h.startColumn.toString()):r.push(C),h.endLineNumber!==void 0&&h.endLineNumber!==null?r.push(h.endLineNumber.toString()):r.push(C),h.endColumn!==void 0&&h.endColumn!==null?r.push(h.endColumn.toString()):r.push(C),r.push(C),r.join("\xA6")}S.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(ve[152],be([0,1,47,4,3]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=b.default,e.INotificationService=(0,k.createDecorator)("notificationService");var T;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var y;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(y=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new S,this.onDidClose=P.Event.None,this.onDidChangeVisibility=P.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=D;class S{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=S});var je=this&&this.__decorate||function(J,e,b,k){var P=arguments.length,T=P<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,b):k,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(J,e,b,k);else for(var D=J.length-1;D>=0;D--)(y=J[D])&&(T=(P<3?y(T):P>3?y(e,b,T):y(e,b))||T);return P>3&&T&&Object.defineProperty(e,b,T),T},Ke=this&&this.__param||function(J,e){return function(b,k){e(b,k,J)}};define(ve[153],be([0,1,4,20,6,11]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,b.createDecorator)("progressService");var y;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(y=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let S=class extends P.Disposable{constructor(I,h){super();this.deferred=new T.DeferredPromise,h.withProgress(I,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,P.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};S=je([Ke(1,e.IProgressService)],S),e.UnmanagedProgress=S;class C extends P.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new P.DisposableStore)}start(I){this.stop();const h=++this.currentOperationId,d=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{h===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,P.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,P.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,P.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:h,token:d.token,stop:()=>this.doStop(h),isCurrent:()=>this.currentOperationId===h}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=(0,b.createDecorator)("editorProgressService")}),define(ve[29],be([0,1,10,42]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class P{constructor(){this.data=new Map}add(y,D){k.ok(b.isString(y)),k.ok(b.isObject(D)),k.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,D)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}e.Registry=new P}),define(ve[91],be([0,1,29,3]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function P(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class T{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,C){this.schemasById[P(S)]=C,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new T;b.Registry.add(e.Extensions.JSONContribution,y)}),define(ve[66],be([0,1,124,3,29,10,91]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=P.Registry.as(y.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:b.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,E=!0){this.registerConfigurations([p],E)}registerConfigurations(p,E=!0){const c=[];p.forEach(l=>{c.push(...this.validateAndRegisterProperties(l,E,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(p){const E=[],c=l=>{if(l.properties)for(const f in l.properties)E.push(f),delete this.configurationProperties[f],this.removeFromSchema(f,l.properties[f]);l.allOf&&l.allOf.forEach(f=>c(f))};for(const l of p){c(l);const f=this.configurationContributors.indexOf(l);f!==-1&&this.configurationContributors.splice(f,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}registerDefaultConfigurations(p){const E=[],c=[];for(const l of p)for(const f in l)if(E.push(f),e.OVERRIDE_PROPERTY_PATTERN.test(f)){this.defaultValues[f]=Object.assign(Object.assign({},this.defaultValues[f]||{}),l[f]);const t={type:"object",default:this.defaultValues[f],description:b.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId};c.push(I(f)),this.configurationProperties[f]=t,this.defaultLanguageConfigurationOverridesNode.properties[f]=t}else{this.defaultValues[f]=l[f];const t=this.configurationProperties[f];t&&(this.updatePropertyDefaultValue(f,t),this.updateSchema(f,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}deregisterDefaultConfigurations(p){const E=[];for(const c of p)for(const l in c)if(E.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const f=this.configurationProperties[l];f&&(this.updatePropertyDefaultValue(l,f),this.updateSchema(l,f))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(E)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const E of p)this.overrideIdentifiers.add(E);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,E=!0,c,l=3){var f;l=T.isUndefinedOrNull(p.scope)?l:p.scope;let t=[],n=p.properties;if(n)for(let s in n){if(E&&r(s)){delete n[s];continue}const u=n[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=T.isUndefinedOrNull(u.scope)?l:u.scope,u.restricted=T.isUndefinedOrNull(u.restricted)?!!((f=c==null?void 0:c.restrictedConfigurations)===null||f===void 0?void 0:f.includes(s)):u.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let a=p.allOf;if(a)for(let s of a)t.push(...this.validateAndRegisterProperties(s,E,c,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const E=c=>{let l=c.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let f=c.allOf;f&&f.forEach(E)};E(p)}updateSchema(p,E){switch(e.allSettings.properties[p]=E,E.scope){case 1:e.applicationSettings.properties[p]=E;break;case 2:e.machineSettings.properties[p]=E;break;case 6:e.machineOverridableSettings.properties[p]=E;break;case 3:e.windowSettings.properties[p]=E;break;case 4:e.resourceSettings.properties[p]=E;break;case 5:e.resourceSettings.properties[p]=E,this.resourceLanguageSettingsSchema.properties[p]=E;break}}removeFromSchema(p,E){switch(delete e.allSettings.properties[p],E.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const E=`[${p}]`,c={type:"object",description:b.localize(2,null),errorMessage:b.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(E,c),e.allSettings.properties[E]=c,e.applicationSettings.properties[E]=c,e.machineSettings.properties[E]=c,e.machineOverridableSettings.properties[E]=c,e.windowSettings.properties[E]=c,e.resourceSettings.properties[E]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,E){let c=this.defaultValues[p];T.isUndefined(c)&&(c=E.default),T.isUndefined(c)&&(c=h(E.type)),E.default=c}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(v){return v.substring(1,v.length-1)}e.overrideIdentifierFromKey=I;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const d=new C;P.Registry.add(e.Extensions.Configuration,d);function r(v){return v.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(v)?b.localize(5,null,v):d.getConfigurationProperties()[v]!==void 0?b.localize(6,null,v):null:b.localize(4,null)}e.validateProperty=r;function o(){const v=[],p=d.getConfigurationProperties();for(const E of Object.keys(p))v.push([E,p[E].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=o}),define(ve[92],be([0,1,23,10,2,29,4,66]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,y.createDecorator)("configurationService");function S(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof P.URI)}e.isConfigurationOverrides=S;var C;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,a){const s=a?n?a.keys.filter(R=>n.keys.indexOf(R)===-1):[...a.keys]:[],u=n?a?n.keys.filter(R=>a.keys.indexOf(R)===-1):[...n.keys]:[],g=[];if(a&&n){for(const R of n.keys)if(a.keys.indexOf(R)!==-1){const $=p(n.contents,R),K=p(a.contents,R);b.equals($,K)||g.push(R)}}const _=[],A=R=>{const $={};for(const K of R)for(const he of K.identifiers)$[f(he)]=K;return $},m=a?A(a.overrides):{},w=n?A(n.overrides):{};if(Object.keys(m).length)for(const R of s){const $=m[R];$&&_.push([(0,D.overrideIdentifierFromKey)(R),$.keys])}if(Object.keys(w).length)for(const R of u){const $=w[R];$&&_.push([(0,D.overrideIdentifierFromKey)(R),$.keys])}if(Object.keys(m).length&&Object.keys(w).length)for(const R of g){const $=w[R],K=m[R];if($&&K){const he=I({contents:$.contents,keys:$.keys,overrides:[]},{contents:K.contents,keys:K.keys,overrides:[]});_.push([(0,D.overrideIdentifierFromKey)(R),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:u,updated:g,overrides:_}}e.compare=I;function h(n,a){const s=[];for(const u of Object.keys(n))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const g={};for(const _ in n[u])g[_]=n[u][_];s.push({identifiers:[(0,D.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(g),contents:d(g,a)})}return s}e.toOverrides=h;function d(n,a){const s=Object.create(null);for(let u in n)r(s,u,n[u],a);return s}e.toValuesTree=d;function r(n,a,s,u){const g=a.split("."),_=g.pop();let A=n;for(let m=0;m<g.length;m++){let w=g[m],R=A[w];switch(typeof R){case"undefined":R=A[w]=Object.create(null);break;case"object":break;default:u(`Ignoring ${a} as ${g.slice(0,m+1).join(".")} is ${JSON.stringify(R)}`);return}A=R}if(typeof A=="object"&&A!==null)try{A[_]=s}catch(m){u(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(A)}`)}else u(`Ignoring ${a} as ${g.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=r;function o(n,a){const s=a.split(".");v(n,s)}e.removeFromValueTree=o;function v(n,a){const s=a.shift();if(a.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const u=n[s];typeof u=="object"&&!Array.isArray(u)&&(v(u,a),Object.keys(u).length===0&&delete n[s])}}function p(n,a,s){function u(A,m){let w=A;for(const R of m){if(typeof w!="object"||w===null)return;w=w[R]}return w}const g=a.split("."),_=u(n,g);return typeof _=="undefined"?s:_}e.getConfigurationValue=p;function E(n,a,s){Object.keys(a).forEach(u=>{u!=="__proto__"&&(u in n?k.isObject(n[u])&&k.isObject(a[u])?E(n[u],a[u],s):s&&(n[u]=a[u]):n[u]=a[u])})}e.merge=E;function c(){const n=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=c;function l(){const n=Object.create(null),a=T.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let s in a){let u=a[s].default;r(n,s,u,g=>console.error(`Conflict in default settings: ${g}`))}return n}e.getDefaultValues=l;function f(n){return`[${n}]`}e.keyFromOverrideIdentifier=f;function t(n,a,s){const u=n.inspect(a),g=n.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:u.defaultValue}e.getMigratedSettingValue=t}),define(ve[154],be([0,1,44,22,13,10,23,2,66,92,29,6,3]),function(J,e,b,k,P,T,y,D,S,C,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(t={},n=[],a=[]){this._contents=t,this._keys=n,this._overrides=a,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,C.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const a=this.getContentsForOverrideIdentifer(n);return a?t?(0,C.getConfigurationValue)(a,t):a:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let a={};for(const s of P.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[s],g=n[s];g&&(typeof u=="object"&&typeof g=="object"?(u=y.deepClone(u),this.mergeContents(u,g)):u=g),a[s]=u}return new d(a,this.keys,this.overrides)}merge(...t){const n=y.deepClone(this.contents),a=y.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const g of u.overrides){const[_]=a.filter(A=>P.equals(A.identifiers,g.identifiers));_?this.mergeContents(_.contents,g.contents):a.push(y.deepClone(g))}for(const g of u.keys)s.indexOf(g)===-1&&s.push(g)}return new d(n,s,a)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const a of Object.keys(n)){if(a in t&&T.isObject(t[a])&&T.isObject(n[a])){this.mergeContents(t[a],n[a]);continue}t[a]=y.deepClone(n[a])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?y.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,C.addToValueTree)(this.contents,t,n,a=>{throw new Error(a)})}removeValue(t){this.removeKey(t)&&(0,C.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let a=0;a<n;a++)t.indexOf(this.keys[a])===0&&(n=a);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=d;class r extends d{constructor(){const t=(0,C.getDefaultValues)(),n=(0,C.getConfigurationKeys)(),a=[];for(const s of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(s)&&a.push({identifiers:[(0,S.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,C.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,a)}}e.DefaultConfigurationModel=r;class o{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const a=this.doParseContent(t);this.parseRaw(a,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:a,keys:s,overrides:u,restricted:g}=this.doParseRaw(t,n);this._configurationModel=new d(a,s,u),this._restrictedConfigurations=g||[]}doParseContent(t){let n={},a=null,s=[],u=[],g=[];function _(m){Array.isArray(s)?s.push(m):a&&(s[a]=m)}let A={onObjectBegin:()=>{let m={};_(m),u.push(s),s=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let m=[];_(m),u.push(s),s=m,a=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:_,onError:(m,w,R)=>{g.push({error:m,offset:w,length:R})}};if(t)try{b.visit(t,A),n=s[0]||{}}catch(m){console.error(`Error while parsing settings file ${this._name}: ${m}`),this._parseErrors=[m]}return n}doParseRaw(t,n){const a=i.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,a,!0,n);t=s.raw;const u=(0,C.toValuesTree)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`)),g=Object.keys(t),_=(0,C.toOverrides)(t,A=>console.error(`Conflict in settings file ${this._name}: ${A}`));return{contents:u,keys:g,overrides:_,restricted:s.restricted}}filter(t,n,a,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},g=[];for(let _ in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(_)&&a){const A=this.filter(t[_],n,!1,s);u[_]=A.raw,g.push(...A.restricted)}else{const A=n[_],m=A?typeof A.scope!="undefined"?A.scope:3:void 0;(A==null?void 0:A.restricted)&&g.push(_),(m===void 0||s.scopes===void 0||s.scopes.includes(m))&&(s.skipRestricted&&(A==null?void 0:A.restricted)||(u[_]=t[_]))}return{raw:u,restricted:g}}}e.ConfigurationModelParser=o;class v extends I.Disposable{constructor(t,n,a,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new o(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(a.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(h.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class p{constructor(t,n,a=new d,s=new d,u=new k.ResourceMap,g=new d,_=new k.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=a,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=g,this._memoryConfigurationByResource=_,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,n,a){return this.getConsolidateConfigurationModel(n,a).getValue(t)}updateValue(t,n,a={}){let s;a.resource?(s=this._memoryConfigurationByResource.get(a.resource),s||(s=new d,this._memoryConfigurationByResource.set(a.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),a.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,a){const s=this.getConsolidateConfigurationModel(n,a),u=this.getFolderConfigurationModelForResource(n.resource,a),g=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,_=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),m=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),w=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=a?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,$=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,K=n.overrideIdentifier?g.override(n.overrideIdentifier).getValue(t):g.getValue(t),he=s.getValue(t),V=P.distinct(P.flatten(s.overrides.map(H=>H.identifiers))).filter(H=>s.getOverrideValue(t,H)!==void 0);return{defaultValue:_,userValue:A,userLocalValue:m,userRemoteValue:w,workspaceValue:R,workspaceFolderValue:$,memoryValue:K,value:he,default:_!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:m!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:w!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:K!==void 0?{value:g.getValue(t),override:n.overrideIdentifier?g.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const a=n.filter(s=>S.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,S.overrideIdentifierFromKey)(s),g=this._defaultConfiguration.getKeysForOverrideIdentifier(u),_=t.getKeysForOverrideIdentifier(u),A=[..._.filter(m=>g.indexOf(m)===-1),...g.filter(m=>_.indexOf(m)===-1),...g.filter(m=>!y.equals(this._defaultConfiguration.override(u).getValue(m),t.override(u).getValue(m)))];return[u,A]});return this.updateDefaultConfiguration(t),{keys:n,overrides:a}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,C.compare)(this.localUserConfiguration,t),g=[...n,...a,...s];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,C.compare)(this.remoteUserConfiguration,t);let g=[...n,...a,...s];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:a,removed:s,overrides:u}=(0,C.compare)(this.workspaceConfiguration,t);let g=[...n,...a,...s];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const a=this.folderConfigurations.get(t),{added:s,updated:u,removed:g,overrides:_}=(0,C.compare)(a,n);let A=[...s,...u,...g];return(A.length||!a)&&this.updateFolderConfiguration(t,n),{keys:A,overrides:_}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:a,updated:s,removed:u,overrides:g}=(0,C.compare)(n,void 0);return{keys:[...a,...s,...u],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let a=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?a.override(t.overrideIdentifier):a}getConsolidatedConfigurationModelForResource({resource:t},n){let a=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(a=this.getFolderConsolidatedConfiguration(s.uri)||a);const u=this._memoryConfigurationByResource.get(t);u&&(a=a.merge(u))}return a}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const a=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=a.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=a}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const a=n.getFolder(t);if(a)return this._folderConfigurations.get(a.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:a,overrides:s,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:a,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(a=>t.add(a))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(a=>n.add(a)),this._folderConfigurations.forEach(a=>a.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),a=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((g,_)=>(g.set(D.URI.revive(_[0]),this.parseConfigurationModel(_[1])),g),new k.ResourceMap);return new p(n,a,new d,s,u,new d,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new d(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function E(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const t=new Set,n=new Map;for(const s of f)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,g])=>{const _=(0,k.getOrSet)(n,u,new Set);g.forEach(A=>_.add(A))});const a=[];return n.forEach((s,u)=>a.push([u,[...s.values()]])),{keys:[...t.values()],overrides:a}}e.mergeChanges=E;class c{constructor(t,n,a,s){this.change=t,this.previous=n,this.currentConfiguraiton=a,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(_=>u.add(_)),t.overrides.forEach(([,_])=>_.forEach(A=>u.add(A))),this.affectedKeys=[...u.values()];const g=new d;this.affectedKeys.forEach(_=>g.setValue(_,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var a;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(a=this.previous)===null||a===void 0?void 0:a.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!y.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let a=(0,C.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof a=="object"&&(s=Object.keys(a)[0]);){if(t=t[s],!t)return!1;a=a[s]}return!0}}e.ConfigurationChangeEvent=c;class l extends c{constructor(t,n,a,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=a,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=l}),define(ve[67],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.RemoteTrustOption=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,b.createDecorator)("remoteAuthorityResolverService");var k;(function(y){y[y.Unknown=0]="Unknown",y[y.DisableTrust=1]="DisableTrust",y[y.MachineTrusted=2]="MachineTrusted"})(k=e.RemoteTrustOption||(e.RemoteTrustOption={}));var P;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends Error{constructor(D,S=P.Unknown,C){super(D);this._message=D,this._code=S,this._detail=C,this.isHandled=S===P.NotAvailable&&C===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(D){return D instanceof T&&D._code===P.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof T&&D._code===P.NoResolverFound}static isHandled(D){return D instanceof T&&D.isHandled}}e.RemoteAuthorityResolverError=T}),define(ve[93],be([0,1,19]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function k(S){return S.scheme===b.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=k;function P(S){if(!!S){const C=S.indexOf("+");return C<0?S:S.substr(0,C)}}e.getRemoteName=P;function T(S){return S.scheme!==b.Schemas.file&&S.scheme!==b.Schemas.vscodeRemote}function y(S){if(S.folders.length)return S.folders.every(C=>T(C.uri))?S.folders[0].uri:void 0;if(S.configuration&&T(S.configuration))return S.configuration}e.getVirtualWorkspaceLocation=y;function D(S){var C;return(C=y(S))===null||C===void 0?void 0:C.scheme}e.getVirtualWorkspaceScheme=D}),define(ve[155],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class b{constructor(P){this._callback=P,this._terminalBufferMap=new Map}dispose(){for(const P of this._terminalBufferMap.values())P.dispose()}startBuffering(P,T,y=5){let D;return D=T(S=>{const C=typeof S=="string"?S:S.data;let i=this._terminalBufferMap.get(P);if(i){i.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(P),y);i={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(P),D.dispose()}},this._terminalBufferMap.set(P,i)}),D}stopBuffering(P){const T=this._terminalBufferMap.get(P);T&&T.dispose()}flushBuffer(P){const T=this._terminalBufferMap.get(P);T&&(this._terminalBufferMap.delete(P),this._callback(P,T.data.join("")))}}e.TerminalDataBufferer=b}),define(ve[156],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var b;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(b=e.ColorScheme||(e.ColorScheme={}))}),define(ve[157],be([0,1,4,6,29,3,156,36]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,b.createDecorator)("themeService");var S;(function(v){function p(E){return E&&typeof E=="object"&&typeof E.id=="string"}v.isThemeColor=p})(S=e.ThemeColor||(e.ThemeColor={}));function C(v){return{id:v}}e.themeColorFromId=C;var i;(function(v){function p(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||S.isThemeColor(t.color))}v.isThemeIcon=p;const E=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const n=E.exec(t);if(!!n){let[,a]=n;return{id:a}}}v.fromString=c;function l(t,n){let a=t.id;const s=a.lastIndexOf("~");return s!==-1&&(a=a.substring(0,s)),n&&(a=`${a}~${n}`),{id:a}}v.modify=l;function f(t,n){var a,s;return t.id===n.id&&((a=t.color)===null||a===void 0?void 0:a.id)===((s=n.color)===null||s===void 0?void 0:s.id)}v.isEqual=f,v.asClassNameArray=D.CSSIcon.asClassNameArray,v.asClassName=D.CSSIcon.asClassName,v.asCSSSelector=D.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function I(v){switch(v){case y.ColorScheme.DARK:return"vs-dark";case y.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class h{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const E=this.themingParticipants.indexOf(p);this.themingParticipants.splice(E,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new h;P.Registry.add(e.Extensions.ThemingContribution,d);function r(v){return d.onColorThemeChange(v)}e.registerThemingParticipant=r;class o extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(E=>this.onThemeChange(E)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,E){let c=this.theme.getColor(p);return c&&E&&(c=E(c,this.theme)),c?c.toString():null}}e.Themable=o}),define(ve[158],be([0,1,29,157,3,128,91,11,36]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class C{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${S.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(p,E,c,l){const f=this.iconsById[p];if(f){if(c&&!f.description){f.description=c,this.iconSchema.properties[p].markdownDescription=`${c} $(${p})`;const a=this.iconReferenceSchema.enum.indexOf(p);a!==-1&&(this.iconReferenceSchema.enumDescriptions[a]=c),this._onDidChange.fire()}return f}let t={id:p,description:c,defaults:E,deprecationMessage:l};this.iconsById[p]=t;let n={$ref:"#/definitions/icons"};return l&&(n.deprecationMessage=l),c&&(n.markdownDescription=`${c}: $(${p})`),this.iconSchema.properties[p]=n,this.iconReferenceSchema.enum.push(p),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:p}}deregisterIcon(p){delete this.iconsById[p],delete this.iconSchema.properties[p];const E=this.iconReferenceSchema.enum.indexOf(p);E!==-1&&(this.iconReferenceSchema.enum.splice(E,1),this.iconReferenceSchema.enumDescriptions.splice(E,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(p=>this.iconsById[p])}getIcon(p){return this.iconsById[p]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(p,E){const c=this.iconFontsById[p];if(c)return c;let l={id:p,definition:E};return this.iconFontsById[p]=l,this._onDidChange.fire(),l}deregisterIconFont(p){delete this.iconFontsById[p]}getIconFonts(){return Object.keys(this.iconFontsById).map(p=>this.iconFontsById[p])}getIconFont(p){return this.iconFontsById[p]}toString(){const p=(f,t)=>f.id.localeCompare(t.id),E=f=>{for(;k.ThemeIcon.isThemeIcon(f.defaults);)f=this.iconsById[f.defaults.id];return`codicon codicon-${f?f.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.iconsById).map(f=>this.iconsById[f]);for(const f of l.filter(t=>!!t.description).sort(p))c.push(`|<i class="${E(f)}"></i>|${f.id}|${k.ThemeIcon.isThemeIcon(f.defaults)?f.defaults.id:f.id}|${f.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const f of l.filter(t=>!k.ThemeIcon.isThemeIcon(t.defaults)).sort(p))c.push(`|<i class="${E(f)}"></i>|${f.id}|`);return c.join(`
`)}}const i=new C;b.Registry.add(e.Extensions.IconContribution,i);function I(v,p,E,c){return i.registerIcon(v,p,E,c)}e.registerIcon=I;function h(){return i}e.getIconRegistry=h;function d(){for(const v of S.iconRegistry.all)i.registerIcon(v.id,v.definition,v.description);S.iconRegistry.onDidRegister(v=>i.registerIcon(v.id,v.definition,v.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let r=b.Registry.as(y.Extensions.JSONContribution);r.registerSchema(e.iconsSchemaId,i.getIconSchema());const o=new D.RunOnceScheduler(()=>r.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.widgetClose=I("widget-close",S.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",S.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",S.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=k.ThemeIcon.modify(S.Codicon.sync,"spin")}),define(ve[48],be([0,1,2,25,4,22]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");var y;(function(h){h[h.EMPTY=1]="EMPTY",h[h.FOLDER=2]="FOLDER",h[h.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function D(h){const d=h;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=D;function S(h){const d=h;return!!(d&&typeof d=="object"&&b.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(d,r,o,v){this._id=d,this._configuration=o,this._ignorePathCasing=v,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=r}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class i{constructor(d,r){this.raw=r,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,k.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(h){return new i({uri:h,index:0,name:(0,k.basenameOrAuthority)(h)},{uri:h.toString()})}e.toWorkspaceFolder=I}),define(ve[159],be([0,1,4,129,48,2,21,14,25,107,44,19,58,37,93]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const o=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,k.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function v(Y){return(typeof Y=="string"?(0,D.extname)(Y):(0,S.extname)(Y))===o}e.hasWorkspaceFileExtension=v,e.IWorkspacesService=(0,b.createDecorator)("workspacesService");function p(Y){return Y.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function E(Y){return Y.hasOwnProperty("folderUri")}e.isRecentFolder=E;function c(Y){return Y.hasOwnProperty("fileUri")}e.isRecentFile=c;function l(Y){const U=Y;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.uri)}e.isSingleFolderWorkspaceIdentifier=l;function f(Y){if(Y.configuration)return{id:Y.id,configPath:Y.configuration};if(Y.folders.length===1)return{id:Y.id,uri:Y.folders[0].uri}}e.toWorkspaceIdentifier=f;function t(Y){const U=Y;return typeof(U==null?void 0:U.id)=="string"&&T.URI.isUri(U.configPath)}e.isWorkspaceIdentifier=t;function n(Y){const U=Y;if(U==null?void 0:U.uri)return{id:U.id,uri:T.URI.revive(U.uri)};const F=Y;if(F==null?void 0:F.configPath)return{id:F.id,configPath:T.URI.revive(F.configPath)};if(Y==null?void 0:Y.id)return{id:Y.id}}e.reviveIdentifier=n;function a(Y,U){return S.extUriBiasedIgnorePathCase.isEqualOrParent(Y,U.untitledWorkspacesHome)}e.isUntitledWorkspace=a;function s(Y){return u(Y)||g(Y)}e.isStoredWorkspaceFolder=s;function u(Y){const U=Y;return typeof(U==null?void 0:U.path)=="string"&&(!U.name||typeof U.name=="string")}e.isRawFileWorkspaceFolder=u;function g(Y){const U=Y;return typeof(U==null?void 0:U.uri)=="string"&&(!U.name||typeof U.name=="string")}e.isRawUriWorkspaceFolder=g;function _(Y,U,F,L,M=!y.isWindows,x){if(Y.scheme!==L.scheme)return{name:F,uri:Y.toString(!0)};let G=U?void 0:x.relativePath(L,Y);if(G!==void 0)G.length===0?G=".":y.isWindows&&Y.scheme===I.Schemas.file&&!M&&(G=G.replace(/\//g,"\\"));else if(Y.scheme===I.Schemas.file)G=Y.fsPath,y.isWindows&&(G=(0,h.normalizeDriveLetter)(G),M&&(G=(0,d.toSlashes)(G)));else{if(!x.isEqualAuthority(Y.authority,L.authority))return{name:F,uri:Y.toString(!0)};G=Y.path}return{name:F,path:G}}e.getStoredWorkspaceFolder=_;function A(Y,U,F){let L=[],M=new Set;const x=F.dirname(U);for(let G of Y){let X;if(u(G))G.path&&(X=F.resolvePath(x,G.path));else if(g(G))try{X=T.URI.parse(G.uri),X.path[0]!=="/"&&(X=X.with({path:"/"+X.path}))}catch(ne){console.warn(ne)}if(X){let ne=F.getComparisonKey(X);if(!M.has(ne)){M.add(ne);const me=G.name||F.basenameOrAuthority(X);L.push(new P.WorkspaceFolder({uri:X,name:me,index:L.length},G))}}}return L}e.toWorkspaceFolders=A;function m(Y,U,F,L,M){let x=w(U,Y);const G=M.dirname(U),X=M.dirname(L),ne=[],me=R(x.folders);for(const ze of x.folders){const W=u(ze)?M.resolvePath(G,ze.path):T.URI.parse(ze.uri);let j;F?j=!1:j=!u(ze)||(0,D.isAbsolute)(ze.path),ne.push(_(W,j,ze.name,X,me,M))}const Le={insertSpaces:!1,tabSize:4,eol:y.isLinux||y.isMacintosh?`
`:`\r
`},We=C.setProperty(Y,["folders"],ne,Le);let Fe=C.applyEdits(Y,We);return x.remoteAuthority===(0,r.getRemoteAuthority)(L)&&(Fe=C.applyEdits(Fe,C.removeProperty(Fe,["remoteAuthority"],Le))),Fe}e.rewriteWorkspaceFileForNewLocation=m;function w(Y,U){let F=i.parse(U);if(F&&Array.isArray(F.folders))F.folders=F.folders.filter(L=>s(L));else throw new Error(`${Y} looks like an invalid workspace file.`);return F}function R(Y){return y.isWindows?Y.some(U=>u(U)&&U.path.indexOf("/")>=0):!0}e.useSlashForPath=R;function $(Y){return Y.workspace&&typeof Y.workspace=="object"&&typeof Y.workspace.id=="string"&&typeof Y.workspace.configPath=="string"}function K(Y){return typeof Y.folderUri=="string"}function he(Y){return typeof Y.fileUri=="string"}function V(Y,U){const F={workspaces:[],files:[]};if(Y){const L=function(x,G){for(let X=0;X<x.length;X++)try{G(x[X],X)}catch(ne){U.warn(`Error restoring recent entry ${JSON.stringify(x[X])}: ${ne.toString()}. Skip entry.`)}},M=Y;if(Array.isArray(M.entries))L(M.entries,x=>{const G=x.label,X=x.remoteAuthority;$(x)?F.workspaces.push({label:G,remoteAuthority:X,workspace:{id:x.workspace.id,configPath:T.URI.parse(x.workspace.configPath)}}):K(x)?F.workspaces.push({label:G,remoteAuthority:X,folderUri:T.URI.parse(x.folderUri)}):he(x)&&F.files.push({label:G,remoteAuthority:X,fileUri:T.URI.parse(x.fileUri)})});else{const x=Y;Array.isArray(x.workspaces3)&&L(x.workspaces3,(G,X)=>{const ne=Array.isArray(x.workspaceLabels)&&x.workspaceLabels[X]||void 0;typeof G=="object"&&typeof G.id=="string"&&typeof G.configURIPath=="string"?F.workspaces.push({label:ne,workspace:{id:G.id,configPath:T.URI.parse(G.configURIPath)}}):typeof G=="string"&&F.workspaces.push({label:ne,folderUri:T.URI.parse(G)})}),Array.isArray(x.files2)&&L(x.files2,(G,X)=>{const ne=Array.isArray(x.fileLabels)&&x.fileLabels[X]||void 0;typeof G=="string"&&F.files.push({label:ne,fileUri:T.URI.parse(G)})})}}return F}e.restoreRecentlyOpened=V;function H(Y){const U={entries:[]};for(const F of Y.workspaces)E(F)?U.entries.push({folderUri:F.folderUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority}):U.entries.push({workspace:{id:F.workspace.id,configPath:F.workspace.configPath.toString()},label:F.label,remoteAuthority:F.remoteAuthority});for(const F of Y.files)U.entries.push({fileUri:F.fileUri.toString(),label:F.label,remoteAuthority:F.remoteAuthority});return U}e.toStoreData=H}),define(ve[68],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class b{constructor(P){this.id=P,this._data=new Map,this._idPool=1}add(P){const T=this._idPool++;return this._data.set(T,P),this.logDebugInfo(),T}get(P,T){return this._data.has(P)?this._data.get(P)[T]:void 0}delete(P){this._data.delete(P),this.logDebugInfo()}logDebugInfo(){!b.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=b,b.enableDebugLogging=!1}),define(ve[160],be([0,1,2,3]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=void 0;class P{constructor(){this._onDidChangeTabs=new k.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(y){this._tabs=y.map(D=>({name:D.name,group:D.group,resource:b.URI.revive(D.resource)})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=P}),define(ve[49],be([0,1,19,4]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class P{constructor(){this._systemSchemes=new Set(Object.keys(b.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(y,D){D===null?this._providerInfo.delete(y):this._providerInfo.set(y,D)}isFreeScheme(y){return!this._providerInfo.has(y)&&!this._systemSchemes.has(y)}getCapabilities(y){return this._providerInfo.get(y)}}e.ExtHostFileSystemInfo=P,e.IExtHostFileSystemInfo=(0,k.createDecorator)("IExtHostFileSystemInfo")}),define(ve[27],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,b.createDecorator)("IExtHostInitDataService")}),define(ve[161],be([0,1,11]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(y,D,S){this._deferredPromises=new Map,this._id=y,this._shared=D,this._storage=S,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new b.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of C.values())i.complete()}catch(i){for(const I of C.values())I.error(i)}})()},0)}get whenReady(){return this._init}get(y,D){let S=this._value[y];return typeof S=="undefined"&&(S=D),S}update(y,D){this._value[y]=D;let S=this._deferredPromises.get(y);if(S!==void 0)return S.p;const C=new b.DeferredPromise;return this._deferredPromises.set(y,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class P extends k{constructor(y,D){super(y.identifier.value,!0,D);this._extension=y}setKeysForSync(y){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},y)}}e.ExtensionGlobalMemento=P}),define(ve[15],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,b.createDecorator)("IExtHostRpcService");class k{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=k});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[162],be([0,1,26,3]),function(J,e,b,k){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(D,S){P.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=b.ExtensionIdentifier.toKey(D.identifier),it(this,P,S,"f"),Ue(this,P,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Ue(this,P,"f").get(this._id,D)}store(D,S){return Ue(this,P,"f").store(this._id,D,S)}delete(D){return Ue(this,P,"f").delete(this._id,D)}}e.ExtensionSecrets=T,P=new WeakMap}),define(ve[94],be([0,1,4,3]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class P{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(y){this._enabled=y}$onDidChangeTelemetryEnabled(y){this._enabled=y,this._onDidChangeTelemetryEnabled.fire(y)}}e.ExtHostTelemetry=P,e.IExtHostTelemetry=(0,b.createDecorator)("IExtHostTelemetry")}),define(ve[69],be([0,1,3]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var k;(function(y){y[y.NewChild=0]="NewChild",y[y.Disposed=1]="Disposed",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp"})(k=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const P=new WeakMap,T=y=>{let D=P.get(y);return D||(D={children:new Map,bus:new b.Emitter},P.set(y,D)),D};e.getPrivateApiFor=T}),define(ve[70],be([0,1,4,3,15]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(D){function S(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}D.fromApiTunnel=S;function C(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}D.fromServiceTunnel=C})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,b.createDecorator)("IExtHostTunnelService");let y=class{constructor(S){this.onDidChangeTunnels=new k.Emitter().event}async $applyCandidateFilter(S){return S}async openTunnel(S,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(S){return{dispose:()=>{}}}registerPortsAttributesProvider(S,C){return{dispose:()=>{}}}async $providePortAttributes(S,C,i,I,h){return[]}async $forwardPort(S,C){}async $closeTunnel(S){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};y=je([Ke(0,P.IExtHostRpcService)],y),e.ExtHostTunnelService=y});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)},Qt=this&&this.__rest||function(J,e){var b={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(b[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(b[k[P]]=J[k[P]]);return b};define(ve[7],be([0,1,13,12,83,22,8,10,2,31,64,67,69]),function(J,e,b,k,P,T,y,D,S,C,i,I,h){"use strict";var d,r,o,v,p,E,c,l,f,t,n,a,s,u,g,_;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelPreload=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function A(B){function O(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(O,B),Object.setPrototypeOf(O.prototype,B.prototype),O}let m=o=class{constructor(O){d.set(this,void 0),it(this,d,O,"f")}static from(...O){let ie=O;return new o(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}dispose(){typeof Ue(this,d,"f")=="function"&&(Ue(this,d,"f").call(this),it(this,d,void 0,"f"))}};d=new WeakMap,m=o=je([A],m),e.Disposable=m;let w=v=class{constructor(O,ie){if(O<0)throw(0,k.illegalArgument)("line must be non-negative");if(ie<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=O,this._character=ie}static Min(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isBefore(ie)&&(ie=Ge)}return ie}static Max(...O){if(O.length===0)throw new TypeError;let ie=O[0];for(let Se=1;Se<O.length;Se++){const Ge=O[Se];Ge.isAfter(ie)&&(ie=Ge)}return ie}static isPosition(O){if(!O)return!1;if(O instanceof v)return!0;let{line:ie,character:Se}=O;return typeof ie=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,ie=0){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return typeof O=="undefined"?Se=0:typeof O=="number"?Se=O:(Se=typeof O.lineDelta=="number"?O.lineDelta:0,ie=typeof O.characterDelta=="number"?O.characterDelta:0),Se===0&&ie===0?this:new v(this.line+Se,this.character+ie)}with(O,ie=this.character){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return typeof O=="undefined"?Se=this.line:typeof O=="number"?Se=O:(Se=typeof O.line=="number"?O.line:this.line,ie=typeof O.character=="number"?O.character:this.character),Se===this.line&&ie===this.character?this:new v(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};w=v=je([A],w),e.Position=w;let R=p=class{constructor(O,ie,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new w(O,ie),ot=new w(Se,Ge)):O instanceof w&&ie instanceof w&&(nt=O,ot=ie),!nt||!ot)throw new Error("Invalid arguments");nt.isBefore(ot)?(this._start=nt,this._end=ot):(this._start=ot,this._end=nt)}static isRange(O){return O instanceof p?!0:O?w.isPosition(O.start)&&w.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof p?this.contains(O._start)&&this.contains(O._end):O instanceof w?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const ie=w.Max(O.start,this._start),Se=w.Min(O.end,this._end);if(!ie.isAfter(Se))return new p(ie,Se)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const ie=w.Min(O.start,this._start),Se=w.Max(O.end,this.end);return new p(ie,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,ie=this.end){if(O===null||ie===null)throw(0,k.illegalArgument)();let Se;return O?w.isPosition(O)?Se=O:(Se=O.start||this.start,ie=O.end||this.end):Se=this.start,Se.isEqual(this._start)&&ie.isEqual(this.end)?this:new p(Se,ie)}toJSON(){return[this.start,this.end]}};R=p=je([A],R),e.Range=R;let $=E=class extends R{constructor(O,ie,Se,Ge){let nt,ot;if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"?(nt=new w(O,ie),ot=new w(Se,Ge)):O instanceof w&&ie instanceof w&&(nt=O,ot=ie),!nt||!ot)throw new Error("Invalid arguments");super(nt,ot);this._anchor=nt,this._active=ot}static isSelection(O){return O instanceof E?!0:O?R.isRange(O)&&w.isPosition(O.anchor)&&w.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};$=E=je([A],$),e.Selection=$;class K{constructor(O,ie,Se){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw(0,k.illegalArgument)("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw(0,k.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(ie),this.connectionToken=Se}}e.ResolvedAuthority=K;class he extends Error{constructor(O,ie=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(O);this._message=O,this._code=ie,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,he.prototype)}static NotAvailable(O,ie){return new he(O,I.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(O){return new he(O,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=he;var V;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var H;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=c=class{constructor(O,ie){this._range=O,this._newText=ie}static isTextEdit(O){return O instanceof c?!0:O?R.isRange(O)&&typeof O.newText=="string":!1}static replace(O,ie){return new c(O,ie)}static insert(O,ie){return c.replace(new R(O,O),ie)}static delete(O){return c.replace(O,"")}static setEndOfLine(O){const ie=new c(new R(new w(0,0),new w(0,0)),"");return ie.newEol=O,ie}get range(){return this._range}set range(O){if(O&&!R.isRange(O))throw(0,k.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,k.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,k.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Y=c=je([A],Y),e.TextEdit=Y;var U;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,ie,Se,Ge){this._edits.push({_type:1,from:O,to:ie,options:Se,metadata:Ge})}createFile(O,ie,Se){this._edits.push({_type:1,from:void 0,to:O,options:ie,metadata:Se})}deleteFile(O,ie,Se){this._edits.push({_type:1,from:O,to:void 0,options:ie,metadata:Se})}replaceNotebookMetadata(O,ie,Se){this._edits.push({_type:3,metadata:Se,uri:O,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(O,ie,Se,Ge,nt){let ot,dt,yt=[],Ct;if($t.isNotebookRange(ie)&&Lt.isNotebookCellDataArray(Se)&&!Lt.isNotebookCellDataArray(Ge)?(ot=ie.start,dt=ie.end,yt=Se,Ct=Ge):typeof ie=="number"&&typeof Se=="number"&&Lt.isNotebookCellDataArray(Ge)&&(ot=ie,dt=Se,yt=Ge,Ct=nt),ot===void 0||dt===void 0)throw new Error("Invalid arguments");(ot!==dt||yt.length>0)&&this._edits.push({_type:5,uri:O,index:ot,count:dt-ot,cells:yt,metadata:Ct})}replaceNotebookCellMetadata(O,ie,Se,Ge){this._edits.push({_type:3,metadata:Ge,uri:O,edit:{editType:8,index:ie,metadata:Se}})}replace(O,ie,Se,Ge){this._edits.push({_type:2,uri:O,edit:new Y(ie,Se),metadata:Ge})}insert(O,ie,Se,Ge){this.replace(O,new R(ie,ie),Se,Ge)}delete(O,ie,Se){this.replace(O,ie,"",Se)}has(O){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===O.toString())}set(O,ie){if(ie)for(const Se of ie)Se&&this._edits.push({_type:2,uri:O,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const Ge=this._edits[Se];Ge._type===2&&Ge.uri.toString()===O.toString()&&(this._edits[Se]=void 0)}(0,b.coalesceInPlace)(this._edits)}}get(O){const ie=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===O.toString()&&ie.push(Se.edit);return ie}entries(){const O=new T.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Se=O.get(ie.uri);Se||(Se=[ie.uri,[]],O.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=je([A],F),e.WorkspaceEdit=F;let L=l=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof l?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=l._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,ie=this._tabstop++){if(typeof O=="function"){const Se=new l;Se._tabstop=this._tabstop,O(Se),this._tabstop=Se._tabstop,O=Se.value}else O=l._escape(O);return this.value+="${",this.value+=ie,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,ie=this._tabstop++){const Se=O.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(O,ie){if(typeof ie=="function"){const Se=new l;Se._tabstop=this._tabstop,ie(Se),this._tabstop=Se._tabstop,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};L=l=je([A],L),e.SnippetString=L;var M;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(M=e.DiagnosticTag||(e.DiagnosticTag={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=f=class{constructor(O,ie){if(this.uri=O,ie)if(ie instanceof R)this.range=ie;else if(ie instanceof w)this.range=new R(ie,ie);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof f?!0:O?R.isRange(O.range)&&S.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=f=je([A],G),e.Location=G;let X=class{constructor(O,ie){this.location=O,this.message=ie}static is(O){return O?typeof O.message=="string"&&O.location&&R.isRange(O.location.range)&&S.URI.isUri(O.location.uri):!1}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.location.range.isEqual(ie.location.range)&&O.location.uri.toString()===ie.location.uri.toString()}};X=je([A],X),e.DiagnosticRelatedInformation=X;let ne=class{constructor(O,ie,Se=x.Error){if(!R.isRange(O))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=O,this.message=ie,this.severity=Se}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,ie){return O===ie?!0:!O||!ie?!1:O.message===ie.message&&O.severity===ie.severity&&O.code===ie.code&&O.severity===ie.severity&&O.source===ie.source&&O.range.isEqual(ie.range)&&(0,b.equals)(O.tags,ie.tags)&&(0,b.equals)(O.relatedInformation,ie.relatedInformation,X.isEqual)}};ne=je([A],ne),e.Diagnostic=ne;let me=class{constructor(O,ie){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:(0,P.isMarkdownString)(O)?this.contents=[O]:this.contents=[O],this.range=ie}};me=je([A],me),e.Hover=me;var Le;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let We=class{constructor(O,ie=Le.Text){this.range=O,this.kind=ie}toJSON(){return{range:this.range,kind:Le[this.kind]}}};We=je([A],We),e.DocumentHighlight=We;var Fe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Fe=e.SymbolKind||(e.SymbolKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let W=t=class{constructor(O,ie,Se,Ge,nt){this.name=O,this.kind=ie,this.containerName=nt,typeof Se=="string"&&(this.containerName=Se),Ge instanceof G?this.location=Ge:Se instanceof R&&(this.location=new G(Ge,Se)),t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Fe[this.kind],location:this.location,containerName:this.containerName}}};W=t=je([A],W),e.SymbolInformation=W;let j=n=class{constructor(O,ie,Se,Ge,nt){this.name=O,this.detail=ie,this.kind=Se,this.range=Ge,this.selectionRange=nt,this.children=[],n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(n.validate)}};j=n=je([A],j),e.DocumentSymbol=j;var te;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(te=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let oe=class{constructor(O,ie){this.title=O,this.kind=ie}};oe=je([A],oe),e.CodeAction=oe;let de=a=class{constructor(O){this.value=O}append(O){return new a(this.value?this.value+a.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+a.sep)}};de.sep=".",de=a=je([A],de),e.CodeActionKind=de,de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll");let _e=class{constructor(O,ie){if(this.range=O,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};_e=je([A],_e),e.SelectionRange=_e;class Be{constructor(O,ie,Se,Ge,nt,ot){this.kind=O,this.name=ie,this.detail=Se,this.uri=Ge,this.range=nt,this.selectionRange=ot}}e.CallHierarchyItem=Be;class fe{constructor(O,ie){this.fromRanges=ie,this.from=O}}e.CallHierarchyIncomingCall=fe;class De{constructor(O,ie){this.fromRanges=ie,this.to=O}}e.CallHierarchyOutgoingCall=De;let Re=class{constructor(O,ie){this.range=O,this.command=ie}get isResolved(){return!!this.command}};Re=je([A],Re),e.CodeLens=Re;let He=s=class{constructor(O,ie=!1){r.set(this,void 0),it(this,r,new P.MarkdownString(O,{supportThemeIcons:ie}),"f")}static isMarkdownString(O){return O instanceof s?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Ue(this,r,"f").value}set value(O){Ue(this,r,"f").value=O}get isTrusted(){return Ue(this,r,"f").isTrusted}set isTrusted(O){Ue(this,r,"f").isTrusted=O}get supportThemeIcons(){return Ue(this,r,"f").supportThemeIcons}appendText(O){return Ue(this,r,"f").appendText(O),this}appendMarkdown(O){return Ue(this,r,"f").appendMarkdown(O),this}appendCodeblock(O,ie){return Ue(this,r,"f").appendCodeblock(ie!=null?ie:"",O),this}};r=new WeakMap,He=s=je([A],He),e.MarkdownString=He;let we=class{constructor(O,ie){this.label=O,this.documentation=ie}};we=je([A],we),e.ParameterInformation=we;let qe=class{constructor(O,ie){this.label=O,this.documentation=ie,this.parameters=[]}};qe=je([A],qe),e.SignatureInformation=qe;let z=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};z=je([A],z),e.SignatureHelp=z;var ee;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(ee=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ge;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ge=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(O,ie,Se){this.text=O,this.position=ie,this.kind=Se}};Ne=je([A],Ne),e.InlayHint=Ne;var Ve;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var $e;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})($e=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(B){B[B.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let ye=class{constructor(O,ie){this.label=O,this.kind=ie}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&$e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};ye=je([A],ye),e.CompletionItem=ye;let Ee=class{constructor(O=[],ie=!1){this.items=O,this.isIncomplete=ie}};Ee=je([A],Ee),e.CompletionList=Ee;var Ce;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(Ce=e.ViewColumn||(e.ViewColumn={}));var re;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(re=e.StatusBarAlignment||(e.StatusBarAlignment={}));var le;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(le=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var N;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(N=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Q;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Q=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ae;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ke;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ke=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(ie){switch(ie){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(ae=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ie=class{constructor(O,ie){if(ie&&!S.URI.isUri(ie))throw(0,k.illegalArgument)("target");if(!R.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.target=ie}};Ie=je([A],Ie),e.DocumentLink=Ie;let Ae=class{constructor(O,ie,Se,Ge){this.red=O,this.green=ie,this.blue=Se,this.alpha=Ge}};Ae=je([A],Ae),e.Color=Ae;let xe=class{constructor(O,ie){if(ie&&!(ie instanceof Ae))throw(0,k.illegalArgument)("color");if(!R.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.color=ie}};xe=je([A],xe),e.ColorInformation=xe;let Ye=class{constructor(O){if(!O||typeof O!="string")throw(0,k.illegalArgument)("label");this.label=O}};Ye=je([A],Ye),e.ColorPresentation=Ye;var rt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(rt=e.ColorFormat||(e.ColorFormat={}));var tt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(tt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Qe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Qe=e.TaskRevealKind||(e.TaskRevealKind={}));var mt;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(mt=e.TaskPanelKind||(e.TaskPanelKind={}));let bt=u=class{constructor(O,ie){if(typeof O!="string"||typeof ie!="string")throw(0,k.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return u.Clean;case"build":return u.Build;case"rebuild":return u.Rebuild;case"test":return u.Test;default:return}}get id(){return this._id}};bt.Clean=new u("clean","Clean"),bt.Build=new u("build","Build"),bt.Rebuild=new u("rebuild","Rebuild"),bt.Test=new u("test","Test"),bt=u=je([A],bt),e.TaskGroup=bt;function pe(B){let O="";for(let ie=0;ie<B.length;ie++)O+=B[ie].replace(/,/g,",,")+",";return O}let ce=class{constructor(O,ie,Se){if(typeof O!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=O,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Se):this._options=ie)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,k.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)O.push(ie);return pe(O)}};ce=je([A],ce),e.ProcessExecution=ce;let se=class{constructor(O,ie,Se){if(this._args=[],Array.isArray(ie)){if(!O)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this._command=O,this._args=ie,this._options=Se}else{if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=O,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)O.push(typeof ie=="string"?ie:ie.value);return pe(O)}};se=je([A],se),e.ShellExecution=se;var q;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(q=e.ShellQuoting||(e.ShellQuoting={}));var Me;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Me=e.TaskScope||(e.TaskScope={}));class Te{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,C.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Te;let Je=g=class{constructor(O,ie,Se,Ge,nt,ot){this.__deprecated=!1,this._definition=this.definition=O;let dt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Se,this.execution=Ge,dt=nt,this.__deprecated=!0):ie===Me.Global||ie===Me.Workspace?(this.target=ie,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot):(this.target=ie,this._name=this.name=Se,this._source=this.source=Ge,this.execution=nt,dt=ot),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ce?this._definition={type:g.ProcessType,id:this._execution.computeId()}:this._execution instanceof se?this._definition={type:g.ShellType,id:this._execution.computeId()}:this._execution instanceof Te?this._definition={type:g.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:g.EmptyType,id:(0,C.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const ie=this._definition.type;(g.EmptyType===ie||g.ProcessType===ie||g.ShellType===ie||g.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Je.ExtensionCallbackType="customExecution",Je.ProcessType="process",Je.ShellType="shell",Je.EmptyType="$empty",Je=g=je([A],Je),e.Task=Je;var et;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(et=e.ProgressLocation||(e.ProgressLocation={}));let ct=class{constructor(O,ie=ht.None){this.collapsibleState=ie,S.URI.isUri(O)?this.resourceUri=O:this.label=O}};ct=je([A],ct),e.TreeItem=ct;var ht;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let Xe=class{constructor(O,ie){this.id=O,this.color=ie}};Xe=je([A],Xe),e.ThemeIcon=Xe,Xe.File=new Xe("file"),Xe.Folder=new Xe("folder");let at=class{constructor(O){this.id=O}};at=je([A],at),e.ThemeColor=at;var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(ft=e.ConfigurationTarget||(e.ConfigurationTarget={}));let lt=class{constructor(O,ie){if(typeof O!="string"&&(!O||!S.URI.isUri(O)&&!S.URI.isUri(O.uri)))throw(0,k.illegalArgument)("base");if(typeof ie!="string")throw(0,k.illegalArgument)("pattern");typeof O=="string"?(this.baseFolder=S.URI.file(O),this.base=O):S.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=ie}};lt=je([A],lt),e.RelativePattern=lt;let Et=class{constructor(O,ie,Se,Ge){this.enabled=typeof O=="boolean"?O:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,C.generateUuid)()),this._id}};Et=je([A],Et),e.Breakpoint=Et;let vt=class extends Et{constructor(O,ie,Se,Ge,nt){super(ie,Se,Ge,nt);if(O===null)throw(0,k.illegalArgument)("location");this.location=O}};vt=je([A],vt),e.SourceBreakpoint=vt;let kt=class extends Et{constructor(O,ie,Se,Ge,nt){super(ie,Se,Ge,nt);this.functionName=O}};kt=je([A],kt),e.FunctionBreakpoint=kt;let At=class extends Et{constructor(O,ie,Se,Ge,nt,ot,dt){super(Ge,nt,ot,dt);if(!ie)throw(0,k.illegalArgument)("dataId");this.label=O,this.dataId=ie,this.canPersist=Se}};At=je([A],At),e.DataBreakpoint=At;let Tt=class{constructor(O,ie,Se){this.command=O,this.args=ie||[],this.options=Se}};Tt=je([A],Tt),e.DebugAdapterExecutable=Tt;let _t=class{constructor(O,ie){this.port=O,this.host=ie}};_t=je([A],_t),e.DebugAdapterServer=_t;let Yt=class{constructor(O){this.path=O}};Yt=je([A],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(O){this.implementation=O}};Jt=je([A],Jt),e.DebugAdapterInlineImplementation=Jt;let gt=class{constructor(O,ie){this.range=O,this.expression=ie}};gt=je([A],gt),e.EvaluatableExpression=gt;let Xt=class{constructor(O,ie){this.range=O,this.text=ie}};Xt=je([A],Xt),e.InlineValueText=Xt;let St=class{constructor(O,ie,Se=!0){this.range=O,this.variableName=ie,this.caseSensitiveLookup=Se}};St=je([A],St),e.InlineValueVariableLookup=St;let jt=class{constructor(O,ie){this.range=O,this.expression=ie}};jt=je([A],jt),e.InlineValueEvaluatableExpression=jt;let Zt=class{constructor(O,ie){this.frameId=O,this.stoppedLocation=ie}};Zt=je([A],Zt),e.InlineValueContext=Zt;var qt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(qt=e.FileChangeType||(e.FileChangeType={}));let ut=_=class extends Error{constructor(O,ie=i.FileSystemProviderErrorCode.Unknown,Se){var Ge;super(S.URI.isUri(O)?O.toString(!0):O);this.code=(Ge=Se==null?void 0:Se.name)!==null&&Ge!==void 0?Ge:"Unknown",(0,i.markAsFileSystemProviderError)(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,_.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(O){return new _(O,i.FileSystemProviderErrorCode.FileExists,_.FileExists)}static FileNotFound(O){return new _(O,i.FileSystemProviderErrorCode.FileNotFound,_.FileNotFound)}static FileNotADirectory(O){return new _(O,i.FileSystemProviderErrorCode.FileNotADirectory,_.FileNotADirectory)}static FileIsADirectory(O){return new _(O,i.FileSystemProviderErrorCode.FileIsADirectory,_.FileIsADirectory)}static NoPermissions(O){return new _(O,i.FileSystemProviderErrorCode.NoPermissions,_.NoPermissions)}static Unavailable(O){return new _(O,i.FileSystemProviderErrorCode.Unavailable,_.Unavailable)}};ut=_=je([A],ut),e.FileSystemError=ut;let en=class{constructor(O,ie,Se){this.start=O,this.end=ie,this.kind=Se}};en=je([A],en),e.FoldingRange=en;var Rt;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Rt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var xt;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(xt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var dn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(dn=e.CommentMode||(e.CommentMode={}));class _n{constructor(O,ie=[]){this.tokenTypes=O,this.tokenModifiers=ie}}e.SemanticTokensLegend=_n;function hn(B){return typeof B=="undefined"||(0,D.isStringArray)(B)}class tn{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let ie=0,Se=O.tokenTypes.length;ie<Se;ie++)this._tokenTypeStrToInt.set(O.tokenTypes[ie],ie);for(let ie=0,Se=O.tokenModifiers.length;ie<Se;ie++)this._tokenModifierStrToInt.set(O.tokenModifiers[ie],ie)}}push(O,ie,Se,Ge,nt){if(typeof O=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof Ge=="number"&&(typeof nt=="number"||typeof nt=="undefined"))return typeof nt=="undefined"&&(nt=0),this._pushEncoded(O,ie,Se,Ge,nt);if(R.isRange(O)&&typeof ie=="string"&&hn(Se))return this._push(O,ie,Se);throw(0,k.illegalArgument)()}_push(O,ie,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const Ge=O.start.line,nt=O.start.character,ot=O.end.character-O.start.character,dt=this._tokenTypeStrToInt.get(ie);let yt=0;if(Se)for(const Ct of Se){if(!this._tokenModifierStrToInt.has(Ct))throw new Error("`tokenModifier` is not in the provided legend");const It=this._tokenModifierStrToInt.get(Ct);yt|=1<<It>>>0}this._pushEncoded(Ge,nt,ot,dt,yt)}_pushEncoded(O,ie,Se,Ge,nt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let Ct=0,It=0;for(let Pt=0;Pt<yt;Pt++){let Mt=this._data[5*Pt],un=this._data[5*Pt+1];Mt===0?(Mt=Ct,un+=It):Mt+=Ct,this._data[5*Pt]=Mt,this._data[5*Pt+1]=un,Ct=Mt,It=un}}let ot=O,dt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(ot-=this._prevLine,ot===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=ot,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=nt,this._prevLine=O,this._prevChar=ie}static _sortAndDeltaEncode(O){let ie=[];const Se=O.length/5|0;for(let dt=0;dt<Se;dt++)ie[dt]=dt;ie.sort((dt,yt)=>{const Ct=O[5*dt],It=O[5*yt];if(Ct===It){const Pt=O[5*dt+1],Mt=O[5*yt+1];return Pt-Mt}return Ct-It});const Ge=new Uint32Array(O.length);let nt=0,ot=0;for(let dt=0;dt<Se;dt++){const yt=5*ie[dt],Ct=O[yt+0],It=O[yt+1],Pt=O[yt+2],Mt=O[yt+3],un=O[yt+4],Tn=Ct-nt,Mn=Tn===0?It-ot:It,cn=5*dt;Ge[cn+0]=Tn,Ge[cn+1]=Mn,Ge[cn+2]=Pt,Ge[cn+3]=Mt,Ge[cn+4]=un,nt=Ct,ot=It}return Ge}build(O){return this._dataIsSortedAndDeltaEncoded?new Kt(new Uint32Array(this._data),O):new Kt(tn._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=tn;class Kt{constructor(O,ie){this.resultId=ie,this.data=O}}e.SemanticTokens=Kt;class Nt{constructor(O,ie,Se){this.start=O,this.deleteCount=ie,this.data=Se}}e.SemanticTokensEdit=Nt;class En{constructor(O,ie){this.resultId=ie,this.edits=O}}e.SemanticTokensEdits=En;var nn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(nn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var rn;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(rn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Gt=class{constructor(){}};Gt.Back={iconPath:new Xe("arrow-left")},Gt=je([A],Gt),e.QuickInputButtons=Gt;var yn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(yn=e.ExtensionKind||(e.ExtensionKind={}));class Ft{constructor(O,ie,Se){this.badge=O,this.tooltip=ie,this.color=Se}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ft;let sn=class{constructor(O){this.kind=O}};sn=je([A],sn),e.ColorTheme=sn;var Sn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(Sn=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(O,ie){if(O<0)throw(0,k.illegalArgument)("start must be positive");if(ie<0)throw(0,k.illegalArgument)("end must be positive");O<=ie?(this._start=O,this._end=ie):(this._start=ie,this._end=O)}static isNotebookRange(O){return O instanceof $t?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let ie=this._start,Se=this._end;return O.start!==void 0&&(ie=O.start),O.end!==void 0&&(Se=O.end),ie===this._start&&Se===this._end?this:new $t(ie,Se)}}e.NotebookRange=$t;class on{constructor(O,ie){typeof O=="object"?Object.assign(this,O):(this.inputCollapsed=O,this.outputCollapsed=ie)}with(O){let{inputCollapsed:ie,outputCollapsed:Se}=O,Ge=Qt(O,["inputCollapsed","outputCollapsed"]);return ie===void 0?ie=this.inputCollapsed:ie===null&&(ie=void 0),Se===void 0?Se=this.outputCollapsed:Se===null&&(Se=void 0),ie===this.inputCollapsed&&Se===this.outputCollapsed&&Object.keys(Ge).length===0?this:new on(Object.assign({inputCollapsed:ie,outputCollapsed:Se},Ge))}}e.NotebookCellMetadata=on;class Ut{constructor(O={}){Object.assign(this,O)}with(O){return new Ut(O)}}e.NotebookDocumentMetadata=Ut;class Lt{constructor(O,ie,Se,Ge,nt,ot){this.kind=O,this.source=ie,this.language=Se,this.outputs=Ge!=null?Ge:[],this.metadata=nt,this.latestExecutionSummary=ot}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(ie=>Lt.isNotebookCellData(ie))}static isNotebookCellData(O){return!0}}e.NotebookCellData=Lt;class fn{constructor(O,ie){this.cells=O,this.metadata=ie!=null?ie:new Ut}}e.NotebookData=fn;class Wt{constructor(O,ie,Se){if(this.mime=O,this.value=ie,this.metadata=Se,(0,y.isFalsyOrWhitespace)(this.mime))throw new Error("INVALID mime type, must not be empty or falsy")}static isNotebookCellOutputItem(O){return O instanceof Wt}}e.NotebookCellOutputItem=Wt;class Oe{constructor(O,ie,Se){this.outputs=O,typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=(0,C.generateUuid)(),this.metadata=ie!=null?ie:Se)}}e.NotebookCellOutput=Oe;var an;(function(B){B[B.Markdown=1]="Markdown",B[B.Code=2]="Code"})(an=e.NotebookCellKind||(e.NotebookCellKind={}));var ln;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ln=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pt;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(pt=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Dn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Dn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Cn{constructor(O,ie,Se,Ge,nt,ot){this.text=O,this.alignment=ie,this.command=Se,this.tooltip=Ge,this.priority=nt,this.accessibilityInformation=ot}}e.NotebookCellStatusBarItem=Cn;var mn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(mn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class gn{constructor(O,ie=[]){this.uri=O,this.provides=typeof ie=="string"?[ie]:ie}}e.NotebookKernelPreload=gn;let Ht=class{constructor(O,ie){this.label=O,this.timestamp=ie}};Ht=je([A],Ht),e.TimelineItem=Ht;var kn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(kn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class pn{constructor(O,ie){this.ranges=O,this.wordPattern=ie}}e.LinkedEditingRanges=pn;var An;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var vn;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(vn=e.TestMessageSeverity||(e.TestMessageSeverity={}));var bn;(function(B){B[B.Pending=0]="Pending",B[B.Resolved=1]="Resolved"})(bn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(B,O,ie,Se)=>{let Ge=ie;return{enumerable:!0,configurable:!1,get(){return Ge},set(nt){Se(Ge,nt)||(Ge=nt,B.bus.fire([3,O,nt]))}}},zt=(B,O)=>B===O,Z=(B,O)=>B===O?!0:!B||!O?!1:B.isEqual(O);class ue{constructor(O,ie,Se,Ge){this.label=ie,this.data=Ge;const nt=(0,h.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>nt.parent},children:{value:new T.ReadonlyMapView(nt.children),enumerable:!0,writable:!1},range:Bt(nt,"range",void 0,Z),description:Bt(nt,"description",void 0,zt),runnable:Bt(nt,"runnable",!0,zt),debuggable:Bt(nt,"debuggable",!1,zt),status:Bt(nt,"status",bn.Resolved,zt),error:Bt(nt,"error",void 0,zt)})}invalidate(){(0,h.getPrivateApiFor)(this).bus.fire([2])}dispose(){const O=(0,h.getPrivateApiFor)(this);O.parent&&(0,h.getPrivateApiFor)(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof ue))throw new Error("Test child must be created through vscode.test.createTestItem()");const ie=(0,h.getPrivateApiFor)(this);if(ie.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);ie.children.set(O.id,O),ie.bus.fire([0,O])}}e.TestItemImpl=ue;class Pe{constructor(O){this.message=O,this.severity=vn.Error}static diff(O,ie,Se){const Ge=new Pe(O);return Ge.expectedOutput=ie,Ge.actualOutput=Se,Ge}}e.TestMessage=Pe;var st;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(st=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var wt;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wt=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Dt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(Dt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(ve[95],be([0,1,42,19,8,120,86,7,13]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function i(r,o){o?C.set(r,o):C.delete(r)}e.setWordDefinitionFor=i;function I(r){return C.get(r)}e.getWordDefinitionFor=I;class h extends T.MirrorTextModel{constructor(o,v,p,E,c,l,f,t){super(v,p,E,c);this._proxy=o,this._languageId=l,this._isDirty=f,this._notebook=t,this._isDisposed=!1}dispose(){(0,b.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(o){return(0,S.equals)(this._lines,o)}get document(){if(!this._document){const o=this;this._document={get uri(){return o._uri},get fileName(){return o._uri.fsPath},get isUntitled(){return o._uri.scheme===k.Schemas.untitled},get languageId(){return o._languageId},get version(){return o._versionId},get isClosed(){return o._isDisposed},get isDirty(){return o._isDirty},get notebook(){return o._notebook},save(){return o._save()},getText(v){return v?o._getTextInRange(v):o.getText()},get eol(){return o._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return o._lines.length},lineAt(v){return o._lineAt(v)},offsetAt(v){return o._offsetAt(v)},positionAt(v){return o._positionAt(v)},validateRange(v){return o._validateRange(v)},validatePosition(v){return o._validatePosition(v)},getWordRangeAtPosition(v,p){return o._getWordRangeAtPosition(v,p)}}}return Object.freeze(this._document)}_acceptLanguageId(o){(0,b.ok)(!this._isDisposed),this._languageId=o}_acceptIsDirty(o){(0,b.ok)(!this._isDisposed),this._isDirty=o}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(o){const v=this._validateRange(o);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const p=this._eol,E=v.start.line,c=v.end.line,l=[];l.push(this._lines[E].substring(v.start.character));for(let f=E+1;f<c;f++)l.push(this._lines[f]);return l.push(this._lines[c].substring(0,v.end.character)),l.join(p)}_lineAt(o){let v;if(o instanceof D.Position?v=o.line:typeof o=="number"&&(v=o),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new d(v,this._lines[v],v===this._lines.length-1)}_offsetAt(o){return o=this._validatePosition(o),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(o.line-1)+o.character}_positionAt(o){o=Math.floor(o),o=Math.max(0,o),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(o),p=this._lines[v.index].length;return new D.Position(v.index,Math.min(v.remainder,p))}_validateRange(o){if(!(o instanceof D.Range))throw new Error("Invalid argument");const v=this._validatePosition(o.start),p=this._validatePosition(o.end);return v===o.start&&p===o.end?o:new D.Range(v.line,v.character,p.line,p.character)}_validatePosition(o){if(!(o instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return o.with(0,0);let{line:v,character:p}=o,E=!1;if(v<0)v=0,p=0,E=!0;else if(v>=this._lines.length)v=this._lines.length-1,p=this._lines[v].length,E=!0;else{const c=this._lines[v].length;p<0?(p=0,E=!0):p>c&&(p=c,E=!0)}return E?new D.Position(v,p):o}_getWordRangeAtPosition(o,v){const p=this._validatePosition(o);if(!v)v=I(this._languageId);else if((0,P.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const E=(0,y.getWordAtText)(p.character+1,(0,y.ensureValidWordDefinition)(v),this._lines[p.line],0);if(E)return new D.Range(p.line,E.startColumn-1,p.line,E.endColumn-1)}}e.ExtHostDocumentData=h;class d{constructor(o,v,p){this._line=o,this._text=v,this._isLastLine=p}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(ve[163],be([0,1,7,3,88,6,59,22,2,31]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(h,d,r,o){this._notebook=r,this._selector=o,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=S.URI.from({scheme:"vscode-concat-doc",path:(0,C.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(p=>{const E=this._cellUris.get(p.document.uri);E!==void 0&&(this._cellLengths.changeValue(E,this._cells[E].document.getText().length+1),this._cellLines.changeValue(E,this._cells[E].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=p=>{p===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(h.onDidChangeNotebookCells(p=>v(p.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const h=[],d=[];for(const r of this._notebook.getCells())r.kind===b.NotebookCellKind.Code&&(!this._selector||(0,y.score)(this._selector,r.document.uri,r.document.languageId,!0))&&(this._cellUris.set(r.document.uri,this._cells.length),this._cells.push(r),h.push(r.document.getText().length+1),d.push(r.document.lineCount));this._cellLengths=new P.PrefixSumComputer(new Uint32Array(h)),this._cellLines=new P.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(h){var d,r;if(!h){let c="";for(const l of this._cells)c+=l.document.getText()+`
`;return c=c.slice(0,-1),c}if(h.isEmpty)return"";const o=this.locationAt(h.start),v=this.locationAt(h.end),p=this._cells[(d=this._cellUris.get(o.uri))!==null&&d!==void 0?d:-1],E=this._cells[(r=this._cellUris.get(v.uri))!==null&&r!==void 0?r:-1];if(!p||!E)return"";if(p===E)return p.document.getText(new b.Range(o.range.start,v.range.end));{const c=p.document.getText(new b.Range(o.range.start,new b.Position(p.document.lineCount,0))),l=E.document.getText(new b.Range(new b.Position(0,0),v.range.end));return c+`
`+l}}offsetAt(h){const d=this._cellLines.getIndexOf(h.line),r=this._cellLengths.getAccumulatedValue(d.index-1),o=this._cells[d.index].document.offsetAt(h.with(d.remainder));return r+o}positionAt(h){if(typeof h=="number"){const r=this._cellLengths.getIndexOf(h),o=this._cellLines.getAccumulatedValue(r.index-1);return this._cells[r.index].document.positionAt(r.remainder).translate(o)}const d=this._cellUris.get(h.uri);if(d!==void 0){const r=this._cellLines.getAccumulatedValue(d-1);return new b.Position(r+h.range.start.line,h.range.start.character)}return new b.Position(0,0)}locationAt(h){b.Range.isRange(h)||(h=new b.Range(h,h));const d=this._cellLines.getIndexOf(h.start.line);let r=d;h.isEmpty||(r=this._cellLines.getIndexOf(h.end.line));const o=new b.Position(d.remainder,h.start.character),v=new b.Position(r.remainder,h.end.character),p=new b.Range(o,v),E=this._cells[d.index];return new b.Location(E.document.uri,E.document.validateRange(p))}contains(h){return this._cellUris.has(h)}validateRange(h){const d=this.validatePosition(h.start),r=this.validatePosition(h.end);return h.with(d,r)}validatePosition(h){const d=this._cellLines.getIndexOf(h.line),r=new b.Position(d.remainder,h.character),o=this._cells[d.index].document.validatePosition(r),v=this._cellLines.getAccumulatedValue(d.index-1);return new b.Position(v+o.line,o.character)}}e.ExtHostNotebookConcatDocument=i}),define(ve[164],be([0,1,7,15,3]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(D){this._actual=new b.ColorTheme(b.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new P.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let S=D==="light"?b.ColorThemeKind.Light:D==="dark"?b.ColorThemeKind.Dark:b.ColorThemeKind.HighContrast;this._actual=new b.ColorTheme(S),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(ve[71],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,b.createDecorator)("IURITransformerService");class k{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=y=>y,this.transformOutgoing=y=>y,this.transformOutgoingURI=y=>y,this.transformOutgoingScheme=y=>y)}}e.URITransformerService=k}),define(ve[165],be([0,1,24]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(S){let C=this.buffers.indexOf(S);return C<0&&(C=this.buffers.length,this.buffers.push(S)),C}}function P(D,S){if(S.serializeBuffersForPostMessage){const C=new k,i=(d,r)=>{if(r instanceof ArrayBuffer){const o=C.add(r);return{$$vscode_array_buffer_reference$$:!0,index:o}}else if(ArrayBuffer.isView(r)){const o=T(r);if(o){const v=C.add(r.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}}return r},I=JSON.stringify(D,i),h=C.buffers.map(d=>{const r=new Uint8Array(d);return b.VSBuffer.wrap(r)});return{message:I,buffers:h}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=P;function T(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function y(D,S){const C=S.map(h=>{const d=new ArrayBuffer(h.byteLength);return new Uint8Array(d).set(h.buffer),d}),i=S.length?(h,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:o}=r,v=C[o];if(r.view)switch(r.view.type){case 1:return new Int8Array(v,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return d}:void 0;return{message:JSON.parse(D,i),arrayBuffers:C}}e.deserializeWebviewMessage=y}),define(ve[72],be([0,1,2]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=void 0;function k(T,y,D){const S=T.webviewResourceRoot.replace("{{resource}}",D.scheme+P(D)).replace("{{uuid}}",y);return b.URI.parse(S)}e.asWebviewUri=k;function P(T){return T.toString().replace(/^\S+?:/,"")}}),define(ve[166],be([0,1,3,6,72,31]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class y{constructor(S,C,i){this._proxy=S,this._editors=C,this._initData=i,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(C.onDidChangeVisibleTextEditors(()=>{const I=C.getVisibleTextEditors();for(const h of this._insets.values())I.indexOf(h.editor)<0&&h.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,C,i,I,h){let d;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===S){d=l;break}if(!d)throw new Error("not a visible editor");const r=this,o=this._handlePool++,v=new b.Emitter,p=new b.Emitter,E=new class{constructor(){this._uuid=(0,T.generateUuid)(),this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,P.asWebviewUri)(r._initData,this._uuid,l)}get cspSource(){return r._initData.webviewCspSource}set options(l){this._options=l,r._proxy.$setOptions(o,l)}get options(){return this._options}set html(l){this._html=l,r._proxy.$setHtml(o,l)}get html(){return this._html}get onDidReceiveMessage(){return v.event}postMessage(l){return r._proxy.$postMessage(o,l)}},c=new class{constructor(){this.editor=S,this.line=C,this.height=i,this.webview=E,this.onDidDispose=p.event}dispose(){r._insets.has(o)&&(r._insets.delete(o),r._proxy.$disposeEditorInset(o),p.fire(),p.dispose(),v.dispose())}};return this._proxy.$createEditorInset(o,d.id,d.value.document.uri,C+1,i,I||{},h.identifier,h.extensionLocation),this._insets.set(o,{editor:S,inset:c,onDidReceiveMessage:v}),c}$onDidDispose(S){const C=this._insets.get(S);C&&C.inset.dispose()}$onDidReceiveMessage(S,C){const i=this._insets.get(S);i&&i.onDidReceiveMessage.fire(C)}}e.ExtHostEditorInsets=y}),define(ve[167],be([0,1,3,63,138,4,6,22,29,13,51,23,36,158]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",h.Codicon.window,(0,P.localize)(0,null));var r;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(r=e.Extensions||(e.Extensions={}));var o;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(o=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function p(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=p;class E extends y.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new b.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new b.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,C.flatten)([...this.viewContainers.values()])}registerViewContainer(g,_,A){var m;const w=this.get(g.id);if(w)return w;const R=g;return R.openCommandActionDescriptor=(A==null?void 0:A.donotRegisterOpenCommand)?void 0:(m=R.openCommandActionDescriptor)!==null&&m!==void 0?m:{id:R.id},(0,D.getOrSet)(this.viewContainers,_,[]).push(R),(A==null?void 0:A.isDefault)&&this.defaultViewContainers.push(R),this._onDidRegister.fire({viewContainer:R,viewContainerLocation:_}),R}deregisterViewContainer(g){for(const _ of this.viewContainers.keys()){const A=this.viewContainers.get(_),m=A==null?void 0:A.indexOf(g);if(m!==-1){A==null||A.splice(m,1),A.length===0&&this.viewContainers.delete(_),this._onDidDeregister.fire({viewContainer:g,viewContainerLocation:_});return}}}get(g){return this.all.filter(_=>_.id===g)[0]}getViewContainers(g){return[...this.viewContainers.get(g)||[]]}getViewContainerLocation(g){return[...this.viewContainers.keys()].filter(_=>this.getViewContainers(_).filter(A=>(A==null?void 0:A.id)===g.id).length>0)[0]}getDefaultViewContainer(g){return this.defaultViewContainers.find(_=>this.getViewContainerLocation(_)===g)}}S.Registry.add(r.ViewContainersRegistry,new E);var c;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function l(u,g){var _,A,m,w;const R=(_=u.group)!==null&&_!==void 0?_:c.More,$=(A=g.group)!==null&&A!==void 0?A:c.More;return R!==$?R.localeCompare($):((m=u.order)!==null&&m!==void 0?m:5)-((w=g.order)!==null&&w!==void 0?w:5)}class f extends y.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new b.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new b.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new b.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new b.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(g,_){this.registerViews2([{views:g,viewContainer:_}])}registerViews2(g){g.forEach(({views:_,viewContainer:A})=>this.addViews(_,A)),this._onViewsRegistered.fire(g)}deregisterViews(g,_){const A=this.removeViews(g,_);A.length&&this._onViewsDeregistered.fire({views:A,viewContainer:_})}moveViews(g,_){for(const A of this._views.keys())if(A!==_){const m=this.removeViews(g,A);m.length&&(this.addViews(m,_),this._onDidChangeContainer.fire({views:m,from:A,to:_}))}}getViews(g){return this._views.get(g)||[]}getView(g){for(const _ of this._viewContainers){const A=(this._views.get(_)||[]).filter(m=>m.id===g)[0];if(A)return A}return null}getViewContainer(g){for(const _ of this._viewContainers)if((this._views.get(_)||[]).filter(m=>m.id===g)[0])return _;return null}registerViewWelcomeContent(g,_){return this._viewWelcomeContents.add(g,_),this._onDidChangeViewWelcomeContent.fire(g),(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,_),this._onDidChangeViewWelcomeContent.fire(g)})}registerViewWelcomeContent2(g,_){const A=new Map;for(const[m,w]of _)this._viewWelcomeContents.add(g,w),A.set(m,(0,y.toDisposable)(()=>{this._viewWelcomeContents.delete(g,w),this._onDidChangeViewWelcomeContent.fire(g)}));return this._onDidChangeViewWelcomeContent.fire(g),A}getViewWelcomeContent(g){const _=[];return this._viewWelcomeContents.forEach(g,A=>_.push(A)),_.sort(l)}addViews(g,_){let A=this._views.get(_);A||(A=[],this._views.set(_,A),this._viewContainers.push(_));for(const m of g){if(this.getView(m.id)!==null)throw new Error((0,P.localize)(1,null,m.id));A.push(m)}}removeViews(g,_){const A=this._views.get(_);if(!A)return[];const m=[],w=[];for(const R of A)g.includes(R)?m.push(R):w.push(R);return m.length&&(w.length?this._views.set(_,w):(this._views.delete(_),this._viewContainers.splice(this._viewContainers.indexOf(_),1))),m}}S.Registry.add(r.ViewsRegistry,new f),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new k.RawContextKey("focusedView","",(0,P.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var a;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(a=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(g,_){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,g),this._hasResolve=!!_,this.resolve=async A=>{var m,w;if(_&&!this.resolved){const R=await _(A);R&&(this.tooltip=(m=this.tooltip)!==null&&m!==void 0?m:R.tooltip,this.command=(w=this.command)!==null&&w!==void 0?w:R.command)}A.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(ve[168],be([0,1,2,148,159,18,149,167]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.OpenIssueReporter=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function S(o){return(v,...p)=>o(v.get(k.ICommandService),...p)}class C{static execute(v,p){const E={forceReuseWindow:p&&p.reuseWindow,remoteAuthority:p&&p.remoteAuthority};return v.executeCommand("_files.newWindow",E)}}e.NewWindowAPICommand=C,C.ID="vscode.newWindow",k.CommandsRegistry.registerCommand({id:C.ID,handler:S(C.execute),description:{description:"Opens an new window",args:[]}}),k.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,v){return o.get(P.IWorkspacesService).removeRecentlyOpened([v])});class i{static execute(v,p){return typeof p=="string"?p=p.match(/^[^:/?#]+:\/\//)?b.URI.parse(p):b.URI.file(p):p=b.URI.revive(p),v.executeCommand("_workbench.removeFromRecentlyOpened",p)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",k.CommandsRegistry.registerCommand(i.ID,S(i.execute));class I{static execute(v,p){const E=typeof p=="string"?{extensionId:p}:p;return v.executeCommand("workbench.action.openIssueReporter",E)}}e.OpenIssueReporter=I,I.ID="vscode.openIssueReporter",k.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,v){const p=o.get(P.IWorkspacesService);let E;const c=v.uri,l=v.label,f=v.remoteAuthority;return v.type==="workspace"?E={workspace:await p.getWorkspaceIdentifier(c),label:l,remoteAuthority:f}:v.type==="folder"?E={folderUri:c,label:l,remoteAuthority:f}:E={fileUri:c,label:l,remoteAuthority:f},p.addRecentlyOpened([E])}),k.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(P.IWorkspacesService).getRecentlyOpened()}),k.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,v){const p=o.get(T.ILogService),E=o.get(y.IEnvironmentService);E.isExtensionDevelopment&&!!E.extensionTestsLocationURI&&p.setLevel(v)}),k.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),k.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,v){const p=o.get(D.IViewDescriptorService),E=p.getViewContainerById(v.destinationId);if(!!E){for(const c of v.viewIds){const l=p.getViewDescriptorById(c);(l==null?void 0:l.canMoveView)&&p.moveViewsToContainer([l],E,D.ViewVisibilityState.Default)}await o.get(D.IViewsService).openViewContainer(E.id,!0)}});class h{static execute(v,p){return!Array.isArray(p==null?void 0:p.viewIds)||typeof(p==null?void 0:p.destinationId)!="string"?Promise.reject("Invalid arguments"):v.executeCommand("_workbench.action.moveViews",p)}}e.MoveViewsAPICommand=h,h.ID="vscode.moveViews",k.CommandsRegistry.registerCommand({id:h.ID,handler:S(h.execute),description:{description:"Move Views",args:[]}});class d{static execute(v,p){return v.executeCommand("_workbench.open",p)}}d.ID="vscode.open",k.CommandsRegistry.registerCommand(d.ID,S(d.execute));class r{static execute(v,p,E,c,l){return v.executeCommand("_workbench.diff",[p,E,c])}}r.ID="vscode.diff",k.CommandsRegistry.registerCommand(r.ID,S(r.execute))}),define(ve[169],be([0,1,3,11,139]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new b.Emitter,this._onExit=new b.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,S,C,i){const I={command:D};if(S&&Object.keys(S).length>0&&(I.arguments=S),this.internalSend("request",I),typeof i=="number"){const h=setTimeout(()=>{clearTimeout(h);const d=this.pendingRequests.get(I.seq);if(d){this.pendingRequests.delete(I.seq);const r={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:(0,P.localize)(0,null,i,D)};d(r)}},i)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,S){return D.type!=="event"||S.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await(0,k.timeout)(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const S=D,C=this.pendingRequests.get(S.request_seq);C&&(this.pendingRequests.delete(S.request_seq),C(S));break}}}internalSend(D,S){S.type=D,S.seq=this.sequence++,this.sendMessage(S)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((S,C)=>D.set(C,S)),await(0,k.timeout)(500),D.forEach((S,C)=>{S({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(ve[170],be([0,1,8,2,14,23,19]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function S(n,a,s){return n.replace(D,function(u,g){return a&&g.length>0&&g[0]!=="_"?u:s&&s.hasOwnProperty(g)?s[g]:u})}e.formatPII=S;function C(n){const a={};for(const s of Object.keys(n))s.startsWith("!")||(a[s]=n[s]);return a}e.filterExceptionsFromTelemetry=C;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let a=n.configuration.type;if(!!a)return a==="vslsShare"&&(a=n.configuration.adapterProxy.configuration.type),(0,b.equalsIgnoreCase)(a,"extensionhost")||(0,b.equalsIgnoreCase)(a,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function h(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=h;function d(n,a,s){let u,g=0,_=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,A=null;for(;A=_.exec(n);){let m=A.index+1,w=m+A[0].length;if(m<=a&&w>=s){u=A[0],g=m;break}}if(u){let m=/\w+/g,w=null;for(;(w=m.exec(u))&&!(w.index+1+g+w[0].length>=s););w&&(u=u.substring(0,m.lastIndex))}return u?{start:g,end:g+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const r=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(n){return!!(n&&n.match(r))}e.isUri=o;function v(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(o(n.path))return k.URI.parse(n.path);if((0,P.isAbsolute)(n.path))return k.URI.file(n.path)}return n.path}function p(n){if(typeof n.path=="object"){const a=k.URI.revive(n.path);if(a)return a.scheme===y.Schemas.file?a.fsPath:a.toString()}return n.path}function E(n,a){const s=a?v:p,u=(0,T.deepClone)(n);return l(u,(g,_)=>{g&&_&&(_.path=s(_))}),u}e.convertToDAPaths=E;function c(n,a){const s=a?v:p,u=(0,T.deepClone)(n);return l(u,(g,_)=>{!g&&_&&(_.path=s(_))}),u}e.convertToVSCPaths=c;function l(n,a){switch(n.type){case"event":const s=n;switch(s.event){case"output":a(!1,s.body.source);break;case"loadedSource":a(!1,s.body.source);break;case"breakpoint":a(!1,s.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":a(!0,u.arguments.source);break;case"breakpointLocations":a(!0,u.arguments.source);break;case"source":a(!0,u.arguments.source);break;case"gotoTargets":a(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(_=>a(!1,_));break;default:break}break;case"response":const g=n;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(_=>a(!1,_.source));break;case"loadedSources":g.body.sources.forEach(_=>a(!1,_));break;case"scopes":g.body.scopes.forEach(_=>a(!1,_.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(_=>a(!1,_.source));break;case"setBreakpoints":g.body.breakpoints.forEach(_=>a(!1,_.source));break;default:break}break}}function f(n){return n.filter(a=>{var s;return!((s=a.presentation)===null||s===void 0?void 0:s.hidden)}).sort((a,s)=>a.presentation?s.presentation?a.presentation.group?s.presentation.group?a.presentation.group!==s.presentation.group?a.presentation.group.localeCompare(s.presentation.group):t(a.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(a.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=f;function t(n,a){return typeof n!="number"?typeof a!="number"?0:1:typeof a!="number"?-1:n-a}}),define(ve[73],be([0,1,28,19,14,21,63]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var D;(function(m){m[m.Markdown=1]="Markdown",m[m.Code=2]="Code"})(D=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(m){m[m.Running=1]="Running",m[m.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var C;(function(m){m[m.Idle=1]="Idle",m[m.Pending=2]="Pending",m[m.Executing=3]="Executing"})(C=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(m){m[m.WithHardKernelDependency=0]="WithHardKernelDependency",m[m.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",m[m.Pure=2]="Pure",m[m.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(m){m[m.ModelChange=1]="ModelChange",m[m.Move=2]="Move",m[m.CellClearOutput=3]="CellClearOutput",m[m.CellsClearOutput=4]="CellsClearOutput",m[m.ChangeLanguage=5]="ChangeLanguage",m[m.Initialize=6]="Initialize",m[m.ChangeCellMetadata=7]="ChangeCellMetadata",m[m.Output=8]="Output",m[m.OutputItem=9]="OutputItem",m[m.ChangeCellContent=10]="ChangeCellContent",m[m.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",m[m.Unknown=12]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var h;(function(m){m[m.Handle=0]="Handle",m[m.Index=1]="Index"})(h=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(m){m[m.Replace=1]="Replace",m[m.Output=2]="Output",m[m.Metadata=3]="Metadata",m[m.CellLanguage=4]="CellLanguage",m[m.DocumentMetadata=5]="DocumentMetadata",m[m.Move=6]="Move",m[m.OutputItems=7]="OutputItems",m[m.PartialMetadata=8]="PartialMetadata"})(d=e.CellEditType||(e.CellEditType={}));function r(m){const w=o.parse(m);return w?w.notebook.toString():m.toString()}e.getCellUndoRedoComparisonKey=r;var o;(function(m){m.scheme=k.Schemas.vscodeNotebookCell;const w=/^ch(\d{7,})/;function R(H,Y){return H.with({scheme:m.scheme,fragment:`ch${Y.toString().padStart(7,"0")}${H.scheme!==k.Schemas.file?H.scheme:""}`})}m.generate=R;function $(H){if(H.scheme===m.scheme){const Y=w.exec(H.fragment);if(!!Y)return{handle:Number(Y[1]),notebook:H.with({scheme:H.fragment.substr(Y[0].length)||k.Schemas.file,fragment:null})}}}m.parse=$;function K(H){if(H.scheme===k.Schemas.vscodeNotebookCellMetadata){const Y=w.exec(H.fragment);if(!!Y)return{handle:Number(Y[1]),notebook:H.with({scheme:H.fragment.substr(Y[0].length)||k.Schemas.file,fragment:null})}}}m.parseCellMetadataUri=K;function he(H,Y,U){return H.with({scheme:U,fragment:`ch${Y.toString().padStart(7,"0")}${H.scheme!==k.Schemas.file?H.scheme:""}`})}m.generateCellUri=he;function V(H,Y){if(H.scheme===Y){const U=w.exec(H.fragment);if(!!U)return{handle:Number(U[1]),notebook:H.with({scheme:H.fragment.substr(U[0].length)||k.Schemas.file,fragment:null})}}}m.parseCellUri=V})(o=e.CellUri||(e.CellUri={}));const v=new Map([["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["application/javascript",{supportedByCore:!0}],["text/html",{supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["image/jpeg",{supportedByCore:!0}],["text/x-javascript",{supportedByCore:!0}],["application/x.notebook.error-traceback",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(m){var w,R;return(R=(w=v.get(m))===null||w===void 0?void 0:w.alwaysSecure)!==null&&R!==void 0?R:!1}e.mimeTypeIsAlwaysSecure=p;function E(m){var w,R;return(R=(w=v.get(m))===null||w===void 0?void 0:w.supportedByCore)!==null&&R!==void 0?R:!1}e.mimeTypeSupportedByCore=E;function c(m){var w,R;return(R=(w=v.get(m))===null||w===void 0?void 0:w.mergeable)!==null&&R!==void 0?R:!1}e.mimeTypeIsMergeable=c;function l(m,w){return T.isWindows&&(m=m.replace(/\//g,"\\"),w=w.replace(/\//g,"\\")),b.match(m,w)}function f(m,w,R){let $=0;for(let K=0;K<w.length;K++){if(l(w[K],m))return $;$++}for(let K=0;K<R.length;K++){if(l(R[K],m))return $;$++}return $}function t(m,w,R){return m.sort(($,K)=>f($,w,R)-f(K,w,R))}e.sortMimeTypes=t;function n(m,w,R,$=(K,he)=>K===he){const K=[];function he(Y,U,F){if(!(U===0&&F.length===0)){const L=K[K.length-1];L&&L.start+L.deleteCount===Y?(L.deleteCount+=U,L.toInsert.push(...F)):K.push({start:Y,deleteCount:U,toInsert:F})}}let V=0,H=0;for(;;){if(V===m.length){he(V,0,w.slice(H));break}if(H===w.length){he(V,m.length-V,[]);break}const Y=m[V],U=w[H];if($(Y,U)){V+=1,H+=1;continue}R(U)?(he(V,1,[]),V+=1):(he(V,0,[U]),H+=1)}return K}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(m){m.default="default",m.option="option"})(a=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(m){const w=m;return!!((typeof w.include=="string"||b.isRelativePattern(w.include))&&(typeof w.exclude=="string"||b.isRelativePattern(w.exclude)))}e.isDocumentExcludePattern=s;function u(m,w,R){if(Array.isArray(m.viewType)&&m.viewType.indexOf(w)>=0||m.viewType===w)return!0;if(m.filenamePattern){let $=s(m.filenamePattern)?m.filenamePattern.include:m.filenamePattern,K=s(m.filenamePattern)?m.filenamePattern.exclude:void 0;if(b.match($,(0,P.basename)(R.fsPath).toLowerCase()))return!(K&&b.match(K,(0,P.basename)(R.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class g{constructor(w){this.textModel=w}getElements(){const w=new Int32Array(this.textModel.cells.length);for(let R=0;R<this.textModel.cells.length;R++)w[R]=this.textModel.cells[R].getHashValue();return w}}e.CellSequence=g,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer";var _;(function(m){m[m.Left=1]="Left",m[m.Right=2]="Right"})(_=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(w){return`${A._prefix}/${w}`}static parse(w){if(w.startsWith(A._prefix))return w.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(ve[171],be([0,1,141,4,63]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new P.RawContextKey("customExecutionSupported",!0,b.localize(0,null)),e.ShellExecutionSupportedContext=new P.RawContextKey("shellExecutionSupported",!1,b.localize(1,null)),e.ProcessExecutionSupportedContext=new P.RawContextKey("processExecutionSupported",!1,b.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(ve[172],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function b(P){return[...P.entries()]}e.serializeEnvironmentVariableCollection=b;function k(P){return new Map(P)}e.deserializeEnvironmentVariableCollection=k}),define(ve[96],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var b;(function(S){S[S.NotExpandable=0]="NotExpandable",S[S.Expandable=1]="Expandable",S[S.BusyExpanding=2]="BusyExpanding",S[S.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));const k=(S,C)=>{C.expand!==void 0&&(S.expand=C.expand),C.item!==void 0&&(S.item=S.item?Object.assign(S.item,C.item):C.item)};e.applyTestItemUpdate=k;var P;(function(S){S[S.Add=0]="Add",S[S.Update=1]="Update",S[S.Remove=2]="Remove",S[S.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",S[S.Retire=4]="Retire"})(P=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(S,C)=>`${S}:${C.toString()}`;e.getTestSubscriptionKey=T;class y{add(C){}update(C){}remove(C,i){}complete(){}}e.IncrementalChangeCollector=y;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const i=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const h=I[1];if(h.parent){if(this.items.has(h.parent)){const d=this.items.get(h.parent);d.children.add(h.item.extId);const r=this.createItem(h,d);this.items.set(h.item.extId,r),i.add(r)}}else{this.roots.add(h.item.extId);const d=this.createItem(h);this.items.set(h.item.extId,d),i.add(d)}h.expand===2&&this.busyControllerCount++;break}case 1:{const h=I[1],d=this.items.get(h.extId);if(!d)break;h.expand!==void 0&&(d.expand===2&&this.busyControllerCount--,h.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(d,h),i.update(d);break}case 2:{const h=this.items.get(I[1]);if(!h)break;h.parent?this.items.get(h.parent).children.delete(h.item.extId):this.roots.delete(h.item.extId);const d=[[I[1]]];for(;d.length;)for(const r of d.pop()){const o=this.items.get(r);o&&(d.push(o.children),this.items.delete(r),i.remove(o,o!==h),o.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new y}}e.AbstractIncrementalTestCollection=D}),define(ve[173],be([0,1,14,46,10,23,21,58,142]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,h,d){this._contributedVariables=new Map,this._context=I,this._labelService=h,d&&(this._envVariablesPromise=d.then(r=>this.prepareEnv(r)))}prepareEnv(I){if(y.isWindows){const h=Object.create(null);return Object.keys(I).forEach(d=>{h[d.toLowerCase()]=I[d]}),h}return I}resolveWithEnvironment(I,h,d){return this.recursiveResolve(this.prepareEnv(I),h?h.uri:void 0,d)}async resolveAsync(I,h){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,h)}async resolveAnyBase(I,h,d,r){const o=T.deepClone(h);return y.isWindows&&o.windows?Object.keys(o.windows).forEach(v=>o[v]=o.windows[v]):y.isMacintosh&&o.osx?Object.keys(o.osx).forEach(v=>o[v]=o.osx[v]):y.isLinux&&o.linux&&Object.keys(o.linux).forEach(v=>o[v]=o.linux[v]),delete o.windows,delete o.osx,delete o.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o,d,r)}async resolveAnyAsync(I,h,d){return this.resolveAnyBase(I,h,d)}async resolveAnyMap(I,h,d){const r=new Map;return{newConfig:await this.resolveAnyBase(I,h,d,r),resolvedVariables:r}}resolveWithInteractionReplace(I,h,d,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,h,d,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,h){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,h)}recursiveResolve(I,h,d,r,o){if(P.isString(d))return this.resolveString(I,h,d,r,o);if(P.isArray(d))return d.map(v=>this.recursiveResolve(I,h,v,r,o));if(P.isObject(d)){let v=Object.create(null);return Object.keys(d).forEach(p=>{const E=this.resolveString(I,h,p,r,o);v[E]=this.recursiveResolve(I,h,d[p],r,o)}),v}return d}resolveString(I,h,d,r,o){return d.replace(C.VARIABLE_REGEXP,(p,E)=>{if(E.includes(C.VARIABLE_LHS))return p;let c=this.evaluateSingleVariable(I,p,E,h,r);return o&&o.set(E,c),c})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,h,d,r,o){let v;const p=d.split(":");p.length>1&&(d=p[0],v=p[1]);const E=()=>{const f=this._context.getFilePath();if(f)return f;throw new Error((0,S.localize)(0,null,h))},c=()=>{const f=E();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,S.localize)(1,null,h,b.basename(f)))},l=()=>{if(v){const f=this._context.getFolderUri(v);if(f)return f;throw new Error((0,S.localize)(2,null,h,v))}if(r)return r;throw this._context.getWorkspaceFolderCount()>1?new Error((0,S.localize)(3,null,h)):new Error((0,S.localize)(4,null,h))};switch(d){case"env":if(v){if(I){const f=I[y.isWindows?v.toLowerCase():v];if(P.isString(f))return f}return""}throw new Error((0,S.localize)(5,null,h));case"config":if(v){const f=this._context.getConfigurationValue(r,v);if(P.isUndefinedOrNull(f))throw new Error((0,S.localize)(6,null,h,v));if(P.isObject(f))throw new Error((0,S.localize)(7,null,h,v));return f}throw new Error((0,S.localize)(8,null,h));case"command":return this.resolveFromMap(h,v,o,"command");case"input":return this.resolveFromMap(h,v,o,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,D.normalizeDriveLetter)(this.fsPath(l()));case"cwd":return r||v?(0,D.normalizeDriveLetter)(this.fsPath(l())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return b.basename(this.fsPath(l()));case"lineNumber":const f=this._context.getLineNumber();if(f)return f;throw new Error((0,S.localize)(9,null,h));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,S.localize)(10,null,h));case"file":return E();case"fileWorkspaceFolder":return c();case"relativeFile":return r||v?b.relative(this.fsPath(l()),E()):E();case"relativeFileDirname":const n=b.dirname(E());if(r||v){const g=b.relative(this.fsPath(l()),n);return g.length===0?".":g}return n;case"fileDirname":return b.dirname(E());case"fileExtname":return b.extname(E());case"fileBasename":return b.basename(E());case"fileBasenameNoExtension":const a=b.basename(E());return a.slice(0,a.length-b.extname(a).length);case"fileDirnameBasename":return b.basename(b.dirname(E()));case"execPath":const s=this._context.getExecPath();return s||h;case"execInstallFolder":const u=this._context.getAppRoot();return u||h;case"pathSeparator":return b.sep;default:try{const g=v?`${d}:${v}`:d;return this.resolveFromMap(h,g,o,void 0)}catch(g){return h}}}}resolveFromMap(I,h,d,r){if(h&&d){const o=r===void 0?d[h]:d[r+":"+h];if(typeof o=="string")return o;throw new Error((0,S.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(ve[174],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,b.createDecorator)("editorGroupsService");var k;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(k=e.GroupDirection||(e.GroupDirection={}));var P;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(P=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var y;(function(h){h[h.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",h[h.EVEN=1]="EVEN",h[h.TOGGLE=2]="TOGGLE"})(y=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var S;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(S=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(h){h[h.GROUP_ACTIVE=0]="GROUP_ACTIVE",h[h.GROUP_INDEX=1]="GROUP_INDEX",h[h.EDITOR_OPEN=2]="EDITOR_OPEN",h[h.EDITOR_CLOSE=3]="EDITOR_CLOSE",h[h.EDITOR_MOVE=4]="EDITOR_MOVE",h[h.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",h[h.EDITOR_LABEL=6]="EDITOR_LABEL",h[h.EDITOR_PIN=7]="EDITOR_PIN",h[h.EDITOR_STICKY=8]="EDITOR_STICKY",h[h.EDITOR_DIRTY=9]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(ve[175],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,b.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(ve[9],be([0,1,13,83,229,57,23,10,2,32,62,143,90,73,175,7]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookKernelPreload=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookCellKind=e.NotebookCellPreviousExecutionResult=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var v;(function(pe){function ce(q){const{selectionStartLineNumber:Me,selectionStartColumn:Te,positionLineNumber:Je,positionColumn:et}=q,ct=new o.Position(Me-1,Te-1),ht=new o.Position(Je-1,et-1);return new o.Selection(ct,ht)}pe.to=ce;function se(q){const{anchor:Me,active:Te}=q;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}pe.from=se})(v=e.Selection||(e.Selection={}));var p;(function(pe){function ce(q){if(!!q){const{start:Me,end:Te}=q;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}}pe.from=ce;function se(q){if(!!q){const{startLineNumber:Me,startColumn:Te,endLineNumber:Je,endColumn:et}=q;return new o.Range(Me-1,Te-1,Je-1,et-1)}}pe.to=se})(p=e.Range||(e.Range={}));var E;(function(pe){function ce(se){switch(se){case 1:return o.StandardTokenType.Comment;case 0:return o.StandardTokenType.Other;case 4:return o.StandardTokenType.RegEx;case 2:return o.StandardTokenType.String}}pe.to=ce})(E=e.TokenType||(e.TokenType={}));var c;(function(pe){function ce(q){return new o.Position(q.lineNumber-1,q.column-1)}pe.to=ce;function se(q){return{lineNumber:q.line+1,column:q.character+1}}pe.from=se})(c=e.Position||(e.Position={}));var l;(function(pe){function ce(q){switch(q){case o.DiagnosticTag.Unnecessary:return 1;case o.DiagnosticTag.Deprecated:return 2}}pe.from=ce;function se(q){switch(q){case 1:return o.DiagnosticTag.Unnecessary;case 2:return o.DiagnosticTag.Deprecated;default:return}}pe.to=se})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var f;(function(pe){function ce(q){let Me;return q.code&&((0,D.isString)(q.code)||(0,D.isNumber)(q.code)?Me=String(q.code):Me={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},p.from(q.range)),{message:q.message,source:q.source,code:Me,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,b.coalesce)(q.tags.map(l.from)):void 0})}pe.from=ce;function se(q){var Me;const Te=new o.Diagnostic(p.to(q),q.message,n.to(q.severity));return Te.source=q.source,Te.code=(0,D.isString)(q.code)?q.code:(Me=q.code)===null||Me===void 0?void 0:Me.value,Te.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Te.tags=q.tags&&(0,b.coalesce)(q.tags.map(l.to)),Te}pe.to=se})(f=e.Diagnostic||(e.Diagnostic={}));var t;(function(pe){function ce(q){return Object.assign(Object.assign({},p.from(q.location.range)),{message:q.message,resource:q.location.uri})}pe.from=ce;function se(q){return new o.DiagnosticRelatedInformation(new o.Location(q.resource,p.to(q)),q.message)}pe.to=se})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(pe){function ce(q){switch(q){case o.DiagnosticSeverity.Error:return h.MarkerSeverity.Error;case o.DiagnosticSeverity.Warning:return h.MarkerSeverity.Warning;case o.DiagnosticSeverity.Information:return h.MarkerSeverity.Info;case o.DiagnosticSeverity.Hint:return h.MarkerSeverity.Hint}return h.MarkerSeverity.Error}pe.from=ce;function se(q){switch(q){case h.MarkerSeverity.Info:return o.DiagnosticSeverity.Information;case h.MarkerSeverity.Warning:return o.DiagnosticSeverity.Warning;case h.MarkerSeverity.Error:return o.DiagnosticSeverity.Error;case h.MarkerSeverity.Hint:return o.DiagnosticSeverity.Hint;default:return o.DiagnosticSeverity.Error}}pe.to=se})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var a;(function(pe){function ce(q){return typeof q=="number"&&q>=o.ViewColumn.One?q-1:q===o.ViewColumn.Beside?r.SIDE_GROUP:r.ACTIVE_GROUP}pe.from=ce;function se(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=se})(a=e.ViewColumn||(e.ViewColumn={}));function s(pe){return typeof pe.range!="undefined"}function u(pe){return pe.length===0?!0:!!s(pe[0])}e.isDecorationOptionsArr=u;var g;(function(pe){function ce(et){return et.map(pe.from)}pe.fromMany=ce;function se(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ct;if(se(et)){const{language:ft,value:lt}=et;ct={value:"```"+ft+`
`+lt+"\n```\n"}}else o.MarkdownString.isMarkdownString(et)?ct={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ct={value:et}:ct={value:""};const ht=Object.create(null);ct.uris=ht;const Xe=ft=>{try{let lt=S.URI.parse(ft,!0);lt=lt.with({query:Me(lt.query,ht)}),ht[ft]=lt}catch(lt){}return""},at=new P.Renderer;return at.link=Xe,at.image=ft=>Xe(k.parseHrefAndDimensions(ft).href),P(ct.value,{renderer:at}),ct}pe.from=q;function Me(et,ct){if(!et)return et;let ht;try{ht=(0,T.parse)(et)}catch(at){}if(!ht)return et;let Xe=!1;return ht=(0,y.cloneAndChange)(ht,at=>{if(S.URI.isUri(at)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[ft]=at,Xe=!0,ft}else return}),Xe?JSON.stringify(ht):et}function Te(et){const ct=new o.MarkdownString(et.value,et.supportThemeIcons);return ct.isTrusted=et.isTrusted,ct}pe.to=Te;function Je(et){if(!!et)return typeof et=="string"?et:pe.from(et)}pe.fromStrict=Je})(g=e.MarkdownString||(e.MarkdownString={}));function _(pe){return u(pe)?pe.map(ce=>({range:p.from(ce.range),hoverMessage:Array.isArray(ce.hoverMessage)?g.fromMany(ce.hoverMessage):ce.hoverMessage?g.from(ce.hoverMessage):void 0,renderOptions:ce.renderOptions})):pe.map(ce=>({range:p.from(ce)}))}e.fromRangeOrRangeWithMessage=_;function A(pe){return typeof pe=="undefined"?pe:typeof pe=="string"?S.URI.file(pe):pe}e.pathOrURIToURI=A;var m;(function(pe){function ce(se){return typeof se=="undefined"?se:{contentText:se.contentText,contentIconPath:se.contentIconPath?A(se.contentIconPath):void 0,border:se.border,borderColor:se.borderColor,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,color:se.color,backgroundColor:se.backgroundColor,margin:se.margin,width:se.width,height:se.height}}pe.from=ce})(m=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var w;(function(pe){function ce(se){return typeof se=="undefined"?se:{backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?A(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?m.from(se.before):void 0,after:se.after?m.from(se.after):void 0}}pe.from=ce})(w=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(pe){function ce(se){if(typeof se=="undefined")return se;switch(se){case o.DecorationRangeBehavior.OpenOpen:return 0;case o.DecorationRangeBehavior.ClosedClosed:return 1;case o.DecorationRangeBehavior.OpenClosed:return 2;case o.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=ce})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var $;(function(pe){function ce(se){return{isWholeLine:se.isWholeLine,rangeBehavior:se.rangeBehavior?R.from(se.rangeBehavior):void 0,overviewRulerLane:se.overviewRulerLane,light:se.light?w.from(se.light):void 0,dark:se.dark?w.from(se.dark):void 0,backgroundColor:se.backgroundColor,outline:se.outline,outlineColor:se.outlineColor,outlineStyle:se.outlineStyle,outlineWidth:se.outlineWidth,border:se.border,borderColor:se.borderColor,borderRadius:se.borderRadius,borderSpacing:se.borderSpacing,borderStyle:se.borderStyle,borderWidth:se.borderWidth,fontStyle:se.fontStyle,fontWeight:se.fontWeight,textDecoration:se.textDecoration,cursor:se.cursor,color:se.color,opacity:se.opacity,letterSpacing:se.letterSpacing,gutterIconPath:se.gutterIconPath?A(se.gutterIconPath):void 0,gutterIconSize:se.gutterIconSize,overviewRulerColor:se.overviewRulerColor,before:se.before?m.from(se.before):void 0,after:se.after?m.from(se.after):void 0}}pe.from=ce})($=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(pe){function ce(q){return{text:q.newText,eol:q.newEol&&ee.from(q.newEol),range:p.from(q.range)}}pe.from=ce;function se(q){const Me=new o.TextEdit(p.to(q.range),q.text);return Me.newEol=typeof q.eol=="undefined"?void 0:ee.to(q.eol),Me}pe.to=se})(K=e.TextEdit||(e.TextEdit={}));var he;(function(pe){function ce(q,Me,Te){var Je,et,ct;const ht={edits:[]};if(q instanceof o.WorkspaceEdit)for(let Xe of q._allEntries())if(Xe._type===1)ht.edits.push({_type:1,oldUri:Xe.from,newUri:Xe.to,options:Xe.options,metadata:Xe.metadata});else if(Xe._type===2){const at=Me==null?void 0:Me.getDocument(Xe.uri);ht.edits.push({_type:2,resource:Xe.uri,edit:K.from(Xe.edit),modelVersionId:at==null?void 0:at.version,metadata:Xe.metadata})}else Xe._type===3?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:Xe.edit,notebookMetadata:Xe.notebookMetadata,notebookVersionId:(Je=Te==null?void 0:Te.getNotebookDocument(Xe.uri,!0))===null||Je===void 0?void 0:Je.apiNotebook.version}):Xe._type===4?(Xe.newOutputs&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:2,index:Xe.index,append:Xe.append,outputs:Xe.newOutputs.map(ke.from)}}),Xe.newMetadata&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:8,index:Xe.index,metadata:Xe.newMetadata}})):Xe._type===5?ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,notebookVersionId:(et=Te==null?void 0:Te.getNotebookDocument(Xe.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:Xe.index,count:Xe.count,cells:Xe.cells.map(Q.from)}}):Xe._type===6&&ht.edits.push({_type:3,metadata:Xe.metadata,resource:Xe.uri,edit:{editType:7,outputId:Xe.outputId,items:((ct=Xe.newOutputItems)===null||ct===void 0?void 0:ct.map(ae.from))||[],append:Xe.append}});return ht}pe.from=ce;function se(q){const Me=new o.WorkspaceEdit;for(const Te of q.edits)Te.edit?Me.replace(S.URI.revive(Te.resource),p.to(Te.edit.range),Te.edit.text):Me.renameFile(S.URI.revive(Te.oldUri),S.URI.revive(Te.newUri),Te.options);return Me}pe.to=se})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var V;(function(pe){const ce=Object.create(null);ce[o.SymbolKind.File]=0,ce[o.SymbolKind.Module]=1,ce[o.SymbolKind.Namespace]=2,ce[o.SymbolKind.Package]=3,ce[o.SymbolKind.Class]=4,ce[o.SymbolKind.Method]=5,ce[o.SymbolKind.Property]=6,ce[o.SymbolKind.Field]=7,ce[o.SymbolKind.Constructor]=8,ce[o.SymbolKind.Enum]=9,ce[o.SymbolKind.Interface]=10,ce[o.SymbolKind.Function]=11,ce[o.SymbolKind.Variable]=12,ce[o.SymbolKind.Constant]=13,ce[o.SymbolKind.String]=14,ce[o.SymbolKind.Number]=15,ce[o.SymbolKind.Boolean]=16,ce[o.SymbolKind.Array]=17,ce[o.SymbolKind.Object]=18,ce[o.SymbolKind.Key]=19,ce[o.SymbolKind.Null]=20,ce[o.SymbolKind.EnumMember]=21,ce[o.SymbolKind.Struct]=22,ce[o.SymbolKind.Event]=23,ce[o.SymbolKind.Operator]=24,ce[o.SymbolKind.TypeParameter]=25;function se(Me){return typeof ce[Me]=="number"?ce[Me]:6}pe.from=se;function q(Me){for(const Te in ce)if(ce[Te]===Me)return Number(Te);return o.SymbolKind.Property}pe.to=q})(V=e.SymbolKind||(e.SymbolKind={}));var H;(function(pe){function ce(q){switch(q){case o.SymbolTag.Deprecated:return 1}}pe.from=ce;function se(q){switch(q){case 1:return o.SymbolTag.Deprecated}}pe.to=se})(H=e.SymbolTag||(e.SymbolTag={}));var Y;(function(pe){function ce(q){return{name:q.name,kind:V.from(q.kind),tags:q.tags&&q.tags.map(H.from),containerName:q.containerName,location:x.from(q.location)}}pe.from=ce;function se(q){const Me=new o.SymbolInformation(q.name,V.to(q.kind),q.containerName,x.to(q.location));return Me.tags=q.tags&&q.tags.map(H.to),Me}pe.to=se})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var U;(function(pe){function ce(q){var Me,Te;const Je={name:q.name||"!!MISSING: name!!",detail:q.detail,range:p.from(q.range),selectionRange:p.from(q.selectionRange),kind:V.from(q.kind),tags:(Te=(Me=q.tags)===null||Me===void 0?void 0:Me.map(H.from))!==null&&Te!==void 0?Te:[]};return q.children&&(Je.children=q.children.map(ce)),Je}pe.from=ce;function se(q){const Me=new o.DocumentSymbol(q.name,q.detail,V.to(q.kind),p.to(q.range),p.to(q.selectionRange));return(0,b.isNonEmptyArray)(q.tags)&&(Me.tags=q.tags.map(H.to)),q.children&&(Me.children=q.children.map(se)),Me}pe.to=se})(U=e.DocumentSymbol||(e.DocumentSymbol={}));var F;(function(pe){function ce(se){const q=new o.CallHierarchyItem(V.to(se.kind),se.name,se.detail||"",S.URI.revive(se.uri),p.to(se.range),p.to(se.selectionRange));return q._sessionId=se._sessionId,q._itemId=se._itemId,q}pe.to=ce})(F=e.CallHierarchyItem||(e.CallHierarchyItem={}));var L;(function(pe){function ce(se){return new o.CallHierarchyIncomingCall(F.to(se.from),se.fromRanges.map(q=>p.to(q)))}pe.to=ce})(L=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(pe){function ce(se){return new o.CallHierarchyOutgoingCall(F.to(se.to),se.fromRanges.map(q=>p.to(q)))}pe.to=ce})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var x;(function(pe){function ce(q){return{range:q.range&&p.from(q.range),uri:q.uri}}pe.from=ce;function se(q){return new o.Location(S.URI.revive(q.uri),p.to(q.range))}pe.to=se})(x=e.location||(e.location={}));var G;(function(pe){function ce(q){const Me=q,Te=q;return{originSelectionRange:Me.originSelectionRange?p.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Te.uri,range:p.from(Me.targetRange?Me.targetRange:Te.range),targetSelectionRange:Me.targetSelectionRange?p.from(Me.targetSelectionRange):void 0}}pe.from=ce;function se(q){return{targetUri:S.URI.revive(q.uri),targetRange:p.to(q.range),targetSelectionRange:q.targetSelectionRange?p.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?p.to(q.originSelectionRange):void 0}}pe.to=se})(G=e.DefinitionLink||(e.DefinitionLink={}));var X;(function(pe){function ce(q){return{range:p.from(q.range),contents:g.fromMany(q.contents)}}pe.from=ce;function se(q){return new o.Hover(q.contents.map(g.to),p.to(q.range))}pe.to=se})(X=e.Hover||(e.Hover={}));var ne;(function(pe){function ce(q){return{range:p.from(q.range),expression:q.expression}}pe.from=ce;function se(q){return new o.EvaluatableExpression(p.to(q.range),q.expression)}pe.to=se})(ne=e.EvaluatableExpression||(e.EvaluatableExpression={}));var me;(function(pe){function ce(q){if(q instanceof o.InlineValueText)return{type:"text",range:p.from(q.range),text:q.text};if(q instanceof o.InlineValueVariableLookup)return{type:"variable",range:p.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof o.InlineValueEvaluatableExpression)return{type:"expression",range:p.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=ce;function se(q){switch(q.type){case"text":return{range:p.to(q.range),text:q.text};case"variable":return{range:p.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:p.to(q.range),expression:q.expression}}}pe.to=se})(me=e.InlineValue||(e.InlineValue={}));var Le;(function(pe){function ce(q){return{frameId:q.frameId,stoppedLocation:p.from(q.stoppedLocation)}}pe.from=ce;function se(q){return new o.InlineValueContext(q.frameId,p.to(q.stoppedLocation))}pe.to=se})(Le=e.InlineValueContext||(e.InlineValueContext={}));var We;(function(pe){function ce(q){return{range:p.from(q.range),kind:q.kind}}pe.from=ce;function se(q){return new o.DocumentHighlight(p.to(q.range),q.kind)}pe.to=se})(We=e.DocumentHighlight||(e.DocumentHighlight={}));var Fe;(function(pe){function ce(se){switch(se){case 1:return o.CompletionTriggerKind.TriggerCharacter;case 2:return o.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return o.CompletionTriggerKind.Invoke}}pe.to=ce})(Fe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ze;(function(pe){function ce(se){return{triggerKind:Fe.to(se.triggerKind),triggerCharacter:se.triggerCharacter}}pe.to=ce})(ze=e.CompletionContext||(e.CompletionContext={}));var W;(function(pe){function ce(q){switch(q){case o.CompletionItemTag.Deprecated:return 1}}pe.from=ce;function se(q){switch(q){case 1:return o.CompletionItemTag.Deprecated}}pe.to=se})(W=e.CompletionItemTag||(e.CompletionItemTag={}));var j;(function(pe){const ce=new Map([[o.CompletionItemKind.Method,0],[o.CompletionItemKind.Function,1],[o.CompletionItemKind.Constructor,2],[o.CompletionItemKind.Field,3],[o.CompletionItemKind.Variable,4],[o.CompletionItemKind.Class,5],[o.CompletionItemKind.Interface,7],[o.CompletionItemKind.Struct,6],[o.CompletionItemKind.Module,8],[o.CompletionItemKind.Property,9],[o.CompletionItemKind.Unit,12],[o.CompletionItemKind.Value,13],[o.CompletionItemKind.Constant,14],[o.CompletionItemKind.Enum,15],[o.CompletionItemKind.EnumMember,16],[o.CompletionItemKind.Keyword,17],[o.CompletionItemKind.Snippet,27],[o.CompletionItemKind.Text,18],[o.CompletionItemKind.Color,19],[o.CompletionItemKind.File,20],[o.CompletionItemKind.Reference,21],[o.CompletionItemKind.Folder,23],[o.CompletionItemKind.Event,10],[o.CompletionItemKind.Operator,11],[o.CompletionItemKind.TypeParameter,24],[o.CompletionItemKind.Issue,26],[o.CompletionItemKind.User,25]]);function se(Te){var Je;return(Je=ce.get(Te))!==null&&Je!==void 0?Je:9}pe.from=se;const q=new Map([[0,o.CompletionItemKind.Method],[1,o.CompletionItemKind.Function],[2,o.CompletionItemKind.Constructor],[3,o.CompletionItemKind.Field],[4,o.CompletionItemKind.Variable],[5,o.CompletionItemKind.Class],[7,o.CompletionItemKind.Interface],[6,o.CompletionItemKind.Struct],[8,o.CompletionItemKind.Module],[9,o.CompletionItemKind.Property],[12,o.CompletionItemKind.Unit],[13,o.CompletionItemKind.Value],[14,o.CompletionItemKind.Constant],[15,o.CompletionItemKind.Enum],[16,o.CompletionItemKind.EnumMember],[17,o.CompletionItemKind.Keyword],[27,o.CompletionItemKind.Snippet],[18,o.CompletionItemKind.Text],[19,o.CompletionItemKind.Color],[20,o.CompletionItemKind.File],[21,o.CompletionItemKind.Reference],[23,o.CompletionItemKind.Folder],[10,o.CompletionItemKind.Event],[11,o.CompletionItemKind.Operator],[24,o.CompletionItemKind.TypeParameter],[25,o.CompletionItemKind.User],[26,o.CompletionItemKind.Issue]]);function Me(Te){var Je;return(Je=q.get(Te))!==null&&Je!==void 0?Je:o.CompletionItemKind.Property}pe.to=Me})(j=e.CompletionItemKind||(e.CompletionItemKind={}));var te;(function(pe){function ce(se,q){var Me;const Te=new o.CompletionItem(typeof se.label=="string"?se.label:se.label.name);return typeof se.label!="string"&&(Te.label2=se.label),Te.insertText=se.insertText,Te.kind=j.to(se.kind),Te.tags=(Me=se.tags)===null||Me===void 0?void 0:Me.map(W.to),Te.detail=se.detail,Te.documentation=k.isMarkdownString(se.documentation)?g.to(se.documentation):se.documentation,Te.sortText=se.sortText,Te.filterText=se.filterText,Te.preselect=se.preselect,Te.commitCharacters=se.commitCharacters,C.Range.isIRange(se.range)?Te.range=p.to(se.range):typeof se.range=="object"&&(Te.range={inserting:p.to(se.range.insert),replacing:p.to(se.range.replace)}),Te.keepWhitespace=typeof se.insertTextRules=="undefined"?!1:Boolean(se.insertTextRules&1),typeof se.insertTextRules!="undefined"&&se.insertTextRules&4?Te.insertText=new o.SnippetString(se.insertText):(Te.insertText=se.insertText,Te.textEdit=Te.range instanceof o.Range?new o.TextEdit(Te.range,Te.insertText):void 0),se.additionalTextEdits&&se.additionalTextEdits.length>0&&(Te.additionalTextEdits=se.additionalTextEdits.map(Je=>K.to(Je))),Te.command=q&&se.command?q.fromInternal(se.command):void 0,Te}pe.to=ce})(te=e.CompletionItem||(e.CompletionItem={}));var oe;(function(pe){function ce(q){return{label:q.label,documentation:q.documentation?g.fromStrict(q.documentation):void 0}}pe.from=ce;function se(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?g.to(q.documentation):q.documentation}}pe.to=se})(oe=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(pe){function ce(q){return{label:q.label,documentation:q.documentation?g.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.from):[],activeParameter:q.activeParameter}}pe.from=ce;function se(q){return{label:q.label,documentation:k.isMarkdownString(q.documentation)?g.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(oe.to):[],activeParameter:q.activeParameter}}pe.to=se})(de=e.SignatureInformation||(e.SignatureInformation={}));var _e;(function(pe){function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(de.from):[]}}pe.from=ce;function se(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(de.to):[]}}pe.to=se})(_e=e.SignatureHelp||(e.SignatureHelp={}));var Be;(function(pe){function ce(q){var Me;return{text:q.text,position:c.from(q.position),kind:fe.from((Me=q.kind)!==null&&Me!==void 0?Me:o.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}pe.from=ce;function se(q){const Me=new o.InlayHint(q.text,c.to(q.position),fe.to(q.kind));return Me.whitespaceAfter=q.whitespaceAfter,Me.whitespaceBefore=q.whitespaceBefore,Me}pe.to=se})(Be=e.InlayHint||(e.InlayHint={}));var fe;(function(pe){function ce(q){return q}pe.from=ce;function se(q){return q}pe.to=se})(fe=e.InlayHintKind||(e.InlayHintKind={}));var De;(function(pe){function ce(q){return{range:p.from(q.range),url:q.target,tooltip:q.tooltip}}pe.from=ce;function se(q){let Me;if(q.url)try{Me=typeof q.url=="string"?S.URI.parse(q.url,!0):S.URI.revive(q.url)}catch(Te){}return new o.DocumentLink(p.to(q.range),Me)}pe.to=se})(De=e.DocumentLink||(e.DocumentLink={}));var Re;(function(pe){function ce(q){const Me=new o.ColorPresentation(q.label);return q.textEdit&&(Me.textEdit=K.to(q.textEdit)),q.additionalTextEdits&&(Me.additionalTextEdits=q.additionalTextEdits.map(Te=>K.to(Te))),Me}pe.to=ce;function se(q){return{label:q.label,textEdit:q.textEdit?K.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Me=>K.from(Me)):void 0}}pe.from=se})(Re=e.ColorPresentation||(e.ColorPresentation={}));var He;(function(pe){function ce(q){return new o.Color(q[0],q[1],q[2],q[3])}pe.to=ce;function se(q){return[q.red,q.green,q.blue,q.alpha]}pe.from=se})(He=e.Color||(e.Color={}));var we;(function(pe){function ce(q){return{range:p.from(q.range)}}pe.from=ce;function se(q){return new o.SelectionRange(p.to(q.range))}pe.to=se})(we=e.SelectionRange||(e.SelectionRange={}));var qe;(function(pe){function ce(se){switch(se){case 2:return o.TextDocumentSaveReason.AfterDelay;case 1:return o.TextDocumentSaveReason.Manual;case 3:case 4:return o.TextDocumentSaveReason.FocusOut}}pe.to=ce})(qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var z;(function(pe){function ce(q){switch(q){case o.TextEditorLineNumbersStyle.Off:return 0;case o.TextEditorLineNumbersStyle.Relative:return 2;case o.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=ce;function se(q){switch(q){case 0:return o.TextEditorLineNumbersStyle.Off;case 2:return o.TextEditorLineNumbersStyle.Relative;case 1:default:return o.TextEditorLineNumbersStyle.On}}pe.to=se})(z=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ee;(function(pe){function ce(q){if(q===o.EndOfLine.CRLF)return 1;if(q===o.EndOfLine.LF)return 0}pe.from=ce;function se(q){if(q===1)return o.EndOfLine.CRLF;if(q===0)return o.EndOfLine.LF}pe.to=se})(ee=e.EndOfLine||(e.EndOfLine={}));var ge;(function(pe){function ce(se){if(typeof se=="object")return se.viewId;switch(se){case o.ProgressLocation.SourceControl:return 3;case o.ProgressLocation.Window:return 10;case o.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=ce})(ge=e.ProgressLocation||(e.ProgressLocation={}));var Ne;(function(pe){function ce(se){const q={start:se.start+1,end:se.end+1};return se.kind&&(q.kind=Ve.from(se.kind)),q}pe.from=ce})(Ne=e.FoldingRange||(e.FoldingRange={}));var Ve;(function(pe){function ce(se){if(se)switch(se){case o.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case o.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case o.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}pe.from=ce})(Ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var $e;(function(pe){function ce(se){if(se)return{pinned:typeof se.preview=="boolean"?!se.preview:void 0,inactive:se.background,preserveFocus:se.preserveFocus,selection:typeof se.selection=="object"?p.from(se.selection):void 0,override:typeof se.override=="boolean"?I.EditorOverride.DISABLED:void 0}}pe.from=ce})($e=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ze;(function(pe){function ce(q){return q instanceof o.RelativePattern||typeof q=="string"?q:se(q)?new o.RelativePattern(q.base,q.pattern):q}pe.from=ce;function se(q){const Me=q;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Ze=e.GlobPattern||(e.GlobPattern={}));var ye;(function(pe){function ce(se){if(se){if(Array.isArray(se))return se.map(ce);if(typeof se=="string")return se;{const q=se;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ze.from(q.pattern),exclusive:q.exclusive}}}else return}pe.from=ce})(ye=e.LanguageSelector||(e.LanguageSelector={}));var Ee;(function(pe){function ce(q){return{start:q.start,end:q.end}}pe.from=ce;function se(q){return new o.NotebookRange(q.start,q.end)}pe.to=se})(Ee=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(pe){function ce(se){return new o.NotebookCellMetadata().with(Object.assign(Object.assign({},se),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}pe.to=ce})(Ce=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var re;(function(pe){function ce(q){return q}pe.from=ce;function se(q){return new o.NotebookDocumentMetadata().with(q)}pe.to=se})(re=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var le;(function(pe){function ce(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}pe.to=ce;function se(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}pe.from=se})(le=e.NotebookCellPreviousExecutionResult||(e.NotebookCellPreviousExecutionResult={}));var N;(function(pe){function ce(q){switch(q){case o.NotebookCellKind.Markdown:return d.CellKind.Markdown;case o.NotebookCellKind.Code:default:return d.CellKind.Code}}pe.from=ce;function se(q){switch(q){case d.CellKind.Markdown:return o.NotebookCellKind.Markdown;case d.CellKind.Code:default:return o.NotebookCellKind.Code}}pe.to=se})(N=e.NotebookCellKind||(e.NotebookCellKind={}));var Q;(function(pe){function ce(q){var Me;return{cellKind:N.from(q.kind),language:q.language,source:q.source,metadata:Object.assign(Object.assign({},q.metadata),le.from((Me=q.latestExecutionSummary)!==null&&Me!==void 0?Me:{})),outputs:q.outputs?q.outputs.map(ke.from):[]}}pe.from=ce;function se(q){return new o.NotebookCellData(N.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ke.to):void 0,q.metadata?Ce.to(q.metadata):void 0)}pe.to=se})(Q=e.NotebookCellData||(e.NotebookCellData={}));var ae;(function(pe){function ce(q){return{mime:q.mime,value:q.value,metadata:q.metadata}}pe.from=ce;function se(q){return new o.NotebookCellOutputItem(q.mime,q.value,q.metadata)}pe.to=se})(ae=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(pe){function ce(q){return{outputId:q.id,outputs:q.outputs.map(ae.from),metadata:q.metadata}}pe.from=ce;function se(q){const Me=q.outputs.map(ae.to);return new o.NotebookCellOutput(Me,q.outputId,q.metadata)}pe.to=se})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(pe){function ce(Te){if(Te!=null){if(Te instanceof o.RelativePattern||typeof Te=="string")return Te;if(Me(Te))return new o.RelativePattern(Te.base,Te.pattern);if(q(Te))return{include:Ze.from(Te.include)||void 0,exclude:Ze.from(Te.exclude)||void 0}}}pe.from=ce;function se(Te){return typeof Te=="string"?Te:Me(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}pe.to=se;function q(Te){const Je=Te,et=Ze.from(Je.include);if(!(et&&et instanceof o.RelativePattern||typeof et=="string"))return!1;const ct=Ze.from(Je.exclude);return!!(ct&&ct instanceof o.RelativePattern||typeof ct=="string")}function Me(Te){const Je=Te;return Je&&typeof Je.base=="string"&&typeof Je.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ae;(function(pe){function ce(se){return{backgroundColor:se.backgroundColor,borderColor:se.borderColor,top:se.top?m.from(se.top):void 0}}pe.from=ce})(Ae=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(pe){function ce(se,q,Me){const Te=typeof se.command=="string"?{title:"",command:se.command}:se.command;return{alignment:se.alignment===o.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Te,Me),text:se.text,tooltip:se.tooltip,accessibilityInformation:se.accessibilityInformation,priority:se.priority}}pe.from=ce})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ye;(function(pe){function ce(se){var q,Me;return{transientOutputs:(q=se==null?void 0:se.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:Object.assign(Object.assign({},se==null?void 0:se.transientCellMetadata),{executionOrder:!0,runState:!0,runStartTime:!0,runStartTimeAdjustment:!0,runEndTime:!0,lastRunSuccess:!0}),transientDocumentMetadata:(Me=se==null?void 0:se.transientDocumentMetadata)!==null&&Me!==void 0?Me:{}}}pe.from=ce})(Ye=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var rt;(function(pe){function ce(q){var Me;return{uri:q.uri,provides:typeof q.provides=="string"?[q.provides]:(Me=q.provides)!==null&&Me!==void 0?Me:[]}}pe.from=ce;function se(q){return new o.NotebookKernelPreload(S.URI.revive(q.uri),q.provides)}pe.to=se})(rt=e.NotebookKernelPreload||(e.NotebookKernelPreload={}));var tt;(function(pe){function ce(q){return{message:g.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?x.from(q.location):void 0}}pe.from=ce;function se(q){const Me=new o.TestMessage(typeof q.message=="string"?q.message:g.to(q.message));return Me.severity=q.severity,Me.actualOutput=q.actualOutput,Me.expectedOutput=q.expectedOutput,Me}pe.to=se})(tt=e.TestMessage||(e.TestMessage={}));var Qe;(function(pe){function ce(Te){var Je,et;return{extId:Te.id,label:Te.label,uri:Te.uri,range:p.from(Te.range)||null,debuggable:(Je=Te.debuggable)!==null&&Je!==void 0?Je:!1,description:Te.description||null,runnable:(et=Te.runnable)!==null&&et!==void 0?et:!0,error:Te.error&&g.fromStrict(Te.error)||null}}pe.from=ce;function se(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:p.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}pe.fromResultSnapshot=se;function q(Te){return{id:Te.extId,label:Te.label,uri:S.URI.revive(Te.uri),range:p.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:o.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}pe.toPlain=q;function Me(Te){const Je=new o.TestItemImpl(Te.extId,Te.label,S.URI.revive(Te.uri),void 0);return Je.range=p.to(Te.range||void 0),Je.debuggable=Te.debuggable,Je.description=Te.description||void 0,Je.runnable=Te.runnable,Je}pe.to=Me})(Qe=e.TestItem||(e.TestItem={}));var mt;(function(pe){const ce=(q,Me)=>Object.assign(Object.assign({},Qe.toPlain(q.item)),{taskStates:q.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(tt.to)})),children:q.children.map(Te=>Me.get(Te)).filter(D.isDefined).map(Te=>ce(Te,Me))});function se(q){const Me=[],Te=new Map;for(const Je of q.items)Te.set(Je.item.extId,Je),Je.direct&&Me.push(Je);return{completedAt:q.completedAt,results:Me.map(Je=>ce(Je,Te))}}pe.to=se})(mt=e.TestResults||(e.TestResults={}));var bt;(function(pe){function ce(se){switch(se){case 1:return o.CodeActionTriggerKind.Invoke;case 2:return o.CodeActionTriggerKind.Automatic}}pe.to=ce})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(ve[176],be([0,1,2,12,7,9,45]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,i,I,h={timeout:1500,errors:3}){this._logService=C,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=h,this._callbacks=new y.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(i,I,h)=>{const r={dispose:this._callbacks.push([i,I,C])};return Array.isArray(h)&&h.push(r),r}}async $participateInSave(C,i){const I=b.URI.revive(C);let h=!1;const d=setTimeout(()=>h=!0,this._thresholds.timeout),r=[];try{for(let o of[...this._callbacks]){if(h)break;const v=this._documents.getDocument(I),p=await this._deliverEventAsyncAndBlameBadListeners(o,{document:v,reason:T.TextDocumentSaveReason.to(i)});r.push(p)}}finally{clearTimeout(d)}return r}_deliverEventAsyncAndBlameBadListeners([C,i,I],h){const d=this._badListeners.get(C);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,i,h).then(()=>!0,r=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this._badListeners.get(C);this._badListeners.set(C,o?o+1:1),typeof o=="number"&&o>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,i,I,h){const d=[],r=Date.now(),{document:o,reason:v}=h,{version:p}=o,E=Object.freeze({document:o,reason:v,waitUntil(c){if(Object.isFrozen(d))throw(0,k.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(c))}});try{i.apply(I,[E])}catch(c){return Promise.reject(c)}return Object.freeze(d),new Promise((c,l)=>{const f=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(f),c(t)}).catch(t=>{clearTimeout(f),l(t)})}).then(c=>{const l={edits:[]};for(const f of c)if(Array.isArray(f)&&f.every(t=>t instanceof P.TextEdit))for(const{newText:t,newEol:n,range:a}of f)l.edits.push({_type:2,resource:o.uri,edit:{range:a&&T.Range.from(a),text:t,eol:n&&T.EndOfLine.from(n)}});if(l.edits.length!==0)return p===o.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(ve[177],be([0,1,3,11,28,2,9,7]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class S{constructor(I,h,d,r,o){this._onDidCreate=new b.Emitter,this._onDidChange=new b.Emitter,this._onDidDelete=new b.Emitter,this._config=0,d&&(this._config+=1),r&&(this._config+=2),o&&(this._config+=4);const v=(0,P.parse)(h),p=I(E=>{if(!d)for(let c of E.created){const l=T.URI.revive(c);v(l.fsPath)&&this._onDidCreate.fire(l)}if(!r)for(let c of E.changed){const l=T.URI.revive(c);v(l.fsPath)&&this._onDidChange.fire(l)}if(!o)for(let c of E.deleted){const l=T.URI.revive(c);v(l.fsPath)&&this._onDidDelete.fire(l)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,p)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,h,d){this._logService=h,this._extHostDocumentsAndEditors=d,this._onFileSystemEvent=new b.Emitter,this._onDidRenameFile=new b.Emitter,this._onDidCreateFile=new b.Emitter,this._onDidDeleteFile=new b.Emitter,this._onWillRenameFile=new k.AsyncEmitter,this._onWillCreateFile=new k.AsyncEmitter,this._onWillDeleteFile=new k.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,h,d,r){return new S(this._onFileSystemEvent.event,I,h,d,r)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,h){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:h.map(d=>({oldUri:T.URI.revive(d.source),newUri:T.URI.revive(d.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:h.map(d=>T.URI.revive(d.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:h.map(d=>T.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,h){return(d,r,o)=>{const v=function(E){d.call(r,E)};return v.extension=I,h.event(v,void 0,o)}}async $onWillRunFileOperation(I,h,d,r){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:h.map(o=>({oldUri:T.URI.revive(o.source),newUri:T.URI.revive(o.target)}))},d,r);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:h.map(o=>T.URI.revive(o.target))},d,r);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:h.map(o=>T.URI.revive(o.target))},d,r)}}async _fireWillEvent(I,h,d,r){const o=new Set,v=[];if(await I.fireAsync(h,r,async(E,c)=>{var l;const f=Date.now(),t=await Promise.resolve(E);t instanceof D.WorkspaceEdit&&(v.push(t),o.add((l=c.extension.displayName)!==null&&l!==void 0?l:c.extension.identifier.value)),Date.now()-f>d&&this._logService.warn("SLOW file-participant",c.extension.identifier)}),!r.isCancellationRequested&&v.length!==0){const p={edits:[]};for(let E of v){let{edits:c}=y.WorkspaceEdit.from(E,this._extHostDocumentsAndEditors);p.edits=p.edits.concat(c)}return{edit:p,extensionNames:Array.from(o)}}}}e.ExtHostFileSystemEventService=C}),define(ve[178],be([0,1,19,23,2,9,7,73]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class S{constructor(h,d,r,o){this.start=h,this.deletedCount=d,this.deletedItems=r,this.items=o}static asApiEvents(h){return h.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(r=>r.apiCell)}))}}class C{constructor(h,d,r){var o;this.notebook=h,this._extHostDocument=d,this._cellData=r,this.handle=r.handle,this.uri=P.URI.revive(r.uri),this.cellKind=r.cellKind,this._outputs=r.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(o=r.metadata)!==null&&o!==void 0?o:{},this._metadata=T.NotebookCellMetadata.to(this._internalMetadata),this._previousResult=T.NotebookCellPreviousExecutionResult.to(this._internalMetadata)}static asModelAddData(h,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:h}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const h=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return h.notebook.getCellIndex(h)},notebook:h.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get outputs(){return h._outputs.slice(0)},get metadata(){return h._metadata},get latestExecutionSummary(){return h._previousResult}})}return this._apiCell}setOutputs(h){this._outputs=h.map(T.NotebookCellOutput.to)}setOutputItems(h,d,r){const o=r.map(T.NotebookCellOutputItem.to),v=this._outputs.find(p=>p.id===h);v&&(d||(v.outputs.length=0),v.outputs.push(...o))}setMetadata(h){this._internalMetadata=h,this._metadata=T.NotebookCellMetadata.to(h),this._previousResult=T.NotebookCellPreviousExecutionResult.to(h)}}e.ExtHostCell=C;class i{constructor(h,d,r,o,v,p,E){this._proxy=h,this._textDocumentsAndEditors=d,this._textDocuments=r,this._emitter=o,this._viewType=v,this._metadata=p,this.uri=E,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const h=this;this._notebook={get uri(){return h.uri},get version(){return h._versionId},get viewType(){return h._viewType},get isDirty(){return h._isDirty},get isUntitled(){return h.uri.scheme===b.Schemas.untitled},get isClosed(){return h._disposed},get metadata(){return h._metadata},get cellCount(){return h._cells.length},cellAt(d){return d=h._validateIndex(d),h._cells[d].apiCell},getCells(d){return(d?h._getCells(d):h._cells).map(o=>o.apiCell)},save(){return h._save()}}}return this._notebook}updateBackup(h){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=h}disposeBackup(){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(h){h.metadata&&(this._metadata=this._metadata.with(h.metadata))}acceptModelChanged(h,d){this._versionId=h.versionId,this._isDirty=d;for(const r of h.rawEvents)r.kind===D.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(r.changes,!0),r.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(r.changes,!1):r.kind===D.NotebookCellsChangeType.Move?this._moveCell(r.index,r.newIdx):r.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(r.index,r.outputs):r.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(r.index,r.outputId,r.append,r.outputItems):r.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(r.index,r.language):r.kind===D.NotebookCellsChangeType.ChangeCellMetadata&&this._changeCellMetadata(r.index,r.metadata)}_validateIndex(h){return h=h|0,h<0?0:h>=this._cells.length?this._cells.length-1:h}_validateRange(h){let d=h.start|0,r=h.end|0;return d<0&&(d=0),r>this._cells.length&&(r=this._cells.length),h.with({start:d,end:r})}_getCells(h){h=this._validateRange(h);const d=[];for(let r=h.start;r<h.end;r++)d.push(this._cells[r]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveDocument(this.uri)}_spliceNotebookCells(h,d){if(!this._disposed){const r=[],o=[],v=[];h.reverse().forEach(p=>{const c=p[2].map(t=>{const n=new C(this,this._textDocumentsAndEditors,t);return d||o.push(C.asModelAddData(this.apiNotebook,t)),n}),l=new S(p[0],p[1],[],c),f=this._cells.splice(p[0],p[1],...c);for(const t of f)v.push(t.uri),l.deletedItems.push(t.apiCell);r.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:v}),d||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(r)}))}}_moveCell(h,d){const r=this._cells.splice(h,1);this._cells.splice(d,0,...r);const o=[new S(h,1,r.map(v=>v.apiCell),[]),new S(d,0,[],r)];this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:S.asApiEvents(o)}))}_setCellOutputs(h,d){const r=this._cells[h];r.setOutputs(d),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[r.apiCell]}))}_setCellOutputItems(h,d,r,o){const v=this._cells[h];v.setOutputItems(d,r,o),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(h,d){const r=this._cells[h];r.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(r.uri,d)}_changeCellMetadata(h,d){var r;const o=this._cells[h],v=o.internalMetadata,p=o.apiCell.metadata;o.setMetadata(d);const E=o.apiCell.metadata;if((0,k.equals)(p,E)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.apiNotebook,cell:o.apiCell})),v.runState!==d.runState){const c=(r=d.runState)!==null&&r!==void 0?r:y.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,k.deepFreeze)({document:this.apiNotebook,cell:o.apiCell,executionState:c}))}}getCellFromApiCell(h){return this._cells.find(d=>d.apiCell===h)}getCellFromIndex(h){return this._cells[h]}getCell(h){return this._cells.find(d=>d.handle===h)}getCellIndex(h){return this._cells.indexOf(h)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(ve[179],be([0,1,7,9]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class P{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,S){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:D,metadata:S})}replaceCells(D,S,C){this._throwIfFinalized(),!(D===S&&C.length===0)&&this._collectedEdits.push({editType:1,index:D,count:S-D,cells:C.map(k.NotebookCellData.from)})}}class T{constructor(D,S,C,i,I,h){this.id=D,this._proxy=S,this.notebookData=C,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=h}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},get visibleRanges(){return D._visibleRanges},revealRange(S,C){D._proxy.$tryRevealRange(D.id,k.NotebookRange.from(S),C!=null?C:b.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(S){const C=new P(this.document.version);return S(C),D._applyEdit(C.finalize())},setDecorations(S,C){return D.setDecorations(S,C)}}}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const S=[];let C=-1;for(let i=0;i<D.cellEdits.length;i++){if(C<0){S.push(D.cellEdits[i]),C++;continue}const h=S[C],d=D.cellEdits[i];if(h.editType===1&&d.editType===1&&h.index===d.index){h.cells.push(...D.cellEdits[i].cells),h.count+=D.cellEdits[i].count;continue}S.push(D.cellEdits[i]),C++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,S)}setDecorations(D,S){if(!(S.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return S.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(S),D.key)}}e.ExtHostNotebookEditor=T}),define(ve[180],be([0,1,9,153,133,20,52]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,h,d){const r=this._handles++,{title:o,location:v,cancellable:p}=h,E={label:(0,P.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(r,{location:b.ProgressLocation.from(v),title:o,source:E,cancellable:p},I),this._withProgress(r,d,!!p)}_withProgress(I,h,d){let r;d&&(r=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,r));const o=p=>{this._proxy.$progressEnd(p),this._mapHandleToCancellationSource.delete(p),r&&r.dispose()};let v;try{v=h(new C(this._proxy,I),d&&r?r.token:T.CancellationToken.None)}catch(p){throw o(I),p}return v.then(p=>o(I),p=>o(I)),v}$acceptProgressCanceled(I){const h=this._mapHandleToCancellationSource.get(I);h&&(h.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function S(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class C extends k.Progress{constructor(I,h){super(d=>this.throttledReport(d));this._proxy=I,this._handle=h}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}je([(0,y.throttle)(100,(i,I)=>S(i,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(ve[97],be([0,1,42,12,54,9,7]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(h,d){const r=D._Keys.nextId();h.$registerTextEditorDecorationType(r,T.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){h.$removeTextEditorDecorationType(r)}})}}e.TextEditorDecorationType=D,D._Keys=new P.IdGenerator("TextEditorDecorationType");class S{constructor(h,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=h,this._documentVersionId=h.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(h,d){this._throwIfFinalized();let r=null;if(h instanceof y.Position)r=new y.Range(h,h);else if(h instanceof y.Range)r=h;else throw new Error("Unrecognized location");this._pushEdit(r,d,!1)}insert(h,d){this._throwIfFinalized(),this._pushEdit(new y.Range(h,h),d,!0)}delete(h){this._throwIfFinalized();let d=null;if(h instanceof y.Range)d=h;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(h,d,r){const o=this._document.validateRange(h);this._collectedEdits.push({range:o,text:d,forceMoveMarkers:r})}setEndOfLine(h){if(this._throwIfFinalized(),h!==y.EndOfLine.LF&&h!==y.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=h}}e.TextEditorEdit=S;class C{constructor(h,d,r,o){this._proxy=h,this._id=d,this._accept(r),this._logService=o;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(p){v._setTabSize(p)},get insertSpaces(){return v._insertSpaces},set insertSpaces(p){v._setInsertSpaces(p)},get cursorStyle(){return v._cursorStyle},set cursorStyle(p){v._setCursorStyle(p)},get lineNumbers(){return v._lineNumbers},set lineNumbers(p){v._setLineNumbers(p)}}}_accept(h){this._tabSize=h.tabSize,this._insertSpaces=h.insertSpaces,this._cursorStyle=h.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(h.lineNumbers)}_validateTabSize(h){if(h==="auto")return"auto";if(typeof h=="number"){const d=Math.floor(h);return d>0?d:null}if(typeof h=="string"){const d=parseInt(h,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(h){const d=this._validateTabSize(h);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(h){return h==="auto"?"auto":h==="false"?!1:Boolean(h)}_setInsertSpaces(h){const d=this._validateInsertSpaces(h);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(h){this._cursorStyle!==h&&(this._cursorStyle=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:h})))}_setLineNumbers(h){this._lineNumbers!==h&&(this._lineNumbers=h,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(h)})))}assign(h){const d={};let r=!1;if(typeof h.tabSize!="undefined"){const o=this._validateTabSize(h.tabSize);o==="auto"?(r=!0,d.tabSize=o):typeof o=="number"&&this._tabSize!==o&&(this._tabSize=o,r=!0,d.tabSize=o)}if(typeof h.insertSpaces!="undefined"){const o=this._validateInsertSpaces(h.insertSpaces);o==="auto"?(r=!0,d.insertSpaces=o):this._insertSpaces!==o&&(this._insertSpaces=o,r=!0,d.insertSpaces=o)}typeof h.cursorStyle!="undefined"&&this._cursorStyle!==h.cursorStyle&&(this._cursorStyle=h.cursorStyle,r=!0,d.cursorStyle=h.cursorStyle),typeof h.lineNumbers!="undefined"&&this._lineNumbers!==h.lineNumbers&&(this._lineNumbers=h.lineNumbers,r=!0,d.lineNumbers=T.TextEditorLineNumbersStyle.from(h.lineNumbers)),r&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(h){h.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=C;class i{constructor(h,d,r,o,v,p,E,c){this.id=h,this._proxy=d,this._logService=r,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new C(this._proxy,this.id,p,r),this._visibleRanges=E,this._viewColumn=c;const l=this;this.value=Object.freeze({get document(){return o.getValue()},set document(f){throw(0,k.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(f){if(!(f instanceof y.Selection))throw(0,k.illegalArgument)("selection");l._selections=[f],l._trySetSelection()},get selections(){return l._selections},set selections(f){if(!Array.isArray(f)||f.some(t=>!(t instanceof y.Selection)))throw(0,k.illegalArgument)("selections");l._selections=f,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(f){throw(0,k.readonly)("visibleRanges")},get options(){return l._options.value},set options(f){l._disposed||l._options.assign(f)},get viewColumn(){return l._viewColumn},set viewColumn(f){throw(0,k.readonly)("viewColumn")},edit(f,t={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new S(o.getValue(),t);return f(n),l._applyEdit(n)},insertSnippet(f,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!t||Array.isArray(t)&&t.length===0)a=l._selections.map(s=>T.Range.from(s));else if(t instanceof y.Position){const{lineNumber:s,column:u}=T.Position.from(t);a=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(t instanceof y.Range)a=[T.Range.from(t)];else{a=[];for(const s of t)if(s instanceof y.Range)a.push(T.Range.from(s));else{const{lineNumber:u,column:g}=T.Position.from(s);a.push({startLineNumber:u,startColumn:g,endLineNumber:u,endColumn:g})}}return d.$tryInsertSnippet(h,f.value,a,n)},setDecorations(f,t){const n=t.length===0;n&&!l._hasDecorationsForKey.has(f.key)||(n?l._hasDecorationsForKey.delete(f.key):l._hasDecorationsForKey.add(f.key),l._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return d.$trySetDecorations(h,f.key,T.fromRangeOrRangeWithMessage(t));{const a=new Array(4*t.length);for(let s=0,u=t.length;s<u;s++){const g=t[s];a[4*s]=g.start.line+1,a[4*s+1]=g.start.character+1,a[4*s+2]=g.end.line+1,a[4*s+3]=g.end.character+1}return d.$trySetDecorationsFast(h,f.key,a)}}))},revealRange(f,t){l._runOnProxy(()=>d.$tryRevealRange(h,T.Range.from(f),t||y.TextEditorRevealType.Default))},show(f){d.$tryShowEditor(h,T.ViewColumn.from(f))},hide(){d.$tryHideEditor(h)}})}dispose(){(0,b.ok)(!this._disposed),this._disposed=!0}_acceptOptions(h){(0,b.ok)(!this._disposed),this._options._accept(h)}_acceptVisibleRanges(h){(0,b.ok)(!this._disposed),this._visibleRanges=h}_acceptViewColumn(h){(0,b.ok)(!this._disposed),this._viewColumn=h}_acceptSelections(h){(0,b.ok)(!this._disposed),this._selections=h}async _trySetSelection(){const h=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,h)),this.value}_applyEdit(h){const d=h.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const r=d.edits.map(v=>v.range);r.sort((v,p)=>v.end.line===p.end.line?v.end.character===p.end.character?v.start.line===p.start.line?v.start.character-p.start.character:v.start.line-p.start.line:v.end.character-p.end.character:v.end.line-p.end.line);for(let v=0,p=r.length-1;v<p;v++){const E=r[v].end;if(r[v+1].start.isBefore(E))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=d.edits.map(v=>({range:T.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,o,{setEndOfLine:typeof d.setEndOfLine=="number"?T.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(h){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):h().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=i}),define(ve[181],be([0,1,136,25,2,3,6,11,7,10,13,9,20]),function(J,e,b,k,P,T,y,D,S,C,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(v,p){if((0,C.isString)(v))return{label:v};if(v&&typeof v=="object"&&typeof v.label=="string"){let E;return Array.isArray(v.highlights)&&(E=v.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),E=E.length?E:void 0),{label:v.label,highlights:E}}}class r{constructor(p,E,c){this._proxy=p,this.commands=E,this.logService=c,this.treeViews=new Map;function l(f){return f&&f.$treeViewId&&f.$treeItemHandle}E.registerArgumentProcessor({processArgument:f=>l(f)?this.convertArgument(f):Array.isArray(f)&&f.length>0?f.map(t=>l(t)?this.convertArgument(t):t):f})}registerTreeDataProvider(p,E,c){const l=this.createTreeView(p,{treeDataProvider:E},c);return{dispose:()=>l.dispose()}}createTreeView(p,E,c){if(!E||!E.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const l=this._proxy.$registerTreeViewDataProvider(p,{showCollapseAll:!!E.showCollapseAll,canSelectMany:!!E.canSelectMany,canDragAndDrop:!!E.canDragAndDrop}),f=this.createExtHostTreeView(p,E,c);return{get onDidCollapseElement(){return f.onDidCollapseElement},get onDidExpandElement(){return f.onDidExpandElement},get selection(){return f.selectedElements},get onDidChangeSelection(){return f.onDidChangeSelection},get visible(){return f.visible},get onDidChangeVisibility(){return f.onDidChangeVisibility},get message(){return f.message},set message(t){f.message=t},get title(){return f.title},set title(t){f.title=t},get description(){return f.description},set description(t){f.description=t},reveal:(t,n)=>f.reveal(t,n),dispose:async()=>{await l,this.treeViews.delete(p),f.dispose()}}}$getChildren(p,E){const c=this.treeViews.get(p);return c?c.getChildren(E):Promise.reject(new Error((0,b.localize)(0,null,p)))}$setParent(p,E,c){const l=this.treeViews.get(p);return l?l.setParent(E,c):Promise.reject(new Error((0,b.localize)(1,null,p)))}async $hasResolve(p){const E=this.treeViews.get(p);if(!E)throw new Error((0,b.localize)(2,null,p));return E.hasResolve}$resolve(p,E,c){const l=this.treeViews.get(p);if(!l)throw new Error((0,b.localize)(3,null,p));return l.resolveTreeItem(E,c)}$setExpanded(p,E,c){const l=this.treeViews.get(p);if(!l)throw new Error((0,b.localize)(4,null,p));l.setExpanded(E,c)}$setSelection(p,E){const c=this.treeViews.get(p);if(!c)throw new Error((0,b.localize)(5,null,p));c.setSelection(E)}$setVisible(p,E){const c=this.treeViews.get(p);if(!c)throw new Error((0,b.localize)(6,null,p));c.setVisible(E)}createExtHostTreeView(p,E,c){const l=new o(p,E,this._proxy,this.commands.converter,this.logService,c);return this.treeViews.set(p,l),l}convertArgument(p){const E=this.treeViews.get(p.$treeViewId);return E?E.getExtensionElement(p.$treeItemHandle):null}}e.ExtHostTreeViews=r;class o extends y.Disposable{constructor(p,E,c,l,f,t){super();if(this.viewId=p,this.proxy=c,this.commands=l,this.logService=f,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new h.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const u of t.contributes.views[s])u.id===p&&(this._title=u.name);this.dataProvider=E.treeDataProvider,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,a;this._register(T.Event.debounce(this._onDidChangeData.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(g=>a=g),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=a;return n=null,this.refresh(u).then(()=>g())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(p=>this.getExtensionElement(p)).filter(p=>!(0,C.isUndefinedOrNull)(p))}getChildren(p){const E=p?this.getExtensionElement(p):void 0;if(p&&!E)return this.logService.error(`No tree item with id '${p}' found.`),Promise.resolve([]);const c=this.getChildrenNodes(p);return(c?Promise.resolve(c):this.fetchChildrenNodes(E)).then(l=>l.map(f=>f.item))}getExtensionElement(p){return this.elements.get(p)}reveal(p,E){E=E||{select:!0,focus:!1};const c=(0,C.isUndefinedOrNull)(E.select)?!0:E.select,l=(0,C.isUndefinedOrNull)(E.focus)?!1:E.focus,f=(0,C.isUndefinedOrNull)(E.expand)?!1:E.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):p?this.refreshPromise.then(()=>this.resolveUnknownParentChain(p)).then(t=>this.resolveTreeNode(p,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(a=>a.item)},{select:c,focus:l,expand:f})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:c,focus:l,expand:f})}get message(){return this._message}set message(p){this._message=p,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(p){this._title=p,this.proxy.$setTitle(this.viewId,p,this._description)}get description(){return this._description}set description(p){this._description=p,this.proxy.$setTitle(this.viewId,this._title,p)}setExpanded(p,E){const c=this.getExtensionElement(p);c&&(E?this._onDidExpandElement.fire(Object.freeze({element:c})):this._onDidCollapseElement.fire(Object.freeze({element:c})))}setSelection(p){(0,i.equals)(this._selectedHandles,p)||(this._selectedHandles=p,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(p){p!==this._visible&&(this._visible=p,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}setParent(p,E){const c=p.map(f=>this.getExtensionElement(f)).filter(f=>!(0,C.isUndefinedOrNull)(f)),l=this.getExtensionElement(E);return this.dataProvider.setParent&&c&&l?(0,D.asPromise)(()=>this.dataProvider.setParent(c,l)):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(p,E){var c;if(!!this.dataProvider.resolveTreeItem){const l=this.elements.get(p);if(l){const f=this.nodes.get(l);if(f){const t=(c=await this.dataProvider.resolveTreeItem(f.extensionItem,l,E))!==null&&c!==void 0?c:f.extensionItem;return f.item.tooltip=this.getTooltip(t.tooltip),f.item.command=this.getCommand(f.disposableStore,t.command),f.item}}}}resolveUnknownParentChain(p){return this.resolveParent(p).then(E=>E?this.resolveUnknownParentChain(E).then(c=>this.resolveTreeNode(E,c[c.length-1]).then(l=>(c.push(l),c))):Promise.resolve([]))}resolveParent(p){const E=this.nodes.get(p);return E?Promise.resolve(E.parent?this.elements.get(E.parent.item.handle):void 0):(0,D.asPromise)(()=>this.dataProvider.getParent(p))}resolveTreeNode(p,E){const c=this.nodes.get(p);return c?Promise.resolve(c):(0,D.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(l=>this.createHandle(p,l,E,!0)).then(l=>this.getChildren(E?E.item.handle:void 0).then(()=>{const f=this.getExtensionElement(l);if(f){const t=this.nodes.get(f);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${l}`)}))}getChildrenNodes(p){if(p){let E;if(typeof p=="string"){const c=this.getExtensionElement(p);E=c?this.nodes.get(c):void 0}else E=p;return E&&E.children||null}return this.roots}async fetchChildrenNodes(p){this.clearChildren(p);const E=new h.CancellationTokenSource(this._refreshCancellationSource.token);try{const c=p?this.nodes.get(p):void 0,l=await this.dataProvider.getChildren(p);if(E.token.isCancellationRequested)return[];const f=await Promise.all((0,i.coalesce)(l||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!E.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,c):null}));return E.token.isCancellationRequested?[]:(0,i.coalesce)(f)}finally{E.dispose()}}refresh(p){if(p.some(c=>!c))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new h.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const c=this.getHandlesToRefresh(p);if(c.length)return this.refreshHandles(c)}return Promise.resolve(void 0)}getHandlesToRefresh(p){const E=new Set,c=p.map(f=>this.nodes.get(f));for(const f of c)if(f&&!E.has(f.item.handle)){let t=f;for(;t&&t.parent&&c.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&E.add(f.item.handle)}const l=[];return E.forEach(f=>{const t=this.elements.get(f);if(t){const n=this.nodes.get(t);n&&(!n.parent||!E.has(n.parent.item.handle))&&l.push(f)}}),l}refreshHandles(p){const E={};return Promise.all(p.map(c=>this.refreshNode(c).then(l=>{l&&(E[c]=l.item)}))).then(()=>Object.keys(E).length?this.proxy.$refresh(this.viewId,E):void 0)}refreshNode(p){const E=this.getExtensionElement(p);if(E){const c=this.nodes.get(E);if(c)return this.clearChildren(E),(0,D.asPromise)(()=>this.dataProvider.getTreeItem(E)).then(l=>{if(l){const f=this.createTreeNode(E,l,c.parent);return this.updateNodeCache(E,f,c,c.parent),c.dispose(),f}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(p,E,c){const l=this.createTreeNode(p,E,c);if(E.id&&this.elements.has(l.item.handle))throw new Error((0,b.localize)(7,null,E.id));return this.addNodeToCache(p,l),this.addNodeToParentCache(l,c),l}getTooltip(p){return S.MarkdownString.isMarkdownString(p)?I.MarkdownString.from(p):p}getCommand(p,E){return E?this.commands.toInternal(E,p):void 0}createTreeNode(p,E,c){const l=new y.DisposableStore,f=this.createHandle(p,E,c),t=this.getLightIconPath(E);return{item:{handle:f,parentHandle:c?c.item.handle:void 0,label:d(E.label,this.extension),description:E.description,resourceUri:E.resourceUri,tooltip:this.getTooltip(E.tooltip),command:this.getCommand(l,E.command),contextValue:E.contextValue,icon:t,iconDark:this.getDarkIconPath(E)||t,themeIcon:this.getThemeIcon(E),collapsibleState:(0,C.isUndefinedOrNull)(E.collapsibleState)?S.TreeItemCollapsibleState.None:E.collapsibleState,accessibilityInformation:E.accessibilityInformation},extensionItem:E,parent:c,children:void 0,disposableStore:l,dispose(){l.dispose()}}}getThemeIcon(p){return p.iconPath instanceof S.ThemeIcon?p.iconPath:void 0}createHandle(p,{id:E,label:c,resourceUri:l},f,t){if(E)return`${o.ID_HANDLE_PREFIX}/${E}`;const n=d(c,this.extension),a=f?f.item.handle:o.LABEL_HANDLE_PREFIX;let s=n?n.label:l?(0,k.basename)(l):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.nodes.has(p)?this.nodes.get(p).item.handle:void 0,g=this.getChildrenNodes(f)||[];let _,A=0;do{if(_=`${a}/${A}:${s}`,t||!this.elements.has(_)||u===_)break;A++}while(A<=g.length);return _}getLightIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon))return typeof p.iconPath=="string"||P.URI.isUri(p.iconPath)?this.getIconPath(p.iconPath):this.getIconPath(p.iconPath.light)}getDarkIconPath(p){if(p.iconPath&&!(p.iconPath instanceof S.ThemeIcon)&&p.iconPath.dark)return this.getIconPath(p.iconPath.dark)}getIconPath(p){return P.URI.isUri(p)?p:P.URI.file(p)}addNodeToCache(p,E){this.elements.set(E.item.handle,p),this.nodes.set(p,E)}updateNodeCache(p,E,c,l){this.elements.delete(E.item.handle),this.nodes.delete(p),E.item.handle!==c.item.handle&&this.elements.delete(c.item.handle),this.addNodeToCache(p,E);const f=this.getChildrenNodes(l)||[],t=f.filter(n=>n.item.handle===c.item.handle)[0];t&&f.splice(f.indexOf(t),1,E)}addNodeToParentCache(p,E){E?(E.children||(E.children=[]),E.children.push(p)):(this.roots||(this.roots=[]),this.roots.push(p))}clearChildren(p){if(p){const E=this.nodes.get(p);if(E){if(E.children)for(const c of E.children){const l=this.elements.get(c.item.handle);l&&this.clear(l)}E.children=void 0}}else this.clearAll()}clear(p){const E=this.nodes.get(p);if(E){if(E.children)for(const c of E.children){const l=this.elements.get(c.item.handle);l&&this.clear(l)}this.nodes.delete(p),this.elements.delete(E.item.handle),E.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(p=>p.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}o.LABEL_HANDLE_PREFIX="0",o.ID_HANDLE_PREFIX="1"}),define(ve[182],be([0,1,13,11,20,10,69,9,7,96]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(v,p){if(p!==void 0){const E=this.testIdsToInternal.get(p),c=E==null?void 0:E.get(v);if(c)return[E,c]}return(0,b.mapFind)(this.testIdsToInternal.values(),E=>{const c=E.get(v);return c&&[E,c]})}createForHierarchy(v=()=>{}){return new r(this.createIdMap(h++),v)}createIdMap(v){const p=new d(v);return this.testIdsToInternal.set(p.id,p),{object:p,dispose:()=>this.testIdsToInternal.delete(p.id)}}}e.OwnedTestCollection=i;var I;(function(o){o[o.Disconnected=0]="Disconnected",o[o.IsChild=1]="IsChild",o[o.IsParent=2]="IsParent",o[o.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let h=0;class d{constructor(v){this.id=v,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(v){if(this.map.has(v.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${v.item.extId}`);this.map.set(v.item.extId,v),v.parent||this._roots.add(v)}has(v){return this.map.has(v)}delete(v){const p=this.map.get(v);return p?(this.map.delete(v),this._roots.delete(p),!0):!1}get(v){return this.map.get(v)}comparePositions(v,p){const E=typeof v=="string"?this.map.get(v):v,c=typeof p=="string"?this.map.get(p):p;if(!E||!c)return 0;if(E===c)return 3;for(let l=this.map.get(c.parent);l;l=this.map.get(l.parent))if(l===E)return 1;for(let l=this.map.get(E.parent);l;l=this.map.get(l.parent))if(l===c)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class r{constructor(v,p){this.testIdToInternal=v,this.publishDiff=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new k.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(v,p){this.addItem(v,p,null)}getTestByReference(v){return this.testItemToInternal.get(v)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const p=this.diff[this.diff.length-1];if(p&&v[0]===1){if(p[0]===1&&p[1].extId===v[1].extId){(0,C.applyTestItemUpdate)(p[1],v[1]);return}if(p[0]===0&&p[1].item.extId===v[1].extId){(0,C.applyTestItemUpdate)(p[1],v[1]);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,p){var E;const c=this.testIdToInternal.object.get(v);if(!!c){if((c.expandLevels===void 0||p>c.expandLevels)&&(c.expandLevels=p),c.expand===1){const l=this.refreshChildren(c);return l.isSettled?this.expandChildren(c,p-1):l.p.then(()=>this.expandChildren(c,p-1))}else if(c.expand===3)return((E=c.initialExpand)===null||E===void 0?void 0:E.isSettled)===!1?c.initialExpand.p.then(()=>this.expandChildren(c,p-1)):this.expandChildren(c,p-1)}}dispose(){var v;for(const p of this.testItemToInternal.values())(v=p.discoverCts)===null||v===void 0||v.dispose(!0),(0,y.getPrivateApiFor)(p.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(v,p){const E=v==null?void 0:v.actual.id;switch(p[0]){case 2:this.pushDiff([4,E]);break;case 1:this.removeItem(v);break;case 0:this.addItem(p[1],v.src.controller,v);break;case 3:const[c,l,f]=p;switch(l){case"status":this.updateExpandability(v);break;case"range":this.pushDiff([1,{extId:E,item:{range:D.Range.from(f)}}]);break;case"error":this.pushDiff([1,{extId:E,item:{error:D.MarkdownString.fromStrict(f)||null}}]);break;default:this.pushDiff([1,{extId:E,item:{[l]:f!=null?f:null}}]);break}break;default:(0,T.assertNever)(p[0])}}addItem(v,p,E){if(!(v instanceof S.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${v.id} did not`);if(this.testItemToInternal.has(v))throw new Error(`Attempted to add a single TestItem ${v.id} multiple times to the tree`);if(this.testIdToInternal.object.has(v.id))throw new Error(`Attempted to insert a duplicate test item ID ${v.id}`);const c=E?E.item.extId:null,l=v.resolveHandler?1:0,f=E?E.expandLevels:1,t={controller:p,tree:this.testIdToInternal.object.id},n={actual:v,parent:c,item:D.TestItem.from(v),expandLevels:f?f-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(v,n),this.pushDiff([0,{parent:c,src:t,expand:l,item:n.item}]);const a=(0,y.getPrivateApiFor)(v);a.parent=E==null?void 0:E.actual,a.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of a.children.values())this.testItemToInternal.has(s)||this.addItem(s,p,n)}updateExpandability(v){var p;let E;v.actual.resolveHandler?v.actual.status===S.TestItemStatus.Pending?E=v.discoverCts?2:1:((p=v.initialExpand)===null||p===void 0||p.complete(),E=3):E=0,E!==v.expand&&(v.expand=E,this.pushDiff([1,{extId:v.actual.id,expand:E}]),E===1&&v.expandLevels!==void 0&&this.refreshChildren(v))}expandChildren(v,p){if(!(p<0)){const E=[...v.actual.children.values()].map(c=>this.expand(c.id,p)).filter(k.isThenable);if(E.length)return Promise.all(E).then(()=>{})}}refreshChildren(v){if(v.discoverCts&&v.discoverCts.dispose(!0),!v.actual.resolveHandler){const p=new k.DeferredPromise;return p.complete(),p}return v.expand=2,v.discoverCts=new P.CancellationTokenSource,this.pushExpandStateUpdate(v),v.initialExpand=new k.DeferredPromise,v.actual.resolveHandler(v.discoverCts.token),v.initialExpand}pushExpandStateUpdate(v){this.pushDiff([1,{extId:v.actual.id,expand:v.expand}])}removeItem(v){var p;this.pushDiff([2,v.actual.id]);const E=[v];for(;E.length;){const c=E.pop();if(!!c){(p=c.discoverCts)===null||p===void 0||p.dispose(!0),this.testIdToInternal.object.delete(c.item.extId),this.testItemToInternal.delete(c.actual);for(const l of c.actual.children.values())E.push(this.testIdToInternal.object.get(l.id))}}}flushDiff(){const v=this.collectDiff();v.length&&this.publishDiff(v)}}e.SingleUseTestCollection=r}),define(ve[183],be([0,1,26,3,14]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class y{constructor(i){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(S),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(b.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(b.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${b.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(h=>I.add(b.ExtensionIdentifier.toKey(h))),this._extensionDescriptions=this._extensionDescriptions.filter(h=>I.has(b.ExtensionIdentifier.toKey(h.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const h=y._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(h.map(d=>d.identifier)),I.length>0){const d=new Set;I.forEach(r=>d.add(b.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>!d.has(b.ExtensionIdentifier.toKey(r.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(h)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,p){this.addNode(v),this.addNode(p),this._arcs.has(v)?this._arcs.get(v).push(p):this._arcs.set(v,[p])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,p){const E=I.getArcs(v);for(let c=0;c<E.length;c++)if(!p.has(E[c]))return!1;return!0}getNodes(){return this._nodesArr}};let h=new Map;for(let v of i){const p=b.ExtensionIdentifier.toKey(v.identifier);if(h.set(p,v),v.extensionDependencies)for(let E of v.extensionDependencies){const c=b.ExtensionIdentifier.toKey(E);I.addArc(p,c)}}let d=new Set;I.getNodes().filter(v=>I.getArcs(v).length===0).forEach(v=>d.add(v));let r=I.getNodes().filter(v=>!d.has(v)),o;do{o=!1;for(let v=0;v<r.length;v++){const p=r[v];I.hasOnlyGoodArcs(p,d)&&(r.splice(v,1),v--,d.add(p),o=!0)}}while(o);return r.map(v=>h.get(v))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(b.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(b.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=y;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function S(C,i){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==h)return I-h;const d=P.posix.basename(C.extensionLocation.path),r=P.posix.basename(i.extensionLocation.path);return d<r?-1:d>r?1:0}}),define(ve[184],be([0,1,24]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var k;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(k=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var P;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(P=e.MessageType||(e.MessageType={}));function T(D){const S=b.VSBuffer.alloc(1);switch(D){case 0:S.writeUInt8(1,0);break;case 1:S.writeUInt8(2,0);break;case 2:S.writeUInt8(3,0);break}return S}e.createMessageOfType=T;function y(D,S){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return S===0;case 2:return S===1;case 3:return S===2;default:return!1}}e.isMessageOfType=y}),define(ve[33],be([0,1,3,2,4,26,150]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(E){this.dependency=E}}e.MissingExtensionDependency=D;var S;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(S=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(E,c,l,f){this.codeLoadingTime=E,this.activateCallTime=c,this.activateResolvedTime=l,this.activationReason=f}}e.ActivationTimes=C;class i{constructor(E,c){this.description=E,this.value=c}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function h(p){p.enableProposedApi||d(p)}e.checkProposedApiEnabled=h;function d(p){throw new Error(`[${p.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.throwProposedApiError=d;function r(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,y.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=r;function o(p){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(p.identifier.id),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!1,extensionLocation:p.location},p.manifest),{uuid:p.identifier.uuid})}e.toExtensionDescription=o;class v{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None}activateByEvent(E){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,c){return Promise.resolve()}_onWillActivateExtension(E){}_onDidActivateExtension(E,c,l,f,t){}_onDidActivateExtensionError(E,c){}_onExtensionRuntimeError(E,c){}_onExtensionHostExit(E){}}e.NullExtensionService=v}),define(ve[185],be([0,1,26,33,18]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class y{constructor(r,o,v,p){this.startup=r,this.codeLoadingTime=o,this.activateCallTime=v,this.activateResolvedTime=p}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class D{constructor(r){this._startup=r,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(r,o){return r===-1||o===-1?-1:o-r}build(){return new y(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class S{constructor(r,o,v,p,E,c){this.activationFailed=r,this.activationFailedError=o,this.activationTimes=v,this.module=p,this.exports=E,this.subscriptions=c}}e.ActivatedExtension=S;class C extends S{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class i extends S{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends S{constructor(r){super(!0,r,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let h=class{constructor(r,o,v,p,E){this._logService=E,this._registry=r,this._resolvedExtensionsSet=new Set,o.forEach(c=>this._resolvedExtensionsSet.add(b.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,v.forEach(c=>this._hostExtensionsMap.set(b.ExtensionIdentifier.toKey(c),c)),this._host=p,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(r){const o=b.ExtensionIdentifier.toKey(r);return this._activatedExtensions.has(o)}getActivatedExtension(r){const o=b.ExtensionIdentifier.toKey(r),v=this._activatedExtensions.get(o);if(!v)throw new Error("Extension `"+r.value+"` is not known or not activated");return v}activateByEvent(r,o){if(this._alreadyActivatedEvents[r])return T;const v=this._registry.getExtensionDescriptionsForActivationEvent(r);return this._activateExtensions(v.map(p=>({id:p.identifier,reason:{startup:o,extensionId:p.identifier,activationEvent:r}}))).then(()=>{this._alreadyActivatedEvents[r]=!0})}activateById(r,o){const v=this._registry.getExtensionDescription(r);if(!v)throw new Error("Extension `"+r+"` is not known");return this._activateExtensions([{id:v.identifier,reason:o}])}_handleActivateRequest(r,o,v){if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(r.id))){o[b.ExtensionIdentifier.toKey(r.id)]=r;return}const p=this._registry.getExtensionDescription(r.id);if(!p){const l=new Error(`Cannot activate unknown extension '${r.id.value}'`);this._host.onExtensionActivationError(r.id,l,new k.MissingExtensionDependency(r.id.value)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(r.id),new I(l));return}const E=typeof p.extensionDependencies=="undefined"?[]:p.extensionDependencies;let c=!0;for(let l=0,f=E.length;l<f;l++){const t=E[l];if(!this._resolvedExtensionsSet.has(b.ExtensionIdentifier.toKey(t))){const n=this._activatedExtensions.get(b.ExtensionIdentifier.toKey(t));if(!(n&&!n.activationFailed)){if(n&&n.activationFailed){const g=p.displayName||p.identifier.value,_=this._registry.getExtensionDescription(t),A=_&&_.displayName||t,m=new Error(`Cannot activate the '${g}' extension because its dependency '${A}' failed to activate`);m.detail=n.activationFailedError,this._host.onExtensionActivationError(p.identifier,m,null),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(p.identifier),new I(m));return}if(this._hostExtensionsMap.has(b.ExtensionIdentifier.toKey(t))){c=!1,o[b.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(b.ExtensionIdentifier.toKey(t)),reason:r.reason};continue}const a=this._registry.getExtensionDescription(t);if(a){c=!1,o[b.ExtensionIdentifier.toKey(t)]={id:a.identifier,reason:r.reason};continue}const s=p.displayName||p.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(p.identifier,u,new k.MissingExtensionDependency(t)),this._activatedExtensions.set(b.ExtensionIdentifier.toKey(p.identifier),new I(u));return}}}c?o[b.ExtensionIdentifier.toKey(p.identifier)]=r:v.push(r)}_activateExtensions(r){if(r.length===0||(r=r.filter(E=>!this._activatedExtensions.has(b.ExtensionIdentifier.toKey(E.id))),r.length===0))return Promise.resolve(void 0);const o=Object.create(null),v=[];for(let E=0,c=r.length;E<c;E++)this._handleActivateRequest(r[E],o,v);for(let E=0,c=v.length;E<c;E++){const l=b.ExtensionIdentifier.toKey(v[E].id);o[l]&&delete o[l]}const p=Object.keys(o).map(E=>o[E]);return v.length===0?Promise.all(p.map(E=>this._activateExtension(E.id,E.reason))).then(E=>{}):this._activateExtensions(p).then(E=>this._activateExtensions(v))}_activateExtension(r,o){const v=b.ExtensionIdentifier.toKey(r);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const p=this._activatingExtensions.get(v);if(p)return p;const E=this._host.actualActivateExtension(r,o).then(void 0,c=>{const l=new Error;return c&&c.name&&(l.name=c.name),c&&c.message?l.message=`Activating extension '${r.value}' failed: ${c.message}.`:l.message=`Activating extension '${r.value}' failed: ${c}.`,c&&c.stack&&(l.stack=c.stack),this._host.onExtensionActivationError(r,l,null),this._logService.error(`Activating extension ${r.value} failed due to an error:`),this._logService.error(c),new I(c)}).then(c=>{this._activatedExtensions.set(v,c),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,E),E}};h=je([Ke(4,P.ILogService)],h),e.ExtensionsActivator=h}),define(ve[186],be([0,1,12]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,y)=>{this._actualOk=T,this._actualErr=y,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,b.onUnexpectedError)(T))}then(T,y){return this._ensureActual().then(T,y)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=k}),define(ve[98],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class b{constructor(S,C){this.isMain=S,this.sid=C,this.nid=++b.count}}e.ProxyIdentifier=b,b.count=0;const k=[];function P(D){const S=new b(!0,D);return k[S.nid]=S,S}e.createMainContextProxyIdentifier=P;function T(D){const S=new b(!1,D);return k[S.nid]=S,S}e.createExtHostContextProxyIdentifier=T;function y(D){return k[D].sid}e.getStringIdentifierForProxy=y}),define(ve[5],be([0,1,2,98,57]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.CellKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var y;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(y=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var S;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(S=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(l){l[l.Markdown=1]="Markdown",l[l.Code=2]="Code"})(C=e.CellKind||(e.CellKind={}));var i;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(i=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var h;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(h=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(l){l.name="$ident";function f(n,a){return Object.defineProperty(n,l.name,{value:a,enumerable:!0}),n}l.mixin=f;function t(n){return n[l.name]}l.of=t})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class r{static mixin(f){return f._id=r._n++,f}}e.IdObject=r,r._n=0;var o;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var v;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(v=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var p;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(p=e.WorkspaceEditType||(e.WorkspaceEditType={}));function E(l){if(l&&l.edits)for(const f of l.edits)typeof f.resource=="object"?f.resource=b.URI.revive(f.resource):(f.newUri=b.URI.revive(f.newUri),f.oldUri=b.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=(0,P.revive)(f.metadata));return l}e.reviveWorkspaceEditDto=E;var c;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(c=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,k.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,k.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,k.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,k.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,k.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,k.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,k.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,k.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,k.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,k.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,k.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,k.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,k.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,k.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,k.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,k.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,k.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,k.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,k.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,k.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,k.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,k.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,k.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,k.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,k.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,k.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,k.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadTheming:(0,k.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,k.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,k.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,k.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,k.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,k.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,k.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,k.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,k.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,k.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,k.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,k.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,k.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,k.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,k.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,k.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,k.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,k.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,k.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,k.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,k.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,k.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,k.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,k.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,k.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,k.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostTheming:(0,k.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,k.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,k.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,k.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,k.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,k.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(ve[74],be([0,1,5,3,4]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(D){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(b.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,S){return this._proxy.$getPassword(D,S)}store(D,S,C){return this._proxy.$setPassword(D,S,C)}delete(D,S){return this._proxy.$deletePassword(D,S)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,P.createDecorator)("IExtHostSecretState")}),define(ve[75],be([0,1,4,18,5,15]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,b.createDecorator)("IExtHostApiDeprecationService");let y=class{constructor(S,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=S.getProxy(P.MainContext.MainThreadTelemetry)}report(S,C,i){const I=this.getUsageKey(S,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${S}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:S}))}getUsageKey(S,C){return`${S}-${C.identifier.value}`}};y=je([Ke(0,T.IExtHostRpcService),Ke(1,k.ILogService)],y),e.ExtHostApiDeprecationService=y,e.NullApiDeprecationService=Object.freeze(new class{report(D,S,C){}})}),define(ve[187],be([0,1,3,5,7,26]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class y{constructor(S){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new b.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new b.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=S.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(S){return this._providers=S,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(S,C,i,I={}){const h=T.ExtensionIdentifier.toKey(S.identifier),d=this._inFlightRequests.get(h)||[],r=i.sort().join(" ");let o=d.find(v=>v.scopes===r);if(o)return o.result;{const v=this._getSession(S,h,C,i,I);o={scopes:r,result:v},d.push(o),this._inFlightRequests.set(h,d);try{await v}finally{const p=d.findIndex(E=>E.scopes===r);p>-1&&(d.splice(p),this._inFlightRequests.set(h,d))}return v}}async _getSession(S,C,i,I,h={}){await this._proxy.$ensureProvider(i);const d=S.displayName||S.name;return this._proxy.$getSession(i,I,C,d,h)}async removeSession(S,C){const i=this._authenticationProviders.get(S);return i?i.provider.removeSession(C):this._proxy.$removeSession(S,C)}registerAuthenticationProvider(S,C,i,I){var h;if(this._authenticationProviders.get(S))throw new Error(`An authentication provider with id '${S}' is already registered.`);this._authenticationProviders.set(S,{label:C,provider:i,options:I!=null?I:{supportsMultipleAccounts:!1}}),this._providers.find(r=>r.id===S)||this._providers.push({id:S,label:C});const d=i.onDidChangeSessions(r=>{var o,v,p;this._proxy.$sendDidChangeSessions(S,{added:(o=r.added)!==null&&o!==void 0?o:[],changed:(v=r.changed)!==null&&v!==void 0?v:[],removed:(p=r.removed)!==null&&p!==void 0?p:[]})});return this._proxy.$registerAuthenticationProvider(S,C,(h=I==null?void 0:I.supportsMultipleAccounts)!==null&&h!==void 0?h:!1),new P.Disposable(()=>{d.dispose(),this._authenticationProviders.delete(S);const r=this._providers.findIndex(o=>o.id===S);r>-1&&this._providers.splice(r),this._proxy.$unregisterAuthenticationProvider(S)})}$createSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$removeSession(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$getSessions(S,C){const i=this._authenticationProviders.get(S);if(i)return Promise.resolve(i.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${S}`)}$onDidChangeAuthenticationSessions(S,C){return this._onDidChangeSessions.fire({provider:{id:S,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(S,C){return S.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),C.forEach(i=>{const I=this._providers.findIndex(h=>h.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:S,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=y}),define(ve[188],be([0,1,5,15,9]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(D,S){this._extHostDocumentsAndEditors=S,this._proxy=D.getProxy(b.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const S=P.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(S)}};T=je([Ke(0,k.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(ve[189],be([0,1,5]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(T){const y=T.getProxy(b.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return y.$readText()},writeText(D){return y.$writeText(D)}})}}e.ExtHostClipboard=k}),define(ve[76],be([0,1,10,7,9,23,5,13,18,57,32,38,2,6,4,15]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(y.MainContext.MainThreadCommands),this._logService=n,this.converter=new p(this,a=>{const s=this._apiCommands.get(a);return(s==null?void 0:s.result)===c.Void?s:void 0},n),this._argumentProcessors=[{processArgument(a){return(0,C.revive)(a)}},{processArgument(a){return(0,T.cloneAndChange)(a,function(s){if(i.Range.isIRange(s))return P.Range.to(s);if(I.Position.isIPosition(s))return P.Position.to(s);if(i.Range.isIRange(s.range)&&h.URI.isUri(s.uri))return P.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...a)=>{const s=t.args.map((g,_)=>{if(!g.validate(a[_]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${a[_]}`);return g.convert(a[_])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,a,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,a,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:a,thisArg:s,description:u}),t&&this._proxy.$registerCommand(n),new k.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,a){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,T.cloneAndChange)(n,function(u){if(u instanceof k.Position)return P.Position.from(u);if(u instanceof k.Range)return P.Range.from(u);if(u instanceof k.Location)return P.location.from(u);if(k.NotebookRange.isNotebookRange(u))return P.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,a);return(0,C.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const a=this._commands.get(t);if(!a)throw new Error("Unknown command");let{callback:s,thisArg:u,description:g}=a;if(g)for(let _=0;_<g.args.length;_++)try{(0,b.validateConstraint)(n[_],g.args[_].constraint)}catch(A){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[_].name}' - ${g.args[_].description}`)}try{return await s.apply(u,n)}catch(_){if(t===this.converter.delegatingCommandId){const A=this.converter.getActualCommand(...n);A&&(t=A.command)}throw this._logService.error(_,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(a=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),a)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(a=>a[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,a]of this._commands){let{description:s}=a;s&&(t[n]=s)}return Promise.resolve(t)}};v=je([Ke(0,o.IExtHostRpcService),Ke(1,S.ILogService)],v),e.ExtHostCommands=v,e.IExtHostCommands=(0,r.createDecorator)("IExtHostCommands");class p{constructor(t,n,a){this._commands=t,this._lookupApiCommand=n,this._logService=a,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!!t){const a={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return a;const s=this._lookupApiCommand(t.command);if(s)a.id=s.internalId,a.arguments=s.args.map((u,g)=>u.convert(t.arguments&&t.arguments[g]));else if((0,D.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,d.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),a.$ident=u,a.id=this.delegatingCommandId,a.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return a}}fromInternal(t){const n=y.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=p;class E{constructor(t,n,a,s){this.name=t,this.description=n,this.validate=a,this.convert=s}optional(){return new E(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new E(t!=null?t:this.name,n!=null?n:this.description,this.validate,this.convert)}}e.ApiCommandArgument=E,E.Uri=new E("uri","Uri of a text document",f=>h.URI.isUri(f),f=>f),E.Position=new E("position","A position in a text document",f=>k.Position.isPosition(f),P.Position.from),E.Range=new E("range","A range in a text document",f=>k.Range.isRange(f),P.Range.from),E.Selection=new E("selection","A selection in a text document",f=>k.Selection.isSelection(f),P.Selection.from),E.Number=new E("number","",f=>typeof f=="number",f=>f),E.String=new E("string","",f=>typeof f=="string",f=>f),E.CallHierarchyItem=new E("item","A call hierarchy item",f=>f instanceof k.CallHierarchyItem,P.CallHierarchyItem.to);class c{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=c,c.Void=new c("no result",f=>f);class l{constructor(t,n,a,s,u){this.id=t,this.internalId=n,this.description=a,this.args=s,this.result=u}}e.ApiCommand=l}),define(ve[190],be([0,1,6,9,7,62,76,168,13,87]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new y.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",h(k.DocumentHighlight.to))),new y.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if(!(0,S.isFalsyOrEmpty)(r)){class v extends P.SymbolInformation{static to(E){const c=new v(E.name,k.SymbolKind.to(E.kind),E.containerName||"",new P.Location(o[0],k.Range.to(E.range)));return c.detail=E.detail,c.range=c.location.range,c.selectionRange=k.Range.to(E.selectionRange),c.children=E.children?E.children.map(v.to):[],c}}return r.map(v.to)}})),new y.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range,new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(k.TextEdit.to))),new y.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,new y.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new y.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new y.ApiCommandResult("A promise that resolves to an array of TextEdits.",h(k.TextEdit.to))),new y.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",d)),new y.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Location-instances.",h(k.location.to))),new y.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A promise that resolves to an array of Hover-instances.",h(k.Hover.to))),new y.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>P.Position.isPosition(o)),r=>r.map(k.Position.from))],new y.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(o=>{let v;for(const p of o.reverse())v=new P.SelectionRange(k.Range.to(p),v);return v}))),new y.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[y.ApiCommandArgument.String.with("query","Search string")],new y.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const o=[];if(Array.isArray(r))for(let v of r)o.push(...v[1].map(k.WorkspaceSymbol.to));return o})),new y.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyItem.to))),new y.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyIncomingCall.to))),new y.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[y.ApiCommandArgument.CallHierarchyItem],new y.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(k.CallHierarchyOutgoingCall.to))),new y.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("newName","The new symbol name")],new y.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return k.WorkspaceEdit.to(r)}})),new y.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new y.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(k.DocumentLink.to))),new y.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new P.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new P.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new y.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!!r){const o=(0,C.decodeSemanticTokensDto)(r);if(o.type==="full")return new P.SemanticTokens(o.data,void 0)}})),new y.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new y.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,o,v)=>{if(!r)return new P.CompletionList([]);const p=r.suggestions.map(E=>k.CompletionItem.to(E,v));return new P.CompletionList(p,r.incomplete)})),new y.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Position,y.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new y.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return k.SignatureHelp.to(r)})),new y.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new y.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,o,v)=>h(p=>new P.CodeLens(k.Range.to(p.range),p.command&&v.fromInternal(p.command)))(r))),new y.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>P.Range.isRange(r),r=>P.Selection.isSelection(r)?k.Selection.from(r):k.Range.from(r)),y.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),y.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new y.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,o,v)=>h(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return v.fromInternal(p.command)}else{const E=new P.CodeAction(p.title,p.kind?new P.CodeActionKind(p.kind):void 0);return p.edit&&(E.edit=k.WorkspaceEdit.to(p.edit)),p.command&&(E.command=v.fromInternal(p.command)),E.isPreferred=p.isPreferred,E}})(r))),new y.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[y.ApiCommandArgument.Uri],new y.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new P.ColorInformation(k.Range.to(o.range),k.Color.to(o.color))):[])),new y.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new y.ApiCommandArgument("color","The color to show and insert",r=>r instanceof P.Color,k.Color.from),new y.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:k.Range.from(r.range)}))],new y.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(k.ColorPresentation.to):[])),new y.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(k.InlayHint.to))),new y.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new y.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",h(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>k.NotebookExclusiveDocumentPattern.to(o))})))),new y.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[y.ApiCommandArgument.Uri,y.ApiCommandArgument.Range],new y.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(k.InlineValue.to))),new y.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[y.ApiCommandArgument.Uri,new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional(),y.ApiCommandArgument.String.with("label","").optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[y.ApiCommandArgument.Uri.with("resource","Resource to open"),y.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)])).optional()],y.ApiCommandResult.Void),new y.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[y.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),y.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),y.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new y.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[k.ViewColumn.from(r.viewColumn),k.TextEditorOpenOptions.from(r)]).optional()],y.ApiCommandResult.Void)];class I{constructor(o){this._disposables=new b.DisposableStore,this._commands=o}static register(o){return i.forEach(o.registerApiCommand,o),new I(o).registerCommands()}registerCommands(){const o=v=>(...p)=>v(this._commands,...p);this._register(D.RemoveFromRecentlyOpenedAPICommand.ID,o(D.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:v=>typeof v=="string"}]}),this._register(D.OpenIssueReporter.ID,o(D.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:v=>typeof v=="string"||typeof v=="object"&&typeof v.extensionId=="string"}]})}_register(o,v,p){const E=this._commands.registerCommand(!1,o,v,this,p);this._disposables.add(E)}}e.ExtHostApiCommands=I;function h(r){return o=>{if(Array.isArray(o))return o.map(r)}}function d(r){if(!!Array.isArray(r)){const o=[];for(const v of r)T.isLocationLink(v)?o.push(k.DefinitionLink.to(v)):o.push(k.location.to(v));return o}}}),define(ve[191],be([0,1,11,52,3,6,2,62,26,9,7,5]),function(J,e,b,k,P,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class h{constructor(l,f,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=l.getProxy(I.MainContext.MainThreadComments),f.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const a=this._commentControllers.get(n.handle);return a||n}else if(n&&n.$mid===7){const a=this._commentControllers.get(n.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.commentUniqueId,g=s.getCommentByUniqueId(u);return g||n}else if(n&&n.$mid===10){const a=this._commentControllers.get(n.thread.commentControlHandle);if(!a)return n;const s=a.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.text,g=n.commentUniqueId,_=s.getCommentByUniqueId(g);return _?(_.body=u,_):n}return n}})}createCommentController(l,f,t){const n=h.handlePool++,a=new r(l,n,this._proxy,f,t);this._commentControllers.set(a.handle,a);const s=this._commentControllersByExtension.get(S.ExtensionIdentifier.toKey(l.identifier))||[];return s.push(a),this._commentControllersByExtension.set(S.ExtensionIdentifier.toKey(l.identifier),s),a}$createCommentThreadTemplate(l,f,t){const n=this._commentControllers.get(l);!n||n.$createCommentThreadTemplate(f,t)}async $updateCommentThreadTemplate(l,f,t){const n=this._commentControllers.get(l);!n||n.$updateCommentThreadTemplate(f,t)}$deleteCommentThread(l,f){const t=this._commentControllers.get(l);t&&t.$deleteCommentThread(f)}$provideCommentingRanges(l,f,t){const n=this._commentControllers.get(l);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const a=this._documents.getDocument(y.URI.revive(f));return(0,b.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(a,t)).then(s=>s?s.map(u=>C.Range.from(u)):void 0)}$toggleReaction(l,f,t,n,a){const s=this._commentControllers.get(l);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,b.asPromise)(()=>{const u=s.getCommentThread(f);if(u){const g=u.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&g&&s.reactionHandler)return s.reactionHandler(g,p(a))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=h,h.handlePool=0;class d{constructor(l,f,t,n,a,s,u){this._proxy=l,this._commentController=f,this._id=t,this._uri=n,this._range=a,this._comments=s,this.handle=d._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new P.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${f.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(l){this._id=l}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(l){l.isEqual(this._range)||(this._range=l,this.modifications.range=l,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(l){this._canReply!==l&&(this._canReply=l,this.modifications.canReply=l,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(l){this._label=l,this.modifications.label=l,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(l){this._contextValue=l,this.modifications.contextValue=l,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(l){this._comments=l,this.modifications.comments=l,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(l){this._collapseState=l,this.modifications.collapsibleState=l,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(!this._isDiposed){this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const l=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),f={};l("range")&&(f.range=C.Range.from(this._range)),l("label")&&(f.label=this.label),l("contextValue")&&(f.contextValue=this.contextValue),l("comments")&&(f.comments=this._comments.map(t=>o(this,this._commentController,t,this._commentsMap))),l("collapsibleState")&&(f.collapseState=E(this._collapseState)),l("canReply")&&(f.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,f)}}getCommentByUniqueId(l){for(let f of this._commentsMap){let t=f[0],n=f[1];if(l===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(l=>l.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}d._handlePool=0,je([(0,k.debounce)(100)],d.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=d;class r{constructor(l,f,t,n,a){this._extension=l,this._handle=f,this._proxy=t,this._id=n,this._label=a,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,a)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(l){this._reactionHandler=l,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this._options}set options(l){this._options=l,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(l,f,t,n){if(typeof l=="string"){const a=new d(this._proxy,this,l,f,t,n,this._extension.identifier);return this._threads.set(a.handle,a),a}else{const a=new d(this._proxy,this,void 0,l,f,t,this._extension.identifier);return this._threads.set(a.handle,a),a}}$createCommentThreadTemplate(l,f){const t=new d(this._proxy,this,void 0,y.URI.revive(l),C.Range.to(f),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(l,f){let t=this._threads.get(l);t&&(t.range=C.Range.to(f))}$deleteCommentThread(l){let f=this._threads.get(l);f&&f.dispose(),this._threads.delete(l)}getCommentThread(l){return this._threads.get(l)}dispose(){this._threads.forEach(l=>{l.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function o(c,l,f,t){let n=t.get(f);n||(n=++c.commentHandle,t.set(f,n));const a=f.author&&f.author.iconPath?f.author.iconPath.toString():void 0;return{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:n,body:C.MarkdownString.from(f.body),userName:f.author.name,userIconPath:a,label:f.label,commentReactions:f.reactions?f.reactions.map(s=>v(s)):void 0}}function v(c){return{label:c.label,iconPath:c.iconPath?C.pathOrURIToURI(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function p(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?y.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function E(c){if(c!==void 0)switch(c){case i.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(ve[99],be([0,1,2,5,7,4,15,18,13,8,14]),function(J,e,b,k,P,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class wn{constructor(d,r){this._logService=r,this._provider=new Map,this._proxy=d.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,r){const o=wn._handlePool++;this._provider.set(o,{provider:d,extensionId:r}),this._proxy.$registerDecorationProvider(o,r.value);const v=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(p=>{if(!p){this._proxy.$onDidChange(o,null);return}let E=(0,S.asArray)(p);if(E.length<=wn._maxEventSize){this._proxy.$onDidChange(o,E);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",r.value,E.length);const c=E.map(t=>({uri:t,rank:(0,C.count)(t.path,"/")})),l=(0,S.groupBy)(c,(t,n)=>t.rank-n.rank||(0,C.compare)(t.uri.path,n.uri.path));let f=[];e:for(let t of l){let n;for(let a of t){let s=(0,i.dirname)(a.uri.path);if(n!==s&&(n=s,f.push(a.uri)>=wn._maxEventSize))break e}}this._proxy.$onDidChange(o,f)});return new P.Disposable(()=>{v==null||v.dispose(),this._proxy.$unregisterDecorationProvider(o),this._provider.delete(o)})}async $provideDecorations(d,r,o){if(!this._provider.has(d))return Object.create(null);const v=Object.create(null),{provider:p,extensionId:E}=this._provider.get(d);return await Promise.all(r.map(async c=>{try{const{uri:l,id:f}=c,t=await Promise.resolve(p.provideFileDecoration(b.URI.revive(l),o));if(!t)return;try{P.FileDecoration.validate(t),v[f]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${E.value}': ${n}`)}}catch(l){this._logService.error(l)}})),v}};I._handlePool=0,I._maxEventSize=250,I=je([Ke(0,y.IExtHostRpcService),Ke(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(ve[192],be([0,1,131,90,2,5,7,9,3,18,22]),function(J,e,b,k,P,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(r,o,v,p,E){this._name=r,this._owner=o,this._maxDiagnosticsPerFile=v,this._proxy=p,this._onDidChangeDiagnostics=E,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(r,o){if(!r){this.clear();return}this._checkDisposed();let v=[];if(P.URI.isUri(r)){if(!o){this.delete(r);return}this._data.set(r,o.slice()),v=[r]}else if(Array.isArray(r)){v=[];let E;r=[...r].sort(I._compareIndexedTuplesByUri);for(const c of r){const[l,f]=c;if((!E||l.toString()!==E.toString())&&(E&&this._data.get(E).length===0&&this._data.delete(E),E=l,v.push(l),this._data.set(l,[])),f){const t=this._data.get(l);t&&t.push(...f)}else{const t=this._data.get(l);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(v),!!this._proxy){const p=[];for(let E of v){let c=[];const l=this._data.get(E);if(l)if(l.length>this._maxDiagnosticsPerFile){c=[];const f=[y.DiagnosticSeverity.Error,y.DiagnosticSeverity.Warning,y.DiagnosticSeverity.Information,y.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of l)if(n.severity===f[t]&&c.push(D.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;c.push({severity:k.MarkerSeverity.Info,message:(0,b.localize)(0,null,l.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=l.map(f=>D.Diagnostic.from(f));p.push([E,c])}this._proxy.$changeMany(this._owner,p)}}delete(r){this._checkDisposed(),this._onDidChangeDiagnostics.fire([r]),this._data.delete(r),this._proxy&&this._proxy.$changeMany(this._owner,[[r,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(r,o){this._checkDisposed();for(let v of this._data.keys())r.apply(o,[v,this.get(v),this])}get(r){this._checkDisposed();const o=this._data.get(r);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(r){return this._checkDisposed(),Array.isArray(this._data.get(r))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(r,o){return r[0].toString()<o[0].toString()?-1:r[0].toString()>o[0].toString()?1:0}}e.DiagnosticCollection=I;let h=class Vt{constructor(r,o){this._logService=o,this._collections=new Map,this._onDidChangeDiagnostics=new S.Emitter,this.onDidChangeDiagnostics=S.Event.map(S.Event.debounce(this._onDidChangeDiagnostics.event,Vt._debouncer,50),Vt._mapper),this._proxy=r.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(r,o){return r?r.concat(o):o}static _mapper(r){const o=[],v=new Set;for(const p of r)typeof p=="string"?v.has(p)||(v.add(p),o.push(P.URI.parse(p))):v.has(p.toString())||(v.add(p.toString()),o.push(p));return Object.freeze(o),{uris:o}}createDiagnosticCollection(r,o){const{_collections:v,_proxy:p,_onDidChangeDiagnostics:E,_logService:c}=this,l=new class{$changeMany(n,a){p.$changeMany(n,a),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,n,a.length===0?"CLEARING":a)}$clear(n){p.$clear(n),c.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,n)}dispose(){p.dispose()}};let f;if(!o)o="_generated_diagnostic_collection_name_#"+Vt._idPool++,f=o;else if(!v.has(o))f=o;else{this._logService.warn(`DiagnosticCollection with name '${o}' does already exist.`);do f=o+Vt._idPool++;while(v.has(f))}return new class extends I{constructor(){super(o,f,Vt._maxDiagnosticsPerFile,l,E);v.set(f,this)}dispose(){super.dispose(),v.delete(f)}}}getDiagnostics(r){if(r)return this._getDiagnostics(r);{const o=new Map,v=[];for(const p of this._collections.values())p.forEach((E,c)=>{let l=o.get(E.toString());typeof l=="undefined"&&(l=v.length,o.set(E.toString(),l),v.push([E,[]])),v[l][1]=v[l][1].concat(...c)});return v}}_getDiagnostics(r){let o=[];for(let v of this._collections.values())v.has(r)&&(o=o.concat(v.get(r)));return o}$acceptMarkersChange(r){if(!this._mirrorCollection){const o="_generated_mirror",v=new I(o,o,Vt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(o,v),this._mirrorCollection=v}for(const[o,v]of r)this._mirrorCollection.set(P.URI.revive(o),v.map(D.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=je([Ke(1,C.ILogService)],h),e.ExtHostDiagnostics=h}),define(ve[193],be([0,1,2,5]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class P{constructor(y){this._proxy=y.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(y){return this._proxy.$showOpenDialog(y).then(D=>D?D.map(S=>b.URI.revive(S)):void 0)}showSaveDialog(y){return this._proxy.$showSaveDialog(y).then(D=>D?b.URI.revive(D):void 0)}}e.ExtHostDialogs=P}),define(ve[194],be([0,1,12,2,7,5,19,20,8]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,h,d){this._documentsAndEditors=h,this._logService=d,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,h){if(Object.keys(y.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const d=C._handlePool++;this._documentContentProviders.set(d,h),this._proxy.$registerTextContentProvider(d,I);let r;return typeof h.onDidChange=="function"&&(r=h.onDidChange(o=>{if(o.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(o)&&this.$provideTextDocumentContent(d,o).then(v=>{if(!(!v&&typeof v!="string")){const p=this._documentsAndEditors.getDocument(o);if(!!p){const E=(0,S.splitLines)(v);if(!p.equalLines(E))return this._proxy.$onVirtualDocumentChange(o,v)}}},b.onUnexpectedError)})),new P.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),r&&(r.dispose(),r=void 0)})}$provideTextDocumentContent(I,h){const d=this._documentContentProviders.get(I);return d?Promise.resolve(d.provideTextDocumentContent(k.URI.revive(h),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${h.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(ve[195],be([0,1,3,6,2,5,95,9,10,23]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(h,d){this._onDidAddDocument=new b.Emitter,this._onDidRemoveDocument=new b.Emitter,this._onDidChangeDocument=new b.Emitter,this._onDidSaveDocument=new b.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=d,this._documentsAndEditors.onDidRemoveDocuments(r=>{for(const o of r)this._onDidRemoveDocument.fire(o.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(r=>{for(const o of r)this._onDidAddDocument.fire(o.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(h){if(!!h){const d=this._documentsAndEditors.getDocument(h);if(d)return d}}getDocument(h){const d=this.getDocumentData(h);if(!(d==null?void 0:d.document))throw new Error(`Unable to retrieve document from URI '${h}'`);return d.document}ensureDocumentData(h){const d=this._documentsAndEditors.getDocument(h);if(d)return Promise.resolve(d);let r=this._documentLoader.get(h.toString());return r||(r=this._proxy.$tryOpenDocument(h).then(o=>{this._documentLoader.delete(h.toString());const v=P.URI.revive(o);return(0,S.assertIsDefined)(this._documentsAndEditors.getDocument(v))},o=>(this._documentLoader.delete(h.toString()),Promise.reject(o))),this._documentLoader.set(h.toString(),r)),r}createDocumentData(h){return this._proxy.$tryCreateDocument(h).then(d=>P.URI.revive(d))}$acceptModelModeChanged(h,d){const r=P.URI.revive(h),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),o._acceptLanguageId(d),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(h){const d=P.URI.revive(h),r=this._documentsAndEditors.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(h,!1),this._onDidSaveDocument.fire(r.document)}$acceptDirtyStateChanged(h,d){const r=P.URI.revive(h),o=this._documentsAndEditors.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(d),this._onDidChangeDocument.fire({document:o.document,contentChanges:[]})}$acceptModelChanged(h,d,r){const o=P.URI.revive(h),v=this._documentsAndEditors.getDocument(o);if(!v)throw new Error("unknown document");v._acceptIsDirty(r),v.onEvents(d),this._onDidChangeDocument.fire((0,C.deepFreeze)({document:v.document,contentChanges:d.changes.map(p=>({range:D.Range.to(p.range),rangeOffset:p.rangeOffset,rangeLength:p.rangeLength,text:p.text}))}))}setWordDefinitionFor(h,d){(0,y.setWordDefinitionFor)(h,d)}}e.ExtHostDocuments=i}),define(ve[39],be([0,1,42,3,6,2,4,5,95,15,97,9,18,22,19,43,108]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class p{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let E=class{constructor(l,f){this._extHostRpc=l,this._logService=f,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const f=[],t=[],n=[];if(l.removedDocuments)for(const a of l.removedDocuments){const s=T.URI.revive(a),u=this._documents.get(s);(u==null?void 0:u.unref())&&(this._documents.delete(s),f.push(u.value))}if(l.addedDocuments)for(const a of l.addedDocuments){const s=T.URI.revive(a.uri);let u=this._documents.get(s);if(u&&s.scheme!==r.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);u||(u=new p(new S.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),s,a.lines,a.EOL,a.versionId,a.modeId,a.isDirty,a.notebook)),this._documents.set(s,u),t.push(u.value)),u.ref()}if(l.removedEditors)for(const a of l.removedEditors){const s=this._editors.get(a);this._editors.delete(a),s&&n.push(s)}if(l.addedEditors)for(const a of l.addedEditors){const s=T.URI.revive(a.documentUri);b.ok(this._documents.has(s),`document '${s}' does not exist`),b.ok(!this._editors.has(a.id),`editor '${a.id}' already exists!`);const u=this._documents.get(s).value,g=new i.ExtHostTextEditor(a.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>u.document),a.selections.map(I.Selection.to),a.options,a.visibleRanges.map(_=>I.Range.to(_)),typeof a.editorPosition=="number"?I.ViewColumn.to(a.editorPosition):void 0);this._editors.set(a.id,g)}l.newActiveEditor!==void 0&&(b.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,P.dispose)(f),(0,P.dispose)(n),l.removedDocuments&&this._onDidRemoveDocuments.fire(f),l.addedDocuments&&this._onDidAddDocuments.fire(t),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(a=>a.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){var f;return(f=this._documents.get(l))===null||f===void 0?void 0:f.value}allDocuments(){return o.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!!this._activeEditorId){const f=this._editors.get(this._activeEditorId);return l?f:f==null?void 0:f.value}}allEditors(){return[...this._editors.values()]}};E=je([Ke(0,C.IExtHostRpcService),Ke(1,h.ILogService)],E),e.ExtHostDocumentsAndEditors=E,e.IExtHostDocumentsAndEditors=(0,y.createDecorator)("IExtHostDocumentsAndEditors")}),define(ve[196],be([0,1,2,5,6,7,9,118,8,24]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const r=this._schemes.indexOf(d);r>=0&&(this._schemes.splice(r,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),r=[];let o,v,p=14,E=14;for(const c of d){let l=o?(0,S.commonPrefixLength)(o,c):0;for(l===0?v=1:v=E;l<c.length;l++)l+1===c.length?(p=E,E=9):E+=1,r.push([v,c.toUpperCase().charCodeAt(l),E]),r.push([v,c.toLowerCase().charCodeAt(l),E]),v=E;o=c,E=p}r.push([9,58,10]),r.push([10,47,12]),this._stateMachine=new D.StateMachine(r)}}provideDocumentLinks(d){this._initStateMachine();const r=[],o=D.LinkComputer.computeLinks({getLineContent(v){return d.lineAt(v-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const v of o){const p=y.DocumentLink.to(v);p.target&&r.push(p)}return r}}class I{constructor(d,r){this._extHostLanguageFeatures=r,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=d.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){var d;(d=this._linkProviderRegistration)===null||d===void 0||d.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,r,o,v={}){if(this._registeredSchemes.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(r),this._registeredSchemes.add(r),this._fsProvider.set(p,o);let E=2;v.isCaseSensitive&&(E+=1024),v.isReadonly&&(E+=2048),typeof o.copy=="function"&&(E+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&(E+=4),this._proxy.$registerFileSystemProvider(p,r,E).catch(l=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${r}`),console.error(l)});const c=o.onDidChangeFile(l=>{const f=[];for(const t of l){let{uri:n,type:a}=t;if(n.scheme===r){let s;switch(a){case T.FileChangeType.Changed:s=0;break;case T.FileChangeType.Created:s=1;break;case T.FileChangeType.Deleted:s=2;break;default:throw new Error("Unknown FileChangeType")}f.push({resource:n,type:s})}}this._proxy.$onFileSystemChange(p,f)});return(0,P.toDisposable)(()=>{c.dispose(),this._linkProvider.delete(r),this._registeredSchemes.delete(r),this._fsProvider.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(d){const{type:r,ctime:o,mtime:v,size:p}=d;return{type:r,ctime:o,mtime:v,size:p}}$stat(d,r){return Promise.resolve(this._getFsProvider(d).stat(b.URI.revive(r))).then(I._asIStat)}$readdir(d,r){return Promise.resolve(this._getFsProvider(d).readDirectory(b.URI.revive(r)))}$readFile(d,r){return Promise.resolve(this._getFsProvider(d).readFile(b.URI.revive(r))).then(o=>C.VSBuffer.wrap(o))}$writeFile(d,r,o,v){return Promise.resolve(this._getFsProvider(d).writeFile(b.URI.revive(r),o.buffer,v))}$delete(d,r,o){return Promise.resolve(this._getFsProvider(d).delete(b.URI.revive(r),o))}$rename(d,r,o,v){return Promise.resolve(this._getFsProvider(d).rename(b.URI.revive(r),b.URI.revive(o),v))}$copy(d,r,o,v){const p=this._getFsProvider(d);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(b.URI.revive(r),b.URI.revive(o),v))}$mkdir(d,r){return Promise.resolve(this._getFsProvider(d).createDirectory(b.URI.revive(r)))}$watch(d,r,o,v){const p=this._getFsProvider(d).watch(b.URI.revive(o),v);this._watches.set(r,p)}$unwatch(d,r){const o=this._watches.get(r);o&&(o.dispose(),this._watches.delete(r))}$open(d,r,o){const v=this._getFsProvider(d);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(b.URI.revive(r),o))}$close(d,r){const o=this._getFsProvider(d);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(r))}$read(d,r,o,v){const p=this._getFsProvider(d);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const E=C.VSBuffer.alloc(v);return Promise.resolve(p.read(r,o,E.buffer,0,v)).then(c=>E.slice(0,c))}$write(d,r,o,v){const p=this._getFsProvider(d);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(r,o,v.buffer,0,v.byteLength))}_getFsProvider(d){const r=this._fsProvider.get(d);if(!r){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return r}}e.ExtHostFileSystem=I}),define(ve[77],be([0,1,5,64,7,24,4,15,49]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ot{constructor(I,h){const d=I.getProxy(b.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(r){return d.$stat(r).catch(Ot._handleError)},readDirectory(r){return d.$readdir(r).catch(Ot._handleError)},createDirectory(r){return d.$mkdir(r).catch(Ot._handleError)},async readFile(r){return d.$readFile(r).then(o=>o.buffer).catch(Ot._handleError)},writeFile(r,o){return d.$writeFile(r,T.VSBuffer.wrap(o)).catch(Ot._handleError)},delete(r,o){return d.$delete(r,Object.assign({recursive:!1,useTrash:!1},o)).catch(Ot._handleError)},rename(r,o,v){return d.$rename(r,o,Object.assign({overwrite:!1},v)).catch(Ot._handleError)},copy(r,o,v){return d.$copy(r,o,Object.assign({overwrite:!1},v)).catch(Ot._handleError)},isWritableFileSystem(r){const o=h.getCapabilities(r);if(typeof o=="number")return!(o&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new P.FileSystemError(String(I));if(I.name==="ENOPRO")throw P.FileSystemError.Unavailable(I.message);switch(I.name){case k.FileSystemProviderErrorCode.FileExists:throw P.FileSystemError.FileExists(I.message);case k.FileSystemProviderErrorCode.FileNotFound:throw P.FileSystemError.FileNotFound(I.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw P.FileSystemError.FileNotADirectory(I.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw P.FileSystemError.FileIsADirectory(I.message);case k.FileSystemProviderErrorCode.NoPermissions:throw P.FileSystemError.NoPermissions(I.message);case k.FileSystemProviderErrorCode.Unavailable:throw P.FileSystemError.Unavailable(I.message);default:throw new P.FileSystemError(I.message,I.name)}}};C=je([Ke(0,D.IExtHostRpcService),Ke(1,S.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=(0,y.createDecorator)("IExtHostConsumerFileSystem")}),define(ve[197],be([0,1,6,5]),function(J,e,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class P{constructor(y){this._handlePool=0,this._proxy=y.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(y){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,y),(0,b.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=P}),define(ve[198],be([0,1,2,23,9,7,11,5,8,32,13,10,115,6,87,54,68,55,12]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(W,j){this._documents=W,this._provider=j}provideDocumentSymbols(W,j){const te=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentSymbols(te,j)).then(oe=>{if(!(0,i.isFalsyOrEmpty)(oe))return oe[0]instanceof T.DocumentSymbol?oe.map(P.DocumentSymbol.from):c._asDocumentSymbolTree(oe)})}static _asDocumentSymbolTree(W){var j;W=W.slice(0).sort((de,_e)=>{let Be=de.location.range.start.compareTo(_e.location.range.start);return Be===0&&(Be=_e.location.range.end.compareTo(de.location.range.end)),Be});const te=[],oe=[];for(const de of W){const _e={name:de.name||"!!MISSING: name!!",kind:P.SymbolKind.from(de.kind),tags:((j=de.tags)===null||j===void 0?void 0:j.map(P.SymbolTag.from))||[],detail:"",containerName:de.containerName,range:P.Range.from(de.location.range),selectionRange:P.Range.from(de.location.range),children:[]};for(;;){if(oe.length===0){oe.push(_e),te.push(_e);break}const Be=oe[oe.length-1];if(C.Range.containsRange(Be.range,_e.range)&&!C.Range.equalsRange(Be.range,_e.range)){Be.children&&Be.children.push(_e),oe.push(_e);break}oe.pop()}}return te}}class l{constructor(W,j,te){this._documents=W,this._commands=j,this._provider=te,this._cache=new v.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(W,j){const te=this._documents.getDocument(W),oe=await this._provider.provideCodeLenses(te,j);if(!(!oe||j.isCancellationRequested)){const de=this._cache.add(oe),_e=new d.DisposableStore;this._disposables.set(de,_e);const Be={cacheId:de,lenses:[]};for(let fe=0;fe<oe.length;fe++)Be.lenses.push({cacheId:[de,fe],range:P.Range.from(oe[fe].range),command:this._commands.toInternal(oe[fe].command,_e)});return Be}}async resolveCodeLens(W,j){var te;const oe=W.cacheId&&this._cache.get(...W.cacheId);if(!!oe){let de;if(typeof this._provider.resolveCodeLens!="function"||oe.isResolved?de=oe:de=await this._provider.resolveCodeLens(oe,j),de||(de=oe),!j.isCancellationRequested){const _e=W.cacheId&&this._disposables.get(W.cacheId[0]);if(!!_e)return W.command=this._commands.toInternal((te=de.command)!==null&&te!==void 0?te:l._badCmd,_e),W}}}releaseCodeLenses(W){var j;(j=this._disposables.get(W))===null||j===void 0||j.dispose(),this._disposables.delete(W),this._cache.delete(W)}}l._badCmd={command:"missing",title:"!!MISSING: command!!"};function f(ze){return Array.isArray(ze)?ze.map(P.DefinitionLink.from):ze?[P.DefinitionLink.from(ze)]:[]}class t{constructor(W,j){this._documents=W,this._provider=j}provideDefinition(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDefinition(oe,de,te)).then(f)}}class n{constructor(W,j){this._documents=W,this._provider=j}provideDeclaration(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDeclaration(oe,de,te)).then(f)}}class a{constructor(W,j){this._documents=W,this._provider=j}provideImplementation(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideImplementation(oe,de,te)).then(f)}}class s{constructor(W,j){this._documents=W,this._provider=j}provideTypeDefinition(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideTypeDefinition(oe,de,te)).then(f)}}class u{constructor(W,j){this._documents=W,this._provider=j}provideHover(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideHover(oe,de,te)).then(_e=>{if(!(!_e||(0,i.isFalsyOrEmpty)(_e.contents)))return _e.range||(_e.range=oe.getWordRangeAtPosition(de)),_e.range||(_e.range=new T.Range(de,de)),P.Hover.from(_e)})}}class g{constructor(W,j){this._documents=W,this._provider=j}provideEvaluatableExpression(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideEvaluatableExpression(oe,de,te)).then(_e=>{if(_e)return P.EvaluatableExpression.from(_e)})}}class _{constructor(W,j){this._documents=W,this._provider=j}provideInlineValues(W,j,te,oe){const de=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlineValues(de,P.Range.to(j),P.InlineValueContext.to(te),oe)).then(_e=>{if(Array.isArray(_e))return _e.map(Be=>P.InlineValue.from(Be))})}}class A{constructor(W,j){this._documents=W,this._provider=j}provideDocumentHighlights(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideDocumentHighlights(oe,de,te)).then(_e=>{if(Array.isArray(_e))return _e.map(P.DocumentHighlight.from)})}}class m{constructor(W,j){this._documents=W,this._provider=j}provideLinkedEditingRanges(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideLinkedEditingRanges(oe,de,te)).then(_e=>{if(_e&&Array.isArray(_e.ranges))return{ranges:(0,i.coalesce)(_e.ranges.map(P.Range.from)),wordPattern:_e.wordPattern}})}}class w{constructor(W,j){this._documents=W,this._provider=j}provideReferences(W,j,te,oe){const de=this._documents.getDocument(W),_e=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideReferences(de,_e,te,oe)).then(Be=>{if(Array.isArray(Be))return Be.map(P.location.from)})}}class R{constructor(W,j,te,oe,de,_e,Be){this._documents=W,this._commands=j,this._diagnostics=te,this._provider=oe,this._logService=de,this._extension=_e,this._apiDeprecation=Be,this._cache=new v.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(W,j,te,oe){const de=this._documents.getDocument(W),_e=h.Selection.isISelection(j)?P.Selection.to(j):P.Range.to(j),Be=[];for(const De of this._diagnostics.getDiagnostics(W))if(_e.intersection(De.range)&&Be.push(De)>R._maxCodeActionsPerFile)break;const fe={diagnostics:Be,only:te.only?new T.CodeActionKind(te.only):void 0,triggerKind:P.CodeActionTriggerKind.to(te.trigger)};return(0,y.asPromise)(()=>this._provider.provideCodeActions(de,_e,fe,oe)).then(De=>{var Re;if(!(!(0,i.isNonEmptyArray)(De)||oe.isCancellationRequested)){const He=this._cache.add(De),we=new d.DisposableStore;this._disposables.set(He,we);const qe=[];for(let z=0;z<De.length;z++){const ee=De[z];!ee||(R._isCommand(ee)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),qe.push({_isSynthetic:!0,title:ee.title,command:this._commands.toInternal(ee,we)})):(fe.only&&(ee.kind?fe.only.contains(ee.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action is of kind '${ee.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${fe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),qe.push({cacheId:[He,z],title:ee.title,command:ee.command&&this._commands.toInternal(ee.command,we),diagnostics:ee.diagnostics&&ee.diagnostics.map(P.Diagnostic.from),edit:ee.edit&&P.WorkspaceEdit.from(ee.edit),kind:ee.kind&&ee.kind.value,isPreferred:ee.isPreferred,disabled:(Re=ee.disabled)===null||Re===void 0?void 0:Re.reason})))}return{cacheId:He,actions:qe}}})}async resolveCodeAction(W,j){var te;const[oe,de]=W,_e=this._cache.get(oe,de);if(!(!_e||R._isCommand(_e))&&!!this._provider.resolveCodeAction){const Be=(te=await this._provider.resolveCodeAction(_e,j))!==null&&te!==void 0?te:_e;return(Be==null?void 0:Be.edit)?P.WorkspaceEdit.from(Be.edit):void 0}}releaseCodeActions(W){var j;(j=this._disposables.get(W))===null||j===void 0||j.dispose(),this._disposables.delete(W),this._cache.delete(W)}static _isCommand(W){return typeof W.command=="string"&&typeof W.title=="string"}}R._maxCodeActionsPerFile=1e3;class ${constructor(W,j){this._documents=W,this._provider=j}provideDocumentFormattingEdits(W,j,te){const oe=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentFormattingEdits(oe,j,te)).then(de=>{if(Array.isArray(de))return de.map(P.TextEdit.from)})}}class K{constructor(W,j){this._documents=W,this._provider=j}provideDocumentRangeFormattingEdits(W,j,te,oe){const de=this._documents.getDocument(W),_e=P.Range.to(j);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(de,_e,te,oe)).then(Be=>{if(Array.isArray(Be))return Be.map(P.TextEdit.from)})}}class he{constructor(W,j){this._documents=W,this._provider=j,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(W,j,te,oe,de){const _e=this._documents.getDocument(W),Be=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(_e,Be,te,oe,de)).then(fe=>{if(Array.isArray(fe))return fe.map(P.TextEdit.from)})}}class V{constructor(W,j){this._provider=W,this._logService=j,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(W,j){const te=D.IdObject.mixin({symbols:[]});return(0,y.asPromise)(()=>this._provider.provideWorkspaceSymbols(W,j)).then(oe=>{if((0,i.isNonEmptyArray)(oe)){for(const de of oe)if(!!de){if(!de.name){this._logService.warn("INVALID SymbolInformation, lacks name",de);continue}const _e=D.IdObject.mixin(P.WorkspaceSymbol.from(de));this._symbolCache.set(_e._id,de),te.symbols.push(_e)}}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol(W,j){if(typeof this._provider.resolveWorkspaceSymbol!="function")return W;const te=this._symbolCache.get(W._id);if(te){const oe=await(0,y.asPromise)(()=>this._provider.resolveWorkspaceSymbol(te,j));return oe&&(0,k.mixin)(W,P.WorkspaceSymbol.from(oe),!0)}}releaseWorkspaceSymbols(W){const j=this._resultCache.get(W);if(j){for(let[te,oe]=j;te<=oe;te++)this._symbolCache.delete(te);this._resultCache.delete(W)}}}class H{constructor(W,j,te){this._documents=W,this._provider=j,this._logService=te}static supportsResolving(W){return typeof W.prepareRename=="function"}provideRenameEdits(W,j,te,oe){const de=this._documents.getDocument(W),_e=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.provideRenameEdits(de,_e,te,oe)).then(Be=>{if(!!Be)return P.WorkspaceEdit.from(Be)},Be=>{const fe=H._asMessage(Be);return fe?{rejectReason:fe,edits:void 0}:Promise.reject(Be)})}resolveRenameLocation(W,j,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const oe=this._documents.getDocument(W),de=P.Position.to(j);return(0,y.asPromise)(()=>this._provider.prepareRename(oe,de,te)).then(_e=>{let Be,fe;if(T.Range.isRange(_e)?(Be=_e,fe=oe.getText(_e)):(0,I.isObject)(_e)&&(Be=_e.range,fe=_e.placeholder),!!Be){if(Be.start.line>de.line||Be.end.line<de.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Be),text:fe}}},_e=>{const Be=H._asMessage(_e);return Be?{rejectReason:Be,range:void 0,text:void 0}:Promise.reject(_e)})}static _asMessage(W){return typeof W=="string"?W:W instanceof Error&&typeof W.message=="string"?W.message:void 0}}class Y{constructor(W,j){this.resultId=W,this.tokens=j}}class U{constructor(W,j){this._documents=W,this._provider=j,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(W,j,te){const oe=this._documents.getDocument(W),de=j!==0?this._previousResults.get(j):null;return(0,y.asPromise)(()=>de&&typeof de.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(oe,de.resultId,te):this._provider.provideDocumentSemanticTokens(oe,te)).then(_e=>(de&&this._previousResults.delete(j),_e?(_e=U._fixProvidedSemanticTokens(_e),this._send(U._convertToEdits(de,_e),_e)):null))}async releaseDocumentSemanticColoring(W){this._previousResults.delete(W)}static _fixProvidedSemanticTokens(W){return U._isSemanticTokens(W)?U._isCorrectSemanticTokens(W)?W:new T.SemanticTokens(new Uint32Array(W.data),W.resultId):U._isSemanticTokensEdits(W)?U._isCorrectSemanticTokensEdits(W)?W:new T.SemanticTokensEdits(W.edits.map(j=>new T.SemanticTokensEdit(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),W.resultId):W}static _isSemanticTokens(W){return W&&!!W.data}static _isCorrectSemanticTokens(W){return W.data instanceof Uint32Array}static _isSemanticTokensEdits(W){return W&&Array.isArray(W.edits)}static _isCorrectSemanticTokensEdits(W){for(const j of W.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(W,j){if(!U._isSemanticTokens(j)||!W||!W.tokens)return j;const te=W.tokens,oe=te.length,de=j.data,_e=de.length;let Be=0;const fe=Math.min(oe,_e);for(;Be<fe&&te[Be]===de[Be];)Be++;if(Be===oe&&Be===_e)return new T.SemanticTokensEdits([],j.resultId);let De=0;const Re=fe-Be;for(;De<Re&&te[oe-De-1]===de[_e-De-1];)De++;return new T.SemanticTokensEdits([{start:Be,deleteCount:oe-Be-De,data:de.subarray(Be,_e-De)}],j.resultId)}_send(W,j){if(U._isSemanticTokens(W)){const te=this._nextResultId++;return this._previousResults.set(te,new Y(W.resultId,W.data)),(0,r.encodeSemanticTokensDto)({id:te,type:"full",data:W.data})}if(U._isSemanticTokensEdits(W)){const te=this._nextResultId++;return U._isSemanticTokens(j)?this._previousResults.set(te,new Y(j.resultId,j.data)):this._previousResults.set(te,new Y(W.resultId)),(0,r.encodeSemanticTokensDto)({id:te,type:"delta",deltas:(W.edits||[]).map(oe=>({start:oe.start,deleteCount:oe.deleteCount,data:oe.data}))})}return null}}e.DocumentSemanticTokensAdapter=U;class F{constructor(W,j){this._documents=W,this._provider=j}provideDocumentRangeSemanticTokens(W,j,te){const oe=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(oe,P.Range.to(j),te)).then(de=>de?this._send(de):null)}_send(W){return(0,r.encodeSemanticTokensDto)({id:0,type:"full",data:W.data})}}e.DocumentRangeSemanticTokensAdapter=F;class L{constructor(W,j,te,oe,de){this._documents=W,this._commands=j,this._provider=te,this._apiDeprecation=oe,this._extension=de,this._cache=new v.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(W){return typeof W.resolveCompletionItem=="function"}async provideCompletionItems(W,j,te,oe){const de=this._documents.getDocument(W),_e=P.Position.to(j),Be=de.getWordRangeAtPosition(_e)||new T.Range(_e,_e),fe=Be.with({end:_e}),De=new p.StopWatch(!0),Re=await(0,y.asPromise)(()=>this._provider.provideCompletionItems(de,_e,oe,P.CompletionContext.to(te)));if(!!Re&&!oe.isCancellationRequested){const He=Array.isArray(Re)?new T.CompletionList(Re):Re,we=L.supportsResolving(this._provider)?this._cache.add(He.items):this._cache.add([]),qe=new d.DisposableStore;this._disposables.set(we,qe);const z=[],ee={x:we,b:z,a:{replace:P.Range.from(Be),insert:P.Range.from(fe)},c:He.isIncomplete||void 0,d:De.elapsed()};for(let ge=0;ge<He.items.length;ge++){const Ne=He.items[ge],Ve=this._convertCompletionItem(Ne,[we,ge],fe,Be);z.push(Ve)}return ee}}async resolveCompletionItem(W,j){if(typeof this._provider.resolveCompletionItem=="function"){const te=this._cache.get(...W);if(!!te){const oe=await(0,y.asPromise)(()=>this._provider.resolveCompletionItem(te,j));if(!!oe)return this._convertCompletionItem(oe,W)}}}releaseCompletionItems(W){var j;(j=this._disposables.get(W))===null||j===void 0||j.dispose(),this._disposables.delete(W),this._cache.delete(W)}_convertCompletionItem(W,j,te,oe){var de;const _e=this._disposables.get(j[0]);if(!_e)throw Error("DisposableStore is missing...");const Be={x:j,a:(de=W.label)!==null&&de!==void 0?de:"",o:W.label2,b:W.kind!==void 0?P.CompletionItemKind.from(W.kind):void 0,n:W.tags&&W.tags.map(P.CompletionItemTag.from),c:W.detail,d:typeof W.documentation=="undefined"?void 0:P.MarkdownString.fromStrict(W.documentation),e:W.sortText!==W.label?W.sortText:void 0,f:W.filterText!==W.label?W.filterText:void 0,g:W.preselect||void 0,i:W.keepWhitespace?1:0,k:W.commitCharacters,l:W.additionalTextEdits&&W.additionalTextEdits.map(P.TextEdit.from),m:this._commands.toInternal(W.command,_e)};W.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Be.h=W.textEdit.newText):typeof W.insertText=="string"?Be.h=W.insertText:W.insertText instanceof T.SnippetString&&(Be.h=W.insertText.value,Be.i|=4);let fe;return W.textEdit?fe=W.textEdit.range:W.range&&(fe=W.range),T.Range.isRange(fe)?Be.j=P.Range.from(fe):fe&&(!(te==null?void 0:te.isEqual(fe.inserting))||!(oe==null?void 0:oe.isEqual(fe.replacing)))&&(Be.j={insert:P.Range.from(fe.inserting),replace:P.Range.from(fe.replacing)}),Be}}class M{constructor(W,j){this._documents=W,this._provider=j,this._cache=new v.Cache("SignatureHelp")}provideSignatureHelp(W,j,te,oe){const de=this._documents.getDocument(W),_e=P.Position.to(j),Be=this.reviveContext(te);return(0,y.asPromise)(()=>this._provider.provideSignatureHelp(de,_e,oe,Be)).then(fe=>{if(fe){const De=this._cache.add([fe]);return Object.assign(Object.assign({},P.SignatureHelp.from(fe)),{id:De})}})}reviveContext(W){let j;if(W.activeSignatureHelp){const te=P.SignatureHelp.to(W.activeSignatureHelp),oe=this._cache.get(W.activeSignatureHelp.id,0);oe?(j=oe,j.activeSignature=te.activeSignature,j.activeParameter=te.activeParameter):j=te}return Object.assign(Object.assign({},W),{activeSignatureHelp:j})}releaseSignatureHelp(W){this._cache.delete(W)}}class x{constructor(W,j){this._documents=W,this._provider=j}provideInlayHints(W,j,te){const oe=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideInlayHints(oe,P.Range.to(j),te)).then(de=>de?{hints:de.map(P.InlayHint.from)}:void 0)}}class G{constructor(W,j){this._documents=W,this._provider=j,this._cache=new v.Cache("DocumentLink")}provideLinks(W,j){const te=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentLinks(te,j)).then(oe=>{if(!(!Array.isArray(oe)||oe.length===0)&&!j.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:oe.map(P.DocumentLink.from)};{const de=this._cache.add(oe),_e={links:[],id:de};for(let Be=0;Be<oe.length;Be++){const fe=P.DocumentLink.from(oe[Be]);fe.cacheId=[de,Be],_e.links.push(fe)}return _e}}})}resolveLink(W,j){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const te=this._cache.get(...W);return te?(0,y.asPromise)(()=>this._provider.resolveDocumentLink(te,j)).then(oe=>oe&&P.DocumentLink.from(oe)||void 0):Promise.resolve(void 0)}releaseLinks(W){this._cache.delete(W)}}class X{constructor(W,j){this._documents=W,this._provider=j}provideColors(W,j){const te=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideDocumentColors(te,j)).then(oe=>Array.isArray(oe)?oe.map(_e=>({color:P.Color.from(_e.color),range:P.Range.from(_e.range)})):[])}provideColorPresentations(W,j,te){const oe=this._documents.getDocument(W),de=P.Range.to(j.range),_e=P.Color.to(j.color);return(0,y.asPromise)(()=>this._provider.provideColorPresentations(_e,{document:oe,range:de},te)).then(Be=>{if(!!Array.isArray(Be))return Be.map(P.ColorPresentation.from)})}}class ne{constructor(W,j){this._documents=W,this._provider=j}provideFoldingRanges(W,j,te){const oe=this._documents.getDocument(W);return(0,y.asPromise)(()=>this._provider.provideFoldingRanges(oe,j,te)).then(de=>{if(!!Array.isArray(de))return de.map(P.FoldingRange.from)})}}class me{constructor(W,j,te){this._documents=W,this._provider=j,this._logService=te}provideSelectionRanges(W,j,te){const oe=this._documents.getDocument(W),de=j.map(P.Position.to);return(0,y.asPromise)(()=>this._provider.provideSelectionRanges(oe,de,te)).then(_e=>{if(!(0,i.isNonEmptyArray)(_e))return[];if(_e.length!==de.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Be=[];for(let fe=0;fe<de.length;fe++){const De=[];Be.push(De);let Re=de[fe],He=_e[fe];for(;;){if(!He.range.contains(Re))throw new Error("INVALID selection range, must contain the previous range");if(De.push(P.SelectionRange.from(He)),!He.parent)break;Re=He.range,He=He.parent}}return Be})}}class Le{constructor(W,j){this._documents=W,this._provider=j,this._idPool=new o.IdGenerator(""),this._cache=new Map}async prepareSession(W,j,te){const oe=this._documents.getDocument(W),de=P.Position.to(j),_e=await this._provider.prepareCallHierarchy(oe,de,te);if(!!_e){const Be=this._idPool.nextId();return this._cache.set(Be,new Map),Array.isArray(_e)?_e.map(fe=>this._cacheAndConvertItem(Be,fe)):[this._cacheAndConvertItem(Be,_e)]}}async provideCallsTo(W,j,te){const oe=this._itemFromCache(W,j);if(!oe)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyIncomingCalls(oe,te);if(!!de)return de.map(_e=>({from:this._cacheAndConvertItem(W,_e.from),fromRanges:_e.fromRanges.map(Be=>P.Range.from(Be))}))}async provideCallsFrom(W,j,te){const oe=this._itemFromCache(W,j);if(!oe)throw new Error("missing call hierarchy item");const de=await this._provider.provideCallHierarchyOutgoingCalls(oe,te);if(!!de)return de.map(_e=>({to:this._cacheAndConvertItem(W,_e.to),fromRanges:_e.fromRanges.map(Be=>P.Range.from(Be))}))}releaseSession(W){this._cache.delete(W)}_cacheAndConvertItem(W,j){var te;const oe=this._cache.get(W),de={_sessionId:W,_itemId:oe.size.toString(36),name:j.name,detail:j.detail,kind:P.SymbolKind.from(j.kind),uri:j.uri,range:P.Range.from(j.range),selectionRange:P.Range.from(j.selectionRange),tags:(te=j.tags)===null||te===void 0?void 0:te.map(P.SymbolTag.from)};return oe.set(de._itemId,j),de}_itemFromCache(W,j){const te=this._cache.get(W);return te==null?void 0:te.get(j)}}class We{constructor(W,j){this.adapter=W,this.extension=j}}class Fe{constructor(W,j,te,oe,de,_e,Be){this._adapter=new Map,this._uriTransformer=j,this._proxy=W.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=oe,this._diagnostics=de,this._logService=_e,this._apiDeprecation=Be}_transformDocumentSelector(W){return(0,i.coalesce)((0,i.asArray)(W).map(j=>this._doTransformDocumentSelector(j)))}_doTransformDocumentSelector(W){if(typeof W=="string")return{$serialized:!0,language:W};if(W)return{$serialized:!0,language:W.language,scheme:this._transformScheme(W.scheme),pattern:typeof W.pattern=="undefined"?void 0:P.GlobPattern.from(W.pattern),exclusive:W.exclusive}}_transformScheme(W){return this._uriTransformer&&typeof W=="string"?this._uriTransformer.transformOutgoingScheme(W):W}_createDisposable(W){return new T.Disposable(()=>{this._adapter.delete(W),this._proxy.$unregister(W)})}_nextHandle(){return Fe._handlePool++}_withAdapter(W,j,te,oe,de=!1){const _e=this._adapter.get(W);if(!_e)return Promise.resolve(oe);if(_e.adapter instanceof j){let Be;_e.extension&&(Be=Date.now(),this._logService.trace(`[${_e.extension.identifier.value}] INVOKE provider '${j.name}'`));const fe=te(_e.adapter,_e.extension),De=_e.extension;return De&&Promise.resolve(fe).then(()=>this._logService.trace(`[${De.identifier.value}] provider DONE after ${Date.now()-Be}ms`),Re=>{de&&Re instanceof E.CancellationError||(this._logService.error(`[${De.identifier.value}] provider FAILED`),this._logService.error(Re))}),fe}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(W,j){const te=this._nextHandle();return this._adapter.set(te,new We(W,j)),te}static _extLabel(W){return W.displayName||W.name}registerDocumentSymbolProvider(W,j,te,oe){const de=this._addNewAdapter(new c(this._documents,te),W),_e=oe&&oe.label||Fe._extLabel(W);return this._proxy.$registerDocumentSymbolProvider(de,this._transformDocumentSelector(j),_e),this._createDisposable(de)}$provideDocumentSymbols(W,j,te){return this._withAdapter(W,c,oe=>oe.provideDocumentSymbols(b.URI.revive(j),te),void 0)}registerCodeLensProvider(W,j,te){const oe=this._nextHandle(),de=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(oe,new We(new l(this._documents,this._commands.converter,te),W)),this._proxy.$registerCodeLensSupport(oe,this._transformDocumentSelector(j),de);let _e=this._createDisposable(oe);if(de!==void 0){const Be=te.onDidChangeCodeLenses(fe=>this._proxy.$emitCodeLensEvent(de));_e=T.Disposable.from(_e,Be)}return _e}$provideCodeLenses(W,j,te){return this._withAdapter(W,l,oe=>oe.provideCodeLenses(b.URI.revive(j),te),void 0)}$resolveCodeLens(W,j,te){return this._withAdapter(W,l,oe=>oe.resolveCodeLens(j,te),void 0)}$releaseCodeLenses(W,j){this._withAdapter(W,l,te=>Promise.resolve(te.releaseCodeLenses(j)),void 0)}registerDefinitionProvider(W,j,te){const oe=this._addNewAdapter(new t(this._documents,te),W);return this._proxy.$registerDefinitionSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDefinition(W,j,te,oe){return this._withAdapter(W,t,de=>de.provideDefinition(b.URI.revive(j),te,oe),[])}registerDeclarationProvider(W,j,te){const oe=this._addNewAdapter(new n(this._documents,te),W);return this._proxy.$registerDeclarationSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDeclaration(W,j,te,oe){return this._withAdapter(W,n,de=>de.provideDeclaration(b.URI.revive(j),te,oe),[])}registerImplementationProvider(W,j,te){const oe=this._addNewAdapter(new a(this._documents,te),W);return this._proxy.$registerImplementationSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideImplementation(W,j,te,oe){return this._withAdapter(W,a,de=>de.provideImplementation(b.URI.revive(j),te,oe),[])}registerTypeDefinitionProvider(W,j,te){const oe=this._addNewAdapter(new s(this._documents,te),W);return this._proxy.$registerTypeDefinitionSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideTypeDefinition(W,j,te,oe){return this._withAdapter(W,s,de=>de.provideTypeDefinition(b.URI.revive(j),te,oe),[])}registerHoverProvider(W,j,te,oe){const de=this._addNewAdapter(new u(this._documents,te),W);return this._proxy.$registerHoverProvider(de,this._transformDocumentSelector(j)),this._createDisposable(de)}$provideHover(W,j,te,oe){return this._withAdapter(W,u,de=>de.provideHover(b.URI.revive(j),te,oe),void 0)}registerEvaluatableExpressionProvider(W,j,te,oe){const de=this._addNewAdapter(new g(this._documents,te),W);return this._proxy.$registerEvaluatableExpressionProvider(de,this._transformDocumentSelector(j)),this._createDisposable(de)}$provideEvaluatableExpression(W,j,te,oe){return this._withAdapter(W,g,de=>de.provideEvaluatableExpression(b.URI.revive(j),te,oe),void 0)}registerInlineValuesProvider(W,j,te,oe){const de=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,_e=this._addNewAdapter(new _(this._documents,te),W);this._proxy.$registerInlineValuesProvider(_e,this._transformDocumentSelector(j),de);let Be=this._createDisposable(_e);if(de!==void 0){const fe=te.onDidChangeInlineValues(De=>this._proxy.$emitInlineValuesEvent(de));Be=T.Disposable.from(Be,fe)}return Be}$provideInlineValues(W,j,te,oe,de){return this._withAdapter(W,_,_e=>_e.provideInlineValues(b.URI.revive(j),te,oe,de),void 0)}registerDocumentHighlightProvider(W,j,te){const oe=this._addNewAdapter(new A(this._documents,te),W);return this._proxy.$registerDocumentHighlightProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDocumentHighlights(W,j,te,oe){return this._withAdapter(W,A,de=>de.provideDocumentHighlights(b.URI.revive(j),te,oe),void 0)}registerLinkedEditingRangeProvider(W,j,te){const oe=this._addNewAdapter(new m(this._documents,te),W);return this._proxy.$registerLinkedEditingRangeProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideLinkedEditingRanges(W,j,te,oe){return this._withAdapter(W,m,async de=>{const _e=await de.provideLinkedEditingRanges(b.URI.revive(j),te,oe);if(_e)return{ranges:_e.ranges,wordPattern:_e.wordPattern?Fe._serializeRegExp(_e.wordPattern):void 0}},void 0)}registerReferenceProvider(W,j,te){const oe=this._addNewAdapter(new w(this._documents,te),W);return this._proxy.$registerReferenceSupport(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideReferences(W,j,te,oe,de){return this._withAdapter(W,w,_e=>_e.provideReferences(b.URI.revive(j),te,oe,de),void 0)}registerCodeActionProvider(W,j,te,oe){var de,_e;const Be=new d.DisposableStore,fe=this._addNewAdapter(new R(this._documents,this._commands.converter,this._diagnostics,te,this._logService,W,this._apiDeprecation),W);return this._proxy.$registerQuickFixSupport(fe,this._transformDocumentSelector(j),{providedKinds:(de=oe==null?void 0:oe.providedCodeActionKinds)===null||de===void 0?void 0:de.map(De=>De.value),documentation:(_e=oe==null?void 0:oe.documentation)===null||_e===void 0?void 0:_e.map(De=>({kind:De.kind.value,command:this._commands.converter.toInternal(De.command,Be)}))},Fe._extLabel(W),Boolean(te.resolveCodeAction)),Be.add(this._createDisposable(fe)),Be}$provideCodeActions(W,j,te,oe,de){return this._withAdapter(W,R,_e=>_e.provideCodeActions(b.URI.revive(j),te,oe,de),void 0)}$resolveCodeAction(W,j,te){return this._withAdapter(W,R,oe=>oe.resolveCodeAction(j,te),void 0)}$releaseCodeActions(W,j){this._withAdapter(W,R,te=>Promise.resolve(te.releaseCodeActions(j)),void 0)}registerDocumentFormattingEditProvider(W,j,te){const oe=this._addNewAdapter(new $(this._documents,te),W);return this._proxy.$registerDocumentFormattingSupport(oe,this._transformDocumentSelector(j),W.identifier,W.displayName||W.name),this._createDisposable(oe)}$provideDocumentFormattingEdits(W,j,te,oe){return this._withAdapter(W,$,de=>de.provideDocumentFormattingEdits(b.URI.revive(j),te,oe),void 0)}registerDocumentRangeFormattingEditProvider(W,j,te){const oe=this._addNewAdapter(new K(this._documents,te),W);return this._proxy.$registerRangeFormattingSupport(oe,this._transformDocumentSelector(j),W.identifier,W.displayName||W.name),this._createDisposable(oe)}$provideDocumentRangeFormattingEdits(W,j,te,oe,de){return this._withAdapter(W,K,_e=>_e.provideDocumentRangeFormattingEdits(b.URI.revive(j),te,oe,de),void 0)}registerOnTypeFormattingEditProvider(W,j,te,oe){const de=this._addNewAdapter(new he(this._documents,te),W);return this._proxy.$registerOnTypeFormattingSupport(de,this._transformDocumentSelector(j),oe,W.identifier),this._createDisposable(de)}$provideOnTypeFormattingEdits(W,j,te,oe,de,_e){return this._withAdapter(W,he,Be=>Be.provideOnTypeFormattingEdits(b.URI.revive(j),te,oe,de,_e),void 0)}registerWorkspaceSymbolProvider(W,j){const te=this._addNewAdapter(new V(j,this._logService),W);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols(W,j,te){return this._withAdapter(W,V,oe=>oe.provideWorkspaceSymbols(j,te),{symbols:[]})}$resolveWorkspaceSymbol(W,j,te){return this._withAdapter(W,V,oe=>oe.resolveWorkspaceSymbol(j,te),void 0)}$releaseWorkspaceSymbols(W,j){this._withAdapter(W,V,te=>te.releaseWorkspaceSymbols(j),void 0)}registerRenameProvider(W,j,te){const oe=this._addNewAdapter(new H(this._documents,te,this._logService),W);return this._proxy.$registerRenameSupport(oe,this._transformDocumentSelector(j),H.supportsResolving(te)),this._createDisposable(oe)}$provideRenameEdits(W,j,te,oe,de){return this._withAdapter(W,H,_e=>_e.provideRenameEdits(b.URI.revive(j),te,oe,de),void 0)}$resolveRenameLocation(W,j,te,oe){return this._withAdapter(W,H,de=>de.resolveRenameLocation(b.URI.revive(j),te,oe),void 0)}registerDocumentSemanticTokensProvider(W,j,te,oe){const de=this._nextHandle(),_e=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(de,new We(new U(this._documents,te),W)),this._proxy.$registerDocumentSemanticTokensProvider(de,this._transformDocumentSelector(j),oe,_e);let Be=this._createDisposable(de);if(_e){const fe=te.onDidChangeSemanticTokens(De=>this._proxy.$emitDocumentSemanticTokensEvent(_e));Be=T.Disposable.from(Be,fe)}return Be}$provideDocumentSemanticTokens(W,j,te,oe){return this._withAdapter(W,U,de=>de.provideDocumentSemanticTokens(b.URI.revive(j),te,oe),null,!0)}$releaseDocumentSemanticTokens(W,j){this._withAdapter(W,U,te=>te.releaseDocumentSemanticColoring(j),void 0)}registerDocumentRangeSemanticTokensProvider(W,j,te,oe){const de=this._addNewAdapter(new F(this._documents,te),W);return this._proxy.$registerDocumentRangeSemanticTokensProvider(de,this._transformDocumentSelector(j),oe),this._createDisposable(de)}$provideDocumentRangeSemanticTokens(W,j,te,oe){return this._withAdapter(W,F,de=>de.provideDocumentRangeSemanticTokens(b.URI.revive(j),te,oe),null,!0)}registerCompletionItemProvider(W,j,te,oe){const de=this._addNewAdapter(new L(this._documents,this._commands.converter,te,this._apiDeprecation,W),W);return this._proxy.$registerSuggestSupport(de,this._transformDocumentSelector(j),oe,L.supportsResolving(te),`${W.identifier.value}(${oe.join("")})`),this._createDisposable(de)}$provideCompletionItems(W,j,te,oe,de){return this._withAdapter(W,L,_e=>_e.provideCompletionItems(b.URI.revive(j),te,oe,de),void 0)}$resolveCompletionItem(W,j,te){return this._withAdapter(W,L,oe=>oe.resolveCompletionItem(j,te),void 0)}$releaseCompletionItems(W,j){this._withAdapter(W,L,te=>te.releaseCompletionItems(j),void 0)}registerSignatureHelpProvider(W,j,te,oe){const de=Array.isArray(oe)?{triggerCharacters:oe,retriggerCharacters:[]}:oe,_e=this._addNewAdapter(new M(this._documents,te),W);return this._proxy.$registerSignatureHelpProvider(_e,this._transformDocumentSelector(j),de),this._createDisposable(_e)}$provideSignatureHelp(W,j,te,oe,de){return this._withAdapter(W,M,_e=>_e.provideSignatureHelp(b.URI.revive(j),te,oe,de),void 0)}$releaseSignatureHelp(W,j){this._withAdapter(W,M,te=>te.releaseSignatureHelp(j),void 0)}registerInlayHintsProvider(W,j,te){const oe=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,de=this._addNewAdapter(new x(this._documents,te),W);this._proxy.$registerInlayHintsProvider(de,this._transformDocumentSelector(j),oe);let _e=this._createDisposable(de);if(oe!==void 0){const Be=te.onDidChangeInlayHints(fe=>this._proxy.$emitInlayHintsEvent(oe));_e=T.Disposable.from(_e,Be)}return _e}$provideInlayHints(W,j,te,oe){return this._withAdapter(W,x,de=>de.provideInlayHints(b.URI.revive(j),te,oe),void 0)}registerDocumentLinkProvider(W,j,te){const oe=this._addNewAdapter(new G(this._documents,te),W);return this._proxy.$registerDocumentLinkProvider(oe,this._transformDocumentSelector(j),typeof te.resolveDocumentLink=="function"),this._createDisposable(oe)}$provideDocumentLinks(W,j,te){return this._withAdapter(W,G,oe=>oe.provideLinks(b.URI.revive(j),te),void 0)}$resolveDocumentLink(W,j,te){return this._withAdapter(W,G,oe=>oe.resolveLink(j,te),void 0)}$releaseDocumentLinks(W,j){this._withAdapter(W,G,te=>te.releaseLinks(j),void 0)}registerColorProvider(W,j,te){const oe=this._addNewAdapter(new X(this._documents,te),W);return this._proxy.$registerDocumentColorProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideDocumentColors(W,j,te){return this._withAdapter(W,X,oe=>oe.provideColors(b.URI.revive(j),te),[])}$provideColorPresentations(W,j,te,oe){return this._withAdapter(W,X,de=>de.provideColorPresentations(b.URI.revive(j),te,oe),void 0)}registerFoldingRangeProvider(W,j,te){const oe=this._nextHandle(),de=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(oe,new We(new ne(this._documents,te),W)),this._proxy.$registerFoldingRangeProvider(oe,this._transformDocumentSelector(j),de);let _e=this._createDisposable(oe);if(de!==void 0){const Be=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(de));_e=T.Disposable.from(_e,Be)}return _e}$provideFoldingRanges(W,j,te,oe){return this._withAdapter(W,ne,de=>de.provideFoldingRanges(b.URI.revive(j),te,oe),void 0)}registerSelectionRangeProvider(W,j,te){const oe=this._addNewAdapter(new me(this._documents,te,this._logService),W);return this._proxy.$registerSelectionRangeProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$provideSelectionRanges(W,j,te,oe){return this._withAdapter(W,me,de=>de.provideSelectionRanges(b.URI.revive(j),te,oe),[])}registerCallHierarchyProvider(W,j,te){const oe=this._addNewAdapter(new Le(this._documents,te),W);return this._proxy.$registerCallHierarchyProvider(oe,this._transformDocumentSelector(j)),this._createDisposable(oe)}$prepareCallHierarchy(W,j,te,oe){return this._withAdapter(W,Le,de=>Promise.resolve(de.prepareSession(b.URI.revive(j),te,oe)),void 0)}$provideCallHierarchyIncomingCalls(W,j,te,oe){return this._withAdapter(W,Le,de=>de.provideCallsTo(j,te,oe),void 0)}$provideCallHierarchyOutgoingCalls(W,j,te,oe){return this._withAdapter(W,Le,de=>de.provideCallsFrom(j,te,oe),void 0)}$releaseCallHierarchy(W,j){this._withAdapter(W,Le,te=>Promise.resolve(te.releaseSession(j)),void 0)}static _serializeRegExp(W){return{pattern:W.source,flags:(0,S.regExpFlags)(W)}}static _serializeIndentationRule(W){return{decreaseIndentPattern:Fe._serializeRegExp(W.decreaseIndentPattern),increaseIndentPattern:Fe._serializeRegExp(W.increaseIndentPattern),indentNextLinePattern:W.indentNextLinePattern?Fe._serializeRegExp(W.indentNextLinePattern):void 0,unIndentedLinePattern:W.unIndentedLinePattern?Fe._serializeRegExp(W.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(W){return{beforeText:Fe._serializeRegExp(W.beforeText),afterText:W.afterText?Fe._serializeRegExp(W.afterText):void 0,previousLineText:W.previousLineText?Fe._serializeRegExp(W.previousLineText):void 0,action:W.action}}static _serializeOnEnterRules(W){return W.map(Fe._serializeOnEnterRule)}setLanguageConfiguration(W,j,te){let{wordPattern:oe}=te;if(oe&&(0,S.regExpLeadsToEndlessLoop)(oe))throw new Error(`Invalid language configuration: wordPattern '${oe}' is not allowed to match the empty string.`);oe?this._documents.setWordDefinitionFor(j,oe):this._documents.setWordDefinitionFor(j,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",W,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",W,"Do not use.");const de=this._nextHandle(),_e={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?Fe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?Fe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?Fe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(de,j,_e),this._createDisposable(de)}$setWordDefinitions(W){for(const j of W)this._documents.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.ExtHostLanguageFeatures=Fe,Fe._handlePool=0}),define(ve[199],be([0,1,5,9,7]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(D,S){this._proxy=D.getProxy(b.MainContext.MainThreadLanguages),this._documents=S}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,S){await this._proxy.$changeLanguage(D,S);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,S){var C;const i=D.version,I=k.Position.from(S),h=await this._proxy.$tokensAtPosition(D.uri,I),d={type:P.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(S))!==null&&C!==void 0?C:new P.Range(S.line,S.character,S.line,S.character)};if(!h)return d;const r={range:k.Range.to(h.range),type:k.TokenType.to(h.type)};return!r.range.contains(S)||i!==D.version?d:r}}e.ExtHostLanguages=T}),define(ve[200],be([0,1,5,18,33]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(D){return D&&D.title}let y=class{constructor(S,C){this._logService=C,this._proxy=S.getProxy(b.MainContext.MainThreadMessageService)}showMessage(S,C,i,I,h){const d={extension:S};let r;typeof I=="string"||T(I)?r=[I,...h]:(d.modal=I&&I.modal,d.useCustom=I&&I.useCustom,r=h),d.useCustom&&(0,P.checkProposedApiEnabled)(S);const o=[];for(let v=0;v<r.length;v++){const p=r[v];if(typeof p=="string")o.push({title:p,handle:v,isCloseAffordance:!1});else if(typeof p=="object"){let{title:E,isCloseAffordance:c}=p;o.push({title:E,isCloseAffordance:!!c,handle:v})}else this._logService.warn("Invalid message item:",p)}return this._proxy.$showMessage(C,i,d,o).then(v=>{if(typeof v=="number")return r[v]})}};y=je([Ke(1,k.ILogService)],y),e.ExtHostMessageService=y}),define(ve[201],be([0,1,24,3,56,54,6,22,8,10,2,68,5,9,7,73,178,179]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class E{constructor(f,t){const n=E._Keys.nextId();f.$registerNotebookEditorDecorationType(n,d.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){f.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=E,E._Keys=new T.IdGenerator("NotebookEditorDecorationType");class c{constructor(f,t,n,a,s,u){this._textDocumentsAndEditors=n,this._textDocuments=a,this.logService=s,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new k.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new k.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new k.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new k.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new k.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=f.getProxy(h.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=f.getProxy(h.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=f.getProxy(h.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:g=>{var _;if(g&&g.$mid===12){const A=(_=g.notebookEditor)===null||_===void 0?void 0:_.notebookUri,m=g.cell.handle,w=this._documents.get(A),R=w==null?void 0:w.getCell(m);if(R)return R.apiCell}return g}})}get activeNotebookEditor(){var f;return(f=this._activeNotebookEditor)===null||f===void 0?void 0:f.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(f=>f.apiEditor)}getEditorById(f){return this._editors.get(f)}getIdByEditor(f){for(const[t,n]of this._editors)if(n.apiEditor===f)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(f,t){const n=this._documents.get(f);if(!n&&!t)throw new Error(`NO notebook document for '${f}'`);return n}_getProviderData(f){const t=this._notebookContentProviders.get(f);if(!t)throw new Error(`NO provider for '${f}'`);return t}registerNotebookContentProvider(f,t,n,a,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:f,provider:n});let u;return n.onDidChangeNotebookContentOptions&&(u=n.onDidChangeNotebookContentOptions(()=>{const g=d.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,g)})),this._notebookProxy.$registerNotebookProvider({id:f.identifier,location:f.extensionLocation},t,d.NotebookDocumentContentOptions.from(a),c._convertNotebookRegistrationData(f,s)),new r.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(f,t){if(!!t){const n=t.filenamePattern.map(a=>d.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}}registerNotebookCellStatusBarItemProvider(f,t,n){const a=c._notebookStatusBarItemProviderHandlePool++,s=typeof n.onDidChangeCellStatusBarItems=="function"?c._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,s,t);let u;return s!==void 0&&(u=n.onDidChangeCellStatusBarItems(g=>this._notebookProxy.$emitCellStatusBarEvent(s))),new r.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,s),u&&u.dispose()})}createNotebookEditorDecorationType(f){return new E(this._notebookEditorsProxy,f).value}async openNotebookDocument(f){const t=this._documents.get(f);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenDocument(f),a=this._documents.get(i.URI.revive(n));return(0,C.assertIsDefined)(a==null?void 0:a.apiNotebook)}async showNotebookDocument(f,t){var n;i.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let a;typeof t=="object"?a={position:d.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(d.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:a={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(f.uri,f.viewType,a),u=s&&((n=this._editors.get(s))===null||n===void 0?void 0:n.apiEditor);if(u)return u;throw s?new Error(`Could NOT open editor for "${f.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.toString()}".`)}async $provideNotebookCellStatusBarItems(f,t,n,a){var s;const u=this._notebookStatusBarItemProviders.get(f),g=i.URI.revive(t),_=this._documents.get(g);if(!(!_||!u)){const A=_.getCellFromIndex(n);if(!!A){const m=await u.provideCellStatusBarItems(A.apiCell,a);if(!!m){const w=new y.DisposableStore,R=this._statusBarCache.add([w]),$=(s=m&&m.map(K=>d.NotebookStatusBarItem.from(K,this._commandsConverter,w)))!==null&&s!==void 0?s:void 0;return{cacheId:R,items:$}}}}}$releaseNotebookCellStatusBarItems(f){this._statusBarCache.delete(f)}registerNotebookSerializer(f,t,n,a,s){if((0,S.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,n),this._notebookProxy.$registerNotebookSerializer(u,{id:f.identifier,location:f.extensionLocation},t,d.NotebookDocumentContentOptions.from(a),c._convertNotebookRegistrationData(f,s)),(0,y.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(f,t,n){const a=this._notebookSerializer.get(f);if(!a)throw new Error("NO serializer found");const s=await a.deserializeNotebook(t.buffer,n);return{metadata:d.NotebookDocumentMetadata.from(s.metadata),cells:s.cells.map(d.NotebookCellData.from)}}async $notebookToData(f,t,n){const a=this._notebookSerializer.get(f);if(!a)throw new Error("NO serializer found");const s=await a.serializeNotebook({metadata:d.NotebookDocumentMetadata.to(t.metadata),cells:t.cells.map(d.NotebookCellData.to)},n);return b.VSBuffer.wrap(s)}async $openNotebook(f,t,n,a,s){const{provider:u}=this._getProviderData(f),g=await u.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:a==null?void 0:a.buffer},s);return{metadata:d.NotebookDocumentMetadata.from(g.metadata),cells:g.cells.map(d.NotebookCellData.from)}}async $saveNotebook(f,t,n){const a=this.getNotebookDocument(i.URI.revive(t)),{provider:s}=this._getProviderData(f);return await s.saveNotebook(a.apiNotebook,n),!0}async $saveNotebookAs(f,t,n,a){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:u}=this._getProviderData(f);return await u.saveNotebookAs(i.URI.revive(n),s.apiNotebook,a),!0}async $backupNotebook(f,t,n){var a;const s=this.getNotebookDocument(i.URI.revive(t)),u=this._getProviderData(f),g=(a=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&a!==void 0?a:this._extensionStoragePaths.globalValue(u.extension),_=String((0,P.hash)([s.uri.toString(),this._backupIdPool++])),A=i.URI.joinPath(g,_),m=await u.provider.backupNotebook(s.apiNotebook,{destination:A},n);return s.updateBackup(m),m.id}$acceptModelChanged(f,t,n){this.getNotebookDocument(i.URI.revive(f)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(f,t){const n=this.getNotebookDocument(i.URI.revive(f));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(f){const t=this.getNotebookDocument(i.URI.revive(f));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",f,t);const n=this._editors.get(f);if(!n)throw new Error(`unknown text editor: ${f}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(d.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(d.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(f){for(const t in f){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(d.ViewColumn.to(f[t]))}}$acceptDocumentPropertiesChanged(f,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",f.path,t);const n=this.getNotebookDocument(i.URI.revive(f));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(f,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const a=new p.ExtHostNotebookEditor(t,this._notebookEditorsProxy,f,n.visibleRanges.map(d.NotebookRange.to),n.selections.map(d.NotebookRange.to),typeof n.viewColumn=="number"?d.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,a)}$acceptDocumentAndEditorsDelta(f){var t,n,a;if(f.removedDocuments)for(const u of f.removedDocuments){const g=i.URI.revive(u),_=this._documents.get(g);_&&(_.dispose(),this._documents.delete(g),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:_.apiNotebook.getCells().map(A=>A.document.uri)}),this._onDidCloseNotebookDocument.fire(_.apiNotebook));for(const A of this._editors.values())A.notebookData.uri.toString()===g.toString()&&this._editors.delete(A.id)}if(f.addedDocuments){const u=[];for(const g of f.addedDocuments){const _=i.URI.revive(g.uri),A=g.viewType;if(this._documents.has(_))throw new Error(`adding EXISTING notebook ${_} `);const m=this,w=new v.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(R){m._onDidChangeNotebookCells.fire(R)},emitCellOutputsChange(R){m._onDidChangeCellOutputs.fire(R)},emitCellMetadataChange(R){m._onDidChangeCellMetadata.fire(R)},emitCellExecutionStateChange(R){m._onDidChangeCellExecutionState.fire(R)}},A,g.metadata?d.NotebookDocumentMetadata.to(g.metadata):new r.NotebookDocumentMetadata,_);w.acceptModelChanged({versionId:g.versionId,rawEvents:[{kind:o.NotebookCellsChangeType.Initialize,changes:[[0,0,g.cells]]}]},!1),u.push(...g.cells.map(R=>v.ExtHostCell.asModelAddData(w.apiNotebook,R))),(t=this._documents.get(_))===null||t===void 0||t.dispose(),this._documents.set(_,w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(w.apiNotebook)}}if(f.addedEditors)for(const u of f.addedEditors){if(this._editors.has(u.id))return;const g=i.URI.revive(u.documentUri),_=this._documents.get(g);_&&this._createExtHostEditor(_,u.id,u)}const s=[];if(f.removedEditors)for(const u of f.removedEditors){const g=this._editors.get(u);g&&(this._editors.delete(u),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===g.id&&(this._activeNotebookEditor=void 0),s.push(g))}if(f.visibleEditors){this._visibleNotebookEditors=f.visibleEditors.map(g=>this._editors.get(g)).filter(g=>!!g);const u=new Set;this._visibleNotebookEditors.forEach(g=>u.add(g.id));for(const g of this._editors.values()){const _=u.has(g.id);g._acceptVisibility(_)}this._visibleNotebookEditors=[...this._editors.values()].map(g=>g).filter(g=>g.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}f.newActiveEditor===null?this._activeNotebookEditor=void 0:f.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(f.newActiveEditor)),f.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((a=this._activeNotebookEditor)===null||a===void 0?void 0:a.apiEditor)}}e.ExtHostNotebookController=c,c._notebookStatusBarItemProviderHandlePool=0}),define(ve[202],be([0,1,3,6,5,26,2,9,72,22,11,20,7,13]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;class r{constructor(c,l,f){this._mainContext=c,this._initData=l,this._extHostNotebook=f,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=c.getProxy(P.MainContext.MainThreadNotebookKernels)}createNotebookController(c,l,f,t,n,a){for(let U of this._kernelData.values())if(U.controller.id===l&&T.ExtensionIdentifier.equals(c.identifier,U.extensionId))throw new Error(`notebook controller with id '${l}' ALREADY exist`);const s=this._handlePool++,u=this,g=()=>console.warn(`NO execute handler from notebook controller '${R.id}' of extension: '${c.identifier}'`);let _=!1;const A=new k.DisposableStore,m=new b.Emitter,w=new b.Emitter,R={id:`${c.identifier.value}/${l}`,viewType:f,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:t||c.identifier.value,preloads:a?a.map(D.NotebookKernelPreload.from):[]};let $=n!=null?n:g,K;this._proxy.$addKernel(s,R).catch(U=>{console.log(U),_=!0});let he=0;const V=()=>{if(!_){const U=++he;Promise.resolve().then(()=>{U===he&&this._proxy.$updateKernel(s,R)})}},H=new C.ResourceMap,Y={get id(){return l},get viewType(){return R.viewType},onDidChangeNotebookAssociation:m.event,get label(){return R.label},set label(U){var F;R.label=(F=U!=null?U:c.displayName)!==null&&F!==void 0?F:c.name,V()},get detail(){var U;return(U=R.detail)!==null&&U!==void 0?U:""},set detail(U){R.detail=U,V()},get description(){var U;return(U=R.description)!==null&&U!==void 0?U:""},set description(U){R.description=U,V()},get supportedLanguages(){return R.supportedLanguages},set supportedLanguages(U){R.supportedLanguages=U,V()},get hasExecutionOrder(){var U;return(U=R.hasExecutionOrder)!==null&&U!==void 0?U:!1},set hasExecutionOrder(U){R.hasExecutionOrder=U,V()},get preloads(){return R.preloads?R.preloads.map(D.NotebookKernelPreload.to):[]},get executeHandler(){return $},set executeHandler(U){$=U!=null?U:g},get interruptHandler(){return K},set interruptHandler(U){K=U,R.supportsInterrupt=Boolean(U),V()},createNotebookCellExecutionTask(U){if(_)throw new Error("notebook controller is DISPOSED");if(!H.has(U.notebook.uri))throw new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return u._createNotebookCellExecution(U)},dispose:()=>{_||(_=!0,this._kernelData.delete(s),A.dispose(),m.dispose(),w.dispose(),this._proxy.$removeKernel(s))},onDidReceiveMessage:w.event,postMessage(U,F){return u._proxy.$postMessage(s,F&&u._extHostNotebook.getIdByEditor(F),U)},asWebviewUri(U){return(0,S.asWebviewUri)(u._initData.environment,String(s),U)},updateNotebookAffinity(U,F){u._proxy.$updateNotebookPriority(s,U.uri,F)}};return this._kernelData.set(s,{extensionId:c.identifier,controller:Y,onDidReceiveMessage:w,onDidChangeSelection:m,associatedNotebooks:H}),Y}$acceptNotebookAssociation(c,l,f){const t=this._kernelData.get(c);if(t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));f?t.associatedNotebooks.set(n.uri,!0):t.associatedNotebooks.delete(n.uri),t.onDidChangeSelection.fire({selected:f,notebook:n.apiNotebook})}}async $executeCells(c,l,f){const t=this._kernelData.get(c);if(!!t){const n=this._extHostNotebook.getNotebookDocument(y.URI.revive(l)),a=[];for(let s of f){const u=n.getCell(s);u&&a.push(u.apiCell)}try{await t.controller.executeHandler.call(t.controller,a,n.apiNotebook,t.controller)}catch(s){console.error(s)}}}async $cancelCells(c,l,f){var t;const n=this._kernelData.get(c);if(!!n){const a=this._extHostNotebook.getNotebookDocument(y.URI.revive(l));n.controller.interruptHandler&&await n.controller.interruptHandler.call(n.controller,a.apiNotebook);for(let s of f){const u=a.getCell(s);u&&((t=this._activeExecutions.get(u.uri))===null||t===void 0||t.cancel())}}}$acceptKernelMessageFromRenderer(c,l,f){const t=this._kernelData.get(c);if(!!t){const n=this._extHostNotebook.getEditorById(l);if(!n)throw new Error(`send message for UNKNOWN editor: ${l}`);t.onDidReceiveMessage.fire(Object.freeze({editor:n.apiEditor,message:f}))}}_createNotebookCellExecution(c){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this._extHostNotebook.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!f)throw new Error("invalid cell");if(this._activeExecutions.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const t=new v(f.notebook,f,this._mainContext.getProxy(P.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(f.uri,t);const n=t.onDidChangeState(()=>{t.state===o.Resolved&&(t.dispose(),n.dispose(),this._activeExecutions.delete(f.uri))});return t.asApiObject()}}e.ExtHostNotebookKernels=r;var o;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(o||(o={}));class v extends k.Disposable{constructor(c,l,f){super();this._document=c,this._cell=l,this._proxy=f,this._onDidChangeState=new b.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=o.Init,this._tokenSource=this._register(new I.CancellationTokenSource),this._collector=new p(10,t=>this.applyEdits(t)),this._executionOrder=l.internalMetadata.executionOrder,this.mixinMetadata({runState:h.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(c){await this._collector.addItem(c)}async applyEdits(c){return this._proxy.$applyEdits(this._document.uri,c,!1)}verifyStateForOutput(){if(this._state===o.Init)throw new Error("Must call start before modifying cell output");if(this._state===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(c){const l={editType:8,handle:this._cell.handle,metadata:c};this.applyEdits([l])}cellIndexToHandle(c){if(typeof c!="number")return this._cell.handle;const l=this._document.getCellFromIndex(c);if(!l)throw new Error("INVALID cell index");return l.handle}asApiObject(){const c=this;return Object.freeze({get document(){return c._document.apiNotebook},get cell(){return c._cell.apiCell},get executionOrder(){return c._executionOrder},set executionOrder(l){c._executionOrder=l,c.mixinMetadata({executionOrder:l})},start(l){var f;if(c._state===o.Resolved||c._state===o.Started)throw new Error("Cannot call start again");c._state=o.Started,c._onDidChangeState.fire(),c.mixinMetadata({runState:h.NotebookCellExecutionState.Executing,runStartTime:(f=l==null?void 0:l.startTime)!==null&&f!==void 0?f:null})},end(l){var f,t;if(c._state===o.Resolved)throw new Error("Cannot call resolve twice");c._state=o.Resolved,c._onDidChangeState.fire(),c.mixinMetadata({runState:h.NotebookCellExecutionState.Idle,lastRunSuccess:(f=l==null?void 0:l.success)!==null&&f!==void 0?f:null,runEndTime:(t=l==null?void 0:l.endTime)!==null&&t!==void 0?t:null})},clearOutput(l){return c.verifyStateForOutput(),this.replaceOutput([],l)},async appendOutput(l,f){c.verifyStateForOutput();const t=c.cellIndexToHandle(f);return l=(0,d.asArray)(l),c.applyEditSoon({editType:2,handle:t,append:!0,outputs:l.map(D.NotebookCellOutput.from)})},async replaceOutput(l,f){c.verifyStateForOutput();const t=c.cellIndexToHandle(f);return l=(0,d.asArray)(l),c.applyEditSoon({editType:2,handle:t,outputs:l.map(D.NotebookCellOutput.from)})},async appendOutputItems(l,f){return c.verifyStateForOutput(),l=(0,d.asArray)(l),c.applyEditSoon({editType:7,append:!0,items:l.map(D.NotebookCellOutputItem.from),outputId:f})},async replaceOutputItems(l,f){return c.verifyStateForOutput(),l=(0,d.asArray)(l),c.applyEditSoon({editType:7,items:l.map(D.NotebookCellOutputItem.from),outputId:f})},token:c._tokenSource.token})}}class p{constructor(c,l){this.delay=c,this.callback=l,this.batch=[]}addItem(c){return this.batch.push(c),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const l=this.batch;return this.batch=[],this.callback(l)})),this.waitPromise}}}),define(ve[100],be([0,1,5,3,6,24,4,15]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class S extends P.Disposable{constructor(r,o,v,p){super();this._onDidAppend=this._register(new k.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=r,this._proxy=p,this._id=p.$register(this.name,o,v),this._disposed=!1,this._offset=0}get name(){return this._name}append(r){this.validate(),this._offset+=r?T.VSBuffer.fromString(r).byteLength:0}update(){this._id.then(r=>this._proxy.$update(r))}appendLine(r){this.validate(),this.append(r+`
`)}clear(){this.validate();const r=this._offset;this._id.then(o=>this._proxy.$clear(o,r))}show(r,o){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof r=="boolean"?r:o)))}hide(){this.validate(),this._id.then(r=>this._proxy.$close(r))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(r=>this._proxy.$dispose(r)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=S;class C extends S{constructor(r,o){super(r,!1,void 0,o)}append(r){super.append(r),this._id.then(o=>this._proxy.$append(o,r)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class i extends S{constructor(r,o,v){super(r,!0,o,v)}append(r){throw new Error("Not supported")}}class I{constructor(r,o){this.name=r,this._channel=o}append(r){this._channel.then(o=>o.append(r))}appendLine(r){this._channel.then(o=>o.appendLine(r))}clear(){this._channel.then(r=>r.clear())}show(r,o){this._channel.then(v=>v.show(r,o))}hide(){this._channel.then(r=>r.hide())}dispose(){this._channel.then(r=>r.dispose())}}e.LazyOutputChannel=I;let h=class{constructor(r){this._proxy=r.getProxy(b.MainContext.MainThreadOutputService)}$setVisibleChannel(r){}createOutputChannel(r){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");return new C(r,this._proxy)}createOutputChannelFromLogFile(r,o){if(r=r.trim(),!r)throw new Error("illegal argument `name`. must not be falsy");if(!o)throw new Error("illegal argument `file`. must not be falsy");return new i(r,o,this._proxy)}};h=je([Ke(0,D.IExtHostRpcService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,y.createDecorator)("IExtHostOutputService")}),define(ve[203],be([0,1,11,20,3,6,5,2,7,12,13,47]),function(J,e,b,k,P,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function h(d,r,o){const v=d.getProxy(y.MainContext.MainThreadQuickOpen);class p{constructor(s,u){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=u}showQuickPick(s,u,g,_=k.CancellationToken.None){this._onDidSelectItem=void 0;const A=Promise.resolve(s),m=++this._instances,w=v.$show(m,{title:g==null?void 0:g.title,placeHolder:g==null?void 0:g.placeHolder,matchOnDescription:g==null?void 0:g.matchOnDescription,matchOnDetail:g==null?void 0:g.matchOnDetail,ignoreFocusLost:g==null?void 0:g.ignoreFocusOut,canPickMany:g==null?void 0:g.canPickMany},_),R={},$=w.then(()=>R);return Promise.race([$,A]).then(K=>{if(K!==R)return A.then(he=>{const V=[];for(let H=0;H<he.length;H++){const Y=he[H];let U,F,L,M,x;typeof Y=="string"?U=Y:(U=Y.label,F=Y.description,L=Y.detail,M=Y.picked,x=Y.alwaysShow),V.push({label:U,description:F,handle:H,detail:L,picked:M,alwaysShow:x})}return g&&typeof g.onDidSelectItem=="function"&&(this._onDidSelectItem=H=>{g.onDidSelectItem(he[H])}),v.$setItems(m,V),w.then(H=>{if(typeof H=="number")return he[H];if(Array.isArray(H))return H.map(Y=>he[Y])})})}).then(void 0,K=>{if(!(0,C.isPromiseCanceledError)(K))return v.$setError(m,K),Promise.reject(K)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,u=k.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,v.$input(s,typeof this._validateInput=="function",u).then(void 0,g=>{if(!(0,C.isPromiseCanceledError)(g))return Promise.reject(g)})}$validateInput(s){return this._validateInput?(0,b.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,u=k.CancellationToken.None){const g=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!!g){const _=await this._workspace.getWorkspaceFolders2();if(!!_)return _.find(A=>A.uri.toString()===g.uri.toString())}}createQuickPick(s,u){const g=new t(s,u,()=>this._sessions.delete(g._id));return this._sessions.set(g._id,g),g}createInputBox(s){const u=new n(s,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(s,u){const g=this._sessions.get(s);g&&g._fireDidChangeValue(u)}$onDidAccept(s){const u=this._sessions.get(s);u&&u._fireDidAccept()}$onDidChangeActive(s,u){const g=this._sessions.get(s);g instanceof t&&g._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const g=this._sessions.get(s);g instanceof t&&g._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){const g=this._sessions.get(s);g&&g._fireDidTriggerButton(u)}$onDidHide(s){const u=this._sessions.get(s);u&&u._fireDidHide()}}class E{constructor(s,u){this._extensionId=s,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new P.Emitter,this._onDidChangeValueEmitter=new P.Emitter,this._onDidTriggerButtonEmitter=new P.Emitter,this._onDidHideEmitter=new P.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((u,g)=>{const _=u===S.QuickInputButtons.Back?-1:g;this._handlesToButtons.set(_,u)}),this.update({buttons:s.map((u,g)=>({iconPath:c(u.iconPath),tooltip:u.tooltip,handle:u===S.QuickInputButtons.Back?-1:g}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const u=this._handlesToButtons.get(s);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),v.$dispose(this._id))}update(s){if(!this._disposed){for(const u of Object.keys(s)){const g=s[u];this._pendingUpdate[u]=g===void 0?null:g}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){v.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}E._nextId=1;function c(a){if(a instanceof S.ThemeIcon)return{id:a.id};const s=f(a),u=l(a);return{dark:typeof s=="string"?D.URI.file(s):s,light:typeof u=="string"?D.URI.file(u):u}}function l(a){return typeof a=="object"&&"light"in a?a.light:a}function f(a){return typeof a=="object"&&"dark"in a?a.dark:a}class t extends E{constructor(s,u,g){super(s,g);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new P.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new P.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,g)=>{this._handlesToItems.set(g,u),this._itemsToHandles.set(u,g)}),this.update({items:s.map((u,g)=>({label:u.label,description:u.description,handle:g,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(s){const u=(0,i.coalesce)(s.map(g=>this._handlesToItems.get(g)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(s){const u=(0,i.coalesce)(s.map(g=>this._handlesToItems.get(g)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends E{constructor(s,u){super(s,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new p(r,o)}e.createExtHostQuickOpen=h}),define(ve[204],be([0,1,2,3,52,6,11,5,13,112,18,26,33]),function(J,e,b,k,P,T,y,D,S,C,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function d(s){if(s)return typeof s.iconPath=="string"?b.URI.file(s.iconPath):s.iconPath}function r(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const g=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,_=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,C.comparePaths)(g,_)}function o(s,u){let g=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(g=r(s,u),g!==0)return g;if(s.light&&u.light)g=r(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(g!==0)return g;if(s.dark&&u.dark)g=r(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return g}function v(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let g=0;g<s.arguments.length;g++){const _=s.arguments[g],A=u.arguments[g];if(_!==A)return _<A?-1:1}return 0}function p(s,u){let g=(0,C.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(g!==0)return g;if(s.command&&u.command)g=v(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(g!==0)return g;if(s.decorations&&u.decorations)g=o(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return g}function E(s,u){for(let g=0;g<s.length;g++)if(s[g]!==u[g])return!1;return!0}function c(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?E(s.arguments,u.arguments):s.arguments===u.arguments)}function l(s,u){return(0,S.equals)(s,u,c)}class f{constructor(u,g,_){this._extension=u,this._proxy=g,this._sourceControlHandle=_,this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,h.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,h.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,h.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,g){(0,h.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,g)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=f;class t{constructor(u,g,_,A,m){this._proxy=u,this._commands=g,this._sourceControlHandle=_,this._id=A,this._label=m,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,g){const _=this._resourceStatesCommandsMap.get(u);return _?(0,y.asPromise)(()=>this._commands.executeCommand(_.command,..._.arguments||[],g)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const g=[...this._resourceStates].sort(p),A=(0,S.sortedDiff)(this._resourceSnapshot,g,p).map(R=>{const $=R.toInsert.map(K=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,K);const V=K.resourceUri,H=d(K.decorations),Y=K.decorations&&d(K.decorations.light)||H,U=K.decorations&&d(K.decorations.dark)||H,F=[];let L;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"){const me=new T.DisposableStore;L=this._commands.converter.toInternal(K.command,me),this._resourceStatesDisposablesMap.set(he,me)}else this._resourceStatesCommandsMap.set(he,K.command);Y&&F.push(Y),U&&U.toString()!==(Y==null?void 0:Y.toString())&&F.push(U);const M=K.decorations&&K.decorations.tooltip||"",x=K.decorations&&!!K.decorations.strikeThrough,G=K.decorations&&!!K.decorations.faded,X=K.contextValue||"";return{rawResource:[he,V,F,M,x,G,X,L],handle:he}});return{start:R.start,deleteCount:R.deleteCount,toInsert:$}}),m=A.map(({start:R,deleteCount:$,toInsert:K})=>[R,$,K.map(he=>he.rawResource)]),w=A.reverse();for(const{start:R,deleteCount:$,toInsert:K}of w){const he=K.map(H=>H.handle),V=this._handlesSnapshot.splice(R,$,...he);for(const H of V)this._resourceStatesMap.delete(H),this._resourceStatesCommandsMap.delete(H),(u=this._resourceStatesDisposablesMap.get(H))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(H)}return this._resourceSnapshot=g,m}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,g,_,A,m,w){this._proxy=g,this._commands=_,this._id=A,this._label=m,this._rootUri=w,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new f(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,A,m,w)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const g=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:g})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(!(this._statusBarCommands&&u&&l(this._statusBarCommands,u))){this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const g=(u||[]).map(_=>this._commands.converter.toInternal(_,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:g})}}get selected(){return this._selected}createResourceGroup(u,g){const _=new t(this._proxy,this._commands,this.handle,u,g),A=k.Event.once(_.onDidDispose)(()=>this.createdResourceGroups.delete(_));return this.createdResourceGroups.set(_,A),this.eventuallyAddResourceGroups(),_}eventuallyAddResourceGroups(){const u=[],g=[];for(const[_,A]of this.createdResourceGroups){A.dispose();const m=_.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(_),this.eventuallyUpdateResourceStates()});k.Event.once(_.onDidDispose)(()=>{this.updatedResourceGroups.delete(_),m.dispose(),this._groups.delete(_.handle),this._proxy.$unregisterGroup(this.handle,_.handle)}),u.push([_.handle,_.id,_.label,_.features]);const w=_._takeResourceStateSnapshot();w.length>0&&g.push([_.handle,w]),this._groups.set(_.handle,_)}this._proxy.$registerGroups(this.handle,u,g),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(g=>{const _=g._takeResourceStateSnapshot();_.length!==0&&u.push([g.handle,_])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,je([(0,P.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),je([(0,P.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let a=class Rn{constructor(u,g,_){this._commands=g,this.logService=_,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),g.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const m=this._sourceControls.get(A.sourceControlHandle);if(!m)return A;const w=m.getResourceGroup(A.groupHandle);return w?w.getResourceState(A.handle):A}else if(A&&A.$mid===4){const m=this._sourceControls.get(A.sourceControlHandle);return m?m.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const m=this._sourceControls.get(A.handle);return m||A}return A}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,g,_,A){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,g,_,A),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const m=Rn._handlePool++,w=new n(u,this._proxy,this._commands,g,_,A);this._sourceControls.set(m,w);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(w),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),R),w}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const g=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),_=g&&g[g.length-1];return _&&_.inputBox}$provideOriginalResource(u,g,_){const A=b.URI.revive(g);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,A.toString());const m=this._sourceControls.get(u);return!m||!m.quickDiffProvider||!m.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,y.asPromise)(()=>m.quickDiffProvider.provideOriginalResource(A,_)).then(w=>w||null)}$onInputBoxValueChange(u,g){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const _=this._sourceControls.get(u);return _&&_.inputBox.$onInputBoxValueChange(g),Promise.resolve(void 0)}$executeResourceCommand(u,g,_,A){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,g,_);const m=this._sourceControls.get(u);if(!m)return Promise.resolve(void 0);const w=m.getResourceGroup(g);return w?w.$executeResourceCommand(_,A):Promise.resolve(void 0)}$validateInput(u,g,_){this.logService.trace("ExtHostSCM#$validateInput",u);const A=this._sourceControls.get(u);return!A||!A.inputBox.validateInput?Promise.resolve(void 0):(0,y.asPromise)(()=>A.inputBox.validateInput(g,_)).then(m=>m?Promise.resolve([m.message,m.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var g,_;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((g=this._sourceControls.get(u))===null||g===void 0||g.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((_=this._sourceControls.get(this._selectedSourceControlHandle))===null||_===void 0||_.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};a._handlePool=0,a=je([Ke(2,i.ILogService)],a),e.ExtHostSCM=a});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[205],be([0,1,7,5,134,6]),function(J,e,b,k,P,T){"use strict";var y,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class S{constructor(h,d,r,o,v=b.StatusBarAlignment.Left,p,E){y.set(this,void 0),D.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,it(this,y,h,"f"),it(this,D,d,"f"),this._id=S.ID_GEN++,this._statusId=r,this._statusName=o,this._alignment=v,this._priority=p,this._accessibilityInformation=E}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!S.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var d;((d=this._command)===null||d===void 0?void 0:d.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Ue(this,D,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Ue(this,D,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,y,"f").$dispose(this.id)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let d=this._color;this._backgroundColor&&(d=S.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,y,"f").$setEntry(this.id,this._statusId,this._statusName,this._text,this._tooltip,(h=this._command)===null||h===void 0?void 0:h.internal,d,this._backgroundColor,this._alignment===b.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=S,y=new WeakMap,D=new WeakMap,S.ID_GEN=0,S.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new b.ThemeColor("statusBarItem.errorForeground")]]);class C{constructor(h){this._messages=[],this._item=h.createStatusBarEntry("status.extensionMessage",(0,P.localize)(0,null),b.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const d={message:h};return this._messages.unshift(d),this._update(),new b.Disposable(()=>{const r=this._messages.indexOf(d);r>=0&&(this._messages.splice(r,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(h,d){this._proxy=h.getProxy(k.MainContext.MainThreadStatusBar),this._commands=d,this._statusMessage=new C(this)}createStatusBarEntry(h,d,r,o,v){return new S(this._proxy,this._commands,h,d,r,o,v)}setStatusBarMessage(h,d){const r=this._statusMessage.setMessage(h);let o;return typeof d=="number"?o=setTimeout(()=>r.dispose(),d):typeof d!="undefined"&&d.then(()=>r.dispose(),()=>r.dispose()),new b.Disposable(()=>{r.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=i}),define(ve[78],be([0,1,5,3,4]),function(J,e,b,k,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(D){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(b.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,S){this._proxy.$registerExtensionStorageKeysToSync(D,S)}getValue(D,S,C){return this._proxy.$getValue(D,S).then(i=>i||C)}setValue(D,S,C){return this._proxy.$setValue(D,S,C)}$acceptValue(D,S,C){this._onDidChangeStorage.fire({shared:D,key:S,value:C})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,P.createDecorator)("IExtHostStorage")}),define(ve[79],be([0,1,4,27,18,77,2]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,b.createDecorator)("IExtensionStoragePaths");let D=class{constructor(C,i,I){var h;this._logService=i,this._extHostFileSystem=I,this._workspace=(h=C.workspace)!==null&&h!==void 0?h:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(d=>this._value=d)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=y.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(h){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(y.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=y.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(h){this._logService.error("[ExtHostStorage]",h);return}}workspaceValue(C){if(this._value)return y.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return y.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=je([Ke(0,k.IExtHostInitDataService),Ke(1,P.ILogService),Ke(2,T.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(ve[40],be([0,1,3,5,4,2,15,6,7,135,12,172,20,31,155]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,P.createDecorator)("IExtHostTerminalService");class o{constructor(t,n,a,s){this._proxy=t,this._id=n,this._creationOptions=a,this._name=s,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(g=>this._pidPromiseComplete=g);const u=this;this.value={get name(){return u._name||""},get processId(){return u._pidPromise},get creationOptions(){return u._creationOptions},get exitStatus(){return u._exitStatus},sendText(g,_=!0){u._checkDisposed(),u._proxy.$sendText(u._id,g,_)},show(g){u._checkDisposed(),u._proxy.$show(u._id,g)},hide(){u._checkDisposed(),u._proxy.$hide(u._id)},dispose(){u._disposed||(u._disposed=!0,u._proxy.$dispose(u._id))},get dimensions(){if(!(u._cols===void 0||u._rows===void 0))return{columns:u._cols,rows:u._rows}}}}async create(t,n,a,s,u,g,_,A,m,w,R){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:this._name,shellPath:t,shellArgs:n,cwd:a,env:s,icon:u,initialText:g,waitOnExit:_,strictEnv:A,hideFromUser:m,isFeatureTerminal:w,isExtensionOwnedTerminal:R})}async createExtensionTerminal(){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,n){return t===this._cols&&n===this._rows||t===0||n===0?!1:(this._cols=t,this._rows=n,!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=o;class v{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new b.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new b.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new b.Emitter,this._onProcessTitleChanged=new b.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new b.Emitter,this._onProcessShellTypeChanged=new b.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput&&this._pty.handleInput(t)}resize(t,n){this._pty.setDimensions&&this._pty.setDimensions({columns:t,rows:n})}async processBinary(t){}acknowledgeDataEvent(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(t||void 0),this._pty.setDimensions&&t&&this._pty.setDimensions(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=v;let p=1,E=class extends D.Disposable{constructor(t,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new b.Emitter,this._onDidOpenTerminal=new b.Emitter,this._onDidChangeActiveTerminal=new b.Emitter,this._onDidChangeTerminalDimensions=new b.Emitter,this._proxy=n.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new r.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new b.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[a,s]of this._terminalProcesses)s.shutdown(!0)}})}get activeTerminal(){var t;return(t=this._activeTerminal)===null||t===void 0?void 0:t.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(t){const n=new o(this._proxy,(0,d.generateUuid)(),t,t.name),a=new v(t.pty);return n.createExtensionTerminal().then(s=>{const u=this._setupExtHostProcessListeners(s,a);this._terminalProcessDisposables[s]=u}),this._terminals.push(n),n.value}attachPtyToTerminal(t,n){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const s=new v(n),u=this._setupExtHostProcessListeners(t,s);this._terminalProcessDisposables[t]=u}async $acceptActiveTerminalChanged(t){const n=this._activeTerminal;if(t===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const a=this._getTerminalById(t);a&&(this._activeTerminal=a,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,n){const a=this._getTerminalById(t);a&&this._onDidWriteTerminalData.fire({terminal:a.value,data:n})}async $acceptTerminalDimensions(t,n,a){const s=this._getTerminalById(t);s&&s.setDimensions(n,a)&&this._onDidChangeTerminalDimensions.fire({terminal:s.value,dimensions:s.value.dimensions})}async $acceptTerminalMaximumDimensions(t,n,a){var s;(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}async $acceptTerminalTitleChange(t,n){const a=this._getTerminalById(t);a&&(a.name=n)}async $acceptTerminalClosed(t,n){const a=this._getTerminalObjectIndexById(this._terminals,t);if(a!==null){const s=this._terminals.splice(a,1)[0];s.setExitCode(n),this._onDidCloseTerminal.fire(s.value)}}$acceptTerminalOpened(t,n,a,s){if(n){const _=this._getTerminalObjectIndexById(this._terminals,n);if(_!==null){this._terminals[_]._id=t,this._onDidOpenTerminal.fire(this.terminals[_]),this._terminals[_].isOpen=!0;return}}const u={name:s.name,shellPath:s.executable,shellArgs:s.args,cwd:typeof s.cwd=="string"?s.cwd:T.URI.revive(s.cwd),env:s.env,hideFromUser:s.hideFromUser},g=new o(this._proxy,t,u,a);this._terminals.push(g),this._onDidOpenTerminal.fire(g.value),g.isOpen=!0}async $acceptTerminalProcessId(t,n){const a=this._getTerminalById(t);a&&a._setProcessId(n)}async $startExtensionTerminal(t,n){const a=this._getTerminalById(t);if(!a)return{message:(0,C.localize)(0,null,t)};a.isOpen||await new Promise(u=>{const g=this.onDidOpenTerminal(async _=>{_===a.value&&(g.dispose(),u())})});const s=this._terminalProcesses.get(t);s?s.startSendingEvents(n):this._extensionTerminalAwaitingStart[t]={initialDimensions:n}}_setupExtHostProcessListeners(t,n){const a=new D.DisposableStore;a.add(n.onProcessReady(u=>this._proxy.$sendProcessReady(t,u.pid,u.cwd))),a.add(n.onProcessTitleChanged(u=>this._proxy.$sendProcessTitle(t,u))),this._bufferer.startBuffering(t,n.onProcessData),a.add(n.onProcessExit(u=>this._onProcessExit(t,u))),n.onProcessOverrideDimensions&&a.add(n.onProcessOverrideDimensions(u=>this._proxy.$sendOverrideDimensions(t,u))),this._terminalProcesses.set(t,n);const s=this._extensionTerminalAwaitingStart[t];return s&&n instanceof v&&(n.startSendingEvents(s.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),a}$acceptProcessAckDataEvent(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.acknowledgeDataEvent(n)}$acceptProcessInput(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.input(n)}$acceptProcessResize(t,n,a){var s;try{(s=this._terminalProcesses.get(t))===null||s===void 0||s.resize(n,a)}catch(u){if(u.code!=="EPIPE"&&u.code!=="ERR_IPC_CHANNEL_CLOSED")throw u}}$acceptProcessShutdown(t,n){var a;(a=this._terminalProcesses.get(t))===null||a===void 0||a.shutdown(n)}$acceptProcessRequestInitialCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getInitialCwd().then(a=>this._proxy.$sendProcessInitialCwd(t,a))}$acceptProcessRequestCwd(t){var n;(n=this._terminalProcesses.get(t))===null||n===void 0||n.getCwd().then(a=>this._proxy.$sendProcessCwd(t,a))}$acceptProcessRequestLatency(t){return t}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new S.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}async $provideLinks(t,n){const a=this._getTerminalById(t);if(!a)return[];this._terminalLinkCache.delete(t);const s=this._terminalLinkCancellationSource.get(t);s&&s.dispose(!0);const u=new h.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,u);const g=[],_={terminal:a.value,line:n},A=[];for(const R of this._linkProviders)A.push(new Promise(async $=>{u.token.onCancellationRequested(()=>$({provider:R,links:[]}));const K=await R.provideTerminalLinks(_,u.token)||[];u.token.isCancellationRequested||$({provider:R,links:K})}));const m=await Promise.all(A);if(u.token.isCancellationRequested)return[];const w=new Map;for(const R of m)R&&R.links.length>0&&g.push(...R.links.map($=>{const K={id:p++,startIndex:$.startIndex,length:$.length,label:$.tooltip};return w.set(K.id,{provider:R.provider,link:$}),K}));return this._terminalLinkCache.set(t,w),g}$activateLink(t,n){var a;const s=(a=this._terminalLinkCache.get(t))===null||a===void 0?void 0:a.get(n);!s||s.provider.handleTerminalLink(s.link)}_onProcessExit(t,n){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const a=this._terminalProcessDisposables[t];a&&(a.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,n)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,n){const a=this._getTerminalObjectIndexById(t,n);return a!==null?t[a]:null}_getTerminalObjectIndexById(t,n){let a=null;return t.some((s,u)=>s._id===n?(a=u,!0):!1),a}getEnvironmentVariableCollection(t){let n=this._environmentVariableCollections.get(t.identifier.value);return n||(n=new c,this._setEnvironmentVariableCollection(t.identifier.value,n)),n}_syncEnvironmentVariableCollection(t,n){const a=(0,I.serializeEnvironmentVariableCollection)(n.map);this._proxy.$setEnvironmentVariableCollection(t,n.persistent,a.length===0?void 0:a)}$initEnvironmentVariableCollections(t){t.forEach(n=>{const a=n[0],s=new c(n[1]);this._setEnvironmentVariableCollection(a,s)})}_setEnvironmentVariableCollection(t,n){this._environmentVariableCollections.set(t,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,n)})}};E=je([Ke(1,y.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class c{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new b.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Replace})}append(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Append})}prepend(t,n){this._setIfDiffers(t,{value:n,type:S.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,n){const a=this.map.get(t);(!a||a.value!==n.value||a.type!==n.type)&&(this.map.set(t,n),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,n){this.map.forEach((a,s)=>t.call(n,s,a,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=c;let l=class extends E{constructor(t){super(!1,t)}createTerminal(t,n,a){throw new i.NotSupportedError}createTerminalFromOptions(t){throw new i.NotSupportedError}getDefaultShell(t,n){throw new i.NotSupportedError}getDefaultShellArgs(t,n){throw new i.NotSupportedError}async getDefaultShellAndArgs(t){throw new i.NotSupportedError}$getAvailableProfiles(t){throw new i.NotSupportedError}};l=je([Ke(0,y.IExtHostRpcService)],l),e.WorkerExtHostTerminalService=l}),define(ve[206],be([0,1,3,13,5,97,9,7]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class S{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new b.Emitter,this._onDidChangeTextEditorOptions=new b.Emitter,this._onDidChangeTextEditorVisibleRanges=new b.Emitter,this._onDidChangeTextEditorViewColumn=new b.Emitter,this._onDidChangeActiveTextEditor=new b.Emitter,this._onDidChangeVisibleTextEditors=new b.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(P.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(h=>this._onDidChangeVisibleTextEditors.fire(h)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(h=>this._onDidChangeActiveTextEditor.fire(h))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(h=>h.value)}async showTextDocument(i,I,h){let d;typeof I=="number"?d={position:y.ViewColumn.from(I),preserveFocus:h}:typeof I=="object"?d={position:y.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?y.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:d={preserveFocus:!1};const r=await this._proxy.$tryShowTextDocument(i.uri,d),o=r&&this._extHostDocumentsAndEditors.getEditor(r);if(o)return o.value;throw r?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i){return new T.TextEditorDecorationType(this._proxy,i).value}$acceptEditorPropertiesChanged(i,I){const h=this._extHostDocumentsAndEditors.getEditor(i);if(!h)throw new Error("unknown text editor");if(I.options&&h._acceptOptions(I.options),I.selections){const d=I.selections.selections.map(y.Selection.to);h._acceptSelections(d)}if(I.visibleRanges){const d=k.coalesce(I.visibleRanges.map(y.Range.to));h._acceptVisibleRanges(d)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:h.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:y.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const d=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),r=I.selections.selections.map(y.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:h.value,selections:r,kind:d})}if(I.visibleRanges){const d=k.coalesce(I.visibleRanges.map(y.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:h.value,visibleRanges:d})}}$acceptEditorPositionData(i){for(const I in i){const h=this._extHostDocumentsAndEditors.getEditor(I);if(!h)throw new Error("Unknown text editor");const d=y.ViewColumn.to(i[I]);h.value.viewColumn!==d&&(h._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:h.value,viewColumn:d}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=S});var Qt=this&&this.__rest||function(J,e){var b={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(b[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(b[k[P]]=J[k[P]]);return b};define(ve[207],be([0,1,2,4,5,6,7]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class D{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(P.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:h=>{var d,r;if(h&&h.$mid===11){const o=h.uri===void 0?void 0:b.URI.revive(h.uri);return(r=(d=this._itemsBySourceAndUriMap.get(h.source))===null||d===void 0?void 0:d.get(S(o)))===null||r===void 0?void 0:r.get(h.handle)}return h}})}async $getTimeline(i,I,h,d,r){const o=this._providers.get(i);return o==null?void 0:o.provideTimeline(b.URI.revive(I),h,d,r)}registerTimelineProvider(i,I,h,d){const r=new T.DisposableStore,o=this.convertTimelineItem(I.id,d,r).bind(this);let v;I.onDidChange&&(v=I.onDidChange(E=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},E),{id:I.id})),this));const p=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(E,c,l,f){var t;(f==null?void 0:f.resetCache)&&(r.clear(),(t=p.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(E,c,l);if(n!=null){const a=o(E,f);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(a)})}},dispose(){var E;for(const c of p.values())(E=c.get(I.id))===null||E===void 0||E.clear();v==null||v.dispose(),r.dispose()}}))}convertTimelineItem(i,I,h){return(d,r)=>{let o;if(r==null?void 0:r.cacheResults){let v=this._itemsBySourceAndUriMap.get(i);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(i,v));const p=S(d);o=v.get(p),o===void 0&&(o=new Map,v.set(p,o))}return v=>{var p,E;const{iconPath:c}=v,l=Qt(v,["iconPath"]),f=`${i}|${(p=v.id)!==null&&p!==void 0?p:v.timestamp}`;o==null||o.set(f,v);let t,n,a;return v.iconPath&&(c instanceof y.ThemeIcon?a={id:c.id}:b.URI.isUri(c)?(t=c,n=c):{light:t,dark:n}=c),Object.assign(Object.assign({},l),{id:(E=l.id)!==null&&E!==void 0?E:void 0,handle:f,source:i,command:v.command?I.toInternal(v.command,h):void 0,icon:t,iconDark:n,themeIcon:a,accessibilityInformation:v.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var h;for(const d of this._itemsBySourceAndUriMap.values())(h=d.get(i.id))===null||h===void 0||h.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=D;function S(C){return C==null?void 0:C.toString()}}),define(ve[208],be([0,1,6,19,2,5]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class y{constructor(S){this._openers=new Map,this._proxy=S.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(S,C,i,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const h=I.schemes.find(d=>!y.supportedSchemes.has(d));if(h)throw new Error(`Scheme '${h}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,i),this._proxy.$registerUriOpener(C,I.schemes,S,I.label),(0,b.toDisposable)(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(S,C,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener with id: ${S}`);const h=P.URI.revive(C);return I.canOpenExternalUri(h,i)}async $openUri(S,C,i){const I=this._openers.get(S);if(!I)throw new Error(`Unknown opener id: '${S}'`);return I.openExternalUri(P.URI.revive(C.resolvedUri),{sourceUri:P.URI.revive(C.sourceUri)},i)}}e.ExtHostUriOpeners=y,y.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(ve[209],be([0,1,5,2,6,12,26]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(b.MainContext.MainThreadUrls)}registerUriHandler(C,i){if(this.handles.has(y.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(y.ExtensionIdentifier.toKey(C)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,C),(0,P.toDisposable)(()=>{this.handles.delete(y.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,i){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(k.URI.revive(i))}catch(h){(0,T.onUnexpectedError)(h)}return Promise.resolve(void 0)}async createAppUri(C){return k.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[50],be([0,1,3,2,144,165,72,5]),function(J,e,b,k,P,T,y,D){"use strict";var S,C,i,I,h,d,r,o,v,p,E,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class l{constructor(_,A,m,w,R,$,K){S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,void 0),h.set(this,void 0),d.set(this,void 0),r.set(this,""),o.set(this,void 0),v.set(this,!1),p.set(this,!1),E.set(this,!1),this._onMessageEmitter=new b.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new b.Emitter),this._onDidDispose=Ue(this,c,"f").event,it(this,S,_,"f"),it(this,C,A,"f"),it(this,o,m,"f"),it(this,I,w,"f"),it(this,h,R,"f"),it(this,d,$,"f"),it(this,E,f($),"f"),it(this,i,K,"f")}dispose(){it(this,v,!0,"f"),Ue(this,c,"f").fire(),Ue(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(_){return it(this,p,!0,"f"),(0,y.asWebviewUri)(Ue(this,I,"f"),Ue(this,S,"f"),_)}get cspSource(){return Ue(this,I,"f").webviewCspSource.replace("{{uuid}}",Ue(this,S,"f"))}get html(){return this.assertNotDisposed(),Ue(this,r,"f")}set html(_){this.assertNotDisposed(),Ue(this,r,"f")!==_&&(it(this,r,_,"f"),!Ue(this,p,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(_)&&(it(this,p,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,C,"f").$setHtml(Ue(this,S,"f"),_))}get options(){return this.assertNotDisposed(),Ue(this,o,"f")}set options(_){this.assertNotDisposed(),Ue(this,C,"f").$setOptions(Ue(this,S,"f"),a(Ue(this,d,"f"),Ue(this,h,"f"),_)),it(this,o,_,"f")}async postMessage(_){if(Ue(this,v,"f"))return!1;const A=(0,T.serializeWebviewMessage)(_,{serializeBuffersForPostMessage:Ue(this,E,"f")});return Ue(this,C,"f").$postMessage(Ue(this,S,"f"),A.message,...A.buffers)}assertNotDisposed(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=l,S=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,h=new WeakMap,d=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap,p=new WeakMap,E=new WeakMap,c=new WeakMap;function f(g){try{const _=(0,P.normalizeVersion)((0,P.parseVersion)(g.engines.vscode));return!!_&&_.majorBase>=1&&_.minorBase>=57}catch(_){return!1}}e.shouldSerializeBuffersForPostMessage=f;class t{constructor(_,A,m,w,R){this.initData=A,this.workspace=m,this._logService=w,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=_.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(_,A,...m){const w=this.getWebview(_);if(w){const{message:R}=(0,T.deserializeWebviewMessage)(A,m);w._onMessageEmitter.fire(R)}}$onMissingCsp(_,A){this._logService.warn(`${A} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(_,A,m){const w=new l(_,this._webviewProxy,s(A),this.initData,this.workspace,m,this._deprecationService);return this._webviews.set(_,w),w._onDidDispose(()=>{this._webviews.delete(_)}),w}deleteWebview(_){this._webviews.delete(_)}getWebview(_){return this._webviews.get(_)}}e.ExtHostWebviews=t;function n(g){return{id:g.identifier,location:g.extensionLocation}}e.toExtensionData=n;function a(g,_,A){return{enableCommandUris:A.enableCommandUris,enableScripts:A.enableScripts,portMapping:A.portMapping,localResourceRoots:A.localResourceRoots||u(g,_)}}e.serializeWebviewOptions=a;function s(g){var _;return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,portMapping:g.portMapping,localResourceRoots:(_=g.localResourceRoots)===null||_===void 0?void 0:_.map(A=>k.URI.from(A))}}e.reviveOptions=s;function u(g,_){return[...((_==null?void 0:_.getWorkspaceFolders())||[]).map(A=>A.uri),g.extensionLocation]}}),define(ve[210],be([0,1,20,56,6,19,25,2,9,50,68,5,7]),function(J,e,b,k,P,T,y,D,S,C,i,I,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=l(this.document.uri)+this._backupCounter++;return(0,y.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class r{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,a){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new d(n,a);return this._documents.set(s,u),u}delete(t,n){const a=this.key(t,n.uri);this._documents.delete(a)}key(t,n){return`${t}@@@${n}`}}var o;(function(f){f[f.Text=0]="Text",f[f.Custom=1]="Custom"})(o||(o={}));class v{constructor(){this._providers=new Map}addTextProvider(t,n,a){return this.add(0,t,n,a)}addCustomProvider(t,n,a){return this.add(1,t,n,a)}get(t){return this._providers.get(t)}add(t,n,a,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:a,provider:s}),new h.Disposable(()=>this._providers.delete(n))}}class p{constructor(t,n,a,s,u){this._extHostDocuments=n,this._extensionStoragePaths=a,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new v,this._documents=new r,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,a,s){const u=new P.DisposableStore;return E(a)?(u.add(this._editorProviders.addTextProvider(n,t,a)),this._proxy.$registerTextEditorProvider((0,C.toExtensionData)(t),n,s.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,C.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(n,t,a)),this.supportEditing(a)&&u.add(a.onDidChangeCustomDocument(g=>{const _=this.getCustomDocumentEntry(n,g.document.uri);if(c(g)){const A=_.addEdit(g);this._proxy.$onDidEdit(g.document.uri,n,A,g.label)}else this._proxy.$onContentChange(g.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,C.toExtensionData)(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,C.shouldSerializeBuffersForPostMessage)(t))),h.Disposable.from(u,new h.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,a,s,u){var g;const _=this._editorProviders.get(n);if(!_)throw new Error(`No provider found for '${n}'`);if(_.type!==1)throw new Error(`Invalid provide type for '${n}'`);const A=D.URI.revive(t),m=await _.provider.openCustomDocument(A,{backupId:a,untitledDocumentData:s==null?void 0:s.buffer},u);let w;return this.supportEditing(_.provider)&&this._extensionStoragePaths&&(w=(g=this._extensionStoragePaths.workspaceValue(_.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(_.extension)),this._documents.add(n,m,w),{editable:this.supportEditing(_.provider)}}async $disposeCustomDocument(t,n){const a=this._editorProviders.get(n);if(!a)throw new Error(`No provider found for '${n}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,a,s,u,g){const _=this._editorProviders.get(a);if(!_)throw new Error(`No provider found for '${a}'`);const A=S.ViewColumn.to(u),m=this._extHostWebview.createNewWebview(n,s.webviewOptions,_.extension),w=this._extHostWebviewPanels.createNewWebviewPanel(n,a,s.title,A,s.panelOptions,m),R=D.URI.revive(t);switch(_.type){case 1:{const{document:$}=this.getCustomDocumentEntry(a,R);return _.provider.resolveCustomEditor($,w,g)}case 0:{const $=this._extHostDocuments.getDocument(R);return _.provider.resolveCustomTextEditor($,w,g)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,a){this.getCustomDocumentEntry(n,t).disposeEdits(a)}async $onMoveCustomEditor(t,n,a){const s=this._editorProviders.get(a);if(!s)throw new Error(`No provider found for '${a}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const g=D.URI.revive(n),_=this._extHostDocuments.getDocument(g);await s.provider.moveCustomTextEditor(_,u,b.CancellationToken.None)}async $undo(t,n,a,s){return this.getCustomDocumentEntry(n,t).undo(a,s)}async $redo(t,n,a,s){return this.getCustomDocumentEntry(n,t).redo(a,s)}async $revert(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,a),s.disposeBackup()}async $onSave(t,n,a){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,a),s.disposeBackup()}async $onSaveAs(t,n,a,s){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,D.URI.revive(a),s)}async $backup(t,n,a){const s=this.getCustomDocumentEntry(n,t),g=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},a);return s.updateBackup(g),g.id}getCustomDocumentEntry(t,n){const a=this._documents.get(t,D.URI.revive(n));if(!a)throw new Error("No custom document found");return a}getCustomEditorProvider(t){const n=this._editorProviders.get(t),a=n==null?void 0:n.provider;if(!a||!this.supportEditing(a))throw new Error("Custom document is not editable");return a}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=p;function E(f){return typeof f.resolveCustomTextEditor=="function"}function c(f){return typeof f.undo=="function"&&typeof f.redo=="function"}function l(f){const t=f.scheme===T.Schemas.file||f.scheme===T.Schemas.untitled?f.fsPath:f.toString();return(0,k.hash)(t)+""}});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[211],be([0,1,3,6,2,31,9,50,5,7]),function(J,e,b,k,P,T,y,D,S,C){"use strict";var i,I,h,d,r,o,v,p,E,c,l,f,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends k.Disposable{constructor(g,_,A,m,w,R,$){super();i.set(this,void 0),I.set(this,void 0),h.set(this,void 0),d.set(this,void 0),r.set(this,void 0),o.set(this,void 0),v.set(this,void 0),p.set(this,void 0),E.set(this,!0),c.set(this,!0),l.set(this,!1),f.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,f,"f").event,t.set(this,this._register(new b.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,it(this,i,g,"f"),it(this,I,_,"f"),it(this,h,A,"f"),it(this,r,R,"f"),it(this,p,w,"f"),it(this,o,m,"f"),it(this,d,$,"f")}dispose(){Ue(this,l,"f")||(it(this,l,!0,"f"),Ue(this,f,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,d,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,h,"f")}get title(){return this.assertNotDisposed(),Ue(this,o,"f")}set title(g){this.assertNotDisposed(),Ue(this,o,"f")!==g&&(it(this,o,g,"f"),Ue(this,I,"f").$setTitle(Ue(this,i,"f"),g))}get iconPath(){return this.assertNotDisposed(),Ue(this,v,"f")}set iconPath(g){this.assertNotDisposed(),Ue(this,v,"f")!==g&&(it(this,v,g,"f"),Ue(this,I,"f").$setIconPath(Ue(this,i,"f"),P.URI.isUri(g)?{light:g,dark:g}:g))}get options(){return Ue(this,r,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,p,"f")=="number"&&Ue(this,p,"f")<0))return Ue(this,p,"f")}get active(){return this.assertNotDisposed(),Ue(this,c,"f")}get visible(){return this.assertNotDisposed(),Ue(this,E,"f")}_updateViewState(g){Ue(this,l,"f")||(this.active!==g.active||this.visible!==g.visible||this.viewColumn!==g.viewColumn)&&(it(this,c,g.active,"f"),it(this,E,g.visible,"f"),it(this,p,g.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(g,_){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,i,"f"),{viewColumn:g?y.ViewColumn.from(g):void 0,preserveFocus:!!_})}assertNotDisposed(){if(Ue(this,l,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,h=new WeakMap,d=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap,p=new WeakMap,E=new WeakMap,c=new WeakMap,l=new WeakMap,f=new WeakMap,t=new WeakMap;class a{constructor(g,_,A){this.webviews=_,this.workspace=A,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=g.getProxy(S.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(g,_,A,m,w={}){const R=typeof m=="object"?m.viewColumn:m,$={viewColumn:y.ViewColumn.from(R),preserveFocus:typeof m=="object"&&!!m.preserveFocus},K=(0,D.shouldSerializeBuffersForPostMessage)(g),he=a.newHandle();this._proxy.$createWebviewPanel((0,D.toExtensionData)(g),he,_,{title:A,panelOptions:s(w),webviewOptions:(0,D.serializeWebviewOptions)(g,this.workspace,w),serializeBuffersForPostMessage:K},$);const V=this.webviews.createNewWebview(he,w,g);return this.createNewWebviewPanel(he,_,A,R,w,V)}$onDidChangeWebviewPanelViewStates(g){const _=Object.keys(g);_.sort((A,m)=>{const w=g[A],R=g[m];return w.active?1:R.active?-1:+w.visible-+R.visible});for(const A of _){const m=this.getWebviewPanel(A);if(!!m){const w=g[A];m._updateViewState({active:w.active,visible:w.visible,viewColumn:y.ViewColumn.to(w.position)})}}}async $onDidDisposeWebviewPanel(g){const _=this.getWebviewPanel(g);_==null||_.dispose(),this._webviewPanels.delete(g),this.webviews.deleteWebview(g)}registerWebviewPanelSerializer(g,_,A){if(this._serializers.has(_))throw new Error(`Serializer for '${_}' already registered`);return this._serializers.set(_,{serializer:A,extension:g}),this._proxy.$registerSerializer(_,{serializeBuffersForPostMessage:(0,D.shouldSerializeBuffersForPostMessage)(g)}),new C.Disposable(()=>{this._serializers.delete(_),this._proxy.$unregisterSerializer(_)})}async $deserializeWebviewPanel(g,_,A,m){const w=this._serializers.get(_);if(!w)throw new Error(`No serializer found for '${_}'`);const{serializer:R,extension:$}=w,K=this.webviews.createNewWebview(g,A.webviewOptions,$),he=this.createNewWebviewPanel(g,_,A.title,m,A.panelOptions,K);await R.deserializeWebviewPanel(he,A.state)}createNewWebviewPanel(g,_,A,m,w,R){const $=new n(g,this._proxy,_,A,m,w,R);return this._webviewPanels.set(g,$),$}getWebviewPanel(g){return this._webviewPanels.get(g)}}e.ExtHostWebviewPanels=a;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[212],be([0,1,3,6,50,5,7]),function(J,e,b,k,P,T,y){"use strict";var D,S,C,i,I,h,d,r,o,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class p extends k.Disposable{constructor(l,f,t,n,a,s){super();D.set(this,void 0),S.set(this,void 0),C.set(this,void 0),i.set(this,void 0),I.set(this,!1),h.set(this,void 0),d.set(this,void 0),r.set(this,void 0),o.set(this,this._register(new b.Emitter)),this.onDidChangeVisibility=Ue(this,o,"f").event,v.set(this,this._register(new b.Emitter)),this.onDidDispose=Ue(this,v,"f").event,it(this,C,t,"f"),it(this,d,n,"f"),it(this,D,l,"f"),it(this,S,f,"f"),it(this,i,a,"f"),it(this,h,s,"f")}dispose(){Ue(this,I,"f")||(it(this,I,!0,"f"),Ue(this,v,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,d,"f")}set title(l){this.assertNotDisposed(),Ue(this,d,"f")!==l&&(it(this,d,l,"f"),Ue(this,S,"f").$setWebviewViewTitle(Ue(this,D,"f"),l))}get description(){return this.assertNotDisposed(),Ue(this,r,"f")}set description(l){this.assertNotDisposed(),Ue(this,r,"f")!==l&&(it(this,r,l,"f"),Ue(this,S,"f").$setWebviewViewDescription(Ue(this,D,"f"),l))}get visible(){return Ue(this,h,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,C,"f")}_setVisible(l){l===Ue(this,h,"f")||Ue(this,I,"f")||(it(this,h,l,"f"),Ue(this,o,"f").fire())}show(l){this.assertNotDisposed(),Ue(this,S,"f").$show(Ue(this,D,"f"),!!l)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,S=new WeakMap,C=new WeakMap,i=new WeakMap,I=new WeakMap,h=new WeakMap,d=new WeakMap,r=new WeakMap,o=new WeakMap,v=new WeakMap;class E{constructor(l,f){this._extHostWebview=f,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=l.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(l,f,t,n){if(this._viewProviders.has(f))throw new Error(`View provider for '${f}' already registered`);return this._viewProviders.set(f,{provider:t,extension:l}),this._proxy.$registerWebviewViewProvider((0,P.toExtensionData)(l),f,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new y.Disposable(()=>{this._viewProviders.delete(f),this._proxy.$unregisterWebviewViewProvider(f)})}async $resolveWebviewView(l,f,t,n,a){const s=this._viewProviders.get(f);if(!s)throw new Error(`No view provider found for '${f}'`);const{provider:u,extension:g}=s,_=this._extHostWebview.createNewWebview(l,{},g),A=new p(l,this._proxy,f,t,_,!0);this._webviewViews.set(l,A),await u.resolveWebviewView(A,{state:n},a)}async $onDidChangeWebviewViewVisibility(l,f){this.getWebviewView(l)._setVisible(f)}async $disposeWebviewView(l){const f=this.getWebviewView(l);this._webviewViews.delete(l),f.dispose(),this._extHostWebview.deleteWebview(l)}getWebviewView(l){const f=this._webviewViews.get(l);if(!f)throw new Error("No webview found");return f}}e.ExtHostWebviewViews=E}),define(ve[101],be([0,1,3,5,2,19,8,4,15]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class Fn{constructor(I){this._onDidChangeWindowState=new b.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Fn.InitialState,this._proxy=I.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(h=>this.$onDidChangeWindowFocus(h))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,h){let d;if(typeof I=="string"){d=I;try{I=P.URI.parse(I)}catch(r){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,y.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,d,h)}async asExternalUri(I,h){if((0,y.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([T.Schemas.http,T.Schemas.https]).has(I.scheme))return Promise.reject(`Invalid scheme '${I.scheme}'`);const d=await this._proxy.$asExternalUri(I,h);return P.URI.from(d)}};C.InitialState={focused:!0},C=je([Ke(0,S.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=(0,D.createDecorator)("IExtHostWindow")}),define(ve[213],be([0,1,18,5,27,15]),function(J,e,b,k,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let y=class extends b.AbstractLogger{constructor(S,C){super();this._proxy=S.getProxy(k.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(S){this.setLevel(S)}trace(S,...C){this.getLevel()<=b.LogLevel.Trace&&this._proxy.$log(this._logFile,b.LogLevel.Trace,Array.from(arguments))}debug(S,...C){this.getLevel()<=b.LogLevel.Debug&&this._proxy.$log(this._logFile,b.LogLevel.Debug,Array.from(arguments))}info(S,...C){this.getLevel()<=b.LogLevel.Info&&this._proxy.$log(this._logFile,b.LogLevel.Info,Array.from(arguments))}warn(S,...C){this.getLevel()<=b.LogLevel.Warning&&this._proxy.$log(this._logFile,b.LogLevel.Warning,Array.from(arguments))}error(S,...C){this.getLevel()<=b.LogLevel.Error&&this._proxy.$log(this._logFile,b.LogLevel.Error,Array.from(arguments))}critical(S,...C){this.getLevel()<=b.LogLevel.Critical&&this._proxy.$log(this._logFile,b.LogLevel.Critical,Array.from(arguments))}flush(){}};y=je([Ke(0,T.IExtHostRpcService),Ke(1,P.IExtHostInitDataService)],y),e.ExtHostLogService=y}),define(ve[214],be([0,1,11,20,12,3,6,113,186,98,24]),function(J,e,b,k,P,T,y,D,S,C,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function h(s,u){try{return JSON.stringify(s,u)}catch(g){return"null"}}function d(s,u){return JSON.stringify(s,u)}function r(s){return s?(u,g)=>g&&g.$mid===1?s.transformOutgoing(g):g:null}var o;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(o=e.RequestInitiator||(e.RequestInitiator={}));var v;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(v=e.ResponsiveState||(e.ResponsiveState={}));const p=()=>{},E=Symbol.for("rpcProtocol"),c=Symbol.for("rpcProxy");class l extends y.Disposable{constructor(u,g=null,_=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=g,this._uriTransformer=_,this._uriReplacer=r(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let A=0,m=C.ProxyIdentifier.count;A<m;A++)this._locals[A]=null,this._proxies[A]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new b.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(A=>this._receiveOneMessage(A))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(P.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+l.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,D.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:g,sid:_}=u;return this._proxies[g]||(this._proxies[g]=this._createProxy(g,_)),this._proxies[g]}_createProxy(u,g){let _={get:(A,m)=>(typeof m=="string"&&!A[m]&&m.charCodeAt(0)===36&&(A[m]=(...w)=>this._remoteCall(u,m,w)),m===c?g:A[m])};return new Proxy(Object.create(null),_)}set(u,g){return this._locals[u.nid]=g,g}assertRegistered(u){for(let g=0,_=u.length;g<_;g++){const A=u[g];if(!this._locals[A.nid])throw new Error(`Missing actor ${A.sid} (isMain: ${A.isMain})`)}}_receiveOneMessage(u){if(!this._isDisposed){const g=u.byteLength,_=f.read(u,0),A=_.readUInt8(),m=_.readUInt32();switch(A){case 1:case 2:{let{rpcId:w,method:R,args:$}=t.deserializeRequestJSONArgs(_);this._uriTransformer&&($=(0,D.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(g,m,w,R,$,A===2);break}case 3:case 4:{let{rpcId:w,method:R,args:$}=t.deserializeRequestMixedArgs(_);this._uriTransformer&&($=(0,D.transformIncomingURIs)($,this._uriTransformer)),this._receiveRequest(g,m,w,R,$,A===4);break}case 5:{this._logger&&this._logger.logIncoming(g,m,0,"ack"),this._onDidReceiveAcknowledge(m);break}case 6:{this._receiveCancel(g,m);break}case 7:{this._receiveReply(g,m,void 0);break}case 9:{let w=t.deserializeReplyOKJSON(_);this._uriTransformer&&(w=(0,D.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReply(g,m,w);break}case 8:{let w=t.deserializeReplyOKVSBuffer(_);this._receiveReply(g,m,w);break}case 10:{let w=t.deserializeReplyErrError(_);this._uriTransformer&&(w=(0,D.transformIncomingURIs)(w,this._uriTransformer)),this._receiveReplyErr(g,m,w);break}case 11:{this._receiveReplyErr(g,m,void 0);break}default:console.error("received unexpected message"),console.error(u)}}}_receiveRequest(u,g,_,A,m,w){this._logger&&this._logger.logIncoming(u,g,1,`receiveRequest ${(0,C.getStringIdentifierForProxy)(_)}.${A}(`,m);const R=String(g);let $,K;if(w){const V=new k.CancellationTokenSource;m.push(V.token),$=this._invokeHandler(_,A,m),K=()=>V.cancel()}else $=this._invokeHandler(_,A,m),K=p;this._cancelInvokedHandlers[R]=K;const he=t.serializeAcknowledged(g);this._logger&&this._logger.logOutgoing(he.byteLength,g,1,"ack"),this._protocol.send(he),$.then(V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyOK(g,V,this._uriReplacer);this._logger&&this._logger.logOutgoing(H.byteLength,g,1,"reply:",V),this._protocol.send(H)},V=>{delete this._cancelInvokedHandlers[R];const H=t.serializeReplyErr(g,V);this._logger&&this._logger.logOutgoing(H.byteLength,g,1,"replyErr:",V),this._protocol.send(H)})}_receiveCancel(u,g){this._logger&&this._logger.logIncoming(u,g,1,"receiveCancel");const _=String(g);this._cancelInvokedHandlers[_]&&this._cancelInvokedHandlers[_]()}_receiveReply(u,g,_){this._logger&&this._logger.logIncoming(u,g,0,"receiveReply:",_);const A=String(g);if(!!this._pendingRPCReplies.hasOwnProperty(A)){const m=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A],m.resolveOk(_)}}_receiveReplyErr(u,g,_){this._logger&&this._logger.logIncoming(u,g,0,"receiveReplyErr:",_);const A=String(g);if(!!this._pendingRPCReplies.hasOwnProperty(A)){const m=this._pendingRPCReplies[A];delete this._pendingRPCReplies[A];let w;_&&(_.$isError?(w=new Error,w.name=_.name,w.message=_.message,w.stack=_.stack):w=_),m.resolveErr(w)}}_invokeHandler(u,g,_){try{return Promise.resolve(this._doInvokeHandler(u,g,_))}catch(A){return Promise.reject(A)}}_doInvokeHandler(u,g,_){const A=this._locals[u];if(!A)throw new Error("Unknown actor "+(0,C.getStringIdentifierForProxy)(u));let m=A[g];if(typeof m!="function")throw new Error("Unknown method "+g+" on actor "+(0,C.getStringIdentifierForProxy)(u));return m.apply(A,_)}_remoteCall(u,g,_){if(this._isDisposed)return Promise.reject(P.canceled());let A=null;if(_.length>0&&k.CancellationToken.isCancellationToken(_[_.length-1])&&(A=_.pop()),A&&A.isCancellationRequested)return Promise.reject(P.canceled());const m=t.serializeRequestArguments(_,this._uriReplacer),w=++this._lastMessageId,R=String(w),$=new S.LazyPromise;A&&A.onCancellationRequested(()=>{const he=t.serializeCancel(w);this._logger&&this._logger.logOutgoing(he.byteLength,w,0,"cancel"),this._protocol.send(t.serializeCancel(w))}),this._pendingRPCReplies[R]=$,this._onWillSendRequest(w);const K=t.serializeRequest(w,u,g,m,!!A);return this._logger&&this._logger.logOutgoing(K.byteLength,w,0,`request: ${(0,C.getStringIdentifierForProxy)(u)}.${g}(`,_),this._protocol.send(K),$}}e.RPCProtocol=l,I=E,l.UNRESPONSIVE_TIME=3*1e3;class f{constructor(u,g){this._buff=u,this._offset=g}static alloc(u,g,_){let A=new f(i.VSBuffer.alloc(_+1+4),0);return A.writeUInt8(u),A.writeUInt32(g),A}static read(u,g){return new f(u,g)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const _=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,_}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const _=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,_}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const g=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,g}static sizeMixedArray(u,g){let _=0;_+=1;for(let A=0,m=u.length;A<m;A++){const w=u[A],R=g[A];switch(_+=1,R){case 1:_+=this.sizeLongString(w);break;case 2:_+=this.sizeVSBuffer(w);break;case 3:break}}return _}writeMixedArray(u,g){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let _=0,A=u.length;_<A;_++){const m=u[_];switch(g[_]){case 1:this.writeUInt8(1),this.writeLongString(m);break;case 2:this.writeUInt8(2),this.writeVSBuffer(m);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let g=new Array(u);for(let _=0;_<u;_++)switch(this.readUInt8()){case 1:g[_]=this.readLongString();break;case 2:g[_]=this.readVSBuffer();break;case 3:g[_]=void 0;break}return g}}class t{static _arrayContainsBufferOrUndefined(u){for(let g=0,_=u.length;g<_;g++)if(u[g]instanceof i.VSBuffer||typeof u[g]=="undefined")return!0;return!1}static serializeRequestArguments(u,g){if(this._arrayContainsBufferOrUndefined(u)){let _=[],A=[];for(let m=0,w=u.length;m<w;m++){const R=u[m];R instanceof i.VSBuffer?(_[m]=R,A[m]=2):typeof R=="undefined"?(_[m]=i.VSBuffer.alloc(0),A[m]=3):(_[m]=i.VSBuffer.fromString(d(R,g)),A[m]=1)}return{type:"mixed",args:_,argsType:A}}return{type:"simple",args:d(u,g)}}static serializeRequest(u,g,_,A,m){return A.type==="mixed"?this._requestMixedArgs(u,g,_,A.args,A.argsType,m):this._requestJSONArgs(u,g,_,A.args,m)}static _requestJSONArgs(u,g,_,A,m){const w=i.VSBuffer.fromString(_),R=i.VSBuffer.fromString(A);let $=0;$+=f.sizeUInt8(),$+=f.sizeShortString(w),$+=f.sizeLongString(R);let K=f.alloc(m?2:1,u,$);return K.writeUInt8(g),K.writeShortString(w),K.writeLongString(R),K.buffer}static deserializeRequestJSONArgs(u){const g=u.readUInt8(),_=u.readShortString(),A=u.readLongString();return{rpcId:g,method:_,args:JSON.parse(A)}}static _requestMixedArgs(u,g,_,A,m,w){const R=i.VSBuffer.fromString(_);let $=0;$+=f.sizeUInt8(),$+=f.sizeShortString(R),$+=f.sizeMixedArray(A,m);let K=f.alloc(w?4:3,u,$);return K.writeUInt8(g),K.writeShortString(R),K.writeMixedArray(A,m),K.buffer}static deserializeRequestMixedArgs(u){const g=u.readUInt8(),_=u.readShortString(),A=u.readMixedArray(),m=new Array(A.length);for(let w=0,R=A.length;w<R;w++){const $=A[w];typeof $=="string"?m[w]=JSON.parse($):m[w]=$}return{rpcId:g,method:_,args:m}}static serializeAcknowledged(u){return f.alloc(5,u,0).buffer}static serializeCancel(u){return f.alloc(6,u,0).buffer}static serializeReplyOK(u,g,_){return typeof g=="undefined"?this._serializeReplyOKEmpty(u):g instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,g):this._serializeReplyOKJSON(u,h(g,_))}static _serializeReplyOKEmpty(u){return f.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,g){let _=0;_+=f.sizeVSBuffer(g);let A=f.alloc(8,u,_);return A.writeVSBuffer(g),A.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,g){const _=i.VSBuffer.fromString(g);let A=0;A+=f.sizeLongString(_);let m=f.alloc(9,u,A);return m.writeLongString(_),m.buffer}static deserializeReplyOKJSON(u){const g=u.readLongString();return JSON.parse(g)}static serializeReplyErr(u,g){return g?this._serializeReplyErrEror(u,g):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,g){const _=i.VSBuffer.fromString(h(P.transformErrorForSerialization(g),null));let A=0;A+=f.sizeLongString(_);let m=f.alloc(10,u,A);return m.writeLongString(_),m.buffer}static deserializeReplyErrError(u){const g=u.readLongString();return JSON.parse(g)}static _serializeReplyErrEmpty(u){return f.alloc(11,u,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var a;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(a||(a={}))}),define(ve[215],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const b=function(T){const y=D=>{self.removeEventListener("message",y);const S=D.data;Object.defineProperties(self,{postMessage:{value(C,i){S.postMessage(C,i)}},onmessage:{get(){return S.onmessage},set(C){S.onmessage=C}}}),S.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),S.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",y)}.toString();class k extends EventTarget{constructor(T,y,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const S=`((${b})('${y}'))`,C=new Blob([S],{type:"application/javascript"}),i=URL.createObjectURL(C),I=new MessageChannel,h=i,d={type:"_newWorker",id:h,port:I.port2,url:i,options:D};T(d,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const r={type:"_terminateWorker",id:h};I.port1.postMessage(r),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(r){I.port1.onmessage=r}},onmessageerror:{get(){return I.port1.onmessageerror},set(r){I.port1.onmessageerror=r}}}),I.port1.addEventListener("messageerror",r=>{const o=new MessageEvent("messageerror",{data:r.data});this.dispatchEvent(o)}),I.port1.addEventListener("message",r=>{const o=new MessageEvent("message",{data:r.data});this.dispatchEvent(o)}),I.port1.start()}}e.NestedWorker=k}),define(ve[216],be([0,1,4]),function(J,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,b.createDecorator)("remoteAgentService")}),define(ve[217],be([0,1,19,14,21,2,4,216]),function(J,e,b,k,P,T,y,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const h=await this.remoteAgentService.getEnvironment();return(h==null?void 0:h.os)||P.OS})(),this.resolveUserHome=(async()=>{const h=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(h==null?void 0:h.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?k.win32:k.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const d=i.indexOf("/",2);d===-1?(I=i.substring(2),i="/"):(I=i.substring(2,d),i=i.substring(d)||"/")}return T.URI.from({scheme:b.Schemas.file,authority:I,path:i,query:"",fragment:""})}};S=je([Ke(1,D.IRemoteAgentService)],S),e.AbstractPathService=S}),define(ve[102],be([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class b{constructor(y,D){this.line=y,this.character=D}isBefore(y){return!1}isBeforeOrEqual(y){return!1}isAfter(y){return!1}isAfterOrEqual(y){return!1}isEqual(y){return!1}compareTo(y){return 0}translate(y,D){return new b(0,0)}with(y){return new b(0,0)}}e.Position=b;class k{constructor(y,D,S,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(y,D),this.end=new b(S,C)}contains(y){return!1}isEqual(y){return!1}intersection(y){}union(y){return new k(0,0,0,0)}with(y){return new k(0,0,0,0)}}e.Range=k;var P;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(P=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ve[41],be([0,1,13,28,23,37,8,4,14,12,102]),function(J,e,b,k,P,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",h=" characters skipped \u27EB",d=(I.length+h.length+5)*2;e.ISearchService=(0,D.createDecorator)("searchService");var r;(function(F){F[F.file=0]="file",F[F.text=1]="text"})(r=e.SearchProviderType||(e.SearchProviderType={}));var o;(function(F){F[F.File=1]="File",F[F.Text=2]="Text"})(o=e.QueryType||(e.QueryType={}));function v(F){return!!F.preview}e.resultIsMatch=v;function p(F){return!!F.resource}e.isFileMatch=p;function E(F){return!!F.message}e.isProgressMessage=E;var c;(function(F){F[F.Normal=0]="Normal",F[F.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class l{constructor(L){this.resource=L,this.results=[]}}e.FileMatch=l;class f{constructor(L,M,x){this.ranges=M;const G=Array.isArray(M)?M:[M];if(x&&x.matchLines===1&&t(G)){L=(0,y.getNLines)(L,x.matchLines);let X="",ne=0,me=0;const Le=Math.floor(x.charsPerLine/5),We=[];for(const Fe of G){const ze=Math.max(Fe.startColumn-Le,0),W=Fe.startColumn+x.charsPerLine;if(ze>me+Le+d){const j=I+(ze-me)+h;X+=j+L.slice(ze,W),ne+=ze-(me+j.length)}else X+=L.slice(me,W);We.push(new a(0,Fe.startColumn-ne,Fe.endColumn-ne)),me=W}this.preview={text:X,matches:Array.isArray(this.ranges)?We:We[0]}}else{const X=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:L,matches:(0,b.mapArrayOrNot)(M,ne=>new n(ne.startLineNumber-X,ne.startColumn,ne.endLineNumber-X,ne.endColumn))}}}}e.TextSearchMatch=f;function t(F){const L=F[0].startLineNumber;for(const M of F)if(M.startLineNumber!==L||M.endLineNumber!==L)return!1;return!0}class n{constructor(L,M,x,G){this.startLineNumber=L,this.startColumn=M,this.endLineNumber=x,this.endColumn=G}}e.SearchRange=n;class a extends n{constructor(L,M,x){super(L,M,L,x)}}e.OneLineRange=a;var s;(function(F){F.Default="default",F.FileNames="fileNames",F.Type="type",F.Modified="modified",F.CountDescending="countDescending",F.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function u(F,L=!0){const M=F&&F.files&&F.files.exclude,x=L&&F&&F.search&&F.search.exclude;if(!(!M&&!x)){if(!M||!x)return M||x;let G=Object.create(null);return G=P.mixin(G,P.deepClone(M)),G=P.mixin(G,P.deepClone(x),!0),G}}e.getExcludes=u;function g(F,L){return F.excludePattern&&k.match(F.excludePattern,L)?!1:F.includePattern||F.usingSearchPaths?F.includePattern&&k.match(F.includePattern,L)?!0:F.usingSearchPaths?!!F.folderQueries&&F.folderQueries.some(M=>{const x=M.folder.fsPath;if(T.isEqualOrParent(L,x)){const G=S.relative(x,L);return!M.includePattern||!!k.match(M.includePattern,G)}else return!1}):!1:!0}e.pathIncludedInQuery=g;var _;(function(F){F[F.unknownEncoding=1]="unknownEncoding",F[F.regexParseError=2]="regexParseError",F[F.globParseError=3]="globParseError",F[F.invalidLiteral=4]="invalidLiteral",F[F.rgProcessError=5]="rgProcessError",F[F.other=6]="other",F[F.canceled=7]="canceled"})(_=e.SearchErrorCode||(e.SearchErrorCode={}));class A extends Error{constructor(L,M){super(L);this.code=M}}e.SearchError=A;function m(F){const L=F.message;if((0,C.isPromiseCanceledError)(F))return new A(L,_.canceled);try{const M=JSON.parse(L);return new A(M.message,M.code)}catch(M){return new A(L,_.other)}}e.deserializeSearchError=m;function w(F){const L={message:F.message,code:F.code};return new Error(JSON.stringify(L))}e.serializeSearchError=w;function R(F){return F.type==="error"?!0:F.type==="success"}e.isSerializedSearchComplete=R;function $(F){return F.type==="success"}e.isSerializedSearchSuccess=$;function K(F){return!!F.path}e.isSerializedFileMatch=K;function he(F,L){const M=F.searchPath?F.searchPath:F.relativePath;return(0,y.fuzzyContains)(M,L)}e.isFilePatternMatch=he;class V{constructor(L){this.path=L,this.results=[]}addMatch(L){this.results.push(L)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=V;function H(F,L){const M=Object.assign(Object.assign({},F||{}),L||{});return Object.keys(M).filter(x=>{const G=M[x];return typeof G=="boolean"&&G})}e.resolvePatternsForProvider=H;class Y{constructor(L,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},L.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=k.parse(this._excludeExpression);let x=L.includePattern;M.includePattern&&(x?x=Object.assign(Object.assign({},x),M.includePattern):x=M.includePattern),x&&(this._parsedIncludeExpression=k.parse(x))}includedInQuerySync(L,M,x){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(L,M,x)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(L,M,x))}includedInQuery(L,M,x){return Promise.resolve(this._parsedExcludeExpression(L,M,x)).then(X=>!!X).then(X=>X?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(L,M,x)).then(ne=>!!ne):Promise.resolve(!0)).then(X=>X)}hasSiblingExcludeClauses(){return U(this._excludeExpression)}}e.QueryGlobTester=Y;function U(F){for(const L in F)if(typeof F[L]!="boolean")return!0;return!1}}),define(ve[30],be([0,1,13,11,20,3,22,19,81,25,8,10,2,137,4,18,152,48,49,27,15,7,41,5]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l,f,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function a(R,$,K){return new C.ExtUri(he=>_(he,K)).isEqual(R,$)}function s(R,$,K){return a(R.uri,$.uri,K)?0:(0,i.compare)(R.uri.toString(),$.uri.toString())}function u(R,$,K){return R.index!==$.index?R.index<$.index?-1:1:a(R.uri,$.uri,K)?(0,i.compare)(R.name,$.name):(0,i.compare)(R.uri.toString(),$.uri.toString())}function g(R,$,K,he){const V=R.slice(0).sort((Y,U)=>K(Y,U,he)),H=$.slice(0).sort((Y,U)=>K(Y,U,he));return(0,b.delta)(V,H,(Y,U)=>K(Y,U,he))}function _(R,$){const K=$.getCapabilities(R.scheme);return!(K&&K&1024)}class A extends p.Workspace{constructor($,K,he,V,H,Y){super($,he.map(U=>new p.WorkspaceFolder(U)),V,Y);this._name=K,this._isUntitled=H,this._workspaceFolders=[],this._structure=y.TernarySearchTree.forUris(Y),he.forEach(U=>{this._workspaceFolders.push(U),this._structure.set(U.uri,U)})}static toExtHostWorkspace($,K,he,V){if(!$)return{workspace:null,added:[],removed:[]};const{id:H,name:Y,folders:U,configuration:F,isUntitled:L}=$,M=[],x=K;K?U.forEach((me,Le)=>{const We=h.URI.revive(me.uri),Fe=A._findFolder(he||K,We,V);Fe?(Fe.name=me.name,Fe.index=me.index,M.push(Fe)):M.push({uri:We,name:me.name,index:Le})}):M.push(...U.map(({uri:me,name:Le,index:We})=>({uri:h.URI.revive(me),name:Le,index:We}))),M.sort((me,Le)=>me.index<Le.index?-1:1);const G=new A(H,Y,M,F?h.URI.revive(F):null,!!L,me=>_(me,V)),{added:X,removed:ne}=g(x?x.workspaceFolders:[],G.workspaceFolders,s,V);return{workspace:G,added:X,removed:ne}}static _findFolder($,K,he){for(let V=0;V<$.folders.length;V++){const H=$.workspaceFolders[V];if(a(H.uri,K,he))return H}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder($,K){return K&&this._structure.get($)&&($=(0,C.dirname)($)),this._structure.findSubstr($)}resolveWorkspaceFolder($){return this._structure.get($)}}let m=class{constructor($,K,he,V){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=V,this._extHostFileSystemInfo=he,this._requestIdProvider=new S.Counter,this._barrier=new k.Barrier,this._proxy=$.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=$.getProxy(n.MainContext.MainThreadMessageService);const H=K.workspace;this._confirmedWorkspace=H?new A(H.id,H.name,[],H.configuration?h.URI.revive(H.configuration):null,!!H.isUntitled,Y=>_(Y,he)):void 0}$initializeWorkspace($,K){this._trusted=K,this.$acceptWorkspaceData($),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?h.URI.from({scheme:D.Schemas.untitled,path:(0,C.basename)((0,C.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders($,K,he,...V){const H=[];if(Array.isArray(V)&&V.forEach(M=>{h.URI.isUri(M.uri)&&!H.some(x=>a(x.uri,M.uri,this._extHostFileSystemInfo))&&H.push({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[K,he].some(M=>typeof M!="number"||M<0)||he===0&&H.length===0)return!1;const Y=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(K+he>Y.length)return!1;const U=Y.slice(0);U.splice(K,he,...H.map(M=>({uri:M.uri,name:M.name||(0,C.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<U.length;M++){const x=U[M];if(U.some((G,X)=>X!==M&&a(x.uri,G.uri,this._extHostFileSystemInfo)))return!1}U.forEach((M,x)=>M.index=x);const{added:F,removed:L}=g(Y,U,u,this._extHostFileSystemInfo);if(F.length===0&&L.length===0)return!1;if(this._proxy){const M=$.displayName||$.name;this._proxy.$updateWorkspaceFolders(M,K,he,H).then(void 0,x=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,d.localize)(0,null,M,x.toString()),{extension:$},[])})}return this.trySetWorkspaceFolders(U),!0}getWorkspaceFolder($,K){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,K)}async getWorkspaceFolder2($,K){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder($,K)}async resolveWorkspaceFolder($){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder($)}getPath(){if(!!this._actualWorkspace){const{folders:$}=this._actualWorkspace;if($.length!==0)return $[0].uri.fsPath}}getRelativePath($,K){let he,V="";if(typeof $=="string"?(he=h.URI.file($),V=$):typeof $!="undefined"&&(he=$,V=$.fsPath),!he)return V;const H=this.getWorkspaceFolder(he,!0);if(!H)return V;typeof K=="undefined"&&this._actualWorkspace&&(K=this._actualWorkspace.folders.length>1);let Y=(0,C.relativePath)(H.uri,he);return K&&H.name&&(Y=`${H.name}/${Y}`),Y}trySetWorkspaceFolders($){this._actualWorkspace&&(this._unconfirmedWorkspace=A.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:$,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData($){const{workspace:K,added:he,removed:V}=A.toExtHostWorkspace($,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=K||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:V}))}findFiles($,K,he,V,H=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${V.value}, entryPoint: findFiles`);let Y;if(K===null?Y=!1:K&&(typeof K=="string"?Y=K:Y=K.pattern),H&&H.isCancellationRequested)return Promise.resolve([]);const{includePattern:U,folder:F}=w($);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(U),(0,I.withUndefinedAsNull)(F),(0,I.withUndefinedAsNull)(Y),(0,I.withUndefinedAsNull)(he),H).then(L=>Array.isArray(L)?L.map(M=>h.URI.revive(M)):[])}async findTextInFiles($,K,he,V,H=P.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${V.value}, entryPoint: findTextInFiles`);const Y=this._requestIdProvider.getNext(),U=typeof K.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:F,folder:L}=w(K.include),M=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,x={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:U,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:F,excludePattern:M},G=!1;if(this._activeSearchCallbacks[Y]=X=>{if(!G){const ne=h.URI.revive(X.resource);X.results.forEach(me=>{(0,t.resultIsMatch)(me)?he({uri:ne,preview:{text:me.preview.text,matches:(0,b.mapArrayOrNot)(me.preview.matches,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))},ranges:(0,b.mapArrayOrNot)(me.ranges,Le=>new f.Range(Le.startLineNumber,Le.startColumn,Le.endLineNumber,Le.endColumn))}):he({uri:ne,text:me.text,lineNumber:me.lineNumber})})}},H.isCancellationRequested)return{};try{const X=await this._proxy.$startTextSearch($,(0,I.withUndefinedAsNull)(L),x,Y,H);return delete this._activeSearchCallbacks[Y],X||{}}catch(X){throw delete this._activeSearchCallbacks[Y],X}}$handleTextSearchResult($,K){this._activeSearchCallbacks[K]&&this._activeSearchCallbacks[K]($)}saveAll($){return this._proxy.$saveAll($)}resolveProxy($){return this._proxy.$resolveProxy($)}get trusted(){return this._trusted}requestWorkspaceTrust($){return this._proxy.$requestWorkspaceTrust($)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};m=je([Ke(0,l.IExtHostRpcService),Ke(1,c.IExtHostInitDataService),Ke(2,E.IExtHostFileSystemInfo),Ke(3,o.ILogService)],m),e.ExtHostWorkspace=m,e.IExtHostWorkspace=(0,r.createDecorator)("IExtHostWorkspace");function w(R){let $,K;return R&&(typeof R=="string"?$=R:($=R.pattern,K=R.baseFolder||h.URI.file(R.base))),{includePattern:$,folder:K}}}),define(ve[34],be([0,1,23,3,30,5,7,154,66,10,11,4,15,18,2]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function o(n,a){if(a){const s=a.split(".");let u=n;for(let g=0;u&&g<s.length;g++)u=u[s[g]];return u}}function v(n){return n instanceof r.URI}function p(n){return n&&n.uri instanceof r.URI&&n.languageId&&typeof n.languageId=="string"}function E(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function c(n){return n&&n.uri instanceof r.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function l(n){if(v(n))return{resource:n};if(p(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(E(n))return{overrideIdentifier:n.languageId};if(c(n))return{resource:n.uri};if(n===null)return{resource:null}}let f=class{constructor(a,s,u){this._proxy=a.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(a=>this._actual)}$initializeConfiguration(a){this._actual=new t(this._proxy,this._extHostWorkspace,a,this._logService),this._barrier.open()}$acceptConfigurationChanged(a,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(a,s))}};f=je([Ke(0,h.IExtHostRpcService),Ke(1,P.IExtHostWorkspace),Ke(2,d.ILogService)],f),e.ExtHostConfiguration=f;class t{constructor(a,s,u,g){this._onDidChangeConfiguration=new k.Emitter,this._proxy=a,this._logService=g,this._extHostWorkspace=s,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(a,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(a),this._configurationScopes=this._toMap(a.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(a,s,u){const g=l(s)||{},_=this._toReadonlyValue(a?o(this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace),a):this._configuration.getValue(void 0,g,this._extHostWorkspace.workspace));a&&this._validateConfigurationAccess(a,g,u==null?void 0:u.identifier);function A(w){if(w==null)return null;if(typeof w=="boolean")return w?1:4;switch(w){case y.ConfigurationTarget.Global:return 1;case y.ConfigurationTarget.Workspace:return 4;case y.ConfigurationTarget.WorkspaceFolder:return 5}}const m={has(w){return typeof o(_,w)!="undefined"},get:(w,R)=>{this._validateConfigurationAccess(a?`${a}.${w}`:w,g,u==null?void 0:u.identifier);let $=o(_,w);if(typeof $=="undefined")$=R;else{let K;const he=(V,H)=>{let Y;const U=()=>{K=K||(0,b.deepClone)(_),Y=Y||o(K,H)};return(0,C.isObject)(V)?new Proxy(V,{get:(F,L)=>{if(typeof L=="string"&&L.toLowerCase()==="tojson")return U(),()=>Y;if(K)return Y=Y||o(K,H),Y[L];const M=F[L];return typeof L=="string"?he(M,`${H}.${L}`):M},set:(F,L,M)=>(U(),Y&&(Y[L]=M),!0),deleteProperty:(F,L)=>(U(),Y&&delete Y[L],!0),defineProperty:(F,L,M)=>(U(),Y&&Object.defineProperty(Y,L,M),!0)}):V};$=he($,w)}return $},update:(w,R,$,K)=>{w=a?`${a}.${w}`:w;const he=A($);return R!==void 0?this._proxy.$updateConfigurationOption(he,w,R,g,K):this._proxy.$removeConfigurationOption(he,w,g,K)},inspect:w=>{var R,$,K,he,V,H,Y,U;w=a?`${a}.${w}`:w;const F=(0,b.deepClone)(this._configuration.inspect(w,g,this._extHostWorkspace.workspace));if(F)return{key:w,defaultValue:(R=F.default)===null||R===void 0?void 0:R.value,globalValue:($=F.user)===null||$===void 0?void 0:$.value,workspaceValue:(K=F.workspace)===null||K===void 0?void 0:K.value,workspaceFolderValue:(he=F.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(V=F.default)===null||V===void 0?void 0:V.override,globalLanguageValue:(H=F.user)===null||H===void 0?void 0:H.override,workspaceLanguageValue:(Y=F.workspace)===null||Y===void 0?void 0:Y.override,workspaceFolderLanguageValue:(U=F.workspaceFolder)===null||U===void 0?void 0:U.override,languageIds:F.overrideIdentifiers}}};return typeof _=="object"&&(0,b.mixin)(m,_,!1),Object.freeze(m)}_toReadonlyValue(a){const s=u=>(0,C.isObject)(u)?new Proxy(u,{get:(g,_)=>s(g[_]),set:(g,_,A)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(_)}' of object`)},deleteProperty:(g,_)=>{throw new Error(`TypeError: Cannot delete read only property '${String(_)}' of object`)},defineProperty:(g,_)=>{throw new Error(`TypeError: Cannot define property '${String(_)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(a)}_validateConfigurationAccess(a,s,u){const g=S.OVERRIDE_PROPERTY_PATTERN.test(a)?4:this._configurationScopes.get(a),_=u?`[${u.value}] `:"";if(g===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${_}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){(s==null?void 0:s.resource)&&this._logService.warn(`${_}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(a,s){const u=new D.ConfigurationChangeEvent(a,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(g,_)=>u.affectsConfiguration(g,l(_))})}_toMap(a){return a.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[103],be([0,1,2,11,3,5,7,30,39,34,20,40,15,27,4,19,21,18,75,171,12]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(V){function H(U){if(U!=null)return U}V.from=H;function Y(U){if(U!=null)return U}V.to=Y})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(V){function H(U){if(U!=null)return U}V.from=H;function Y(U){if(U!=null)return U}V.to=Y})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var a;(function(V){function H(U){if(U!=null)return U}V.from=H;function Y(U){if(U!=null)return U}V.to=Y})(a=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(V){function H(F){if(F){const L=F;return L&&!!L.process}else return!1}V.is=H;function Y(F){if(F!=null){const L={process:F.process,args:F.args};return F.options&&(L.options=a.from(F.options)),L}}V.from=Y;function U(F){if(F!=null)return new y.ProcessExecution(F.process,F.args,F.options)}V.to=U})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(V){function H(U){if(U!=null)return U}V.from=H;function Y(U){if(U!=null)return U}V.to=Y})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var g;(function(V){function H(F){if(F){const L=F;return L&&(!!L.commandLine||!!L.command)}else return!1}V.is=H;function Y(F){if(F!=null){const L={};return F.commandLine!==void 0?L.commandLine=F.commandLine:(L.command=F.command,L.args=F.args),F.options&&(L.options=u.from(F.options)),L}}V.from=Y;function U(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new y.ShellExecution(F.commandLine,F.options):new y.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=U})(g=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var _;(function(V){function H(F){if(F){let L=F;return L&&L.customExecution==="customExecution"}else return!1}V.is=H;function Y(F){return{customExecution:"customExecution"}}V.from=Y;function U(F,L){return L.get(F)}V.to=U})(_=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var A;(function(V){function H(Y,U){let F;return Y.scope!==void 0&&typeof Y.scope!="number"?F=Y.scope.uri:Y.scope!==void 0&&typeof Y.scope=="number"&&(Y.scope===y.TaskScope.Workspace&&U&&U.workspaceFile?F=U.workspaceFile:F=c.USER_TASKS_GROUP_KEY),{id:Y._id,workspaceFolder:F}}V.from=H})(A=e.TaskHandleDTO||(e.TaskHandleDTO={}));var m;(function(V){function H(F,L){if(F==null)return[];const M=[];for(let x of F){const G=Y(x,L);G&&M.push(G)}return M}V.fromMany=H;function Y(F,L){if(F!=null){let M;F.execution instanceof y.ProcessExecution?M=s.from(F.execution):F.execution instanceof y.ShellExecution?M=g.from(F.execution):F.execution&&F.execution instanceof y.CustomExecution&&(M=_.from(F.execution));const x=t.from(F.definition);let G;if(F.scope?typeof F.scope=="number"?G=F.scope:G=F.scope.uri:G=y.TaskScope.Workspace,!(!x||!G)){const X=F.group?F.group.id:void 0;return{_id:F._id,definition:x,name:F.name,source:{extensionId:L.identifier.value,label:F.source,scope:G},execution:M,isBackground:F.isBackground,group:X,presentationOptions:n.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}}}V.from=Y;async function U(F,L,M){if(F!=null){let x;s.is(F.execution)?x=s.to(F.execution):g.is(F.execution)?x=g.to(F.execution):_.is(F.execution)&&(x=_.to(F._id,M));const G=t.to(F.definition);let X;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?X=F.source.scope:X=await L.resolveWorkspaceFolder(b.URI.revive(F.source.scope)):X=y.TaskScope.Workspace),!(!G||!X)){const ne=new y.Task(G,X,F.name,F.source.label,x,F.problemMatchers);return F.isBackground!==void 0&&(ne.isBackground=F.isBackground),F.group!==void 0&&(ne.group=y.TaskGroup.from(F.group)),F.presentationOptions&&(ne.presentationOptions=n.to(F.presentationOptions)),F._id&&(ne._id=F._id),F.detail&&(ne.detail=F.detail),ne}}}V.to=U})(m=e.TaskDTO||(e.TaskDTO={}));var w;(function(V){function H(U){return U}V.from=H;function Y(U){if(!!U)return Object.assign(Object.create(null),U)}V.to=Y})(w=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(H,Y,U){this._id=Y,this._task=U,f.set(this,void 0),it(this,f,H,"f")}get task(){return this._task}terminate(){Ue(this,f,"f").terminateTask(this)}fireDidStartProcess(H){}fireDidEndProcess(H){}}f=new WeakMap;var $;(function(V){function H(Y){return{id:Y._id,task:void 0}}V.from=H})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let K=class{constructor(H,Y,U,F,L,M,x,G){this._onDidExecuteTask=new P.Emitter,this._onDidTerminateTask=new P.Emitter,this._onDidTaskProcessStarted=new P.Emitter,this._onDidTaskProcessEnded=new P.Emitter,this._proxy=H.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=U,this._editorService=F,this._configurationService=L,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=x,this._deprecationService=G,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(H,Y,U){if(!U)return new y.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:Y,provider:U,extension:H}),this._proxy.$registerTaskProvider(F,Y),new y.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(H,Y){this._proxy.$registerTaskSystem(H,Y)}fetchTasks(H){return this._proxy.$fetchTasks(w.from(H)).then(async Y=>{const U=[];for(let F of Y){const L=await m.to(F,this._workspaceProvider,this._providedCustomExecutions2);L&&U.push(L)}return U})}get taskExecutions(){const H=[];return this._taskExecutions.forEach(Y=>H.push(Y)),H}terminateTask(H){if(!(H instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(H._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(H,Y,U){const F=this._providedCustomExecutions2.get(H.id);if(F){if(this._activeCustomExecutions2.get(H.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(H.id,F),this._terminalService.attachPtyToTerminal(Y,await F.callback(U))}this._lastStartedTask=H.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(H)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(H){const Y=await this.getTaskExecution(H);this._taskExecutionPromises.delete(H.id),this._taskExecutions.delete(H.id),this.customExecutionComplete(H),this._onDidTerminateTask.fire({execution:Y})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(H){const Y=await this.getTaskExecution(H.id);this._onDidTaskProcessStarted.fire({execution:Y,processId:H.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(H){const Y=await this.getTaskExecution(H.id);this._onDidTaskProcessEnded.fire({execution:Y,exitCode:H.exitCode})}$provideTasks(H,Y){const U=this._handlers.get(H);if(!U)return Promise.reject(new Error("no handler found"));const F=[],L=(0,k.asPromise)(()=>U.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(Y,F,U,M));return new Promise(M=>{L.then(x=>{Promise.all(F).then(()=>{M(x)})})})}async $resolveTask(H,Y){const U=this._handlers.get(H);if(!U)return Promise.reject(new Error("no handler found"));if(Y.definition.type!==U.type)throw new Error(`Unexpected: Task of type [${Y.definition.type}] cannot be resolved by provider of type [${U.type}].`);const F=await m.to(Y,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const L=await U.provider.resolveTask(F,i.CancellationToken.None);if(!!L){this.checkDeprecation(L,U);const M=m.from(L,U.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(L.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return _.is(M.execution)&&await this.addCustomExecution(M,L,!0),await this.resolveTaskInternal(M)}}nextHandle(){return this._handleCounter++}async addCustomExecution(H,Y,U){const F=await this._proxy.$createTaskId(H);!U&&!this._providedCustomExecutions2.has(F)&&this._notProvidedCustomExecutions.add(F),this._providedCustomExecutions2.set(F,Y.execution)}async getTaskExecution(H,Y){if(typeof H=="string"){const L=this._taskExecutionPromises.get(H);if(!L)throw new Error("Unexpected: The specified task is missing an execution");return L}let U=this._taskExecutionPromises.get(H.id);if(U)return U;const F=new Promise(async(L,M)=>{const x=Y||await m.to(H.task,this._workspaceProvider,this._providedCustomExecutions2);x?L(new R(this,H.id,x)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(H.id,F),F.then(L=>(this._taskExecutions.set(H.id,L),L),L=>Promise.reject(L))}checkDeprecation(H,Y){H._deprecated&&this._deprecationService.report("Task.constructor",Y.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(H){this._activeCustomExecutions2.get(H.id)&&this._activeCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.has(H.id)&&this._lastStartedTask!==H.id&&(this._providedCustomExecutions2.delete(H.id),this._notProvidedCustomExecutions.delete(H.id));let U=this._notProvidedCustomExecutions.values(),F=U.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=U.next()}};K=je([Ke(0,h.IExtHostRpcService),Ke(1,d.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,p.ILogService),Ke(7,E.IExtHostApiDeprecationService)],K),e.ExtHostTaskBase=K;let he=class extends K{constructor(H,Y,U,F,L,M,x,G){super(H,Y,U,F,L,M,x,G);this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:v.PlatformToString(0)})}async executeTask(H,Y){if(!Y.execution)throw new Error("Tasks to execute must include an execution");const U=m.from(Y,H);if(U===void 0)throw new Error("Task is not valid");if(_.is(U.execution))await this.addCustomExecution(U,Y,!1);else throw new l.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(U),Y);return this._proxy.$executeTask(U).catch(L=>{throw new Error(L)}),F}provideTasksInternal(H,Y,U,F){const L=[];if(F)for(let M of F){this.checkDeprecation(M,U),(!M.definition||!H[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const x=m.from(M,U.extension);x&&_.is(x.execution)?(L.push(x),Y.push(this.addCustomExecution(x,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:L,extension:U.extension}}async resolveTaskInternal(H){if(_.is(H.execution))return H;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(H,Y){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}async $findExecutable(H,Y,U){}};he=je([Ke(0,h.IExtHostRpcService),Ke(1,d.IExtHostInitDataService),Ke(2,D.IExtHostWorkspace),Ke(3,S.IExtHostDocumentsAndEditors),Ke(4,C.IExtHostConfiguration),Ke(5,I.IExtHostTerminalService),Ke(6,p.ILogService),Ke(7,E.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,r.createDecorator)("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)},Qt=this&&this.__rest||function(J,e){var b={};for(var k in J)Object.prototype.hasOwnProperty.call(J,k)&&e.indexOf(k)<0&&(b[k]=J[k]);if(J!=null&&typeof Object.getOwnPropertySymbols=="function")for(var P=0,k=Object.getOwnPropertySymbols(J);P<k.length;P++)e.indexOf(k[P])<0&&Object.prototype.propertyIsEnumerable.call(J,k[P])&&(b[k[P]]=J[k[P]]);return b};define(ve[218],be([0,1,13,11,24,20,3,53,43,6,23,10,2,31,5,39,15,69,9,7,30,182,96]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l,f,t){"use strict";var n,a,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const g=(U,F)=>`${U}:${F.toString()}`;let _=class{constructor(F,L,M){this.documents=L,this.workspace=M,this.resultsChangedEmitter=new y.Emitter,this.controllers=new Map,this.ownedTests=new f.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=F.getProxy(r.MainContext.MainThreadTesting),this.runQueue=new A(this.proxy),this.workspaceObservers=new H(this.proxy),this.textDocumentObservers=new Y(this.proxy,L)}registerTestController(F,L){const M=(0,d.generateUuid)();this.controllers.set(M,{instance:L,extensionId:F}),this.proxy.$registerTestController(M);const x=[...this.testControllers.keys()];return setTimeout(()=>{var G;for(const X of x)(G=this.testControllers.get(X))===null||G===void 0||G.subscribeFn(M,L)},0),new c.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(F){return this.textDocumentObservers.checkout(F.uri)}createWorkspaceTestObserver(F){return this.workspaceObservers.checkout(F.uri)}async runTests(F,L=T.CancellationToken.None){const M=x=>x.map(this.getInternalTestForReference,this).filter(I.isDefined).map(G=>({src:G.src,testId:G.item.extId}));await this.proxy.$runTests({exclude:F.exclude?M(F.exclude).map(x=>x.testId):void 0,tests:M(F.tests),debug:F.debug},L)}createTestRun(F,L,M,x=!0){return this.runQueue.createTestRun(F,L,M,x)}$publishTestResults(F){this.results=Object.freeze(F.map(L=>(0,i.deepFreeze)(E.TestResults.to(L))).concat(this.results).sort((L,M)=>M.completedAt-L.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(F,L){const M=h.URI.revive(L),x=g(F,M);if(!this.testControllers.has(x)){const G=new T.CancellationTokenSource;let X;if(F===1){let Fe=this.documents.getDocument(M);if(!Fe){const ze=new C.DisposableStore;Fe=await new Promise(W=>{ze.add((0,k.disposableTimeout)(()=>W(void 0),5e3)),ze.add(this.documents.onDidAddDocuments(j=>{const te=j.find(oe=>oe.document.uri.toString()===M.toString());te&&W(te)}))}).finally(()=>ze.dispose())}if(Fe){const ze=await this.workspace.getWorkspaceFolder2(M,!1);X=W=>W.createDocumentTestRoot?W.createDocumentTestRoot(Fe.document,G.token):(0,e.createDefaultDocumentTestRoot)(W,Fe.document,ze,G.token)}}else{const Fe=await this.workspace.getWorkspaceFolder2(M,!1);Fe&&(X=ze=>ze.createWorkspaceTestRoot(Fe,G.token))}if(!!X){const ne=async(Fe,ze)=>{try{const W=await X(ze);W&&Le.addRoot(W,Fe)}catch(W){console.error(W)}},me=new C.DisposableStore,Le=me.add(this.ownedTests.createForHierarchy(Fe=>this.proxy.$publishDiff(F,L,Fe)));me.add((0,C.toDisposable)(()=>G.dispose(!0)));const We=[];for(const[Fe,ze]of this.controllers)We.push(ne(Fe,ze.instance));Promise.all(We).then(()=>Le.pushDiff([3,-1])),this.testControllers.set(x,{store:me,collection:Le,subscribeFn:ne})}}}async $expandTest(F,L){const M=(0,b.mapFind)(this.testControllers.values(),x=>x.collection.treeId===F.src.tree?x:void 0);await(M==null?void 0:M.collection.expand(F.testId,L<0?Infinity:L)),this.flushCollectionDiffs()}$unsubscribeFromTests(F,L){var M;const x=h.URI.revive(L),G=g(F,x);(M=this.testControllers.get(G))===null||M===void 0||M.store.dispose(),this.testControllers.delete(G)}$acceptDiff(F,L,M){F===1?this.textDocumentObservers.acceptDiff(h.URI.revive(L),M):this.workspaceObservers.acceptDiff(h.URI.revive(L),M)}async $runTestsForProvider(F,L){const M=this.controllers.get(F.tests[0].src.controller);if(!!M){const x=F.tests.map(({testId:ne,src:me})=>this.ownedTests.getTestById(ne,me==null?void 0:me.tree)).filter(I.isDefined).map(([ne,me])=>me),G=F.excludeExtIds.map(ne=>this.ownedTests.getTestById(ne)).filter(I.isDefined).filter(([ne,me])=>x.some(Le=>ne.comparePositions(Le,me)===1));if(!!x.length){const X={tests:x.map(ne=>$.unwrap(ne.actual)),exclude:G.map(([,ne])=>$.unwrap(ne.actual)),debug:F.debug};await this.runQueue.enqueueRun({dto:m.fromInternal(F),token:L,extensionId:M.extensionId,req:X,doRun:()=>M.instance.runTests(X,L)})}}}$lookupTest(F){const L=this.ownedTests.getTestById(F.testId);if(!L)return Promise.resolve(void 0);const M=L[1],{actual:x,discoverCts:G,expandLevels:X}=M,ne=Qt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(ne)}flushCollectionDiffs(){for(const{collection:F}of this.testControllers.values())F.flushDiff()}getInternalTestForReference(F){var L,M;return(M=(L=this.workspaceObservers.getMirroredTestDataByReference(F))!==null&&L!==void 0?L:(0,b.mapFind)(this.testControllers.values(),x=>x.collection.getTestByReference(F)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(F)}};_=je([Ke(0,v.IExtHostRpcService),Ke(1,o.IExtHostDocumentsAndEditors),Ke(2,l.IExtHostWorkspace)],_),e.ExtHostTesting=_;class A{constructor(F){this.proxy=F,this.state=new Map}enqueueRun(F){let L=this.state.get(F.extensionId);L||(L={queue:[],current:void 0},this.state.set(F.extensionId,L));const M=new k.DeferredPromise,x=()=>{const G=[],X=new Set;L.current={publicReq:F.req,factory:ne=>{const me=new w(ne,F.dto,X,this.proxy);return G.push(me),F.token.onCancellationRequested(()=>me.end()),me}},this.invokeRunner(F.extensionId,F.dto.id,F.doRun,G).finally(()=>M.complete())};return L.queue.push(x),L.queue.length===1&&x(),M.p}createTestRun(F,L,M,x){var G,X;const ne=this.state.get(F);if((ne==null?void 0:ne.current.publicReq)===L)return ne.current.factory(M);const me=m.fromPublic(L),Le=new w(M,me,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(X=(G=L.exclude)===null||G===void 0?void 0:G.map(We=>We.id))!==null&&X!==void 0?X:[],id:me.id,tests:L.tests.map(We=>We.id),persist:x}),Le.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(me.id)),Le}invokeRunner(F,L,M,x){try{const G=M();return(0,k.isThenable)(G)?G.then(()=>this.handleInvokeResult(F,L,x,void 0)).catch(X=>this.handleInvokeResult(F,L,x,X)):this.handleInvokeResult(F,L,x,void 0)}catch(G){return this.handleInvokeResult(F,L,x,G)}}async handleInvokeResult(F,L,M,x){const G=this.state.get(F);!G||(G.queue.shift(),G.queue.length>0?G.queue[0]():this.state.delete(F),await Promise.all(M.map(X=>X.onEnd.wait())))}}class m{constructor(F,L,M){this.id=F,this.include=L,this.exclude=M}static fromPublic(F){var L,M;return new m((0,d.generateUuid)(),new Set(F.tests.map(x=>x.id)),new Set((M=(L=F.exclude)===null||L===void 0?void 0:L.map(x=>x.id))!==null&&M!==void 0?M:S.Iterable.empty()))}static fromInternal(F){return new m(F.runId,new Set(F.tests.map(L=>L.testId)),new Set(F.excludeExtIds))}isIncluded(F){for(let L=F;L;L=L.parent){if(this.include.has(L.id))return!0;if(this.exclude.has(L.id))return!1}return!0}}class w{constructor(F,L,M,x){this.name=F,n.set(this,void 0),a.set(this,void 0),s.set(this,(0,d.generateUuid)()),u.set(this,void 0),this.onEnd=new k.Barrier,it(this,n,x,"f"),it(this,a,L,"f"),it(this,u,M,"f"),x.$startedTestRunTask(L.id,{id:Ue(this,s,"f"),name:F,running:!0})}setState(F,L,M){Ue(this,a,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$updateTestStateInRun(Ue(this,a,"f").id,Ue(this,s,"f"),F.id,L,M))}appendMessage(F,L){Ue(this,a,"f").isIncluded(F)&&(this.ensureTestIsKnown(F),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,a,"f").id,Ue(this,s,"f"),F.id,E.TestMessage.from(L)))}appendOutput(F){Ue(this,n,"f").$appendOutputToRun(Ue(this,a,"f").id,Ue(this,s,"f"),P.VSBuffer.fromString(F))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,a,"f").id,Ue(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(F){const L=Ue(this,u,"f");if(!L.has(F.id)){const M=[];for(;M.unshift(E.TestItem.from(F)),!(L.has(F.id)||(L.add(F.id),!F.parent));)F=F.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,a,"f").id,M)}}}n=new WeakMap,a=new WeakMap,s=new WeakMap,u=new WeakMap;const R=async(U,F,L,M)=>{if(!!L){const x=await U.createWorkspaceTestRoot(L,M);if(!!x){M.onCancellationRequested(()=>{$.removeFilter(F)});const G=$.getWrapperForTestItem(x,F);return G.refreshMatch(),G}}};e.createDefaultDocumentTestRoot=R;class $ extends c.TestItemImpl{constructor(F,L,M){super(F.id,F.label,F.uri,void 0);if(this.actual=F,this.filterDocument=L,this.actualParent=M,!(F instanceof c.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${F.id} did not`);this.debuggable=F.debuggable,this.runnable=F.runnable,this.description=F.description,this.error=F.error,this.status=F.status,this.range=F.range,this.resolveHandler=F.resolveHandler;const x=(0,p.getPrivateApiFor)(this);(0,p.getPrivateApiFor)(F).bus.event(X=>{switch(X[0]){case 3:this[X[1]]=X[2];break;case 0:const ne=$.getWrapperForTestItem(X[1],this.filterDocument,this);(0,p.getPrivateApiFor)(ne).parent=F,ne.refreshMatch();break;default:x.bus.fire(X)}})}static removeFilter(F){this.wrapperMap.delete(F)}static getWrapperForTestItem(F,L,M){let x=this.wrapperMap.get(L);if(x==null?void 0:x.has(F))return x.get(F);x||(x=new WeakMap,this.wrapperMap.set(L,x));const G=new $(F,L,M);return x.set(F,G),G}static unwrap(F){return F instanceof $?F.actual:F}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var F,L;const M=this._cachedMatchesFilter;for(const G of this.actual.children.values()){const X=$.getWrapperForTestItem(G,this.filterDocument,this);X.hasNodeMatchingFilter?this.children.has(X.id)||this.addChild(X):X.dispose()}const x=this.children.size>0||((F=this.actual.uri)===null||F===void 0?void 0:F.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=x,x!==M&&((L=this.actualParent)===null||L===void 0||L.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,p.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,p.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=$,$.wrapperMap=new WeakMap;class K extends t.IncrementalChangeCollector{constructor(F){super();this.emitter=F,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(F){this.added.add(F)}update(F){Object.assign(F.revived,E.TestItem.toPlain(F.item)),this.added.has(F)||this.updated.add(F)}remove(F){if(this.added.has(F)){this.added.delete(F);return}if(this.updated.delete(F),F.parent&&this.alreadyRemoved.has(F.parent)){this.alreadyRemoved.add(F.item.extId);return}this.removed.add(F)}getChangeEvent(){const{added:F,updated:L,removed:M}=this;return{get added(){return[...F].map(x=>x.revived)},get updated(){return[...L].map(x=>x.revived)},get removed(){return[...M].map(x=>x.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new y.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(F){let L=[];for(const M of F){const x=this.items.get(M);x&&L.push(x.revived)}return L}getMirroredTestDataById(F){return this.items.get(F)}getMirroredTestDataByReference(F){return this.items.get(F.id)}createItem(F,L){return Object.assign(Object.assign({},F),{revived:E.TestItem.toPlain(F.item),depth:L?L.depth+1:0,children:new Set})}createChangeCollector(){return new K(this.changeEmitter)}}e.MirroredTestCollection=he;class V{constructor(){this.resources=new Map}checkout(F){var L,M;const x=F.toString(),G=(L=this.resources.get(x))!==null&&L!==void 0?L:this.createObserverData(F);return(M=G.pendingDeletion)===null||M===void 0||M.dispose(),G.observers++,{onDidChangeTest:G.tests.onDidChangeTests,onDidDiscoverInitialTests:new y.Emitter().event,get tests(){return G.tests.rootTestItems},dispose:(0,D.once)(()=>{--G.observers||(G.pendingDeletion=this.eventuallyDispose(F))})}}getMirroredTestDataByReference(F){for(const{tests:L}of this.resources.values()){const M=L.getMirroredTestDataByReference(F);if(M)return M}}eventuallyDispose(F){return(0,k.disposableTimeout)(()=>this.unlisten(F),10*1e3)}createObserverData(F){const L=new he,M=this.listen(F,G=>L.apply(G)),x={observers:0,tests:L,listener:M};return this.resources.set(F.toString(),x),x}unlisten(F){var L;const M=F.toString(),x=this.resources.get(M);x&&(x.observers=-1,(L=x.pendingDeletion)===null||L===void 0||L.dispose(),x.listener.dispose(),this.resources.delete(M))}}class H extends V{constructor(F){super();this.proxy=F,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){this.proxy.$subscribeToDiffs(0,F);const M=F.toString();return this.diffListeners.set(M,L),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,F),this.diffListeners.delete(M)})}}class Y extends V{constructor(F,L){super();this.proxy=F,this.documents=L,this.diffListeners=new Map}acceptDiff(F,L){var M;(M=this.diffListeners.get(F.toString()))===null||M===void 0||M(L)}listen(F,L){if(!this.documents.getDocument(F))return new c.Disposable(()=>{});const x=F.toString();return this.diffListeners.set(x,L),this.proxy.$subscribeToDiffs(1,F),new c.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,F),this.diffListeners.delete(x)})}}}),define(ve[219],be([0,1,13,51,28,58,22,19,14,25,8,10,2,116,140,92,48,174,217,41]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let l=class{constructor(A,m,w,R){this.configurationService=A,this.workspaceContextService=m,this.editorGroupsService=w,this.pathService=R}text(A,m,w={}){A=this.getContentPattern(A,w);const R=this.configurationService.getValue(),$=m&&m.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),K=this.commonQuery(m==null?void 0:m.map(v.toWorkspaceFolder),w);return Object.assign(Object.assign({},K),{type:2,contentPattern:A,previewOptions:w.previewOptions,maxFileSize:w.maxFileSize,usePCRE2:R.search.usePCRE2||$||!1,beforeContext:w.beforeContext,afterContext:w.afterContext,userDisabledExcludesAndIgnoreFiles:w.disregardExcludeSettings&&w.disregardIgnoreFiles})}getContentPattern(A,m){const w=this.configurationService.getValue();A.isRegExp&&(A.pattern=A.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},A),{wordSeparators:w.editor.wordSeparators});return this.isCaseSensitive(A,m)&&(R.isCaseSensitive=!0),this.isMultiline(A)&&(R.isMultiline=!0),R}file(A,m={}){const w=this.commonQuery(A,m);return Object.assign(Object.assign({},w),{type:1,filePattern:m.filePattern?m.filePattern.trim():m.filePattern,exists:m.exists,sortByScore:m.sortByScore,cacheKey:m.cacheKey})}handleIncludeExclude(A,m){return A?(A=Array.isArray(A)?A.map(s):s(A),m?this.parseSearchPaths(A):{pattern:t(...Array.isArray(A)?A:[A])}):{}}commonQuery(A=[],m={}){const w=this.handleIncludeExclude(m.includePattern,m.expandPatterns),R=this.handleIncludeExclude(m.excludePattern,m.expandPatterns),$=A.length>1,K=(w.searchPaths&&w.searchPaths.length?w.searchPaths.map(H=>this.getFolderQueryForSearchPath(H,m,R)):A.map(H=>this.getFolderQueryForRoot(H,m,R,$))).filter(H=>!!H),he={_reason:m._reason,folderQueries:K,usingSearchPaths:!!(w.searchPaths&&w.searchPaths.length),extraFileResources:m.extraFileResources,excludePattern:R.pattern,includePattern:w.pattern,onlyOpenEditors:m.onlyOpenEditors,maxResults:m.maxResults};if(m.onlyOpenEditors){const Y=b.coalesce(b.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(L=>L.resource)))).filter(F=>(0,c.pathIncludedInQuery)(he,F.fsPath)),U=this.commonQueryFromFileList(Y);return Object.assign(Object.assign({},he),U)}const V=m.extraFileResources&&m.extraFileResources.filter(H=>(0,c.pathIncludedInQuery)(he,H.fsPath));return he.extraFileResources=V&&V.length?V:void 0,he}commonQueryFromFileList(A){const m=[],w=new y.ResourceMap,R={};let $=!1;return A.forEach(K=>{var he,V;if(K.scheme!==D.Schemas.walkThrough)if((0,C.isAbsolutePath)(K)){const Y=(V=(he=this.workspaceContextService.getWorkspaceFolder(K))===null||he===void 0?void 0:he.uri)!==null&&V!==void 0?V:K.with({path:S.dirname(K.fsPath)});let U=w.get(Y);U||($=!0,U={folder:Y,includePattern:{}},m.push(U),w.set(Y,U));const F=S.relative(Y.fsPath,K.fsPath);(0,I.assertIsDefined)(U.includePattern)[F.replace(/\\/g,"/")]=!0}else K.fsPath&&($=!0,R[K.fsPath]=!0)}),{folderQueries:m,includePattern:R,usingSearchPaths:!0,excludePattern:$?void 0:{"**/*":!0}}}isCaseSensitive(A,m){if(m.isSmartCase){if(A.isRegExp){if(i.containsUppercaseCharacter(A.pattern,!0))return!0}else if(i.containsUppercaseCharacter(A.pattern))return!0}return!!A.isCaseSensitive}isMultiline(A){return A.isMultiline||A.isRegExp&&(0,d.isMultilineRegexSource)(A.pattern)||A.pattern.indexOf(`
`)>=0?!0:!!A.isMultiline}parseSearchPaths(A){const m=U=>S.isAbsolute(U)||/^\.\.?([\/\\]|$)/.test(U),R=(Array.isArray(A)?A:n(A)).map(U=>{const F=this.pathService.resolvedUserHome;return F?(0,T.untildify)(U,F.scheme===D.Schemas.file?F.fsPath:F.path):U}),$=k.groupBy(R,U=>m(U)?"searchPaths":"exprSegments"),K=($.exprSegments||[]).map(U=>i.rtrim(U,"/")).map(U=>i.rtrim(U,"\\")).map(U=>(U[0]==="."&&(U="*"+U),a(U))),he={},V=this.expandSearchPathPatterns($.searchPaths||[]);V&&V.length&&(he.searchPaths=V);const H=b.flatten(K),Y=t(...H);return Y&&(he.pattern=Y),he}getExcludesForFolder(A,m){return m.disregardExcludeSettings?void 0:(0,c.getExcludes)(A,!m.disregardSearchExcludeSettings)}expandSearchPathPatterns(A){if(!A||!A.length)return[];const m=b.flatten(A.map(R=>{let{pathPortion:$,globPortion:K}=f(R);K&&(K=u(K));const he=this.expandOneSearchPath($);return b.flatten(he.map(V=>this.resolveOneSearchPathPattern(V,K)))})),w=new Map;return m.forEach(R=>{const $=R.searchPath.toString(),K=w.get($);K?R.pattern&&(K.pattern=K.pattern||{},K.pattern[R.pattern]=!0):w.set($,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(w.values())}expandOneSearchPath(A){if(S.isAbsolute(A)){const m=this.workspaceContextService.getWorkspace().folders;return m[0]&&m[0].uri.scheme!==D.Schemas.file?[{searchPath:m[0].uri.with({path:A})}]:[{searchPath:h.URI.file(S.normalize(A))}]}if(this.workspaceContextService.getWorkbenchState()===2){const m=this.workspaceContextService.getWorkspace().folders[0].uri;if(A=s(A),A.startsWith("../")||A===".."){const R=S.posix.resolve(m.path,A);return[{searchPath:m.with({path:R})}]}const w=u(A);return[{searchPath:m,pattern:w}]}else{if(A==="./"||A===".\\")return[];{const m=A.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map($=>{const K=m.match(new RegExp(`^${$.name}(?:/(.*))?`));return K?{match:K,folder:$}:null}).filter(I.isDefined);if(R.length)return R.map($=>{const K=$.match[1];return{searchPath:$.folder.uri,pattern:K&&u(K)}});{const $=A.match(/\.[\/\\](.+)[\/\\]?/),K=$?$[1]:A,he=r.localize(0,null,K);throw new Error(he)}}}}resolveOneSearchPathPattern(A,m){const w=A.pattern&&m?`${A.pattern}/${m}`:A.pattern||m,R=[{searchPath:A.searchPath,pattern:w}];return w&&!w.endsWith("**")&&R.push({searchPath:A.searchPath,pattern:w+"/**"}),R}getFolderQueryForSearchPath(A,m,w){const R=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(A.searchPath),m,w,!1);return R?Object.assign(Object.assign({},R),{includePattern:A.pattern}):null}getFolderQueryForRoot(A,m,w,R){let $;const K=h.URI.isUri(A)?A:A.uri;if(w.searchPaths){const U=w.searchPaths.filter(F=>(0,C.isEqual)(F.searchPath,K))[0];if(U&&!U.pattern)return null;U&&($=U.pattern)}const he=this.configurationService.getValue({resource:K}),V=this.getExcludesForFolder(he,m),H=Object.assign(Object.assign({},V||{}),$||{}),Y=h.URI.isUri(A)?(0,C.basename)(A):A.name;return{folder:K,folderName:R?Y:void 0,excludePattern:Object.keys(H).length>0?H:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof m.disregardIgnoreFiles=="boolean"?m.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof m.disregardGlobalIgnoreFiles=="boolean"?m.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof m.ignoreSymlinks=="boolean"?m.ignoreSymlinks:!he.search.followSymlinks}}};l=je([Ke(0,o.IConfigurationService),Ke(1,v.IWorkspaceContextService),Ke(2,p.IEditorGroupsService),Ke(3,E.IPathService)],l),e.QueryBuilder=l;function f(_){const A=_.match(/[\*\{\}\(\)\[\]\?]/);if(A){const m=A.index,w=_.substr(0,m).match(/[/|\\][^/\\]*$/);if(w){let R=_.substr(0,w.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:_.substr((w.index||0)+1)}}}return{pathPortion:_}}function t(..._){return _.length?_.reduce((A,m)=>(A[m]=!0,A),Object.create(null)):void 0}function n(_){return P.splitGlobAware(_,",").map(A=>A.trim()).filter(A=>!!A.length)}function a(_){return[`**/${_}/**`,`**/${_}`].map(m=>m.replace(/\*\*\/\*\*/g,"**"))}function s(_){return _.replace(/\\/g,"/")}function u(_){return s(_).replace(/^\.\//,"").replace(/\/+$/g,"")}function g(_,A){_=b.distinct(_,R=>R.toString());const m=[],w=A.getWorkspace();return _&&_.forEach(R=>{let $;if(A.getWorkbenchState()===2)$=(0,C.relativePath)(w.folders[0].uri,R),$&&$!=="."&&($="./"+$);else{const K=A.getWorkspaceFolder(R);if(K){const he=K.name;if(w.folders.filter(H=>H.name===he).length===1){const H=(0,C.relativePath)(K.uri,R);H===""?$=`./${K.name}`:$=`./${K.name}/${H}`}else $=R.fsPath}}$&&m.push($)}),m}e.resolveResourcesForSearchIncludes=g}),define(ve[220],be([0,1,25,2,20,12,4,219,41,48]),function(J,e,b,k,P,T,y,D,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(o,v){const p=v.activationEvents;if(!p)return Promise.resolve(void 0);const E=[],c=[];for(const s of p)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||o.forceUsingSearch?c.push(u):E.push(u)}if(E.length===0&&c.length===0)return Promise.resolve(void 0);let l;const f=new Promise((s,u)=>{l=s}),t=s=>l({activationEvent:s}),n=Promise.all(E.map(s=>h(o,s,t))).then(()=>{}),a=d(o,v.identifier,c,t);return Promise.all([n,a]).then(()=>{l(void 0)}),f}e.checkActivateWorkspaceContainsExtension=I;async function h(o,v,p){for(const E of o.folders)if(await o.exists(b.joinPath(k.URI.revive(E),v))){p(`workspaceContains:${v}`);return}}async function d(o,v,p,E){if(p.length===0)return Promise.resolve(void 0);const c=new P.CancellationTokenSource,l=o.checkExists(o.folders,p,c.token),f=setTimeout(async()=>{c.cancel(),E(`workspaceContainsTimeout:${p.join(",")}`)},i);let t=!1;try{t=await l}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}c.dispose(),clearTimeout(f),t&&E(`workspaceContains:${p.join(",")}`)}function r(o,v,p,E){const c=o.get(y.IInstantiationService),l=o.get(S.ISearchService),t=c.createInstance(D.QueryBuilder).file(v.map(n=>(0,C.toWorkspaceFolder)(k.URI.revive(n))),{_reason:"checkExists",includePattern:p,exists:!0});return l.fileSearch(t,E).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=r});var it=this&&this.__classPrivateFieldSet||function(J,e,b,k,P){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?J!==e||!P:!e.has(J))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?P.call(J,b):P?P.value=b:e.set(J,b),b},Ue=this&&this.__classPrivateFieldGet||function(J,e,b,k){if(b==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?J!==e||!k:!e.has(J))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?k:b==="a"?k.call(J):k?k.value:e.get(J)};define(ve[35],be([0,1,132,14,80,25,11,6,22,2,18,5,34,185,78,30,33,183,12,26,24,161,7,67,4,27,79,15,65,70,40,3,220,74,162]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l,f,t,n,a,s,u,g,_,A,m,w,R,$,K){"use strict";var he,V,H;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,a.createDecorator)("IHostUtils");let Y=class Ln extends D.Disposable{constructor(M,x,G,X,ne,me,Le,We,Fe,ze){super();this._onDidChangeRemoteConnectionData=this._register(new w.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=x,this._extHostContext=G,this._initData=Le,this._extHostWorkspace=X,this._extHostConfiguration=ne,this._logService=me,this._extHostTunnelService=Fe,this._extHostTerminalService=ze,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new y.Barrier,this._readyToStartExtensionHost=new y.Barrier,this._readyToRunExtensions=new y.Barrier,this._eagerExtensionsActivated=new y.Barrier,this._registry=new p.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new r.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=We,this._instaService=M.createChild(new _.ServiceCollection([r.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const W=new Set;this._initData.hostExtensions.forEach(j=>W.add(c.ExtensionIdentifier.toKey(j))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(j,te,oe)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(j,E.transformErrorForSerialization(te),oe)},actualActivateExtension:async(j,te)=>{if(W.has(c.ExtensionIdentifier.toKey(j)))return await this._mainThreadExtensionsProxy.$activateExtension(j,te),new d.HostExtension;const oe=this._registry.getExtensionDescription(j);return this._activateExtension(oe,te)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),P.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){E.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(ne=>ne.identifier).filter(ne=>this.isActivated(ne)).map(ne=>this._deactivate(ne))}catch(x){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,x){return this._activator.activateByEvent(M,x)}_activateById(M,x){return this._activator.activateById(M,x)}activateByIdWithErrors(M,x){return this._activateById(M,x).then(()=>{const G=this._activator.getActivatedExtension(M);if(G.activationFailed)return Promise.reject(G.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=S.TernarySearchTree.forPaths(),x=this._registry.getAllExtensionDescriptions().map(G=>{if(!!this._getEntryPoint(G))return this._hostUtils.realpath(G.extensionLocation.fsPath).then(X=>M.set(C.URI.file(X).fsPath,G))});this._extensionPathIndex=Promise.all(x).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let x=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return x;const G=this._activator.getActivatedExtension(M);if(!G)return x;try{typeof G.module.deactivate=="function"&&(x=Promise.resolve(G.module.deactivate()).then(void 0,X=>Promise.resolve(void 0)))}catch(X){}try{(0,D.dispose)(G.subscriptions)}catch(X){}return x}async _activateExtension(M,x){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,x).then(G=>{const X=G.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,X.codeLoadingTime,X.activateCallTime,X.activateResolvedTime,x),this._logExtensionActivationTimes(M,x,"success",X),G},G=>{throw this._logExtensionActivationTimes(M,x,"failure"),G})}_logExtensionActivationTimes(M,x,G,X){const ne=U(M,x);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ne),X||{}),{outcome:G}))}_doActivateExtension(M,x){const G=U(M,x);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",G);const X=this._getEntryPoint(M);if(!X)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify(x)}`),this._logService.flush();const ne=new d.ExtensionActivationTimesBuilder(x.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,X),ne),this._loadExtensionContext(M)]).then(me=>(P.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),Ln._callActivate(this._logService,M.identifier,me[0],me[1],ne))).then(me=>(P.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),me))}_loadExtensionContext(M){const x=new f.ExtensionGlobalMemento(M,this._storage),G=new f.ExtensionMemento(M.identifier.value,!1,this._storage),X=new K.ExtensionSecrets(M,this._secretState),ne=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([x.whenReady,G.whenReady,this._storagePath.whenReady]).then(()=>{const Le=this;let We;return Object.freeze({globalState:x,workspaceState:G,secrets:X,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Fe){return k.join(M.extensionLocation.fsPath,Fe)},get storagePath(){var Fe;return(Fe=Le._storagePath.workspaceValue(M))===null||Fe===void 0?void 0:Fe.fsPath},get globalStoragePath(){return Le._storagePath.globalValue(M).fsPath},get logPath(){return k.join(Le._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return C.URI.joinPath(Le._initData.logsLocation,M.identifier.value)},get storageUri(){return Le._storagePath.workspaceValue(M)},get globalStorageUri(){return Le._storagePath.globalValue(M)},get extensionMode(){return ne},get extension(){return We===void 0&&(We=new F(Le,M.identifier,M,me)),We},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(M),Le.extensionRuntime},get environmentVariableCollection(){return Le._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,x,G,X,ne){return G=G||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,x,G,X,ne).then(me=>new d.ActivatedExtension(!1,null,ne.build(),G,me,X.subscriptions))}static _callActivateOptional(M,x,G,X,ne){if(typeof G.activate=="function")try{ne.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${x.value}`);const me=typeof global=="object"?global:self,Le=G.activate.apply(me,[X]);return ne.activateCallStop(),ne.activateResolveStart(),Promise.resolve(Le).then(We=>(ne.activateResolveStop(),We))}catch(me){return Promise.reject(me)}else return Promise.resolve(G)}_activateOneStartupFinished(M,x){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:x}).then(void 0,G=>{this._logService.error(G)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(P.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const x of M.activationEvents)x==="onStartupFinished"&&this._activateOneStartupFinished(M,x)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,ne=>{this._logService.error(ne)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ne=>this._handleWorkspaceContainsEagerExtensions(ne.added)));const x=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],G=this._handleWorkspaceContainsEagerExtensions(x),X=Promise.all([M,G]).then(()=>{});return Promise.race([X,(0,y.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),X}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(x=>this._handleWorkspaceContainsEagerExtension(M,x))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,x){if(!this.isActivated(x.identifier)){const G=!this._initData.remote.isRemote&&!!this._initData.remote.authority,X={folders:M.map(me=>me.uri),forceUsingSearch:G,exists:me=>this._hostUtils.exists(me.fsPath),checkExists:(me,Le,We)=>this._mainThreadWorkspaceProxy.$checkExists(me,Le,We)},ne=await(0,R.checkActivateWorkspaceContainsExtension)(X,x);if(!!ne)return this._activateById(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ne.activationEvent}).then(void 0,me=>this._logService.error(me))}}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:x}=this._initData.environment;if(!M||!x)throw new Error(b.localize(0,null));const G=await this._loadCommonJSModule(null,x,new d.ExtensionActivationTimesBuilder(!1));if(!G||typeof G.run!="function")throw new Error(b.localize(1,null,x.toString()));return new Promise((X,ne)=>{const me=(Fe,ze)=>{Fe?ne(Fe):X(typeof ze=="number"&&ze>0?1:0)},Le=(0,T.originalFSPath)(x),We=G.run(Le,me);We&&We.then&&We.then(()=>{X(0)}).catch(Fe=>{ne(Fe.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,x){return this._resolvers[M]=x,(0,D.toDisposable)(()=>{delete this._resolvers[M]})}async $resolveAuthority(M,x){const G=M.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const X=M.substr(0,G);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${X}`,!1);const ne=this._resolvers[X];if(!ne)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${X}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(ne)),P.mark(`code/extHost/willResolveAuthority/${X}`);const me=await ne.resolve(M,{resolveAttempt:x});P.mark(`code/extHost/didResolveAuthorityOK/${X}`);const Le={authority:M,host:me.host,port:me.port,connectionToken:me.connectionToken},We={extensionHostEnv:me.extensionHostEnv,trust:me.trust};return{type:"ok",value:{authority:Le,options:We,tunnelInformation:{environmentTunnels:me.environmentTunnels}}}}catch(me){if(P.mark(`code/extHost/didResolveAuthorityError/${X}`),me instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:me._code,message:me._message,detail:me._detail}};throw me}}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,x){return x===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(G=>this._activateByEvent(M,!1))}async $activate(M,x){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,x),!0):!1}async $deltaExtensions(M,x){M.forEach(X=>X.extensionLocation=C.URI.revive(X.extensionLocation));const G=await this.getExtensionPathIndex();return await Promise.all(x.map(async X=>{const ne=this._registry.getExtensionDescription(X);if(!!ne){const me=await this._hostUtils.realpath(ne.extensionLocation.fsPath);G.delete(C.URI.file(me).fsPath)}})),await Promise.all(M.map(async X=>{const ne=await this._hostUtils.realpath(X.extensionLocation.fsPath);G.set(C.URI.file(ne).fsPath,X)})),this._registry.deltaExtensions(M,x),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let x=l.VSBuffer.alloc(M),G=Math.random()%256;for(let X=0;X<M;X++)x.writeUInt8(G,X);return x}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};Y=je([Ke(0,a.IInstantiationService),Ke(1,e.IHostUtils),Ke(2,g.IExtHostRpcService),Ke(3,o.IExtHostWorkspace),Ke(4,h.IExtHostConfiguration),Ke(5,i.ILogService),Ke(6,s.IExtHostInitDataService),Ke(7,u.IExtensionStoragePaths),Ke(8,A.IExtHostTunnelService),Ke(9,m.IExtHostTerminalService)],Y),e.AbstractExtHostExtensionService=Y;function U(L,M){return{id:L.identifier.value,name:L.name,extensionVersion:L.version,publisherDisplayName:L.publisher,activationEvents:L.activationEvents?L.activationEvents.join(","):null,isBuiltin:L.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,a.createDecorator)("IExtHostExtensionService");class F{constructor(M,x,G,X){he.set(this,void 0),V.set(this,void 0),H.set(this,void 0),it(this,he,M,"f"),it(this,V,x,"f"),it(this,H,G.identifier,"f"),this.id=G.identifier.value,this.extensionUri=G.extensionLocation,this.extensionPath=k.normalize((0,T.originalFSPath)(G.extensionLocation)),this.packageJSON=G,this.extensionKind=X}get isActive(){return Ue(this,he,"f").isActivated(Ue(this,H,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,he,"f").getExtensionExports(Ue(this,H,"f"))}activate(){return Ue(this,he,"f").activateByIdWithErrors(Ue(this,H,"f"),{startup:!1,extensionId:Ue(this,V,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=F,he=new WeakMap,V=new WeakMap,H=new WeakMap}),define(ve[104],be([0,1,14,2,3,11,5,7,169,30,35,39,173,34,170,15,4,10,46]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let c=class{constructor(g,_,A,m,w){this._workspaceService=_,this._extensionService=A,this._editorsService=m,this._configurationService=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new P.Emitter,this._onDidTerminateDebugSession=new P.Emitter,this._onDidChangeActiveDebugSession=new P.Emitter,this._onDidReceiveDebugSessionCustomEvent=new P.Emitter,this._debugServiceProxy=g.getProxy(y.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new P.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new f(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(R=>{R.onDidChange($=>{this.registerAllDebugTypes(R)}),this.registerAllDebugTypes(R)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(g,_){const A=g;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let m=`debug:${encodeURIComponent(A.path||"")}`,w="?";return _&&(m+=`${w}session=${encodeURIComponent(_.id)}`,w="&"),m+=`${w}ref=${A.sourceReference}`,k.URI.parse(m)}else{if(A.path)return k.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(g){const _=[];for(const A of g.getAllExtensionDescriptions())if(A.contributes){const m=A.contributes.debuggers;if(m&&m.length>0)for(const w of m)(0,r.isDebuggerMainContribution)(w)&&_.push(w.type)}this._debugServiceProxy.$registerDebugTypes(_)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const g=[];return this._breakpoints.forEach(_=>g.push(_)),g}addBreakpoints(g){this.startBreakpoints();const _=g.filter(w=>{const R=w.id;return this._breakpoints.has(R)?!1:(this._breakpoints.set(R,w),!0)});this.fireBreakpointChanges(_,[],[]);const A=[],m=new Map;for(const w of _)if(w instanceof D.SourceBreakpoint){let R=m.get(w.location.uri.toString());R||(R={type:"sourceMulti",uri:w.location.uri,lines:[]},m.set(w.location.uri.toString(),R),A.push(R)),R.lines.push({id:w.id,enabled:w.enabled,condition:w.condition,hitCondition:w.hitCondition,logMessage:w.logMessage,line:w.location.range.start.line,character:w.location.range.start.character})}else w instanceof D.FunctionBreakpoint&&A.push({type:"function",id:w.id,enabled:w.enabled,hitCondition:w.hitCondition,logMessage:w.logMessage,condition:w.condition,functionName:w.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(g){this.startBreakpoints();const _=g.filter(R=>this._breakpoints.delete(R.id));this.fireBreakpointChanges([],_,[]);const A=_.filter(R=>R instanceof D.SourceBreakpoint).map(R=>R.id),m=_.filter(R=>R instanceof D.FunctionBreakpoint).map(R=>R.id),w=_.filter(R=>R instanceof D.DataBreakpoint).map(R=>R.id);return this._debugServiceProxy.$unregisterBreakpoints(A,m,w)}startDebugging(g,_,A){return this._debugServiceProxy.$startDebugging(g?g.uri:void 0,_,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(g){return this._debugServiceProxy.$stopDebugging(g?g.id:void 0)}registerDebugConfigurationProvider(g,_,A){if(!_)return new D.Disposable(()=>{});const m=this._configProviderHandleCounter++;return this._configProviders.push({type:g,handle:m,provider:_}),this._debugServiceProxy.$registerDebugConfigurationProvider(g,A,!!_.provideDebugConfigurations,!!_.resolveDebugConfiguration,!!_.resolveDebugConfigurationWithSubstitutedVariables,m),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(w=>w.provider!==_),this._debugServiceProxy.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(g,_,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(g,_))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${_}' debugger.`);if(this.getAdapterDescriptorFactoryByType(_))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:_,handle:m,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(_,m),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(w=>w.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(g,_){if(!_)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:g,handle:A,factory:_}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(m=>m.factory!==_)})}async $runInTerminal(g,_){return Promise.resolve(void 0)}async $substituteVariables(g,_){if(!this._variableResolver){const[w,R]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(w||[],this._editorsService,R)}let A;const m=await this.getFolder(g);return m&&(A={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,_)}createDebugAdapter(g,_){if(g.type==="implementation")return new a(g.implementation)}createSignService(){}async $startDASession(g,_){const A=this,m=await this.getSession(_);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(m.type),m).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const R=this.convertToDto(w),$=this.createDebugAdapter(R,m);if(!$)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const K=$;return this._debugAdapters.set(g,K),this.getDebugAdapterTrackers(m).then(he=>(he&&this._debugAdaptersTrackers.set(g,he),K.onMessage(async V=>{if(V.type==="request"&&V.command==="handshake"){const H=V,Y={type:"response",seq:0,command:H.command,request_seq:H.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const U=await this._signService.sign(H.arguments.value);Y.body={signature:U},K.sendResponse(Y)}else throw new Error("no signer")}catch(U){Y.success=!1,Y.message=U.message,K.sendResponse(Y)}}else he&&he.onDidSendMessage&&he.onDidSendMessage(V),V=(0,r.convertToVSCPaths)(V,!0),A._debugServiceProxy.$acceptDAMessage(g,V)}),K.onError(V=>{he&&he.onError&&he.onError(V),this._debugServiceProxy.$acceptDAError(g,V.name,V.message,V.stack)}),K.onExit(V=>{he&&he.onExit&&he.onExit((0,p.withNullAsUndefined)(V),void 0),this._debugServiceProxy.$acceptDAExit(g,(0,p.withNullAsUndefined)(V),void 0)}),he&&he.onWillStartSession&&he.onWillStartSession(),K.startSession()))})}$sendDAMessage(g,_){_=(0,r.convertToDAPaths)(_,!1);const A=this._debugAdaptersTrackers.get(g);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(_);const m=this._debugAdapters.get(g);m&&m.sendMessage(_)}$stopDASession(g){const _=this._debugAdaptersTrackers.get(g);this._debugAdaptersTrackers.delete(g),_&&_.onWillStopSession&&_.onWillStopSession();const A=this._debugAdapters.get(g);return this._debugAdapters.delete(g),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(g){const _=[],A=[],m=[];if(g.added)for(const w of g.added){const R=w.id;if(R&&!this._breakpoints.has(R)){let $;if(w.type==="function")$=new D.FunctionBreakpoint(w.functionName,w.enabled,w.condition,w.hitCondition,w.logMessage);else if(w.type==="data")$=new D.DataBreakpoint(w.label,w.dataId,w.canPersist,w.enabled,w.hitCondition,w.condition,w.logMessage);else{const K=k.URI.revive(w.uri);$=new D.SourceBreakpoint(new D.Location(K,new D.Position(w.line,w.character)),w.enabled,w.condition,w.hitCondition,w.logMessage)}$._id=R,this._breakpoints.set(R,$),_.push($)}}if(g.removed)for(const w of g.removed){const R=this._breakpoints.get(w);R&&(this._breakpoints.delete(w),A.push(R))}if(g.changed){for(const w of g.changed)if(w.id){const R=this._breakpoints.get(w.id);if(R){if(R instanceof D.FunctionBreakpoint&&w.type==="function"){const $=R;$.enabled=w.enabled,$.condition=w.condition,$.hitCondition=w.hitCondition,$.logMessage=w.logMessage,$.functionName=w.functionName}else if(R instanceof D.SourceBreakpoint&&w.type==="source"){const $=R;$.enabled=w.enabled,$.condition=w.condition,$.hitCondition=w.hitCondition,$.logMessage=w.logMessage,$.location=new D.Location(k.URI.revive(w.uri),new D.Position(w.line,w.character))}m.push(R)}}}this.fireBreakpointChanges(_,A,m)}$provideDebugConfigurations(g,_,A){return(0,T.asPromise)(async()=>{const m=this.getConfigProviderByHandle(g);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const w=await this.getFolder(_);return m.provideDebugConfigurations(w,A)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(g,_,A,m){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(g);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const R=await this.getFolder(_);return w.resolveDebugConfiguration(R,A,m)})}$resolveDebugConfigurationWithSubstitutedVariables(g,_,A,m){return(0,T.asPromise)(async()=>{const w=this.getConfigProviderByHandle(g);if(!w)throw new Error("no DebugConfigurationProvider found");if(!w.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const R=await this.getFolder(_);return w.resolveDebugConfigurationWithSubstitutedVariables(R,A,m)})}async $provideDebugAdapter(g,_){const A=this.getAdapterDescriptorFactoryByHandle(g);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.getSession(_);return this.getAdapterDescriptor(A,m).then(w=>{if(!w)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.convertToDto(w)})}async $acceptDebugSessionStarted(g){const _=await this.getSession(g);this._onDidStartDebugSession.fire(_)}async $acceptDebugSessionTerminated(g){const _=await this.getSession(g);_&&(this._onDidTerminateDebugSession.fire(_),this._debugSessions.delete(_.id))}async $acceptDebugSessionActiveChanged(g){this._activeDebugSession=g?await this.getSession(g):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(g,_){const A=await this.getSession(g);A&&A._acceptNameChanged(_)}async $acceptDebugSessionCustomEvent(g,_){const m={session:await this.getSession(g),event:_.event,body:_.body};this._onDidReceiveDebugSessionCustomEvent.fire(m)}convertToDto(g){if(g instanceof D.DebugAdapterExecutable)return{type:"executable",command:g.command,args:g.args,options:g.options};if(g instanceof D.DebugAdapterServer)return{type:"server",port:g.port,host:g.host};if(g instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:g.path};if(g instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:g.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(g){const _=this._adapterFactories.filter(A=>A.type===g);if(_.length>0)return _[0].factory}getAdapterDescriptorFactoryByHandle(g){const _=this._adapterFactories.filter(A=>A.handle===g);if(_.length>0)return _[0].factory}getConfigProviderByHandle(g){const _=this._configProviders.filter(A=>A.handle===g);if(_.length>0)return _[0].provider}definesDebugType(g,_){if(g.contributes){const A=g.contributes.debuggers;if(A&&A.length>0){for(const m of A)if(m.label&&m.type&&m.type===_)return!0}}return!1}getDebugAdapterTrackers(g){const A=g.configuration.type,m=this._trackerFactories.filter(w=>w.type===A||w.type==="*").map(w=>(0,T.asPromise)(()=>w.factory.createDebugAdapterTracker(g)).then(R=>R,R=>null));return Promise.race([Promise.all(m).then(w=>{const R=w.filter($=>!!$);if(R.length>0)return new n(R)}),new Promise((w,R)=>{const $=setTimeout(()=>{clearTimeout($),R(new Error("timeout"))},1e3)})]).catch(w=>{})}async getAdapterDescriptor(g,_){const A=_.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(g){const w=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>g.createDebugAdapterDescriptor(_,this.daExecutableFromPackage(_,w))).then(R=>{if(R)return R})}const m=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(_,m))}daExecutableFromPackage(g,_){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(g,_,A){(g.length>0||_.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:g,removed:_,changed:A}))}async getSession(g){if(g)if(typeof g=="string"){const _=this._debugSessions.get(g);if(_)return _}else{let _=this._debugSessions.get(g.id);if(!_){const A=await this.getFolder(g.folderUri);_=new l(this._debugServiceProxy,g.id,g.type,g.name,A,g.configuration),this._debugSessions.set(_.id,_),this._debugServiceProxy.$sessionCached(_.id)}return _}throw new Error("cannot find session")}getFolder(g){if(g){const _=k.URI.revive(g);return this._workspaceService.resolveWorkspaceFolder(_)}return Promise.resolve(void 0)}};c=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,d.IExtHostConfiguration)],c),e.ExtHostDebugServiceBase=c;class l{constructor(g,_,A,m,w,R){this._debugServiceProxy=g,this._id=_,this._type=A,this._name=m,this._workspaceFolder=w,this._configuration=R}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(g){this._name=g,this._debugServiceProxy.$setDebugSessionName(this._id,g)}_acceptNameChanged(g){this._name=g}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(g,_){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,g,_)}getDebugProtocolBreakpoint(g){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,g.id)}}e.ExtHostDebugSession=l;class f{constructor(g){this.value=Object.freeze({append(_){g.$appendDebugConsole(_)},appendLine(_){this.append(_+`
`)}})}}e.ExtHostDebugConsole=f;class t extends h.AbstractVariableResolverService{constructor(g,_,A,m){super({getFolderUri:w=>{const R=g.filter($=>$.name===w);if(R&&R.length>0)return R[0].uri},getWorkspaceFolderCount:()=>g.length,getConfigurationValue:(w,R)=>A.getConfiguration(void 0,w).get(R),getAppRoot:()=>E.cwd(),getExecPath:()=>E.env.VSCODE_EXEC_PATH,getFilePath:()=>{if(_){const w=_.activeEditor();if(w)return b.normalize(w.document.uri.fsPath)}},getWorkspaceFolderPathForFile:()=>{if(_&&m){const w=_.activeEditor();if(w){const R=m.getWorkspaceFolder(w.document.uri);if(R)return b.normalize(R.uri.fsPath)}}},getSelectedText:()=>{if(_){const w=_.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(_){const w=_.activeEditor();if(w)return String(w.selection.end.line+1)}}},void 0,Promise.resolve(E.env))}}e.ExtHostVariableResolverService=t;class n{constructor(g){this.trackers=g}onWillStartSession(){this.trackers.forEach(g=>g.onWillStartSession?g.onWillStartSession():void 0)}onWillReceiveMessage(g){this.trackers.forEach(_=>_.onWillReceiveMessage?_.onWillReceiveMessage(g):void 0)}onDidSendMessage(g){this.trackers.forEach(_=>_.onDidSendMessage?_.onDidSendMessage(g):void 0)}onWillStopSession(){this.trackers.forEach(g=>g.onWillStopSession?g.onWillStopSession():void 0)}onError(g){this.trackers.forEach(_=>_.onError?_.onError(g):void 0)}onExit(g,_){this.trackers.forEach(A=>A.onExit?A.onExit(g,_):void 0)}}class a extends S.AbstractDebugAdapter{constructor(g){super();this.implementation=g,g.onDidSendMessage(_=>{this.acceptMessage(_)})}startSession(){return Promise.resolve(void 0)}sendMessage(g){this.implementation.handleMessage(g)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends c{constructor(g,_,A,m,w){super(g,_,A,m,w)}createVariableResolver(g,_,A){return new t(g,_,A)}};s=je([Ke(0,o.IExtHostRpcService),Ke(1,C.IExtHostWorkspace),Ke(2,i.IExtHostExtensionService),Ke(3,I.IExtHostDocumentsAndEditors),Ke(4,d.IExtHostConfiguration)],s),e.WorkerExtHostDebugService=s}),define(ve[221],be([0,1,80,2,5,34,33,26,15,27,4,35,46,18]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let r=class{constructor(c,l,f,t,n,a,s){this._apiFactory=c,this._extensionRegistry=l,this._instaService=f,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=a,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),b.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const l=await this._extHostExtensionService.getExtensionPathIndex();this.register(new o(this._apiFactory,l,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(p,l,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let l of c.nodeModuleName)this._factories.set(l,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(l=>c.alternativeModuleName(l))}};r=je([Ke(2,i.IInstantiationService),Ke(3,T.IExtHostConfiguration),Ke(4,I.IExtHostExtensionService),Ke(5,C.IExtHostInitDataService),Ke(6,d.ILogService)],r),e.RequireInterceptor=r;class o{constructor(c,l,f,t,n){this._apiFactory=c,this._extensionPaths=l,this._extensionRegistry=f,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,l){const f=this._extensionPaths.findSubstr(l.fsPath);if(f){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(f.identifier));return t||(t=this._apiFactory(f,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(f.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,a)=>t+=`	${a} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${l.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(y.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(c,l){this.nodeModuleName="keytar";const{environment:f}=l,t=c.getProxy(P.MainContext.MainThreadKeytar);if(f.appRoot){let n=f.appRoot.fsPath;h.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,a)=>t.$getPassword(n,a),setPassword:(n,a,s)=>t.$setPassword(n,a,s),deletePassword:(n,a)=>t.$deletePassword(n,a),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(c,l){return this._impl}alternativeModuleName(c){const l=c.length;if(!(l<=7||!this.alternativeNames)){const f=l-7;if((c.charAt(f)==="/"||c.charAt(f)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}}};v=je([Ke(0,S.IExtHostRpcService),Ke(1,C.IExtHostInitDataService)],v);let p=class{constructor(c,l,f){this._extensionPaths=c,this._appUriScheme=l,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=f.getProxy(P.MainContext.MainThreadTelemetry);const t=f.getProxy(P.MainContext.MainThreadWindow);this._impl=(n,a)=>{const s=k.URI.parse(n);return a?this.callOriginal(n,a):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,a)}}load(c,l,f){const t=this._extensionPaths.findSubstr(l.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=f(c),this._impl}callOriginal(c,l){return this.sendNoForwardTelemetry(),this._original(c,l)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};p=je([Ke(2,S.IExtHostRpcService)],p)}),define(ve[222],be([0,1,11,12,80,6,2,5,214,18,61,65,27,151,15,71,35,40]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class E{constructor(l,f,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t;const a=new S.RPCProtocol(l,null,n);f=E._transform(f,a);const s=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());s.set(h.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},f)),s.set(r.IExtHostRpcService,new r.ExtHostRpcService(a)),s.set(o.IURITransformerService,new o.URITransformerService(n)),s.set(v.IHostUtils,t);const u=new d.InstantiationService(s,!0),g=u.invokeFunction(w=>w.get(p.IExtHostTerminalService));this._disposables.add(g),this._logService=u.invokeFunction(w=>w.get(C.ILogService)),P.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",f),this._extensionService=u.invokeFunction(w=>w.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const _=new WeakMap;this._extensionService.getExtensionPathIndex().then(w=>{Error.prepareStackTrace=(R,$)=>{let K="",he,V;for(const H of $)K+=`
	at ${H.toString()}`,V=H.getFileName(),!he&&V&&(he=w.findSubstr(V));return _.set(R,he),`${R.name||"Error"}: ${R.message||""}${K}`}});const A=a.getProxy(D.MainContext.MainThreadExtensionService),m=a.getProxy(D.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(w=>{const R=k.transformErrorForSerialization(w),$=_.get(w);$?A.$onExtensionRuntimeError($.identifier,R):m.$onUnexpectedError(R)})}terminate(l){if(!this._isTerminating){this._isTerminating=!0,this._logService.info(`extension host terminating: ${l}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(t=>{});const f=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,b.timeout)(4e3),f]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}}static _transform(l,f){l.extensions.forEach(n=>n.extensionLocation=y.URI.revive(f.transformIncomingURIs(n.extensionLocation))),l.environment.appRoot=y.URI.revive(f.transformIncomingURIs(l.environment.appRoot));const t=l.environment.extensionDevelopmentLocationURI;return t&&(l.environment.extensionDevelopmentLocationURI=t.map(n=>y.URI.revive(f.transformIncomingURIs(n)))),l.environment.extensionTestsLocationURI=y.URI.revive(f.transformIncomingURIs(l.environment.extensionTestsLocationURI)),l.environment.globalStorageHome=y.URI.revive(f.transformIncomingURIs(l.environment.globalStorageHome)),l.environment.workspaceStorageHome=y.URI.revive(f.transformIncomingURIs(l.environment.workspaceStorageHome)),l.logsLocation=y.URI.revive(f.transformIncomingURIs(l.logsLocation)),l.logFile=y.URI.revive(f.transformIncomingURIs(l.logFile)),l.workspace=f.transformIncomingURIs(l.workspace),l}}e.ExtensionHostMain=E}),define(ve[223],be([0,1,14,20,60,28,25,55,41]),function(J,e,b,k,P,T,y,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(h,d,r){this.config=h,this.provider=d,this.sessionToken=r,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=h.filePattern,this.includePattern=h.includePattern&&T.parse(h.includePattern),this.maxResults=h.maxResults||void 0,this.exists=h.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=h.excludePattern&&T.parse(h.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(h=>h.cancel()),this.activeCancellationTokens=new Set}search(h){const d=this.config.folderQueries||[];return new Promise((r,o)=>{const v=p=>{this.resultCount++,h(p)};if(this.isCanceled)return r({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(p=>{const E=p.toString(),c=b.basename(E);this.globalExcludePattern&&this.globalExcludePattern(E,c)||this.matchFile(v,{base:p,basename:c})}),Promise.all(d.map(p=>this.searchInFolder(p,v))).then(p=>{r({limitHit:this.isLimitHit,stats:p[0]||void 0})},p=>{o(new Error((0,P.toErrorMessage)(p)))})})}async searchInFolder(h,d){const r=new k.CancellationTokenSource,o=this.getSearchOptionsForFolder(h),v=this.initDirectoryTree(),p=new S.QueryGlobTester(this.config,h),E=!p.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(r),c=D.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},o,r.token),f=c.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(n=>{const a=b.posix.relative(h.folder.path,n.path);if(E){const s=b.basename(n.path);this.matchFile(d,{base:h.folder,relativePath:a,basename:s});return}this.addDirectoryEntries(v,h.folder,a,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,p,d),{providerTime:f,postProcessTime:t.elapsed()})}finally{r.dispose(),this.activeCancellationTokens.delete(r)}}getSearchOptionsForFolder(h){const d=(0,S.resolvePatternsForProvider)(this.config.includePattern,h.includePattern),r=(0,S.resolvePatternsForProvider)(this.config.excludePattern,h.excludePattern);return{folder:h.folder,excludes:r,includes:d,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,followSymlinks:!h.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const h={rootEntries:[],pathToEntries:Object.create(null)};return h.pathToEntries["."]=h.rootEntries,h}addDirectoryEntries({pathToEntries:h},d,r,o){if(r===this.filePattern){const p=b.basename(this.filePattern);this.matchFile(o,{base:d,relativePath:this.filePattern,basename:p})}function v(p){const E=b.basename(p),c=b.dirname(p);let l=h[c];l||(l=h[c]=[],v(c)),l.push({base:d,relativePath:p,basename:E})}v(r)}matchDirectoryTree({rootEntries:h,pathToEntries:d},r,o){const v=this,p=this.filePattern;function E(c){const l=T.hasSiblingFn(()=>c.map(f=>f.basename));for(let f=0,t=c.length;f<t;f++){const n=c[f],{relativePath:a,basename:s}=n;if(!!r.includedInQuerySync(a,s,p!==s?l:void 0)){const u=d[a];if(u)E(u);else{if(a===p)continue;v.matchFile(o,n)}if(v.isLimitHit)break}}}E(h)}matchFile(h,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||h(d))}}class i{constructor(){this.sessions=new Map}fileSearch(h,d,r,o){const v=this.getSessionTokenSource(h.cacheKey),p=new C(h,d,v&&v.token);let E=0;const c=l=>{E+=l.length,r(l.map(f=>this.rawMatchToSearchItem(f)))};return this.doSearch(p,i.BATCH_SIZE,c,o).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:E,detailStats:l.stats}}))}clearCache(h){const d=this.getSessionTokenSource(h);d&&d.cancel()}getSessionTokenSource(h){if(!!h)return this.sessions.has(h)||this.sessions.set(h,new k.CancellationTokenSource),this.sessions.get(h)}rawMatchToSearchItem(h){return h.relativePath?{resource:y.joinPath(h.base,h.relativePath)}:{resource:h.base}}doSearch(h,d,r,o){o.onCancellationRequested(()=>{h.cancel()});const v=E=>{E&&(p.push(E),d>0&&p.length>=d&&(r(p),p=[]))};let p=[];return h.search(v).then(E=>(p.length&&r(p),E),E=>(p.length&&r(p),Promise.reject(E)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(ve[224],be([0,1,14,13,20,60,25,28,2,41,19,10]),function(J,e,b,k,P,T,y,D,S,C,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class h{constructor(c,l,f){this.query=c,this.provider=l,this.fileUtils=f,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,l){const f=this.query.folderQueries||[],t=new P.CancellationTokenSource;return l.onCancellationRequested(()=>t.cancel()),new Promise((n,a)=>{this.collector=new r(c);let s=!1;const u=(g,_)=>{if(!s&&!this.isLimitHit){const A=this.resultSize(g);v(g)&&typeof this.query.maxResults=="number"&&this.resultCount+A>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),g=this.trimResultToSize(g,this.query.maxResults-this.resultCount));const m=this.resultSize(g);this.resultCount+=m,(m>0||!v(g))&&this.collector.add(g,_)}};Promise.all(f.map((g,_)=>this.searchInFolder(g,A=>u(A,_),t.token))).then(g=>{t.dispose(),this.collector.flush();const _=g.some(A=>!!A&&!!A.limitHit);n({limitHit:this.isLimitHit||_,messages:(0,k.flatten)(g.map(A=>(A==null?void 0:A.message)?(0,I.isArray)(A.message)?A.message:[A.message]:[])),stats:{type:"textSearchProvider"}})},g=>{t.dispose();const _=(0,T.toErrorMessage)(g);a(new Error(_))})})}resultSize(c){return v(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,l){const f=Array.isArray(c.ranges)?c.ranges:[c.ranges],t=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:f.slice(0,l),preview:{matches:t.slice(0,l),text:c.preview.text},uri:c.uri}}async searchInFolder(c,l,f){const t=new C.QueryGlobTester(this.query,c),n=[],a={report:g=>{if(!!this.validateProviderResult(g)){const _=c.folder.scheme===i.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(y.dirname(g.uri))):void 0,A=y.relativePath(c.folder,g.uri);A&&n.push(t.includedInQuery(A,b.basename(A),_).then(m=>{m&&l(g)}))}}},s=this.getSearchOptionsForFolder(c),u=await this.provider.provideTextSearchResults(d(this.query.contentPattern),s,a,f);return await Promise.all(n),u}validateProviderResult(c){if(v(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const l=(0,C.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),f=(0,C.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),t={folder:S.URI.from(c.folder),excludes:f,includes:l,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=h;function d(E){return{isCaseSensitive:E.isCaseSensitive||!1,isRegExp:E.isRegExp||!1,isWordMatch:E.isWordMatch||!1,isMultiline:E.isMultiline||!1,pattern:E.pattern}}class r{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,l=>this.sendItems(l))}add(c,l){this._currentFileMatch&&(this._currentFolderIdx!==l||!y.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=l,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(o(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=r;function o(E){return v(E)?{preview:{matches:(0,k.mapArrayOrNot)(E.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:E.preview.text},ranges:(0,k.mapArrayOrNot)(E.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:E.text,lineNumber:E.lineNumber}}function v(E){return!!E.preview}e.extensionResultIsMatch=v;class p{constructor(c,l){this.maxBatchSize=c,this.cb=l,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,l){!c||this.addItemToBatch(c,l)}addItems(c,l){!c||this.addItemsToBatch(c,l)}addItemToBatch(c,l){this.batch.push(c),this.batchSize+=l,this.onUpdate()}addItemsToBatch(c,l){this.batch=this.batch.concat(c),this.batchSize+=l,this.onUpdate()}onUpdate(){this.totalNumberCompleted<p.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},p.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=p,p.TIMEOUT=4e3,p.START_BATCH_AFTER_COUNT=50}),define(ve[105],be([0,1,6,5,4,223,15,71,18,2,224]),function(J,e,b,k,P,T,y,D,S,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,P.createDecorator)("IExtHostSearch");let I=class{constructor(o,v,p){this.extHostRpc=o,this._uriTransformer=v,this._logService=p,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(o){return this._uriTransformer.transformOutgoingScheme(o)}registerTextSearchProvider(o,v){if(this._textSearchUsedSchemes.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this._textSearchUsedSchemes.add(o);const p=this._handlePool++;return this._textSearchProvider.set(p,v),this._proxy.$registerTextSearchProvider(p,this._transformScheme(o)),(0,b.toDisposable)(()=>{this._textSearchUsedSchemes.delete(o),this._textSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}registerFileSearchProvider(o,v){if(this._fileSearchUsedSchemes.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this._fileSearchUsedSchemes.add(o);const p=this._handlePool++;return this._fileSearchProvider.set(p,v),this._proxy.$registerFileSearchProvider(p,this._transformScheme(o)),(0,b.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(o),this._fileSearchProvider.delete(p),this._proxy.$unregisterProvider(p)})}$provideFileSearchResults(o,v,p,E){const c=h(p),l=this._fileSearchProvider.get(o);if(l)return this._fileSearchManager.fileSearch(c,l,f=>{this._proxy.$handleFileMatch(o,v,f.map(t=>t.resource))},E);throw new Error("unknown provider: "+o)}$clearCache(o){return this._fileSearchManager.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,v,p,E){const c=this._textSearchProvider.get(o);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const l=h(p);return this.createTextSearchManager(l,c).search(t=>this._proxy.$handleTextMatch(o,v,t),E)}createTextSearchManager(o,v){return new i.TextSearchManager(o,v,{readdir:p=>Promise.resolve([]),toCanonicalName:p=>p})}};I=je([Ke(0,y.IExtHostRpcService),Ke(1,D.IURITransformerService),Ke(2,S.ILogService)],I),e.ExtHostSearch=I;function h(r){return Object.assign(Object.assign({},r),{folderQueries:r.folderQueries&&r.folderQueries.map(d),extraFileResources:r.extraFileResources&&r.extraFileResources.map(o=>C.URI.revive(o))})}e.reviveQuery=h;function d(r){return Object.assign(Object.assign({},r),{folder:C.URI.revive(r.folder)})}}),define(ve[225],be([0,1,130,20,12,3,47,2,123,85,117,59,64,5,190,189,76,191,34,192,193,194,176,195,39,35,196,177,198,199,200,100,180,203,204,205,78,40,206,181,9,7,209,50,101,30,33,51,166,197,93,99,103,104,105,18,71,15,27,201,164,70,75,187,207,163,79,77,212,210,211,188,49,218,208,74,160,94,202,67,102]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l,f,t,n,a,s,u,g,_,A,m,w,R,$,K,he,V,H,Y,U,F,L,M,x,G,X,ne,me,Le,We,Fe,ze,W,j,te,oe,de,_e,Be,fe,De,Re,He,we,qe,z,ee,ge,Ne,Ve,$e,Ze,ye,Ee,Ce,re,le,N,Q,ae,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ie(Ae){const xe=Ae.get(Be.IExtHostInitDataService),Ye=Ae.get(ye.IExtHostFileSystemInfo),rt=Ae.get(ge.IExtHostConsumerFileSystem),tt=Ae.get(s.IExtHostExtensionService),Qe=Ae.get(X.IExtHostWorkspace),mt=Ae.get(N.IExtHostTelemetry),bt=Ae.get(E.IExtHostConfiguration),pe=Ae.get(de.IURITransformerService),ce=Ae.get(_e.IExtHostRpcService),se=Ae.get(V.IExtHostStorage),q=Ae.get(ee.IExtensionStoragePaths),Me=Ae.get(oe.ILogService),Te=Ae.get(Re.IExtHostTunnelService),Je=Ae.get(He.IExtHostApiDeprecationService),et=Ae.get(G.IExtHostWindow),ct=Ae.get(re.IExtHostSecretState);ce.set(d.ExtHostContext.ExtHostFileSystemInfo,Ye),ce.set(d.ExtHostContext.ExtHostLogService,Me),ce.set(d.ExtHostContext.ExtHostWorkspace,Qe),ce.set(d.ExtHostContext.ExtHostConfiguration,bt),ce.set(d.ExtHostContext.ExtHostExtensionService,tt),ce.set(d.ExtHostContext.ExtHostStorage,se),ce.set(d.ExtHostContext.ExtHostTunnelService,Te),ce.set(d.ExtHostContext.ExtHostWindow,et),ce.set(d.ExtHostContext.ExtHostSecretState,ct),ce.set(d.ExtHostContext.ExtHostTelemetry,mt);const ht=ce.set(d.ExtHostContext.ExtHostDecorations,Ae.get(ze.IExtHostDecorations)),Xe=ce.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Ae.get(a.IExtHostDocumentsAndEditors)),at=ce.set(d.ExtHostContext.ExtHostCommands,Ae.get(v.IExtHostCommands)),ft=ce.set(d.ExtHostContext.ExtHostTerminalService,Ae.get(H.IExtHostTerminalService)),lt=ce.set(d.ExtHostContext.ExtHostDebugService,Ae.get(j.IExtHostDebugService)),Et=ce.set(d.ExtHostContext.ExtHostSearch,Ae.get(te.IExtHostSearch)),vt=ce.set(d.ExtHostContext.ExtHostTask,Ae.get(W.IExtHostTask)),kt=ce.set(d.ExtHostContext.ExtHostOutputService,Ae.get(w.IExtHostOutputService)),At=ce.set(d.ExtHostContext.ExtHostEditorTabs,new le.ExtHostEditorTabs),Tt=ce.set(d.ExtHostContext.ExtHostUrls,new M.ExtHostUrls(ce)),_t=ce.set(d.ExtHostContext.ExtHostDocuments,new n.ExtHostDocuments(ce,Xe)),Yt=ce.set(d.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(ce,Xe,Me)),Jt=ce.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(Me,_t,ce.getProxy(d.MainContext.MainThreadBulkEdits))),gt=ce.set(d.ExtHostContext.ExtHostNotebook,new fe.ExtHostNotebookController(ce,at,Xe,_t,Me,q)),Xt=ce.set(d.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(ce,xe,gt)),St=ce.set(d.ExtHostContext.ExtHostEditors,new Y.ExtHostEditors(ce,Xe)),jt=ce.set(d.ExtHostContext.ExtHostTreeViews,new U.ExtHostTreeViews(ce.getProxy(d.MainContext.MainThreadTreeViews),at,Me)),Zt=ce.set(d.ExtHostContext.ExtHostEditorInsets,new Le.ExtHostEditorInsets(ce.getProxy(d.MainContext.MainThreadEditorInsets),St,xe.environment)),qt=ce.set(d.ExtHostContext.ExtHostDiagnostics,new c.ExtHostDiagnostics(ce,Me)),ut=ce.set(d.ExtHostContext.ExtHostLanguageFeatures,new _.ExtHostLanguageFeatures(ce,pe,_t,at,qt,Me,Je)),en=ce.set(d.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(ce,ut)),Rt=ce.set(d.ExtHostContext.ExtHostFileSystemEventService,new g.ExtHostFileSystemEventService(ce,Me,Xe)),xt=ce.set(d.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(ce,Qe,at)),dn=ce.set(d.ExtHostContext.ExtHostSCM,new K.ExtHostSCM(ce,at,Me)),_n=ce.set(d.ExtHostContext.ExtHostComments,new p.ExtHostComments(ce,at,_t)),hn=ce.set(d.ExtHostContext.ExtHostProgress,new R.ExtHostProgress(ce.getProxy(d.MainContext.MainThreadProgress))),tn=ce.set(d.ExtHostContext.ExtHosLabelService,new We.ExtHostLabelService(ce)),Kt=ce.set(d.ExtHostContext.ExtHostTheming,new De.ExtHostTheming(ce)),Nt=ce.set(d.ExtHostContext.ExtHostAuthentication,new we.ExtHostAuthentication(ce)),En=ce.set(d.ExtHostContext.ExtHostTimeline,new qe.ExtHostTimeline(ce,at)),nn=ce.set(d.ExtHostContext.ExtHostWebviews,new x.ExtHostWebviews(ce,xe.environment,Qe,Me,Je)),rn=ce.set(d.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ce,nn,Qe)),Gt=ce.set(d.ExtHostContext.ExtHostCustomEditors,new Ve.ExtHostCustomEditors(ce,_t,q,nn,rn)),yn=ce.set(d.ExtHostContext.ExtHostWebviewViews,new Ne.ExtHostWebviewViews(ce,nn)),Ft=ce.set(d.ExtHostContext.ExtHostTesting,new Ee.ExtHostTesting(ce,Xe,Qe)),sn=ce.set(d.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(ce)),Sn=(0,me.values)(d.ExtHostContext);ce.assertRegistered(Sn);const $t=new Ze.ExtHostBulkEdits(ce,Xe),on=new o.ExtHostClipboard(ce),Ut=new m.ExtHostMessageService(ce,Me),Lt=new l.ExtHostDialogs(ce),fn=new he.ExtHostStatusBar(ce,at.converter),Wt=new A.ExtHostLanguages(ce,_t);return r.ExtHostApiCommands.register(at),function(Oe,an,ln){const pt=function(){let Z=!Oe.isUnderDevelopment;function ue(Pe){Z||(Me.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Pe(st){if(Array.isArray(st))st.forEach(Pe);else if(typeof st=="string")ue(st);else{const wt=st;typeof wt.scheme=="undefined"&&ue(st),!Oe.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,ne.throwProposedApiError)(Oe)}return st}}(),Dn={getSession(Z,ue,Pe){return Nt.getSession(Oe,Z,ue,Pe)},get onDidChangeSessions(){return Nt.onDidChangeSessions},registerAuthenticationProvider(Z,ue,Pe,st){return Nt.registerAuthenticationProvider(Z,ue,Pe,st)},get onDidChangeAuthenticationProviders(){return(0,ne.checkProposedApiEnabled)(Oe),Nt.onDidChangeAuthenticationProviders},get providers(){return(0,ne.checkProposedApiEnabled)(Oe),Nt.providers},logout(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),Nt.removeSession(Z,ue)}},Cn={registerCommand(Z,ue,Pe){return at.registerCommand(!0,Z,ue,Pe)},registerTextEditorCommand(Z,ue,Pe){return at.registerCommand(!0,Z,(...st)=>{const wt=St.getActiveTextEditor();if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Dt=>{ue.apply(Pe,[wt,Dt,...st])}).then(Dt=>{Dt||Me.warn("Edits from command "+Z+" were not applied.")},Dt=>{Me.warn("An error occurred while running command "+Z,Dt)})})},registerDiffInformationCommand:(Z,ue,Pe)=>((0,ne.checkProposedApiEnabled)(Oe),at.registerCommand(!0,Z,async(...st)=>{const wt=Xe.activeEditor(!0);if(!wt){Me.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Dt=await St.getDiffInformation(wt.id);ue.apply(Pe,[Dt,...st])})),executeCommand(Z,...ue){return at.executeCommand(Z,...ue)},getCommands(Z=!1){return at.getCommands(Z)}},mn={get machineId(){return xe.telemetryInfo.machineId},get sessionId(){return xe.telemetryInfo.sessionId},get language(){return xe.environment.appLanguage},get appName(){return xe.environment.appName},get appRoot(){var Z,ue;return(ue=(Z=xe.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&ue!==void 0?ue:""},get uriScheme(){return xe.environment.appUriScheme},get clipboard(){return on.value},get shell(){return ft.getDefaultShell(!1,ln)},get isTelemetryEnabled(){return mt.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return mt.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(xe.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,ue){return et.openUri(Z,{allowTunneling:!!xe.remote.authority,allowContributedOpeners:ue==null?void 0:ue.allowContributedOpeners})},asExternalUri(Z){return Z.scheme===xe.environment.appUriScheme?Tt.createAppUri(Z):et.asExternalUri(Z,{allowTunneling:!!xe.remote.authority})},get remoteName(){return(0,Fe.getRemoteName)(xe.remote.authority)},get uiKind(){return xe.uiKind}};xe.environment.extensionTestsLocationURI||Object.freeze(mn);const gn=xe.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Ht={registerTestController(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.registerTestController(Oe.identifier.value,Z)},createDocumentTestObserver(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createWorkspaceTestObserver(Z)},runTests(Z){return(0,ne.checkProposedApiEnabled)(Oe),Ft.runTests(Z)},createTestItem(Z,ue){return new L.TestItemImpl(Z.id,Z.label,Z.uri,ue)},createTestRun(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),Ft.createTestRun(Oe.identifier.value,Z,ue,Pe)},get onDidChangeTestResults(){return(0,ne.checkProposedApiEnabled)(Oe),Ft.onResultsChanged},get testResults(){return(0,ne.checkProposedApiEnabled)(Oe),Ft.results}};Ht.createTestRunTask=Ht.createTestRun;const kn={getExtension(Z){const ue=an.getExtensionDescription(Z);if(ue)return new s.Extension(tt,Oe.identifier,ue,gn)},get all(){return an.getAllExtensionDescriptions().map(Z=>new s.Extension(tt,Oe.identifier,Z,gn))},get onDidChange(){return an.onDidChange}},In={createDiagnosticCollection(Z){return qt.createDiagnosticCollection(Oe.identifier,Z)},get onDidChangeDiagnostics(){return qt.onDidChangeDiagnostics},getDiagnostics:Z=>qt.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,ue){return Wt.changeLanguage(Z.uri,ue)},match(Z,ue){return(0,I.score)(F.LanguageSelector.from(Z),ue.uri,ue.languageId,!0)},registerCodeActionsProvider(Z,ue,Pe){return ut.registerCodeActionProvider(Oe,pt(Z),ue,Pe)},registerCodeLensProvider(Z,ue){return ut.registerCodeLensProvider(Oe,pt(Z),ue)},registerDefinitionProvider(Z,ue){return ut.registerDefinitionProvider(Oe,pt(Z),ue)},registerDeclarationProvider(Z,ue){return ut.registerDeclarationProvider(Oe,pt(Z),ue)},registerImplementationProvider(Z,ue){return ut.registerImplementationProvider(Oe,pt(Z),ue)},registerTypeDefinitionProvider(Z,ue){return ut.registerTypeDefinitionProvider(Oe,pt(Z),ue)},registerHoverProvider(Z,ue){return ut.registerHoverProvider(Oe,pt(Z),ue,Oe.identifier)},registerEvaluatableExpressionProvider(Z,ue){return ut.registerEvaluatableExpressionProvider(Oe,pt(Z),ue,Oe.identifier)},registerInlineValuesProvider(Z,ue){return ut.registerInlineValuesProvider(Oe,pt(Z),ue,Oe.identifier)},registerDocumentHighlightProvider(Z,ue){return ut.registerDocumentHighlightProvider(Oe,pt(Z),ue)},registerLinkedEditingRangeProvider(Z,ue){return ut.registerLinkedEditingRangeProvider(Oe,pt(Z),ue)},registerReferenceProvider(Z,ue){return ut.registerReferenceProvider(Oe,pt(Z),ue)},registerRenameProvider(Z,ue){return ut.registerRenameProvider(Oe,pt(Z),ue)},registerDocumentSymbolProvider(Z,ue,Pe){return ut.registerDocumentSymbolProvider(Oe,pt(Z),ue,Pe)},registerWorkspaceSymbolProvider(Z){return ut.registerWorkspaceSymbolProvider(Oe,Z)},registerDocumentFormattingEditProvider(Z,ue){return ut.registerDocumentFormattingEditProvider(Oe,pt(Z),ue)},registerDocumentRangeFormattingEditProvider(Z,ue){return ut.registerDocumentRangeFormattingEditProvider(Oe,pt(Z),ue)},registerOnTypeFormattingEditProvider(Z,ue,Pe,...st){return ut.registerOnTypeFormattingEditProvider(Oe,pt(Z),ue,[Pe].concat(st))},registerDocumentSemanticTokensProvider(Z,ue,Pe){return ut.registerDocumentSemanticTokensProvider(Oe,pt(Z),ue,Pe)},registerDocumentRangeSemanticTokensProvider(Z,ue,Pe){return ut.registerDocumentRangeSemanticTokensProvider(Oe,pt(Z),ue,Pe)},registerSignatureHelpProvider(Z,ue,Pe,...st){return typeof Pe=="object"?ut.registerSignatureHelpProvider(Oe,pt(Z),ue,Pe):ut.registerSignatureHelpProvider(Oe,pt(Z),ue,typeof Pe=="undefined"?[]:[Pe,...st])},registerCompletionItemProvider(Z,ue,...Pe){return ut.registerCompletionItemProvider(Oe,pt(Z),ue,Pe)},registerDocumentLinkProvider(Z,ue){return ut.registerDocumentLinkProvider(Oe,pt(Z),ue)},registerColorProvider(Z,ue){return ut.registerColorProvider(Oe,pt(Z),ue)},registerFoldingRangeProvider(Z,ue){return ut.registerFoldingRangeProvider(Oe,pt(Z),ue)},registerSelectionRangeProvider(Z,ue){return ut.registerSelectionRangeProvider(Oe,Z,ue)},registerCallHierarchyProvider(Z,ue){return ut.registerCallHierarchyProvider(Oe,Z,ue)},setLanguageConfiguration:(Z,ue)=>ut.setLanguageConfiguration(Oe,Z,ue),getTokenInformationAtPosition(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),Wt.tokenAtPosition(Z,ue)},registerInlayHintsProvider(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),ut.registerInlayHintsProvider(Oe,Z,ue)}},Pn={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return ft.activeTerminal},get terminals(){return ft.terminals},async showTextDocument(Z,ue,Pe){const st=await(D.URI.isUri(Z)?Promise.resolve(pn.openTextDocument(Z)):Promise.resolve(Z));return St.showTextDocument(st,ue,Pe)},createTextEditorDecorationType(Z){return St.createTextEditorDecorationType(Z)},onDidChangeActiveTextEditor(Z,ue,Pe){return St.onDidChangeActiveTextEditor(Z,ue,Pe)},onDidChangeVisibleTextEditors(Z,ue,Pe){return St.onDidChangeVisibleTextEditors(Z,ue,Pe)},onDidChangeTextEditorSelection(Z,ue,Pe){return St.onDidChangeTextEditorSelection(Z,ue,Pe)},onDidChangeTextEditorOptions(Z,ue,Pe){return St.onDidChangeTextEditorOptions(Z,ue,Pe)},onDidChangeTextEditorVisibleRanges(Z,ue,Pe){return St.onDidChangeTextEditorVisibleRanges(Z,ue,Pe)},onDidChangeTextEditorViewColumn(Z,ue,Pe){return St.onDidChangeTextEditorViewColumn(Z,ue,Pe)},onDidCloseTerminal(Z,ue,Pe){return ft.onDidCloseTerminal(Z,ue,Pe)},onDidOpenTerminal(Z,ue,Pe){return ft.onDidOpenTerminal(Z,ue,Pe)},onDidChangeActiveTerminal(Z,ue,Pe){return ft.onDidChangeActiveTerminal(Z,ue,Pe)},onDidChangeTerminalDimensions(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),ft.onDidChangeTerminalDimensions(Z,ue,Pe)},onDidWriteTerminalData(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),ft.onDidWriteTerminalData(Z,ue,Pe)},get state(){return et.state},onDidChangeWindowState(Z,ue,Pe){return et.onDidChangeWindowState(Z,ue,Pe)},showInformationMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Info,Z,ue[0],ue.slice(1))},showWarningMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Warning,Z,ue[0],ue.slice(1))},showErrorMessage(Z,...ue){return Ut.showMessage(Oe,y.default.Error,Z,ue[0],ue.slice(1))},showQuickPick(Z,ue,Pe){return xt.showQuickPick(Z,!!Oe.enableProposedApi,ue,Pe)},showWorkspaceFolderPick(Z){return xt.showWorkspaceFolderPick(Z)},showInputBox(Z,ue){return xt.showInput(Z,ue)},showOpenDialog(Z){return Lt.showOpenDialog(Z)},showSaveDialog(Z){return Lt.showSaveDialog(Z)},createStatusBarItem(Z,ue){let Pe,st,wt,Dt;return Z&&typeof Z!="number"?(Pe=Z.id,st=Z.name,wt=Z.alignment,ue=Z.priority,Dt=Z.accessibilityInformation):(Pe=Oe.identifier.value,st=b.localize(0,null,Oe.displayName||Oe.name),wt=Z),fn.createStatusBarEntry(Pe,st,wt,ue,Dt)},setStatusBarMessage(Z,ue){return fn.setStatusBarMessage(Z,ue)},withScmProgress(Z){return Je.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),hn.withProgress(Oe,{location:L.ProgressLocation.SourceControl},(ue,Pe)=>Z({report(st){}}))},withProgress(Z,ue){return hn.withProgress(Oe,Z,ue)},createOutputChannel(Z){return kt.createOutputChannel(Z)},createWebviewPanel(Z,ue,Pe,st){return rn.createWebviewPanel(Oe,Z,ue,Pe,st)},createWebviewTextEditorInset(Z,ue,Pe,st){return(0,ne.checkProposedApiEnabled)(Oe),Zt.createWebviewEditorInset(Z,ue,Pe,st,Oe)},createTerminal(Z,ue,Pe){return typeof Z=="object"?"pty"in Z?ft.createExtensionTerminal(Z):(Z.icon&&(0,ne.checkProposedApiEnabled)(Oe),ft.createTerminalFromOptions(Z)):ft.createTerminal(Z,ue,Pe)},registerTerminalLinkProvider(Z){return ft.registerLinkProvider(Z)},registerTreeDataProvider(Z,ue){return jt.registerTreeDataProvider(Z,ue,Oe)},createTreeView(Z,ue){return jt.createTreeView(Z,ue,Oe)},registerWebviewPanelSerializer:(Z,ue)=>rn.registerWebviewPanelSerializer(Oe,Z,ue),registerCustomEditorProvider:(Z,ue,Pe={})=>Gt.registerCustomEditorProvider(Oe,Z,ue,Pe),registerFileDecorationProvider(Z){return ht.registerFileDecorationProvider(Z,Oe.identifier)},registerUriHandler(Z){return Tt.registerUriHandler(Oe.identifier,Z)},createQuickPick(){return xt.createQuickPick(Oe.identifier,!!Oe.enableProposedApi)},createInputBox(){return xt.createInputBox(Oe.identifier)},get activeColorTheme(){return Kt.activeColorTheme},onDidChangeActiveColorTheme(Z,ue,Pe){return Kt.onDidChangeActiveColorTheme(Z,ue,Pe)},registerWebviewViewProvider(Z,ue,Pe){return yn.registerWebviewViewProvider(Oe,Z,ue,Pe==null?void 0:Pe.webviewOptions)},get activeNotebookEditor(){return(0,ne.checkProposedApiEnabled)(Oe),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeActiveNotebookEditor(Z,ue,Pe)},get visibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Oe),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookEditorSelection(Z,ue,Pe)},onDidChangeNotebookEditorVisibleRanges(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookEditorVisibleRanges(Z,ue,Pe)},showNotebookDocument(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),gt.showNotebookDocument(Z,ue)},registerExternalUriOpener(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),sn.registerExternalUriOpener(Oe.identifier,Z,ue,Pe)},get openEditors(){return(0,ne.checkProposedApiEnabled)(Oe),At.tabs},get onDidChangeOpenEditors(){return(0,ne.checkProposedApiEnabled)(Oe),At.onDidChangeTabs}},pn={get rootPath(){return Je.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Qe.getPath()},set rootPath(Z){throw P.readonly()},getWorkspaceFolder(Z){return Qe.getWorkspaceFolder(Z)},get workspaceFolders(){return Qe.getWorkspaceFolders()},get name(){return Qe.name},set name(Z){throw P.readonly()},get workspaceFile(){return Qe.workspaceFile},set workspaceFile(Z){throw P.readonly()},updateWorkspaceFolders:(Z,ue,...Pe)=>Qe.updateWorkspaceFolders(Oe,Z,ue||0,...Pe),onDidChangeWorkspaceFolders:function(Z,ue,Pe){return Qe.onDidChangeWorkspace(Z,ue,Pe)},asRelativePath:(Z,ue)=>Qe.getRelativePath(Z,ue),findFiles:(Z,ue,Pe,st)=>Qe.findFiles(F.GlobPattern.from(Z),F.GlobPattern.from(ue),Pe,Oe.identifier,st),findTextInFiles:(Z,ue,Pe,st)=>{let wt,Dt;return typeof ue=="object"?(wt=ue,Dt=Pe):(wt={},Dt=ue,st=Pe),Qe.findTextInFiles(Z,wt||{},Dt,Oe.identifier,st)},saveAll:Z=>Qe.saveAll(Z),applyEdit(Z){return $t.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,ue,Pe,st)=>Rt.createFileSystemWatcher(F.GlobPattern.from(Z),ue,Pe,st),get textDocuments(){return _t.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw P.readonly()},openTextDocument(Z){let ue;const Pe=Z;if(typeof Z=="string")ue=Promise.resolve(D.URI.file(Z));else if(D.URI.isUri(Z))ue=Promise.resolve(Z);else if(!Pe||typeof Pe=="object")ue=_t.createDocumentData(Pe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(st=>_t.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Z,ue,Pe)=>_t.onDidAddDocument(Z,ue,Pe),onDidCloseTextDocument:(Z,ue,Pe)=>_t.onDidRemoveDocument(Z,ue,Pe),onDidChangeTextDocument:(Z,ue,Pe)=>_t.onDidChangeDocument(Z,ue,Pe),onDidSaveTextDocument:(Z,ue,Pe)=>_t.onDidSaveDocument(Z,ue,Pe),onWillSaveTextDocument:(Z,ue,Pe)=>Jt.getOnWillSaveTextDocumentEvent(Oe)(Z,ue,Pe),onDidChangeConfiguration:(Z,ue,Pe)=>ln.onDidChangeConfiguration(Z,ue,Pe),getConfiguration(Z,ue){return ue=arguments.length===1?void 0:ue,ln.getConfiguration(Z,ue,Oe)},registerTextDocumentContentProvider(Z,ue){return Yt.registerTextDocumentContentProvider(Z,ue)},registerTaskProvider:(Z,ue)=>(Je.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),vt.registerTaskProvider(Oe,Z,ue)),registerFileSystemProvider(Z,ue,Pe){return en.registerFileSystemProvider(Oe.identifier,Z,ue,Pe)},get fs(){return rt.value},registerFileSearchProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Et.registerFileSearchProvider(Z,ue)),registerTextSearchProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Et.registerTextSearchProvider(Z,ue)),registerRemoteAuthorityResolver:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),tt.registerRemoteAuthorityResolver(Z,ue)),registerResourceLabelFormatter:Z=>((0,ne.checkProposedApiEnabled)(Oe),tn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,ue,Pe)=>Rt.onDidCreateFile(Z,ue,Pe),onDidDeleteFiles:(Z,ue,Pe)=>Rt.onDidDeleteFile(Z,ue,Pe),onDidRenameFiles:(Z,ue,Pe)=>Rt.onDidRenameFile(Z,ue,Pe),onWillCreateFiles:(Z,ue,Pe)=>Rt.getOnWillCreateFileEvent(Oe)(Z,ue,Pe),onWillDeleteFiles:(Z,ue,Pe)=>Rt.getOnWillDeleteFileEvent(Oe)(Z,ue,Pe),onWillRenameFiles:(Z,ue,Pe)=>Rt.getOnWillRenameFileEvent(Oe)(Z,ue,Pe),openTunnel:Z=>((0,ne.checkProposedApiEnabled)(Oe),Te.openTunnel(Oe,Z).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,ne.checkProposedApiEnabled)(Oe),Te.getTunnels()},onDidChangeTunnels:(Z,ue,Pe)=>((0,ne.checkProposedApiEnabled)(Oe),Te.onDidChangeTunnels(Z,ue,Pe)),registerPortAttributesProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),Te.registerPortsAttributesProvider(Z,ue)),registerTimelineProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),En.registerTimelineProvider(Z,ue,Oe.identifier,at.converter)),get isTrusted(){return Qe.trusted},requestWorkspaceTrust:Z=>((0,ne.checkProposedApiEnabled)(Oe),Qe.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,ue,Pe)=>Qe.onDidGrantWorkspaceTrust(Z,ue,Pe)},An={get inputBox(){return Je.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),dn.getLastInputBox(Oe)},createSourceControl(Z,ue,Pe){return dn.createSourceControl(Oe,Z,ue,Pe)}},vn={createCommentController(Z,ue){return _n.createCommentController(Oe,Z,ue)}},bn={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},onDidStartDebugSession(Z,ue,Pe){return lt.onDidStartDebugSession(Z,ue,Pe)},onDidTerminateDebugSession(Z,ue,Pe){return lt.onDidTerminateDebugSession(Z,ue,Pe)},onDidChangeActiveDebugSession(Z,ue,Pe){return lt.onDidChangeActiveDebugSession(Z,ue,Pe)},onDidReceiveDebugSessionCustomEvent(Z,ue,Pe){return lt.onDidReceiveDebugSessionCustomEvent(Z,ue,Pe)},onDidChangeBreakpoints(Z,ue,Pe){return lt.onDidChangeBreakpoints(Z,ue,Pe)},registerDebugConfigurationProvider(Z,ue,Pe){return lt.registerDebugConfigurationProvider(Z,ue,Pe||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,ue){return lt.registerDebugAdapterDescriptorFactory(Oe,Z,ue)},registerDebugAdapterTrackerFactory(Z,ue){return lt.registerDebugAdapterTrackerFactory(Z,ue)},startDebugging(Z,ue,Pe){return!Pe||typeof Pe=="object"&&"configuration"in Pe?lt.startDebugging(Z,ue,{parentSession:Pe}):lt.startDebugging(Z,ue,Pe||{})},stopDebugging(Z){return lt.stopDebugging(Z)},addBreakpoints(Z){return lt.addBreakpoints(Z)},removeBreakpoints(Z){return lt.removeBreakpoints(Z)},asDebugSourceUri(Z,ue){return lt.asDebugSourceUri(Z,ue)}},Bt={registerTaskProvider:(Z,ue)=>vt.registerTaskProvider(Oe,Z,ue),fetchTasks:Z=>vt.fetchTasks(Z),executeTask:Z=>vt.executeTask(Oe,Z),get taskExecutions(){return vt.taskExecutions},onDidStartTask:(Z,ue,Pe)=>vt.onDidStartTask(Z,ue,Pe),onDidEndTask:(Z,ue,Pe)=>vt.onDidEndTask(Z,ue,Pe),onDidStartTaskProcess:(Z,ue,Pe)=>vt.onDidStartTaskProcess(Z,ue,Pe),onDidEndTaskProcess:(Z,ue,Pe)=>vt.onDidEndTaskProcess(Z,ue,Pe)},zt={openNotebookDocument:Z=>((0,ne.checkProposedApiEnabled)(Oe),gt.openNotebookDocument(Z)),get onDidOpenNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,ne.checkProposedApiEnabled)(Oe),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,ue,Pe,st){return(0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookSerializer(Oe,Z,ue,Pe,Oe.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Z,ue,Pe,st)=>((0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookContentProvider(Oe,Z,ue,Pe,Oe.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(Z,ue)=>((0,ne.checkProposedApiEnabled)(Oe),gt.registerNotebookCellStatusBarItemProvider(Oe,Z,ue)),createNotebookEditorDecorationType(Z){return(0,ne.checkProposedApiEnabled)(Oe),gt.createNotebookEditorDecorationType(Z)},onDidChangeNotebookDocumentMetadata(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookDocumentMetadata(Z,ue,Pe)},onDidChangeNotebookCells(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookCells(Z,ue,Pe)},onDidChangeCellExecutionState(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeNotebookCellExecutionState(Z,ue,Pe)},onDidChangeCellOutputs(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeCellOutputs(Z,ue,Pe)},onDidChangeCellMetadata(Z,ue,Pe){return(0,ne.checkProposedApiEnabled)(Oe),gt.onDidChangeCellMetadata(Z,ue,Pe)},createConcatTextDocument(Z,ue){return(0,ne.checkProposedApiEnabled)(Oe),new z.ExtHostNotebookConcatDocument(gt,_t,Z,ue)},createNotebookController(Z,ue,Pe,st,wt){return(0,ne.checkProposedApiEnabled)(Oe),Xt.createNotebookController(Oe,Z,ue,Pe,st,wt)}};return{version:xe.version,authentication:Dn,commands:Cn,comments:vn,debug:bn,env:mn,extensions:kn,languages:In,notebook:zt,scm:An,tasks:Bt,test:Ht,window:Pn,workspace:pn,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:k.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,EventEmitter:T.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:h.FileType,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,Hover:L.Hover,IndentAction:i.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:C.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:D.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,RemoteTrustOption:ae.RemoteTrustOption,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookDocumentMetadata:L.NotebookDocumentMetadata,NotebookCellMetadata:L.NotebookCellMetadata,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookKernelPreload:L.NotebookKernelPreload,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,LinkedEditingRanges:L.LinkedEditingRanges,TestItemStatus:L.TestItemStatus,TestResultState:L.TestResultState,TestMessage:L.TestMessage,TextSearchCompleteMessageType:ke.TextSearchCompleteMessageType,TestMessageSeverity:L.TestMessageSeverity,WorkspaceTrustState:L.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ie}),define(ve[226],be([0,1,61,100,30,99,34,76,39,40,103,104,105,79,78,70,75,101,77,49,74,94]),function(J,e,b,k,P,T,y,D,S,C,i,I,h,d,r,o,v,p,E,c,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(d.IExtensionStoragePaths,d.ExtensionStoragePaths),(0,b.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService),(0,b.registerSingleton)(D.IExtHostCommands,D.ExtHostCommands),(0,b.registerSingleton)(y.IExtHostConfiguration,y.ExtHostConfiguration),(0,b.registerSingleton)(E.IExtHostConsumerFileSystem,E.ExtHostConsumerFileSystem),(0,b.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,b.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,b.registerSingleton)(S.IExtHostDocumentsAndEditors,S.ExtHostDocumentsAndEditors),(0,b.registerSingleton)(c.IExtHostFileSystemInfo,c.ExtHostFileSystemInfo),(0,b.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,b.registerSingleton)(h.IExtHostSearch,h.ExtHostSearch),(0,b.registerSingleton)(r.IExtHostStorage,r.ExtHostStorage),(0,b.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,b.registerSingleton)(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),(0,b.registerSingleton)(o.IExtHostTunnelService,o.ExtHostTunnelService),(0,b.registerSingleton)(p.IExtHostWindow,p.ExtHostWindow),(0,b.registerSingleton)(P.IExtHostWorkspace,P.ExtHostWorkspace),(0,b.registerSingleton)(l.IExtHostSecretState,l.ExtHostSecretState),(0,b.registerSingleton)(f.IExtHostTelemetry,f.ExtHostTelemetry)}),define(ve[227],be([0,1,225,35,221,7,11,5]),function(J,e,b,k,P,T,y,D){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(r){var o;const v=(o=self.trustedTypes)===null||o===void 0?void 0:o.createPolicy("TrustedFunctionWorkaround",{createScript:(E,...c)=>{c.forEach(n=>{var a;if(!((a=self.trustedTypes)===null||a===void 0?void 0:a.isScript(n)))throw new Error("TrustedScripts only, please")});const l=c.slice(0,-1).join(","),f=c.pop().toString();return`(function anonymous(${l}) {
${f}
})`}});function p(...E){return v?self.eval(v.createScript("",...E)):new Function(...E)}r.create=p})(C||(C={}));class i extends P.RequireInterceptor{_installInterceptor(){}getModule(o,v){for(let p of this._alternatives){let E=p(o);if(E){o=E;break}}if(this._factories.has(o))return this._factories.get(o).load(o,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const o=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);d(o,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(b.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(o){return o.browser}async _loadCommonJSModule(o,v,p){var E,c,l,f,t,n,a,s;v=v.with({path:h(v.path,".js")}),o&&performance.mark(`code/extHost/willFetchExtensionCode/${o.value}`);const u=await fetch(v.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o.value}`),u.status!==200)throw new Error(u.statusText);const g=await u.text(),_=`${v.toString(!0)}#vscode-extension`,A=`${g}
//# sourceURL=${_}`;let m;try{m=C.create((c=(E=I._ttpExtensionScripts)===null||E===void 0?void 0:E.createScript("module"))!==null&&c!==void 0?c:"module",(f=(l=I._ttpExtensionScripts)===null||l===void 0?void 0:l.createScript("exports"))!==null&&f!==void 0?f:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(a=I._ttpExtensionScripts)===null||a===void 0?void 0:a.createScript(A))!==null&&s!==void 0?s:A)}catch(K){throw o?console.error(`Loading code for extension ${o.value} failed: ${K.message}`):console.error(`Loading code failed: ${K.message}`),console.error(`${v.toString(!0)}${typeof K.line=="number"?` line ${K.line}`:""}${typeof K.column=="number"?` column ${K.column}`:""}`),console.error(K),K}const w={},R={exports:w},$=K=>{const he=this._fakeModules.getModule(K,v);if(he===void 0)throw new Error(`Cannot load module '${K}'`);return he};try{return p.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o.value}`),m(R,w,$),R.exports!==w?R.exports:w}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o.value}`),p.codeLoadingStop()}}async $setRemoteEnvironment(o){throw new Error("Not supported")}async _waitForDebuggerAttachment(o=5e3){if(!!this._initData.environment.isExtensionDevelopmentDebug){const v=Date.now()+o;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,y.timeout)(10)}}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(S=self.trustedTypes)===null||S===void 0?void 0:S.createPolicy("ExtensionScripts",{createScript:r=>r});function h(r,o){return r.endsWith(o)?r:r+o}function d(r,o){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(c,l){const f=console[c];console[c]=function(){r.$logExtensionHostMessage({type:"__$console",severity:l,arguments:E(arguments)}),o&&f.apply(console,arguments)}}const p=1e5;function E(c){const l=[],f=[];if(c.length)for(let t=0;t<c.length;t++){if(typeof c[t]=="undefined")c[t]="undefined";else if(c[t]instanceof Error){const n=c[t];n.stack?c[t]=n.stack:c[t]=n.toString()}f.push(c[t])}try{const t=JSON.stringify(f,function(n,a){if(a&&typeof a=="object"){if(l.indexOf(a)!==-1)return"[Circular]";l.push(a)}return a});return t.length>p?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(ve[228],be([0,1,61,18,35,227,213]),function(J,e,b,k,P,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.registerSingleton)(P.IExtHostExtensionService,T.ExtHostExtensionService),(0,b.registerSingleton)(k.ILogService,y.ExtHostLogService)}),define(ve[230],be([0,1,24,3,184,222,215,14,80,226,228]),function(J,e,b,k,P,T,y,D,S){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const v=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:E=>E}),p=self.Worker;Worker=function(E,c){const l=`importScripts('${E}');`;c=c||{},c.name=c.name||D.basename(E.toString());const f=new Blob([l],{type:"application/javascript"}),t=URL.createObjectURL(f);return new p(v?v.createScriptURL(t):t,c)}}else self.Worker=class extends y.NestedWorker{constructor(v,p){super(I,v,Object.assign({name:D.basename(v.toString())},p))}};const h=new class{exit(v){i()}async exists(v){return!0}async realpath(v){return v}};class d{constructor(){const p=new MessageChannel,E=new k.Emitter;let c=!1;I(p.port2,[p.port2]),p.port1.onmessage=l=>{const{data:f}=l;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const t=b.VSBuffer.wrap(new Uint8Array(f,0,f.byteLength));if((0,P.isMessageOfType)(t,2)){c=!0,o("received terminate message from renderer");return}E.fire(t)},this.protocol={onMessage:E.event,send:l=>{if(!c){const f=l.buffer.buffer.slice(l.buffer.byteOffset,l.buffer.byteOffset+l.buffer.byteLength);p.port1.postMessage(f,[f])}}}}}function r(v){return new Promise(p=>{const E=v.onMessage(c=>{E.dispose();const l=JSON.parse(c.toString());v.send((0,P.createMessageOfType)(0)),p({protocol:v,initData:l})});v.send((0,P.createMessageOfType)(1))})}let o=v=>i();(function(){const p=new d;S.mark("code/extHost/willConnectToRenderer"),r(p.protocol).then(E=>{S.mark("code/extHost/didWaitForInitData");const c=new T.ExtensionHostMain(E.protocol,E.initData,h,null);o=l=>c.terminate(l)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/54d33cf14cf6c0e86880b5b74a5a3628de42bce9/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
